/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 97;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 88,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 96,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 85,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 79,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 45,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 42,
  Feature_HasSVE2SHA3Bit = 95,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 58,
  Feature_HasSMEBit = 51,
  Feature_HasSMEF64F64Bit = 53,
  Feature_HasSMEF16F16Bit = 61,
  Feature_HasSMEI16I64Bit = 56,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 60,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 48,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 43,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 49,
  Feature_HasLUTBit = 50,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 54,
  Feature_HasSMEF8F32Bit = 52,
  Feature_HasSME_MOP4Bit = 57,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 86,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 47,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 59,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 46,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 55,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 41,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 87,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 94,
  Feature_HasMatMulFP64Bit = 44,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 91,
  Feature_HasFastIncVLBit = 92,
  Feature_UseSVEFPLD1RBit = 90,
  Feature_UseLDAPURBit = 89,
  Feature_AllowMisalignedMemAccessesBit = 93,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasFailedISel() || !MF->getProperties().hasLegalized())
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(903), /*)*//*default:*//*Label 154*/ GIMT_Encode4(438866),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3410),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36405),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50633),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(53154),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(53236), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(53318),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(61064),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(86179), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(97147), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(104671), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(114753),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(115244),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(115735),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(116003),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(116153),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(116644), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(116677),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(125615),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(126665), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(129714), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(143240),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(144591),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(145583),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(146575),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(148067), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(149559),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(150551),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(151543),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(152535),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(153527),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(154519),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(155511), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(156216),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(156921),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_FMAXIMUM*//*Label 34*/ GIMT_Encode4(157626),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_FMINIMUM*//*Label 35*/ GIMT_Encode4(158331), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(159036), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(159087),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(264139), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(275655),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 40*/ GIMT_Encode4(275945),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 41*/ GIMT_Encode4(277382),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 42*/ GIMT_Encode4(277502), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 43*/ GIMT_Encode4(277743),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 44*/ GIMT_Encode4(279641),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(281295),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(284074),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(284899),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(285337), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(286162),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(286292), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(286834), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 52*/ GIMT_Encode4(294611), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 53*/ GIMT_Encode4(295656),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 54*/ GIMT_Encode4(296140),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 55*/ GIMT_Encode4(296624),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 56*/ GIMT_Encode4(297096),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 57*/ GIMT_Encode4(299472),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 58*/ GIMT_Encode4(299944), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(301334),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(303132),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(303870),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(307966), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(324239), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(324855),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(328362),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(328610),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(328798),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(329775),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(330752),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(335380),
     /*    614 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 71*/ GIMT_Encode4(339386),
     /*    618 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 72*/ GIMT_Encode4(339706),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 73*/ GIMT_Encode4(340026), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 74*/ GIMT_Encode4(340883),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 75*/ GIMT_Encode4(341165),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 76*/ GIMT_Encode4(341543),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 77*/ GIMT_Encode4(341921),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 78*/ GIMT_Encode4(342271),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 79*/ GIMT_Encode4(342621),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 80*/ GIMT_Encode4(343324), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 81*/ GIMT_Encode4(344027),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 82*/ GIMT_Encode4(344431),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 83*/ GIMT_Encode4(344835),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 84*/ GIMT_Encode4(345239),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 85*/ GIMT_Encode4(345643),
     /*    722 */ /*TargetOpcode::G_LROUND*//*Label 86*/ GIMT_Encode4(346458),
     /*    726 */ /*TargetOpcode::G_LLROUND*//*Label 87*/ GIMT_Encode4(346624),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 88*/ GIMT_Encode4(346723), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 89*/ GIMT_Encode4(346739),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(352111),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(385033), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 92*/ GIMT_Encode4(387951), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 93*/ GIMT_Encode4(390271), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 94*/ GIMT_Encode4(390423), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 95*/ GIMT_Encode4(391097),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 96*/ GIMT_Encode4(391257),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 97*/ GIMT_Encode4(391571),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 98*/ GIMT_Encode4(391725), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 99*/ GIMT_Encode4(392216),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 100*/ GIMT_Encode4(392516),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 101*/ GIMT_Encode4(393007),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 102*/ GIMT_Encode4(393498), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 103*/ GIMT_Encode4(393989),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 104*/ GIMT_Encode4(395115),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 105*/ GIMT_Encode4(395731),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 106*/ GIMT_Encode4(399453), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 107*/ GIMT_Encode4(400069),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 108*/ GIMT_Encode4(415676), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 109*/ GIMT_Encode4(415976),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 110*/ GIMT_Encode4(415990),
     /*    958 */ /*TargetOpcode::G_UBSANTRAP*//*Label 111*/ GIMT_Encode4(416011), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 112*/ GIMT_Encode4(416036), GIMT_Encode4(0),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 113*/ GIMT_Encode4(416346),
     /*    982 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 114*/ GIMT_Encode4(416517),
     /*    986 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 115*/ GIMT_Encode4(416688),
     /*    990 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 116*/ GIMT_Encode4(416859),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 117*/ GIMT_Encode4(417030), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 118*/ GIMT_Encode4(418159),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 119*/ GIMT_Encode4(418362),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 120*/ GIMT_Encode4(418565),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 121*/ GIMT_Encode4(418768), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3278 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 122*/ GIMT_Encode4(418971), GIMT_Encode4(0),
     /*   3286 */ /*AArch64::G_BSP*//*Label 123*/ GIMT_Encode4(419111),
     /*   3290 */ /*AArch64::G_DUP*//*Label 124*/ GIMT_Encode4(420099),
     /*   3294 */ /*AArch64::G_DUPLANE16*//*Label 125*/ GIMT_Encode4(422082),
     /*   3298 */ /*AArch64::G_DUPLANE32*//*Label 126*/ GIMT_Encode4(422337),
     /*   3302 */ /*AArch64::G_DUPLANE64*//*Label 127*/ GIMT_Encode4(422592),
     /*   3306 */ /*AArch64::G_DUPLANE8*//*Label 128*/ GIMT_Encode4(422738),
     /*   3310 */ /*AArch64::G_EXT*//*Label 129*/ GIMT_Encode4(422917),
     /*   3314 */ /*AArch64::G_FCMEQ*//*Label 130*/ GIMT_Encode4(424567),
     /*   3318 */ /*AArch64::G_FCMGE*//*Label 131*/ GIMT_Encode4(425126),
     /*   3322 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(426218),
     /*   3326 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(427310),
     /*   3330 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(427464),
     /*   3334 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(427640),
     /*   3338 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(427914),
     /*   3342 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(428120),
     /*   3346 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(428519),
     /*   3350 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(428889),
     /*   3354 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(429006),
     /*   3358 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(430239),
     /*   3362 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(431019),
     /*   3366 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(431799),
     /*   3370 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(432005),
     /*   3374 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(432872),
     /*   3378 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(433242),
     /*   3382 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(433359),
     /*   3386 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(434592),
     /*   3390 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(435372),
     /*   3394 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(436152),
     /*   3398 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(436850),
     /*   3402 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(437306),
     /*   3406 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(438086),
     /*   3410 */ // Label 0: @3410
     /*   3410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(36404),
     /*   3421 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3509),
     /*   3425 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(6288), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(11616),
     /*   3437 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(15224),
     /*   3441 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(21126),
     /*   3445 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(24624),
     /*   3449 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(30802),
     /*   3453 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(31652),
     /*   3457 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(35230), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3477 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(35954), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(36326), GIMT_Encode4(0),
     /*   3497 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(36352), GIMT_Encode4(0),
     /*   3505 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(36378),
     /*   3509 */ // Label 155: @3509
     /*   3509 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(6287),
     /*   3514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3520 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3553), // Rule ID 13279 //
     /*   3525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3540 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3551 */     GIR_RootConstrainSelectedInstOperands,
     /*   3552 */     // GIR_Coverage, 13279,
     /*   3552 */     GIR_EraseRootFromParent_Done,
     /*   3553 */   // Label 170: @3553
     /*   3553 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3705), // Rule ID 13716 //
     /*   3558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3585 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3588 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3593 */     // MIs[2] pattern
     /*   3593 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3596 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3607 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3640 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3704 */     // GIR_Coverage, 13716,
     /*   3704 */     GIR_EraseRootFromParent_Done,
     /*   3705 */   // Label 171: @3705
     /*   3705 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3857), // Rule ID 15570 //
     /*   3710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3745 */     // MIs[2] pattern
     /*   3745 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3748 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3759 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3839 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3856 */     // GIR_Coverage, 15570,
     /*   3856 */     GIR_EraseRootFromParent_Done,
     /*   3857 */   // Label 172: @3857
     /*   3857 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4009), // Rule ID 15582 //
     /*   3862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3889 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3892 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3897 */     // MIs[2] pattern
     /*   3897 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3900 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3911 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3937 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4008 */     // GIR_Coverage, 15582,
     /*   4008 */     GIR_EraseRootFromParent_Done,
     /*   4009 */   // Label 173: @4009
     /*   4009 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4161), // Rule ID 15594 //
     /*   4014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4041 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4044 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4049 */     // MIs[2] pattern
     /*   4049 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4052 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4063 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4063 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4066 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4070 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4089 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4096 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4143 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4160 */     // GIR_Coverage, 15594,
     /*   4160 */     GIR_EraseRootFromParent_Done,
     /*   4161 */   // Label 174: @4161
     /*   4161 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4194), // Rule ID 91 //
     /*   4166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4181 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4192 */     GIR_RootConstrainSelectedInstOperands,
     /*   4193 */     // GIR_Coverage, 91,
     /*   4193 */     GIR_EraseRootFromParent_Done,
     /*   4194 */   // Label 175: @4194
     /*   4194 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4346), // Rule ID 2649 //
     /*   4199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4230 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4233 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4238 */     // MIs[2] pattern
     /*   4238 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4241 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4248 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4274 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4281 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4328 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4345 */     // GIR_Coverage, 2649,
     /*   4345 */     GIR_EraseRootFromParent_Done,
     /*   4346 */   // Label 176: @4346
     /*   4346 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4498), // Rule ID 9993 //
     /*   4351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4382 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4385 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4390 */     // MIs[2] pattern
     /*   4390 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4393 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4400 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4497 */     // GIR_Coverage, 9993,
     /*   4497 */     GIR_EraseRootFromParent_Done,
     /*   4498 */   // Label 177: @4498
     /*   4498 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4650), // Rule ID 10005 //
     /*   4503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4534 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4537 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4542 */     // MIs[2] pattern
     /*   4542 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4545 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4552 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4585 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4649 */     // GIR_Coverage, 10005,
     /*   4649 */     GIR_EraseRootFromParent_Done,
     /*   4650 */   // Label 178: @4650
     /*   4650 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4802), // Rule ID 10017 //
     /*   4655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4686 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4689 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4694 */     // MIs[2] pattern
     /*   4694 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4697 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4704 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4784 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4801 */     // GIR_Coverage, 10017,
     /*   4801 */     GIR_EraseRootFromParent_Done,
     /*   4802 */   // Label 179: @4802
     /*   4802 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4959), // Rule ID 15613 //
     /*   4807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4834 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4837 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4853 */     // MIs[2] pred
     /*   4853 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4864 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4890 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4897 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4958 */     // GIR_Coverage, 15613,
     /*   4958 */     GIR_EraseRootFromParent_Done,
     /*   4959 */   // Label 180: @4959
     /*   4959 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(5116), // Rule ID 15614 //
     /*   4964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4991 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4994 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5010 */     // MIs[2] pred
     /*   5010 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5021 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5047 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5098 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5115 */     // GIR_Coverage, 15614,
     /*   5115 */     GIR_EraseRootFromParent_Done,
     /*   5116 */   // Label 181: @5116
     /*   5116 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5273), // Rule ID 15615 //
     /*   5121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5148 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5151 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5167 */     // MIs[2] pred
     /*   5167 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5178 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5204 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5272 */     // GIR_Coverage, 15615,
     /*   5272 */     GIR_EraseRootFromParent_Done,
     /*   5273 */   // Label 182: @5273
     /*   5273 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5430), // Rule ID 15616 //
     /*   5278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5305 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5308 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5317 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5324 */     // MIs[2] pred
     /*   5324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5335 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5361 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5368 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5429 */     // GIR_Coverage, 15616,
     /*   5429 */     GIR_EraseRootFromParent_Done,
     /*   5430 */   // Label 183: @5430
     /*   5430 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5587), // Rule ID 10109 //
     /*   5435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5466 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5469 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5485 */     // MIs[2] pred
     /*   5485 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5492 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5518 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5586 */     // GIR_Coverage, 10109,
     /*   5586 */     GIR_EraseRootFromParent_Done,
     /*   5587 */   // Label 184: @5587
     /*   5587 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5744), // Rule ID 10110 //
     /*   5592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5623 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5626 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5635 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5642 */     // MIs[2] pred
     /*   5642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5649 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5682 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5743 */     // GIR_Coverage, 10110,
     /*   5743 */     GIR_EraseRootFromParent_Done,
     /*   5744 */   // Label 185: @5744
     /*   5744 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5901), // Rule ID 10111 //
     /*   5749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5780 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5783 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5792 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5799 */     // MIs[2] pred
     /*   5799 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5806 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5832 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5839 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5900 */     // GIR_Coverage, 10111,
     /*   5900 */     GIR_EraseRootFromParent_Done,
     /*   5901 */   // Label 186: @5901
     /*   5901 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(6058), // Rule ID 10112 //
     /*   5906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5937 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5940 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5956 */     // MIs[2] pred
     /*   5956 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5963 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5963 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5966 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5970 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5996 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6057 */     // GIR_Coverage, 10112,
     /*   6057 */     GIR_EraseRootFromParent_Done,
     /*   6058 */   // Label 187: @6058
     /*   6058 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6091), // Rule ID 13283 //
     /*   6063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6078 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6089 */     GIR_RootConstrainSelectedInstOperands,
     /*   6090 */     // GIR_Coverage, 13283,
     /*   6090 */     GIR_EraseRootFromParent_Done,
     /*   6091 */   // Label 188: @6091
     /*   6091 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6127), // Rule ID 13856 //
     /*   6096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6111 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6125 */     GIR_RootConstrainSelectedInstOperands,
     /*   6126 */     // GIR_Coverage, 13856,
     /*   6126 */     GIR_EraseRootFromParent_Done,
     /*   6127 */   // Label 189: @6127
     /*   6127 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6160), // Rule ID 97 //
     /*   6132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6147 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6158 */     GIR_RootConstrainSelectedInstOperands,
     /*   6159 */     // GIR_Coverage, 97,
     /*   6159 */     GIR_EraseRootFromParent_Done,
     /*   6160 */   // Label 190: @6160
     /*   6160 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6196), // Rule ID 3918 //
     /*   6165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6180 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6194 */     GIR_RootConstrainSelectedInstOperands,
     /*   6195 */     // GIR_Coverage, 3918,
     /*   6195 */     GIR_EraseRootFromParent_Done,
     /*   6196 */   // Label 191: @6196
     /*   6196 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6229), // Rule ID 13281 //
     /*   6201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6216 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6227 */     GIR_RootConstrainSelectedInstOperands,
     /*   6228 */     // GIR_Coverage, 13281,
     /*   6228 */     GIR_EraseRootFromParent_Done,
     /*   6229 */   // Label 192: @6229
     /*   6229 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6262), // Rule ID 95 //
     /*   6234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6249 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6260 */     GIR_RootConstrainSelectedInstOperands,
     /*   6261 */     // GIR_Coverage, 95,
     /*   6261 */     GIR_EraseRootFromParent_Done,
     /*   6262 */   // Label 193: @6262
     /*   6262 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6286), // Rule ID 93 //
     /*   6267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6279 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6284 */     GIR_RootConstrainSelectedInstOperands,
     /*   6285 */     // GIR_Coverage, 93,
     /*   6285 */     GIR_Done,
     /*   6286 */   // Label 194: @6286
     /*   6286 */   GIM_Reject,
     /*   6287 */ // Label 169: @6287
     /*   6287 */ GIM_Reject,
     /*   6288 */ // Label 156: @6288
     /*   6288 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(11615),
     /*   6293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6299 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6435), // Rule ID 5389 //
     /*   6304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6337 */     // MIs[1] Operand 2
     /*   6337 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6364 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6368 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6372 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6377 */     // MIs[3] Operand 2
     /*   6377 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6390 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6417 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6434 */     // GIR_Coverage, 5389,
     /*   6434 */     GIR_EraseRootFromParent_Done,
     /*   6435 */   // Label 196: @6435
     /*   6435 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6571), // Rule ID 5388 //
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6473 */     // MIs[1] Operand 2
     /*   6473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6504 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6508 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6513 */     // MIs[3] Operand 2
     /*   6513 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6526 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6570 */     // GIR_Coverage, 5388,
     /*   6570 */     GIR_EraseRootFromParent_Done,
     /*   6571 */   // Label 197: @6571
     /*   6571 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6707), // Rule ID 5398 //
     /*   6576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6609 */     // MIs[1] Operand 2
     /*   6609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6636 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6640 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6644 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6649 */     // MIs[3] Operand 2
     /*   6649 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6660 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6662 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6706 */     // GIR_Coverage, 5398,
     /*   6706 */     GIR_EraseRootFromParent_Done,
     /*   6707 */   // Label 198: @6707
     /*   6707 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6843), // Rule ID 5387 //
     /*   6712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6745 */     // MIs[1] Operand 2
     /*   6745 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6772 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6776 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6780 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6785 */     // MIs[3] Operand 2
     /*   6785 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6798 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6842 */     // GIR_Coverage, 5387,
     /*   6842 */     GIR_EraseRootFromParent_Done,
     /*   6843 */   // Label 199: @6843
     /*   6843 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6979), // Rule ID 5386 //
     /*   6848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6881 */     // MIs[1] Operand 2
     /*   6881 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6916 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6921 */     // MIs[3] Operand 2
     /*   6921 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6934 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6978 */     // GIR_Coverage, 5386,
     /*   6978 */     GIR_EraseRootFromParent_Done,
     /*   6979 */   // Label 200: @6979
     /*   6979 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(7047), // Rule ID 6945 //
     /*   6984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   7013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7025 */     // MIs[2] Rn
     /*   7025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7036 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7045 */     GIR_RootConstrainSelectedInstOperands,
     /*   7046 */     // GIR_Coverage, 6945,
     /*   7046 */     GIR_EraseRootFromParent_Done,
     /*   7047 */   // Label 201: @7047
     /*   7047 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7115), // Rule ID 14014 //
     /*   7052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7093 */     // MIs[2] Rn
     /*   7093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7104 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 14014,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 202: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7148), // Rule ID 13280 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7135 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7146 */     GIR_RootConstrainSelectedInstOperands,
     /*   7147 */     // GIR_Coverage, 13280,
     /*   7147 */     GIR_EraseRootFromParent_Done,
     /*   7148 */   // Label 203: @7148
     /*   7148 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7281), // Rule ID 3970 //
     /*   7153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7190 */     // MIs[2] Operand 2
     /*   7190 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7213 */     // MIs[3] Operand 1
     /*   7213 */     // No operand predicates
     /*   7213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7219 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7231 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7279 */     GIR_RootConstrainSelectedInstOperands,
     /*   7280 */     // GIR_Coverage, 3970,
     /*   7280 */     GIR_EraseRootFromParent_Done,
     /*   7281 */   // Label 204: @7281
     /*   7281 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7376), // Rule ID 3968 //
     /*   7286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7335 */     // MIs[3] Operand 1
     /*   7335 */     // No operand predicates
     /*   7335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7341 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7353 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7374 */     GIR_RootConstrainSelectedInstOperands,
     /*   7375 */     // GIR_Coverage, 3968,
     /*   7375 */     GIR_EraseRootFromParent_Done,
     /*   7376 */   // Label 205: @7376
     /*   7376 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7471), // Rule ID 3969 //
     /*   7381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7430 */     // MIs[3] Operand 1
     /*   7430 */     // No operand predicates
     /*   7430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7436 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7448 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7469 */     GIR_RootConstrainSelectedInstOperands,
     /*   7470 */     // GIR_Coverage, 3969,
     /*   7470 */     GIR_EraseRootFromParent_Done,
     /*   7471 */   // Label 206: @7471
     /*   7471 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7504), // Rule ID 92 //
     /*   7476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7491 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7502 */     GIR_RootConstrainSelectedInstOperands,
     /*   7503 */     // GIR_Coverage, 92,
     /*   7503 */     GIR_EraseRootFromParent_Done,
     /*   7504 */   // Label 207: @7504
     /*   7504 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7637), // Rule ID 13866 //
     /*   7509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7550 */     // MIs[2] Operand 2
     /*   7550 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7573 */     // MIs[3] Operand 1
     /*   7573 */     // No operand predicates
     /*   7573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7575 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7587 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7635 */     GIR_RootConstrainSelectedInstOperands,
     /*   7636 */     // GIR_Coverage, 13866,
     /*   7636 */     GIR_EraseRootFromParent_Done,
     /*   7637 */   // Label 208: @7637
     /*   7637 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7732), // Rule ID 13864 //
     /*   7642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7695 */     // MIs[3] Operand 1
     /*   7695 */     // No operand predicates
     /*   7695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7697 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7730 */     GIR_RootConstrainSelectedInstOperands,
     /*   7731 */     // GIR_Coverage, 13864,
     /*   7731 */     GIR_EraseRootFromParent_Done,
     /*   7732 */   // Label 209: @7732
     /*   7732 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7827), // Rule ID 13865 //
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7786 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7790 */     // MIs[3] Operand 1
     /*   7790 */     // No operand predicates
     /*   7790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7792 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7804 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7825 */     GIR_RootConstrainSelectedInstOperands,
     /*   7826 */     // GIR_Coverage, 13865,
     /*   7826 */     GIR_EraseRootFromParent_Done,
     /*   7827 */   // Label 210: @7827
     /*   7827 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7909), // Rule ID 13291 //
     /*   7832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7892 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7907 */     GIR_RootConstrainSelectedInstOperands,
     /*   7908 */     // GIR_Coverage, 13291,
     /*   7908 */     GIR_EraseRootFromParent_Done,
     /*   7909 */   // Label 211: @7909
     /*   7909 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7991), // Rule ID 13292 //
     /*   7914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7974 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7989 */     GIR_RootConstrainSelectedInstOperands,
     /*   7990 */     // GIR_Coverage, 13292,
     /*   7990 */     GIR_EraseRootFromParent_Done,
     /*   7991 */   // Label 212: @7991
     /*   7991 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8073), // Rule ID 123 //
     /*   7996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8056 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8071 */     GIR_RootConstrainSelectedInstOperands,
     /*   8072 */     // GIR_Coverage, 123,
     /*   8072 */     GIR_EraseRootFromParent_Done,
     /*   8073 */   // Label 213: @8073
     /*   8073 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8155), // Rule ID 125 //
     /*   8078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8138 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8153 */     GIR_RootConstrainSelectedInstOperands,
     /*   8154 */     // GIR_Coverage, 125,
     /*   8154 */     GIR_EraseRootFromParent_Done,
     /*   8155 */   // Label 214: @8155
     /*   8155 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8213), // Rule ID 13711 //
     /*   8160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8183 */     // MIs[1] pattern
     /*   8183 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8186 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8197 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8211 */     GIR_RootConstrainSelectedInstOperands,
     /*   8212 */     // GIR_Coverage, 13711,
     /*   8212 */     GIR_EraseRootFromParent_Done,
     /*   8213 */   // Label 215: @8213
     /*   8213 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8271), // Rule ID 15565 //
     /*   8218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8233 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8236 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8241 */     // MIs[1] pattern
     /*   8241 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8244 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8255 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8269 */     GIR_RootConstrainSelectedInstOperands,
     /*   8270 */     // GIR_Coverage, 15565,
     /*   8270 */     GIR_EraseRootFromParent_Done,
     /*   8271 */   // Label 216: @8271
     /*   8271 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8329), // Rule ID 15577 //
     /*   8276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8299 */     // MIs[1] pattern
     /*   8299 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8302 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8313 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8327 */     GIR_RootConstrainSelectedInstOperands,
     /*   8328 */     // GIR_Coverage, 15577,
     /*   8328 */     GIR_EraseRootFromParent_Done,
     /*   8329 */   // Label 217: @8329
     /*   8329 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8387), // Rule ID 15589 //
     /*   8334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8349 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8352 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8357 */     // MIs[1] pattern
     /*   8357 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8360 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8371 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8385 */     GIR_RootConstrainSelectedInstOperands,
     /*   8386 */     // GIR_Coverage, 15589,
     /*   8386 */     GIR_EraseRootFromParent_Done,
     /*   8387 */   // Label 218: @8387
     /*   8387 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8445), // Rule ID 2646 //
     /*   8392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8411 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8414 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8419 */     // MIs[1] pattern
     /*   8419 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8422 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8429 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8443 */     GIR_RootConstrainSelectedInstOperands,
     /*   8444 */     // GIR_Coverage, 2646,
     /*   8444 */     GIR_EraseRootFromParent_Done,
     /*   8445 */   // Label 219: @8445
     /*   8445 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8503), // Rule ID 9990 //
     /*   8450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8469 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8472 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8477 */     // MIs[1] pattern
     /*   8477 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8480 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8487 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 9990,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 220: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8561), // Rule ID 10002 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8527 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8530 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8535 */     // MIs[1] pattern
     /*   8535 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8538 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8545 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8559 */     GIR_RootConstrainSelectedInstOperands,
     /*   8560 */     // GIR_Coverage, 10002,
     /*   8560 */     GIR_EraseRootFromParent_Done,
     /*   8561 */   // Label 221: @8561
     /*   8561 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8619), // Rule ID 10014 //
     /*   8566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8585 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8588 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8593 */     // MIs[1] pattern
     /*   8593 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8596 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8603 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8617 */     GIR_RootConstrainSelectedInstOperands,
     /*   8618 */     // GIR_Coverage, 10014,
     /*   8618 */     GIR_EraseRootFromParent_Done,
     /*   8619 */   // Label 222: @8619
     /*   8619 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8782), // Rule ID 13986 //
     /*   8624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8666 */     // MIs[1] Operand 2
     /*   8666 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8683 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8683 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8686 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8690 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8709 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8712 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8716 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8764 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8781 */     // GIR_Coverage, 13986,
     /*   8781 */     GIR_EraseRootFromParent_Done,
     /*   8782 */   // Label 223: @8782
     /*   8782 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8945), // Rule ID 13983 //
     /*   8787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8829 */     // MIs[1] Operand 2
     /*   8829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8846 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8872 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8879 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8882 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8909 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8927 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8944 */     // GIR_Coverage, 13983,
     /*   8944 */     GIR_EraseRootFromParent_Done,
     /*   8945 */   // Label 224: @8945
     /*   8945 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(9095), // Rule ID 13992 //
     /*   8950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8983 */     // MIs[1] Operand 2
     /*   8983 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9000 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9029 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9077 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9094 */     // GIR_Coverage, 13992,
     /*   9094 */     GIR_EraseRootFromParent_Done,
     /*   9095 */   // Label 225: @9095
     /*   9095 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(9245), // Rule ID 13995 //
     /*   9100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9133 */     // MIs[1] Operand 2
     /*   9133 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9150 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9150 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9153 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9157 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9176 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9244 */     // GIR_Coverage, 13995,
     /*   9244 */     GIR_EraseRootFromParent_Done,
     /*   9245 */   // Label 226: @9245
     /*   9245 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9395), // Rule ID 13991 //
     /*   9250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9283 */     // MIs[1] Operand 2
     /*   9283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9300 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9300 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9303 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9307 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9326 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9329 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9333 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9336 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9341 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9377 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9394 */     // GIR_Coverage, 13991,
     /*   9394 */     GIR_EraseRootFromParent_Done,
     /*   9395 */   // Label 227: @9395
     /*   9395 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9558), // Rule ID 5371 //
     /*   9400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9446 */     // MIs[1] Operand 2
     /*   9446 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9459 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9485 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9492 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9557 */     // GIR_Coverage, 5371,
     /*   9557 */     GIR_EraseRootFromParent_Done,
     /*   9558 */   // Label 228: @9558
     /*   9558 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9721), // Rule ID 5368 //
     /*   9563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9609 */     // MIs[1] Operand 2
     /*   9609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9622 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9622 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9625 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9629 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9636 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9639 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9643 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9648 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9651 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9655 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9720 */     // GIR_Coverage, 5368,
     /*   9720 */     GIR_EraseRootFromParent_Done,
     /*   9721 */   // Label 229: @9721
     /*   9721 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9871), // Rule ID 5395 //
     /*   9726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9763 */     // MIs[1] Operand 2
     /*   9763 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9776 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9776 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9779 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9783 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9802 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9809 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9839 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9853 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9870 */     // GIR_Coverage, 5395,
     /*   9870 */     GIR_EraseRootFromParent_Done,
     /*   9871 */   // Label 230: @9871
     /*   9871 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(10021), // Rule ID 5401 //
     /*   9876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9913 */     // MIs[1] Operand 2
     /*   9913 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9926 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9926 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9929 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9933 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9940 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9943 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9947 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9952 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9959 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9972 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9989 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10020 */     // GIR_Coverage, 5401,
     /*  10020 */     GIR_EraseRootFromParent_Done,
     /*  10021 */   // Label 231: @10021
     /*  10021 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(10171), // Rule ID 5394 //
     /*  10026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10063 */     // MIs[1] Operand 2
     /*  10063 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10076 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10102 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10109 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10170 */     // GIR_Coverage, 5394,
     /*  10170 */     GIR_EraseRootFromParent_Done,
     /*  10171 */   // Label 232: @10171
     /*  10171 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10204), // Rule ID 13284 //
     /*  10176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10191 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10202 */     GIR_RootConstrainSelectedInstOperands,
     /*  10203 */     // GIR_Coverage, 13284,
     /*  10203 */     GIR_EraseRootFromParent_Done,
     /*  10204 */   // Label 233: @10204
     /*  10204 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10240), // Rule ID 13857 //
     /*  10209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10224 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10238 */     GIR_RootConstrainSelectedInstOperands,
     /*  10239 */     // GIR_Coverage, 13857,
     /*  10239 */     GIR_EraseRootFromParent_Done,
     /*  10240 */   // Label 234: @10240
     /*  10240 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10273), // Rule ID 98 //
     /*  10245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10260 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10271 */     GIR_RootConstrainSelectedInstOperands,
     /*  10272 */     // GIR_Coverage, 98,
     /*  10272 */     GIR_EraseRootFromParent_Done,
     /*  10273 */   // Label 235: @10273
     /*  10273 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10309), // Rule ID 3919 //
     /*  10278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10293 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10307 */     GIR_RootConstrainSelectedInstOperands,
     /*  10308 */     // GIR_Coverage, 3919,
     /*  10308 */     GIR_EraseRootFromParent_Done,
     /*  10309 */   // Label 236: @10309
     /*  10309 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10342), // Rule ID 13282 //
     /*  10314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10329 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10340 */     GIR_RootConstrainSelectedInstOperands,
     /*  10341 */     // GIR_Coverage, 13282,
     /*  10341 */     GIR_EraseRootFromParent_Done,
     /*  10342 */   // Label 237: @10342
     /*  10342 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10405), // Rule ID 15605 //
     /*  10347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10362 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10365 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10381 */     // MIs[1] pred
     /*  10381 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10392 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10403 */     GIR_RootConstrainSelectedInstOperands,
     /*  10404 */     // GIR_Coverage, 15605,
     /*  10404 */     GIR_EraseRootFromParent_Done,
     /*  10405 */   // Label 238: @10405
     /*  10405 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10468), // Rule ID 15606 //
     /*  10410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10425 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10428 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10444 */     // MIs[1] pred
     /*  10444 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10455 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10466 */     GIR_RootConstrainSelectedInstOperands,
     /*  10467 */     // GIR_Coverage, 15606,
     /*  10467 */     GIR_EraseRootFromParent_Done,
     /*  10468 */   // Label 239: @10468
     /*  10468 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10531), // Rule ID 15607 //
     /*  10473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10488 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10491 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10507 */     // MIs[1] pred
     /*  10507 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10518 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10529 */     GIR_RootConstrainSelectedInstOperands,
     /*  10530 */     // GIR_Coverage, 15607,
     /*  10530 */     GIR_EraseRootFromParent_Done,
     /*  10531 */   // Label 240: @10531
     /*  10531 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10594), // Rule ID 15608 //
     /*  10536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10551 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10554 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10563 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10570 */     // MIs[1] pred
     /*  10570 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10581 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10592 */     GIR_RootConstrainSelectedInstOperands,
     /*  10593 */     // GIR_Coverage, 15608,
     /*  10593 */     GIR_EraseRootFromParent_Done,
     /*  10594 */   // Label 241: @10594
     /*  10594 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10627), // Rule ID 96 //
     /*  10599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10614 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10625 */     GIR_RootConstrainSelectedInstOperands,
     /*  10626 */     // GIR_Coverage, 96,
     /*  10626 */     GIR_EraseRootFromParent_Done,
     /*  10627 */   // Label 242: @10627
     /*  10627 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10690), // Rule ID 10101 //
     /*  10632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10651 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10654 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10670 */     // MIs[1] pred
     /*  10670 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10677 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10688 */     GIR_RootConstrainSelectedInstOperands,
     /*  10689 */     // GIR_Coverage, 10101,
     /*  10689 */     GIR_EraseRootFromParent_Done,
     /*  10690 */   // Label 243: @10690
     /*  10690 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10753), // Rule ID 10102 //
     /*  10695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10714 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10717 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10733 */     // MIs[1] pred
     /*  10733 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10740 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10751 */     GIR_RootConstrainSelectedInstOperands,
     /*  10752 */     // GIR_Coverage, 10102,
     /*  10752 */     GIR_EraseRootFromParent_Done,
     /*  10753 */   // Label 244: @10753
     /*  10753 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10816), // Rule ID 10103 //
     /*  10758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10777 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10780 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10789 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10796 */     // MIs[1] pred
     /*  10796 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10803 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10814 */     GIR_RootConstrainSelectedInstOperands,
     /*  10815 */     // GIR_Coverage, 10103,
     /*  10815 */     GIR_EraseRootFromParent_Done,
     /*  10816 */   // Label 245: @10816
     /*  10816 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10879), // Rule ID 10104 //
     /*  10821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10840 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10843 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10859 */     // MIs[1] pred
     /*  10859 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10866 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10877 */     GIR_RootConstrainSelectedInstOperands,
     /*  10878 */     // GIR_Coverage, 10104,
     /*  10878 */     GIR_EraseRootFromParent_Done,
     /*  10879 */   // Label 246: @10879
     /*  10879 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(10935), // Rule ID 13390 //
     /*  10884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10922 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 667:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10933 */     GIR_RootConstrainSelectedInstOperands,
     /*  10934 */     // GIR_Coverage, 13390,
     /*  10934 */     GIR_EraseRootFromParent_Done,
     /*  10935 */   // Label 247: @10935
     /*  10935 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(10991), // Rule ID 13402 //
     /*  10940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10955 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10958 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10978 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10989 */     GIR_RootConstrainSelectedInstOperands,
     /*  10990 */     // GIR_Coverage, 13402,
     /*  10990 */     GIR_EraseRootFromParent_Done,
     /*  10991 */   // Label 248: @10991
     /*  10991 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11058), // Rule ID 13618 //
     /*  10996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11020 */     // MIs[1] imm
     /*  11020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11032 */     // MIs[2] Operand 1
     /*  11032 */     // No operand predicates
     /*  11032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11042 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11056 */     GIR_RootConstrainSelectedInstOperands,
     /*  11057 */     // GIR_Coverage, 13618,
     /*  11057 */     GIR_EraseRootFromParent_Done,
     /*  11058 */   // Label 249: @11058
     /*  11058 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11125), // Rule ID 13621 //
     /*  11063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11087 */     // MIs[1] imm
     /*  11087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11099 */     // MIs[2] Operand 1
     /*  11099 */     // No operand predicates
     /*  11099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11109 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11123 */     GIR_RootConstrainSelectedInstOperands,
     /*  11124 */     // GIR_Coverage, 13621,
     /*  11124 */     GIR_EraseRootFromParent_Done,
     /*  11125 */   // Label 250: @11125
     /*  11125 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11181), // Rule ID 997 //
     /*  11130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11168 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 667:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11179 */     GIR_RootConstrainSelectedInstOperands,
     /*  11180 */     // GIR_Coverage, 997,
     /*  11180 */     GIR_EraseRootFromParent_Done,
     /*  11181 */   // Label 251: @11181
     /*  11181 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11237), // Rule ID 1058 //
     /*  11186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11224 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11235 */     GIR_RootConstrainSelectedInstOperands,
     /*  11236 */     // GIR_Coverage, 1058,
     /*  11236 */     GIR_EraseRootFromParent_Done,
     /*  11237 */   // Label 252: @11237
     /*  11237 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11304), // Rule ID 2121 //
     /*  11242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11270 */     // MIs[1] imm
     /*  11270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11282 */     // MIs[2] Operand 1
     /*  11282 */     // No operand predicates
     /*  11282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11288 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11302 */     GIR_RootConstrainSelectedInstOperands,
     /*  11303 */     // GIR_Coverage, 2121,
     /*  11303 */     GIR_EraseRootFromParent_Done,
     /*  11304 */   // Label 253: @11304
     /*  11304 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11371), // Rule ID 2130 //
     /*  11309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11337 */     // MIs[1] imm
     /*  11337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11345 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11349 */     // MIs[2] Operand 1
     /*  11349 */     // No operand predicates
     /*  11349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11355 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11369 */     GIR_RootConstrainSelectedInstOperands,
     /*  11370 */     // GIR_Coverage, 2130,
     /*  11370 */     GIR_EraseRootFromParent_Done,
     /*  11371 */   // Label 254: @11371
     /*  11371 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11419), // Rule ID 13389 //
     /*  11376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11406 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11417 */     GIR_RootConstrainSelectedInstOperands,
     /*  11418 */     // GIR_Coverage, 13389,
     /*  11418 */     GIR_EraseRootFromParent_Done,
     /*  11419 */   // Label 255: @11419
     /*  11419 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11467), // Rule ID 13401 //
     /*  11424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11454 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11465 */     GIR_RootConstrainSelectedInstOperands,
     /*  11466 */     // GIR_Coverage, 13401,
     /*  11466 */     GIR_EraseRootFromParent_Done,
     /*  11467 */   // Label 256: @11467
     /*  11467 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11515), // Rule ID 996 //
     /*  11472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11502 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11513 */     GIR_RootConstrainSelectedInstOperands,
     /*  11514 */     // GIR_Coverage, 996,
     /*  11514 */     GIR_EraseRootFromParent_Done,
     /*  11515 */   // Label 257: @11515
     /*  11515 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11563), // Rule ID 1057 //
     /*  11520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11550 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11561 */     GIR_RootConstrainSelectedInstOperands,
     /*  11562 */     // GIR_Coverage, 1057,
     /*  11562 */     GIR_EraseRootFromParent_Done,
     /*  11563 */   // Label 258: @11563
     /*  11563 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11587), // Rule ID 94 //
     /*  11568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11580 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11585 */     GIR_RootConstrainSelectedInstOperands,
     /*  11586 */     // GIR_Coverage, 94,
     /*  11586 */     GIR_Done,
     /*  11587 */   // Label 259: @11587
     /*  11587 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11614), // Rule ID 1607 //
     /*  11592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11607 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11612 */     GIR_RootConstrainSelectedInstOperands,
     /*  11613 */     // GIR_Coverage, 1607,
     /*  11613 */     GIR_Done,
     /*  11614 */   // Label 260: @11614
     /*  11614 */   GIM_Reject,
     /*  11615 */ // Label 195: @11615
     /*  11615 */ GIM_Reject,
     /*  11616 */ // Label 157: @11616
     /*  11616 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(15223),
     /*  11621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11627 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11815), // Rule ID 6966 //
     /*  11632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11669 */     // MIs[2] Operand 2
     /*  11669 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11688 */     // MIs[3] Rn
     /*  11688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11693 */     // MIs[3] Operand 2
     /*  11693 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11712 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11716 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11720 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11724 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11728 */     // MIs[5] Rn
     /*  11728 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11733 */     // MIs[5] Operand 2
     /*  11733 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11744 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11748 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11752 */     // MIs[6] Rn
     /*  11752 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11757 */     // MIs[6] Operand 2
     /*  11757 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11768 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11770 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11814 */     // GIR_Coverage, 6966,
     /*  11814 */     GIR_EraseRootFromParent_Done,
     /*  11815 */   // Label 262: @11815
     /*  11815 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12003), // Rule ID 14025 //
     /*  11820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11857 */     // MIs[2] Operand 2
     /*  11857 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11876 */     // MIs[3] Rn
     /*  11876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11881 */     // MIs[3] Operand 2
     /*  11881 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11896 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11900 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11904 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11908 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11912 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11916 */     // MIs[5] Rn
     /*  11916 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11921 */     // MIs[5] Operand 2
     /*  11921 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11932 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11936 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11940 */     // MIs[6] Rn
     /*  11940 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11945 */     // MIs[6] Operand 2
     /*  11945 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11956 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11958 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11985 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12002 */     // GIR_Coverage, 14025,
     /*  12002 */     GIR_EraseRootFromParent_Done,
     /*  12003 */   // Label 263: @12003
     /*  12003 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12139), // Rule ID 5385 //
     /*  12008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12041 */     // MIs[1] Operand 2
     /*  12041 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12068 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12072 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12076 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12081 */     // MIs[3] Operand 2
     /*  12081 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12092 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12094 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12121 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12138 */     // GIR_Coverage, 5385,
     /*  12138 */     GIR_EraseRootFromParent_Done,
     /*  12139 */   // Label 264: @12139
     /*  12139 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12275), // Rule ID 5384 //
     /*  12144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12177 */     // MIs[1] Operand 2
     /*  12177 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12208 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12212 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12217 */     // MIs[3] Operand 2
     /*  12217 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12228 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12230 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12257 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12274 */     // GIR_Coverage, 5384,
     /*  12274 */     GIR_EraseRootFromParent_Done,
     /*  12275 */   // Label 265: @12275
     /*  12275 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12411), // Rule ID 5397 //
     /*  12280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12313 */     // MIs[1] Operand 2
     /*  12313 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12336 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12340 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12344 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12348 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12353 */     // MIs[3] Operand 2
     /*  12353 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12364 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12366 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12393 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12410 */     // GIR_Coverage, 5397,
     /*  12410 */     GIR_EraseRootFromParent_Done,
     /*  12411 */   // Label 266: @12411
     /*  12411 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12547), // Rule ID 5383 //
     /*  12416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12449 */     // MIs[1] Operand 2
     /*  12449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12489 */     // MIs[3] Operand 2
     /*  12489 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12502 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12546 */     // GIR_Coverage, 5383,
     /*  12546 */     GIR_EraseRootFromParent_Done,
     /*  12547 */   // Label 267: @12547
     /*  12547 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12683), // Rule ID 5382 //
     /*  12552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12585 */     // MIs[1] Operand 2
     /*  12585 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12616 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12620 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12625 */     // MIs[3] Operand 2
     /*  12625 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12638 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12665 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12682 */     // GIR_Coverage, 5382,
     /*  12682 */     GIR_EraseRootFromParent_Done,
     /*  12683 */   // Label 268: @12683
     /*  12683 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12846), // Rule ID 13985 //
     /*  12688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12730 */     // MIs[1] Operand 2
     /*  12730 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12747 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12747 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12750 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12754 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12773 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12776 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12780 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12783 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  12805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12828 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12845 */     // GIR_Coverage, 13985,
     /*  12845 */     GIR_EraseRootFromParent_Done,
     /*  12846 */   // Label 269: @12846
     /*  12846 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(13009), // Rule ID 13982 //
     /*  12851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  12875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12893 */     // MIs[1] Operand 2
     /*  12893 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12910 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12936 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12943 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13008 */     // GIR_Coverage, 13982,
     /*  13008 */     GIR_EraseRootFromParent_Done,
     /*  13009 */   // Label 270: @13009
     /*  13009 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(13159), // Rule ID 13990 //
     /*  13014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13047 */     // MIs[1] Operand 2
     /*  13047 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13064 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13064 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13067 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13071 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13090 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13093 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13097 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13158 */     // GIR_Coverage, 13990,
     /*  13158 */     GIR_EraseRootFromParent_Done,
     /*  13159 */   // Label 271: @13159
     /*  13159 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(13309), // Rule ID 13994 //
     /*  13164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13197 */     // MIs[1] Operand 2
     /*  13197 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13214 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13214 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13217 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13221 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13228 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13231 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13235 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13240 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13243 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13247 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13277 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13308 */     // GIR_Coverage, 13994,
     /*  13308 */     GIR_EraseRootFromParent_Done,
     /*  13309 */   // Label 272: @13309
     /*  13309 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13459), // Rule ID 13989 //
     /*  13314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13347 */     // MIs[1] Operand 2
     /*  13347 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13364 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13364 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13367 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13371 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13390 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13393 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13397 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13458 */     // GIR_Coverage, 13989,
     /*  13458 */     GIR_EraseRootFromParent_Done,
     /*  13459 */   // Label 273: @13459
     /*  13459 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13622), // Rule ID 5370 //
     /*  13464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13510 */     // MIs[1] Operand 2
     /*  13510 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13523 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13523 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13526 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13530 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13549 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13556 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13569 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13586 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13621 */     // GIR_Coverage, 5370,
     /*  13621 */     GIR_EraseRootFromParent_Done,
     /*  13622 */   // Label 274: @13622
     /*  13622 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13785), // Rule ID 5367 //
     /*  13627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13673 */     // MIs[1] Operand 2
     /*  13673 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13686 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13686 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13689 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13693 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13700 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13703 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13707 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13712 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13715 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13719 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13727 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13749 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13784 */     // GIR_Coverage, 5367,
     /*  13784 */     GIR_EraseRootFromParent_Done,
     /*  13785 */   // Label 275: @13785
     /*  13785 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13935), // Rule ID 5393 //
     /*  13790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13827 */     // MIs[1] Operand 2
     /*  13827 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13840 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13866 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13934 */     // GIR_Coverage, 5393,
     /*  13934 */     GIR_EraseRootFromParent_Done,
     /*  13935 */   // Label 276: @13935
     /*  13935 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(14085), // Rule ID 5400 //
     /*  13940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13977 */     // MIs[1] Operand 2
     /*  13977 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13990 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14004 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14007 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14011 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14016 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14023 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14053 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14067 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14084 */     // GIR_Coverage, 5400,
     /*  14084 */     GIR_EraseRootFromParent_Done,
     /*  14085 */   // Label 277: @14085
     /*  14085 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(14235), // Rule ID 5392 //
     /*  14090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14127 */     // MIs[1] Operand 2
     /*  14127 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14140 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14140 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14143 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14147 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14166 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14173 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14217 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14234 */     // GIR_Coverage, 5392,
     /*  14234 */     GIR_EraseRootFromParent_Done,
     /*  14235 */   // Label 278: @14235
     /*  14235 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(14304), // Rule ID 13424 //
     /*  14240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14287 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14302 */     GIR_RootConstrainSelectedInstOperands,
     /*  14303 */     // GIR_Coverage, 13424,
     /*  14303 */     GIR_EraseRootFromParent_Done,
     /*  14304 */   // Label 279: @14304
     /*  14304 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14373), // Rule ID 13436 //
     /*  14309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14356 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14371 */     GIR_RootConstrainSelectedInstOperands,
     /*  14372 */     // GIR_Coverage, 13436,
     /*  14372 */     GIR_EraseRootFromParent_Done,
     /*  14373 */   // Label 280: @14373
     /*  14373 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14429), // Rule ID 13386 //
     /*  14378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14416 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14427 */     GIR_RootConstrainSelectedInstOperands,
     /*  14428 */     // GIR_Coverage, 13386,
     /*  14428 */     GIR_EraseRootFromParent_Done,
     /*  14429 */   // Label 281: @14429
     /*  14429 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14485), // Rule ID 13398 //
     /*  14434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14449 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14452 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14472 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14483 */     GIR_RootConstrainSelectedInstOperands,
     /*  14484 */     // GIR_Coverage, 13398,
     /*  14484 */     GIR_EraseRootFromParent_Done,
     /*  14485 */   // Label 282: @14485
     /*  14485 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14552), // Rule ID 13638 //
     /*  14490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14514 */     // MIs[1] imm
     /*  14514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14526 */     // MIs[2] Operand 1
     /*  14526 */     // No operand predicates
     /*  14526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14536 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14550 */     GIR_RootConstrainSelectedInstOperands,
     /*  14551 */     // GIR_Coverage, 13638,
     /*  14551 */     GIR_EraseRootFromParent_Done,
     /*  14552 */   // Label 283: @14552
     /*  14552 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14619), // Rule ID 13659 //
     /*  14557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14581 */     // MIs[1] imm
     /*  14581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14593 */     // MIs[2] Operand 1
     /*  14593 */     // No operand predicates
     /*  14593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14603 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14617 */     GIR_RootConstrainSelectedInstOperands,
     /*  14618 */     // GIR_Coverage, 13659,
     /*  14618 */     GIR_EraseRootFromParent_Done,
     /*  14619 */   // Label 284: @14619
     /*  14619 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14688), // Rule ID 1365 //
     /*  14624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14643 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14646 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14655 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14671 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14686 */     GIR_RootConstrainSelectedInstOperands,
     /*  14687 */     // GIR_Coverage, 1365,
     /*  14687 */     GIR_EraseRootFromParent_Done,
     /*  14688 */   // Label 285: @14688
     /*  14688 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14757), // Rule ID 1488 //
     /*  14693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14712 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14715 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14724 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14740 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14755 */     GIR_RootConstrainSelectedInstOperands,
     /*  14756 */     // GIR_Coverage, 1488,
     /*  14756 */     GIR_EraseRootFromParent_Done,
     /*  14757 */   // Label 286: @14757
     /*  14757 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14813), // Rule ID 993 //
     /*  14762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14781 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14784 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14800 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14811 */     GIR_RootConstrainSelectedInstOperands,
     /*  14812 */     // GIR_Coverage, 993,
     /*  14812 */     GIR_EraseRootFromParent_Done,
     /*  14813 */   // Label 287: @14813
     /*  14813 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14869), // Rule ID 1054 //
     /*  14818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14837 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14840 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14856 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14867 */     GIR_RootConstrainSelectedInstOperands,
     /*  14868 */     // GIR_Coverage, 1054,
     /*  14868 */     GIR_EraseRootFromParent_Done,
     /*  14869 */   // Label 288: @14869
     /*  14869 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14936), // Rule ID 2238 //
     /*  14874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14902 */     // MIs[1] imm
     /*  14902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14910 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14914 */     // MIs[2] Operand 1
     /*  14914 */     // No operand predicates
     /*  14914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14920 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14934 */     GIR_RootConstrainSelectedInstOperands,
     /*  14935 */     // GIR_Coverage, 2238,
     /*  14935 */     GIR_EraseRootFromParent_Done,
     /*  14936 */   // Label 289: @14936
     /*  14936 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15003), // Rule ID 2297 //
     /*  14941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14969 */     // MIs[1] imm
     /*  14969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14981 */     // MIs[2] Operand 1
     /*  14981 */     // No operand predicates
     /*  14981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14987 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15001 */     GIR_RootConstrainSelectedInstOperands,
     /*  15002 */     // GIR_Coverage, 2297,
     /*  15002 */     GIR_EraseRootFromParent_Done,
     /*  15003 */   // Label 290: @15003
     /*  15003 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15051), // Rule ID 13385 //
     /*  15008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15038 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15049 */     GIR_RootConstrainSelectedInstOperands,
     /*  15050 */     // GIR_Coverage, 13385,
     /*  15050 */     GIR_EraseRootFromParent_Done,
     /*  15051 */   // Label 291: @15051
     /*  15051 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15099), // Rule ID 13397 //
     /*  15056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15086 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15097 */     GIR_RootConstrainSelectedInstOperands,
     /*  15098 */     // GIR_Coverage, 13397,
     /*  15098 */     GIR_EraseRootFromParent_Done,
     /*  15099 */   // Label 292: @15099
     /*  15099 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15147), // Rule ID 992 //
     /*  15104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15134 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15145 */     GIR_RootConstrainSelectedInstOperands,
     /*  15146 */     // GIR_Coverage, 992,
     /*  15146 */     GIR_EraseRootFromParent_Done,
     /*  15147 */   // Label 293: @15147
     /*  15147 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15195), // Rule ID 1053 //
     /*  15152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15182 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15193 */     GIR_RootConstrainSelectedInstOperands,
     /*  15194 */     // GIR_Coverage, 1053,
     /*  15194 */     GIR_EraseRootFromParent_Done,
     /*  15195 */   // Label 294: @15195
     /*  15195 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15222), // Rule ID 1104 //
     /*  15200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15215 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15220 */     GIR_RootConstrainSelectedInstOperands,
     /*  15221 */     // GIR_Coverage, 1104,
     /*  15221 */     GIR_Done,
     /*  15222 */   // Label 295: @15222
     /*  15222 */   GIM_Reject,
     /*  15223 */ // Label 261: @15223
     /*  15223 */ GIM_Reject,
     /*  15224 */ // Label 158: @15224
     /*  15224 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(21125),
     /*  15229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15235 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15353), // Rule ID 13567 //
     /*  15240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15283 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15287 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15291 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15300 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15304 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15308 */     // MIs[4] Operand 1
     /*  15308 */     // No operand predicates
     /*  15308 */     // MIs[2] Operand 2
     /*  15308 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15323 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15332 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15351 */     GIR_RootConstrainSelectedInstOperands,
     /*  15352 */     // GIR_Coverage, 13567,
     /*  15352 */     GIR_EraseRootFromParent_Done,
     /*  15353 */   // Label 297: @15353
     /*  15353 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15471), // Rule ID 13568 //
     /*  15358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15401 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15405 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15409 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15414 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15418 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15422 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15426 */     // MIs[4] Operand 1
     /*  15426 */     // No operand predicates
     /*  15426 */     // MIs[2] Operand 2
     /*  15426 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15441 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15450 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15469 */     GIR_RootConstrainSelectedInstOperands,
     /*  15470 */     // GIR_Coverage, 13568,
     /*  15470 */     GIR_EraseRootFromParent_Done,
     /*  15471 */   // Label 298: @15471
     /*  15471 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15589), // Rule ID 13603 //
     /*  15476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15519 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15527 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15540 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15544 */     // MIs[4] Operand 1
     /*  15544 */     // No operand predicates
     /*  15544 */     // MIs[2] Operand 2
     /*  15544 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15559 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15568 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15587 */     GIR_RootConstrainSelectedInstOperands,
     /*  15588 */     // GIR_Coverage, 13603,
     /*  15588 */     GIR_EraseRootFromParent_Done,
     /*  15589 */   // Label 299: @15589
     /*  15589 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15707), // Rule ID 13604 //
     /*  15594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15641 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15645 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15654 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15658 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15662 */     // MIs[4] Operand 1
     /*  15662 */     // No operand predicates
     /*  15662 */     // MIs[2] Operand 2
     /*  15662 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15677 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15686 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15705 */     GIR_RootConstrainSelectedInstOperands,
     /*  15706 */     // GIR_Coverage, 13604,
     /*  15706 */     GIR_EraseRootFromParent_Done,
     /*  15707 */   // Label 300: @15707
     /*  15707 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15825), // Rule ID 2042 //
     /*  15712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15763 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15767 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15776 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15780 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15784 */     // MIs[4] Operand 1
     /*  15784 */     // No operand predicates
     /*  15784 */     // MIs[2] Operand 2
     /*  15784 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15795 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15804 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15823 */     GIR_RootConstrainSelectedInstOperands,
     /*  15824 */     // GIR_Coverage, 2042,
     /*  15824 */     GIR_EraseRootFromParent_Done,
     /*  15825 */   // Label 301: @15825
     /*  15825 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15943), // Rule ID 13566 //
     /*  15830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15881 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15885 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15898 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15902 */     // MIs[4] Operand 1
     /*  15902 */     // No operand predicates
     /*  15902 */     // MIs[2] Operand 2
     /*  15902 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15913 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15922 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15941 */     GIR_RootConstrainSelectedInstOperands,
     /*  15942 */     // GIR_Coverage, 13566,
     /*  15942 */     GIR_EraseRootFromParent_Done,
     /*  15943 */   // Label 302: @15943
     /*  15943 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(16061), // Rule ID 2094 //
     /*  15948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15999 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16003 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16008 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16012 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16016 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16020 */     // MIs[4] Operand 1
     /*  16020 */     // No operand predicates
     /*  16020 */     // MIs[2] Operand 2
     /*  16020 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16031 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16040 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16059 */     GIR_RootConstrainSelectedInstOperands,
     /*  16060 */     // GIR_Coverage, 2094,
     /*  16060 */     GIR_EraseRootFromParent_Done,
     /*  16061 */   // Label 303: @16061
     /*  16061 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(16179), // Rule ID 13602 //
     /*  16066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16113 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16117 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16121 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16126 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16130 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16134 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16138 */     // MIs[4] Operand 1
     /*  16138 */     // No operand predicates
     /*  16138 */     // MIs[2] Operand 2
     /*  16138 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16149 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16158 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16177 */     GIR_RootConstrainSelectedInstOperands,
     /*  16178 */     // GIR_Coverage, 13602,
     /*  16178 */     GIR_EraseRootFromParent_Done,
     /*  16179 */   // Label 304: @16179
     /*  16179 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16266), // Rule ID 13468 //
     /*  16184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16211 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16214 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16223 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16247 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16264 */     GIR_RootConstrainSelectedInstOperands,
     /*  16265 */     // GIR_Coverage, 13468,
     /*  16265 */     GIR_EraseRootFromParent_Done,
     /*  16266 */   // Label 305: @16266
     /*  16266 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16353), // Rule ID 13496 //
     /*  16271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16298 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16301 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16310 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16334 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16351 */     GIR_RootConstrainSelectedInstOperands,
     /*  16352 */     // GIR_Coverage, 13496,
     /*  16352 */     GIR_EraseRootFromParent_Done,
     /*  16353 */   // Label 306: @16353
     /*  16353 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16440), // Rule ID 1699 //
     /*  16358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16389 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16392 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16401 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16421 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16438 */     GIR_RootConstrainSelectedInstOperands,
     /*  16439 */     // GIR_Coverage, 1699,
     /*  16439 */     GIR_EraseRootFromParent_Done,
     /*  16440 */   // Label 307: @16440
     /*  16440 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16527), // Rule ID 1777 //
     /*  16445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16476 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16479 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16488 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16508 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16525 */     GIR_RootConstrainSelectedInstOperands,
     /*  16526 */     // GIR_Coverage, 1777,
     /*  16526 */     GIR_EraseRootFromParent_Done,
     /*  16527 */   // Label 308: @16527
     /*  16527 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16642), // Rule ID 13562 //
     /*  16532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16583 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16596 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16600 */     // MIs[4] Operand 1
     /*  16600 */     // No operand predicates
     /*  16600 */     // MIs[2] Operand 2
     /*  16600 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16622 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16640 */     GIR_RootConstrainSelectedInstOperands,
     /*  16641 */     // GIR_Coverage, 13562,
     /*  16641 */     GIR_EraseRootFromParent_Done,
     /*  16642 */   // Label 309: @16642
     /*  16642 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16757), // Rule ID 13561 //
     /*  16647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16699 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16703 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16716 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16720 */     // MIs[4] Operand 1
     /*  16720 */     // No operand predicates
     /*  16720 */     // MIs[2] Operand 2
     /*  16720 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16735 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16737 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16755 */     GIR_RootConstrainSelectedInstOperands,
     /*  16756 */     // GIR_Coverage, 13561,
     /*  16756 */     GIR_EraseRootFromParent_Done,
     /*  16757 */   // Label 310: @16757
     /*  16757 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16872), // Rule ID 13598 //
     /*  16762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16805 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16809 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16813 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16826 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16830 */     // MIs[4] Operand 1
     /*  16830 */     // No operand predicates
     /*  16830 */     // MIs[2] Operand 2
     /*  16830 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16852 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16870 */     GIR_RootConstrainSelectedInstOperands,
     /*  16871 */     // GIR_Coverage, 13598,
     /*  16871 */     GIR_EraseRootFromParent_Done,
     /*  16872 */   // Label 311: @16872
     /*  16872 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16987), // Rule ID 13597 //
     /*  16877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16929 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16946 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16950 */     // MIs[4] Operand 1
     /*  16950 */     // No operand predicates
     /*  16950 */     // MIs[2] Operand 2
     /*  16950 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16965 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16967 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16985 */     GIR_RootConstrainSelectedInstOperands,
     /*  16986 */     // GIR_Coverage, 13597,
     /*  16986 */     GIR_EraseRootFromParent_Done,
     /*  16987 */   // Label 312: @16987
     /*  16987 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(17056), // Rule ID 1801 //
     /*  16992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17039 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17054 */     GIR_RootConstrainSelectedInstOperands,
     /*  17055 */     // GIR_Coverage, 1801,
     /*  17055 */     GIR_EraseRootFromParent_Done,
     /*  17056 */   // Label 313: @17056
     /*  17056 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17125), // Rule ID 1800 //
     /*  17061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17108 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17123 */     GIR_RootConstrainSelectedInstOperands,
     /*  17124 */     // GIR_Coverage, 1800,
     /*  17124 */     GIR_EraseRootFromParent_Done,
     /*  17125 */   // Label 314: @17125
     /*  17125 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17194), // Rule ID 1717 //
     /*  17130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17177 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17192 */     GIR_RootConstrainSelectedInstOperands,
     /*  17193 */     // GIR_Coverage, 1717,
     /*  17193 */     GIR_EraseRootFromParent_Done,
     /*  17194 */   // Label 315: @17194
     /*  17194 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17263), // Rule ID 1799 //
     /*  17199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17246 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17261 */     GIR_RootConstrainSelectedInstOperands,
     /*  17262 */     // GIR_Coverage, 1799,
     /*  17262 */     GIR_EraseRootFromParent_Done,
     /*  17263 */   // Label 316: @17263
     /*  17263 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17332), // Rule ID 1798 //
     /*  17268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17315 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17330 */     GIR_RootConstrainSelectedInstOperands,
     /*  17331 */     // GIR_Coverage, 1798,
     /*  17331 */     GIR_EraseRootFromParent_Done,
     /*  17332 */   // Label 317: @17332
     /*  17332 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17447), // Rule ID 13560 //
     /*  17337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17384 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17388 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17392 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17397 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17401 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17405 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17409 */     // MIs[4] Operand 1
     /*  17409 */     // No operand predicates
     /*  17409 */     // MIs[2] Operand 2
     /*  17409 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17425 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17427 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17445 */     GIR_RootConstrainSelectedInstOperands,
     /*  17446 */     // GIR_Coverage, 13560,
     /*  17446 */     GIR_EraseRootFromParent_Done,
     /*  17447 */   // Label 318: @17447
     /*  17447 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17562), // Rule ID 2040 //
     /*  17452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17508 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17512 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17517 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17521 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17525 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17529 */     // MIs[4] Operand 1
     /*  17529 */     // No operand predicates
     /*  17529 */     // MIs[2] Operand 2
     /*  17529 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17542 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17560 */     GIR_RootConstrainSelectedInstOperands,
     /*  17561 */     // GIR_Coverage, 2040,
     /*  17561 */     GIR_EraseRootFromParent_Done,
     /*  17562 */   // Label 319: @17562
     /*  17562 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17677), // Rule ID 13596 //
     /*  17567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17622 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17635 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17639 */     // MIs[4] Operand 1
     /*  17639 */     // No operand predicates
     /*  17639 */     // MIs[2] Operand 2
     /*  17639 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17657 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17675 */     GIR_RootConstrainSelectedInstOperands,
     /*  17676 */     // GIR_Coverage, 13596,
     /*  17676 */     GIR_EraseRootFromParent_Done,
     /*  17677 */   // Label 320: @17677
     /*  17677 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17792), // Rule ID 2092 //
     /*  17682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17734 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17738 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17742 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17747 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17751 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17755 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17759 */     // MIs[4] Operand 1
     /*  17759 */     // No operand predicates
     /*  17759 */     // MIs[2] Operand 2
     /*  17759 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17772 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17790 */     GIR_RootConstrainSelectedInstOperands,
     /*  17791 */     // GIR_Coverage, 2092,
     /*  17791 */     GIR_EraseRootFromParent_Done,
     /*  17792 */   // Label 321: @17792
     /*  17792 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17859), // Rule ID 13480 //
     /*  17797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17840 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17857 */     GIR_RootConstrainSelectedInstOperands,
     /*  17858 */     // GIR_Coverage, 13480,
     /*  17858 */     GIR_EraseRootFromParent_Done,
     /*  17859 */   // Label 322: @17859
     /*  17859 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17926), // Rule ID 13514 //
     /*  17864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17907 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17924 */     GIR_RootConstrainSelectedInstOperands,
     /*  17925 */     // GIR_Coverage, 13514,
     /*  17925 */     GIR_EraseRootFromParent_Done,
     /*  17926 */   // Label 323: @17926
     /*  17926 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17993), // Rule ID 1729 //
     /*  17931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17974 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17991 */     GIR_RootConstrainSelectedInstOperands,
     /*  17992 */     // GIR_Coverage, 1729,
     /*  17992 */     GIR_EraseRootFromParent_Done,
     /*  17993 */   // Label 324: @17993
     /*  17993 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18060), // Rule ID 1819 //
     /*  17998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18041 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18058 */     GIR_RootConstrainSelectedInstOperands,
     /*  18059 */     // GIR_Coverage, 1819,
     /*  18059 */     GIR_EraseRootFromParent_Done,
     /*  18060 */   // Label 325: @18060
     /*  18060 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18141), // Rule ID 13466 //
     /*  18065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18092 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18095 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18104 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18124 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18139 */     GIR_RootConstrainSelectedInstOperands,
     /*  18140 */     // GIR_Coverage, 13466,
     /*  18140 */     GIR_EraseRootFromParent_Done,
     /*  18141 */   // Label 326: @18141
     /*  18141 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18222), // Rule ID 13494 //
     /*  18146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18173 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18176 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18185 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18205 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18220 */     GIR_RootConstrainSelectedInstOperands,
     /*  18221 */     // GIR_Coverage, 13494,
     /*  18221 */     GIR_EraseRootFromParent_Done,
     /*  18222 */   // Label 327: @18222
     /*  18222 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18303), // Rule ID 1697 //
     /*  18227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18258 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18261 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18270 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18286 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18301 */     GIR_RootConstrainSelectedInstOperands,
     /*  18302 */     // GIR_Coverage, 1697,
     /*  18302 */     GIR_EraseRootFromParent_Done,
     /*  18303 */   // Label 328: @18303
     /*  18303 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18384), // Rule ID 1775 //
     /*  18308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18339 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18342 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18351 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18367 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18382 */     GIR_RootConstrainSelectedInstOperands,
     /*  18383 */     // GIR_Coverage, 1775,
     /*  18383 */     GIR_EraseRootFromParent_Done,
     /*  18384 */   // Label 329: @18384
     /*  18384 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18476), // Rule ID 13565 //
     /*  18389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18445 */     // MIs[3] Operand 1
     /*  18445 */     // No operand predicates
     /*  18445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18456 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18474 */     GIR_RootConstrainSelectedInstOperands,
     /*  18475 */     // GIR_Coverage, 13565,
     /*  18475 */     GIR_EraseRootFromParent_Done,
     /*  18476 */   // Label 330: @18476
     /*  18476 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18568), // Rule ID 13564 //
     /*  18481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18542 */     // MIs[3] Operand 1
     /*  18542 */     // No operand predicates
     /*  18542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18548 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18566 */     GIR_RootConstrainSelectedInstOperands,
     /*  18567 */     // GIR_Coverage, 13564,
     /*  18567 */     GIR_EraseRootFromParent_Done,
     /*  18568 */   // Label 331: @18568
     /*  18568 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18660), // Rule ID 13601 //
     /*  18573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18625 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18629 */     // MIs[3] Operand 1
     /*  18629 */     // No operand predicates
     /*  18629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18640 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18658 */     GIR_RootConstrainSelectedInstOperands,
     /*  18659 */     // GIR_Coverage, 13601,
     /*  18659 */     GIR_EraseRootFromParent_Done,
     /*  18660 */   // Label 332: @18660
     /*  18660 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18752), // Rule ID 13600 //
     /*  18665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18722 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18726 */     // MIs[3] Operand 1
     /*  18726 */     // No operand predicates
     /*  18726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18732 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18750 */     GIR_RootConstrainSelectedInstOperands,
     /*  18751 */     // GIR_Coverage, 13600,
     /*  18751 */     GIR_EraseRootFromParent_Done,
     /*  18752 */   // Label 333: @18752
     /*  18752 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18844), // Rule ID 13563 //
     /*  18757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18817 */     // MIs[3] Operand 1
     /*  18817 */     // No operand predicates
     /*  18817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18824 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18842 */     GIR_RootConstrainSelectedInstOperands,
     /*  18843 */     // GIR_Coverage, 13563,
     /*  18843 */     GIR_EraseRootFromParent_Done,
     /*  18844 */   // Label 334: @18844
     /*  18844 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18936), // Rule ID 2041 //
     /*  18849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18914 */     // MIs[3] Operand 1
     /*  18914 */     // No operand predicates
     /*  18914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18916 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18934 */     GIR_RootConstrainSelectedInstOperands,
     /*  18935 */     // GIR_Coverage, 2041,
     /*  18935 */     GIR_EraseRootFromParent_Done,
     /*  18936 */   // Label 335: @18936
     /*  18936 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19028), // Rule ID 13599 //
     /*  18941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18997 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19001 */     // MIs[3] Operand 1
     /*  19001 */     // No operand predicates
     /*  19001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19008 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19026 */     GIR_RootConstrainSelectedInstOperands,
     /*  19027 */     // GIR_Coverage, 13599,
     /*  19027 */     GIR_EraseRootFromParent_Done,
     /*  19028 */   // Label 336: @19028
     /*  19028 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19120), // Rule ID 2093 //
     /*  19033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19094 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19098 */     // MIs[3] Operand 1
     /*  19098 */     // No operand predicates
     /*  19098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19100 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19118 */     GIR_RootConstrainSelectedInstOperands,
     /*  19119 */     // GIR_Coverage, 2093,
     /*  19119 */     GIR_EraseRootFromParent_Done,
     /*  19120 */   // Label 337: @19120
     /*  19120 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19171), // Rule ID 13508 //
     /*  19125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19157 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19169 */     GIR_RootConstrainSelectedInstOperands,
     /*  19170 */     // GIR_Coverage, 13508,
     /*  19170 */     GIR_EraseRootFromParent_Done,
     /*  19171 */   // Label 338: @19171
     /*  19171 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19222), // Rule ID 13474 //
     /*  19176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19208 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19220 */     GIR_RootConstrainSelectedInstOperands,
     /*  19221 */     // GIR_Coverage, 13474,
     /*  19221 */     GIR_EraseRootFromParent_Done,
     /*  19222 */   // Label 339: @19222
     /*  19222 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19273), // Rule ID 13507 //
     /*  19227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19259 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19271 */     GIR_RootConstrainSelectedInstOperands,
     /*  19272 */     // GIR_Coverage, 13507,
     /*  19272 */     GIR_EraseRootFromParent_Done,
     /*  19273 */   // Label 340: @19273
     /*  19273 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19324), // Rule ID 1813 //
     /*  19278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19310 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19322 */     GIR_RootConstrainSelectedInstOperands,
     /*  19323 */     // GIR_Coverage, 1813,
     /*  19323 */     GIR_EraseRootFromParent_Done,
     /*  19324 */   // Label 341: @19324
     /*  19324 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19375), // Rule ID 1723 //
     /*  19329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19361 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19373 */     GIR_RootConstrainSelectedInstOperands,
     /*  19374 */     // GIR_Coverage, 1723,
     /*  19374 */     GIR_EraseRootFromParent_Done,
     /*  19375 */   // Label 342: @19375
     /*  19375 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19426), // Rule ID 1812 //
     /*  19380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19412 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19424 */     GIR_RootConstrainSelectedInstOperands,
     /*  19425 */     // GIR_Coverage, 1812,
     /*  19425 */     GIR_EraseRootFromParent_Done,
     /*  19426 */   // Label 343: @19426
     /*  19426 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19482), // Rule ID 13392 //
     /*  19431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19469 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19480 */     GIR_RootConstrainSelectedInstOperands,
     /*  19481 */     // GIR_Coverage, 13392,
     /*  19481 */     GIR_EraseRootFromParent_Done,
     /*  19482 */   // Label 344: @19482
     /*  19482 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19538), // Rule ID 13404 //
     /*  19487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19502 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19505 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19525 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19536 */     GIR_RootConstrainSelectedInstOperands,
     /*  19537 */     // GIR_Coverage, 13404,
     /*  19537 */     GIR_EraseRootFromParent_Done,
     /*  19538 */   // Label 345: @19538
     /*  19538 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19605), // Rule ID 13642 //
     /*  19543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19567 */     // MIs[1] imm
     /*  19567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19579 */     // MIs[2] Operand 1
     /*  19579 */     // No operand predicates
     /*  19579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19589 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19603 */     GIR_RootConstrainSelectedInstOperands,
     /*  19604 */     // GIR_Coverage, 13642,
     /*  19604 */     GIR_EraseRootFromParent_Done,
     /*  19605 */   // Label 346: @19605
     /*  19605 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19672), // Rule ID 13663 //
     /*  19610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19634 */     // MIs[1] imm
     /*  19634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19646 */     // MIs[2] Operand 1
     /*  19646 */     // No operand predicates
     /*  19646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19656 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19670 */     GIR_RootConstrainSelectedInstOperands,
     /*  19671 */     // GIR_Coverage, 13663,
     /*  19671 */     GIR_EraseRootFromParent_Done,
     /*  19672 */   // Label 347: @19672
     /*  19672 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19728), // Rule ID 999 //
     /*  19677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19715 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19726 */     GIR_RootConstrainSelectedInstOperands,
     /*  19727 */     // GIR_Coverage, 999,
     /*  19727 */     GIR_EraseRootFromParent_Done,
     /*  19728 */   // Label 348: @19728
     /*  19728 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19784), // Rule ID 1060 //
     /*  19733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19752 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19755 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19771 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19782 */     GIR_RootConstrainSelectedInstOperands,
     /*  19783 */     // GIR_Coverage, 1060,
     /*  19783 */     GIR_EraseRootFromParent_Done,
     /*  19784 */   // Label 349: @19784
     /*  19784 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19851), // Rule ID 2242 //
     /*  19789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19817 */     // MIs[1] imm
     /*  19817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19829 */     // MIs[2] Operand 1
     /*  19829 */     // No operand predicates
     /*  19829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19835 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19849 */     GIR_RootConstrainSelectedInstOperands,
     /*  19850 */     // GIR_Coverage, 2242,
     /*  19850 */     GIR_EraseRootFromParent_Done,
     /*  19851 */   // Label 350: @19851
     /*  19851 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19918), // Rule ID 2301 //
     /*  19856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19884 */     // MIs[1] imm
     /*  19884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19896 */     // MIs[2] Operand 1
     /*  19896 */     // No operand predicates
     /*  19896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19902 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19916 */     GIR_RootConstrainSelectedInstOperands,
     /*  19917 */     // GIR_Coverage, 2301,
     /*  19917 */     GIR_EraseRootFromParent_Done,
     /*  19918 */   // Label 351: @19918
     /*  19918 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19988), // Rule ID 6962 //
     /*  19923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19961 */     // MIs[2] Rn
     /*  19961 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19966 */     // MIs[2] Rm
     /*  19966 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19973 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19986 */     GIR_RootConstrainSelectedInstOperands,
     /*  19987 */     // GIR_Coverage, 6962,
     /*  19987 */     GIR_EraseRootFromParent_Done,
     /*  19988 */   // Label 352: @19988
     /*  19988 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20058), // Rule ID 14021 //
     /*  19993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20031 */     // MIs[2] Rn
     /*  20031 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20036 */     // MIs[2] Rm
     /*  20036 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20043 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20056 */     GIR_RootConstrainSelectedInstOperands,
     /*  20057 */     // GIR_Coverage, 14021,
     /*  20057 */     GIR_EraseRootFromParent_Done,
     /*  20058 */   // Label 353: @20058
     /*  20058 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20121), // Rule ID 1797 //
     /*  20063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20106 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20119 */     GIR_RootConstrainSelectedInstOperands,
     /*  20120 */     // GIR_Coverage, 1797,
     /*  20120 */     GIR_EraseRootFromParent_Done,
     /*  20121 */   // Label 354: @20121
     /*  20121 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20184), // Rule ID 1796 //
     /*  20126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20169 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20182 */     GIR_RootConstrainSelectedInstOperands,
     /*  20183 */     // GIR_Coverage, 1796,
     /*  20183 */     GIR_EraseRootFromParent_Done,
     /*  20184 */   // Label 355: @20184
     /*  20184 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20247), // Rule ID 1716 //
     /*  20189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20232 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20245 */     GIR_RootConstrainSelectedInstOperands,
     /*  20246 */     // GIR_Coverage, 1716,
     /*  20246 */     GIR_EraseRootFromParent_Done,
     /*  20247 */   // Label 356: @20247
     /*  20247 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20310), // Rule ID 1795 //
     /*  20252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20295 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20308 */     GIR_RootConstrainSelectedInstOperands,
     /*  20309 */     // GIR_Coverage, 1795,
     /*  20309 */     GIR_EraseRootFromParent_Done,
     /*  20310 */   // Label 357: @20310
     /*  20310 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20373), // Rule ID 1794 //
     /*  20315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20358 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20371 */     GIR_RootConstrainSelectedInstOperands,
     /*  20372 */     // GIR_Coverage, 1794,
     /*  20372 */     GIR_EraseRootFromParent_Done,
     /*  20373 */   // Label 358: @20373
     /*  20373 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20434), // Rule ID 13479 //
     /*  20378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20417 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20432 */     GIR_RootConstrainSelectedInstOperands,
     /*  20433 */     // GIR_Coverage, 13479,
     /*  20433 */     GIR_EraseRootFromParent_Done,
     /*  20434 */   // Label 359: @20434
     /*  20434 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20495), // Rule ID 13513 //
     /*  20439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20478 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20493 */     GIR_RootConstrainSelectedInstOperands,
     /*  20494 */     // GIR_Coverage, 13513,
     /*  20494 */     GIR_EraseRootFromParent_Done,
     /*  20495 */   // Label 360: @20495
     /*  20495 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20543), // Rule ID 13506 //
     /*  20500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20530 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20541 */     GIR_RootConstrainSelectedInstOperands,
     /*  20542 */     // GIR_Coverage, 13506,
     /*  20542 */     GIR_EraseRootFromParent_Done,
     /*  20543 */   // Label 361: @20543
     /*  20543 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20591), // Rule ID 13391 //
     /*  20548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20578 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20589 */     GIR_RootConstrainSelectedInstOperands,
     /*  20590 */     // GIR_Coverage, 13391,
     /*  20590 */     GIR_EraseRootFromParent_Done,
     /*  20591 */   // Label 362: @20591
     /*  20591 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20639), // Rule ID 13473 //
     /*  20596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20626 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20637 */     GIR_RootConstrainSelectedInstOperands,
     /*  20638 */     // GIR_Coverage, 13473,
     /*  20638 */     GIR_EraseRootFromParent_Done,
     /*  20639 */   // Label 363: @20639
     /*  20639 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20687), // Rule ID 13403 //
     /*  20644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20674 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20685 */     GIR_RootConstrainSelectedInstOperands,
     /*  20686 */     // GIR_Coverage, 13403,
     /*  20686 */     GIR_EraseRootFromParent_Done,
     /*  20687 */   // Label 364: @20687
     /*  20687 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20735), // Rule ID 13505 //
     /*  20692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20722 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20733 */     GIR_RootConstrainSelectedInstOperands,
     /*  20734 */     // GIR_Coverage, 13505,
     /*  20734 */     GIR_EraseRootFromParent_Done,
     /*  20735 */   // Label 365: @20735
     /*  20735 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20796), // Rule ID 1728 //
     /*  20740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20779 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20794 */     GIR_RootConstrainSelectedInstOperands,
     /*  20795 */     // GIR_Coverage, 1728,
     /*  20795 */     GIR_EraseRootFromParent_Done,
     /*  20796 */   // Label 366: @20796
     /*  20796 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20857), // Rule ID 1818 //
     /*  20801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20840 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20855 */     GIR_RootConstrainSelectedInstOperands,
     /*  20856 */     // GIR_Coverage, 1818,
     /*  20856 */     GIR_EraseRootFromParent_Done,
     /*  20857 */   // Label 367: @20857
     /*  20857 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20905), // Rule ID 1811 //
     /*  20862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20892 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20903 */     GIR_RootConstrainSelectedInstOperands,
     /*  20904 */     // GIR_Coverage, 1811,
     /*  20904 */     GIR_EraseRootFromParent_Done,
     /*  20905 */   // Label 368: @20905
     /*  20905 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20953), // Rule ID 998 //
     /*  20910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20940 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20951 */     GIR_RootConstrainSelectedInstOperands,
     /*  20952 */     // GIR_Coverage, 998,
     /*  20952 */     GIR_EraseRootFromParent_Done,
     /*  20953 */   // Label 369: @20953
     /*  20953 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21001), // Rule ID 1722 //
     /*  20958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20988 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20999 */     GIR_RootConstrainSelectedInstOperands,
     /*  21000 */     // GIR_Coverage, 1722,
     /*  21000 */     GIR_EraseRootFromParent_Done,
     /*  21001 */   // Label 370: @21001
     /*  21001 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21049), // Rule ID 1059 //
     /*  21006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21036 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21047 */     GIR_RootConstrainSelectedInstOperands,
     /*  21048 */     // GIR_Coverage, 1059,
     /*  21048 */     GIR_EraseRootFromParent_Done,
     /*  21049 */   // Label 371: @21049
     /*  21049 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(21097), // Rule ID 1810 //
     /*  21054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21095 */     GIR_RootConstrainSelectedInstOperands,
     /*  21096 */     // GIR_Coverage, 1810,
     /*  21096 */     GIR_EraseRootFromParent_Done,
     /*  21097 */   // Label 372: @21097
     /*  21097 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21124), // Rule ID 1106 //
     /*  21102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21117 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21122 */     GIR_RootConstrainSelectedInstOperands,
     /*  21123 */     // GIR_Coverage, 1106,
     /*  21123 */     GIR_Done,
     /*  21124 */   // Label 373: @21124
     /*  21124 */   GIM_Reject,
     /*  21125 */ // Label 296: @21125
     /*  21125 */ GIM_Reject,
     /*  21126 */ // Label 159: @21126
     /*  21126 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(24623),
     /*  21131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21137 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21273), // Rule ID 5381 //
     /*  21142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21175 */     // MIs[1] Operand 2
     /*  21175 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21206 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21210 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21215 */     // MIs[3] Operand 2
     /*  21215 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21226 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21228 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21244 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21272 */     // GIR_Coverage, 5381,
     /*  21272 */     GIR_EraseRootFromParent_Done,
     /*  21273 */   // Label 375: @21273
     /*  21273 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21409), // Rule ID 5380 //
     /*  21278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21311 */     // MIs[1] Operand 2
     /*  21311 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21338 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21342 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21346 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21351 */     // MIs[3] Operand 2
     /*  21351 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21362 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21364 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21408 */     // GIR_Coverage, 5380,
     /*  21408 */     GIR_EraseRootFromParent_Done,
     /*  21409 */   // Label 376: @21409
     /*  21409 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21545), // Rule ID 5396 //
     /*  21414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21447 */     // MIs[1] Operand 2
     /*  21447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21478 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21482 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21487 */     // MIs[3] Operand 2
     /*  21487 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21498 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21500 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21527 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21544 */     // GIR_Coverage, 5396,
     /*  21544 */     GIR_EraseRootFromParent_Done,
     /*  21545 */   // Label 377: @21545
     /*  21545 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21681), // Rule ID 5379 //
     /*  21550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21583 */     // MIs[1] Operand 2
     /*  21583 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21606 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21610 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21614 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21618 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21623 */     // MIs[3] Operand 2
     /*  21623 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21634 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21636 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21663 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21680 */     // GIR_Coverage, 5379,
     /*  21680 */     GIR_EraseRootFromParent_Done,
     /*  21681 */   // Label 378: @21681
     /*  21681 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21817), // Rule ID 5378 //
     /*  21686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21719 */     // MIs[1] Operand 2
     /*  21719 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21742 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21746 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21750 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21759 */     // MIs[3] Operand 2
     /*  21759 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21772 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21799 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21816 */     // GIR_Coverage, 5378,
     /*  21816 */     GIR_EraseRootFromParent_Done,
     /*  21817 */   // Label 379: @21817
     /*  21817 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21950), // Rule ID 14026 //
     /*  21822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  21846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21867 */     // MIs[1] Operand 2
     /*  21867 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  21882 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21886 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21890 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21894 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21898 */     // MIs[5] Rn
     /*  21898 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21903 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21905 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21932 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21949 */     // GIR_Coverage, 14026,
     /*  21949 */     GIR_EraseRootFromParent_Done,
     /*  21950 */   // Label 380: @21950
     /*  21950 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22083), // Rule ID 6967 //
     /*  21955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22004 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22008 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22012 */     // MIs[4] Rn
     /*  22012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22017 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22021 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22025 */     // MIs[3] Operand 2
     /*  22025 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22036 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22038 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22065 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22082 */     // GIR_Coverage, 6967,
     /*  22082 */     GIR_EraseRootFromParent_Done,
     /*  22083 */   // Label 381: @22083
     /*  22083 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22246), // Rule ID 13984 //
     /*  22088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22130 */     // MIs[1] Operand 2
     /*  22130 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22147 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22147 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22150 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22154 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22173 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22176 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22180 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22183 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22210 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22228 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22245 */     // GIR_Coverage, 13984,
     /*  22245 */     GIR_EraseRootFromParent_Done,
     /*  22246 */   // Label 382: @22246
     /*  22246 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22409), // Rule ID 13981 //
     /*  22251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22293 */     // MIs[1] Operand 2
     /*  22293 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22310 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22324 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22327 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22331 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22336 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22343 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22408 */     // GIR_Coverage, 13981,
     /*  22408 */     GIR_EraseRootFromParent_Done,
     /*  22409 */   // Label 383: @22409
     /*  22409 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22559), // Rule ID 13988 //
     /*  22414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22447 */     // MIs[1] Operand 2
     /*  22447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22464 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22490 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22558 */     // GIR_Coverage, 13988,
     /*  22558 */     GIR_EraseRootFromParent_Done,
     /*  22559 */   // Label 384: @22559
     /*  22559 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22709), // Rule ID 13993 //
     /*  22564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22597 */     // MIs[1] Operand 2
     /*  22597 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22614 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22640 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22647 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22677 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22691 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22708 */     // GIR_Coverage, 13993,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 385: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22859), // Rule ID 13987 //
     /*  22714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22747 */     // MIs[1] Operand 2
     /*  22747 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22764 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22764 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22767 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22771 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22778 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22781 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22785 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22790 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22793 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22797 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22841 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22858 */     // GIR_Coverage, 13987,
     /*  22858 */     GIR_EraseRootFromParent_Done,
     /*  22859 */   // Label 386: @22859
     /*  22859 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(23022), // Rule ID 5369 //
     /*  22864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22910 */     // MIs[1] Operand 2
     /*  22910 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22923 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22923 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22926 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22930 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22949 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22952 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  22956 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23004 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23021 */     // GIR_Coverage, 5369,
     /*  23021 */     GIR_EraseRootFromParent_Done,
     /*  23022 */   // Label 387: @23022
     /*  23022 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(23185), // Rule ID 5366 //
     /*  23027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23073 */     // MIs[1] Operand 2
     /*  23073 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23086 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23086 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23089 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23093 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23100 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23103 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23107 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23112 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23119 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23167 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23184 */     // GIR_Coverage, 5366,
     /*  23184 */     GIR_EraseRootFromParent_Done,
     /*  23185 */   // Label 388: @23185
     /*  23185 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(23335), // Rule ID 5391 //
     /*  23190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23227 */     // MIs[1] Operand 2
     /*  23227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23240 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23240 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23243 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23247 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23266 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23269 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23273 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23276 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23317 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23334 */     // GIR_Coverage, 5391,
     /*  23334 */     GIR_EraseRootFromParent_Done,
     /*  23335 */   // Label 389: @23335
     /*  23335 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23485), // Rule ID 5399 //
     /*  23340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23377 */     // MIs[1] Operand 2
     /*  23377 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23390 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23390 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23393 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23397 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23416 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23423 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23426 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23467 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23484 */     // GIR_Coverage, 5399,
     /*  23484 */     GIR_EraseRootFromParent_Done,
     /*  23485 */   // Label 390: @23485
     /*  23485 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23635), // Rule ID 5390 //
     /*  23490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23527 */     // MIs[1] Operand 2
     /*  23527 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23540 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23566 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23573 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23634 */     // GIR_Coverage, 5390,
     /*  23634 */     GIR_EraseRootFromParent_Done,
     /*  23635 */   // Label 391: @23635
     /*  23635 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23704), // Rule ID 13420 //
     /*  23640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23687 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23702 */     GIR_RootConstrainSelectedInstOperands,
     /*  23703 */     // GIR_Coverage, 13420,
     /*  23703 */     GIR_EraseRootFromParent_Done,
     /*  23704 */   // Label 392: @23704
     /*  23704 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23773), // Rule ID 13432 //
     /*  23709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23756 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23771 */     GIR_RootConstrainSelectedInstOperands,
     /*  23772 */     // GIR_Coverage, 13432,
     /*  23772 */     GIR_EraseRootFromParent_Done,
     /*  23773 */   // Label 393: @23773
     /*  23773 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23829), // Rule ID 13382 //
     /*  23778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23793 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23796 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  23801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23816 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  23819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23827 */     GIR_RootConstrainSelectedInstOperands,
     /*  23828 */     // GIR_Coverage, 13382,
     /*  23828 */     GIR_EraseRootFromParent_Done,
     /*  23829 */   // Label 394: @23829
     /*  23829 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23885), // Rule ID 13394 //
     /*  23834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23849 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23852 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  23857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23872 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  23875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23883 */     GIR_RootConstrainSelectedInstOperands,
     /*  23884 */     // GIR_Coverage, 13394,
     /*  23884 */     GIR_EraseRootFromParent_Done,
     /*  23885 */   // Label 395: @23885
     /*  23885 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23952), // Rule ID 13634 //
     /*  23890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  23905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23914 */     // MIs[1] imm
     /*  23914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23926 */     // MIs[2] Operand 1
     /*  23926 */     // No operand predicates
     /*  23926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23936 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  23939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23950 */     GIR_RootConstrainSelectedInstOperands,
     /*  23951 */     // GIR_Coverage, 13634,
     /*  23951 */     GIR_EraseRootFromParent_Done,
     /*  23952 */   // Label 396: @23952
     /*  23952 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24019), // Rule ID 13655 //
     /*  23957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  23972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23981 */     // MIs[1] imm
     /*  23981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23993 */     // MIs[2] Operand 1
     /*  23993 */     // No operand predicates
     /*  23993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24003 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24017 */     GIR_RootConstrainSelectedInstOperands,
     /*  24018 */     // GIR_Coverage, 13655,
     /*  24018 */     GIR_EraseRootFromParent_Done,
     /*  24019 */   // Label 397: @24019
     /*  24019 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24088), // Rule ID 1361 //
     /*  24024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24043 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24046 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24071 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24086 */     GIR_RootConstrainSelectedInstOperands,
     /*  24087 */     // GIR_Coverage, 1361,
     /*  24087 */     GIR_EraseRootFromParent_Done,
     /*  24088 */   // Label 398: @24088
     /*  24088 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24157), // Rule ID 1484 //
     /*  24093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24112 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24115 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24140 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24155 */     GIR_RootConstrainSelectedInstOperands,
     /*  24156 */     // GIR_Coverage, 1484,
     /*  24156 */     GIR_EraseRootFromParent_Done,
     /*  24157 */   // Label 399: @24157
     /*  24157 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24213), // Rule ID 989 //
     /*  24162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24181 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24184 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24200 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24211 */     GIR_RootConstrainSelectedInstOperands,
     /*  24212 */     // GIR_Coverage, 989,
     /*  24212 */     GIR_EraseRootFromParent_Done,
     /*  24213 */   // Label 400: @24213
     /*  24213 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24269), // Rule ID 1050 //
     /*  24218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24237 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24240 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24256 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24267 */     GIR_RootConstrainSelectedInstOperands,
     /*  24268 */     // GIR_Coverage, 1050,
     /*  24268 */     GIR_EraseRootFromParent_Done,
     /*  24269 */   // Label 401: @24269
     /*  24269 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24336), // Rule ID 2234 //
     /*  24274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24302 */     // MIs[1] imm
     /*  24302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24314 */     // MIs[2] Operand 1
     /*  24314 */     // No operand predicates
     /*  24314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24320 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24334 */     GIR_RootConstrainSelectedInstOperands,
     /*  24335 */     // GIR_Coverage, 2234,
     /*  24335 */     GIR_EraseRootFromParent_Done,
     /*  24336 */   // Label 402: @24336
     /*  24336 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24403), // Rule ID 2293 //
     /*  24341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24369 */     // MIs[1] imm
     /*  24369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24381 */     // MIs[2] Operand 1
     /*  24381 */     // No operand predicates
     /*  24381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24387 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24401 */     GIR_RootConstrainSelectedInstOperands,
     /*  24402 */     // GIR_Coverage, 2293,
     /*  24402 */     GIR_EraseRootFromParent_Done,
     /*  24403 */   // Label 403: @24403
     /*  24403 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24451), // Rule ID 13381 //
     /*  24408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24438 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24449 */     GIR_RootConstrainSelectedInstOperands,
     /*  24450 */     // GIR_Coverage, 13381,
     /*  24450 */     GIR_EraseRootFromParent_Done,
     /*  24451 */   // Label 404: @24451
     /*  24451 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24499), // Rule ID 13393 //
     /*  24456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24486 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24497 */     GIR_RootConstrainSelectedInstOperands,
     /*  24498 */     // GIR_Coverage, 13393,
     /*  24498 */     GIR_EraseRootFromParent_Done,
     /*  24499 */   // Label 405: @24499
     /*  24499 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24547), // Rule ID 988 //
     /*  24504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24534 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24545 */     GIR_RootConstrainSelectedInstOperands,
     /*  24546 */     // GIR_Coverage, 988,
     /*  24546 */     GIR_EraseRootFromParent_Done,
     /*  24547 */   // Label 406: @24547
     /*  24547 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24595), // Rule ID 1049 //
     /*  24552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24582 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24593 */     GIR_RootConstrainSelectedInstOperands,
     /*  24594 */     // GIR_Coverage, 1049,
     /*  24594 */     GIR_EraseRootFromParent_Done,
     /*  24595 */   // Label 407: @24595
     /*  24595 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24622), // Rule ID 1102 //
     /*  24600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24615 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24620 */     GIR_RootConstrainSelectedInstOperands,
     /*  24621 */     // GIR_Coverage, 1102,
     /*  24621 */     GIR_Done,
     /*  24622 */   // Label 408: @24622
     /*  24622 */   GIM_Reject,
     /*  24623 */ // Label 374: @24623
     /*  24623 */ GIM_Reject,
     /*  24624 */ // Label 160: @24624
     /*  24624 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(30801),
     /*  24629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24635 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24753), // Rule ID 13558 //
     /*  24640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24687 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24700 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24704 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24708 */     // MIs[4] Operand 1
     /*  24708 */     // No operand predicates
     /*  24708 */     // MIs[2] Operand 2
     /*  24708 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24723 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24732 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24751 */     GIR_RootConstrainSelectedInstOperands,
     /*  24752 */     // GIR_Coverage, 13558,
     /*  24752 */     GIR_EraseRootFromParent_Done,
     /*  24753 */   // Label 410: @24753
     /*  24753 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24871), // Rule ID 13559 //
     /*  24758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24801 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24805 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24809 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24822 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24826 */     // MIs[4] Operand 1
     /*  24826 */     // No operand predicates
     /*  24826 */     // MIs[2] Operand 2
     /*  24826 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24841 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24850 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24869 */     GIR_RootConstrainSelectedInstOperands,
     /*  24870 */     // GIR_Coverage, 13559,
     /*  24870 */     GIR_EraseRootFromParent_Done,
     /*  24871 */   // Label 411: @24871
     /*  24871 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24989), // Rule ID 13594 //
     /*  24876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24923 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24927 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24932 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24936 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24940 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24944 */     // MIs[4] Operand 1
     /*  24944 */     // No operand predicates
     /*  24944 */     // MIs[2] Operand 2
     /*  24944 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24959 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24968 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  24971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24987 */     GIR_RootConstrainSelectedInstOperands,
     /*  24988 */     // GIR_Coverage, 13594,
     /*  24988 */     GIR_EraseRootFromParent_Done,
     /*  24989 */   // Label 412: @24989
     /*  24989 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25107), // Rule ID 13595 //
     /*  24994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25037 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25041 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25045 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25054 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25058 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25062 */     // MIs[4] Operand 1
     /*  25062 */     // No operand predicates
     /*  25062 */     // MIs[2] Operand 2
     /*  25062 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25077 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25086 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25105 */     GIR_RootConstrainSelectedInstOperands,
     /*  25106 */     // GIR_Coverage, 13595,
     /*  25106 */     GIR_EraseRootFromParent_Done,
     /*  25107 */   // Label 413: @25107
     /*  25107 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25225), // Rule ID 2039 //
     /*  25112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25159 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25167 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25180 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25184 */     // MIs[4] Operand 1
     /*  25184 */     // No operand predicates
     /*  25184 */     // MIs[2] Operand 2
     /*  25184 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25204 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25223 */     GIR_RootConstrainSelectedInstOperands,
     /*  25224 */     // GIR_Coverage, 2039,
     /*  25224 */     GIR_EraseRootFromParent_Done,
     /*  25225 */   // Label 414: @25225
     /*  25225 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(25343), // Rule ID 13557 //
     /*  25230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25281 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25285 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25294 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25298 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25302 */     // MIs[4] Operand 1
     /*  25302 */     // No operand predicates
     /*  25302 */     // MIs[2] Operand 2
     /*  25302 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25313 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25322 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25341 */     GIR_RootConstrainSelectedInstOperands,
     /*  25342 */     // GIR_Coverage, 13557,
     /*  25342 */     GIR_EraseRootFromParent_Done,
     /*  25343 */   // Label 415: @25343
     /*  25343 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25461), // Rule ID 2091 //
     /*  25348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25412 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25416 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25420 */     // MIs[4] Operand 1
     /*  25420 */     // No operand predicates
     /*  25420 */     // MIs[2] Operand 2
     /*  25420 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25431 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25440 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25459 */     GIR_RootConstrainSelectedInstOperands,
     /*  25460 */     // GIR_Coverage, 2091,
     /*  25460 */     GIR_EraseRootFromParent_Done,
     /*  25461 */   // Label 416: @25461
     /*  25461 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25579), // Rule ID 13593 //
     /*  25466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25517 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25521 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25530 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25534 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25538 */     // MIs[4] Operand 1
     /*  25538 */     // No operand predicates
     /*  25538 */     // MIs[2] Operand 2
     /*  25538 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25549 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25558 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25577 */     GIR_RootConstrainSelectedInstOperands,
     /*  25578 */     // GIR_Coverage, 13593,
     /*  25578 */     GIR_EraseRootFromParent_Done,
     /*  25579 */   // Label 417: @25579
     /*  25579 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25666), // Rule ID 13464 //
     /*  25584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25611 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25614 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25623 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25647 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25664 */     GIR_RootConstrainSelectedInstOperands,
     /*  25665 */     // GIR_Coverage, 13464,
     /*  25665 */     GIR_EraseRootFromParent_Done,
     /*  25666 */   // Label 418: @25666
     /*  25666 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25753), // Rule ID 13492 //
     /*  25671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25698 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25701 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25710 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25734 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25751 */     GIR_RootConstrainSelectedInstOperands,
     /*  25752 */     // GIR_Coverage, 13492,
     /*  25752 */     GIR_EraseRootFromParent_Done,
     /*  25753 */   // Label 419: @25753
     /*  25753 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25840), // Rule ID 1695 //
     /*  25758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25789 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25792 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25801 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25821 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25838 */     GIR_RootConstrainSelectedInstOperands,
     /*  25839 */     // GIR_Coverage, 1695,
     /*  25839 */     GIR_EraseRootFromParent_Done,
     /*  25840 */   // Label 420: @25840
     /*  25840 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25927), // Rule ID 1773 //
     /*  25845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25876 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25879 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25888 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25908 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25925 */     GIR_RootConstrainSelectedInstOperands,
     /*  25926 */     // GIR_Coverage, 1773,
     /*  25926 */     GIR_EraseRootFromParent_Done,
     /*  25927 */   // Label 421: @25927
     /*  25927 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(26042), // Rule ID 13553 //
     /*  25932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25979 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25983 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25996 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26000 */     // MIs[4] Operand 1
     /*  26000 */     // No operand predicates
     /*  26000 */     // MIs[2] Operand 2
     /*  26000 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26022 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26040 */     GIR_RootConstrainSelectedInstOperands,
     /*  26041 */     // GIR_Coverage, 13553,
     /*  26041 */     GIR_EraseRootFromParent_Done,
     /*  26042 */   // Label 422: @26042
     /*  26042 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26157), // Rule ID 13552 //
     /*  26047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26095 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26099 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26103 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26108 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26112 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26116 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26120 */     // MIs[4] Operand 1
     /*  26120 */     // No operand predicates
     /*  26120 */     // MIs[2] Operand 2
     /*  26120 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26137 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26155 */     GIR_RootConstrainSelectedInstOperands,
     /*  26156 */     // GIR_Coverage, 13552,
     /*  26156 */     GIR_EraseRootFromParent_Done,
     /*  26157 */   // Label 423: @26157
     /*  26157 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26272), // Rule ID 13589 //
     /*  26162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26226 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26230 */     // MIs[4] Operand 1
     /*  26230 */     // No operand predicates
     /*  26230 */     // MIs[2] Operand 2
     /*  26230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26250 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26252 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26270 */     GIR_RootConstrainSelectedInstOperands,
     /*  26271 */     // GIR_Coverage, 13589,
     /*  26271 */     GIR_EraseRootFromParent_Done,
     /*  26272 */   // Label 424: @26272
     /*  26272 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26387), // Rule ID 13588 //
     /*  26277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26325 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26329 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26333 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26346 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26350 */     // MIs[4] Operand 1
     /*  26350 */     // No operand predicates
     /*  26350 */     // MIs[2] Operand 2
     /*  26350 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26365 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26367 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26385 */     GIR_RootConstrainSelectedInstOperands,
     /*  26386 */     // GIR_Coverage, 13588,
     /*  26386 */     GIR_EraseRootFromParent_Done,
     /*  26387 */   // Label 425: @26387
     /*  26387 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26456), // Rule ID 1793 //
     /*  26392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26439 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26454 */     GIR_RootConstrainSelectedInstOperands,
     /*  26455 */     // GIR_Coverage, 1793,
     /*  26455 */     GIR_EraseRootFromParent_Done,
     /*  26456 */   // Label 426: @26456
     /*  26456 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26525), // Rule ID 1792 //
     /*  26461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26508 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26523 */     GIR_RootConstrainSelectedInstOperands,
     /*  26524 */     // GIR_Coverage, 1792,
     /*  26524 */     GIR_EraseRootFromParent_Done,
     /*  26525 */   // Label 427: @26525
     /*  26525 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26594), // Rule ID 1715 //
     /*  26530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26577 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26592 */     GIR_RootConstrainSelectedInstOperands,
     /*  26593 */     // GIR_Coverage, 1715,
     /*  26593 */     GIR_EraseRootFromParent_Done,
     /*  26594 */   // Label 428: @26594
     /*  26594 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26663), // Rule ID 1791 //
     /*  26599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26646 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26661 */     GIR_RootConstrainSelectedInstOperands,
     /*  26662 */     // GIR_Coverage, 1791,
     /*  26662 */     GIR_EraseRootFromParent_Done,
     /*  26663 */   // Label 429: @26663
     /*  26663 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26732), // Rule ID 1790 //
     /*  26668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26715 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26730 */     GIR_RootConstrainSelectedInstOperands,
     /*  26731 */     // GIR_Coverage, 1790,
     /*  26731 */     GIR_EraseRootFromParent_Done,
     /*  26732 */   // Label 430: @26732
     /*  26732 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26847), // Rule ID 13551 //
     /*  26737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26792 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26797 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26801 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26805 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26809 */     // MIs[4] Operand 1
     /*  26809 */     // No operand predicates
     /*  26809 */     // MIs[2] Operand 2
     /*  26809 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26825 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26827 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26845 */     GIR_RootConstrainSelectedInstOperands,
     /*  26846 */     // GIR_Coverage, 13551,
     /*  26846 */     GIR_EraseRootFromParent_Done,
     /*  26847 */   // Label 431: @26847
     /*  26847 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26962), // Rule ID 2037 //
     /*  26852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26908 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26917 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26921 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26925 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26929 */     // MIs[4] Operand 1
     /*  26929 */     // No operand predicates
     /*  26929 */     // MIs[2] Operand 2
     /*  26929 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26940 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26942 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26960 */     GIR_RootConstrainSelectedInstOperands,
     /*  26961 */     // GIR_Coverage, 2037,
     /*  26961 */     GIR_EraseRootFromParent_Done,
     /*  26962 */   // Label 432: @26962
     /*  26962 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27077), // Rule ID 13587 //
     /*  26967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27022 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27027 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27031 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27035 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27039 */     // MIs[4] Operand 1
     /*  27039 */     // No operand predicates
     /*  27039 */     // MIs[2] Operand 2
     /*  27039 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27057 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27075 */     GIR_RootConstrainSelectedInstOperands,
     /*  27076 */     // GIR_Coverage, 13587,
     /*  27076 */     GIR_EraseRootFromParent_Done,
     /*  27077 */   // Label 433: @27077
     /*  27077 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27192), // Rule ID 2089 //
     /*  27082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27138 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27142 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27155 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27159 */     // MIs[4] Operand 1
     /*  27159 */     // No operand predicates
     /*  27159 */     // MIs[2] Operand 2
     /*  27159 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27172 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27190 */     GIR_RootConstrainSelectedInstOperands,
     /*  27191 */     // GIR_Coverage, 2089,
     /*  27191 */     GIR_EraseRootFromParent_Done,
     /*  27192 */   // Label 434: @27192
     /*  27192 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27259), // Rule ID 13478 //
     /*  27197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27240 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27257 */     GIR_RootConstrainSelectedInstOperands,
     /*  27258 */     // GIR_Coverage, 13478,
     /*  27258 */     GIR_EraseRootFromParent_Done,
     /*  27259 */   // Label 435: @27259
     /*  27259 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27326), // Rule ID 13512 //
     /*  27264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27307 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27324 */     GIR_RootConstrainSelectedInstOperands,
     /*  27325 */     // GIR_Coverage, 13512,
     /*  27325 */     GIR_EraseRootFromParent_Done,
     /*  27326 */   // Label 436: @27326
     /*  27326 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27393), // Rule ID 1727 //
     /*  27331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27374 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27391 */     GIR_RootConstrainSelectedInstOperands,
     /*  27392 */     // GIR_Coverage, 1727,
     /*  27392 */     GIR_EraseRootFromParent_Done,
     /*  27393 */   // Label 437: @27393
     /*  27393 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27460), // Rule ID 1817 //
     /*  27398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27441 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27458 */     GIR_RootConstrainSelectedInstOperands,
     /*  27459 */     // GIR_Coverage, 1817,
     /*  27459 */     GIR_EraseRootFromParent_Done,
     /*  27460 */   // Label 438: @27460
     /*  27460 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27541), // Rule ID 13462 //
     /*  27465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27492 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27495 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27504 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27524 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27539 */     GIR_RootConstrainSelectedInstOperands,
     /*  27540 */     // GIR_Coverage, 13462,
     /*  27540 */     GIR_EraseRootFromParent_Done,
     /*  27541 */   // Label 439: @27541
     /*  27541 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27622), // Rule ID 13490 //
     /*  27546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27573 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27576 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27585 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27605 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27620 */     GIR_RootConstrainSelectedInstOperands,
     /*  27621 */     // GIR_Coverage, 13490,
     /*  27621 */     GIR_EraseRootFromParent_Done,
     /*  27622 */   // Label 440: @27622
     /*  27622 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27703), // Rule ID 1693 //
     /*  27627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27658 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27661 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27670 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27686 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27701 */     GIR_RootConstrainSelectedInstOperands,
     /*  27702 */     // GIR_Coverage, 1693,
     /*  27702 */     GIR_EraseRootFromParent_Done,
     /*  27703 */   // Label 441: @27703
     /*  27703 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27784), // Rule ID 1771 //
     /*  27708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27739 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27742 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27751 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27767 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27782 */     GIR_RootConstrainSelectedInstOperands,
     /*  27783 */     // GIR_Coverage, 1771,
     /*  27783 */     GIR_EraseRootFromParent_Done,
     /*  27784 */   // Label 442: @27784
     /*  27784 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27876), // Rule ID 13556 //
     /*  27789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27841 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27845 */     // MIs[3] Operand 1
     /*  27845 */     // No operand predicates
     /*  27845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27856 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27874 */     GIR_RootConstrainSelectedInstOperands,
     /*  27875 */     // GIR_Coverage, 13556,
     /*  27875 */     GIR_EraseRootFromParent_Done,
     /*  27876 */   // Label 443: @27876
     /*  27876 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27968), // Rule ID 13555 //
     /*  27881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27938 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27942 */     // MIs[3] Operand 1
     /*  27942 */     // No operand predicates
     /*  27942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27948 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27966 */     GIR_RootConstrainSelectedInstOperands,
     /*  27967 */     // GIR_Coverage, 13555,
     /*  27967 */     GIR_EraseRootFromParent_Done,
     /*  27968 */   // Label 444: @27968
     /*  27968 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28060), // Rule ID 13592 //
     /*  27973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28029 */     // MIs[3] Operand 1
     /*  28029 */     // No operand predicates
     /*  28029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28040 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28058 */     GIR_RootConstrainSelectedInstOperands,
     /*  28059 */     // GIR_Coverage, 13592,
     /*  28059 */     GIR_EraseRootFromParent_Done,
     /*  28060 */   // Label 445: @28060
     /*  28060 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28152), // Rule ID 13591 //
     /*  28065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28122 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28126 */     // MIs[3] Operand 1
     /*  28126 */     // No operand predicates
     /*  28126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28132 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28150 */     GIR_RootConstrainSelectedInstOperands,
     /*  28151 */     // GIR_Coverage, 13591,
     /*  28151 */     GIR_EraseRootFromParent_Done,
     /*  28152 */   // Label 446: @28152
     /*  28152 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28244), // Rule ID 13554 //
     /*  28157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28213 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28217 */     // MIs[3] Operand 1
     /*  28217 */     // No operand predicates
     /*  28217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28224 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28242 */     GIR_RootConstrainSelectedInstOperands,
     /*  28243 */     // GIR_Coverage, 13554,
     /*  28243 */     GIR_EraseRootFromParent_Done,
     /*  28244 */   // Label 447: @28244
     /*  28244 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28336), // Rule ID 2038 //
     /*  28249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28310 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28314 */     // MIs[3] Operand 1
     /*  28314 */     // No operand predicates
     /*  28314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28316 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28334 */     GIR_RootConstrainSelectedInstOperands,
     /*  28335 */     // GIR_Coverage, 2038,
     /*  28335 */     GIR_EraseRootFromParent_Done,
     /*  28336 */   // Label 448: @28336
     /*  28336 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28428), // Rule ID 13590 //
     /*  28341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28397 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28401 */     // MIs[3] Operand 1
     /*  28401 */     // No operand predicates
     /*  28401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28408 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28426 */     GIR_RootConstrainSelectedInstOperands,
     /*  28427 */     // GIR_Coverage, 13590,
     /*  28427 */     GIR_EraseRootFromParent_Done,
     /*  28428 */   // Label 449: @28428
     /*  28428 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28520), // Rule ID 2090 //
     /*  28433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28494 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28498 */     // MIs[3] Operand 1
     /*  28498 */     // No operand predicates
     /*  28498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28500 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28518 */     GIR_RootConstrainSelectedInstOperands,
     /*  28519 */     // GIR_Coverage, 2090,
     /*  28519 */     GIR_EraseRootFromParent_Done,
     /*  28520 */   // Label 450: @28520
     /*  28520 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28571), // Rule ID 13504 //
     /*  28525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28557 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28569 */     GIR_RootConstrainSelectedInstOperands,
     /*  28570 */     // GIR_Coverage, 13504,
     /*  28570 */     GIR_EraseRootFromParent_Done,
     /*  28571 */   // Label 451: @28571
     /*  28571 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28622), // Rule ID 13472 //
     /*  28576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28608 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28620 */     GIR_RootConstrainSelectedInstOperands,
     /*  28621 */     // GIR_Coverage, 13472,
     /*  28621 */     GIR_EraseRootFromParent_Done,
     /*  28622 */   // Label 452: @28622
     /*  28622 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28673), // Rule ID 13503 //
     /*  28627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28659 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28671 */     GIR_RootConstrainSelectedInstOperands,
     /*  28672 */     // GIR_Coverage, 13503,
     /*  28672 */     GIR_EraseRootFromParent_Done,
     /*  28673 */   // Label 453: @28673
     /*  28673 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28724), // Rule ID 1809 //
     /*  28678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28710 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28722 */     GIR_RootConstrainSelectedInstOperands,
     /*  28723 */     // GIR_Coverage, 1809,
     /*  28723 */     GIR_EraseRootFromParent_Done,
     /*  28724 */   // Label 454: @28724
     /*  28724 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28775), // Rule ID 1721 //
     /*  28729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28761 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28773 */     GIR_RootConstrainSelectedInstOperands,
     /*  28774 */     // GIR_Coverage, 1721,
     /*  28774 */     GIR_EraseRootFromParent_Done,
     /*  28775 */   // Label 455: @28775
     /*  28775 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28826), // Rule ID 1808 //
     /*  28780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28812 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28824 */     GIR_RootConstrainSelectedInstOperands,
     /*  28825 */     // GIR_Coverage, 1808,
     /*  28825 */     GIR_EraseRootFromParent_Done,
     /*  28826 */   // Label 456: @28826
     /*  28826 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(28895), // Rule ID 13426 //
     /*  28831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28846 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28849 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28858 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28878 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  28881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28893 */     GIR_RootConstrainSelectedInstOperands,
     /*  28894 */     // GIR_Coverage, 13426,
     /*  28894 */     GIR_EraseRootFromParent_Done,
     /*  28895 */   // Label 457: @28895
     /*  28895 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(28964), // Rule ID 13438 //
     /*  28900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28947 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 731:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  28950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28962 */     GIR_RootConstrainSelectedInstOperands,
     /*  28963 */     // GIR_Coverage, 13438,
     /*  28963 */     GIR_EraseRootFromParent_Done,
     /*  28964 */   // Label 458: @28964
     /*  28964 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29020), // Rule ID 13388 //
     /*  28969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  28992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29007 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29018 */     GIR_RootConstrainSelectedInstOperands,
     /*  29019 */     // GIR_Coverage, 13388,
     /*  29019 */     GIR_EraseRootFromParent_Done,
     /*  29020 */   // Label 459: @29020
     /*  29020 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29076), // Rule ID 13400 //
     /*  29025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29063 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29074 */     GIR_RootConstrainSelectedInstOperands,
     /*  29075 */     // GIR_Coverage, 13400,
     /*  29075 */     GIR_EraseRootFromParent_Done,
     /*  29076 */   // Label 460: @29076
     /*  29076 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29143), // Rule ID 13640 //
     /*  29081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29105 */     // MIs[1] imm
     /*  29105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29117 */     // MIs[2] Operand 1
     /*  29117 */     // No operand predicates
     /*  29117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29127 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29141 */     GIR_RootConstrainSelectedInstOperands,
     /*  29142 */     // GIR_Coverage, 13640,
     /*  29142 */     GIR_EraseRootFromParent_Done,
     /*  29143 */   // Label 461: @29143
     /*  29143 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29210), // Rule ID 13661 //
     /*  29148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29172 */     // MIs[1] imm
     /*  29172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29184 */     // MIs[2] Operand 1
     /*  29184 */     // No operand predicates
     /*  29184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29194 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29208 */     GIR_RootConstrainSelectedInstOperands,
     /*  29209 */     // GIR_Coverage, 13661,
     /*  29209 */     GIR_EraseRootFromParent_Done,
     /*  29210 */   // Label 462: @29210
     /*  29210 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29279), // Rule ID 1367 //
     /*  29215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29234 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29237 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29246 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29262 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29277 */     GIR_RootConstrainSelectedInstOperands,
     /*  29278 */     // GIR_Coverage, 1367,
     /*  29278 */     GIR_EraseRootFromParent_Done,
     /*  29279 */   // Label 463: @29279
     /*  29279 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29348), // Rule ID 1490 //
     /*  29284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29303 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29306 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29331 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 731:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29346 */     GIR_RootConstrainSelectedInstOperands,
     /*  29347 */     // GIR_Coverage, 1490,
     /*  29347 */     GIR_EraseRootFromParent_Done,
     /*  29348 */   // Label 464: @29348
     /*  29348 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29404), // Rule ID 995 //
     /*  29353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29372 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29375 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29391 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29402 */     GIR_RootConstrainSelectedInstOperands,
     /*  29403 */     // GIR_Coverage, 995,
     /*  29403 */     GIR_EraseRootFromParent_Done,
     /*  29404 */   // Label 465: @29404
     /*  29404 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29460), // Rule ID 1056 //
     /*  29409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29447 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29458 */     GIR_RootConstrainSelectedInstOperands,
     /*  29459 */     // GIR_Coverage, 1056,
     /*  29459 */     GIR_EraseRootFromParent_Done,
     /*  29460 */   // Label 466: @29460
     /*  29460 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29527), // Rule ID 2240 //
     /*  29465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29493 */     // MIs[1] imm
     /*  29493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29505 */     // MIs[2] Operand 1
     /*  29505 */     // No operand predicates
     /*  29505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29511 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29525 */     GIR_RootConstrainSelectedInstOperands,
     /*  29526 */     // GIR_Coverage, 2240,
     /*  29526 */     GIR_EraseRootFromParent_Done,
     /*  29527 */   // Label 467: @29527
     /*  29527 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29594), // Rule ID 2299 //
     /*  29532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29560 */     // MIs[1] imm
     /*  29560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29568 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29572 */     // MIs[2] Operand 1
     /*  29572 */     // No operand predicates
     /*  29572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29578 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29592 */     GIR_RootConstrainSelectedInstOperands,
     /*  29593 */     // GIR_Coverage, 2299,
     /*  29593 */     GIR_EraseRootFromParent_Done,
     /*  29594 */   // Label 468: @29594
     /*  29594 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29664), // Rule ID 6963 //
     /*  29599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29637 */     // MIs[2] Rn
     /*  29637 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29642 */     // MIs[2] Rm
     /*  29642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29649 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29662 */     GIR_RootConstrainSelectedInstOperands,
     /*  29663 */     // GIR_Coverage, 6963,
     /*  29663 */     GIR_EraseRootFromParent_Done,
     /*  29664 */   // Label 469: @29664
     /*  29664 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29734), // Rule ID 14022 //
     /*  29669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29707 */     // MIs[2] Rn
     /*  29707 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29712 */     // MIs[2] Rm
     /*  29712 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29719 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29732 */     GIR_RootConstrainSelectedInstOperands,
     /*  29733 */     // GIR_Coverage, 14022,
     /*  29733 */     GIR_EraseRootFromParent_Done,
     /*  29734 */   // Label 470: @29734
     /*  29734 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29797), // Rule ID 1789 //
     /*  29739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29782 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29795 */     GIR_RootConstrainSelectedInstOperands,
     /*  29796 */     // GIR_Coverage, 1789,
     /*  29796 */     GIR_EraseRootFromParent_Done,
     /*  29797 */   // Label 471: @29797
     /*  29797 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29860), // Rule ID 1788 //
     /*  29802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29845 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29858 */     GIR_RootConstrainSelectedInstOperands,
     /*  29859 */     // GIR_Coverage, 1788,
     /*  29859 */     GIR_EraseRootFromParent_Done,
     /*  29860 */   // Label 472: @29860
     /*  29860 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(29923), // Rule ID 1714 //
     /*  29865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29908 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  29911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29921 */     GIR_RootConstrainSelectedInstOperands,
     /*  29922 */     // GIR_Coverage, 1714,
     /*  29922 */     GIR_EraseRootFromParent_Done,
     /*  29923 */   // Label 473: @29923
     /*  29923 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(29986), // Rule ID 1787 //
     /*  29928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29971 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29984 */     GIR_RootConstrainSelectedInstOperands,
     /*  29985 */     // GIR_Coverage, 1787,
     /*  29985 */     GIR_EraseRootFromParent_Done,
     /*  29986 */   // Label 474: @29986
     /*  29986 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30049), // Rule ID 1786 //
     /*  29991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30034 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30047 */     GIR_RootConstrainSelectedInstOperands,
     /*  30048 */     // GIR_Coverage, 1786,
     /*  30048 */     GIR_EraseRootFromParent_Done,
     /*  30049 */   // Label 475: @30049
     /*  30049 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30110), // Rule ID 13477 //
     /*  30054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30093 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30108 */     GIR_RootConstrainSelectedInstOperands,
     /*  30109 */     // GIR_Coverage, 13477,
     /*  30109 */     GIR_EraseRootFromParent_Done,
     /*  30110 */   // Label 476: @30110
     /*  30110 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30171), // Rule ID 13511 //
     /*  30115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30154 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30169 */     GIR_RootConstrainSelectedInstOperands,
     /*  30170 */     // GIR_Coverage, 13511,
     /*  30170 */     GIR_EraseRootFromParent_Done,
     /*  30171 */   // Label 477: @30171
     /*  30171 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30219), // Rule ID 13502 //
     /*  30176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30206 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30217 */     GIR_RootConstrainSelectedInstOperands,
     /*  30218 */     // GIR_Coverage, 13502,
     /*  30218 */     GIR_EraseRootFromParent_Done,
     /*  30219 */   // Label 478: @30219
     /*  30219 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30267), // Rule ID 13387 //
     /*  30224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30254 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30265 */     GIR_RootConstrainSelectedInstOperands,
     /*  30266 */     // GIR_Coverage, 13387,
     /*  30266 */     GIR_EraseRootFromParent_Done,
     /*  30267 */   // Label 479: @30267
     /*  30267 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30315), // Rule ID 13471 //
     /*  30272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30302 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30313 */     GIR_RootConstrainSelectedInstOperands,
     /*  30314 */     // GIR_Coverage, 13471,
     /*  30314 */     GIR_EraseRootFromParent_Done,
     /*  30315 */   // Label 480: @30315
     /*  30315 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30363), // Rule ID 13399 //
     /*  30320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30350 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30361 */     GIR_RootConstrainSelectedInstOperands,
     /*  30362 */     // GIR_Coverage, 13399,
     /*  30362 */     GIR_EraseRootFromParent_Done,
     /*  30363 */   // Label 481: @30363
     /*  30363 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30411), // Rule ID 13501 //
     /*  30368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30398 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30409 */     GIR_RootConstrainSelectedInstOperands,
     /*  30410 */     // GIR_Coverage, 13501,
     /*  30410 */     GIR_EraseRootFromParent_Done,
     /*  30411 */   // Label 482: @30411
     /*  30411 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30472), // Rule ID 1726 //
     /*  30416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30455 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30470 */     GIR_RootConstrainSelectedInstOperands,
     /*  30471 */     // GIR_Coverage, 1726,
     /*  30471 */     GIR_EraseRootFromParent_Done,
     /*  30472 */   // Label 483: @30472
     /*  30472 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30533), // Rule ID 1816 //
     /*  30477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30516 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30531 */     GIR_RootConstrainSelectedInstOperands,
     /*  30532 */     // GIR_Coverage, 1816,
     /*  30532 */     GIR_EraseRootFromParent_Done,
     /*  30533 */   // Label 484: @30533
     /*  30533 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30581), // Rule ID 1807 //
     /*  30538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30568 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30579 */     GIR_RootConstrainSelectedInstOperands,
     /*  30580 */     // GIR_Coverage, 1807,
     /*  30580 */     GIR_EraseRootFromParent_Done,
     /*  30581 */   // Label 485: @30581
     /*  30581 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30629), // Rule ID 994 //
     /*  30586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30616 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30627 */     GIR_RootConstrainSelectedInstOperands,
     /*  30628 */     // GIR_Coverage, 994,
     /*  30628 */     GIR_EraseRootFromParent_Done,
     /*  30629 */   // Label 486: @30629
     /*  30629 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30677), // Rule ID 1720 //
     /*  30634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30664 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30675 */     GIR_RootConstrainSelectedInstOperands,
     /*  30676 */     // GIR_Coverage, 1720,
     /*  30676 */     GIR_EraseRootFromParent_Done,
     /*  30677 */   // Label 487: @30677
     /*  30677 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30725), // Rule ID 1055 //
     /*  30682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30712 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30723 */     GIR_RootConstrainSelectedInstOperands,
     /*  30724 */     // GIR_Coverage, 1055,
     /*  30724 */     GIR_EraseRootFromParent_Done,
     /*  30725 */   // Label 488: @30725
     /*  30725 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(30773), // Rule ID 1806 //
     /*  30730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30760 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30771 */     GIR_RootConstrainSelectedInstOperands,
     /*  30772 */     // GIR_Coverage, 1806,
     /*  30772 */     GIR_EraseRootFromParent_Done,
     /*  30773 */   // Label 489: @30773
     /*  30773 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30800), // Rule ID 1105 //
     /*  30778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30793 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  30793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  30798 */     GIR_RootConstrainSelectedInstOperands,
     /*  30799 */     // GIR_Coverage, 1105,
     /*  30799 */     GIR_Done,
     /*  30800 */   // Label 490: @30800
     /*  30800 */   GIM_Reject,
     /*  30801 */ // Label 409: @30801
     /*  30801 */ GIM_Reject,
     /*  30802 */ // Label 161: @30802
     /*  30802 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31651),
     /*  30807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30813 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30946), // Rule ID 14027 //
     /*  30818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  30859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30863 */     // MIs[1] Operand 2
     /*  30863 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  30874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  30878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30882 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30886 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30890 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30894 */     // MIs[5] Rn
     /*  30894 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30899 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30901 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  30935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30945 */     // GIR_Coverage, 14027,
     /*  30945 */     GIR_EraseRootFromParent_Done,
     /*  30946 */   // Label 492: @30946
     /*  30946 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31079), // Rule ID 6968 //
     /*  30951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  30988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31004 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31008 */     // MIs[4] Rn
     /*  31008 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31013 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31017 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31021 */     // MIs[3] Operand 2
     /*  31021 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31032 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31034 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31078 */     // GIR_Coverage, 6968,
     /*  31078 */     GIR_EraseRootFromParent_Done,
     /*  31079 */   // Label 493: @31079
     /*  31079 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31148), // Rule ID 13416 //
     /*  31084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31099 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31102 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31111 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31131 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31146 */     GIR_RootConstrainSelectedInstOperands,
     /*  31147 */     // GIR_Coverage, 13416,
     /*  31147 */     GIR_EraseRootFromParent_Done,
     /*  31148 */   // Label 494: @31148
     /*  31148 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31217), // Rule ID 13428 //
     /*  31153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31168 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31171 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31200 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31215 */     GIR_RootConstrainSelectedInstOperands,
     /*  31216 */     // GIR_Coverage, 13428,
     /*  31216 */     GIR_EraseRootFromParent_Done,
     /*  31217 */   // Label 495: @31217
     /*  31217 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31284), // Rule ID 13630 //
     /*  31222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31246 */     // MIs[1] imm
     /*  31246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31258 */     // MIs[2] Operand 1
     /*  31258 */     // No operand predicates
     /*  31258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31268 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31282 */     GIR_RootConstrainSelectedInstOperands,
     /*  31283 */     // GIR_Coverage, 13630,
     /*  31283 */     GIR_EraseRootFromParent_Done,
     /*  31284 */   // Label 496: @31284
     /*  31284 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31351), // Rule ID 13651 //
     /*  31289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31313 */     // MIs[1] imm
     /*  31313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31325 */     // MIs[2] Operand 1
     /*  31325 */     // No operand predicates
     /*  31325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31335 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31349 */     GIR_RootConstrainSelectedInstOperands,
     /*  31350 */     // GIR_Coverage, 13651,
     /*  31350 */     GIR_EraseRootFromParent_Done,
     /*  31351 */   // Label 497: @31351
     /*  31351 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31420), // Rule ID 1357 //
     /*  31356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31375 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31378 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31403 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31418 */     GIR_RootConstrainSelectedInstOperands,
     /*  31419 */     // GIR_Coverage, 1357,
     /*  31419 */     GIR_EraseRootFromParent_Done,
     /*  31420 */   // Label 498: @31420
     /*  31420 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31489), // Rule ID 1480 //
     /*  31425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31444 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31447 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31472 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31487 */     GIR_RootConstrainSelectedInstOperands,
     /*  31488 */     // GIR_Coverage, 1480,
     /*  31488 */     GIR_EraseRootFromParent_Done,
     /*  31489 */   // Label 499: @31489
     /*  31489 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31556), // Rule ID 2230 //
     /*  31494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31522 */     // MIs[1] imm
     /*  31522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31534 */     // MIs[2] Operand 1
     /*  31534 */     // No operand predicates
     /*  31534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31540 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31554 */     GIR_RootConstrainSelectedInstOperands,
     /*  31555 */     // GIR_Coverage, 2230,
     /*  31555 */     GIR_EraseRootFromParent_Done,
     /*  31556 */   // Label 500: @31556
     /*  31556 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31623), // Rule ID 2289 //
     /*  31561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31589 */     // MIs[1] imm
     /*  31589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31601 */     // MIs[2] Operand 1
     /*  31601 */     // No operand predicates
     /*  31601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31607 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31621 */     GIR_RootConstrainSelectedInstOperands,
     /*  31622 */     // GIR_Coverage, 2289,
     /*  31622 */     GIR_EraseRootFromParent_Done,
     /*  31623 */   // Label 501: @31623
     /*  31623 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31650), // Rule ID 1100 //
     /*  31628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31643 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31648 */     GIR_RootConstrainSelectedInstOperands,
     /*  31649 */     // GIR_Coverage, 1100,
     /*  31649 */     GIR_Done,
     /*  31650 */   // Label 502: @31650
     /*  31650 */   GIM_Reject,
     /*  31651 */ // Label 491: @31651
     /*  31651 */ GIM_Reject,
     /*  31652 */ // Label 162: @31652
     /*  31652 */ GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(35229),
     /*  31657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31663 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31750), // Rule ID 13460 //
     /*  31668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31695 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31698 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31707 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31731 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31748 */     GIR_RootConstrainSelectedInstOperands,
     /*  31749 */     // GIR_Coverage, 13460,
     /*  31749 */     GIR_EraseRootFromParent_Done,
     /*  31750 */   // Label 504: @31750
     /*  31750 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31837), // Rule ID 13488 //
     /*  31755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31782 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31785 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31794 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31818 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31835 */     GIR_RootConstrainSelectedInstOperands,
     /*  31836 */     // GIR_Coverage, 13488,
     /*  31836 */     GIR_EraseRootFromParent_Done,
     /*  31837 */   // Label 505: @31837
     /*  31837 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31924), // Rule ID 1691 //
     /*  31842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31873 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31876 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31885 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31905 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31922 */     GIR_RootConstrainSelectedInstOperands,
     /*  31923 */     // GIR_Coverage, 1691,
     /*  31923 */     GIR_EraseRootFromParent_Done,
     /*  31924 */   // Label 506: @31924
     /*  31924 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32011), // Rule ID 1769 //
     /*  31929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31960 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31963 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31972 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31992 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32009 */     GIR_RootConstrainSelectedInstOperands,
     /*  32010 */     // GIR_Coverage, 1769,
     /*  32010 */     GIR_EraseRootFromParent_Done,
     /*  32011 */   // Label 507: @32011
     /*  32011 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32080), // Rule ID 1785 //
     /*  32016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32063 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32078 */     GIR_RootConstrainSelectedInstOperands,
     /*  32079 */     // GIR_Coverage, 1785,
     /*  32079 */     GIR_EraseRootFromParent_Done,
     /*  32080 */   // Label 508: @32080
     /*  32080 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(32149), // Rule ID 1784 //
     /*  32085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32132 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32147 */     GIR_RootConstrainSelectedInstOperands,
     /*  32148 */     // GIR_Coverage, 1784,
     /*  32148 */     GIR_EraseRootFromParent_Done,
     /*  32149 */   // Label 509: @32149
     /*  32149 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(32218), // Rule ID 1713 //
     /*  32154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32201 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32216 */     GIR_RootConstrainSelectedInstOperands,
     /*  32217 */     // GIR_Coverage, 1713,
     /*  32217 */     GIR_EraseRootFromParent_Done,
     /*  32218 */   // Label 510: @32218
     /*  32218 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32287), // Rule ID 1783 //
     /*  32223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32270 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32285 */     GIR_RootConstrainSelectedInstOperands,
     /*  32286 */     // GIR_Coverage, 1783,
     /*  32286 */     GIR_EraseRootFromParent_Done,
     /*  32287 */   // Label 511: @32287
     /*  32287 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32356), // Rule ID 1782 //
     /*  32292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32339 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32354 */     GIR_RootConstrainSelectedInstOperands,
     /*  32355 */     // GIR_Coverage, 1782,
     /*  32355 */     GIR_EraseRootFromParent_Done,
     /*  32356 */   // Label 512: @32356
     /*  32356 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32423), // Rule ID 13476 //
     /*  32361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32404 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32421 */     GIR_RootConstrainSelectedInstOperands,
     /*  32422 */     // GIR_Coverage, 13476,
     /*  32422 */     GIR_EraseRootFromParent_Done,
     /*  32423 */   // Label 513: @32423
     /*  32423 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32490), // Rule ID 13510 //
     /*  32428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32471 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32488 */     GIR_RootConstrainSelectedInstOperands,
     /*  32489 */     // GIR_Coverage, 13510,
     /*  32489 */     GIR_EraseRootFromParent_Done,
     /*  32490 */   // Label 514: @32490
     /*  32490 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32557), // Rule ID 1725 //
     /*  32495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32538 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32555 */     GIR_RootConstrainSelectedInstOperands,
     /*  32556 */     // GIR_Coverage, 1725,
     /*  32556 */     GIR_EraseRootFromParent_Done,
     /*  32557 */   // Label 515: @32557
     /*  32557 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32624), // Rule ID 1815 //
     /*  32562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32605 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32622 */     GIR_RootConstrainSelectedInstOperands,
     /*  32623 */     // GIR_Coverage, 1815,
     /*  32623 */     GIR_EraseRootFromParent_Done,
     /*  32624 */   // Label 516: @32624
     /*  32624 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32705), // Rule ID 13458 //
     /*  32629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32656 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32659 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32668 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32688 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32703 */     GIR_RootConstrainSelectedInstOperands,
     /*  32704 */     // GIR_Coverage, 13458,
     /*  32704 */     GIR_EraseRootFromParent_Done,
     /*  32705 */   // Label 517: @32705
     /*  32705 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32786), // Rule ID 13486 //
     /*  32710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32749 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32769 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32784 */     GIR_RootConstrainSelectedInstOperands,
     /*  32785 */     // GIR_Coverage, 13486,
     /*  32785 */     GIR_EraseRootFromParent_Done,
     /*  32786 */   // Label 518: @32786
     /*  32786 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32867), // Rule ID 1689 //
     /*  32791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32822 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32825 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32834 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32850 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32865 */     GIR_RootConstrainSelectedInstOperands,
     /*  32866 */     // GIR_Coverage, 1689,
     /*  32866 */     GIR_EraseRootFromParent_Done,
     /*  32867 */   // Label 519: @32867
     /*  32867 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(32948), // Rule ID 1767 //
     /*  32872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32903 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32906 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32915 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32931 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32946 */     GIR_RootConstrainSelectedInstOperands,
     /*  32947 */     // GIR_Coverage, 1767,
     /*  32947 */     GIR_EraseRootFromParent_Done,
     /*  32948 */   // Label 520: @32948
     /*  32948 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(32999), // Rule ID 13500 //
     /*  32953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32985 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  32988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32997 */     GIR_RootConstrainSelectedInstOperands,
     /*  32998 */     // GIR_Coverage, 13500,
     /*  32998 */     GIR_EraseRootFromParent_Done,
     /*  32999 */   // Label 521: @32999
     /*  32999 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33050), // Rule ID 13470 //
     /*  33004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33036 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33048 */     GIR_RootConstrainSelectedInstOperands,
     /*  33049 */     // GIR_Coverage, 13470,
     /*  33049 */     GIR_EraseRootFromParent_Done,
     /*  33050 */   // Label 522: @33050
     /*  33050 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33101), // Rule ID 13499 //
     /*  33055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33087 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33099 */     GIR_RootConstrainSelectedInstOperands,
     /*  33100 */     // GIR_Coverage, 13499,
     /*  33100 */     GIR_EraseRootFromParent_Done,
     /*  33101 */   // Label 523: @33101
     /*  33101 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33152), // Rule ID 1805 //
     /*  33106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33138 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33150 */     GIR_RootConstrainSelectedInstOperands,
     /*  33151 */     // GIR_Coverage, 1805,
     /*  33151 */     GIR_EraseRootFromParent_Done,
     /*  33152 */   // Label 524: @33152
     /*  33152 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33203), // Rule ID 1719 //
     /*  33157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33189 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33201 */     GIR_RootConstrainSelectedInstOperands,
     /*  33202 */     // GIR_Coverage, 1719,
     /*  33202 */     GIR_EraseRootFromParent_Done,
     /*  33203 */   // Label 525: @33203
     /*  33203 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33254), // Rule ID 1804 //
     /*  33208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33240 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33252 */     GIR_RootConstrainSelectedInstOperands,
     /*  33253 */     // GIR_Coverage, 1804,
     /*  33253 */     GIR_EraseRootFromParent_Done,
     /*  33254 */   // Label 526: @33254
     /*  33254 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33323), // Rule ID 13422 //
     /*  33259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33274 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33277 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33306 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33321 */     GIR_RootConstrainSelectedInstOperands,
     /*  33322 */     // GIR_Coverage, 13422,
     /*  33322 */     GIR_EraseRootFromParent_Done,
     /*  33323 */   // Label 527: @33323
     /*  33323 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33392), // Rule ID 13434 //
     /*  33328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33343 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33346 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33375 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 731:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33390 */     GIR_RootConstrainSelectedInstOperands,
     /*  33391 */     // GIR_Coverage, 13434,
     /*  33391 */     GIR_EraseRootFromParent_Done,
     /*  33392 */   // Label 528: @33392
     /*  33392 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33448), // Rule ID 13384 //
     /*  33397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33435 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33446 */     GIR_RootConstrainSelectedInstOperands,
     /*  33447 */     // GIR_Coverage, 13384,
     /*  33447 */     GIR_EraseRootFromParent_Done,
     /*  33448 */   // Label 529: @33448
     /*  33448 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33504), // Rule ID 13396 //
     /*  33453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33491 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33502 */     GIR_RootConstrainSelectedInstOperands,
     /*  33503 */     // GIR_Coverage, 13396,
     /*  33503 */     GIR_EraseRootFromParent_Done,
     /*  33504 */   // Label 530: @33504
     /*  33504 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33571), // Rule ID 13636 //
     /*  33509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33533 */     // MIs[1] imm
     /*  33533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33545 */     // MIs[2] Operand 1
     /*  33545 */     // No operand predicates
     /*  33545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33555 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33569 */     GIR_RootConstrainSelectedInstOperands,
     /*  33570 */     // GIR_Coverage, 13636,
     /*  33570 */     GIR_EraseRootFromParent_Done,
     /*  33571 */   // Label 531: @33571
     /*  33571 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33638), // Rule ID 13657 //
     /*  33576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33600 */     // MIs[1] imm
     /*  33600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33612 */     // MIs[2] Operand 1
     /*  33612 */     // No operand predicates
     /*  33612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33622 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33636 */     GIR_RootConstrainSelectedInstOperands,
     /*  33637 */     // GIR_Coverage, 13657,
     /*  33637 */     GIR_EraseRootFromParent_Done,
     /*  33638 */   // Label 532: @33638
     /*  33638 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33707), // Rule ID 1363 //
     /*  33643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33662 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33665 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33674 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33690 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33705 */     GIR_RootConstrainSelectedInstOperands,
     /*  33706 */     // GIR_Coverage, 1363,
     /*  33706 */     GIR_EraseRootFromParent_Done,
     /*  33707 */   // Label 533: @33707
     /*  33707 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33776), // Rule ID 1486 //
     /*  33712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33731 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33734 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33743 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33759 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 731:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33774 */     GIR_RootConstrainSelectedInstOperands,
     /*  33775 */     // GIR_Coverage, 1486,
     /*  33775 */     GIR_EraseRootFromParent_Done,
     /*  33776 */   // Label 534: @33776
     /*  33776 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33832), // Rule ID 991 //
     /*  33781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33800 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33803 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33819 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33830 */     GIR_RootConstrainSelectedInstOperands,
     /*  33831 */     // GIR_Coverage, 991,
     /*  33831 */     GIR_EraseRootFromParent_Done,
     /*  33832 */   // Label 535: @33832
     /*  33832 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(33888), // Rule ID 1052 //
     /*  33837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33856 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33859 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33875 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33886 */     GIR_RootConstrainSelectedInstOperands,
     /*  33887 */     // GIR_Coverage, 1052,
     /*  33887 */     GIR_EraseRootFromParent_Done,
     /*  33888 */   // Label 536: @33888
     /*  33888 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(33955), // Rule ID 2236 //
     /*  33893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33921 */     // MIs[1] imm
     /*  33921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33929 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33933 */     // MIs[2] Operand 1
     /*  33933 */     // No operand predicates
     /*  33933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33939 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33953 */     GIR_RootConstrainSelectedInstOperands,
     /*  33954 */     // GIR_Coverage, 2236,
     /*  33954 */     GIR_EraseRootFromParent_Done,
     /*  33955 */   // Label 537: @33955
     /*  33955 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34022), // Rule ID 2295 //
     /*  33960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33988 */     // MIs[1] imm
     /*  33988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33996 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34000 */     // MIs[2] Operand 1
     /*  34000 */     // No operand predicates
     /*  34000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34006 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34020 */     GIR_RootConstrainSelectedInstOperands,
     /*  34021 */     // GIR_Coverage, 2295,
     /*  34021 */     GIR_EraseRootFromParent_Done,
     /*  34022 */   // Label 538: @34022
     /*  34022 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34092), // Rule ID 6964 //
     /*  34027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34065 */     // MIs[2] Rn
     /*  34065 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34070 */     // MIs[2] Rm
     /*  34070 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34077 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34090 */     GIR_RootConstrainSelectedInstOperands,
     /*  34091 */     // GIR_Coverage, 6964,
     /*  34091 */     GIR_EraseRootFromParent_Done,
     /*  34092 */   // Label 539: @34092
     /*  34092 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34162), // Rule ID 14023 //
     /*  34097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34135 */     // MIs[2] Rn
     /*  34135 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34140 */     // MIs[2] Rm
     /*  34140 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34147 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34160 */     GIR_RootConstrainSelectedInstOperands,
     /*  34161 */     // GIR_Coverage, 14023,
     /*  34161 */     GIR_EraseRootFromParent_Done,
     /*  34162 */   // Label 540: @34162
     /*  34162 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34225), // Rule ID 1781 //
     /*  34167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34210 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34223 */     GIR_RootConstrainSelectedInstOperands,
     /*  34224 */     // GIR_Coverage, 1781,
     /*  34224 */     GIR_EraseRootFromParent_Done,
     /*  34225 */   // Label 541: @34225
     /*  34225 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34288), // Rule ID 1780 //
     /*  34230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34273 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34286 */     GIR_RootConstrainSelectedInstOperands,
     /*  34287 */     // GIR_Coverage, 1780,
     /*  34287 */     GIR_EraseRootFromParent_Done,
     /*  34288 */   // Label 542: @34288
     /*  34288 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34351), // Rule ID 1712 //
     /*  34293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34336 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34349 */     GIR_RootConstrainSelectedInstOperands,
     /*  34350 */     // GIR_Coverage, 1712,
     /*  34350 */     GIR_EraseRootFromParent_Done,
     /*  34351 */   // Label 543: @34351
     /*  34351 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34414), // Rule ID 1779 //
     /*  34356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34399 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34412 */     GIR_RootConstrainSelectedInstOperands,
     /*  34413 */     // GIR_Coverage, 1779,
     /*  34413 */     GIR_EraseRootFromParent_Done,
     /*  34414 */   // Label 544: @34414
     /*  34414 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34477), // Rule ID 1778 //
     /*  34419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34462 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34475 */     GIR_RootConstrainSelectedInstOperands,
     /*  34476 */     // GIR_Coverage, 1778,
     /*  34476 */     GIR_EraseRootFromParent_Done,
     /*  34477 */   // Label 545: @34477
     /*  34477 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34538), // Rule ID 13475 //
     /*  34482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34521 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34536 */     GIR_RootConstrainSelectedInstOperands,
     /*  34537 */     // GIR_Coverage, 13475,
     /*  34537 */     GIR_EraseRootFromParent_Done,
     /*  34538 */   // Label 546: @34538
     /*  34538 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34599), // Rule ID 13509 //
     /*  34543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34582 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34597 */     GIR_RootConstrainSelectedInstOperands,
     /*  34598 */     // GIR_Coverage, 13509,
     /*  34598 */     GIR_EraseRootFromParent_Done,
     /*  34599 */   // Label 547: @34599
     /*  34599 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34647), // Rule ID 13498 //
     /*  34604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34634 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34645 */     GIR_RootConstrainSelectedInstOperands,
     /*  34646 */     // GIR_Coverage, 13498,
     /*  34646 */     GIR_EraseRootFromParent_Done,
     /*  34647 */   // Label 548: @34647
     /*  34647 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34695), // Rule ID 13383 //
     /*  34652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34682 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34693 */     GIR_RootConstrainSelectedInstOperands,
     /*  34694 */     // GIR_Coverage, 13383,
     /*  34694 */     GIR_EraseRootFromParent_Done,
     /*  34695 */   // Label 549: @34695
     /*  34695 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34743), // Rule ID 13469 //
     /*  34700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34730 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34741 */     GIR_RootConstrainSelectedInstOperands,
     /*  34742 */     // GIR_Coverage, 13469,
     /*  34742 */     GIR_EraseRootFromParent_Done,
     /*  34743 */   // Label 550: @34743
     /*  34743 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34791), // Rule ID 13395 //
     /*  34748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34778 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34789 */     GIR_RootConstrainSelectedInstOperands,
     /*  34790 */     // GIR_Coverage, 13395,
     /*  34790 */     GIR_EraseRootFromParent_Done,
     /*  34791 */   // Label 551: @34791
     /*  34791 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34839), // Rule ID 13497 //
     /*  34796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34826 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34837 */     GIR_RootConstrainSelectedInstOperands,
     /*  34838 */     // GIR_Coverage, 13497,
     /*  34838 */     GIR_EraseRootFromParent_Done,
     /*  34839 */   // Label 552: @34839
     /*  34839 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34900), // Rule ID 1724 //
     /*  34844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34883 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34898 */     GIR_RootConstrainSelectedInstOperands,
     /*  34899 */     // GIR_Coverage, 1724,
     /*  34899 */     GIR_EraseRootFromParent_Done,
     /*  34900 */   // Label 553: @34900
     /*  34900 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(34961), // Rule ID 1814 //
     /*  34905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34944 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34959 */     GIR_RootConstrainSelectedInstOperands,
     /*  34960 */     // GIR_Coverage, 1814,
     /*  34960 */     GIR_EraseRootFromParent_Done,
     /*  34961 */   // Label 554: @34961
     /*  34961 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35009), // Rule ID 1803 //
     /*  34966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34996 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35007 */     GIR_RootConstrainSelectedInstOperands,
     /*  35008 */     // GIR_Coverage, 1803,
     /*  35008 */     GIR_EraseRootFromParent_Done,
     /*  35009 */   // Label 555: @35009
     /*  35009 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35057), // Rule ID 990 //
     /*  35014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35044 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35055 */     GIR_RootConstrainSelectedInstOperands,
     /*  35056 */     // GIR_Coverage, 990,
     /*  35056 */     GIR_EraseRootFromParent_Done,
     /*  35057 */   // Label 556: @35057
     /*  35057 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35105), // Rule ID 1718 //
     /*  35062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35092 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35103 */     GIR_RootConstrainSelectedInstOperands,
     /*  35104 */     // GIR_Coverage, 1718,
     /*  35104 */     GIR_EraseRootFromParent_Done,
     /*  35105 */   // Label 557: @35105
     /*  35105 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35153), // Rule ID 1051 //
     /*  35110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35140 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35151 */     GIR_RootConstrainSelectedInstOperands,
     /*  35152 */     // GIR_Coverage, 1051,
     /*  35152 */     GIR_EraseRootFromParent_Done,
     /*  35153 */   // Label 558: @35153
     /*  35153 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35201), // Rule ID 1802 //
     /*  35158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35188 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35199 */     GIR_RootConstrainSelectedInstOperands,
     /*  35200 */     // GIR_Coverage, 1802,
     /*  35200 */     GIR_EraseRootFromParent_Done,
     /*  35201 */   // Label 559: @35201
     /*  35201 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35228), // Rule ID 1103 //
     /*  35206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35221 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35226 */     GIR_RootConstrainSelectedInstOperands,
     /*  35227 */     // GIR_Coverage, 1103,
     /*  35227 */     GIR_Done,
     /*  35228 */   // Label 560: @35228
     /*  35228 */   GIM_Reject,
     /*  35229 */ // Label 503: @35229
     /*  35229 */ GIM_Reject,
     /*  35230 */ // Label 163: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35953),
     /*  35235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35241 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35310), // Rule ID 13418 //
     /*  35246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35261 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35264 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35273 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35293 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35308 */     GIR_RootConstrainSelectedInstOperands,
     /*  35309 */     // GIR_Coverage, 13418,
     /*  35309 */     GIR_EraseRootFromParent_Done,
     /*  35310 */   // Label 562: @35310
     /*  35310 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35379), // Rule ID 13430 //
     /*  35315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35330 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35333 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35342 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35362 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 731:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35377 */     GIR_RootConstrainSelectedInstOperands,
     /*  35378 */     // GIR_Coverage, 13430,
     /*  35378 */     GIR_EraseRootFromParent_Done,
     /*  35379 */   // Label 563: @35379
     /*  35379 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35446), // Rule ID 13632 //
     /*  35384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35408 */     // MIs[1] imm
     /*  35408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35416 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35420 */     // MIs[2] Operand 1
     /*  35420 */     // No operand predicates
     /*  35420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35430 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35444 */     GIR_RootConstrainSelectedInstOperands,
     /*  35445 */     // GIR_Coverage, 13632,
     /*  35445 */     GIR_EraseRootFromParent_Done,
     /*  35446 */   // Label 564: @35446
     /*  35446 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35513), // Rule ID 13653 //
     /*  35451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35475 */     // MIs[1] imm
     /*  35475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35487 */     // MIs[2] Operand 1
     /*  35487 */     // No operand predicates
     /*  35487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35497 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35511 */     GIR_RootConstrainSelectedInstOperands,
     /*  35512 */     // GIR_Coverage, 13653,
     /*  35512 */     GIR_EraseRootFromParent_Done,
     /*  35513 */   // Label 565: @35513
     /*  35513 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35582), // Rule ID 1359 //
     /*  35518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35537 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35540 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35565 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35580 */     GIR_RootConstrainSelectedInstOperands,
     /*  35581 */     // GIR_Coverage, 1359,
     /*  35581 */     GIR_EraseRootFromParent_Done,
     /*  35582 */   // Label 566: @35582
     /*  35582 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35651), // Rule ID 1482 //
     /*  35587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35606 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35609 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35634 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 731:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35649 */     GIR_RootConstrainSelectedInstOperands,
     /*  35650 */     // GIR_Coverage, 1482,
     /*  35650 */     GIR_EraseRootFromParent_Done,
     /*  35651 */   // Label 567: @35651
     /*  35651 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35718), // Rule ID 2232 //
     /*  35656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35684 */     // MIs[1] imm
     /*  35684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35692 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35696 */     // MIs[2] Operand 1
     /*  35696 */     // No operand predicates
     /*  35696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35702 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35716 */     GIR_RootConstrainSelectedInstOperands,
     /*  35717 */     // GIR_Coverage, 2232,
     /*  35717 */     GIR_EraseRootFromParent_Done,
     /*  35718 */   // Label 568: @35718
     /*  35718 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35785), // Rule ID 2291 //
     /*  35723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35751 */     // MIs[1] imm
     /*  35751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35763 */     // MIs[2] Operand 1
     /*  35763 */     // No operand predicates
     /*  35763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35769 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35783 */     GIR_RootConstrainSelectedInstOperands,
     /*  35784 */     // GIR_Coverage, 2291,
     /*  35784 */     GIR_EraseRootFromParent_Done,
     /*  35785 */   // Label 569: @35785
     /*  35785 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35855), // Rule ID 6965 //
     /*  35790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  35802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  35828 */     // MIs[2] Rn
     /*  35828 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35833 */     // MIs[2] Rm
     /*  35833 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35840 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35853 */     GIR_RootConstrainSelectedInstOperands,
     /*  35854 */     // GIR_Coverage, 6965,
     /*  35854 */     GIR_EraseRootFromParent_Done,
     /*  35855 */   // Label 570: @35855
     /*  35855 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(35925), // Rule ID 14024 //
     /*  35860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  35872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  35898 */     // MIs[2] Rn
     /*  35898 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35903 */     // MIs[2] Rm
     /*  35903 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35910 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35923 */     GIR_RootConstrainSelectedInstOperands,
     /*  35924 */     // GIR_Coverage, 14024,
     /*  35924 */     GIR_EraseRootFromParent_Done,
     /*  35925 */   // Label 571: @35925
     /*  35925 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(35952), // Rule ID 1101 //
     /*  35930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35945 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  35950 */     GIR_RootConstrainSelectedInstOperands,
     /*  35951 */     // GIR_Coverage, 1101,
     /*  35951 */     GIR_Done,
     /*  35952 */   // Label 572: @35952
     /*  35952 */   GIM_Reject,
     /*  35953 */ // Label 561: @35953
     /*  35953 */ GIM_Reject,
     /*  35954 */ // Label 164: @35954
     /*  35954 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36325),
     /*  35959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  35969 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36031), // Rule ID 15208 //
     /*  35974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36005 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36018 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36029 */     GIR_RootConstrainSelectedInstOperands,
     /*  36030 */     // GIR_Coverage, 15208,
     /*  36030 */     GIR_EraseRootFromParent_Done,
     /*  36031 */   // Label 574: @36031
     /*  36031 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36093), // Rule ID 15207 //
     /*  36036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36067 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36080 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36091 */     GIR_RootConstrainSelectedInstOperands,
     /*  36092 */     // GIR_Coverage, 15207,
     /*  36092 */     GIR_EraseRootFromParent_Done,
     /*  36093 */   // Label 575: @36093
     /*  36093 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36155), // Rule ID 15206 //
     /*  36098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36129 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36142 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36153 */     GIR_RootConstrainSelectedInstOperands,
     /*  36154 */     // GIR_Coverage, 15206,
     /*  36154 */     GIR_EraseRootFromParent_Done,
     /*  36155 */   // Label 576: @36155
     /*  36155 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36217), // Rule ID 8940 //
     /*  36160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36191 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36204 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36215 */     GIR_RootConstrainSelectedInstOperands,
     /*  36216 */     // GIR_Coverage, 8940,
     /*  36216 */     GIR_EraseRootFromParent_Done,
     /*  36217 */   // Label 577: @36217
     /*  36217 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36263), // Rule ID 15209 //
     /*  36222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36237 */     // MIs[1] Operand 2
     /*  36237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36250 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36261 */     GIR_RootConstrainSelectedInstOperands,
     /*  36262 */     // GIR_Coverage, 15209,
     /*  36262 */     GIR_EraseRootFromParent_Done,
     /*  36263 */   // Label 578: @36263
     /*  36263 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36309), // Rule ID 8941 //
     /*  36268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36283 */     // MIs[1] Operand 2
     /*  36283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36296 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36307 */     GIR_RootConstrainSelectedInstOperands,
     /*  36308 */     // GIR_Coverage, 8941,
     /*  36308 */     GIR_EraseRootFromParent_Done,
     /*  36309 */   // Label 579: @36309
     /*  36309 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36324), // Rule ID 2773 //
     /*  36314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36317 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36322 */     GIR_RootConstrainSelectedInstOperands,
     /*  36323 */     // GIR_Coverage, 2773,
     /*  36323 */     GIR_Done,
     /*  36324 */   // Label 580: @36324
     /*  36324 */   GIM_Reject,
     /*  36325 */ // Label 573: @36325
     /*  36325 */ GIM_Reject,
     /*  36326 */ // Label 165: @36326
     /*  36326 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36351), // Rule ID 2772 //
     /*  36331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36344 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36349 */   GIR_RootConstrainSelectedInstOperands,
     /*  36350 */   // GIR_Coverage, 2772,
     /*  36350 */   GIR_Done,
     /*  36351 */ // Label 581: @36351
     /*  36351 */ GIM_Reject,
     /*  36352 */ // Label 166: @36352
     /*  36352 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36377), // Rule ID 2771 //
     /*  36357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36370 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36375 */   GIR_RootConstrainSelectedInstOperands,
     /*  36376 */   // GIR_Coverage, 2771,
     /*  36376 */   GIR_Done,
     /*  36377 */ // Label 582: @36377
     /*  36377 */ GIM_Reject,
     /*  36378 */ // Label 167: @36378
     /*  36378 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36403), // Rule ID 2770 //
     /*  36383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36396 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36401 */   GIR_RootConstrainSelectedInstOperands,
     /*  36402 */   // GIR_Coverage, 2770,
     /*  36402 */   GIR_Done,
     /*  36403 */ // Label 583: @36403
     /*  36403 */ GIM_Reject,
     /*  36404 */ // Label 168: @36404
     /*  36404 */ GIM_Reject,
     /*  36405 */ // Label 1: @36405
     /*  36405 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 597*/ GIMT_Encode4(50632),
     /*  36416 */ /*GILLT_s32*//*Label 584*/ GIMT_Encode4(36504),
     /*  36420 */ /*GILLT_s64*//*Label 585*/ GIMT_Encode4(37986), GIMT_Encode4(0),
     /*  36428 */ /*GILLT_v2s32*//*Label 586*/ GIMT_Encode4(41268),
     /*  36432 */ /*GILLT_v2s64*//*Label 587*/ GIMT_Encode4(42759),
     /*  36436 */ /*GILLT_v4s16*//*Label 588*/ GIMT_Encode4(45219),
     /*  36440 */ /*GILLT_v4s32*//*Label 589*/ GIMT_Encode4(46710),
     /*  36444 */ /*GILLT_v8s8*//*Label 590*/ GIMT_Encode4(49170),
     /*  36448 */ /*GILLT_v8s16*//*Label 591*/ GIMT_Encode4(49245),
     /*  36452 */ /*GILLT_v16s8*//*Label 592*/ GIMT_Encode4(50453), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36472 */ /*GILLT_nxv2s64*//*Label 593*/ GIMT_Encode4(50528), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36484 */ /*GILLT_nxv4s32*//*Label 594*/ GIMT_Encode4(50554), GIMT_Encode4(0),
     /*  36492 */ /*GILLT_nxv8s16*//*Label 595*/ GIMT_Encode4(50580), GIMT_Encode4(0),
     /*  36500 */ /*GILLT_nxv16s8*//*Label 596*/ GIMT_Encode4(50606),
     /*  36504 */ // Label 584: @36504
     /*  36504 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(37985),
     /*  36509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36515 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(36667), // Rule ID 9987 //
     /*  36520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36551 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36554 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36559 */     // MIs[2] pattern
     /*  36559 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36562 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36569 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36569 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36572 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36576 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36595 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36602 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36610 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36666 */     // GIR_Coverage, 9987,
     /*  36666 */     GIR_EraseRootFromParent_Done,
     /*  36667 */   // Label 599: @36667
     /*  36667 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36819), // Rule ID 9999 //
     /*  36672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36703 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36706 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36711 */     // MIs[2] pattern
     /*  36711 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36714 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36721 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36721 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36724 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36728 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36747 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36750 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36754 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36762 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36818 */     // GIR_Coverage, 9999,
     /*  36818 */     GIR_EraseRootFromParent_Done,
     /*  36819 */   // Label 600: @36819
     /*  36819 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36971), // Rule ID 10011 //
     /*  36824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36855 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36858 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  36863 */     // MIs[2] pattern
     /*  36863 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36866 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36873 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36873 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36876 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36880 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36899 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36902 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36906 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  36931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36936 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36970 */     // GIR_Coverage, 10011,
     /*  36970 */     GIR_EraseRootFromParent_Done,
     /*  36971 */   // Label 601: @36971
     /*  36971 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(37123), // Rule ID 10023 //
     /*  36976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37007 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37010 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37015 */     // MIs[2] pattern
     /*  37015 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37018 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37025 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37025 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37028 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37032 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37051 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37054 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37058 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37105 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37122 */     // GIR_Coverage, 10023,
     /*  37122 */     GIR_EraseRootFromParent_Done,
     /*  37123 */   // Label 602: @37123
     /*  37123 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(37185), // Rule ID 3950 //
     /*  37128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37164 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37183 */     GIR_RootConstrainSelectedInstOperands,
     /*  37184 */     // GIR_Coverage, 3950,
     /*  37184 */     GIR_EraseRootFromParent_Done,
     /*  37185 */   // Label 603: @37185
     /*  37185 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(37342), // Rule ID 10125 //
     /*  37190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37221 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37224 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37233 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37240 */     // MIs[2] pred
     /*  37240 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37247 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37273 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37280 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37314 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37324 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37341 */     // GIR_Coverage, 10125,
     /*  37341 */     GIR_EraseRootFromParent_Done,
     /*  37342 */   // Label 604: @37342
     /*  37342 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37499), // Rule ID 10126 //
     /*  37347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37378 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37381 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37390 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37397 */     // MIs[2] pred
     /*  37397 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37404 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37404 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37407 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37411 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37430 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37433 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37437 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37440 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37481 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37498 */     // GIR_Coverage, 10126,
     /*  37498 */     GIR_EraseRootFromParent_Done,
     /*  37499 */   // Label 605: @37499
     /*  37499 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37656), // Rule ID 10127 //
     /*  37504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37535 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37538 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37547 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37554 */     // MIs[2] pred
     /*  37554 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37561 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37587 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37628 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37638 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37655 */     // GIR_Coverage, 10127,
     /*  37655 */     GIR_EraseRootFromParent_Done,
     /*  37656 */   // Label 606: @37656
     /*  37656 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37813), // Rule ID 10128 //
     /*  37661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37692 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37695 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37704 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37711 */     // MIs[2] pred
     /*  37711 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37718 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37718 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37721 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37725 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37744 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37751 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37785 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37795 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37812 */     // GIR_Coverage, 10128,
     /*  37812 */     GIR_EraseRootFromParent_Done,
     /*  37813 */   // Label 607: @37813
     /*  37813 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37849), // Rule ID 3915 //
     /*  37818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  37833 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  37833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  37836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37838 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  37840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  37844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37847 */     GIR_RootConstrainSelectedInstOperands,
     /*  37848 */     // GIR_Coverage, 3915,
     /*  37848 */     GIR_EraseRootFromParent_Done,
     /*  37849 */   // Label 608: @37849
     /*  37849 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37882), // Rule ID 3920 //
     /*  37854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  37869 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  37872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37880 */     GIR_RootConstrainSelectedInstOperands,
     /*  37881 */     // GIR_Coverage, 3920,
     /*  37881 */     GIR_EraseRootFromParent_Done,
     /*  37882 */   // Label 609: @37882
     /*  37882 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37918), // Rule ID 3909 //
     /*  37887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  37902 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  37905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37916 */     GIR_RootConstrainSelectedInstOperands,
     /*  37917 */     // GIR_Coverage, 3909,
     /*  37917 */     GIR_EraseRootFromParent_Done,
     /*  37918 */   // Label 610: @37918
     /*  37918 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37954), // Rule ID 3913 //
     /*  37923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  37938 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  37938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  37941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  37949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37952 */     GIR_RootConstrainSelectedInstOperands,
     /*  37953 */     // GIR_Coverage, 3913,
     /*  37953 */     GIR_EraseRootFromParent_Done,
     /*  37954 */   // Label 611: @37954
     /*  37954 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37984), // Rule ID 3911 //
     /*  37959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37971 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  37971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  37976 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  37982 */     GIR_RootConstrainSelectedInstOperands,
     /*  37983 */     // GIR_Coverage, 3911,
     /*  37983 */     GIR_Done,
     /*  37984 */   // Label 612: @37984
     /*  37984 */   GIM_Reject,
     /*  37985 */ // Label 598: @37985
     /*  37985 */ GIM_Reject,
     /*  37986 */ // Label 585: @37986
     /*  37986 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(41267),
     /*  37991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37997 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38133), // Rule ID 5413 //
     /*  38002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38035 */     // MIs[1] Operand 2
     /*  38035 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38066 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38070 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38075 */     // MIs[3] Operand 2
     /*  38075 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38088 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38115 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38132 */     // GIR_Coverage, 5413,
     /*  38132 */     GIR_EraseRootFromParent_Done,
     /*  38133 */   // Label 614: @38133
     /*  38133 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38269), // Rule ID 5412 //
     /*  38138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38171 */     // MIs[1] Operand 2
     /*  38171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38198 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38202 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38206 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38211 */     // MIs[3] Operand 2
     /*  38211 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38222 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38224 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38268 */     // GIR_Coverage, 5412,
     /*  38268 */     GIR_EraseRootFromParent_Done,
     /*  38269 */   // Label 615: @38269
     /*  38269 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38405), // Rule ID 5422 //
     /*  38274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38307 */     // MIs[1] Operand 2
     /*  38307 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38330 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38334 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38338 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38342 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38347 */     // MIs[3] Operand 2
     /*  38347 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38358 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38360 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38387 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38404 */     // GIR_Coverage, 5422,
     /*  38404 */     GIR_EraseRootFromParent_Done,
     /*  38405 */   // Label 616: @38405
     /*  38405 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38541), // Rule ID 5411 //
     /*  38410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38443 */     // MIs[1] Operand 2
     /*  38443 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38466 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38470 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38474 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38478 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38483 */     // MIs[3] Operand 2
     /*  38483 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38494 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38496 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38523 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38540 */     // GIR_Coverage, 5411,
     /*  38540 */     GIR_EraseRootFromParent_Done,
     /*  38541 */   // Label 617: @38541
     /*  38541 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38677), // Rule ID 5410 //
     /*  38546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38579 */     // MIs[1] Operand 2
     /*  38579 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38602 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38606 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38610 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38614 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38619 */     // MIs[3] Operand 2
     /*  38619 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38632 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38659 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38676 */     // GIR_Coverage, 5410,
     /*  38676 */     GIR_EraseRootFromParent_Done,
     /*  38677 */   // Label 618: @38677
     /*  38677 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38814), // Rule ID 3967 //
     /*  38682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38723 */     // MIs[2] Operand 2
     /*  38723 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38742 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38746 */     // MIs[3] Operand 1
     /*  38746 */     // No operand predicates
     /*  38746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38748 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38760 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38779 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  38806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38812 */     GIR_RootConstrainSelectedInstOperands,
     /*  38813 */     // GIR_Coverage, 3967,
     /*  38813 */     GIR_EraseRootFromParent_Done,
     /*  38814 */   // Label 619: @38814
     /*  38814 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38913), // Rule ID 3965 //
     /*  38819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38868 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38872 */     // MIs[3] Operand 1
     /*  38872 */     // No operand predicates
     /*  38872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38874 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38886 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38911 */     GIR_RootConstrainSelectedInstOperands,
     /*  38912 */     // GIR_Coverage, 3965,
     /*  38912 */     GIR_EraseRootFromParent_Done,
     /*  38913 */   // Label 620: @38913
     /*  38913 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(39012), // Rule ID 3966 //
     /*  38918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38967 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  38971 */     // MIs[3] Operand 1
     /*  38971 */     // No operand predicates
     /*  38971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38973 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38985 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  38995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39010 */     GIR_RootConstrainSelectedInstOperands,
     /*  39011 */     // GIR_Coverage, 3966,
     /*  39011 */     GIR_EraseRootFromParent_Done,
     /*  39012 */   // Label 621: @39012
     /*  39012 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(39098), // Rule ID 3960 //
     /*  39017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39066 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39077 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39096 */     GIR_RootConstrainSelectedInstOperands,
     /*  39097 */     // GIR_Coverage, 3960,
     /*  39097 */     GIR_EraseRootFromParent_Done,
     /*  39098 */   // Label 622: @39098
     /*  39098 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39184), // Rule ID 3961 //
     /*  39103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39152 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39163 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39182 */     GIR_RootConstrainSelectedInstOperands,
     /*  39183 */     // GIR_Coverage, 3961,
     /*  39183 */     GIR_EraseRootFromParent_Done,
     /*  39184 */   // Label 623: @39184
     /*  39184 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39317), // Rule ID 3973 //
     /*  39189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39230 */     // MIs[2] Operand 2
     /*  39230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39249 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39253 */     // MIs[3] Operand 1
     /*  39253 */     // No operand predicates
     /*  39253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39255 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39267 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39286 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39315 */     GIR_RootConstrainSelectedInstOperands,
     /*  39316 */     // GIR_Coverage, 3973,
     /*  39316 */     GIR_EraseRootFromParent_Done,
     /*  39317 */   // Label 624: @39317
     /*  39317 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39412), // Rule ID 3971 //
     /*  39322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39371 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39375 */     // MIs[3] Operand 1
     /*  39375 */     // No operand predicates
     /*  39375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39377 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39389 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39410 */     GIR_RootConstrainSelectedInstOperands,
     /*  39411 */     // GIR_Coverage, 3971,
     /*  39411 */     GIR_EraseRootFromParent_Done,
     /*  39412 */   // Label 625: @39412
     /*  39412 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39507), // Rule ID 3972 //
     /*  39417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39466 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39470 */     // MIs[3] Operand 1
     /*  39470 */     // No operand predicates
     /*  39470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39472 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39484 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39505 */     GIR_RootConstrainSelectedInstOperands,
     /*  39506 */     // GIR_Coverage, 3972,
     /*  39506 */     GIR_EraseRootFromParent_Done,
     /*  39507 */   // Label 626: @39507
     /*  39507 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39589), // Rule ID 124 //
     /*  39512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39561 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39565 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39572 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39587 */     GIR_RootConstrainSelectedInstOperands,
     /*  39588 */     // GIR_Coverage, 124,
     /*  39588 */     GIR_EraseRootFromParent_Done,
     /*  39589 */   // Label 627: @39589
     /*  39589 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39671), // Rule ID 126 //
     /*  39594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39643 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39647 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39654 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39669 */     GIR_RootConstrainSelectedInstOperands,
     /*  39670 */     // GIR_Coverage, 126,
     /*  39670 */     GIR_EraseRootFromParent_Done,
     /*  39671 */   // Label 628: @39671
     /*  39671 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39733), // Rule ID 3951 //
     /*  39676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39712 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39731 */     GIR_RootConstrainSelectedInstOperands,
     /*  39732 */     // GIR_Coverage, 3951,
     /*  39732 */     GIR_EraseRootFromParent_Done,
     /*  39733 */   // Label 629: @39733
     /*  39733 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39791), // Rule ID 9984 //
     /*  39738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39757 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39760 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39765 */     // MIs[1] pattern
     /*  39765 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39768 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39775 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39789 */     GIR_RootConstrainSelectedInstOperands,
     /*  39790 */     // GIR_Coverage, 9984,
     /*  39790 */     GIR_EraseRootFromParent_Done,
     /*  39791 */   // Label 630: @39791
     /*  39791 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39849), // Rule ID 9996 //
     /*  39796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39815 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39818 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  39823 */     // MIs[1] pattern
     /*  39823 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39826 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39833 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  39836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39847 */     GIR_RootConstrainSelectedInstOperands,
     /*  39848 */     // GIR_Coverage, 9996,
     /*  39848 */     GIR_EraseRootFromParent_Done,
     /*  39849 */   // Label 631: @39849
     /*  39849 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39907), // Rule ID 10008 //
     /*  39854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39873 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39876 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  39881 */     // MIs[1] pattern
     /*  39881 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39884 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39891 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  39894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39905 */     GIR_RootConstrainSelectedInstOperands,
     /*  39906 */     // GIR_Coverage, 10008,
     /*  39906 */     GIR_EraseRootFromParent_Done,
     /*  39907 */   // Label 632: @39907
     /*  39907 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39965), // Rule ID 10020 //
     /*  39912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39931 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39934 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  39939 */     // MIs[1] pattern
     /*  39939 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39942 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39949 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  39952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39963 */     GIR_RootConstrainSelectedInstOperands,
     /*  39964 */     // GIR_Coverage, 10020,
     /*  39964 */     GIR_EraseRootFromParent_Done,
     /*  39965 */   // Label 633: @39965
     /*  39965 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40128), // Rule ID 5377 //
     /*  39970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40016 */     // MIs[1] Operand 2
     /*  40016 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40029 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40029 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40032 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40036 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40055 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40062 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40075 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40127 */     // GIR_Coverage, 5377,
     /*  40127 */     GIR_EraseRootFromParent_Done,
     /*  40128 */   // Label 634: @40128
     /*  40128 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40291), // Rule ID 5374 //
     /*  40133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40179 */     // MIs[1] Operand 2
     /*  40179 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40192 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40218 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40225 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40290 */     // GIR_Coverage, 5374,
     /*  40290 */     GIR_EraseRootFromParent_Done,
     /*  40291 */   // Label 635: @40291
     /*  40291 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40441), // Rule ID 5419 //
     /*  40296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40333 */     // MIs[1] Operand 2
     /*  40333 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40346 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40346 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40349 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40353 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40372 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40440 */     // GIR_Coverage, 5419,
     /*  40440 */     GIR_EraseRootFromParent_Done,
     /*  40441 */   // Label 636: @40441
     /*  40441 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40591), // Rule ID 5425 //
     /*  40446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40483 */     // MIs[1] Operand 2
     /*  40483 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40496 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40590 */     // GIR_Coverage, 5425,
     /*  40590 */     GIR_EraseRootFromParent_Done,
     /*  40591 */   // Label 637: @40591
     /*  40591 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40741), // Rule ID 5418 //
     /*  40596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40633 */     // MIs[1] Operand 2
     /*  40633 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40646 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40723 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40740 */     // GIR_Coverage, 5418,
     /*  40740 */     GIR_EraseRootFromParent_Done,
     /*  40741 */   // Label 638: @40741
     /*  40741 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40777), // Rule ID 3916 //
     /*  40746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40761 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40766 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40775 */     GIR_RootConstrainSelectedInstOperands,
     /*  40776 */     // GIR_Coverage, 3916,
     /*  40776 */     GIR_EraseRootFromParent_Done,
     /*  40777 */   // Label 639: @40777
     /*  40777 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40810), // Rule ID 3921 //
     /*  40782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  40797 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  40800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40808 */     GIR_RootConstrainSelectedInstOperands,
     /*  40809 */     // GIR_Coverage, 3921,
     /*  40809 */     GIR_EraseRootFromParent_Done,
     /*  40810 */   // Label 640: @40810
     /*  40810 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40846), // Rule ID 3910 //
     /*  40815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  40830 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  40833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40844 */     GIR_RootConstrainSelectedInstOperands,
     /*  40845 */     // GIR_Coverage, 3910,
     /*  40845 */     GIR_EraseRootFromParent_Done,
     /*  40846 */   // Label 641: @40846
     /*  40846 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40882), // Rule ID 3914 //
     /*  40851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  40866 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  40866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  40869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  40877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40880 */     GIR_RootConstrainSelectedInstOperands,
     /*  40881 */     // GIR_Coverage, 3914,
     /*  40881 */     GIR_EraseRootFromParent_Done,
     /*  40882 */   // Label 642: @40882
     /*  40882 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40945), // Rule ID 10117 //
     /*  40887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40906 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40909 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  40918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40925 */     // MIs[1] pred
     /*  40925 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40932 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  40935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40943 */     GIR_RootConstrainSelectedInstOperands,
     /*  40944 */     // GIR_Coverage, 10117,
     /*  40944 */     GIR_EraseRootFromParent_Done,
     /*  40945 */   // Label 643: @40945
     /*  40945 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41008), // Rule ID 10118 //
     /*  40950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40969 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40972 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  40981 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40988 */     // MIs[1] pred
     /*  40988 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40995 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  40998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41006 */     GIR_RootConstrainSelectedInstOperands,
     /*  41007 */     // GIR_Coverage, 10118,
     /*  41007 */     GIR_EraseRootFromParent_Done,
     /*  41008 */   // Label 644: @41008
     /*  41008 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41071), // Rule ID 10119 //
     /*  41013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41032 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41035 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41044 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41051 */     // MIs[1] pred
     /*  41051 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41058 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41069 */     GIR_RootConstrainSelectedInstOperands,
     /*  41070 */     // GIR_Coverage, 10119,
     /*  41070 */     GIR_EraseRootFromParent_Done,
     /*  41071 */   // Label 645: @41071
     /*  41071 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41134), // Rule ID 10120 //
     /*  41076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41095 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41098 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41114 */     // MIs[1] pred
     /*  41114 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41121 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41132 */     GIR_RootConstrainSelectedInstOperands,
     /*  41133 */     // GIR_Coverage, 10120,
     /*  41133 */     GIR_EraseRootFromParent_Done,
     /*  41134 */   // Label 646: @41134
     /*  41134 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41173), // Rule ID 1655 //
     /*  41139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41150 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41156 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41164 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41171 */     GIR_RootConstrainSelectedInstOperands,
     /*  41172 */     // GIR_Coverage, 1655,
     /*  41172 */     GIR_EraseRootFromParent_Done,
     /*  41173 */   // Label 647: @41173
     /*  41173 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41209), // Rule ID 5260 //
     /*  41178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41200 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41207 */     GIR_RootConstrainSelectedInstOperands,
     /*  41208 */     // GIR_Coverage, 5260,
     /*  41208 */     GIR_EraseRootFromParent_Done,
     /*  41209 */   // Label 648: @41209
     /*  41209 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41236), // Rule ID 1644 //
     /*  41214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41229 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41234 */     GIR_RootConstrainSelectedInstOperands,
     /*  41235 */     // GIR_Coverage, 1644,
     /*  41235 */     GIR_Done,
     /*  41236 */   // Label 649: @41236
     /*  41236 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41266), // Rule ID 3912 //
     /*  41241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41253 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41258 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41264 */     GIR_RootConstrainSelectedInstOperands,
     /*  41265 */     // GIR_Coverage, 3912,
     /*  41265 */     GIR_Done,
     /*  41266 */   // Label 650: @41266
     /*  41266 */   GIM_Reject,
     /*  41267 */ // Label 613: @41267
     /*  41267 */ GIM_Reject,
     /*  41268 */ // Label 586: @41268
     /*  41268 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(42758),
     /*  41273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41283 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41415), // Rule ID 5409 //
     /*  41288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41317 */     // MIs[1] Operand 2
     /*  41317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41344 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41348 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41352 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41357 */     // MIs[3] Operand 2
     /*  41357 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41368 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41370 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41414 */     // GIR_Coverage, 5409,
     /*  41414 */     GIR_EraseRootFromParent_Done,
     /*  41415 */   // Label 652: @41415
     /*  41415 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41547), // Rule ID 5408 //
     /*  41420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41449 */     // MIs[1] Operand 2
     /*  41449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41489 */     // MIs[3] Operand 2
     /*  41489 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41502 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41546 */     // GIR_Coverage, 5408,
     /*  41546 */     GIR_EraseRootFromParent_Done,
     /*  41547 */   // Label 653: @41547
     /*  41547 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41679), // Rule ID 5421 //
     /*  41552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41581 */     // MIs[1] Operand 2
     /*  41581 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41612 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41616 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41621 */     // MIs[3] Operand 2
     /*  41621 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41632 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41634 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41661 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41678 */     // GIR_Coverage, 5421,
     /*  41678 */     GIR_EraseRootFromParent_Done,
     /*  41679 */   // Label 654: @41679
     /*  41679 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41811), // Rule ID 5407 //
     /*  41684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41713 */     // MIs[1] Operand 2
     /*  41713 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41732 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41744 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41748 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41753 */     // MIs[3] Operand 2
     /*  41753 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41766 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41793 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41810 */     // GIR_Coverage, 5407,
     /*  41810 */     GIR_EraseRootFromParent_Done,
     /*  41811 */   // Label 655: @41811
     /*  41811 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41943), // Rule ID 5406 //
     /*  41816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41845 */     // MIs[1] Operand 2
     /*  41845 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41872 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41876 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41880 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41885 */     // MIs[3] Operand 2
     /*  41885 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41896 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41898 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41942 */     // GIR_Coverage, 5406,
     /*  41942 */     GIR_EraseRootFromParent_Done,
     /*  41943 */   // Label 656: @41943
     /*  41943 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42102), // Rule ID 5376 //
     /*  41948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41990 */     // MIs[1] Operand 2
     /*  41990 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42003 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42003 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42006 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42010 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42017 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42020 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42024 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42029 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42032 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42036 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42039 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42066 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42084 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42101 */     // GIR_Coverage, 5376,
     /*  42101 */     GIR_EraseRootFromParent_Done,
     /*  42102 */   // Label 657: @42102
     /*  42102 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42261), // Rule ID 5373 //
     /*  42107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42149 */     // MIs[1] Operand 2
     /*  42149 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42162 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42162 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42165 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42169 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42188 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42195 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42225 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42243 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42260 */     // GIR_Coverage, 5373,
     /*  42260 */     GIR_EraseRootFromParent_Done,
     /*  42261 */   // Label 658: @42261
     /*  42261 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42407), // Rule ID 5417 //
     /*  42266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42299 */     // MIs[1] Operand 2
     /*  42299 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42312 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42312 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42315 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42319 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42338 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42341 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42345 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42406 */     // GIR_Coverage, 5417,
     /*  42406 */     GIR_EraseRootFromParent_Done,
     /*  42407 */   // Label 659: @42407
     /*  42407 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42553), // Rule ID 5424 //
     /*  42412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42445 */     // MIs[1] Operand 2
     /*  42445 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42458 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42458 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42461 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42465 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42484 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42491 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42504 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42521 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42535 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42552 */     // GIR_Coverage, 5424,
     /*  42552 */     GIR_EraseRootFromParent_Done,
     /*  42553 */   // Label 660: @42553
     /*  42553 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42699), // Rule ID 5416 //
     /*  42558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42591 */     // MIs[1] Operand 2
     /*  42591 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42604 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42604 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42607 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42611 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42618 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42621 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42625 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42630 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42633 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42637 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42640 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42645 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42681 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42698 */     // GIR_Coverage, 5416,
     /*  42698 */     GIR_EraseRootFromParent_Done,
     /*  42699 */   // Label 661: @42699
     /*  42699 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42734), // Rule ID 969 //
     /*  42704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42725 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42732 */     GIR_RootConstrainSelectedInstOperands,
     /*  42733 */     // GIR_Coverage, 969,
     /*  42733 */     GIR_EraseRootFromParent_Done,
     /*  42734 */   // Label 662: @42734
     /*  42734 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42757), // Rule ID 1476 //
     /*  42739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42750 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42755 */     GIR_RootConstrainSelectedInstOperands,
     /*  42756 */     // GIR_Coverage, 1476,
     /*  42756 */     GIR_Done,
     /*  42757 */   // Label 663: @42757
     /*  42757 */   GIM_Reject,
     /*  42758 */ // Label 651: @42758
     /*  42758 */ GIM_Reject,
     /*  42759 */ // Label 587: @42759
     /*  42759 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(45218),
     /*  42764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42774 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42888), // Rule ID 2048 //
     /*  42779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42826 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42835 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42839 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42843 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42847 */     // MIs[4] Operand 1
     /*  42847 */     // No operand predicates
     /*  42847 */     // MIs[2] Operand 2
     /*  42847 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42858 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42867 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42886 */     GIR_RootConstrainSelectedInstOperands,
     /*  42887 */     // GIR_Coverage, 2048,
     /*  42887 */     GIR_EraseRootFromParent_Done,
     /*  42888 */   // Label 665: @42888
     /*  42888 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(43002), // Rule ID 13574 //
     /*  42893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42936 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42940 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42944 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42957 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42961 */     // MIs[4] Operand 1
     /*  42961 */     // No operand predicates
     /*  42961 */     // MIs[2] Operand 2
     /*  42961 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42972 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42981 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43000 */     GIR_RootConstrainSelectedInstOperands,
     /*  43001 */     // GIR_Coverage, 13574,
     /*  43001 */     GIR_EraseRootFromParent_Done,
     /*  43002 */   // Label 666: @43002
     /*  43002 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(43116), // Rule ID 2100 //
     /*  43007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43071 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43075 */     // MIs[4] Operand 1
     /*  43075 */     // No operand predicates
     /*  43075 */     // MIs[2] Operand 2
     /*  43075 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43095 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43114 */     GIR_RootConstrainSelectedInstOperands,
     /*  43115 */     // GIR_Coverage, 2100,
     /*  43115 */     GIR_EraseRootFromParent_Done,
     /*  43116 */   // Label 667: @43116
     /*  43116 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43230), // Rule ID 13610 //
     /*  43121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43172 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43181 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43185 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43189 */     // MIs[4] Operand 1
     /*  43189 */     // No operand predicates
     /*  43189 */     // MIs[2] Operand 2
     /*  43189 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43209 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43228 */     GIR_RootConstrainSelectedInstOperands,
     /*  43229 */     // GIR_Coverage, 13610,
     /*  43229 */     GIR_EraseRootFromParent_Done,
     /*  43230 */   // Label 668: @43230
     /*  43230 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43295), // Rule ID 1855 //
     /*  43235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43278 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43293 */     GIR_RootConstrainSelectedInstOperands,
     /*  43294 */     // GIR_Coverage, 1855,
     /*  43294 */     GIR_EraseRootFromParent_Done,
     /*  43295 */   // Label 669: @43295
     /*  43295 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43360), // Rule ID 1854 //
     /*  43300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43343 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43358 */     GIR_RootConstrainSelectedInstOperands,
     /*  43359 */     // GIR_Coverage, 1854,
     /*  43359 */     GIR_EraseRootFromParent_Done,
     /*  43360 */   // Label 670: @43360
     /*  43360 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43425), // Rule ID 1759 //
     /*  43365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43408 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43423 */     GIR_RootConstrainSelectedInstOperands,
     /*  43424 */     // GIR_Coverage, 1759,
     /*  43424 */     GIR_EraseRootFromParent_Done,
     /*  43425 */   // Label 671: @43425
     /*  43425 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43490), // Rule ID 1853 //
     /*  43430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43473 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43488 */     GIR_RootConstrainSelectedInstOperands,
     /*  43489 */     // GIR_Coverage, 1853,
     /*  43489 */     GIR_EraseRootFromParent_Done,
     /*  43490 */   // Label 672: @43490
     /*  43490 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43555), // Rule ID 1852 //
     /*  43495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43538 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43553 */     GIR_RootConstrainSelectedInstOperands,
     /*  43554 */     // GIR_Coverage, 1852,
     /*  43554 */     GIR_EraseRootFromParent_Done,
     /*  43555 */   // Label 673: @43555
     /*  43555 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43666), // Rule ID 13572 //
     /*  43560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43611 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43624 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43628 */     // MIs[4] Operand 1
     /*  43628 */     // No operand predicates
     /*  43628 */     // MIs[2] Operand 2
     /*  43628 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43644 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43646 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43664 */     GIR_RootConstrainSelectedInstOperands,
     /*  43665 */     // GIR_Coverage, 13572,
     /*  43665 */     GIR_EraseRootFromParent_Done,
     /*  43666 */   // Label 674: @43666
     /*  43666 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43777), // Rule ID 2046 //
     /*  43671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43723 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43740 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43744 */     // MIs[4] Operand 1
     /*  43744 */     // No operand predicates
     /*  43744 */     // MIs[2] Operand 2
     /*  43744 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43755 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43757 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43775 */     GIR_RootConstrainSelectedInstOperands,
     /*  43776 */     // GIR_Coverage, 2046,
     /*  43776 */     GIR_EraseRootFromParent_Done,
     /*  43777 */   // Label 675: @43777
     /*  43777 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43888), // Rule ID 13608 //
     /*  43782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43829 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43833 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43838 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43842 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43846 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43850 */     // MIs[4] Operand 1
     /*  43850 */     // No operand predicates
     /*  43850 */     // MIs[2] Operand 2
     /*  43850 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43866 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43868 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43886 */     GIR_RootConstrainSelectedInstOperands,
     /*  43887 */     // GIR_Coverage, 13608,
     /*  43887 */     GIR_EraseRootFromParent_Done,
     /*  43888 */   // Label 676: @43888
     /*  43888 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(43999), // Rule ID 2098 //
     /*  43893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43941 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43945 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43949 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43962 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43966 */     // MIs[4] Operand 1
     /*  43966 */     // No operand predicates
     /*  43966 */     // MIs[2] Operand 2
     /*  43966 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43979 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43997 */     GIR_RootConstrainSelectedInstOperands,
     /*  43998 */     // GIR_Coverage, 2098,
     /*  43998 */     GIR_EraseRootFromParent_Done,
     /*  43999 */   // Label 677: @43999
     /*  43999 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44062), // Rule ID 1735 //
     /*  44004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44043 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44060 */     GIR_RootConstrainSelectedInstOperands,
     /*  44061 */     // GIR_Coverage, 1735,
     /*  44061 */     GIR_EraseRootFromParent_Done,
     /*  44062 */   // Label 678: @44062
     /*  44062 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44125), // Rule ID 1825 //
     /*  44067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44106 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44123 */     GIR_RootConstrainSelectedInstOperands,
     /*  44124 */     // GIR_Coverage, 1825,
     /*  44124 */     GIR_EraseRootFromParent_Done,
     /*  44125 */   // Label 679: @44125
     /*  44125 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44213), // Rule ID 13573 //
     /*  44130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44182 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44186 */     // MIs[3] Operand 1
     /*  44186 */     // No operand predicates
     /*  44186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44193 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44211 */     GIR_RootConstrainSelectedInstOperands,
     /*  44212 */     // GIR_Coverage, 13573,
     /*  44212 */     GIR_EraseRootFromParent_Done,
     /*  44213 */   // Label 680: @44213
     /*  44213 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44301), // Rule ID 2047 //
     /*  44218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44279 */     // MIs[3] Operand 1
     /*  44279 */     // No operand predicates
     /*  44279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44281 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44299 */     GIR_RootConstrainSelectedInstOperands,
     /*  44300 */     // GIR_Coverage, 2047,
     /*  44300 */     GIR_EraseRootFromParent_Done,
     /*  44301 */   // Label 681: @44301
     /*  44301 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44389), // Rule ID 13609 //
     /*  44306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44358 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44362 */     // MIs[3] Operand 1
     /*  44362 */     // No operand predicates
     /*  44362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44369 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44387 */     GIR_RootConstrainSelectedInstOperands,
     /*  44388 */     // GIR_Coverage, 13609,
     /*  44388 */     GIR_EraseRootFromParent_Done,
     /*  44389 */   // Label 682: @44389
     /*  44389 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44477), // Rule ID 2099 //
     /*  44394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44451 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44455 */     // MIs[3] Operand 1
     /*  44455 */     // No operand predicates
     /*  44455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44457 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44475 */     GIR_RootConstrainSelectedInstOperands,
     /*  44476 */     // GIR_Coverage, 2099,
     /*  44476 */     GIR_EraseRootFromParent_Done,
     /*  44477 */   // Label 683: @44477
     /*  44477 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44524), // Rule ID 1867 //
     /*  44482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44510 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44522 */     GIR_RootConstrainSelectedInstOperands,
     /*  44523 */     // GIR_Coverage, 1867,
     /*  44523 */     GIR_EraseRootFromParent_Done,
     /*  44524 */   // Label 684: @44524
     /*  44524 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44571), // Rule ID 1765 //
     /*  44529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44557 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44569 */     GIR_RootConstrainSelectedInstOperands,
     /*  44570 */     // GIR_Coverage, 1765,
     /*  44570 */     GIR_EraseRootFromParent_Done,
     /*  44571 */   // Label 685: @44571
     /*  44571 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44618), // Rule ID 1866 //
     /*  44576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44604 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44616 */     GIR_RootConstrainSelectedInstOperands,
     /*  44617 */     // GIR_Coverage, 1866,
     /*  44617 */     GIR_EraseRootFromParent_Done,
     /*  44618 */   // Label 686: @44618
     /*  44618 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44677), // Rule ID 1851 //
     /*  44623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44662 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44675 */     GIR_RootConstrainSelectedInstOperands,
     /*  44676 */     // GIR_Coverage, 1851,
     /*  44676 */     GIR_EraseRootFromParent_Done,
     /*  44677 */   // Label 687: @44677
     /*  44677 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44736), // Rule ID 1850 //
     /*  44682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44721 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44734 */     GIR_RootConstrainSelectedInstOperands,
     /*  44735 */     // GIR_Coverage, 1850,
     /*  44735 */     GIR_EraseRootFromParent_Done,
     /*  44736 */   // Label 688: @44736
     /*  44736 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44795), // Rule ID 1758 //
     /*  44741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44780 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44793 */     GIR_RootConstrainSelectedInstOperands,
     /*  44794 */     // GIR_Coverage, 1758,
     /*  44794 */     GIR_EraseRootFromParent_Done,
     /*  44795 */   // Label 689: @44795
     /*  44795 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44854), // Rule ID 1849 //
     /*  44800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44839 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44852 */     GIR_RootConstrainSelectedInstOperands,
     /*  44853 */     // GIR_Coverage, 1849,
     /*  44853 */     GIR_EraseRootFromParent_Done,
     /*  44854 */   // Label 690: @44854
     /*  44854 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44913), // Rule ID 1848 //
     /*  44859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44898 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44911 */     GIR_RootConstrainSelectedInstOperands,
     /*  44912 */     // GIR_Coverage, 1848,
     /*  44912 */     GIR_EraseRootFromParent_Done,
     /*  44913 */   // Label 691: @44913
     /*  44913 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44948), // Rule ID 971 //
     /*  44918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44939 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  44939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  44942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44946 */     GIR_RootConstrainSelectedInstOperands,
     /*  44947 */     // GIR_Coverage, 971,
     /*  44947 */     GIR_EraseRootFromParent_Done,
     /*  44948 */   // Label 692: @44948
     /*  44948 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45005), // Rule ID 1734 //
     /*  44953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44988 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  44991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45003 */     GIR_RootConstrainSelectedInstOperands,
     /*  45004 */     // GIR_Coverage, 1734,
     /*  45004 */     GIR_EraseRootFromParent_Done,
     /*  45005 */   // Label 693: @45005
     /*  45005 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45062), // Rule ID 1824 //
     /*  45010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45045 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45060 */     GIR_RootConstrainSelectedInstOperands,
     /*  45061 */     // GIR_Coverage, 1824,
     /*  45061 */     GIR_EraseRootFromParent_Done,
     /*  45062 */   // Label 694: @45062
     /*  45062 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45106), // Rule ID 1865 //
     /*  45067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45093 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45104 */     GIR_RootConstrainSelectedInstOperands,
     /*  45105 */     // GIR_Coverage, 1865,
     /*  45105 */     GIR_EraseRootFromParent_Done,
     /*  45106 */   // Label 695: @45106
     /*  45106 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45150), // Rule ID 1764 //
     /*  45111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45137 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45148 */     GIR_RootConstrainSelectedInstOperands,
     /*  45149 */     // GIR_Coverage, 1764,
     /*  45149 */     GIR_EraseRootFromParent_Done,
     /*  45150 */   // Label 696: @45150
     /*  45150 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45194), // Rule ID 1864 //
     /*  45155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45181 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45192 */     GIR_RootConstrainSelectedInstOperands,
     /*  45193 */     // GIR_Coverage, 1864,
     /*  45193 */     GIR_EraseRootFromParent_Done,
     /*  45194 */   // Label 697: @45194
     /*  45194 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45217), // Rule ID 1478 //
     /*  45199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45210 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45215 */     GIR_RootConstrainSelectedInstOperands,
     /*  45216 */     // GIR_Coverage, 1478,
     /*  45216 */     GIR_Done,
     /*  45217 */   // Label 698: @45217
     /*  45217 */   GIM_Reject,
     /*  45218 */ // Label 664: @45218
     /*  45218 */ GIM_Reject,
     /*  45219 */ // Label 588: @45219
     /*  45219 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(46709),
     /*  45224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45234 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45366), // Rule ID 5405 //
     /*  45239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45268 */     // MIs[1] Operand 2
     /*  45268 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45287 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45291 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45295 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45299 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45303 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45308 */     // MIs[3] Operand 2
     /*  45308 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45319 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45321 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45337 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45348 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45365 */     // GIR_Coverage, 5405,
     /*  45365 */     GIR_EraseRootFromParent_Done,
     /*  45366 */   // Label 700: @45366
     /*  45366 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45498), // Rule ID 5404 //
     /*  45371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45400 */     // MIs[1] Operand 2
     /*  45400 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45435 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45440 */     // MIs[3] Operand 2
     /*  45440 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45453 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45497 */     // GIR_Coverage, 5404,
     /*  45497 */     GIR_EraseRootFromParent_Done,
     /*  45498 */   // Label 701: @45498
     /*  45498 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(45630), // Rule ID 5420 //
     /*  45503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45532 */     // MIs[1] Operand 2
     /*  45532 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45555 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45559 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45563 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45567 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45572 */     // MIs[3] Operand 2
     /*  45572 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45583 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45585 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45612 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45629 */     // GIR_Coverage, 5420,
     /*  45629 */     GIR_EraseRootFromParent_Done,
     /*  45630 */   // Label 702: @45630
     /*  45630 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45762), // Rule ID 5403 //
     /*  45635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45664 */     // MIs[1] Operand 2
     /*  45664 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45699 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45704 */     // MIs[3] Operand 2
     /*  45704 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45717 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45744 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45761 */     // GIR_Coverage, 5403,
     /*  45761 */     GIR_EraseRootFromParent_Done,
     /*  45762 */   // Label 703: @45762
     /*  45762 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45894), // Rule ID 5402 //
     /*  45767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45796 */     // MIs[1] Operand 2
     /*  45796 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45827 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45831 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45836 */     // MIs[3] Operand 2
     /*  45836 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45847 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45849 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45893 */     // GIR_Coverage, 5402,
     /*  45893 */     GIR_EraseRootFromParent_Done,
     /*  45894 */   // Label 704: @45894
     /*  45894 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46053), // Rule ID 5375 //
     /*  45899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  45923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  45931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45941 */     // MIs[1] Operand 2
     /*  45941 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45954 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45954 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  45957 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45961 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45968 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  45971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45975 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45980 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  45987 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  45990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  46012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46035 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46052 */     // GIR_Coverage, 5375,
     /*  46052 */     GIR_EraseRootFromParent_Done,
     /*  46053 */   // Label 705: @46053
     /*  46053 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46212), // Rule ID 5372 //
     /*  46058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46100 */     // MIs[1] Operand 2
     /*  46100 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46113 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46113 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46116 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46120 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46139 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46142 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46146 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46149 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46194 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46211 */     // GIR_Coverage, 5372,
     /*  46211 */     GIR_EraseRootFromParent_Done,
     /*  46212 */   // Label 706: @46212
     /*  46212 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46358), // Rule ID 5415 //
     /*  46217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46250 */     // MIs[1] Operand 2
     /*  46250 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46263 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46263 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46266 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46270 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46277 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46280 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46284 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46289 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46292 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46296 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46299 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46304 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46340 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46357 */     // GIR_Coverage, 5415,
     /*  46357 */     GIR_EraseRootFromParent_Done,
     /*  46358 */   // Label 707: @46358
     /*  46358 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46504), // Rule ID 5423 //
     /*  46363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46396 */     // MIs[1] Operand 2
     /*  46396 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46409 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46409 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46412 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46416 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46435 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46442 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46486 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46503 */     // GIR_Coverage, 5423,
     /*  46503 */     GIR_EraseRootFromParent_Done,
     /*  46504 */   // Label 708: @46504
     /*  46504 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46650), // Rule ID 5414 //
     /*  46509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46542 */     // MIs[1] Operand 2
     /*  46542 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46555 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46555 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46558 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46562 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46581 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46584 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46588 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46649 */     // GIR_Coverage, 5414,
     /*  46649 */     GIR_EraseRootFromParent_Done,
     /*  46650 */   // Label 709: @46650
     /*  46650 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46685), // Rule ID 967 //
     /*  46655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46662 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46668 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46676 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46683 */     GIR_RootConstrainSelectedInstOperands,
     /*  46684 */     // GIR_Coverage, 967,
     /*  46684 */     GIR_EraseRootFromParent_Done,
     /*  46685 */   // Label 710: @46685
     /*  46685 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46708), // Rule ID 1474 //
     /*  46690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46701 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46706 */     GIR_RootConstrainSelectedInstOperands,
     /*  46707 */     // GIR_Coverage, 1474,
     /*  46707 */     GIR_Done,
     /*  46708 */   // Label 711: @46708
     /*  46708 */   GIM_Reject,
     /*  46709 */ // Label 699: @46709
     /*  46709 */ GIM_Reject,
     /*  46710 */ // Label 589: @46710
     /*  46710 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(49169),
     /*  46715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46725 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46839), // Rule ID 2045 //
     /*  46730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46798 */     // MIs[4] Operand 1
     /*  46798 */     // No operand predicates
     /*  46798 */     // MIs[2] Operand 2
     /*  46798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46818 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46837 */     GIR_RootConstrainSelectedInstOperands,
     /*  46838 */     // GIR_Coverage, 2045,
     /*  46838 */     GIR_EraseRootFromParent_Done,
     /*  46839 */   // Label 713: @46839
     /*  46839 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46953), // Rule ID 13571 //
     /*  46844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46887 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46891 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46895 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46900 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46904 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46908 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46912 */     // MIs[4] Operand 1
     /*  46912 */     // No operand predicates
     /*  46912 */     // MIs[2] Operand 2
     /*  46912 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46923 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46932 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46951 */     GIR_RootConstrainSelectedInstOperands,
     /*  46952 */     // GIR_Coverage, 13571,
     /*  46952 */     GIR_EraseRootFromParent_Done,
     /*  46953 */   // Label 714: @46953
     /*  46953 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(47067), // Rule ID 2097 //
     /*  46958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47001 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47005 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47009 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47018 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47022 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47026 */     // MIs[4] Operand 1
     /*  47026 */     // No operand predicates
     /*  47026 */     // MIs[2] Operand 2
     /*  47026 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47046 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47065 */     GIR_RootConstrainSelectedInstOperands,
     /*  47066 */     // GIR_Coverage, 2097,
     /*  47066 */     GIR_EraseRootFromParent_Done,
     /*  47067 */   // Label 715: @47067
     /*  47067 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47181), // Rule ID 13607 //
     /*  47072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47115 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47132 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47136 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47140 */     // MIs[4] Operand 1
     /*  47140 */     // No operand predicates
     /*  47140 */     // MIs[2] Operand 2
     /*  47140 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47151 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47160 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47179 */     GIR_RootConstrainSelectedInstOperands,
     /*  47180 */     // GIR_Coverage, 13607,
     /*  47180 */     GIR_EraseRootFromParent_Done,
     /*  47181 */   // Label 716: @47181
     /*  47181 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47246), // Rule ID 1847 //
     /*  47186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47229 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47244 */     GIR_RootConstrainSelectedInstOperands,
     /*  47245 */     // GIR_Coverage, 1847,
     /*  47245 */     GIR_EraseRootFromParent_Done,
     /*  47246 */   // Label 717: @47246
     /*  47246 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47311), // Rule ID 1846 //
     /*  47251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47294 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47309 */     GIR_RootConstrainSelectedInstOperands,
     /*  47310 */     // GIR_Coverage, 1846,
     /*  47310 */     GIR_EraseRootFromParent_Done,
     /*  47311 */   // Label 718: @47311
     /*  47311 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47376), // Rule ID 1757 //
     /*  47316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47359 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47374 */     GIR_RootConstrainSelectedInstOperands,
     /*  47375 */     // GIR_Coverage, 1757,
     /*  47375 */     GIR_EraseRootFromParent_Done,
     /*  47376 */   // Label 719: @47376
     /*  47376 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47441), // Rule ID 1845 //
     /*  47381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47424 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47439 */     GIR_RootConstrainSelectedInstOperands,
     /*  47440 */     // GIR_Coverage, 1845,
     /*  47440 */     GIR_EraseRootFromParent_Done,
     /*  47441 */   // Label 720: @47441
     /*  47441 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47506), // Rule ID 1844 //
     /*  47446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47489 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47504 */     GIR_RootConstrainSelectedInstOperands,
     /*  47505 */     // GIR_Coverage, 1844,
     /*  47505 */     GIR_EraseRootFromParent_Done,
     /*  47506 */   // Label 721: @47506
     /*  47506 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47617), // Rule ID 13569 //
     /*  47511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47562 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47567 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47571 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47575 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47579 */     // MIs[4] Operand 1
     /*  47579 */     // No operand predicates
     /*  47579 */     // MIs[2] Operand 2
     /*  47579 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47595 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47597 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47615 */     GIR_RootConstrainSelectedInstOperands,
     /*  47616 */     // GIR_Coverage, 13569,
     /*  47616 */     GIR_EraseRootFromParent_Done,
     /*  47617 */   // Label 722: @47617
     /*  47617 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47728), // Rule ID 2043 //
     /*  47622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47678 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47683 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47687 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47691 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47695 */     // MIs[4] Operand 1
     /*  47695 */     // No operand predicates
     /*  47695 */     // MIs[2] Operand 2
     /*  47695 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47706 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47708 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47726 */     GIR_RootConstrainSelectedInstOperands,
     /*  47727 */     // GIR_Coverage, 2043,
     /*  47727 */     GIR_EraseRootFromParent_Done,
     /*  47728 */   // Label 723: @47728
     /*  47728 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47839), // Rule ID 13605 //
     /*  47733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47784 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47789 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47793 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47797 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47801 */     // MIs[4] Operand 1
     /*  47801 */     // No operand predicates
     /*  47801 */     // MIs[2] Operand 2
     /*  47801 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47817 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47819 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47837 */     GIR_RootConstrainSelectedInstOperands,
     /*  47838 */     // GIR_Coverage, 13605,
     /*  47838 */     GIR_EraseRootFromParent_Done,
     /*  47839 */   // Label 724: @47839
     /*  47839 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(47950), // Rule ID 2095 //
     /*  47844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47896 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47900 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47913 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47917 */     // MIs[4] Operand 1
     /*  47917 */     // No operand predicates
     /*  47917 */     // MIs[2] Operand 2
     /*  47917 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47928 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47930 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47948 */     GIR_RootConstrainSelectedInstOperands,
     /*  47949 */     // GIR_Coverage, 2095,
     /*  47949 */     GIR_EraseRootFromParent_Done,
     /*  47950 */   // Label 725: @47950
     /*  47950 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48013), // Rule ID 1733 //
     /*  47955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47994 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  47997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48011 */     GIR_RootConstrainSelectedInstOperands,
     /*  48012 */     // GIR_Coverage, 1733,
     /*  48012 */     GIR_EraseRootFromParent_Done,
     /*  48013 */   // Label 726: @48013
     /*  48013 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48076), // Rule ID 1823 //
     /*  48018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48057 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48074 */     GIR_RootConstrainSelectedInstOperands,
     /*  48075 */     // GIR_Coverage, 1823,
     /*  48075 */     GIR_EraseRootFromParent_Done,
     /*  48076 */   // Label 727: @48076
     /*  48076 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48164), // Rule ID 13570 //
     /*  48081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48133 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48137 */     // MIs[3] Operand 1
     /*  48137 */     // No operand predicates
     /*  48137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48144 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48162 */     GIR_RootConstrainSelectedInstOperands,
     /*  48163 */     // GIR_Coverage, 13570,
     /*  48163 */     GIR_EraseRootFromParent_Done,
     /*  48164 */   // Label 728: @48164
     /*  48164 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48252), // Rule ID 2044 //
     /*  48169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48226 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48230 */     // MIs[3] Operand 1
     /*  48230 */     // No operand predicates
     /*  48230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48232 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48250 */     GIR_RootConstrainSelectedInstOperands,
     /*  48251 */     // GIR_Coverage, 2044,
     /*  48251 */     GIR_EraseRootFromParent_Done,
     /*  48252 */   // Label 729: @48252
     /*  48252 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48340), // Rule ID 13606 //
     /*  48257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48313 */     // MIs[3] Operand 1
     /*  48313 */     // No operand predicates
     /*  48313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48320 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48338 */     GIR_RootConstrainSelectedInstOperands,
     /*  48339 */     // GIR_Coverage, 13606,
     /*  48339 */     GIR_EraseRootFromParent_Done,
     /*  48340 */   // Label 730: @48340
     /*  48340 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48428), // Rule ID 2096 //
     /*  48345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48402 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48406 */     // MIs[3] Operand 1
     /*  48406 */     // No operand predicates
     /*  48406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48408 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48426 */     GIR_RootConstrainSelectedInstOperands,
     /*  48427 */     // GIR_Coverage, 2096,
     /*  48427 */     GIR_EraseRootFromParent_Done,
     /*  48428 */   // Label 731: @48428
     /*  48428 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48475), // Rule ID 1863 //
     /*  48433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48461 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48473 */     GIR_RootConstrainSelectedInstOperands,
     /*  48474 */     // GIR_Coverage, 1863,
     /*  48474 */     GIR_EraseRootFromParent_Done,
     /*  48475 */   // Label 732: @48475
     /*  48475 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48522), // Rule ID 1763 //
     /*  48480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48508 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48520 */     GIR_RootConstrainSelectedInstOperands,
     /*  48521 */     // GIR_Coverage, 1763,
     /*  48521 */     GIR_EraseRootFromParent_Done,
     /*  48522 */   // Label 733: @48522
     /*  48522 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48569), // Rule ID 1862 //
     /*  48527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48555 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48567 */     GIR_RootConstrainSelectedInstOperands,
     /*  48568 */     // GIR_Coverage, 1862,
     /*  48568 */     GIR_EraseRootFromParent_Done,
     /*  48569 */   // Label 734: @48569
     /*  48569 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48628), // Rule ID 1843 //
     /*  48574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48613 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48626 */     GIR_RootConstrainSelectedInstOperands,
     /*  48627 */     // GIR_Coverage, 1843,
     /*  48627 */     GIR_EraseRootFromParent_Done,
     /*  48628 */   // Label 735: @48628
     /*  48628 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48687), // Rule ID 1842 //
     /*  48633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48672 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48685 */     GIR_RootConstrainSelectedInstOperands,
     /*  48686 */     // GIR_Coverage, 1842,
     /*  48686 */     GIR_EraseRootFromParent_Done,
     /*  48687 */   // Label 736: @48687
     /*  48687 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48746), // Rule ID 1756 //
     /*  48692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48731 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48744 */     GIR_RootConstrainSelectedInstOperands,
     /*  48745 */     // GIR_Coverage, 1756,
     /*  48745 */     GIR_EraseRootFromParent_Done,
     /*  48746 */   // Label 737: @48746
     /*  48746 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48805), // Rule ID 1841 //
     /*  48751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48790 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48803 */     GIR_RootConstrainSelectedInstOperands,
     /*  48804 */     // GIR_Coverage, 1841,
     /*  48804 */     GIR_EraseRootFromParent_Done,
     /*  48805 */   // Label 738: @48805
     /*  48805 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48864), // Rule ID 1840 //
     /*  48810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48849 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48862 */     GIR_RootConstrainSelectedInstOperands,
     /*  48863 */     // GIR_Coverage, 1840,
     /*  48863 */     GIR_EraseRootFromParent_Done,
     /*  48864 */   // Label 739: @48864
     /*  48864 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48899), // Rule ID 970 //
     /*  48869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  48884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48890 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  48890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  48893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48897 */     GIR_RootConstrainSelectedInstOperands,
     /*  48898 */     // GIR_Coverage, 970,
     /*  48898 */     GIR_EraseRootFromParent_Done,
     /*  48899 */   // Label 740: @48899
     /*  48899 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(48956), // Rule ID 1732 //
     /*  48904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48939 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  48942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48954 */     GIR_RootConstrainSelectedInstOperands,
     /*  48955 */     // GIR_Coverage, 1732,
     /*  48955 */     GIR_EraseRootFromParent_Done,
     /*  48956 */   // Label 741: @48956
     /*  48956 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49013), // Rule ID 1822 //
     /*  48961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48996 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  48999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  49011 */     GIR_RootConstrainSelectedInstOperands,
     /*  49012 */     // GIR_Coverage, 1822,
     /*  49012 */     GIR_EraseRootFromParent_Done,
     /*  49013 */   // Label 742: @49013
     /*  49013 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49057), // Rule ID 1861 //
     /*  49018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49044 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49055 */     GIR_RootConstrainSelectedInstOperands,
     /*  49056 */     // GIR_Coverage, 1861,
     /*  49056 */     GIR_EraseRootFromParent_Done,
     /*  49057 */   // Label 743: @49057
     /*  49057 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49101), // Rule ID 1762 //
     /*  49062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49088 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49099 */     GIR_RootConstrainSelectedInstOperands,
     /*  49100 */     // GIR_Coverage, 1762,
     /*  49100 */     GIR_EraseRootFromParent_Done,
     /*  49101 */   // Label 744: @49101
     /*  49101 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49145), // Rule ID 1860 //
     /*  49106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49132 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49143 */     GIR_RootConstrainSelectedInstOperands,
     /*  49144 */     // GIR_Coverage, 1860,
     /*  49144 */     GIR_EraseRootFromParent_Done,
     /*  49145 */   // Label 745: @49145
     /*  49145 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49168), // Rule ID 1477 //
     /*  49150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49161 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49166 */     GIR_RootConstrainSelectedInstOperands,
     /*  49167 */     // GIR_Coverage, 1477,
     /*  49167 */     GIR_Done,
     /*  49168 */   // Label 746: @49168
     /*  49168 */   GIM_Reject,
     /*  49169 */ // Label 712: @49169
     /*  49169 */ GIM_Reject,
     /*  49170 */ // Label 590: @49170
     /*  49170 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49244),
     /*  49175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49185 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49220), // Rule ID 965 //
     /*  49190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49211 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49218 */     GIR_RootConstrainSelectedInstOperands,
     /*  49219 */     // GIR_Coverage, 965,
     /*  49219 */     GIR_EraseRootFromParent_Done,
     /*  49220 */   // Label 748: @49220
     /*  49220 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49243), // Rule ID 1472 //
     /*  49225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49236 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49241 */     GIR_RootConstrainSelectedInstOperands,
     /*  49242 */     // GIR_Coverage, 1472,
     /*  49242 */     GIR_Done,
     /*  49243 */   // Label 749: @49243
     /*  49243 */   GIM_Reject,
     /*  49244 */ // Label 747: @49244
     /*  49244 */ GIM_Reject,
     /*  49245 */ // Label 591: @49245
     /*  49245 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(50452),
     /*  49250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49260 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49325), // Rule ID 1839 //
     /*  49265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49308 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49323 */     GIR_RootConstrainSelectedInstOperands,
     /*  49324 */     // GIR_Coverage, 1839,
     /*  49324 */     GIR_EraseRootFromParent_Done,
     /*  49325 */   // Label 751: @49325
     /*  49325 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49390), // Rule ID 1838 //
     /*  49330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49373 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49388 */     GIR_RootConstrainSelectedInstOperands,
     /*  49389 */     // GIR_Coverage, 1838,
     /*  49389 */     GIR_EraseRootFromParent_Done,
     /*  49390 */   // Label 752: @49390
     /*  49390 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(49455), // Rule ID 1755 //
     /*  49395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49438 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49453 */     GIR_RootConstrainSelectedInstOperands,
     /*  49454 */     // GIR_Coverage, 1755,
     /*  49454 */     GIR_EraseRootFromParent_Done,
     /*  49455 */   // Label 753: @49455
     /*  49455 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49520), // Rule ID 1837 //
     /*  49460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49503 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49518 */     GIR_RootConstrainSelectedInstOperands,
     /*  49519 */     // GIR_Coverage, 1837,
     /*  49519 */     GIR_EraseRootFromParent_Done,
     /*  49520 */   // Label 754: @49520
     /*  49520 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49585), // Rule ID 1836 //
     /*  49525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49568 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49583 */     GIR_RootConstrainSelectedInstOperands,
     /*  49584 */     // GIR_Coverage, 1836,
     /*  49584 */     GIR_EraseRootFromParent_Done,
     /*  49585 */   // Label 755: @49585
     /*  49585 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49648), // Rule ID 1731 //
     /*  49590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49629 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49646 */     GIR_RootConstrainSelectedInstOperands,
     /*  49647 */     // GIR_Coverage, 1731,
     /*  49647 */     GIR_EraseRootFromParent_Done,
     /*  49648 */   // Label 756: @49648
     /*  49648 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(49711), // Rule ID 1821 //
     /*  49653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49692 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49709 */     GIR_RootConstrainSelectedInstOperands,
     /*  49710 */     // GIR_Coverage, 1821,
     /*  49710 */     GIR_EraseRootFromParent_Done,
     /*  49711 */   // Label 757: @49711
     /*  49711 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49758), // Rule ID 1859 //
     /*  49716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49744 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49756 */     GIR_RootConstrainSelectedInstOperands,
     /*  49757 */     // GIR_Coverage, 1859,
     /*  49757 */     GIR_EraseRootFromParent_Done,
     /*  49758 */   // Label 758: @49758
     /*  49758 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49805), // Rule ID 1761 //
     /*  49763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49791 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  49794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1761,
     /*  49804 */     GIR_EraseRootFromParent_Done,
     /*  49805 */   // Label 759: @49805
     /*  49805 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49852), // Rule ID 1858 //
     /*  49810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49838 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49850 */     GIR_RootConstrainSelectedInstOperands,
     /*  49851 */     // GIR_Coverage, 1858,
     /*  49851 */     GIR_EraseRootFromParent_Done,
     /*  49852 */   // Label 760: @49852
     /*  49852 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(49911), // Rule ID 1835 //
     /*  49857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49896 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49909 */     GIR_RootConstrainSelectedInstOperands,
     /*  49910 */     // GIR_Coverage, 1835,
     /*  49910 */     GIR_EraseRootFromParent_Done,
     /*  49911 */   // Label 761: @49911
     /*  49911 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(49970), // Rule ID 1834 //
     /*  49916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49955 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49968 */     GIR_RootConstrainSelectedInstOperands,
     /*  49969 */     // GIR_Coverage, 1834,
     /*  49969 */     GIR_EraseRootFromParent_Done,
     /*  49970 */   // Label 762: @49970
     /*  49970 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(50029), // Rule ID 1754 //
     /*  49975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50014 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  50017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50027 */     GIR_RootConstrainSelectedInstOperands,
     /*  50028 */     // GIR_Coverage, 1754,
     /*  50028 */     GIR_EraseRootFromParent_Done,
     /*  50029 */   // Label 763: @50029
     /*  50029 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50088), // Rule ID 1833 //
     /*  50034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50073 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50086 */     GIR_RootConstrainSelectedInstOperands,
     /*  50087 */     // GIR_Coverage, 1833,
     /*  50087 */     GIR_EraseRootFromParent_Done,
     /*  50088 */   // Label 764: @50088
     /*  50088 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50147), // Rule ID 1832 //
     /*  50093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50132 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50145 */     GIR_RootConstrainSelectedInstOperands,
     /*  50146 */     // GIR_Coverage, 1832,
     /*  50146 */     GIR_EraseRootFromParent_Done,
     /*  50147 */   // Label 765: @50147
     /*  50147 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50182), // Rule ID 968 //
     /*  50152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50165 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50173 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50180 */     GIR_RootConstrainSelectedInstOperands,
     /*  50181 */     // GIR_Coverage, 968,
     /*  50181 */     GIR_EraseRootFromParent_Done,
     /*  50182 */   // Label 766: @50182
     /*  50182 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50239), // Rule ID 1730 //
     /*  50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50222 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50237 */     GIR_RootConstrainSelectedInstOperands,
     /*  50238 */     // GIR_Coverage, 1730,
     /*  50238 */     GIR_EraseRootFromParent_Done,
     /*  50239 */   // Label 767: @50239
     /*  50239 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50296), // Rule ID 1820 //
     /*  50244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50279 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50294 */     GIR_RootConstrainSelectedInstOperands,
     /*  50295 */     // GIR_Coverage, 1820,
     /*  50295 */     GIR_EraseRootFromParent_Done,
     /*  50296 */   // Label 768: @50296
     /*  50296 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50340), // Rule ID 1857 //
     /*  50301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50327 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50338 */     GIR_RootConstrainSelectedInstOperands,
     /*  50339 */     // GIR_Coverage, 1857,
     /*  50339 */     GIR_EraseRootFromParent_Done,
     /*  50340 */   // Label 769: @50340
     /*  50340 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50384), // Rule ID 1760 //
     /*  50345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50371 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50382 */     GIR_RootConstrainSelectedInstOperands,
     /*  50383 */     // GIR_Coverage, 1760,
     /*  50383 */     GIR_EraseRootFromParent_Done,
     /*  50384 */   // Label 770: @50384
     /*  50384 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50428), // Rule ID 1856 //
     /*  50389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50415 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50426 */     GIR_RootConstrainSelectedInstOperands,
     /*  50427 */     // GIR_Coverage, 1856,
     /*  50427 */     GIR_EraseRootFromParent_Done,
     /*  50428 */   // Label 771: @50428
     /*  50428 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50451), // Rule ID 1475 //
     /*  50433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50444 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50449 */     GIR_RootConstrainSelectedInstOperands,
     /*  50450 */     // GIR_Coverage, 1475,
     /*  50450 */     GIR_Done,
     /*  50451 */   // Label 772: @50451
     /*  50451 */   GIM_Reject,
     /*  50452 */ // Label 750: @50452
     /*  50452 */ GIM_Reject,
     /*  50453 */ // Label 592: @50453
     /*  50453 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50527),
     /*  50458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50468 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50503), // Rule ID 966 //
     /*  50473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50480 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50486 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50494 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50501 */     GIR_RootConstrainSelectedInstOperands,
     /*  50502 */     // GIR_Coverage, 966,
     /*  50502 */     GIR_EraseRootFromParent_Done,
     /*  50503 */   // Label 774: @50503
     /*  50503 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50526), // Rule ID 1473 //
     /*  50508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50519 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50524 */     GIR_RootConstrainSelectedInstOperands,
     /*  50525 */     // GIR_Coverage, 1473,
     /*  50525 */     GIR_Done,
     /*  50526 */   // Label 775: @50526
     /*  50526 */   GIM_Reject,
     /*  50527 */ // Label 773: @50527
     /*  50527 */ GIM_Reject,
     /*  50528 */ // Label 593: @50528
     /*  50528 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50553), // Rule ID 7487 //
     /*  50533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50546 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50551 */   GIR_RootConstrainSelectedInstOperands,
     /*  50552 */   // GIR_Coverage, 7487,
     /*  50552 */   GIR_Done,
     /*  50553 */ // Label 776: @50553
     /*  50553 */ GIM_Reject,
     /*  50554 */ // Label 594: @50554
     /*  50554 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50579), // Rule ID 7486 //
     /*  50559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50572 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50577 */   GIR_RootConstrainSelectedInstOperands,
     /*  50578 */   // GIR_Coverage, 7486,
     /*  50578 */   GIR_Done,
     /*  50579 */ // Label 777: @50579
     /*  50579 */ GIM_Reject,
     /*  50580 */ // Label 595: @50580
     /*  50580 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(50605), // Rule ID 7485 //
     /*  50585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50598 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50603 */   GIR_RootConstrainSelectedInstOperands,
     /*  50604 */   // GIR_Coverage, 7485,
     /*  50604 */   GIR_Done,
     /*  50605 */ // Label 778: @50605
     /*  50605 */ GIM_Reject,
     /*  50606 */ // Label 596: @50606
     /*  50606 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50631), // Rule ID 7484 //
     /*  50611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50624 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50629 */   GIR_RootConstrainSelectedInstOperands,
     /*  50630 */   // GIR_Coverage, 7484,
     /*  50630 */   GIR_Done,
     /*  50631 */ // Label 779: @50631
     /*  50631 */ GIM_Reject,
     /*  50632 */ // Label 597: @50632
     /*  50632 */ GIM_Reject,
     /*  50633 */ // Label 2: @50633
     /*  50633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 788*/ GIMT_Encode4(53153),
     /*  50644 */ /*GILLT_s32*//*Label 780*/ GIMT_Encode4(50684),
     /*  50648 */ /*GILLT_s64*//*Label 781*/ GIMT_Encode4(50841), GIMT_Encode4(0),
     /*  50656 */ /*GILLT_v2s32*//*Label 782*/ GIMT_Encode4(52077), GIMT_Encode4(0),
     /*  50664 */ /*GILLT_v4s16*//*Label 783*/ GIMT_Encode4(52415),
     /*  50668 */ /*GILLT_v4s32*//*Label 784*/ GIMT_Encode4(52753),
     /*  50672 */ /*GILLT_v8s8*//*Label 785*/ GIMT_Encode4(52919),
     /*  50676 */ /*GILLT_v8s16*//*Label 786*/ GIMT_Encode4(52953),
     /*  50680 */ /*GILLT_v16s8*//*Label 787*/ GIMT_Encode4(53119),
     /*  50684 */ // Label 780: @50684
     /*  50684 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(50840),
     /*  50689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50699 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(50754), // Rule ID 3952 //
     /*  50704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50720 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50735 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50752 */     GIR_RootConstrainSelectedInstOperands,
     /*  50753 */     // GIR_Coverage, 3952,
     /*  50753 */     GIR_EraseRootFromParent_Done,
     /*  50754 */   // Label 790: @50754
     /*  50754 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(50809), // Rule ID 13860 //
     /*  50759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50779 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50790 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50807 */     GIR_RootConstrainSelectedInstOperands,
     /*  50808 */     // GIR_Coverage, 13860,
     /*  50808 */     GIR_EraseRootFromParent_Done,
     /*  50809 */   // Label 791: @50809
     /*  50809 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(50839), // Rule ID 3948 //
     /*  50814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50822 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  50825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50837 */     GIR_RootConstrainSelectedInstOperands,
     /*  50838 */     // GIR_Coverage, 3948,
     /*  50838 */     GIR_EraseRootFromParent_Done,
     /*  50839 */   // Label 792: @50839
     /*  50839 */   GIM_Reject,
     /*  50840 */ // Label 789: @50840
     /*  50840 */ GIM_Reject,
     /*  50841 */ // Label 781: @50841
     /*  50841 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(52076),
     /*  50846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50856 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(51002), // Rule ID 3957 //
     /*  50861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50882 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50914 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50927 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  50927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  50930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50939 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  50945 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50967 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  50973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  50986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  50994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51000 */     GIR_RootConstrainSelectedInstOperands,
     /*  51001 */     // GIR_Coverage, 3957,
     /*  51001 */     GIR_EraseRootFromParent_Done,
     /*  51002 */   // Label 794: @51002
     /*  51002 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(51106), // Rule ID 3958 //
     /*  51007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51028 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51058 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51070 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51104 */     GIR_RootConstrainSelectedInstOperands,
     /*  51105 */     // GIR_Coverage, 3958,
     /*  51105 */     GIR_EraseRootFromParent_Done,
     /*  51106 */   // Label 795: @51106
     /*  51106 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51210), // Rule ID 13863 //
     /*  51111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51149 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51162 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51208 */     GIR_RootConstrainSelectedInstOperands,
     /*  51209 */     // GIR_Coverage, 13863,
     /*  51209 */     GIR_EraseRootFromParent_Done,
     /*  51210 */   // Label 796: @51210
     /*  51210 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(51265), // Rule ID 3953 //
     /*  51215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51246 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51263 */     GIR_RootConstrainSelectedInstOperands,
     /*  51264 */     // GIR_Coverage, 3953,
     /*  51264 */     GIR_EraseRootFromParent_Done,
     /*  51265 */   // Label 797: @51265
     /*  51265 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(51320), // Rule ID 13861 //
     /*  51270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51301 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51318 */     GIR_RootConstrainSelectedInstOperands,
     /*  51319 */     // GIR_Coverage, 13861,
     /*  51319 */     GIR_EraseRootFromParent_Done,
     /*  51320 */   // Label 798: @51320
     /*  51320 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51433), // Rule ID 3964 //
     /*  51325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51342 */     // MIs[1] Operand 2
     /*  51342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51365 */     // MIs[2] Operand 1
     /*  51365 */     // No operand predicates
     /*  51365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51367 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51379 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51398 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51431 */     GIR_RootConstrainSelectedInstOperands,
     /*  51432 */     // GIR_Coverage, 3964,
     /*  51432 */     GIR_EraseRootFromParent_Done,
     /*  51433 */   // Label 799: @51433
     /*  51433 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51508), // Rule ID 3962 //
     /*  51438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51467 */     // MIs[2] Operand 1
     /*  51467 */     // No operand predicates
     /*  51467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51469 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51481 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51506 */     GIR_RootConstrainSelectedInstOperands,
     /*  51507 */     // GIR_Coverage, 3962,
     /*  51507 */     GIR_EraseRootFromParent_Done,
     /*  51508 */   // Label 800: @51508
     /*  51508 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51583), // Rule ID 3963 //
     /*  51513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51542 */     // MIs[2] Operand 1
     /*  51542 */     // No operand predicates
     /*  51542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51544 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51556 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51581 */     GIR_RootConstrainSelectedInstOperands,
     /*  51582 */     // GIR_Coverage, 3963,
     /*  51582 */     GIR_EraseRootFromParent_Done,
     /*  51583 */   // Label 801: @51583
     /*  51583 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51721), // Rule ID 3954 //
     /*  51588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51605 */     // MIs[1] Operand 2
     /*  51605 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51633 */     // MIs[2] Operand 2
     /*  51633 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51646 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  51646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51658 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  51664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51686 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51719 */     GIR_RootConstrainSelectedInstOperands,
     /*  51720 */     // GIR_Coverage, 3954,
     /*  51720 */     GIR_EraseRootFromParent_Done,
     /*  51721 */   // Label 802: @51721
     /*  51721 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51821), // Rule ID 3955 //
     /*  51726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51743 */     // MIs[1] Operand 2
     /*  51743 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51773 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51785 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51819 */     GIR_RootConstrainSelectedInstOperands,
     /*  51820 */     // GIR_Coverage, 3955,
     /*  51820 */     GIR_EraseRootFromParent_Done,
     /*  51821 */   // Label 803: @51821
     /*  51821 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51921), // Rule ID 13862 //
     /*  51826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51860 */     // MIs[2] Operand 2
     /*  51860 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51873 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51885 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51919 */     GIR_RootConstrainSelectedInstOperands,
     /*  51920 */     // GIR_Coverage, 13862,
     /*  51920 */     GIR_EraseRootFromParent_Done,
     /*  51921 */   // Label 804: @51921
     /*  51921 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51983), // Rule ID 3956 //
     /*  51926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51962 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51981 */     GIR_RootConstrainSelectedInstOperands,
     /*  51982 */     // GIR_Coverage, 3956,
     /*  51982 */     GIR_EraseRootFromParent_Done,
     /*  51983 */   // Label 805: @51983
     /*  51983 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(52045), // Rule ID 3959 //
     /*  51988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52024 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52043 */     GIR_RootConstrainSelectedInstOperands,
     /*  52044 */     // GIR_Coverage, 3959,
     /*  52044 */     GIR_EraseRootFromParent_Done,
     /*  52045 */   // Label 806: @52045
     /*  52045 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52075), // Rule ID 3949 //
     /*  52050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52058 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  52061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52073 */     GIR_RootConstrainSelectedInstOperands,
     /*  52074 */     // GIR_Coverage, 3949,
     /*  52074 */     GIR_EraseRootFromParent_Done,
     /*  52075 */   // Label 807: @52075
     /*  52075 */   GIM_Reject,
     /*  52076 */ // Label 793: @52076
     /*  52076 */ GIM_Reject,
     /*  52077 */ // Label 782: @52077
     /*  52077 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52414),
     /*  52082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52092 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52178), // Rule ID 13548 //
     /*  52097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52141 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52145 */     // MIs[3] Operand 1
     /*  52145 */     // No operand predicates
     /*  52145 */     // MIs[1] Operand 2
     /*  52145 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52162 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52176 */     GIR_RootConstrainSelectedInstOperands,
     /*  52177 */     // GIR_Coverage, 13548,
     /*  52177 */     GIR_EraseRootFromParent_Done,
     /*  52178 */   // Label 809: @52178
     /*  52178 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52264), // Rule ID 2034 //
     /*  52183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52231 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52235 */     // MIs[3] Operand 1
     /*  52235 */     // No operand predicates
     /*  52235 */     // MIs[1] Operand 2
     /*  52235 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52248 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52262 */     GIR_RootConstrainSelectedInstOperands,
     /*  52263 */     // GIR_Coverage, 2034,
     /*  52263 */     GIR_EraseRootFromParent_Done,
     /*  52264 */   // Label 810: @52264
     /*  52264 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52327), // Rule ID 13549 //
     /*  52269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52305 */     // MIs[2] Operand 1
     /*  52305 */     // No operand predicates
     /*  52305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52311 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52325 */     GIR_RootConstrainSelectedInstOperands,
     /*  52326 */     // GIR_Coverage, 13549,
     /*  52326 */     GIR_EraseRootFromParent_Done,
     /*  52327 */   // Label 811: @52327
     /*  52327 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52390), // Rule ID 2035 //
     /*  52332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52372 */     // MIs[2] Operand 1
     /*  52372 */     // No operand predicates
     /*  52372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52374 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52388 */     GIR_RootConstrainSelectedInstOperands,
     /*  52389 */     // GIR_Coverage, 2035,
     /*  52389 */     GIR_EraseRootFromParent_Done,
     /*  52390 */   // Label 812: @52390
     /*  52390 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52413), // Rule ID 1352 //
     /*  52395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52406 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  52406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  52411 */     GIR_RootConstrainSelectedInstOperands,
     /*  52412 */     // GIR_Coverage, 1352,
     /*  52412 */     GIR_Done,
     /*  52413 */   // Label 813: @52413
     /*  52413 */   GIM_Reject,
     /*  52414 */ // Label 808: @52414
     /*  52414 */ GIM_Reject,
     /*  52415 */ // Label 783: @52415
     /*  52415 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52752),
     /*  52420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52430 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52516), // Rule ID 13545 //
     /*  52435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52479 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52483 */     // MIs[3] Operand 1
     /*  52483 */     // No operand predicates
     /*  52483 */     // MIs[1] Operand 2
     /*  52483 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52500 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52514 */     GIR_RootConstrainSelectedInstOperands,
     /*  52515 */     // GIR_Coverage, 13545,
     /*  52515 */     GIR_EraseRootFromParent_Done,
     /*  52516 */   // Label 815: @52516
     /*  52516 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52602), // Rule ID 2031 //
     /*  52521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52573 */     // MIs[3] Operand 1
     /*  52573 */     // No operand predicates
     /*  52573 */     // MIs[1] Operand 2
     /*  52573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52586 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52600 */     GIR_RootConstrainSelectedInstOperands,
     /*  52601 */     // GIR_Coverage, 2031,
     /*  52601 */     GIR_EraseRootFromParent_Done,
     /*  52602 */   // Label 816: @52602
     /*  52602 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52665), // Rule ID 13546 //
     /*  52607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52643 */     // MIs[2] Operand 1
     /*  52643 */     // No operand predicates
     /*  52643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52649 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52663 */     GIR_RootConstrainSelectedInstOperands,
     /*  52664 */     // GIR_Coverage, 13546,
     /*  52664 */     GIR_EraseRootFromParent_Done,
     /*  52665 */   // Label 817: @52665
     /*  52665 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52728), // Rule ID 2032 //
     /*  52670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52710 */     // MIs[2] Operand 1
     /*  52710 */     // No operand predicates
     /*  52710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52712 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52726 */     GIR_RootConstrainSelectedInstOperands,
     /*  52727 */     // GIR_Coverage, 2032,
     /*  52727 */     GIR_EraseRootFromParent_Done,
     /*  52728 */   // Label 818: @52728
     /*  52728 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52751), // Rule ID 1350 //
     /*  52733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52744 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52749 */     GIR_RootConstrainSelectedInstOperands,
     /*  52750 */     // GIR_Coverage, 1350,
     /*  52750 */     GIR_Done,
     /*  52751 */   // Label 819: @52751
     /*  52751 */   GIM_Reject,
     /*  52752 */ // Label 814: @52752
     /*  52752 */ GIM_Reject,
     /*  52753 */ // Label 784: @52753
     /*  52753 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52918),
     /*  52758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52768 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52831), // Rule ID 13550 //
     /*  52773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52809 */     // MIs[2] Operand 1
     /*  52809 */     // No operand predicates
     /*  52809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52815 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52829 */     GIR_RootConstrainSelectedInstOperands,
     /*  52830 */     // GIR_Coverage, 13550,
     /*  52830 */     GIR_EraseRootFromParent_Done,
     /*  52831 */   // Label 821: @52831
     /*  52831 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52894), // Rule ID 2036 //
     /*  52836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52876 */     // MIs[2] Operand 1
     /*  52876 */     // No operand predicates
     /*  52876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52878 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52892 */     GIR_RootConstrainSelectedInstOperands,
     /*  52893 */     // GIR_Coverage, 2036,
     /*  52893 */     GIR_EraseRootFromParent_Done,
     /*  52894 */   // Label 822: @52894
     /*  52894 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(52917), // Rule ID 1353 //
     /*  52899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52910 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52915 */     GIR_RootConstrainSelectedInstOperands,
     /*  52916 */     // GIR_Coverage, 1353,
     /*  52916 */     GIR_Done,
     /*  52917 */   // Label 823: @52917
     /*  52917 */   GIM_Reject,
     /*  52918 */ // Label 820: @52918
     /*  52918 */ GIM_Reject,
     /*  52919 */ // Label 785: @52919
     /*  52919 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(52952), // Rule ID 1348 //
     /*  52924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52945 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52950 */   GIR_RootConstrainSelectedInstOperands,
     /*  52951 */   // GIR_Coverage, 1348,
     /*  52951 */   GIR_Done,
     /*  52952 */ // Label 824: @52952
     /*  52952 */ GIM_Reject,
     /*  52953 */ // Label 786: @52953
     /*  52953 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53118),
     /*  52958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52968 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53031), // Rule ID 13547 //
     /*  52973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53009 */     // MIs[2] Operand 1
     /*  53009 */     // No operand predicates
     /*  53009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53015 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53029 */     GIR_RootConstrainSelectedInstOperands,
     /*  53030 */     // GIR_Coverage, 13547,
     /*  53030 */     GIR_EraseRootFromParent_Done,
     /*  53031 */   // Label 826: @53031
     /*  53031 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53094), // Rule ID 2033 //
     /*  53036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53076 */     // MIs[2] Operand 1
     /*  53076 */     // No operand predicates
     /*  53076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53078 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53092 */     GIR_RootConstrainSelectedInstOperands,
     /*  53093 */     // GIR_Coverage, 2033,
     /*  53093 */     GIR_EraseRootFromParent_Done,
     /*  53094 */   // Label 827: @53094
     /*  53094 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(53117), // Rule ID 1351 //
     /*  53099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53110 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  53110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  53115 */     GIR_RootConstrainSelectedInstOperands,
     /*  53116 */     // GIR_Coverage, 1351,
     /*  53116 */     GIR_Done,
     /*  53117 */   // Label 828: @53117
     /*  53117 */   GIM_Reject,
     /*  53118 */ // Label 825: @53118
     /*  53118 */ GIM_Reject,
     /*  53119 */ // Label 787: @53119
     /*  53119 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(53152), // Rule ID 1349 //
     /*  53124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53145 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  53150 */   GIR_RootConstrainSelectedInstOperands,
     /*  53151 */   // GIR_Coverage, 1349,
     /*  53151 */   GIR_Done,
     /*  53152 */ // Label 829: @53152
     /*  53152 */ GIM_Reject,
     /*  53153 */ // Label 788: @53153
     /*  53153 */ GIM_Reject,
     /*  53154 */ // Label 3: @53154
     /*  53154 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 832*/ GIMT_Encode4(53235),
     /*  53165 */ /*GILLT_s32*//*Label 830*/ GIMT_Encode4(53173),
     /*  53169 */ /*GILLT_s64*//*Label 831*/ GIMT_Encode4(53204),
     /*  53173 */ // Label 830: @53173
     /*  53173 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(53203), // Rule ID 117 //
     /*  53178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53196 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  53201 */   GIR_RootConstrainSelectedInstOperands,
     /*  53202 */   // GIR_Coverage, 117,
     /*  53202 */   GIR_Done,
     /*  53203 */ // Label 833: @53203
     /*  53203 */ GIM_Reject,
     /*  53204 */ // Label 831: @53204
     /*  53204 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(53234), // Rule ID 118 //
     /*  53209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53227 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  53232 */   GIR_RootConstrainSelectedInstOperands,
     /*  53233 */   // GIR_Coverage, 118,
     /*  53233 */   GIR_Done,
     /*  53234 */ // Label 834: @53234
     /*  53234 */ GIM_Reject,
     /*  53235 */ // Label 832: @53235
     /*  53235 */ GIM_Reject,
     /*  53236 */ // Label 4: @53236
     /*  53236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 837*/ GIMT_Encode4(53317),
     /*  53247 */ /*GILLT_s32*//*Label 835*/ GIMT_Encode4(53255),
     /*  53251 */ /*GILLT_s64*//*Label 836*/ GIMT_Encode4(53286),
     /*  53255 */ // Label 835: @53255
     /*  53255 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(53285), // Rule ID 115 //
     /*  53260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53278 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  53283 */   GIR_RootConstrainSelectedInstOperands,
     /*  53284 */   // GIR_Coverage, 115,
     /*  53284 */   GIR_Done,
     /*  53285 */ // Label 838: @53285
     /*  53285 */ GIM_Reject,
     /*  53286 */ // Label 836: @53286
     /*  53286 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(53316), // Rule ID 116 //
     /*  53291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53309 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  53314 */   GIR_RootConstrainSelectedInstOperands,
     /*  53315 */   // GIR_Coverage, 116,
     /*  53315 */   GIR_Done,
     /*  53316 */ // Label 839: @53316
     /*  53316 */ GIM_Reject,
     /*  53317 */ // Label 837: @53317
     /*  53317 */ GIM_Reject,
     /*  53318 */ // Label 5: @53318
     /*  53318 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 858*/ GIMT_Encode4(61063),
     /*  53329 */ /*GILLT_s32*//*Label 840*/ GIMT_Encode4(53417),
     /*  53333 */ /*GILLT_s64*//*Label 841*/ GIMT_Encode4(53915), GIMT_Encode4(0),
     /*  53341 */ /*GILLT_v2s32*//*Label 842*/ GIMT_Encode4(55350),
     /*  53345 */ /*GILLT_v2s64*//*Label 843*/ GIMT_Encode4(55510),
     /*  53349 */ /*GILLT_v4s16*//*Label 844*/ GIMT_Encode4(55670),
     /*  53353 */ /*GILLT_v4s32*//*Label 845*/ GIMT_Encode4(55830),
     /*  53357 */ /*GILLT_v8s8*//*Label 846*/ GIMT_Encode4(55990),
     /*  53361 */ /*GILLT_v8s16*//*Label 847*/ GIMT_Encode4(56150),
     /*  53365 */ /*GILLT_v16s8*//*Label 848*/ GIMT_Encode4(56310),
     /*  53369 */ /*GILLT_nxv1s1*//*Label 849*/ GIMT_Encode4(56470),
     /*  53373 */ /*GILLT_nxv2s1*//*Label 850*/ GIMT_Encode4(57011), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  53385 */ /*GILLT_nxv2s64*//*Label 851*/ GIMT_Encode4(57552),
     /*  53389 */ /*GILLT_nxv4s1*//*Label 852*/ GIMT_Encode4(58024), GIMT_Encode4(0),
     /*  53397 */ /*GILLT_nxv4s32*//*Label 853*/ GIMT_Encode4(58565),
     /*  53401 */ /*GILLT_nxv8s1*//*Label 854*/ GIMT_Encode4(59037),
     /*  53405 */ /*GILLT_nxv8s16*//*Label 855*/ GIMT_Encode4(59578),
     /*  53409 */ /*GILLT_nxv16s1*//*Label 856*/ GIMT_Encode4(60050),
     /*  53413 */ /*GILLT_nxv16s8*//*Label 857*/ GIMT_Encode4(60591),
     /*  53417 */ // Label 840: @53417
     /*  53417 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53914),
     /*  53422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53428 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53483), // Rule ID 13303 //
     /*  53433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53453 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53470 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53481 */     GIR_RootConstrainSelectedInstOperands,
     /*  53482 */     // GIR_Coverage, 13303,
     /*  53482 */     GIR_EraseRootFromParent_Done,
     /*  53483 */   // Label 860: @53483
     /*  53483 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53538), // Rule ID 162 //
     /*  53488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53525 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53536 */     GIR_RootConstrainSelectedInstOperands,
     /*  53537 */     // GIR_Coverage, 162,
     /*  53537 */     GIR_EraseRootFromParent_Done,
     /*  53538 */   // Label 861: @53538
     /*  53538 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53607), // Rule ID 5674 //
     /*  53543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53580 */     // MIs[2] Operand 1
     /*  53580 */     // No operand predicates
     /*  53580 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53593 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  53593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53605 */     GIR_RootConstrainSelectedInstOperands,
     /*  53606 */     // GIR_Coverage, 5674,
     /*  53606 */     GIR_EraseRootFromParent_Done,
     /*  53607 */   // Label 862: @53607
     /*  53607 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53676), // Rule ID 5675 //
     /*  53612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53645 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53649 */     // MIs[2] Operand 1
     /*  53649 */     // No operand predicates
     /*  53649 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53662 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  53662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53674 */     GIR_RootConstrainSelectedInstOperands,
     /*  53675 */     // GIR_Coverage, 5675,
     /*  53675 */     GIR_EraseRootFromParent_Done,
     /*  53676 */   // Label 863: @53676
     /*  53676 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53729), // Rule ID 13301 //
     /*  53681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53706 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53716 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53727 */     GIR_RootConstrainSelectedInstOperands,
     /*  53728 */     // GIR_Coverage, 13301,
     /*  53728 */     GIR_EraseRootFromParent_Done,
     /*  53729 */   // Label 864: @53729
     /*  53729 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53782), // Rule ID 160 //
     /*  53734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53769 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53780 */     GIR_RootConstrainSelectedInstOperands,
     /*  53781 */     // GIR_Coverage, 160,
     /*  53781 */     GIR_EraseRootFromParent_Done,
     /*  53782 */   // Label 865: @53782
     /*  53782 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53823), // Rule ID 142 //
     /*  53787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53803 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53807 */     // MIs[1] Operand 1
     /*  53807 */     // No operand predicates
     /*  53807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53809 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53816 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53821 */     GIR_RootConstrainSelectedInstOperands,
     /*  53822 */     // GIR_Coverage, 142,
     /*  53822 */     GIR_EraseRootFromParent_Done,
     /*  53823 */   // Label 866: @53823
     /*  53823 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(53856), // Rule ID 13299 //
     /*  53828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53843 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53854 */     GIR_RootConstrainSelectedInstOperands,
     /*  53855 */     // GIR_Coverage, 13299,
     /*  53855 */     GIR_EraseRootFromParent_Done,
     /*  53856 */   // Label 867: @53856
     /*  53856 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53889), // Rule ID 158 //
     /*  53861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53876 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53887 */     GIR_RootConstrainSelectedInstOperands,
     /*  53888 */     // GIR_Coverage, 158,
     /*  53888 */     GIR_EraseRootFromParent_Done,
     /*  53889 */   // Label 868: @53889
     /*  53889 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53913), // Rule ID 156 //
     /*  53894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53906 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53911 */     GIR_RootConstrainSelectedInstOperands,
     /*  53912 */     // GIR_Coverage, 156,
     /*  53912 */     GIR_Done,
     /*  53913 */   // Label 869: @53913
     /*  53913 */   GIM_Reject,
     /*  53914 */ // Label 859: @53914
     /*  53914 */ GIM_Reject,
     /*  53915 */ // Label 841: @53915
     /*  53915 */ GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(55349),
     /*  53920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53926 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(53981), // Rule ID 13304 //
     /*  53931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53968 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53979 */     GIR_RootConstrainSelectedInstOperands,
     /*  53980 */     // GIR_Coverage, 13304,
     /*  53980 */     GIR_EraseRootFromParent_Done,
     /*  53981 */   // Label 871: @53981
     /*  53981 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54036), // Rule ID 163 //
     /*  53986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54023 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  54026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54034 */     GIR_RootConstrainSelectedInstOperands,
     /*  54035 */     // GIR_Coverage, 163,
     /*  54035 */     GIR_EraseRootFromParent_Done,
     /*  54036 */   // Label 872: @54036
     /*  54036 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54149), // Rule ID 5676 //
     /*  54041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54086 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  54090 */     // MIs[3] Operand 1
     /*  54090 */     // No operand predicates
     /*  54090 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54103 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  54103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  54110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54148 */     // GIR_Coverage, 5676,
     /*  54148 */     GIR_EraseRootFromParent_Done,
     /*  54149 */   // Label 873: @54149
     /*  54149 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54262), // Rule ID 5677 //
     /*  54154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54199 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54203 */     // MIs[3] Operand 1
     /*  54203 */     // No operand predicates
     /*  54203 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54216 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  54216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  54223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54261 */     // GIR_Coverage, 5677,
     /*  54261 */     GIR_EraseRootFromParent_Done,
     /*  54262 */   // Label 874: @54262
     /*  54262 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54361), // Rule ID 7136 //
     /*  54267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54279 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54282 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54287 */     // MIs[1] addr
     /*  54287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54296 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  54300 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54313 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  54320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54329 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54360 */     // GIR_Coverage, 7136,
     /*  54360 */     GIR_EraseRootFromParent_Done,
     /*  54361 */   // Label 875: @54361
     /*  54361 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54460), // Rule ID 7137 //
     /*  54366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54378 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54381 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54386 */     // MIs[1] addr
     /*  54386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54395 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  54399 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54412 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  54419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54428 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54459 */     // GIR_Coverage, 7137,
     /*  54459 */     GIR_EraseRootFromParent_Done,
     /*  54460 */   // Label 876: @54460
     /*  54460 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54559), // Rule ID 7138 //
     /*  54465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54477 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54480 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54485 */     // MIs[1] addr
     /*  54485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54494 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  54498 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54511 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  54518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54527 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54558 */     // GIR_Coverage, 7138,
     /*  54558 */     GIR_EraseRootFromParent_Done,
     /*  54559 */   // Label 877: @54559
     /*  54559 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54658), // Rule ID 7143 //
     /*  54564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54576 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54579 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54584 */     // MIs[1] addr
     /*  54584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54593 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  54597 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54610 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  54617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54626 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54657 */     // GIR_Coverage, 7143,
     /*  54657 */     GIR_EraseRootFromParent_Done,
     /*  54658 */   // Label 878: @54658
     /*  54658 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54757), // Rule ID 7144 //
     /*  54663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54675 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54678 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54683 */     // MIs[1] addr
     /*  54683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54692 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  54696 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54709 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  54716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54725 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54756 */     // GIR_Coverage, 7144,
     /*  54756 */     GIR_EraseRootFromParent_Done,
     /*  54757 */   // Label 879: @54757
     /*  54757 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54856), // Rule ID 7145 //
     /*  54762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54774 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54777 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54782 */     // MIs[1] addr
     /*  54782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54791 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54795 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54808 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54824 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54855 */     // GIR_Coverage, 7145,
     /*  54855 */     GIR_EraseRootFromParent_Done,
     /*  54856 */   // Label 880: @54856
     /*  54856 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54909), // Rule ID 13302 //
     /*  54861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54886 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54896 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54907 */     GIR_RootConstrainSelectedInstOperands,
     /*  54908 */     // GIR_Coverage, 13302,
     /*  54908 */     GIR_EraseRootFromParent_Done,
     /*  54909 */   // Label 881: @54909
     /*  54909 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54962), // Rule ID 161 //
     /*  54914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54949 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54960 */     GIR_RootConstrainSelectedInstOperands,
     /*  54961 */     // GIR_Coverage, 161,
     /*  54961 */     GIR_EraseRootFromParent_Done,
     /*  54962 */   // Label 882: @54962
     /*  54962 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55062), // Rule ID 4001 //
     /*  54967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54975 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54986 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54998 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  55004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  55021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55026 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  55035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55061 */     // GIR_Coverage, 4001,
     /*  55061 */     GIR_EraseRootFromParent_Done,
     /*  55062 */   // Label 883: @55062
     /*  55062 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55103), // Rule ID 143 //
     /*  55067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55083 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  55087 */     // MIs[1] Operand 1
     /*  55087 */     // No operand predicates
     /*  55087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55089 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  55089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  55092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55096 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  55101 */     GIR_RootConstrainSelectedInstOperands,
     /*  55102 */     // GIR_Coverage, 143,
     /*  55102 */     GIR_EraseRootFromParent_Done,
     /*  55103 */   // Label 884: @55103
     /*  55103 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55136), // Rule ID 13300 //
     /*  55108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55123 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55134 */     GIR_RootConstrainSelectedInstOperands,
     /*  55135 */     // GIR_Coverage, 13300,
     /*  55135 */     GIR_EraseRootFromParent_Done,
     /*  55136 */   // Label 885: @55136
     /*  55136 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55169), // Rule ID 159 //
     /*  55141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55156 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55167 */     GIR_RootConstrainSelectedInstOperands,
     /*  55168 */     // GIR_Coverage, 159,
     /*  55168 */     GIR_EraseRootFromParent_Done,
     /*  55169 */   // Label 886: @55169
     /*  55169 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55233), // Rule ID 13968 //
     /*  55174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55206 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55212 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55220 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55225 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55231 */     GIR_RootConstrainSelectedInstOperands,
     /*  55232 */     // GIR_Coverage, 13968,
     /*  55232 */     GIR_EraseRootFromParent_Done,
     /*  55233 */   // Label 887: @55233
     /*  55233 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55297), // Rule ID 5056 //
     /*  55238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55274 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55284 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55289 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55295 */     GIR_RootConstrainSelectedInstOperands,
     /*  55296 */     // GIR_Coverage, 5056,
     /*  55296 */     GIR_EraseRootFromParent_Done,
     /*  55297 */   // Label 888: @55297
     /*  55297 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55321), // Rule ID 157 //
     /*  55302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55314 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  55314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  55319 */     GIR_RootConstrainSelectedInstOperands,
     /*  55320 */     // GIR_Coverage, 157,
     /*  55320 */     GIR_Done,
     /*  55321 */   // Label 889: @55321
     /*  55321 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55348), // Rule ID 2477 //
     /*  55326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55341 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55346 */     GIR_RootConstrainSelectedInstOperands,
     /*  55347 */     // GIR_Coverage, 2477,
     /*  55347 */     GIR_Done,
     /*  55348 */   // Label 890: @55348
     /*  55348 */   GIM_Reject,
     /*  55349 */ // Label 870: @55349
     /*  55349 */ GIM_Reject,
     /*  55350 */ // Label 842: @55350
     /*  55350 */ GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55509),
     /*  55355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55365 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55425), // Rule ID 13967 //
     /*  55370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55412 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55423 */     GIR_RootConstrainSelectedInstOperands,
     /*  55424 */     // GIR_Coverage, 13967,
     /*  55424 */     GIR_EraseRootFromParent_Done,
     /*  55425 */   // Label 892: @55425
     /*  55425 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(55485), // Rule ID 5055 //
     /*  55430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55462 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55472 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55477 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55483 */     GIR_RootConstrainSelectedInstOperands,
     /*  55484 */     // GIR_Coverage, 5055,
     /*  55484 */     GIR_EraseRootFromParent_Done,
     /*  55485 */   // Label 893: @55485
     /*  55485 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(55508), // Rule ID 2476 //
     /*  55490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55501 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55506 */     GIR_RootConstrainSelectedInstOperands,
     /*  55507 */     // GIR_Coverage, 2476,
     /*  55507 */     GIR_Done,
     /*  55508 */   // Label 894: @55508
     /*  55508 */   GIM_Reject,
     /*  55509 */ // Label 891: @55509
     /*  55509 */ GIM_Reject,
     /*  55510 */ // Label 843: @55510
     /*  55510 */ GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(55669),
     /*  55515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55525 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55585), // Rule ID 13971 //
     /*  55530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55572 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55577 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55583 */     GIR_RootConstrainSelectedInstOperands,
     /*  55584 */     // GIR_Coverage, 13971,
     /*  55584 */     GIR_EraseRootFromParent_Done,
     /*  55585 */   // Label 896: @55585
     /*  55585 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55645), // Rule ID 5059 //
     /*  55590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55622 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55632 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55637 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55643 */     GIR_RootConstrainSelectedInstOperands,
     /*  55644 */     // GIR_Coverage, 5059,
     /*  55644 */     GIR_EraseRootFromParent_Done,
     /*  55645 */   // Label 897: @55645
     /*  55645 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55668), // Rule ID 2480 //
     /*  55650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55661 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55666 */     GIR_RootConstrainSelectedInstOperands,
     /*  55667 */     // GIR_Coverage, 2480,
     /*  55667 */     GIR_Done,
     /*  55668 */   // Label 898: @55668
     /*  55668 */   GIM_Reject,
     /*  55669 */ // Label 895: @55669
     /*  55669 */ GIM_Reject,
     /*  55670 */ // Label 844: @55670
     /*  55670 */ GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55829),
     /*  55675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55685 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55745), // Rule ID 13966 //
     /*  55690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55718 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55732 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55737 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55743 */     GIR_RootConstrainSelectedInstOperands,
     /*  55744 */     // GIR_Coverage, 13966,
     /*  55744 */     GIR_EraseRootFromParent_Done,
     /*  55745 */   // Label 900: @55745
     /*  55745 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55805), // Rule ID 5054 //
     /*  55750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55782 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55788 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55792 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55797 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55803 */     GIR_RootConstrainSelectedInstOperands,
     /*  55804 */     // GIR_Coverage, 5054,
     /*  55804 */     GIR_EraseRootFromParent_Done,
     /*  55805 */   // Label 901: @55805
     /*  55805 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55828), // Rule ID 2475 //
     /*  55810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55821 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55826 */     GIR_RootConstrainSelectedInstOperands,
     /*  55827 */     // GIR_Coverage, 2475,
     /*  55827 */     GIR_Done,
     /*  55828 */   // Label 902: @55828
     /*  55828 */   GIM_Reject,
     /*  55829 */ // Label 899: @55829
     /*  55829 */ GIM_Reject,
     /*  55830 */ // Label 845: @55830
     /*  55830 */ GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55989),
     /*  55835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55845 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55905), // Rule ID 13970 //
     /*  55850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55892 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55897 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55903 */     GIR_RootConstrainSelectedInstOperands,
     /*  55904 */     // GIR_Coverage, 13970,
     /*  55904 */     GIR_EraseRootFromParent_Done,
     /*  55905 */   // Label 904: @55905
     /*  55905 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55965), // Rule ID 5058 //
     /*  55910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55952 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55963 */     GIR_RootConstrainSelectedInstOperands,
     /*  55964 */     // GIR_Coverage, 5058,
     /*  55964 */     GIR_EraseRootFromParent_Done,
     /*  55965 */   // Label 905: @55965
     /*  55965 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55988), // Rule ID 2479 //
     /*  55970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55981 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55986 */     GIR_RootConstrainSelectedInstOperands,
     /*  55987 */     // GIR_Coverage, 2479,
     /*  55987 */     GIR_Done,
     /*  55988 */   // Label 906: @55988
     /*  55988 */   GIM_Reject,
     /*  55989 */ // Label 903: @55989
     /*  55989 */ GIM_Reject,
     /*  55990 */ // Label 846: @55990
     /*  55990 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56149),
     /*  55995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56005 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56065), // Rule ID 13439 //
     /*  56010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56038 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56052 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56063 */     GIR_RootConstrainSelectedInstOperands,
     /*  56064 */     // GIR_Coverage, 13439,
     /*  56064 */     GIR_EraseRootFromParent_Done,
     /*  56065 */   // Label 908: @56065
     /*  56065 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56125), // Rule ID 1597 //
     /*  56070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56102 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56112 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56123 */     GIR_RootConstrainSelectedInstOperands,
     /*  56124 */     // GIR_Coverage, 1597,
     /*  56124 */     GIR_EraseRootFromParent_Done,
     /*  56125 */   // Label 909: @56125
     /*  56125 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(56148), // Rule ID 1595 //
     /*  56130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56141 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56146 */     GIR_RootConstrainSelectedInstOperands,
     /*  56147 */     // GIR_Coverage, 1595,
     /*  56147 */     GIR_Done,
     /*  56148 */   // Label 910: @56148
     /*  56148 */   GIM_Reject,
     /*  56149 */ // Label 907: @56149
     /*  56149 */ GIM_Reject,
     /*  56150 */ // Label 847: @56150
     /*  56150 */ GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(56309),
     /*  56155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56165 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(56225), // Rule ID 13969 //
     /*  56170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56212 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56217 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56223 */     GIR_RootConstrainSelectedInstOperands,
     /*  56224 */     // GIR_Coverage, 13969,
     /*  56224 */     GIR_EraseRootFromParent_Done,
     /*  56225 */   // Label 912: @56225
     /*  56225 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(56285), // Rule ID 5057 //
     /*  56230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56262 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56268 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56272 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56277 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56283 */     GIR_RootConstrainSelectedInstOperands,
     /*  56284 */     // GIR_Coverage, 5057,
     /*  56284 */     GIR_EraseRootFromParent_Done,
     /*  56285 */   // Label 913: @56285
     /*  56285 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(56308), // Rule ID 2478 //
     /*  56290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56301 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56306 */     GIR_RootConstrainSelectedInstOperands,
     /*  56307 */     // GIR_Coverage, 2478,
     /*  56307 */     GIR_Done,
     /*  56308 */   // Label 914: @56308
     /*  56308 */   GIM_Reject,
     /*  56309 */ // Label 911: @56309
     /*  56309 */ GIM_Reject,
     /*  56310 */ // Label 848: @56310
     /*  56310 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(56469),
     /*  56315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56325 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(56385), // Rule ID 13440 //
     /*  56330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56358 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56372 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56383 */     GIR_RootConstrainSelectedInstOperands,
     /*  56384 */     // GIR_Coverage, 13440,
     /*  56384 */     GIR_EraseRootFromParent_Done,
     /*  56385 */   // Label 916: @56385
     /*  56385 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(56445), // Rule ID 1598 //
     /*  56390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56432 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56443 */     GIR_RootConstrainSelectedInstOperands,
     /*  56444 */     // GIR_Coverage, 1598,
     /*  56444 */     GIR_EraseRootFromParent_Done,
     /*  56445 */   // Label 917: @56445
     /*  56445 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(56468), // Rule ID 1596 //
     /*  56450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56461 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56466 */     GIR_RootConstrainSelectedInstOperands,
     /*  56467 */     // GIR_Coverage, 1596,
     /*  56467 */     GIR_Done,
     /*  56468 */   // Label 918: @56468
     /*  56468 */   GIM_Reject,
     /*  56469 */ // Label 915: @56469
     /*  56469 */ GIM_Reject,
     /*  56470 */ // Label 849: @56470
     /*  56470 */ GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57010),
     /*  56475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56485 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(56542), // Rule ID 15163 //
     /*  56490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56527 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56540 */     GIR_RootConstrainSelectedInstOperands,
     /*  56541 */     // GIR_Coverage, 15163,
     /*  56541 */     GIR_EraseRootFromParent_Done,
     /*  56542 */   // Label 920: @56542
     /*  56542 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56599), // Rule ID 15166 //
     /*  56547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56578 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56584 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56597 */     GIR_RootConstrainSelectedInstOperands,
     /*  56598 */     // GIR_Coverage, 15166,
     /*  56598 */     GIR_EraseRootFromParent_Done,
     /*  56599 */   // Label 921: @56599
     /*  56599 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56656), // Rule ID 15162 //
     /*  56604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56635 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56641 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56654 */     GIR_RootConstrainSelectedInstOperands,
     /*  56655 */     // GIR_Coverage, 15162,
     /*  56655 */     GIR_EraseRootFromParent_Done,
     /*  56656 */   // Label 922: @56656
     /*  56656 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56713), // Rule ID 15165 //
     /*  56661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56692 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56698 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56711 */     GIR_RootConstrainSelectedInstOperands,
     /*  56712 */     // GIR_Coverage, 15165,
     /*  56712 */     GIR_EraseRootFromParent_Done,
     /*  56713 */   // Label 923: @56713
     /*  56713 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56770), // Rule ID 15161 //
     /*  56718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56749 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56755 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56768 */     GIR_RootConstrainSelectedInstOperands,
     /*  56769 */     // GIR_Coverage, 15161,
     /*  56769 */     GIR_EraseRootFromParent_Done,
     /*  56770 */   // Label 924: @56770
     /*  56770 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56827), // Rule ID 15164 //
     /*  56775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56806 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56812 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56825 */     GIR_RootConstrainSelectedInstOperands,
     /*  56826 */     // GIR_Coverage, 15164,
     /*  56826 */     GIR_EraseRootFromParent_Done,
     /*  56827 */   // Label 925: @56827
     /*  56827 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56884), // Rule ID 8479 //
     /*  56832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56863 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56869 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56882 */     GIR_RootConstrainSelectedInstOperands,
     /*  56883 */     // GIR_Coverage, 8479,
     /*  56883 */     GIR_EraseRootFromParent_Done,
     /*  56884 */   // Label 926: @56884
     /*  56884 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56941), // Rule ID 8480 //
     /*  56889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56920 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56926 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56939 */     GIR_RootConstrainSelectedInstOperands,
     /*  56940 */     // GIR_Coverage, 8480,
     /*  56940 */     GIR_EraseRootFromParent_Done,
     /*  56941 */   // Label 927: @56941
     /*  56941 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56988), // Rule ID 10743 //
     /*  56946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56957 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56986 */     GIR_RootConstrainSelectedInstOperands,
     /*  56987 */     // GIR_Coverage, 10743,
     /*  56987 */     GIR_EraseRootFromParent_Done,
     /*  56988 */   // Label 928: @56988
     /*  56988 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57009), // Rule ID 2746 //
     /*  56993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56996 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57007 */     GIR_RootConstrainSelectedInstOperands,
     /*  57008 */     // GIR_Coverage, 2746,
     /*  57008 */     GIR_EraseRootFromParent_Done,
     /*  57009 */   // Label 929: @57009
     /*  57009 */   GIM_Reject,
     /*  57010 */ // Label 919: @57010
     /*  57010 */ GIM_Reject,
     /*  57011 */ // Label 850: @57011
     /*  57011 */ GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57551),
     /*  57016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57026 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57083), // Rule ID 15154 //
     /*  57031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57068 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57081 */     GIR_RootConstrainSelectedInstOperands,
     /*  57082 */     // GIR_Coverage, 15154,
     /*  57082 */     GIR_EraseRootFromParent_Done,
     /*  57083 */   // Label 931: @57083
     /*  57083 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57140), // Rule ID 15157 //
     /*  57088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57119 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57125 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57138 */     GIR_RootConstrainSelectedInstOperands,
     /*  57139 */     // GIR_Coverage, 15157,
     /*  57139 */     GIR_EraseRootFromParent_Done,
     /*  57140 */   // Label 932: @57140
     /*  57140 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57197), // Rule ID 15153 //
     /*  57145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57176 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57182 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57195 */     GIR_RootConstrainSelectedInstOperands,
     /*  57196 */     // GIR_Coverage, 15153,
     /*  57196 */     GIR_EraseRootFromParent_Done,
     /*  57197 */   // Label 933: @57197
     /*  57197 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(57254), // Rule ID 15156 //
     /*  57202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57233 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57239 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57252 */     GIR_RootConstrainSelectedInstOperands,
     /*  57253 */     // GIR_Coverage, 15156,
     /*  57253 */     GIR_EraseRootFromParent_Done,
     /*  57254 */   // Label 934: @57254
     /*  57254 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(57311), // Rule ID 15152 //
     /*  57259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57290 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57296 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57309 */     GIR_RootConstrainSelectedInstOperands,
     /*  57310 */     // GIR_Coverage, 15152,
     /*  57310 */     GIR_EraseRootFromParent_Done,
     /*  57311 */   // Label 935: @57311
     /*  57311 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(57368), // Rule ID 15155 //
     /*  57316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57347 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57353 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57366 */     GIR_RootConstrainSelectedInstOperands,
     /*  57367 */     // GIR_Coverage, 15155,
     /*  57367 */     GIR_EraseRootFromParent_Done,
     /*  57368 */   // Label 936: @57368
     /*  57368 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(57425), // Rule ID 8475 //
     /*  57373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57404 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57410 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57423 */     GIR_RootConstrainSelectedInstOperands,
     /*  57424 */     // GIR_Coverage, 8475,
     /*  57424 */     GIR_EraseRootFromParent_Done,
     /*  57425 */   // Label 937: @57425
     /*  57425 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57482), // Rule ID 8476 //
     /*  57430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57461 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57467 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57480 */     GIR_RootConstrainSelectedInstOperands,
     /*  57481 */     // GIR_Coverage, 8476,
     /*  57481 */     GIR_EraseRootFromParent_Done,
     /*  57482 */   // Label 938: @57482
     /*  57482 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(57529), // Rule ID 10742 //
     /*  57487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57498 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  57498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  57505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57527 */     GIR_RootConstrainSelectedInstOperands,
     /*  57528 */     // GIR_Coverage, 10742,
     /*  57528 */     GIR_EraseRootFromParent_Done,
     /*  57529 */   // Label 939: @57529
     /*  57529 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57550), // Rule ID 2745 //
     /*  57534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57537 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57548 */     GIR_RootConstrainSelectedInstOperands,
     /*  57549 */     // GIR_Coverage, 2745,
     /*  57549 */     GIR_EraseRootFromParent_Done,
     /*  57550 */   // Label 940: @57550
     /*  57550 */   GIM_Reject,
     /*  57551 */ // Label 930: @57551
     /*  57551 */ GIM_Reject,
     /*  57552 */ // Label 851: @57552
     /*  57552 */ GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(58023),
     /*  57557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57567 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57622), // Rule ID 15094 //
     /*  57572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57603 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57609 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57620 */     GIR_RootConstrainSelectedInstOperands,
     /*  57621 */     // GIR_Coverage, 15094,
     /*  57621 */     GIR_EraseRootFromParent_Done,
     /*  57622 */   // Label 942: @57622
     /*  57622 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57677), // Rule ID 15097 //
     /*  57627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57658 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57664 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57675 */     GIR_RootConstrainSelectedInstOperands,
     /*  57676 */     // GIR_Coverage, 15097,
     /*  57676 */     GIR_EraseRootFromParent_Done,
     /*  57677 */   // Label 943: @57677
     /*  57677 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57732), // Rule ID 15093 //
     /*  57682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57719 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57730 */     GIR_RootConstrainSelectedInstOperands,
     /*  57731 */     // GIR_Coverage, 15093,
     /*  57731 */     GIR_EraseRootFromParent_Done,
     /*  57732 */   // Label 944: @57732
     /*  57732 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57787), // Rule ID 15096 //
     /*  57737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57774 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57785 */     GIR_RootConstrainSelectedInstOperands,
     /*  57786 */     // GIR_Coverage, 15096,
     /*  57786 */     GIR_EraseRootFromParent_Done,
     /*  57787 */   // Label 945: @57787
     /*  57787 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57842), // Rule ID 15092 //
     /*  57792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57823 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57829 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57840 */     GIR_RootConstrainSelectedInstOperands,
     /*  57841 */     // GIR_Coverage, 15092,
     /*  57841 */     GIR_EraseRootFromParent_Done,
     /*  57842 */   // Label 946: @57842
     /*  57842 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57897), // Rule ID 15095 //
     /*  57847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57878 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57884 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57895 */     GIR_RootConstrainSelectedInstOperands,
     /*  57896 */     // GIR_Coverage, 15095,
     /*  57896 */     GIR_EraseRootFromParent_Done,
     /*  57897 */   // Label 947: @57897
     /*  57897 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57952), // Rule ID 7524 //
     /*  57902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57933 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57939 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57950 */     GIR_RootConstrainSelectedInstOperands,
     /*  57951 */     // GIR_Coverage, 7524,
     /*  57951 */     GIR_EraseRootFromParent_Done,
     /*  57952 */   // Label 948: @57952
     /*  57952 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58007), // Rule ID 7525 //
     /*  57957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57988 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57994 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58005 */     GIR_RootConstrainSelectedInstOperands,
     /*  58006 */     // GIR_Coverage, 7525,
     /*  58006 */     GIR_EraseRootFromParent_Done,
     /*  58007 */   // Label 949: @58007
     /*  58007 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58022), // Rule ID 3139 //
     /*  58012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58015 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  58015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58020 */     GIR_RootConstrainSelectedInstOperands,
     /*  58021 */     // GIR_Coverage, 3139,
     /*  58021 */     GIR_Done,
     /*  58022 */   // Label 950: @58022
     /*  58022 */   GIM_Reject,
     /*  58023 */ // Label 941: @58023
     /*  58023 */ GIM_Reject,
     /*  58024 */ // Label 852: @58024
     /*  58024 */ GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58564),
     /*  58029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58039 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58096), // Rule ID 15145 //
     /*  58044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58075 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58081 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58094 */     GIR_RootConstrainSelectedInstOperands,
     /*  58095 */     // GIR_Coverage, 15145,
     /*  58095 */     GIR_EraseRootFromParent_Done,
     /*  58096 */   // Label 952: @58096
     /*  58096 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58153), // Rule ID 15148 //
     /*  58101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58132 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58138 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58151 */     GIR_RootConstrainSelectedInstOperands,
     /*  58152 */     // GIR_Coverage, 15148,
     /*  58152 */     GIR_EraseRootFromParent_Done,
     /*  58153 */   // Label 953: @58153
     /*  58153 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58210), // Rule ID 15144 //
     /*  58158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58195 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58208 */     GIR_RootConstrainSelectedInstOperands,
     /*  58209 */     // GIR_Coverage, 15144,
     /*  58209 */     GIR_EraseRootFromParent_Done,
     /*  58210 */   // Label 954: @58210
     /*  58210 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(58267), // Rule ID 15147 //
     /*  58215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58252 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58265 */     GIR_RootConstrainSelectedInstOperands,
     /*  58266 */     // GIR_Coverage, 15147,
     /*  58266 */     GIR_EraseRootFromParent_Done,
     /*  58267 */   // Label 955: @58267
     /*  58267 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(58324), // Rule ID 15143 //
     /*  58272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58309 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58322 */     GIR_RootConstrainSelectedInstOperands,
     /*  58323 */     // GIR_Coverage, 15143,
     /*  58323 */     GIR_EraseRootFromParent_Done,
     /*  58324 */   // Label 956: @58324
     /*  58324 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(58381), // Rule ID 15146 //
     /*  58329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58360 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58366 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58379 */     GIR_RootConstrainSelectedInstOperands,
     /*  58380 */     // GIR_Coverage, 15146,
     /*  58380 */     GIR_EraseRootFromParent_Done,
     /*  58381 */   // Label 957: @58381
     /*  58381 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(58438), // Rule ID 8471 //
     /*  58386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58417 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58423 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58436 */     GIR_RootConstrainSelectedInstOperands,
     /*  58437 */     // GIR_Coverage, 8471,
     /*  58437 */     GIR_EraseRootFromParent_Done,
     /*  58438 */   // Label 958: @58438
     /*  58438 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58495), // Rule ID 8472 //
     /*  58443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58474 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58480 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58493 */     GIR_RootConstrainSelectedInstOperands,
     /*  58494 */     // GIR_Coverage, 8472,
     /*  58494 */     GIR_EraseRootFromParent_Done,
     /*  58495 */   // Label 959: @58495
     /*  58495 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(58542), // Rule ID 10741 //
     /*  58500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58511 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  58511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  58518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58540 */     GIR_RootConstrainSelectedInstOperands,
     /*  58541 */     // GIR_Coverage, 10741,
     /*  58541 */     GIR_EraseRootFromParent_Done,
     /*  58542 */   // Label 960: @58542
     /*  58542 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58563), // Rule ID 2744 //
     /*  58547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58550 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58561 */     GIR_RootConstrainSelectedInstOperands,
     /*  58562 */     // GIR_Coverage, 2744,
     /*  58562 */     GIR_EraseRootFromParent_Done,
     /*  58563 */   // Label 961: @58563
     /*  58563 */   GIM_Reject,
     /*  58564 */ // Label 951: @58564
     /*  58564 */ GIM_Reject,
     /*  58565 */ // Label 853: @58565
     /*  58565 */ GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(59036),
     /*  58570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58580 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58635), // Rule ID 15085 //
     /*  58585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58616 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58622 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58633 */     GIR_RootConstrainSelectedInstOperands,
     /*  58634 */     // GIR_Coverage, 15085,
     /*  58634 */     GIR_EraseRootFromParent_Done,
     /*  58635 */   // Label 963: @58635
     /*  58635 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58690), // Rule ID 15088 //
     /*  58640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58671 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58677 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58688 */     GIR_RootConstrainSelectedInstOperands,
     /*  58689 */     // GIR_Coverage, 15088,
     /*  58689 */     GIR_EraseRootFromParent_Done,
     /*  58690 */   // Label 964: @58690
     /*  58690 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58745), // Rule ID 15084 //
     /*  58695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58726 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58732 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58743 */     GIR_RootConstrainSelectedInstOperands,
     /*  58744 */     // GIR_Coverage, 15084,
     /*  58744 */     GIR_EraseRootFromParent_Done,
     /*  58745 */   // Label 965: @58745
     /*  58745 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58800), // Rule ID 15087 //
     /*  58750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58781 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58787 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58798 */     GIR_RootConstrainSelectedInstOperands,
     /*  58799 */     // GIR_Coverage, 15087,
     /*  58799 */     GIR_EraseRootFromParent_Done,
     /*  58800 */   // Label 966: @58800
     /*  58800 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58855), // Rule ID 15083 //
     /*  58805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58836 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58842 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58853 */     GIR_RootConstrainSelectedInstOperands,
     /*  58854 */     // GIR_Coverage, 15083,
     /*  58854 */     GIR_EraseRootFromParent_Done,
     /*  58855 */   // Label 967: @58855
     /*  58855 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58910), // Rule ID 15086 //
     /*  58860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58891 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58897 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58908 */     GIR_RootConstrainSelectedInstOperands,
     /*  58909 */     // GIR_Coverage, 15086,
     /*  58909 */     GIR_EraseRootFromParent_Done,
     /*  58910 */   // Label 968: @58910
     /*  58910 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58965), // Rule ID 7520 //
     /*  58915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58952 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58963 */     GIR_RootConstrainSelectedInstOperands,
     /*  58964 */     // GIR_Coverage, 7520,
     /*  58964 */     GIR_EraseRootFromParent_Done,
     /*  58965 */   // Label 969: @58965
     /*  58965 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59020), // Rule ID 7521 //
     /*  58970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59007 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59018 */     GIR_RootConstrainSelectedInstOperands,
     /*  59019 */     // GIR_Coverage, 7521,
     /*  59019 */     GIR_EraseRootFromParent_Done,
     /*  59020 */   // Label 970: @59020
     /*  59020 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59035), // Rule ID 3138 //
     /*  59025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59028 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59033 */     GIR_RootConstrainSelectedInstOperands,
     /*  59034 */     // GIR_Coverage, 3138,
     /*  59034 */     GIR_Done,
     /*  59035 */   // Label 971: @59035
     /*  59035 */   GIM_Reject,
     /*  59036 */ // Label 962: @59036
     /*  59036 */ GIM_Reject,
     /*  59037 */ // Label 854: @59037
     /*  59037 */ GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59577),
     /*  59042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59052 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59109), // Rule ID 15136 //
     /*  59057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59088 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59094 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59107 */     GIR_RootConstrainSelectedInstOperands,
     /*  59108 */     // GIR_Coverage, 15136,
     /*  59108 */     GIR_EraseRootFromParent_Done,
     /*  59109 */   // Label 973: @59109
     /*  59109 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59166), // Rule ID 15139 //
     /*  59114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59145 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59151 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59164 */     GIR_RootConstrainSelectedInstOperands,
     /*  59165 */     // GIR_Coverage, 15139,
     /*  59165 */     GIR_EraseRootFromParent_Done,
     /*  59166 */   // Label 974: @59166
     /*  59166 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59223), // Rule ID 15135 //
     /*  59171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59202 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59208 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59221 */     GIR_RootConstrainSelectedInstOperands,
     /*  59222 */     // GIR_Coverage, 15135,
     /*  59222 */     GIR_EraseRootFromParent_Done,
     /*  59223 */   // Label 975: @59223
     /*  59223 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(59280), // Rule ID 15138 //
     /*  59228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59259 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59265 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59278 */     GIR_RootConstrainSelectedInstOperands,
     /*  59279 */     // GIR_Coverage, 15138,
     /*  59279 */     GIR_EraseRootFromParent_Done,
     /*  59280 */   // Label 976: @59280
     /*  59280 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(59337), // Rule ID 15134 //
     /*  59285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59322 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59335 */     GIR_RootConstrainSelectedInstOperands,
     /*  59336 */     // GIR_Coverage, 15134,
     /*  59336 */     GIR_EraseRootFromParent_Done,
     /*  59337 */   // Label 977: @59337
     /*  59337 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(59394), // Rule ID 15137 //
     /*  59342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59373 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59379 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59392 */     GIR_RootConstrainSelectedInstOperands,
     /*  59393 */     // GIR_Coverage, 15137,
     /*  59393 */     GIR_EraseRootFromParent_Done,
     /*  59394 */   // Label 978: @59394
     /*  59394 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(59451), // Rule ID 8467 //
     /*  59399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59430 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59436 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59449 */     GIR_RootConstrainSelectedInstOperands,
     /*  59450 */     // GIR_Coverage, 8467,
     /*  59450 */     GIR_EraseRootFromParent_Done,
     /*  59451 */   // Label 979: @59451
     /*  59451 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(59508), // Rule ID 8468 //
     /*  59456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59487 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59493 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59506 */     GIR_RootConstrainSelectedInstOperands,
     /*  59507 */     // GIR_Coverage, 8468,
     /*  59507 */     GIR_EraseRootFromParent_Done,
     /*  59508 */   // Label 980: @59508
     /*  59508 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(59555), // Rule ID 10740 //
     /*  59513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59524 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  59524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  59531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59553 */     GIR_RootConstrainSelectedInstOperands,
     /*  59554 */     // GIR_Coverage, 10740,
     /*  59554 */     GIR_EraseRootFromParent_Done,
     /*  59555 */   // Label 981: @59555
     /*  59555 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(59576), // Rule ID 2743 //
     /*  59560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59563 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59574 */     GIR_RootConstrainSelectedInstOperands,
     /*  59575 */     // GIR_Coverage, 2743,
     /*  59575 */     GIR_EraseRootFromParent_Done,
     /*  59576 */   // Label 982: @59576
     /*  59576 */   GIM_Reject,
     /*  59577 */ // Label 972: @59577
     /*  59577 */ GIM_Reject,
     /*  59578 */ // Label 855: @59578
     /*  59578 */ GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(60049),
     /*  59583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59593 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59648), // Rule ID 15076 //
     /*  59598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59629 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59635 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59646 */     GIR_RootConstrainSelectedInstOperands,
     /*  59647 */     // GIR_Coverage, 15076,
     /*  59647 */     GIR_EraseRootFromParent_Done,
     /*  59648 */   // Label 984: @59648
     /*  59648 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59703), // Rule ID 15079 //
     /*  59653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59690 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59701 */     GIR_RootConstrainSelectedInstOperands,
     /*  59702 */     // GIR_Coverage, 15079,
     /*  59702 */     GIR_EraseRootFromParent_Done,
     /*  59703 */   // Label 985: @59703
     /*  59703 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59758), // Rule ID 15075 //
     /*  59708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59745 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59756 */     GIR_RootConstrainSelectedInstOperands,
     /*  59757 */     // GIR_Coverage, 15075,
     /*  59757 */     GIR_EraseRootFromParent_Done,
     /*  59758 */   // Label 986: @59758
     /*  59758 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59813), // Rule ID 15078 //
     /*  59763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59794 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59800 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59811 */     GIR_RootConstrainSelectedInstOperands,
     /*  59812 */     // GIR_Coverage, 15078,
     /*  59812 */     GIR_EraseRootFromParent_Done,
     /*  59813 */   // Label 987: @59813
     /*  59813 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59868), // Rule ID 15074 //
     /*  59818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59855 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59866 */     GIR_RootConstrainSelectedInstOperands,
     /*  59867 */     // GIR_Coverage, 15074,
     /*  59867 */     GIR_EraseRootFromParent_Done,
     /*  59868 */   // Label 988: @59868
     /*  59868 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59923), // Rule ID 15077 //
     /*  59873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59904 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59910 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59921 */     GIR_RootConstrainSelectedInstOperands,
     /*  59922 */     // GIR_Coverage, 15077,
     /*  59922 */     GIR_EraseRootFromParent_Done,
     /*  59923 */   // Label 989: @59923
     /*  59923 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59978), // Rule ID 7516 //
     /*  59928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59959 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59965 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59976 */     GIR_RootConstrainSelectedInstOperands,
     /*  59977 */     // GIR_Coverage, 7516,
     /*  59977 */     GIR_EraseRootFromParent_Done,
     /*  59978 */   // Label 990: @59978
     /*  59978 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60033), // Rule ID 7517 //
     /*  59983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  60002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60014 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60020 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60031 */     GIR_RootConstrainSelectedInstOperands,
     /*  60032 */     // GIR_Coverage, 7517,
     /*  60032 */     GIR_EraseRootFromParent_Done,
     /*  60033 */   // Label 991: @60033
     /*  60033 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60048), // Rule ID 3137 //
     /*  60038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60041 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60046 */     GIR_RootConstrainSelectedInstOperands,
     /*  60047 */     // GIR_Coverage, 3137,
     /*  60047 */     GIR_Done,
     /*  60048 */   // Label 992: @60048
     /*  60048 */   GIM_Reject,
     /*  60049 */ // Label 983: @60049
     /*  60049 */ GIM_Reject,
     /*  60050 */ // Label 856: @60050
     /*  60050 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60590),
     /*  60055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60065 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60122), // Rule ID 15127 //
     /*  60070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60107 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60120 */     GIR_RootConstrainSelectedInstOperands,
     /*  60121 */     // GIR_Coverage, 15127,
     /*  60121 */     GIR_EraseRootFromParent_Done,
     /*  60122 */   // Label 994: @60122
     /*  60122 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60179), // Rule ID 15130 //
     /*  60127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60158 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60164 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60177 */     GIR_RootConstrainSelectedInstOperands,
     /*  60178 */     // GIR_Coverage, 15130,
     /*  60178 */     GIR_EraseRootFromParent_Done,
     /*  60179 */   // Label 995: @60179
     /*  60179 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(60236), // Rule ID 15126 //
     /*  60184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60215 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60221 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60234 */     GIR_RootConstrainSelectedInstOperands,
     /*  60235 */     // GIR_Coverage, 15126,
     /*  60235 */     GIR_EraseRootFromParent_Done,
     /*  60236 */   // Label 996: @60236
     /*  60236 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(60293), // Rule ID 15129 //
     /*  60241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60272 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60278 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60291 */     GIR_RootConstrainSelectedInstOperands,
     /*  60292 */     // GIR_Coverage, 15129,
     /*  60292 */     GIR_EraseRootFromParent_Done,
     /*  60293 */   // Label 997: @60293
     /*  60293 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(60350), // Rule ID 15125 //
     /*  60298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60335 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60348 */     GIR_RootConstrainSelectedInstOperands,
     /*  60349 */     // GIR_Coverage, 15125,
     /*  60349 */     GIR_EraseRootFromParent_Done,
     /*  60350 */   // Label 998: @60350
     /*  60350 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(60407), // Rule ID 15128 //
     /*  60355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60386 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60392 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60405 */     GIR_RootConstrainSelectedInstOperands,
     /*  60406 */     // GIR_Coverage, 15128,
     /*  60406 */     GIR_EraseRootFromParent_Done,
     /*  60407 */   // Label 999: @60407
     /*  60407 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(60464), // Rule ID 8463 //
     /*  60412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60443 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60449 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60462 */     GIR_RootConstrainSelectedInstOperands,
     /*  60463 */     // GIR_Coverage, 8463,
     /*  60463 */     GIR_EraseRootFromParent_Done,
     /*  60464 */   // Label 1000: @60464
     /*  60464 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(60521), // Rule ID 8464 //
     /*  60469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60500 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60506 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60519 */     GIR_RootConstrainSelectedInstOperands,
     /*  60520 */     // GIR_Coverage, 8464,
     /*  60520 */     GIR_EraseRootFromParent_Done,
     /*  60521 */   // Label 1001: @60521
     /*  60521 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(60568), // Rule ID 10739 //
     /*  60526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60537 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  60537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  60540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  60544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60566 */     GIR_RootConstrainSelectedInstOperands,
     /*  60567 */     // GIR_Coverage, 10739,
     /*  60567 */     GIR_EraseRootFromParent_Done,
     /*  60568 */   // Label 1002: @60568
     /*  60568 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(60589), // Rule ID 2742 //
     /*  60573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60576 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60587 */     GIR_RootConstrainSelectedInstOperands,
     /*  60588 */     // GIR_Coverage, 2742,
     /*  60588 */     GIR_EraseRootFromParent_Done,
     /*  60589 */   // Label 1003: @60589
     /*  60589 */   GIM_Reject,
     /*  60590 */ // Label 993: @60590
     /*  60590 */ GIM_Reject,
     /*  60591 */ // Label 857: @60591
     /*  60591 */ GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61062),
     /*  60596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60606 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60661), // Rule ID 15067 //
     /*  60611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60642 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60648 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60659 */     GIR_RootConstrainSelectedInstOperands,
     /*  60660 */     // GIR_Coverage, 15067,
     /*  60660 */     GIR_EraseRootFromParent_Done,
     /*  60661 */   // Label 1005: @60661
     /*  60661 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60716), // Rule ID 15070 //
     /*  60666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60697 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60703 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60714 */     GIR_RootConstrainSelectedInstOperands,
     /*  60715 */     // GIR_Coverage, 15070,
     /*  60715 */     GIR_EraseRootFromParent_Done,
     /*  60716 */   // Label 1006: @60716
     /*  60716 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60771), // Rule ID 15066 //
     /*  60721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60758 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60769 */     GIR_RootConstrainSelectedInstOperands,
     /*  60770 */     // GIR_Coverage, 15066,
     /*  60770 */     GIR_EraseRootFromParent_Done,
     /*  60771 */   // Label 1007: @60771
     /*  60771 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60826), // Rule ID 15069 //
     /*  60776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60813 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60824 */     GIR_RootConstrainSelectedInstOperands,
     /*  60825 */     // GIR_Coverage, 15069,
     /*  60825 */     GIR_EraseRootFromParent_Done,
     /*  60826 */   // Label 1008: @60826
     /*  60826 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60881), // Rule ID 15065 //
     /*  60831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60868 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60879 */     GIR_RootConstrainSelectedInstOperands,
     /*  60880 */     // GIR_Coverage, 15065,
     /*  60880 */     GIR_EraseRootFromParent_Done,
     /*  60881 */   // Label 1009: @60881
     /*  60881 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(60936), // Rule ID 15068 //
     /*  60886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60917 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60923 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60934 */     GIR_RootConstrainSelectedInstOperands,
     /*  60935 */     // GIR_Coverage, 15068,
     /*  60935 */     GIR_EraseRootFromParent_Done,
     /*  60936 */   // Label 1010: @60936
     /*  60936 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(60991), // Rule ID 7512 //
     /*  60941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60972 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60978 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60989 */     GIR_RootConstrainSelectedInstOperands,
     /*  60990 */     // GIR_Coverage, 7512,
     /*  60990 */     GIR_EraseRootFromParent_Done,
     /*  60991 */   // Label 1011: @60991
     /*  60991 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(61046), // Rule ID 7513 //
     /*  60996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  61011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  61015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61027 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61033 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61044 */     GIR_RootConstrainSelectedInstOperands,
     /*  61045 */     // GIR_Coverage, 7513,
     /*  61045 */     GIR_EraseRootFromParent_Done,
     /*  61046 */   // Label 1012: @61046
     /*  61046 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61061), // Rule ID 3136 //
     /*  61051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61054 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61059 */     GIR_RootConstrainSelectedInstOperands,
     /*  61060 */     // GIR_Coverage, 3136,
     /*  61060 */     GIR_Done,
     /*  61061 */   // Label 1013: @61061
     /*  61061 */   GIM_Reject,
     /*  61062 */ // Label 1004: @61062
     /*  61062 */ GIM_Reject,
     /*  61063 */ // Label 858: @61063
     /*  61063 */ GIM_Reject,
     /*  61064 */ // Label 6: @61064
     /*  61064 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1032*/ GIMT_Encode4(86178),
     /*  61075 */ /*GILLT_s32*//*Label 1014*/ GIMT_Encode4(61163),
     /*  61079 */ /*GILLT_s64*//*Label 1015*/ GIMT_Encode4(61523), GIMT_Encode4(0),
     /*  61087 */ /*GILLT_v2s32*//*Label 1016*/ GIMT_Encode4(63422),
     /*  61091 */ /*GILLT_v2s64*//*Label 1017*/ GIMT_Encode4(64730),
     /*  61095 */ /*GILLT_v4s16*//*Label 1018*/ GIMT_Encode4(66038),
     /*  61099 */ /*GILLT_v4s32*//*Label 1019*/ GIMT_Encode4(67346),
     /*  61103 */ /*GILLT_v8s8*//*Label 1020*/ GIMT_Encode4(68654),
     /*  61107 */ /*GILLT_v8s16*//*Label 1021*/ GIMT_Encode4(69962),
     /*  61111 */ /*GILLT_v16s8*//*Label 1022*/ GIMT_Encode4(71270),
     /*  61115 */ /*GILLT_nxv1s1*//*Label 1023*/ GIMT_Encode4(72578),
     /*  61119 */ /*GILLT_nxv2s1*//*Label 1024*/ GIMT_Encode4(72610), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  61131 */ /*GILLT_nxv2s64*//*Label 1025*/ GIMT_Encode4(72642),
     /*  61135 */ /*GILLT_nxv4s1*//*Label 1026*/ GIMT_Encode4(76002), GIMT_Encode4(0),
     /*  61143 */ /*GILLT_nxv4s32*//*Label 1027*/ GIMT_Encode4(76034),
     /*  61147 */ /*GILLT_nxv8s1*//*Label 1028*/ GIMT_Encode4(79394),
     /*  61151 */ /*GILLT_nxv8s16*//*Label 1029*/ GIMT_Encode4(79426),
     /*  61155 */ /*GILLT_nxv16s1*//*Label 1030*/ GIMT_Encode4(82786),
     /*  61159 */ /*GILLT_nxv16s8*//*Label 1031*/ GIMT_Encode4(82818),
     /*  61163 */ // Label 1014: @61163
     /*  61163 */ GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(61522),
     /*  61168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61174 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(61229), // Rule ID 13323 //
     /*  61179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61216 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61227 */     GIR_RootConstrainSelectedInstOperands,
     /*  61228 */     // GIR_Coverage, 13323,
     /*  61228 */     GIR_EraseRootFromParent_Done,
     /*  61229 */   // Label 1034: @61229
     /*  61229 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(61284), // Rule ID 174 //
     /*  61234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61271 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61282 */     GIR_RootConstrainSelectedInstOperands,
     /*  61283 */     // GIR_Coverage, 174,
     /*  61283 */     GIR_EraseRootFromParent_Done,
     /*  61284 */   // Label 1035: @61284
     /*  61284 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(61325), // Rule ID 146 //
     /*  61289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  61293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61305 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  61309 */     // MIs[1] Operand 1
     /*  61309 */     // No operand predicates
     /*  61309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61311 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  61311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  61314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61318 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  61323 */     GIR_RootConstrainSelectedInstOperands,
     /*  61324 */     // GIR_Coverage, 146,
     /*  61324 */     GIR_EraseRootFromParent_Done,
     /*  61325 */   // Label 1036: @61325
     /*  61325 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(61358), // Rule ID 13325 //
     /*  61330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61345 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61356 */     GIR_RootConstrainSelectedInstOperands,
     /*  61357 */     // GIR_Coverage, 13325,
     /*  61357 */     GIR_EraseRootFromParent_Done,
     /*  61358 */   // Label 1037: @61358
     /*  61358 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(61391), // Rule ID 178 //
     /*  61363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61378 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61389 */     GIR_RootConstrainSelectedInstOperands,
     /*  61390 */     // GIR_Coverage, 178,
     /*  61390 */     GIR_EraseRootFromParent_Done,
     /*  61391 */   // Label 1038: @61391
     /*  61391 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(61444), // Rule ID 13321 //
     /*  61396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61421 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61431 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61442 */     GIR_RootConstrainSelectedInstOperands,
     /*  61443 */     // GIR_Coverage, 13321,
     /*  61443 */     GIR_EraseRootFromParent_Done,
     /*  61444 */   // Label 1039: @61444
     /*  61444 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(61497), // Rule ID 172 //
     /*  61449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61478 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61484 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61495 */     GIR_RootConstrainSelectedInstOperands,
     /*  61496 */     // GIR_Coverage, 172,
     /*  61496 */     GIR_EraseRootFromParent_Done,
     /*  61497 */   // Label 1040: @61497
     /*  61497 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61521), // Rule ID 176 //
     /*  61502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61514 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  61519 */     GIR_RootConstrainSelectedInstOperands,
     /*  61520 */     // GIR_Coverage, 176,
     /*  61520 */     GIR_Done,
     /*  61521 */   // Label 1041: @61521
     /*  61521 */   GIM_Reject,
     /*  61522 */ // Label 1033: @61522
     /*  61522 */ GIM_Reject,
     /*  61523 */ // Label 1015: @61523
     /*  61523 */ GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(63421),
     /*  61528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61534 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(61656), // Rule ID 4014 //
     /*  61539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61580 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61584 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61619 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61623 */     // MIs[4] Rn
     /*  61623 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61628 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61632 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61645 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61654 */     GIR_RootConstrainSelectedInstOperands,
     /*  61655 */     // GIR_Coverage, 4014,
     /*  61655 */     GIR_EraseRootFromParent_Done,
     /*  61656 */   // Label 1043: @61656
     /*  61656 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61778), // Rule ID 13883 //
     /*  61661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61706 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61733 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61737 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61741 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61745 */     // MIs[4] Rn
     /*  61745 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61750 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61754 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61765 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61767 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61776 */     GIR_RootConstrainSelectedInstOperands,
     /*  61777 */     // GIR_Coverage, 13883,
     /*  61777 */     GIR_EraseRootFromParent_Done,
     /*  61778 */   // Label 1044: @61778
     /*  61778 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61833), // Rule ID 13324 //
     /*  61783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61803 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61820 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61831 */     GIR_RootConstrainSelectedInstOperands,
     /*  61832 */     // GIR_Coverage, 13324,
     /*  61832 */     GIR_EraseRootFromParent_Done,
     /*  61833 */   // Label 1045: @61833
     /*  61833 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61888), // Rule ID 175 //
     /*  61838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61862 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61875 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61886 */     GIR_RootConstrainSelectedInstOperands,
     /*  61887 */     // GIR_Coverage, 175,
     /*  61887 */     GIR_EraseRootFromParent_Done,
     /*  61888 */   // Label 1046: @61888
     /*  61888 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(61997), // Rule ID 13683 //
     /*  61893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61962 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61966 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61971 */     // MIs[4] LHS
     /*  61971 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61978 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61995 */     GIR_RootConstrainSelectedInstOperands,
     /*  61996 */     // GIR_Coverage, 13683,
     /*  61996 */     GIR_EraseRootFromParent_Done,
     /*  61997 */   // Label 1047: @61997
     /*  61997 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(62106), // Rule ID 13682 //
     /*  62002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62050 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62071 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62075 */     // MIs[4] LHS
     /*  62075 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62080 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62087 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62104 */     GIR_RootConstrainSelectedInstOperands,
     /*  62105 */     // GIR_Coverage, 13682,
     /*  62105 */     GIR_EraseRootFromParent_Done,
     /*  62106 */   // Label 1048: @62106
     /*  62106 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62215), // Rule ID 13685 //
     /*  62111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62164 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62170 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62180 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  62184 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62189 */     // MIs[4] LHS
     /*  62189 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62194 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62196 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62213 */     GIR_RootConstrainSelectedInstOperands,
     /*  62214 */     // GIR_Coverage, 13685,
     /*  62214 */     GIR_EraseRootFromParent_Done,
     /*  62215 */   // Label 1049: @62215
     /*  62215 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62324), // Rule ID 13684 //
     /*  62220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62273 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62293 */     // MIs[4] LHS
     /*  62293 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62298 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62305 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62322 */     GIR_RootConstrainSelectedInstOperands,
     /*  62323 */     // GIR_Coverage, 13684,
     /*  62323 */     GIR_EraseRootFromParent_Done,
     /*  62324 */   // Label 1050: @62324
     /*  62324 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62433), // Rule ID 2471 //
     /*  62329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62390 */     // MIs[3] LHS
     /*  62390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62412 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62414 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62431 */     GIR_RootConstrainSelectedInstOperands,
     /*  62432 */     // GIR_Coverage, 2471,
     /*  62432 */     GIR_EraseRootFromParent_Done,
     /*  62433 */   // Label 1051: @62433
     /*  62433 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62542), // Rule ID 13680 //
     /*  62438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62499 */     // MIs[3] LHS
     /*  62499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62523 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62540 */     GIR_RootConstrainSelectedInstOperands,
     /*  62541 */     // GIR_Coverage, 13680,
     /*  62541 */     GIR_EraseRootFromParent_Done,
     /*  62542 */   // Label 1052: @62542
     /*  62542 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62651), // Rule ID 13679 //
     /*  62547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62613 */     // MIs[3] LHS
     /*  62613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62622 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62632 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62649 */     GIR_RootConstrainSelectedInstOperands,
     /*  62650 */     // GIR_Coverage, 13679,
     /*  62650 */     GIR_EraseRootFromParent_Done,
     /*  62651 */   // Label 1053: @62651
     /*  62651 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62760), // Rule ID 13681 //
     /*  62656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62722 */     // MIs[3] LHS
     /*  62722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62727 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62731 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62737 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62741 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62758 */     GIR_RootConstrainSelectedInstOperands,
     /*  62759 */     // GIR_Coverage, 13681,
     /*  62759 */     GIR_EraseRootFromParent_Done,
     /*  62760 */   // Label 1054: @62760
     /*  62760 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62801), // Rule ID 147 //
     /*  62765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62781 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62785 */     // MIs[1] Operand 1
     /*  62785 */     // No operand predicates
     /*  62785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62787 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62794 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62799 */     GIR_RootConstrainSelectedInstOperands,
     /*  62800 */     // GIR_Coverage, 147,
     /*  62800 */     GIR_EraseRootFromParent_Done,
     /*  62801 */   // Label 1055: @62801
     /*  62801 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62834), // Rule ID 13326 //
     /*  62806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62821 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62832 */     GIR_RootConstrainSelectedInstOperands,
     /*  62833 */     // GIR_Coverage, 13326,
     /*  62833 */     GIR_EraseRootFromParent_Done,
     /*  62834 */   // Label 1056: @62834
     /*  62834 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62867), // Rule ID 179 //
     /*  62839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62854 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62865 */     GIR_RootConstrainSelectedInstOperands,
     /*  62866 */     // GIR_Coverage, 179,
     /*  62866 */     GIR_EraseRootFromParent_Done,
     /*  62867 */   // Label 1057: @62867
     /*  62867 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62934), // Rule ID 13619 //
     /*  62872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62896 */     // MIs[1] imm
     /*  62896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62908 */     // MIs[2] Operand 1
     /*  62908 */     // No operand predicates
     /*  62908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62918 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62932 */     GIR_RootConstrainSelectedInstOperands,
     /*  62933 */     // GIR_Coverage, 13619,
     /*  62933 */     GIR_EraseRootFromParent_Done,
     /*  62934 */   // Label 1058: @62934
     /*  62934 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63001), // Rule ID 13622 //
     /*  62939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62963 */     // MIs[1] imm
     /*  62963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62975 */     // MIs[2] Operand 1
     /*  62975 */     // No operand predicates
     /*  62975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62985 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62999 */     GIR_RootConstrainSelectedInstOperands,
     /*  63000 */     // GIR_Coverage, 13622,
     /*  63000 */     GIR_EraseRootFromParent_Done,
     /*  63001 */   // Label 1059: @63001
     /*  63001 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63054), // Rule ID 13322 //
     /*  63006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63031 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63041 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63052 */     GIR_RootConstrainSelectedInstOperands,
     /*  63053 */     // GIR_Coverage, 13322,
     /*  63053 */     GIR_EraseRootFromParent_Done,
     /*  63054 */   // Label 1060: @63054
     /*  63054 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63121), // Rule ID 2122 //
     /*  63059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63087 */     // MIs[1] imm
     /*  63087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63099 */     // MIs[2] Operand 1
     /*  63099 */     // No operand predicates
     /*  63099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63105 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  63108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63119 */     GIR_RootConstrainSelectedInstOperands,
     /*  63120 */     // GIR_Coverage, 2122,
     /*  63120 */     GIR_EraseRootFromParent_Done,
     /*  63121 */   // Label 1061: @63121
     /*  63121 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63188), // Rule ID 2131 //
     /*  63126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63154 */     // MIs[1] imm
     /*  63154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63162 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63166 */     // MIs[2] Operand 1
     /*  63166 */     // No operand predicates
     /*  63166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63172 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  63175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63186 */     GIR_RootConstrainSelectedInstOperands,
     /*  63187 */     // GIR_Coverage, 2131,
     /*  63187 */     GIR_EraseRootFromParent_Done,
     /*  63188 */   // Label 1062: @63188
     /*  63188 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63241), // Rule ID 173 //
     /*  63193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63222 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63228 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63239 */     GIR_RootConstrainSelectedInstOperands,
     /*  63240 */     // GIR_Coverage, 173,
     /*  63240 */     GIR_EraseRootFromParent_Done,
     /*  63241 */   // Label 1063: @63241
     /*  63241 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63305), // Rule ID 13974 //
     /*  63246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63278 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63284 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63292 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63297 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63303 */     GIR_RootConstrainSelectedInstOperands,
     /*  63304 */     // GIR_Coverage, 13974,
     /*  63304 */     GIR_EraseRootFromParent_Done,
     /*  63305 */   // Label 1064: @63305
     /*  63305 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63369), // Rule ID 5068 //
     /*  63310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63346 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63352 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63356 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63361 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63367 */     GIR_RootConstrainSelectedInstOperands,
     /*  63368 */     // GIR_Coverage, 5068,
     /*  63368 */     GIR_EraseRootFromParent_Done,
     /*  63369 */   // Label 1065: @63369
     /*  63369 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63393), // Rule ID 177 //
     /*  63374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63386 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  63391 */     GIR_RootConstrainSelectedInstOperands,
     /*  63392 */     // GIR_Coverage, 177,
     /*  63392 */     GIR_Done,
     /*  63393 */   // Label 1066: @63393
     /*  63393 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63420), // Rule ID 5074 //
     /*  63398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63413 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  63418 */     GIR_RootConstrainSelectedInstOperands,
     /*  63419 */     // GIR_Coverage, 5074,
     /*  63419 */     GIR_Done,
     /*  63420 */   // Label 1067: @63420
     /*  63420 */   GIM_Reject,
     /*  63421 */ // Label 1042: @63421
     /*  63421 */ GIM_Reject,
     /*  63422 */ // Label 1016: @63422
     /*  63422 */ GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(64729),
     /*  63427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63433 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63542), // Rule ID 13676 //
     /*  63438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63486 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63492 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63499 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63503 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63507 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63511 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63516 */     // MIs[4] LHS
     /*  63516 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63523 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63540 */     GIR_RootConstrainSelectedInstOperands,
     /*  63541 */     // GIR_Coverage, 13676,
     /*  63541 */     GIR_EraseRootFromParent_Done,
     /*  63542 */   // Label 1069: @63542
     /*  63542 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63651), // Rule ID 13675 //
     /*  63547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63595 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63616 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63620 */     // MIs[4] LHS
     /*  63620 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63625 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63632 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63649 */     GIR_RootConstrainSelectedInstOperands,
     /*  63650 */     // GIR_Coverage, 13675,
     /*  63650 */     GIR_EraseRootFromParent_Done,
     /*  63651 */   // Label 1070: @63651
     /*  63651 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63760), // Rule ID 13678 //
     /*  63656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63709 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63715 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63717 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63721 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63725 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63729 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63734 */     // MIs[4] LHS
     /*  63734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63741 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63758 */     GIR_RootConstrainSelectedInstOperands,
     /*  63759 */     // GIR_Coverage, 13678,
     /*  63759 */     GIR_EraseRootFromParent_Done,
     /*  63760 */   // Label 1071: @63760
     /*  63760 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63869), // Rule ID 13677 //
     /*  63765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63818 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63834 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63838 */     // MIs[4] LHS
     /*  63838 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63843 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63850 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63867 */     GIR_RootConstrainSelectedInstOperands,
     /*  63868 */     // GIR_Coverage, 13677,
     /*  63868 */     GIR_EraseRootFromParent_Done,
     /*  63869 */   // Label 1072: @63869
     /*  63869 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(63978), // Rule ID 2470 //
     /*  63874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63931 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63935 */     // MIs[3] LHS
     /*  63935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63944 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63957 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63959 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63976 */     GIR_RootConstrainSelectedInstOperands,
     /*  63977 */     // GIR_Coverage, 2470,
     /*  63977 */     GIR_EraseRootFromParent_Done,
     /*  63978 */   // Label 1073: @63978
     /*  63978 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64087), // Rule ID 13673 //
     /*  63983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64040 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64044 */     // MIs[3] LHS
     /*  64044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64049 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64053 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64059 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64066 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64068 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64085 */     GIR_RootConstrainSelectedInstOperands,
     /*  64086 */     // GIR_Coverage, 13673,
     /*  64086 */     GIR_EraseRootFromParent_Done,
     /*  64087 */   // Label 1074: @64087
     /*  64087 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64196), // Rule ID 13672 //
     /*  64092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64158 */     // MIs[3] LHS
     /*  64158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64167 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64175 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64177 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64194 */     GIR_RootConstrainSelectedInstOperands,
     /*  64195 */     // GIR_Coverage, 13672,
     /*  64195 */     GIR_EraseRootFromParent_Done,
     /*  64196 */   // Label 1075: @64196
     /*  64196 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64305), // Rule ID 13674 //
     /*  64201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64267 */     // MIs[3] LHS
     /*  64267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64272 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64276 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64282 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64284 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64286 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64303 */     GIR_RootConstrainSelectedInstOperands,
     /*  64304 */     // GIR_Coverage, 13674,
     /*  64304 */     GIR_EraseRootFromParent_Done,
     /*  64305 */   // Label 1076: @64305
     /*  64305 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64372), // Rule ID 13639 //
     /*  64310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64334 */     // MIs[1] imm
     /*  64334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64342 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64346 */     // MIs[2] Operand 1
     /*  64346 */     // No operand predicates
     /*  64346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64356 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64370 */     GIR_RootConstrainSelectedInstOperands,
     /*  64371 */     // GIR_Coverage, 13639,
     /*  64371 */     GIR_EraseRootFromParent_Done,
     /*  64372 */   // Label 1077: @64372
     /*  64372 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64439), // Rule ID 13660 //
     /*  64377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64401 */     // MIs[1] imm
     /*  64401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64413 */     // MIs[2] Operand 1
     /*  64413 */     // No operand predicates
     /*  64413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64423 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64437 */     GIR_RootConstrainSelectedInstOperands,
     /*  64438 */     // GIR_Coverage, 13660,
     /*  64438 */     GIR_EraseRootFromParent_Done,
     /*  64439 */   // Label 1078: @64439
     /*  64439 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64506), // Rule ID 2239 //
     /*  64444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64472 */     // MIs[1] imm
     /*  64472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64480 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64484 */     // MIs[2] Operand 1
     /*  64484 */     // No operand predicates
     /*  64484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64490 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64504 */     GIR_RootConstrainSelectedInstOperands,
     /*  64505 */     // GIR_Coverage, 2239,
     /*  64505 */     GIR_EraseRootFromParent_Done,
     /*  64506 */   // Label 1079: @64506
     /*  64506 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64573), // Rule ID 2298 //
     /*  64511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64539 */     // MIs[1] imm
     /*  64539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64547 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64551 */     // MIs[2] Operand 1
     /*  64551 */     // No operand predicates
     /*  64551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64557 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64571 */     GIR_RootConstrainSelectedInstOperands,
     /*  64572 */     // GIR_Coverage, 2298,
     /*  64572 */     GIR_EraseRootFromParent_Done,
     /*  64573 */   // Label 1080: @64573
     /*  64573 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64637), // Rule ID 13973 //
     /*  64578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64610 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64624 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64629 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64635 */     GIR_RootConstrainSelectedInstOperands,
     /*  64636 */     // GIR_Coverage, 13973,
     /*  64636 */     GIR_EraseRootFromParent_Done,
     /*  64637 */   // Label 1081: @64637
     /*  64637 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64701), // Rule ID 5067 //
     /*  64642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64678 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64688 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64693 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64699 */     GIR_RootConstrainSelectedInstOperands,
     /*  64700 */     // GIR_Coverage, 5067,
     /*  64700 */     GIR_EraseRootFromParent_Done,
     /*  64701 */   // Label 1082: @64701
     /*  64701 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64728), // Rule ID 5073 //
     /*  64706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64721 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64726 */     GIR_RootConstrainSelectedInstOperands,
     /*  64727 */     // GIR_Coverage, 5073,
     /*  64727 */     GIR_Done,
     /*  64728 */   // Label 1083: @64728
     /*  64728 */   GIM_Reject,
     /*  64729 */ // Label 1068: @64729
     /*  64729 */ GIM_Reject,
     /*  64730 */ // Label 1017: @64730
     /*  64730 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(66037),
     /*  64735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64741 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64850), // Rule ID 13704 //
     /*  64746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64811 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64815 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64819 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64824 */     // MIs[4] LHS
     /*  64824 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64829 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64831 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64848 */     GIR_RootConstrainSelectedInstOperands,
     /*  64849 */     // GIR_Coverage, 13704,
     /*  64849 */     GIR_EraseRootFromParent_Done,
     /*  64850 */   // Label 1085: @64850
     /*  64850 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(64959), // Rule ID 13703 //
     /*  64855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64903 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64924 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64928 */     // MIs[4] LHS
     /*  64928 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64933 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64938 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64940 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64957 */     GIR_RootConstrainSelectedInstOperands,
     /*  64958 */     // GIR_Coverage, 13703,
     /*  64958 */     GIR_EraseRootFromParent_Done,
     /*  64959 */   // Label 1086: @64959
     /*  64959 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65068), // Rule ID 13706 //
     /*  64964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65017 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65033 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65037 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65042 */     // MIs[4] LHS
     /*  65042 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65047 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65049 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65066 */     GIR_RootConstrainSelectedInstOperands,
     /*  65067 */     // GIR_Coverage, 13706,
     /*  65067 */     GIR_EraseRootFromParent_Done,
     /*  65068 */   // Label 1087: @65068
     /*  65068 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65177), // Rule ID 13705 //
     /*  65073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65126 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65132 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65142 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65146 */     // MIs[4] LHS
     /*  65146 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65151 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65156 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65158 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65175 */     GIR_RootConstrainSelectedInstOperands,
     /*  65176 */     // GIR_Coverage, 13705,
     /*  65176 */     GIR_EraseRootFromParent_Done,
     /*  65177 */   // Label 1088: @65177
     /*  65177 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65286), // Rule ID 2474 //
     /*  65182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65243 */     // MIs[3] LHS
     /*  65243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65265 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65267 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65284 */     GIR_RootConstrainSelectedInstOperands,
     /*  65285 */     // GIR_Coverage, 2474,
     /*  65285 */     GIR_EraseRootFromParent_Done,
     /*  65286 */   // Label 1089: @65286
     /*  65286 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65395), // Rule ID 13701 //
     /*  65291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65352 */     // MIs[3] LHS
     /*  65352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65357 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65361 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65374 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65376 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65393 */     GIR_RootConstrainSelectedInstOperands,
     /*  65394 */     // GIR_Coverage, 13701,
     /*  65394 */     GIR_EraseRootFromParent_Done,
     /*  65395 */   // Label 1090: @65395
     /*  65395 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65504), // Rule ID 13700 //
     /*  65400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65462 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65466 */     // MIs[3] LHS
     /*  65466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65475 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65483 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65485 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65502 */     GIR_RootConstrainSelectedInstOperands,
     /*  65503 */     // GIR_Coverage, 13700,
     /*  65503 */     GIR_EraseRootFromParent_Done,
     /*  65504 */   // Label 1091: @65504
     /*  65504 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65613), // Rule ID 13702 //
     /*  65509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65571 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65575 */     // MIs[3] LHS
     /*  65575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65584 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65592 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65594 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65611 */     GIR_RootConstrainSelectedInstOperands,
     /*  65612 */     // GIR_Coverage, 13702,
     /*  65612 */     GIR_EraseRootFromParent_Done,
     /*  65613 */   // Label 1092: @65613
     /*  65613 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65680), // Rule ID 13643 //
     /*  65618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65642 */     // MIs[1] imm
     /*  65642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65650 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65654 */     // MIs[2] Operand 1
     /*  65654 */     // No operand predicates
     /*  65654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65664 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65678 */     GIR_RootConstrainSelectedInstOperands,
     /*  65679 */     // GIR_Coverage, 13643,
     /*  65679 */     GIR_EraseRootFromParent_Done,
     /*  65680 */   // Label 1093: @65680
     /*  65680 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65747), // Rule ID 13664 //
     /*  65685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65709 */     // MIs[1] imm
     /*  65709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65721 */     // MIs[2] Operand 1
     /*  65721 */     // No operand predicates
     /*  65721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65731 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65745 */     GIR_RootConstrainSelectedInstOperands,
     /*  65746 */     // GIR_Coverage, 13664,
     /*  65746 */     GIR_EraseRootFromParent_Done,
     /*  65747 */   // Label 1094: @65747
     /*  65747 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65814), // Rule ID 2243 //
     /*  65752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65780 */     // MIs[1] imm
     /*  65780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65788 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65792 */     // MIs[2] Operand 1
     /*  65792 */     // No operand predicates
     /*  65792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65798 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65812 */     GIR_RootConstrainSelectedInstOperands,
     /*  65813 */     // GIR_Coverage, 2243,
     /*  65813 */     GIR_EraseRootFromParent_Done,
     /*  65814 */   // Label 1095: @65814
     /*  65814 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65881), // Rule ID 2302 //
     /*  65819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65847 */     // MIs[1] imm
     /*  65847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65855 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65859 */     // MIs[2] Operand 1
     /*  65859 */     // No operand predicates
     /*  65859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65865 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65879 */     GIR_RootConstrainSelectedInstOperands,
     /*  65880 */     // GIR_Coverage, 2302,
     /*  65880 */     GIR_EraseRootFromParent_Done,
     /*  65881 */   // Label 1096: @65881
     /*  65881 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(65945), // Rule ID 13977 //
     /*  65886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65918 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65932 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65937 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65943 */     GIR_RootConstrainSelectedInstOperands,
     /*  65944 */     // GIR_Coverage, 13977,
     /*  65944 */     GIR_EraseRootFromParent_Done,
     /*  65945 */   // Label 1097: @65945
     /*  65945 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(66009), // Rule ID 5071 //
     /*  65950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65986 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65992 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65996 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66001 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66007 */     GIR_RootConstrainSelectedInstOperands,
     /*  66008 */     // GIR_Coverage, 5071,
     /*  66008 */     GIR_EraseRootFromParent_Done,
     /*  66009 */   // Label 1098: @66009
     /*  66009 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(66036), // Rule ID 5077 //
     /*  66014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66029 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  66029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  66034 */     GIR_RootConstrainSelectedInstOperands,
     /*  66035 */     // GIR_Coverage, 5077,
     /*  66035 */     GIR_Done,
     /*  66036 */   // Label 1099: @66036
     /*  66036 */   GIM_Reject,
     /*  66037 */ // Label 1084: @66037
     /*  66037 */ GIM_Reject,
     /*  66038 */ // Label 1018: @66038
     /*  66038 */ GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(67345),
     /*  66043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66049 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66158), // Rule ID 13669 //
     /*  66054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66102 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66115 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66119 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66123 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66127 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66132 */     // MIs[4] LHS
     /*  66132 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66137 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66139 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66156 */     GIR_RootConstrainSelectedInstOperands,
     /*  66157 */     // GIR_Coverage, 13669,
     /*  66157 */     GIR_EraseRootFromParent_Done,
     /*  66158 */   // Label 1101: @66158
     /*  66158 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66267), // Rule ID 13668 //
     /*  66163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66211 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66224 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66228 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66232 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66236 */     // MIs[4] LHS
     /*  66236 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66241 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66248 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66265 */     GIR_RootConstrainSelectedInstOperands,
     /*  66266 */     // GIR_Coverage, 13668,
     /*  66266 */     GIR_EraseRootFromParent_Done,
     /*  66267 */   // Label 1102: @66267
     /*  66267 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66376), // Rule ID 13671 //
     /*  66272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66325 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66333 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66337 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66341 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66345 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66350 */     // MIs[4] LHS
     /*  66350 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66355 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66357 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66374 */     GIR_RootConstrainSelectedInstOperands,
     /*  66375 */     // GIR_Coverage, 13671,
     /*  66375 */     GIR_EraseRootFromParent_Done,
     /*  66376 */   // Label 1103: @66376
     /*  66376 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66485), // Rule ID 13670 //
     /*  66381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66450 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66454 */     // MIs[4] LHS
     /*  66454 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66459 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66464 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66466 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66483 */     GIR_RootConstrainSelectedInstOperands,
     /*  66484 */     // GIR_Coverage, 13670,
     /*  66484 */     GIR_EraseRootFromParent_Done,
     /*  66485 */   // Label 1104: @66485
     /*  66485 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66594), // Rule ID 2469 //
     /*  66490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66547 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66551 */     // MIs[3] LHS
     /*  66551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66560 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66566 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66575 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66592 */     GIR_RootConstrainSelectedInstOperands,
     /*  66593 */     // GIR_Coverage, 2469,
     /*  66593 */     GIR_EraseRootFromParent_Done,
     /*  66594 */   // Label 1105: @66594
     /*  66594 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66703), // Rule ID 13666 //
     /*  66599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66656 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66660 */     // MIs[3] LHS
     /*  66660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66665 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66669 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66682 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66684 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66701 */     GIR_RootConstrainSelectedInstOperands,
     /*  66702 */     // GIR_Coverage, 13666,
     /*  66702 */     GIR_EraseRootFromParent_Done,
     /*  66703 */   // Label 1106: @66703
     /*  66703 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66812), // Rule ID 13665 //
     /*  66708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66774 */     // MIs[3] LHS
     /*  66774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66783 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66791 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66793 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66810 */     GIR_RootConstrainSelectedInstOperands,
     /*  66811 */     // GIR_Coverage, 13665,
     /*  66811 */     GIR_EraseRootFromParent_Done,
     /*  66812 */   // Label 1107: @66812
     /*  66812 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(66921), // Rule ID 13667 //
     /*  66817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66883 */     // MIs[3] LHS
     /*  66883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66892 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66898 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66900 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66902 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66919 */     GIR_RootConstrainSelectedInstOperands,
     /*  66920 */     // GIR_Coverage, 13667,
     /*  66920 */     GIR_EraseRootFromParent_Done,
     /*  66921 */   // Label 1108: @66921
     /*  66921 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66988), // Rule ID 13635 //
     /*  66926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66950 */     // MIs[1] imm
     /*  66950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66962 */     // MIs[2] Operand 1
     /*  66962 */     // No operand predicates
     /*  66962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66972 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66986 */     GIR_RootConstrainSelectedInstOperands,
     /*  66987 */     // GIR_Coverage, 13635,
     /*  66987 */     GIR_EraseRootFromParent_Done,
     /*  66988 */   // Label 1109: @66988
     /*  66988 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67055), // Rule ID 13656 //
     /*  66993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67017 */     // MIs[1] imm
     /*  67017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67025 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67029 */     // MIs[2] Operand 1
     /*  67029 */     // No operand predicates
     /*  67029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67039 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67053 */     GIR_RootConstrainSelectedInstOperands,
     /*  67054 */     // GIR_Coverage, 13656,
     /*  67054 */     GIR_EraseRootFromParent_Done,
     /*  67055 */   // Label 1110: @67055
     /*  67055 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67122), // Rule ID 2235 //
     /*  67060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67088 */     // MIs[1] imm
     /*  67088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67100 */     // MIs[2] Operand 1
     /*  67100 */     // No operand predicates
     /*  67100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67106 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  67109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67120 */     GIR_RootConstrainSelectedInstOperands,
     /*  67121 */     // GIR_Coverage, 2235,
     /*  67121 */     GIR_EraseRootFromParent_Done,
     /*  67122 */   // Label 1111: @67122
     /*  67122 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67189), // Rule ID 2294 //
     /*  67127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67155 */     // MIs[1] imm
     /*  67155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67163 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67167 */     // MIs[2] Operand 1
     /*  67167 */     // No operand predicates
     /*  67167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67173 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67187 */     GIR_RootConstrainSelectedInstOperands,
     /*  67188 */     // GIR_Coverage, 2294,
     /*  67188 */     GIR_EraseRootFromParent_Done,
     /*  67189 */   // Label 1112: @67189
     /*  67189 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67253), // Rule ID 13972 //
     /*  67194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67226 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67232 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67240 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67245 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67251 */     GIR_RootConstrainSelectedInstOperands,
     /*  67252 */     // GIR_Coverage, 13972,
     /*  67252 */     GIR_EraseRootFromParent_Done,
     /*  67253 */   // Label 1113: @67253
     /*  67253 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67317), // Rule ID 5066 //
     /*  67258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67294 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67304 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67309 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67315 */     GIR_RootConstrainSelectedInstOperands,
     /*  67316 */     // GIR_Coverage, 5066,
     /*  67316 */     GIR_EraseRootFromParent_Done,
     /*  67317 */   // Label 1114: @67317
     /*  67317 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(67344), // Rule ID 5072 //
     /*  67322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67337 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  67342 */     GIR_RootConstrainSelectedInstOperands,
     /*  67343 */     // GIR_Coverage, 5072,
     /*  67343 */     GIR_Done,
     /*  67344 */   // Label 1115: @67344
     /*  67344 */   GIM_Reject,
     /*  67345 */ // Label 1100: @67345
     /*  67345 */ GIM_Reject,
     /*  67346 */ // Label 1019: @67346
     /*  67346 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(68653),
     /*  67351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67357 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67466), // Rule ID 13697 //
     /*  67362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67410 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67416 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67435 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67440 */     // MIs[4] LHS
     /*  67440 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67445 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67447 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67464 */     GIR_RootConstrainSelectedInstOperands,
     /*  67465 */     // GIR_Coverage, 13697,
     /*  67465 */     GIR_EraseRootFromParent_Done,
     /*  67466 */   // Label 1117: @67466
     /*  67466 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67575), // Rule ID 13696 //
     /*  67471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67519 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67540 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67544 */     // MIs[4] LHS
     /*  67544 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67549 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67554 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67556 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67573 */     GIR_RootConstrainSelectedInstOperands,
     /*  67574 */     // GIR_Coverage, 13696,
     /*  67574 */     GIR_EraseRootFromParent_Done,
     /*  67575 */   // Label 1118: @67575
     /*  67575 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67684), // Rule ID 13699 //
     /*  67580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67649 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67653 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67658 */     // MIs[4] LHS
     /*  67658 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67663 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67665 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67682 */     GIR_RootConstrainSelectedInstOperands,
     /*  67683 */     // GIR_Coverage, 13699,
     /*  67683 */     GIR_EraseRootFromParent_Done,
     /*  67684 */   // Label 1119: @67684
     /*  67684 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67793), // Rule ID 13698 //
     /*  67689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67750 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67754 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67758 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67762 */     // MIs[4] LHS
     /*  67762 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67767 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67772 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67774 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67791 */     GIR_RootConstrainSelectedInstOperands,
     /*  67792 */     // GIR_Coverage, 13698,
     /*  67792 */     GIR_EraseRootFromParent_Done,
     /*  67793 */   // Label 1120: @67793
     /*  67793 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(67902), // Rule ID 2473 //
     /*  67798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67855 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67859 */     // MIs[3] LHS
     /*  67859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67864 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67868 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67881 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67883 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67900 */     GIR_RootConstrainSelectedInstOperands,
     /*  67901 */     // GIR_Coverage, 2473,
     /*  67901 */     GIR_EraseRootFromParent_Done,
     /*  67902 */   // Label 1121: @67902
     /*  67902 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68011), // Rule ID 13694 //
     /*  67907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67968 */     // MIs[3] LHS
     /*  67968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67973 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67977 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67992 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68009 */     GIR_RootConstrainSelectedInstOperands,
     /*  68010 */     // GIR_Coverage, 13694,
     /*  68010 */     GIR_EraseRootFromParent_Done,
     /*  68011 */   // Label 1122: @68011
     /*  68011 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68120), // Rule ID 13693 //
     /*  68016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68078 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68082 */     // MIs[3] LHS
     /*  68082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68087 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68091 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68099 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68101 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68118 */     GIR_RootConstrainSelectedInstOperands,
     /*  68119 */     // GIR_Coverage, 13693,
     /*  68119 */     GIR_EraseRootFromParent_Done,
     /*  68120 */   // Label 1123: @68120
     /*  68120 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68229), // Rule ID 13695 //
     /*  68125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68191 */     // MIs[3] LHS
     /*  68191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68210 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68227 */     GIR_RootConstrainSelectedInstOperands,
     /*  68228 */     // GIR_Coverage, 13695,
     /*  68228 */     GIR_EraseRootFromParent_Done,
     /*  68229 */   // Label 1124: @68229
     /*  68229 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68296), // Rule ID 13641 //
     /*  68234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68258 */     // MIs[1] imm
     /*  68258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68266 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68270 */     // MIs[2] Operand 1
     /*  68270 */     // No operand predicates
     /*  68270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68280 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68294 */     GIR_RootConstrainSelectedInstOperands,
     /*  68295 */     // GIR_Coverage, 13641,
     /*  68295 */     GIR_EraseRootFromParent_Done,
     /*  68296 */   // Label 1125: @68296
     /*  68296 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68363), // Rule ID 13662 //
     /*  68301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68325 */     // MIs[1] imm
     /*  68325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68337 */     // MIs[2] Operand 1
     /*  68337 */     // No operand predicates
     /*  68337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68347 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68361 */     GIR_RootConstrainSelectedInstOperands,
     /*  68362 */     // GIR_Coverage, 13662,
     /*  68362 */     GIR_EraseRootFromParent_Done,
     /*  68363 */   // Label 1126: @68363
     /*  68363 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68430), // Rule ID 2241 //
     /*  68368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68396 */     // MIs[1] imm
     /*  68396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68408 */     // MIs[2] Operand 1
     /*  68408 */     // No operand predicates
     /*  68408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68414 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68428 */     GIR_RootConstrainSelectedInstOperands,
     /*  68429 */     // GIR_Coverage, 2241,
     /*  68429 */     GIR_EraseRootFromParent_Done,
     /*  68430 */   // Label 1127: @68430
     /*  68430 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68497), // Rule ID 2300 //
     /*  68435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68463 */     // MIs[1] imm
     /*  68463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68475 */     // MIs[2] Operand 1
     /*  68475 */     // No operand predicates
     /*  68475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68481 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68495 */     GIR_RootConstrainSelectedInstOperands,
     /*  68496 */     // GIR_Coverage, 2300,
     /*  68496 */     GIR_EraseRootFromParent_Done,
     /*  68497 */   // Label 1128: @68497
     /*  68497 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68561), // Rule ID 13976 //
     /*  68502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68534 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68540 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68548 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68553 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68559 */     GIR_RootConstrainSelectedInstOperands,
     /*  68560 */     // GIR_Coverage, 13976,
     /*  68560 */     GIR_EraseRootFromParent_Done,
     /*  68561 */   // Label 1129: @68561
     /*  68561 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68625), // Rule ID 5070 //
     /*  68566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68602 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68612 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68623 */     GIR_RootConstrainSelectedInstOperands,
     /*  68624 */     // GIR_Coverage, 5070,
     /*  68624 */     GIR_EraseRootFromParent_Done,
     /*  68625 */   // Label 1130: @68625
     /*  68625 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68652), // Rule ID 5076 //
     /*  68630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68645 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68650 */     GIR_RootConstrainSelectedInstOperands,
     /*  68651 */     // GIR_Coverage, 5076,
     /*  68651 */     GIR_Done,
     /*  68652 */   // Label 1131: @68652
     /*  68652 */   GIM_Reject,
     /*  68653 */ // Label 1116: @68653
     /*  68653 */ GIM_Reject,
     /*  68654 */ // Label 1020: @68654
     /*  68654 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(69961),
     /*  68659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68665 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68774), // Rule ID 13447 //
     /*  68670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68718 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68739 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68743 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68748 */     // MIs[4] Rd
     /*  68748 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68753 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68755 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68772 */     GIR_RootConstrainSelectedInstOperands,
     /*  68773 */     // GIR_Coverage, 13447,
     /*  68773 */     GIR_EraseRootFromParent_Done,
     /*  68774 */   // Label 1133: @68774
     /*  68774 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68883), // Rule ID 13446 //
     /*  68779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68827 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68848 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68852 */     // MIs[4] Rd
     /*  68852 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68857 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68862 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68864 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68881 */     GIR_RootConstrainSelectedInstOperands,
     /*  68882 */     // GIR_Coverage, 13446,
     /*  68882 */     GIR_EraseRootFromParent_Done,
     /*  68883 */   // Label 1134: @68883
     /*  68883 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(68992), // Rule ID 13449 //
     /*  68888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68957 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68961 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68966 */     // MIs[4] Rd
     /*  68966 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68971 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68973 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68990 */     GIR_RootConstrainSelectedInstOperands,
     /*  68991 */     // GIR_Coverage, 13449,
     /*  68991 */     GIR_EraseRootFromParent_Done,
     /*  68992 */   // Label 1135: @68992
     /*  68992 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69101), // Rule ID 13448 //
     /*  68997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69050 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69066 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69070 */     // MIs[4] Rd
     /*  69070 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69075 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69080 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69082 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  69091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  69095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69099 */     GIR_RootConstrainSelectedInstOperands,
     /*  69100 */     // GIR_Coverage, 13448,
     /*  69100 */     GIR_EraseRootFromParent_Done,
     /*  69101 */   // Label 1136: @69101
     /*  69101 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69210), // Rule ID 1605 //
     /*  69106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69167 */     // MIs[3] Rd
     /*  69167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69176 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69182 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69191 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69208 */     GIR_RootConstrainSelectedInstOperands,
     /*  69209 */     // GIR_Coverage, 1605,
     /*  69209 */     GIR_EraseRootFromParent_Done,
     /*  69210 */   // Label 1137: @69210
     /*  69210 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69319), // Rule ID 13444 //
     /*  69215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69272 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69276 */     // MIs[3] Rd
     /*  69276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69285 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69300 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69317 */     GIR_RootConstrainSelectedInstOperands,
     /*  69318 */     // GIR_Coverage, 13444,
     /*  69318 */     GIR_EraseRootFromParent_Done,
     /*  69319 */   // Label 1138: @69319
     /*  69319 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69428), // Rule ID 13443 //
     /*  69324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69390 */     // MIs[3] Rd
     /*  69390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69409 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69426 */     GIR_RootConstrainSelectedInstOperands,
     /*  69427 */     // GIR_Coverage, 13443,
     /*  69427 */     GIR_EraseRootFromParent_Done,
     /*  69428 */   // Label 1139: @69428
     /*  69428 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69537), // Rule ID 13445 //
     /*  69433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69499 */     // MIs[3] Rd
     /*  69499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69516 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69518 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69535 */     GIR_RootConstrainSelectedInstOperands,
     /*  69536 */     // GIR_Coverage, 13445,
     /*  69536 */     GIR_EraseRootFromParent_Done,
     /*  69537 */   // Label 1140: @69537
     /*  69537 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69604), // Rule ID 13631 //
     /*  69542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69566 */     // MIs[1] imm
     /*  69566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69578 */     // MIs[2] Operand 1
     /*  69578 */     // No operand predicates
     /*  69578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69588 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69602 */     GIR_RootConstrainSelectedInstOperands,
     /*  69603 */     // GIR_Coverage, 13631,
     /*  69603 */     GIR_EraseRootFromParent_Done,
     /*  69604 */   // Label 1141: @69604
     /*  69604 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69671), // Rule ID 13652 //
     /*  69609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69633 */     // MIs[1] imm
     /*  69633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69645 */     // MIs[2] Operand 1
     /*  69645 */     // No operand predicates
     /*  69645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69655 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69669 */     GIR_RootConstrainSelectedInstOperands,
     /*  69670 */     // GIR_Coverage, 13652,
     /*  69670 */     GIR_EraseRootFromParent_Done,
     /*  69671 */   // Label 1142: @69671
     /*  69671 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69738), // Rule ID 2231 //
     /*  69676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69704 */     // MIs[1] imm
     /*  69704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69716 */     // MIs[2] Operand 1
     /*  69716 */     // No operand predicates
     /*  69716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69722 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69736 */     GIR_RootConstrainSelectedInstOperands,
     /*  69737 */     // GIR_Coverage, 2231,
     /*  69737 */     GIR_EraseRootFromParent_Done,
     /*  69738 */   // Label 1143: @69738
     /*  69738 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69805), // Rule ID 2290 //
     /*  69743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69771 */     // MIs[1] imm
     /*  69771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69783 */     // MIs[2] Operand 1
     /*  69783 */     // No operand predicates
     /*  69783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69789 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69803 */     GIR_RootConstrainSelectedInstOperands,
     /*  69804 */     // GIR_Coverage, 2290,
     /*  69804 */     GIR_EraseRootFromParent_Done,
     /*  69805 */   // Label 1144: @69805
     /*  69805 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69869), // Rule ID 13441 //
     /*  69810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69842 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69848 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69856 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69867 */     GIR_RootConstrainSelectedInstOperands,
     /*  69868 */     // GIR_Coverage, 13441,
     /*  69868 */     GIR_EraseRootFromParent_Done,
     /*  69869 */   // Label 1145: @69869
     /*  69869 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69933), // Rule ID 1601 //
     /*  69874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69910 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69920 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69931 */     GIR_RootConstrainSelectedInstOperands,
     /*  69932 */     // GIR_Coverage, 1601,
     /*  69932 */     GIR_EraseRootFromParent_Done,
     /*  69933 */   // Label 1146: @69933
     /*  69933 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(69960), // Rule ID 1603 //
     /*  69938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69953 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69958 */     GIR_RootConstrainSelectedInstOperands,
     /*  69959 */     // GIR_Coverage, 1603,
     /*  69959 */     GIR_Done,
     /*  69960 */   // Label 1147: @69960
     /*  69960 */   GIM_Reject,
     /*  69961 */ // Label 1132: @69961
     /*  69961 */ GIM_Reject,
     /*  69962 */ // Label 1021: @69962
     /*  69962 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71269),
     /*  69967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69973 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70082), // Rule ID 13690 //
     /*  69978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70026 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70032 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70039 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70043 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70047 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70051 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70056 */     // MIs[4] LHS
     /*  70056 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70061 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70063 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70080 */     GIR_RootConstrainSelectedInstOperands,
     /*  70081 */     // GIR_Coverage, 13690,
     /*  70081 */     GIR_EraseRootFromParent_Done,
     /*  70082 */   // Label 1149: @70082
     /*  70082 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70191), // Rule ID 13689 //
     /*  70087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70135 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70148 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70152 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70156 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70160 */     // MIs[4] LHS
     /*  70160 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70165 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70172 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70189 */     GIR_RootConstrainSelectedInstOperands,
     /*  70190 */     // GIR_Coverage, 13689,
     /*  70190 */     GIR_EraseRootFromParent_Done,
     /*  70191 */   // Label 1150: @70191
     /*  70191 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70300), // Rule ID 13692 //
     /*  70196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70249 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70257 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70261 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70265 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70269 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70274 */     // MIs[4] LHS
     /*  70274 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70279 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70281 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70298 */     GIR_RootConstrainSelectedInstOperands,
     /*  70299 */     // GIR_Coverage, 13692,
     /*  70299 */     GIR_EraseRootFromParent_Done,
     /*  70300 */   // Label 1151: @70300
     /*  70300 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70409), // Rule ID 13691 //
     /*  70305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70358 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70366 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70370 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70374 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70378 */     // MIs[4] LHS
     /*  70378 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70383 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70390 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70407 */     GIR_RootConstrainSelectedInstOperands,
     /*  70408 */     // GIR_Coverage, 13691,
     /*  70408 */     GIR_EraseRootFromParent_Done,
     /*  70409 */   // Label 1152: @70409
     /*  70409 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70518), // Rule ID 2472 //
     /*  70414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70471 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70475 */     // MIs[3] LHS
     /*  70475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70484 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70490 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70497 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70499 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70516 */     GIR_RootConstrainSelectedInstOperands,
     /*  70517 */     // GIR_Coverage, 2472,
     /*  70517 */     GIR_EraseRootFromParent_Done,
     /*  70518 */   // Label 1153: @70518
     /*  70518 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70627), // Rule ID 13687 //
     /*  70523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70580 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70584 */     // MIs[3] LHS
     /*  70584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70589 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70593 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70606 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70608 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70625 */     GIR_RootConstrainSelectedInstOperands,
     /*  70626 */     // GIR_Coverage, 13687,
     /*  70626 */     GIR_EraseRootFromParent_Done,
     /*  70627 */   // Label 1154: @70627
     /*  70627 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70736), // Rule ID 13686 //
     /*  70632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70694 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70698 */     // MIs[3] LHS
     /*  70698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70703 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70707 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70717 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70734 */     GIR_RootConstrainSelectedInstOperands,
     /*  70735 */     // GIR_Coverage, 13686,
     /*  70735 */     GIR_EraseRootFromParent_Done,
     /*  70736 */   // Label 1155: @70736
     /*  70736 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70845), // Rule ID 13688 //
     /*  70741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70803 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70807 */     // MIs[3] LHS
     /*  70807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70816 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70822 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70824 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70826 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70843 */     GIR_RootConstrainSelectedInstOperands,
     /*  70844 */     // GIR_Coverage, 13688,
     /*  70844 */     GIR_EraseRootFromParent_Done,
     /*  70845 */   // Label 1156: @70845
     /*  70845 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70912), // Rule ID 13637 //
     /*  70850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70874 */     // MIs[1] imm
     /*  70874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70886 */     // MIs[2] Operand 1
     /*  70886 */     // No operand predicates
     /*  70886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70896 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70910 */     GIR_RootConstrainSelectedInstOperands,
     /*  70911 */     // GIR_Coverage, 13637,
     /*  70911 */     GIR_EraseRootFromParent_Done,
     /*  70912 */   // Label 1157: @70912
     /*  70912 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70979), // Rule ID 13658 //
     /*  70917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70941 */     // MIs[1] imm
     /*  70941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70953 */     // MIs[2] Operand 1
     /*  70953 */     // No operand predicates
     /*  70953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70963 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70977 */     GIR_RootConstrainSelectedInstOperands,
     /*  70978 */     // GIR_Coverage, 13658,
     /*  70978 */     GIR_EraseRootFromParent_Done,
     /*  70979 */   // Label 1158: @70979
     /*  70979 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71046), // Rule ID 2237 //
     /*  70984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71012 */     // MIs[1] imm
     /*  71012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71024 */     // MIs[2] Operand 1
     /*  71024 */     // No operand predicates
     /*  71024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71030 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  71033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71044 */     GIR_RootConstrainSelectedInstOperands,
     /*  71045 */     // GIR_Coverage, 2237,
     /*  71045 */     GIR_EraseRootFromParent_Done,
     /*  71046 */   // Label 1159: @71046
     /*  71046 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71113), // Rule ID 2296 //
     /*  71051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71079 */     // MIs[1] imm
     /*  71079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71091 */     // MIs[2] Operand 1
     /*  71091 */     // No operand predicates
     /*  71091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71097 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  71100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71111 */     GIR_RootConstrainSelectedInstOperands,
     /*  71112 */     // GIR_Coverage, 2296,
     /*  71112 */     GIR_EraseRootFromParent_Done,
     /*  71113 */   // Label 1160: @71113
     /*  71113 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71177), // Rule ID 13975 //
     /*  71118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71150 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71164 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71169 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  71171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71175 */     GIR_RootConstrainSelectedInstOperands,
     /*  71176 */     // GIR_Coverage, 13975,
     /*  71176 */     GIR_EraseRootFromParent_Done,
     /*  71177 */   // Label 1161: @71177
     /*  71177 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71241), // Rule ID 5069 //
     /*  71182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71218 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71228 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71233 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  71235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71239 */     GIR_RootConstrainSelectedInstOperands,
     /*  71240 */     // GIR_Coverage, 5069,
     /*  71240 */     GIR_EraseRootFromParent_Done,
     /*  71241 */   // Label 1162: @71241
     /*  71241 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71268), // Rule ID 5075 //
     /*  71246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71261 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71266 */     GIR_RootConstrainSelectedInstOperands,
     /*  71267 */     // GIR_Coverage, 5075,
     /*  71267 */     GIR_Done,
     /*  71268 */   // Label 1163: @71268
     /*  71268 */   GIM_Reject,
     /*  71269 */ // Label 1148: @71269
     /*  71269 */ GIM_Reject,
     /*  71270 */ // Label 1022: @71270
     /*  71270 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72577),
     /*  71275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71281 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71390), // Rule ID 13454 //
     /*  71286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71334 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71340 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71347 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71351 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71355 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71359 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71364 */     // MIs[4] Rd
     /*  71364 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71369 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71371 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71388 */     GIR_RootConstrainSelectedInstOperands,
     /*  71389 */     // GIR_Coverage, 13454,
     /*  71389 */     GIR_EraseRootFromParent_Done,
     /*  71390 */   // Label 1165: @71390
     /*  71390 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71499), // Rule ID 13453 //
     /*  71395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71443 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71464 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71468 */     // MIs[4] Rd
     /*  71468 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71473 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71480 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71497 */     GIR_RootConstrainSelectedInstOperands,
     /*  71498 */     // GIR_Coverage, 13453,
     /*  71498 */     GIR_EraseRootFromParent_Done,
     /*  71499 */   // Label 1166: @71499
     /*  71499 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71608), // Rule ID 13456 //
     /*  71504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71557 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71565 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71569 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71573 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71577 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71582 */     // MIs[4] Rd
     /*  71582 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71587 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71589 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71606 */     GIR_RootConstrainSelectedInstOperands,
     /*  71607 */     // GIR_Coverage, 13456,
     /*  71607 */     GIR_EraseRootFromParent_Done,
     /*  71608 */   // Label 1167: @71608
     /*  71608 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71717), // Rule ID 13455 //
     /*  71613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71666 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71672 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71682 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71686 */     // MIs[4] Rd
     /*  71686 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71691 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71696 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71698 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71715 */     GIR_RootConstrainSelectedInstOperands,
     /*  71716 */     // GIR_Coverage, 13455,
     /*  71716 */     GIR_EraseRootFromParent_Done,
     /*  71717 */   // Label 1168: @71717
     /*  71717 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(71826), // Rule ID 1606 //
     /*  71722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71779 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71783 */     // MIs[3] Rd
     /*  71783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71788 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71792 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71798 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71805 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71807 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71824 */     GIR_RootConstrainSelectedInstOperands,
     /*  71825 */     // GIR_Coverage, 1606,
     /*  71825 */     GIR_EraseRootFromParent_Done,
     /*  71826 */   // Label 1169: @71826
     /*  71826 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71935), // Rule ID 13451 //
     /*  71831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71888 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71892 */     // MIs[3] Rd
     /*  71892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71901 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71914 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71916 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71933 */     GIR_RootConstrainSelectedInstOperands,
     /*  71934 */     // GIR_Coverage, 13451,
     /*  71934 */     GIR_EraseRootFromParent_Done,
     /*  71935 */   // Label 1170: @71935
     /*  71935 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72044), // Rule ID 13450 //
     /*  71940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72006 */     // MIs[3] Rd
     /*  72006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  72011 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72015 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72021 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72023 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72025 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  72034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72042 */     GIR_RootConstrainSelectedInstOperands,
     /*  72043 */     // GIR_Coverage, 13450,
     /*  72043 */     GIR_EraseRootFromParent_Done,
     /*  72044 */   // Label 1171: @72044
     /*  72044 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72153), // Rule ID 13452 //
     /*  72049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72115 */     // MIs[3] Rd
     /*  72115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72124 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72130 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72132 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72134 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  72143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72151 */     GIR_RootConstrainSelectedInstOperands,
     /*  72152 */     // GIR_Coverage, 13452,
     /*  72152 */     GIR_EraseRootFromParent_Done,
     /*  72153 */   // Label 1172: @72153
     /*  72153 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72220), // Rule ID 13633 //
     /*  72158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72182 */     // MIs[1] imm
     /*  72182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72190 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72194 */     // MIs[2] Operand 1
     /*  72194 */     // No operand predicates
     /*  72194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72204 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72218 */     GIR_RootConstrainSelectedInstOperands,
     /*  72219 */     // GIR_Coverage, 13633,
     /*  72219 */     GIR_EraseRootFromParent_Done,
     /*  72220 */   // Label 1173: @72220
     /*  72220 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72287), // Rule ID 13654 //
     /*  72225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72249 */     // MIs[1] imm
     /*  72249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72261 */     // MIs[2] Operand 1
     /*  72261 */     // No operand predicates
     /*  72261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72271 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72285 */     GIR_RootConstrainSelectedInstOperands,
     /*  72286 */     // GIR_Coverage, 13654,
     /*  72286 */     GIR_EraseRootFromParent_Done,
     /*  72287 */   // Label 1174: @72287
     /*  72287 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72354), // Rule ID 2233 //
     /*  72292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72320 */     // MIs[1] imm
     /*  72320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72328 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72332 */     // MIs[2] Operand 1
     /*  72332 */     // No operand predicates
     /*  72332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72338 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72352 */     GIR_RootConstrainSelectedInstOperands,
     /*  72353 */     // GIR_Coverage, 2233,
     /*  72353 */     GIR_EraseRootFromParent_Done,
     /*  72354 */   // Label 1175: @72354
     /*  72354 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72421), // Rule ID 2292 //
     /*  72359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72387 */     // MIs[1] imm
     /*  72387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72395 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72399 */     // MIs[2] Operand 1
     /*  72399 */     // No operand predicates
     /*  72399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72405 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72419 */     GIR_RootConstrainSelectedInstOperands,
     /*  72420 */     // GIR_Coverage, 2292,
     /*  72420 */     GIR_EraseRootFromParent_Done,
     /*  72421 */   // Label 1176: @72421
     /*  72421 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72485), // Rule ID 13442 //
     /*  72426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72458 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72472 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72483 */     GIR_RootConstrainSelectedInstOperands,
     /*  72484 */     // GIR_Coverage, 13442,
     /*  72484 */     GIR_EraseRootFromParent_Done,
     /*  72485 */   // Label 1177: @72485
     /*  72485 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72549), // Rule ID 1602 //
     /*  72490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72526 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72536 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72547 */     GIR_RootConstrainSelectedInstOperands,
     /*  72548 */     // GIR_Coverage, 1602,
     /*  72548 */     GIR_EraseRootFromParent_Done,
     /*  72549 */   // Label 1178: @72549
     /*  72549 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72576), // Rule ID 1604 //
     /*  72554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72569 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72574 */     GIR_RootConstrainSelectedInstOperands,
     /*  72575 */     // GIR_Coverage, 1604,
     /*  72575 */     GIR_Done,
     /*  72576 */   // Label 1179: @72576
     /*  72576 */   GIM_Reject,
     /*  72577 */ // Label 1164: @72577
     /*  72577 */ GIM_Reject,
     /*  72578 */ // Label 1023: @72578
     /*  72578 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72609), // Rule ID 8502 //
     /*  72583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  72589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  72592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72596 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  72596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72601 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72603 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72605 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72607 */   GIR_RootConstrainSelectedInstOperands,
     /*  72608 */   // GIR_Coverage, 8502,
     /*  72608 */   GIR_EraseRootFromParent_Done,
     /*  72609 */ // Label 1180: @72609
     /*  72609 */ GIM_Reject,
     /*  72610 */ // Label 1024: @72610
     /*  72610 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72641), // Rule ID 8501 //
     /*  72615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  72621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  72624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72628 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  72628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72633 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72635 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72637 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72639 */   GIR_RootConstrainSelectedInstOperands,
     /*  72640 */   // GIR_Coverage, 8501,
     /*  72640 */   GIR_EraseRootFromParent_Done,
     /*  72641 */ // Label 1181: @72641
     /*  72641 */ GIM_Reject,
     /*  72642 */ // Label 1025: @72642
     /*  72642 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(76001),
     /*  72647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72657 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72775), // Rule ID 15807 //
     /*  72662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72701 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72707 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72709 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72713 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72717 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72721 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72725 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72729 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72737 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72741 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72745 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72749 */     // MIs[6] Op3
     /*  72749 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  72754 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72756 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  72765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  72769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  72773 */     GIR_RootConstrainSelectedInstOperands,
     /*  72774 */     // GIR_Coverage, 15807,
     /*  72774 */     GIR_EraseRootFromParent_Done,
     /*  72775 */   // Label 1183: @72775
     /*  72775 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72893), // Rule ID 15809 //
     /*  72780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72819 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72825 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72835 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72839 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72843 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72847 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72853 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72855 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72859 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72863 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72867 */     // MIs[6] Op3
     /*  72867 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72872 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72874 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  72883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  72887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  72891 */     GIR_RootConstrainSelectedInstOperands,
     /*  72892 */     // GIR_Coverage, 15809,
     /*  72892 */     GIR_EraseRootFromParent_Done,
     /*  72893 */   // Label 1184: @72893
     /*  72893 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73011), // Rule ID 15806 //
     /*  72898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72937 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72943 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72945 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72949 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72953 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72957 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72961 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72965 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72971 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72973 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72977 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72981 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72985 */     // MIs[6] Op3
     /*  72985 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  72990 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72992 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  73001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  73005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  73009 */     GIR_RootConstrainSelectedInstOperands,
     /*  73010 */     // GIR_Coverage, 15806,
     /*  73010 */     GIR_EraseRootFromParent_Done,
     /*  73011 */   // Label 1185: @73011
     /*  73011 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73129), // Rule ID 15808 //
     /*  73016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73055 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73061 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  73067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73071 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73075 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73079 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73083 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  73091 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  73095 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73099 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73103 */     // MIs[6] Op3
     /*  73103 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73108 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73110 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  73113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  73119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  73123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73127 */     GIR_RootConstrainSelectedInstOperands,
     /*  73128 */     // GIR_Coverage, 15808,
     /*  73128 */     GIR_EraseRootFromParent_Done,
     /*  73129 */   // Label 1186: @73129
     /*  73129 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73247), // Rule ID 15754 //
     /*  73134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73173 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73179 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73181 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73185 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73189 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73193 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73197 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73201 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73205 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73209 */     // MIs[5] Op3
     /*  73209 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73214 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73218 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73226 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73228 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  73241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  73245 */     GIR_RootConstrainSelectedInstOperands,
     /*  73246 */     // GIR_Coverage, 15754,
     /*  73246 */     GIR_EraseRootFromParent_Done,
     /*  73247 */   // Label 1187: @73247
     /*  73247 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73365), // Rule ID 15759 //
     /*  73252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73291 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73307 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73311 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73315 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73319 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73323 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73327 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73331 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73339 */     // MIs[4] Op3
     /*  73339 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73344 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73346 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73363 */     GIR_RootConstrainSelectedInstOperands,
     /*  73364 */     // GIR_Coverage, 15759,
     /*  73364 */     GIR_EraseRootFromParent_Done,
     /*  73365 */   // Label 1188: @73365
     /*  73365 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73483), // Rule ID 15760 //
     /*  73370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73409 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73417 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73421 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73425 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73429 */     // MIs[4] Op3
     /*  73429 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73434 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73438 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73442 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73446 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73450 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73454 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73462 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73464 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73481 */     GIR_RootConstrainSelectedInstOperands,
     /*  73482 */     // GIR_Coverage, 15760,
     /*  73482 */     GIR_EraseRootFromParent_Done,
     /*  73483 */   // Label 1189: @73483
     /*  73483 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73601), // Rule ID 11950 //
     /*  73488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73527 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73535 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73539 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73543 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73547 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73551 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73555 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73559 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73563 */     // MIs[5] Op3
     /*  73563 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73568 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73572 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73578 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73580 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73582 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  73595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  73599 */     GIR_RootConstrainSelectedInstOperands,
     /*  73600 */     // GIR_Coverage, 11950,
     /*  73600 */     GIR_EraseRootFromParent_Done,
     /*  73601 */   // Label 1190: @73601
     /*  73601 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73719), // Rule ID 15756 //
     /*  73606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73645 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73653 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73657 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73661 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73665 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73669 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73673 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73677 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73681 */     // MIs[5] Op3
     /*  73681 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73686 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73690 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73696 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73698 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73700 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  73713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  73717 */     GIR_RootConstrainSelectedInstOperands,
     /*  73718 */     // GIR_Coverage, 15756,
     /*  73718 */     GIR_EraseRootFromParent_Done,
     /*  73719 */   // Label 1191: @73719
     /*  73719 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73837), // Rule ID 15757 //
     /*  73724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73763 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73771 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73775 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73779 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73783 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73787 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73791 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73795 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73799 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73803 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73811 */     // MIs[4] Op3
     /*  73811 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73816 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73818 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73835 */     GIR_RootConstrainSelectedInstOperands,
     /*  73836 */     // GIR_Coverage, 15757,
     /*  73836 */     GIR_EraseRootFromParent_Done,
     /*  73837 */   // Label 1192: @73837
     /*  73837 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(73955), // Rule ID 15758 //
     /*  73842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73881 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73887 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73893 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73897 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73901 */     // MIs[4] Op3
     /*  73901 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73906 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73910 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73914 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73918 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73922 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73926 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73932 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73934 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73936 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73953 */     GIR_RootConstrainSelectedInstOperands,
     /*  73954 */     // GIR_Coverage, 15758,
     /*  73954 */     GIR_EraseRootFromParent_Done,
     /*  73955 */   // Label 1193: @73955
     /*  73955 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74073), // Rule ID 15755 //
     /*  73960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73999 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74015 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74019 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74023 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74027 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74031 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74035 */     // MIs[5] Op3
     /*  74035 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74040 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74044 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74050 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74052 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74054 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  74063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74071 */     GIR_RootConstrainSelectedInstOperands,
     /*  74072 */     // GIR_Coverage, 15755,
     /*  74072 */     GIR_EraseRootFromParent_Done,
     /*  74073 */   // Label 1194: @74073
     /*  74073 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74191), // Rule ID 15803 //
     /*  74078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74121 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74125 */     // MIs[3] Op3
     /*  74125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74134 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74142 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74146 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74150 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74154 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74158 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74162 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74170 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74172 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  74185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74189 */     GIR_RootConstrainSelectedInstOperands,
     /*  74190 */     // GIR_Coverage, 15803,
     /*  74190 */     GIR_EraseRootFromParent_Done,
     /*  74191 */   // Label 1195: @74191
     /*  74191 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74309), // Rule ID 15805 //
     /*  74196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74243 */     // MIs[3] Op3
     /*  74243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74260 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74264 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74268 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74272 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74276 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74280 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74286 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74288 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74290 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  74303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74307 */     GIR_RootConstrainSelectedInstOperands,
     /*  74308 */     // GIR_Coverage, 15805,
     /*  74308 */     GIR_EraseRootFromParent_Done,
     /*  74309 */   // Label 1196: @74309
     /*  74309 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74427), // Rule ID 11961 //
     /*  74314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74361 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74365 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74369 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74375 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74377 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74381 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74385 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74389 */     // MIs[5] Op3
     /*  74389 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74394 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74398 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74406 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74408 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  74421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74425 */     GIR_RootConstrainSelectedInstOperands,
     /*  74426 */     // GIR_Coverage, 11961,
     /*  74426 */     GIR_EraseRootFromParent_Done,
     /*  74427 */   // Label 1197: @74427
     /*  74427 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74545), // Rule ID 15804 //
     /*  74432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74487 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74493 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74495 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74499 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74503 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74507 */     // MIs[5] Op3
     /*  74507 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74512 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74516 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74524 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74526 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  74539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74543 */     GIR_RootConstrainSelectedInstOperands,
     /*  74544 */     // GIR_Coverage, 15804,
     /*  74544 */     GIR_EraseRootFromParent_Done,
     /*  74545 */   // Label 1198: @74545
     /*  74545 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74635), // Rule ID 15732 //
     /*  74550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74589 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74597 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74601 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74605 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74609 */     // MIs[4] Op3
     /*  74609 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74616 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  74625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74633 */     GIR_RootConstrainSelectedInstOperands,
     /*  74634 */     // GIR_Coverage, 15732,
     /*  74634 */     GIR_EraseRootFromParent_Done,
     /*  74635 */   // Label 1199: @74635
     /*  74635 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74725), // Rule ID 15731 //
     /*  74640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74679 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74699 */     // MIs[4] Op3
     /*  74699 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74706 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  74715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74723 */     GIR_RootConstrainSelectedInstOperands,
     /*  74724 */     // GIR_Coverage, 15731,
     /*  74724 */     GIR_EraseRootFromParent_Done,
     /*  74725 */   // Label 1200: @74725
     /*  74725 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74815), // Rule ID 15730 //
     /*  74730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74769 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74789 */     // MIs[4] Op3
     /*  74789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74794 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74796 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  74805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74813 */     GIR_RootConstrainSelectedInstOperands,
     /*  74814 */     // GIR_Coverage, 15730,
     /*  74814 */     GIR_EraseRootFromParent_Done,
     /*  74815 */   // Label 1201: @74815
     /*  74815 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74905), // Rule ID 15729 //
     /*  74820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74859 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74867 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74871 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74875 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74879 */     // MIs[4] Op3
     /*  74879 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74886 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  74895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74903 */     GIR_RootConstrainSelectedInstOperands,
     /*  74904 */     // GIR_Coverage, 15729,
     /*  74904 */     GIR_EraseRootFromParent_Done,
     /*  74905 */   // Label 1202: @74905
     /*  74905 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74995), // Rule ID 15726 //
     /*  74910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74953 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74957 */     // MIs[3] Op3
     /*  74957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74966 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74972 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74976 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  74989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74993 */     GIR_RootConstrainSelectedInstOperands,
     /*  74994 */     // GIR_Coverage, 15726,
     /*  74994 */     GIR_EraseRootFromParent_Done,
     /*  74995 */   // Label 1203: @74995
     /*  74995 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(75085), // Rule ID 15728 //
     /*  75000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75043 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75047 */     // MIs[3] Op3
     /*  75047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75052 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75056 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75062 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75064 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75066 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75083 */     GIR_RootConstrainSelectedInstOperands,
     /*  75084 */     // GIR_Coverage, 15728,
     /*  75084 */     GIR_EraseRootFromParent_Done,
     /*  75085 */   // Label 1204: @75085
     /*  75085 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75175), // Rule ID 11942 //
     /*  75090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75133 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75137 */     // MIs[3] Op3
     /*  75137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75142 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75146 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75154 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75156 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75173 */     GIR_RootConstrainSelectedInstOperands,
     /*  75174 */     // GIR_Coverage, 11942,
     /*  75174 */     GIR_EraseRootFromParent_Done,
     /*  75175 */   // Label 1205: @75175
     /*  75175 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75265), // Rule ID 15727 //
     /*  75180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75223 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75227 */     // MIs[3] Op3
     /*  75227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75236 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75242 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75244 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75246 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75263 */     GIR_RootConstrainSelectedInstOperands,
     /*  75264 */     // GIR_Coverage, 15727,
     /*  75264 */     GIR_EraseRootFromParent_Done,
     /*  75265 */   // Label 1206: @75265
     /*  75265 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(75355), // Rule ID 15810 //
     /*  75270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75313 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75317 */     // MIs[3] Op3
     /*  75317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75326 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75334 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75336 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  75349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75353 */     GIR_RootConstrainSelectedInstOperands,
     /*  75354 */     // GIR_Coverage, 15810,
     /*  75354 */     GIR_EraseRootFromParent_Done,
     /*  75355 */   // Label 1207: @75355
     /*  75355 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75445), // Rule ID 15812 //
     /*  75360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75407 */     // MIs[3] Op3
     /*  75407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75416 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75422 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75424 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75426 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  75439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75443 */     GIR_RootConstrainSelectedInstOperands,
     /*  75444 */     // GIR_Coverage, 15812,
     /*  75444 */     GIR_EraseRootFromParent_Done,
     /*  75445 */   // Label 1208: @75445
     /*  75445 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75535), // Rule ID 11962 //
     /*  75450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75493 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75497 */     // MIs[3] Op3
     /*  75497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75506 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75514 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75516 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75533 */     GIR_RootConstrainSelectedInstOperands,
     /*  75534 */     // GIR_Coverage, 11962,
     /*  75534 */     GIR_EraseRootFromParent_Done,
     /*  75535 */   // Label 1209: @75535
     /*  75535 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75625), // Rule ID 15811 //
     /*  75540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75583 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75587 */     // MIs[3] Op3
     /*  75587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75596 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75602 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75606 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75623 */     GIR_RootConstrainSelectedInstOperands,
     /*  75624 */     // GIR_Coverage, 15811,
     /*  75624 */     GIR_EraseRootFromParent_Done,
     /*  75625 */   // Label 1210: @75625
     /*  75625 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75715), // Rule ID 15814 //
     /*  75630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75669 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75677 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75681 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75685 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75689 */     // MIs[4] Op3
     /*  75689 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  75694 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75696 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  75705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  75713 */     GIR_RootConstrainSelectedInstOperands,
     /*  75714 */     // GIR_Coverage, 15814,
     /*  75714 */     GIR_EraseRootFromParent_Done,
     /*  75715 */   // Label 1211: @75715
     /*  75715 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75805), // Rule ID 15816 //
     /*  75720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75759 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75765 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75767 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75771 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75775 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75779 */     // MIs[4] Op3
     /*  75779 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75784 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75786 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  75795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75803 */     GIR_RootConstrainSelectedInstOperands,
     /*  75804 */     // GIR_Coverage, 15816,
     /*  75804 */     GIR_EraseRootFromParent_Done,
     /*  75805 */   // Label 1212: @75805
     /*  75805 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75895), // Rule ID 15813 //
     /*  75810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75849 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75857 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75861 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75865 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75869 */     // MIs[4] Op3
     /*  75869 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  75874 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75876 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  75885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  75893 */     GIR_RootConstrainSelectedInstOperands,
     /*  75894 */     // GIR_Coverage, 15813,
     /*  75894 */     GIR_EraseRootFromParent_Done,
     /*  75895 */   // Label 1213: @75895
     /*  75895 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75985), // Rule ID 15815 //
     /*  75900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75939 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75945 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75955 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75959 */     // MIs[4] Op3
     /*  75959 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75964 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75966 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  75975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75983 */     GIR_RootConstrainSelectedInstOperands,
     /*  75984 */     // GIR_Coverage, 15815,
     /*  75984 */     GIR_EraseRootFromParent_Done,
     /*  75985 */   // Label 1214: @75985
     /*  75985 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(76000), // Rule ID 7507 //
     /*  75990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75993 */     // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  75993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  75998 */     GIR_RootConstrainSelectedInstOperands,
     /*  75999 */     // GIR_Coverage, 7507,
     /*  75999 */     GIR_Done,
     /*  76000 */   // Label 1215: @76000
     /*  76000 */   GIM_Reject,
     /*  76001 */ // Label 1182: @76001
     /*  76001 */ GIM_Reject,
     /*  76002 */ // Label 1026: @76002
     /*  76002 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(76033), // Rule ID 8500 //
     /*  76007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  76010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  76013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  76016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  76020 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  76020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  76023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  76025 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76027 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76029 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  76031 */   GIR_RootConstrainSelectedInstOperands,
     /*  76032 */   // GIR_Coverage, 8500,
     /*  76032 */   GIR_EraseRootFromParent_Done,
     /*  76033 */ // Label 1216: @76033
     /*  76033 */ GIM_Reject,
     /*  76034 */ // Label 1027: @76034
     /*  76034 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(79393),
     /*  76039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  76049 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(76167), // Rule ID 15793 //
     /*  76054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76093 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76099 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76101 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76105 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76109 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76113 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76117 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76121 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76127 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76129 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76133 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76137 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76141 */     // MIs[6] Op3
     /*  76141 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  76146 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76148 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  76157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  76165 */     GIR_RootConstrainSelectedInstOperands,
     /*  76166 */     // GIR_Coverage, 15793,
     /*  76166 */     GIR_EraseRootFromParent_Done,
     /*  76167 */   // Label 1218: @76167
     /*  76167 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(76285), // Rule ID 15795 //
     /*  76172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76211 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76219 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76223 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76227 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76231 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76235 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76239 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76247 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76251 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76255 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76259 */     // MIs[6] Op3
     /*  76259 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76264 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76266 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  76275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76283 */     GIR_RootConstrainSelectedInstOperands,
     /*  76284 */     // GIR_Coverage, 15795,
     /*  76284 */     GIR_EraseRootFromParent_Done,
     /*  76285 */   // Label 1219: @76285
     /*  76285 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76403), // Rule ID 15792 //
     /*  76290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76329 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76335 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76337 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76341 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76345 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76349 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76353 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76357 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76365 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76369 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76373 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76377 */     // MIs[6] Op3
     /*  76377 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  76382 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76384 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  76393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  76401 */     GIR_RootConstrainSelectedInstOperands,
     /*  76402 */     // GIR_Coverage, 15792,
     /*  76402 */     GIR_EraseRootFromParent_Done,
     /*  76403 */   // Label 1220: @76403
     /*  76403 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76521), // Rule ID 15794 //
     /*  76408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76447 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76453 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76459 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76463 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76467 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76471 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76475 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76483 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76487 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76491 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76495 */     // MIs[6] Op3
     /*  76495 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76500 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76502 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  76511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76519 */     GIR_RootConstrainSelectedInstOperands,
     /*  76520 */     // GIR_Coverage, 15794,
     /*  76520 */     GIR_EraseRootFromParent_Done,
     /*  76521 */   // Label 1221: @76521
     /*  76521 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76639), // Rule ID 15747 //
     /*  76526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76565 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76571 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76573 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76577 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76581 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76585 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76589 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  76593 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76597 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76601 */     // MIs[5] Op3
     /*  76601 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76606 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76610 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76618 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76620 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  76629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  76633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76637 */     GIR_RootConstrainSelectedInstOperands,
     /*  76638 */     // GIR_Coverage, 15747,
     /*  76638 */     GIR_EraseRootFromParent_Done,
     /*  76639 */   // Label 1222: @76639
     /*  76639 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76757), // Rule ID 15752 //
     /*  76644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76683 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76689 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76691 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76695 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76699 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76703 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  76707 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76711 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76715 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76719 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76723 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76731 */     // MIs[4] Op3
     /*  76731 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76736 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76738 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  76747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76755 */     GIR_RootConstrainSelectedInstOperands,
     /*  76756 */     // GIR_Coverage, 15752,
     /*  76756 */     GIR_EraseRootFromParent_Done,
     /*  76757 */   // Label 1223: @76757
     /*  76757 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76875), // Rule ID 15753 //
     /*  76762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76801 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76807 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76809 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76813 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76817 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76821 */     // MIs[4] Op3
     /*  76821 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76826 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76830 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76834 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76838 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76842 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76846 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76852 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76854 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76856 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  76865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76873 */     GIR_RootConstrainSelectedInstOperands,
     /*  76874 */     // GIR_Coverage, 15753,
     /*  76874 */     GIR_EraseRootFromParent_Done,
     /*  76875 */   // Label 1224: @76875
     /*  76875 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(76993), // Rule ID 11948 //
     /*  76880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76919 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76925 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76927 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76931 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76935 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76939 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76943 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76947 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76951 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76955 */     // MIs[5] Op3
     /*  76955 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76960 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76964 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76972 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76974 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  76983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76991 */     GIR_RootConstrainSelectedInstOperands,
     /*  76992 */     // GIR_Coverage, 11948,
     /*  76992 */     GIR_EraseRootFromParent_Done,
     /*  76993 */   // Label 1225: @76993
     /*  76993 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(77111), // Rule ID 15749 //
     /*  76998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77037 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77045 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77049 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77053 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77057 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77061 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  77065 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77069 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77073 */     // MIs[5] Op3
     /*  77073 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77078 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77082 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77090 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77092 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  77101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  77105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77109 */     GIR_RootConstrainSelectedInstOperands,
     /*  77110 */     // GIR_Coverage, 15749,
     /*  77110 */     GIR_EraseRootFromParent_Done,
     /*  77111 */   // Label 1226: @77111
     /*  77111 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(77229), // Rule ID 15750 //
     /*  77116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77155 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77161 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77167 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77171 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77175 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  77179 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77183 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77187 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77191 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77195 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77201 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77203 */     // MIs[4] Op3
     /*  77203 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77208 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77210 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  77219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77227 */     GIR_RootConstrainSelectedInstOperands,
     /*  77228 */     // GIR_Coverage, 15750,
     /*  77228 */     GIR_EraseRootFromParent_Done,
     /*  77229 */   // Label 1227: @77229
     /*  77229 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(77347), // Rule ID 15751 //
     /*  77234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77273 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77293 */     // MIs[4] Op3
     /*  77293 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77298 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77302 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77306 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77310 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77314 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77318 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77326 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77328 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  77337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77345 */     GIR_RootConstrainSelectedInstOperands,
     /*  77346 */     // GIR_Coverage, 15751,
     /*  77346 */     GIR_EraseRootFromParent_Done,
     /*  77347 */   // Label 1228: @77347
     /*  77347 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77465), // Rule ID 15748 //
     /*  77352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77391 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77399 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77403 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77407 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77411 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77415 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77419 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77423 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77427 */     // MIs[5] Op3
     /*  77427 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77432 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77436 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77442 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77444 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77446 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  77455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77463 */     GIR_RootConstrainSelectedInstOperands,
     /*  77464 */     // GIR_Coverage, 15748,
     /*  77464 */     GIR_EraseRootFromParent_Done,
     /*  77465 */   // Label 1229: @77465
     /*  77465 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(77583), // Rule ID 15789 //
     /*  77470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77517 */     // MIs[3] Op3
     /*  77517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  77522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77526 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77534 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77538 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77542 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77546 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77550 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77554 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77560 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77562 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77564 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  77577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77581 */     GIR_RootConstrainSelectedInstOperands,
     /*  77582 */     // GIR_Coverage, 15789,
     /*  77582 */     GIR_EraseRootFromParent_Done,
     /*  77583 */   // Label 1230: @77583
     /*  77583 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(77701), // Rule ID 15791 //
     /*  77588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77631 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77635 */     // MIs[3] Op3
     /*  77635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77640 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77644 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77652 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77656 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77660 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77664 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77668 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77672 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77678 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77680 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77682 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  77695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77699 */     GIR_RootConstrainSelectedInstOperands,
     /*  77700 */     // GIR_Coverage, 15791,
     /*  77700 */     GIR_EraseRootFromParent_Done,
     /*  77701 */   // Label 1231: @77701
     /*  77701 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(77819), // Rule ID 11958 //
     /*  77706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77749 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77753 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77757 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77761 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77767 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77769 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77773 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77777 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77781 */     // MIs[5] Op3
     /*  77781 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  77786 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77790 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77798 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77800 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77817 */     GIR_RootConstrainSelectedInstOperands,
     /*  77818 */     // GIR_Coverage, 11958,
     /*  77818 */     GIR_EraseRootFromParent_Done,
     /*  77819 */   // Label 1232: @77819
     /*  77819 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(77937), // Rule ID 15790 //
     /*  77824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77867 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77871 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77887 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77891 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77895 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77899 */     // MIs[5] Op3
     /*  77899 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77904 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77908 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77916 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77918 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77935 */     GIR_RootConstrainSelectedInstOperands,
     /*  77936 */     // GIR_Coverage, 15790,
     /*  77936 */     GIR_EraseRootFromParent_Done,
     /*  77937 */   // Label 1233: @77937
     /*  77937 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(78027), // Rule ID 15725 //
     /*  77942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77981 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77987 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77989 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77993 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77997 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78001 */     // MIs[4] Op3
     /*  78001 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78006 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78008 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  78017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78025 */     GIR_RootConstrainSelectedInstOperands,
     /*  78026 */     // GIR_Coverage, 15725,
     /*  78026 */     GIR_EraseRootFromParent_Done,
     /*  78027 */   // Label 1234: @78027
     /*  78027 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(78117), // Rule ID 15724 //
     /*  78032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78071 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78077 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78079 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78083 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78087 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78091 */     // MIs[4] Op3
     /*  78091 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78096 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78098 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  78107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78115 */     GIR_RootConstrainSelectedInstOperands,
     /*  78116 */     // GIR_Coverage, 15724,
     /*  78116 */     GIR_EraseRootFromParent_Done,
     /*  78117 */   // Label 1235: @78117
     /*  78117 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(78207), // Rule ID 15723 //
     /*  78122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78161 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78167 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78177 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78181 */     // MIs[4] Op3
     /*  78181 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78186 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78188 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  78197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78205 */     GIR_RootConstrainSelectedInstOperands,
     /*  78206 */     // GIR_Coverage, 15723,
     /*  78206 */     GIR_EraseRootFromParent_Done,
     /*  78207 */   // Label 1236: @78207
     /*  78207 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(78297), // Rule ID 15722 //
     /*  78212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78251 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78257 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78259 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78263 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78267 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78271 */     // MIs[4] Op3
     /*  78271 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78276 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78278 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  78287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78295 */     GIR_RootConstrainSelectedInstOperands,
     /*  78296 */     // GIR_Coverage, 15722,
     /*  78296 */     GIR_EraseRootFromParent_Done,
     /*  78297 */   // Label 1237: @78297
     /*  78297 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(78387), // Rule ID 15719 //
     /*  78302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78345 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78349 */     // MIs[3] Op3
     /*  78349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78358 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78366 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78368 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  78381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78385 */     GIR_RootConstrainSelectedInstOperands,
     /*  78386 */     // GIR_Coverage, 15719,
     /*  78386 */     GIR_EraseRootFromParent_Done,
     /*  78387 */   // Label 1238: @78387
     /*  78387 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(78477), // Rule ID 15721 //
     /*  78392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78439 */     // MIs[3] Op3
     /*  78439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78448 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78454 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78458 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  78471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78475 */     GIR_RootConstrainSelectedInstOperands,
     /*  78476 */     // GIR_Coverage, 15721,
     /*  78476 */     GIR_EraseRootFromParent_Done,
     /*  78477 */   // Label 1239: @78477
     /*  78477 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(78567), // Rule ID 11940 //
     /*  78482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78525 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78529 */     // MIs[3] Op3
     /*  78529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78534 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78538 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78544 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78548 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  78561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78565 */     GIR_RootConstrainSelectedInstOperands,
     /*  78566 */     // GIR_Coverage, 11940,
     /*  78566 */     GIR_EraseRootFromParent_Done,
     /*  78567 */   // Label 1240: @78567
     /*  78567 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(78657), // Rule ID 15720 //
     /*  78572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78615 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78619 */     // MIs[3] Op3
     /*  78619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78624 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78628 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78638 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  78651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78655 */     GIR_RootConstrainSelectedInstOperands,
     /*  78656 */     // GIR_Coverage, 15720,
     /*  78656 */     GIR_EraseRootFromParent_Done,
     /*  78657 */   // Label 1241: @78657
     /*  78657 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(78747), // Rule ID 15796 //
     /*  78662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78705 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78709 */     // MIs[3] Op3
     /*  78709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78718 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78726 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78728 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  78741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78745 */     GIR_RootConstrainSelectedInstOperands,
     /*  78746 */     // GIR_Coverage, 15796,
     /*  78746 */     GIR_EraseRootFromParent_Done,
     /*  78747 */   // Label 1242: @78747
     /*  78747 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(78837), // Rule ID 15798 //
     /*  78752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78795 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78799 */     // MIs[3] Op3
     /*  78799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78808 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78816 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78818 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  78831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78835 */     GIR_RootConstrainSelectedInstOperands,
     /*  78836 */     // GIR_Coverage, 15798,
     /*  78836 */     GIR_EraseRootFromParent_Done,
     /*  78837 */   // Label 1243: @78837
     /*  78837 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(78927), // Rule ID 11959 //
     /*  78842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78885 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78889 */     // MIs[3] Op3
     /*  78889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78894 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78898 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78904 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78906 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78908 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  78921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78925 */     GIR_RootConstrainSelectedInstOperands,
     /*  78926 */     // GIR_Coverage, 11959,
     /*  78926 */     GIR_EraseRootFromParent_Done,
     /*  78927 */   // Label 1244: @78927
     /*  78927 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(79017), // Rule ID 15797 //
     /*  78932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78979 */     // MIs[3] Op3
     /*  78979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78998 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79015 */     GIR_RootConstrainSelectedInstOperands,
     /*  79016 */     // GIR_Coverage, 15797,
     /*  79016 */     GIR_EraseRootFromParent_Done,
     /*  79017 */   // Label 1245: @79017
     /*  79017 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(79107), // Rule ID 15800 //
     /*  79022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79061 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79067 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79073 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79077 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79081 */     // MIs[4] Op3
     /*  79081 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  79086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79088 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  79105 */     GIR_RootConstrainSelectedInstOperands,
     /*  79106 */     // GIR_Coverage, 15800,
     /*  79106 */     GIR_EraseRootFromParent_Done,
     /*  79107 */   // Label 1246: @79107
     /*  79107 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(79197), // Rule ID 15802 //
     /*  79112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79151 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79159 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79163 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79167 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79171 */     // MIs[4] Op3
     /*  79171 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79176 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79178 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79195 */     GIR_RootConstrainSelectedInstOperands,
     /*  79196 */     // GIR_Coverage, 15802,
     /*  79196 */     GIR_EraseRootFromParent_Done,
     /*  79197 */   // Label 1247: @79197
     /*  79197 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(79287), // Rule ID 15799 //
     /*  79202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79241 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79249 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79253 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79257 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79261 */     // MIs[4] Op3
     /*  79261 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  79266 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79268 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  79285 */     GIR_RootConstrainSelectedInstOperands,
     /*  79286 */     // GIR_Coverage, 15799,
     /*  79286 */     GIR_EraseRootFromParent_Done,
     /*  79287 */   // Label 1248: @79287
     /*  79287 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(79377), // Rule ID 15801 //
     /*  79292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79331 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79351 */     // MIs[4] Op3
     /*  79351 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79356 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79358 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79375 */     GIR_RootConstrainSelectedInstOperands,
     /*  79376 */     // GIR_Coverage, 15801,
     /*  79376 */     GIR_EraseRootFromParent_Done,
     /*  79377 */   // Label 1249: @79377
     /*  79377 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(79392), // Rule ID 7506 //
     /*  79382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79385 */     // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  79385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  79390 */     GIR_RootConstrainSelectedInstOperands,
     /*  79391 */     // GIR_Coverage, 7506,
     /*  79391 */     GIR_Done,
     /*  79392 */   // Label 1250: @79392
     /*  79392 */   GIM_Reject,
     /*  79393 */ // Label 1217: @79393
     /*  79393 */ GIM_Reject,
     /*  79394 */ // Label 1028: @79394
     /*  79394 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(79425), // Rule ID 8499 //
     /*  79399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  79405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  79408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79412 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  79412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  79415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79417 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79419 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79421 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79423 */   GIR_RootConstrainSelectedInstOperands,
     /*  79424 */   // GIR_Coverage, 8499,
     /*  79424 */   GIR_EraseRootFromParent_Done,
     /*  79425 */ // Label 1251: @79425
     /*  79425 */ GIM_Reject,
     /*  79426 */ // Label 1029: @79426
     /*  79426 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(82785),
     /*  79431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79441 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(79559), // Rule ID 15779 //
     /*  79446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79485 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79491 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79493 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79497 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79501 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79505 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79509 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79513 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79521 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79525 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79529 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79533 */     // MIs[6] Op3
     /*  79533 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  79538 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79540 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  79549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  79557 */     GIR_RootConstrainSelectedInstOperands,
     /*  79558 */     // GIR_Coverage, 15779,
     /*  79558 */     GIR_EraseRootFromParent_Done,
     /*  79559 */   // Label 1253: @79559
     /*  79559 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(79677), // Rule ID 15781 //
     /*  79564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79603 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79609 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79619 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79623 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79627 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79631 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79637 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79639 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79643 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79647 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79651 */     // MIs[6] Op3
     /*  79651 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79656 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79658 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  79667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  79671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79675 */     GIR_RootConstrainSelectedInstOperands,
     /*  79676 */     // GIR_Coverage, 15781,
     /*  79676 */     GIR_EraseRootFromParent_Done,
     /*  79677 */   // Label 1254: @79677
     /*  79677 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(79795), // Rule ID 15778 //
     /*  79682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79721 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79729 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79733 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79737 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79741 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79745 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79749 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79755 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79757 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79761 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79765 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79769 */     // MIs[6] Op3
     /*  79769 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  79774 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79776 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  79785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  79793 */     GIR_RootConstrainSelectedInstOperands,
     /*  79794 */     // GIR_Coverage, 15778,
     /*  79794 */     GIR_EraseRootFromParent_Done,
     /*  79795 */   // Label 1255: @79795
     /*  79795 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(79913), // Rule ID 15780 //
     /*  79800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79839 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79847 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79851 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79855 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79859 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79863 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79867 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79873 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79875 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79879 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79883 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79887 */     // MIs[6] Op3
     /*  79887 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79892 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79894 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  79903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  79907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79911 */     GIR_RootConstrainSelectedInstOperands,
     /*  79912 */     // GIR_Coverage, 15780,
     /*  79912 */     GIR_EraseRootFromParent_Done,
     /*  79913 */   // Label 1256: @79913
     /*  79913 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(80031), // Rule ID 15740 //
     /*  79918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79957 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79963 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79965 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79969 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79973 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79977 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79981 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  79985 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79989 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79993 */     // MIs[5] Op3
     /*  79993 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79998 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80002 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80008 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80010 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80012 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  80025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80029 */     GIR_RootConstrainSelectedInstOperands,
     /*  80030 */     // GIR_Coverage, 15740,
     /*  80030 */     GIR_EraseRootFromParent_Done,
     /*  80031 */   // Label 1257: @80031
     /*  80031 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(80149), // Rule ID 15745 //
     /*  80036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80083 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80087 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80091 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80095 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80099 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80103 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80107 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80111 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80115 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80123 */     // MIs[4] Op3
     /*  80123 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80128 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80130 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  80143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80147 */     GIR_RootConstrainSelectedInstOperands,
     /*  80148 */     // GIR_Coverage, 15745,
     /*  80148 */     GIR_EraseRootFromParent_Done,
     /*  80149 */   // Label 1258: @80149
     /*  80149 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(80267), // Rule ID 15746 //
     /*  80154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80193 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80199 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80201 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80205 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80209 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80213 */     // MIs[4] Op3
     /*  80213 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80218 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80222 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80226 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80230 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80234 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80238 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80246 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80248 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  80261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80265 */     GIR_RootConstrainSelectedInstOperands,
     /*  80266 */     // GIR_Coverage, 15746,
     /*  80266 */     GIR_EraseRootFromParent_Done,
     /*  80267 */   // Label 1259: @80267
     /*  80267 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(80385), // Rule ID 11946 //
     /*  80272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80311 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80319 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80323 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80327 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80331 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80335 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80339 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80343 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80347 */     // MIs[5] Op3
     /*  80347 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80352 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80356 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80364 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80366 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  80379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80383 */     GIR_RootConstrainSelectedInstOperands,
     /*  80384 */     // GIR_Coverage, 11946,
     /*  80384 */     GIR_EraseRootFromParent_Done,
     /*  80385 */   // Label 1260: @80385
     /*  80385 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(80503), // Rule ID 15742 //
     /*  80390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80429 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80435 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80437 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80441 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80445 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80449 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80453 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80457 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80461 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80465 */     // MIs[5] Op3
     /*  80465 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80470 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80474 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80480 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80482 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80484 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  80497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80501 */     GIR_RootConstrainSelectedInstOperands,
     /*  80502 */     // GIR_Coverage, 15742,
     /*  80502 */     GIR_EraseRootFromParent_Done,
     /*  80503 */   // Label 1261: @80503
     /*  80503 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(80621), // Rule ID 15743 //
     /*  80508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80547 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80553 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80555 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80559 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80563 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80567 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80571 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80575 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80579 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80583 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80587 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80595 */     // MIs[4] Op3
     /*  80595 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80600 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80602 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  80615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80619 */     GIR_RootConstrainSelectedInstOperands,
     /*  80620 */     // GIR_Coverage, 15743,
     /*  80620 */     GIR_EraseRootFromParent_Done,
     /*  80621 */   // Label 1262: @80621
     /*  80621 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(80739), // Rule ID 15744 //
     /*  80626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80665 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80671 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80673 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80677 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80681 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80685 */     // MIs[4] Op3
     /*  80685 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80690 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80694 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80698 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80702 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80706 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80710 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80718 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80720 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  80733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80737 */     GIR_RootConstrainSelectedInstOperands,
     /*  80738 */     // GIR_Coverage, 15744,
     /*  80738 */     GIR_EraseRootFromParent_Done,
     /*  80739 */   // Label 1263: @80739
     /*  80739 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(80857), // Rule ID 15741 //
     /*  80744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80783 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80791 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80795 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80799 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80803 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80807 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80811 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80815 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80819 */     // MIs[5] Op3
     /*  80819 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80824 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80828 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80836 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80838 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  80851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80855 */     GIR_RootConstrainSelectedInstOperands,
     /*  80856 */     // GIR_Coverage, 15741,
     /*  80856 */     GIR_EraseRootFromParent_Done,
     /*  80857 */   // Label 1264: @80857
     /*  80857 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(80975), // Rule ID 15775 //
     /*  80862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80905 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80909 */     // MIs[3] Op3
     /*  80909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80914 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80918 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80926 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  80930 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80934 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80938 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80942 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80946 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80952 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80954 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80956 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  80969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80973 */     GIR_RootConstrainSelectedInstOperands,
     /*  80974 */     // GIR_Coverage, 15775,
     /*  80974 */     GIR_EraseRootFromParent_Done,
     /*  80975 */   // Label 1265: @80975
     /*  80975 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(81093), // Rule ID 15777 //
     /*  80980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81027 */     // MIs[3] Op3
     /*  81027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81036 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81042 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81044 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81048 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81052 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81056 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81060 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81064 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81072 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81074 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  81087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81091 */     GIR_RootConstrainSelectedInstOperands,
     /*  81092 */     // GIR_Coverage, 15777,
     /*  81092 */     GIR_EraseRootFromParent_Done,
     /*  81093 */   // Label 1266: @81093
     /*  81093 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(81211), // Rule ID 11955 //
     /*  81098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81141 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81145 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81149 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81153 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81159 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81161 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81165 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81169 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81173 */     // MIs[5] Op3
     /*  81173 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81178 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81182 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81190 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81192 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  81205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81209 */     GIR_RootConstrainSelectedInstOperands,
     /*  81210 */     // GIR_Coverage, 11955,
     /*  81210 */     GIR_EraseRootFromParent_Done,
     /*  81211 */   // Label 1267: @81211
     /*  81211 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(81329), // Rule ID 15776 //
     /*  81216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81267 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81271 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81277 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81279 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81283 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81287 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81291 */     // MIs[5] Op3
     /*  81291 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81296 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81300 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81306 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81308 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81310 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  81323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81327 */     GIR_RootConstrainSelectedInstOperands,
     /*  81328 */     // GIR_Coverage, 15776,
     /*  81328 */     GIR_EraseRootFromParent_Done,
     /*  81329 */   // Label 1268: @81329
     /*  81329 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(81419), // Rule ID 15718 //
     /*  81334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81373 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81381 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81385 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81389 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81393 */     // MIs[4] Op3
     /*  81393 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81398 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81400 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  81409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81417 */     GIR_RootConstrainSelectedInstOperands,
     /*  81418 */     // GIR_Coverage, 15718,
     /*  81418 */     GIR_EraseRootFromParent_Done,
     /*  81419 */   // Label 1269: @81419
     /*  81419 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(81509), // Rule ID 15717 //
     /*  81424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81463 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81469 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81475 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81479 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81483 */     // MIs[4] Op3
     /*  81483 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81490 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  81499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81507 */     GIR_RootConstrainSelectedInstOperands,
     /*  81508 */     // GIR_Coverage, 15717,
     /*  81508 */     GIR_EraseRootFromParent_Done,
     /*  81509 */   // Label 1270: @81509
     /*  81509 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(81599), // Rule ID 15716 //
     /*  81514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81553 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81561 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81565 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81569 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81573 */     // MIs[4] Op3
     /*  81573 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81578 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81580 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  81589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  81593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81597 */     GIR_RootConstrainSelectedInstOperands,
     /*  81598 */     // GIR_Coverage, 15716,
     /*  81598 */     GIR_EraseRootFromParent_Done,
     /*  81599 */   // Label 1271: @81599
     /*  81599 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(81689), // Rule ID 15715 //
     /*  81604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81643 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81649 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81651 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81655 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81659 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81663 */     // MIs[4] Op3
     /*  81663 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81668 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81670 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  81679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  81683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81687 */     GIR_RootConstrainSelectedInstOperands,
     /*  81688 */     // GIR_Coverage, 15715,
     /*  81688 */     GIR_EraseRootFromParent_Done,
     /*  81689 */   // Label 1272: @81689
     /*  81689 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(81779), // Rule ID 15712 //
     /*  81694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81737 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81741 */     // MIs[3] Op3
     /*  81741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81746 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81750 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81758 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81760 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  81773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81777 */     GIR_RootConstrainSelectedInstOperands,
     /*  81778 */     // GIR_Coverage, 15712,
     /*  81778 */     GIR_EraseRootFromParent_Done,
     /*  81779 */   // Label 1273: @81779
     /*  81779 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(81869), // Rule ID 15714 //
     /*  81784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81827 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81831 */     // MIs[3] Op3
     /*  81831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81840 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81846 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81850 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  81863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81867 */     GIR_RootConstrainSelectedInstOperands,
     /*  81868 */     // GIR_Coverage, 15714,
     /*  81868 */     GIR_EraseRootFromParent_Done,
     /*  81869 */   // Label 1274: @81869
     /*  81869 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(81959), // Rule ID 11938 //
     /*  81874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81917 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81921 */     // MIs[3] Op3
     /*  81921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81926 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81930 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81936 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81938 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81940 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81957 */     GIR_RootConstrainSelectedInstOperands,
     /*  81958 */     // GIR_Coverage, 11938,
     /*  81958 */     GIR_EraseRootFromParent_Done,
     /*  81959 */   // Label 1275: @81959
     /*  81959 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(82049), // Rule ID 15713 //
     /*  81964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82007 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82011 */     // MIs[3] Op3
     /*  82011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82016 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82020 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82026 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82028 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82030 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82047 */     GIR_RootConstrainSelectedInstOperands,
     /*  82048 */     // GIR_Coverage, 15713,
     /*  82048 */     GIR_EraseRootFromParent_Done,
     /*  82049 */   // Label 1276: @82049
     /*  82049 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(82139), // Rule ID 15782 //
     /*  82054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82097 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82101 */     // MIs[3] Op3
     /*  82101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82106 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82110 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82120 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  82133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82137 */     GIR_RootConstrainSelectedInstOperands,
     /*  82138 */     // GIR_Coverage, 15782,
     /*  82138 */     GIR_EraseRootFromParent_Done,
     /*  82139 */   // Label 1277: @82139
     /*  82139 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(82229), // Rule ID 15784 //
     /*  82144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82191 */     // MIs[3] Op3
     /*  82191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82210 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  82223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82227 */     GIR_RootConstrainSelectedInstOperands,
     /*  82228 */     // GIR_Coverage, 15784,
     /*  82228 */     GIR_EraseRootFromParent_Done,
     /*  82229 */   // Label 1278: @82229
     /*  82229 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(82319), // Rule ID 11956 //
     /*  82234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82281 */     // MIs[3] Op3
     /*  82281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82286 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82290 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82300 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82317 */     GIR_RootConstrainSelectedInstOperands,
     /*  82318 */     // GIR_Coverage, 11956,
     /*  82318 */     GIR_EraseRootFromParent_Done,
     /*  82319 */   // Label 1279: @82319
     /*  82319 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(82409), // Rule ID 15783 //
     /*  82324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82367 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82371 */     // MIs[3] Op3
     /*  82371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82380 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82386 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82390 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82407 */     GIR_RootConstrainSelectedInstOperands,
     /*  82408 */     // GIR_Coverage, 15783,
     /*  82408 */     GIR_EraseRootFromParent_Done,
     /*  82409 */   // Label 1280: @82409
     /*  82409 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(82499), // Rule ID 15786 //
     /*  82414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82453 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82461 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82465 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82469 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82473 */     // MIs[4] Op3
     /*  82473 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  82478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82480 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  82497 */     GIR_RootConstrainSelectedInstOperands,
     /*  82498 */     // GIR_Coverage, 15786,
     /*  82498 */     GIR_EraseRootFromParent_Done,
     /*  82499 */   // Label 1281: @82499
     /*  82499 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(82589), // Rule ID 15788 //
     /*  82504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82543 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82551 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82555 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82559 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82563 */     // MIs[4] Op3
     /*  82563 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82570 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  82583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82587 */     GIR_RootConstrainSelectedInstOperands,
     /*  82588 */     // GIR_Coverage, 15788,
     /*  82588 */     GIR_EraseRootFromParent_Done,
     /*  82589 */   // Label 1282: @82589
     /*  82589 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(82679), // Rule ID 15785 //
     /*  82594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82649 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82653 */     // MIs[4] Op3
     /*  82653 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  82658 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82660 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  82677 */     GIR_RootConstrainSelectedInstOperands,
     /*  82678 */     // GIR_Coverage, 15785,
     /*  82678 */     GIR_EraseRootFromParent_Done,
     /*  82679 */   // Label 1283: @82679
     /*  82679 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(82769), // Rule ID 15787 //
     /*  82684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82739 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82743 */     // MIs[4] Op3
     /*  82743 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82750 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  82763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82767 */     GIR_RootConstrainSelectedInstOperands,
     /*  82768 */     // GIR_Coverage, 15787,
     /*  82768 */     GIR_EraseRootFromParent_Done,
     /*  82769 */   // Label 1284: @82769
     /*  82769 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(82784), // Rule ID 7505 //
     /*  82774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  82777 */     // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  82777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  82782 */     GIR_RootConstrainSelectedInstOperands,
     /*  82783 */     // GIR_Coverage, 7505,
     /*  82783 */     GIR_Done,
     /*  82784 */   // Label 1285: @82784
     /*  82784 */   GIM_Reject,
     /*  82785 */ // Label 1252: @82785
     /*  82785 */ GIM_Reject,
     /*  82786 */ // Label 1030: @82786
     /*  82786 */ GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(82817), // Rule ID 8498 //
     /*  82791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  82794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  82797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  82800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  82804 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  82804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  82807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  82809 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  82811 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  82813 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  82815 */   GIR_RootConstrainSelectedInstOperands,
     /*  82816 */   // GIR_Coverage, 8498,
     /*  82816 */   GIR_EraseRootFromParent_Done,
     /*  82817 */ // Label 1286: @82817
     /*  82817 */ GIM_Reject,
     /*  82818 */ // Label 1031: @82818
     /*  82818 */ GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(86177),
     /*  82823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  82833 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(82951), // Rule ID 15765 //
     /*  82838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82877 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82883 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82885 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  82889 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82893 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82897 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82901 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82905 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  82913 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  82917 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82921 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82925 */     // MIs[6] Op3
     /*  82925 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  82930 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82932 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  82932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  82941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  82949 */     GIR_RootConstrainSelectedInstOperands,
     /*  82950 */     // GIR_Coverage, 15765,
     /*  82950 */     GIR_EraseRootFromParent_Done,
     /*  82951 */   // Label 1288: @82951
     /*  82951 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(83069), // Rule ID 15767 //
     /*  82956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82995 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83001 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83003 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83007 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83011 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83015 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83019 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83023 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83031 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83035 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83039 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83043 */     // MIs[6] Op3
     /*  83043 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83048 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83050 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  83059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83067 */     GIR_RootConstrainSelectedInstOperands,
     /*  83068 */     // GIR_Coverage, 15767,
     /*  83068 */     GIR_EraseRootFromParent_Done,
     /*  83069 */   // Label 1289: @83069
     /*  83069 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(83187), // Rule ID 15764 //
     /*  83074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83133 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83137 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83141 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83147 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83149 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83153 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83157 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83161 */     // MIs[6] Op3
     /*  83161 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  83166 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83168 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  83177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  83185 */     GIR_RootConstrainSelectedInstOperands,
     /*  83186 */     // GIR_Coverage, 15764,
     /*  83186 */     GIR_EraseRootFromParent_Done,
     /*  83187 */   // Label 1290: @83187
     /*  83187 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(83305), // Rule ID 15766 //
     /*  83192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83231 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83247 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83251 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83255 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83259 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83265 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83267 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83271 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83275 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83279 */     // MIs[6] Op3
     /*  83279 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83284 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83286 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  83295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83303 */     GIR_RootConstrainSelectedInstOperands,
     /*  83304 */     // GIR_Coverage, 15766,
     /*  83304 */     GIR_EraseRootFromParent_Done,
     /*  83305 */   // Label 1291: @83305
     /*  83305 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(83423), // Rule ID 15733 //
     /*  83310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83349 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83355 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83357 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83361 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83365 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83369 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83373 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83377 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83381 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83385 */     // MIs[5] Op3
     /*  83385 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83390 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83394 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83402 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83404 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  83417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83421 */     GIR_RootConstrainSelectedInstOperands,
     /*  83422 */     // GIR_Coverage, 15733,
     /*  83422 */     GIR_EraseRootFromParent_Done,
     /*  83423 */   // Label 1292: @83423
     /*  83423 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(83541), // Rule ID 15738 //
     /*  83428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83467 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83473 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83475 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83479 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83483 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83487 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83491 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83495 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83499 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83503 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83507 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83515 */     // MIs[4] Op3
     /*  83515 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83520 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83522 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  83531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  83535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83539 */     GIR_RootConstrainSelectedInstOperands,
     /*  83540 */     // GIR_Coverage, 15738,
     /*  83540 */     GIR_EraseRootFromParent_Done,
     /*  83541 */   // Label 1293: @83541
     /*  83541 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(83659), // Rule ID 15739 //
     /*  83546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83585 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83591 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83593 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83597 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83601 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83605 */     // MIs[4] Op3
     /*  83605 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83610 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83614 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83618 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83622 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83626 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83630 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83638 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83640 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  83649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  83653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83657 */     GIR_RootConstrainSelectedInstOperands,
     /*  83658 */     // GIR_Coverage, 15739,
     /*  83658 */     GIR_EraseRootFromParent_Done,
     /*  83659 */   // Label 1294: @83659
     /*  83659 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(83777), // Rule ID 11944 //
     /*  83664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83703 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83709 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83711 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83715 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83719 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83723 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83727 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83731 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83735 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83739 */     // MIs[5] Op3
     /*  83739 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83744 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83748 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83756 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83758 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83775 */     GIR_RootConstrainSelectedInstOperands,
     /*  83776 */     // GIR_Coverage, 11944,
     /*  83776 */     GIR_EraseRootFromParent_Done,
     /*  83777 */   // Label 1295: @83777
     /*  83777 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(83895), // Rule ID 15735 //
     /*  83782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83821 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83827 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83829 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83833 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83837 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83841 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83845 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83849 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83853 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83857 */     // MIs[5] Op3
     /*  83857 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83862 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83866 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83874 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83876 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  83889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83893 */     GIR_RootConstrainSelectedInstOperands,
     /*  83894 */     // GIR_Coverage, 15735,
     /*  83894 */     GIR_EraseRootFromParent_Done,
     /*  83895 */   // Label 1296: @83895
     /*  83895 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(84013), // Rule ID 15736 //
     /*  83900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83939 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83945 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83955 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83959 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83963 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83967 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83971 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83975 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83979 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83985 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83987 */     // MIs[4] Op3
     /*  83987 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83992 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83994 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  84003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84011 */     GIR_RootConstrainSelectedInstOperands,
     /*  84012 */     // GIR_Coverage, 15736,
     /*  84012 */     GIR_EraseRootFromParent_Done,
     /*  84013 */   // Label 1297: @84013
     /*  84013 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(84131), // Rule ID 15737 //
     /*  84018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84057 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84063 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84065 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84069 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84073 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84077 */     // MIs[4] Op3
     /*  84077 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84082 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84086 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84090 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84094 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84098 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84102 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84110 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84112 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  84121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84129 */     GIR_RootConstrainSelectedInstOperands,
     /*  84130 */     // GIR_Coverage, 15737,
     /*  84130 */     GIR_EraseRootFromParent_Done,
     /*  84131 */   // Label 1298: @84131
     /*  84131 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(84249), // Rule ID 15734 //
     /*  84136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84175 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84181 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84187 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84191 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84195 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84199 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84203 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84207 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84211 */     // MIs[5] Op3
     /*  84211 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84216 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84220 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84226 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84228 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84230 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  84239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84247 */     GIR_RootConstrainSelectedInstOperands,
     /*  84248 */     // GIR_Coverage, 15734,
     /*  84248 */     GIR_EraseRootFromParent_Done,
     /*  84249 */   // Label 1299: @84249
     /*  84249 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(84367), // Rule ID 15761 //
     /*  84254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84297 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84301 */     // MIs[3] Op3
     /*  84301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84310 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84318 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84322 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84326 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84330 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84334 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84338 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84346 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84348 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  84357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  84361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84365 */     GIR_RootConstrainSelectedInstOperands,
     /*  84366 */     // GIR_Coverage, 15761,
     /*  84366 */     GIR_EraseRootFromParent_Done,
     /*  84367 */   // Label 1300: @84367
     /*  84367 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(84485), // Rule ID 15763 //
     /*  84372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84415 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84419 */     // MIs[3] Op3
     /*  84419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84428 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84434 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84436 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84440 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84444 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84448 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84452 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84456 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84464 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84466 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  84475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  84479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84483 */     GIR_RootConstrainSelectedInstOperands,
     /*  84484 */     // GIR_Coverage, 15763,
     /*  84484 */     GIR_EraseRootFromParent_Done,
     /*  84485 */   // Label 1301: @84485
     /*  84485 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(84603), // Rule ID 11952 //
     /*  84490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84537 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84541 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84545 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84551 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84553 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84557 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84561 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84565 */     // MIs[5] Op3
     /*  84565 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84570 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84574 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84580 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84582 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84584 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  84593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  84597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84601 */     GIR_RootConstrainSelectedInstOperands,
     /*  84602 */     // GIR_Coverage, 11952,
     /*  84602 */     GIR_EraseRootFromParent_Done,
     /*  84603 */   // Label 1302: @84603
     /*  84603 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(84721), // Rule ID 15762 //
     /*  84608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84655 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84663 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84669 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84671 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84675 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84679 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84683 */     // MIs[5] Op3
     /*  84683 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84688 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84692 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84698 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84700 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84702 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  84711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  84715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84719 */     GIR_RootConstrainSelectedInstOperands,
     /*  84720 */     // GIR_Coverage, 15762,
     /*  84720 */     GIR_EraseRootFromParent_Done,
     /*  84721 */   // Label 1303: @84721
     /*  84721 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(84811), // Rule ID 15711 //
     /*  84726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84765 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84773 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84777 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84781 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84785 */     // MIs[4] Op3
     /*  84785 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84790 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84792 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  84805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84809 */     GIR_RootConstrainSelectedInstOperands,
     /*  84810 */     // GIR_Coverage, 15711,
     /*  84810 */     GIR_EraseRootFromParent_Done,
     /*  84811 */   // Label 1304: @84811
     /*  84811 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(84901), // Rule ID 15710 //
     /*  84816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84855 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84861 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84863 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84867 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84871 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84875 */     // MIs[4] Op3
     /*  84875 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84882 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  84895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84899 */     GIR_RootConstrainSelectedInstOperands,
     /*  84900 */     // GIR_Coverage, 15710,
     /*  84900 */     GIR_EraseRootFromParent_Done,
     /*  84901 */   // Label 1305: @84901
     /*  84901 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(84991), // Rule ID 15709 //
     /*  84906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84945 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84951 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84953 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84957 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84961 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84965 */     // MIs[4] Op3
     /*  84965 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84972 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84989 */     GIR_RootConstrainSelectedInstOperands,
     /*  84990 */     // GIR_Coverage, 15709,
     /*  84990 */     GIR_EraseRootFromParent_Done,
     /*  84991 */   // Label 1306: @84991
     /*  84991 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(85081), // Rule ID 15708 //
     /*  84996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85035 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85041 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85043 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85047 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85051 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85055 */     // MIs[4] Op3
     /*  85055 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85060 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85062 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  85071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85079 */     GIR_RootConstrainSelectedInstOperands,
     /*  85080 */     // GIR_Coverage, 15708,
     /*  85080 */     GIR_EraseRootFromParent_Done,
     /*  85081 */   // Label 1307: @85081
     /*  85081 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(85171), // Rule ID 15705 //
     /*  85086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85133 */     // MIs[3] Op3
     /*  85133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85142 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85150 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85152 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85169 */     GIR_RootConstrainSelectedInstOperands,
     /*  85170 */     // GIR_Coverage, 15705,
     /*  85170 */     GIR_EraseRootFromParent_Done,
     /*  85171 */   // Label 1308: @85171
     /*  85171 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(85261), // Rule ID 15707 //
     /*  85176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85219 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85223 */     // MIs[3] Op3
     /*  85223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85232 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85238 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85242 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85259 */     GIR_RootConstrainSelectedInstOperands,
     /*  85260 */     // GIR_Coverage, 15707,
     /*  85260 */     GIR_EraseRootFromParent_Done,
     /*  85261 */   // Label 1309: @85261
     /*  85261 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(85351), // Rule ID 11936 //
     /*  85266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85313 */     // MIs[3] Op3
     /*  85313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85322 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85330 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85332 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85349 */     GIR_RootConstrainSelectedInstOperands,
     /*  85350 */     // GIR_Coverage, 11936,
     /*  85350 */     GIR_EraseRootFromParent_Done,
     /*  85351 */   // Label 1310: @85351
     /*  85351 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(85441), // Rule ID 15706 //
     /*  85356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85403 */     // MIs[3] Op3
     /*  85403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85412 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85420 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85422 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85439 */     GIR_RootConstrainSelectedInstOperands,
     /*  85440 */     // GIR_Coverage, 15706,
     /*  85440 */     GIR_EraseRootFromParent_Done,
     /*  85441 */   // Label 1311: @85441
     /*  85441 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(85531), // Rule ID 15768 //
     /*  85446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85489 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85493 */     // MIs[3] Op3
     /*  85493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85498 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85502 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85508 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85510 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85512 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  85525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85529 */     GIR_RootConstrainSelectedInstOperands,
     /*  85530 */     // GIR_Coverage, 15768,
     /*  85530 */     GIR_EraseRootFromParent_Done,
     /*  85531 */   // Label 1312: @85531
     /*  85531 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(85621), // Rule ID 15770 //
     /*  85536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85583 */     // MIs[3] Op3
     /*  85583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85592 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85598 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85600 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85602 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  85615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85619 */     GIR_RootConstrainSelectedInstOperands,
     /*  85620 */     // GIR_Coverage, 15770,
     /*  85620 */     GIR_EraseRootFromParent_Done,
     /*  85621 */   // Label 1313: @85621
     /*  85621 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(85711), // Rule ID 11953 //
     /*  85626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85669 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85673 */     // MIs[3] Op3
     /*  85673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85682 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85688 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85690 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85692 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  85705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85709 */     GIR_RootConstrainSelectedInstOperands,
     /*  85710 */     // GIR_Coverage, 11953,
     /*  85710 */     GIR_EraseRootFromParent_Done,
     /*  85711 */   // Label 1314: @85711
     /*  85711 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(85801), // Rule ID 15769 //
     /*  85716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85763 */     // MIs[3] Op3
     /*  85763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85772 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85782 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  85795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85799 */     GIR_RootConstrainSelectedInstOperands,
     /*  85800 */     // GIR_Coverage, 15769,
     /*  85800 */     GIR_EraseRootFromParent_Done,
     /*  85801 */   // Label 1315: @85801
     /*  85801 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(85891), // Rule ID 15772 //
     /*  85806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  85845 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85851 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85857 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85861 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85865 */     // MIs[4] Op3
     /*  85865 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  85870 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85872 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  85881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  85889 */     GIR_RootConstrainSelectedInstOperands,
     /*  85890 */     // GIR_Coverage, 15772,
     /*  85890 */     GIR_EraseRootFromParent_Done,
     /*  85891 */   // Label 1316: @85891
     /*  85891 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(85981), // Rule ID 15774 //
     /*  85896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  85935 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85941 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85943 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85947 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85951 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85955 */     // MIs[4] Op3
     /*  85955 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85960 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85962 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  85971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85979 */     GIR_RootConstrainSelectedInstOperands,
     /*  85980 */     // GIR_Coverage, 15774,
     /*  85980 */     GIR_EraseRootFromParent_Done,
     /*  85981 */   // Label 1317: @85981
     /*  85981 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(86071), // Rule ID 15771 //
     /*  85986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  86025 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86033 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86037 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86041 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86045 */     // MIs[4] Op3
     /*  86045 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  86050 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86052 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  86069 */     GIR_RootConstrainSelectedInstOperands,
     /*  86070 */     // GIR_Coverage, 15771,
     /*  86070 */     GIR_EraseRootFromParent_Done,
     /*  86071 */   // Label 1318: @86071
     /*  86071 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(86161), // Rule ID 15773 //
     /*  86076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  86115 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86123 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86127 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86131 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86135 */     // MIs[4] Op3
     /*  86135 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86140 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86142 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86159 */     GIR_RootConstrainSelectedInstOperands,
     /*  86160 */     // GIR_Coverage, 15773,
     /*  86160 */     GIR_EraseRootFromParent_Done,
     /*  86161 */   // Label 1319: @86161
     /*  86161 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(86176), // Rule ID 7504 //
     /*  86166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86169 */     // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  86169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  86174 */     GIR_RootConstrainSelectedInstOperands,
     /*  86175 */     // GIR_Coverage, 7504,
     /*  86175 */     GIR_Done,
     /*  86176 */   // Label 1320: @86176
     /*  86176 */   GIM_Reject,
     /*  86177 */ // Label 1287: @86177
     /*  86177 */ GIM_Reject,
     /*  86178 */ // Label 1032: @86178
     /*  86178 */ GIM_Reject,
     /*  86179 */ // Label 7: @86179
     /*  86179 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1339*/ GIMT_Encode4(97146),
     /*  86190 */ /*GILLT_s32*//*Label 1321*/ GIMT_Encode4(86278),
     /*  86194 */ /*GILLT_s64*//*Label 1322*/ GIMT_Encode4(86958), GIMT_Encode4(0),
     /*  86202 */ /*GILLT_v2s32*//*Label 1323*/ GIMT_Encode4(87801),
     /*  86206 */ /*GILLT_v2s64*//*Label 1324*/ GIMT_Encode4(88036),
     /*  86210 */ /*GILLT_v4s16*//*Label 1325*/ GIMT_Encode4(88725),
     /*  86214 */ /*GILLT_v4s32*//*Label 1326*/ GIMT_Encode4(88960),
     /*  86218 */ /*GILLT_v8s8*//*Label 1327*/ GIMT_Encode4(89649),
     /*  86222 */ /*GILLT_v8s16*//*Label 1328*/ GIMT_Encode4(89887),
     /*  86226 */ /*GILLT_v16s8*//*Label 1329*/ GIMT_Encode4(90576),
     /*  86230 */ /*GILLT_nxv1s1*//*Label 1330*/ GIMT_Encode4(91268),
     /*  86234 */ /*GILLT_nxv2s1*//*Label 1331*/ GIMT_Encode4(91318), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86246 */ /*GILLT_nxv2s64*//*Label 1332*/ GIMT_Encode4(91368),
     /*  86250 */ /*GILLT_nxv4s1*//*Label 1333*/ GIMT_Encode4(92775), GIMT_Encode4(0),
     /*  86258 */ /*GILLT_nxv4s32*//*Label 1334*/ GIMT_Encode4(92825),
     /*  86262 */ /*GILLT_nxv8s1*//*Label 1335*/ GIMT_Encode4(94232),
     /*  86266 */ /*GILLT_nxv8s16*//*Label 1336*/ GIMT_Encode4(94282),
     /*  86270 */ /*GILLT_nxv16s1*//*Label 1337*/ GIMT_Encode4(95689),
     /*  86274 */ /*GILLT_nxv16s8*//*Label 1338*/ GIMT_Encode4(95739),
     /*  86278 */ // Label 1321: @86278
     /*  86278 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(86957),
     /*  86283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86289 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(86347), // Rule ID 13312 //
     /*  86294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86319 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86332 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86345 */     GIR_RootConstrainSelectedInstOperands,
     /*  86346 */     // GIR_Coverage, 13312,
     /*  86346 */     GIR_EraseRootFromParent_Done,
     /*  86347 */   // Label 1341: @86347
     /*  86347 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(86402), // Rule ID 13311 //
     /*  86352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86389 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  86396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86400 */     GIR_RootConstrainSelectedInstOperands,
     /*  86401 */     // GIR_Coverage, 13311,
     /*  86401 */     GIR_EraseRootFromParent_Done,
     /*  86402 */   // Label 1342: @86402
     /*  86402 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(86460), // Rule ID 13309 //
     /*  86407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86445 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86454 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86458 */     GIR_RootConstrainSelectedInstOperands,
     /*  86459 */     // GIR_Coverage, 13309,
     /*  86459 */     GIR_EraseRootFromParent_Done,
     /*  86460 */   // Label 1343: @86460
     /*  86460 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(86518), // Rule ID 166 //
     /*  86465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86503 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86516 */     GIR_RootConstrainSelectedInstOperands,
     /*  86517 */     // GIR_Coverage, 166,
     /*  86517 */     GIR_EraseRootFromParent_Done,
     /*  86518 */   // Label 1344: @86518
     /*  86518 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(86576), // Rule ID 13310 //
     /*  86523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86548 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86561 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86574 */     GIR_RootConstrainSelectedInstOperands,
     /*  86575 */     // GIR_Coverage, 13310,
     /*  86575 */     GIR_EraseRootFromParent_Done,
     /*  86576 */   // Label 1345: @86576
     /*  86576 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(86631), // Rule ID 13313 //
     /*  86581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86605 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86618 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86629 */     GIR_RootConstrainSelectedInstOperands,
     /*  86630 */     // GIR_Coverage, 13313,
     /*  86630 */     GIR_EraseRootFromParent_Done,
     /*  86631 */   // Label 1346: @86631
     /*  86631 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(86672), // Rule ID 144 //
     /*  86636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  86640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86652 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  86656 */     // MIs[1] Operand 1
     /*  86656 */     // No operand predicates
     /*  86656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86658 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  86658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  86661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86665 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  86670 */     GIR_RootConstrainSelectedInstOperands,
     /*  86671 */     // GIR_Coverage, 144,
     /*  86671 */     GIR_EraseRootFromParent_Done,
     /*  86672 */   // Label 1347: @86672
     /*  86672 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(86705), // Rule ID 13319 //
     /*  86677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86692 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  86695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  86699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86703 */     GIR_RootConstrainSelectedInstOperands,
     /*  86704 */     // GIR_Coverage, 13319,
     /*  86704 */     GIR_EraseRootFromParent_Done,
     /*  86705 */   // Label 1348: @86705
     /*  86705 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(86738), // Rule ID 170 //
     /*  86710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86725 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  86728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86736 */     GIR_RootConstrainSelectedInstOperands,
     /*  86737 */     // GIR_Coverage, 170,
     /*  86737 */     GIR_EraseRootFromParent_Done,
     /*  86738 */   // Label 1349: @86738
     /*  86738 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(86791), // Rule ID 13305 //
     /*  86743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86778 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  86789 */     GIR_RootConstrainSelectedInstOperands,
     /*  86790 */     // GIR_Coverage, 13305,
     /*  86790 */     GIR_EraseRootFromParent_Done,
     /*  86791 */   // Label 1350: @86791
     /*  86791 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(86847), // Rule ID 164 //
     /*  86796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86832 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  86845 */     GIR_RootConstrainSelectedInstOperands,
     /*  86846 */     // GIR_Coverage, 164,
     /*  86846 */     GIR_EraseRootFromParent_Done,
     /*  86847 */   // Label 1351: @86847
     /*  86847 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(86900), // Rule ID 13306 //
     /*  86852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86881 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86887 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  86898 */     GIR_RootConstrainSelectedInstOperands,
     /*  86899 */     // GIR_Coverage, 13306,
     /*  86899 */     GIR_EraseRootFromParent_Done,
     /*  86900 */   // Label 1352: @86900
     /*  86900 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(86932), // Rule ID 3999 //
     /*  86905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86917 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  86917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  86920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  86930 */     GIR_RootConstrainSelectedInstOperands,
     /*  86931 */     // GIR_Coverage, 3999,
     /*  86931 */     GIR_EraseRootFromParent_Done,
     /*  86932 */   // Label 1353: @86932
     /*  86932 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(86956), // Rule ID 168 //
     /*  86937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86949 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  86954 */     GIR_RootConstrainSelectedInstOperands,
     /*  86955 */     // GIR_Coverage, 168,
     /*  86955 */     GIR_Done,
     /*  86956 */   // Label 1354: @86956
     /*  86956 */   GIM_Reject,
     /*  86957 */ // Label 1340: @86957
     /*  86957 */ GIM_Reject,
     /*  86958 */ // Label 1322: @86958
     /*  86958 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(87800),
     /*  86963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86969 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(87027), // Rule ID 13317 //
     /*  86974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  86990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  86994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86999 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87012 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87025 */     GIR_RootConstrainSelectedInstOperands,
     /*  87026 */     // GIR_Coverage, 13317,
     /*  87026 */     GIR_EraseRootFromParent_Done,
     /*  87027 */   // Label 1356: @87027
     /*  87027 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(87082), // Rule ID 13316 //
     /*  87032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87052 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87069 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87080 */     GIR_RootConstrainSelectedInstOperands,
     /*  87081 */     // GIR_Coverage, 13316,
     /*  87081 */     GIR_EraseRootFromParent_Done,
     /*  87082 */   // Label 1357: @87082
     /*  87082 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(87140), // Rule ID 13314 //
     /*  87087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87125 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87138 */     GIR_RootConstrainSelectedInstOperands,
     /*  87139 */     // GIR_Coverage, 13314,
     /*  87139 */     GIR_EraseRootFromParent_Done,
     /*  87140 */   // Label 1358: @87140
     /*  87140 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(87198), // Rule ID 167 //
     /*  87145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87183 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87196 */     GIR_RootConstrainSelectedInstOperands,
     /*  87197 */     // GIR_Coverage, 167,
     /*  87197 */     GIR_EraseRootFromParent_Done,
     /*  87198 */   // Label 1359: @87198
     /*  87198 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(87256), // Rule ID 13315 //
     /*  87203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87228 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87241 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87254 */     GIR_RootConstrainSelectedInstOperands,
     /*  87255 */     // GIR_Coverage, 13315,
     /*  87255 */     GIR_EraseRootFromParent_Done,
     /*  87256 */   // Label 1360: @87256
     /*  87256 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(87311), // Rule ID 13318 //
     /*  87261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87285 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87298 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87309 */     GIR_RootConstrainSelectedInstOperands,
     /*  87310 */     // GIR_Coverage, 13318,
     /*  87310 */     GIR_EraseRootFromParent_Done,
     /*  87311 */   // Label 1361: @87311
     /*  87311 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(87411), // Rule ID 1613 //
     /*  87316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87335 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  87339 */     // MIs[1] Operand 1
     /*  87339 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  87348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  87356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  87360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  87374 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87380 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  87382 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87386 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87396 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  87396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  87399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  87405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  87409 */     GIR_RootConstrainSelectedInstOperands,
     /*  87410 */     // GIR_Coverage, 1613,
     /*  87410 */     GIR_EraseRootFromParent_Done,
     /*  87411 */   // Label 1362: @87411
     /*  87411 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(87452), // Rule ID 145 //
     /*  87416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  87420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87432 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  87436 */     // MIs[1] Operand 1
     /*  87436 */     // No operand predicates
     /*  87436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87438 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  87438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  87441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87445 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  87450 */     GIR_RootConstrainSelectedInstOperands,
     /*  87451 */     // GIR_Coverage, 145,
     /*  87451 */     GIR_EraseRootFromParent_Done,
     /*  87452 */   // Label 1363: @87452
     /*  87452 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(87485), // Rule ID 13320 //
     /*  87457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87472 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  87475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87483 */     GIR_RootConstrainSelectedInstOperands,
     /*  87484 */     // GIR_Coverage, 13320,
     /*  87484 */     GIR_EraseRootFromParent_Done,
     /*  87485 */   // Label 1364: @87485
     /*  87485 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(87518), // Rule ID 171 //
     /*  87490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87505 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  87508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87516 */     GIR_RootConstrainSelectedInstOperands,
     /*  87517 */     // GIR_Coverage, 171,
     /*  87517 */     GIR_EraseRootFromParent_Done,
     /*  87518 */   // Label 1365: @87518
     /*  87518 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(87571), // Rule ID 13307 //
     /*  87523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87548 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87558 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  87569 */     GIR_RootConstrainSelectedInstOperands,
     /*  87570 */     // GIR_Coverage, 13307,
     /*  87570 */     GIR_EraseRootFromParent_Done,
     /*  87571 */   // Label 1366: @87571
     /*  87571 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(87627), // Rule ID 165 //
     /*  87576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87612 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  87625 */     GIR_RootConstrainSelectedInstOperands,
     /*  87626 */     // GIR_Coverage, 165,
     /*  87626 */     GIR_EraseRootFromParent_Done,
     /*  87627 */   // Label 1367: @87627
     /*  87627 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(87680), // Rule ID 13308 //
     /*  87632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87661 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87667 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  87678 */     GIR_RootConstrainSelectedInstOperands,
     /*  87679 */     // GIR_Coverage, 13308,
     /*  87679 */     GIR_EraseRootFromParent_Done,
     /*  87680 */   // Label 1368: @87680
     /*  87680 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(87712), // Rule ID 4000 //
     /*  87685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87697 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  87697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  87700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  87710 */     GIR_RootConstrainSelectedInstOperands,
     /*  87711 */     // GIR_Coverage, 4000,
     /*  87711 */     GIR_EraseRootFromParent_Done,
     /*  87712 */   // Label 1369: @87712
     /*  87712 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(87748), // Rule ID 4984 //
     /*  87717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87729 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  87737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87739 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  87739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  87742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87746 */     GIR_RootConstrainSelectedInstOperands,
     /*  87747 */     // GIR_Coverage, 4984,
     /*  87747 */     GIR_EraseRootFromParent_Done,
     /*  87748 */   // Label 1370: @87748
     /*  87748 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(87772), // Rule ID 169 //
     /*  87753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87765 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  87770 */     GIR_RootConstrainSelectedInstOperands,
     /*  87771 */     // GIR_Coverage, 169,
     /*  87771 */     GIR_Done,
     /*  87772 */   // Label 1371: @87772
     /*  87772 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(87799), // Rule ID 5062 //
     /*  87777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87792 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  87792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  87797 */     GIR_RootConstrainSelectedInstOperands,
     /*  87798 */     // GIR_Coverage, 5062,
     /*  87798 */     GIR_Done,
     /*  87799 */   // Label 1372: @87799
     /*  87799 */   GIM_Reject,
     /*  87800 */ // Label 1355: @87800
     /*  87800 */ GIM_Reject,
     /*  87801 */ // Label 1323: @87801
     /*  87801 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88035),
     /*  87806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87816 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(87912), // Rule ID 1160 //
     /*  87821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  87840 */     // MIs[1] Operand 1
     /*  87840 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  87849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  87875 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87881 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  87883 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87887 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87893 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87895 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87897 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  87897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  87900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  87906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  87910 */     GIR_RootConstrainSelectedInstOperands,
     /*  87911 */     // GIR_Coverage, 1160,
     /*  87911 */     GIR_EraseRootFromParent_Done,
     /*  87912 */   // Label 1374: @87912
     /*  87912 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(87979), // Rule ID 5031 //
     /*  87917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87929 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  87933 */     // MIs[1] Operand 1
     /*  87933 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  87942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87948 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  87950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  87954 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87960 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87964 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  87964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  87967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87977 */     GIR_RootConstrainSelectedInstOperands,
     /*  87978 */     // GIR_Coverage, 5031,
     /*  87978 */     GIR_EraseRootFromParent_Done,
     /*  87979 */   // Label 1375: @87979
     /*  87979 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88011), // Rule ID 4982 //
     /*  87984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87992 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87998 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88002 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  88002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  88005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88009 */     GIR_RootConstrainSelectedInstOperands,
     /*  88010 */     // GIR_Coverage, 4982,
     /*  88010 */     GIR_EraseRootFromParent_Done,
     /*  88011 */   // Label 1376: @88011
     /*  88011 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88034), // Rule ID 5061 //
     /*  88016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88027 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  88027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  88032 */     GIR_RootConstrainSelectedInstOperands,
     /*  88033 */     // GIR_Coverage, 5061,
     /*  88033 */     GIR_Done,
     /*  88034 */   // Label 1377: @88034
     /*  88034 */   GIM_Reject,
     /*  88035 */ // Label 1373: @88035
     /*  88035 */ GIM_Reject,
     /*  88036 */ // Label 1324: @88036
     /*  88036 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88724),
     /*  88041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88051 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88147), // Rule ID 1162 //
     /*  88056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88071 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  88075 */     // MIs[1] Operand 1
     /*  88075 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88110 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88116 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88118 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88122 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88128 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88130 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88132 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  88132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  88135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88145 */     GIR_RootConstrainSelectedInstOperands,
     /*  88146 */     // GIR_Coverage, 1162,
     /*  88146 */     GIR_EraseRootFromParent_Done,
     /*  88147 */   // Label 1379: @88147
     /*  88147 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(88214), // Rule ID 5033 //
     /*  88152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  88168 */     // MIs[1] Operand 1
     /*  88168 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  88177 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  88185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  88189 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88199 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  88199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  88202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88212 */     GIR_RootConstrainSelectedInstOperands,
     /*  88213 */     // GIR_Coverage, 5033,
     /*  88213 */     GIR_EraseRootFromParent_Done,
     /*  88214 */   // Label 1380: @88214
     /*  88214 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(88299), // Rule ID 13852 //
     /*  88219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  88242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88263 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88282 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  88289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88297 */     GIR_RootConstrainSelectedInstOperands,
     /*  88298 */     // GIR_Coverage, 13852,
     /*  88298 */     GIR_EraseRootFromParent_Done,
     /*  88299 */   // Label 1381: @88299
     /*  88299 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(88384), // Rule ID 13851 //
     /*  88304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88353 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88359 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88367 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  88374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  88378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88382 */     GIR_RootConstrainSelectedInstOperands,
     /*  88383 */     // GIR_Coverage, 13851,
     /*  88383 */     GIR_EraseRootFromParent_Done,
     /*  88384 */   // Label 1382: @88384
     /*  88384 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(88469), // Rule ID 13850 //
     /*  88389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  88416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88452 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  88459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88467 */     GIR_RootConstrainSelectedInstOperands,
     /*  88468 */     // GIR_Coverage, 13850,
     /*  88468 */     GIR_EraseRootFromParent_Done,
     /*  88469 */   // Label 1383: @88469
     /*  88469 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(88554), // Rule ID 3827 //
     /*  88474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88527 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88537 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  88544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  88548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88552 */     GIR_RootConstrainSelectedInstOperands,
     /*  88553 */     // GIR_Coverage, 3827,
     /*  88553 */     GIR_EraseRootFromParent_Done,
     /*  88554 */   // Label 1384: @88554
     /*  88554 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(88586), // Rule ID 4985 //
     /*  88559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88567 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88573 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88577 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  88577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  88580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88584 */     GIR_RootConstrainSelectedInstOperands,
     /*  88585 */     // GIR_Coverage, 4985,
     /*  88585 */     GIR_EraseRootFromParent_Done,
     /*  88586 */   // Label 1385: @88586
     /*  88586 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(88643), // Rule ID 3823 //
     /*  88591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88626 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  88629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  88635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  88641 */     GIR_RootConstrainSelectedInstOperands,
     /*  88642 */     // GIR_Coverage, 3823,
     /*  88642 */     GIR_EraseRootFromParent_Done,
     /*  88643 */   // Label 1386: @88643
     /*  88643 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(88700), // Rule ID 13840 //
     /*  88648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88683 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  88686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  88692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  88698 */     GIR_RootConstrainSelectedInstOperands,
     /*  88699 */     // GIR_Coverage, 13840,
     /*  88699 */     GIR_EraseRootFromParent_Done,
     /*  88700 */   // Label 1387: @88700
     /*  88700 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(88723), // Rule ID 5065 //
     /*  88705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88716 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  88716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  88721 */     GIR_RootConstrainSelectedInstOperands,
     /*  88722 */     // GIR_Coverage, 5065,
     /*  88722 */     GIR_Done,
     /*  88723 */   // Label 1388: @88723
     /*  88723 */   GIM_Reject,
     /*  88724 */ // Label 1378: @88724
     /*  88724 */ GIM_Reject,
     /*  88725 */ // Label 1325: @88725
     /*  88725 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(88959),
     /*  88730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88740 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(88836), // Rule ID 1158 //
     /*  88745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88760 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  88764 */     // MIs[1] Operand 1
     /*  88764 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88799 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88811 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88821 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  88821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  88824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88834 */     GIR_RootConstrainSelectedInstOperands,
     /*  88835 */     // GIR_Coverage, 1158,
     /*  88835 */     GIR_EraseRootFromParent_Done,
     /*  88836 */   // Label 1390: @88836
     /*  88836 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(88903), // Rule ID 5029 //
     /*  88841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88853 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  88857 */     // MIs[1] Operand 1
     /*  88857 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  88866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88872 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  88874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  88878 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88888 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  88888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  88891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88901 */     GIR_RootConstrainSelectedInstOperands,
     /*  88902 */     // GIR_Coverage, 5029,
     /*  88902 */     GIR_EraseRootFromParent_Done,
     /*  88903 */   // Label 1391: @88903
     /*  88903 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(88935), // Rule ID 4980 //
     /*  88908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88916 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88922 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88926 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  88926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  88929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88933 */     GIR_RootConstrainSelectedInstOperands,
     /*  88934 */     // GIR_Coverage, 4980,
     /*  88934 */     GIR_EraseRootFromParent_Done,
     /*  88935 */   // Label 1392: @88935
     /*  88935 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(88958), // Rule ID 5060 //
     /*  88940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88951 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  88951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  88956 */     GIR_RootConstrainSelectedInstOperands,
     /*  88957 */     // GIR_Coverage, 5060,
     /*  88957 */     GIR_Done,
     /*  88958 */   // Label 1393: @88958
     /*  88958 */   GIM_Reject,
     /*  88959 */ // Label 1389: @88959
     /*  88959 */ GIM_Reject,
     /*  88960 */ // Label 1326: @88960
     /*  88960 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(89648),
     /*  88965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  88968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88975 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(89071), // Rule ID 1161 //
     /*  88980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88995 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88999 */     // MIs[1] Operand 1
     /*  88999 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89034 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89040 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89046 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89054 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89056 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  89056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  89059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89069 */     GIR_RootConstrainSelectedInstOperands,
     /*  89070 */     // GIR_Coverage, 1161,
     /*  89070 */     GIR_EraseRootFromParent_Done,
     /*  89071 */   // Label 1395: @89071
     /*  89071 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(89138), // Rule ID 5032 //
     /*  89076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89088 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89092 */     // MIs[1] Operand 1
     /*  89092 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89101 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89107 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89123 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  89123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  89126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89136 */     GIR_RootConstrainSelectedInstOperands,
     /*  89137 */     // GIR_Coverage, 5032,
     /*  89137 */     GIR_EraseRootFromParent_Done,
     /*  89138 */   // Label 1396: @89138
     /*  89138 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(89223), // Rule ID 13849 //
     /*  89143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89187 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89206 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89221 */     GIR_RootConstrainSelectedInstOperands,
     /*  89222 */     // GIR_Coverage, 13849,
     /*  89222 */     GIR_EraseRootFromParent_Done,
     /*  89223 */   // Label 1397: @89223
     /*  89223 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(89308), // Rule ID 13848 //
     /*  89228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89277 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89291 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89306 */     GIR_RootConstrainSelectedInstOperands,
     /*  89307 */     // GIR_Coverage, 13848,
     /*  89307 */     GIR_EraseRootFromParent_Done,
     /*  89308 */   // Label 1398: @89308
     /*  89308 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(89393), // Rule ID 13847 //
     /*  89313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89361 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89376 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89391 */     GIR_RootConstrainSelectedInstOperands,
     /*  89392 */     // GIR_Coverage, 13847,
     /*  89392 */     GIR_EraseRootFromParent_Done,
     /*  89393 */   // Label 1399: @89393
     /*  89393 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(89478), // Rule ID 3826 //
     /*  89398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89451 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89457 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89461 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89476 */     GIR_RootConstrainSelectedInstOperands,
     /*  89477 */     // GIR_Coverage, 3826,
     /*  89477 */     GIR_EraseRootFromParent_Done,
     /*  89478 */   // Label 1400: @89478
     /*  89478 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(89510), // Rule ID 4983 //
     /*  89483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89491 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89497 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89501 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  89501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  89504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89508 */     GIR_RootConstrainSelectedInstOperands,
     /*  89509 */     // GIR_Coverage, 4983,
     /*  89509 */     GIR_EraseRootFromParent_Done,
     /*  89510 */   // Label 1401: @89510
     /*  89510 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(89567), // Rule ID 3822 //
     /*  89515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89550 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  89553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  89559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  89565 */     GIR_RootConstrainSelectedInstOperands,
     /*  89566 */     // GIR_Coverage, 3822,
     /*  89566 */     GIR_EraseRootFromParent_Done,
     /*  89567 */   // Label 1402: @89567
     /*  89567 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(89624), // Rule ID 13839 //
     /*  89572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89607 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  89610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  89616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  89622 */     GIR_RootConstrainSelectedInstOperands,
     /*  89623 */     // GIR_Coverage, 13839,
     /*  89623 */     GIR_EraseRootFromParent_Done,
     /*  89624 */   // Label 1403: @89624
     /*  89624 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(89647), // Rule ID 5064 //
     /*  89629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89640 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  89640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  89645 */     GIR_RootConstrainSelectedInstOperands,
     /*  89646 */     // GIR_Coverage, 5064,
     /*  89646 */     GIR_Done,
     /*  89647 */   // Label 1404: @89647
     /*  89647 */   GIM_Reject,
     /*  89648 */ // Label 1394: @89648
     /*  89648 */ GIM_Reject,
     /*  89649 */ // Label 1327: @89649
     /*  89649 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(89886),
     /*  89654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89664 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(89760), // Rule ID 1156 //
     /*  89669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89684 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  89688 */     // MIs[1] Operand 1
     /*  89688 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89729 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89735 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89741 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89743 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89745 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  89745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  89748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89758 */     GIR_RootConstrainSelectedInstOperands,
     /*  89759 */     // GIR_Coverage, 1156,
     /*  89759 */     GIR_EraseRootFromParent_Done,
     /*  89760 */   // Label 1406: @89760
     /*  89760 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(89827), // Rule ID 5027 //
     /*  89765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89777 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  89781 */     // MIs[1] Operand 1
     /*  89781 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89790 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89796 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89802 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89812 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  89812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  89815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89825 */     GIR_RootConstrainSelectedInstOperands,
     /*  89826 */     // GIR_Coverage, 5027,
     /*  89826 */     GIR_EraseRootFromParent_Done,
     /*  89827 */   // Label 1407: @89827
     /*  89827 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(89862), // Rule ID 972 //
     /*  89832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89843 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89853 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  89853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89860 */     GIR_RootConstrainSelectedInstOperands,
     /*  89861 */     // GIR_Coverage, 972,
     /*  89861 */     GIR_EraseRootFromParent_Done,
     /*  89862 */   // Label 1408: @89862
     /*  89862 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(89885), // Rule ID 1599 //
     /*  89867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89878 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  89878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89883 */     GIR_RootConstrainSelectedInstOperands,
     /*  89884 */     // GIR_Coverage, 1599,
     /*  89884 */     GIR_Done,
     /*  89885 */   // Label 1409: @89885
     /*  89885 */   GIM_Reject,
     /*  89886 */ // Label 1405: @89886
     /*  89886 */ GIM_Reject,
     /*  89887 */ // Label 1328: @89887
     /*  89887 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(90575),
     /*  89892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89902 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(89998), // Rule ID 1159 //
     /*  89907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89922 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89926 */     // MIs[1] Operand 1
     /*  89926 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89961 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89967 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89973 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89979 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89981 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89983 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  89983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  89986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89996 */     GIR_RootConstrainSelectedInstOperands,
     /*  89997 */     // GIR_Coverage, 1159,
     /*  89997 */     GIR_EraseRootFromParent_Done,
     /*  89998 */   // Label 1411: @89998
     /*  89998 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(90065), // Rule ID 5030 //
     /*  90003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90019 */     // MIs[1] Operand 1
     /*  90019 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90028 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90034 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90040 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90050 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  90050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  90053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90063 */     GIR_RootConstrainSelectedInstOperands,
     /*  90064 */     // GIR_Coverage, 5030,
     /*  90064 */     GIR_EraseRootFromParent_Done,
     /*  90065 */   // Label 1412: @90065
     /*  90065 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(90150), // Rule ID 13846 //
     /*  90070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90114 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90120 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90133 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90148 */     GIR_RootConstrainSelectedInstOperands,
     /*  90149 */     // GIR_Coverage, 13846,
     /*  90149 */     GIR_EraseRootFromParent_Done,
     /*  90150 */   // Label 1413: @90150
     /*  90150 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(90235), // Rule ID 13845 //
     /*  90155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90204 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90210 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90218 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90233 */     GIR_RootConstrainSelectedInstOperands,
     /*  90234 */     // GIR_Coverage, 13845,
     /*  90234 */     GIR_EraseRootFromParent_Done,
     /*  90235 */   // Label 1414: @90235
     /*  90235 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(90320), // Rule ID 13844 //
     /*  90240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90288 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90303 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90318 */     GIR_RootConstrainSelectedInstOperands,
     /*  90319 */     // GIR_Coverage, 13844,
     /*  90319 */     GIR_EraseRootFromParent_Done,
     /*  90320 */   // Label 1415: @90320
     /*  90320 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(90405), // Rule ID 3825 //
     /*  90325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90378 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90388 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90403 */     GIR_RootConstrainSelectedInstOperands,
     /*  90404 */     // GIR_Coverage, 3825,
     /*  90404 */     GIR_EraseRootFromParent_Done,
     /*  90405 */   // Label 1416: @90405
     /*  90405 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(90437), // Rule ID 4981 //
     /*  90410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90424 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90428 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  90428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90435 */     GIR_RootConstrainSelectedInstOperands,
     /*  90436 */     // GIR_Coverage, 4981,
     /*  90436 */     GIR_EraseRootFromParent_Done,
     /*  90437 */   // Label 1417: @90437
     /*  90437 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(90494), // Rule ID 3821 //
     /*  90442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90477 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  90492 */     GIR_RootConstrainSelectedInstOperands,
     /*  90493 */     // GIR_Coverage, 3821,
     /*  90493 */     GIR_EraseRootFromParent_Done,
     /*  90494 */   // Label 1418: @90494
     /*  90494 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(90551), // Rule ID 13838 //
     /*  90499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90534 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  90549 */     GIR_RootConstrainSelectedInstOperands,
     /*  90550 */     // GIR_Coverage, 13838,
     /*  90550 */     GIR_EraseRootFromParent_Done,
     /*  90551 */   // Label 1419: @90551
     /*  90551 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(90574), // Rule ID 5063 //
     /*  90556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90567 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  90567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  90572 */     GIR_RootConstrainSelectedInstOperands,
     /*  90573 */     // GIR_Coverage, 5063,
     /*  90573 */     GIR_Done,
     /*  90574 */   // Label 1420: @90574
     /*  90574 */   GIM_Reject,
     /*  90575 */ // Label 1410: @90575
     /*  90575 */ GIM_Reject,
     /*  90576 */ // Label 1329: @90576
     /*  90576 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91267),
     /*  90581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90591 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(90687), // Rule ID 1157 //
     /*  90596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90615 */     // MIs[1] Operand 1
     /*  90615 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90650 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90656 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90662 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90670 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90672 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  90672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  90675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90685 */     GIR_RootConstrainSelectedInstOperands,
     /*  90686 */     // GIR_Coverage, 1157,
     /*  90686 */     GIR_EraseRootFromParent_Done,
     /*  90687 */   // Label 1422: @90687
     /*  90687 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(90754), // Rule ID 5028 //
     /*  90692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90704 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90708 */     // MIs[1] Operand 1
     /*  90708 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90717 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90723 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90729 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90739 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  90739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  90742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90752 */     GIR_RootConstrainSelectedInstOperands,
     /*  90753 */     // GIR_Coverage, 5028,
     /*  90753 */     GIR_EraseRootFromParent_Done,
     /*  90754 */   // Label 1423: @90754
     /*  90754 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(90839), // Rule ID 13843 //
     /*  90759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90803 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90822 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90837 */     GIR_RootConstrainSelectedInstOperands,
     /*  90838 */     // GIR_Coverage, 13843,
     /*  90838 */     GIR_EraseRootFromParent_Done,
     /*  90839 */   // Label 1424: @90839
     /*  90839 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(90924), // Rule ID 13842 //
     /*  90844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90893 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90907 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90922 */     GIR_RootConstrainSelectedInstOperands,
     /*  90923 */     // GIR_Coverage, 13842,
     /*  90923 */     GIR_EraseRootFromParent_Done,
     /*  90924 */   // Label 1425: @90924
     /*  90924 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91009), // Rule ID 13841 //
     /*  90929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90977 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90992 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91007 */     GIR_RootConstrainSelectedInstOperands,
     /*  91008 */     // GIR_Coverage, 13841,
     /*  91008 */     GIR_EraseRootFromParent_Done,
     /*  91009 */   // Label 1426: @91009
     /*  91009 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91094), // Rule ID 3824 //
     /*  91014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91067 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91077 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91092 */     GIR_RootConstrainSelectedInstOperands,
     /*  91093 */     // GIR_Coverage, 3824,
     /*  91093 */     GIR_EraseRootFromParent_Done,
     /*  91094 */   // Label 1427: @91094
     /*  91094 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91129), // Rule ID 973 //
     /*  91099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91110 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91120 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  91120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  91123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91127 */     GIR_RootConstrainSelectedInstOperands,
     /*  91128 */     // GIR_Coverage, 973,
     /*  91128 */     GIR_EraseRootFromParent_Done,
     /*  91129 */   // Label 1428: @91129
     /*  91129 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91186), // Rule ID 3820 //
     /*  91134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91169 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91184 */     GIR_RootConstrainSelectedInstOperands,
     /*  91185 */     // GIR_Coverage, 3820,
     /*  91185 */     GIR_EraseRootFromParent_Done,
     /*  91186 */   // Label 1429: @91186
     /*  91186 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(91243), // Rule ID 13837 //
     /*  91191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91226 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  91241 */     GIR_RootConstrainSelectedInstOperands,
     /*  91242 */     // GIR_Coverage, 13837,
     /*  91242 */     GIR_EraseRootFromParent_Done,
     /*  91243 */   // Label 1430: @91243
     /*  91243 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91266), // Rule ID 1600 //
     /*  91248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91259 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  91259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  91264 */     GIR_RootConstrainSelectedInstOperands,
     /*  91265 */     // GIR_Coverage, 1600,
     /*  91265 */     GIR_Done,
     /*  91266 */   // Label 1431: @91266
     /*  91266 */   GIM_Reject,
     /*  91267 */ // Label 1421: @91267
     /*  91267 */ GIM_Reject,
     /*  91268 */ // Label 1330: @91268
     /*  91268 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(91317), // Rule ID 8492 //
     /*  91273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  91276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  91279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  91282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  91286 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  91286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  91289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  91293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91298 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  91301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  91306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  91308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91311 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  91313 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  91315 */   GIR_RootConstrainSelectedInstOperands,
     /*  91316 */   // GIR_Coverage, 8492,
     /*  91316 */   GIR_EraseRootFromParent_Done,
     /*  91317 */ // Label 1432: @91317
     /*  91317 */ GIM_Reject,
     /*  91318 */ // Label 1331: @91318
     /*  91318 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(91367), // Rule ID 8491 //
     /*  91323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  91326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  91329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  91332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  91336 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  91336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  91339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  91343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91348 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  91351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  91356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  91358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91361 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  91363 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  91365 */   GIR_RootConstrainSelectedInstOperands,
     /*  91366 */   // GIR_Coverage, 8491,
     /*  91366 */   GIR_EraseRootFromParent_Done,
     /*  91367 */ // Label 1433: @91367
     /*  91367 */ GIM_Reject,
     /*  91368 */ // Label 1332: @91368
     /*  91368 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(92774),
     /*  91373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91383 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(91501), // Rule ID 15844 //
     /*  91388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91431 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91439 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91443 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91451 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91455 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91459 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91463 */     // MIs[5] Op3
     /*  91463 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91468 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91472 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91480 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91482 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  91491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  91495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91499 */     GIR_RootConstrainSelectedInstOperands,
     /*  91500 */     // GIR_Coverage, 15844,
     /*  91500 */     GIR_EraseRootFromParent_Done,
     /*  91501 */   // Label 1435: @91501
     /*  91501 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(91619), // Rule ID 15843 //
     /*  91506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91553 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91557 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91561 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91567 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91569 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91573 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91577 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91581 */     // MIs[5] Op3
     /*  91581 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91586 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91590 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91598 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91600 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  91609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  91613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91617 */     GIR_RootConstrainSelectedInstOperands,
     /*  91618 */     // GIR_Coverage, 15843,
     /*  91618 */     GIR_EraseRootFromParent_Done,
     /*  91619 */   // Label 1436: @91619
     /*  91619 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(91737), // Rule ID 15842 //
     /*  91624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91671 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91679 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91687 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91691 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91695 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91699 */     // MIs[5] Op3
     /*  91699 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91704 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91708 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91714 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91716 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91718 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  91727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  91731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91735 */     GIR_RootConstrainSelectedInstOperands,
     /*  91736 */     // GIR_Coverage, 15842,
     /*  91736 */     GIR_EraseRootFromParent_Done,
     /*  91737 */   // Label 1437: @91737
     /*  91737 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(91855), // Rule ID 15841 //
     /*  91742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91785 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91789 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91793 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91797 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91803 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91805 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91809 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91813 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91817 */     // MIs[5] Op3
     /*  91817 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91822 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91826 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91834 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91836 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  91845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  91849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91853 */     GIR_RootConstrainSelectedInstOperands,
     /*  91854 */     // GIR_Coverage, 15841,
     /*  91854 */     GIR_EraseRootFromParent_Done,
     /*  91855 */   // Label 1438: @91855
     /*  91855 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(91973), // Rule ID 15838 //
     /*  91860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  91899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91907 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91911 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  91915 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91919 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91923 */     // MIs[4] Op3
     /*  91923 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  91928 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  91932 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  91940 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91944 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91952 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91954 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  91963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  91967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  91971 */     GIR_RootConstrainSelectedInstOperands,
     /*  91972 */     // GIR_Coverage, 15838,
     /*  91972 */     GIR_EraseRootFromParent_Done,
     /*  91973 */   // Label 1439: @91973
     /*  91973 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92091), // Rule ID 15840 //
     /*  91978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92025 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92029 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  92033 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92037 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92041 */     // MIs[4] Op3
     /*  92041 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  92046 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92050 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92058 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92062 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92068 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92070 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92072 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  92081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  92085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92089 */     GIR_RootConstrainSelectedInstOperands,
     /*  92090 */     // GIR_Coverage, 15840,
     /*  92090 */     GIR_EraseRootFromParent_Done,
     /*  92091 */   // Label 1440: @92091
     /*  92091 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92209), // Rule ID 11970 //
     /*  92096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92139 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92143 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92155 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92159 */     // MIs[4] Op3
     /*  92159 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  92164 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92168 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92176 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92180 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92186 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92188 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92190 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  92199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  92203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  92207 */     GIR_RootConstrainSelectedInstOperands,
     /*  92208 */     // GIR_Coverage, 11970,
     /*  92208 */     GIR_EraseRootFromParent_Done,
     /*  92209 */   // Label 1441: @92209
     /*  92209 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92327), // Rule ID 15839 //
     /*  92214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92257 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92261 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92265 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92269 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92273 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92277 */     // MIs[4] Op3
     /*  92277 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  92282 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92286 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92292 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92294 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92298 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92304 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92306 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92308 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  92317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  92321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92325 */     GIR_RootConstrainSelectedInstOperands,
     /*  92326 */     // GIR_Coverage, 15839,
     /*  92326 */     GIR_EraseRootFromParent_Done,
     /*  92327 */   // Label 1442: @92327
     /*  92327 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92398), // Rule ID 15704 //
     /*  92332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92371 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92377 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92381 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  92388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92396 */     GIR_RootConstrainSelectedInstOperands,
     /*  92397 */     // GIR_Coverage, 15704,
     /*  92397 */     GIR_EraseRootFromParent_Done,
     /*  92398 */   // Label 1443: @92398
     /*  92398 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92469), // Rule ID 15703 //
     /*  92403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92442 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92452 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  92459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92467 */     GIR_RootConstrainSelectedInstOperands,
     /*  92468 */     // GIR_Coverage, 15703,
     /*  92468 */     GIR_EraseRootFromParent_Done,
     /*  92469 */   // Label 1444: @92469
     /*  92469 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92540), // Rule ID 15702 //
     /*  92474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92513 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92523 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92538 */     GIR_RootConstrainSelectedInstOperands,
     /*  92539 */     // GIR_Coverage, 15702,
     /*  92539 */     GIR_EraseRootFromParent_Done,
     /*  92540 */   // Label 1445: @92540
     /*  92540 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92611), // Rule ID 11934 //
     /*  92545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92584 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92594 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92609 */     GIR_RootConstrainSelectedInstOperands,
     /*  92610 */     // GIR_Coverage, 11934,
     /*  92610 */     GIR_EraseRootFromParent_Done,
     /*  92611 */   // Label 1446: @92611
     /*  92611 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92672), // Rule ID 11969 //
     /*  92616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  92627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92635 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  92639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  92643 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92649 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  92651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  92653 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  92662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  92666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  92670 */     GIR_RootConstrainSelectedInstOperands,
     /*  92671 */     // GIR_Coverage, 11969,
     /*  92671 */     GIR_EraseRootFromParent_Done,
     /*  92672 */   // Label 1447: @92672
     /*  92672 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92715), // Rule ID 13804 //
     /*  92677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92698 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  92701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  92707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  92713 */     GIR_RootConstrainSelectedInstOperands,
     /*  92714 */     // GIR_Coverage, 13804,
     /*  92714 */     GIR_EraseRootFromParent_Done,
     /*  92715 */   // Label 1448: @92715
     /*  92715 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(92758), // Rule ID 3147 //
     /*  92720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92741 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  92744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  92756 */     GIR_RootConstrainSelectedInstOperands,
     /*  92757 */     // GIR_Coverage, 3147,
     /*  92757 */     GIR_EraseRootFromParent_Done,
     /*  92758 */   // Label 1449: @92758
     /*  92758 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92773), // Rule ID 7511 //
     /*  92763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92766 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  92766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  92771 */     GIR_RootConstrainSelectedInstOperands,
     /*  92772 */     // GIR_Coverage, 7511,
     /*  92772 */     GIR_Done,
     /*  92773 */   // Label 1450: @92773
     /*  92773 */   GIM_Reject,
     /*  92774 */ // Label 1434: @92774
     /*  92774 */ GIM_Reject,
     /*  92775 */ // Label 1333: @92775
     /*  92775 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(92824), // Rule ID 8490 //
     /*  92780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  92786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  92789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  92793 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  92793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  92796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  92800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92805 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  92808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  92813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  92815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92818 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92820 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  92822 */   GIR_RootConstrainSelectedInstOperands,
     /*  92823 */   // GIR_Coverage, 8490,
     /*  92823 */   GIR_EraseRootFromParent_Done,
     /*  92824 */ // Label 1451: @92824
     /*  92824 */ GIM_Reject,
     /*  92825 */ // Label 1334: @92825
     /*  92825 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(94231),
     /*  92830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92840 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(92958), // Rule ID 15837 //
     /*  92845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  92884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92900 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92906 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92908 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  92912 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92916 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92920 */     // MIs[5] Op3
     /*  92920 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  92925 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92929 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92935 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92937 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92939 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  92939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  92948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  92952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  92956 */     GIR_RootConstrainSelectedInstOperands,
     /*  92957 */     // GIR_Coverage, 15837,
     /*  92957 */     GIR_EraseRootFromParent_Done,
     /*  92958 */   // Label 1453: @92958
     /*  92958 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(93076), // Rule ID 15836 //
     /*  92963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93006 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93010 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93018 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93024 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93026 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93030 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93034 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93038 */     // MIs[5] Op3
     /*  93038 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93043 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93047 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93055 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93057 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  93070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93074 */     GIR_RootConstrainSelectedInstOperands,
     /*  93075 */     // GIR_Coverage, 15836,
     /*  93075 */     GIR_EraseRootFromParent_Done,
     /*  93076 */   // Label 1454: @93076
     /*  93076 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93194), // Rule ID 15835 //
     /*  93081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93132 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93136 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93142 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93144 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93148 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93152 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93156 */     // MIs[5] Op3
     /*  93156 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93161 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93165 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93171 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93173 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93175 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  93184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93192 */     GIR_RootConstrainSelectedInstOperands,
     /*  93193 */     // GIR_Coverage, 15835,
     /*  93193 */     GIR_EraseRootFromParent_Done,
     /*  93194 */   // Label 1455: @93194
     /*  93194 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(93312), // Rule ID 15834 //
     /*  93199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93242 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93246 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93250 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93254 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93260 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93262 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93266 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93270 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93274 */     // MIs[5] Op3
     /*  93274 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93279 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93283 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93291 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93293 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93310 */     GIR_RootConstrainSelectedInstOperands,
     /*  93311 */     // GIR_Coverage, 15834,
     /*  93311 */     GIR_EraseRootFromParent_Done,
     /*  93312 */   // Label 1456: @93312
     /*  93312 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(93430), // Rule ID 15831 //
     /*  93317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93360 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93364 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93372 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93376 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93380 */     // MIs[4] Op3
     /*  93380 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93385 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93389 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93395 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93397 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93401 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93407 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93409 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93411 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93428 */     GIR_RootConstrainSelectedInstOperands,
     /*  93429 */     // GIR_Coverage, 15831,
     /*  93429 */     GIR_EraseRootFromParent_Done,
     /*  93430 */   // Label 1457: @93430
     /*  93430 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(93548), // Rule ID 15833 //
     /*  93435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93478 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93490 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93494 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93498 */     // MIs[4] Op3
     /*  93498 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93503 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93507 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93515 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93519 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93527 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93529 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93546 */     GIR_RootConstrainSelectedInstOperands,
     /*  93547 */     // GIR_Coverage, 15833,
     /*  93547 */     GIR_EraseRootFromParent_Done,
     /*  93548 */   // Label 1458: @93548
     /*  93548 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(93666), // Rule ID 11968 //
     /*  93553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93596 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93600 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93612 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93616 */     // MIs[4] Op3
     /*  93616 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93621 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93625 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93633 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93637 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93643 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93645 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93647 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93664 */     GIR_RootConstrainSelectedInstOperands,
     /*  93665 */     // GIR_Coverage, 11968,
     /*  93665 */     GIR_EraseRootFromParent_Done,
     /*  93666 */   // Label 1459: @93666
     /*  93666 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(93784), // Rule ID 15832 //
     /*  93671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93722 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93726 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93730 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93734 */     // MIs[4] Op3
     /*  93734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93739 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93743 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93749 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93751 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93755 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93763 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93765 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93782 */     GIR_RootConstrainSelectedInstOperands,
     /*  93783 */     // GIR_Coverage, 15832,
     /*  93783 */     GIR_EraseRootFromParent_Done,
     /*  93784 */   // Label 1460: @93784
     /*  93784 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93855), // Rule ID 15701 //
     /*  93789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93828 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93838 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93853 */     GIR_RootConstrainSelectedInstOperands,
     /*  93854 */     // GIR_Coverage, 15701,
     /*  93854 */     GIR_EraseRootFromParent_Done,
     /*  93855 */   // Label 1461: @93855
     /*  93855 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(93926), // Rule ID 15700 //
     /*  93860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93899 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93905 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93909 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  93920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93924 */     GIR_RootConstrainSelectedInstOperands,
     /*  93925 */     // GIR_Coverage, 15700,
     /*  93925 */     GIR_EraseRootFromParent_Done,
     /*  93926 */   // Label 1462: @93926
     /*  93926 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(93997), // Rule ID 15699 //
     /*  93931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  93938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93970 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93980 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  93987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93995 */     GIR_RootConstrainSelectedInstOperands,
     /*  93996 */     // GIR_Coverage, 15699,
     /*  93996 */     GIR_EraseRootFromParent_Done,
     /*  93997 */   // Label 1463: @93997
     /*  93997 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(94068), // Rule ID 11932 //
     /*  94002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94041 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94047 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94051 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94066 */     GIR_RootConstrainSelectedInstOperands,
     /*  94067 */     // GIR_Coverage, 11932,
     /*  94067 */     GIR_EraseRootFromParent_Done,
     /*  94068 */   // Label 1464: @94068
     /*  94068 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(94129), // Rule ID 11967 //
     /*  94073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  94084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94092 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  94096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  94100 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94106 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  94108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94110 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  94119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  94123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  94127 */     GIR_RootConstrainSelectedInstOperands,
     /*  94128 */     // GIR_Coverage, 11967,
     /*  94128 */     GIR_EraseRootFromParent_Done,
     /*  94129 */   // Label 1465: @94129
     /*  94129 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(94172), // Rule ID 13803 //
     /*  94134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94155 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  94164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  94170 */     GIR_RootConstrainSelectedInstOperands,
     /*  94171 */     // GIR_Coverage, 13803,
     /*  94171 */     GIR_EraseRootFromParent_Done,
     /*  94172 */   // Label 1466: @94172
     /*  94172 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(94215), // Rule ID 3145 //
     /*  94177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94198 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  94213 */     GIR_RootConstrainSelectedInstOperands,
     /*  94214 */     // GIR_Coverage, 3145,
     /*  94214 */     GIR_EraseRootFromParent_Done,
     /*  94215 */   // Label 1467: @94215
     /*  94215 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(94230), // Rule ID 7510 //
     /*  94220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94223 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  94223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  94228 */     GIR_RootConstrainSelectedInstOperands,
     /*  94229 */     // GIR_Coverage, 7510,
     /*  94229 */     GIR_Done,
     /*  94230 */   // Label 1468: @94230
     /*  94230 */   GIM_Reject,
     /*  94231 */ // Label 1452: @94231
     /*  94231 */ GIM_Reject,
     /*  94232 */ // Label 1335: @94232
     /*  94232 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(94281), // Rule ID 8489 //
     /*  94237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  94243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  94246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  94250 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  94250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  94253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  94257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94262 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  94265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  94270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  94272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94275 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94277 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  94279 */   GIR_RootConstrainSelectedInstOperands,
     /*  94280 */   // GIR_Coverage, 8489,
     /*  94280 */   GIR_EraseRootFromParent_Done,
     /*  94281 */ // Label 1469: @94281
     /*  94281 */ GIM_Reject,
     /*  94282 */ // Label 1336: @94282
     /*  94282 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(95688),
     /*  94287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94297 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(94415), // Rule ID 15830 //
     /*  94302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94345 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94349 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94353 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94357 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94365 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94369 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94373 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94377 */     // MIs[5] Op3
     /*  94377 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94382 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94386 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94394 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94396 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94413 */     GIR_RootConstrainSelectedInstOperands,
     /*  94414 */     // GIR_Coverage, 15830,
     /*  94414 */     GIR_EraseRootFromParent_Done,
     /*  94415 */   // Label 1471: @94415
     /*  94415 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(94533), // Rule ID 15829 //
     /*  94420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94463 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94467 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94475 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94483 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94487 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94491 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94495 */     // MIs[5] Op3
     /*  94495 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94500 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94504 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94510 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94512 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94514 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94531 */     GIR_RootConstrainSelectedInstOperands,
     /*  94532 */     // GIR_Coverage, 15829,
     /*  94532 */     GIR_EraseRootFromParent_Done,
     /*  94533 */   // Label 1472: @94533
     /*  94533 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(94651), // Rule ID 15828 //
     /*  94538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94581 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94585 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94589 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94593 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94601 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94605 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94609 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94613 */     // MIs[5] Op3
     /*  94613 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94618 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94622 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94630 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94632 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94649 */     GIR_RootConstrainSelectedInstOperands,
     /*  94650 */     // GIR_Coverage, 15828,
     /*  94650 */     GIR_EraseRootFromParent_Done,
     /*  94651 */   // Label 1473: @94651
     /*  94651 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(94769), // Rule ID 15827 //
     /*  94656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94699 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94703 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94707 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94711 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94719 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94723 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94727 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94731 */     // MIs[5] Op3
     /*  94731 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94736 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94740 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94746 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94748 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94750 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94767 */     GIR_RootConstrainSelectedInstOperands,
     /*  94768 */     // GIR_Coverage, 15827,
     /*  94768 */     GIR_EraseRootFromParent_Done,
     /*  94769 */   // Label 1474: @94769
     /*  94769 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(94887), // Rule ID 15824 //
     /*  94774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94821 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94825 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94829 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94833 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94837 */     // MIs[4] Op3
     /*  94837 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  94842 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94846 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94852 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94854 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94858 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94864 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94866 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94868 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  94877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  94885 */     GIR_RootConstrainSelectedInstOperands,
     /*  94886 */     // GIR_Coverage, 15824,
     /*  94886 */     GIR_EraseRootFromParent_Done,
     /*  94887 */   // Label 1475: @94887
     /*  94887 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(95005), // Rule ID 15826 //
     /*  94892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94939 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94943 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94947 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94951 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94955 */     // MIs[4] Op3
     /*  94955 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  94960 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94964 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94972 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94976 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94982 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94984 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94986 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  94995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95003 */     GIR_RootConstrainSelectedInstOperands,
     /*  95004 */     // GIR_Coverage, 15826,
     /*  95004 */     GIR_EraseRootFromParent_Done,
     /*  95005 */   // Label 1476: @95005
     /*  95005 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(95123), // Rule ID 11966 //
     /*  95010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95057 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95061 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95065 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95069 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95073 */     // MIs[4] Op3
     /*  95073 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  95078 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95082 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95090 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95094 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95100 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95102 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95104 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  95113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  95121 */     GIR_RootConstrainSelectedInstOperands,
     /*  95122 */     // GIR_Coverage, 11966,
     /*  95122 */     GIR_EraseRootFromParent_Done,
     /*  95123 */   // Label 1477: @95123
     /*  95123 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(95241), // Rule ID 15825 //
     /*  95128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95171 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95175 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95179 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95183 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95187 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95191 */     // MIs[4] Op3
     /*  95191 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  95196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95200 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95208 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95212 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95218 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95220 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95222 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95239 */     GIR_RootConstrainSelectedInstOperands,
     /*  95240 */     // GIR_Coverage, 15825,
     /*  95240 */     GIR_EraseRootFromParent_Done,
     /*  95241 */   // Label 1478: @95241
     /*  95241 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(95312), // Rule ID 15698 //
     /*  95246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95285 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95295 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95310 */     GIR_RootConstrainSelectedInstOperands,
     /*  95311 */     // GIR_Coverage, 15698,
     /*  95311 */     GIR_EraseRootFromParent_Done,
     /*  95312 */   // Label 1479: @95312
     /*  95312 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(95383), // Rule ID 15697 //
     /*  95317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95356 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95366 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95381 */     GIR_RootConstrainSelectedInstOperands,
     /*  95382 */     // GIR_Coverage, 15697,
     /*  95382 */     GIR_EraseRootFromParent_Done,
     /*  95383 */   // Label 1480: @95383
     /*  95383 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(95454), // Rule ID 15696 //
     /*  95388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95427 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95433 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95437 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95452 */     GIR_RootConstrainSelectedInstOperands,
     /*  95453 */     // GIR_Coverage, 15696,
     /*  95453 */     GIR_EraseRootFromParent_Done,
     /*  95454 */   // Label 1481: @95454
     /*  95454 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(95525), // Rule ID 11930 //
     /*  95459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95498 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95508 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95523 */     GIR_RootConstrainSelectedInstOperands,
     /*  95524 */     // GIR_Coverage, 11930,
     /*  95524 */     GIR_EraseRootFromParent_Done,
     /*  95525 */   // Label 1482: @95525
     /*  95525 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(95586), // Rule ID 11965 //
     /*  95530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  95541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  95553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  95557 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  95565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95567 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  95576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  95580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  95584 */     GIR_RootConstrainSelectedInstOperands,
     /*  95585 */     // GIR_Coverage, 11965,
     /*  95585 */     GIR_EraseRootFromParent_Done,
     /*  95586 */   // Label 1483: @95586
     /*  95586 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(95629), // Rule ID 13802 //
     /*  95591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95612 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  95621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  95627 */     GIR_RootConstrainSelectedInstOperands,
     /*  95628 */     // GIR_Coverage, 13802,
     /*  95628 */     GIR_EraseRootFromParent_Done,
     /*  95629 */   // Label 1484: @95629
     /*  95629 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(95672), // Rule ID 3143 //
     /*  95634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95655 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  95670 */     GIR_RootConstrainSelectedInstOperands,
     /*  95671 */     // GIR_Coverage, 3143,
     /*  95671 */     GIR_EraseRootFromParent_Done,
     /*  95672 */   // Label 1485: @95672
     /*  95672 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(95687), // Rule ID 7509 //
     /*  95677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95680 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  95680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  95685 */     GIR_RootConstrainSelectedInstOperands,
     /*  95686 */     // GIR_Coverage, 7509,
     /*  95686 */     GIR_Done,
     /*  95687 */   // Label 1486: @95687
     /*  95687 */   GIM_Reject,
     /*  95688 */ // Label 1470: @95688
     /*  95688 */ GIM_Reject,
     /*  95689 */ // Label 1337: @95689
     /*  95689 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(95738), // Rule ID 8488 //
     /*  95694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  95700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  95703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  95707 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  95707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  95710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  95714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95719 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  95722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  95727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  95729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95732 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95734 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  95736 */   GIR_RootConstrainSelectedInstOperands,
     /*  95737 */   // GIR_Coverage, 8488,
     /*  95737 */   GIR_EraseRootFromParent_Done,
     /*  95738 */ // Label 1487: @95738
     /*  95738 */ GIM_Reject,
     /*  95739 */ // Label 1338: @95739
     /*  95739 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(97145),
     /*  95744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95754 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(95872), // Rule ID 15823 //
     /*  95759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95806 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95814 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95822 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95826 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95830 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95834 */     // MIs[5] Op3
     /*  95834 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95839 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95843 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95851 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95853 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  95853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  95862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95870 */     GIR_RootConstrainSelectedInstOperands,
     /*  95871 */     // GIR_Coverage, 15823,
     /*  95871 */     GIR_EraseRootFromParent_Done,
     /*  95872 */   // Label 1489: @95872
     /*  95872 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(95990), // Rule ID 15822 //
     /*  95877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95928 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95932 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95940 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95944 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95948 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95952 */     // MIs[5] Op3
     /*  95952 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95957 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95961 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95969 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95971 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  95971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  95980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95988 */     GIR_RootConstrainSelectedInstOperands,
     /*  95989 */     // GIR_Coverage, 15822,
     /*  95989 */     GIR_EraseRootFromParent_Done,
     /*  95990 */   // Label 1490: @95990
     /*  95990 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(96108), // Rule ID 15821 //
     /*  95995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96042 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96046 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96050 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96058 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96062 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96066 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96070 */     // MIs[5] Op3
     /*  96070 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96075 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96079 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96085 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96087 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96089 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  96098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96106 */     GIR_RootConstrainSelectedInstOperands,
     /*  96107 */     // GIR_Coverage, 15821,
     /*  96107 */     GIR_EraseRootFromParent_Done,
     /*  96108 */   // Label 1491: @96108
     /*  96108 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(96226), // Rule ID 15820 //
     /*  96113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96160 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96168 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96176 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96180 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96184 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96188 */     // MIs[5] Op3
     /*  96188 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96193 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96197 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96203 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96205 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96207 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96224 */     GIR_RootConstrainSelectedInstOperands,
     /*  96225 */     // GIR_Coverage, 15820,
     /*  96225 */     GIR_EraseRootFromParent_Done,
     /*  96226 */   // Label 1492: @96226
     /*  96226 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(96344), // Rule ID 15817 //
     /*  96231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96282 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96286 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96290 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96294 */     // MIs[4] Op3
     /*  96294 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96299 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96303 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96309 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96311 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96315 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96321 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96323 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96325 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96342 */     GIR_RootConstrainSelectedInstOperands,
     /*  96343 */     // GIR_Coverage, 15817,
     /*  96343 */     GIR_EraseRootFromParent_Done,
     /*  96344 */   // Label 1493: @96344
     /*  96344 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(96462), // Rule ID 15819 //
     /*  96349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96392 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96396 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96408 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96412 */     // MIs[4] Op3
     /*  96412 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96417 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96421 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96429 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96433 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96439 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96441 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96443 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96460 */     GIR_RootConstrainSelectedInstOperands,
     /*  96461 */     // GIR_Coverage, 15819,
     /*  96461 */     GIR_EraseRootFromParent_Done,
     /*  96462 */   // Label 1494: @96462
     /*  96462 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(96580), // Rule ID 11964 //
     /*  96467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96510 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96514 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96518 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96522 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96526 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96530 */     // MIs[4] Op3
     /*  96530 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96535 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96539 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96545 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96547 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96551 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96559 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96561 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96578 */     GIR_RootConstrainSelectedInstOperands,
     /*  96579 */     // GIR_Coverage, 11964,
     /*  96579 */     GIR_EraseRootFromParent_Done,
     /*  96580 */   // Label 1495: @96580
     /*  96580 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(96698), // Rule ID 15818 //
     /*  96585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96632 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96636 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96640 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96644 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96648 */     // MIs[4] Op3
     /*  96648 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96653 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96657 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96665 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96669 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96677 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96679 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96696 */     GIR_RootConstrainSelectedInstOperands,
     /*  96697 */     // GIR_Coverage, 15818,
     /*  96697 */     GIR_EraseRootFromParent_Done,
     /*  96698 */   // Label 1496: @96698
     /*  96698 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(96769), // Rule ID 15695 //
     /*  96703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96752 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96767 */     GIR_RootConstrainSelectedInstOperands,
     /*  96768 */     // GIR_Coverage, 15695,
     /*  96768 */     GIR_EraseRootFromParent_Done,
     /*  96769 */   // Label 1497: @96769
     /*  96769 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(96840), // Rule ID 15694 //
     /*  96774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96813 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96819 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96823 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96838 */     GIR_RootConstrainSelectedInstOperands,
     /*  96839 */     // GIR_Coverage, 15694,
     /*  96839 */     GIR_EraseRootFromParent_Done,
     /*  96840 */   // Label 1498: @96840
     /*  96840 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(96911), // Rule ID 15693 //
     /*  96845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96884 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96890 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96894 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96909 */     GIR_RootConstrainSelectedInstOperands,
     /*  96910 */     // GIR_Coverage, 15693,
     /*  96910 */     GIR_EraseRootFromParent_Done,
     /*  96911 */   // Label 1499: @96911
     /*  96911 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(96982), // Rule ID 11928 //
     /*  96916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96955 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96965 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96980 */     GIR_RootConstrainSelectedInstOperands,
     /*  96981 */     // GIR_Coverage, 11928,
     /*  96981 */     GIR_EraseRootFromParent_Done,
     /*  96982 */   // Label 1500: @96982
     /*  96982 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(97043), // Rule ID 11963 //
     /*  96987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  96998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97006 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  97010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  97014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  97022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97024 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  97033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  97037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  97041 */     GIR_RootConstrainSelectedInstOperands,
     /*  97042 */     // GIR_Coverage, 11963,
     /*  97042 */     GIR_EraseRootFromParent_Done,
     /*  97043 */   // Label 1501: @97043
     /*  97043 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(97086), // Rule ID 13801 //
     /*  97048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97069 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  97078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  97082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  97084 */     GIR_RootConstrainSelectedInstOperands,
     /*  97085 */     // GIR_Coverage, 13801,
     /*  97085 */     GIR_EraseRootFromParent_Done,
     /*  97086 */   // Label 1502: @97086
     /*  97086 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(97129), // Rule ID 3141 //
     /*  97091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97112 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  97123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  97127 */     GIR_RootConstrainSelectedInstOperands,
     /*  97128 */     // GIR_Coverage, 3141,
     /*  97128 */     GIR_EraseRootFromParent_Done,
     /*  97129 */   // Label 1503: @97129
     /*  97129 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(97144), // Rule ID 7508 //
     /*  97134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97137 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  97137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  97142 */     GIR_RootConstrainSelectedInstOperands,
     /*  97143 */     // GIR_Coverage, 7508,
     /*  97143 */     GIR_Done,
     /*  97144 */   // Label 1504: @97144
     /*  97144 */   GIM_Reject,
     /*  97145 */ // Label 1488: @97145
     /*  97145 */ GIM_Reject,
     /*  97146 */ // Label 1339: @97146
     /*  97146 */ GIM_Reject,
     /*  97147 */ // Label 8: @97147
     /*  97147 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(104670),
     /*  97152 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  97155 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1517*/ GIMT_Encode4(104669),
     /*  97166 */   /*GILLT_v2s64*//*Label 1506*/ GIMT_Encode4(97234), GIMT_Encode4(0),
     /*  97174 */   /*GILLT_v4s32*//*Label 1507*/ GIMT_Encode4(97755), GIMT_Encode4(0),
     /*  97182 */   /*GILLT_v8s16*//*Label 1508*/ GIMT_Encode4(100167),
     /*  97186 */   /*GILLT_v16s8*//*Label 1509*/ GIMT_Encode4(102576), GIMT_Encode4(0),
     /*  97194 */   /*GILLT_nxv2s1*//*Label 1510*/ GIMT_Encode4(104487), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  97210 */   /*GILLT_nxv4s1*//*Label 1511*/ GIMT_Encode4(104513),
     /*  97214 */   /*GILLT_nxv4s16*//*Label 1512*/ GIMT_Encode4(104539),
     /*  97218 */   /*GILLT_nxv4s32*//*Label 1513*/ GIMT_Encode4(104565),
     /*  97222 */   /*GILLT_nxv8s1*//*Label 1514*/ GIMT_Encode4(104591),
     /*  97226 */   /*GILLT_nxv8s16*//*Label 1515*/ GIMT_Encode4(104617),
     /*  97230 */   /*GILLT_nxv16s1*//*Label 1516*/ GIMT_Encode4(104643),
     /*  97234 */   // Label 1506: @97234
     /*  97234 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(97754),
     /*  97239 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  97245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97253 */     GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(97315), // Rule ID 5820 //
     /*  97258 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97262 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97268 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  97270 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97272 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  97272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  97279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97284 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97288 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97290 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97293 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97295 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97301 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97304 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97314 */       // GIR_Coverage, 5820,
     /*  97314 */       GIR_EraseRootFromParent_Done,
     /*  97315 */     // Label 1519: @97315
     /*  97315 */     GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(97377), // Rule ID 5824 //
     /*  97320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97324 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97330 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  97332 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97334 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  97334 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97337 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  97341 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97346 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97350 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97352 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97355 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97357 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97360 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97363 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97366 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97371 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97376 */       // GIR_Coverage, 5824,
     /*  97376 */       GIR_EraseRootFromParent_Done,
     /*  97377 */     // Label 1520: @97377
     /*  97377 */     GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(97435), // Rule ID 5821 //
     /*  97382 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97386 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  97390 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97392 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  97392 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  97395 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97399 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97404 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97406 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97409 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97411 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97414 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  97416 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97419 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97424 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97429 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97434 */       // GIR_Coverage, 5821,
     /*  97434 */       GIR_EraseRootFromParent_Done,
     /*  97435 */     // Label 1521: @97435
     /*  97435 */     GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(97493), // Rule ID 5825 //
     /*  97440 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97444 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  97448 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97450 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  97450 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  97453 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97457 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97462 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97464 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97467 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97469 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97472 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  97474 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97477 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97482 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97487 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97492 */       // GIR_Coverage, 5825,
     /*  97492 */       GIR_EraseRootFromParent_Done,
     /*  97493 */     // Label 1522: @97493
     /*  97493 */     GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(97623), // Rule ID 5819 //
     /*  97498 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97502 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  97502 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  97505 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97509 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97514 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97516 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  97519 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97523 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97528 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97531 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  97535 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  97538 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97543 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97548 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97553 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97556 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97560 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97565 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97567 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97570 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97574 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97579 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97582 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97586 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97589 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97594 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97599 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97604 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  97607 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97609 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97612 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  97615 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97618 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97621 */       GIR_RootConstrainSelectedInstOperands,
     /*  97622 */       // GIR_Coverage, 5819,
     /*  97622 */       GIR_EraseRootFromParent_Done,
     /*  97623 */     // Label 1523: @97623
     /*  97623 */     GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(97753), // Rule ID 5823 //
     /*  97628 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97632 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  97632 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  97635 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97639 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97644 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97646 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  97649 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97653 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97658 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97661 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  97665 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  97668 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97673 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97678 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97683 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97686 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97690 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97695 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97697 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97700 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97704 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97709 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97712 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97716 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97719 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97724 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97729 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97734 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  97737 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97739 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97742 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  97745 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97748 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97751 */       GIR_RootConstrainSelectedInstOperands,
     /*  97752 */       // GIR_Coverage, 5823,
     /*  97752 */       GIR_EraseRootFromParent_Done,
     /*  97753 */     // Label 1524: @97753
     /*  97753 */     GIM_Reject,
     /*  97754 */   // Label 1518: @97754
     /*  97754 */   GIM_Reject,
     /*  97755 */   // Label 1507: @97755
     /*  97755 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(100166),
     /*  97760 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  97766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97770 */     GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97899), // Rule ID 5443 //
     /*  97775 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97779 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97783 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  97787 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97791 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97795 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  97799 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97803 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97807 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97811 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97815 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  97819 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97824 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97828 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97834 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97836 */       // MIs[2] Operand 2
     /*  97836 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  97847 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  97849 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  97849 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97852 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97856 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97861 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  97864 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97868 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97871 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97876 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97881 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  97884 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97886 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97889 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  97893 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  97897 */       GIR_RootConstrainSelectedInstOperands,
     /*  97898 */       // GIR_Coverage, 5443,
     /*  97898 */       GIR_EraseRootFromParent_Done,
     /*  97899 */     // Label 1526: @97899
     /*  97899 */     GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(98021), // Rule ID 5439 //
     /*  97904 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97908 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97912 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  97916 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97920 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97924 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  97928 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97932 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97936 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  97940 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97944 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  97948 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97953 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97958 */       // MIs[2] Operand 2
     /*  97958 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  97969 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  97971 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  97971 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97974 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97978 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97983 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  97986 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97990 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97993 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97998 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98003 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  98006 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98008 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98011 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  98015 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  98019 */       GIR_RootConstrainSelectedInstOperands,
     /*  98020 */       // GIR_Coverage, 5439,
     /*  98020 */       GIR_EraseRootFromParent_Done,
     /*  98021 */     // Label 1527: @98021
     /*  98021 */     GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(98143), // Rule ID 5441 //
     /*  98026 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98030 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98034 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98038 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98042 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98046 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98050 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98054 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  98058 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  98062 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98066 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98070 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98075 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98080 */       // MIs[2] Operand 2
     /*  98080 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  98091 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98093 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98093 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98096 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98100 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98105 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  98108 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98112 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98115 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98120 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98125 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  98128 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98130 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98133 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  98137 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  98141 */       GIR_RootConstrainSelectedInstOperands,
     /*  98142 */       // GIR_Coverage, 5441,
     /*  98142 */       GIR_EraseRootFromParent_Done,
     /*  98143 */     // Label 1528: @98143
     /*  98143 */     GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(98245), // Rule ID 5589 //
     /*  98148 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98152 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98156 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98160 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98164 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98168 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98172 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98177 */       // MIs[2] Operand 2
     /*  98177 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  98188 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  98192 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98196 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98200 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  98204 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98208 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98212 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98217 */       // MIs[4] Operand 2
     /*  98217 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  98228 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  98230 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  98230 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  98233 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98235 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  98239 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  98243 */       GIR_RootConstrainSelectedInstOperands,
     /*  98244 */       // GIR_Coverage, 5589,
     /*  98244 */       GIR_EraseRootFromParent_Done,
     /*  98245 */     // Label 1529: @98245
     /*  98245 */     GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(98374), // Rule ID 6375 //
     /*  98250 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98254 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98258 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98262 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98265 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  98270 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98274 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98278 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98283 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  98287 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98289 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  98289 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  98292 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  98296 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98301 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98304 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98306 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98309 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98313 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98318 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98320 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98323 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98327 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98332 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98335 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  98339 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98342 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98347 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98352 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  98360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98362 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98365 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  98369 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98372 */       GIR_RootConstrainSelectedInstOperands,
     /*  98373 */       // GIR_Coverage, 6375,
     /*  98373 */       GIR_EraseRootFromParent_Done,
     /*  98374 */     // Label 1530: @98374
     /*  98374 */     GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(98416), // Rule ID 5830 //
     /*  98379 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  98386 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  98393 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  98393 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  98396 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98398 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  98403 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98406 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98411 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  98414 */       GIR_RootConstrainSelectedInstOperands,
     /*  98415 */       // GIR_Coverage, 5830,
     /*  98415 */       GIR_EraseRootFromParent_Done,
     /*  98416 */     // Label 1531: @98416
     /*  98416 */     GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(98458), // Rule ID 5834 //
     /*  98421 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  98428 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  98435 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  98435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  98438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98440 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  98445 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98448 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98453 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  98456 */       GIR_RootConstrainSelectedInstOperands,
     /*  98457 */       // GIR_Coverage, 5834,
     /*  98457 */       GIR_EraseRootFromParent_Done,
     /*  98458 */     // Label 1532: @98458
     /*  98458 */     GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(98581), // Rule ID 2571 //
     /*  98463 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98466 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98470 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98474 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98478 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98481 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  98486 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98490 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98494 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98499 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98503 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98507 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98511 */       // MIs[2] Operand 1
     /*  98511 */       // No operand predicates
     /*  98511 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98513 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  98513 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98516 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98520 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98525 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98527 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98530 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98534 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98539 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98542 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98546 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98549 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98554 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98564 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  98567 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98569 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98572 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  98576 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  98579 */       GIR_RootConstrainSelectedInstOperands,
     /*  98580 */       // GIR_Coverage, 2571,
     /*  98580 */       GIR_EraseRootFromParent_Done,
     /*  98581 */     // Label 1533: @98581
     /*  98581 */     GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(98704), // Rule ID 6345 //
     /*  98586 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98605 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98609 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  98613 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98617 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98622 */       // MIs[2] imm
     /*  98622 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98626 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98630 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98634 */       // MIs[3] Operand 1
     /*  98634 */       // No operand predicates
     /*  98634 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98636 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  98636 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98639 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98643 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98648 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98650 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98653 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98657 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98662 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98665 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98669 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98672 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98677 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98682 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98687 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  98690 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98692 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98695 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  98699 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  98702 */       GIR_RootConstrainSelectedInstOperands,
     /*  98703 */       // GIR_Coverage, 6345,
     /*  98703 */       GIR_EraseRootFromParent_Done,
     /*  98704 */     // Label 1534: @98704
     /*  98704 */     GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(98824), // Rule ID 6381 //
     /*  98709 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98713 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98717 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98721 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98725 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98729 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98733 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98737 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98742 */       // MIs[2] imm
     /*  98742 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98746 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98750 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98754 */       // MIs[3] Operand 1
     /*  98754 */       // No operand predicates
     /*  98754 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98756 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  98756 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98759 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98763 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98768 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98770 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98773 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98777 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98782 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98785 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98789 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98792 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98797 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98802 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98807 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  98810 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98812 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98815 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  98819 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  98822 */       GIR_RootConstrainSelectedInstOperands,
     /*  98823 */       // GIR_Coverage, 6381,
     /*  98823 */       GIR_EraseRootFromParent_Done,
     /*  98824 */     // Label 1535: @98824
     /*  98824 */     GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98941), // Rule ID 2494 //
     /*  98829 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98832 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98836 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98840 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98844 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98847 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  98852 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98856 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98860 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98865 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98870 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98872 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 576:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98872 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98875 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98879 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98884 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98886 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98889 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98893 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98898 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98901 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98905 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98908 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98913 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98918 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98923 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  98926 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98928 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98931 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  98935 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  98939 */       GIR_RootConstrainSelectedInstOperands,
     /*  98940 */       // GIR_Coverage, 2494,
     /*  98940 */       GIR_EraseRootFromParent_Done,
     /*  98941 */     // Label 1536: @98941
     /*  98941 */     GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(99058), // Rule ID 5359 //
     /*  98946 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98949 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98953 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98957 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98961 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98964 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  98969 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98973 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98977 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98982 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98987 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98989 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 721:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98989 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98992 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98996 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99001 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99003 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99006 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99010 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99015 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99018 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99022 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99025 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99030 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99035 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99040 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99043 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99045 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99048 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99052 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99056 */       GIR_RootConstrainSelectedInstOperands,
     /*  99057 */       // GIR_Coverage, 5359,
     /*  99057 */       GIR_EraseRootFromParent_Done,
     /*  99058 */     // Label 1537: @99058
     /*  99058 */     GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(99175), // Rule ID 5362 //
     /*  99063 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99066 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99070 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99074 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99078 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99081 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  99086 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99090 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99094 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99099 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99104 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99106 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99106 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99109 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99113 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99118 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99120 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99123 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99127 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99132 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99135 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99139 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99142 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99147 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99152 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99157 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  99160 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99162 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99165 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99169 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99173 */       GIR_RootConstrainSelectedInstOperands,
     /*  99174 */       // GIR_Coverage, 5362,
     /*  99174 */       GIR_EraseRootFromParent_Done,
     /*  99175 */     // Label 1538: @99175
     /*  99175 */     GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99292), // Rule ID 5365 //
     /*  99180 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99183 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99187 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99191 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99195 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99198 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  99203 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99207 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99211 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99216 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99221 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99223 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 665:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99223 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99226 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99230 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99235 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99237 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99240 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99244 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99249 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99252 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99256 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99259 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99264 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99269 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99274 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  99277 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99279 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99282 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99286 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99290 */       GIR_RootConstrainSelectedInstOperands,
     /*  99291 */       // GIR_Coverage, 5365,
     /*  99291 */       GIR_EraseRootFromParent_Done,
     /*  99292 */     // Label 1539: @99292
     /*  99292 */     GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(99396), // Rule ID 2490 //
     /*  99297 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99312 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  99315 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  99320 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99324 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99329 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99331 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  99331 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99334 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99338 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99343 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99345 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99348 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99352 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99357 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99360 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99364 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99367 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99372 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99377 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  99385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99387 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99390 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99394 */       GIR_RootConstrainSelectedInstOperands,
     /*  99395 */       // GIR_Coverage, 2490,
     /*  99395 */       GIR_EraseRootFromParent_Done,
     /*  99396 */     // Label 1540: @99396
     /*  99396 */     GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99452), // Rule ID 5522 //
     /*  99401 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99405 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99409 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99413 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99418 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  99422 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99426 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99430 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99435 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  99437 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  99437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  99440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99442 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  99446 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  99450 */       GIR_RootConstrainSelectedInstOperands,
     /*  99451 */       // GIR_Coverage, 5522,
     /*  99451 */       GIR_EraseRootFromParent_Done,
     /*  99452 */     // Label 1541: @99452
     /*  99452 */     GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(99518), // Rule ID 5828 //
     /*  99457 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99461 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99465 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99471 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  99473 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99475 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  99475 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  99478 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  99482 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99487 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99491 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99493 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99496 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99498 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99501 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99504 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99507 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99512 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99517 */       // GIR_Coverage, 5828,
     /*  99517 */       GIR_EraseRootFromParent_Done,
     /*  99518 */     // Label 1542: @99518
     /*  99518 */     GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(99584), // Rule ID 5832 //
     /*  99523 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99527 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99531 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99537 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  99539 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99541 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  99541 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  99544 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  99548 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99553 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99557 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99559 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99562 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99564 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99567 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99570 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99573 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99578 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99583 */       // GIR_Coverage, 5832,
     /*  99583 */       GIR_EraseRootFromParent_Done,
     /*  99584 */     // Label 1543: @99584
     /*  99584 */     GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99677), // Rule ID 4947 //
     /*  99589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  99601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99605 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99610 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99612 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  99612 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99615 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99619 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99624 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99626 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99629 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99633 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99638 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99641 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99645 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99658 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99663 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  99666 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99668 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99671 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  99675 */       GIR_RootConstrainSelectedInstOperands,
     /*  99676 */       // GIR_Coverage, 4947,
     /*  99676 */       GIR_EraseRootFromParent_Done,
     /*  99677 */     // Label 1544: @99677
     /*  99677 */     GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99773), // Rule ID 4994 //
     /*  99682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99685 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99689 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99693 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99697 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99701 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99706 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99708 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  99708 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99711 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99715 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99720 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99722 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99725 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99729 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99734 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99737 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99741 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99759 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  99762 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99764 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99767 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  99771 */       GIR_RootConstrainSelectedInstOperands,
     /*  99772 */       // GIR_Coverage, 4994,
     /*  99772 */       GIR_EraseRootFromParent_Done,
     /*  99773 */     // Label 1545: @99773
     /*  99773 */     GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(99835), // Rule ID 5829 //
     /*  99778 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  99790 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99792 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  99792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  99795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99804 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99806 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99809 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99811 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99814 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  99816 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99819 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99824 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99829 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99834 */       // GIR_Coverage, 5829,
     /*  99834 */       GIR_EraseRootFromParent_Done,
     /*  99835 */     // Label 1546: @99835
     /*  99835 */     GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(99897), // Rule ID 5833 //
     /*  99840 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99844 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99848 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  99852 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99854 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  99854 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  99857 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99861 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99866 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99873 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99876 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  99878 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99881 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99886 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99891 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99896 */       // GIR_Coverage, 5833,
     /*  99896 */       GIR_EraseRootFromParent_Done,
     /*  99897 */     // Label 1547: @99897
     /*  99897 */     GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100031), // Rule ID 5827 //
     /*  99902 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99906 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99910 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  99910 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  99913 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99917 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99922 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99924 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  99927 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99931 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99936 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99939 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99943 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99946 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99951 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99956 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99961 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99964 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99968 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99973 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99975 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99978 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99982 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99987 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99990 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99994 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99997 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100002 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100012 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100015 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100017 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100020 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100023 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100026 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100029 */       GIR_RootConstrainSelectedInstOperands,
     /* 100030 */       // GIR_Coverage, 5827,
     /* 100030 */       GIR_EraseRootFromParent_Done,
     /* 100031 */     // Label 1548: @100031
     /* 100031 */     GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(100165), // Rule ID 5831 //
     /* 100036 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100040 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100044 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 100044 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 100047 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100051 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100056 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100058 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 100061 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100065 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100070 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 100073 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 100077 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 100080 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100085 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100090 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100095 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100098 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100102 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100107 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100109 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100112 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100116 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100121 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100124 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100128 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100131 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100136 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100141 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100146 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100149 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100151 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100154 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100157 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100160 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100163 */       GIR_RootConstrainSelectedInstOperands,
     /* 100164 */       // GIR_Coverage, 5831,
     /* 100164 */       GIR_EraseRootFromParent_Done,
     /* 100165 */     // Label 1549: @100165
     /* 100165 */     GIM_Reject,
     /* 100166 */   // Label 1525: @100166
     /* 100166 */   GIM_Reject,
     /* 100167 */   // Label 1508: @100167
     /* 100167 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(102575),
     /* 100172 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 100178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100182 */     GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(100311), // Rule ID 5437 //
     /* 100187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100199 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100203 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100207 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100211 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100215 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100219 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 100223 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100227 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100231 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100236 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 100240 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 100246 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 100248 */       // MIs[2] Operand 2
     /* 100248 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100259 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 100261 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 100261 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100264 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100268 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100273 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100276 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100280 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 100296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100309 */       GIR_RootConstrainSelectedInstOperands,
     /* 100310 */       // GIR_Coverage, 5437,
     /* 100310 */       GIR_EraseRootFromParent_Done,
     /* 100311 */     // Label 1551: @100311
     /* 100311 */     GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(100433), // Rule ID 5433 //
     /* 100316 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100324 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100328 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100332 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100336 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100340 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100344 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100348 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 100352 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100356 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100360 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100365 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100370 */       // MIs[2] Operand 2
     /* 100370 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100381 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100383 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 100383 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100386 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100390 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100395 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100398 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100402 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100410 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 100418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100420 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100423 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100427 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100431 */       GIR_RootConstrainSelectedInstOperands,
     /* 100432 */       // GIR_Coverage, 5433,
     /* 100432 */       GIR_EraseRootFromParent_Done,
     /* 100433 */     // Label 1552: @100433
     /* 100433 */     GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(100555), // Rule ID 5435 //
     /* 100438 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100442 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100446 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100450 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100454 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100458 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100462 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100466 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100470 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 100474 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100478 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100482 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100487 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100492 */       // MIs[2] Operand 2
     /* 100492 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100503 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100505 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 100505 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100508 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100512 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100517 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100520 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100524 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100527 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100532 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 100540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100542 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100549 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100553 */       GIR_RootConstrainSelectedInstOperands,
     /* 100554 */       // GIR_Coverage, 5435,
     /* 100554 */       GIR_EraseRootFromParent_Done,
     /* 100555 */     // Label 1553: @100555
     /* 100555 */     GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(100657), // Rule ID 5588 //
     /* 100560 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100564 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100568 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100572 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100576 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100580 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100584 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100589 */       // MIs[2] Operand 2
     /* 100589 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100600 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 100604 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100608 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100612 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 100616 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100620 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100624 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100629 */       // MIs[4] Operand 2
     /* 100629 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /* 100640 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 100642 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 100642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 100645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100647 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 100651 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 100655 */       GIR_RootConstrainSelectedInstOperands,
     /* 100656 */       // GIR_Coverage, 5588,
     /* 100656 */       GIR_EraseRootFromParent_Done,
     /* 100657 */     // Label 1554: @100657
     /* 100657 */     GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(100786), // Rule ID 6374 //
     /* 100662 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100666 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100670 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100674 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100677 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 100682 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100686 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100695 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /* 100699 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100701 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 100701 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100704 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 100708 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100713 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100718 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100721 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100725 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100730 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100732 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100735 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100739 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100744 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100747 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 100751 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100759 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100764 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 100772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100774 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100777 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 100781 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100784 */       GIR_RootConstrainSelectedInstOperands,
     /* 100785 */       // GIR_Coverage, 6374,
     /* 100785 */       GIR_EraseRootFromParent_Done,
     /* 100786 */     // Label 1555: @100786
     /* 100786 */     GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(100828), // Rule ID 5838 //
     /* 100791 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 100798 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 100805 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /* 100805 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100808 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100810 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 100815 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100818 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100823 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100826 */       GIR_RootConstrainSelectedInstOperands,
     /* 100827 */       // GIR_Coverage, 5838,
     /* 100827 */       GIR_EraseRootFromParent_Done,
     /* 100828 */     // Label 1556: @100828
     /* 100828 */     GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(100870), // Rule ID 5842 //
     /* 100833 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 100840 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 100847 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /* 100847 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100850 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100852 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 100857 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100860 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100865 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100868 */       GIR_RootConstrainSelectedInstOperands,
     /* 100869 */       // GIR_Coverage, 5842,
     /* 100869 */       GIR_EraseRootFromParent_Done,
     /* 100870 */     // Label 1557: @100870
     /* 100870 */     GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(100993), // Rule ID 2569 //
     /* 100875 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100878 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100882 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100886 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100890 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100893 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 100898 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100902 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100906 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100911 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 100915 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100919 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 100923 */       // MIs[2] Operand 1
     /* 100923 */       // No operand predicates
     /* 100923 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 100925 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 100925 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100928 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100932 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100937 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100939 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100942 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100946 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100951 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100954 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100958 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100961 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100966 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100971 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100976 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /* 100979 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100981 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100984 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100988 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 100991 */       GIR_RootConstrainSelectedInstOperands,
     /* 100992 */       // GIR_Coverage, 2569,
     /* 100992 */       GIR_EraseRootFromParent_Done,
     /* 100993 */     // Label 1558: @100993
     /* 100993 */     GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(101116), // Rule ID 6344 //
     /* 100998 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101001 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101005 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101009 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101013 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101017 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101021 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 101025 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101029 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101034 */       // MIs[2] imm
     /* 101034 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 101038 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101042 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 101046 */       // MIs[3] Operand 1
     /* 101046 */       // No operand predicates
     /* 101046 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101048 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 101048 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101051 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101055 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101060 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101062 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101065 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101069 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101074 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101077 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101081 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101084 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101089 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101094 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101099 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 101102 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101104 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101107 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 101111 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 101114 */       GIR_RootConstrainSelectedInstOperands,
     /* 101115 */       // GIR_Coverage, 6344,
     /* 101115 */       GIR_EraseRootFromParent_Done,
     /* 101116 */     // Label 1559: @101116
     /* 101116 */     GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(101236), // Rule ID 6380 //
     /* 101121 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101125 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101129 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101133 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101137 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101141 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101145 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101149 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101154 */       // MIs[2] imm
     /* 101154 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 101158 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101162 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 101166 */       // MIs[3] Operand 1
     /* 101166 */       // No operand predicates
     /* 101166 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101168 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 101168 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101171 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101175 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101180 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101182 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101185 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101189 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101194 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101197 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101201 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101209 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101214 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101219 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 101222 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101224 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101227 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 101231 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 101234 */       GIR_RootConstrainSelectedInstOperands,
     /* 101235 */       // GIR_Coverage, 6380,
     /* 101235 */       GIR_EraseRootFromParent_Done,
     /* 101236 */     // Label 1560: @101236
     /* 101236 */     GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(101353), // Rule ID 2493 //
     /* 101241 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101244 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101248 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101252 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101256 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101259 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 101264 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101268 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101272 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101277 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101282 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101284 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 576:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101284 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101287 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101291 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101296 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101298 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101301 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101305 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101310 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101313 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101317 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101325 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101330 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101335 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 101338 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101340 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101343 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101347 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101351 */       GIR_RootConstrainSelectedInstOperands,
     /* 101352 */       // GIR_Coverage, 2493,
     /* 101352 */       GIR_EraseRootFromParent_Done,
     /* 101353 */     // Label 1561: @101353
     /* 101353 */     GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(101470), // Rule ID 5358 //
     /* 101358 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101361 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101365 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101369 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101373 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101376 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 101381 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101385 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101389 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101394 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101399 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101401 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 721:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101401 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101404 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101408 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101413 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101415 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101418 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101422 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101427 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101430 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101434 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101437 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101442 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101447 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101452 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 101455 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101457 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101460 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101464 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101468 */       GIR_RootConstrainSelectedInstOperands,
     /* 101469 */       // GIR_Coverage, 5358,
     /* 101469 */       GIR_EraseRootFromParent_Done,
     /* 101470 */     // Label 1562: @101470
     /* 101470 */     GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101587), // Rule ID 5361 //
     /* 101475 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101478 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101482 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101486 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101490 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101493 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 101498 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101502 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101506 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101511 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101516 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101518 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101518 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101521 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101525 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101530 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101532 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101535 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101539 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101544 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101547 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101551 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101554 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101569 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 101572 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101574 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101577 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101581 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101585 */       GIR_RootConstrainSelectedInstOperands,
     /* 101586 */       // GIR_Coverage, 5361,
     /* 101586 */       GIR_EraseRootFromParent_Done,
     /* 101587 */     // Label 1563: @101587
     /* 101587 */     GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(101704), // Rule ID 5364 //
     /* 101592 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101595 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101599 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101603 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101607 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101610 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 101615 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101619 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101623 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101628 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101633 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101635 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 665:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101635 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101638 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101642 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101647 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101649 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101652 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101656 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101661 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101664 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101668 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101671 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101676 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101681 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101686 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /* 101689 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101691 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101694 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101698 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101702 */       GIR_RootConstrainSelectedInstOperands,
     /* 101703 */       // GIR_Coverage, 5364,
     /* 101703 */       GIR_EraseRootFromParent_Done,
     /* 101704 */     // Label 1564: @101704
     /* 101704 */     GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(101805), // Rule ID 4941 //
     /* 101709 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101713 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101717 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101721 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 101724 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 101729 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101733 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101738 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101740 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 771:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 101740 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101743 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101747 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101752 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101754 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101757 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101761 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101766 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101769 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101773 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101776 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101781 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101786 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101791 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 101794 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101796 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101799 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101803 */       GIR_RootConstrainSelectedInstOperands,
     /* 101804 */       // GIR_Coverage, 4941,
     /* 101804 */       GIR_EraseRootFromParent_Done,
     /* 101805 */     // Label 1565: @101805
     /* 101805 */     GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(101861), // Rule ID 5513 //
     /* 101810 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101814 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101818 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101822 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101827 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 101831 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101835 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101839 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101844 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 101846 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 101846 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 101849 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101851 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 101855 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 101859 */       GIR_RootConstrainSelectedInstOperands,
     /* 101860 */       // GIR_Coverage, 5513,
     /* 101860 */       GIR_EraseRootFromParent_Done,
     /* 101861 */     // Label 1566: @101861
     /* 101861 */     GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(101927), // Rule ID 5836 //
     /* 101866 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101870 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101874 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101880 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101882 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101884 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /* 101884 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101887 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101891 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101896 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101900 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101902 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101905 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101907 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101910 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101913 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101916 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101921 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101926 */       // GIR_Coverage, 5836,
     /* 101926 */       GIR_EraseRootFromParent_Done,
     /* 101927 */     // Label 1567: @101927
     /* 101927 */     GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(101993), // Rule ID 5840 //
     /* 101932 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101936 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101940 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101946 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101948 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101950 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /* 101950 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101953 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101957 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101962 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101966 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101968 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101971 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101973 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101976 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101979 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101982 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101987 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101992 */       // GIR_Coverage, 5840,
     /* 101992 */       GIR_EraseRootFromParent_Done,
     /* 101993 */     // Label 1568: @101993
     /* 101993 */     GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102086), // Rule ID 4949 //
     /* 101998 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102002 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102006 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 102010 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102014 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102019 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102021 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 102021 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102024 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102028 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102033 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102035 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102038 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102042 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102047 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102050 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102054 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102057 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102062 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102067 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102072 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 102075 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102077 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102080 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102084 */       GIR_RootConstrainSelectedInstOperands,
     /* 102085 */       // GIR_Coverage, 4949,
     /* 102085 */       GIR_EraseRootFromParent_Done,
     /* 102086 */     // Label 1569: @102086
     /* 102086 */     GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(102182), // Rule ID 4993 //
     /* 102091 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102094 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102098 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102102 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102106 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102110 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102115 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102117 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /* 102117 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102120 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102124 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102129 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102131 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102134 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102138 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102143 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102146 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102150 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102153 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102158 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102168 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /* 102171 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102173 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102176 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102180 */       GIR_RootConstrainSelectedInstOperands,
     /* 102181 */       // GIR_Coverage, 4993,
     /* 102181 */       GIR_EraseRootFromParent_Done,
     /* 102182 */     // Label 1570: @102182
     /* 102182 */     GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(102244), // Rule ID 5837 //
     /* 102187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 102199 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102201 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /* 102201 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 102204 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102208 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102213 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102215 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102218 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102220 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102223 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102225 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 102228 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102233 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102238 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102243 */       // GIR_Coverage, 5837,
     /* 102243 */       GIR_EraseRootFromParent_Done,
     /* 102244 */     // Label 1571: @102244
     /* 102244 */     GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(102306), // Rule ID 5841 //
     /* 102249 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102253 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102257 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 102261 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102263 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /* 102263 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 102266 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102270 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102275 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102277 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102280 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102282 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102285 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102287 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 102290 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102295 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102300 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102305 */       // GIR_Coverage, 5841,
     /* 102305 */       GIR_EraseRootFromParent_Done,
     /* 102306 */     // Label 1572: @102306
     /* 102306 */     GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(102440), // Rule ID 5835 //
     /* 102311 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102315 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102319 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 102319 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 102322 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102326 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102331 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102333 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 102336 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102340 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102345 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 102348 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 102352 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 102355 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102360 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102365 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102370 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102373 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102377 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102382 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102384 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102387 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102391 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102396 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102399 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102403 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102406 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102411 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102416 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102421 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102424 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102426 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102429 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102432 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102435 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102438 */       GIR_RootConstrainSelectedInstOperands,
     /* 102439 */       // GIR_Coverage, 5835,
     /* 102439 */       GIR_EraseRootFromParent_Done,
     /* 102440 */     // Label 1573: @102440
     /* 102440 */     GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(102574), // Rule ID 5839 //
     /* 102445 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102449 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102453 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 102453 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 102456 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102460 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102465 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102467 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 102470 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102474 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102479 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 102482 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 102486 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 102489 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102494 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102499 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102504 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102507 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102511 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102516 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102518 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102521 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102525 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102530 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102533 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102537 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102540 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102545 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102550 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102555 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102558 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102560 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102563 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102566 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102569 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102572 */       GIR_RootConstrainSelectedInstOperands,
     /* 102573 */       // GIR_Coverage, 5839,
     /* 102573 */       GIR_EraseRootFromParent_Done,
     /* 102574 */     // Label 1574: @102574
     /* 102574 */     GIM_Reject,
     /* 102575 */   // Label 1550: @102575
     /* 102575 */   GIM_Reject,
     /* 102576 */   // Label 1509: @102576
     /* 102576 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(104486),
     /* 102581 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102591 */     GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(102720), // Rule ID 5431 //
     /* 102596 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102600 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102604 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102608 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102612 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102616 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102620 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102624 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102628 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 102632 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102636 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102640 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102645 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 102649 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 102655 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 102657 */       // MIs[2] Operand 2
     /* 102657 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102668 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 102670 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 102670 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102673 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102677 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102682 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102685 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102689 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102692 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102697 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 102705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102707 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102710 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102714 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102718 */       GIR_RootConstrainSelectedInstOperands,
     /* 102719 */       // GIR_Coverage, 5431,
     /* 102719 */       GIR_EraseRootFromParent_Done,
     /* 102720 */     // Label 1576: @102720
     /* 102720 */     GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(102842), // Rule ID 5427 //
     /* 102725 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102729 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102733 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102737 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102741 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102745 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102749 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102753 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102757 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 102761 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102765 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102769 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102774 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102779 */       // MIs[2] Operand 2
     /* 102779 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102790 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102792 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 102792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102804 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102807 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102811 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102814 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102819 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102824 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 102827 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102829 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102832 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102836 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102840 */       GIR_RootConstrainSelectedInstOperands,
     /* 102841 */       // GIR_Coverage, 5427,
     /* 102841 */       GIR_EraseRootFromParent_Done,
     /* 102842 */     // Label 1577: @102842
     /* 102842 */     GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(102964), // Rule ID 5429 //
     /* 102847 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102851 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102855 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102859 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102863 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102867 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102871 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102875 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102879 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 102883 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102887 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102891 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102896 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102901 */       // MIs[2] Operand 2
     /* 102901 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102912 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102914 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 102914 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102917 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102921 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102926 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102929 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102933 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 102949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102954 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102958 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102962 */       GIR_RootConstrainSelectedInstOperands,
     /* 102963 */       // GIR_Coverage, 5429,
     /* 102963 */       GIR_EraseRootFromParent_Done,
     /* 102964 */     // Label 1578: @102964
     /* 102964 */     GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(103066), // Rule ID 5587 //
     /* 102969 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102973 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102977 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102981 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102985 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102989 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102993 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102998 */       // MIs[2] Operand 2
     /* 102998 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 103009 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 103013 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103017 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103021 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 103025 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 103029 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103033 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103038 */       // MIs[4] Operand 2
     /* 103038 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /* 103049 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 103051 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 103051 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 103054 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103056 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 103060 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 103064 */       GIR_RootConstrainSelectedInstOperands,
     /* 103065 */       // GIR_Coverage, 5587,
     /* 103065 */       GIR_EraseRootFromParent_Done,
     /* 103066 */     // Label 1579: @103066
     /* 103066 */     GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(103195), // Rule ID 6373 //
     /* 103071 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103075 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103079 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103083 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103086 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 103091 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103095 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103099 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103104 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /* 103108 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103110 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 103110 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 103113 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 103117 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103122 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103125 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103127 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103130 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103134 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103139 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103141 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103144 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103148 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103153 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103156 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 103160 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103168 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103173 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103178 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 103181 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103183 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103186 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103190 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103193 */       GIR_RootConstrainSelectedInstOperands,
     /* 103194 */       // GIR_Coverage, 6373,
     /* 103194 */       GIR_EraseRootFromParent_Done,
     /* 103195 */     // Label 1580: @103195
     /* 103195 */     GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(103237), // Rule ID 5846 //
     /* 103200 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 103207 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 103214 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /* 103214 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 103217 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103219 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 103224 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103227 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103232 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103235 */       GIR_RootConstrainSelectedInstOperands,
     /* 103236 */       // GIR_Coverage, 5846,
     /* 103236 */       GIR_EraseRootFromParent_Done,
     /* 103237 */     // Label 1581: @103237
     /* 103237 */     GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(103360), // Rule ID 2567 //
     /* 103242 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103245 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103249 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103253 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103257 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103260 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 103265 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103269 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103273 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103278 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 103282 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103286 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103290 */       // MIs[2] Operand 1
     /* 103290 */       // No operand predicates
     /* 103290 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 103292 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103292 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103295 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103299 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103304 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103306 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103309 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103313 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103318 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103321 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103325 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103328 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103333 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103338 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103343 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /* 103346 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103348 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103351 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103355 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 103358 */       GIR_RootConstrainSelectedInstOperands,
     /* 103359 */       // GIR_Coverage, 2567,
     /* 103359 */       GIR_EraseRootFromParent_Done,
     /* 103360 */     // Label 1582: @103360
     /* 103360 */     GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(103483), // Rule ID 6343 //
     /* 103365 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103368 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103372 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103376 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103380 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103384 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 103388 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 103392 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103396 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103401 */       // MIs[2] imm
     /* 103401 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 103405 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103409 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103413 */       // MIs[3] Operand 1
     /* 103413 */       // No operand predicates
     /* 103413 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 103415 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103415 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103418 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103422 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103427 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103441 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103444 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103448 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103456 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103466 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 103469 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103471 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103474 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 103478 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 103481 */       GIR_RootConstrainSelectedInstOperands,
     /* 103482 */       // GIR_Coverage, 6343,
     /* 103482 */       GIR_EraseRootFromParent_Done,
     /* 103483 */     // Label 1583: @103483
     /* 103483 */     GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(103603), // Rule ID 6379 //
     /* 103488 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103492 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103496 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103500 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103504 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 103508 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 103512 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103516 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103521 */       // MIs[2] imm
     /* 103521 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 103525 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103529 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103533 */       // MIs[3] Operand 1
     /* 103533 */       // No operand predicates
     /* 103533 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 103535 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103535 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103538 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103542 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103547 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103549 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103552 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103556 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103561 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103564 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103568 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103571 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103576 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103581 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103586 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 103589 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103591 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103594 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 103598 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 103601 */       GIR_RootConstrainSelectedInstOperands,
     /* 103602 */       // GIR_Coverage, 6379,
     /* 103602 */       GIR_EraseRootFromParent_Done,
     /* 103603 */     // Label 1584: @103603
     /* 103603 */     GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(103720), // Rule ID 2492 //
     /* 103608 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103611 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103615 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103619 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103623 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103626 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 103631 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103635 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103639 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103644 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103649 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103651 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 576:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103651 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103654 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103658 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103663 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103665 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103668 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103672 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103677 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103680 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103684 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103687 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103692 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103697 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 103705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103707 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103710 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103714 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103718 */       GIR_RootConstrainSelectedInstOperands,
     /* 103719 */       // GIR_Coverage, 2492,
     /* 103719 */       GIR_EraseRootFromParent_Done,
     /* 103720 */     // Label 1585: @103720
     /* 103720 */     GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(103837), // Rule ID 5357 //
     /* 103725 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103728 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103732 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103736 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103740 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103743 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 103748 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103752 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103756 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103761 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103766 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103768 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 721:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103768 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103771 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103775 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103780 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103782 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103785 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103789 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103794 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103797 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103801 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103804 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103809 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103814 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103819 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 103822 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103824 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103827 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103831 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103835 */       GIR_RootConstrainSelectedInstOperands,
     /* 103836 */       // GIR_Coverage, 5357,
     /* 103836 */       GIR_EraseRootFromParent_Done,
     /* 103837 */     // Label 1586: @103837
     /* 103837 */     GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103954), // Rule ID 5360 //
     /* 103842 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103845 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103849 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103853 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103857 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103860 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 103865 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103869 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103873 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103878 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103883 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103885 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103885 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103888 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103892 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103897 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103899 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103902 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103906 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103911 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103914 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103918 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103921 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103926 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103936 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 103939 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103941 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103944 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103948 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103952 */       GIR_RootConstrainSelectedInstOperands,
     /* 103953 */       // GIR_Coverage, 5360,
     /* 103953 */       GIR_EraseRootFromParent_Done,
     /* 103954 */     // Label 1587: @103954
     /* 103954 */     GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(104071), // Rule ID 5363 //
     /* 103959 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103962 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103966 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103970 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103974 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103977 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 103982 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103986 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103990 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103995 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104000 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104002 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 665:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104002 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104005 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104009 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104014 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104016 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104019 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104023 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104028 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104031 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104035 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104038 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104043 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104048 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104053 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /* 104056 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104058 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104061 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 104065 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 104069 */       GIR_RootConstrainSelectedInstOperands,
     /* 104070 */       // GIR_Coverage, 5363,
     /* 104070 */       GIR_EraseRootFromParent_Done,
     /* 104071 */     // Label 1588: @104071
     /* 104071 */     GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(104127), // Rule ID 5504 //
     /* 104076 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104080 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104084 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104088 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104093 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 104097 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104101 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104105 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104110 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 104112 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 104112 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 104115 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104117 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 104121 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 104125 */       GIR_RootConstrainSelectedInstOperands,
     /* 104126 */       // GIR_Coverage, 5504,
     /* 104126 */       GIR_EraseRootFromParent_Done,
     /* 104127 */     // Label 1589: @104127
     /* 104127 */     GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(104193), // Rule ID 5844 //
     /* 104132 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104136 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104140 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 104146 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 104148 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104150 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /* 104150 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104153 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 104157 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104162 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 104166 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104168 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104171 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104173 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104176 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104179 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 104182 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104187 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104192 */       // GIR_Coverage, 5844,
     /* 104192 */       GIR_EraseRootFromParent_Done,
     /* 104193 */     // Label 1590: @104193
     /* 104193 */     GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(104289), // Rule ID 4992 //
     /* 104198 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104201 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104205 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104209 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104213 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104217 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104222 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104224 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /* 104224 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104227 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104231 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104236 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104238 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104241 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104245 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104250 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104253 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104257 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104260 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104265 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104270 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104275 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /* 104278 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104280 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104283 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104287 */       GIR_RootConstrainSelectedInstOperands,
     /* 104288 */       // GIR_Coverage, 4992,
     /* 104288 */       GIR_EraseRootFromParent_Done,
     /* 104289 */     // Label 1591: @104289
     /* 104289 */     GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(104351), // Rule ID 5845 //
     /* 104294 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104298 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104302 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 104306 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104308 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /* 104308 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 104311 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104315 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104320 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104322 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104325 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104327 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104330 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 104332 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 104335 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104340 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104345 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104350 */       // GIR_Coverage, 5845,
     /* 104350 */       GIR_EraseRootFromParent_Done,
     /* 104351 */     // Label 1592: @104351
     /* 104351 */     GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(104485), // Rule ID 5843 //
     /* 104356 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104360 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104364 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 104364 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 104367 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104371 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104376 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104378 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 104381 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104385 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104390 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 104393 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 104397 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 104400 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104405 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104410 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104415 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104418 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104422 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104427 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104441 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104444 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104448 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104456 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104466 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104469 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104471 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104474 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104477 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104480 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104483 */       GIR_RootConstrainSelectedInstOperands,
     /* 104484 */       // GIR_Coverage, 5843,
     /* 104484 */       GIR_EraseRootFromParent_Done,
     /* 104485 */     // Label 1593: @104485
     /* 104485 */     GIM_Reject,
     /* 104486 */   // Label 1575: @104486
     /* 104486 */   GIM_Reject,
     /* 104487 */   // Label 1510: @104487
     /* 104487 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(104512), // Rule ID 9119 //
     /* 104492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104495 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 104498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 104501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104505 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /* 104505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 104510 */     GIR_RootConstrainSelectedInstOperands,
     /* 104511 */     // GIR_Coverage, 9119,
     /* 104511 */     GIR_Done,
     /* 104512 */   // Label 1594: @104512
     /* 104512 */   GIM_Reject,
     /* 104513 */   // Label 1511: @104513
     /* 104513 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(104538), // Rule ID 9120 //
     /* 104518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104521 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 104524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 104527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104531 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /* 104531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 104536 */     GIR_RootConstrainSelectedInstOperands,
     /* 104537 */     // GIR_Coverage, 9120,
     /* 104537 */     GIR_Done,
     /* 104538 */   // Label 1595: @104538
     /* 104538 */   GIM_Reject,
     /* 104539 */   // Label 1512: @104539
     /* 104539 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(104564), // Rule ID 9123 //
     /* 104544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104547 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 104550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 104553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104557 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /* 104557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 104562 */     GIR_RootConstrainSelectedInstOperands,
     /* 104563 */     // GIR_Coverage, 9123,
     /* 104563 */     GIR_Done,
     /* 104564 */   // Label 1596: @104564
     /* 104564 */   GIM_Reject,
     /* 104565 */   // Label 1513: @104565
     /* 104565 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(104590), // Rule ID 9125 //
     /* 104570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104573 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 104576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 104579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104583 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /* 104583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 104588 */     GIR_RootConstrainSelectedInstOperands,
     /* 104589 */     // GIR_Coverage, 9125,
     /* 104589 */     GIR_Done,
     /* 104590 */   // Label 1597: @104590
     /* 104590 */   GIM_Reject,
     /* 104591 */   // Label 1514: @104591
     /* 104591 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(104616), // Rule ID 9121 //
     /* 104596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104599 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 104602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 104605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104609 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /* 104609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 104614 */     GIR_RootConstrainSelectedInstOperands,
     /* 104615 */     // GIR_Coverage, 9121,
     /* 104615 */     GIR_Done,
     /* 104616 */   // Label 1598: @104616
     /* 104616 */   GIM_Reject,
     /* 104617 */   // Label 1515: @104617
     /* 104617 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(104642), // Rule ID 9124 //
     /* 104622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104625 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 104628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 104631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104635 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /* 104635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 104640 */     GIR_RootConstrainSelectedInstOperands,
     /* 104641 */     // GIR_Coverage, 9124,
     /* 104641 */     GIR_Done,
     /* 104642 */   // Label 1599: @104642
     /* 104642 */   GIM_Reject,
     /* 104643 */   // Label 1516: @104643
     /* 104643 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(104668), // Rule ID 9122 //
     /* 104648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104651 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 104654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 104657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104661 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /* 104661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 104666 */     GIR_RootConstrainSelectedInstOperands,
     /* 104667 */     // GIR_Coverage, 9122,
     /* 104667 */     GIR_Done,
     /* 104668 */   // Label 1600: @104668
     /* 104668 */   GIM_Reject,
     /* 104669 */   // Label 1517: @104669
     /* 104669 */   GIM_Reject,
     /* 104670 */ // Label 1505: @104670
     /* 104670 */ GIM_Reject,
     /* 104671 */ // Label 9: @104671
     /* 104671 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1615*/ GIMT_Encode4(114752),
     /* 104682 */ /*GILLT_s32*//*Label 1601*/ GIMT_Encode4(104770),
     /* 104686 */ /*GILLT_s64*//*Label 1602*/ GIMT_Encode4(105273),
     /* 104690 */ /*GILLT_s128*//*Label 1603*/ GIMT_Encode4(107264),
     /* 104694 */ /*GILLT_v2s32*//*Label 1604*/ GIMT_Encode4(107910),
     /* 104698 */ /*GILLT_v2s64*//*Label 1605*/ GIMT_Encode4(108825),
     /* 104702 */ /*GILLT_v4s16*//*Label 1606*/ GIMT_Encode4(109594),
     /* 104706 */ /*GILLT_v4s32*//*Label 1607*/ GIMT_Encode4(110509),
     /* 104710 */ /*GILLT_v8s8*//*Label 1608*/ GIMT_Encode4(111354),
     /* 104714 */ /*GILLT_v8s16*//*Label 1609*/ GIMT_Encode4(111915),
     /* 104718 */ /*GILLT_v16s8*//*Label 1610*/ GIMT_Encode4(112760), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104738 */ /*GILLT_nxv2s64*//*Label 1611*/ GIMT_Encode4(113212), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104750 */ /*GILLT_nxv4s32*//*Label 1612*/ GIMT_Encode4(113661), GIMT_Encode4(0),
     /* 104758 */ /*GILLT_nxv8s16*//*Label 1613*/ GIMT_Encode4(114110), GIMT_Encode4(0),
     /* 104766 */ /*GILLT_nxv16s8*//*Label 1614*/ GIMT_Encode4(114559),
     /* 104770 */ // Label 1601: @104770
     /* 104770 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(105272),
     /* 104775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104778 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(104852), // Rule ID 7096 //
     /* 104783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104795 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104802 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104809 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104812 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 104825 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15853>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 104825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 104828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104850 */     GIR_RootConstrainSelectedInstOperands,
     /* 104851 */     // GIR_Coverage, 7096,
     /* 104851 */     GIR_EraseRootFromParent_Done,
     /* 104852 */   // Label 1617: @104852
     /* 104852 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(104926), // Rule ID 7097 //
     /* 104857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104869 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104876 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104883 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 104899 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15853>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 104899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 104902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104924 */     GIR_RootConstrainSelectedInstOperands,
     /* 104925 */     // GIR_Coverage, 7097,
     /* 104925 */     GIR_EraseRootFromParent_Done,
     /* 104926 */   // Label 1618: @104926
     /* 104926 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(104995), // Rule ID 7098 //
     /* 104931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104943 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104950 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104957 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104960 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 104973 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15853>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 104976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104993 */     GIR_RootConstrainSelectedInstOperands,
     /* 104994 */     // GIR_Coverage, 7098,
     /* 104994 */     GIR_EraseRootFromParent_Done,
     /* 104995 */   // Label 1619: @104995
     /* 104995 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(105064), // Rule ID 7099 //
     /* 105000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105012 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105019 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 105026 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105029 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 105042 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15853>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 105045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105062 */     GIR_RootConstrainSelectedInstOperands,
     /* 105063 */     // GIR_Coverage, 7099,
     /* 105063 */     GIR_EraseRootFromParent_Done,
     /* 105064 */   // Label 1620: @105064
     /* 105064 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(105117), // Rule ID 5805 //
     /* 105069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 105073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105095 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v16i8:{ *:[v16i8] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v16i8] }:$src, bsub:{ *:[i32] })
     /* 105095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105100 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 105106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 105111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105116 */     // GIR_Coverage, 5805,
     /* 105116 */     GIR_EraseRootFromParent_Done,
     /* 105117 */   // Label 1621: @105117
     /* 105117 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(105170), // Rule ID 5806 //
     /* 105122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 105126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105142 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105148 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v8i16:{ *:[v8i16] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v8i16] }:$src, hsub:{ *:[i32] })
     /* 105148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105153 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // src
     /* 105159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 105164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105169 */     // GIR_Coverage, 5806,
     /* 105169 */     GIR_EraseRootFromParent_Done,
     /* 105170 */   // Label 1622: @105170
     /* 105170 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(105223), // Rule ID 5807 //
     /* 105175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105201 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /* 105201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105206 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /* 105212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105222 */     // GIR_Coverage, 5807,
     /* 105222 */     GIR_EraseRootFromParent_Done,
     /* 105223 */   // Label 1623: @105223
     /* 105223 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(105247), // Rule ID 6707 //
     /* 105228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105236 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /* 105236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105246 */     // GIR_Coverage, 6707,
     /* 105246 */     GIR_Done,
     /* 105247 */   // Label 1624: @105247
     /* 105247 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(105271), // Rule ID 6708 //
     /* 105252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105260 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /* 105260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105270 */     // GIR_Coverage, 6708,
     /* 105270 */     GIR_Done,
     /* 105271 */   // Label 1625: @105271
     /* 105271 */   GIM_Reject,
     /* 105272 */ // Label 1616: @105272
     /* 105272 */ GIM_Reject,
     /* 105273 */ // Label 1602: @105273
     /* 105273 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(105350), // Rule ID 7100 //
     /* 105278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105293 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105296 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105300 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105307 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105310 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105316 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105323 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15861>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105348 */   GIR_RootConstrainSelectedInstOperands,
     /* 105349 */   // GIR_Coverage, 7100,
     /* 105349 */   GIR_EraseRootFromParent_Done,
     /* 105350 */ // Label 1626: @105350
     /* 105350 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(105427), // Rule ID 7101 //
     /* 105355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105370 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105373 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105377 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105384 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105387 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105393 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105400 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15861>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105425 */   GIR_RootConstrainSelectedInstOperands,
     /* 105426 */   // GIR_Coverage, 7101,
     /* 105426 */   GIR_EraseRootFromParent_Done,
     /* 105427 */ // Label 1627: @105427
     /* 105427 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(105499), // Rule ID 7102 //
     /* 105432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105454 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105461 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105464 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105468 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105470 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105477 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15861>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105497 */   GIR_RootConstrainSelectedInstOperands,
     /* 105498 */   // GIR_Coverage, 7102,
     /* 105498 */   GIR_EraseRootFromParent_Done,
     /* 105499 */ // Label 1628: @105499
     /* 105499 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(105571), // Rule ID 7103 //
     /* 105504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105511 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105515 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105519 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105522 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105526 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105533 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105536 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105540 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105542 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105549 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15861>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105569 */   GIR_RootConstrainSelectedInstOperands,
     /* 105570 */   // GIR_Coverage, 7103,
     /* 105570 */   GIR_EraseRootFromParent_Done,
     /* 105571 */ // Label 1629: @105571
     /* 105571 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(105627), // Rule ID 5808 //
     /* 105576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105591 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105595 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105599 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105605 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /* 105605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105610 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 105616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105626 */   // GIR_Coverage, 5808,
     /* 105626 */   GIR_EraseRootFromParent_Done,
     /* 105627 */ // Label 1630: @105627
     /* 105627 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(105657), // Rule ID 6682 //
     /* 105632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105646 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /* 105646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105651 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105656 */   // GIR_Coverage, 6682,
     /* 105656 */   GIR_Done,
     /* 105657 */ // Label 1631: @105657
     /* 105657 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(105687), // Rule ID 6683 //
     /* 105662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105676 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /* 105676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105686 */   // GIR_Coverage, 6683,
     /* 105686 */   GIR_Done,
     /* 105687 */ // Label 1632: @105687
     /* 105687 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(105717), // Rule ID 6684 //
     /* 105692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105706 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /* 105706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105716 */   // GIR_Coverage, 6684,
     /* 105716 */   GIR_Done,
     /* 105717 */ // Label 1633: @105717
     /* 105717 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(105747), // Rule ID 6685 //
     /* 105722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105736 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /* 105736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105746 */   // GIR_Coverage, 6685,
     /* 105746 */   GIR_Done,
     /* 105747 */ // Label 1634: @105747
     /* 105747 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(105777), // Rule ID 6686 //
     /* 105752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105766 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /* 105766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105776 */   // GIR_Coverage, 6686,
     /* 105776 */   GIR_Done,
     /* 105777 */ // Label 1635: @105777
     /* 105777 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(105807), // Rule ID 6687 //
     /* 105782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105796 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 105796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105801 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105806 */   // GIR_Coverage, 6687,
     /* 105806 */   GIR_Done,
     /* 105807 */ // Label 1636: @105807
     /* 105807 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(105857), // Rule ID 6693 //
     /* 105812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105826 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /* 105826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105838 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105842 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 105850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105855 */   GIR_RootConstrainSelectedInstOperands,
     /* 105856 */   // GIR_Coverage, 6693,
     /* 105856 */   GIR_EraseRootFromParent_Done,
     /* 105857 */ // Label 1637: @105857
     /* 105857 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(105907), // Rule ID 6694 //
     /* 105862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105876 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /* 105876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105888 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 105900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105905 */   GIR_RootConstrainSelectedInstOperands,
     /* 105906 */   // GIR_Coverage, 6694,
     /* 105906 */   GIR_EraseRootFromParent_Done,
     /* 105907 */ // Label 1638: @105907
     /* 105907 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(105957), // Rule ID 6695 //
     /* 105912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105926 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /* 105926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105938 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105942 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 105950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105955 */   GIR_RootConstrainSelectedInstOperands,
     /* 105956 */   // GIR_Coverage, 6695,
     /* 105956 */   GIR_EraseRootFromParent_Done,
     /* 105957 */ // Label 1639: @105957
     /* 105957 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106007), // Rule ID 6696 //
     /* 105962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105976 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /* 105976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105988 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 106002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106005 */   GIR_RootConstrainSelectedInstOperands,
     /* 106006 */   // GIR_Coverage, 6696,
     /* 106006 */   GIR_EraseRootFromParent_Done,
     /* 106007 */ // Label 1640: @106007
     /* 106007 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106057), // Rule ID 6697 //
     /* 106012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106026 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /* 106026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106038 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 106042 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 106052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106055 */   GIR_RootConstrainSelectedInstOperands,
     /* 106056 */   // GIR_Coverage, 6697,
     /* 106056 */   GIR_EraseRootFromParent_Done,
     /* 106057 */ // Label 1641: @106057
     /* 106057 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106084), // Rule ID 6698 //
     /* 106062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106073 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 106073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106083 */   // GIR_Coverage, 6698,
     /* 106083 */   GIR_Done,
     /* 106084 */ // Label 1642: @106084
     /* 106084 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106111), // Rule ID 6699 //
     /* 106089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106100 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 106100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106110 */   // GIR_Coverage, 6699,
     /* 106110 */   GIR_Done,
     /* 106111 */ // Label 1643: @106111
     /* 106111 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106138), // Rule ID 6700 //
     /* 106116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106127 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /* 106127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106137 */   // GIR_Coverage, 6700,
     /* 106137 */   GIR_Done,
     /* 106138 */ // Label 1644: @106138
     /* 106138 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(106165), // Rule ID 6709 //
     /* 106143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106154 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 106154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106159 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106164 */   // GIR_Coverage, 6709,
     /* 106164 */   GIR_Done,
     /* 106165 */ // Label 1645: @106165
     /* 106165 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(106192), // Rule ID 6710 //
     /* 106170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106181 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /* 106181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106191 */   // GIR_Coverage, 6710,
     /* 106191 */   GIR_Done,
     /* 106192 */ // Label 1646: @106192
     /* 106192 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(106219), // Rule ID 6711 //
     /* 106197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106208 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 106208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106213 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106218 */   // GIR_Coverage, 6711,
     /* 106218 */   GIR_Done,
     /* 106219 */ // Label 1647: @106219
     /* 106219 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(106251), // Rule ID 6712 //
     /* 106224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106238 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106241 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106243 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106250 */   // GIR_Coverage, 6712,
     /* 106250 */   GIR_EraseRootFromParent_Done,
     /* 106251 */ // Label 1648: @106251
     /* 106251 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(106283), // Rule ID 6713 //
     /* 106256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106270 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106273 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106275 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106277 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106282 */   // GIR_Coverage, 6713,
     /* 106282 */   GIR_EraseRootFromParent_Done,
     /* 106283 */ // Label 1649: @106283
     /* 106283 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(106315), // Rule ID 6714 //
     /* 106288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106302 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106305 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106307 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106309 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106314 */   // GIR_Coverage, 6714,
     /* 106314 */   GIR_EraseRootFromParent_Done,
     /* 106315 */ // Label 1650: @106315
     /* 106315 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(106347), // Rule ID 6715 //
     /* 106320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106334 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106337 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106339 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106341 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106346 */   // GIR_Coverage, 6715,
     /* 106346 */   GIR_EraseRootFromParent_Done,
     /* 106347 */ // Label 1651: @106347
     /* 106347 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(106379), // Rule ID 6716 //
     /* 106352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106366 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106369 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106371 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106378 */   // GIR_Coverage, 6716,
     /* 106378 */   GIR_EraseRootFromParent_Done,
     /* 106379 */ // Label 1652: @106379
     /* 106379 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(106405), // Rule ID 6717 //
     /* 106384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106398 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /* 106398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106403 */   GIR_RootConstrainSelectedInstOperands,
     /* 106404 */   // GIR_Coverage, 6717,
     /* 106404 */   GIR_Done,
     /* 106405 */ // Label 1653: @106405
     /* 106405 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(106431), // Rule ID 6718 //
     /* 106410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106424 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /* 106424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106429 */   GIR_RootConstrainSelectedInstOperands,
     /* 106430 */   // GIR_Coverage, 6718,
     /* 106430 */   GIR_Done,
     /* 106431 */ // Label 1654: @106431
     /* 106431 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(106457), // Rule ID 6719 //
     /* 106436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106450 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /* 106450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 106455 */   GIR_RootConstrainSelectedInstOperands,
     /* 106456 */   // GIR_Coverage, 6719,
     /* 106456 */   GIR_Done,
     /* 106457 */ // Label 1655: @106457
     /* 106457 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(106483), // Rule ID 6720 //
     /* 106462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106476 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /* 106476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106481 */   GIR_RootConstrainSelectedInstOperands,
     /* 106482 */   // GIR_Coverage, 6720,
     /* 106482 */   GIR_Done,
     /* 106483 */ // Label 1656: @106483
     /* 106483 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(106509), // Rule ID 6721 //
     /* 106488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106502 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /* 106502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106507 */   GIR_RootConstrainSelectedInstOperands,
     /* 106508 */   // GIR_Coverage, 6721,
     /* 106508 */   GIR_Done,
     /* 106509 */ // Label 1657: @106509
     /* 106509 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(106538), // Rule ID 6722 //
     /* 106514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106525 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106528 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106530 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106532 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106537 */   // GIR_Coverage, 6722,
     /* 106537 */   GIR_EraseRootFromParent_Done,
     /* 106538 */ // Label 1658: @106538
     /* 106538 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(106567), // Rule ID 6723 //
     /* 106543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106554 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106557 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106559 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106561 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106566 */   // GIR_Coverage, 6723,
     /* 106566 */   GIR_EraseRootFromParent_Done,
     /* 106567 */ // Label 1659: @106567
     /* 106567 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(106599), // Rule ID 6777 //
     /* 106572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106586 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106589 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106591 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106593 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106598 */   // GIR_Coverage, 6777,
     /* 106598 */   GIR_EraseRootFromParent_Done,
     /* 106599 */ // Label 1660: @106599
     /* 106599 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(106631), // Rule ID 6778 //
     /* 106604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106618 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106621 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106623 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106630 */   // GIR_Coverage, 6778,
     /* 106630 */   GIR_EraseRootFromParent_Done,
     /* 106631 */ // Label 1661: @106631
     /* 106631 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(106663), // Rule ID 6779 //
     /* 106636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106650 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106653 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106655 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106662 */   // GIR_Coverage, 6779,
     /* 106662 */   GIR_EraseRootFromParent_Done,
     /* 106663 */ // Label 1662: @106663
     /* 106663 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(106695), // Rule ID 6780 //
     /* 106668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106682 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106685 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106687 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106694 */   // GIR_Coverage, 6780,
     /* 106694 */   GIR_EraseRootFromParent_Done,
     /* 106695 */ // Label 1663: @106695
     /* 106695 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(106727), // Rule ID 6781 //
     /* 106700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106714 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106717 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106719 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106726 */   // GIR_Coverage, 6781,
     /* 106726 */   GIR_EraseRootFromParent_Done,
     /* 106727 */ // Label 1664: @106727
     /* 106727 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(106753), // Rule ID 6782 //
     /* 106732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106746 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /* 106746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106751 */   GIR_RootConstrainSelectedInstOperands,
     /* 106752 */   // GIR_Coverage, 6782,
     /* 106752 */   GIR_Done,
     /* 106753 */ // Label 1665: @106753
     /* 106753 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(106779), // Rule ID 6783 //
     /* 106758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106772 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /* 106772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106777 */   GIR_RootConstrainSelectedInstOperands,
     /* 106778 */   // GIR_Coverage, 6783,
     /* 106778 */   GIR_Done,
     /* 106779 */ // Label 1666: @106779
     /* 106779 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(106805), // Rule ID 6784 //
     /* 106784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106798 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /* 106798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106803 */   GIR_RootConstrainSelectedInstOperands,
     /* 106804 */   // GIR_Coverage, 6784,
     /* 106804 */   GIR_Done,
     /* 106805 */ // Label 1667: @106805
     /* 106805 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(106831), // Rule ID 6785 //
     /* 106810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106824 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /* 106824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 106829 */   GIR_RootConstrainSelectedInstOperands,
     /* 106830 */   // GIR_Coverage, 6785,
     /* 106830 */   GIR_Done,
     /* 106831 */ // Label 1668: @106831
     /* 106831 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(106857), // Rule ID 6786 //
     /* 106836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106850 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /* 106850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106855 */   GIR_RootConstrainSelectedInstOperands,
     /* 106856 */   // GIR_Coverage, 6786,
     /* 106856 */   GIR_Done,
     /* 106857 */ // Label 1669: @106857
     /* 106857 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(106886), // Rule ID 6787 //
     /* 106862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106873 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106876 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106885 */   // GIR_Coverage, 6787,
     /* 106885 */   GIR_EraseRootFromParent_Done,
     /* 106886 */ // Label 1670: @106886
     /* 106886 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(106915), // Rule ID 6788 //
     /* 106891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106902 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106914 */   // GIR_Coverage, 6788,
     /* 106914 */   GIR_EraseRootFromParent_Done,
     /* 106915 */ // Label 1671: @106915
     /* 106915 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(106947), // Rule ID 6789 //
     /* 106920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106934 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106946 */   // GIR_Coverage, 6789,
     /* 106946 */   GIR_EraseRootFromParent_Done,
     /* 106947 */ // Label 1672: @106947
     /* 106947 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(106979), // Rule ID 6790 //
     /* 106952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106966 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106978 */   // GIR_Coverage, 6790,
     /* 106978 */   GIR_EraseRootFromParent_Done,
     /* 106979 */ // Label 1673: @106979
     /* 106979 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(107011), // Rule ID 6791 //
     /* 106984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106998 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107010 */   // GIR_Coverage, 6791,
     /* 107010 */   GIR_EraseRootFromParent_Done,
     /* 107011 */ // Label 1674: @107011
     /* 107011 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(107043), // Rule ID 6792 //
     /* 107016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107030 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107042 */   // GIR_Coverage, 6792,
     /* 107042 */   GIR_EraseRootFromParent_Done,
     /* 107043 */ // Label 1675: @107043
     /* 107043 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(107075), // Rule ID 6793 //
     /* 107048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107062 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107074 */   // GIR_Coverage, 6793,
     /* 107074 */   GIR_EraseRootFromParent_Done,
     /* 107075 */ // Label 1676: @107075
     /* 107075 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(107101), // Rule ID 6794 //
     /* 107080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107094 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /* 107094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107099 */   GIR_RootConstrainSelectedInstOperands,
     /* 107100 */   // GIR_Coverage, 6794,
     /* 107100 */   GIR_Done,
     /* 107101 */ // Label 1677: @107101
     /* 107101 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(107127), // Rule ID 6795 //
     /* 107106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107120 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /* 107120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107125 */   GIR_RootConstrainSelectedInstOperands,
     /* 107126 */   // GIR_Coverage, 6795,
     /* 107126 */   GIR_Done,
     /* 107127 */ // Label 1678: @107127
     /* 107127 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(107153), // Rule ID 6796 //
     /* 107132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107146 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /* 107146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107151 */   GIR_RootConstrainSelectedInstOperands,
     /* 107152 */   // GIR_Coverage, 6796,
     /* 107152 */   GIR_Done,
     /* 107153 */ // Label 1679: @107153
     /* 107153 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(107179), // Rule ID 6797 //
     /* 107158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107172 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /* 107172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107177 */   GIR_RootConstrainSelectedInstOperands,
     /* 107178 */   // GIR_Coverage, 6797,
     /* 107178 */   GIR_Done,
     /* 107179 */ // Label 1680: @107179
     /* 107179 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(107205), // Rule ID 6798 //
     /* 107184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107198 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /* 107198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107203 */   GIR_RootConstrainSelectedInstOperands,
     /* 107204 */   // GIR_Coverage, 6798,
     /* 107204 */   GIR_Done,
     /* 107205 */ // Label 1681: @107205
     /* 107205 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(107234), // Rule ID 6799 //
     /* 107210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107221 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107224 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107226 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107233 */   // GIR_Coverage, 6799,
     /* 107233 */   GIR_EraseRootFromParent_Done,
     /* 107234 */ // Label 1682: @107234
     /* 107234 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(107263), // Rule ID 6800 //
     /* 107239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107250 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107253 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107255 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107262 */   // GIR_Coverage, 6800,
     /* 107262 */   GIR_EraseRootFromParent_Done,
     /* 107263 */ // Label 1683: @107263
     /* 107263 */ GIM_Reject,
     /* 107264 */ // Label 1603: @107264
     /* 107264 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(107296), // Rule ID 6814 //
     /* 107269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107283 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107286 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107288 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107295 */   // GIR_Coverage, 6814,
     /* 107295 */   GIR_EraseRootFromParent_Done,
     /* 107296 */ // Label 1684: @107296
     /* 107296 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(107328), // Rule ID 6815 //
     /* 107301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107315 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107318 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107320 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107327 */   // GIR_Coverage, 6815,
     /* 107327 */   GIR_EraseRootFromParent_Done,
     /* 107328 */ // Label 1685: @107328
     /* 107328 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(107360), // Rule ID 6816 //
     /* 107333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107347 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107350 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107352 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107359 */   // GIR_Coverage, 6816,
     /* 107359 */   GIR_EraseRootFromParent_Done,
     /* 107360 */ // Label 1686: @107360
     /* 107360 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(107392), // Rule ID 6817 //
     /* 107365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107379 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107382 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107384 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107391 */   // GIR_Coverage, 6817,
     /* 107391 */   GIR_EraseRootFromParent_Done,
     /* 107392 */ // Label 1687: @107392
     /* 107392 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(107424), // Rule ID 6818 //
     /* 107397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107411 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107414 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107416 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107423 */   // GIR_Coverage, 6818,
     /* 107423 */   GIR_EraseRootFromParent_Done,
     /* 107424 */ // Label 1688: @107424
     /* 107424 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(107456), // Rule ID 6819 //
     /* 107429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107443 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107446 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107448 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107450 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107455 */   // GIR_Coverage, 6819,
     /* 107455 */   GIR_EraseRootFromParent_Done,
     /* 107456 */ // Label 1689: @107456
     /* 107456 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(107488), // Rule ID 6820 //
     /* 107461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 107467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107475 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107478 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107480 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107482 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107487 */   // GIR_Coverage, 6820,
     /* 107487 */   GIR_EraseRootFromParent_Done,
     /* 107488 */ // Label 1690: @107488
     /* 107488 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(107521), // Rule ID 6821 //
     /* 107493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107507 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /* 107507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107519 */   GIR_RootConstrainSelectedInstOperands,
     /* 107520 */   // GIR_Coverage, 6821,
     /* 107520 */   GIR_EraseRootFromParent_Done,
     /* 107521 */ // Label 1691: @107521
     /* 107521 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(107592), // Rule ID 6822 //
     /* 107526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107540 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /* 107540 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107543 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107547 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107552 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107570 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107590 */   GIR_RootConstrainSelectedInstOperands,
     /* 107591 */   // GIR_Coverage, 6822,
     /* 107591 */   GIR_EraseRootFromParent_Done,
     /* 107592 */ // Label 1692: @107592
     /* 107592 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(107663), // Rule ID 6823 //
     /* 107597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107611 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /* 107611 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107614 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107618 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107623 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107641 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107661 */   GIR_RootConstrainSelectedInstOperands,
     /* 107662 */   // GIR_Coverage, 6823,
     /* 107662 */   GIR_EraseRootFromParent_Done,
     /* 107663 */ // Label 1693: @107663
     /* 107663 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(107734), // Rule ID 6824 //
     /* 107668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107682 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /* 107682 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107685 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107689 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107694 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107712 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107723 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107732 */   GIR_RootConstrainSelectedInstOperands,
     /* 107733 */   // GIR_Coverage, 6824,
     /* 107733 */   GIR_EraseRootFromParent_Done,
     /* 107734 */ // Label 1694: @107734
     /* 107734 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(107767), // Rule ID 6825 //
     /* 107739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107753 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /* 107753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107760 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107765 */   GIR_RootConstrainSelectedInstOperands,
     /* 107766 */   // GIR_Coverage, 6825,
     /* 107766 */   GIR_EraseRootFromParent_Done,
     /* 107767 */ // Label 1695: @107767
     /* 107767 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(107838), // Rule ID 6826 //
     /* 107772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107786 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /* 107786 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107789 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107793 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107798 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107816 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107836 */   GIR_RootConstrainSelectedInstOperands,
     /* 107837 */   // GIR_Coverage, 6826,
     /* 107837 */   GIR_EraseRootFromParent_Done,
     /* 107838 */ // Label 1696: @107838
     /* 107838 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(107909), // Rule ID 6827 //
     /* 107843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 107849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107857 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /* 107857 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107860 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 107864 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107869 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 107882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107887 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107907 */   GIR_RootConstrainSelectedInstOperands,
     /* 107908 */   // GIR_Coverage, 6827,
     /* 107908 */   GIR_EraseRootFromParent_Done,
     /* 107909 */ // Label 1697: @107909
     /* 107909 */ GIM_Reject,
     /* 107910 */ // Label 1604: @107910
     /* 107910 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(107940), // Rule ID 6679 //
     /* 107915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107929 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107939 */   // GIR_Coverage, 6679,
     /* 107939 */   GIR_Done,
     /* 107940 */ // Label 1698: @107940
     /* 107940 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(107970), // Rule ID 6681 //
     /* 107945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107959 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107969 */   // GIR_Coverage, 6681,
     /* 107969 */   GIR_Done,
     /* 107970 */ // Label 1699: @107970
     /* 107970 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108020), // Rule ID 6690 //
     /* 107975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107989 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 107989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108001 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 108005 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 108015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108018 */   GIR_RootConstrainSelectedInstOperands,
     /* 108019 */   // GIR_Coverage, 6690,
     /* 108019 */   GIR_EraseRootFromParent_Done,
     /* 108020 */ // Label 1700: @108020
     /* 108020 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108070), // Rule ID 6692 //
     /* 108025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108039 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 108039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 108042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108051 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 108055 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 108065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108068 */   GIR_RootConstrainSelectedInstOperands,
     /* 108069 */   // GIR_Coverage, 6692,
     /* 108069 */   GIR_EraseRootFromParent_Done,
     /* 108070 */ // Label 1701: @108070
     /* 108070 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108102), // Rule ID 6724 //
     /* 108075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108089 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108101 */   // GIR_Coverage, 6724,
     /* 108101 */   GIR_EraseRootFromParent_Done,
     /* 108102 */ // Label 1702: @108102
     /* 108102 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108134), // Rule ID 6725 //
     /* 108107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108121 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108133 */   // GIR_Coverage, 6725,
     /* 108133 */   GIR_EraseRootFromParent_Done,
     /* 108134 */ // Label 1703: @108134
     /* 108134 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108166), // Rule ID 6726 //
     /* 108139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108153 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108165 */   // GIR_Coverage, 6726,
     /* 108165 */   GIR_EraseRootFromParent_Done,
     /* 108166 */ // Label 1704: @108166
     /* 108166 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108198), // Rule ID 6727 //
     /* 108171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108185 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108197 */   // GIR_Coverage, 6727,
     /* 108197 */   GIR_EraseRootFromParent_Done,
     /* 108198 */ // Label 1705: @108198
     /* 108198 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108230), // Rule ID 6728 //
     /* 108203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108217 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108229 */   // GIR_Coverage, 6728,
     /* 108229 */   GIR_EraseRootFromParent_Done,
     /* 108230 */ // Label 1706: @108230
     /* 108230 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(108262), // Rule ID 6729 //
     /* 108235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108249 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108252 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108254 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108261 */   // GIR_Coverage, 6729,
     /* 108261 */   GIR_EraseRootFromParent_Done,
     /* 108262 */ // Label 1707: @108262
     /* 108262 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(108288), // Rule ID 6730 //
     /* 108267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108281 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /* 108281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108286 */   GIR_RootConstrainSelectedInstOperands,
     /* 108287 */   // GIR_Coverage, 6730,
     /* 108287 */   GIR_Done,
     /* 108288 */ // Label 1708: @108288
     /* 108288 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(108314), // Rule ID 6731 //
     /* 108293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108307 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /* 108307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108312 */   GIR_RootConstrainSelectedInstOperands,
     /* 108313 */   // GIR_Coverage, 6731,
     /* 108313 */   GIR_Done,
     /* 108314 */ // Label 1709: @108314
     /* 108314 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(108340), // Rule ID 6732 //
     /* 108319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108333 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /* 108333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 108338 */   GIR_RootConstrainSelectedInstOperands,
     /* 108339 */   // GIR_Coverage, 6732,
     /* 108339 */   GIR_Done,
     /* 108340 */ // Label 1710: @108340
     /* 108340 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(108366), // Rule ID 6733 //
     /* 108345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108359 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /* 108359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108364 */   GIR_RootConstrainSelectedInstOperands,
     /* 108365 */   // GIR_Coverage, 6733,
     /* 108365 */   GIR_Done,
     /* 108366 */ // Label 1711: @108366
     /* 108366 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(108392), // Rule ID 6734 //
     /* 108371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108385 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /* 108385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108390 */   GIR_RootConstrainSelectedInstOperands,
     /* 108391 */   // GIR_Coverage, 6734,
     /* 108391 */   GIR_Done,
     /* 108392 */ // Label 1712: @108392
     /* 108392 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(108418), // Rule ID 6735 //
     /* 108397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108411 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /* 108411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108416 */   GIR_RootConstrainSelectedInstOperands,
     /* 108417 */   // GIR_Coverage, 6735,
     /* 108417 */   GIR_Done,
     /* 108418 */ // Label 1713: @108418
     /* 108418 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(108447), // Rule ID 6736 //
     /* 108423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108434 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108437 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108439 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108441 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108446 */   // GIR_Coverage, 6736,
     /* 108446 */   GIR_EraseRootFromParent_Done,
     /* 108447 */ // Label 1714: @108447
     /* 108447 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(108479), // Rule ID 6801 //
     /* 108452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108466 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108469 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108478 */   // GIR_Coverage, 6801,
     /* 108478 */   GIR_EraseRootFromParent_Done,
     /* 108479 */ // Label 1715: @108479
     /* 108479 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(108511), // Rule ID 6802 //
     /* 108484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108498 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108501 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108503 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108510 */   // GIR_Coverage, 6802,
     /* 108510 */   GIR_EraseRootFromParent_Done,
     /* 108511 */ // Label 1716: @108511
     /* 108511 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(108543), // Rule ID 6803 //
     /* 108516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108530 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108533 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108537 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108542 */   // GIR_Coverage, 6803,
     /* 108542 */   GIR_EraseRootFromParent_Done,
     /* 108543 */ // Label 1717: @108543
     /* 108543 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(108575), // Rule ID 6804 //
     /* 108548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108562 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108565 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108567 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108569 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108574 */   // GIR_Coverage, 6804,
     /* 108574 */   GIR_EraseRootFromParent_Done,
     /* 108575 */ // Label 1718: @108575
     /* 108575 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(108607), // Rule ID 6805 //
     /* 108580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108594 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108597 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108599 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108601 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108606 */   // GIR_Coverage, 6805,
     /* 108606 */   GIR_EraseRootFromParent_Done,
     /* 108607 */ // Label 1719: @108607
     /* 108607 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(108639), // Rule ID 6806 //
     /* 108612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108626 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108629 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108631 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108638 */   // GIR_Coverage, 6806,
     /* 108638 */   GIR_EraseRootFromParent_Done,
     /* 108639 */ // Label 1720: @108639
     /* 108639 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(108665), // Rule ID 6807 //
     /* 108644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108658 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /* 108658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108663 */   GIR_RootConstrainSelectedInstOperands,
     /* 108664 */   // GIR_Coverage, 6807,
     /* 108664 */   GIR_Done,
     /* 108665 */ // Label 1721: @108665
     /* 108665 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(108691), // Rule ID 6808 //
     /* 108670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108684 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /* 108684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108689 */   GIR_RootConstrainSelectedInstOperands,
     /* 108690 */   // GIR_Coverage, 6808,
     /* 108690 */   GIR_Done,
     /* 108691 */ // Label 1722: @108691
     /* 108691 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(108717), // Rule ID 6809 //
     /* 108696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108710 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /* 108710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 108715 */   GIR_RootConstrainSelectedInstOperands,
     /* 108716 */   // GIR_Coverage, 6809,
     /* 108716 */   GIR_Done,
     /* 108717 */ // Label 1723: @108717
     /* 108717 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(108743), // Rule ID 6810 //
     /* 108722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108736 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /* 108736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108741 */   GIR_RootConstrainSelectedInstOperands,
     /* 108742 */   // GIR_Coverage, 6810,
     /* 108742 */   GIR_Done,
     /* 108743 */ // Label 1724: @108743
     /* 108743 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(108769), // Rule ID 6811 //
     /* 108748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108762 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /* 108762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108767 */   GIR_RootConstrainSelectedInstOperands,
     /* 108768 */   // GIR_Coverage, 6811,
     /* 108768 */   GIR_Done,
     /* 108769 */ // Label 1725: @108769
     /* 108769 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(108795), // Rule ID 6812 //
     /* 108774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108788 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /* 108788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108793 */   GIR_RootConstrainSelectedInstOperands,
     /* 108794 */   // GIR_Coverage, 6812,
     /* 108794 */   GIR_Done,
     /* 108795 */ // Label 1726: @108795
     /* 108795 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(108824), // Rule ID 6813 //
     /* 108800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108811 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108814 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108823 */   // GIR_Coverage, 6813,
     /* 108823 */   GIR_EraseRootFromParent_Done,
     /* 108824 */ // Label 1727: @108824
     /* 108824 */ GIM_Reject,
     /* 108825 */ // Label 1605: @108825
     /* 108825 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(108857), // Rule ID 6828 //
     /* 108830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 108836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108844 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108856 */   // GIR_Coverage, 6828,
     /* 108856 */   GIR_EraseRootFromParent_Done,
     /* 108857 */ // Label 1728: @108857
     /* 108857 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(108889), // Rule ID 6829 //
     /* 108862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108876 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108888 */   // GIR_Coverage, 6829,
     /* 108888 */   GIR_EraseRootFromParent_Done,
     /* 108889 */ // Label 1729: @108889
     /* 108889 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(108921), // Rule ID 6830 //
     /* 108894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108908 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108911 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108913 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108920 */   // GIR_Coverage, 6830,
     /* 108920 */   GIR_EraseRootFromParent_Done,
     /* 108921 */ // Label 1730: @108921
     /* 108921 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(108953), // Rule ID 6831 //
     /* 108926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108940 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108943 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108952 */   // GIR_Coverage, 6831,
     /* 108952 */   GIR_EraseRootFromParent_Done,
     /* 108953 */ // Label 1731: @108953
     /* 108953 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(108985), // Rule ID 6832 //
     /* 108958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108972 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108984 */   // GIR_Coverage, 6832,
     /* 108984 */   GIR_EraseRootFromParent_Done,
     /* 108985 */ // Label 1732: @108985
     /* 108985 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(109017), // Rule ID 6833 //
     /* 108990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109004 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 109004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109016 */   // GIR_Coverage, 6833,
     /* 109016 */   GIR_EraseRootFromParent_Done,
     /* 109017 */ // Label 1733: @109017
     /* 109017 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(109050), // Rule ID 6834 //
     /* 109022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109036 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 109036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109041 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109043 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109048 */   GIR_RootConstrainSelectedInstOperands,
     /* 109049 */   // GIR_Coverage, 6834,
     /* 109049 */   GIR_EraseRootFromParent_Done,
     /* 109050 */ // Label 1734: @109050
     /* 109050 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(109076), // Rule ID 6835 //
     /* 109055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109069 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /* 109069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109074 */   GIR_RootConstrainSelectedInstOperands,
     /* 109075 */   // GIR_Coverage, 6835,
     /* 109075 */   GIR_Done,
     /* 109076 */ // Label 1735: @109076
     /* 109076 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(109102), // Rule ID 6836 //
     /* 109081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109095 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /* 109095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109100 */   GIR_RootConstrainSelectedInstOperands,
     /* 109101 */   // GIR_Coverage, 6836,
     /* 109101 */   GIR_Done,
     /* 109102 */ // Label 1736: @109102
     /* 109102 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(109128), // Rule ID 6837 //
     /* 109107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109121 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /* 109121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109126 */   GIR_RootConstrainSelectedInstOperands,
     /* 109127 */   // GIR_Coverage, 6837,
     /* 109127 */   GIR_Done,
     /* 109128 */ // Label 1737: @109128
     /* 109128 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(109154), // Rule ID 6838 //
     /* 109133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109147 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /* 109147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109152 */   GIR_RootConstrainSelectedInstOperands,
     /* 109153 */   // GIR_Coverage, 6838,
     /* 109153 */   GIR_Done,
     /* 109154 */ // Label 1738: @109154
     /* 109154 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(109180), // Rule ID 6839 //
     /* 109159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109173 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /* 109173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109178 */   GIR_RootConstrainSelectedInstOperands,
     /* 109179 */   // GIR_Coverage, 6839,
     /* 109179 */   GIR_Done,
     /* 109180 */ // Label 1739: @109180
     /* 109180 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(109209), // Rule ID 6840 //
     /* 109185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109196 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 109196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109199 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109201 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109208 */   // GIR_Coverage, 6840,
     /* 109208 */   GIR_EraseRootFromParent_Done,
     /* 109209 */ // Label 1740: @109209
     /* 109209 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(109241), // Rule ID 6854 //
     /* 109214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109228 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109231 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109233 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109240 */   // GIR_Coverage, 6854,
     /* 109240 */   GIR_EraseRootFromParent_Done,
     /* 109241 */ // Label 1741: @109241
     /* 109241 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(109273), // Rule ID 6855 //
     /* 109246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109260 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109263 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109265 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109267 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109272 */   // GIR_Coverage, 6855,
     /* 109272 */   GIR_EraseRootFromParent_Done,
     /* 109273 */ // Label 1742: @109273
     /* 109273 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(109305), // Rule ID 6856 //
     /* 109278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109292 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109295 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109297 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109299 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109304 */   // GIR_Coverage, 6856,
     /* 109304 */   GIR_EraseRootFromParent_Done,
     /* 109305 */ // Label 1743: @109305
     /* 109305 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(109337), // Rule ID 6857 //
     /* 109310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109324 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109336 */   // GIR_Coverage, 6857,
     /* 109336 */   GIR_EraseRootFromParent_Done,
     /* 109337 */ // Label 1744: @109337
     /* 109337 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(109369), // Rule ID 6858 //
     /* 109342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109356 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109359 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109368 */   // GIR_Coverage, 6858,
     /* 109368 */   GIR_EraseRootFromParent_Done,
     /* 109369 */ // Label 1745: @109369
     /* 109369 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(109401), // Rule ID 6859 //
     /* 109374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109388 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109391 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109400 */   // GIR_Coverage, 6859,
     /* 109400 */   GIR_EraseRootFromParent_Done,
     /* 109401 */ // Label 1746: @109401
     /* 109401 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(109434), // Rule ID 6860 //
     /* 109406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109420 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 109420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109425 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109432 */   GIR_RootConstrainSelectedInstOperands,
     /* 109433 */   // GIR_Coverage, 6860,
     /* 109433 */   GIR_EraseRootFromParent_Done,
     /* 109434 */ // Label 1747: @109434
     /* 109434 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(109460), // Rule ID 6861 //
     /* 109439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109453 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /* 109453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109458 */   GIR_RootConstrainSelectedInstOperands,
     /* 109459 */   // GIR_Coverage, 6861,
     /* 109459 */   GIR_Done,
     /* 109460 */ // Label 1748: @109460
     /* 109460 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(109486), // Rule ID 6862 //
     /* 109465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109479 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /* 109479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109484 */   GIR_RootConstrainSelectedInstOperands,
     /* 109485 */   // GIR_Coverage, 6862,
     /* 109485 */   GIR_Done,
     /* 109486 */ // Label 1749: @109486
     /* 109486 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(109512), // Rule ID 6863 //
     /* 109491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109505 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /* 109505 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109510 */   GIR_RootConstrainSelectedInstOperands,
     /* 109511 */   // GIR_Coverage, 6863,
     /* 109511 */   GIR_Done,
     /* 109512 */ // Label 1750: @109512
     /* 109512 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(109538), // Rule ID 6864 //
     /* 109517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109531 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /* 109531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109536 */   GIR_RootConstrainSelectedInstOperands,
     /* 109537 */   // GIR_Coverage, 6864,
     /* 109537 */   GIR_Done,
     /* 109538 */ // Label 1751: @109538
     /* 109538 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(109564), // Rule ID 6865 //
     /* 109543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109557 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /* 109557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109562 */   GIR_RootConstrainSelectedInstOperands,
     /* 109563 */   // GIR_Coverage, 6865,
     /* 109563 */   GIR_Done,
     /* 109564 */ // Label 1752: @109564
     /* 109564 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(109593), // Rule ID 6866 //
     /* 109569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109580 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109583 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109585 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109592 */   // GIR_Coverage, 6866,
     /* 109592 */   GIR_EraseRootFromParent_Done,
     /* 109593 */ // Label 1753: @109593
     /* 109593 */ GIM_Reject,
     /* 109594 */ // Label 1606: @109594
     /* 109594 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(109624), // Rule ID 6678 //
     /* 109599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109613 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109623 */   // GIR_Coverage, 6678,
     /* 109623 */   GIR_Done,
     /* 109624 */ // Label 1754: @109624
     /* 109624 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(109654), // Rule ID 6680 //
     /* 109629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109643 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109653 */   // GIR_Coverage, 6680,
     /* 109653 */   GIR_Done,
     /* 109654 */ // Label 1755: @109654
     /* 109654 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(109704), // Rule ID 6689 //
     /* 109659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109673 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109685 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109689 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109702 */   GIR_RootConstrainSelectedInstOperands,
     /* 109703 */   // GIR_Coverage, 6689,
     /* 109703 */   GIR_EraseRootFromParent_Done,
     /* 109704 */ // Label 1756: @109704
     /* 109704 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(109754), // Rule ID 6691 //
     /* 109709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109723 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109735 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109752 */   GIR_RootConstrainSelectedInstOperands,
     /* 109753 */   // GIR_Coverage, 6691,
     /* 109753 */   GIR_EraseRootFromParent_Done,
     /* 109754 */ // Label 1757: @109754
     /* 109754 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(109786), // Rule ID 6737 //
     /* 109759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109773 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109776 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109785 */   // GIR_Coverage, 6737,
     /* 109785 */   GIR_EraseRootFromParent_Done,
     /* 109786 */ // Label 1758: @109786
     /* 109786 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(109818), // Rule ID 6738 //
     /* 109791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109805 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109808 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109810 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109812 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109817 */   // GIR_Coverage, 6738,
     /* 109817 */   GIR_EraseRootFromParent_Done,
     /* 109818 */ // Label 1759: @109818
     /* 109818 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(109850), // Rule ID 6739 //
     /* 109823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109837 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109840 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109842 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109844 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109849 */   // GIR_Coverage, 6739,
     /* 109849 */   GIR_EraseRootFromParent_Done,
     /* 109850 */ // Label 1760: @109850
     /* 109850 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(109882), // Rule ID 6740 //
     /* 109855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109869 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109872 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109874 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109876 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109881 */   // GIR_Coverage, 6740,
     /* 109881 */   GIR_EraseRootFromParent_Done,
     /* 109882 */ // Label 1761: @109882
     /* 109882 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(109914), // Rule ID 6741 //
     /* 109887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109901 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109904 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109906 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109908 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109913 */   // GIR_Coverage, 6741,
     /* 109913 */   GIR_EraseRootFromParent_Done,
     /* 109914 */ // Label 1762: @109914
     /* 109914 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(109946), // Rule ID 6742 //
     /* 109919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109933 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109936 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109938 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109945 */   // GIR_Coverage, 6742,
     /* 109945 */   GIR_EraseRootFromParent_Done,
     /* 109946 */ // Label 1763: @109946
     /* 109946 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(109972), // Rule ID 6743 //
     /* 109951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109965 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /* 109965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109970 */   GIR_RootConstrainSelectedInstOperands,
     /* 109971 */   // GIR_Coverage, 6743,
     /* 109971 */   GIR_Done,
     /* 109972 */ // Label 1764: @109972
     /* 109972 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(109998), // Rule ID 6744 //
     /* 109977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109991 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /* 109991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109996 */   GIR_RootConstrainSelectedInstOperands,
     /* 109997 */   // GIR_Coverage, 6744,
     /* 109997 */   GIR_Done,
     /* 109998 */ // Label 1765: @109998
     /* 109998 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(110024), // Rule ID 6745 //
     /* 110003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110017 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /* 110017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 110022 */   GIR_RootConstrainSelectedInstOperands,
     /* 110023 */   // GIR_Coverage, 6745,
     /* 110023 */   GIR_Done,
     /* 110024 */ // Label 1766: @110024
     /* 110024 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(110050), // Rule ID 6746 //
     /* 110029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110043 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /* 110043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110048 */   GIR_RootConstrainSelectedInstOperands,
     /* 110049 */   // GIR_Coverage, 6746,
     /* 110049 */   GIR_Done,
     /* 110050 */ // Label 1767: @110050
     /* 110050 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(110076), // Rule ID 6747 //
     /* 110055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110069 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /* 110069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110074 */   GIR_RootConstrainSelectedInstOperands,
     /* 110075 */   // GIR_Coverage, 6747,
     /* 110075 */   GIR_Done,
     /* 110076 */ // Label 1768: @110076
     /* 110076 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(110102), // Rule ID 6748 //
     /* 110081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110095 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /* 110095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110100 */   GIR_RootConstrainSelectedInstOperands,
     /* 110101 */   // GIR_Coverage, 6748,
     /* 110101 */   GIR_Done,
     /* 110102 */ // Label 1769: @110102
     /* 110102 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(110131), // Rule ID 6749 //
     /* 110107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110118 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 110118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110121 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110123 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110125 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110130 */   // GIR_Coverage, 6749,
     /* 110130 */   GIR_EraseRootFromParent_Done,
     /* 110131 */ // Label 1770: @110131
     /* 110131 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(110163), // Rule ID 6750 //
     /* 110136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110150 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110153 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110155 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110162 */   // GIR_Coverage, 6750,
     /* 110162 */   GIR_EraseRootFromParent_Done,
     /* 110163 */ // Label 1771: @110163
     /* 110163 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(110195), // Rule ID 6751 //
     /* 110168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110182 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110185 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110187 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110189 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110194 */   // GIR_Coverage, 6751,
     /* 110194 */   GIR_EraseRootFromParent_Done,
     /* 110195 */ // Label 1772: @110195
     /* 110195 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(110227), // Rule ID 6752 //
     /* 110200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110214 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110217 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110219 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110226 */   // GIR_Coverage, 6752,
     /* 110226 */   GIR_EraseRootFromParent_Done,
     /* 110227 */ // Label 1773: @110227
     /* 110227 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(110259), // Rule ID 6753 //
     /* 110232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110246 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110249 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110251 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110258 */   // GIR_Coverage, 6753,
     /* 110258 */   GIR_EraseRootFromParent_Done,
     /* 110259 */ // Label 1774: @110259
     /* 110259 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(110291), // Rule ID 6754 //
     /* 110264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110278 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110281 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110285 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110290 */   // GIR_Coverage, 6754,
     /* 110290 */   GIR_EraseRootFromParent_Done,
     /* 110291 */ // Label 1775: @110291
     /* 110291 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(110323), // Rule ID 6755 //
     /* 110296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110310 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110313 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110315 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110322 */   // GIR_Coverage, 6755,
     /* 110322 */   GIR_EraseRootFromParent_Done,
     /* 110323 */ // Label 1776: @110323
     /* 110323 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(110349), // Rule ID 6756 //
     /* 110328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110342 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /* 110342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110347 */   GIR_RootConstrainSelectedInstOperands,
     /* 110348 */   // GIR_Coverage, 6756,
     /* 110348 */   GIR_Done,
     /* 110349 */ // Label 1777: @110349
     /* 110349 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(110375), // Rule ID 6757 //
     /* 110354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110368 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /* 110368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110373 */   GIR_RootConstrainSelectedInstOperands,
     /* 110374 */   // GIR_Coverage, 6757,
     /* 110374 */   GIR_Done,
     /* 110375 */ // Label 1778: @110375
     /* 110375 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(110401), // Rule ID 6758 //
     /* 110380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110394 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /* 110394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 110399 */   GIR_RootConstrainSelectedInstOperands,
     /* 110400 */   // GIR_Coverage, 6758,
     /* 110400 */   GIR_Done,
     /* 110401 */ // Label 1779: @110401
     /* 110401 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(110427), // Rule ID 6759 //
     /* 110406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110420 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /* 110420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110425 */   GIR_RootConstrainSelectedInstOperands,
     /* 110426 */   // GIR_Coverage, 6759,
     /* 110426 */   GIR_Done,
     /* 110427 */ // Label 1780: @110427
     /* 110427 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(110453), // Rule ID 6760 //
     /* 110432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110446 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /* 110446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110451 */   GIR_RootConstrainSelectedInstOperands,
     /* 110452 */   // GIR_Coverage, 6760,
     /* 110452 */   GIR_Done,
     /* 110453 */ // Label 1781: @110453
     /* 110453 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(110479), // Rule ID 6761 //
     /* 110458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110472 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /* 110472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110477 */   GIR_RootConstrainSelectedInstOperands,
     /* 110478 */   // GIR_Coverage, 6761,
     /* 110478 */   GIR_Done,
     /* 110479 */ // Label 1782: @110479
     /* 110479 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(110508), // Rule ID 6762 //
     /* 110484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110495 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110498 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110500 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110502 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110507 */   // GIR_Coverage, 6762,
     /* 110507 */   GIR_EraseRootFromParent_Done,
     /* 110508 */ // Label 1783: @110508
     /* 110508 */ GIM_Reject,
     /* 110509 */ // Label 1607: @110509
     /* 110509 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(110541), // Rule ID 6841 //
     /* 110514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110528 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110531 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110533 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110540 */   // GIR_Coverage, 6841,
     /* 110540 */   GIR_EraseRootFromParent_Done,
     /* 110541 */ // Label 1784: @110541
     /* 110541 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(110573), // Rule ID 6842 //
     /* 110546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110560 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110563 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110565 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110567 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110572 */   // GIR_Coverage, 6842,
     /* 110572 */   GIR_EraseRootFromParent_Done,
     /* 110573 */ // Label 1785: @110573
     /* 110573 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(110605), // Rule ID 6843 //
     /* 110578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110592 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110595 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110597 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110604 */   // GIR_Coverage, 6843,
     /* 110604 */   GIR_EraseRootFromParent_Done,
     /* 110605 */ // Label 1786: @110605
     /* 110605 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(110637), // Rule ID 6844 //
     /* 110610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110624 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110627 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110629 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110636 */   // GIR_Coverage, 6844,
     /* 110636 */   GIR_EraseRootFromParent_Done,
     /* 110637 */ // Label 1787: @110637
     /* 110637 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(110669), // Rule ID 6845 //
     /* 110642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110656 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110659 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110661 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110668 */   // GIR_Coverage, 6845,
     /* 110668 */   GIR_EraseRootFromParent_Done,
     /* 110669 */ // Label 1788: @110669
     /* 110669 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(110701), // Rule ID 6846 //
     /* 110674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110688 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110691 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110693 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110700 */   // GIR_Coverage, 6846,
     /* 110700 */   GIR_EraseRootFromParent_Done,
     /* 110701 */ // Label 1789: @110701
     /* 110701 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(110772), // Rule ID 6847 //
     /* 110706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110720 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 110720 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 110723 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110727 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110732 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 110741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110750 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 110767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110770 */   GIR_RootConstrainSelectedInstOperands,
     /* 110771 */   // GIR_Coverage, 6847,
     /* 110771 */   GIR_EraseRootFromParent_Done,
     /* 110772 */ // Label 1790: @110772
     /* 110772 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(110798), // Rule ID 6848 //
     /* 110777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110791 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /* 110791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 110796 */   GIR_RootConstrainSelectedInstOperands,
     /* 110797 */   // GIR_Coverage, 6848,
     /* 110797 */   GIR_Done,
     /* 110798 */ // Label 1791: @110798
     /* 110798 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(110824), // Rule ID 6849 //
     /* 110803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110817 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /* 110817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 110822 */   GIR_RootConstrainSelectedInstOperands,
     /* 110823 */   // GIR_Coverage, 6849,
     /* 110823 */   GIR_Done,
     /* 110824 */ // Label 1792: @110824
     /* 110824 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(110850), // Rule ID 6850 //
     /* 110829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110843 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /* 110843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 110848 */   GIR_RootConstrainSelectedInstOperands,
     /* 110849 */   // GIR_Coverage, 6850,
     /* 110849 */   GIR_Done,
     /* 110850 */ // Label 1793: @110850
     /* 110850 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(110876), // Rule ID 6851 //
     /* 110855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110869 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /* 110869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110874 */   GIR_RootConstrainSelectedInstOperands,
     /* 110875 */   // GIR_Coverage, 6851,
     /* 110875 */   GIR_Done,
     /* 110876 */ // Label 1794: @110876
     /* 110876 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(110902), // Rule ID 6852 //
     /* 110881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110895 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /* 110895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110900 */   GIR_RootConstrainSelectedInstOperands,
     /* 110901 */   // GIR_Coverage, 6852,
     /* 110901 */   GIR_Done,
     /* 110902 */ // Label 1795: @110902
     /* 110902 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(110931), // Rule ID 6853 //
     /* 110907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110918 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110930 */   // GIR_Coverage, 6853,
     /* 110930 */   GIR_EraseRootFromParent_Done,
     /* 110931 */ // Label 1796: @110931
     /* 110931 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(110963), // Rule ID 6867 //
     /* 110936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110950 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110962 */   // GIR_Coverage, 6867,
     /* 110962 */   GIR_EraseRootFromParent_Done,
     /* 110963 */ // Label 1797: @110963
     /* 110963 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(110995), // Rule ID 6868 //
     /* 110968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110982 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110994 */   // GIR_Coverage, 6868,
     /* 110994 */   GIR_EraseRootFromParent_Done,
     /* 110995 */ // Label 1798: @110995
     /* 110995 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(111027), // Rule ID 6869 //
     /* 111000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111014 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111026 */   // GIR_Coverage, 6869,
     /* 111026 */   GIR_EraseRootFromParent_Done,
     /* 111027 */ // Label 1799: @111027
     /* 111027 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(111059), // Rule ID 6870 //
     /* 111032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111046 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111058 */   // GIR_Coverage, 6870,
     /* 111058 */   GIR_EraseRootFromParent_Done,
     /* 111059 */ // Label 1800: @111059
     /* 111059 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(111091), // Rule ID 6871 //
     /* 111064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111078 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111090 */   // GIR_Coverage, 6871,
     /* 111090 */   GIR_EraseRootFromParent_Done,
     /* 111091 */ // Label 1801: @111091
     /* 111091 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(111123), // Rule ID 6872 //
     /* 111096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111110 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111122 */   // GIR_Coverage, 6872,
     /* 111122 */   GIR_EraseRootFromParent_Done,
     /* 111123 */ // Label 1802: @111123
     /* 111123 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(111194), // Rule ID 6873 //
     /* 111128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 111134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111142 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 111142 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 111145 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111149 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111154 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111172 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 111181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 111189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 111192 */   GIR_RootConstrainSelectedInstOperands,
     /* 111193 */   // GIR_Coverage, 6873,
     /* 111193 */   GIR_EraseRootFromParent_Done,
     /* 111194 */ // Label 1803: @111194
     /* 111194 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(111220), // Rule ID 6874 //
     /* 111199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111213 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /* 111213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111218 */   GIR_RootConstrainSelectedInstOperands,
     /* 111219 */   // GIR_Coverage, 6874,
     /* 111219 */   GIR_Done,
     /* 111220 */ // Label 1804: @111220
     /* 111220 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(111246), // Rule ID 6875 //
     /* 111225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111239 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /* 111239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 111244 */   GIR_RootConstrainSelectedInstOperands,
     /* 111245 */   // GIR_Coverage, 6875,
     /* 111245 */   GIR_Done,
     /* 111246 */ // Label 1805: @111246
     /* 111246 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(111272), // Rule ID 6876 //
     /* 111251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111265 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /* 111265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 111270 */   GIR_RootConstrainSelectedInstOperands,
     /* 111271 */   // GIR_Coverage, 6876,
     /* 111271 */   GIR_Done,
     /* 111272 */ // Label 1806: @111272
     /* 111272 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(111298), // Rule ID 6877 //
     /* 111277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111291 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /* 111291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111296 */   GIR_RootConstrainSelectedInstOperands,
     /* 111297 */   // GIR_Coverage, 6877,
     /* 111297 */   GIR_Done,
     /* 111298 */ // Label 1807: @111298
     /* 111298 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(111324), // Rule ID 6878 //
     /* 111303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111317 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /* 111317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 111322 */   GIR_RootConstrainSelectedInstOperands,
     /* 111323 */   // GIR_Coverage, 6878,
     /* 111323 */   GIR_Done,
     /* 111324 */ // Label 1808: @111324
     /* 111324 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(111353), // Rule ID 6879 //
     /* 111329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111340 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111343 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111345 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111352 */   // GIR_Coverage, 6879,
     /* 111352 */   GIR_EraseRootFromParent_Done,
     /* 111353 */ // Label 1809: @111353
     /* 111353 */ GIM_Reject,
     /* 111354 */ // Label 1608: @111354
     /* 111354 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(111428), // Rule ID 5682 //
     /* 111359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 111374 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111378 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111385 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /* 111385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /* 111392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111397 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 111401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 111417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111422 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111427 */   // GIR_Coverage, 5682,
     /* 111427 */   GIR_EraseRootFromParent_Done,
     /* 111428 */ // Label 1810: @111428
     /* 111428 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(111458), // Rule ID 6677 //
     /* 111433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111447 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111457 */   // GIR_Coverage, 6677,
     /* 111457 */   GIR_Done,
     /* 111458 */ // Label 1811: @111458
     /* 111458 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(111508), // Rule ID 6688 //
     /* 111463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111477 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111489 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111493 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111503 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111506 */   GIR_RootConstrainSelectedInstOperands,
     /* 111507 */   // GIR_Coverage, 6688,
     /* 111507 */   GIR_EraseRootFromParent_Done,
     /* 111508 */ // Label 1812: @111508
     /* 111508 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(111540), // Rule ID 6763 //
     /* 111513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111527 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111530 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111532 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111539 */   // GIR_Coverage, 6763,
     /* 111539 */   GIR_EraseRootFromParent_Done,
     /* 111540 */ // Label 1813: @111540
     /* 111540 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(111572), // Rule ID 6764 //
     /* 111545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111559 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111562 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111564 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111566 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111571 */   // GIR_Coverage, 6764,
     /* 111571 */   GIR_EraseRootFromParent_Done,
     /* 111572 */ // Label 1814: @111572
     /* 111572 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(111604), // Rule ID 6765 //
     /* 111577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111591 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111594 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111596 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111603 */   // GIR_Coverage, 6765,
     /* 111603 */   GIR_EraseRootFromParent_Done,
     /* 111604 */ // Label 1815: @111604
     /* 111604 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(111636), // Rule ID 6766 //
     /* 111609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111623 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111626 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111628 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111630 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111635 */   // GIR_Coverage, 6766,
     /* 111635 */   GIR_EraseRootFromParent_Done,
     /* 111636 */ // Label 1816: @111636
     /* 111636 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(111668), // Rule ID 6767 //
     /* 111641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111655 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111658 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111660 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111667 */   // GIR_Coverage, 6767,
     /* 111667 */   GIR_EraseRootFromParent_Done,
     /* 111668 */ // Label 1817: @111668
     /* 111668 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(111700), // Rule ID 6768 //
     /* 111673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111687 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111690 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111692 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111699 */   // GIR_Coverage, 6768,
     /* 111699 */   GIR_EraseRootFromParent_Done,
     /* 111700 */ // Label 1818: @111700
     /* 111700 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(111732), // Rule ID 6769 //
     /* 111705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111719 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111722 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111724 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111731 */   // GIR_Coverage, 6769,
     /* 111731 */   GIR_EraseRootFromParent_Done,
     /* 111732 */ // Label 1819: @111732
     /* 111732 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(111758), // Rule ID 6770 //
     /* 111737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111751 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /* 111751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111756 */   GIR_RootConstrainSelectedInstOperands,
     /* 111757 */   // GIR_Coverage, 6770,
     /* 111757 */   GIR_Done,
     /* 111758 */ // Label 1820: @111758
     /* 111758 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(111784), // Rule ID 6771 //
     /* 111763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111777 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /* 111777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 111782 */   GIR_RootConstrainSelectedInstOperands,
     /* 111783 */   // GIR_Coverage, 6771,
     /* 111783 */   GIR_Done,
     /* 111784 */ // Label 1821: @111784
     /* 111784 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(111810), // Rule ID 6772 //
     /* 111789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111803 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /* 111803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111808 */   GIR_RootConstrainSelectedInstOperands,
     /* 111809 */   // GIR_Coverage, 6772,
     /* 111809 */   GIR_Done,
     /* 111810 */ // Label 1822: @111810
     /* 111810 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(111836), // Rule ID 6773 //
     /* 111815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111829 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /* 111829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111834 */   GIR_RootConstrainSelectedInstOperands,
     /* 111835 */   // GIR_Coverage, 6773,
     /* 111835 */   GIR_Done,
     /* 111836 */ // Label 1823: @111836
     /* 111836 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(111862), // Rule ID 6774 //
     /* 111841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111855 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /* 111855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 111860 */   GIR_RootConstrainSelectedInstOperands,
     /* 111861 */   // GIR_Coverage, 6774,
     /* 111861 */   GIR_Done,
     /* 111862 */ // Label 1824: @111862
     /* 111862 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(111888), // Rule ID 6775 //
     /* 111867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111881 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /* 111881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111886 */   GIR_RootConstrainSelectedInstOperands,
     /* 111887 */   // GIR_Coverage, 6775,
     /* 111887 */   GIR_Done,
     /* 111888 */ // Label 1825: @111888
     /* 111888 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(111914), // Rule ID 6776 //
     /* 111893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111907 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /* 111907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111912 */   GIR_RootConstrainSelectedInstOperands,
     /* 111913 */   // GIR_Coverage, 6776,
     /* 111913 */   GIR_Done,
     /* 111914 */ // Label 1826: @111914
     /* 111914 */ GIM_Reject,
     /* 111915 */ // Label 1609: @111915
     /* 111915 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(111947), // Rule ID 6880 //
     /* 111920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 111926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111934 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111946 */   // GIR_Coverage, 6880,
     /* 111946 */   GIR_EraseRootFromParent_Done,
     /* 111947 */ // Label 1827: @111947
     /* 111947 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(111979), // Rule ID 6881 //
     /* 111952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111966 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111978 */   // GIR_Coverage, 6881,
     /* 111978 */   GIR_EraseRootFromParent_Done,
     /* 111979 */ // Label 1828: @111979
     /* 111979 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(112011), // Rule ID 6882 //
     /* 111984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111998 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112010 */   // GIR_Coverage, 6882,
     /* 112010 */   GIR_EraseRootFromParent_Done,
     /* 112011 */ // Label 1829: @112011
     /* 112011 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(112043), // Rule ID 6883 //
     /* 112016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112030 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112042 */   // GIR_Coverage, 6883,
     /* 112042 */   GIR_EraseRootFromParent_Done,
     /* 112043 */ // Label 1830: @112043
     /* 112043 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(112075), // Rule ID 6884 //
     /* 112048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112062 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112074 */   // GIR_Coverage, 6884,
     /* 112074 */   GIR_EraseRootFromParent_Done,
     /* 112075 */ // Label 1831: @112075
     /* 112075 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(112107), // Rule ID 6885 //
     /* 112080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112094 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112106 */   // GIR_Coverage, 6885,
     /* 112106 */   GIR_EraseRootFromParent_Done,
     /* 112107 */ // Label 1832: @112107
     /* 112107 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(112178), // Rule ID 6886 //
     /* 112112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112126 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112126 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112129 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112133 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112138 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112156 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112176 */   GIR_RootConstrainSelectedInstOperands,
     /* 112177 */   // GIR_Coverage, 6886,
     /* 112177 */   GIR_EraseRootFromParent_Done,
     /* 112178 */ // Label 1833: @112178
     /* 112178 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(112204), // Rule ID 6887 //
     /* 112183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112197 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /* 112197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112202 */   GIR_RootConstrainSelectedInstOperands,
     /* 112203 */   // GIR_Coverage, 6887,
     /* 112203 */   GIR_Done,
     /* 112204 */ // Label 1834: @112204
     /* 112204 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(112230), // Rule ID 6888 //
     /* 112209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112223 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /* 112223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112228 */   GIR_RootConstrainSelectedInstOperands,
     /* 112229 */   // GIR_Coverage, 6888,
     /* 112229 */   GIR_Done,
     /* 112230 */ // Label 1835: @112230
     /* 112230 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(112256), // Rule ID 6889 //
     /* 112235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112249 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /* 112249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 112254 */   GIR_RootConstrainSelectedInstOperands,
     /* 112255 */   // GIR_Coverage, 6889,
     /* 112255 */   GIR_Done,
     /* 112256 */ // Label 1836: @112256
     /* 112256 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(112282), // Rule ID 6890 //
     /* 112261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112275 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /* 112275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112280 */   GIR_RootConstrainSelectedInstOperands,
     /* 112281 */   // GIR_Coverage, 6890,
     /* 112281 */   GIR_Done,
     /* 112282 */ // Label 1837: @112282
     /* 112282 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(112308), // Rule ID 6891 //
     /* 112287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112301 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /* 112301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112306 */   GIR_RootConstrainSelectedInstOperands,
     /* 112307 */   // GIR_Coverage, 6891,
     /* 112307 */   GIR_Done,
     /* 112308 */ // Label 1838: @112308
     /* 112308 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(112337), // Rule ID 6892 //
     /* 112313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112324 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112336 */   // GIR_Coverage, 6892,
     /* 112336 */   GIR_EraseRootFromParent_Done,
     /* 112337 */ // Label 1839: @112337
     /* 112337 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(112369), // Rule ID 6893 //
     /* 112342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112356 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112359 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112368 */   // GIR_Coverage, 6893,
     /* 112368 */   GIR_EraseRootFromParent_Done,
     /* 112369 */ // Label 1840: @112369
     /* 112369 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(112401), // Rule ID 6894 //
     /* 112374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112388 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112391 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112400 */   // GIR_Coverage, 6894,
     /* 112400 */   GIR_EraseRootFromParent_Done,
     /* 112401 */ // Label 1841: @112401
     /* 112401 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(112433), // Rule ID 6895 //
     /* 112406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112420 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112423 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112425 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112432 */   // GIR_Coverage, 6895,
     /* 112432 */   GIR_EraseRootFromParent_Done,
     /* 112433 */ // Label 1842: @112433
     /* 112433 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(112465), // Rule ID 6896 //
     /* 112438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112452 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112455 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112457 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112464 */   // GIR_Coverage, 6896,
     /* 112464 */   GIR_EraseRootFromParent_Done,
     /* 112465 */ // Label 1843: @112465
     /* 112465 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(112497), // Rule ID 6897 //
     /* 112470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112484 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112487 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112489 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112496 */   // GIR_Coverage, 6897,
     /* 112496 */   GIR_EraseRootFromParent_Done,
     /* 112497 */ // Label 1844: @112497
     /* 112497 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(112529), // Rule ID 6898 //
     /* 112502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112516 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112519 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112521 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112528 */   // GIR_Coverage, 6898,
     /* 112528 */   GIR_EraseRootFromParent_Done,
     /* 112529 */ // Label 1845: @112529
     /* 112529 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(112600), // Rule ID 6899 //
     /* 112534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112548 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112548 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112551 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112555 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112560 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112578 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112598 */   GIR_RootConstrainSelectedInstOperands,
     /* 112599 */   // GIR_Coverage, 6899,
     /* 112599 */   GIR_EraseRootFromParent_Done,
     /* 112600 */ // Label 1846: @112600
     /* 112600 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(112626), // Rule ID 6900 //
     /* 112605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112619 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /* 112619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112624 */   GIR_RootConstrainSelectedInstOperands,
     /* 112625 */   // GIR_Coverage, 6900,
     /* 112625 */   GIR_Done,
     /* 112626 */ // Label 1847: @112626
     /* 112626 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(112652), // Rule ID 6901 //
     /* 112631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112645 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /* 112645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112650 */   GIR_RootConstrainSelectedInstOperands,
     /* 112651 */   // GIR_Coverage, 6901,
     /* 112651 */   GIR_Done,
     /* 112652 */ // Label 1848: @112652
     /* 112652 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(112678), // Rule ID 6902 //
     /* 112657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112671 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /* 112671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 112676 */   GIR_RootConstrainSelectedInstOperands,
     /* 112677 */   // GIR_Coverage, 6902,
     /* 112677 */   GIR_Done,
     /* 112678 */ // Label 1849: @112678
     /* 112678 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(112704), // Rule ID 6903 //
     /* 112683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112697 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /* 112697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112702 */   GIR_RootConstrainSelectedInstOperands,
     /* 112703 */   // GIR_Coverage, 6903,
     /* 112703 */   GIR_Done,
     /* 112704 */ // Label 1850: @112704
     /* 112704 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(112730), // Rule ID 6904 //
     /* 112709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112723 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /* 112723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112728 */   GIR_RootConstrainSelectedInstOperands,
     /* 112729 */   // GIR_Coverage, 6904,
     /* 112729 */   GIR_Done,
     /* 112730 */ // Label 1851: @112730
     /* 112730 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(112759), // Rule ID 6905 //
     /* 112735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112746 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112749 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112751 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112753 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112758 */   // GIR_Coverage, 6905,
     /* 112758 */   GIR_EraseRootFromParent_Done,
     /* 112759 */ // Label 1852: @112759
     /* 112759 */ GIM_Reject,
     /* 112760 */ // Label 1610: @112760
     /* 112760 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(112792), // Rule ID 6906 //
     /* 112765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112779 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112782 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112784 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112786 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112791 */   // GIR_Coverage, 6906,
     /* 112791 */   GIR_EraseRootFromParent_Done,
     /* 112792 */ // Label 1853: @112792
     /* 112792 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(112824), // Rule ID 6907 //
     /* 112797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112811 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112814 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112823 */   // GIR_Coverage, 6907,
     /* 112823 */   GIR_EraseRootFromParent_Done,
     /* 112824 */ // Label 1854: @112824
     /* 112824 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(112856), // Rule ID 6908 //
     /* 112829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112843 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112846 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112848 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112850 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112855 */   // GIR_Coverage, 6908,
     /* 112855 */   GIR_EraseRootFromParent_Done,
     /* 112856 */ // Label 1855: @112856
     /* 112856 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(112888), // Rule ID 6909 //
     /* 112861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112875 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112878 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112887 */   // GIR_Coverage, 6909,
     /* 112887 */   GIR_EraseRootFromParent_Done,
     /* 112888 */ // Label 1856: @112888
     /* 112888 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(112920), // Rule ID 6910 //
     /* 112893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112907 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112910 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112912 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112914 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112919 */   // GIR_Coverage, 6910,
     /* 112919 */   GIR_EraseRootFromParent_Done,
     /* 112920 */ // Label 1857: @112920
     /* 112920 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(112952), // Rule ID 6911 //
     /* 112925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112939 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112942 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112944 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112946 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112951 */   // GIR_Coverage, 6911,
     /* 112951 */   GIR_EraseRootFromParent_Done,
     /* 112952 */ // Label 1858: @112952
     /* 112952 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(112984), // Rule ID 6912 //
     /* 112957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112971 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112974 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112976 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112978 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112983 */   // GIR_Coverage, 6912,
     /* 112983 */   GIR_EraseRootFromParent_Done,
     /* 112984 */ // Label 1859: @112984
     /* 112984 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(113055), // Rule ID 6913 //
     /* 112989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113003 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 113003 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 113006 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113010 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113015 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113033 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 113042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 113044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 113050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 113053 */   GIR_RootConstrainSelectedInstOperands,
     /* 113054 */   // GIR_Coverage, 6913,
     /* 113054 */   GIR_EraseRootFromParent_Done,
     /* 113055 */ // Label 1860: @113055
     /* 113055 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(113081), // Rule ID 6914 //
     /* 113060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113074 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /* 113074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113079 */   GIR_RootConstrainSelectedInstOperands,
     /* 113080 */   // GIR_Coverage, 6914,
     /* 113080 */   GIR_Done,
     /* 113081 */ // Label 1861: @113081
     /* 113081 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(113107), // Rule ID 6915 //
     /* 113086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113100 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /* 113100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 113105 */   GIR_RootConstrainSelectedInstOperands,
     /* 113106 */   // GIR_Coverage, 6915,
     /* 113106 */   GIR_Done,
     /* 113107 */ // Label 1862: @113107
     /* 113107 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(113133), // Rule ID 6916 //
     /* 113112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113126 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /* 113126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113131 */   GIR_RootConstrainSelectedInstOperands,
     /* 113132 */   // GIR_Coverage, 6916,
     /* 113132 */   GIR_Done,
     /* 113133 */ // Label 1863: @113133
     /* 113133 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(113159), // Rule ID 6917 //
     /* 113138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113152 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /* 113152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113157 */   GIR_RootConstrainSelectedInstOperands,
     /* 113158 */   // GIR_Coverage, 6917,
     /* 113158 */   GIR_Done,
     /* 113159 */ // Label 1864: @113159
     /* 113159 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(113185), // Rule ID 6918 //
     /* 113164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113178 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /* 113178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 113183 */   GIR_RootConstrainSelectedInstOperands,
     /* 113184 */   // GIR_Coverage, 6918,
     /* 113184 */   GIR_Done,
     /* 113185 */ // Label 1865: @113185
     /* 113185 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(113211), // Rule ID 6919 //
     /* 113190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113204 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /* 113204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113209 */   GIR_RootConstrainSelectedInstOperands,
     /* 113210 */   // GIR_Coverage, 6919,
     /* 113210 */   GIR_Done,
     /* 113211 */ // Label 1866: @113211
     /* 113211 */ GIM_Reject,
     /* 113212 */ // Label 1611: @113212
     /* 113212 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(113244), // Rule ID 10620 //
     /* 113217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113231 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113234 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113236 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113243 */   // GIR_Coverage, 10620,
     /* 113243 */   GIR_EraseRootFromParent_Done,
     /* 113244 */ // Label 1867: @113244
     /* 113244 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(113276), // Rule ID 10621 //
     /* 113249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113263 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113266 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113268 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113275 */   // GIR_Coverage, 10621,
     /* 113275 */   GIR_EraseRootFromParent_Done,
     /* 113276 */ // Label 1868: @113276
     /* 113276 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(113308), // Rule ID 10622 //
     /* 113281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113295 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113298 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113300 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113307 */   // GIR_Coverage, 10622,
     /* 113307 */   GIR_EraseRootFromParent_Done,
     /* 113308 */ // Label 1869: @113308
     /* 113308 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(113340), // Rule ID 10623 //
     /* 113313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113327 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113330 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113332 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113334 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113339 */   // GIR_Coverage, 10623,
     /* 113339 */   GIR_EraseRootFromParent_Done,
     /* 113340 */ // Label 1870: @113340
     /* 113340 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(113372), // Rule ID 10624 //
     /* 113345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113359 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113362 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113371 */   // GIR_Coverage, 10624,
     /* 113371 */   GIR_EraseRootFromParent_Done,
     /* 113372 */ // Label 1871: @113372
     /* 113372 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(113404), // Rule ID 10625 //
     /* 113377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113391 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113394 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113396 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113403 */   // GIR_Coverage, 10625,
     /* 113403 */   GIR_EraseRootFromParent_Done,
     /* 113404 */ // Label 1872: @113404
     /* 113404 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(113436), // Rule ID 10638 //
     /* 113409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113423 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113426 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113428 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113435 */   // GIR_Coverage, 10638,
     /* 113435 */   GIR_EraseRootFromParent_Done,
     /* 113436 */ // Label 1873: @113436
     /* 113436 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(113468), // Rule ID 10639 //
     /* 113441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113455 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113458 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113460 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113467 */   // GIR_Coverage, 10639,
     /* 113467 */   GIR_EraseRootFromParent_Done,
     /* 113468 */ // Label 1874: @113468
     /* 113468 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(113500), // Rule ID 10640 //
     /* 113473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113487 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113490 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113492 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113494 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113499 */   // GIR_Coverage, 10640,
     /* 113499 */   GIR_EraseRootFromParent_Done,
     /* 113500 */ // Label 1875: @113500
     /* 113500 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(113532), // Rule ID 10641 //
     /* 113505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113519 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113522 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113524 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113526 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113531 */   // GIR_Coverage, 10641,
     /* 113531 */   GIR_EraseRootFromParent_Done,
     /* 113532 */ // Label 1876: @113532
     /* 113532 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(113564), // Rule ID 10642 //
     /* 113537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113551 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113554 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113563 */   // GIR_Coverage, 10642,
     /* 113563 */   GIR_EraseRootFromParent_Done,
     /* 113564 */ // Label 1877: @113564
     /* 113564 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(113596), // Rule ID 10643 //
     /* 113569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113583 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113586 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113588 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113595 */   // GIR_Coverage, 10643,
     /* 113595 */   GIR_EraseRootFromParent_Done,
     /* 113596 */ // Label 1878: @113596
     /* 113596 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(113628), // Rule ID 10648 //
     /* 113601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 113604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113615 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113618 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113620 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113627 */   // GIR_Coverage, 10648,
     /* 113627 */   GIR_EraseRootFromParent_Done,
     /* 113628 */ // Label 1879: @113628
     /* 113628 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(113660), // Rule ID 10649 //
     /* 113633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 113636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113647 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113650 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113652 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113654 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113659 */   // GIR_Coverage, 10649,
     /* 113659 */   GIR_EraseRootFromParent_Done,
     /* 113660 */ // Label 1880: @113660
     /* 113660 */ GIM_Reject,
     /* 113661 */ // Label 1612: @113661
     /* 113661 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(113693), // Rule ID 10614 //
     /* 113666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113680 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113683 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113685 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113692 */   // GIR_Coverage, 10614,
     /* 113692 */   GIR_EraseRootFromParent_Done,
     /* 113693 */ // Label 1881: @113693
     /* 113693 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(113725), // Rule ID 10615 //
     /* 113698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113712 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113715 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113717 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113724 */   // GIR_Coverage, 10615,
     /* 113724 */   GIR_EraseRootFromParent_Done,
     /* 113725 */ // Label 1882: @113725
     /* 113725 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(113757), // Rule ID 10616 //
     /* 113730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113744 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113747 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113749 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113756 */   // GIR_Coverage, 10616,
     /* 113756 */   GIR_EraseRootFromParent_Done,
     /* 113757 */ // Label 1883: @113757
     /* 113757 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(113789), // Rule ID 10617 //
     /* 113762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113776 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113779 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113781 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113783 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113788 */   // GIR_Coverage, 10617,
     /* 113788 */   GIR_EraseRootFromParent_Done,
     /* 113789 */ // Label 1884: @113789
     /* 113789 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(113821), // Rule ID 10618 //
     /* 113794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113808 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113811 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113813 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113820 */   // GIR_Coverage, 10618,
     /* 113820 */   GIR_EraseRootFromParent_Done,
     /* 113821 */ // Label 1885: @113821
     /* 113821 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(113853), // Rule ID 10619 //
     /* 113826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113840 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113843 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113845 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113852 */   // GIR_Coverage, 10619,
     /* 113852 */   GIR_EraseRootFromParent_Done,
     /* 113853 */ // Label 1886: @113853
     /* 113853 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(113885), // Rule ID 10632 //
     /* 113858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113872 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113875 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113884 */   // GIR_Coverage, 10632,
     /* 113884 */   GIR_EraseRootFromParent_Done,
     /* 113885 */ // Label 1887: @113885
     /* 113885 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(113917), // Rule ID 10633 //
     /* 113890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113904 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113907 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113909 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113916 */   // GIR_Coverage, 10633,
     /* 113916 */   GIR_EraseRootFromParent_Done,
     /* 113917 */ // Label 1888: @113917
     /* 113917 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(113949), // Rule ID 10634 //
     /* 113922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113936 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113939 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113941 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113943 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113948 */   // GIR_Coverage, 10634,
     /* 113948 */   GIR_EraseRootFromParent_Done,
     /* 113949 */ // Label 1889: @113949
     /* 113949 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(113981), // Rule ID 10635 //
     /* 113954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113968 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113971 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113973 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113980 */   // GIR_Coverage, 10635,
     /* 113980 */   GIR_EraseRootFromParent_Done,
     /* 113981 */ // Label 1890: @113981
     /* 113981 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(114013), // Rule ID 10636 //
     /* 113986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114000 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 114000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114003 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114005 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114012 */   // GIR_Coverage, 10636,
     /* 114012 */   GIR_EraseRootFromParent_Done,
     /* 114013 */ // Label 1891: @114013
     /* 114013 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(114045), // Rule ID 10637 //
     /* 114018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114032 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 114032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114035 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114037 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114044 */   // GIR_Coverage, 10637,
     /* 114044 */   GIR_EraseRootFromParent_Done,
     /* 114045 */ // Label 1892: @114045
     /* 114045 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(114077), // Rule ID 10646 //
     /* 114050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114064 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 114064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114076 */   // GIR_Coverage, 10646,
     /* 114076 */   GIR_EraseRootFromParent_Done,
     /* 114077 */ // Label 1893: @114077
     /* 114077 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(114109), // Rule ID 10647 //
     /* 114082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114096 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 114096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114099 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114101 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114108 */   // GIR_Coverage, 10647,
     /* 114108 */   GIR_EraseRootFromParent_Done,
     /* 114109 */ // Label 1894: @114109
     /* 114109 */ GIM_Reject,
     /* 114110 */ // Label 1613: @114110
     /* 114110 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(114142), // Rule ID 10608 //
     /* 114115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114129 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114132 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114134 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114141 */   // GIR_Coverage, 10608,
     /* 114141 */   GIR_EraseRootFromParent_Done,
     /* 114142 */ // Label 1895: @114142
     /* 114142 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(114174), // Rule ID 10609 //
     /* 114147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114161 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114164 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114166 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114168 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114173 */   // GIR_Coverage, 10609,
     /* 114173 */   GIR_EraseRootFromParent_Done,
     /* 114174 */ // Label 1896: @114174
     /* 114174 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(114206), // Rule ID 10610 //
     /* 114179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114193 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114196 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114198 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114205 */   // GIR_Coverage, 10610,
     /* 114205 */   GIR_EraseRootFromParent_Done,
     /* 114206 */ // Label 1897: @114206
     /* 114206 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(114238), // Rule ID 10611 //
     /* 114211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114225 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114228 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114230 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114237 */   // GIR_Coverage, 10611,
     /* 114237 */   GIR_EraseRootFromParent_Done,
     /* 114238 */ // Label 1898: @114238
     /* 114238 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(114270), // Rule ID 10612 //
     /* 114243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114257 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114260 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114262 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114269 */   // GIR_Coverage, 10612,
     /* 114269 */   GIR_EraseRootFromParent_Done,
     /* 114270 */ // Label 1899: @114270
     /* 114270 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(114302), // Rule ID 10613 //
     /* 114275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114289 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114292 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114294 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114296 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114301 */   // GIR_Coverage, 10613,
     /* 114301 */   GIR_EraseRootFromParent_Done,
     /* 114302 */ // Label 1900: @114302
     /* 114302 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(114334), // Rule ID 10626 //
     /* 114307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114321 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114324 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114326 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114328 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114333 */   // GIR_Coverage, 10626,
     /* 114333 */   GIR_EraseRootFromParent_Done,
     /* 114334 */ // Label 1901: @114334
     /* 114334 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(114366), // Rule ID 10627 //
     /* 114339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114353 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114356 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114358 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114365 */   // GIR_Coverage, 10627,
     /* 114365 */   GIR_EraseRootFromParent_Done,
     /* 114366 */ // Label 1902: @114366
     /* 114366 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(114398), // Rule ID 10628 //
     /* 114371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114385 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114388 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114390 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114392 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114397 */   // GIR_Coverage, 10628,
     /* 114397 */   GIR_EraseRootFromParent_Done,
     /* 114398 */ // Label 1903: @114398
     /* 114398 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(114430), // Rule ID 10629 //
     /* 114403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114417 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114420 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114422 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114424 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114429 */   // GIR_Coverage, 10629,
     /* 114429 */   GIR_EraseRootFromParent_Done,
     /* 114430 */ // Label 1904: @114430
     /* 114430 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(114462), // Rule ID 10630 //
     /* 114435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114449 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114452 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114456 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114461 */   // GIR_Coverage, 10630,
     /* 114461 */   GIR_EraseRootFromParent_Done,
     /* 114462 */ // Label 1905: @114462
     /* 114462 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(114494), // Rule ID 10631 //
     /* 114467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114481 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114484 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114486 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114488 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114493 */   // GIR_Coverage, 10631,
     /* 114493 */   GIR_EraseRootFromParent_Done,
     /* 114494 */ // Label 1906: @114494
     /* 114494 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(114526), // Rule ID 10644 //
     /* 114499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114513 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114516 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114518 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114525 */   // GIR_Coverage, 10644,
     /* 114525 */   GIR_EraseRootFromParent_Done,
     /* 114526 */ // Label 1907: @114526
     /* 114526 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(114558), // Rule ID 10645 //
     /* 114531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114545 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114548 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114550 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114557 */   // GIR_Coverage, 10645,
     /* 114557 */   GIR_EraseRootFromParent_Done,
     /* 114558 */ // Label 1908: @114558
     /* 114558 */ GIM_Reject,
     /* 114559 */ // Label 1614: @114559
     /* 114559 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(114591), // Rule ID 10602 //
     /* 114564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114578 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114581 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114583 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114590 */   // GIR_Coverage, 10602,
     /* 114590 */   GIR_EraseRootFromParent_Done,
     /* 114591 */ // Label 1909: @114591
     /* 114591 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(114623), // Rule ID 10603 //
     /* 114596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114610 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114613 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114615 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114622 */   // GIR_Coverage, 10603,
     /* 114622 */   GIR_EraseRootFromParent_Done,
     /* 114623 */ // Label 1910: @114623
     /* 114623 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(114655), // Rule ID 10604 //
     /* 114628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114642 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114645 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114647 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114654 */   // GIR_Coverage, 10604,
     /* 114654 */   GIR_EraseRootFromParent_Done,
     /* 114655 */ // Label 1911: @114655
     /* 114655 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(114687), // Rule ID 10605 //
     /* 114660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114674 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114677 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114686 */   // GIR_Coverage, 10605,
     /* 114686 */   GIR_EraseRootFromParent_Done,
     /* 114687 */ // Label 1912: @114687
     /* 114687 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(114719), // Rule ID 10606 //
     /* 114692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114706 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114709 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114711 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114713 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114718 */   // GIR_Coverage, 10606,
     /* 114718 */   GIR_EraseRootFromParent_Done,
     /* 114719 */ // Label 1913: @114719
     /* 114719 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(114751), // Rule ID 10607 //
     /* 114724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114738 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114741 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114745 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114750 */   // GIR_Coverage, 10607,
     /* 114750 */   GIR_EraseRootFromParent_Done,
     /* 114751 */ // Label 1914: @114751
     /* 114751 */ GIM_Reject,
     /* 114752 */ // Label 1615: @114752
     /* 114752 */ GIM_Reject,
     /* 114753 */ // Label 10: @114753
     /* 114753 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1923*/ GIMT_Encode4(115243),
     /* 114764 */ /*GILLT_s16*//*Label 1915*/ GIMT_Encode4(114804),
     /* 114768 */ /*GILLT_s32*//*Label 1916*/ GIMT_Encode4(114835),
     /* 114772 */ /*GILLT_s64*//*Label 1917*/ GIMT_Encode4(114866), GIMT_Encode4(0),
     /* 114780 */ /*GILLT_v2s32*//*Label 1918*/ GIMT_Encode4(114897),
     /* 114784 */ /*GILLT_v2s64*//*Label 1919*/ GIMT_Encode4(114928),
     /* 114788 */ /*GILLT_v4s16*//*Label 1920*/ GIMT_Encode4(114959),
     /* 114792 */ /*GILLT_v4s32*//*Label 1921*/ GIMT_Encode4(114990), GIMT_Encode4(0),
     /* 114800 */ /*GILLT_v8s16*//*Label 1922*/ GIMT_Encode4(115021),
     /* 114804 */ // Label 1915: @114804
     /* 114804 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(114834), // Rule ID 564 //
     /* 114809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 114812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114823 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 114823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /* 114828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114832 */   GIR_RootConstrainSelectedInstOperands,
     /* 114833 */   // GIR_Coverage, 564,
     /* 114833 */   GIR_Done,
     /* 114834 */ // Label 1924: @114834
     /* 114834 */ GIM_Reject,
     /* 114835 */ // Label 1916: @114835
     /* 114835 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(114865), // Rule ID 566 //
     /* 114840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114854 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 114854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /* 114859 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114863 */   GIR_RootConstrainSelectedInstOperands,
     /* 114864 */   // GIR_Coverage, 566,
     /* 114864 */   GIR_Done,
     /* 114865 */ // Label 1925: @114865
     /* 114865 */ GIM_Reject,
     /* 114866 */ // Label 1917: @114866
     /* 114866 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(114896), // Rule ID 568 //
     /* 114871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114885 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 114885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /* 114890 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114894 */   GIR_RootConstrainSelectedInstOperands,
     /* 114895 */   // GIR_Coverage, 568,
     /* 114895 */   GIR_Done,
     /* 114896 */ // Label 1926: @114896
     /* 114896 */ GIM_Reject,
     /* 114897 */ // Label 1918: @114897
     /* 114897 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(114927), // Rule ID 933 //
     /* 114902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114916 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 114916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /* 114921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114925 */   GIR_RootConstrainSelectedInstOperands,
     /* 114926 */   // GIR_Coverage, 933,
     /* 114926 */   GIR_Done,
     /* 114927 */ // Label 1927: @114927
     /* 114927 */ GIM_Reject,
     /* 114928 */ // Label 1919: @114928
     /* 114928 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(114958), // Rule ID 937 //
     /* 114933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114947 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 114947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /* 114952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114956 */   GIR_RootConstrainSelectedInstOperands,
     /* 114957 */   // GIR_Coverage, 937,
     /* 114957 */   GIR_Done,
     /* 114958 */ // Label 1928: @114958
     /* 114958 */ GIM_Reject,
     /* 114959 */ // Label 1920: @114959
     /* 114959 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(114989), // Rule ID 929 //
     /* 114964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114978 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 114978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /* 114983 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114987 */   GIR_RootConstrainSelectedInstOperands,
     /* 114988 */   // GIR_Coverage, 929,
     /* 114988 */   GIR_Done,
     /* 114989 */ // Label 1929: @114989
     /* 114989 */ GIM_Reject,
     /* 114990 */ // Label 1921: @114990
     /* 114990 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(115020), // Rule ID 935 //
     /* 114995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115009 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 115009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 115014 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115018 */   GIR_RootConstrainSelectedInstOperands,
     /* 115019 */   // GIR_Coverage, 935,
     /* 115019 */   GIR_Done,
     /* 115020 */ // Label 1930: @115020
     /* 115020 */ GIM_Reject,
     /* 115021 */ // Label 1922: @115021
     /* 115021 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(115242),
     /* 115026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115037 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(115056), // Rule ID 931 //
     /* 115042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115045 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 115045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /* 115050 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115054 */     GIR_RootConstrainSelectedInstOperands,
     /* 115055 */     // GIR_Coverage, 931,
     /* 115055 */     GIR_Done,
     /* 115056 */   // Label 1932: @115056
     /* 115056 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(115241), // Rule ID 7038 //
     /* 115061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 115064 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 115064 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 115067 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 115071 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115076 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 115082 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 115085 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 115089 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115094 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 115097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 115099 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 115102 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115106 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115111 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 115117 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115122 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115127 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 115130 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 115134 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115139 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 115142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 115144 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 115147 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 115151 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115156 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 115159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115161 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 115164 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 115168 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115173 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 115176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 115181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115204 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115207 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 115210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 115231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 115239 */     GIR_RootConstrainSelectedInstOperands,
     /* 115240 */     // GIR_Coverage, 7038,
     /* 115240 */     GIR_EraseRootFromParent_Done,
     /* 115241 */   // Label 1933: @115241
     /* 115241 */   GIM_Reject,
     /* 115242 */ // Label 1931: @115242
     /* 115242 */ GIM_Reject,
     /* 115243 */ // Label 1923: @115243
     /* 115243 */ GIM_Reject,
     /* 115244 */ // Label 11: @115244
     /* 115244 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1942*/ GIMT_Encode4(115734),
     /* 115255 */ /*GILLT_s16*//*Label 1934*/ GIMT_Encode4(115295),
     /* 115259 */ /*GILLT_s32*//*Label 1935*/ GIMT_Encode4(115326),
     /* 115263 */ /*GILLT_s64*//*Label 1936*/ GIMT_Encode4(115357), GIMT_Encode4(0),
     /* 115271 */ /*GILLT_v2s32*//*Label 1937*/ GIMT_Encode4(115388),
     /* 115275 */ /*GILLT_v2s64*//*Label 1938*/ GIMT_Encode4(115419),
     /* 115279 */ /*GILLT_v4s16*//*Label 1939*/ GIMT_Encode4(115450),
     /* 115283 */ /*GILLT_v4s32*//*Label 1940*/ GIMT_Encode4(115481), GIMT_Encode4(0),
     /* 115291 */ /*GILLT_v8s16*//*Label 1941*/ GIMT_Encode4(115512),
     /* 115295 */ // Label 1934: @115295
     /* 115295 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(115325), // Rule ID 528 //
     /* 115300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115314 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 115314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /* 115319 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115323 */   GIR_RootConstrainSelectedInstOperands,
     /* 115324 */   // GIR_Coverage, 528,
     /* 115324 */   GIR_Done,
     /* 115325 */ // Label 1943: @115325
     /* 115325 */ GIM_Reject,
     /* 115326 */ // Label 1935: @115326
     /* 115326 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(115356), // Rule ID 530 //
     /* 115331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115345 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 115345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /* 115350 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115354 */   GIR_RootConstrainSelectedInstOperands,
     /* 115355 */   // GIR_Coverage, 530,
     /* 115355 */   GIR_Done,
     /* 115356 */ // Label 1944: @115356
     /* 115356 */ GIM_Reject,
     /* 115357 */ // Label 1936: @115357
     /* 115357 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(115387), // Rule ID 532 //
     /* 115362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115376 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 115376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /* 115381 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115385 */   GIR_RootConstrainSelectedInstOperands,
     /* 115386 */   // GIR_Coverage, 532,
     /* 115386 */   GIR_Done,
     /* 115387 */ // Label 1945: @115387
     /* 115387 */ GIM_Reject,
     /* 115388 */ // Label 1937: @115388
     /* 115388 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(115418), // Rule ID 873 //
     /* 115393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115407 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 115407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /* 115412 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115416 */   GIR_RootConstrainSelectedInstOperands,
     /* 115417 */   // GIR_Coverage, 873,
     /* 115417 */   GIR_Done,
     /* 115418 */ // Label 1946: @115418
     /* 115418 */ GIM_Reject,
     /* 115419 */ // Label 1938: @115419
     /* 115419 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(115449), // Rule ID 877 //
     /* 115424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 115430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115438 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 115438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /* 115443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115447 */   GIR_RootConstrainSelectedInstOperands,
     /* 115448 */   // GIR_Coverage, 877,
     /* 115448 */   GIR_Done,
     /* 115449 */ // Label 1947: @115449
     /* 115449 */ GIM_Reject,
     /* 115450 */ // Label 1939: @115450
     /* 115450 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(115480), // Rule ID 869 //
     /* 115455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115469 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 115469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /* 115474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115478 */   GIR_RootConstrainSelectedInstOperands,
     /* 115479 */   // GIR_Coverage, 869,
     /* 115479 */   GIR_Done,
     /* 115480 */ // Label 1948: @115480
     /* 115480 */ GIM_Reject,
     /* 115481 */ // Label 1940: @115481
     /* 115481 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(115511), // Rule ID 875 //
     /* 115486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115500 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 115500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115505 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115509 */   GIR_RootConstrainSelectedInstOperands,
     /* 115510 */   // GIR_Coverage, 875,
     /* 115510 */   GIR_Done,
     /* 115511 */ // Label 1949: @115511
     /* 115511 */ GIM_Reject,
     /* 115512 */ // Label 1941: @115512
     /* 115512 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(115733),
     /* 115517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115528 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(115547), // Rule ID 871 //
     /* 115533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115536 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 115536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /* 115541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115545 */     GIR_RootConstrainSelectedInstOperands,
     /* 115546 */     // GIR_Coverage, 871,
     /* 115546 */     GIR_Done,
     /* 115547 */   // Label 1951: @115547
     /* 115547 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(115732), // Rule ID 7032 //
     /* 115552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 115555 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 115555 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 115558 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 115562 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115567 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 115573 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 115576 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115580 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115585 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 115588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 115590 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 115593 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115597 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115602 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 115608 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115613 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115618 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 115621 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 115625 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115630 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 115633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 115635 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 115638 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115642 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115647 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 115650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115652 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 115655 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 115659 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115664 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 115667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 115672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115695 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115698 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 115701 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 115722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 115730 */     GIR_RootConstrainSelectedInstOperands,
     /* 115731 */     // GIR_Coverage, 7032,
     /* 115731 */     GIR_EraseRootFromParent_Done,
     /* 115732 */   // Label 1952: @115732
     /* 115732 */   GIM_Reject,
     /* 115733 */ // Label 1950: @115733
     /* 115733 */ GIM_Reject,
     /* 115734 */ // Label 1942: @115734
     /* 115734 */ GIM_Reject,
     /* 115735 */ // Label 12: @115735
     /* 115735 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1955*/ GIMT_Encode4(116002),
     /* 115746 */ /*GILLT_s32*//*Label 1953*/ GIMT_Encode4(115754),
     /* 115750 */ /*GILLT_s64*//*Label 1954*/ GIMT_Encode4(115878),
     /* 115754 */ // Label 1953: @115754
     /* 115754 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(115797), // Rule ID 4818 //
     /* 115759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115769 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 115769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 115776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115781 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 115790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115795 */   GIR_RootConstrainSelectedInstOperands,
     /* 115796 */   // GIR_Coverage, 4818,
     /* 115796 */   GIR_EraseRootFromParent_Done,
     /* 115797 */ // Label 1956: @115797
     /* 115797 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(115837), // Rule ID 4824 //
     /* 115802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115809 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 115809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 115816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115821 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 115830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115835 */   GIR_RootConstrainSelectedInstOperands,
     /* 115836 */   // GIR_Coverage, 4824,
     /* 115836 */   GIR_EraseRootFromParent_Done,
     /* 115837 */ // Label 1957: @115837
     /* 115837 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(115877), // Rule ID 4826 //
     /* 115842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115849 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 115849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 115852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 115856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115861 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 115870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115875 */   GIR_RootConstrainSelectedInstOperands,
     /* 115876 */   // GIR_Coverage, 4826,
     /* 115876 */   GIR_EraseRootFromParent_Done,
     /* 115877 */ // Label 1958: @115877
     /* 115877 */ GIM_Reject,
     /* 115878 */ // Label 1954: @115878
     /* 115878 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(115921), // Rule ID 4820 //
     /* 115883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115893 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 115893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 115900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115905 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 115914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115919 */   GIR_RootConstrainSelectedInstOperands,
     /* 115920 */   // GIR_Coverage, 4820,
     /* 115920 */   GIR_EraseRootFromParent_Done,
     /* 115921 */ // Label 1959: @115921
     /* 115921 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(115961), // Rule ID 4828 //
     /* 115926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115933 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 115933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 115940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 115954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115959 */   GIR_RootConstrainSelectedInstOperands,
     /* 115960 */   // GIR_Coverage, 4828,
     /* 115960 */   GIR_EraseRootFromParent_Done,
     /* 115961 */ // Label 1960: @115961
     /* 115961 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(116001), // Rule ID 4830 //
     /* 115966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115973 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 115973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 115976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 115980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115985 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 115994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115999 */   GIR_RootConstrainSelectedInstOperands,
     /* 116000 */   // GIR_Coverage, 4830,
     /* 116000 */   GIR_EraseRootFromParent_Done,
     /* 116001 */ // Label 1961: @116001
     /* 116001 */ GIM_Reject,
     /* 116002 */ // Label 1955: @116002
     /* 116002 */ GIM_Reject,
     /* 116003 */ // Label 13: @116003
     /* 116003 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(116152),
     /* 116008 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 116011 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1966*/ GIMT_Encode4(116151),
     /* 116022 */   /*GILLT_s16*//*Label 1963*/ GIMT_Encode4(116034),
     /* 116026 */   /*GILLT_s32*//*Label 1964*/ GIMT_Encode4(116075),
     /* 116030 */   /*GILLT_s64*//*Label 1965*/ GIMT_Encode4(116113),
     /* 116034 */   // Label 1963: @116034
     /* 116034 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(116074), // Rule ID 4822 //
     /* 116039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116046 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 116046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 116049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 116053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 116067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116072 */     GIR_RootConstrainSelectedInstOperands,
     /* 116073 */     // GIR_Coverage, 4822,
     /* 116073 */     GIR_EraseRootFromParent_Done,
     /* 116074 */   // Label 1967: @116074
     /* 116074 */   GIM_Reject,
     /* 116075 */   // Label 1964: @116075
     /* 116075 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(116112), // Rule ID 4832 //
     /* 116080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116084 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 116084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 116091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 116105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116110 */     GIR_RootConstrainSelectedInstOperands,
     /* 116111 */     // GIR_Coverage, 4832,
     /* 116111 */     GIR_EraseRootFromParent_Done,
     /* 116112 */   // Label 1968: @116112
     /* 116112 */   GIM_Reject,
     /* 116113 */   // Label 1965: @116113
     /* 116113 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(116150), // Rule ID 4834 //
     /* 116118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116122 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 116122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 116125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 116129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 116143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116148 */     GIR_RootConstrainSelectedInstOperands,
     /* 116149 */     // GIR_Coverage, 4834,
     /* 116149 */     GIR_EraseRootFromParent_Done,
     /* 116150 */   // Label 1969: @116150
     /* 116150 */   GIM_Reject,
     /* 116151 */   // Label 1966: @116151
     /* 116151 */   GIM_Reject,
     /* 116152 */ // Label 1962: @116152
     /* 116152 */ GIM_Reject,
     /* 116153 */ // Label 14: @116153
     /* 116153 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1978*/ GIMT_Encode4(116643),
     /* 116164 */ /*GILLT_s16*//*Label 1970*/ GIMT_Encode4(116204),
     /* 116168 */ /*GILLT_s32*//*Label 1971*/ GIMT_Encode4(116235),
     /* 116172 */ /*GILLT_s64*//*Label 1972*/ GIMT_Encode4(116266), GIMT_Encode4(0),
     /* 116180 */ /*GILLT_v2s32*//*Label 1973*/ GIMT_Encode4(116297),
     /* 116184 */ /*GILLT_v2s64*//*Label 1974*/ GIMT_Encode4(116328),
     /* 116188 */ /*GILLT_v4s16*//*Label 1975*/ GIMT_Encode4(116359),
     /* 116192 */ /*GILLT_v4s32*//*Label 1976*/ GIMT_Encode4(116390), GIMT_Encode4(0),
     /* 116200 */ /*GILLT_v8s16*//*Label 1977*/ GIMT_Encode4(116421),
     /* 116204 */ // Label 1970: @116204
     /* 116204 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(116234), // Rule ID 546 //
     /* 116209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116223 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /* 116228 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116232 */   GIR_RootConstrainSelectedInstOperands,
     /* 116233 */   // GIR_Coverage, 546,
     /* 116233 */   GIR_Done,
     /* 116234 */ // Label 1979: @116234
     /* 116234 */ GIM_Reject,
     /* 116235 */ // Label 1971: @116235
     /* 116235 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(116265), // Rule ID 548 //
     /* 116240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116254 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /* 116259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116263 */   GIR_RootConstrainSelectedInstOperands,
     /* 116264 */   // GIR_Coverage, 548,
     /* 116264 */   GIR_Done,
     /* 116265 */ // Label 1980: @116265
     /* 116265 */ GIM_Reject,
     /* 116266 */ // Label 1972: @116266
     /* 116266 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(116296), // Rule ID 550 //
     /* 116271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116285 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /* 116290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116294 */   GIR_RootConstrainSelectedInstOperands,
     /* 116295 */   // GIR_Coverage, 550,
     /* 116295 */   GIR_Done,
     /* 116296 */ // Label 1981: @116296
     /* 116296 */ GIM_Reject,
     /* 116297 */ // Label 1973: @116297
     /* 116297 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(116327), // Rule ID 903 //
     /* 116302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116316 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /* 116321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116325 */   GIR_RootConstrainSelectedInstOperands,
     /* 116326 */   // GIR_Coverage, 903,
     /* 116326 */   GIR_Done,
     /* 116327 */ // Label 1982: @116327
     /* 116327 */ GIM_Reject,
     /* 116328 */ // Label 1974: @116328
     /* 116328 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(116358), // Rule ID 907 //
     /* 116333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116347 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /* 116352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116356 */   GIR_RootConstrainSelectedInstOperands,
     /* 116357 */   // GIR_Coverage, 907,
     /* 116357 */   GIR_Done,
     /* 116358 */ // Label 1983: @116358
     /* 116358 */ GIM_Reject,
     /* 116359 */ // Label 1975: @116359
     /* 116359 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(116389), // Rule ID 899 //
     /* 116364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116378 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /* 116383 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116387 */   GIR_RootConstrainSelectedInstOperands,
     /* 116388 */   // GIR_Coverage, 899,
     /* 116388 */   GIR_Done,
     /* 116389 */ // Label 1984: @116389
     /* 116389 */ GIM_Reject,
     /* 116390 */ // Label 1976: @116390
     /* 116390 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(116420), // Rule ID 905 //
     /* 116395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116409 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116414 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116418 */   GIR_RootConstrainSelectedInstOperands,
     /* 116419 */   // GIR_Coverage, 905,
     /* 116419 */   GIR_Done,
     /* 116420 */ // Label 1985: @116420
     /* 116420 */ GIM_Reject,
     /* 116421 */ // Label 1977: @116421
     /* 116421 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(116642),
     /* 116426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116437 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(116456), // Rule ID 901 //
     /* 116442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116445 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 116445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /* 116450 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116454 */     GIR_RootConstrainSelectedInstOperands,
     /* 116455 */     // GIR_Coverage, 901,
     /* 116455 */     GIR_Done,
     /* 116456 */   // Label 1987: @116456
     /* 116456 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(116641), // Rule ID 7034 //
     /* 116461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 116464 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 116464 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 116467 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 116471 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116476 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 116482 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 116485 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116489 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116494 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 116497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 116499 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 116502 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116506 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116511 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 116517 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116522 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116527 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 116530 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 116534 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116539 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 116542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 116544 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 116547 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116551 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116556 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 116559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 116564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 116568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116573 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 116576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116578 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 116581 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116585 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 116610 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 116631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 116639 */     GIR_RootConstrainSelectedInstOperands,
     /* 116640 */     // GIR_Coverage, 7034,
     /* 116640 */     GIR_EraseRootFromParent_Done,
     /* 116641 */   // Label 1988: @116641
     /* 116641 */   GIM_Reject,
     /* 116642 */ // Label 1986: @116642
     /* 116642 */ GIM_Reject,
     /* 116643 */ // Label 1978: @116643
     /* 116643 */ GIM_Reject,
     /* 116644 */ // Label 15: @116644
     /* 116644 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(116676), // Rule ID 3901 //
     /* 116649 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 116652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116656 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /* 116656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 116659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116661 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /* 116671 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 116674 */   GIR_RootConstrainSelectedInstOperands,
     /* 116675 */   // GIR_Coverage, 3901,
     /* 116675 */   GIR_EraseRootFromParent_Done,
     /* 116676 */ // Label 1989: @116676
     /* 116676 */ GIM_Reject,
     /* 116677 */ // Label 16: @116677
     /* 116677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2010*/ GIMT_Encode4(125614),
     /* 116688 */ /*GILLT_s8*//*Label 1990*/ GIMT_Encode4(116784),
     /* 116692 */ /*GILLT_s16*//*Label 1991*/ GIMT_Encode4(116960),
     /* 116696 */ /*GILLT_s32*//*Label 1992*/ GIMT_Encode4(117136),
     /* 116700 */ /*GILLT_s64*//*Label 1993*/ GIMT_Encode4(119530),
     /* 116704 */ /*GILLT_s128*//*Label 1994*/ GIMT_Encode4(122243),
     /* 116708 */ /*GILLT_v2s32*//*Label 1995*/ GIMT_Encode4(122452),
     /* 116712 */ /*GILLT_v2s64*//*Label 1996*/ GIMT_Encode4(122830),
     /* 116716 */ /*GILLT_v4s16*//*Label 1997*/ GIMT_Encode4(123208),
     /* 116720 */ /*GILLT_v4s32*//*Label 1998*/ GIMT_Encode4(123586),
     /* 116724 */ /*GILLT_v8s8*//*Label 1999*/ GIMT_Encode4(123964),
     /* 116728 */ /*GILLT_v8s16*//*Label 2000*/ GIMT_Encode4(124172),
     /* 116732 */ /*GILLT_v16s8*//*Label 2001*/ GIMT_Encode4(124550), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116744 */ /*GILLT_nxv2s16*//*Label 2002*/ GIMT_Encode4(124758),
     /* 116748 */ /*GILLT_nxv2s32*//*Label 2003*/ GIMT_Encode4(124822),
     /* 116752 */ /*GILLT_nxv2s64*//*Label 2004*/ GIMT_Encode4(124886), GIMT_Encode4(0),
     /* 116760 */ /*GILLT_nxv4s16*//*Label 2005*/ GIMT_Encode4(125060),
     /* 116764 */ /*GILLT_nxv4s32*//*Label 2006*/ GIMT_Encode4(125124), GIMT_Encode4(0),
     /* 116772 */ /*GILLT_nxv8s16*//*Label 2007*/ GIMT_Encode4(125298),
     /* 116776 */ /*GILLT_nxv16s1*//*Label 2008*/ GIMT_Encode4(125472),
     /* 116780 */ /*GILLT_nxv16s8*//*Label 2009*/ GIMT_Encode4(125516),
     /* 116784 */ // Label 1990: @116784
     /* 116784 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(116959),
     /* 116789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 116800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116804 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(116845), // Rule ID 237 //
     /* 116809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116819 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 116822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116843 */     GIR_RootConstrainSelectedInstOperands,
     /* 116844 */     // GIR_Coverage, 237,
     /* 116844 */     GIR_EraseRootFromParent_Done,
     /* 116845 */   // Label 2012: @116845
     /* 116845 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(116886), // Rule ID 238 //
     /* 116850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116860 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 116863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116884 */     GIR_RootConstrainSelectedInstOperands,
     /* 116885 */     // GIR_Coverage, 238,
     /* 116885 */     GIR_EraseRootFromParent_Done,
     /* 116886 */   // Label 2013: @116886
     /* 116886 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(116922), // Rule ID 261 //
     /* 116891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116901 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 116904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116920 */     GIR_RootConstrainSelectedInstOperands,
     /* 116921 */     // GIR_Coverage, 261,
     /* 116921 */     GIR_EraseRootFromParent_Done,
     /* 116922 */   // Label 2014: @116922
     /* 116922 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(116958), // Rule ID 282 //
     /* 116927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 116937 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 116940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116956 */     GIR_RootConstrainSelectedInstOperands,
     /* 116957 */     // GIR_Coverage, 282,
     /* 116957 */     GIR_EraseRootFromParent_Done,
     /* 116958 */   // Label 2015: @116958
     /* 116958 */   GIM_Reject,
     /* 116959 */ // Label 2011: @116959
     /* 116959 */ GIM_Reject,
     /* 116960 */ // Label 1991: @116960
     /* 116960 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(117135),
     /* 116965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116968 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116976 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116980 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(117021), // Rule ID 239 //
     /* 116985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116995 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 116998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117019 */     GIR_RootConstrainSelectedInstOperands,
     /* 117020 */     // GIR_Coverage, 239,
     /* 117020 */     GIR_EraseRootFromParent_Done,
     /* 117021 */   // Label 2017: @117021
     /* 117021 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(117062), // Rule ID 240 //
     /* 117026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117036 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 117039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117060 */     GIR_RootConstrainSelectedInstOperands,
     /* 117061 */     // GIR_Coverage, 240,
     /* 117061 */     GIR_EraseRootFromParent_Done,
     /* 117062 */   // Label 2018: @117062
     /* 117062 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(117098), // Rule ID 262 //
     /* 117067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 117077 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 117077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 117080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117096 */     GIR_RootConstrainSelectedInstOperands,
     /* 117097 */     // GIR_Coverage, 262,
     /* 117097 */     GIR_EraseRootFromParent_Done,
     /* 117098 */   // Label 2019: @117098
     /* 117098 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(117134), // Rule ID 283 //
     /* 117103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117113 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 117116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117132 */     GIR_RootConstrainSelectedInstOperands,
     /* 117133 */     // GIR_Coverage, 283,
     /* 117133 */     GIR_EraseRootFromParent_Done,
     /* 117134 */   // Label 2020: @117134
     /* 117134 */   GIM_Reject,
     /* 117135 */ // Label 2016: @117135
     /* 117135 */ GIM_Reject,
     /* 117136 */ // Label 1992: @117136
     /* 117136 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(117189), // Rule ID 233 //
     /* 117141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117144 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117152 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117156 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117163 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 117166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117187 */   GIR_RootConstrainSelectedInstOperands,
     /* 117188 */   // GIR_Coverage, 233,
     /* 117188 */   GIR_EraseRootFromParent_Done,
     /* 117189 */ // Label 2021: @117189
     /* 117189 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(117242), // Rule ID 234 //
     /* 117194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117197 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117216 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 117219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117240 */   GIR_RootConstrainSelectedInstOperands,
     /* 117241 */   // GIR_Coverage, 234,
     /* 117241 */   GIR_EraseRootFromParent_Done,
     /* 117242 */ // Label 2022: @117242
     /* 117242 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(117298), // Rule ID 241 //
     /* 117247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117272 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 117275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117292 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117296 */   GIR_RootConstrainSelectedInstOperands,
     /* 117297 */   // GIR_Coverage, 241,
     /* 117297 */   GIR_EraseRootFromParent_Done,
     /* 117298 */ // Label 2023: @117298
     /* 117298 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(117354), // Rule ID 242 //
     /* 117303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117309 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117328 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 117331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117352 */   GIR_RootConstrainSelectedInstOperands,
     /* 117353 */   // GIR_Coverage, 242,
     /* 117353 */   GIR_EraseRootFromParent_Done,
     /* 117354 */ // Label 2024: @117354
     /* 117354 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(117414), // Rule ID 4117 //
     /* 117359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117362 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117388 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 117388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 117391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117408 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117412 */   GIR_RootConstrainSelectedInstOperands,
     /* 117413 */   // GIR_Coverage, 4117,
     /* 117413 */   GIR_EraseRootFromParent_Done,
     /* 117414 */ // Label 2025: @117414
     /* 117414 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(117474), // Rule ID 4118 //
     /* 117419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117422 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117426 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117448 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 117448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 117451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117472 */   GIR_RootConstrainSelectedInstOperands,
     /* 117473 */   // GIR_Coverage, 4118,
     /* 117473 */   GIR_EraseRootFromParent_Done,
     /* 117474 */ // Label 2026: @117474
     /* 117474 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(117534), // Rule ID 4119 //
     /* 117479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117482 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117486 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117497 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117501 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117508 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 117511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117532 */   GIR_RootConstrainSelectedInstOperands,
     /* 117533 */   // GIR_Coverage, 4119,
     /* 117533 */   GIR_EraseRootFromParent_Done,
     /* 117534 */ // Label 2027: @117534
     /* 117534 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(117594), // Rule ID 4120 //
     /* 117539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117542 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117546 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117557 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117561 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117568 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 117571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117592 */   GIR_RootConstrainSelectedInstOperands,
     /* 117593 */   // GIR_Coverage, 4120,
     /* 117593 */   GIR_EraseRootFromParent_Done,
     /* 117594 */ // Label 2028: @117594
     /* 117594 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(117654), // Rule ID 4121 //
     /* 117599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117602 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117606 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117628 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 117631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117652 */   GIR_RootConstrainSelectedInstOperands,
     /* 117653 */   // GIR_Coverage, 4121,
     /* 117653 */   GIR_EraseRootFromParent_Done,
     /* 117654 */ // Label 2029: @117654
     /* 117654 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(117714), // Rule ID 4122 //
     /* 117659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117662 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117666 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117688 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 117691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117712 */   GIR_RootConstrainSelectedInstOperands,
     /* 117713 */   // GIR_Coverage, 4122,
     /* 117713 */   GIR_EraseRootFromParent_Done,
     /* 117714 */ // Label 2030: @117714
     /* 117714 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(117762), // Rule ID 260 //
     /* 117719 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117722 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117730 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117734 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117741 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 117744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117756 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117760 */   GIR_RootConstrainSelectedInstOperands,
     /* 117761 */   // GIR_Coverage, 260,
     /* 117761 */   GIR_EraseRootFromParent_Done,
     /* 117762 */ // Label 2031: @117762
     /* 117762 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(117813), // Rule ID 263 //
     /* 117767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117785 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117792 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 117795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117807 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117811 */   GIR_RootConstrainSelectedInstOperands,
     /* 117812 */   // GIR_Coverage, 263,
     /* 117812 */   GIR_EraseRootFromParent_Done,
     /* 117813 */ // Label 2032: @117813
     /* 117813 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(117876), // Rule ID 7064 //
     /* 117818 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117821 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117825 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117832 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117839 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117843 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117850 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15837>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 117850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 117853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117874 */   GIR_RootConstrainSelectedInstOperands,
     /* 117875 */   // GIR_Coverage, 7064,
     /* 117875 */   GIR_EraseRootFromParent_Done,
     /* 117876 */ // Label 2033: @117876
     /* 117876 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(117939), // Rule ID 7066 //
     /* 117881 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117884 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117888 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117895 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117906 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117913 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15837>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 117913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 117916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117937 */   GIR_RootConstrainSelectedInstOperands,
     /* 117938 */   // GIR_Coverage, 7066,
     /* 117938 */   GIR_EraseRootFromParent_Done,
     /* 117939 */ // Label 2034: @117939
     /* 117939 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(118002), // Rule ID 7076 //
     /* 117944 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117947 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117951 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117958 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117965 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117969 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117976 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15845>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 117979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118000 */   GIR_RootConstrainSelectedInstOperands,
     /* 118001 */   // GIR_Coverage, 7076,
     /* 118001 */   GIR_EraseRootFromParent_Done,
     /* 118002 */ // Label 2035: @118002
     /* 118002 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(118065), // Rule ID 7078 //
     /* 118007 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118010 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118014 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118021 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118028 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 118039 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15845>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 118039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 118042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118063 */   GIR_RootConstrainSelectedInstOperands,
     /* 118064 */   // GIR_Coverage, 7078,
     /* 118064 */   GIR_EraseRootFromParent_Done,
     /* 118065 */ // Label 2036: @118065
     /* 118065 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(118128), // Rule ID 7086 //
     /* 118070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118073 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118077 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118084 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 118102 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15853>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 118102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 118105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118126 */   GIR_RootConstrainSelectedInstOperands,
     /* 118127 */   // GIR_Coverage, 7086,
     /* 118127 */   GIR_EraseRootFromParent_Done,
     /* 118128 */ // Label 2037: @118128
     /* 118128 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(118191), // Rule ID 7087 //
     /* 118133 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118136 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118147 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118165 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15853>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 118168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118189 */   GIR_RootConstrainSelectedInstOperands,
     /* 118190 */   // GIR_Coverage, 7087,
     /* 118190 */   GIR_EraseRootFromParent_Done,
     /* 118191 */ // Label 2038: @118191
     /* 118191 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(118239), // Rule ID 281 //
     /* 118196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118199 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118218 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 118221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118237 */   GIR_RootConstrainSelectedInstOperands,
     /* 118238 */   // GIR_Coverage, 281,
     /* 118238 */   GIR_EraseRootFromParent_Done,
     /* 118239 */ // Label 2039: @118239
     /* 118239 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(118290), // Rule ID 284 //
     /* 118244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118262 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118269 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 118272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118288 */   GIR_RootConstrainSelectedInstOperands,
     /* 118289 */   // GIR_Coverage, 284,
     /* 118289 */   GIR_EraseRootFromParent_Done,
     /* 118290 */ // Label 2040: @118290
     /* 118290 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(118345), // Rule ID 4144 //
     /* 118295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118298 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118302 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118324 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 118327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118343 */   GIR_RootConstrainSelectedInstOperands,
     /* 118344 */   // GIR_Coverage, 4144,
     /* 118344 */   GIR_EraseRootFromParent_Done,
     /* 118345 */ // Label 2041: @118345
     /* 118345 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(118400), // Rule ID 4145 //
     /* 118350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118353 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118357 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118379 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118398 */   GIR_RootConstrainSelectedInstOperands,
     /* 118399 */   // GIR_Coverage, 4145,
     /* 118399 */   GIR_EraseRootFromParent_Done,
     /* 118400 */ // Label 2042: @118400
     /* 118400 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(118455), // Rule ID 4146 //
     /* 118405 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118408 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118427 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118434 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118449 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118453 */   GIR_RootConstrainSelectedInstOperands,
     /* 118454 */   // GIR_Coverage, 4146,
     /* 118454 */   GIR_EraseRootFromParent_Done,
     /* 118455 */ // Label 2043: @118455
     /* 118455 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(118510), // Rule ID 4167 //
     /* 118460 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118463 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118467 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118482 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118489 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 118492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118504 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118508 */   GIR_RootConstrainSelectedInstOperands,
     /* 118509 */   // GIR_Coverage, 4167,
     /* 118509 */   GIR_EraseRootFromParent_Done,
     /* 118510 */ // Label 2044: @118510
     /* 118510 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(118565), // Rule ID 4168 //
     /* 118515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118518 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118522 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118544 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118563 */   GIR_RootConstrainSelectedInstOperands,
     /* 118564 */   // GIR_Coverage, 4168,
     /* 118564 */   GIR_EraseRootFromParent_Done,
     /* 118565 */ // Label 2045: @118565
     /* 118565 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(118620), // Rule ID 4169 //
     /* 118570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118573 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118577 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118588 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118592 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118599 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118618 */   GIR_RootConstrainSelectedInstOperands,
     /* 118619 */   // GIR_Coverage, 4169,
     /* 118619 */   GIR_EraseRootFromParent_Done,
     /* 118620 */ // Label 2046: @118620
     /* 118620 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(118678), // Rule ID 7068 //
     /* 118625 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118628 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118632 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118639 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118646 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118657 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15837>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118672 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118676 */   GIR_RootConstrainSelectedInstOperands,
     /* 118677 */   // GIR_Coverage, 7068,
     /* 118677 */   GIR_EraseRootFromParent_Done,
     /* 118678 */ // Label 2047: @118678
     /* 118678 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(118736), // Rule ID 7070 //
     /* 118683 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118686 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118690 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118697 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118708 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118715 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15837>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118730 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118734 */   GIR_RootConstrainSelectedInstOperands,
     /* 118735 */   // GIR_Coverage, 7070,
     /* 118735 */   GIR_EraseRootFromParent_Done,
     /* 118736 */ // Label 2048: @118736
     /* 118736 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(118794), // Rule ID 7080 //
     /* 118741 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118744 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118755 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118773 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15845>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 118776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118788 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118792 */   GIR_RootConstrainSelectedInstOperands,
     /* 118793 */   // GIR_Coverage, 7080,
     /* 118793 */   GIR_EraseRootFromParent_Done,
     /* 118794 */ // Label 2049: @118794
     /* 118794 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(118852), // Rule ID 7082 //
     /* 118799 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118802 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118806 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118813 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118831 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15845>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 118834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118850 */   GIR_RootConstrainSelectedInstOperands,
     /* 118851 */   // GIR_Coverage, 7082,
     /* 118851 */   GIR_EraseRootFromParent_Done,
     /* 118852 */ // Label 2050: @118852
     /* 118852 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(118910), // Rule ID 7088 //
     /* 118857 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118864 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118871 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118878 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118882 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 118889 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15853>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 118889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 118892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118904 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118908 */   GIR_RootConstrainSelectedInstOperands,
     /* 118909 */   // GIR_Coverage, 7088,
     /* 118909 */   GIR_EraseRootFromParent_Done,
     /* 118910 */ // Label 2051: @118910
     /* 118910 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(118968), // Rule ID 7089 //
     /* 118915 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118922 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118929 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118940 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118947 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15853>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 118950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118962 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118966 */   GIR_RootConstrainSelectedInstOperands,
     /* 118967 */   // GIR_Coverage, 7089,
     /* 118967 */   GIR_EraseRootFromParent_Done,
     /* 118968 */ // Label 2052: @118968
     /* 118968 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(119029), // Rule ID 7474 //
     /* 118973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 118976 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118979 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118983 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119001 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 119008 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15826>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 119011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119027 */   GIR_RootConstrainSelectedInstOperands,
     /* 119028 */   // GIR_Coverage, 7474,
     /* 119028 */   GIR_EraseRootFromParent_Done,
     /* 119029 */ // Label 2053: @119029
     /* 119029 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(119090), // Rule ID 7476 //
     /* 119034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 119037 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119040 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119044 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119051 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 119069 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15828>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 119072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119088 */   GIR_RootConstrainSelectedInstOperands,
     /* 119089 */   // GIR_Coverage, 7476,
     /* 119089 */   GIR_EraseRootFromParent_Done,
     /* 119090 */ // Label 2054: @119090
     /* 119090 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(119151), // Rule ID 7478 //
     /* 119095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 119098 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119101 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 119130 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15830>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 119133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119149 */   GIR_RootConstrainSelectedInstOperands,
     /* 119150 */   // GIR_Coverage, 7478,
     /* 119150 */   GIR_EraseRootFromParent_Done,
     /* 119151 */ // Label 2055: @119151
     /* 119151 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(119195), // Rule ID 7054 //
     /* 119156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119159 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119162 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119180 */   // MIs[0] ptr
     /* 119180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119188 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15826>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 119193 */   GIR_RootConstrainSelectedInstOperands,
     /* 119194 */   // GIR_Coverage, 7054,
     /* 119194 */   GIR_Done,
     /* 119195 */ // Label 2056: @119195
     /* 119195 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(119239), // Rule ID 7056 //
     /* 119200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119206 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119210 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119224 */   // MIs[0] ptr
     /* 119224 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119232 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15828>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 119237 */   GIR_RootConstrainSelectedInstOperands,
     /* 119238 */   // GIR_Coverage, 7056,
     /* 119238 */   GIR_Done,
     /* 119239 */ // Label 2057: @119239
     /* 119239 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(119283), // Rule ID 7058 //
     /* 119244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119247 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119254 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119268 */   // MIs[0] ptr
     /* 119268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119276 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15830>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 119281 */   GIR_RootConstrainSelectedInstOperands,
     /* 119282 */   // GIR_Coverage, 7058,
     /* 119282 */   GIR_Done,
     /* 119283 */ // Label 2058: @119283
     /* 119283 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(119324), // Rule ID 7060 //
     /* 119288 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119291 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119295 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119302 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119309 */   // MIs[0] ptr
     /* 119309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119317 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15834>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 119322 */   GIR_RootConstrainSelectedInstOperands,
     /* 119323 */   // GIR_Coverage, 7060,
     /* 119323 */   GIR_Done,
     /* 119324 */ // Label 2059: @119324
     /* 119324 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(119365), // Rule ID 7062 //
     /* 119329 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119332 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119350 */   // MIs[0] ptr
     /* 119350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119358 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15826>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 119363 */   GIR_RootConstrainSelectedInstOperands,
     /* 119364 */   // GIR_Coverage, 7062,
     /* 119364 */   GIR_Done,
     /* 119365 */ // Label 2060: @119365
     /* 119365 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(119406), // Rule ID 7072 //
     /* 119370 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119373 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119384 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119391 */   // MIs[0] ptr
     /* 119391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119399 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15842>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 119404 */   GIR_RootConstrainSelectedInstOperands,
     /* 119405 */   // GIR_Coverage, 7072,
     /* 119405 */   GIR_Done,
     /* 119406 */ // Label 2061: @119406
     /* 119406 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(119447), // Rule ID 7074 //
     /* 119411 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119414 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119418 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119432 */   // MIs[0] ptr
     /* 119432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119440 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15828>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 119445 */   GIR_RootConstrainSelectedInstOperands,
     /* 119446 */   // GIR_Coverage, 7074,
     /* 119446 */   GIR_Done,
     /* 119447 */ // Label 2062: @119447
     /* 119447 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(119488), // Rule ID 7084 //
     /* 119452 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119459 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119466 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119473 */   // MIs[0] ptr
     /* 119473 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119481 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15850>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 119486 */   GIR_RootConstrainSelectedInstOperands,
     /* 119487 */   // GIR_Coverage, 7084,
     /* 119487 */   GIR_Done,
     /* 119488 */ // Label 2063: @119488
     /* 119488 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(119529), // Rule ID 7085 //
     /* 119493 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119496 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119507 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119514 */   // MIs[0] ptr
     /* 119514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119522 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15830>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 119527 */   GIR_RootConstrainSelectedInstOperands,
     /* 119528 */   // GIR_Coverage, 7085,
     /* 119528 */   GIR_Done,
     /* 119529 */ // Label 2064: @119529
     /* 119529 */ GIM_Reject,
     /* 119530 */ // Label 1993: @119530
     /* 119530 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(119583), // Rule ID 235 //
     /* 119535 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119538 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119557 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 119560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119581 */   GIR_RootConstrainSelectedInstOperands,
     /* 119582 */   // GIR_Coverage, 235,
     /* 119582 */   GIR_EraseRootFromParent_Done,
     /* 119583 */ // Label 2065: @119583
     /* 119583 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(119636), // Rule ID 236 //
     /* 119588 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119591 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119610 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 119613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119634 */   GIR_RootConstrainSelectedInstOperands,
     /* 119635 */   // GIR_Coverage, 236,
     /* 119635 */   GIR_EraseRootFromParent_Done,
     /* 119636 */ // Label 2066: @119636
     /* 119636 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(119692), // Rule ID 243 //
     /* 119641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119644 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119647 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119666 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119690 */   GIR_RootConstrainSelectedInstOperands,
     /* 119691 */   // GIR_Coverage, 243,
     /* 119691 */   GIR_EraseRootFromParent_Done,
     /* 119692 */ // Label 2067: @119692
     /* 119692 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(119748), // Rule ID 244 //
     /* 119697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119722 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119742 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119746 */   GIR_RootConstrainSelectedInstOperands,
     /* 119747 */   // GIR_Coverage, 244,
     /* 119747 */   GIR_EraseRootFromParent_Done,
     /* 119748 */ // Label 2068: @119748
     /* 119748 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(119801), // Rule ID 4083 //
     /* 119753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119756 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119764 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119768 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119775 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119799 */   GIR_RootConstrainSelectedInstOperands,
     /* 119800 */   // GIR_Coverage, 4083,
     /* 119800 */   GIR_EraseRootFromParent_Done,
     /* 119801 */ // Label 2069: @119801
     /* 119801 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(119854), // Rule ID 4084 //
     /* 119806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119828 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119852 */   GIR_RootConstrainSelectedInstOperands,
     /* 119853 */   // GIR_Coverage, 4084,
     /* 119853 */   GIR_EraseRootFromParent_Done,
     /* 119854 */ // Label 2070: @119854
     /* 119854 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(119907), // Rule ID 4085 //
     /* 119859 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119862 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119881 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119905 */   GIR_RootConstrainSelectedInstOperands,
     /* 119906 */   // GIR_Coverage, 4085,
     /* 119906 */   GIR_EraseRootFromParent_Done,
     /* 119907 */ // Label 2071: @119907
     /* 119907 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(119960), // Rule ID 4086 //
     /* 119912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119915 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119934 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119958 */   GIR_RootConstrainSelectedInstOperands,
     /* 119959 */   // GIR_Coverage, 4086,
     /* 119959 */   GIR_EraseRootFromParent_Done,
     /* 119960 */ // Label 2072: @119960
     /* 119960 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(120052), // Rule ID 4109 //
     /* 119965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119968 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119972 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 119983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119994 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 119994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 120001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120021 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120051 */   // GIR_Coverage, 4109,
     /* 120051 */   GIR_EraseRootFromParent_Done,
     /* 120052 */ // Label 2073: @120052
     /* 120052 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(120144), // Rule ID 4110 //
     /* 120057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120060 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120064 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120075 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120079 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 120086 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 120093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120113 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120143 */   // GIR_Coverage, 4110,
     /* 120143 */   GIR_EraseRootFromParent_Done,
     /* 120144 */ // Label 2074: @120144
     /* 120144 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(120236), // Rule ID 4111 //
     /* 120149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120152 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120167 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 120178 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 120185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120205 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120235 */   // GIR_Coverage, 4111,
     /* 120235 */   GIR_EraseRootFromParent_Done,
     /* 120236 */ // Label 2075: @120236
     /* 120236 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(120328), // Rule ID 4112 //
     /* 120241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120244 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 120270 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 120277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120297 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120327 */   // GIR_Coverage, 4112,
     /* 120327 */   GIR_EraseRootFromParent_Done,
     /* 120328 */ // Label 2076: @120328
     /* 120328 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(120420), // Rule ID 4113 //
     /* 120333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120336 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120340 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120351 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 120362 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 120369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120389 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120409 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120419 */   // GIR_Coverage, 4113,
     /* 120419 */   GIR_EraseRootFromParent_Done,
     /* 120420 */ // Label 2077: @120420
     /* 120420 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(120512), // Rule ID 4114 //
     /* 120425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120428 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120443 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120447 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 120454 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 120461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120481 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120511 */   // GIR_Coverage, 4114,
     /* 120511 */   GIR_EraseRootFromParent_Done,
     /* 120512 */ // Label 2078: @120512
     /* 120512 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(120604), // Rule ID 4115 //
     /* 120517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120520 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120535 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120539 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 120546 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 120553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120573 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120593 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120603 */   // GIR_Coverage, 4115,
     /* 120603 */   GIR_EraseRootFromParent_Done,
     /* 120604 */ // Label 2079: @120604
     /* 120604 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(120696), // Rule ID 4116 //
     /* 120609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120612 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120631 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 120638 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 120645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120665 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120695 */   // GIR_Coverage, 4116,
     /* 120695 */   GIR_EraseRootFromParent_Done,
     /* 120696 */ // Label 2080: @120696
     /* 120696 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(120744), // Rule ID 259 //
     /* 120701 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120704 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120712 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120716 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120723 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 120726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120742 */   GIR_RootConstrainSelectedInstOperands,
     /* 120743 */   // GIR_Coverage, 259,
     /* 120743 */   GIR_EraseRootFromParent_Done,
     /* 120744 */ // Label 2081: @120744
     /* 120744 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(120795), // Rule ID 264 //
     /* 120749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120767 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120774 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 120777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120793 */   GIR_RootConstrainSelectedInstOperands,
     /* 120794 */   // GIR_Coverage, 264,
     /* 120794 */   GIR_EraseRootFromParent_Done,
     /* 120795 */ // Label 2082: @120795
     /* 120795 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(120858), // Rule ID 7092 //
     /* 120800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120803 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120807 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120814 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120825 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120832 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15861>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 120835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120856 */   GIR_RootConstrainSelectedInstOperands,
     /* 120857 */   // GIR_Coverage, 7092,
     /* 120857 */   GIR_EraseRootFromParent_Done,
     /* 120858 */ // Label 2083: @120858
     /* 120858 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(120921), // Rule ID 7093 //
     /* 120863 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120866 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120870 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120877 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120888 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120895 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15861>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 120898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120919 */   GIR_RootConstrainSelectedInstOperands,
     /* 120920 */   // GIR_Coverage, 7093,
     /* 120920 */   GIR_EraseRootFromParent_Done,
     /* 120921 */ // Label 2084: @120921
     /* 120921 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(120969), // Rule ID 280 //
     /* 120926 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120929 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120937 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120941 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120948 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 120951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120963 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120967 */   GIR_RootConstrainSelectedInstOperands,
     /* 120968 */   // GIR_Coverage, 280,
     /* 120968 */   GIR_EraseRootFromParent_Done,
     /* 120969 */ // Label 2085: @120969
     /* 120969 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(121020), // Rule ID 285 //
     /* 120974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120977 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120980 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120992 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120999 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121018 */   GIR_RootConstrainSelectedInstOperands,
     /* 121019 */   // GIR_Coverage, 285,
     /* 121019 */   GIR_EraseRootFromParent_Done,
     /* 121020 */ // Label 2086: @121020
     /* 121020 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(121068), // Rule ID 4130 //
     /* 121025 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121028 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121047 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 121050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121066 */   GIR_RootConstrainSelectedInstOperands,
     /* 121067 */   // GIR_Coverage, 4130,
     /* 121067 */   GIR_EraseRootFromParent_Done,
     /* 121068 */ // Label 2087: @121068
     /* 121068 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(121116), // Rule ID 4131 //
     /* 121073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121095 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 121098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121114 */   GIR_RootConstrainSelectedInstOperands,
     /* 121115 */   // GIR_Coverage, 4131,
     /* 121115 */   GIR_EraseRootFromParent_Done,
     /* 121116 */ // Label 2088: @121116
     /* 121116 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(121203), // Rule ID 4147 //
     /* 121121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121124 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121128 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121139 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121143 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 121150 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 121157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121172 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121197 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121202 */   // GIR_Coverage, 4147,
     /* 121202 */   GIR_EraseRootFromParent_Done,
     /* 121203 */ // Label 2089: @121203
     /* 121203 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(121290), // Rule ID 4148 //
     /* 121208 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121211 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121215 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121226 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121230 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 121237 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121237 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121240 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 121244 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121259 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121289 */   // GIR_Coverage, 4148,
     /* 121289 */   GIR_EraseRootFromParent_Done,
     /* 121290 */ // Label 2090: @121290
     /* 121290 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(121377), // Rule ID 4149 //
     /* 121295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121298 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121302 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 121324 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 121331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121346 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121376 */   // GIR_Coverage, 4149,
     /* 121376 */   GIR_EraseRootFromParent_Done,
     /* 121377 */ // Label 2091: @121377
     /* 121377 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(121464), // Rule ID 4150 //
     /* 121382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121385 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121389 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121400 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121404 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 121411 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 121418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121433 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121463 */   // GIR_Coverage, 4150,
     /* 121463 */   GIR_EraseRootFromParent_Done,
     /* 121464 */ // Label 2092: @121464
     /* 121464 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(121512), // Rule ID 4158 //
     /* 121469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121491 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121510 */   GIR_RootConstrainSelectedInstOperands,
     /* 121511 */   // GIR_Coverage, 4158,
     /* 121511 */   GIR_EraseRootFromParent_Done,
     /* 121512 */ // Label 2093: @121512
     /* 121512 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(121560), // Rule ID 4159 //
     /* 121517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121539 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121558 */   GIR_RootConstrainSelectedInstOperands,
     /* 121559 */   // GIR_Coverage, 4159,
     /* 121559 */   GIR_EraseRootFromParent_Done,
     /* 121560 */ // Label 2094: @121560
     /* 121560 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(121647), // Rule ID 4170 //
     /* 121565 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121568 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121572 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 121594 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 121601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121616 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121646 */   // GIR_Coverage, 4170,
     /* 121646 */   GIR_EraseRootFromParent_Done,
     /* 121647 */ // Label 2095: @121647
     /* 121647 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(121734), // Rule ID 4171 //
     /* 121652 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121655 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121659 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121670 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121674 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 121681 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 121688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121703 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121733 */   // GIR_Coverage, 4171,
     /* 121733 */   GIR_EraseRootFromParent_Done,
     /* 121734 */ // Label 2096: @121734
     /* 121734 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(121821), // Rule ID 4172 //
     /* 121739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121742 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121768 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 121775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121790 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121820 */   // GIR_Coverage, 4172,
     /* 121820 */   GIR_EraseRootFromParent_Done,
     /* 121821 */ // Label 2097: @121821
     /* 121821 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(121908), // Rule ID 4173 //
     /* 121826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121829 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121833 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121848 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121855 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 121862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121877 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121907 */   // GIR_Coverage, 4173,
     /* 121907 */   GIR_EraseRootFromParent_Done,
     /* 121908 */ // Label 2098: @121908
     /* 121908 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(121966), // Rule ID 7094 //
     /* 121913 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121920 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121927 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121945 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15861>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 121948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121964 */   GIR_RootConstrainSelectedInstOperands,
     /* 121965 */   // GIR_Coverage, 7094,
     /* 121965 */   GIR_EraseRootFromParent_Done,
     /* 121966 */ // Label 2099: @121966
     /* 121966 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(122024), // Rule ID 7095 //
     /* 121971 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121974 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121985 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122003 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15861>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 122006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122022 */   GIR_RootConstrainSelectedInstOperands,
     /* 122023 */   // GIR_Coverage, 7095,
     /* 122023 */   GIR_EraseRootFromParent_Done,
     /* 122024 */ // Label 2100: @122024
     /* 122024 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(122085), // Rule ID 7479 //
     /* 122029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 122032 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122039 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122046 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122053 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122057 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122064 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15832>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 122067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122083 */   GIR_RootConstrainSelectedInstOperands,
     /* 122084 */   // GIR_Coverage, 7479,
     /* 122084 */   GIR_EraseRootFromParent_Done,
     /* 122085 */ // Label 2101: @122085
     /* 122085 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(122116), // Rule ID 6435 //
     /* 122090 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122093 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122101 */   // MIs[0] Rn
     /* 122101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122109 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 122109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 122114 */   GIR_RootConstrainSelectedInstOperands,
     /* 122115 */   // GIR_Coverage, 6435,
     /* 122115 */   GIR_Done,
     /* 122116 */ // Label 2102: @122116
     /* 122116 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(122160), // Rule ID 7059 //
     /* 122121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 122124 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122131 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122138 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122145 */   // MIs[0] ptr
     /* 122145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122153 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15832>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 122158 */   GIR_RootConstrainSelectedInstOperands,
     /* 122159 */   // GIR_Coverage, 7059,
     /* 122159 */   GIR_Done,
     /* 122160 */ // Label 2103: @122160
     /* 122160 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(122201), // Rule ID 7090 //
     /* 122165 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122186 */   // MIs[0] ptr
     /* 122186 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122194 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15858>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 122199 */   GIR_RootConstrainSelectedInstOperands,
     /* 122200 */   // GIR_Coverage, 7090,
     /* 122200 */   GIR_Done,
     /* 122201 */ // Label 2104: @122201
     /* 122201 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(122242), // Rule ID 7091 //
     /* 122206 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122213 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122220 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122227 */   // MIs[0] ptr
     /* 122227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122235 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15832>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 122240 */   GIR_RootConstrainSelectedInstOperands,
     /* 122241 */   // GIR_Coverage, 7091,
     /* 122241 */   GIR_Done,
     /* 122242 */ // Label 2105: @122242
     /* 122242 */ GIM_Reject,
     /* 122243 */ // Label 1994: @122243
     /* 122243 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(122451),
     /* 122248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122251 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122263 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(122304), // Rule ID 245 //
     /* 122268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122278 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122302 */     GIR_RootConstrainSelectedInstOperands,
     /* 122303 */     // GIR_Coverage, 245,
     /* 122303 */     GIR_EraseRootFromParent_Done,
     /* 122304 */   // Label 2107: @122304
     /* 122304 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(122345), // Rule ID 246 //
     /* 122309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122319 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 122322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122343 */     GIR_RootConstrainSelectedInstOperands,
     /* 122344 */     // GIR_Coverage, 246,
     /* 122344 */     GIR_EraseRootFromParent_Done,
     /* 122345 */   // Label 2108: @122345
     /* 122345 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(122381), // Rule ID 265 //
     /* 122350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122360 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 122363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122379 */     GIR_RootConstrainSelectedInstOperands,
     /* 122380 */     // GIR_Coverage, 265,
     /* 122380 */     GIR_EraseRootFromParent_Done,
     /* 122381 */   // Label 2109: @122381
     /* 122381 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(122417), // Rule ID 286 //
     /* 122386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122396 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 122399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122415 */     GIR_RootConstrainSelectedInstOperands,
     /* 122416 */     // GIR_Coverage, 286,
     /* 122416 */     GIR_EraseRootFromParent_Done,
     /* 122417 */   // Label 2110: @122417
     /* 122417 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(122450), // Rule ID 4139 //
     /* 122422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122429 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 122432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122448 */     GIR_RootConstrainSelectedInstOperands,
     /* 122449 */     // GIR_Coverage, 4139,
     /* 122449 */     GIR_EraseRootFromParent_Done,
     /* 122450 */   // Label 2111: @122450
     /* 122450 */   GIM_Reject,
     /* 122451 */ // Label 2106: @122451
     /* 122451 */ GIM_Reject,
     /* 122452 */ // Label 1995: @122452
     /* 122452 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(122829),
     /* 122457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122468 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(122513), // Rule ID 4073 //
     /* 122473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122487 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 122490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122511 */     GIR_RootConstrainSelectedInstOperands,
     /* 122512 */     // GIR_Coverage, 4073,
     /* 122512 */     GIR_EraseRootFromParent_Done,
     /* 122513 */   // Label 2113: @122513
     /* 122513 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(122558), // Rule ID 4074 //
     /* 122518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122532 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 122535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122556 */     GIR_RootConstrainSelectedInstOperands,
     /* 122557 */     // GIR_Coverage, 4074,
     /* 122557 */     GIR_EraseRootFromParent_Done,
     /* 122558 */   // Label 2114: @122558
     /* 122558 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(122603), // Rule ID 4075 //
     /* 122563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122577 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 122580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122601 */     GIR_RootConstrainSelectedInstOperands,
     /* 122602 */     // GIR_Coverage, 4075,
     /* 122602 */     GIR_EraseRootFromParent_Done,
     /* 122603 */   // Label 2115: @122603
     /* 122603 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(122648), // Rule ID 4076 //
     /* 122608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122622 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 122625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122646 */     GIR_RootConstrainSelectedInstOperands,
     /* 122647 */     // GIR_Coverage, 4076,
     /* 122647 */     GIR_EraseRootFromParent_Done,
     /* 122648 */   // Label 2116: @122648
     /* 122648 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(122688), // Rule ID 4125 //
     /* 122653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122667 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122686 */     GIR_RootConstrainSelectedInstOperands,
     /* 122687 */     // GIR_Coverage, 4125,
     /* 122687 */     GIR_EraseRootFromParent_Done,
     /* 122688 */   // Label 2117: @122688
     /* 122688 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(122728), // Rule ID 4128 //
     /* 122693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122707 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122726 */     GIR_RootConstrainSelectedInstOperands,
     /* 122727 */     // GIR_Coverage, 4128,
     /* 122727 */     GIR_EraseRootFromParent_Done,
     /* 122728 */   // Label 2118: @122728
     /* 122728 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(122768), // Rule ID 4153 //
     /* 122733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122747 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122766 */     GIR_RootConstrainSelectedInstOperands,
     /* 122767 */     // GIR_Coverage, 4153,
     /* 122767 */     GIR_EraseRootFromParent_Done,
     /* 122768 */   // Label 2119: @122768
     /* 122768 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(122808), // Rule ID 4154 //
     /* 122773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122787 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122806 */     GIR_RootConstrainSelectedInstOperands,
     /* 122807 */     // GIR_Coverage, 4154,
     /* 122807 */     GIR_EraseRootFromParent_Done,
     /* 122808 */   // Label 2120: @122808
     /* 122808 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(122828), // Rule ID 6434 //
     /* 122813 */     // MIs[0] Rn
     /* 122813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122821 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 122821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 122826 */     GIR_RootConstrainSelectedInstOperands,
     /* 122827 */     // GIR_Coverage, 6434,
     /* 122827 */     GIR_Done,
     /* 122828 */   // Label 2121: @122828
     /* 122828 */   GIM_Reject,
     /* 122829 */ // Label 2112: @122829
     /* 122829 */ GIM_Reject,
     /* 122830 */ // Label 1996: @122830
     /* 122830 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(123207),
     /* 122835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122846 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(122891), // Rule ID 4087 //
     /* 122851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122865 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122889 */     GIR_RootConstrainSelectedInstOperands,
     /* 122890 */     // GIR_Coverage, 4087,
     /* 122890 */     GIR_EraseRootFromParent_Done,
     /* 122891 */   // Label 2123: @122891
     /* 122891 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(122936), // Rule ID 4088 //
     /* 122896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122910 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 122913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122934 */     GIR_RootConstrainSelectedInstOperands,
     /* 122935 */     // GIR_Coverage, 4088,
     /* 122935 */     GIR_EraseRootFromParent_Done,
     /* 122936 */   // Label 2124: @122936
     /* 122936 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(122981), // Rule ID 4089 //
     /* 122941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122955 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122979 */     GIR_RootConstrainSelectedInstOperands,
     /* 122980 */     // GIR_Coverage, 4089,
     /* 122980 */     GIR_EraseRootFromParent_Done,
     /* 122981 */   // Label 2125: @122981
     /* 122981 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(123026), // Rule ID 4090 //
     /* 122986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123000 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123024 */     GIR_RootConstrainSelectedInstOperands,
     /* 123025 */     // GIR_Coverage, 4090,
     /* 123025 */     GIR_EraseRootFromParent_Done,
     /* 123026 */   // Label 2126: @123026
     /* 123026 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(123066), // Rule ID 4133 //
     /* 123031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123045 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123064 */     GIR_RootConstrainSelectedInstOperands,
     /* 123065 */     // GIR_Coverage, 4133,
     /* 123065 */     GIR_EraseRootFromParent_Done,
     /* 123066 */   // Label 2127: @123066
     /* 123066 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(123106), // Rule ID 4137 //
     /* 123071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123085 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123104 */     GIR_RootConstrainSelectedInstOperands,
     /* 123105 */     // GIR_Coverage, 4137,
     /* 123105 */     GIR_EraseRootFromParent_Done,
     /* 123106 */   // Label 2128: @123106
     /* 123106 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(123146), // Rule ID 4160 //
     /* 123111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123125 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123144 */     GIR_RootConstrainSelectedInstOperands,
     /* 123145 */     // GIR_Coverage, 4160,
     /* 123145 */     GIR_EraseRootFromParent_Done,
     /* 123146 */   // Label 2129: @123146
     /* 123146 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(123186), // Rule ID 4161 //
     /* 123151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123165 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123184 */     GIR_RootConstrainSelectedInstOperands,
     /* 123185 */     // GIR_Coverage, 4161,
     /* 123185 */     GIR_EraseRootFromParent_Done,
     /* 123186 */   // Label 2130: @123186
     /* 123186 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(123206), // Rule ID 6431 //
     /* 123191 */     // MIs[0] Rn
     /* 123191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123199 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 123204 */     GIR_RootConstrainSelectedInstOperands,
     /* 123205 */     // GIR_Coverage, 6431,
     /* 123205 */     GIR_Done,
     /* 123206 */   // Label 2131: @123206
     /* 123206 */   GIM_Reject,
     /* 123207 */ // Label 2122: @123207
     /* 123207 */ GIM_Reject,
     /* 123208 */ // Label 1997: @123208
     /* 123208 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(123585),
     /* 123213 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123216 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123224 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(123269), // Rule ID 4079 //
     /* 123229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123243 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123267 */     GIR_RootConstrainSelectedInstOperands,
     /* 123268 */     // GIR_Coverage, 4079,
     /* 123268 */     GIR_EraseRootFromParent_Done,
     /* 123269 */   // Label 2133: @123269
     /* 123269 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(123314), // Rule ID 4080 //
     /* 123274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123288 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 123291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123312 */     GIR_RootConstrainSelectedInstOperands,
     /* 123313 */     // GIR_Coverage, 4080,
     /* 123313 */     GIR_EraseRootFromParent_Done,
     /* 123314 */   // Label 2134: @123314
     /* 123314 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(123359), // Rule ID 4081 //
     /* 123319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123333 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123357 */     GIR_RootConstrainSelectedInstOperands,
     /* 123358 */     // GIR_Coverage, 4081,
     /* 123358 */     GIR_EraseRootFromParent_Done,
     /* 123359 */   // Label 2135: @123359
     /* 123359 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(123404), // Rule ID 4082 //
     /* 123364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123378 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 123381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123402 */     GIR_RootConstrainSelectedInstOperands,
     /* 123403 */     // GIR_Coverage, 4082,
     /* 123403 */     GIR_EraseRootFromParent_Done,
     /* 123404 */   // Label 2136: @123404
     /* 123404 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(123444), // Rule ID 4127 //
     /* 123409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123423 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 123426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123442 */     GIR_RootConstrainSelectedInstOperands,
     /* 123443 */     // GIR_Coverage, 4127,
     /* 123443 */     GIR_EraseRootFromParent_Done,
     /* 123444 */   // Label 2137: @123444
     /* 123444 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(123484), // Rule ID 4129 //
     /* 123449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123463 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 123466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123482 */     GIR_RootConstrainSelectedInstOperands,
     /* 123483 */     // GIR_Coverage, 4129,
     /* 123483 */     GIR_EraseRootFromParent_Done,
     /* 123484 */   // Label 2138: @123484
     /* 123484 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(123524), // Rule ID 4155 //
     /* 123489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123503 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123522 */     GIR_RootConstrainSelectedInstOperands,
     /* 123523 */     // GIR_Coverage, 4155,
     /* 123523 */     GIR_EraseRootFromParent_Done,
     /* 123524 */   // Label 2139: @123524
     /* 123524 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(123564), // Rule ID 4157 //
     /* 123529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123543 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123562 */     GIR_RootConstrainSelectedInstOperands,
     /* 123563 */     // GIR_Coverage, 4157,
     /* 123563 */     GIR_EraseRootFromParent_Done,
     /* 123564 */   // Label 2140: @123564
     /* 123564 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(123584), // Rule ID 6433 //
     /* 123569 */     // MIs[0] Rn
     /* 123569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123577 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 123582 */     GIR_RootConstrainSelectedInstOperands,
     /* 123583 */     // GIR_Coverage, 6433,
     /* 123583 */     GIR_Done,
     /* 123584 */   // Label 2141: @123584
     /* 123584 */   GIM_Reject,
     /* 123585 */ // Label 2132: @123585
     /* 123585 */ GIM_Reject,
     /* 123586 */ // Label 1998: @123586
     /* 123586 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(123963),
     /* 123591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123594 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123602 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(123647), // Rule ID 4091 //
     /* 123607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123621 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123645 */     GIR_RootConstrainSelectedInstOperands,
     /* 123646 */     // GIR_Coverage, 4091,
     /* 123646 */     GIR_EraseRootFromParent_Done,
     /* 123647 */   // Label 2143: @123647
     /* 123647 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(123692), // Rule ID 4092 //
     /* 123652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123666 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123690 */     GIR_RootConstrainSelectedInstOperands,
     /* 123691 */     // GIR_Coverage, 4092,
     /* 123691 */     GIR_EraseRootFromParent_Done,
     /* 123692 */   // Label 2144: @123692
     /* 123692 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(123737), // Rule ID 4093 //
     /* 123697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123711 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123735 */     GIR_RootConstrainSelectedInstOperands,
     /* 123736 */     // GIR_Coverage, 4093,
     /* 123736 */     GIR_EraseRootFromParent_Done,
     /* 123737 */   // Label 2145: @123737
     /* 123737 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(123782), // Rule ID 4094 //
     /* 123742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123756 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123780 */     GIR_RootConstrainSelectedInstOperands,
     /* 123781 */     // GIR_Coverage, 4094,
     /* 123781 */     GIR_EraseRootFromParent_Done,
     /* 123782 */   // Label 2146: @123782
     /* 123782 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(123822), // Rule ID 4132 //
     /* 123787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123801 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123820 */     GIR_RootConstrainSelectedInstOperands,
     /* 123821 */     // GIR_Coverage, 4132,
     /* 123821 */     GIR_EraseRootFromParent_Done,
     /* 123822 */   // Label 2147: @123822
     /* 123822 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(123862), // Rule ID 4136 //
     /* 123827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123841 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123860 */     GIR_RootConstrainSelectedInstOperands,
     /* 123861 */     // GIR_Coverage, 4136,
     /* 123861 */     GIR_EraseRootFromParent_Done,
     /* 123862 */   // Label 2148: @123862
     /* 123862 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(123902), // Rule ID 4162 //
     /* 123867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123881 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123900 */     GIR_RootConstrainSelectedInstOperands,
     /* 123901 */     // GIR_Coverage, 4162,
     /* 123901 */     GIR_EraseRootFromParent_Done,
     /* 123902 */   // Label 2149: @123902
     /* 123902 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(123942), // Rule ID 4163 //
     /* 123907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123921 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123940 */     GIR_RootConstrainSelectedInstOperands,
     /* 123941 */     // GIR_Coverage, 4163,
     /* 123941 */     GIR_EraseRootFromParent_Done,
     /* 123942 */   // Label 2150: @123942
     /* 123942 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(123962), // Rule ID 6430 //
     /* 123947 */     // MIs[0] Rn
     /* 123947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123955 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 123960 */     GIR_RootConstrainSelectedInstOperands,
     /* 123961 */     // GIR_Coverage, 6430,
     /* 123961 */     GIR_Done,
     /* 123962 */   // Label 2151: @123962
     /* 123962 */   GIM_Reject,
     /* 123963 */ // Label 2142: @123963
     /* 123963 */ GIM_Reject,
     /* 123964 */ // Label 1999: @123964
     /* 123964 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(124171),
     /* 123969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123972 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123980 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(124025), // Rule ID 4077 //
     /* 123985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123999 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124023 */     GIR_RootConstrainSelectedInstOperands,
     /* 124024 */     // GIR_Coverage, 4077,
     /* 124024 */     GIR_EraseRootFromParent_Done,
     /* 124025 */   // Label 2153: @124025
     /* 124025 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(124070), // Rule ID 4078 //
     /* 124030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124044 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124068 */     GIR_RootConstrainSelectedInstOperands,
     /* 124069 */     // GIR_Coverage, 4078,
     /* 124069 */     GIR_EraseRootFromParent_Done,
     /* 124070 */   // Label 2154: @124070
     /* 124070 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(124110), // Rule ID 4126 //
     /* 124075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124089 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124108 */     GIR_RootConstrainSelectedInstOperands,
     /* 124109 */     // GIR_Coverage, 4126,
     /* 124109 */     GIR_EraseRootFromParent_Done,
     /* 124110 */   // Label 2155: @124110
     /* 124110 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(124150), // Rule ID 4156 //
     /* 124115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124129 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124148 */     GIR_RootConstrainSelectedInstOperands,
     /* 124149 */     // GIR_Coverage, 4156,
     /* 124149 */     GIR_EraseRootFromParent_Done,
     /* 124150 */   // Label 2156: @124150
     /* 124150 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(124170), // Rule ID 6432 //
     /* 124155 */     // MIs[0] Rn
     /* 124155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124163 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 124168 */     GIR_RootConstrainSelectedInstOperands,
     /* 124169 */     // GIR_Coverage, 6432,
     /* 124169 */     GIR_Done,
     /* 124170 */   // Label 2157: @124170
     /* 124170 */   GIM_Reject,
     /* 124171 */ // Label 2152: @124171
     /* 124171 */ GIM_Reject,
     /* 124172 */ // Label 2000: @124172
     /* 124172 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(124549),
     /* 124177 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124180 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124188 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(124233), // Rule ID 4095 //
     /* 124193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124207 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124231 */     GIR_RootConstrainSelectedInstOperands,
     /* 124232 */     // GIR_Coverage, 4095,
     /* 124232 */     GIR_EraseRootFromParent_Done,
     /* 124233 */   // Label 2159: @124233
     /* 124233 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(124278), // Rule ID 4096 //
     /* 124238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124252 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124276 */     GIR_RootConstrainSelectedInstOperands,
     /* 124277 */     // GIR_Coverage, 4096,
     /* 124277 */     GIR_EraseRootFromParent_Done,
     /* 124278 */   // Label 2160: @124278
     /* 124278 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(124323), // Rule ID 4097 //
     /* 124283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124297 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124321 */     GIR_RootConstrainSelectedInstOperands,
     /* 124322 */     // GIR_Coverage, 4097,
     /* 124322 */     GIR_EraseRootFromParent_Done,
     /* 124323 */   // Label 2161: @124323
     /* 124323 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(124368), // Rule ID 4098 //
     /* 124328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124342 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124366 */     GIR_RootConstrainSelectedInstOperands,
     /* 124367 */     // GIR_Coverage, 4098,
     /* 124367 */     GIR_EraseRootFromParent_Done,
     /* 124368 */   // Label 2162: @124368
     /* 124368 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(124408), // Rule ID 4135 //
     /* 124373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124387 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124406 */     GIR_RootConstrainSelectedInstOperands,
     /* 124407 */     // GIR_Coverage, 4135,
     /* 124407 */     GIR_EraseRootFromParent_Done,
     /* 124408 */   // Label 2163: @124408
     /* 124408 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(124448), // Rule ID 4138 //
     /* 124413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124427 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124446 */     GIR_RootConstrainSelectedInstOperands,
     /* 124447 */     // GIR_Coverage, 4138,
     /* 124447 */     GIR_EraseRootFromParent_Done,
     /* 124448 */   // Label 2164: @124448
     /* 124448 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(124488), // Rule ID 4164 //
     /* 124453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124467 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124486 */     GIR_RootConstrainSelectedInstOperands,
     /* 124487 */     // GIR_Coverage, 4164,
     /* 124487 */     GIR_EraseRootFromParent_Done,
     /* 124488 */   // Label 2165: @124488
     /* 124488 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(124528), // Rule ID 4166 //
     /* 124493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124507 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124526 */     GIR_RootConstrainSelectedInstOperands,
     /* 124527 */     // GIR_Coverage, 4166,
     /* 124527 */     GIR_EraseRootFromParent_Done,
     /* 124528 */   // Label 2166: @124528
     /* 124528 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(124548), // Rule ID 6429 //
     /* 124533 */     // MIs[0] Rn
     /* 124533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124541 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 124546 */     GIR_RootConstrainSelectedInstOperands,
     /* 124547 */     // GIR_Coverage, 6429,
     /* 124547 */     GIR_Done,
     /* 124548 */   // Label 2167: @124548
     /* 124548 */   GIM_Reject,
     /* 124549 */ // Label 2158: @124549
     /* 124549 */ GIM_Reject,
     /* 124550 */ // Label 2001: @124550
     /* 124550 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(124757),
     /* 124555 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124558 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124566 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(124611), // Rule ID 4099 //
     /* 124571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124585 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124609 */     GIR_RootConstrainSelectedInstOperands,
     /* 124610 */     // GIR_Coverage, 4099,
     /* 124610 */     GIR_EraseRootFromParent_Done,
     /* 124611 */   // Label 2169: @124611
     /* 124611 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(124656), // Rule ID 4100 //
     /* 124616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124630 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124654 */     GIR_RootConstrainSelectedInstOperands,
     /* 124655 */     // GIR_Coverage, 4100,
     /* 124655 */     GIR_EraseRootFromParent_Done,
     /* 124656 */   // Label 2170: @124656
     /* 124656 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(124696), // Rule ID 4134 //
     /* 124661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124675 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124694 */     GIR_RootConstrainSelectedInstOperands,
     /* 124695 */     // GIR_Coverage, 4134,
     /* 124695 */     GIR_EraseRootFromParent_Done,
     /* 124696 */   // Label 2171: @124696
     /* 124696 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(124736), // Rule ID 4165 //
     /* 124701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124715 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124734 */     GIR_RootConstrainSelectedInstOperands,
     /* 124735 */     // GIR_Coverage, 4165,
     /* 124735 */     GIR_EraseRootFromParent_Done,
     /* 124736 */   // Label 2172: @124736
     /* 124736 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(124756), // Rule ID 6428 //
     /* 124741 */     // MIs[0] Rn
     /* 124741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124749 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 124754 */     GIR_RootConstrainSelectedInstOperands,
     /* 124755 */     // GIR_Coverage, 6428,
     /* 124755 */     GIR_Done,
     /* 124756 */   // Label 2173: @124756
     /* 124756 */   GIM_Reject,
     /* 124757 */ // Label 2168: @124757
     /* 124757 */ GIM_Reject,
     /* 124758 */ // Label 2002: @124758
     /* 124758 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(124821), // Rule ID 11004 //
     /* 124763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124777 */   // MIs[0] base
     /* 124777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124785 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124797 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 124805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124810 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124819 */   GIR_RootConstrainSelectedInstOperands,
     /* 124820 */   // GIR_Coverage, 11004,
     /* 124820 */   GIR_EraseRootFromParent_Done,
     /* 124821 */ // Label 2174: @124821
     /* 124821 */ GIM_Reject,
     /* 124822 */ // Label 2003: @124822
     /* 124822 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(124885), // Rule ID 11010 //
     /* 124827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124841 */   // MIs[0] base
     /* 124841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124849 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124861 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 124869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124871 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124874 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124883 */   GIR_RootConstrainSelectedInstOperands,
     /* 124884 */   // GIR_Coverage, 11010,
     /* 124884 */   GIR_EraseRootFromParent_Done,
     /* 124885 */ // Label 2175: @124885
     /* 124885 */ GIM_Reject,
     /* 124886 */ // Label 2004: @124886
     /* 124886 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(125059),
     /* 124891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124894 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124906 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(124954), // Rule ID 10995 //
     /* 124911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124918 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124930 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 124938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124943 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124952 */     GIR_RootConstrainSelectedInstOperands,
     /* 124953 */     // GIR_Coverage, 10995,
     /* 124953 */     GIR_EraseRootFromParent_Done,
     /* 124954 */   // Label 2177: @124954
     /* 124954 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(125002), // Rule ID 11013 //
     /* 124959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124966 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 124986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124991 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125000 */     GIR_RootConstrainSelectedInstOperands,
     /* 125001 */     // GIR_Coverage, 11013,
     /* 125001 */     GIR_EraseRootFromParent_Done,
     /* 125002 */   // Label 2178: @125002
     /* 125002 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(125030), // Rule ID 11040 //
     /* 125007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125014 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125019 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125028 */     GIR_RootConstrainSelectedInstOperands,
     /* 125029 */     // GIR_Coverage, 11040,
     /* 125029 */     GIR_EraseRootFromParent_Done,
     /* 125030 */   // Label 2179: @125030
     /* 125030 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(125058), // Rule ID 11052 //
     /* 125035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125042 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125047 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125056 */     GIR_RootConstrainSelectedInstOperands,
     /* 125057 */     // GIR_Coverage, 11052,
     /* 125057 */     GIR_EraseRootFromParent_Done,
     /* 125058 */   // Label 2180: @125058
     /* 125058 */   GIM_Reject,
     /* 125059 */ // Label 2176: @125059
     /* 125059 */ GIM_Reject,
     /* 125060 */ // Label 2005: @125060
     /* 125060 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(125123), // Rule ID 11001 //
     /* 125065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125071 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125079 */   // MIs[0] base
     /* 125079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125087 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125099 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 125107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125112 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125117 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125121 */   GIR_RootConstrainSelectedInstOperands,
     /* 125122 */   // GIR_Coverage, 11001,
     /* 125122 */   GIR_EraseRootFromParent_Done,
     /* 125123 */ // Label 2181: @125123
     /* 125123 */ GIM_Reject,
     /* 125124 */ // Label 2006: @125124
     /* 125124 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(125297),
     /* 125129 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125132 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125144 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(125192), // Rule ID 10983 //
     /* 125149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125156 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125168 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 125176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125181 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125190 */     GIR_RootConstrainSelectedInstOperands,
     /* 125191 */     // GIR_Coverage, 10983,
     /* 125191 */     GIR_EraseRootFromParent_Done,
     /* 125192 */   // Label 2183: @125192
     /* 125192 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(125240), // Rule ID 11007 //
     /* 125197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125204 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 125224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125229 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125238 */     GIR_RootConstrainSelectedInstOperands,
     /* 125239 */     // GIR_Coverage, 11007,
     /* 125239 */     GIR_EraseRootFromParent_Done,
     /* 125240 */   // Label 2184: @125240
     /* 125240 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(125268), // Rule ID 11036 //
     /* 125245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125252 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125257 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125266 */     GIR_RootConstrainSelectedInstOperands,
     /* 125267 */     // GIR_Coverage, 11036,
     /* 125267 */     GIR_EraseRootFromParent_Done,
     /* 125268 */   // Label 2185: @125268
     /* 125268 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(125296), // Rule ID 11048 //
     /* 125273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125280 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125285 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125294 */     GIR_RootConstrainSelectedInstOperands,
     /* 125295 */     // GIR_Coverage, 11048,
     /* 125295 */     GIR_EraseRootFromParent_Done,
     /* 125296 */   // Label 2186: @125296
     /* 125296 */   GIM_Reject,
     /* 125297 */ // Label 2182: @125297
     /* 125297 */ GIM_Reject,
     /* 125298 */ // Label 2007: @125298
     /* 125298 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(125471),
     /* 125303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125306 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125318 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(125366), // Rule ID 10962 //
     /* 125323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125330 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 125350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125355 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125364 */     GIR_RootConstrainSelectedInstOperands,
     /* 125365 */     // GIR_Coverage, 10962,
     /* 125365 */     GIR_EraseRootFromParent_Done,
     /* 125366 */   // Label 2188: @125366
     /* 125366 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(125414), // Rule ID 10998 //
     /* 125371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125378 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125390 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 125398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125403 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125412 */     GIR_RootConstrainSelectedInstOperands,
     /* 125413 */     // GIR_Coverage, 10998,
     /* 125413 */     GIR_EraseRootFromParent_Done,
     /* 125414 */   // Label 2189: @125414
     /* 125414 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(125442), // Rule ID 11032 //
     /* 125419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125426 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125431 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125440 */     GIR_RootConstrainSelectedInstOperands,
     /* 125441 */     // GIR_Coverage, 11032,
     /* 125441 */     GIR_EraseRootFromParent_Done,
     /* 125442 */   // Label 2190: @125442
     /* 125442 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(125470), // Rule ID 11044 //
     /* 125447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125454 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125459 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125468 */     GIR_RootConstrainSelectedInstOperands,
     /* 125469 */     // GIR_Coverage, 11044,
     /* 125469 */     GIR_EraseRootFromParent_Done,
     /* 125470 */   // Label 2191: @125470
     /* 125470 */   GIM_Reject,
     /* 125471 */ // Label 2187: @125471
     /* 125471 */ GIM_Reject,
     /* 125472 */ // Label 2008: @125472
     /* 125472 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(125515), // Rule ID 2428 //
     /* 125477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 125491 */   // MIs[0] base
     /* 125491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125499 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 125502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 125504 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125509 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125513 */   GIR_RootConstrainSelectedInstOperands,
     /* 125514 */   // GIR_Coverage, 2428,
     /* 125514 */   GIR_EraseRootFromParent_Done,
     /* 125515 */ // Label 2192: @125515
     /* 125515 */ GIM_Reject,
     /* 125516 */ // Label 2009: @125516
     /* 125516 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(125613),
     /* 125521 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125524 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125532 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125536 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(125584), // Rule ID 10930 //
     /* 125541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125548 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 125555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 125568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125573 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125582 */     GIR_RootConstrainSelectedInstOperands,
     /* 125583 */     // GIR_Coverage, 10930,
     /* 125583 */     GIR_EraseRootFromParent_Done,
     /* 125584 */   // Label 2194: @125584
     /* 125584 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(125612), // Rule ID 11028 //
     /* 125589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125596 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125601 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125610 */     GIR_RootConstrainSelectedInstOperands,
     /* 125611 */     // GIR_Coverage, 11028,
     /* 125611 */     GIR_EraseRootFromParent_Done,
     /* 125612 */   // Label 2195: @125612
     /* 125612 */   GIM_Reject,
     /* 125613 */ // Label 2193: @125613
     /* 125613 */ GIM_Reject,
     /* 125614 */ // Label 2010: @125614
     /* 125614 */ GIM_Reject,
     /* 125615 */ // Label 17: @125615
     /* 125615 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2198*/ GIMT_Encode4(126664),
     /* 125626 */ /*GILLT_s32*//*Label 2196*/ GIMT_Encode4(125634),
     /* 125630 */ /*GILLT_s64*//*Label 2197*/ GIMT_Encode4(126048),
     /* 125634 */ // Label 2196: @125634
     /* 125634 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(126047),
     /* 125639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125642 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(125695), // Rule ID 247 //
     /* 125647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 125669 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 125669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 125672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125693 */     GIR_RootConstrainSelectedInstOperands,
     /* 125694 */     // GIR_Coverage, 247,
     /* 125694 */     GIR_EraseRootFromParent_Done,
     /* 125695 */   // Label 2200: @125695
     /* 125695 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(125748), // Rule ID 248 //
     /* 125700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 125722 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 125722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 125725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125746 */     GIR_RootConstrainSelectedInstOperands,
     /* 125747 */     // GIR_Coverage, 248,
     /* 125747 */     GIR_EraseRootFromParent_Done,
     /* 125748 */   // Label 2201: @125748
     /* 125748 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(125801), // Rule ID 251 //
     /* 125753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 125775 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 125775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 125778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125799 */     GIR_RootConstrainSelectedInstOperands,
     /* 125800 */     // GIR_Coverage, 251,
     /* 125800 */     GIR_EraseRootFromParent_Done,
     /* 125801 */   // Label 2202: @125801
     /* 125801 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(125854), // Rule ID 252 //
     /* 125806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 125828 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 125828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 125831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125852 */     GIR_RootConstrainSelectedInstOperands,
     /* 125853 */     // GIR_Coverage, 252,
     /* 125853 */     GIR_EraseRootFromParent_Done,
     /* 125854 */   // Label 2203: @125854
     /* 125854 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(125902), // Rule ID 268 //
     /* 125859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 125881 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 125881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 125884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125900 */     GIR_RootConstrainSelectedInstOperands,
     /* 125901 */     // GIR_Coverage, 268,
     /* 125901 */     GIR_EraseRootFromParent_Done,
     /* 125902 */   // Label 2204: @125902
     /* 125902 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(125950), // Rule ID 270 //
     /* 125907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 125929 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 125929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 125932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125948 */     GIR_RootConstrainSelectedInstOperands,
     /* 125949 */     // GIR_Coverage, 270,
     /* 125949 */     GIR_EraseRootFromParent_Done,
     /* 125950 */   // Label 2205: @125950
     /* 125950 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(125998), // Rule ID 289 //
     /* 125955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 125977 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 125977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 125980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125996 */     GIR_RootConstrainSelectedInstOperands,
     /* 125997 */     // GIR_Coverage, 289,
     /* 125997 */     GIR_EraseRootFromParent_Done,
     /* 125998 */   // Label 2206: @125998
     /* 125998 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(126046), // Rule ID 291 //
     /* 126003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 126025 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 126028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126044 */     GIR_RootConstrainSelectedInstOperands,
     /* 126045 */     // GIR_Coverage, 291,
     /* 126045 */     GIR_EraseRootFromParent_Done,
     /* 126046 */   // Label 2207: @126046
     /* 126046 */   GIM_Reject,
     /* 126047 */ // Label 2199: @126047
     /* 126047 */ GIM_Reject,
     /* 126048 */ // Label 2197: @126048
     /* 126048 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(126663),
     /* 126053 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126056 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(126109), // Rule ID 249 //
     /* 126061 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 126083 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 126083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 126086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126107 */     GIR_RootConstrainSelectedInstOperands,
     /* 126108 */     // GIR_Coverage, 249,
     /* 126108 */     GIR_EraseRootFromParent_Done,
     /* 126109 */   // Label 2209: @126109
     /* 126109 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(126162), // Rule ID 250 //
     /* 126114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 126136 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 126136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 126139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126160 */     GIR_RootConstrainSelectedInstOperands,
     /* 126161 */     // GIR_Coverage, 250,
     /* 126161 */     GIR_EraseRootFromParent_Done,
     /* 126162 */   // Label 2210: @126162
     /* 126162 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(126215), // Rule ID 253 //
     /* 126167 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126189 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 126192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126213 */     GIR_RootConstrainSelectedInstOperands,
     /* 126214 */     // GIR_Coverage, 253,
     /* 126214 */     GIR_EraseRootFromParent_Done,
     /* 126215 */   // Label 2211: @126215
     /* 126215 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(126268), // Rule ID 254 //
     /* 126220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126242 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 126245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126266 */     GIR_RootConstrainSelectedInstOperands,
     /* 126267 */     // GIR_Coverage, 254,
     /* 126267 */     GIR_EraseRootFromParent_Done,
     /* 126268 */   // Label 2212: @126268
     /* 126268 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(126321), // Rule ID 255 //
     /* 126273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 126295 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 126295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 126298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126319 */     GIR_RootConstrainSelectedInstOperands,
     /* 126320 */     // GIR_Coverage, 255,
     /* 126320 */     GIR_EraseRootFromParent_Done,
     /* 126321 */   // Label 2213: @126321
     /* 126321 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(126374), // Rule ID 256 //
     /* 126326 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 126348 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 126348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 126351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126372 */     GIR_RootConstrainSelectedInstOperands,
     /* 126373 */     // GIR_Coverage, 256,
     /* 126373 */     GIR_EraseRootFromParent_Done,
     /* 126374 */   // Label 2214: @126374
     /* 126374 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(126422), // Rule ID 269 //
     /* 126379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 126401 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 126401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 126404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126420 */     GIR_RootConstrainSelectedInstOperands,
     /* 126421 */     // GIR_Coverage, 269,
     /* 126421 */     GIR_EraseRootFromParent_Done,
     /* 126422 */   // Label 2215: @126422
     /* 126422 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(126470), // Rule ID 271 //
     /* 126427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 126449 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 126449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 126452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126468 */     GIR_RootConstrainSelectedInstOperands,
     /* 126469 */     // GIR_Coverage, 271,
     /* 126469 */     GIR_EraseRootFromParent_Done,
     /* 126470 */   // Label 2216: @126470
     /* 126470 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(126518), // Rule ID 272 //
     /* 126475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 126497 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 126497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 126500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126516 */     GIR_RootConstrainSelectedInstOperands,
     /* 126517 */     // GIR_Coverage, 272,
     /* 126517 */     GIR_EraseRootFromParent_Done,
     /* 126518 */   // Label 2217: @126518
     /* 126518 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(126566), // Rule ID 290 //
     /* 126523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 126545 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 126548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126564 */     GIR_RootConstrainSelectedInstOperands,
     /* 126565 */     // GIR_Coverage, 290,
     /* 126565 */     GIR_EraseRootFromParent_Done,
     /* 126566 */   // Label 2218: @126566
     /* 126566 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(126614), // Rule ID 292 //
     /* 126571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 126593 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 126596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126612 */     GIR_RootConstrainSelectedInstOperands,
     /* 126613 */     // GIR_Coverage, 292,
     /* 126613 */     GIR_EraseRootFromParent_Done,
     /* 126614 */   // Label 2219: @126614
     /* 126614 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(126662), // Rule ID 293 //
     /* 126619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 126641 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 126644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126660 */     GIR_RootConstrainSelectedInstOperands,
     /* 126661 */     // GIR_Coverage, 293,
     /* 126661 */     GIR_EraseRootFromParent_Done,
     /* 126662 */   // Label 2220: @126662
     /* 126662 */   GIM_Reject,
     /* 126663 */ // Label 2208: @126663
     /* 126663 */ GIM_Reject,
     /* 126664 */ // Label 2198: @126664
     /* 126664 */ GIM_Reject,
     /* 126665 */ // Label 18: @126665
     /* 126665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2223*/ GIMT_Encode4(129713),
     /* 126676 */ /*GILLT_s32*//*Label 2221*/ GIMT_Encode4(126684),
     /* 126680 */ /*GILLT_s64*//*Label 2222*/ GIMT_Encode4(128223),
     /* 126684 */ // Label 2221: @126684
     /* 126684 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(126740), // Rule ID 229 //
     /* 126689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126692 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126714 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 126717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126738 */   GIR_RootConstrainSelectedInstOperands,
     /* 126739 */   // GIR_Coverage, 229,
     /* 126739 */   GIR_EraseRootFromParent_Done,
     /* 126740 */ // Label 2224: @126740
     /* 126740 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(126796), // Rule ID 230 //
     /* 126745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126770 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 126773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126794 */   GIR_RootConstrainSelectedInstOperands,
     /* 126795 */   // GIR_Coverage, 230,
     /* 126795 */   GIR_EraseRootFromParent_Done,
     /* 126796 */ // Label 2225: @126796
     /* 126796 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(126852), // Rule ID 231 //
     /* 126801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126804 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126815 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126819 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 126826 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 126826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 126829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126850 */   GIR_RootConstrainSelectedInstOperands,
     /* 126851 */   // GIR_Coverage, 231,
     /* 126851 */   GIR_EraseRootFromParent_Done,
     /* 126852 */ // Label 2226: @126852
     /* 126852 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(126908), // Rule ID 232 //
     /* 126857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126860 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 126882 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 126882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 126885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126902 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126906 */   GIR_RootConstrainSelectedInstOperands,
     /* 126907 */   // GIR_Coverage, 232,
     /* 126907 */   GIR_EraseRootFromParent_Done,
     /* 126908 */ // Label 2227: @126908
     /* 126908 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126964), // Rule ID 4123 //
     /* 126913 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126916 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126931 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126938 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 126941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126958 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126962 */   GIR_RootConstrainSelectedInstOperands,
     /* 126963 */   // GIR_Coverage, 4123,
     /* 126963 */   GIR_EraseRootFromParent_Done,
     /* 126964 */ // Label 2228: @126964
     /* 126964 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(127020), // Rule ID 4124 //
     /* 126969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126972 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126994 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 126997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127018 */   GIR_RootConstrainSelectedInstOperands,
     /* 127019 */   // GIR_Coverage, 4124,
     /* 127019 */   GIR_EraseRootFromParent_Done,
     /* 127020 */ // Label 2229: @127020
     /* 127020 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(127071), // Rule ID 266 //
     /* 127025 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127039 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127043 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127050 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 127053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127065 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127069 */   GIR_RootConstrainSelectedInstOperands,
     /* 127070 */   // GIR_Coverage, 266,
     /* 127070 */   GIR_EraseRootFromParent_Done,
     /* 127071 */ // Label 2230: @127071
     /* 127071 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(127122), // Rule ID 267 //
     /* 127076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127079 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127101 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127120 */   GIR_RootConstrainSelectedInstOperands,
     /* 127121 */   // GIR_Coverage, 267,
     /* 127121 */   GIR_EraseRootFromParent_Done,
     /* 127122 */ // Label 2231: @127122
     /* 127122 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(127181), // Rule ID 7065 //
     /* 127127 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127137 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127155 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15837>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 127155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 127158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127175 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127179 */   GIR_RootConstrainSelectedInstOperands,
     /* 127180 */   // GIR_Coverage, 7065,
     /* 127180 */   GIR_EraseRootFromParent_Done,
     /* 127181 */ // Label 2232: @127181
     /* 127181 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(127240), // Rule ID 7067 //
     /* 127186 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127189 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127196 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127203 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127207 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127214 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15837>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 127214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 127217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127224 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127238 */   GIR_RootConstrainSelectedInstOperands,
     /* 127239 */   // GIR_Coverage, 7067,
     /* 127239 */   GIR_EraseRootFromParent_Done,
     /* 127240 */ // Label 2233: @127240
     /* 127240 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(127299), // Rule ID 7077 //
     /* 127245 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127255 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127273 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15845>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 127276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127297 */   GIR_RootConstrainSelectedInstOperands,
     /* 127298 */   // GIR_Coverage, 7077,
     /* 127298 */   GIR_EraseRootFromParent_Done,
     /* 127299 */ // Label 2234: @127299
     /* 127299 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(127358), // Rule ID 7079 //
     /* 127304 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127307 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127314 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127325 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127332 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15845>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 127335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127352 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127356 */   GIR_RootConstrainSelectedInstOperands,
     /* 127357 */   // GIR_Coverage, 7079,
     /* 127357 */   GIR_EraseRootFromParent_Done,
     /* 127358 */ // Label 2235: @127358
     /* 127358 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(127409), // Rule ID 287 //
     /* 127363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127388 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127407 */   GIR_RootConstrainSelectedInstOperands,
     /* 127408 */   // GIR_Coverage, 287,
     /* 127408 */   GIR_EraseRootFromParent_Done,
     /* 127409 */ // Label 2236: @127409
     /* 127409 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(127460), // Rule ID 288 //
     /* 127414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127417 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127432 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127439 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127454 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127458 */   GIR_RootConstrainSelectedInstOperands,
     /* 127459 */   // GIR_Coverage, 288,
     /* 127459 */   GIR_EraseRootFromParent_Done,
     /* 127460 */ // Label 2237: @127460
     /* 127460 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(127511), // Rule ID 4142 //
     /* 127465 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127490 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127505 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127509 */   GIR_RootConstrainSelectedInstOperands,
     /* 127510 */   // GIR_Coverage, 4142,
     /* 127510 */   GIR_EraseRootFromParent_Done,
     /* 127511 */ // Label 2238: @127511
     /* 127511 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(127562), // Rule ID 4174 //
     /* 127516 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127519 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127534 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127541 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127560 */   GIR_RootConstrainSelectedInstOperands,
     /* 127561 */   // GIR_Coverage, 4174,
     /* 127561 */   GIR_EraseRootFromParent_Done,
     /* 127562 */ // Label 2239: @127562
     /* 127562 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(127613), // Rule ID 4175 //
     /* 127567 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127592 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127611 */   GIR_RootConstrainSelectedInstOperands,
     /* 127612 */   // GIR_Coverage, 4175,
     /* 127612 */   GIR_EraseRootFromParent_Done,
     /* 127613 */ // Label 2240: @127613
     /* 127613 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(127664), // Rule ID 4176 //
     /* 127618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127621 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127632 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127636 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127643 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127662 */   GIR_RootConstrainSelectedInstOperands,
     /* 127663 */   // GIR_Coverage, 4176,
     /* 127663 */   GIR_EraseRootFromParent_Done,
     /* 127664 */ // Label 2241: @127664
     /* 127664 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(127718), // Rule ID 7069 //
     /* 127669 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127672 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127679 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127690 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127697 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15837>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127716 */   GIR_RootConstrainSelectedInstOperands,
     /* 127717 */   // GIR_Coverage, 7069,
     /* 127717 */   GIR_EraseRootFromParent_Done,
     /* 127718 */ // Label 2242: @127718
     /* 127718 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(127772), // Rule ID 7071 //
     /* 127723 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127726 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127733 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127751 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15837>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127770 */   GIR_RootConstrainSelectedInstOperands,
     /* 127771 */   // GIR_Coverage, 7071,
     /* 127771 */   GIR_EraseRootFromParent_Done,
     /* 127772 */ // Label 2243: @127772
     /* 127772 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(127826), // Rule ID 7081 //
     /* 127777 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127787 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127798 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127805 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15845>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 127808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127820 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127824 */   GIR_RootConstrainSelectedInstOperands,
     /* 127825 */   // GIR_Coverage, 7081,
     /* 127825 */   GIR_EraseRootFromParent_Done,
     /* 127826 */ // Label 2244: @127826
     /* 127826 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(127880), // Rule ID 7083 //
     /* 127831 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127834 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127841 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127859 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15845>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127878 */   GIR_RootConstrainSelectedInstOperands,
     /* 127879 */   // GIR_Coverage, 7083,
     /* 127879 */   GIR_EraseRootFromParent_Done,
     /* 127880 */ // Label 2245: @127880
     /* 127880 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(127937), // Rule ID 7475 //
     /* 127885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 127888 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127891 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127898 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127916 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15826>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 127919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127931 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127935 */   GIR_RootConstrainSelectedInstOperands,
     /* 127936 */   // GIR_Coverage, 7475,
     /* 127936 */   GIR_EraseRootFromParent_Done,
     /* 127937 */ // Label 2246: @127937
     /* 127937 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(127994), // Rule ID 7477 //
     /* 127942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 127945 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127948 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127973 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15828>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 127976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127992 */   GIR_RootConstrainSelectedInstOperands,
     /* 127993 */   // GIR_Coverage, 7477,
     /* 127993 */   GIR_EraseRootFromParent_Done,
     /* 127994 */ // Label 2247: @127994
     /* 127994 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(128034), // Rule ID 7055 //
     /* 127999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 128002 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128005 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128012 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128019 */   // MIs[0] ptr
     /* 128019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128027 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15826>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 128032 */   GIR_RootConstrainSelectedInstOperands,
     /* 128033 */   // GIR_Coverage, 7055,
     /* 128033 */   GIR_Done,
     /* 128034 */ // Label 2248: @128034
     /* 128034 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(128074), // Rule ID 7057 //
     /* 128039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 128042 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128045 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128059 */   // MIs[0] ptr
     /* 128059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128067 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15828>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 128072 */   GIR_RootConstrainSelectedInstOperands,
     /* 128073 */   // GIR_Coverage, 7057,
     /* 128073 */   GIR_Done,
     /* 128074 */ // Label 2249: @128074
     /* 128074 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(128111), // Rule ID 7061 //
     /* 128079 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128082 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128096 */   // MIs[0] ptr
     /* 128096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128104 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15834>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 128109 */   GIR_RootConstrainSelectedInstOperands,
     /* 128110 */   // GIR_Coverage, 7061,
     /* 128110 */   GIR_Done,
     /* 128111 */ // Label 2250: @128111
     /* 128111 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(128148), // Rule ID 7063 //
     /* 128116 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128119 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128133 */   // MIs[0] ptr
     /* 128133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128141 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15826>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 128146 */   GIR_RootConstrainSelectedInstOperands,
     /* 128147 */   // GIR_Coverage, 7063,
     /* 128147 */   GIR_Done,
     /* 128148 */ // Label 2251: @128148
     /* 128148 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(128185), // Rule ID 7073 //
     /* 128153 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128170 */   // MIs[0] ptr
     /* 128170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128178 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15842>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 128183 */   GIR_RootConstrainSelectedInstOperands,
     /* 128184 */   // GIR_Coverage, 7073,
     /* 128184 */   GIR_Done,
     /* 128185 */ // Label 2252: @128185
     /* 128185 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(128222), // Rule ID 7075 //
     /* 128190 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128193 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128207 */   // MIs[0] ptr
     /* 128207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128215 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15828>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 128220 */   GIR_RootConstrainSelectedInstOperands,
     /* 128221 */   // GIR_Coverage, 7075,
     /* 128221 */   GIR_Done,
     /* 128222 */ // Label 2253: @128222
     /* 128222 */ GIM_Reject,
     /* 128223 */ // Label 2222: @128223
     /* 128223 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(129712),
     /* 128228 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128231 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(128316), // Rule ID 4101 //
     /* 128236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128258 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128285 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128315 */     // GIR_Coverage, 4101,
     /* 128315 */     GIR_EraseRootFromParent_Done,
     /* 128316 */   // Label 2255: @128316
     /* 128316 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(128401), // Rule ID 4102 //
     /* 128321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128343 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128370 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128400 */     // GIR_Coverage, 4102,
     /* 128400 */     GIR_EraseRootFromParent_Done,
     /* 128401 */   // Label 2256: @128401
     /* 128401 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(128486), // Rule ID 4103 //
     /* 128406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128428 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128485 */     // GIR_Coverage, 4103,
     /* 128485 */     GIR_EraseRootFromParent_Done,
     /* 128486 */   // Label 2257: @128486
     /* 128486 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(128571), // Rule ID 4104 //
     /* 128491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128513 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128540 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128570 */     // GIR_Coverage, 4104,
     /* 128570 */     GIR_EraseRootFromParent_Done,
     /* 128571 */   // Label 2258: @128571
     /* 128571 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(128656), // Rule ID 4105 //
     /* 128576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 128598 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 128605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128625 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128655 */     // GIR_Coverage, 4105,
     /* 128655 */     GIR_EraseRootFromParent_Done,
     /* 128656 */   // Label 2259: @128656
     /* 128656 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(128741), // Rule ID 4106 //
     /* 128661 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 128683 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 128690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128740 */     // GIR_Coverage, 4106,
     /* 128740 */     GIR_EraseRootFromParent_Done,
     /* 128741 */   // Label 2260: @128741
     /* 128741 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(128826), // Rule ID 4107 //
     /* 128746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128768 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128795 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128825 */     // GIR_Coverage, 4107,
     /* 128825 */     GIR_EraseRootFromParent_Done,
     /* 128826 */   // Label 2261: @128826
     /* 128826 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(128911), // Rule ID 4108 //
     /* 128831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128853 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128880 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128910 */     // GIR_Coverage, 4108,
     /* 128910 */     GIR_EraseRootFromParent_Done,
     /* 128911 */   // Label 2262: @128911
     /* 128911 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(128991), // Rule ID 4140 //
     /* 128916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128938 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 128938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128960 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128990 */     // GIR_Coverage, 4140,
     /* 128990 */     GIR_EraseRootFromParent_Done,
     /* 128991 */   // Label 2263: @128991
     /* 128991 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(129071), // Rule ID 4141 //
     /* 128996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 129018 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 129018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 129025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129040 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129070 */     // GIR_Coverage, 4141,
     /* 129070 */     GIR_EraseRootFromParent_Done,
     /* 129071 */   // Label 2264: @129071
     /* 129071 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(129151), // Rule ID 4143 //
     /* 129076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 129098 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 129098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 129105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129120 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129150 */     // GIR_Coverage, 4143,
     /* 129150 */     GIR_EraseRootFromParent_Done,
     /* 129151 */   // Label 2265: @129151
     /* 129151 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(129231), // Rule ID 4151 //
     /* 129156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 129178 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 129178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 129185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129200 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129230 */     // GIR_Coverage, 4151,
     /* 129230 */     GIR_EraseRootFromParent_Done,
     /* 129231 */   // Label 2266: @129231
     /* 129231 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(129311), // Rule ID 4177 //
     /* 129236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 129258 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 129265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129280 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129310 */     // GIR_Coverage, 4177,
     /* 129310 */     GIR_EraseRootFromParent_Done,
     /* 129311 */   // Label 2267: @129311
     /* 129311 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(129391), // Rule ID 4178 //
     /* 129316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129338 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129390 */     // GIR_Coverage, 4178,
     /* 129390 */     GIR_EraseRootFromParent_Done,
     /* 129391 */   // Label 2268: @129391
     /* 129391 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(129471), // Rule ID 4179 //
     /* 129396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129418 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129440 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129470 */     // GIR_Coverage, 4179,
     /* 129470 */     GIR_EraseRootFromParent_Done,
     /* 129471 */   // Label 2269: @129471
     /* 129471 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(129551), // Rule ID 4180 //
     /* 129476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129498 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129550 */     // GIR_Coverage, 4180,
     /* 129550 */     GIR_EraseRootFromParent_Done,
     /* 129551 */   // Label 2270: @129551
     /* 129551 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(129631), // Rule ID 4181 //
     /* 129556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129578 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129630 */     // GIR_Coverage, 4181,
     /* 129630 */     GIR_EraseRootFromParent_Done,
     /* 129631 */   // Label 2271: @129631
     /* 129631 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(129711), // Rule ID 4182 //
     /* 129636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129658 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129680 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129710 */     // GIR_Coverage, 4182,
     /* 129710 */     GIR_EraseRootFromParent_Done,
     /* 129711 */   // Label 2272: @129711
     /* 129711 */   GIM_Reject,
     /* 129712 */ // Label 2254: @129712
     /* 129712 */ GIM_Reject,
     /* 129713 */ // Label 2223: @129713
     /* 129713 */ GIM_Reject,
     /* 129714 */ // Label 19: @129714
     /* 129714 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2293*/ GIMT_Encode4(143239),
     /* 129725 */ /*GILLT_s8*//*Label 2273*/ GIMT_Encode4(129821),
     /* 129729 */ /*GILLT_s16*//*Label 2274*/ GIMT_Encode4(130188),
     /* 129733 */ /*GILLT_s32*//*Label 2275*/ GIMT_Encode4(131327),
     /* 129737 */ /*GILLT_s64*//*Label 2276*/ GIMT_Encode4(135922),
     /* 129741 */ /*GILLT_s128*//*Label 2277*/ GIMT_Encode4(139691),
     /* 129745 */ /*GILLT_v2s32*//*Label 2278*/ GIMT_Encode4(139897),
     /* 129749 */ /*GILLT_v2s64*//*Label 2279*/ GIMT_Encode4(140303),
     /* 129753 */ /*GILLT_v4s16*//*Label 2280*/ GIMT_Encode4(140753),
     /* 129757 */ /*GILLT_v4s32*//*Label 2281*/ GIMT_Encode4(141159),
     /* 129761 */ /*GILLT_v8s8*//*Label 2282*/ GIMT_Encode4(141565),
     /* 129765 */ /*GILLT_v8s16*//*Label 2283*/ GIMT_Encode4(141785),
     /* 129769 */ /*GILLT_v16s8*//*Label 2284*/ GIMT_Encode4(142191), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129781 */ /*GILLT_nxv2s16*//*Label 2285*/ GIMT_Encode4(142411),
     /* 129785 */ /*GILLT_nxv2s32*//*Label 2286*/ GIMT_Encode4(142471),
     /* 129789 */ /*GILLT_nxv2s64*//*Label 2287*/ GIMT_Encode4(142531), GIMT_Encode4(0),
     /* 129797 */ /*GILLT_nxv4s16*//*Label 2288*/ GIMT_Encode4(142701),
     /* 129801 */ /*GILLT_nxv4s32*//*Label 2289*/ GIMT_Encode4(142761), GIMT_Encode4(0),
     /* 129809 */ /*GILLT_nxv8s16*//*Label 2290*/ GIMT_Encode4(142931),
     /* 129813 */ /*GILLT_nxv16s1*//*Label 2291*/ GIMT_Encode4(143101),
     /* 129817 */ /*GILLT_nxv16s8*//*Label 2292*/ GIMT_Encode4(143145),
     /* 129821 */ // Label 2273: @129821
     /* 129821 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(130187),
     /* 129826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129829 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129833 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(129901), // Rule ID 13264 //
     /* 129838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 129842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 129846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 129859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 129863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129867 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 129871 */     // MIs[2] Operand 1
     /* 129871 */     // No operand predicates
     /* 129871 */     // MIs[0] Rn
     /* 129871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 129881 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 129881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 129884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 129888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 129891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 129899 */     GIR_RootConstrainSelectedInstOperands,
     /* 129900 */     // GIR_Coverage, 13264,
     /* 129900 */     GIR_EraseRootFromParent_Done,
     /* 129901 */   // Label 2295: @129901
     /* 129901 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(130000), // Rule ID 13265 //
     /* 129906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 129910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 129914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 129918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 129927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 129931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129935 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 129939 */     // MIs[2] Operand 1
     /* 129939 */     // No operand predicates
     /* 129939 */     // MIs[0] Rn
     /* 129939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 129949 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 129949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 129952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129961 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 129964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 129968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 129971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 129976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 129981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 129984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 129990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 129998 */     GIR_RootConstrainSelectedInstOperands,
     /* 129999 */     // GIR_Coverage, 13265,
     /* 129999 */     GIR_EraseRootFromParent_Done,
     /* 130000 */   // Label 2296: @130000
     /* 130000 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(130049), // Rule ID 303 //
     /* 130005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 130023 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 130023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 130026 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130047 */     GIR_RootConstrainSelectedInstOperands,
     /* 130048 */     // GIR_Coverage, 303,
     /* 130048 */     GIR_EraseRootFromParent_Done,
     /* 130049 */   // Label 2297: @130049
     /* 130049 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(130098), // Rule ID 304 //
     /* 130054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 130072 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 130072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 130075 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130096 */     GIR_RootConstrainSelectedInstOperands,
     /* 130097 */     // GIR_Coverage, 304,
     /* 130097 */     GIR_EraseRootFromParent_Done,
     /* 130098 */   // Label 2298: @130098
     /* 130098 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(130142), // Rule ID 313 //
     /* 130103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130121 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 130121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 130124 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130140 */     GIR_RootConstrainSelectedInstOperands,
     /* 130141 */     // GIR_Coverage, 313,
     /* 130141 */     GIR_EraseRootFromParent_Done,
     /* 130142 */   // Label 2299: @130142
     /* 130142 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(130186), // Rule ID 321 //
     /* 130147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 130165 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 130165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 130168 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130184 */     GIR_RootConstrainSelectedInstOperands,
     /* 130185 */     // GIR_Coverage, 321,
     /* 130185 */     GIR_EraseRootFromParent_Done,
     /* 130186 */   // Label 2300: @130186
     /* 130186 */   GIM_Reject,
     /* 130187 */ // Label 2294: @130187
     /* 130187 */ GIM_Reject,
     /* 130188 */ // Label 2274: @130188
     /* 130188 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(131326),
     /* 130193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130200 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(130299), // Rule ID 4515 //
     /* 130205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130226 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 130243 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 130243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130255 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 130274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130297 */     GIR_RootConstrainSelectedInstOperands,
     /* 130298 */     // GIR_Coverage, 4515,
     /* 130298 */     GIR_EraseRootFromParent_Done,
     /* 130299 */   // Label 2302: @130299
     /* 130299 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(130398), // Rule ID 4516 //
     /* 130304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130325 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 130342 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 130342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130354 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 130373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130396 */     GIR_RootConstrainSelectedInstOperands,
     /* 130397 */     // GIR_Coverage, 4516,
     /* 130397 */     GIR_EraseRootFromParent_Done,
     /* 130398 */   // Label 2303: @130398
     /* 130398 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(130497), // Rule ID 13262 //
     /* 130403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 130441 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 130441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130453 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 130472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130495 */     GIR_RootConstrainSelectedInstOperands,
     /* 130496 */     // GIR_Coverage, 13262,
     /* 130496 */     GIR_EraseRootFromParent_Done,
     /* 130497 */   // Label 2304: @130497
     /* 130497 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(130596), // Rule ID 13263 //
     /* 130502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130523 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 130540 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 130540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130552 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 130571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130594 */     GIR_RootConstrainSelectedInstOperands,
     /* 130595 */     // GIR_Coverage, 13263,
     /* 130595 */     GIR_EraseRootFromParent_Done,
     /* 130596 */   // Label 2305: @130596
     /* 130596 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(130690), // Rule ID 4544 //
     /* 130601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130622 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130639 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 130639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130651 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 130670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130688 */     GIR_RootConstrainSelectedInstOperands,
     /* 130689 */     // GIR_Coverage, 4544,
     /* 130689 */     GIR_EraseRootFromParent_Done,
     /* 130690 */   // Label 2306: @130690
     /* 130690 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(130784), // Rule ID 4571 //
     /* 130695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 130733 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 130733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 130764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130782 */     GIR_RootConstrainSelectedInstOperands,
     /* 130783 */     // GIR_Coverage, 4571,
     /* 130783 */     GIR_EraseRootFromParent_Done,
     /* 130784 */   // Label 2307: @130784
     /* 130784 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(130878), // Rule ID 13261 //
     /* 130789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130810 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130827 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 130827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130839 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 130858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130876 */     GIR_RootConstrainSelectedInstOperands,
     /* 130877 */     // GIR_Coverage, 13261,
     /* 130877 */     GIR_EraseRootFromParent_Done,
     /* 130878 */   // Label 2308: @130878
     /* 130878 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(130972), // Rule ID 13267 //
     /* 130883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130904 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 130921 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 130921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 130952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130970 */     GIR_RootConstrainSelectedInstOperands,
     /* 130971 */     // GIR_Coverage, 13267,
     /* 130971 */     GIR_EraseRootFromParent_Done,
     /* 130972 */   // Label 2309: @130972
     /* 130972 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(131040), // Rule ID 6497 //
     /* 130977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131006 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 131010 */     // MIs[2] Operand 1
     /* 131010 */     // No operand predicates
     /* 131010 */     // MIs[0] Rn
     /* 131010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131020 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 131023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131038 */     GIR_RootConstrainSelectedInstOperands,
     /* 131039 */     // GIR_Coverage, 6497,
     /* 131039 */     GIR_EraseRootFromParent_Done,
     /* 131040 */   // Label 2310: @131040
     /* 131040 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(131139), // Rule ID 6502 //
     /* 131045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 131057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131074 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 131078 */     // MIs[2] Operand 1
     /* 131078 */     // No operand predicates
     /* 131078 */     // MIs[0] Rn
     /* 131078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131088 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 131091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131100 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 131103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131107 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 131110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 131123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131137 */     GIR_RootConstrainSelectedInstOperands,
     /* 131138 */     // GIR_Coverage, 6502,
     /* 131138 */     GIR_EraseRootFromParent_Done,
     /* 131139 */   // Label 2311: @131139
     /* 131139 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(131188), // Rule ID 305 //
     /* 131144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131162 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131165 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131186 */     GIR_RootConstrainSelectedInstOperands,
     /* 131187 */     // GIR_Coverage, 305,
     /* 131187 */     GIR_EraseRootFromParent_Done,
     /* 131188 */   // Label 2312: @131188
     /* 131188 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(131237), // Rule ID 306 //
     /* 131193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131211 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131214 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131235 */     GIR_RootConstrainSelectedInstOperands,
     /* 131236 */     // GIR_Coverage, 306,
     /* 131236 */     GIR_EraseRootFromParent_Done,
     /* 131237 */   // Label 2313: @131237
     /* 131237 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(131281), // Rule ID 314 //
     /* 131242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 131260 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 131260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 131263 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131279 */     GIR_RootConstrainSelectedInstOperands,
     /* 131280 */     // GIR_Coverage, 314,
     /* 131280 */     GIR_EraseRootFromParent_Done,
     /* 131281 */   // Label 2314: @131281
     /* 131281 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(131325), // Rule ID 322 //
     /* 131286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 131304 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 131304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 131307 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131323 */     GIR_RootConstrainSelectedInstOperands,
     /* 131324 */     // GIR_Coverage, 322,
     /* 131324 */     GIR_EraseRootFromParent_Done,
     /* 131325 */   // Label 2315: @131325
     /* 131325 */   GIM_Reject,
     /* 131326 */ // Label 2301: @131326
     /* 131326 */ GIM_Reject,
     /* 131327 */ // Label 2275: @131327
     /* 131327 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(131440), // Rule ID 4513 //
     /* 131332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131335 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131339 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131354 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131358 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131362 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131367 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131371 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131384 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131396 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131402 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131438 */   GIR_RootConstrainSelectedInstOperands,
     /* 131439 */   // GIR_Coverage, 4513,
     /* 131439 */   GIR_EraseRootFromParent_Done,
     /* 131440 */ // Label 2316: @131440
     /* 131440 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(131553), // Rule ID 4514 //
     /* 131445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131448 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131480 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131497 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131509 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131551 */   GIR_RootConstrainSelectedInstOperands,
     /* 131552 */   // GIR_Coverage, 4514,
     /* 131552 */   GIR_EraseRootFromParent_Done,
     /* 131553 */ // Label 2317: @131553
     /* 131553 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131659), // Rule ID 4517 //
     /* 131558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131561 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131581 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131586 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 131603 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 131603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131615 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131626 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 131634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131657 */   GIR_RootConstrainSelectedInstOperands,
     /* 131658 */   // GIR_Coverage, 4517,
     /* 131658 */   GIR_EraseRootFromParent_Done,
     /* 131659 */ // Label 2318: @131659
     /* 131659 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131765), // Rule ID 4518 //
     /* 131664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131671 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131679 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131687 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131692 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131700 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131702 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 131709 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 131709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131721 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131727 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 131740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131763 */   GIR_RootConstrainSelectedInstOperands,
     /* 131764 */   // GIR_Coverage, 4518,
     /* 131764 */   GIR_EraseRootFromParent_Done,
     /* 131765 */ // Label 2319: @131765
     /* 131765 */ GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131871), // Rule ID 4519 //
     /* 131770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131785 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131789 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131793 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131798 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131806 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 131815 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 131815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131827 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 131846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131869 */   GIR_RootConstrainSelectedInstOperands,
     /* 131870 */   // GIR_Coverage, 4519,
     /* 131870 */   GIR_EraseRootFromParent_Done,
     /* 131871 */ // Label 2320: @131871
     /* 131871 */ GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(131977), // Rule ID 4520 //
     /* 131876 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131879 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131883 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131891 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131895 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131899 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131904 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131914 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 131921 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 131921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131933 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131944 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 131952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131965 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131970 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131975 */   GIR_RootConstrainSelectedInstOperands,
     /* 131976 */   // GIR_Coverage, 4520,
     /* 131976 */   GIR_EraseRootFromParent_Done,
     /* 131977 */ // Label 2321: @131977
     /* 131977 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(132083), // Rule ID 13269 //
     /* 131982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131997 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132001 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132005 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132010 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132018 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 132027 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 132027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132039 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132045 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132050 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 132058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132076 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132081 */   GIR_RootConstrainSelectedInstOperands,
     /* 132082 */   // GIR_Coverage, 13269,
     /* 132082 */   GIR_EraseRootFromParent_Done,
     /* 132083 */ // Label 2322: @132083
     /* 132083 */ GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(132189), // Rule ID 13270 //
     /* 132088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132091 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132103 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132107 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132111 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132116 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132126 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 132133 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 132133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132145 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132156 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 132164 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132187 */   GIR_RootConstrainSelectedInstOperands,
     /* 132188 */   // GIR_Coverage, 13270,
     /* 132188 */   GIR_EraseRootFromParent_Done,
     /* 132189 */ // Label 2323: @132189
     /* 132189 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(132297), // Rule ID 4543 //
     /* 132194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132197 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132201 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132208 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132216 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132220 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132224 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132229 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132233 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132239 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132246 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132258 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132269 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132295 */   GIR_RootConstrainSelectedInstOperands,
     /* 132296 */   // GIR_Coverage, 4543,
     /* 132296 */   GIR_EraseRootFromParent_Done,
     /* 132297 */ // Label 2324: @132297
     /* 132297 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(132398), // Rule ID 4545 //
     /* 132302 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132305 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132309 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132313 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132317 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132321 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132330 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132338 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132340 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132347 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132359 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132391 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132396 */   GIR_RootConstrainSelectedInstOperands,
     /* 132397 */   // GIR_Coverage, 4545,
     /* 132397 */   GIR_EraseRootFromParent_Done,
     /* 132398 */ // Label 2325: @132398
     /* 132398 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(132499), // Rule ID 4546 //
     /* 132403 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132406 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132418 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132422 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132426 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132431 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132435 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132439 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132448 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132460 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132466 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132471 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132497 */   GIR_RootConstrainSelectedInstOperands,
     /* 132498 */   // GIR_Coverage, 4546,
     /* 132498 */   GIR_EraseRootFromParent_Done,
     /* 132499 */ // Label 2326: @132499
     /* 132499 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(132607), // Rule ID 4570 //
     /* 132504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132507 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132518 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132526 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132530 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132534 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132539 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132547 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132556 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132568 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132605 */   GIR_RootConstrainSelectedInstOperands,
     /* 132606 */   // GIR_Coverage, 4570,
     /* 132606 */   GIR_EraseRootFromParent_Done,
     /* 132607 */ // Label 2327: @132607
     /* 132607 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(132708), // Rule ID 4572 //
     /* 132612 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132615 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132627 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132631 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132635 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132640 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132644 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132648 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132657 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132669 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132675 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132680 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132706 */   GIR_RootConstrainSelectedInstOperands,
     /* 132707 */   // GIR_Coverage, 4572,
     /* 132707 */   GIR_EraseRootFromParent_Done,
     /* 132708 */ // Label 2328: @132708
     /* 132708 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(132809), // Rule ID 4573 //
     /* 132713 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132716 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132720 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132728 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132732 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132736 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132741 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132745 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132751 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132758 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132770 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132781 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132807 */   GIR_RootConstrainSelectedInstOperands,
     /* 132808 */   // GIR_Coverage, 4573,
     /* 132808 */   GIR_EraseRootFromParent_Done,
     /* 132809 */ // Label 2329: @132809
     /* 132809 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132910), // Rule ID 13266 //
     /* 132814 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132829 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132833 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132837 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132842 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132846 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132859 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132871 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132877 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132908 */   GIR_RootConstrainSelectedInstOperands,
     /* 132909 */   // GIR_Coverage, 13266,
     /* 132909 */   GIR_EraseRootFromParent_Done,
     /* 132910 */ // Label 2330: @132910
     /* 132910 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(133011), // Rule ID 13268 //
     /* 132915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132938 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132943 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132951 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132953 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 132960 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132972 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133009 */   GIR_RootConstrainSelectedInstOperands,
     /* 133010 */   // GIR_Coverage, 13268,
     /* 133010 */   GIR_EraseRootFromParent_Done,
     /* 133011 */ // Label 2331: @133011
     /* 133011 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(133093), // Rule ID 6491 //
     /* 133016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133019 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133038 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 133042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133051 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133055 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133059 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 133063 */   // MIs[2] Operand 1
     /* 133063 */   // No operand predicates
     /* 133063 */   // MIs[0] Rn
     /* 133063 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133071 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133073 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 133076 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133080 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133083 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133085 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133091 */   GIR_RootConstrainSelectedInstOperands,
     /* 133092 */   // GIR_Coverage, 6491,
     /* 133092 */   GIR_EraseRootFromParent_Done,
     /* 133093 */ // Label 2332: @133093
     /* 133093 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(133175), // Rule ID 6492 //
     /* 133098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133101 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133112 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133120 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133124 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133128 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133133 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133137 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133141 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 133145 */   // MIs[2] Operand 1
     /* 133145 */   // No operand predicates
     /* 133145 */   // MIs[0] Rn
     /* 133145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133153 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133155 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 133158 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133162 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133165 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133173 */   GIR_RootConstrainSelectedInstOperands,
     /* 133174 */   // GIR_Coverage, 6492,
     /* 133174 */   GIR_EraseRootFromParent_Done,
     /* 133175 */ // Label 2333: @133175
     /* 133175 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(133250), // Rule ID 6493 //
     /* 133180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133187 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133195 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133199 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133208 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133212 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133216 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133220 */   // MIs[2] Operand 1
     /* 133220 */   // No operand predicates
     /* 133220 */   // MIs[0] Rn
     /* 133220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133228 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133230 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133233 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133237 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133240 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133248 */   GIR_RootConstrainSelectedInstOperands,
     /* 133249 */   // GIR_Coverage, 6493,
     /* 133249 */   GIR_EraseRootFromParent_Done,
     /* 133250 */ // Label 2334: @133250
     /* 133250 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133325), // Rule ID 6494 //
     /* 133255 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133258 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133262 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133270 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133274 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133278 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133283 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133287 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133291 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133295 */   // MIs[2] Operand 1
     /* 133295 */   // No operand predicates
     /* 133295 */   // MIs[0] Rn
     /* 133295 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133303 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133305 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133308 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133312 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133315 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133323 */   GIR_RootConstrainSelectedInstOperands,
     /* 133324 */   // GIR_Coverage, 6494,
     /* 133324 */   GIR_EraseRootFromParent_Done,
     /* 133325 */ // Label 2335: @133325
     /* 133325 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133438), // Rule ID 6498 //
     /* 133330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133333 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133337 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133352 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 133356 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133360 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133365 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133369 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133373 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 133377 */   // MIs[2] Operand 1
     /* 133377 */   // No operand predicates
     /* 133377 */   // MIs[0] Rn
     /* 133377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133385 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133387 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133399 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133402 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133406 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133409 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 133422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133425 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133428 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133436 */   GIR_RootConstrainSelectedInstOperands,
     /* 133437 */   // GIR_Coverage, 6498,
     /* 133437 */   GIR_EraseRootFromParent_Done,
     /* 133438 */ // Label 2336: @133438
     /* 133438 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133551), // Rule ID 6499 //
     /* 133443 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133446 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133465 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 133469 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133473 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133478 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133482 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133486 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 133490 */   // MIs[2] Operand 1
     /* 133490 */   // No operand predicates
     /* 133490 */   // MIs[0] Rn
     /* 133490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133498 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133500 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133512 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133515 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133519 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133527 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 133535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133538 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133541 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133543 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133549 */   GIR_RootConstrainSelectedInstOperands,
     /* 133550 */   // GIR_Coverage, 6499,
     /* 133550 */   GIR_EraseRootFromParent_Done,
     /* 133551 */ // Label 2337: @133551
     /* 133551 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133657), // Rule ID 6500 //
     /* 133556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133559 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133563 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133567 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133571 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133575 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133579 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133584 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133588 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133592 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133596 */   // MIs[2] Operand 1
     /* 133596 */   // No operand predicates
     /* 133596 */   // MIs[0] Rn
     /* 133596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133604 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133606 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133618 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133621 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133625 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133628 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133633 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133644 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133647 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133649 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133655 */   GIR_RootConstrainSelectedInstOperands,
     /* 133656 */   // GIR_Coverage, 6500,
     /* 133656 */   GIR_EraseRootFromParent_Done,
     /* 133657 */ // Label 2338: @133657
     /* 133657 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133763), // Rule ID 6501 //
     /* 133662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133665 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133669 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133673 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133677 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133681 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133685 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133690 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133694 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133698 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133702 */   // MIs[2] Operand 1
     /* 133702 */   // No operand predicates
     /* 133702 */   // MIs[0] Rn
     /* 133702 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133710 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133712 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133724 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133727 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133731 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133734 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133750 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133753 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133761 */   GIR_RootConstrainSelectedInstOperands,
     /* 133762 */   // GIR_Coverage, 6501,
     /* 133762 */   GIR_EraseRootFromParent_Done,
     /* 133763 */ // Label 2339: @133763
     /* 133763 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133823), // Rule ID 295 //
     /* 133768 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133771 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133786 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133790 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 133797 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 133797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 133800 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133821 */   GIR_RootConstrainSelectedInstOperands,
     /* 133822 */   // GIR_Coverage, 295,
     /* 133822 */   GIR_EraseRootFromParent_Done,
     /* 133823 */ // Label 2340: @133823
     /* 133823 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133883), // Rule ID 296 //
     /* 133828 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133831 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133846 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133850 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 133857 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 133857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 133860 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133881 */   GIR_RootConstrainSelectedInstOperands,
     /* 133882 */   // GIR_Coverage, 296,
     /* 133882 */   GIR_EraseRootFromParent_Done,
     /* 133883 */ // Label 2341: @133883
     /* 133883 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133943), // Rule ID 297 //
     /* 133888 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133891 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 133917 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 133917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 133920 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133937 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133941 */   GIR_RootConstrainSelectedInstOperands,
     /* 133942 */   // GIR_Coverage, 297,
     /* 133942 */   GIR_EraseRootFromParent_Done,
     /* 133943 */ // Label 2342: @133943
     /* 133943 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(134003), // Rule ID 298 //
     /* 133948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133951 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133955 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 133977 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 133977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 133980 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134001 */   GIR_RootConstrainSelectedInstOperands,
     /* 134002 */   // GIR_Coverage, 298,
     /* 134002 */   GIR_EraseRootFromParent_Done,
     /* 134003 */ // Label 2343: @134003
     /* 134003 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(134056), // Rule ID 299 //
     /* 134008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134011 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134023 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134030 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 134033 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134054 */   GIR_RootConstrainSelectedInstOperands,
     /* 134055 */   // GIR_Coverage, 299,
     /* 134055 */   GIR_EraseRootFromParent_Done,
     /* 134056 */ // Label 2344: @134056
     /* 134056 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(134109), // Rule ID 300 //
     /* 134061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134083 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 134086 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134107 */   GIR_RootConstrainSelectedInstOperands,
     /* 134108 */   // GIR_Coverage, 300,
     /* 134108 */   GIR_EraseRootFromParent_Done,
     /* 134109 */ // Label 2345: @134109
     /* 134109 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(134165), // Rule ID 307 //
     /* 134114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134117 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134120 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134132 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134139 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 134142 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134159 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134163 */   GIR_RootConstrainSelectedInstOperands,
     /* 134164 */   // GIR_Coverage, 307,
     /* 134164 */   GIR_EraseRootFromParent_Done,
     /* 134165 */ // Label 2346: @134165
     /* 134165 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(134221), // Rule ID 308 //
     /* 134170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134176 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134195 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 134198 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134219 */   GIR_RootConstrainSelectedInstOperands,
     /* 134220 */   // GIR_Coverage, 308,
     /* 134220 */   GIR_EraseRootFromParent_Done,
     /* 134221 */ // Label 2347: @134221
     /* 134221 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134273), // Rule ID 312 //
     /* 134226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134248 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 134251 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134267 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134271 */   GIR_RootConstrainSelectedInstOperands,
     /* 134272 */   // GIR_Coverage, 312,
     /* 134272 */   GIR_EraseRootFromParent_Done,
     /* 134273 */ // Label 2348: @134273
     /* 134273 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134324), // Rule ID 315 //
     /* 134278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134284 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134303 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134306 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134322 */   GIR_RootConstrainSelectedInstOperands,
     /* 134323 */   // GIR_Coverage, 315,
     /* 134323 */   GIR_EraseRootFromParent_Done,
     /* 134324 */ // Label 2349: @134324
     /* 134324 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134383), // Rule ID 317 //
     /* 134329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134332 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 134358 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 134358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 134361 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134381 */   GIR_RootConstrainSelectedInstOperands,
     /* 134382 */   // GIR_Coverage, 317,
     /* 134382 */   GIR_EraseRootFromParent_Done,
     /* 134383 */ // Label 2350: @134383
     /* 134383 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134442), // Rule ID 318 //
     /* 134388 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134391 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 134417 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 134417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 134420 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134440 */   GIR_RootConstrainSelectedInstOperands,
     /* 134441 */   // GIR_Coverage, 318,
     /* 134441 */   GIR_EraseRootFromParent_Done,
     /* 134442 */ // Label 2351: @134442
     /* 134442 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134519), // Rule ID 7124 //
     /* 134447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134457 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134468 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134472 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134477 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134490 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15890>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 134493 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 134497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134517 */   GIR_RootConstrainSelectedInstOperands,
     /* 134518 */   // GIR_Coverage, 7124,
     /* 134518 */   GIR_EraseRootFromParent_Done,
     /* 134519 */ // Label 2352: @134519
     /* 134519 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134596), // Rule ID 7125 //
     /* 134524 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134527 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134534 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134537 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134541 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134545 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134558 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134560 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134567 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15890>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 134570 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 134574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134594 */   GIR_RootConstrainSelectedInstOperands,
     /* 134595 */   // GIR_Coverage, 7125,
     /* 134595 */   GIR_EraseRootFromParent_Done,
     /* 134596 */ // Label 2353: @134596
     /* 134596 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134655), // Rule ID 7105 //
     /* 134601 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134604 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134611 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 134629 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15876>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 134629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 134632 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134649 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134653 */   GIR_RootConstrainSelectedInstOperands,
     /* 134654 */   // GIR_Coverage, 7105,
     /* 134654 */   GIR_EraseRootFromParent_Done,
     /* 134655 */ // Label 2354: @134655
     /* 134655 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(134714), // Rule ID 7106 //
     /* 134660 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134663 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134670 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 134688 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15876>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 134688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 134691 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134712 */   GIR_RootConstrainSelectedInstOperands,
     /* 134713 */   // GIR_Coverage, 7106,
     /* 134713 */   GIR_EraseRootFromParent_Done,
     /* 134714 */ // Label 2355: @134714
     /* 134714 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(134773), // Rule ID 7110 //
     /* 134719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134729 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 134747 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15883>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 134747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 134750 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134771 */   GIR_RootConstrainSelectedInstOperands,
     /* 134772 */   // GIR_Coverage, 7110,
     /* 134772 */   GIR_EraseRootFromParent_Done,
     /* 134773 */ // Label 2356: @134773
     /* 134773 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(134832), // Rule ID 7111 //
     /* 134778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 134806 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15883>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 134806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 134809 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134830 */   GIR_RootConstrainSelectedInstOperands,
     /* 134831 */   // GIR_Coverage, 7111,
     /* 134831 */   GIR_EraseRootFromParent_Done,
     /* 134832 */ // Label 2357: @134832
     /* 134832 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(134891), // Rule ID 7115 //
     /* 134837 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134840 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134847 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134865 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15890>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 134868 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134885 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134889 */   GIR_RootConstrainSelectedInstOperands,
     /* 134890 */   // GIR_Coverage, 7115,
     /* 134890 */   GIR_EraseRootFromParent_Done,
     /* 134891 */ // Label 2358: @134891
     /* 134891 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(134950), // Rule ID 7116 //
     /* 134896 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134899 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134906 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134917 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134924 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15890>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 134927 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134948 */   GIR_RootConstrainSelectedInstOperands,
     /* 134949 */   // GIR_Coverage, 7116,
     /* 134949 */   GIR_EraseRootFromParent_Done,
     /* 134950 */ // Label 2359: @134950
     /* 134950 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(135022), // Rule ID 7126 //
     /* 134955 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134958 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134965 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134976 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134980 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134985 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134989 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134998 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15890>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 135001 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 135005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135020 */   GIR_RootConstrainSelectedInstOperands,
     /* 135021 */   // GIR_Coverage, 7126,
     /* 135021 */   GIR_EraseRootFromParent_Done,
     /* 135022 */ // Label 2360: @135022
     /* 135022 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(135094), // Rule ID 7127 //
     /* 135027 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135030 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135037 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 135048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 135052 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135057 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135061 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135063 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135070 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15890>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 135073 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 135077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135092 */   GIR_RootConstrainSelectedInstOperands,
     /* 135093 */   // GIR_Coverage, 7127,
     /* 135093 */   GIR_EraseRootFromParent_Done,
     /* 135094 */ // Label 2361: @135094
     /* 135094 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(135146), // Rule ID 320 //
     /* 135099 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135110 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135114 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135121 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 135124 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135144 */   GIR_RootConstrainSelectedInstOperands,
     /* 135145 */   // GIR_Coverage, 320,
     /* 135145 */   GIR_EraseRootFromParent_Done,
     /* 135146 */ // Label 2362: @135146
     /* 135146 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(135197), // Rule ID 323 //
     /* 135151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135154 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135157 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135176 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 135179 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135191 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135195 */   GIR_RootConstrainSelectedInstOperands,
     /* 135196 */   // GIR_Coverage, 323,
     /* 135196 */   GIR_EraseRootFromParent_Done,
     /* 135197 */ // Label 2363: @135197
     /* 135197 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(135256), // Rule ID 326 //
     /* 135202 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135205 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135224 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135231 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 135234 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135250 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135254 */   GIR_RootConstrainSelectedInstOperands,
     /* 135255 */   // GIR_Coverage, 326,
     /* 135255 */   GIR_EraseRootFromParent_Done,
     /* 135256 */ // Label 2364: @135256
     /* 135256 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(135315), // Rule ID 327 //
     /* 135261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135264 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135279 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135290 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 135293 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135309 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135313 */   GIR_RootConstrainSelectedInstOperands,
     /* 135314 */   // GIR_Coverage, 327,
     /* 135314 */   GIR_EraseRootFromParent_Done,
     /* 135315 */ // Label 2365: @135315
     /* 135315 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(135369), // Rule ID 7107 //
     /* 135320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135330 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 135348 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15876>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 135348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 135351 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135367 */   GIR_RootConstrainSelectedInstOperands,
     /* 135368 */   // GIR_Coverage, 7107,
     /* 135368 */   GIR_EraseRootFromParent_Done,
     /* 135369 */ // Label 2366: @135369
     /* 135369 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(135423), // Rule ID 7108 //
     /* 135374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135384 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135402 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15876>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 135405 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135421 */   GIR_RootConstrainSelectedInstOperands,
     /* 135422 */   // GIR_Coverage, 7108,
     /* 135422 */   GIR_EraseRootFromParent_Done,
     /* 135423 */ // Label 2367: @135423
     /* 135423 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(135477), // Rule ID 7112 //
     /* 135428 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 135456 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15883>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 135456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 135459 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135475 */   GIR_RootConstrainSelectedInstOperands,
     /* 135476 */   // GIR_Coverage, 7112,
     /* 135476 */   GIR_EraseRootFromParent_Done,
     /* 135477 */ // Label 2368: @135477
     /* 135477 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(135531), // Rule ID 7113 //
     /* 135482 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135492 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135510 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15883>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 135513 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135525 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135529 */   GIR_RootConstrainSelectedInstOperands,
     /* 135530 */   // GIR_Coverage, 7113,
     /* 135530 */   GIR_EraseRootFromParent_Done,
     /* 135531 */ // Label 2369: @135531
     /* 135531 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(135585), // Rule ID 7117 //
     /* 135536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135546 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135557 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 135564 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15890>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 135564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 135567 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135579 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135583 */   GIR_RootConstrainSelectedInstOperands,
     /* 135584 */   // GIR_Coverage, 7117,
     /* 135584 */   GIR_EraseRootFromParent_Done,
     /* 135585 */ // Label 2370: @135585
     /* 135585 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(135639), // Rule ID 7118 //
     /* 135590 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135593 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135600 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135611 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135618 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15890>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 135621 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135633 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135637 */   GIR_RootConstrainSelectedInstOperands,
     /* 135638 */   // GIR_Coverage, 7118,
     /* 135638 */   GIR_EraseRootFromParent_Done,
     /* 135639 */ // Label 2371: @135639
     /* 135639 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(135696), // Rule ID 7480 //
     /* 135644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135647 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135650 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135657 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135675 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15874>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 135678 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135690 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135694 */   GIR_RootConstrainSelectedInstOperands,
     /* 135695 */   // GIR_Coverage, 7480,
     /* 135695 */   GIR_EraseRootFromParent_Done,
     /* 135696 */ // Label 2372: @135696
     /* 135696 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(135753), // Rule ID 7481 //
     /* 135701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135704 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135707 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135714 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135732 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15881>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 135735 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135751 */   GIR_RootConstrainSelectedInstOperands,
     /* 135752 */   // GIR_Coverage, 7481,
     /* 135752 */   GIR_EraseRootFromParent_Done,
     /* 135753 */ // Label 2373: @135753
     /* 135753 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(135810), // Rule ID 7482 //
     /* 135758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135761 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135764 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135771 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135778 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135782 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135789 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15888>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 135792 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135808 */   GIR_RootConstrainSelectedInstOperands,
     /* 135809 */   // GIR_Coverage, 7482,
     /* 135809 */   GIR_EraseRootFromParent_Done,
     /* 135810 */ // Label 2374: @135810
     /* 135810 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(135847), // Rule ID 7104 //
     /* 135815 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135818 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135825 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135832 */   // MIs[0] ptr
     /* 135832 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135840 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15874>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 135845 */   GIR_RootConstrainSelectedInstOperands,
     /* 135846 */   // GIR_Coverage, 7104,
     /* 135846 */   GIR_Done,
     /* 135847 */ // Label 2375: @135847
     /* 135847 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(135884), // Rule ID 7109 //
     /* 135852 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135855 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135862 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135869 */   // MIs[0] ptr
     /* 135869 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135877 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15881>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 135882 */   GIR_RootConstrainSelectedInstOperands,
     /* 135883 */   // GIR_Coverage, 7109,
     /* 135883 */   GIR_Done,
     /* 135884 */ // Label 2376: @135884
     /* 135884 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(135921), // Rule ID 7114 //
     /* 135889 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135892 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135899 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135906 */   // MIs[0] ptr
     /* 135906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135914 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15888>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 135919 */   GIR_RootConstrainSelectedInstOperands,
     /* 135920 */   // GIR_Coverage, 7114,
     /* 135920 */   GIR_Done,
     /* 135921 */ // Label 2377: @135921
     /* 135921 */ GIM_Reject,
     /* 135922 */ // Label 2276: @135922
     /* 135922 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(136028), // Rule ID 4521 //
     /* 135927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135942 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 135946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135950 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135955 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 135959 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135965 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 135972 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 135972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 135975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135984 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 135990 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 136003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136026 */   GIR_RootConstrainSelectedInstOperands,
     /* 136027 */   // GIR_Coverage, 4521,
     /* 136027 */   GIR_EraseRootFromParent_Done,
     /* 136028 */ // Label 2378: @136028
     /* 136028 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(136134), // Rule ID 4522 //
     /* 136033 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136052 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136056 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136061 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136078 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136090 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136096 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 136109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136132 */   GIR_RootConstrainSelectedInstOperands,
     /* 136133 */   // GIR_Coverage, 4522,
     /* 136133 */   GIR_EraseRootFromParent_Done,
     /* 136134 */ // Label 2379: @136134
     /* 136134 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(136240), // Rule ID 4523 //
     /* 136139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136142 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136154 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136162 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136167 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136171 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 136184 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 136184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136196 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 136215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136238 */   GIR_RootConstrainSelectedInstOperands,
     /* 136239 */   // GIR_Coverage, 4523,
     /* 136239 */   GIR_EraseRootFromParent_Done,
     /* 136240 */ // Label 2380: @136240
     /* 136240 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(136346), // Rule ID 4524 //
     /* 136245 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136248 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136260 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136264 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136268 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136273 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136290 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136302 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 136321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136344 */   GIR_RootConstrainSelectedInstOperands,
     /* 136345 */   // GIR_Coverage, 4524,
     /* 136345 */   GIR_EraseRootFromParent_Done,
     /* 136346 */ // Label 2381: @136346
     /* 136346 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(136447), // Rule ID 4547 //
     /* 136351 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136354 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136366 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136370 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136374 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136379 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136383 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 136396 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 136396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136408 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 136427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136445 */   GIR_RootConstrainSelectedInstOperands,
     /* 136446 */   // GIR_Coverage, 4547,
     /* 136446 */   GIR_EraseRootFromParent_Done,
     /* 136447 */ // Label 2382: @136447
     /* 136447 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(136548), // Rule ID 4548 //
     /* 136452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136480 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 136497 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 136497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136509 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 136528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136546 */   GIR_RootConstrainSelectedInstOperands,
     /* 136547 */   // GIR_Coverage, 4548,
     /* 136547 */   GIR_EraseRootFromParent_Done,
     /* 136548 */ // Label 2383: @136548
     /* 136548 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(136649), // Rule ID 4574 //
     /* 136553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136556 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136560 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136568 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136572 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136576 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136581 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 136598 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136610 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136616 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 136629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136642 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136647 */   GIR_RootConstrainSelectedInstOperands,
     /* 136648 */   // GIR_Coverage, 4574,
     /* 136648 */   GIR_EraseRootFromParent_Done,
     /* 136649 */ // Label 2384: @136649
     /* 136649 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(136750), // Rule ID 4575 //
     /* 136654 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136657 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136661 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136665 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136669 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136673 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136677 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136682 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136690 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 136699 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136711 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136717 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136722 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 136730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136748 */   GIR_RootConstrainSelectedInstOperands,
     /* 136749 */   // GIR_Coverage, 4575,
     /* 136749 */   GIR_EraseRootFromParent_Done,
     /* 136750 */ // Label 2385: @136750
     /* 136750 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(136825), // Rule ID 6495 //
     /* 136755 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136758 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136770 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136774 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136778 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136783 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 136787 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 136791 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 136795 */   // MIs[2] Operand 1
     /* 136795 */   // No operand predicates
     /* 136795 */   // MIs[0] Rn
     /* 136795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136803 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 136805 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 136805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 136808 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 136812 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 136815 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 136823 */   GIR_RootConstrainSelectedInstOperands,
     /* 136824 */   // GIR_Coverage, 6495,
     /* 136824 */   GIR_EraseRootFromParent_Done,
     /* 136825 */ // Label 2386: @136825
     /* 136825 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(136900), // Rule ID 6496 //
     /* 136830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136845 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136849 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136853 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136858 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 136862 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 136866 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 136870 */   // MIs[2] Operand 1
     /* 136870 */   // No operand predicates
     /* 136870 */   // MIs[0] Rn
     /* 136870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136878 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 136880 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 136880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 136883 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 136887 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 136890 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136892 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 136898 */   GIR_RootConstrainSelectedInstOperands,
     /* 136899 */   // GIR_Coverage, 6496,
     /* 136899 */   GIR_EraseRootFromParent_Done,
     /* 136900 */ // Label 2387: @136900
     /* 136900 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(136953), // Rule ID 301 //
     /* 136905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136908 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136916 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 136927 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 136927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 136930 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136947 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136951 */   GIR_RootConstrainSelectedInstOperands,
     /* 136952 */   // GIR_Coverage, 301,
     /* 136952 */   GIR_EraseRootFromParent_Done,
     /* 136953 */ // Label 2388: @136953
     /* 136953 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(137006), // Rule ID 302 //
     /* 136958 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136961 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136969 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136973 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136980 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 136983 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137004 */   GIR_RootConstrainSelectedInstOperands,
     /* 137005 */   // GIR_Coverage, 302,
     /* 137005 */   GIR_EraseRootFromParent_Done,
     /* 137006 */ // Label 2389: @137006
     /* 137006 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(137062), // Rule ID 309 //
     /* 137011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137017 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137036 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137039 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137056 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137060 */   GIR_RootConstrainSelectedInstOperands,
     /* 137061 */   // GIR_Coverage, 309,
     /* 137061 */   GIR_EraseRootFromParent_Done,
     /* 137062 */ // Label 2390: @137062
     /* 137062 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(137118), // Rule ID 310 //
     /* 137067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137070 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137073 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137081 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137085 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137092 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137095 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137112 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137116 */   GIR_RootConstrainSelectedInstOperands,
     /* 137117 */   // GIR_Coverage, 310,
     /* 137117 */   GIR_EraseRootFromParent_Done,
     /* 137118 */ // Label 2391: @137118
     /* 137118 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(137207), // Rule ID 4479 //
     /* 137123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137126 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137141 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137145 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 137152 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 137152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137164 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137170 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137175 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 137183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137205 */   GIR_RootConstrainSelectedInstOperands,
     /* 137206 */   // GIR_Coverage, 4479,
     /* 137206 */   GIR_EraseRootFromParent_Done,
     /* 137207 */ // Label 2392: @137207
     /* 137207 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(137296), // Rule ID 4480 //
     /* 137212 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137215 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 137241 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 137241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137253 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 137272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137294 */   GIR_RootConstrainSelectedInstOperands,
     /* 137295 */   // GIR_Coverage, 4480,
     /* 137295 */   GIR_EraseRootFromParent_Done,
     /* 137296 */ // Label 2393: @137296
     /* 137296 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(137385), // Rule ID 4481 //
     /* 137301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137304 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137308 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 137330 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 137330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137342 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 137361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137383 */   GIR_RootConstrainSelectedInstOperands,
     /* 137384 */   // GIR_Coverage, 4481,
     /* 137384 */   GIR_EraseRootFromParent_Done,
     /* 137385 */ // Label 2394: @137385
     /* 137385 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(137474), // Rule ID 4482 //
     /* 137390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137393 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137397 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137412 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 137419 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 137419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137431 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137437 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 137450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137472 */   GIR_RootConstrainSelectedInstOperands,
     /* 137473 */   // GIR_Coverage, 4482,
     /* 137473 */   GIR_EraseRootFromParent_Done,
     /* 137474 */ // Label 2395: @137474
     /* 137474 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(137563), // Rule ID 4483 //
     /* 137479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137482 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137486 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137497 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137501 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 137508 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 137508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137520 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137526 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137531 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 137539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137561 */   GIR_RootConstrainSelectedInstOperands,
     /* 137562 */   // GIR_Coverage, 4483,
     /* 137562 */   GIR_EraseRootFromParent_Done,
     /* 137563 */ // Label 2396: @137563
     /* 137563 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(137652), // Rule ID 4484 //
     /* 137568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137571 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137575 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137586 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137590 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 137597 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 137597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137609 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137620 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 137628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137650 */   GIR_RootConstrainSelectedInstOperands,
     /* 137651 */   // GIR_Coverage, 4484,
     /* 137651 */   GIR_EraseRootFromParent_Done,
     /* 137652 */ // Label 2397: @137652
     /* 137652 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(137705), // Rule ID 4495 //
     /* 137657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137668 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137672 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137679 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137682 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137703 */   GIR_RootConstrainSelectedInstOperands,
     /* 137704 */   // GIR_Coverage, 4495,
     /* 137704 */   GIR_EraseRootFromParent_Done,
     /* 137705 */ // Label 2398: @137705
     /* 137705 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(137758), // Rule ID 4496 //
     /* 137710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137713 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137732 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137735 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137752 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137756 */   GIR_RootConstrainSelectedInstOperands,
     /* 137757 */   // GIR_Coverage, 4496,
     /* 137757 */   GIR_EraseRootFromParent_Done,
     /* 137758 */ // Label 2399: @137758
     /* 137758 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(137811), // Rule ID 4497 //
     /* 137763 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137766 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137774 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137785 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137788 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137809 */   GIR_RootConstrainSelectedInstOperands,
     /* 137810 */   // GIR_Coverage, 4497,
     /* 137810 */   GIR_EraseRootFromParent_Done,
     /* 137811 */ // Label 2400: @137811
     /* 137811 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(137864), // Rule ID 4498 //
     /* 137816 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137819 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137838 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137841 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137862 */   GIR_RootConstrainSelectedInstOperands,
     /* 137863 */   // GIR_Coverage, 4498,
     /* 137863 */   GIR_EraseRootFromParent_Done,
     /* 137864 */ // Label 2401: @137864
     /* 137864 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(137916), // Rule ID 311 //
     /* 137869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137872 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137891 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 137894 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 137900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137914 */   GIR_RootConstrainSelectedInstOperands,
     /* 137915 */   // GIR_Coverage, 311,
     /* 137915 */   GIR_EraseRootFromParent_Done,
     /* 137916 */ // Label 2402: @137916
     /* 137916 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(137967), // Rule ID 316 //
     /* 137921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137924 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137927 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137935 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137939 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137946 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137949 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137965 */   GIR_RootConstrainSelectedInstOperands,
     /* 137966 */   // GIR_Coverage, 316,
     /* 137966 */   GIR_EraseRootFromParent_Done,
     /* 137967 */ // Label 2403: @137967
     /* 137967 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(138015), // Rule ID 4525 //
     /* 137972 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137975 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137994 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137997 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138009 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138013 */   GIR_RootConstrainSelectedInstOperands,
     /* 138014 */   // GIR_Coverage, 4525,
     /* 138014 */   GIR_EraseRootFromParent_Done,
     /* 138015 */ // Label 2404: @138015
     /* 138015 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(138063), // Rule ID 4526 //
     /* 138020 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138023 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138031 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138042 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 138042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138045 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138061 */   GIR_RootConstrainSelectedInstOperands,
     /* 138062 */   // GIR_Coverage, 4526,
     /* 138062 */   GIR_EraseRootFromParent_Done,
     /* 138063 */ // Label 2405: @138063
     /* 138063 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(138147), // Rule ID 4540 //
     /* 138068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138071 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138075 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138090 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 138097 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 138097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138109 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138115 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138120 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 138128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138145 */   GIR_RootConstrainSelectedInstOperands,
     /* 138146 */   // GIR_Coverage, 4540,
     /* 138146 */   GIR_EraseRootFromParent_Done,
     /* 138147 */ // Label 2406: @138147
     /* 138147 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(138231), // Rule ID 4541 //
     /* 138152 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138155 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138174 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 138181 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 138181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138193 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138199 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 138212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138229 */   GIR_RootConstrainSelectedInstOperands,
     /* 138230 */   // GIR_Coverage, 4541,
     /* 138230 */   GIR_EraseRootFromParent_Done,
     /* 138231 */ // Label 2407: @138231
     /* 138231 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(138315), // Rule ID 4542 //
     /* 138236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138239 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138243 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138254 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138258 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 138265 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 138265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138277 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 138296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138309 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138313 */   GIR_RootConstrainSelectedInstOperands,
     /* 138314 */   // GIR_Coverage, 4542,
     /* 138314 */   GIR_EraseRootFromParent_Done,
     /* 138315 */ // Label 2408: @138315
     /* 138315 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(138392), // Rule ID 7128 //
     /* 138320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138330 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138333 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138341 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138345 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138354 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138356 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138363 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15897>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 138366 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138390 */   GIR_RootConstrainSelectedInstOperands,
     /* 138391 */   // GIR_Coverage, 7128,
     /* 138391 */   GIR_EraseRootFromParent_Done,
     /* 138392 */ // Label 2409: @138392
     /* 138392 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(138469), // Rule ID 7129 //
     /* 138397 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138407 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138418 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138422 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138440 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15897>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 138443 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138462 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138467 */   GIR_RootConstrainSelectedInstOperands,
     /* 138468 */   // GIR_Coverage, 7129,
     /* 138468 */   GIR_EraseRootFromParent_Done,
     /* 138469 */ // Label 2410: @138469
     /* 138469 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(138528), // Rule ID 7120 //
     /* 138474 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138477 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138484 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138502 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15897>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 138505 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138522 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138526 */   GIR_RootConstrainSelectedInstOperands,
     /* 138527 */   // GIR_Coverage, 7120,
     /* 138527 */   GIR_EraseRootFromParent_Done,
     /* 138528 */ // Label 2411: @138528
     /* 138528 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(138587), // Rule ID 7121 //
     /* 138533 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138543 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138561 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15897>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 138564 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138585 */   GIR_RootConstrainSelectedInstOperands,
     /* 138586 */   // GIR_Coverage, 7121,
     /* 138586 */   GIR_EraseRootFromParent_Done,
     /* 138587 */ // Label 2412: @138587
     /* 138587 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(138659), // Rule ID 7130 //
     /* 138592 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138595 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138602 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138605 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138613 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138617 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138635 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15897>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 138635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138638 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138657 */   GIR_RootConstrainSelectedInstOperands,
     /* 138658 */   // GIR_Coverage, 7130,
     /* 138658 */   GIR_EraseRootFromParent_Done,
     /* 138659 */ // Label 2413: @138659
     /* 138659 */ GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(138731), // Rule ID 7131 //
     /* 138664 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138674 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138677 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138685 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138689 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138694 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138698 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138700 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138707 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15897>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138710 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138729 */   GIR_RootConstrainSelectedInstOperands,
     /* 138730 */   // GIR_Coverage, 7131,
     /* 138730 */   GIR_EraseRootFromParent_Done,
     /* 138731 */ // Label 2414: @138731
     /* 138731 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(138828), // Rule ID 7472 //
     /* 138736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 138739 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138742 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138749 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138752 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138756 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138760 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138764 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 138768 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138772 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138776 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 138780 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138785 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 138789 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138793 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138797 */   // MIs[3] Operand 1
     /* 138797 */   // No operand predicates
     /* 138797 */   // MIs[0] Rn
     /* 138797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138805 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138807 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 138810 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 138814 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 138817 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 138826 */   GIR_RootConstrainSelectedInstOperands,
     /* 138827 */   // GIR_Coverage, 7472,
     /* 138827 */   GIR_EraseRootFromParent_Done,
     /* 138828 */ // Label 2415: @138828
     /* 138828 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(138880), // Rule ID 319 //
     /* 138833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138836 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138848 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138855 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 138855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 138858 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 138864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138878 */   GIR_RootConstrainSelectedInstOperands,
     /* 138879 */   // GIR_Coverage, 319,
     /* 138879 */   GIR_EraseRootFromParent_Done,
     /* 138880 */ // Label 2416: @138880
     /* 138880 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(138931), // Rule ID 324 //
     /* 138885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138888 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138891 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138899 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138903 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138910 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 138910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138913 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138929 */   GIR_RootConstrainSelectedInstOperands,
     /* 138930 */   // GIR_Coverage, 324,
     /* 138930 */   GIR_EraseRootFromParent_Done,
     /* 138931 */ // Label 2417: @138931
     /* 138931 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(138985), // Rule ID 7122 //
     /* 138936 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138946 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138964 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15897>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 138964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 138967 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138983 */   GIR_RootConstrainSelectedInstOperands,
     /* 138984 */   // GIR_Coverage, 7122,
     /* 138984 */   GIR_EraseRootFromParent_Done,
     /* 138985 */ // Label 2418: @138985
     /* 138985 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(139039), // Rule ID 7123 //
     /* 138990 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139000 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139007 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139011 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139018 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15897>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 139021 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 139023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139033 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139037 */   GIR_RootConstrainSelectedInstOperands,
     /* 139038 */   // GIR_Coverage, 7123,
     /* 139038 */   GIR_EraseRootFromParent_Done,
     /* 139039 */ // Label 2419: @139039
     /* 139039 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(139096), // Rule ID 7483 //
     /* 139044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 139047 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139057 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139064 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139068 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139075 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 139078 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 139080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139090 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139094 */   GIR_RootConstrainSelectedInstOperands,
     /* 139095 */   // GIR_Coverage, 7483,
     /* 139095 */   GIR_EraseRootFromParent_Done,
     /* 139096 */ // Label 2420: @139096
     /* 139096 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(139144), // Rule ID 4549 //
     /* 139101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139104 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139123 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 139126 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139142 */   GIR_RootConstrainSelectedInstOperands,
     /* 139143 */   // GIR_Coverage, 4549,
     /* 139143 */   GIR_EraseRootFromParent_Done,
     /* 139144 */ // Label 2421: @139144
     /* 139144 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(139192), // Rule ID 4550 //
     /* 139149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139152 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139160 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139164 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139171 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 139174 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139190 */   GIR_RootConstrainSelectedInstOperands,
     /* 139191 */   // GIR_Coverage, 4550,
     /* 139191 */   GIR_EraseRootFromParent_Done,
     /* 139192 */ // Label 2422: @139192
     /* 139192 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(139276), // Rule ID 4565 //
     /* 139197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139200 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139204 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139215 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139219 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 139226 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139226 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139229 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139233 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139238 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139244 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139249 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 139257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139274 */   GIR_RootConstrainSelectedInstOperands,
     /* 139275 */   // GIR_Coverage, 4565,
     /* 139275 */   GIR_EraseRootFromParent_Done,
     /* 139276 */ // Label 2423: @139276
     /* 139276 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(139360), // Rule ID 4566 //
     /* 139281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139284 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 139310 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139322 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139328 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139333 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 139341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139358 */   GIR_RootConstrainSelectedInstOperands,
     /* 139359 */   // GIR_Coverage, 4566,
     /* 139359 */   GIR_EraseRootFromParent_Done,
     /* 139360 */ // Label 2424: @139360
     /* 139360 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(139444), // Rule ID 4567 //
     /* 139365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139368 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139372 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139383 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139387 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 139394 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139406 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139412 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139417 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 139425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139442 */   GIR_RootConstrainSelectedInstOperands,
     /* 139443 */   // GIR_Coverage, 4567,
     /* 139443 */   GIR_EraseRootFromParent_Done,
     /* 139444 */ // Label 2425: @139444
     /* 139444 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(139528), // Rule ID 7471 //
     /* 139449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 139452 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139462 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139465 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139469 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 139473 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 139477 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139481 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139486 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139490 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 139494 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 139498 */   // MIs[2] Operand 1
     /* 139498 */   // No operand predicates
     /* 139498 */   // MIs[0] Rn
     /* 139498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139506 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139508 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 139508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 139511 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 139515 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 139518 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139520 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 139526 */   GIR_RootConstrainSelectedInstOperands,
     /* 139527 */   // GIR_Coverage, 7471,
     /* 139527 */   GIR_EraseRootFromParent_Done,
     /* 139528 */ // Label 2426: @139528
     /* 139528 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(139626), // Rule ID 7473 //
     /* 139533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 139536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139546 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 139557 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 139561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139566 */   // MIs[0] Rn
     /* 139566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139576 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 139576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 139579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 139583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139588 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 139591 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 139595 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 139598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 139611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139617 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139619 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139624 */   GIR_RootConstrainSelectedInstOperands,
     /* 139625 */   // GIR_Coverage, 7473,
     /* 139625 */   GIR_EraseRootFromParent_Done,
     /* 139626 */ // Label 2427: @139626
     /* 139626 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(139663), // Rule ID 7119 //
     /* 139631 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139634 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139641 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139648 */   // MIs[0] ptr
     /* 139648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139656 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 139656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 139661 */   GIR_RootConstrainSelectedInstOperands,
     /* 139662 */   // GIR_Coverage, 7119,
     /* 139662 */   GIR_Done,
     /* 139663 */ // Label 2428: @139663
     /* 139663 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(139690), // Rule ID 6443 //
     /* 139668 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139671 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139675 */   // MIs[0] Rn
     /* 139675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139683 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 139683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 139688 */   GIR_RootConstrainSelectedInstOperands,
     /* 139689 */   // GIR_Coverage, 6443,
     /* 139689 */   GIR_Done,
     /* 139690 */ // Label 2429: @139690
     /* 139690 */ GIM_Reject,
     /* 139691 */ // Label 2277: @139691
     /* 139691 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(139896),
     /* 139696 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139699 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139711 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(139752), // Rule ID 4477 //
     /* 139716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 139719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 139726 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 139726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 139729 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139750 */     GIR_RootConstrainSelectedInstOperands,
     /* 139751 */     // GIR_Coverage, 4477,
     /* 139751 */     GIR_EraseRootFromParent_Done,
     /* 139752 */   // Label 2431: @139752
     /* 139752 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(139793), // Rule ID 4478 //
     /* 139757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 139760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 139767 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 139767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 139770 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139791 */     GIR_RootConstrainSelectedInstOperands,
     /* 139792 */     // GIR_Coverage, 4478,
     /* 139792 */     GIR_EraseRootFromParent_Done,
     /* 139793 */   // Label 2432: @139793
     /* 139793 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(139826), // Rule ID 4532 //
     /* 139798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 139805 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 139805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 139808 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139824 */     GIR_RootConstrainSelectedInstOperands,
     /* 139825 */     // GIR_Coverage, 4532,
     /* 139825 */     GIR_EraseRootFromParent_Done,
     /* 139826 */   // Label 2433: @139826
     /* 139826 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(139859), // Rule ID 4556 //
     /* 139831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 139838 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 139841 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139857 */     GIR_RootConstrainSelectedInstOperands,
     /* 139858 */     // GIR_Coverage, 4556,
     /* 139858 */     GIR_EraseRootFromParent_Done,
     /* 139859 */   // Label 2434: @139859
     /* 139859 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(139895), // Rule ID 325 //
     /* 139864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 139874 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 139874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 139877 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139893 */     GIR_RootConstrainSelectedInstOperands,
     /* 139894 */     // GIR_Coverage, 325,
     /* 139894 */     GIR_EraseRootFromParent_Done,
     /* 139895 */   // Label 2435: @139895
     /* 139895 */   GIM_Reject,
     /* 139896 */ // Label 2430: @139896
     /* 139896 */ GIM_Reject,
     /* 139897 */ // Label 2278: @139897
     /* 139897 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(140302),
     /* 139902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139905 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139909 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(139958), // Rule ID 4485 //
     /* 139914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 139917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139932 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139935 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139956 */     GIR_RootConstrainSelectedInstOperands,
     /* 139957 */     // GIR_Coverage, 4485,
     /* 139957 */     GIR_EraseRootFromParent_Done,
     /* 139958 */   // Label 2437: @139958
     /* 139958 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(140007), // Rule ID 4486 //
     /* 139963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 139966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139981 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139984 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140005 */     GIR_RootConstrainSelectedInstOperands,
     /* 140006 */     // GIR_Coverage, 4486,
     /* 140006 */     GIR_EraseRootFromParent_Done,
     /* 140007 */   // Label 2438: @140007
     /* 140007 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(140056), // Rule ID 4487 //
     /* 140012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140030 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140033 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140054 */     GIR_RootConstrainSelectedInstOperands,
     /* 140055 */     // GIR_Coverage, 4487,
     /* 140055 */     GIR_EraseRootFromParent_Done,
     /* 140056 */   // Label 2439: @140056
     /* 140056 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(140105), // Rule ID 4488 //
     /* 140061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140079 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140082 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140103 */     GIR_RootConstrainSelectedInstOperands,
     /* 140104 */     // GIR_Coverage, 4488,
     /* 140104 */     GIR_EraseRootFromParent_Done,
     /* 140105 */   // Label 2440: @140105
     /* 140105 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(140149), // Rule ID 4527 //
     /* 140110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140128 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140131 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140147 */     GIR_RootConstrainSelectedInstOperands,
     /* 140148 */     // GIR_Coverage, 4527,
     /* 140148 */     GIR_EraseRootFromParent_Done,
     /* 140149 */   // Label 2441: @140149
     /* 140149 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(140193), // Rule ID 4530 //
     /* 140154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140172 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140175 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140191 */     GIR_RootConstrainSelectedInstOperands,
     /* 140192 */     // GIR_Coverage, 4530,
     /* 140192 */     GIR_EraseRootFromParent_Done,
     /* 140193 */   // Label 2442: @140193
     /* 140193 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(140237), // Rule ID 4551 //
     /* 140198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140216 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140219 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140235 */     GIR_RootConstrainSelectedInstOperands,
     /* 140236 */     // GIR_Coverage, 4551,
     /* 140236 */     GIR_EraseRootFromParent_Done,
     /* 140237 */   // Label 2443: @140237
     /* 140237 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(140281), // Rule ID 4554 //
     /* 140242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140260 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140263 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140279 */     GIR_RootConstrainSelectedInstOperands,
     /* 140280 */     // GIR_Coverage, 4554,
     /* 140280 */     GIR_EraseRootFromParent_Done,
     /* 140281 */   // Label 2444: @140281
     /* 140281 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(140301), // Rule ID 6442 //
     /* 140286 */     // MIs[0] Rn
     /* 140286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140294 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 140294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 140299 */     GIR_RootConstrainSelectedInstOperands,
     /* 140300 */     // GIR_Coverage, 6442,
     /* 140300 */     GIR_Done,
     /* 140301 */   // Label 2445: @140301
     /* 140301 */   GIM_Reject,
     /* 140302 */ // Label 2436: @140302
     /* 140302 */ GIM_Reject,
     /* 140303 */ // Label 2279: @140303
     /* 140303 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(140752),
     /* 140308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140311 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140315 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(140364), // Rule ID 4499 //
     /* 140320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 140338 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 140338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 140341 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140362 */     GIR_RootConstrainSelectedInstOperands,
     /* 140363 */     // GIR_Coverage, 4499,
     /* 140363 */     GIR_EraseRootFromParent_Done,
     /* 140364 */   // Label 2447: @140364
     /* 140364 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(140413), // Rule ID 4500 //
     /* 140369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 140387 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 140387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 140390 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140411 */     GIR_RootConstrainSelectedInstOperands,
     /* 140412 */     // GIR_Coverage, 4500,
     /* 140412 */     GIR_EraseRootFromParent_Done,
     /* 140413 */   // Label 2448: @140413
     /* 140413 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(140462), // Rule ID 4501 //
     /* 140418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 140436 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 140436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 140439 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140460 */     GIR_RootConstrainSelectedInstOperands,
     /* 140461 */     // GIR_Coverage, 4501,
     /* 140461 */     GIR_EraseRootFromParent_Done,
     /* 140462 */   // Label 2449: @140462
     /* 140462 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(140511), // Rule ID 4502 //
     /* 140467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 140485 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 140485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 140488 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140509 */     GIR_RootConstrainSelectedInstOperands,
     /* 140510 */     // GIR_Coverage, 4502,
     /* 140510 */     GIR_EraseRootFromParent_Done,
     /* 140511 */   // Label 2450: @140511
     /* 140511 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(140555), // Rule ID 4534 //
     /* 140516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 140534 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 140534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 140537 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140553 */     GIR_RootConstrainSelectedInstOperands,
     /* 140554 */     // GIR_Coverage, 4534,
     /* 140554 */     GIR_EraseRootFromParent_Done,
     /* 140555 */   // Label 2451: @140555
     /* 140555 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(140599), // Rule ID 4538 //
     /* 140560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 140578 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 140578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 140581 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140597 */     GIR_RootConstrainSelectedInstOperands,
     /* 140598 */     // GIR_Coverage, 4538,
     /* 140598 */     GIR_EraseRootFromParent_Done,
     /* 140599 */   // Label 2452: @140599
     /* 140599 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(140643), // Rule ID 4558 //
     /* 140604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140622 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140625 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140641 */     GIR_RootConstrainSelectedInstOperands,
     /* 140642 */     // GIR_Coverage, 4558,
     /* 140642 */     GIR_EraseRootFromParent_Done,
     /* 140643 */   // Label 2453: @140643
     /* 140643 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(140687), // Rule ID 4562 //
     /* 140648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140666 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140669 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140685 */     GIR_RootConstrainSelectedInstOperands,
     /* 140686 */     // GIR_Coverage, 4562,
     /* 140686 */     GIR_EraseRootFromParent_Done,
     /* 140687 */   // Label 2454: @140687
     /* 140687 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(140731), // Rule ID 4563 //
     /* 140692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140710 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140713 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140729 */     GIR_RootConstrainSelectedInstOperands,
     /* 140730 */     // GIR_Coverage, 4563,
     /* 140730 */     GIR_EraseRootFromParent_Done,
     /* 140731 */   // Label 2455: @140731
     /* 140731 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(140751), // Rule ID 6439 //
     /* 140736 */     // MIs[0] Rn
     /* 140736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140744 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 140744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 140749 */     GIR_RootConstrainSelectedInstOperands,
     /* 140750 */     // GIR_Coverage, 6439,
     /* 140750 */     GIR_Done,
     /* 140751 */   // Label 2456: @140751
     /* 140751 */   GIM_Reject,
     /* 140752 */ // Label 2446: @140752
     /* 140752 */ GIM_Reject,
     /* 140753 */ // Label 2280: @140753
     /* 140753 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(141158),
     /* 140758 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140761 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140765 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(140814), // Rule ID 4489 //
     /* 140770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140788 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140791 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140812 */     GIR_RootConstrainSelectedInstOperands,
     /* 140813 */     // GIR_Coverage, 4489,
     /* 140813 */     GIR_EraseRootFromParent_Done,
     /* 140814 */   // Label 2458: @140814
     /* 140814 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(140863), // Rule ID 4490 //
     /* 140819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140837 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140840 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140861 */     GIR_RootConstrainSelectedInstOperands,
     /* 140862 */     // GIR_Coverage, 4490,
     /* 140862 */     GIR_EraseRootFromParent_Done,
     /* 140863 */   // Label 2459: @140863
     /* 140863 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(140912), // Rule ID 4493 //
     /* 140868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140886 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140889 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140910 */     GIR_RootConstrainSelectedInstOperands,
     /* 140911 */     // GIR_Coverage, 4493,
     /* 140911 */     GIR_EraseRootFromParent_Done,
     /* 140912 */   // Label 2460: @140912
     /* 140912 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(140961), // Rule ID 4494 //
     /* 140917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140935 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140938 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140959 */     GIR_RootConstrainSelectedInstOperands,
     /* 140960 */     // GIR_Coverage, 4494,
     /* 140960 */     GIR_EraseRootFromParent_Done,
     /* 140961 */   // Label 2461: @140961
     /* 140961 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(141005), // Rule ID 4529 //
     /* 140966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140984 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140987 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141003 */     GIR_RootConstrainSelectedInstOperands,
     /* 141004 */     // GIR_Coverage, 4529,
     /* 141004 */     GIR_EraseRootFromParent_Done,
     /* 141005 */   // Label 2462: @141005
     /* 141005 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(141049), // Rule ID 4531 //
     /* 141010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141028 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141031 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141047 */     GIR_RootConstrainSelectedInstOperands,
     /* 141048 */     // GIR_Coverage, 4531,
     /* 141048 */     GIR_EraseRootFromParent_Done,
     /* 141049 */   // Label 2463: @141049
     /* 141049 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(141093), // Rule ID 4553 //
     /* 141054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141072 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141075 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141091 */     GIR_RootConstrainSelectedInstOperands,
     /* 141092 */     // GIR_Coverage, 4553,
     /* 141092 */     GIR_EraseRootFromParent_Done,
     /* 141093 */   // Label 2464: @141093
     /* 141093 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(141137), // Rule ID 4555 //
     /* 141098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141116 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141119 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141135 */     GIR_RootConstrainSelectedInstOperands,
     /* 141136 */     // GIR_Coverage, 4555,
     /* 141136 */     GIR_EraseRootFromParent_Done,
     /* 141137 */   // Label 2465: @141137
     /* 141137 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(141157), // Rule ID 6441 //
     /* 141142 */     // MIs[0] Rn
     /* 141142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141150 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 141155 */     GIR_RootConstrainSelectedInstOperands,
     /* 141156 */     // GIR_Coverage, 6441,
     /* 141156 */     GIR_Done,
     /* 141157 */   // Label 2466: @141157
     /* 141157 */   GIM_Reject,
     /* 141158 */ // Label 2457: @141158
     /* 141158 */ GIM_Reject,
     /* 141159 */ // Label 2281: @141159
     /* 141159 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(141564),
     /* 141164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141167 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141171 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(141220), // Rule ID 4503 //
     /* 141176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141194 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141197 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141218 */     GIR_RootConstrainSelectedInstOperands,
     /* 141219 */     // GIR_Coverage, 4503,
     /* 141219 */     GIR_EraseRootFromParent_Done,
     /* 141220 */   // Label 2468: @141220
     /* 141220 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(141269), // Rule ID 4504 //
     /* 141225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141243 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141246 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141267 */     GIR_RootConstrainSelectedInstOperands,
     /* 141268 */     // GIR_Coverage, 4504,
     /* 141268 */     GIR_EraseRootFromParent_Done,
     /* 141269 */   // Label 2469: @141269
     /* 141269 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(141318), // Rule ID 4505 //
     /* 141274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141292 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141295 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141316 */     GIR_RootConstrainSelectedInstOperands,
     /* 141317 */     // GIR_Coverage, 4505,
     /* 141317 */     GIR_EraseRootFromParent_Done,
     /* 141318 */   // Label 2470: @141318
     /* 141318 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(141367), // Rule ID 4506 //
     /* 141323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141341 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141344 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141365 */     GIR_RootConstrainSelectedInstOperands,
     /* 141366 */     // GIR_Coverage, 4506,
     /* 141366 */     GIR_EraseRootFromParent_Done,
     /* 141367 */   // Label 2471: @141367
     /* 141367 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(141411), // Rule ID 4533 //
     /* 141372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141390 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141393 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141409 */     GIR_RootConstrainSelectedInstOperands,
     /* 141410 */     // GIR_Coverage, 4533,
     /* 141410 */     GIR_EraseRootFromParent_Done,
     /* 141411 */   // Label 2472: @141411
     /* 141411 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(141455), // Rule ID 4537 //
     /* 141416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141434 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141437 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141453 */     GIR_RootConstrainSelectedInstOperands,
     /* 141454 */     // GIR_Coverage, 4537,
     /* 141454 */     GIR_EraseRootFromParent_Done,
     /* 141455 */   // Label 2473: @141455
     /* 141455 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(141499), // Rule ID 4557 //
     /* 141460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141478 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141481 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141497 */     GIR_RootConstrainSelectedInstOperands,
     /* 141498 */     // GIR_Coverage, 4557,
     /* 141498 */     GIR_EraseRootFromParent_Done,
     /* 141499 */   // Label 2474: @141499
     /* 141499 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(141543), // Rule ID 4561 //
     /* 141504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141522 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141525 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141541 */     GIR_RootConstrainSelectedInstOperands,
     /* 141542 */     // GIR_Coverage, 4561,
     /* 141542 */     GIR_EraseRootFromParent_Done,
     /* 141543 */   // Label 2475: @141543
     /* 141543 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(141563), // Rule ID 6438 //
     /* 141548 */     // MIs[0] Rn
     /* 141548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141556 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 141561 */     GIR_RootConstrainSelectedInstOperands,
     /* 141562 */     // GIR_Coverage, 6438,
     /* 141562 */     GIR_Done,
     /* 141563 */   // Label 2476: @141563
     /* 141563 */   GIM_Reject,
     /* 141564 */ // Label 2467: @141564
     /* 141564 */ GIM_Reject,
     /* 141565 */ // Label 2282: @141565
     /* 141565 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(141784),
     /* 141570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141573 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141577 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(141626), // Rule ID 4491 //
     /* 141582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141600 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141603 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141624 */     GIR_RootConstrainSelectedInstOperands,
     /* 141625 */     // GIR_Coverage, 4491,
     /* 141625 */     GIR_EraseRootFromParent_Done,
     /* 141626 */   // Label 2478: @141626
     /* 141626 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(141675), // Rule ID 4492 //
     /* 141631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141649 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141652 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141673 */     GIR_RootConstrainSelectedInstOperands,
     /* 141674 */     // GIR_Coverage, 4492,
     /* 141674 */     GIR_EraseRootFromParent_Done,
     /* 141675 */   // Label 2479: @141675
     /* 141675 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(141719), // Rule ID 4528 //
     /* 141680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141698 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141701 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141717 */     GIR_RootConstrainSelectedInstOperands,
     /* 141718 */     // GIR_Coverage, 4528,
     /* 141718 */     GIR_EraseRootFromParent_Done,
     /* 141719 */   // Label 2480: @141719
     /* 141719 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(141763), // Rule ID 4552 //
     /* 141724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141742 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141745 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141761 */     GIR_RootConstrainSelectedInstOperands,
     /* 141762 */     // GIR_Coverage, 4552,
     /* 141762 */     GIR_EraseRootFromParent_Done,
     /* 141763 */   // Label 2481: @141763
     /* 141763 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(141783), // Rule ID 6440 //
     /* 141768 */     // MIs[0] Rn
     /* 141768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141776 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 141781 */     GIR_RootConstrainSelectedInstOperands,
     /* 141782 */     // GIR_Coverage, 6440,
     /* 141782 */     GIR_Done,
     /* 141783 */   // Label 2482: @141783
     /* 141783 */   GIM_Reject,
     /* 141784 */ // Label 2477: @141784
     /* 141784 */ GIM_Reject,
     /* 141785 */ // Label 2283: @141785
     /* 141785 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(142190),
     /* 141790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141797 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(141846), // Rule ID 4507 //
     /* 141802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141820 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141823 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141844 */     GIR_RootConstrainSelectedInstOperands,
     /* 141845 */     // GIR_Coverage, 4507,
     /* 141845 */     GIR_EraseRootFromParent_Done,
     /* 141846 */   // Label 2484: @141846
     /* 141846 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(141895), // Rule ID 4508 //
     /* 141851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141869 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141872 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141893 */     GIR_RootConstrainSelectedInstOperands,
     /* 141894 */     // GIR_Coverage, 4508,
     /* 141894 */     GIR_EraseRootFromParent_Done,
     /* 141895 */   // Label 2485: @141895
     /* 141895 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(141944), // Rule ID 4511 //
     /* 141900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141918 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141921 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141942 */     GIR_RootConstrainSelectedInstOperands,
     /* 141943 */     // GIR_Coverage, 4511,
     /* 141943 */     GIR_EraseRootFromParent_Done,
     /* 141944 */   // Label 2486: @141944
     /* 141944 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(141993), // Rule ID 4512 //
     /* 141949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141967 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141970 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141991 */     GIR_RootConstrainSelectedInstOperands,
     /* 141992 */     // GIR_Coverage, 4512,
     /* 141992 */     GIR_EraseRootFromParent_Done,
     /* 141993 */   // Label 2487: @141993
     /* 141993 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(142037), // Rule ID 4536 //
     /* 141998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142016 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142019 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142035 */     GIR_RootConstrainSelectedInstOperands,
     /* 142036 */     // GIR_Coverage, 4536,
     /* 142036 */     GIR_EraseRootFromParent_Done,
     /* 142037 */   // Label 2488: @142037
     /* 142037 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(142081), // Rule ID 4539 //
     /* 142042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142060 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142063 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142079 */     GIR_RootConstrainSelectedInstOperands,
     /* 142080 */     // GIR_Coverage, 4539,
     /* 142080 */     GIR_EraseRootFromParent_Done,
     /* 142081 */   // Label 2489: @142081
     /* 142081 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(142125), // Rule ID 4560 //
     /* 142086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142104 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142107 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142123 */     GIR_RootConstrainSelectedInstOperands,
     /* 142124 */     // GIR_Coverage, 4560,
     /* 142124 */     GIR_EraseRootFromParent_Done,
     /* 142125 */   // Label 2490: @142125
     /* 142125 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(142169), // Rule ID 4564 //
     /* 142130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142148 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142151 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142167 */     GIR_RootConstrainSelectedInstOperands,
     /* 142168 */     // GIR_Coverage, 4564,
     /* 142168 */     GIR_EraseRootFromParent_Done,
     /* 142169 */   // Label 2491: @142169
     /* 142169 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(142189), // Rule ID 6437 //
     /* 142174 */     // MIs[0] Rn
     /* 142174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142182 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 142187 */     GIR_RootConstrainSelectedInstOperands,
     /* 142188 */     // GIR_Coverage, 6437,
     /* 142188 */     GIR_Done,
     /* 142189 */   // Label 2492: @142189
     /* 142189 */   GIM_Reject,
     /* 142190 */ // Label 2483: @142190
     /* 142190 */ GIM_Reject,
     /* 142191 */ // Label 2284: @142191
     /* 142191 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(142410),
     /* 142196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142199 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142203 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(142252), // Rule ID 4509 //
     /* 142208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142226 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142229 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142250 */     GIR_RootConstrainSelectedInstOperands,
     /* 142251 */     // GIR_Coverage, 4509,
     /* 142251 */     GIR_EraseRootFromParent_Done,
     /* 142252 */   // Label 2494: @142252
     /* 142252 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(142301), // Rule ID 4510 //
     /* 142257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142275 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142278 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142299 */     GIR_RootConstrainSelectedInstOperands,
     /* 142300 */     // GIR_Coverage, 4510,
     /* 142300 */     GIR_EraseRootFromParent_Done,
     /* 142301 */   // Label 2495: @142301
     /* 142301 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(142345), // Rule ID 4535 //
     /* 142306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142324 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142327 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142343 */     GIR_RootConstrainSelectedInstOperands,
     /* 142344 */     // GIR_Coverage, 4535,
     /* 142344 */     GIR_EraseRootFromParent_Done,
     /* 142345 */   // Label 2496: @142345
     /* 142345 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(142389), // Rule ID 4559 //
     /* 142350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142368 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142371 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142387 */     GIR_RootConstrainSelectedInstOperands,
     /* 142388 */     // GIR_Coverage, 4559,
     /* 142388 */     GIR_EraseRootFromParent_Done,
     /* 142389 */   // Label 2497: @142389
     /* 142389 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(142409), // Rule ID 6436 //
     /* 142394 */     // MIs[0] Rn
     /* 142394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142402 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 142407 */     GIR_RootConstrainSelectedInstOperands,
     /* 142408 */     // GIR_Coverage, 6436,
     /* 142408 */     GIR_Done,
     /* 142409 */   // Label 2498: @142409
     /* 142409 */   GIM_Reject,
     /* 142410 */ // Label 2493: @142410
     /* 142410 */ GIM_Reject,
     /* 142411 */ // Label 2285: @142411
     /* 142411 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(142470), // Rule ID 10920 //
     /* 142416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142422 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142426 */   // MIs[0] base
     /* 142426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142434 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142446 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 142454 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142459 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142468 */   GIR_RootConstrainSelectedInstOperands,
     /* 142469 */   // GIR_Coverage, 10920,
     /* 142469 */   GIR_EraseRootFromParent_Done,
     /* 142470 */ // Label 2499: @142470
     /* 142470 */ GIM_Reject,
     /* 142471 */ // Label 2286: @142471
     /* 142471 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(142530), // Rule ID 10926 //
     /* 142476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142482 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142486 */   // MIs[0] base
     /* 142486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142494 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142506 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 142514 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142519 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142528 */   GIR_RootConstrainSelectedInstOperands,
     /* 142529 */   // GIR_Coverage, 10926,
     /* 142529 */   GIR_EraseRootFromParent_Done,
     /* 142530 */ // Label 2500: @142530
     /* 142530 */ GIM_Reject,
     /* 142531 */ // Label 2287: @142531
     /* 142531 */ GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(142700),
     /* 142536 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142539 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142547 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(142595), // Rule ID 10911 //
     /* 142552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142559 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 142579 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142584 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142593 */     GIR_RootConstrainSelectedInstOperands,
     /* 142594 */     // GIR_Coverage, 10911,
     /* 142594 */     GIR_EraseRootFromParent_Done,
     /* 142595 */   // Label 2502: @142595
     /* 142595 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(142643), // Rule ID 10929 //
     /* 142600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142607 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142619 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 142627 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142632 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142641 */     GIR_RootConstrainSelectedInstOperands,
     /* 142642 */     // GIR_Coverage, 10929,
     /* 142642 */     GIR_EraseRootFromParent_Done,
     /* 142643 */   // Label 2503: @142643
     /* 142643 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(142671), // Rule ID 11041 //
     /* 142648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142655 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142658 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142660 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142669 */     GIR_RootConstrainSelectedInstOperands,
     /* 142670 */     // GIR_Coverage, 11041,
     /* 142670 */     GIR_EraseRootFromParent_Done,
     /* 142671 */   // Label 2504: @142671
     /* 142671 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(142699), // Rule ID 11053 //
     /* 142676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142683 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142686 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142688 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142697 */     GIR_RootConstrainSelectedInstOperands,
     /* 142698 */     // GIR_Coverage, 11053,
     /* 142698 */     GIR_EraseRootFromParent_Done,
     /* 142699 */   // Label 2505: @142699
     /* 142699 */   GIM_Reject,
     /* 142700 */ // Label 2501: @142700
     /* 142700 */ GIM_Reject,
     /* 142701 */ // Label 2288: @142701
     /* 142701 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(142760), // Rule ID 10917 //
     /* 142706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142709 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142712 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142716 */   // MIs[0] base
     /* 142716 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142724 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142736 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 142744 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142749 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142758 */   GIR_RootConstrainSelectedInstOperands,
     /* 142759 */   // GIR_Coverage, 10917,
     /* 142759 */   GIR_EraseRootFromParent_Done,
     /* 142760 */ // Label 2506: @142760
     /* 142760 */ GIM_Reject,
     /* 142761 */ // Label 2289: @142761
     /* 142761 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(142930),
     /* 142766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142777 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(142825), // Rule ID 10905 //
     /* 142782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142789 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 142809 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142814 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142823 */     GIR_RootConstrainSelectedInstOperands,
     /* 142824 */     // GIR_Coverage, 10905,
     /* 142824 */     GIR_EraseRootFromParent_Done,
     /* 142825 */   // Label 2508: @142825
     /* 142825 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(142873), // Rule ID 10923 //
     /* 142830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142837 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 142857 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142862 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142871 */     GIR_RootConstrainSelectedInstOperands,
     /* 142872 */     // GIR_Coverage, 10923,
     /* 142872 */     GIR_EraseRootFromParent_Done,
     /* 142873 */   // Label 2509: @142873
     /* 142873 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(142901), // Rule ID 11037 //
     /* 142878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142885 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142888 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142890 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142899 */     GIR_RootConstrainSelectedInstOperands,
     /* 142900 */     // GIR_Coverage, 11037,
     /* 142900 */     GIR_EraseRootFromParent_Done,
     /* 142901 */   // Label 2510: @142901
     /* 142901 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(142929), // Rule ID 11049 //
     /* 142906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142913 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142916 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142918 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142927 */     GIR_RootConstrainSelectedInstOperands,
     /* 142928 */     // GIR_Coverage, 11049,
     /* 142928 */     GIR_EraseRootFromParent_Done,
     /* 142929 */   // Label 2511: @142929
     /* 142929 */   GIM_Reject,
     /* 142930 */ // Label 2507: @142930
     /* 142930 */ GIM_Reject,
     /* 142931 */ // Label 2290: @142931
     /* 142931 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(143100),
     /* 142936 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142939 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142943 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142947 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(142995), // Rule ID 10896 //
     /* 142952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142959 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 142966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142971 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 142979 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142984 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142993 */     GIR_RootConstrainSelectedInstOperands,
     /* 142994 */     // GIR_Coverage, 10896,
     /* 142994 */     GIR_EraseRootFromParent_Done,
     /* 142995 */   // Label 2513: @142995
     /* 142995 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(143043), // Rule ID 10914 //
     /* 143000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143007 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 143014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 143027 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143032 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143041 */     GIR_RootConstrainSelectedInstOperands,
     /* 143042 */     // GIR_Coverage, 10914,
     /* 143042 */     GIR_EraseRootFromParent_Done,
     /* 143043 */   // Label 2514: @143043
     /* 143043 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(143071), // Rule ID 11033 //
     /* 143048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 143051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143055 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 143058 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143060 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143069 */     GIR_RootConstrainSelectedInstOperands,
     /* 143070 */     // GIR_Coverage, 11033,
     /* 143070 */     GIR_EraseRootFromParent_Done,
     /* 143071 */   // Label 2515: @143071
     /* 143071 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(143099), // Rule ID 11045 //
     /* 143076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 143079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143083 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 143086 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143088 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143097 */     GIR_RootConstrainSelectedInstOperands,
     /* 143098 */     // GIR_Coverage, 11045,
     /* 143098 */     GIR_EraseRootFromParent_Done,
     /* 143099 */   // Label 2516: @143099
     /* 143099 */   GIM_Reject,
     /* 143100 */ // Label 2512: @143100
     /* 143100 */ GIM_Reject,
     /* 143101 */ // Label 2291: @143101
     /* 143101 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(143144), // Rule ID 2430 //
     /* 143106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 143120 */   // MIs[0] base
     /* 143120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143128 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 143131 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 143133 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143142 */   GIR_RootConstrainSelectedInstOperands,
     /* 143143 */   // GIR_Coverage, 2430,
     /* 143143 */   GIR_EraseRootFromParent_Done,
     /* 143144 */ // Label 2517: @143144
     /* 143144 */ GIM_Reject,
     /* 143145 */ // Label 2292: @143145
     /* 143145 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(143238),
     /* 143150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143161 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(143209), // Rule ID 10882 //
     /* 143166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143173 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 143180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143185 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 143193 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143198 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143207 */     GIR_RootConstrainSelectedInstOperands,
     /* 143208 */     // GIR_Coverage, 10882,
     /* 143208 */     GIR_EraseRootFromParent_Done,
     /* 143209 */   // Label 2519: @143209
     /* 143209 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(143237), // Rule ID 11029 //
     /* 143214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 143217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143221 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 143224 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143226 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143235 */     GIR_RootConstrainSelectedInstOperands,
     /* 143236 */     // GIR_Coverage, 11029,
     /* 143236 */     GIR_EraseRootFromParent_Done,
     /* 143237 */   // Label 2520: @143237
     /* 143237 */   GIM_Reject,
     /* 143238 */ // Label 2518: @143238
     /* 143238 */ GIM_Reject,
     /* 143239 */ // Label 2293: @143239
     /* 143239 */ GIM_Reject,
     /* 143240 */ // Label 20: @143240
     /* 143240 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2523*/ GIMT_Encode4(144590),
     /* 143251 */ /*GILLT_s32*//*Label 2521*/ GIMT_Encode4(143259),
     /* 143255 */ /*GILLT_s64*//*Label 2522*/ GIMT_Encode4(144277),
     /* 143259 */ // Label 2521: @143259
     /* 143259 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(144276),
     /* 143264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 143270 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(143325), // Rule ID 7342 //
     /* 143275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143292 */     // MIs[0] Rn
     /* 143292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143308 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 143311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143323 */     GIR_RootConstrainSelectedInstOperands,
     /* 143324 */     // GIR_Coverage, 7342,
     /* 143324 */     GIR_EraseRootFromParent_Done,
     /* 143325 */   // Label 2525: @143325
     /* 143325 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(143380), // Rule ID 7343 //
     /* 143330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143347 */     // MIs[0] Rn
     /* 143347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143363 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 143366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143378 */     GIR_RootConstrainSelectedInstOperands,
     /* 143379 */     // GIR_Coverage, 7343,
     /* 143379 */     GIR_EraseRootFromParent_Done,
     /* 143380 */   // Label 2526: @143380
     /* 143380 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(143435), // Rule ID 7344 //
     /* 143385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143388 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143402 */     // MIs[0] Rn
     /* 143402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143418 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 143421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143433 */     GIR_RootConstrainSelectedInstOperands,
     /* 143434 */     // GIR_Coverage, 7344,
     /* 143434 */     GIR_EraseRootFromParent_Done,
     /* 143435 */   // Label 2527: @143435
     /* 143435 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(143490), // Rule ID 7345 //
     /* 143440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 143453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143457 */     // MIs[0] Rn
     /* 143457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143473 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 143476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143488 */     GIR_RootConstrainSelectedInstOperands,
     /* 143489 */     // GIR_Coverage, 7345,
     /* 143489 */     GIR_EraseRootFromParent_Done,
     /* 143490 */   // Label 2528: @143490
     /* 143490 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(143545), // Rule ID 7346 //
     /* 143495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 143508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143512 */     // MIs[0] Rn
     /* 143512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143528 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 143531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143543 */     GIR_RootConstrainSelectedInstOperands,
     /* 143544 */     // GIR_Coverage, 7346,
     /* 143544 */     GIR_EraseRootFromParent_Done,
     /* 143545 */   // Label 2529: @143545
     /* 143545 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(143600), // Rule ID 7347 //
     /* 143550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143553 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143560 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143567 */     // MIs[0] Rn
     /* 143567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143583 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 143586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143598 */     GIR_RootConstrainSelectedInstOperands,
     /* 143599 */     // GIR_Coverage, 7347,
     /* 143599 */     GIR_EraseRootFromParent_Done,
     /* 143600 */   // Label 2530: @143600
     /* 143600 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(143655), // Rule ID 7348 //
     /* 143605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143622 */     // MIs[0] Rn
     /* 143622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143638 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 143641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143653 */     GIR_RootConstrainSelectedInstOperands,
     /* 143654 */     // GIR_Coverage, 7348,
     /* 143654 */     GIR_EraseRootFromParent_Done,
     /* 143655 */   // Label 2531: @143655
     /* 143655 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(143710), // Rule ID 7349 //
     /* 143660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143677 */     // MIs[0] Rn
     /* 143677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143693 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 143696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143708 */     GIR_RootConstrainSelectedInstOperands,
     /* 143709 */     // GIR_Coverage, 7349,
     /* 143709 */     GIR_EraseRootFromParent_Done,
     /* 143710 */   // Label 2532: @143710
     /* 143710 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(143765), // Rule ID 7350 //
     /* 143715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143718 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 143728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143732 */     // MIs[0] Rn
     /* 143732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143748 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 143751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143763 */     GIR_RootConstrainSelectedInstOperands,
     /* 143764 */     // GIR_Coverage, 7350,
     /* 143764 */     GIR_EraseRootFromParent_Done,
     /* 143765 */   // Label 2533: @143765
     /* 143765 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(143820), // Rule ID 7351 //
     /* 143770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 143783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143787 */     // MIs[0] Rn
     /* 143787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143803 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 143806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143818 */     GIR_RootConstrainSelectedInstOperands,
     /* 143819 */     // GIR_Coverage, 7351,
     /* 143819 */     GIR_EraseRootFromParent_Done,
     /* 143820 */   // Label 2534: @143820
     /* 143820 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(143875), // Rule ID 7352 //
     /* 143825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143842 */     // MIs[0] Rn
     /* 143842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143858 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 143861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143873 */     GIR_RootConstrainSelectedInstOperands,
     /* 143874 */     // GIR_Coverage, 7352,
     /* 143874 */     GIR_EraseRootFromParent_Done,
     /* 143875 */   // Label 2535: @143875
     /* 143875 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(143930), // Rule ID 7353 //
     /* 143880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143897 */     // MIs[0] Rn
     /* 143897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143913 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 143916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143928 */     GIR_RootConstrainSelectedInstOperands,
     /* 143929 */     // GIR_Coverage, 7353,
     /* 143929 */     GIR_EraseRootFromParent_Done,
     /* 143930 */   // Label 2536: @143930
     /* 143930 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(143985), // Rule ID 7354 //
     /* 143935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143938 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143945 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143952 */     // MIs[0] Rn
     /* 143952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143968 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 143971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143983 */     GIR_RootConstrainSelectedInstOperands,
     /* 143984 */     // GIR_Coverage, 7354,
     /* 143984 */     GIR_EraseRootFromParent_Done,
     /* 143985 */   // Label 2537: @143985
     /* 143985 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(144040), // Rule ID 7355 //
     /* 143990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144007 */     // MIs[0] Rn
     /* 144007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144023 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 144026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144038 */     GIR_RootConstrainSelectedInstOperands,
     /* 144039 */     // GIR_Coverage, 7355,
     /* 144039 */     GIR_EraseRootFromParent_Done,
     /* 144040 */   // Label 2538: @144040
     /* 144040 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(144095), // Rule ID 7356 //
     /* 144045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144062 */     // MIs[0] Rn
     /* 144062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144078 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 144081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144093 */     GIR_RootConstrainSelectedInstOperands,
     /* 144094 */     // GIR_Coverage, 7356,
     /* 144094 */     GIR_EraseRootFromParent_Done,
     /* 144095 */   // Label 2539: @144095
     /* 144095 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(144155), // Rule ID 13193 //
     /* 144100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144114 */     // MIs[0] addr
     /* 144114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144130 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 144136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144138 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144143 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144145 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144147 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144153 */     GIR_RootConstrainSelectedInstOperands,
     /* 144154 */     // GIR_Coverage, 13193,
     /* 144154 */     GIR_EraseRootFromParent_Done,
     /* 144155 */   // Label 2540: @144155
     /* 144155 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(144215), // Rule ID 13194 //
     /* 144160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144174 */     // MIs[0] addr
     /* 144174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144190 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 144196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144198 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144203 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144205 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144207 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144213 */     GIR_RootConstrainSelectedInstOperands,
     /* 144214 */     // GIR_Coverage, 13194,
     /* 144214 */     GIR_EraseRootFromParent_Done,
     /* 144215 */   // Label 2541: @144215
     /* 144215 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(144275), // Rule ID 13195 //
     /* 144220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144234 */     // MIs[0] addr
     /* 144234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144250 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 144256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144258 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144263 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144265 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144267 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144273 */     GIR_RootConstrainSelectedInstOperands,
     /* 144274 */     // GIR_Coverage, 13195,
     /* 144274 */     GIR_EraseRootFromParent_Done,
     /* 144275 */   // Label 2542: @144275
     /* 144275 */   GIM_Reject,
     /* 144276 */ // Label 2524: @144276
     /* 144276 */ GIM_Reject,
     /* 144277 */ // Label 2522: @144277
     /* 144277 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(144589),
     /* 144282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 144288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 144295 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(144343), // Rule ID 2582 //
     /* 144300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144303 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144310 */     // MIs[0] Rn
     /* 144310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144326 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 144329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144341 */     GIR_RootConstrainSelectedInstOperands,
     /* 144342 */     // GIR_Coverage, 2582,
     /* 144342 */     GIR_EraseRootFromParent_Done,
     /* 144343 */   // Label 2544: @144343
     /* 144343 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(144391), // Rule ID 2583 //
     /* 144348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144358 */     // MIs[0] Rn
     /* 144358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144374 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 144377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144389 */     GIR_RootConstrainSelectedInstOperands,
     /* 144390 */     // GIR_Coverage, 2583,
     /* 144390 */     GIR_EraseRootFromParent_Done,
     /* 144391 */   // Label 2545: @144391
     /* 144391 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(144439), // Rule ID 2584 //
     /* 144396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144406 */     // MIs[0] Rn
     /* 144406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144422 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 144425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144437 */     GIR_RootConstrainSelectedInstOperands,
     /* 144438 */     // GIR_Coverage, 2584,
     /* 144438 */     GIR_EraseRootFromParent_Done,
     /* 144439 */   // Label 2546: @144439
     /* 144439 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(144487), // Rule ID 2585 //
     /* 144444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144454 */     // MIs[0] Rn
     /* 144454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144470 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 144473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144485 */     GIR_RootConstrainSelectedInstOperands,
     /* 144486 */     // GIR_Coverage, 2585,
     /* 144486 */     GIR_EraseRootFromParent_Done,
     /* 144487 */   // Label 2547: @144487
     /* 144487 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(144535), // Rule ID 2586 //
     /* 144492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144495 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144502 */     // MIs[0] Rn
     /* 144502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144518 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 144521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144533 */     GIR_RootConstrainSelectedInstOperands,
     /* 144534 */     // GIR_Coverage, 2586,
     /* 144534 */     GIR_EraseRootFromParent_Done,
     /* 144535 */   // Label 2548: @144535
     /* 144535 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(144588), // Rule ID 13196 //
     /* 144540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144547 */     // MIs[0] addr
     /* 144547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144563 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 144563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 144569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144571 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144576 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144578 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144580 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144586 */     GIR_RootConstrainSelectedInstOperands,
     /* 144587 */     // GIR_Coverage, 13196,
     /* 144587 */     GIR_EraseRootFromParent_Done,
     /* 144588 */   // Label 2549: @144588
     /* 144588 */   GIM_Reject,
     /* 144589 */ // Label 2543: @144589
     /* 144589 */ GIM_Reject,
     /* 144590 */ // Label 2523: @144590
     /* 144590 */ GIM_Reject,
     /* 144591 */ // Label 21: @144591
     /* 144591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2552*/ GIMT_Encode4(145582),
     /* 144602 */ /*GILLT_s32*//*Label 2550*/ GIMT_Encode4(144610),
     /* 144606 */ /*GILLT_s64*//*Label 2551*/ GIMT_Encode4(145355),
     /* 144610 */ // Label 2550: @144610
     /* 144610 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(145354),
     /* 144615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144618 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(144667), // Rule ID 7327 //
     /* 144623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144626 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144640 */     // MIs[0] Rn
     /* 144640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144652 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 144655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144665 */     GIR_RootConstrainSelectedInstOperands,
     /* 144666 */     // GIR_Coverage, 7327,
     /* 144666 */     GIR_EraseRootFromParent_Done,
     /* 144667 */   // Label 2554: @144667
     /* 144667 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(144716), // Rule ID 7328 //
     /* 144672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144675 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144682 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144689 */     // MIs[0] Rn
     /* 144689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144701 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 144704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144714 */     GIR_RootConstrainSelectedInstOperands,
     /* 144715 */     // GIR_Coverage, 7328,
     /* 144715 */     GIR_EraseRootFromParent_Done,
     /* 144716 */   // Label 2555: @144716
     /* 144716 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(144765), // Rule ID 7329 //
     /* 144721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144724 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144731 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144738 */     // MIs[0] Rn
     /* 144738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144750 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 144753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144763 */     GIR_RootConstrainSelectedInstOperands,
     /* 144764 */     // GIR_Coverage, 7329,
     /* 144764 */     GIR_EraseRootFromParent_Done,
     /* 144765 */   // Label 2556: @144765
     /* 144765 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(144814), // Rule ID 7330 //
     /* 144770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144787 */     // MIs[0] Rn
     /* 144787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144799 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 144802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144812 */     GIR_RootConstrainSelectedInstOperands,
     /* 144813 */     // GIR_Coverage, 7330,
     /* 144813 */     GIR_EraseRootFromParent_Done,
     /* 144814 */   // Label 2557: @144814
     /* 144814 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(144863), // Rule ID 7331 //
     /* 144819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144822 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144829 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144836 */     // MIs[0] Rn
     /* 144836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144848 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 144851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144861 */     GIR_RootConstrainSelectedInstOperands,
     /* 144862 */     // GIR_Coverage, 7331,
     /* 144862 */     GIR_EraseRootFromParent_Done,
     /* 144863 */   // Label 2558: @144863
     /* 144863 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(144912), // Rule ID 7332 //
     /* 144868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144885 */     // MIs[0] Rn
     /* 144885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144897 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 144900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144910 */     GIR_RootConstrainSelectedInstOperands,
     /* 144911 */     // GIR_Coverage, 7332,
     /* 144911 */     GIR_EraseRootFromParent_Done,
     /* 144912 */   // Label 2559: @144912
     /* 144912 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(144961), // Rule ID 7333 //
     /* 144917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144934 */     // MIs[0] Rn
     /* 144934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144946 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 144949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144959 */     GIR_RootConstrainSelectedInstOperands,
     /* 144960 */     // GIR_Coverage, 7333,
     /* 144960 */     GIR_EraseRootFromParent_Done,
     /* 144961 */   // Label 2560: @144961
     /* 144961 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(145010), // Rule ID 7334 //
     /* 144966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144983 */     // MIs[0] Rn
     /* 144983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144995 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 144998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145008 */     GIR_RootConstrainSelectedInstOperands,
     /* 145009 */     // GIR_Coverage, 7334,
     /* 145009 */     GIR_EraseRootFromParent_Done,
     /* 145010 */   // Label 2561: @145010
     /* 145010 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(145059), // Rule ID 7335 //
     /* 145015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145032 */     // MIs[0] Rn
     /* 145032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145044 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 145047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145057 */     GIR_RootConstrainSelectedInstOperands,
     /* 145058 */     // GIR_Coverage, 7335,
     /* 145058 */     GIR_EraseRootFromParent_Done,
     /* 145059 */   // Label 2562: @145059
     /* 145059 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(145108), // Rule ID 7336 //
     /* 145064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145081 */     // MIs[0] Rn
     /* 145081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145093 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 145096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145106 */     GIR_RootConstrainSelectedInstOperands,
     /* 145107 */     // GIR_Coverage, 7336,
     /* 145107 */     GIR_EraseRootFromParent_Done,
     /* 145108 */   // Label 2563: @145108
     /* 145108 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(145157), // Rule ID 7337 //
     /* 145113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145130 */     // MIs[0] Rn
     /* 145130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145142 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 145145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145155 */     GIR_RootConstrainSelectedInstOperands,
     /* 145156 */     // GIR_Coverage, 7337,
     /* 145156 */     GIR_EraseRootFromParent_Done,
     /* 145157 */   // Label 2564: @145157
     /* 145157 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(145206), // Rule ID 7338 //
     /* 145162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145165 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145179 */     // MIs[0] Rn
     /* 145179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145191 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 145194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145204 */     GIR_RootConstrainSelectedInstOperands,
     /* 145205 */     // GIR_Coverage, 7338,
     /* 145205 */     GIR_EraseRootFromParent_Done,
     /* 145206 */   // Label 2565: @145206
     /* 145206 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(145255), // Rule ID 7339 //
     /* 145211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145214 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145228 */     // MIs[0] Rn
     /* 145228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145240 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 145243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145253 */     GIR_RootConstrainSelectedInstOperands,
     /* 145254 */     // GIR_Coverage, 7339,
     /* 145254 */     GIR_EraseRootFromParent_Done,
     /* 145255 */   // Label 2566: @145255
     /* 145255 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(145304), // Rule ID 7340 //
     /* 145260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145277 */     // MIs[0] Rn
     /* 145277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145289 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 145292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145302 */     GIR_RootConstrainSelectedInstOperands,
     /* 145303 */     // GIR_Coverage, 7340,
     /* 145303 */     GIR_EraseRootFromParent_Done,
     /* 145304 */   // Label 2567: @145304
     /* 145304 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(145353), // Rule ID 7341 //
     /* 145309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145326 */     // MIs[0] Rn
     /* 145326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145338 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 145341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145351 */     GIR_RootConstrainSelectedInstOperands,
     /* 145352 */     // GIR_Coverage, 7341,
     /* 145352 */     GIR_EraseRootFromParent_Done,
     /* 145353 */   // Label 2568: @145353
     /* 145353 */   GIM_Reject,
     /* 145354 */ // Label 2553: @145354
     /* 145354 */ GIM_Reject,
     /* 145355 */ // Label 2551: @145355
     /* 145355 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(145581),
     /* 145360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145363 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 145370 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(145412), // Rule ID 7322 //
     /* 145375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145385 */     // MIs[0] Rn
     /* 145385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145397 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 145400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145410 */     GIR_RootConstrainSelectedInstOperands,
     /* 145411 */     // GIR_Coverage, 7322,
     /* 145411 */     GIR_EraseRootFromParent_Done,
     /* 145412 */   // Label 2570: @145412
     /* 145412 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(145454), // Rule ID 7323 //
     /* 145417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145427 */     // MIs[0] Rn
     /* 145427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145439 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 145442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145452 */     GIR_RootConstrainSelectedInstOperands,
     /* 145453 */     // GIR_Coverage, 7323,
     /* 145453 */     GIR_EraseRootFromParent_Done,
     /* 145454 */   // Label 2571: @145454
     /* 145454 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(145496), // Rule ID 7324 //
     /* 145459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145462 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145469 */     // MIs[0] Rn
     /* 145469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145481 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 145484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145494 */     GIR_RootConstrainSelectedInstOperands,
     /* 145495 */     // GIR_Coverage, 7324,
     /* 145495 */     GIR_EraseRootFromParent_Done,
     /* 145496 */   // Label 2572: @145496
     /* 145496 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(145538), // Rule ID 7325 //
     /* 145501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145511 */     // MIs[0] Rn
     /* 145511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145523 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 145526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145536 */     GIR_RootConstrainSelectedInstOperands,
     /* 145537 */     // GIR_Coverage, 7325,
     /* 145537 */     GIR_EraseRootFromParent_Done,
     /* 145538 */   // Label 2573: @145538
     /* 145538 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(145580), // Rule ID 7326 //
     /* 145543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145553 */     // MIs[0] Rn
     /* 145553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145565 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 145568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145578 */     GIR_RootConstrainSelectedInstOperands,
     /* 145579 */     // GIR_Coverage, 7326,
     /* 145579 */     GIR_EraseRootFromParent_Done,
     /* 145580 */   // Label 2574: @145580
     /* 145580 */   GIM_Reject,
     /* 145581 */ // Label 2569: @145581
     /* 145581 */ GIM_Reject,
     /* 145582 */ // Label 2552: @145582
     /* 145582 */ GIM_Reject,
     /* 145583 */ // Label 22: @145583
     /* 145583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2577*/ GIMT_Encode4(146574),
     /* 145594 */ /*GILLT_s32*//*Label 2575*/ GIMT_Encode4(145602),
     /* 145598 */ /*GILLT_s64*//*Label 2576*/ GIMT_Encode4(146347),
     /* 145602 */ // Label 2575: @145602
     /* 145602 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(146346),
     /* 145607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145610 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(145659), // Rule ID 7167 //
     /* 145615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145632 */     // MIs[0] Rn
     /* 145632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145644 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 145647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145657 */     GIR_RootConstrainSelectedInstOperands,
     /* 145658 */     // GIR_Coverage, 7167,
     /* 145658 */     GIR_EraseRootFromParent_Done,
     /* 145659 */   // Label 2579: @145659
     /* 145659 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(145708), // Rule ID 7168 //
     /* 145664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145667 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145674 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145681 */     // MIs[0] Rn
     /* 145681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145693 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 145696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145706 */     GIR_RootConstrainSelectedInstOperands,
     /* 145707 */     // GIR_Coverage, 7168,
     /* 145707 */     GIR_EraseRootFromParent_Done,
     /* 145708 */   // Label 2580: @145708
     /* 145708 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(145757), // Rule ID 7169 //
     /* 145713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145723 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145730 */     // MIs[0] Rn
     /* 145730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145742 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 145745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145755 */     GIR_RootConstrainSelectedInstOperands,
     /* 145756 */     // GIR_Coverage, 7169,
     /* 145756 */     GIR_EraseRootFromParent_Done,
     /* 145757 */   // Label 2581: @145757
     /* 145757 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(145806), // Rule ID 7170 //
     /* 145762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145765 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145779 */     // MIs[0] Rn
     /* 145779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145791 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 145794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145804 */     GIR_RootConstrainSelectedInstOperands,
     /* 145805 */     // GIR_Coverage, 7170,
     /* 145805 */     GIR_EraseRootFromParent_Done,
     /* 145806 */   // Label 2582: @145806
     /* 145806 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(145855), // Rule ID 7171 //
     /* 145811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145814 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145821 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145828 */     // MIs[0] Rn
     /* 145828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145840 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 145843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145853 */     GIR_RootConstrainSelectedInstOperands,
     /* 145854 */     // GIR_Coverage, 7171,
     /* 145854 */     GIR_EraseRootFromParent_Done,
     /* 145855 */   // Label 2583: @145855
     /* 145855 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(145904), // Rule ID 7172 //
     /* 145860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145877 */     // MIs[0] Rn
     /* 145877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145889 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 145892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145902 */     GIR_RootConstrainSelectedInstOperands,
     /* 145903 */     // GIR_Coverage, 7172,
     /* 145903 */     GIR_EraseRootFromParent_Done,
     /* 145904 */   // Label 2584: @145904
     /* 145904 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(145953), // Rule ID 7173 //
     /* 145909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145926 */     // MIs[0] Rn
     /* 145926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145938 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 145941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145951 */     GIR_RootConstrainSelectedInstOperands,
     /* 145952 */     // GIR_Coverage, 7173,
     /* 145952 */     GIR_EraseRootFromParent_Done,
     /* 145953 */   // Label 2585: @145953
     /* 145953 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(146002), // Rule ID 7174 //
     /* 145958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145975 */     // MIs[0] Rn
     /* 145975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145987 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 145990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146000 */     GIR_RootConstrainSelectedInstOperands,
     /* 146001 */     // GIR_Coverage, 7174,
     /* 146001 */     GIR_EraseRootFromParent_Done,
     /* 146002 */   // Label 2586: @146002
     /* 146002 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(146051), // Rule ID 7175 //
     /* 146007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146024 */     // MIs[0] Rn
     /* 146024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146036 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 146039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146049 */     GIR_RootConstrainSelectedInstOperands,
     /* 146050 */     // GIR_Coverage, 7175,
     /* 146050 */     GIR_EraseRootFromParent_Done,
     /* 146051 */   // Label 2587: @146051
     /* 146051 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(146100), // Rule ID 7176 //
     /* 146056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146073 */     // MIs[0] Rn
     /* 146073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146085 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 146088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146098 */     GIR_RootConstrainSelectedInstOperands,
     /* 146099 */     // GIR_Coverage, 7176,
     /* 146099 */     GIR_EraseRootFromParent_Done,
     /* 146100 */   // Label 2588: @146100
     /* 146100 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(146149), // Rule ID 7177 //
     /* 146105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146122 */     // MIs[0] Rn
     /* 146122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146134 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 146137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146147 */     GIR_RootConstrainSelectedInstOperands,
     /* 146148 */     // GIR_Coverage, 7177,
     /* 146148 */     GIR_EraseRootFromParent_Done,
     /* 146149 */   // Label 2589: @146149
     /* 146149 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(146198), // Rule ID 7178 //
     /* 146154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146171 */     // MIs[0] Rn
     /* 146171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146183 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 146186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146196 */     GIR_RootConstrainSelectedInstOperands,
     /* 146197 */     // GIR_Coverage, 7178,
     /* 146197 */     GIR_EraseRootFromParent_Done,
     /* 146198 */   // Label 2590: @146198
     /* 146198 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(146247), // Rule ID 7179 //
     /* 146203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146220 */     // MIs[0] Rn
     /* 146220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146232 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 146235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146245 */     GIR_RootConstrainSelectedInstOperands,
     /* 146246 */     // GIR_Coverage, 7179,
     /* 146246 */     GIR_EraseRootFromParent_Done,
     /* 146247 */   // Label 2591: @146247
     /* 146247 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(146296), // Rule ID 7180 //
     /* 146252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146269 */     // MIs[0] Rn
     /* 146269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146281 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 146284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146294 */     GIR_RootConstrainSelectedInstOperands,
     /* 146295 */     // GIR_Coverage, 7180,
     /* 146295 */     GIR_EraseRootFromParent_Done,
     /* 146296 */   // Label 2592: @146296
     /* 146296 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(146345), // Rule ID 7181 //
     /* 146301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146304 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146318 */     // MIs[0] Rn
     /* 146318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146330 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 146333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146343 */     GIR_RootConstrainSelectedInstOperands,
     /* 146344 */     // GIR_Coverage, 7181,
     /* 146344 */     GIR_EraseRootFromParent_Done,
     /* 146345 */   // Label 2593: @146345
     /* 146345 */   GIM_Reject,
     /* 146346 */ // Label 2578: @146346
     /* 146346 */ GIM_Reject,
     /* 146347 */ // Label 2576: @146347
     /* 146347 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(146573),
     /* 146352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146355 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 146362 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(146404), // Rule ID 2572 //
     /* 146367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146377 */     // MIs[0] Rn
     /* 146377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146389 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 146392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146402 */     GIR_RootConstrainSelectedInstOperands,
     /* 146403 */     // GIR_Coverage, 2572,
     /* 146403 */     GIR_EraseRootFromParent_Done,
     /* 146404 */   // Label 2595: @146404
     /* 146404 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(146446), // Rule ID 2573 //
     /* 146409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146412 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146419 */     // MIs[0] Rn
     /* 146419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146431 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 146434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146444 */     GIR_RootConstrainSelectedInstOperands,
     /* 146445 */     // GIR_Coverage, 2573,
     /* 146445 */     GIR_EraseRootFromParent_Done,
     /* 146446 */   // Label 2596: @146446
     /* 146446 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(146488), // Rule ID 2574 //
     /* 146451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146461 */     // MIs[0] Rn
     /* 146461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146473 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 146476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146486 */     GIR_RootConstrainSelectedInstOperands,
     /* 146487 */     // GIR_Coverage, 2574,
     /* 146487 */     GIR_EraseRootFromParent_Done,
     /* 146488 */   // Label 2597: @146488
     /* 146488 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(146530), // Rule ID 2575 //
     /* 146493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146496 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146503 */     // MIs[0] Rn
     /* 146503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146515 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 146518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146528 */     GIR_RootConstrainSelectedInstOperands,
     /* 146529 */     // GIR_Coverage, 2575,
     /* 146529 */     GIR_EraseRootFromParent_Done,
     /* 146530 */   // Label 2598: @146530
     /* 146530 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(146572), // Rule ID 2576 //
     /* 146535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146545 */     // MIs[0] Rn
     /* 146545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146557 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 146560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146570 */     GIR_RootConstrainSelectedInstOperands,
     /* 146571 */     // GIR_Coverage, 2576,
     /* 146571 */     GIR_EraseRootFromParent_Done,
     /* 146572 */   // Label 2599: @146572
     /* 146572 */   GIM_Reject,
     /* 146573 */ // Label 2594: @146573
     /* 146573 */ GIM_Reject,
     /* 146574 */ // Label 2577: @146574
     /* 146574 */ GIM_Reject,
     /* 146575 */ // Label 23: @146575
     /* 146575 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2602*/ GIMT_Encode4(148066),
     /* 146586 */ /*GILLT_s32*//*Label 2600*/ GIMT_Encode4(146594),
     /* 146590 */ /*GILLT_s64*//*Label 2601*/ GIMT_Encode4(147714),
     /* 146594 */ // Label 2600: @146594
     /* 146594 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(147713),
     /* 146599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146602 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(146676), // Rule ID 7362 //
     /* 146607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146624 */     // MIs[0] Rn
     /* 146624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146636 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146648 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 146663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146674 */     GIR_RootConstrainSelectedInstOperands,
     /* 146675 */     // GIR_Coverage, 7362,
     /* 146675 */     GIR_EraseRootFromParent_Done,
     /* 146676 */   // Label 2604: @146676
     /* 146676 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(146750), // Rule ID 7363 //
     /* 146681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146691 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146698 */     // MIs[0] Rn
     /* 146698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146710 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146722 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 146737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146748 */     GIR_RootConstrainSelectedInstOperands,
     /* 146749 */     // GIR_Coverage, 7363,
     /* 146749 */     GIR_EraseRootFromParent_Done,
     /* 146750 */   // Label 2605: @146750
     /* 146750 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(146824), // Rule ID 7364 //
     /* 146755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146772 */     // MIs[0] Rn
     /* 146772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146784 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146796 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 146811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146822 */     GIR_RootConstrainSelectedInstOperands,
     /* 146823 */     // GIR_Coverage, 7364,
     /* 146823 */     GIR_EraseRootFromParent_Done,
     /* 146824 */   // Label 2606: @146824
     /* 146824 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(146898), // Rule ID 7365 //
     /* 146829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146832 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146839 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146846 */     // MIs[0] Rn
     /* 146846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146858 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146870 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 146885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146896 */     GIR_RootConstrainSelectedInstOperands,
     /* 146897 */     // GIR_Coverage, 7365,
     /* 146897 */     GIR_EraseRootFromParent_Done,
     /* 146898 */   // Label 2607: @146898
     /* 146898 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(146972), // Rule ID 7366 //
     /* 146903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146913 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146920 */     // MIs[0] Rn
     /* 146920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146932 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146944 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 146959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146970 */     GIR_RootConstrainSelectedInstOperands,
     /* 146971 */     // GIR_Coverage, 7366,
     /* 146971 */     GIR_EraseRootFromParent_Done,
     /* 146972 */   // Label 2608: @146972
     /* 146972 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(147046), // Rule ID 7367 //
     /* 146977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146994 */     // MIs[0] Rn
     /* 146994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147006 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147018 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 147033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147044 */     GIR_RootConstrainSelectedInstOperands,
     /* 147045 */     // GIR_Coverage, 7367,
     /* 147045 */     GIR_EraseRootFromParent_Done,
     /* 147046 */   // Label 2609: @147046
     /* 147046 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(147120), // Rule ID 7368 //
     /* 147051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147068 */     // MIs[0] Rn
     /* 147068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147080 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147092 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 147107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147118 */     GIR_RootConstrainSelectedInstOperands,
     /* 147119 */     // GIR_Coverage, 7368,
     /* 147119 */     GIR_EraseRootFromParent_Done,
     /* 147120 */   // Label 2610: @147120
     /* 147120 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(147194), // Rule ID 7369 //
     /* 147125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147142 */     // MIs[0] Rn
     /* 147142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147154 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147166 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 147181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147192 */     GIR_RootConstrainSelectedInstOperands,
     /* 147193 */     // GIR_Coverage, 7369,
     /* 147193 */     GIR_EraseRootFromParent_Done,
     /* 147194 */   // Label 2611: @147194
     /* 147194 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(147268), // Rule ID 7370 //
     /* 147199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147202 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147209 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147216 */     // MIs[0] Rn
     /* 147216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147228 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147240 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147266 */     GIR_RootConstrainSelectedInstOperands,
     /* 147267 */     // GIR_Coverage, 7370,
     /* 147267 */     GIR_EraseRootFromParent_Done,
     /* 147268 */   // Label 2612: @147268
     /* 147268 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(147342), // Rule ID 7371 //
     /* 147273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147290 */     // MIs[0] Rn
     /* 147290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147302 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147314 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147340 */     GIR_RootConstrainSelectedInstOperands,
     /* 147341 */     // GIR_Coverage, 7371,
     /* 147341 */     GIR_EraseRootFromParent_Done,
     /* 147342 */   // Label 2613: @147342
     /* 147342 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(147416), // Rule ID 7372 //
     /* 147347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147364 */     // MIs[0] Rn
     /* 147364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147376 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147388 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 147403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147414 */     GIR_RootConstrainSelectedInstOperands,
     /* 147415 */     // GIR_Coverage, 7372,
     /* 147415 */     GIR_EraseRootFromParent_Done,
     /* 147416 */   // Label 2614: @147416
     /* 147416 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(147490), // Rule ID 7373 //
     /* 147421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147424 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147438 */     // MIs[0] Rn
     /* 147438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147450 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147462 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 147477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147488 */     GIR_RootConstrainSelectedInstOperands,
     /* 147489 */     // GIR_Coverage, 7373,
     /* 147489 */     GIR_EraseRootFromParent_Done,
     /* 147490 */   // Label 2615: @147490
     /* 147490 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(147564), // Rule ID 7374 //
     /* 147495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147512 */     // MIs[0] Rn
     /* 147512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147524 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147536 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 147551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147562 */     GIR_RootConstrainSelectedInstOperands,
     /* 147563 */     // GIR_Coverage, 7374,
     /* 147563 */     GIR_EraseRootFromParent_Done,
     /* 147564 */   // Label 2616: @147564
     /* 147564 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(147638), // Rule ID 7375 //
     /* 147569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147572 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147579 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147586 */     // MIs[0] Rn
     /* 147586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147598 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147610 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147636 */     GIR_RootConstrainSelectedInstOperands,
     /* 147637 */     // GIR_Coverage, 7375,
     /* 147637 */     GIR_EraseRootFromParent_Done,
     /* 147638 */   // Label 2617: @147638
     /* 147638 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(147712), // Rule ID 7376 //
     /* 147643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147660 */     // MIs[0] Rn
     /* 147660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147672 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147684 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147710 */     GIR_RootConstrainSelectedInstOperands,
     /* 147711 */     // GIR_Coverage, 7376,
     /* 147711 */     GIR_EraseRootFromParent_Done,
     /* 147712 */   // Label 2618: @147712
     /* 147712 */   GIM_Reject,
     /* 147713 */ // Label 2603: @147713
     /* 147713 */ GIM_Reject,
     /* 147714 */ // Label 2601: @147714
     /* 147714 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(148065),
     /* 147719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 147729 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(147796), // Rule ID 7357 //
     /* 147734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147744 */     // MIs[0] Rn
     /* 147744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147756 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147768 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 147783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147794 */     GIR_RootConstrainSelectedInstOperands,
     /* 147795 */     // GIR_Coverage, 7357,
     /* 147795 */     GIR_EraseRootFromParent_Done,
     /* 147796 */   // Label 2620: @147796
     /* 147796 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(147863), // Rule ID 7358 //
     /* 147801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147811 */     // MIs[0] Rn
     /* 147811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147823 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147835 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 147850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147861 */     GIR_RootConstrainSelectedInstOperands,
     /* 147862 */     // GIR_Coverage, 7358,
     /* 147862 */     GIR_EraseRootFromParent_Done,
     /* 147863 */   // Label 2621: @147863
     /* 147863 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(147930), // Rule ID 7359 //
     /* 147868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147878 */     // MIs[0] Rn
     /* 147878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147890 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147902 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 147917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147928 */     GIR_RootConstrainSelectedInstOperands,
     /* 147929 */     // GIR_Coverage, 7359,
     /* 147929 */     GIR_EraseRootFromParent_Done,
     /* 147930 */   // Label 2622: @147930
     /* 147930 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(147997), // Rule ID 7360 //
     /* 147935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147938 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147945 */     // MIs[0] Rn
     /* 147945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147957 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147969 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 147984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147995 */     GIR_RootConstrainSelectedInstOperands,
     /* 147996 */     // GIR_Coverage, 7360,
     /* 147996 */     GIR_EraseRootFromParent_Done,
     /* 147997 */   // Label 2623: @147997
     /* 147997 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(148064), // Rule ID 7361 //
     /* 148002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148005 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148012 */     // MIs[0] Rn
     /* 148012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148024 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 148027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 148031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148036 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 148051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148062 */     GIR_RootConstrainSelectedInstOperands,
     /* 148063 */     // GIR_Coverage, 7361,
     /* 148063 */     GIR_EraseRootFromParent_Done,
     /* 148064 */   // Label 2624: @148064
     /* 148064 */   GIM_Reject,
     /* 148065 */ // Label 2619: @148065
     /* 148065 */ GIM_Reject,
     /* 148066 */ // Label 2602: @148066
     /* 148066 */ GIM_Reject,
     /* 148067 */ // Label 24: @148067
     /* 148067 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2627*/ GIMT_Encode4(149558),
     /* 148078 */ /*GILLT_s32*//*Label 2625*/ GIMT_Encode4(148086),
     /* 148082 */ /*GILLT_s64*//*Label 2626*/ GIMT_Encode4(149206),
     /* 148086 */ // Label 2625: @148086
     /* 148086 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(149205),
     /* 148091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148094 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(148168), // Rule ID 7382 //
     /* 148099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148102 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148109 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148116 */     // MIs[0] Rn
     /* 148116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148128 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148140 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 148155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148166 */     GIR_RootConstrainSelectedInstOperands,
     /* 148167 */     // GIR_Coverage, 7382,
     /* 148167 */     GIR_EraseRootFromParent_Done,
     /* 148168 */   // Label 2629: @148168
     /* 148168 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(148242), // Rule ID 7383 //
     /* 148173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148176 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148183 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148190 */     // MIs[0] Rn
     /* 148190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148202 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148214 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 148229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148240 */     GIR_RootConstrainSelectedInstOperands,
     /* 148241 */     // GIR_Coverage, 7383,
     /* 148241 */     GIR_EraseRootFromParent_Done,
     /* 148242 */   // Label 2630: @148242
     /* 148242 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(148316), // Rule ID 7384 //
     /* 148247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148250 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148264 */     // MIs[0] Rn
     /* 148264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148276 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148288 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 148303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148314 */     GIR_RootConstrainSelectedInstOperands,
     /* 148315 */     // GIR_Coverage, 7384,
     /* 148315 */     GIR_EraseRootFromParent_Done,
     /* 148316 */   // Label 2631: @148316
     /* 148316 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(148390), // Rule ID 7385 //
     /* 148321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148324 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148338 */     // MIs[0] Rn
     /* 148338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148350 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148362 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 148377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148388 */     GIR_RootConstrainSelectedInstOperands,
     /* 148389 */     // GIR_Coverage, 7385,
     /* 148389 */     GIR_EraseRootFromParent_Done,
     /* 148390 */   // Label 2632: @148390
     /* 148390 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(148464), // Rule ID 7386 //
     /* 148395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148405 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148412 */     // MIs[0] Rn
     /* 148412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148424 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148436 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 148451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148462 */     GIR_RootConstrainSelectedInstOperands,
     /* 148463 */     // GIR_Coverage, 7386,
     /* 148463 */     GIR_EraseRootFromParent_Done,
     /* 148464 */   // Label 2633: @148464
     /* 148464 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(148538), // Rule ID 7387 //
     /* 148469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148472 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148486 */     // MIs[0] Rn
     /* 148486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148498 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148510 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 148525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148536 */     GIR_RootConstrainSelectedInstOperands,
     /* 148537 */     // GIR_Coverage, 7387,
     /* 148537 */     GIR_EraseRootFromParent_Done,
     /* 148538 */   // Label 2634: @148538
     /* 148538 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(148612), // Rule ID 7388 //
     /* 148543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148546 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148553 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148560 */     // MIs[0] Rn
     /* 148560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148572 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148584 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 148599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148610 */     GIR_RootConstrainSelectedInstOperands,
     /* 148611 */     // GIR_Coverage, 7388,
     /* 148611 */     GIR_EraseRootFromParent_Done,
     /* 148612 */   // Label 2635: @148612
     /* 148612 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(148686), // Rule ID 7389 //
     /* 148617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148620 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148627 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148634 */     // MIs[0] Rn
     /* 148634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148646 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148658 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148664 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 148673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148684 */     GIR_RootConstrainSelectedInstOperands,
     /* 148685 */     // GIR_Coverage, 7389,
     /* 148685 */     GIR_EraseRootFromParent_Done,
     /* 148686 */   // Label 2636: @148686
     /* 148686 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(148760), // Rule ID 7390 //
     /* 148691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148708 */     // MIs[0] Rn
     /* 148708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148720 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148732 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 148747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148758 */     GIR_RootConstrainSelectedInstOperands,
     /* 148759 */     // GIR_Coverage, 7390,
     /* 148759 */     GIR_EraseRootFromParent_Done,
     /* 148760 */   // Label 2637: @148760
     /* 148760 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(148834), // Rule ID 7391 //
     /* 148765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148782 */     // MIs[0] Rn
     /* 148782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148794 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148806 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 148821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148832 */     GIR_RootConstrainSelectedInstOperands,
     /* 148833 */     // GIR_Coverage, 7391,
     /* 148833 */     GIR_EraseRootFromParent_Done,
     /* 148834 */   // Label 2638: @148834
     /* 148834 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(148908), // Rule ID 7392 //
     /* 148839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148856 */     // MIs[0] Rn
     /* 148856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148868 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148880 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 148895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148906 */     GIR_RootConstrainSelectedInstOperands,
     /* 148907 */     // GIR_Coverage, 7392,
     /* 148907 */     GIR_EraseRootFromParent_Done,
     /* 148908 */   // Label 2639: @148908
     /* 148908 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(148982), // Rule ID 7393 //
     /* 148913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148923 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148930 */     // MIs[0] Rn
     /* 148930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148942 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148954 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 148969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148980 */     GIR_RootConstrainSelectedInstOperands,
     /* 148981 */     // GIR_Coverage, 7393,
     /* 148981 */     GIR_EraseRootFromParent_Done,
     /* 148982 */   // Label 2640: @148982
     /* 148982 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(149056), // Rule ID 7394 //
     /* 148987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148997 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149004 */     // MIs[0] Rn
     /* 149004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149016 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149028 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 149043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149054 */     GIR_RootConstrainSelectedInstOperands,
     /* 149055 */     // GIR_Coverage, 7394,
     /* 149055 */     GIR_EraseRootFromParent_Done,
     /* 149056 */   // Label 2641: @149056
     /* 149056 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(149130), // Rule ID 7395 //
     /* 149061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149078 */     // MIs[0] Rn
     /* 149078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149090 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149102 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 149117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149128 */     GIR_RootConstrainSelectedInstOperands,
     /* 149129 */     // GIR_Coverage, 7395,
     /* 149129 */     GIR_EraseRootFromParent_Done,
     /* 149130 */   // Label 2642: @149130
     /* 149130 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(149204), // Rule ID 7396 //
     /* 149135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149152 */     // MIs[0] Rn
     /* 149152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149164 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149176 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 149191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149202 */     GIR_RootConstrainSelectedInstOperands,
     /* 149203 */     // GIR_Coverage, 7396,
     /* 149203 */     GIR_EraseRootFromParent_Done,
     /* 149204 */   // Label 2643: @149204
     /* 149204 */   GIM_Reject,
     /* 149205 */ // Label 2628: @149205
     /* 149205 */ GIM_Reject,
     /* 149206 */ // Label 2626: @149206
     /* 149206 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(149557),
     /* 149211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149214 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149221 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(149288), // Rule ID 7377 //
     /* 149226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149229 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149236 */     // MIs[0] Rn
     /* 149236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149248 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149260 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 149275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149286 */     GIR_RootConstrainSelectedInstOperands,
     /* 149287 */     // GIR_Coverage, 7377,
     /* 149287 */     GIR_EraseRootFromParent_Done,
     /* 149288 */   // Label 2645: @149288
     /* 149288 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(149355), // Rule ID 7378 //
     /* 149293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149303 */     // MIs[0] Rn
     /* 149303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149315 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149327 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 149342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149353 */     GIR_RootConstrainSelectedInstOperands,
     /* 149354 */     // GIR_Coverage, 7378,
     /* 149354 */     GIR_EraseRootFromParent_Done,
     /* 149355 */   // Label 2646: @149355
     /* 149355 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(149422), // Rule ID 7379 //
     /* 149360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149363 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149370 */     // MIs[0] Rn
     /* 149370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149382 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149394 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 149409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149420 */     GIR_RootConstrainSelectedInstOperands,
     /* 149421 */     // GIR_Coverage, 7379,
     /* 149421 */     GIR_EraseRootFromParent_Done,
     /* 149422 */   // Label 2647: @149422
     /* 149422 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(149489), // Rule ID 7380 //
     /* 149427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149437 */     // MIs[0] Rn
     /* 149437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149449 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149461 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 149476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149487 */     GIR_RootConstrainSelectedInstOperands,
     /* 149488 */     // GIR_Coverage, 7380,
     /* 149488 */     GIR_EraseRootFromParent_Done,
     /* 149489 */   // Label 2648: @149489
     /* 149489 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(149556), // Rule ID 7381 //
     /* 149494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149504 */     // MIs[0] Rn
     /* 149504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149516 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149528 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 149543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149554 */     GIR_RootConstrainSelectedInstOperands,
     /* 149555 */     // GIR_Coverage, 7381,
     /* 149555 */     GIR_EraseRootFromParent_Done,
     /* 149556 */   // Label 2649: @149556
     /* 149556 */   GIM_Reject,
     /* 149557 */ // Label 2644: @149557
     /* 149557 */ GIM_Reject,
     /* 149558 */ // Label 2627: @149558
     /* 149558 */ GIM_Reject,
     /* 149559 */ // Label 25: @149559
     /* 149559 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2652*/ GIMT_Encode4(150550),
     /* 149570 */ /*GILLT_s32*//*Label 2650*/ GIMT_Encode4(149578),
     /* 149574 */ /*GILLT_s64*//*Label 2651*/ GIMT_Encode4(150323),
     /* 149578 */ // Label 2650: @149578
     /* 149578 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(150322),
     /* 149583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149586 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(149635), // Rule ID 7187 //
     /* 149591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149594 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149601 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149608 */     // MIs[0] Rn
     /* 149608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149620 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 149623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149633 */     GIR_RootConstrainSelectedInstOperands,
     /* 149634 */     // GIR_Coverage, 7187,
     /* 149634 */     GIR_EraseRootFromParent_Done,
     /* 149635 */   // Label 2654: @149635
     /* 149635 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(149684), // Rule ID 7188 //
     /* 149640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149657 */     // MIs[0] Rn
     /* 149657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149669 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 149672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149682 */     GIR_RootConstrainSelectedInstOperands,
     /* 149683 */     // GIR_Coverage, 7188,
     /* 149683 */     GIR_EraseRootFromParent_Done,
     /* 149684 */   // Label 2655: @149684
     /* 149684 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(149733), // Rule ID 7189 //
     /* 149689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149692 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149699 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149706 */     // MIs[0] Rn
     /* 149706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149718 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 149721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149731 */     GIR_RootConstrainSelectedInstOperands,
     /* 149732 */     // GIR_Coverage, 7189,
     /* 149732 */     GIR_EraseRootFromParent_Done,
     /* 149733 */   // Label 2656: @149733
     /* 149733 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(149782), // Rule ID 7190 //
     /* 149738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149755 */     // MIs[0] Rn
     /* 149755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149767 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 149770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149780 */     GIR_RootConstrainSelectedInstOperands,
     /* 149781 */     // GIR_Coverage, 7190,
     /* 149781 */     GIR_EraseRootFromParent_Done,
     /* 149782 */   // Label 2657: @149782
     /* 149782 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(149831), // Rule ID 7191 //
     /* 149787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149790 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149797 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149804 */     // MIs[0] Rn
     /* 149804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149816 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 149819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149829 */     GIR_RootConstrainSelectedInstOperands,
     /* 149830 */     // GIR_Coverage, 7191,
     /* 149830 */     GIR_EraseRootFromParent_Done,
     /* 149831 */   // Label 2658: @149831
     /* 149831 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(149880), // Rule ID 7192 //
     /* 149836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149839 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149846 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149853 */     // MIs[0] Rn
     /* 149853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149865 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 149868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149878 */     GIR_RootConstrainSelectedInstOperands,
     /* 149879 */     // GIR_Coverage, 7192,
     /* 149879 */     GIR_EraseRootFromParent_Done,
     /* 149880 */   // Label 2659: @149880
     /* 149880 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(149929), // Rule ID 7193 //
     /* 149885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149902 */     // MIs[0] Rn
     /* 149902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149914 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 149917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149927 */     GIR_RootConstrainSelectedInstOperands,
     /* 149928 */     // GIR_Coverage, 7193,
     /* 149928 */     GIR_EraseRootFromParent_Done,
     /* 149929 */   // Label 2660: @149929
     /* 149929 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(149978), // Rule ID 7194 //
     /* 149934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149951 */     // MIs[0] Rn
     /* 149951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149963 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 149966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149976 */     GIR_RootConstrainSelectedInstOperands,
     /* 149977 */     // GIR_Coverage, 7194,
     /* 149977 */     GIR_EraseRootFromParent_Done,
     /* 149978 */   // Label 2661: @149978
     /* 149978 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(150027), // Rule ID 7195 //
     /* 149983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149993 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150000 */     // MIs[0] Rn
     /* 150000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150012 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 150015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150025 */     GIR_RootConstrainSelectedInstOperands,
     /* 150026 */     // GIR_Coverage, 7195,
     /* 150026 */     GIR_EraseRootFromParent_Done,
     /* 150027 */   // Label 2662: @150027
     /* 150027 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(150076), // Rule ID 7196 //
     /* 150032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150049 */     // MIs[0] Rn
     /* 150049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150061 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 150064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150074 */     GIR_RootConstrainSelectedInstOperands,
     /* 150075 */     // GIR_Coverage, 7196,
     /* 150075 */     GIR_EraseRootFromParent_Done,
     /* 150076 */   // Label 2663: @150076
     /* 150076 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(150125), // Rule ID 7197 //
     /* 150081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150098 */     // MIs[0] Rn
     /* 150098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150110 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 150113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150123 */     GIR_RootConstrainSelectedInstOperands,
     /* 150124 */     // GIR_Coverage, 7197,
     /* 150124 */     GIR_EraseRootFromParent_Done,
     /* 150125 */   // Label 2664: @150125
     /* 150125 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(150174), // Rule ID 7198 //
     /* 150130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150147 */     // MIs[0] Rn
     /* 150147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150159 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 150162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150172 */     GIR_RootConstrainSelectedInstOperands,
     /* 150173 */     // GIR_Coverage, 7198,
     /* 150173 */     GIR_EraseRootFromParent_Done,
     /* 150174 */   // Label 2665: @150174
     /* 150174 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(150223), // Rule ID 7199 //
     /* 150179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150196 */     // MIs[0] Rn
     /* 150196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150208 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 150211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150221 */     GIR_RootConstrainSelectedInstOperands,
     /* 150222 */     // GIR_Coverage, 7199,
     /* 150222 */     GIR_EraseRootFromParent_Done,
     /* 150223 */   // Label 2666: @150223
     /* 150223 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(150272), // Rule ID 7200 //
     /* 150228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150245 */     // MIs[0] Rn
     /* 150245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150257 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 150260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150270 */     GIR_RootConstrainSelectedInstOperands,
     /* 150271 */     // GIR_Coverage, 7200,
     /* 150271 */     GIR_EraseRootFromParent_Done,
     /* 150272 */   // Label 2667: @150272
     /* 150272 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(150321), // Rule ID 7201 //
     /* 150277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150294 */     // MIs[0] Rn
     /* 150294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150306 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 150309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150319 */     GIR_RootConstrainSelectedInstOperands,
     /* 150320 */     // GIR_Coverage, 7201,
     /* 150320 */     GIR_EraseRootFromParent_Done,
     /* 150321 */   // Label 2668: @150321
     /* 150321 */   GIM_Reject,
     /* 150322 */ // Label 2653: @150322
     /* 150322 */ GIM_Reject,
     /* 150323 */ // Label 2651: @150323
     /* 150323 */ GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(150549),
     /* 150328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150331 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150338 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(150380), // Rule ID 7182 //
     /* 150343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150346 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150353 */     // MIs[0] Rn
     /* 150353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150365 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 150368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150378 */     GIR_RootConstrainSelectedInstOperands,
     /* 150379 */     // GIR_Coverage, 7182,
     /* 150379 */     GIR_EraseRootFromParent_Done,
     /* 150380 */   // Label 2670: @150380
     /* 150380 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(150422), // Rule ID 7183 //
     /* 150385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150388 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150395 */     // MIs[0] Rn
     /* 150395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150407 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 150410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150420 */     GIR_RootConstrainSelectedInstOperands,
     /* 150421 */     // GIR_Coverage, 7183,
     /* 150421 */     GIR_EraseRootFromParent_Done,
     /* 150422 */   // Label 2671: @150422
     /* 150422 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(150464), // Rule ID 7184 //
     /* 150427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150437 */     // MIs[0] Rn
     /* 150437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150449 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 150452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150462 */     GIR_RootConstrainSelectedInstOperands,
     /* 150463 */     // GIR_Coverage, 7184,
     /* 150463 */     GIR_EraseRootFromParent_Done,
     /* 150464 */   // Label 2672: @150464
     /* 150464 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(150506), // Rule ID 7185 //
     /* 150469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150479 */     // MIs[0] Rn
     /* 150479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150491 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 150494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150504 */     GIR_RootConstrainSelectedInstOperands,
     /* 150505 */     // GIR_Coverage, 7185,
     /* 150505 */     GIR_EraseRootFromParent_Done,
     /* 150506 */   // Label 2673: @150506
     /* 150506 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(150548), // Rule ID 7186 //
     /* 150511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150521 */     // MIs[0] Rn
     /* 150521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150533 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 150536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150546 */     GIR_RootConstrainSelectedInstOperands,
     /* 150547 */     // GIR_Coverage, 7186,
     /* 150547 */     GIR_EraseRootFromParent_Done,
     /* 150548 */   // Label 2674: @150548
     /* 150548 */   GIM_Reject,
     /* 150549 */ // Label 2669: @150549
     /* 150549 */ GIM_Reject,
     /* 150550 */ // Label 2652: @150550
     /* 150550 */ GIM_Reject,
     /* 150551 */ // Label 26: @150551
     /* 150551 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2677*/ GIMT_Encode4(151542),
     /* 150562 */ /*GILLT_s32*//*Label 2675*/ GIMT_Encode4(150570),
     /* 150566 */ /*GILLT_s64*//*Label 2676*/ GIMT_Encode4(151315),
     /* 150570 */ // Label 2675: @150570
     /* 150570 */ GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(151314),
     /* 150575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150578 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(150627), // Rule ID 7207 //
     /* 150583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150586 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150593 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150600 */     // MIs[0] Rn
     /* 150600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150612 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 150615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150625 */     GIR_RootConstrainSelectedInstOperands,
     /* 150626 */     // GIR_Coverage, 7207,
     /* 150626 */     GIR_EraseRootFromParent_Done,
     /* 150627 */   // Label 2679: @150627
     /* 150627 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(150676), // Rule ID 7208 //
     /* 150632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150635 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150642 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150649 */     // MIs[0] Rn
     /* 150649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150661 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 150664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150674 */     GIR_RootConstrainSelectedInstOperands,
     /* 150675 */     // GIR_Coverage, 7208,
     /* 150675 */     GIR_EraseRootFromParent_Done,
     /* 150676 */   // Label 2680: @150676
     /* 150676 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(150725), // Rule ID 7209 //
     /* 150681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150691 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150698 */     // MIs[0] Rn
     /* 150698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150710 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 150713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150723 */     GIR_RootConstrainSelectedInstOperands,
     /* 150724 */     // GIR_Coverage, 7209,
     /* 150724 */     GIR_EraseRootFromParent_Done,
     /* 150725 */   // Label 2681: @150725
     /* 150725 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(150774), // Rule ID 7210 //
     /* 150730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150747 */     // MIs[0] Rn
     /* 150747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150759 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 150762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150772 */     GIR_RootConstrainSelectedInstOperands,
     /* 150773 */     // GIR_Coverage, 7210,
     /* 150773 */     GIR_EraseRootFromParent_Done,
     /* 150774 */   // Label 2682: @150774
     /* 150774 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(150823), // Rule ID 7211 //
     /* 150779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150782 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150789 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150796 */     // MIs[0] Rn
     /* 150796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150808 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 150811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150821 */     GIR_RootConstrainSelectedInstOperands,
     /* 150822 */     // GIR_Coverage, 7211,
     /* 150822 */     GIR_EraseRootFromParent_Done,
     /* 150823 */   // Label 2683: @150823
     /* 150823 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(150872), // Rule ID 7212 //
     /* 150828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150845 */     // MIs[0] Rn
     /* 150845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150857 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 150860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150870 */     GIR_RootConstrainSelectedInstOperands,
     /* 150871 */     // GIR_Coverage, 7212,
     /* 150871 */     GIR_EraseRootFromParent_Done,
     /* 150872 */   // Label 2684: @150872
     /* 150872 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(150921), // Rule ID 7213 //
     /* 150877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150894 */     // MIs[0] Rn
     /* 150894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150906 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 150909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150919 */     GIR_RootConstrainSelectedInstOperands,
     /* 150920 */     // GIR_Coverage, 7213,
     /* 150920 */     GIR_EraseRootFromParent_Done,
     /* 150921 */   // Label 2685: @150921
     /* 150921 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(150970), // Rule ID 7214 //
     /* 150926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150943 */     // MIs[0] Rn
     /* 150943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150955 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 150958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150968 */     GIR_RootConstrainSelectedInstOperands,
     /* 150969 */     // GIR_Coverage, 7214,
     /* 150969 */     GIR_EraseRootFromParent_Done,
     /* 150970 */   // Label 2686: @150970
     /* 150970 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(151019), // Rule ID 7215 //
     /* 150975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150992 */     // MIs[0] Rn
     /* 150992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151004 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 151007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151017 */     GIR_RootConstrainSelectedInstOperands,
     /* 151018 */     // GIR_Coverage, 7215,
     /* 151018 */     GIR_EraseRootFromParent_Done,
     /* 151019 */   // Label 2687: @151019
     /* 151019 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(151068), // Rule ID 7216 //
     /* 151024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151041 */     // MIs[0] Rn
     /* 151041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151053 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 151056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151066 */     GIR_RootConstrainSelectedInstOperands,
     /* 151067 */     // GIR_Coverage, 7216,
     /* 151067 */     GIR_EraseRootFromParent_Done,
     /* 151068 */   // Label 2688: @151068
     /* 151068 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(151117), // Rule ID 7217 //
     /* 151073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151090 */     // MIs[0] Rn
     /* 151090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151102 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 151105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151115 */     GIR_RootConstrainSelectedInstOperands,
     /* 151116 */     // GIR_Coverage, 7217,
     /* 151116 */     GIR_EraseRootFromParent_Done,
     /* 151117 */   // Label 2689: @151117
     /* 151117 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(151166), // Rule ID 7218 //
     /* 151122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151139 */     // MIs[0] Rn
     /* 151139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151151 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 151154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151164 */     GIR_RootConstrainSelectedInstOperands,
     /* 151165 */     // GIR_Coverage, 7218,
     /* 151165 */     GIR_EraseRootFromParent_Done,
     /* 151166 */   // Label 2690: @151166
     /* 151166 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(151215), // Rule ID 7219 //
     /* 151171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151188 */     // MIs[0] Rn
     /* 151188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151200 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 151203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151213 */     GIR_RootConstrainSelectedInstOperands,
     /* 151214 */     // GIR_Coverage, 7219,
     /* 151214 */     GIR_EraseRootFromParent_Done,
     /* 151215 */   // Label 2691: @151215
     /* 151215 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(151264), // Rule ID 7220 //
     /* 151220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151237 */     // MIs[0] Rn
     /* 151237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151249 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 151252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151262 */     GIR_RootConstrainSelectedInstOperands,
     /* 151263 */     // GIR_Coverage, 7220,
     /* 151263 */     GIR_EraseRootFromParent_Done,
     /* 151264 */   // Label 2692: @151264
     /* 151264 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(151313), // Rule ID 7221 //
     /* 151269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151286 */     // MIs[0] Rn
     /* 151286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151298 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 151301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151311 */     GIR_RootConstrainSelectedInstOperands,
     /* 151312 */     // GIR_Coverage, 7221,
     /* 151312 */     GIR_EraseRootFromParent_Done,
     /* 151313 */   // Label 2693: @151313
     /* 151313 */   GIM_Reject,
     /* 151314 */ // Label 2678: @151314
     /* 151314 */ GIM_Reject,
     /* 151315 */ // Label 2676: @151315
     /* 151315 */ GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(151541),
     /* 151320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151330 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(151372), // Rule ID 7202 //
     /* 151335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151338 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151345 */     // MIs[0] Rn
     /* 151345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151357 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 151360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151370 */     GIR_RootConstrainSelectedInstOperands,
     /* 151371 */     // GIR_Coverage, 7202,
     /* 151371 */     GIR_EraseRootFromParent_Done,
     /* 151372 */   // Label 2695: @151372
     /* 151372 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(151414), // Rule ID 7203 //
     /* 151377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151387 */     // MIs[0] Rn
     /* 151387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151399 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 151402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151412 */     GIR_RootConstrainSelectedInstOperands,
     /* 151413 */     // GIR_Coverage, 7203,
     /* 151413 */     GIR_EraseRootFromParent_Done,
     /* 151414 */   // Label 2696: @151414
     /* 151414 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(151456), // Rule ID 7204 //
     /* 151419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151422 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151429 */     // MIs[0] Rn
     /* 151429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151441 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 151444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151454 */     GIR_RootConstrainSelectedInstOperands,
     /* 151455 */     // GIR_Coverage, 7204,
     /* 151455 */     GIR_EraseRootFromParent_Done,
     /* 151456 */   // Label 2697: @151456
     /* 151456 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(151498), // Rule ID 7205 //
     /* 151461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151471 */     // MIs[0] Rn
     /* 151471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151483 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 151486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151496 */     GIR_RootConstrainSelectedInstOperands,
     /* 151497 */     // GIR_Coverage, 7205,
     /* 151497 */     GIR_EraseRootFromParent_Done,
     /* 151498 */   // Label 2698: @151498
     /* 151498 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(151540), // Rule ID 7206 //
     /* 151503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151513 */     // MIs[0] Rn
     /* 151513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151525 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 151528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151538 */     GIR_RootConstrainSelectedInstOperands,
     /* 151539 */     // GIR_Coverage, 7206,
     /* 151539 */     GIR_EraseRootFromParent_Done,
     /* 151540 */   // Label 2699: @151540
     /* 151540 */   GIM_Reject,
     /* 151541 */ // Label 2694: @151541
     /* 151541 */ GIM_Reject,
     /* 151542 */ // Label 2677: @151542
     /* 151542 */ GIM_Reject,
     /* 151543 */ // Label 27: @151543
     /* 151543 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2702*/ GIMT_Encode4(152534),
     /* 151554 */ /*GILLT_s32*//*Label 2700*/ GIMT_Encode4(151562),
     /* 151558 */ /*GILLT_s64*//*Label 2701*/ GIMT_Encode4(152307),
     /* 151562 */ // Label 2700: @151562
     /* 151562 */ GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(152306),
     /* 151567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151570 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(151619), // Rule ID 7247 //
     /* 151575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151592 */     // MIs[0] Rn
     /* 151592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151604 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 151607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151617 */     GIR_RootConstrainSelectedInstOperands,
     /* 151618 */     // GIR_Coverage, 7247,
     /* 151618 */     GIR_EraseRootFromParent_Done,
     /* 151619 */   // Label 2704: @151619
     /* 151619 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(151668), // Rule ID 7248 //
     /* 151624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151627 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151634 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151641 */     // MIs[0] Rn
     /* 151641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151653 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 151656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151666 */     GIR_RootConstrainSelectedInstOperands,
     /* 151667 */     // GIR_Coverage, 7248,
     /* 151667 */     GIR_EraseRootFromParent_Done,
     /* 151668 */   // Label 2705: @151668
     /* 151668 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(151717), // Rule ID 7249 //
     /* 151673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151676 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151683 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151690 */     // MIs[0] Rn
     /* 151690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151702 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 151705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151715 */     GIR_RootConstrainSelectedInstOperands,
     /* 151716 */     // GIR_Coverage, 7249,
     /* 151716 */     GIR_EraseRootFromParent_Done,
     /* 151717 */   // Label 2706: @151717
     /* 151717 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(151766), // Rule ID 7250 //
     /* 151722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151725 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151739 */     // MIs[0] Rn
     /* 151739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151751 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 151754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151764 */     GIR_RootConstrainSelectedInstOperands,
     /* 151765 */     // GIR_Coverage, 7250,
     /* 151765 */     GIR_EraseRootFromParent_Done,
     /* 151766 */   // Label 2707: @151766
     /* 151766 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(151815), // Rule ID 7251 //
     /* 151771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151774 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151781 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151788 */     // MIs[0] Rn
     /* 151788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151800 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 151803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151813 */     GIR_RootConstrainSelectedInstOperands,
     /* 151814 */     // GIR_Coverage, 7251,
     /* 151814 */     GIR_EraseRootFromParent_Done,
     /* 151815 */   // Label 2708: @151815
     /* 151815 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(151864), // Rule ID 7252 //
     /* 151820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151837 */     // MIs[0] Rn
     /* 151837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151849 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 151852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151862 */     GIR_RootConstrainSelectedInstOperands,
     /* 151863 */     // GIR_Coverage, 7252,
     /* 151863 */     GIR_EraseRootFromParent_Done,
     /* 151864 */   // Label 2709: @151864
     /* 151864 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(151913), // Rule ID 7253 //
     /* 151869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151886 */     // MIs[0] Rn
     /* 151886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151898 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 151901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151911 */     GIR_RootConstrainSelectedInstOperands,
     /* 151912 */     // GIR_Coverage, 7253,
     /* 151912 */     GIR_EraseRootFromParent_Done,
     /* 151913 */   // Label 2710: @151913
     /* 151913 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(151962), // Rule ID 7254 //
     /* 151918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151935 */     // MIs[0] Rn
     /* 151935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151947 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 151950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151960 */     GIR_RootConstrainSelectedInstOperands,
     /* 151961 */     // GIR_Coverage, 7254,
     /* 151961 */     GIR_EraseRootFromParent_Done,
     /* 151962 */   // Label 2711: @151962
     /* 151962 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(152011), // Rule ID 7255 //
     /* 151967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151984 */     // MIs[0] Rn
     /* 151984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151996 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 151999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152009 */     GIR_RootConstrainSelectedInstOperands,
     /* 152010 */     // GIR_Coverage, 7255,
     /* 152010 */     GIR_EraseRootFromParent_Done,
     /* 152011 */   // Label 2712: @152011
     /* 152011 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(152060), // Rule ID 7256 //
     /* 152016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152033 */     // MIs[0] Rn
     /* 152033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152045 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 152048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152058 */     GIR_RootConstrainSelectedInstOperands,
     /* 152059 */     // GIR_Coverage, 7256,
     /* 152059 */     GIR_EraseRootFromParent_Done,
     /* 152060 */   // Label 2713: @152060
     /* 152060 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(152109), // Rule ID 7257 //
     /* 152065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152082 */     // MIs[0] Rn
     /* 152082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152094 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 152097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152107 */     GIR_RootConstrainSelectedInstOperands,
     /* 152108 */     // GIR_Coverage, 7257,
     /* 152108 */     GIR_EraseRootFromParent_Done,
     /* 152109 */   // Label 2714: @152109
     /* 152109 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(152158), // Rule ID 7258 //
     /* 152114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152131 */     // MIs[0] Rn
     /* 152131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152143 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 152146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152156 */     GIR_RootConstrainSelectedInstOperands,
     /* 152157 */     // GIR_Coverage, 7258,
     /* 152157 */     GIR_EraseRootFromParent_Done,
     /* 152158 */   // Label 2715: @152158
     /* 152158 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(152207), // Rule ID 7259 //
     /* 152163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152180 */     // MIs[0] Rn
     /* 152180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152192 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 152195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152205 */     GIR_RootConstrainSelectedInstOperands,
     /* 152206 */     // GIR_Coverage, 7259,
     /* 152206 */     GIR_EraseRootFromParent_Done,
     /* 152207 */   // Label 2716: @152207
     /* 152207 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(152256), // Rule ID 7260 //
     /* 152212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152229 */     // MIs[0] Rn
     /* 152229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152241 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 152244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152254 */     GIR_RootConstrainSelectedInstOperands,
     /* 152255 */     // GIR_Coverage, 7260,
     /* 152255 */     GIR_EraseRootFromParent_Done,
     /* 152256 */   // Label 2717: @152256
     /* 152256 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(152305), // Rule ID 7261 //
     /* 152261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152278 */     // MIs[0] Rn
     /* 152278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152290 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 152293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152303 */     GIR_RootConstrainSelectedInstOperands,
     /* 152304 */     // GIR_Coverage, 7261,
     /* 152304 */     GIR_EraseRootFromParent_Done,
     /* 152305 */   // Label 2718: @152305
     /* 152305 */   GIM_Reject,
     /* 152306 */ // Label 2703: @152306
     /* 152306 */ GIM_Reject,
     /* 152307 */ // Label 2701: @152307
     /* 152307 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(152533),
     /* 152312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 152322 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(152364), // Rule ID 7242 //
     /* 152327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152330 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152337 */     // MIs[0] Rn
     /* 152337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152349 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 152352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152362 */     GIR_RootConstrainSelectedInstOperands,
     /* 152363 */     // GIR_Coverage, 7242,
     /* 152363 */     GIR_EraseRootFromParent_Done,
     /* 152364 */   // Label 2720: @152364
     /* 152364 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(152406), // Rule ID 7243 //
     /* 152369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152379 */     // MIs[0] Rn
     /* 152379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152391 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 152394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152404 */     GIR_RootConstrainSelectedInstOperands,
     /* 152405 */     // GIR_Coverage, 7243,
     /* 152405 */     GIR_EraseRootFromParent_Done,
     /* 152406 */   // Label 2721: @152406
     /* 152406 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(152448), // Rule ID 7244 //
     /* 152411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152414 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152421 */     // MIs[0] Rn
     /* 152421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152433 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 152436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152446 */     GIR_RootConstrainSelectedInstOperands,
     /* 152447 */     // GIR_Coverage, 7244,
     /* 152447 */     GIR_EraseRootFromParent_Done,
     /* 152448 */   // Label 2722: @152448
     /* 152448 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(152490), // Rule ID 7245 //
     /* 152453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152463 */     // MIs[0] Rn
     /* 152463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152475 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 152478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152488 */     GIR_RootConstrainSelectedInstOperands,
     /* 152489 */     // GIR_Coverage, 7245,
     /* 152489 */     GIR_EraseRootFromParent_Done,
     /* 152490 */   // Label 2723: @152490
     /* 152490 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(152532), // Rule ID 7246 //
     /* 152495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152505 */     // MIs[0] Rn
     /* 152505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152517 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 152520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152530 */     GIR_RootConstrainSelectedInstOperands,
     /* 152531 */     // GIR_Coverage, 7246,
     /* 152531 */     GIR_EraseRootFromParent_Done,
     /* 152532 */   // Label 2724: @152532
     /* 152532 */   GIM_Reject,
     /* 152533 */ // Label 2719: @152533
     /* 152533 */ GIM_Reject,
     /* 152534 */ // Label 2702: @152534
     /* 152534 */ GIM_Reject,
     /* 152535 */ // Label 28: @152535
     /* 152535 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2727*/ GIMT_Encode4(153526),
     /* 152546 */ /*GILLT_s32*//*Label 2725*/ GIMT_Encode4(152554),
     /* 152550 */ /*GILLT_s64*//*Label 2726*/ GIMT_Encode4(153299),
     /* 152554 */ // Label 2725: @152554
     /* 152554 */ GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(153298),
     /* 152559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152562 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(152611), // Rule ID 7267 //
     /* 152567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152584 */     // MIs[0] Rn
     /* 152584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152596 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 152599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152609 */     GIR_RootConstrainSelectedInstOperands,
     /* 152610 */     // GIR_Coverage, 7267,
     /* 152610 */     GIR_EraseRootFromParent_Done,
     /* 152611 */   // Label 2729: @152611
     /* 152611 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(152660), // Rule ID 7268 //
     /* 152616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152626 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152633 */     // MIs[0] Rn
     /* 152633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152645 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 152648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152658 */     GIR_RootConstrainSelectedInstOperands,
     /* 152659 */     // GIR_Coverage, 7268,
     /* 152659 */     GIR_EraseRootFromParent_Done,
     /* 152660 */   // Label 2730: @152660
     /* 152660 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(152709), // Rule ID 7269 //
     /* 152665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152668 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152682 */     // MIs[0] Rn
     /* 152682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152694 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 152697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152707 */     GIR_RootConstrainSelectedInstOperands,
     /* 152708 */     // GIR_Coverage, 7269,
     /* 152708 */     GIR_EraseRootFromParent_Done,
     /* 152709 */   // Label 2731: @152709
     /* 152709 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(152758), // Rule ID 7270 //
     /* 152714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152717 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152724 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152731 */     // MIs[0] Rn
     /* 152731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152743 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 152746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152756 */     GIR_RootConstrainSelectedInstOperands,
     /* 152757 */     // GIR_Coverage, 7270,
     /* 152757 */     GIR_EraseRootFromParent_Done,
     /* 152758 */   // Label 2732: @152758
     /* 152758 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(152807), // Rule ID 7271 //
     /* 152763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152766 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152773 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152780 */     // MIs[0] Rn
     /* 152780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152792 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 152795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152805 */     GIR_RootConstrainSelectedInstOperands,
     /* 152806 */     // GIR_Coverage, 7271,
     /* 152806 */     GIR_EraseRootFromParent_Done,
     /* 152807 */   // Label 2733: @152807
     /* 152807 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(152856), // Rule ID 7272 //
     /* 152812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152829 */     // MIs[0] Rn
     /* 152829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152841 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 152844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152854 */     GIR_RootConstrainSelectedInstOperands,
     /* 152855 */     // GIR_Coverage, 7272,
     /* 152855 */     GIR_EraseRootFromParent_Done,
     /* 152856 */   // Label 2734: @152856
     /* 152856 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(152905), // Rule ID 7273 //
     /* 152861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152878 */     // MIs[0] Rn
     /* 152878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152890 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 152893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152903 */     GIR_RootConstrainSelectedInstOperands,
     /* 152904 */     // GIR_Coverage, 7273,
     /* 152904 */     GIR_EraseRootFromParent_Done,
     /* 152905 */   // Label 2735: @152905
     /* 152905 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(152954), // Rule ID 7274 //
     /* 152910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152927 */     // MIs[0] Rn
     /* 152927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152939 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 152942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152952 */     GIR_RootConstrainSelectedInstOperands,
     /* 152953 */     // GIR_Coverage, 7274,
     /* 152953 */     GIR_EraseRootFromParent_Done,
     /* 152954 */   // Label 2736: @152954
     /* 152954 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(153003), // Rule ID 7275 //
     /* 152959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152976 */     // MIs[0] Rn
     /* 152976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152988 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 152991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153001 */     GIR_RootConstrainSelectedInstOperands,
     /* 153002 */     // GIR_Coverage, 7275,
     /* 153002 */     GIR_EraseRootFromParent_Done,
     /* 153003 */   // Label 2737: @153003
     /* 153003 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(153052), // Rule ID 7276 //
     /* 153008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153025 */     // MIs[0] Rn
     /* 153025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153037 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 153040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153050 */     GIR_RootConstrainSelectedInstOperands,
     /* 153051 */     // GIR_Coverage, 7276,
     /* 153051 */     GIR_EraseRootFromParent_Done,
     /* 153052 */   // Label 2738: @153052
     /* 153052 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(153101), // Rule ID 7277 //
     /* 153057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153074 */     // MIs[0] Rn
     /* 153074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153086 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 153089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153099 */     GIR_RootConstrainSelectedInstOperands,
     /* 153100 */     // GIR_Coverage, 7277,
     /* 153100 */     GIR_EraseRootFromParent_Done,
     /* 153101 */   // Label 2739: @153101
     /* 153101 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(153150), // Rule ID 7278 //
     /* 153106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153123 */     // MIs[0] Rn
     /* 153123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153135 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 153138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153148 */     GIR_RootConstrainSelectedInstOperands,
     /* 153149 */     // GIR_Coverage, 7278,
     /* 153149 */     GIR_EraseRootFromParent_Done,
     /* 153150 */   // Label 2740: @153150
     /* 153150 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(153199), // Rule ID 7279 //
     /* 153155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153172 */     // MIs[0] Rn
     /* 153172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153184 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 153187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153197 */     GIR_RootConstrainSelectedInstOperands,
     /* 153198 */     // GIR_Coverage, 7279,
     /* 153198 */     GIR_EraseRootFromParent_Done,
     /* 153199 */   // Label 2741: @153199
     /* 153199 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(153248), // Rule ID 7280 //
     /* 153204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153221 */     // MIs[0] Rn
     /* 153221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153233 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 153236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153246 */     GIR_RootConstrainSelectedInstOperands,
     /* 153247 */     // GIR_Coverage, 7280,
     /* 153247 */     GIR_EraseRootFromParent_Done,
     /* 153248 */   // Label 2742: @153248
     /* 153248 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(153297), // Rule ID 7281 //
     /* 153253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153270 */     // MIs[0] Rn
     /* 153270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153282 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 153285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153295 */     GIR_RootConstrainSelectedInstOperands,
     /* 153296 */     // GIR_Coverage, 7281,
     /* 153296 */     GIR_EraseRootFromParent_Done,
     /* 153297 */   // Label 2743: @153297
     /* 153297 */   GIM_Reject,
     /* 153298 */ // Label 2728: @153298
     /* 153298 */ GIM_Reject,
     /* 153299 */ // Label 2726: @153299
     /* 153299 */ GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(153525),
     /* 153304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153307 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153314 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(153356), // Rule ID 7262 //
     /* 153319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153329 */     // MIs[0] Rn
     /* 153329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153341 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 153344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153354 */     GIR_RootConstrainSelectedInstOperands,
     /* 153355 */     // GIR_Coverage, 7262,
     /* 153355 */     GIR_EraseRootFromParent_Done,
     /* 153356 */   // Label 2745: @153356
     /* 153356 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(153398), // Rule ID 7263 //
     /* 153361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153371 */     // MIs[0] Rn
     /* 153371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153383 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 153386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153396 */     GIR_RootConstrainSelectedInstOperands,
     /* 153397 */     // GIR_Coverage, 7263,
     /* 153397 */     GIR_EraseRootFromParent_Done,
     /* 153398 */   // Label 2746: @153398
     /* 153398 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(153440), // Rule ID 7264 //
     /* 153403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153406 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153413 */     // MIs[0] Rn
     /* 153413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153425 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 153428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153438 */     GIR_RootConstrainSelectedInstOperands,
     /* 153439 */     // GIR_Coverage, 7264,
     /* 153439 */     GIR_EraseRootFromParent_Done,
     /* 153440 */   // Label 2747: @153440
     /* 153440 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(153482), // Rule ID 7265 //
     /* 153445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153455 */     // MIs[0] Rn
     /* 153455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153467 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 153470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153480 */     GIR_RootConstrainSelectedInstOperands,
     /* 153481 */     // GIR_Coverage, 7265,
     /* 153481 */     GIR_EraseRootFromParent_Done,
     /* 153482 */   // Label 2748: @153482
     /* 153482 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(153524), // Rule ID 7266 //
     /* 153487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153497 */     // MIs[0] Rn
     /* 153497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153509 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 153512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153522 */     GIR_RootConstrainSelectedInstOperands,
     /* 153523 */     // GIR_Coverage, 7266,
     /* 153523 */     GIR_EraseRootFromParent_Done,
     /* 153524 */   // Label 2749: @153524
     /* 153524 */   GIM_Reject,
     /* 153525 */ // Label 2744: @153525
     /* 153525 */ GIM_Reject,
     /* 153526 */ // Label 2727: @153526
     /* 153526 */ GIM_Reject,
     /* 153527 */ // Label 29: @153527
     /* 153527 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2752*/ GIMT_Encode4(154518),
     /* 153538 */ /*GILLT_s32*//*Label 2750*/ GIMT_Encode4(153546),
     /* 153542 */ /*GILLT_s64*//*Label 2751*/ GIMT_Encode4(154291),
     /* 153546 */ // Label 2750: @153546
     /* 153546 */ GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(154290),
     /* 153551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153554 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(153603), // Rule ID 7287 //
     /* 153559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153562 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153569 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153576 */     // MIs[0] Rn
     /* 153576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153588 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 153591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153601 */     GIR_RootConstrainSelectedInstOperands,
     /* 153602 */     // GIR_Coverage, 7287,
     /* 153602 */     GIR_EraseRootFromParent_Done,
     /* 153603 */   // Label 2754: @153603
     /* 153603 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(153652), // Rule ID 7288 //
     /* 153608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153611 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153618 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153625 */     // MIs[0] Rn
     /* 153625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153637 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 153640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153650 */     GIR_RootConstrainSelectedInstOperands,
     /* 153651 */     // GIR_Coverage, 7288,
     /* 153651 */     GIR_EraseRootFromParent_Done,
     /* 153652 */   // Label 2755: @153652
     /* 153652 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(153701), // Rule ID 7289 //
     /* 153657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153660 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153667 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153674 */     // MIs[0] Rn
     /* 153674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153686 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 153689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153699 */     GIR_RootConstrainSelectedInstOperands,
     /* 153700 */     // GIR_Coverage, 7289,
     /* 153700 */     GIR_EraseRootFromParent_Done,
     /* 153701 */   // Label 2756: @153701
     /* 153701 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(153750), // Rule ID 7290 //
     /* 153706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153709 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153723 */     // MIs[0] Rn
     /* 153723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153735 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 153738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153748 */     GIR_RootConstrainSelectedInstOperands,
     /* 153749 */     // GIR_Coverage, 7290,
     /* 153749 */     GIR_EraseRootFromParent_Done,
     /* 153750 */   // Label 2757: @153750
     /* 153750 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(153799), // Rule ID 7291 //
     /* 153755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153772 */     // MIs[0] Rn
     /* 153772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153784 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 153787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153797 */     GIR_RootConstrainSelectedInstOperands,
     /* 153798 */     // GIR_Coverage, 7291,
     /* 153798 */     GIR_EraseRootFromParent_Done,
     /* 153799 */   // Label 2758: @153799
     /* 153799 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(153848), // Rule ID 7292 //
     /* 153804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153807 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153821 */     // MIs[0] Rn
     /* 153821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153833 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 153836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153846 */     GIR_RootConstrainSelectedInstOperands,
     /* 153847 */     // GIR_Coverage, 7292,
     /* 153847 */     GIR_EraseRootFromParent_Done,
     /* 153848 */   // Label 2759: @153848
     /* 153848 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(153897), // Rule ID 7293 //
     /* 153853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153856 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153870 */     // MIs[0] Rn
     /* 153870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153882 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 153885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153895 */     GIR_RootConstrainSelectedInstOperands,
     /* 153896 */     // GIR_Coverage, 7293,
     /* 153896 */     GIR_EraseRootFromParent_Done,
     /* 153897 */   // Label 2760: @153897
     /* 153897 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(153946), // Rule ID 7294 //
     /* 153902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153919 */     // MIs[0] Rn
     /* 153919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153931 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 153934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153944 */     GIR_RootConstrainSelectedInstOperands,
     /* 153945 */     // GIR_Coverage, 7294,
     /* 153945 */     GIR_EraseRootFromParent_Done,
     /* 153946 */   // Label 2761: @153946
     /* 153946 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(153995), // Rule ID 7295 //
     /* 153951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153968 */     // MIs[0] Rn
     /* 153968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153980 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 153983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153993 */     GIR_RootConstrainSelectedInstOperands,
     /* 153994 */     // GIR_Coverage, 7295,
     /* 153994 */     GIR_EraseRootFromParent_Done,
     /* 153995 */   // Label 2762: @153995
     /* 153995 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(154044), // Rule ID 7296 //
     /* 154000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154017 */     // MIs[0] Rn
     /* 154017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154029 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 154032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154042 */     GIR_RootConstrainSelectedInstOperands,
     /* 154043 */     // GIR_Coverage, 7296,
     /* 154043 */     GIR_EraseRootFromParent_Done,
     /* 154044 */   // Label 2763: @154044
     /* 154044 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(154093), // Rule ID 7297 //
     /* 154049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154066 */     // MIs[0] Rn
     /* 154066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154078 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 154081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154091 */     GIR_RootConstrainSelectedInstOperands,
     /* 154092 */     // GIR_Coverage, 7297,
     /* 154092 */     GIR_EraseRootFromParent_Done,
     /* 154093 */   // Label 2764: @154093
     /* 154093 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(154142), // Rule ID 7298 //
     /* 154098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154101 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154115 */     // MIs[0] Rn
     /* 154115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154127 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 154130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154140 */     GIR_RootConstrainSelectedInstOperands,
     /* 154141 */     // GIR_Coverage, 7298,
     /* 154141 */     GIR_EraseRootFromParent_Done,
     /* 154142 */   // Label 2765: @154142
     /* 154142 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(154191), // Rule ID 7299 //
     /* 154147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154164 */     // MIs[0] Rn
     /* 154164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154176 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 154179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154189 */     GIR_RootConstrainSelectedInstOperands,
     /* 154190 */     // GIR_Coverage, 7299,
     /* 154190 */     GIR_EraseRootFromParent_Done,
     /* 154191 */   // Label 2766: @154191
     /* 154191 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(154240), // Rule ID 7300 //
     /* 154196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154213 */     // MIs[0] Rn
     /* 154213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154225 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 154228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154238 */     GIR_RootConstrainSelectedInstOperands,
     /* 154239 */     // GIR_Coverage, 7300,
     /* 154239 */     GIR_EraseRootFromParent_Done,
     /* 154240 */   // Label 2767: @154240
     /* 154240 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(154289), // Rule ID 7301 //
     /* 154245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154262 */     // MIs[0] Rn
     /* 154262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154274 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 154277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154287 */     GIR_RootConstrainSelectedInstOperands,
     /* 154288 */     // GIR_Coverage, 7301,
     /* 154288 */     GIR_EraseRootFromParent_Done,
     /* 154289 */   // Label 2768: @154289
     /* 154289 */   GIM_Reject,
     /* 154290 */ // Label 2753: @154290
     /* 154290 */ GIM_Reject,
     /* 154291 */ // Label 2751: @154291
     /* 154291 */ GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(154517),
     /* 154296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154299 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154306 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(154348), // Rule ID 7282 //
     /* 154311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154314 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154321 */     // MIs[0] Rn
     /* 154321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154333 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 154336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154346 */     GIR_RootConstrainSelectedInstOperands,
     /* 154347 */     // GIR_Coverage, 7282,
     /* 154347 */     GIR_EraseRootFromParent_Done,
     /* 154348 */   // Label 2770: @154348
     /* 154348 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(154390), // Rule ID 7283 //
     /* 154353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154363 */     // MIs[0] Rn
     /* 154363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154375 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 154378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154388 */     GIR_RootConstrainSelectedInstOperands,
     /* 154389 */     // GIR_Coverage, 7283,
     /* 154389 */     GIR_EraseRootFromParent_Done,
     /* 154390 */   // Label 2771: @154390
     /* 154390 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(154432), // Rule ID 7284 //
     /* 154395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154405 */     // MIs[0] Rn
     /* 154405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154417 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 154420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154430 */     GIR_RootConstrainSelectedInstOperands,
     /* 154431 */     // GIR_Coverage, 7284,
     /* 154431 */     GIR_EraseRootFromParent_Done,
     /* 154432 */   // Label 2772: @154432
     /* 154432 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(154474), // Rule ID 7285 //
     /* 154437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154447 */     // MIs[0] Rn
     /* 154447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154459 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 154462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154472 */     GIR_RootConstrainSelectedInstOperands,
     /* 154473 */     // GIR_Coverage, 7285,
     /* 154473 */     GIR_EraseRootFromParent_Done,
     /* 154474 */   // Label 2773: @154474
     /* 154474 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(154516), // Rule ID 7286 //
     /* 154479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154489 */     // MIs[0] Rn
     /* 154489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154501 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 154504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154514 */     GIR_RootConstrainSelectedInstOperands,
     /* 154515 */     // GIR_Coverage, 7286,
     /* 154515 */     GIR_EraseRootFromParent_Done,
     /* 154516 */   // Label 2774: @154516
     /* 154516 */   GIM_Reject,
     /* 154517 */ // Label 2769: @154517
     /* 154517 */ GIM_Reject,
     /* 154518 */ // Label 2752: @154518
     /* 154518 */ GIM_Reject,
     /* 154519 */ // Label 30: @154519
     /* 154519 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2777*/ GIMT_Encode4(155510),
     /* 154530 */ /*GILLT_s32*//*Label 2775*/ GIMT_Encode4(154538),
     /* 154534 */ /*GILLT_s64*//*Label 2776*/ GIMT_Encode4(155283),
     /* 154538 */ // Label 2775: @154538
     /* 154538 */ GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(155282),
     /* 154543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154546 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(154595), // Rule ID 7307 //
     /* 154551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154554 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154561 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154568 */     // MIs[0] Rn
     /* 154568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154580 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 154583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154593 */     GIR_RootConstrainSelectedInstOperands,
     /* 154594 */     // GIR_Coverage, 7307,
     /* 154594 */     GIR_EraseRootFromParent_Done,
     /* 154595 */   // Label 2779: @154595
     /* 154595 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(154644), // Rule ID 7308 //
     /* 154600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154603 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154610 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154617 */     // MIs[0] Rn
     /* 154617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154629 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 154632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154642 */     GIR_RootConstrainSelectedInstOperands,
     /* 154643 */     // GIR_Coverage, 7308,
     /* 154643 */     GIR_EraseRootFromParent_Done,
     /* 154644 */   // Label 2780: @154644
     /* 154644 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(154693), // Rule ID 7309 //
     /* 154649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154652 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154666 */     // MIs[0] Rn
     /* 154666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154678 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 154681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154691 */     GIR_RootConstrainSelectedInstOperands,
     /* 154692 */     // GIR_Coverage, 7309,
     /* 154692 */     GIR_EraseRootFromParent_Done,
     /* 154693 */   // Label 2781: @154693
     /* 154693 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(154742), // Rule ID 7310 //
     /* 154698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154701 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154708 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154715 */     // MIs[0] Rn
     /* 154715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154727 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 154730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154740 */     GIR_RootConstrainSelectedInstOperands,
     /* 154741 */     // GIR_Coverage, 7310,
     /* 154741 */     GIR_EraseRootFromParent_Done,
     /* 154742 */   // Label 2782: @154742
     /* 154742 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(154791), // Rule ID 7311 //
     /* 154747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154764 */     // MIs[0] Rn
     /* 154764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154776 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 154779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154789 */     GIR_RootConstrainSelectedInstOperands,
     /* 154790 */     // GIR_Coverage, 7311,
     /* 154790 */     GIR_EraseRootFromParent_Done,
     /* 154791 */   // Label 2783: @154791
     /* 154791 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(154840), // Rule ID 7312 //
     /* 154796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154799 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154806 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154813 */     // MIs[0] Rn
     /* 154813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154825 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 154828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154838 */     GIR_RootConstrainSelectedInstOperands,
     /* 154839 */     // GIR_Coverage, 7312,
     /* 154839 */     GIR_EraseRootFromParent_Done,
     /* 154840 */   // Label 2784: @154840
     /* 154840 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(154889), // Rule ID 7313 //
     /* 154845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154855 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154862 */     // MIs[0] Rn
     /* 154862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154874 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 154877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154887 */     GIR_RootConstrainSelectedInstOperands,
     /* 154888 */     // GIR_Coverage, 7313,
     /* 154888 */     GIR_EraseRootFromParent_Done,
     /* 154889 */   // Label 2785: @154889
     /* 154889 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(154938), // Rule ID 7314 //
     /* 154894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154904 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154911 */     // MIs[0] Rn
     /* 154911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154923 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 154926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154936 */     GIR_RootConstrainSelectedInstOperands,
     /* 154937 */     // GIR_Coverage, 7314,
     /* 154937 */     GIR_EraseRootFromParent_Done,
     /* 154938 */   // Label 2786: @154938
     /* 154938 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(154987), // Rule ID 7315 //
     /* 154943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154960 */     // MIs[0] Rn
     /* 154960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154972 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 154975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154985 */     GIR_RootConstrainSelectedInstOperands,
     /* 154986 */     // GIR_Coverage, 7315,
     /* 154986 */     GIR_EraseRootFromParent_Done,
     /* 154987 */   // Label 2787: @154987
     /* 154987 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155036), // Rule ID 7316 //
     /* 154992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155009 */     // MIs[0] Rn
     /* 155009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155021 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 155024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155034 */     GIR_RootConstrainSelectedInstOperands,
     /* 155035 */     // GIR_Coverage, 7316,
     /* 155035 */     GIR_EraseRootFromParent_Done,
     /* 155036 */   // Label 2788: @155036
     /* 155036 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155085), // Rule ID 7317 //
     /* 155041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155058 */     // MIs[0] Rn
     /* 155058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155070 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 155073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155083 */     GIR_RootConstrainSelectedInstOperands,
     /* 155084 */     // GIR_Coverage, 7317,
     /* 155084 */     GIR_EraseRootFromParent_Done,
     /* 155085 */   // Label 2789: @155085
     /* 155085 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155134), // Rule ID 7318 //
     /* 155090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155107 */     // MIs[0] Rn
     /* 155107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155119 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 155122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155132 */     GIR_RootConstrainSelectedInstOperands,
     /* 155133 */     // GIR_Coverage, 7318,
     /* 155133 */     GIR_EraseRootFromParent_Done,
     /* 155134 */   // Label 2790: @155134
     /* 155134 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(155183), // Rule ID 7319 //
     /* 155139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155156 */     // MIs[0] Rn
     /* 155156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155168 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 155171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155181 */     GIR_RootConstrainSelectedInstOperands,
     /* 155182 */     // GIR_Coverage, 7319,
     /* 155182 */     GIR_EraseRootFromParent_Done,
     /* 155183 */   // Label 2791: @155183
     /* 155183 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(155232), // Rule ID 7320 //
     /* 155188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155191 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155205 */     // MIs[0] Rn
     /* 155205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155217 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 155220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155230 */     GIR_RootConstrainSelectedInstOperands,
     /* 155231 */     // GIR_Coverage, 7320,
     /* 155231 */     GIR_EraseRootFromParent_Done,
     /* 155232 */   // Label 2792: @155232
     /* 155232 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(155281), // Rule ID 7321 //
     /* 155237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155254 */     // MIs[0] Rn
     /* 155254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155266 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 155269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155279 */     GIR_RootConstrainSelectedInstOperands,
     /* 155280 */     // GIR_Coverage, 7321,
     /* 155280 */     GIR_EraseRootFromParent_Done,
     /* 155281 */   // Label 2793: @155281
     /* 155281 */   GIM_Reject,
     /* 155282 */ // Label 2778: @155282
     /* 155282 */ GIM_Reject,
     /* 155283 */ // Label 2776: @155283
     /* 155283 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(155509),
     /* 155288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155291 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 155298 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(155340), // Rule ID 7302 //
     /* 155303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155313 */     // MIs[0] Rn
     /* 155313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155325 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 155328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155338 */     GIR_RootConstrainSelectedInstOperands,
     /* 155339 */     // GIR_Coverage, 7302,
     /* 155339 */     GIR_EraseRootFromParent_Done,
     /* 155340 */   // Label 2795: @155340
     /* 155340 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(155382), // Rule ID 7303 //
     /* 155345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155355 */     // MIs[0] Rn
     /* 155355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155367 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 155370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155380 */     GIR_RootConstrainSelectedInstOperands,
     /* 155381 */     // GIR_Coverage, 7303,
     /* 155381 */     GIR_EraseRootFromParent_Done,
     /* 155382 */   // Label 2796: @155382
     /* 155382 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(155424), // Rule ID 7304 //
     /* 155387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155397 */     // MIs[0] Rn
     /* 155397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155409 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 155412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155422 */     GIR_RootConstrainSelectedInstOperands,
     /* 155423 */     // GIR_Coverage, 7304,
     /* 155423 */     GIR_EraseRootFromParent_Done,
     /* 155424 */   // Label 2797: @155424
     /* 155424 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(155466), // Rule ID 7305 //
     /* 155429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155439 */     // MIs[0] Rn
     /* 155439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155451 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 155454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155464 */     GIR_RootConstrainSelectedInstOperands,
     /* 155465 */     // GIR_Coverage, 7305,
     /* 155465 */     GIR_EraseRootFromParent_Done,
     /* 155466 */   // Label 2798: @155466
     /* 155466 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(155508), // Rule ID 7306 //
     /* 155471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155481 */     // MIs[0] Rn
     /* 155481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155493 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 155496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155506 */     GIR_RootConstrainSelectedInstOperands,
     /* 155507 */     // GIR_Coverage, 7306,
     /* 155507 */     GIR_EraseRootFromParent_Done,
     /* 155508 */   // Label 2799: @155508
     /* 155508 */   GIM_Reject,
     /* 155509 */ // Label 2794: @155509
     /* 155509 */ GIM_Reject,
     /* 155510 */ // Label 2777: @155510
     /* 155510 */ GIM_Reject,
     /* 155511 */ // Label 31: @155511
     /* 155511 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2803*/ GIMT_Encode4(156215),
     /* 155522 */ /*GILLT_s16*//*Label 2800*/ GIMT_Encode4(155534),
     /* 155526 */ /*GILLT_s32*//*Label 2801*/ GIMT_Encode4(155761),
     /* 155530 */ /*GILLT_s64*//*Label 2802*/ GIMT_Encode4(155988),
     /* 155534 */ // Label 2800: @155534
     /* 155534 */ GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(155760),
     /* 155539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155542 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155549 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(155591), // Rule ID 2577 //
     /* 155554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155564 */     // MIs[0] Rn
     /* 155564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155576 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 155579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155589 */     GIR_RootConstrainSelectedInstOperands,
     /* 155590 */     // GIR_Coverage, 2577,
     /* 155590 */     GIR_EraseRootFromParent_Done,
     /* 155591 */   // Label 2805: @155591
     /* 155591 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(155633), // Rule ID 2578 //
     /* 155596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155606 */     // MIs[0] Rn
     /* 155606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155618 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 155621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155631 */     GIR_RootConstrainSelectedInstOperands,
     /* 155632 */     // GIR_Coverage, 2578,
     /* 155632 */     GIR_EraseRootFromParent_Done,
     /* 155633 */   // Label 2806: @155633
     /* 155633 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(155675), // Rule ID 2579 //
     /* 155638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155641 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155648 */     // MIs[0] Rn
     /* 155648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155660 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 155663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155673 */     GIR_RootConstrainSelectedInstOperands,
     /* 155674 */     // GIR_Coverage, 2579,
     /* 155674 */     GIR_EraseRootFromParent_Done,
     /* 155675 */   // Label 2807: @155675
     /* 155675 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(155717), // Rule ID 2580 //
     /* 155680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155683 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155690 */     // MIs[0] Rn
     /* 155690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155702 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 155705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155715 */     GIR_RootConstrainSelectedInstOperands,
     /* 155716 */     // GIR_Coverage, 2580,
     /* 155716 */     GIR_EraseRootFromParent_Done,
     /* 155717 */   // Label 2808: @155717
     /* 155717 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(155759), // Rule ID 2581 //
     /* 155722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155732 */     // MIs[0] Rn
     /* 155732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155744 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 155747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155757 */     GIR_RootConstrainSelectedInstOperands,
     /* 155758 */     // GIR_Coverage, 2581,
     /* 155758 */     GIR_EraseRootFromParent_Done,
     /* 155759 */   // Label 2809: @155759
     /* 155759 */   GIM_Reject,
     /* 155760 */ // Label 2804: @155760
     /* 155760 */ GIM_Reject,
     /* 155761 */ // Label 2801: @155761
     /* 155761 */ GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(155987),
     /* 155766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155769 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155776 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(155818), // Rule ID 7397 //
     /* 155781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155791 */     // MIs[0] Rn
     /* 155791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155803 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 155806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155816 */     GIR_RootConstrainSelectedInstOperands,
     /* 155817 */     // GIR_Coverage, 7397,
     /* 155817 */     GIR_EraseRootFromParent_Done,
     /* 155818 */   // Label 2811: @155818
     /* 155818 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(155860), // Rule ID 7398 //
     /* 155823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155833 */     // MIs[0] Rn
     /* 155833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155845 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 155848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155858 */     GIR_RootConstrainSelectedInstOperands,
     /* 155859 */     // GIR_Coverage, 7398,
     /* 155859 */     GIR_EraseRootFromParent_Done,
     /* 155860 */   // Label 2812: @155860
     /* 155860 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(155902), // Rule ID 7399 //
     /* 155865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155875 */     // MIs[0] Rn
     /* 155875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155887 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 155890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155900 */     GIR_RootConstrainSelectedInstOperands,
     /* 155901 */     // GIR_Coverage, 7399,
     /* 155901 */     GIR_EraseRootFromParent_Done,
     /* 155902 */   // Label 2813: @155902
     /* 155902 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(155944), // Rule ID 7400 //
     /* 155907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155917 */     // MIs[0] Rn
     /* 155917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155929 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 155932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155942 */     GIR_RootConstrainSelectedInstOperands,
     /* 155943 */     // GIR_Coverage, 7400,
     /* 155943 */     GIR_EraseRootFromParent_Done,
     /* 155944 */   // Label 2814: @155944
     /* 155944 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(155986), // Rule ID 7401 //
     /* 155949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155959 */     // MIs[0] Rn
     /* 155959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155971 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 155974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155984 */     GIR_RootConstrainSelectedInstOperands,
     /* 155985 */     // GIR_Coverage, 7401,
     /* 155985 */     GIR_EraseRootFromParent_Done,
     /* 155986 */   // Label 2815: @155986
     /* 155986 */   GIM_Reject,
     /* 155987 */ // Label 2810: @155987
     /* 155987 */ GIM_Reject,
     /* 155988 */ // Label 2802: @155988
     /* 155988 */ GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(156214),
     /* 155993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155996 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156003 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(156045), // Rule ID 7402 //
     /* 156008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156011 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156018 */     // MIs[0] Rn
     /* 156018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156030 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 156033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156043 */     GIR_RootConstrainSelectedInstOperands,
     /* 156044 */     // GIR_Coverage, 7402,
     /* 156044 */     GIR_EraseRootFromParent_Done,
     /* 156045 */   // Label 2817: @156045
     /* 156045 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(156087), // Rule ID 7403 //
     /* 156050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156060 */     // MIs[0] Rn
     /* 156060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156072 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 156075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156085 */     GIR_RootConstrainSelectedInstOperands,
     /* 156086 */     // GIR_Coverage, 7403,
     /* 156086 */     GIR_EraseRootFromParent_Done,
     /* 156087 */   // Label 2818: @156087
     /* 156087 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(156129), // Rule ID 7404 //
     /* 156092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156102 */     // MIs[0] Rn
     /* 156102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156114 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 156117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156127 */     GIR_RootConstrainSelectedInstOperands,
     /* 156128 */     // GIR_Coverage, 7404,
     /* 156128 */     GIR_EraseRootFromParent_Done,
     /* 156129 */   // Label 2819: @156129
     /* 156129 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(156171), // Rule ID 7405 //
     /* 156134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156144 */     // MIs[0] Rn
     /* 156144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156156 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 156159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156169 */     GIR_RootConstrainSelectedInstOperands,
     /* 156170 */     // GIR_Coverage, 7405,
     /* 156170 */     GIR_EraseRootFromParent_Done,
     /* 156171 */   // Label 2820: @156171
     /* 156171 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(156213), // Rule ID 7406 //
     /* 156176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156186 */     // MIs[0] Rn
     /* 156186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156198 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 156201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156211 */     GIR_RootConstrainSelectedInstOperands,
     /* 156212 */     // GIR_Coverage, 7406,
     /* 156212 */     GIR_EraseRootFromParent_Done,
     /* 156213 */   // Label 2821: @156213
     /* 156213 */   GIM_Reject,
     /* 156214 */ // Label 2816: @156214
     /* 156214 */ GIM_Reject,
     /* 156215 */ // Label 2803: @156215
     /* 156215 */ GIM_Reject,
     /* 156216 */ // Label 32: @156216
     /* 156216 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2825*/ GIMT_Encode4(156920),
     /* 156227 */ /*GILLT_s16*//*Label 2822*/ GIMT_Encode4(156239),
     /* 156231 */ /*GILLT_s32*//*Label 2823*/ GIMT_Encode4(156466),
     /* 156235 */ /*GILLT_s64*//*Label 2824*/ GIMT_Encode4(156693),
     /* 156239 */ // Label 2822: @156239
     /* 156239 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(156465),
     /* 156244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156247 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156254 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(156296), // Rule ID 7407 //
     /* 156259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156269 */     // MIs[0] Rn
     /* 156269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156281 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 156284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156294 */     GIR_RootConstrainSelectedInstOperands,
     /* 156295 */     // GIR_Coverage, 7407,
     /* 156295 */     GIR_EraseRootFromParent_Done,
     /* 156296 */   // Label 2827: @156296
     /* 156296 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(156338), // Rule ID 7408 //
     /* 156301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156311 */     // MIs[0] Rn
     /* 156311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156323 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 156326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156336 */     GIR_RootConstrainSelectedInstOperands,
     /* 156337 */     // GIR_Coverage, 7408,
     /* 156337 */     GIR_EraseRootFromParent_Done,
     /* 156338 */   // Label 2828: @156338
     /* 156338 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(156380), // Rule ID 7409 //
     /* 156343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156346 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156353 */     // MIs[0] Rn
     /* 156353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156365 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 156368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156378 */     GIR_RootConstrainSelectedInstOperands,
     /* 156379 */     // GIR_Coverage, 7409,
     /* 156379 */     GIR_EraseRootFromParent_Done,
     /* 156380 */   // Label 2829: @156380
     /* 156380 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(156422), // Rule ID 7410 //
     /* 156385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156388 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156395 */     // MIs[0] Rn
     /* 156395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156407 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 156410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156420 */     GIR_RootConstrainSelectedInstOperands,
     /* 156421 */     // GIR_Coverage, 7410,
     /* 156421 */     GIR_EraseRootFromParent_Done,
     /* 156422 */   // Label 2830: @156422
     /* 156422 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(156464), // Rule ID 7411 //
     /* 156427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156437 */     // MIs[0] Rn
     /* 156437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156449 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 156452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156462 */     GIR_RootConstrainSelectedInstOperands,
     /* 156463 */     // GIR_Coverage, 7411,
     /* 156463 */     GIR_EraseRootFromParent_Done,
     /* 156464 */   // Label 2831: @156464
     /* 156464 */   GIM_Reject,
     /* 156465 */ // Label 2826: @156465
     /* 156465 */ GIM_Reject,
     /* 156466 */ // Label 2823: @156466
     /* 156466 */ GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(156692),
     /* 156471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156481 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(156523), // Rule ID 7412 //
     /* 156486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156496 */     // MIs[0] Rn
     /* 156496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156508 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 156511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156521 */     GIR_RootConstrainSelectedInstOperands,
     /* 156522 */     // GIR_Coverage, 7412,
     /* 156522 */     GIR_EraseRootFromParent_Done,
     /* 156523 */   // Label 2833: @156523
     /* 156523 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(156565), // Rule ID 7413 //
     /* 156528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156538 */     // MIs[0] Rn
     /* 156538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156550 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 156553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156563 */     GIR_RootConstrainSelectedInstOperands,
     /* 156564 */     // GIR_Coverage, 7413,
     /* 156564 */     GIR_EraseRootFromParent_Done,
     /* 156565 */   // Label 2834: @156565
     /* 156565 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(156607), // Rule ID 7414 //
     /* 156570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156580 */     // MIs[0] Rn
     /* 156580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156592 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 156595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156605 */     GIR_RootConstrainSelectedInstOperands,
     /* 156606 */     // GIR_Coverage, 7414,
     /* 156606 */     GIR_EraseRootFromParent_Done,
     /* 156607 */   // Label 2835: @156607
     /* 156607 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(156649), // Rule ID 7415 //
     /* 156612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156622 */     // MIs[0] Rn
     /* 156622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156634 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 156637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156647 */     GIR_RootConstrainSelectedInstOperands,
     /* 156648 */     // GIR_Coverage, 7415,
     /* 156648 */     GIR_EraseRootFromParent_Done,
     /* 156649 */   // Label 2836: @156649
     /* 156649 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(156691), // Rule ID 7416 //
     /* 156654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156664 */     // MIs[0] Rn
     /* 156664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156676 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 156679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156689 */     GIR_RootConstrainSelectedInstOperands,
     /* 156690 */     // GIR_Coverage, 7416,
     /* 156690 */     GIR_EraseRootFromParent_Done,
     /* 156691 */   // Label 2837: @156691
     /* 156691 */   GIM_Reject,
     /* 156692 */ // Label 2832: @156692
     /* 156692 */ GIM_Reject,
     /* 156693 */ // Label 2824: @156693
     /* 156693 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(156919),
     /* 156698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156701 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156708 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(156750), // Rule ID 7417 //
     /* 156713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156723 */     // MIs[0] Rn
     /* 156723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156735 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 156738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156748 */     GIR_RootConstrainSelectedInstOperands,
     /* 156749 */     // GIR_Coverage, 7417,
     /* 156749 */     GIR_EraseRootFromParent_Done,
     /* 156750 */   // Label 2839: @156750
     /* 156750 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(156792), // Rule ID 7418 //
     /* 156755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156765 */     // MIs[0] Rn
     /* 156765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156777 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 156780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156790 */     GIR_RootConstrainSelectedInstOperands,
     /* 156791 */     // GIR_Coverage, 7418,
     /* 156791 */     GIR_EraseRootFromParent_Done,
     /* 156792 */   // Label 2840: @156792
     /* 156792 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(156834), // Rule ID 7419 //
     /* 156797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156807 */     // MIs[0] Rn
     /* 156807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156819 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 156822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156832 */     GIR_RootConstrainSelectedInstOperands,
     /* 156833 */     // GIR_Coverage, 7419,
     /* 156833 */     GIR_EraseRootFromParent_Done,
     /* 156834 */   // Label 2841: @156834
     /* 156834 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(156876), // Rule ID 7420 //
     /* 156839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156849 */     // MIs[0] Rn
     /* 156849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156861 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 156864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156874 */     GIR_RootConstrainSelectedInstOperands,
     /* 156875 */     // GIR_Coverage, 7420,
     /* 156875 */     GIR_EraseRootFromParent_Done,
     /* 156876 */   // Label 2842: @156876
     /* 156876 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(156918), // Rule ID 7421 //
     /* 156881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156891 */     // MIs[0] Rn
     /* 156891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156903 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 156906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156916 */     GIR_RootConstrainSelectedInstOperands,
     /* 156917 */     // GIR_Coverage, 7421,
     /* 156917 */     GIR_EraseRootFromParent_Done,
     /* 156918 */   // Label 2843: @156918
     /* 156918 */   GIM_Reject,
     /* 156919 */ // Label 2838: @156919
     /* 156919 */ GIM_Reject,
     /* 156920 */ // Label 2825: @156920
     /* 156920 */ GIM_Reject,
     /* 156921 */ // Label 33: @156921
     /* 156921 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2847*/ GIMT_Encode4(157625),
     /* 156932 */ /*GILLT_s16*//*Label 2844*/ GIMT_Encode4(156944),
     /* 156936 */ /*GILLT_s32*//*Label 2845*/ GIMT_Encode4(157171),
     /* 156940 */ /*GILLT_s64*//*Label 2846*/ GIMT_Encode4(157398),
     /* 156944 */ // Label 2844: @156944
     /* 156944 */ GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(157170),
     /* 156949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156952 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156959 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(157001), // Rule ID 7422 //
     /* 156964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156974 */     // MIs[0] Rn
     /* 156974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156986 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 156989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156999 */     GIR_RootConstrainSelectedInstOperands,
     /* 157000 */     // GIR_Coverage, 7422,
     /* 157000 */     GIR_EraseRootFromParent_Done,
     /* 157001 */   // Label 2849: @157001
     /* 157001 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(157043), // Rule ID 7423 //
     /* 157006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157016 */     // MIs[0] Rn
     /* 157016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157028 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 157031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157041 */     GIR_RootConstrainSelectedInstOperands,
     /* 157042 */     // GIR_Coverage, 7423,
     /* 157042 */     GIR_EraseRootFromParent_Done,
     /* 157043 */   // Label 2850: @157043
     /* 157043 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(157085), // Rule ID 7424 //
     /* 157048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157058 */     // MIs[0] Rn
     /* 157058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157070 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 157073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157083 */     GIR_RootConstrainSelectedInstOperands,
     /* 157084 */     // GIR_Coverage, 7424,
     /* 157084 */     GIR_EraseRootFromParent_Done,
     /* 157085 */   // Label 2851: @157085
     /* 157085 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(157127), // Rule ID 7425 //
     /* 157090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157093 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157100 */     // MIs[0] Rn
     /* 157100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157112 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 157115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157125 */     GIR_RootConstrainSelectedInstOperands,
     /* 157126 */     // GIR_Coverage, 7425,
     /* 157126 */     GIR_EraseRootFromParent_Done,
     /* 157127 */   // Label 2852: @157127
     /* 157127 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(157169), // Rule ID 7426 //
     /* 157132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157142 */     // MIs[0] Rn
     /* 157142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157154 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 157157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157167 */     GIR_RootConstrainSelectedInstOperands,
     /* 157168 */     // GIR_Coverage, 7426,
     /* 157168 */     GIR_EraseRootFromParent_Done,
     /* 157169 */   // Label 2853: @157169
     /* 157169 */   GIM_Reject,
     /* 157170 */ // Label 2848: @157170
     /* 157170 */ GIM_Reject,
     /* 157171 */ // Label 2845: @157171
     /* 157171 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(157397),
     /* 157176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157179 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157186 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(157228), // Rule ID 7427 //
     /* 157191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157201 */     // MIs[0] Rn
     /* 157201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157213 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 157216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157226 */     GIR_RootConstrainSelectedInstOperands,
     /* 157227 */     // GIR_Coverage, 7427,
     /* 157227 */     GIR_EraseRootFromParent_Done,
     /* 157228 */   // Label 2855: @157228
     /* 157228 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(157270), // Rule ID 7428 //
     /* 157233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157243 */     // MIs[0] Rn
     /* 157243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157255 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 157258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157268 */     GIR_RootConstrainSelectedInstOperands,
     /* 157269 */     // GIR_Coverage, 7428,
     /* 157269 */     GIR_EraseRootFromParent_Done,
     /* 157270 */   // Label 2856: @157270
     /* 157270 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(157312), // Rule ID 7429 //
     /* 157275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157285 */     // MIs[0] Rn
     /* 157285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157297 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 157300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157310 */     GIR_RootConstrainSelectedInstOperands,
     /* 157311 */     // GIR_Coverage, 7429,
     /* 157311 */     GIR_EraseRootFromParent_Done,
     /* 157312 */   // Label 2857: @157312
     /* 157312 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(157354), // Rule ID 7430 //
     /* 157317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157327 */     // MIs[0] Rn
     /* 157327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157339 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 157342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157352 */     GIR_RootConstrainSelectedInstOperands,
     /* 157353 */     // GIR_Coverage, 7430,
     /* 157353 */     GIR_EraseRootFromParent_Done,
     /* 157354 */   // Label 2858: @157354
     /* 157354 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(157396), // Rule ID 7431 //
     /* 157359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157362 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157369 */     // MIs[0] Rn
     /* 157369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157381 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 157384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157394 */     GIR_RootConstrainSelectedInstOperands,
     /* 157395 */     // GIR_Coverage, 7431,
     /* 157395 */     GIR_EraseRootFromParent_Done,
     /* 157396 */   // Label 2859: @157396
     /* 157396 */   GIM_Reject,
     /* 157397 */ // Label 2854: @157397
     /* 157397 */ GIM_Reject,
     /* 157398 */ // Label 2846: @157398
     /* 157398 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(157624),
     /* 157403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157406 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157413 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(157455), // Rule ID 7432 //
     /* 157418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157428 */     // MIs[0] Rn
     /* 157428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157440 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 157443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157453 */     GIR_RootConstrainSelectedInstOperands,
     /* 157454 */     // GIR_Coverage, 7432,
     /* 157454 */     GIR_EraseRootFromParent_Done,
     /* 157455 */   // Label 2861: @157455
     /* 157455 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(157497), // Rule ID 7433 //
     /* 157460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157470 */     // MIs[0] Rn
     /* 157470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157482 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 157485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157495 */     GIR_RootConstrainSelectedInstOperands,
     /* 157496 */     // GIR_Coverage, 7433,
     /* 157496 */     GIR_EraseRootFromParent_Done,
     /* 157497 */   // Label 2862: @157497
     /* 157497 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(157539), // Rule ID 7434 //
     /* 157502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157512 */     // MIs[0] Rn
     /* 157512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157524 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 157527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157537 */     GIR_RootConstrainSelectedInstOperands,
     /* 157538 */     // GIR_Coverage, 7434,
     /* 157538 */     GIR_EraseRootFromParent_Done,
     /* 157539 */   // Label 2863: @157539
     /* 157539 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(157581), // Rule ID 7435 //
     /* 157544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157554 */     // MIs[0] Rn
     /* 157554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157566 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 157569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157579 */     GIR_RootConstrainSelectedInstOperands,
     /* 157580 */     // GIR_Coverage, 7435,
     /* 157580 */     GIR_EraseRootFromParent_Done,
     /* 157581 */   // Label 2864: @157581
     /* 157581 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(157623), // Rule ID 7436 //
     /* 157586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157596 */     // MIs[0] Rn
     /* 157596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157608 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 157611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157621 */     GIR_RootConstrainSelectedInstOperands,
     /* 157622 */     // GIR_Coverage, 7436,
     /* 157622 */     GIR_EraseRootFromParent_Done,
     /* 157623 */   // Label 2865: @157623
     /* 157623 */   GIM_Reject,
     /* 157624 */ // Label 2860: @157624
     /* 157624 */ GIM_Reject,
     /* 157625 */ // Label 2847: @157625
     /* 157625 */ GIM_Reject,
     /* 157626 */ // Label 34: @157626
     /* 157626 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2869*/ GIMT_Encode4(158330),
     /* 157637 */ /*GILLT_s16*//*Label 2866*/ GIMT_Encode4(157649),
     /* 157641 */ /*GILLT_s32*//*Label 2867*/ GIMT_Encode4(157876),
     /* 157645 */ /*GILLT_s64*//*Label 2868*/ GIMT_Encode4(158103),
     /* 157649 */ // Label 2866: @157649
     /* 157649 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(157875),
     /* 157654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157657 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157664 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(157706), // Rule ID 7437 //
     /* 157669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157679 */     // MIs[0] Rn
     /* 157679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157691 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_monotonic>>  =>  (LDFMAXH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXH),
     /* 157694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157704 */     GIR_RootConstrainSelectedInstOperands,
     /* 157705 */     // GIR_Coverage, 7437,
     /* 157705 */     GIR_EraseRootFromParent_Done,
     /* 157706 */   // Label 2871: @157706
     /* 157706 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(157748), // Rule ID 7438 //
     /* 157711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157721 */     // MIs[0] Rn
     /* 157721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157733 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acquire>>  =>  (LDFMAXAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAH),
     /* 157736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157746 */     GIR_RootConstrainSelectedInstOperands,
     /* 157747 */     // GIR_Coverage, 7438,
     /* 157747 */     GIR_EraseRootFromParent_Done,
     /* 157748 */   // Label 2872: @157748
     /* 157748 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(157790), // Rule ID 7439 //
     /* 157753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157756 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157763 */     // MIs[0] Rn
     /* 157763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157775 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_release>>  =>  (LDFMAXLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLH),
     /* 157778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157788 */     GIR_RootConstrainSelectedInstOperands,
     /* 157789 */     // GIR_Coverage, 7439,
     /* 157789 */     GIR_EraseRootFromParent_Done,
     /* 157790 */   // Label 2873: @157790
     /* 157790 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(157832), // Rule ID 7440 //
     /* 157795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157805 */     // MIs[0] Rn
     /* 157805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157817 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acq_rel>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 157820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157830 */     GIR_RootConstrainSelectedInstOperands,
     /* 157831 */     // GIR_Coverage, 7440,
     /* 157831 */     GIR_EraseRootFromParent_Done,
     /* 157832 */   // Label 2874: @157832
     /* 157832 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(157874), // Rule ID 7441 //
     /* 157837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157840 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157847 */     // MIs[0] Rn
     /* 157847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157859 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_seq_cst>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 157862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157872 */     GIR_RootConstrainSelectedInstOperands,
     /* 157873 */     // GIR_Coverage, 7441,
     /* 157873 */     GIR_EraseRootFromParent_Done,
     /* 157874 */   // Label 2875: @157874
     /* 157874 */   GIM_Reject,
     /* 157875 */ // Label 2870: @157875
     /* 157875 */ GIM_Reject,
     /* 157876 */ // Label 2867: @157876
     /* 157876 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(158102),
     /* 157881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157884 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157891 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(157933), // Rule ID 7442 //
     /* 157896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157906 */     // MIs[0] Rn
     /* 157906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157918 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_monotonic>>  =>  (LDFMAXS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXS),
     /* 157921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157931 */     GIR_RootConstrainSelectedInstOperands,
     /* 157932 */     // GIR_Coverage, 7442,
     /* 157932 */     GIR_EraseRootFromParent_Done,
     /* 157933 */   // Label 2877: @157933
     /* 157933 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(157975), // Rule ID 7443 //
     /* 157938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157948 */     // MIs[0] Rn
     /* 157948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157960 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acquire>>  =>  (LDFMAXAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAS),
     /* 157963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157973 */     GIR_RootConstrainSelectedInstOperands,
     /* 157974 */     // GIR_Coverage, 7443,
     /* 157974 */     GIR_EraseRootFromParent_Done,
     /* 157975 */   // Label 2878: @157975
     /* 157975 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(158017), // Rule ID 7444 //
     /* 157980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157990 */     // MIs[0] Rn
     /* 157990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158002 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_release>>  =>  (LDFMAXLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLS),
     /* 158005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158015 */     GIR_RootConstrainSelectedInstOperands,
     /* 158016 */     // GIR_Coverage, 7444,
     /* 158016 */     GIR_EraseRootFromParent_Done,
     /* 158017 */   // Label 2879: @158017
     /* 158017 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(158059), // Rule ID 7445 //
     /* 158022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158032 */     // MIs[0] Rn
     /* 158032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158044 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acq_rel>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 158047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158057 */     GIR_RootConstrainSelectedInstOperands,
     /* 158058 */     // GIR_Coverage, 7445,
     /* 158058 */     GIR_EraseRootFromParent_Done,
     /* 158059 */   // Label 2880: @158059
     /* 158059 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(158101), // Rule ID 7446 //
     /* 158064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158074 */     // MIs[0] Rn
     /* 158074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158086 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_seq_cst>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 158089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158099 */     GIR_RootConstrainSelectedInstOperands,
     /* 158100 */     // GIR_Coverage, 7446,
     /* 158100 */     GIR_EraseRootFromParent_Done,
     /* 158101 */   // Label 2881: @158101
     /* 158101 */   GIM_Reject,
     /* 158102 */ // Label 2876: @158102
     /* 158102 */ GIM_Reject,
     /* 158103 */ // Label 2868: @158103
     /* 158103 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(158329),
     /* 158108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158118 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(158160), // Rule ID 7447 //
     /* 158123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158133 */     // MIs[0] Rn
     /* 158133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158145 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_monotonic>>  =>  (LDFMAXD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXD),
     /* 158148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158158 */     GIR_RootConstrainSelectedInstOperands,
     /* 158159 */     // GIR_Coverage, 7447,
     /* 158159 */     GIR_EraseRootFromParent_Done,
     /* 158160 */   // Label 2883: @158160
     /* 158160 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(158202), // Rule ID 7448 //
     /* 158165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158175 */     // MIs[0] Rn
     /* 158175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158187 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acquire>>  =>  (LDFMAXAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAD),
     /* 158190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158200 */     GIR_RootConstrainSelectedInstOperands,
     /* 158201 */     // GIR_Coverage, 7448,
     /* 158201 */     GIR_EraseRootFromParent_Done,
     /* 158202 */   // Label 2884: @158202
     /* 158202 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(158244), // Rule ID 7449 //
     /* 158207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158217 */     // MIs[0] Rn
     /* 158217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158229 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_release>>  =>  (LDFMAXLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLD),
     /* 158232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158242 */     GIR_RootConstrainSelectedInstOperands,
     /* 158243 */     // GIR_Coverage, 7449,
     /* 158243 */     GIR_EraseRootFromParent_Done,
     /* 158244 */   // Label 2885: @158244
     /* 158244 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(158286), // Rule ID 7450 //
     /* 158249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158259 */     // MIs[0] Rn
     /* 158259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158271 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acq_rel>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 158274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158284 */     GIR_RootConstrainSelectedInstOperands,
     /* 158285 */     // GIR_Coverage, 7450,
     /* 158285 */     GIR_EraseRootFromParent_Done,
     /* 158286 */   // Label 2886: @158286
     /* 158286 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(158328), // Rule ID 7451 //
     /* 158291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158301 */     // MIs[0] Rn
     /* 158301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158313 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_seq_cst>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 158316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158326 */     GIR_RootConstrainSelectedInstOperands,
     /* 158327 */     // GIR_Coverage, 7451,
     /* 158327 */     GIR_EraseRootFromParent_Done,
     /* 158328 */   // Label 2887: @158328
     /* 158328 */   GIM_Reject,
     /* 158329 */ // Label 2882: @158329
     /* 158329 */ GIM_Reject,
     /* 158330 */ // Label 2869: @158330
     /* 158330 */ GIM_Reject,
     /* 158331 */ // Label 35: @158331
     /* 158331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2891*/ GIMT_Encode4(159035),
     /* 158342 */ /*GILLT_s16*//*Label 2888*/ GIMT_Encode4(158354),
     /* 158346 */ /*GILLT_s32*//*Label 2889*/ GIMT_Encode4(158581),
     /* 158350 */ /*GILLT_s64*//*Label 2890*/ GIMT_Encode4(158808),
     /* 158354 */ // Label 2888: @158354
     /* 158354 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(158580),
     /* 158359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158362 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158369 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(158411), // Rule ID 7452 //
     /* 158374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158384 */     // MIs[0] Rn
     /* 158384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158396 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_monotonic>>  =>  (LDFMINH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINH),
     /* 158399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158409 */     GIR_RootConstrainSelectedInstOperands,
     /* 158410 */     // GIR_Coverage, 7452,
     /* 158410 */     GIR_EraseRootFromParent_Done,
     /* 158411 */   // Label 2893: @158411
     /* 158411 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(158453), // Rule ID 7453 //
     /* 158416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158426 */     // MIs[0] Rn
     /* 158426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158438 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acquire>>  =>  (LDFMINAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAH),
     /* 158441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158451 */     GIR_RootConstrainSelectedInstOperands,
     /* 158452 */     // GIR_Coverage, 7453,
     /* 158452 */     GIR_EraseRootFromParent_Done,
     /* 158453 */   // Label 2894: @158453
     /* 158453 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(158495), // Rule ID 7454 //
     /* 158458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158461 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158468 */     // MIs[0] Rn
     /* 158468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158480 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_release>>  =>  (LDFMINLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLH),
     /* 158483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158493 */     GIR_RootConstrainSelectedInstOperands,
     /* 158494 */     // GIR_Coverage, 7454,
     /* 158494 */     GIR_EraseRootFromParent_Done,
     /* 158495 */   // Label 2895: @158495
     /* 158495 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(158537), // Rule ID 7455 //
     /* 158500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158503 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158510 */     // MIs[0] Rn
     /* 158510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158522 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acq_rel>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 158525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158535 */     GIR_RootConstrainSelectedInstOperands,
     /* 158536 */     // GIR_Coverage, 7455,
     /* 158536 */     GIR_EraseRootFromParent_Done,
     /* 158537 */   // Label 2896: @158537
     /* 158537 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(158579), // Rule ID 7456 //
     /* 158542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158545 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158552 */     // MIs[0] Rn
     /* 158552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158564 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_seq_cst>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 158567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158577 */     GIR_RootConstrainSelectedInstOperands,
     /* 158578 */     // GIR_Coverage, 7456,
     /* 158578 */     GIR_EraseRootFromParent_Done,
     /* 158579 */   // Label 2897: @158579
     /* 158579 */   GIM_Reject,
     /* 158580 */ // Label 2892: @158580
     /* 158580 */ GIM_Reject,
     /* 158581 */ // Label 2889: @158581
     /* 158581 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(158807),
     /* 158586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158589 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158596 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(158638), // Rule ID 7457 //
     /* 158601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158611 */     // MIs[0] Rn
     /* 158611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158623 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_monotonic>>  =>  (LDFMINS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINS),
     /* 158626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158636 */     GIR_RootConstrainSelectedInstOperands,
     /* 158637 */     // GIR_Coverage, 7457,
     /* 158637 */     GIR_EraseRootFromParent_Done,
     /* 158638 */   // Label 2899: @158638
     /* 158638 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(158680), // Rule ID 7458 //
     /* 158643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158653 */     // MIs[0] Rn
     /* 158653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158665 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acquire>>  =>  (LDFMINAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAS),
     /* 158668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158678 */     GIR_RootConstrainSelectedInstOperands,
     /* 158679 */     // GIR_Coverage, 7458,
     /* 158679 */     GIR_EraseRootFromParent_Done,
     /* 158680 */   // Label 2900: @158680
     /* 158680 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(158722), // Rule ID 7459 //
     /* 158685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158695 */     // MIs[0] Rn
     /* 158695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158707 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_release>>  =>  (LDFMINLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLS),
     /* 158710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158720 */     GIR_RootConstrainSelectedInstOperands,
     /* 158721 */     // GIR_Coverage, 7459,
     /* 158721 */     GIR_EraseRootFromParent_Done,
     /* 158722 */   // Label 2901: @158722
     /* 158722 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(158764), // Rule ID 7460 //
     /* 158727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158737 */     // MIs[0] Rn
     /* 158737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158749 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acq_rel>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 158752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158762 */     GIR_RootConstrainSelectedInstOperands,
     /* 158763 */     // GIR_Coverage, 7460,
     /* 158763 */     GIR_EraseRootFromParent_Done,
     /* 158764 */   // Label 2902: @158764
     /* 158764 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(158806), // Rule ID 7461 //
     /* 158769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158779 */     // MIs[0] Rn
     /* 158779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158791 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_seq_cst>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 158794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158804 */     GIR_RootConstrainSelectedInstOperands,
     /* 158805 */     // GIR_Coverage, 7461,
     /* 158805 */     GIR_EraseRootFromParent_Done,
     /* 158806 */   // Label 2903: @158806
     /* 158806 */   GIM_Reject,
     /* 158807 */ // Label 2898: @158807
     /* 158807 */ GIM_Reject,
     /* 158808 */ // Label 2890: @158808
     /* 158808 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(159034),
     /* 158813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158823 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(158865), // Rule ID 7462 //
     /* 158828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158838 */     // MIs[0] Rn
     /* 158838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158850 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_monotonic>>  =>  (LDFMIND:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMIND),
     /* 158853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158863 */     GIR_RootConstrainSelectedInstOperands,
     /* 158864 */     // GIR_Coverage, 7462,
     /* 158864 */     GIR_EraseRootFromParent_Done,
     /* 158865 */   // Label 2905: @158865
     /* 158865 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(158907), // Rule ID 7463 //
     /* 158870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158880 */     // MIs[0] Rn
     /* 158880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158892 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acquire>>  =>  (LDFMINAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAD),
     /* 158895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158905 */     GIR_RootConstrainSelectedInstOperands,
     /* 158906 */     // GIR_Coverage, 7463,
     /* 158906 */     GIR_EraseRootFromParent_Done,
     /* 158907 */   // Label 2906: @158907
     /* 158907 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(158949), // Rule ID 7464 //
     /* 158912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158922 */     // MIs[0] Rn
     /* 158922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158934 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_release>>  =>  (LDFMINLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLD),
     /* 158937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158947 */     GIR_RootConstrainSelectedInstOperands,
     /* 158948 */     // GIR_Coverage, 7464,
     /* 158948 */     GIR_EraseRootFromParent_Done,
     /* 158949 */   // Label 2907: @158949
     /* 158949 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(158991), // Rule ID 7465 //
     /* 158954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158964 */     // MIs[0] Rn
     /* 158964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158976 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acq_rel>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 158979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158989 */     GIR_RootConstrainSelectedInstOperands,
     /* 158990 */     // GIR_Coverage, 7465,
     /* 158990 */     GIR_EraseRootFromParent_Done,
     /* 158991 */   // Label 2908: @158991
     /* 158991 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(159033), // Rule ID 7466 //
     /* 158996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159006 */     // MIs[0] Rn
     /* 159006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159018 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_seq_cst>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 159021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159031 */     GIR_RootConstrainSelectedInstOperands,
     /* 159032 */     // GIR_Coverage, 7466,
     /* 159032 */     GIR_EraseRootFromParent_Done,
     /* 159033 */   // Label 2909: @159033
     /* 159033 */   GIM_Reject,
     /* 159034 */ // Label 2904: @159034
     /* 159034 */ GIM_Reject,
     /* 159035 */ // Label 2891: @159035
     /* 159035 */ GIM_Reject,
     /* 159036 */ // Label 36: @159036
     /* 159036 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(159063), // Rule ID 7052 //
     /* 159041 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159044 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 159048 */   // MIs[0] Operand 1
     /* 159048 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 159051 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 159051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 159054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 159057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159061 */   GIR_RootConstrainSelectedInstOperands,
     /* 159062 */   // GIR_Coverage, 7052,
     /* 159062 */   GIR_EraseRootFromParent_Done,
     /* 159063 */ // Label 2910: @159063
     /* 159063 */ GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(159086), // Rule ID 7053 //
     /* 159068 */   // MIs[0] Operand 0
     /* 159068 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 159071 */   // MIs[0] Operand 1
     /* 159071 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 159074 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 159074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 159077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 159080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159084 */   GIR_RootConstrainSelectedInstOperands,
     /* 159085 */   // GIR_Coverage, 7053,
     /* 159085 */   GIR_EraseRootFromParent_Done,
     /* 159086 */ // Label 2911: @159086
     /* 159086 */ GIM_Reject,
     /* 159087 */ // Label 37: @159087
     /* 159087 */ GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(171614),
     /* 159092 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 159095 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(159186), // Rule ID 6531 //
     /* 159100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 159103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 159108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 159111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159126 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159129 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 159134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159138 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 159142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159154 */     // (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 519:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 159154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 159157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 159161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 159170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 159174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 159179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159184 */     GIR_RootConstrainSelectedInstOperands,
     /* 159185 */     // GIR_Coverage, 6531,
     /* 159185 */     GIR_EraseRootFromParent_Done,
     /* 159186 */   // Label 2913: @159186
     /* 159186 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(159277), // Rule ID 6532 //
     /* 159191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 159194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 159199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 159202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159217 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159220 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 159225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159229 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 159233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159245 */     // (intrinsic_wo_chain:{ *:[v16i8] } 520:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 159245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 159248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 159252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159257 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 159261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 159265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 159270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159275 */     GIR_RootConstrainSelectedInstOperands,
     /* 159276 */     // GIR_Coverage, 6532,
     /* 159276 */     GIR_EraseRootFromParent_Done,
     /* 159277 */   // Label 2914: @159277
     /* 159277 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(159338), // Rule ID 4931 //
     /* 159282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 159287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159314 */     // MIs[1] Operand 2
     /* 159314 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 159325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159327 */     // (intrinsic_wo_chain:{ *:[v4f32] } 774:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 159327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 159330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 159336 */     GIR_RootConstrainSelectedInstOperands,
     /* 159337 */     // GIR_Coverage, 4931,
     /* 159337 */     GIR_EraseRootFromParent_Done,
     /* 159338 */   // Label 2915: @159338
     /* 159338 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(159378), // Rule ID 2644 //
     /* 159343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 159351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159358 */     // MIs[0] pattern
     /* 159358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159366 */     // (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 159369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159371 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159376 */     GIR_RootConstrainSelectedInstOperands,
     /* 159377 */     // GIR_Coverage, 2644,
     /* 159377 */     GIR_EraseRootFromParent_Done,
     /* 159378 */   // Label 2916: @159378
     /* 159378 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(159418), // Rule ID 9973 //
     /* 159383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 159391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159398 */     // MIs[0] pattern
     /* 159398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159406 */     // (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 159409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159411 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159416 */     GIR_RootConstrainSelectedInstOperands,
     /* 159417 */     // GIR_Coverage, 9973,
     /* 159417 */     GIR_EraseRootFromParent_Done,
     /* 159418 */   // Label 2917: @159418
     /* 159418 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(159458), // Rule ID 9976 //
     /* 159423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 159431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159438 */     // MIs[0] pattern
     /* 159438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159446 */     // (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 159449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159451 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159456 */     GIR_RootConstrainSelectedInstOperands,
     /* 159457 */     // GIR_Coverage, 9976,
     /* 159457 */     GIR_EraseRootFromParent_Done,
     /* 159458 */   // Label 2918: @159458
     /* 159458 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(159498), // Rule ID 9979 //
     /* 159463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 159471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159478 */     // MIs[0] pattern
     /* 159478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159486 */     // (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 159489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159491 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159496 */     GIR_RootConstrainSelectedInstOperands,
     /* 159497 */     // GIR_Coverage, 9979,
     /* 159497 */     GIR_EraseRootFromParent_Done,
     /* 159498 */   // Label 2919: @159498
     /* 159498 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(159537), // Rule ID 66 //
     /* 159503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 159506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 159511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159525 */     // (intrinsic_wo_chain:{ *:[i32] } 553:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 159528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 159535 */     GIR_RootConstrainSelectedInstOperands,
     /* 159536 */     // GIR_Coverage, 66,
     /* 159536 */     GIR_EraseRootFromParent_Done,
     /* 159537 */   // Label 2920: @159537
     /* 159537 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(159573), // Rule ID 346 //
     /* 159542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159564 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 159567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159571 */     GIR_RootConstrainSelectedInstOperands,
     /* 159572 */     // GIR_Coverage, 346,
     /* 159572 */     GIR_EraseRootFromParent_Done,
     /* 159573 */   // Label 2921: @159573
     /* 159573 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(159609), // Rule ID 347 //
     /* 159578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159600 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 159600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 159603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159607 */     GIR_RootConstrainSelectedInstOperands,
     /* 159608 */     // GIR_Coverage, 347,
     /* 159608 */     GIR_EraseRootFromParent_Done,
     /* 159609 */   // Label 2922: @159609
     /* 159609 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(159645), // Rule ID 348 //
     /* 159614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159636 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 159636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 159639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159643 */     GIR_RootConstrainSelectedInstOperands,
     /* 159644 */     // GIR_Coverage, 348,
     /* 159644 */     GIR_EraseRootFromParent_Done,
     /* 159645 */   // Label 2923: @159645
     /* 159645 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(159681), // Rule ID 349 //
     /* 159650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159672 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 159672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 159675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159679 */     GIR_RootConstrainSelectedInstOperands,
     /* 159680 */     // GIR_Coverage, 349,
     /* 159680 */     GIR_EraseRootFromParent_Done,
     /* 159681 */   // Label 2924: @159681
     /* 159681 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(159717), // Rule ID 350 //
     /* 159686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159708 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 159711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159715 */     GIR_RootConstrainSelectedInstOperands,
     /* 159716 */     // GIR_Coverage, 350,
     /* 159716 */     GIR_EraseRootFromParent_Done,
     /* 159717 */   // Label 2925: @159717
     /* 159717 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(159753), // Rule ID 351 //
     /* 159722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159744 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 159744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 159747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159751 */     GIR_RootConstrainSelectedInstOperands,
     /* 159752 */     // GIR_Coverage, 351,
     /* 159752 */     GIR_EraseRootFromParent_Done,
     /* 159753 */   // Label 2926: @159753
     /* 159753 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(159789), // Rule ID 352 //
     /* 159758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159780 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 159783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159787 */     GIR_RootConstrainSelectedInstOperands,
     /* 159788 */     // GIR_Coverage, 352,
     /* 159788 */     GIR_EraseRootFromParent_Done,
     /* 159789 */   // Label 2927: @159789
     /* 159789 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(159825), // Rule ID 353 //
     /* 159794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159816 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 159816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 159819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159823 */     GIR_RootConstrainSelectedInstOperands,
     /* 159824 */     // GIR_Coverage, 353,
     /* 159824 */     GIR_EraseRootFromParent_Done,
     /* 159825 */   // Label 2928: @159825
     /* 159825 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(159861), // Rule ID 354 //
     /* 159830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159852 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 159852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 159855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159859 */     GIR_RootConstrainSelectedInstOperands,
     /* 159860 */     // GIR_Coverage, 354,
     /* 159860 */     GIR_EraseRootFromParent_Done,
     /* 159861 */   // Label 2929: @159861
     /* 159861 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(159897), // Rule ID 355 //
     /* 159866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159888 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 159888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 159891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159895 */     GIR_RootConstrainSelectedInstOperands,
     /* 159896 */     // GIR_Coverage, 355,
     /* 159896 */     GIR_EraseRootFromParent_Done,
     /* 159897 */   // Label 2930: @159897
     /* 159897 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(159933), // Rule ID 356 //
     /* 159902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159924 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 159927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159931 */     GIR_RootConstrainSelectedInstOperands,
     /* 159932 */     // GIR_Coverage, 356,
     /* 159932 */     GIR_EraseRootFromParent_Done,
     /* 159933 */   // Label 2931: @159933
     /* 159933 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(159969), // Rule ID 357 //
     /* 159938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159960 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 159960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 159963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159967 */     GIR_RootConstrainSelectedInstOperands,
     /* 159968 */     // GIR_Coverage, 357,
     /* 159968 */     GIR_EraseRootFromParent_Done,
     /* 159969 */   // Label 2932: @159969
     /* 159969 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(160005), // Rule ID 358 //
     /* 159974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 159982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159996 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 159999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160003 */     GIR_RootConstrainSelectedInstOperands,
     /* 160004 */     // GIR_Coverage, 358,
     /* 160004 */     GIR_EraseRootFromParent_Done,
     /* 160005 */   // Label 2933: @160005
     /* 160005 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(160041), // Rule ID 359 //
     /* 160010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160032 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 160035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160039 */     GIR_RootConstrainSelectedInstOperands,
     /* 160040 */     // GIR_Coverage, 359,
     /* 160040 */     GIR_EraseRootFromParent_Done,
     /* 160041 */   // Label 2934: @160041
     /* 160041 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(160077), // Rule ID 360 //
     /* 160046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160068 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 160071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160075 */     GIR_RootConstrainSelectedInstOperands,
     /* 160076 */     // GIR_Coverage, 360,
     /* 160076 */     GIR_EraseRootFromParent_Done,
     /* 160077 */   // Label 2935: @160077
     /* 160077 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(160113), // Rule ID 361 //
     /* 160082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160104 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 160107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160111 */     GIR_RootConstrainSelectedInstOperands,
     /* 160112 */     // GIR_Coverage, 361,
     /* 160112 */     GIR_EraseRootFromParent_Done,
     /* 160113 */   // Label 2936: @160113
     /* 160113 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(160149), // Rule ID 362 //
     /* 160118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160140 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 160143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160147 */     GIR_RootConstrainSelectedInstOperands,
     /* 160148 */     // GIR_Coverage, 362,
     /* 160148 */     GIR_EraseRootFromParent_Done,
     /* 160149 */   // Label 2937: @160149
     /* 160149 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(160185), // Rule ID 363 //
     /* 160154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160176 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 160179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160183 */     GIR_RootConstrainSelectedInstOperands,
     /* 160184 */     // GIR_Coverage, 363,
     /* 160184 */     GIR_EraseRootFromParent_Done,
     /* 160185 */   // Label 2938: @160185
     /* 160185 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(160221), // Rule ID 364 //
     /* 160190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160212 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 160215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160219 */     GIR_RootConstrainSelectedInstOperands,
     /* 160220 */     // GIR_Coverage, 364,
     /* 160220 */     GIR_EraseRootFromParent_Done,
     /* 160221 */   // Label 2939: @160221
     /* 160221 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(160257), // Rule ID 365 //
     /* 160226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160248 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 160251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160255 */     GIR_RootConstrainSelectedInstOperands,
     /* 160256 */     // GIR_Coverage, 365,
     /* 160256 */     GIR_EraseRootFromParent_Done,
     /* 160257 */   // Label 2940: @160257
     /* 160257 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(160293), // Rule ID 366 //
     /* 160262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160284 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 160287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160291 */     GIR_RootConstrainSelectedInstOperands,
     /* 160292 */     // GIR_Coverage, 366,
     /* 160292 */     GIR_EraseRootFromParent_Done,
     /* 160293 */   // Label 2941: @160293
     /* 160293 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(160329), // Rule ID 367 //
     /* 160298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160320 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 160323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160327 */     GIR_RootConstrainSelectedInstOperands,
     /* 160328 */     // GIR_Coverage, 367,
     /* 160328 */     GIR_EraseRootFromParent_Done,
     /* 160329 */   // Label 2942: @160329
     /* 160329 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(160365), // Rule ID 368 //
     /* 160334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160356 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 160359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160363 */     GIR_RootConstrainSelectedInstOperands,
     /* 160364 */     // GIR_Coverage, 368,
     /* 160364 */     GIR_EraseRootFromParent_Done,
     /* 160365 */   // Label 2943: @160365
     /* 160365 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(160401), // Rule ID 369 //
     /* 160370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160392 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 160395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160399 */     GIR_RootConstrainSelectedInstOperands,
     /* 160400 */     // GIR_Coverage, 369,
     /* 160400 */     GIR_EraseRootFromParent_Done,
     /* 160401 */   // Label 2944: @160401
     /* 160401 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(160437), // Rule ID 370 //
     /* 160406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160428 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 160431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160435 */     GIR_RootConstrainSelectedInstOperands,
     /* 160436 */     // GIR_Coverage, 370,
     /* 160436 */     GIR_EraseRootFromParent_Done,
     /* 160437 */   // Label 2945: @160437
     /* 160437 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(160473), // Rule ID 371 //
     /* 160442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160464 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 160467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160471 */     GIR_RootConstrainSelectedInstOperands,
     /* 160472 */     // GIR_Coverage, 371,
     /* 160472 */     GIR_EraseRootFromParent_Done,
     /* 160473 */   // Label 2946: @160473
     /* 160473 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(160509), // Rule ID 372 //
     /* 160478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160500 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 160503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160507 */     GIR_RootConstrainSelectedInstOperands,
     /* 160508 */     // GIR_Coverage, 372,
     /* 160508 */     GIR_EraseRootFromParent_Done,
     /* 160509 */   // Label 2947: @160509
     /* 160509 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(160545), // Rule ID 373 //
     /* 160514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160536 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 160539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160543 */     GIR_RootConstrainSelectedInstOperands,
     /* 160544 */     // GIR_Coverage, 373,
     /* 160544 */     GIR_EraseRootFromParent_Done,
     /* 160545 */   // Label 2948: @160545
     /* 160545 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(160581), // Rule ID 374 //
     /* 160550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160572 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 160575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160579 */     GIR_RootConstrainSelectedInstOperands,
     /* 160580 */     // GIR_Coverage, 374,
     /* 160580 */     GIR_EraseRootFromParent_Done,
     /* 160581 */   // Label 2949: @160581
     /* 160581 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(160617), // Rule ID 375 //
     /* 160586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160608 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 160611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160615 */     GIR_RootConstrainSelectedInstOperands,
     /* 160616 */     // GIR_Coverage, 375,
     /* 160616 */     GIR_EraseRootFromParent_Done,
     /* 160617 */   // Label 2950: @160617
     /* 160617 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(160653), // Rule ID 376 //
     /* 160622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160644 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 160647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160651 */     GIR_RootConstrainSelectedInstOperands,
     /* 160652 */     // GIR_Coverage, 376,
     /* 160652 */     GIR_EraseRootFromParent_Done,
     /* 160653 */   // Label 2951: @160653
     /* 160653 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(160689), // Rule ID 377 //
     /* 160658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160680 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 160683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160687 */     GIR_RootConstrainSelectedInstOperands,
     /* 160688 */     // GIR_Coverage, 377,
     /* 160688 */     GIR_EraseRootFromParent_Done,
     /* 160689 */   // Label 2952: @160689
     /* 160689 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(160725), // Rule ID 378 //
     /* 160694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160716 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 160719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160723 */     GIR_RootConstrainSelectedInstOperands,
     /* 160724 */     // GIR_Coverage, 378,
     /* 160724 */     GIR_EraseRootFromParent_Done,
     /* 160725 */   // Label 2953: @160725
     /* 160725 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(160761), // Rule ID 379 //
     /* 160730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160752 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 160755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160759 */     GIR_RootConstrainSelectedInstOperands,
     /* 160760 */     // GIR_Coverage, 379,
     /* 160760 */     GIR_EraseRootFromParent_Done,
     /* 160761 */   // Label 2954: @160761
     /* 160761 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(160797), // Rule ID 380 //
     /* 160766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160788 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 160791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160795 */     GIR_RootConstrainSelectedInstOperands,
     /* 160796 */     // GIR_Coverage, 380,
     /* 160796 */     GIR_EraseRootFromParent_Done,
     /* 160797 */   // Label 2955: @160797
     /* 160797 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(160833), // Rule ID 381 //
     /* 160802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160824 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 160827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160831 */     GIR_RootConstrainSelectedInstOperands,
     /* 160832 */     // GIR_Coverage, 381,
     /* 160832 */     GIR_EraseRootFromParent_Done,
     /* 160833 */   // Label 2956: @160833
     /* 160833 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(160869), // Rule ID 382 //
     /* 160838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160860 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 160863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160867 */     GIR_RootConstrainSelectedInstOperands,
     /* 160868 */     // GIR_Coverage, 382,
     /* 160868 */     GIR_EraseRootFromParent_Done,
     /* 160869 */   // Label 2957: @160869
     /* 160869 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(160905), // Rule ID 383 //
     /* 160874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160896 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 160899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160903 */     GIR_RootConstrainSelectedInstOperands,
     /* 160904 */     // GIR_Coverage, 383,
     /* 160904 */     GIR_EraseRootFromParent_Done,
     /* 160905 */   // Label 2958: @160905
     /* 160905 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(160941), // Rule ID 384 //
     /* 160910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160932 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 160935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160939 */     GIR_RootConstrainSelectedInstOperands,
     /* 160940 */     // GIR_Coverage, 384,
     /* 160940 */     GIR_EraseRootFromParent_Done,
     /* 160941 */   // Label 2959: @160941
     /* 160941 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(160977), // Rule ID 385 //
     /* 160946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160968 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 160971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160975 */     GIR_RootConstrainSelectedInstOperands,
     /* 160976 */     // GIR_Coverage, 385,
     /* 160976 */     GIR_EraseRootFromParent_Done,
     /* 160977 */   // Label 2960: @160977
     /* 160977 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(161013), // Rule ID 386 //
     /* 160982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161004 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 161007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161011 */     GIR_RootConstrainSelectedInstOperands,
     /* 161012 */     // GIR_Coverage, 386,
     /* 161012 */     GIR_EraseRootFromParent_Done,
     /* 161013 */   // Label 2961: @161013
     /* 161013 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(161049), // Rule ID 387 //
     /* 161018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 161026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161040 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 161043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161047 */     GIR_RootConstrainSelectedInstOperands,
     /* 161048 */     // GIR_Coverage, 387,
     /* 161048 */     GIR_EraseRootFromParent_Done,
     /* 161049 */   // Label 2962: @161049
     /* 161049 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(161085), // Rule ID 388 //
     /* 161054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161076 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 161079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161083 */     GIR_RootConstrainSelectedInstOperands,
     /* 161084 */     // GIR_Coverage, 388,
     /* 161084 */     GIR_EraseRootFromParent_Done,
     /* 161085 */   // Label 2963: @161085
     /* 161085 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(161121), // Rule ID 389 //
     /* 161090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161112 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 161115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161119 */     GIR_RootConstrainSelectedInstOperands,
     /* 161120 */     // GIR_Coverage, 389,
     /* 161120 */     GIR_EraseRootFromParent_Done,
     /* 161121 */   // Label 2964: @161121
     /* 161121 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(161157), // Rule ID 390 //
     /* 161126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161148 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 161151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161155 */     GIR_RootConstrainSelectedInstOperands,
     /* 161156 */     // GIR_Coverage, 390,
     /* 161156 */     GIR_EraseRootFromParent_Done,
     /* 161157 */   // Label 2965: @161157
     /* 161157 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(161193), // Rule ID 391 //
     /* 161162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161184 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 161187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161191 */     GIR_RootConstrainSelectedInstOperands,
     /* 161192 */     // GIR_Coverage, 391,
     /* 161192 */     GIR_EraseRootFromParent_Done,
     /* 161193 */   // Label 2966: @161193
     /* 161193 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(161229), // Rule ID 392 //
     /* 161198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161220 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 161223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161227 */     GIR_RootConstrainSelectedInstOperands,
     /* 161228 */     // GIR_Coverage, 392,
     /* 161228 */     GIR_EraseRootFromParent_Done,
     /* 161229 */   // Label 2967: @161229
     /* 161229 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(161265), // Rule ID 393 //
     /* 161234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161256 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 161259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161263 */     GIR_RootConstrainSelectedInstOperands,
     /* 161264 */     // GIR_Coverage, 393,
     /* 161264 */     GIR_EraseRootFromParent_Done,
     /* 161265 */   // Label 2968: @161265
     /* 161265 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(161301), // Rule ID 575 //
     /* 161270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 161278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161292 */     // (intrinsic_wo_chain:{ *:[f32] } 555:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 161295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161299 */     GIR_RootConstrainSelectedInstOperands,
     /* 161300 */     // GIR_Coverage, 575,
     /* 161300 */     GIR_EraseRootFromParent_Done,
     /* 161301 */   // Label 2969: @161301
     /* 161301 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(161337), // Rule ID 576 //
     /* 161306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 161314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161328 */     // (intrinsic_wo_chain:{ *:[f64] } 555:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 161331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161335 */     GIR_RootConstrainSelectedInstOperands,
     /* 161336 */     // GIR_Coverage, 576,
     /* 161336 */     GIR_EraseRootFromParent_Done,
     /* 161337 */   // Label 2970: @161337
     /* 161337 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(161373), // Rule ID 577 //
     /* 161342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 161350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161364 */     // (intrinsic_wo_chain:{ *:[f32] } 557:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 161367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161371 */     GIR_RootConstrainSelectedInstOperands,
     /* 161372 */     // GIR_Coverage, 577,
     /* 161372 */     GIR_EraseRootFromParent_Done,
     /* 161373 */   // Label 2971: @161373
     /* 161373 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(161409), // Rule ID 578 //
     /* 161378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 161386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161400 */     // (intrinsic_wo_chain:{ *:[f64] } 557:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 161403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161407 */     GIR_RootConstrainSelectedInstOperands,
     /* 161408 */     // GIR_Coverage, 578,
     /* 161408 */     GIR_EraseRootFromParent_Done,
     /* 161409 */   // Label 2972: @161409
     /* 161409 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(161445), // Rule ID 579 //
     /* 161414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 161422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161436 */     // (intrinsic_wo_chain:{ *:[f32] } 554:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 161439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161443 */     GIR_RootConstrainSelectedInstOperands,
     /* 161444 */     // GIR_Coverage, 579,
     /* 161444 */     GIR_EraseRootFromParent_Done,
     /* 161445 */   // Label 2973: @161445
     /* 161445 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(161481), // Rule ID 580 //
     /* 161450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 161458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161472 */     // (intrinsic_wo_chain:{ *:[f64] } 554:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 161475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161479 */     GIR_RootConstrainSelectedInstOperands,
     /* 161480 */     // GIR_Coverage, 580,
     /* 161480 */     GIR_EraseRootFromParent_Done,
     /* 161481 */   // Label 2974: @161481
     /* 161481 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(161517), // Rule ID 581 //
     /* 161486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 161494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161508 */     // (intrinsic_wo_chain:{ *:[f32] } 556:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 161511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161515 */     GIR_RootConstrainSelectedInstOperands,
     /* 161516 */     // GIR_Coverage, 581,
     /* 161516 */     GIR_EraseRootFromParent_Done,
     /* 161517 */   // Label 2975: @161517
     /* 161517 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(161553), // Rule ID 582 //
     /* 161522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 161530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161544 */     // (intrinsic_wo_chain:{ *:[f64] } 556:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 161547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161551 */     GIR_RootConstrainSelectedInstOperands,
     /* 161552 */     // GIR_Coverage, 582,
     /* 161552 */     GIR_EraseRootFromParent_Done,
     /* 161553 */   // Label 2976: @161553
     /* 161553 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(161589), // Rule ID 710 //
     /* 161558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161580 */     // (intrinsic_wo_chain:{ *:[v8i8] } 582:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 161580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 161583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161587 */     GIR_RootConstrainSelectedInstOperands,
     /* 161588 */     // GIR_Coverage, 710,
     /* 161588 */     GIR_EraseRootFromParent_Done,
     /* 161589 */   // Label 2977: @161589
     /* 161589 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(161625), // Rule ID 711 //
     /* 161594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161616 */     // (intrinsic_wo_chain:{ *:[v16i8] } 582:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 161616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 161619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161623 */     GIR_RootConstrainSelectedInstOperands,
     /* 161624 */     // GIR_Coverage, 711,
     /* 161624 */     GIR_EraseRootFromParent_Done,
     /* 161625 */   // Label 2978: @161625
     /* 161625 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(161661), // Rule ID 712 //
     /* 161630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161652 */     // (intrinsic_wo_chain:{ *:[v4i16] } 582:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 161652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 161655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161659 */     GIR_RootConstrainSelectedInstOperands,
     /* 161660 */     // GIR_Coverage, 712,
     /* 161660 */     GIR_EraseRootFromParent_Done,
     /* 161661 */   // Label 2979: @161661
     /* 161661 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(161697), // Rule ID 713 //
     /* 161666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161688 */     // (intrinsic_wo_chain:{ *:[v8i16] } 582:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 161688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 161691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161695 */     GIR_RootConstrainSelectedInstOperands,
     /* 161696 */     // GIR_Coverage, 713,
     /* 161696 */     GIR_EraseRootFromParent_Done,
     /* 161697 */   // Label 2980: @161697
     /* 161697 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(161733), // Rule ID 714 //
     /* 161702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161724 */     // (intrinsic_wo_chain:{ *:[v2i32] } 582:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 161724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 161727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161731 */     GIR_RootConstrainSelectedInstOperands,
     /* 161732 */     // GIR_Coverage, 714,
     /* 161732 */     GIR_EraseRootFromParent_Done,
     /* 161733 */   // Label 2981: @161733
     /* 161733 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(161769), // Rule ID 715 //
     /* 161738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161760 */     // (intrinsic_wo_chain:{ *:[v4i32] } 582:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 161760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 161763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161767 */     GIR_RootConstrainSelectedInstOperands,
     /* 161768 */     // GIR_Coverage, 715,
     /* 161768 */     GIR_EraseRootFromParent_Done,
     /* 161769 */   // Label 2982: @161769
     /* 161769 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(161805), // Rule ID 796 //
     /* 161774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161796 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 161796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 161799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161803 */     GIR_RootConstrainSelectedInstOperands,
     /* 161804 */     // GIR_Coverage, 796,
     /* 161804 */     GIR_EraseRootFromParent_Done,
     /* 161805 */   // Label 2983: @161805
     /* 161805 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(161841), // Rule ID 797 //
     /* 161810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161832 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 161832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 161835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161839 */     GIR_RootConstrainSelectedInstOperands,
     /* 161840 */     // GIR_Coverage, 797,
     /* 161840 */     GIR_EraseRootFromParent_Done,
     /* 161841 */   // Label 2984: @161841
     /* 161841 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(161877), // Rule ID 798 //
     /* 161846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161868 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 161868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 161871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161875 */     GIR_RootConstrainSelectedInstOperands,
     /* 161876 */     // GIR_Coverage, 798,
     /* 161876 */     GIR_EraseRootFromParent_Done,
     /* 161877 */   // Label 2985: @161877
     /* 161877 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(161913), // Rule ID 799 //
     /* 161882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161904 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 161904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 161907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161911 */     GIR_RootConstrainSelectedInstOperands,
     /* 161912 */     // GIR_Coverage, 799,
     /* 161912 */     GIR_EraseRootFromParent_Done,
     /* 161913 */   // Label 2986: @161913
     /* 161913 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(161949), // Rule ID 800 //
     /* 161918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161940 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 161940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 161943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161947 */     GIR_RootConstrainSelectedInstOperands,
     /* 161948 */     // GIR_Coverage, 800,
     /* 161948 */     GIR_EraseRootFromParent_Done,
     /* 161949 */   // Label 2987: @161949
     /* 161949 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(161985), // Rule ID 801 //
     /* 161954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161976 */     // (intrinsic_wo_chain:{ *:[v4i16] } 591:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 161976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 161979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161983 */     GIR_RootConstrainSelectedInstOperands,
     /* 161984 */     // GIR_Coverage, 801,
     /* 161984 */     GIR_EraseRootFromParent_Done,
     /* 161985 */   // Label 2988: @161985
     /* 161985 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(162021), // Rule ID 802 //
     /* 161990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 591:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 162015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162019 */     GIR_RootConstrainSelectedInstOperands,
     /* 162020 */     // GIR_Coverage, 802,
     /* 162020 */     GIR_EraseRootFromParent_Done,
     /* 162021 */   // Label 2989: @162021
     /* 162021 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(162057), // Rule ID 803 //
     /* 162026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 162034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162048 */     // (intrinsic_wo_chain:{ *:[v2i32] } 591:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 162051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162055 */     GIR_RootConstrainSelectedInstOperands,
     /* 162056 */     // GIR_Coverage, 803,
     /* 162056 */     GIR_EraseRootFromParent_Done,
     /* 162057 */   // Label 2990: @162057
     /* 162057 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(162093), // Rule ID 804 //
     /* 162062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 162070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 591:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 162087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162091 */     GIR_RootConstrainSelectedInstOperands,
     /* 162092 */     // GIR_Coverage, 804,
     /* 162092 */     GIR_EraseRootFromParent_Done,
     /* 162093 */   // Label 2991: @162093
     /* 162093 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(162129), // Rule ID 805 //
     /* 162098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 162106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162120 */     // (intrinsic_wo_chain:{ *:[v2i64] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 162123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162127 */     GIR_RootConstrainSelectedInstOperands,
     /* 162128 */     // GIR_Coverage, 805,
     /* 162128 */     GIR_EraseRootFromParent_Done,
     /* 162129 */   // Label 2992: @162129
     /* 162129 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(162165), // Rule ID 806 //
     /* 162134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162156 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 162159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162163 */     GIR_RootConstrainSelectedInstOperands,
     /* 162164 */     // GIR_Coverage, 806,
     /* 162164 */     GIR_EraseRootFromParent_Done,
     /* 162165 */   // Label 2993: @162165
     /* 162165 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(162201), // Rule ID 807 //
     /* 162170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162192 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 162195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162199 */     GIR_RootConstrainSelectedInstOperands,
     /* 162200 */     // GIR_Coverage, 807,
     /* 162200 */     GIR_EraseRootFromParent_Done,
     /* 162201 */   // Label 2994: @162201
     /* 162201 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(162237), // Rule ID 808 //
     /* 162206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162228 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 162231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162235 */     GIR_RootConstrainSelectedInstOperands,
     /* 162236 */     // GIR_Coverage, 808,
     /* 162236 */     GIR_EraseRootFromParent_Done,
     /* 162237 */   // Label 2995: @162237
     /* 162237 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(162273), // Rule ID 809 //
     /* 162242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 162267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162271 */     GIR_RootConstrainSelectedInstOperands,
     /* 162272 */     // GIR_Coverage, 809,
     /* 162272 */     GIR_EraseRootFromParent_Done,
     /* 162273 */   // Label 2996: @162273
     /* 162273 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(162309), // Rule ID 810 //
     /* 162278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162300 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 162303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162307 */     GIR_RootConstrainSelectedInstOperands,
     /* 162308 */     // GIR_Coverage, 810,
     /* 162308 */     GIR_EraseRootFromParent_Done,
     /* 162309 */   // Label 2997: @162309
     /* 162309 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(162345), // Rule ID 811 //
     /* 162314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162336 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 162339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162343 */     GIR_RootConstrainSelectedInstOperands,
     /* 162344 */     // GIR_Coverage, 811,
     /* 162344 */     GIR_EraseRootFromParent_Done,
     /* 162345 */   // Label 2998: @162345
     /* 162345 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(162381), // Rule ID 812 //
     /* 162350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162372 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 162375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162379 */     GIR_RootConstrainSelectedInstOperands,
     /* 162380 */     // GIR_Coverage, 812,
     /* 162380 */     GIR_EraseRootFromParent_Done,
     /* 162381 */   // Label 2999: @162381
     /* 162381 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(162417), // Rule ID 813 //
     /* 162386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162408 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 162411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162415 */     GIR_RootConstrainSelectedInstOperands,
     /* 162416 */     // GIR_Coverage, 813,
     /* 162416 */     GIR_EraseRootFromParent_Done,
     /* 162417 */   // Label 3000: @162417
     /* 162417 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(162453), // Rule ID 814 //
     /* 162422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162444 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 162447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162451 */     GIR_RootConstrainSelectedInstOperands,
     /* 162452 */     // GIR_Coverage, 814,
     /* 162452 */     GIR_EraseRootFromParent_Done,
     /* 162453 */   // Label 3001: @162453
     /* 162453 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(162489), // Rule ID 815 //
     /* 162458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162480 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 162483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162487 */     GIR_RootConstrainSelectedInstOperands,
     /* 162488 */     // GIR_Coverage, 815,
     /* 162488 */     GIR_EraseRootFromParent_Done,
     /* 162489 */   // Label 3002: @162489
     /* 162489 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(162525), // Rule ID 816 //
     /* 162494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 594:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 162519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162523 */     GIR_RootConstrainSelectedInstOperands,
     /* 162524 */     // GIR_Coverage, 816,
     /* 162524 */     GIR_EraseRootFromParent_Done,
     /* 162525 */   // Label 3003: @162525
     /* 162525 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(162561), // Rule ID 817 //
     /* 162530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162552 */     // (intrinsic_wo_chain:{ *:[v8i16] } 594:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 162555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162559 */     GIR_RootConstrainSelectedInstOperands,
     /* 162560 */     // GIR_Coverage, 817,
     /* 162560 */     GIR_EraseRootFromParent_Done,
     /* 162561 */   // Label 3004: @162561
     /* 162561 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(162597), // Rule ID 818 //
     /* 162566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162588 */     // (intrinsic_wo_chain:{ *:[v2i32] } 594:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 162591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162595 */     GIR_RootConstrainSelectedInstOperands,
     /* 162596 */     // GIR_Coverage, 818,
     /* 162596 */     GIR_EraseRootFromParent_Done,
     /* 162597 */   // Label 3005: @162597
     /* 162597 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(162633), // Rule ID 819 //
     /* 162602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 594:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 162627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162631 */     GIR_RootConstrainSelectedInstOperands,
     /* 162632 */     // GIR_Coverage, 819,
     /* 162632 */     GIR_EraseRootFromParent_Done,
     /* 162633 */   // Label 3006: @162633
     /* 162633 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(162669), // Rule ID 820 //
     /* 162638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162660 */     // (intrinsic_wo_chain:{ *:[v2i64] } 594:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 162663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162667 */     GIR_RootConstrainSelectedInstOperands,
     /* 162668 */     // GIR_Coverage, 820,
     /* 162668 */     GIR_EraseRootFromParent_Done,
     /* 162669 */   // Label 3007: @162669
     /* 162669 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(162705), // Rule ID 821 //
     /* 162674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162696 */     // (intrinsic_wo_chain:{ *:[v4i16] } 595:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 162699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162703 */     GIR_RootConstrainSelectedInstOperands,
     /* 162704 */     // GIR_Coverage, 821,
     /* 162704 */     GIR_EraseRootFromParent_Done,
     /* 162705 */   // Label 3008: @162705
     /* 162705 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(162741), // Rule ID 822 //
     /* 162710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162732 */     // (intrinsic_wo_chain:{ *:[v8i16] } 595:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 162735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162739 */     GIR_RootConstrainSelectedInstOperands,
     /* 162740 */     // GIR_Coverage, 822,
     /* 162740 */     GIR_EraseRootFromParent_Done,
     /* 162741 */   // Label 3009: @162741
     /* 162741 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(162777), // Rule ID 823 //
     /* 162746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162768 */     // (intrinsic_wo_chain:{ *:[v2i32] } 595:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 162771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162775 */     GIR_RootConstrainSelectedInstOperands,
     /* 162776 */     // GIR_Coverage, 823,
     /* 162776 */     GIR_EraseRootFromParent_Done,
     /* 162777 */   // Label 3010: @162777
     /* 162777 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(162813), // Rule ID 824 //
     /* 162782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162804 */     // (intrinsic_wo_chain:{ *:[v4i32] } 595:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 162807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162811 */     GIR_RootConstrainSelectedInstOperands,
     /* 162812 */     // GIR_Coverage, 824,
     /* 162812 */     GIR_EraseRootFromParent_Done,
     /* 162813 */   // Label 3011: @162813
     /* 162813 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(162849), // Rule ID 825 //
     /* 162818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162840 */     // (intrinsic_wo_chain:{ *:[v2i64] } 595:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 162843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162847 */     GIR_RootConstrainSelectedInstOperands,
     /* 162848 */     // GIR_Coverage, 825,
     /* 162848 */     GIR_EraseRootFromParent_Done,
     /* 162849 */   // Label 3012: @162849
     /* 162849 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(162885), // Rule ID 826 //
     /* 162854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162876 */     // (intrinsic_wo_chain:{ *:[v4i16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 162879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162883 */     GIR_RootConstrainSelectedInstOperands,
     /* 162884 */     // GIR_Coverage, 826,
     /* 162884 */     GIR_EraseRootFromParent_Done,
     /* 162885 */   // Label 3013: @162885
     /* 162885 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(162921), // Rule ID 827 //
     /* 162890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162912 */     // (intrinsic_wo_chain:{ *:[v8i16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 162915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162919 */     GIR_RootConstrainSelectedInstOperands,
     /* 162920 */     // GIR_Coverage, 827,
     /* 162920 */     GIR_EraseRootFromParent_Done,
     /* 162921 */   // Label 3014: @162921
     /* 162921 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(162957), // Rule ID 828 //
     /* 162926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162948 */     // (intrinsic_wo_chain:{ *:[v2i32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 162951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162955 */     GIR_RootConstrainSelectedInstOperands,
     /* 162956 */     // GIR_Coverage, 828,
     /* 162956 */     GIR_EraseRootFromParent_Done,
     /* 162957 */   // Label 3015: @162957
     /* 162957 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(162993), // Rule ID 829 //
     /* 162962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 162987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162991 */     GIR_RootConstrainSelectedInstOperands,
     /* 162992 */     // GIR_Coverage, 829,
     /* 162992 */     GIR_EraseRootFromParent_Done,
     /* 162993 */   // Label 3016: @162993
     /* 162993 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(163029), // Rule ID 830 //
     /* 162998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 163006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163020 */     // (intrinsic_wo_chain:{ *:[v2i64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 163023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163027 */     GIR_RootConstrainSelectedInstOperands,
     /* 163028 */     // GIR_Coverage, 830,
     /* 163028 */     GIR_EraseRootFromParent_Done,
     /* 163029 */   // Label 3017: @163029
     /* 163029 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(163065), // Rule ID 831 //
     /* 163034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163056 */     // (intrinsic_wo_chain:{ *:[v4i16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 163059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163063 */     GIR_RootConstrainSelectedInstOperands,
     /* 163064 */     // GIR_Coverage, 831,
     /* 163064 */     GIR_EraseRootFromParent_Done,
     /* 163065 */   // Label 3018: @163065
     /* 163065 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(163101), // Rule ID 832 //
     /* 163070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163092 */     // (intrinsic_wo_chain:{ *:[v8i16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 163095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163099 */     GIR_RootConstrainSelectedInstOperands,
     /* 163100 */     // GIR_Coverage, 832,
     /* 163100 */     GIR_EraseRootFromParent_Done,
     /* 163101 */   // Label 3019: @163101
     /* 163101 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(163137), // Rule ID 833 //
     /* 163106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163128 */     // (intrinsic_wo_chain:{ *:[v2i32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 163131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163135 */     GIR_RootConstrainSelectedInstOperands,
     /* 163136 */     // GIR_Coverage, 833,
     /* 163136 */     GIR_EraseRootFromParent_Done,
     /* 163137 */   // Label 3020: @163137
     /* 163137 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(163173), // Rule ID 834 //
     /* 163142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 163167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163171 */     GIR_RootConstrainSelectedInstOperands,
     /* 163172 */     // GIR_Coverage, 834,
     /* 163172 */     GIR_EraseRootFromParent_Done,
     /* 163173 */   // Label 3021: @163173
     /* 163173 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(163209), // Rule ID 835 //
     /* 163178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163200 */     // (intrinsic_wo_chain:{ *:[v2i64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 163203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163207 */     GIR_RootConstrainSelectedInstOperands,
     /* 163208 */     // GIR_Coverage, 835,
     /* 163208 */     GIR_EraseRootFromParent_Done,
     /* 163209 */   // Label 3022: @163209
     /* 163209 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(163245), // Rule ID 836 //
     /* 163214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 163222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163236 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 163236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 163239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163243 */     GIR_RootConstrainSelectedInstOperands,
     /* 163244 */     // GIR_Coverage, 836,
     /* 163244 */     GIR_EraseRootFromParent_Done,
     /* 163245 */   // Label 3023: @163245
     /* 163245 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(163281), // Rule ID 863 //
     /* 163250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163272 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 163272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 163275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163279 */     GIR_RootConstrainSelectedInstOperands,
     /* 163280 */     // GIR_Coverage, 863,
     /* 163280 */     GIR_EraseRootFromParent_Done,
     /* 163281 */   // Label 3024: @163281
     /* 163281 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(163317), // Rule ID 864 //
     /* 163286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163308 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 163308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 163311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163315 */     GIR_RootConstrainSelectedInstOperands,
     /* 163316 */     // GIR_Coverage, 864,
     /* 163316 */     GIR_EraseRootFromParent_Done,
     /* 163317 */   // Label 3025: @163317
     /* 163317 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(163353), // Rule ID 865 //
     /* 163322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163344 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 163347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163351 */     GIR_RootConstrainSelectedInstOperands,
     /* 163352 */     // GIR_Coverage, 865,
     /* 163352 */     GIR_EraseRootFromParent_Done,
     /* 163353 */   // Label 3026: @163353
     /* 163353 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(163389), // Rule ID 866 //
     /* 163358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163380 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 163383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163387 */     GIR_RootConstrainSelectedInstOperands,
     /* 163388 */     // GIR_Coverage, 866,
     /* 163388 */     GIR_EraseRootFromParent_Done,
     /* 163389 */   // Label 3027: @163389
     /* 163389 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(163425), // Rule ID 867 //
     /* 163394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163416 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 163419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163423 */     GIR_RootConstrainSelectedInstOperands,
     /* 163424 */     // GIR_Coverage, 867,
     /* 163424 */     GIR_EraseRootFromParent_Done,
     /* 163425 */   // Label 3028: @163425
     /* 163425 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(163461), // Rule ID 938 //
     /* 163430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163452 */     // (intrinsic_wo_chain:{ *:[v2f32] } 643:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 163455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163459 */     GIR_RootConstrainSelectedInstOperands,
     /* 163460 */     // GIR_Coverage, 938,
     /* 163460 */     GIR_EraseRootFromParent_Done,
     /* 163461 */   // Label 3029: @163461
     /* 163461 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(163497), // Rule ID 939 //
     /* 163466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163488 */     // (intrinsic_wo_chain:{ *:[v4f32] } 643:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 163491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163495 */     GIR_RootConstrainSelectedInstOperands,
     /* 163496 */     // GIR_Coverage, 939,
     /* 163496 */     GIR_EraseRootFromParent_Done,
     /* 163497 */   // Label 3030: @163497
     /* 163497 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(163533), // Rule ID 940 //
     /* 163502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163524 */     // (intrinsic_wo_chain:{ *:[v2f64] } 643:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 163527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163531 */     GIR_RootConstrainSelectedInstOperands,
     /* 163532 */     // GIR_Coverage, 940,
     /* 163532 */     GIR_EraseRootFromParent_Done,
     /* 163533 */   // Label 3031: @163533
     /* 163533 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(163569), // Rule ID 941 //
     /* 163538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163560 */     // (intrinsic_wo_chain:{ *:[v2f32] } 645:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 163563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163567 */     GIR_RootConstrainSelectedInstOperands,
     /* 163568 */     // GIR_Coverage, 941,
     /* 163568 */     GIR_EraseRootFromParent_Done,
     /* 163569 */   // Label 3032: @163569
     /* 163569 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(163605), // Rule ID 942 //
     /* 163574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163596 */     // (intrinsic_wo_chain:{ *:[v4f32] } 645:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 163599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163603 */     GIR_RootConstrainSelectedInstOperands,
     /* 163604 */     // GIR_Coverage, 942,
     /* 163604 */     GIR_EraseRootFromParent_Done,
     /* 163605 */   // Label 3033: @163605
     /* 163605 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(163641), // Rule ID 943 //
     /* 163610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163632 */     // (intrinsic_wo_chain:{ *:[v2f64] } 645:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 163635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163639 */     GIR_RootConstrainSelectedInstOperands,
     /* 163640 */     // GIR_Coverage, 943,
     /* 163640 */     GIR_EraseRootFromParent_Done,
     /* 163641 */   // Label 3034: @163641
     /* 163641 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(163677), // Rule ID 944 //
     /* 163646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163668 */     // (intrinsic_wo_chain:{ *:[v2f32] } 642:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 163671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163675 */     GIR_RootConstrainSelectedInstOperands,
     /* 163676 */     // GIR_Coverage, 944,
     /* 163676 */     GIR_EraseRootFromParent_Done,
     /* 163677 */   // Label 3035: @163677
     /* 163677 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(163713), // Rule ID 945 //
     /* 163682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163704 */     // (intrinsic_wo_chain:{ *:[v4f32] } 642:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 163707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163711 */     GIR_RootConstrainSelectedInstOperands,
     /* 163712 */     // GIR_Coverage, 945,
     /* 163712 */     GIR_EraseRootFromParent_Done,
     /* 163713 */   // Label 3036: @163713
     /* 163713 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(163749), // Rule ID 946 //
     /* 163718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163740 */     // (intrinsic_wo_chain:{ *:[v2f64] } 642:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 163743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163747 */     GIR_RootConstrainSelectedInstOperands,
     /* 163748 */     // GIR_Coverage, 946,
     /* 163748 */     GIR_EraseRootFromParent_Done,
     /* 163749 */   // Label 3037: @163749
     /* 163749 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(163785), // Rule ID 947 //
     /* 163754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163776 */     // (intrinsic_wo_chain:{ *:[v2f32] } 644:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 163779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163783 */     GIR_RootConstrainSelectedInstOperands,
     /* 163784 */     // GIR_Coverage, 947,
     /* 163784 */     GIR_EraseRootFromParent_Done,
     /* 163785 */   // Label 3038: @163785
     /* 163785 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(163821), // Rule ID 948 //
     /* 163790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163812 */     // (intrinsic_wo_chain:{ *:[v4f32] } 644:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 163815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163819 */     GIR_RootConstrainSelectedInstOperands,
     /* 163820 */     // GIR_Coverage, 948,
     /* 163820 */     GIR_EraseRootFromParent_Done,
     /* 163821 */   // Label 3039: @163821
     /* 163821 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(163857), // Rule ID 949 //
     /* 163826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163848 */     // (intrinsic_wo_chain:{ *:[v2f64] } 644:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 163851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163855 */     GIR_RootConstrainSelectedInstOperands,
     /* 163856 */     // GIR_Coverage, 949,
     /* 163856 */     GIR_EraseRootFromParent_Done,
     /* 163857 */   // Label 3040: @163857
     /* 163857 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(163893), // Rule ID 950 //
     /* 163862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163884 */     // (intrinsic_wo_chain:{ *:[v4f16] } 646:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 163884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 163887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163891 */     GIR_RootConstrainSelectedInstOperands,
     /* 163892 */     // GIR_Coverage, 950,
     /* 163892 */     GIR_EraseRootFromParent_Done,
     /* 163893 */   // Label 3041: @163893
     /* 163893 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(163929), // Rule ID 951 //
     /* 163898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163920 */     // (intrinsic_wo_chain:{ *:[v8f16] } 646:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 163920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 163923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163927 */     GIR_RootConstrainSelectedInstOperands,
     /* 163928 */     // GIR_Coverage, 951,
     /* 163928 */     GIR_EraseRootFromParent_Done,
     /* 163929 */   // Label 3042: @163929
     /* 163929 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(163965), // Rule ID 952 //
     /* 163934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163956 */     // (intrinsic_wo_chain:{ *:[v2f32] } 646:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 163959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163963 */     GIR_RootConstrainSelectedInstOperands,
     /* 163964 */     // GIR_Coverage, 952,
     /* 163964 */     GIR_EraseRootFromParent_Done,
     /* 163965 */   // Label 3043: @163965
     /* 163965 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(164001), // Rule ID 953 //
     /* 163970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163992 */     // (intrinsic_wo_chain:{ *:[v4f32] } 646:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 163995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163999 */     GIR_RootConstrainSelectedInstOperands,
     /* 164000 */     // GIR_Coverage, 953,
     /* 164000 */     GIR_EraseRootFromParent_Done,
     /* 164001 */   // Label 3044: @164001
     /* 164001 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(164037), // Rule ID 954 //
     /* 164006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 164014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164028 */     // (intrinsic_wo_chain:{ *:[v2f64] } 646:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 164028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 164031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164035 */     GIR_RootConstrainSelectedInstOperands,
     /* 164036 */     // GIR_Coverage, 954,
     /* 164036 */     GIR_EraseRootFromParent_Done,
     /* 164037 */   // Label 3045: @164037
     /* 164037 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(164073), // Rule ID 1001 //
     /* 164042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164064 */     // (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 164064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 164067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164071 */     GIR_RootConstrainSelectedInstOperands,
     /* 164072 */     // GIR_Coverage, 1001,
     /* 164072 */     GIR_EraseRootFromParent_Done,
     /* 164073 */   // Label 3046: @164073
     /* 164073 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(164109), // Rule ID 1003 //
     /* 164078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164100 */     // (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 164100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 164103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164107 */     GIR_RootConstrainSelectedInstOperands,
     /* 164108 */     // GIR_Coverage, 1003,
     /* 164108 */     GIR_EraseRootFromParent_Done,
     /* 164109 */   // Label 3047: @164109
     /* 164109 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(164145), // Rule ID 1005 //
     /* 164114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164136 */     // (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 164136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 164139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164143 */     GIR_RootConstrainSelectedInstOperands,
     /* 164144 */     // GIR_Coverage, 1005,
     /* 164144 */     GIR_EraseRootFromParent_Done,
     /* 164145 */   // Label 3048: @164145
     /* 164145 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(164181), // Rule ID 1007 //
     /* 164150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164172 */     // (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 164172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 164175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164179 */     GIR_RootConstrainSelectedInstOperands,
     /* 164180 */     // GIR_Coverage, 1007,
     /* 164180 */     GIR_EraseRootFromParent_Done,
     /* 164181 */   // Label 3049: @164181
     /* 164181 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(164217), // Rule ID 1009 //
     /* 164186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164208 */     // (intrinsic_wo_chain:{ *:[v1i64] } 667:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 164208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 164211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164215 */     GIR_RootConstrainSelectedInstOperands,
     /* 164216 */     // GIR_Coverage, 1009,
     /* 164216 */     GIR_EraseRootFromParent_Done,
     /* 164217 */   // Label 3050: @164217
     /* 164217 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(164253), // Rule ID 1011 //
     /* 164222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164244 */     // (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 164244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 164247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164251 */     GIR_RootConstrainSelectedInstOperands,
     /* 164252 */     // GIR_Coverage, 1011,
     /* 164252 */     GIR_EraseRootFromParent_Done,
     /* 164253 */   // Label 3051: @164253
     /* 164253 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(164289), // Rule ID 1022 //
     /* 164258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164280 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 164280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 164283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164287 */     GIR_RootConstrainSelectedInstOperands,
     /* 164288 */     // GIR_Coverage, 1022,
     /* 164288 */     GIR_EraseRootFromParent_Done,
     /* 164289 */   // Label 3052: @164289
     /* 164289 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(164325), // Rule ID 1023 //
     /* 164294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164316 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 164316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 164319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164323 */     GIR_RootConstrainSelectedInstOperands,
     /* 164324 */     // GIR_Coverage, 1023,
     /* 164324 */     GIR_EraseRootFromParent_Done,
     /* 164325 */   // Label 3053: @164325
     /* 164325 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(164361), // Rule ID 1024 //
     /* 164330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164352 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 164352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 164355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164359 */     GIR_RootConstrainSelectedInstOperands,
     /* 164360 */     // GIR_Coverage, 1024,
     /* 164360 */     GIR_EraseRootFromParent_Done,
     /* 164361 */   // Label 3054: @164361
     /* 164361 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(164397), // Rule ID 1025 //
     /* 164366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164388 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 164388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 164391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164395 */     GIR_RootConstrainSelectedInstOperands,
     /* 164396 */     // GIR_Coverage, 1025,
     /* 164396 */     GIR_EraseRootFromParent_Done,
     /* 164397 */   // Label 3055: @164397
     /* 164397 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(164433), // Rule ID 1026 //
     /* 164402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164424 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 164424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 164427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164431 */     GIR_RootConstrainSelectedInstOperands,
     /* 164432 */     // GIR_Coverage, 1026,
     /* 164432 */     GIR_EraseRootFromParent_Done,
     /* 164433 */   // Label 3056: @164433
     /* 164433 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(164469), // Rule ID 1027 //
     /* 164438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164460 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 164460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 164463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164467 */     GIR_RootConstrainSelectedInstOperands,
     /* 164468 */     // GIR_Coverage, 1027,
     /* 164468 */     GIR_EraseRootFromParent_Done,
     /* 164469 */   // Label 3057: @164469
     /* 164469 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(164505), // Rule ID 1028 //
     /* 164474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164496 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 164496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 164499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164503 */     GIR_RootConstrainSelectedInstOperands,
     /* 164504 */     // GIR_Coverage, 1028,
     /* 164504 */     GIR_EraseRootFromParent_Done,
     /* 164505 */   // Label 3058: @164505
     /* 164505 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(164541), // Rule ID 1029 //
     /* 164510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164532 */     // (intrinsic_wo_chain:{ *:[v8i8] } 692:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 164532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 164535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164539 */     GIR_RootConstrainSelectedInstOperands,
     /* 164540 */     // GIR_Coverage, 1029,
     /* 164540 */     GIR_EraseRootFromParent_Done,
     /* 164541 */   // Label 3059: @164541
     /* 164541 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(164577), // Rule ID 1030 //
     /* 164546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 692:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 164568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 164571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164575 */     GIR_RootConstrainSelectedInstOperands,
     /* 164576 */     // GIR_Coverage, 1030,
     /* 164576 */     GIR_EraseRootFromParent_Done,
     /* 164577 */   // Label 3060: @164577
     /* 164577 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(164613), // Rule ID 1031 //
     /* 164582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164604 */     // (intrinsic_wo_chain:{ *:[v4i16] } 692:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 164604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 164607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164611 */     GIR_RootConstrainSelectedInstOperands,
     /* 164612 */     // GIR_Coverage, 1031,
     /* 164612 */     GIR_EraseRootFromParent_Done,
     /* 164613 */   // Label 3061: @164613
     /* 164613 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(164649), // Rule ID 1032 //
     /* 164618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164640 */     // (intrinsic_wo_chain:{ *:[v8i16] } 692:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 164640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 164643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164647 */     GIR_RootConstrainSelectedInstOperands,
     /* 164648 */     // GIR_Coverage, 1032,
     /* 164648 */     GIR_EraseRootFromParent_Done,
     /* 164649 */   // Label 3062: @164649
     /* 164649 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(164685), // Rule ID 1033 //
     /* 164654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164676 */     // (intrinsic_wo_chain:{ *:[v2i32] } 692:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 164676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 164679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164683 */     GIR_RootConstrainSelectedInstOperands,
     /* 164684 */     // GIR_Coverage, 1033,
     /* 164684 */     GIR_EraseRootFromParent_Done,
     /* 164685 */   // Label 3063: @164685
     /* 164685 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(164721), // Rule ID 1034 //
     /* 164690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164712 */     // (intrinsic_wo_chain:{ *:[v4i32] } 692:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 164712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 164715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164719 */     GIR_RootConstrainSelectedInstOperands,
     /* 164720 */     // GIR_Coverage, 1034,
     /* 164720 */     GIR_EraseRootFromParent_Done,
     /* 164721 */   // Label 3064: @164721
     /* 164721 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(164757), // Rule ID 1035 //
     /* 164726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164748 */     // (intrinsic_wo_chain:{ *:[v2i64] } 692:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 164748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 164751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164755 */     GIR_RootConstrainSelectedInstOperands,
     /* 164756 */     // GIR_Coverage, 1035,
     /* 164756 */     GIR_EraseRootFromParent_Done,
     /* 164757 */   // Label 3065: @164757
     /* 164757 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(164793), // Rule ID 1062 //
     /* 164762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164784 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 164784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 164787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164791 */     GIR_RootConstrainSelectedInstOperands,
     /* 164792 */     // GIR_Coverage, 1062,
     /* 164792 */     GIR_EraseRootFromParent_Done,
     /* 164793 */   // Label 3066: @164793
     /* 164793 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(164829), // Rule ID 1064 //
     /* 164798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164820 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 164820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 164823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164827 */     GIR_RootConstrainSelectedInstOperands,
     /* 164828 */     // GIR_Coverage, 1064,
     /* 164828 */     GIR_EraseRootFromParent_Done,
     /* 164829 */   // Label 3067: @164829
     /* 164829 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(164865), // Rule ID 1066 //
     /* 164834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164856 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 164856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 164859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164863 */     GIR_RootConstrainSelectedInstOperands,
     /* 164864 */     // GIR_Coverage, 1066,
     /* 164864 */     GIR_EraseRootFromParent_Done,
     /* 164865 */   // Label 3068: @164865
     /* 164865 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(164901), // Rule ID 1068 //
     /* 164870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164892 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 164892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 164895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164899 */     GIR_RootConstrainSelectedInstOperands,
     /* 164900 */     // GIR_Coverage, 1068,
     /* 164900 */     GIR_EraseRootFromParent_Done,
     /* 164901 */   // Label 3069: @164901
     /* 164901 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(164937), // Rule ID 1070 //
     /* 164906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164928 */     // (intrinsic_wo_chain:{ *:[v1i64] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 164928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 164931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164935 */     GIR_RootConstrainSelectedInstOperands,
     /* 164936 */     // GIR_Coverage, 1070,
     /* 164936 */     GIR_EraseRootFromParent_Done,
     /* 164937 */   // Label 3070: @164937
     /* 164937 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(164973), // Rule ID 1072 //
     /* 164942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164964 */     // (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 164964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 164967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164971 */     GIR_RootConstrainSelectedInstOperands,
     /* 164972 */     // GIR_Coverage, 1072,
     /* 164972 */     GIR_EraseRootFromParent_Done,
     /* 164973 */   // Label 3071: @164973
     /* 164973 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(165009), // Rule ID 1086 //
     /* 164978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 164986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165000 */     // (intrinsic_wo_chain:{ *:[v2i32] } 753:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 165000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 165003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165007 */     GIR_RootConstrainSelectedInstOperands,
     /* 165008 */     // GIR_Coverage, 1086,
     /* 165008 */     GIR_EraseRootFromParent_Done,
     /* 165009 */   // Label 3072: @165009
     /* 165009 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(165045), // Rule ID 1087 //
     /* 165014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 165022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165036 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 165036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 165039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165043 */     GIR_RootConstrainSelectedInstOperands,
     /* 165044 */     // GIR_Coverage, 1087,
     /* 165044 */     GIR_EraseRootFromParent_Done,
     /* 165045 */   // Label 3073: @165045
     /* 165045 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(165081), // Rule ID 1088 //
     /* 165050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 165058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165072 */     // (intrinsic_wo_chain:{ *:[v2i32] } 756:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 165072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 165075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165079 */     GIR_RootConstrainSelectedInstOperands,
     /* 165080 */     // GIR_Coverage, 1088,
     /* 165080 */     GIR_EraseRootFromParent_Done,
     /* 165081 */   // Label 3074: @165081
     /* 165081 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(165117), // Rule ID 1089 //
     /* 165086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 165094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165108 */     // (intrinsic_wo_chain:{ *:[v4i32] } 756:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 165108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 165111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165115 */     GIR_RootConstrainSelectedInstOperands,
     /* 165116 */     // GIR_Coverage, 1089,
     /* 165116 */     GIR_EraseRootFromParent_Done,
     /* 165117 */   // Label 3075: @165117
     /* 165117 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(165153), // Rule ID 1653 //
     /* 165122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 165130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165144 */     // (intrinsic_wo_chain:{ *:[f32] } 793:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 165147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165151 */     GIR_RootConstrainSelectedInstOperands,
     /* 165152 */     // GIR_Coverage, 1653,
     /* 165152 */     GIR_EraseRootFromParent_Done,
     /* 165153 */   // Label 3076: @165153
     /* 165153 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(165189), // Rule ID 1659 //
     /* 165158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165180 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 165180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 165183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165187 */     GIR_RootConstrainSelectedInstOperands,
     /* 165188 */     // GIR_Coverage, 1659,
     /* 165188 */     GIR_EraseRootFromParent_Done,
     /* 165189 */   // Label 3077: @165189
     /* 165189 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(165225), // Rule ID 1660 //
     /* 165194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165216 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 165219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165223 */     GIR_RootConstrainSelectedInstOperands,
     /* 165224 */     // GIR_Coverage, 1660,
     /* 165224 */     GIR_EraseRootFromParent_Done,
     /* 165225 */   // Label 3078: @165225
     /* 165225 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(165261), // Rule ID 1661 //
     /* 165230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165252 */     // (intrinsic_wo_chain:{ *:[i64] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 165252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 165255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165259 */     GIR_RootConstrainSelectedInstOperands,
     /* 165260 */     // GIR_Coverage, 1661,
     /* 165260 */     GIR_EraseRootFromParent_Done,
     /* 165261 */   // Label 3079: @165261
     /* 165261 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(165297), // Rule ID 1662 //
     /* 165266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165288 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 165291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165295 */     GIR_RootConstrainSelectedInstOperands,
     /* 165296 */     // GIR_Coverage, 1662,
     /* 165296 */     GIR_EraseRootFromParent_Done,
     /* 165297 */   // Label 3080: @165297
     /* 165297 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(165333), // Rule ID 1663 //
     /* 165302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 165310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165324 */     // (intrinsic_wo_chain:{ *:[f32] } 670:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 165327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165331 */     GIR_RootConstrainSelectedInstOperands,
     /* 165332 */     // GIR_Coverage, 1663,
     /* 165332 */     GIR_EraseRootFromParent_Done,
     /* 165333 */   // Label 3081: @165333
     /* 165333 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(165369), // Rule ID 1664 //
     /* 165338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 165346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165360 */     // (intrinsic_wo_chain:{ *:[f32] } 671:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 165363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165367 */     GIR_RootConstrainSelectedInstOperands,
     /* 165368 */     // GIR_Coverage, 1664,
     /* 165368 */     GIR_EraseRootFromParent_Done,
     /* 165369 */   // Label 3082: @165369
     /* 165369 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(165405), // Rule ID 1670 //
     /* 165374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 165382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165396 */     // (intrinsic_wo_chain:{ *:[f32] } 672:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 165399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165403 */     GIR_RootConstrainSelectedInstOperands,
     /* 165404 */     // GIR_Coverage, 1670,
     /* 165404 */     GIR_EraseRootFromParent_Done,
     /* 165405 */   // Label 3083: @165405
     /* 165405 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(165441), // Rule ID 1943 //
     /* 165410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165432 */     // (intrinsic_wo_chain:{ *:[f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 165435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165439 */     GIR_RootConstrainSelectedInstOperands,
     /* 165440 */     // GIR_Coverage, 1943,
     /* 165440 */     GIR_EraseRootFromParent_Done,
     /* 165441 */   // Label 3084: @165441
     /* 165441 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(165477), // Rule ID 1945 //
     /* 165446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165468 */     // (intrinsic_wo_chain:{ *:[f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 165471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165475 */     GIR_RootConstrainSelectedInstOperands,
     /* 165476 */     // GIR_Coverage, 1945,
     /* 165476 */     GIR_EraseRootFromParent_Done,
     /* 165477 */   // Label 3085: @165477
     /* 165477 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(165513), // Rule ID 1947 //
     /* 165482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165504 */     // (intrinsic_wo_chain:{ *:[f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 165507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165511 */     GIR_RootConstrainSelectedInstOperands,
     /* 165512 */     // GIR_Coverage, 1947,
     /* 165512 */     GIR_EraseRootFromParent_Done,
     /* 165513 */   // Label 3086: @165513
     /* 165513 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(165549), // Rule ID 1949 //
     /* 165518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165540 */     // (intrinsic_wo_chain:{ *:[f16] } 606:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 165543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165547 */     GIR_RootConstrainSelectedInstOperands,
     /* 165548 */     // GIR_Coverage, 1949,
     /* 165548 */     GIR_EraseRootFromParent_Done,
     /* 165549 */   // Label 3087: @165549
     /* 165549 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(165585), // Rule ID 1951 //
     /* 165554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165576 */     // (intrinsic_wo_chain:{ *:[f16] } 606:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 165579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165583 */     GIR_RootConstrainSelectedInstOperands,
     /* 165584 */     // GIR_Coverage, 1951,
     /* 165584 */     GIR_EraseRootFromParent_Done,
     /* 165585 */   // Label 3088: @165585
     /* 165585 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(165621), // Rule ID 1953 //
     /* 165590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165612 */     // (intrinsic_wo_chain:{ *:[f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 165615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165619 */     GIR_RootConstrainSelectedInstOperands,
     /* 165620 */     // GIR_Coverage, 1953,
     /* 165620 */     GIR_EraseRootFromParent_Done,
     /* 165621 */   // Label 3089: @165621
     /* 165621 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(165657), // Rule ID 1955 //
     /* 165626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165648 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 165651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165655 */     GIR_RootConstrainSelectedInstOperands,
     /* 165656 */     // GIR_Coverage, 1955,
     /* 165656 */     GIR_EraseRootFromParent_Done,
     /* 165657 */   // Label 3090: @165657
     /* 165657 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(165693), // Rule ID 1957 //
     /* 165662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165684 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 165687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165691 */     GIR_RootConstrainSelectedInstOperands,
     /* 165692 */     // GIR_Coverage, 1957,
     /* 165692 */     GIR_EraseRootFromParent_Done,
     /* 165693 */   // Label 3091: @165693
     /* 165693 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(165729), // Rule ID 1959 //
     /* 165698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165720 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 165723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165727 */     GIR_RootConstrainSelectedInstOperands,
     /* 165728 */     // GIR_Coverage, 1959,
     /* 165728 */     GIR_EraseRootFromParent_Done,
     /* 165729 */   // Label 3092: @165729
     /* 165729 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(165765), // Rule ID 1961 //
     /* 165734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165756 */     // (intrinsic_wo_chain:{ *:[f16] } 612:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 165759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165763 */     GIR_RootConstrainSelectedInstOperands,
     /* 165764 */     // GIR_Coverage, 1961,
     /* 165764 */     GIR_EraseRootFromParent_Done,
     /* 165765 */   // Label 3093: @165765
     /* 165765 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(165801), // Rule ID 1963 //
     /* 165770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165792 */     // (intrinsic_wo_chain:{ *:[f16] } 612:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 165795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165799 */     GIR_RootConstrainSelectedInstOperands,
     /* 165800 */     // GIR_Coverage, 1963,
     /* 165800 */     GIR_EraseRootFromParent_Done,
     /* 165801 */   // Label 3094: @165801
     /* 165801 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(165837), // Rule ID 1965 //
     /* 165806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165828 */     // (intrinsic_wo_chain:{ *:[f32] } 612:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 165831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165835 */     GIR_RootConstrainSelectedInstOperands,
     /* 165836 */     // GIR_Coverage, 1965,
     /* 165836 */     GIR_EraseRootFromParent_Done,
     /* 165837 */   // Label 3095: @165837
     /* 165837 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(165873), // Rule ID 2305 //
     /* 165842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 165845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 165850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165864 */     // (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 165867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165871 */     GIR_RootConstrainSelectedInstOperands,
     /* 165872 */     // GIR_Coverage, 2305,
     /* 165872 */     GIR_EraseRootFromParent_Done,
     /* 165873 */   // Label 3096: @165873
     /* 165873 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(165909), // Rule ID 2306 //
     /* 165878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 165881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 165886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165900 */     // (intrinsic_wo_chain:{ *:[v16i8] } 520:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 165903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165907 */     GIR_RootConstrainSelectedInstOperands,
     /* 165908 */     // GIR_Coverage, 2306,
     /* 165908 */     GIR_EraseRootFromParent_Done,
     /* 165909 */   // Label 3097: @165909
     /* 165909 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(165945), // Rule ID 2314 //
     /* 165914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 165917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 165922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165936 */     // (intrinsic_wo_chain:{ *:[i32] } 528:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 165939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165943 */     GIR_RootConstrainSelectedInstOperands,
     /* 165944 */     // GIR_Coverage, 2314,
     /* 165944 */     GIR_EraseRootFromParent_Done,
     /* 165945 */   // Label 3098: @165945
     /* 165945 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(165981), // Rule ID 2508 //
     /* 165950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165972 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 165972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 165975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165979 */     GIR_RootConstrainSelectedInstOperands,
     /* 165980 */     // GIR_Coverage, 2508,
     /* 165980 */     GIR_EraseRootFromParent_Done,
     /* 165981 */   // Label 3099: @165981
     /* 165981 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(166020), // Rule ID 3541 //
     /* 165986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 165994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 165997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166008 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 166008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 166011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166018 */     GIR_RootConstrainSelectedInstOperands,
     /* 166019 */     // GIR_Coverage, 3541,
     /* 166019 */     GIR_EraseRootFromParent_Done,
     /* 166020 */   // Label 3100: @166020
     /* 166020 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(166059), // Rule ID 3542 //
     /* 166025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 166033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 166036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166047 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 166047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 166050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166057 */     GIR_RootConstrainSelectedInstOperands,
     /* 166058 */     // GIR_Coverage, 3542,
     /* 166058 */     GIR_EraseRootFromParent_Done,
     /* 166059 */   // Label 3101: @166059
     /* 166059 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(166098), // Rule ID 3543 //
     /* 166064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 166072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 166075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166086 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 166086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 166089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166096 */     GIR_RootConstrainSelectedInstOperands,
     /* 166097 */     // GIR_Coverage, 3543,
     /* 166097 */     GIR_EraseRootFromParent_Done,
     /* 166098 */   // Label 3102: @166098
     /* 166098 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(166137), // Rule ID 3544 //
     /* 166103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 166111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 166114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166125 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 166125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 166128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166135 */     GIR_RootConstrainSelectedInstOperands,
     /* 166136 */     // GIR_Coverage, 3544,
     /* 166136 */     GIR_EraseRootFromParent_Done,
     /* 166137 */   // Label 3103: @166137
     /* 166137 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(166193), // Rule ID 3548 //
     /* 166142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 166156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1636:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 166164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 166181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166191 */     GIR_RootConstrainSelectedInstOperands,
     /* 166192 */     // GIR_Coverage, 3548,
     /* 166192 */     GIR_EraseRootFromParent_Done,
     /* 166193 */   // Label 3104: @166193
     /* 166193 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(166249), // Rule ID 3549 //
     /* 166198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 166212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1636:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 166220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 166237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166247 */     GIR_RootConstrainSelectedInstOperands,
     /* 166248 */     // GIR_Coverage, 3549,
     /* 166248 */     GIR_EraseRootFromParent_Done,
     /* 166249 */   // Label 3105: @166249
     /* 166249 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(166305), // Rule ID 3550 //
     /* 166254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 166268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1636:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 166276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 166293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166303 */     GIR_RootConstrainSelectedInstOperands,
     /* 166304 */     // GIR_Coverage, 3550,
     /* 166304 */     GIR_EraseRootFromParent_Done,
     /* 166305 */   // Label 3106: @166305
     /* 166305 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(166361), // Rule ID 3551 //
     /* 166310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 166324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1636:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 166332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 166349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166359 */     GIR_RootConstrainSelectedInstOperands,
     /* 166360 */     // GIR_Coverage, 3551,
     /* 166360 */     GIR_EraseRootFromParent_Done,
     /* 166361 */   // Label 3107: @166361
     /* 166361 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(166394), // Rule ID 4006 //
     /* 166366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 166371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166385 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 166385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 166388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166392 */     GIR_RootConstrainSelectedInstOperands,
     /* 166393 */     // GIR_Coverage, 4006,
     /* 166393 */     GIR_EraseRootFromParent_Done,
     /* 166394 */   // Label 3108: @166394
     /* 166394 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(166459), // Rule ID 4007 //
     /* 166399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 166404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166418 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 166418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 166425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 166434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 166448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166458 */     // GIR_Coverage, 4007,
     /* 166458 */     GIR_EraseRootFromParent_Done,
     /* 166459 */   // Label 3109: @166459
     /* 166459 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(166492), // Rule ID 4813 //
     /* 166464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 166469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166483 */     // (intrinsic_wo_chain:{ *:[v1f64] } 643:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 166486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166490 */     GIR_RootConstrainSelectedInstOperands,
     /* 166491 */     // GIR_Coverage, 4813,
     /* 166491 */     GIR_EraseRootFromParent_Done,
     /* 166492 */   // Label 3110: @166492
     /* 166492 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(166525), // Rule ID 4814 //
     /* 166497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 166502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166516 */     // (intrinsic_wo_chain:{ *:[v1f64] } 645:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 166519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166523 */     GIR_RootConstrainSelectedInstOperands,
     /* 166524 */     // GIR_Coverage, 4814,
     /* 166524 */     GIR_EraseRootFromParent_Done,
     /* 166525 */   // Label 3111: @166525
     /* 166525 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(166558), // Rule ID 4815 //
     /* 166530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 166535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166549 */     // (intrinsic_wo_chain:{ *:[v1f64] } 642:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 166552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166556 */     GIR_RootConstrainSelectedInstOperands,
     /* 166557 */     // GIR_Coverage, 4815,
     /* 166557 */     GIR_EraseRootFromParent_Done,
     /* 166558 */   // Label 3112: @166558
     /* 166558 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(166591), // Rule ID 4816 //
     /* 166563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 166568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166582 */     // (intrinsic_wo_chain:{ *:[v1f64] } 644:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 166585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166589 */     GIR_RootConstrainSelectedInstOperands,
     /* 166590 */     // GIR_Coverage, 4816,
     /* 166590 */     GIR_EraseRootFromParent_Done,
     /* 166591 */   // Label 3113: @166591
     /* 166591 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(166624), // Rule ID 4930 //
     /* 166596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 166601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166615 */     // (intrinsic_wo_chain:{ *:[v4f32] } 774:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 166615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 166618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166622 */     GIR_RootConstrainSelectedInstOperands,
     /* 166623 */     // GIR_Coverage, 4930,
     /* 166623 */     GIR_EraseRootFromParent_Done,
     /* 166624 */   // Label 3114: @166624
     /* 166624 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(166657), // Rule ID 4940 //
     /* 166629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 166634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166648 */     // (intrinsic_wo_chain:{ *:[v4i16] } 771:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 166648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 166651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166655 */     GIR_RootConstrainSelectedInstOperands,
     /* 166656 */     // GIR_Coverage, 4940,
     /* 166656 */     GIR_EraseRootFromParent_Done,
     /* 166657 */   // Label 3115: @166657
     /* 166657 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(166693), // Rule ID 5261 //
     /* 166662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166684 */     // (intrinsic_wo_chain:{ *:[v1i64] } 692:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 166684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 166687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166691 */     GIR_RootConstrainSelectedInstOperands,
     /* 166692 */     // GIR_Coverage, 5261,
     /* 166692 */     GIR_EraseRootFromParent_Done,
     /* 166693 */   // Label 3116: @166693
     /* 166693 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(166726), // Rule ID 5264 //
     /* 166698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 166703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166717 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 166720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166724 */     GIR_RootConstrainSelectedInstOperands,
     /* 166725 */     // GIR_Coverage, 5264,
     /* 166725 */     GIR_EraseRootFromParent_Done,
     /* 166726 */   // Label 3117: @166726
     /* 166726 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(166759), // Rule ID 5265 //
     /* 166731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 166736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166750 */     // (intrinsic_wo_chain:{ *:[v1i64] } 591:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 166753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166757 */     GIR_RootConstrainSelectedInstOperands,
     /* 166758 */     // GIR_Coverage, 5265,
     /* 166758 */     GIR_EraseRootFromParent_Done,
     /* 166759 */   // Label 3118: @166759
     /* 166759 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(166792), // Rule ID 5266 //
     /* 166764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 166769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166783 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 166786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166790 */     GIR_RootConstrainSelectedInstOperands,
     /* 166791 */     // GIR_Coverage, 5266,
     /* 166791 */     GIR_EraseRootFromParent_Done,
     /* 166792 */   // Label 3119: @166792
     /* 166792 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(166825), // Rule ID 5267 //
     /* 166797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 166802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166816 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 166819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166823 */     GIR_RootConstrainSelectedInstOperands,
     /* 166824 */     // GIR_Coverage, 5267,
     /* 166824 */     GIR_EraseRootFromParent_Done,
     /* 166825 */   // Label 3120: @166825
     /* 166825 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(166858), // Rule ID 5268 //
     /* 166830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 166835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166849 */     // (intrinsic_wo_chain:{ *:[v1i64] } 594:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 166852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166856 */     GIR_RootConstrainSelectedInstOperands,
     /* 166857 */     // GIR_Coverage, 5268,
     /* 166857 */     GIR_EraseRootFromParent_Done,
     /* 166858 */   // Label 3121: @166858
     /* 166858 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(166891), // Rule ID 5269 //
     /* 166863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 166868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166882 */     // (intrinsic_wo_chain:{ *:[v1i64] } 595:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 166885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166889 */     GIR_RootConstrainSelectedInstOperands,
     /* 166890 */     // GIR_Coverage, 5269,
     /* 166890 */     GIR_EraseRootFromParent_Done,
     /* 166891 */   // Label 3122: @166891
     /* 166891 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(166924), // Rule ID 5270 //
     /* 166896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 166901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166915 */     // (intrinsic_wo_chain:{ *:[v1i64] } 596:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 166918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166922 */     GIR_RootConstrainSelectedInstOperands,
     /* 166923 */     // GIR_Coverage, 5270,
     /* 166923 */     GIR_EraseRootFromParent_Done,
     /* 166924 */   // Label 3123: @166924
     /* 166924 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(166957), // Rule ID 5271 //
     /* 166929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 166934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166948 */     // (intrinsic_wo_chain:{ *:[v1i64] } 597:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 166951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166955 */     GIR_RootConstrainSelectedInstOperands,
     /* 166956 */     // GIR_Coverage, 5271,
     /* 166956 */     GIR_EraseRootFromParent_Done,
     /* 166957 */   // Label 3124: @166957
     /* 166957 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(166990), // Rule ID 5272 //
     /* 166962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 166967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166981 */     // (intrinsic_wo_chain:{ *:[v1i64] } 599:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 166984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166988 */     GIR_RootConstrainSelectedInstOperands,
     /* 166989 */     // GIR_Coverage, 5272,
     /* 166989 */     GIR_EraseRootFromParent_Done,
     /* 166990 */   // Label 3125: @166990
     /* 166990 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(167023), // Rule ID 5273 //
     /* 166995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 167000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167014 */     // (intrinsic_wo_chain:{ *:[v1i64] } 600:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 167017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167021 */     GIR_RootConstrainSelectedInstOperands,
     /* 167022 */     // GIR_Coverage, 5273,
     /* 167022 */     GIR_EraseRootFromParent_Done,
     /* 167023 */   // Label 3126: @167023
     /* 167023 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(167056), // Rule ID 5274 //
     /* 167028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167047 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 167050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167054 */     GIR_RootConstrainSelectedInstOperands,
     /* 167055 */     // GIR_Coverage, 5274,
     /* 167055 */     GIR_EraseRootFromParent_Done,
     /* 167056 */   // Label 3127: @167056
     /* 167056 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(167089), // Rule ID 5275 //
     /* 167061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167080 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 167083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167087 */     GIR_RootConstrainSelectedInstOperands,
     /* 167088 */     // GIR_Coverage, 5275,
     /* 167088 */     GIR_EraseRootFromParent_Done,
     /* 167089 */   // Label 3128: @167089
     /* 167089 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(167122), // Rule ID 5276 //
     /* 167094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167113 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 167116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167120 */     GIR_RootConstrainSelectedInstOperands,
     /* 167121 */     // GIR_Coverage, 5276,
     /* 167121 */     GIR_EraseRootFromParent_Done,
     /* 167122 */   // Label 3129: @167122
     /* 167122 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(167155), // Rule ID 5277 //
     /* 167127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167146 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 167149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167153 */     GIR_RootConstrainSelectedInstOperands,
     /* 167154 */     // GIR_Coverage, 5277,
     /* 167154 */     GIR_EraseRootFromParent_Done,
     /* 167155 */   // Label 3130: @167155
     /* 167155 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(167188), // Rule ID 5289 //
     /* 167160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167179 */     // (intrinsic_wo_chain:{ *:[f16] } 641:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 167182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167186 */     GIR_RootConstrainSelectedInstOperands,
     /* 167187 */     // GIR_Coverage, 5289,
     /* 167187 */     GIR_EraseRootFromParent_Done,
     /* 167188 */   // Label 3131: @167188
     /* 167188 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(167221), // Rule ID 5290 //
     /* 167193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167212 */     // (intrinsic_wo_chain:{ *:[f32] } 641:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 167215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167219 */     GIR_RootConstrainSelectedInstOperands,
     /* 167220 */     // GIR_Coverage, 5290,
     /* 167220 */     GIR_EraseRootFromParent_Done,
     /* 167221 */   // Label 3132: @167221
     /* 167221 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(167254), // Rule ID 5291 //
     /* 167226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167245 */     // (intrinsic_wo_chain:{ *:[f64] } 641:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 167248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167252 */     GIR_RootConstrainSelectedInstOperands,
     /* 167253 */     // GIR_Coverage, 5291,
     /* 167253 */     GIR_EraseRootFromParent_Done,
     /* 167254 */   // Label 3133: @167254
     /* 167254 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(167287), // Rule ID 5292 //
     /* 167259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167278 */     // (intrinsic_wo_chain:{ *:[f16] } 646:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 167281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167285 */     GIR_RootConstrainSelectedInstOperands,
     /* 167286 */     // GIR_Coverage, 5292,
     /* 167286 */     GIR_EraseRootFromParent_Done,
     /* 167287 */   // Label 3134: @167287
     /* 167287 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(167320), // Rule ID 5293 //
     /* 167292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167311 */     // (intrinsic_wo_chain:{ *:[f32] } 646:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 167314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167318 */     GIR_RootConstrainSelectedInstOperands,
     /* 167319 */     // GIR_Coverage, 5293,
     /* 167319 */     GIR_EraseRootFromParent_Done,
     /* 167320 */   // Label 3135: @167320
     /* 167320 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(167353), // Rule ID 5294 //
     /* 167325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167344 */     // (intrinsic_wo_chain:{ *:[f64] } 646:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 167347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167351 */     GIR_RootConstrainSelectedInstOperands,
     /* 167352 */     // GIR_Coverage, 5294,
     /* 167352 */     GIR_EraseRootFromParent_Done,
     /* 167353 */   // Label 3136: @167353
     /* 167353 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(167386), // Rule ID 5295 //
     /* 167358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167377 */     // (intrinsic_wo_chain:{ *:[v1f64] } 646:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 167380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167384 */     GIR_RootConstrainSelectedInstOperands,
     /* 167385 */     // GIR_Coverage, 5295,
     /* 167385 */     GIR_EraseRootFromParent_Done,
     /* 167386 */   // Label 3137: @167386
     /* 167386 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(167419), // Rule ID 5625 //
     /* 167391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167410 */     // (intrinsic_wo_chain:{ *:[f32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 167413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167417 */     GIR_RootConstrainSelectedInstOperands,
     /* 167418 */     // GIR_Coverage, 5625,
     /* 167418 */     GIR_EraseRootFromParent_Done,
     /* 167419 */   // Label 3138: @167419
     /* 167419 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(167504), // Rule ID 5626 //
     /* 167424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167443 */     // (intrinsic_wo_chain:{ *:[f32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 167443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 167450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167477 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 167484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 167497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167502 */     GIR_RootConstrainSelectedInstOperands,
     /* 167503 */     // GIR_Coverage, 5626,
     /* 167503 */     GIR_EraseRootFromParent_Done,
     /* 167504 */   // Label 3139: @167504
     /* 167504 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(167537), // Rule ID 5627 //
     /* 167509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167528 */     // (intrinsic_wo_chain:{ *:[f64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 167531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167535 */     GIR_RootConstrainSelectedInstOperands,
     /* 167536 */     // GIR_Coverage, 5627,
     /* 167536 */     GIR_EraseRootFromParent_Done,
     /* 167537 */   // Label 3140: @167537
     /* 167537 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(167570), // Rule ID 5629 //
     /* 167542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167561 */     // (intrinsic_wo_chain:{ *:[f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 167564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167568 */     GIR_RootConstrainSelectedInstOperands,
     /* 167569 */     // GIR_Coverage, 5629,
     /* 167569 */     GIR_EraseRootFromParent_Done,
     /* 167570 */   // Label 3141: @167570
     /* 167570 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(167603), // Rule ID 5631 //
     /* 167575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167594 */     // (intrinsic_wo_chain:{ *:[f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 167597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167601 */     GIR_RootConstrainSelectedInstOperands,
     /* 167602 */     // GIR_Coverage, 5631,
     /* 167602 */     GIR_EraseRootFromParent_Done,
     /* 167603 */   // Label 3142: @167603
     /* 167603 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(167636), // Rule ID 5633 //
     /* 167608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167627 */     // (intrinsic_wo_chain:{ *:[f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 167630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167634 */     GIR_RootConstrainSelectedInstOperands,
     /* 167635 */     // GIR_Coverage, 5633,
     /* 167635 */     GIR_EraseRootFromParent_Done,
     /* 167636 */   // Label 3143: @167636
     /* 167636 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(167669), // Rule ID 5635 //
     /* 167641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167660 */     // (intrinsic_wo_chain:{ *:[f64] } 606:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 167663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167667 */     GIR_RootConstrainSelectedInstOperands,
     /* 167668 */     // GIR_Coverage, 5635,
     /* 167668 */     GIR_EraseRootFromParent_Done,
     /* 167669 */   // Label 3144: @167669
     /* 167669 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(167702), // Rule ID 5637 //
     /* 167674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167693 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 167696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167700 */     GIR_RootConstrainSelectedInstOperands,
     /* 167701 */     // GIR_Coverage, 5637,
     /* 167701 */     GIR_EraseRootFromParent_Done,
     /* 167702 */   // Label 3145: @167702
     /* 167702 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(167735), // Rule ID 5639 //
     /* 167707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167726 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 167729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167733 */     GIR_RootConstrainSelectedInstOperands,
     /* 167734 */     // GIR_Coverage, 5639,
     /* 167734 */     GIR_EraseRootFromParent_Done,
     /* 167735 */   // Label 3146: @167735
     /* 167735 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(167768), // Rule ID 5641 //
     /* 167740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167759 */     // (intrinsic_wo_chain:{ *:[f32] } 612:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 167762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167766 */     GIR_RootConstrainSelectedInstOperands,
     /* 167767 */     // GIR_Coverage, 5641,
     /* 167767 */     GIR_EraseRootFromParent_Done,
     /* 167768 */   // Label 3147: @167768
     /* 167768 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(167801), // Rule ID 5643 //
     /* 167773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167792 */     // (intrinsic_wo_chain:{ *:[f64] } 612:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 167795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167799 */     GIR_RootConstrainSelectedInstOperands,
     /* 167800 */     // GIR_Coverage, 5643,
     /* 167800 */     GIR_EraseRootFromParent_Done,
     /* 167801 */   // Label 3148: @167801
     /* 167801 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(167834), // Rule ID 13200 //
     /* 167806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 167814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 167821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167825 */     // (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 167825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 167828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167832 */     GIR_RootConstrainSelectedInstOperands,
     /* 167833 */     // GIR_Coverage, 13200,
     /* 167833 */     GIR_EraseRootFromParent_Done,
     /* 167834 */   // Label 3149: @167834
     /* 167834 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(167867), // Rule ID 13202 //
     /* 167839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 167847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 167854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167858 */     // (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 167861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167865 */     GIR_RootConstrainSelectedInstOperands,
     /* 167866 */     // GIR_Coverage, 13202,
     /* 167866 */     GIR_EraseRootFromParent_Done,
     /* 167867 */   // Label 3150: @167867
     /* 167867 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(167900), // Rule ID 13204 //
     /* 167872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167891 */     // (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 167891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 167894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167898 */     GIR_RootConstrainSelectedInstOperands,
     /* 167899 */     // GIR_Coverage, 13204,
     /* 167899 */     GIR_EraseRootFromParent_Done,
     /* 167900 */   // Label 3151: @167900
     /* 167900 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(167933), // Rule ID 13206 //
     /* 167905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167924 */     // (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 167924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 167927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167931 */     GIR_RootConstrainSelectedInstOperands,
     /* 167932 */     // GIR_Coverage, 13206,
     /* 167932 */     GIR_EraseRootFromParent_Done,
     /* 167933 */   // Label 3152: @167933
     /* 167933 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(168048), // Rule ID 13207 //
     /* 167938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167957 */     // (intrinsic_wo_chain:{ *:[i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 167957 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 167960 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 167964 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167969 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 167975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 167978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 167992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 167996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168001 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168004 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168030 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168047 */     // GIR_Coverage, 13207,
     /* 168047 */     GIR_EraseRootFromParent_Done,
     /* 168048 */   // Label 3153: @168048
     /* 168048 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(168081), // Rule ID 13209 //
     /* 168053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168072 */     // (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 168072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 168075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168079 */     GIR_RootConstrainSelectedInstOperands,
     /* 168080 */     // GIR_Coverage, 13209,
     /* 168080 */     GIR_EraseRootFromParent_Done,
     /* 168081 */   // Label 3154: @168081
     /* 168081 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(168114), // Rule ID 13211 //
     /* 168086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168105 */     // (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 168105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 168108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168112 */     GIR_RootConstrainSelectedInstOperands,
     /* 168113 */     // GIR_Coverage, 13211,
     /* 168113 */     GIR_EraseRootFromParent_Done,
     /* 168114 */   // Label 3155: @168114
     /* 168114 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(168147), // Rule ID 13213 //
     /* 168119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168138 */     // (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 168138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 168141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168145 */     GIR_RootConstrainSelectedInstOperands,
     /* 168146 */     // GIR_Coverage, 13213,
     /* 168146 */     GIR_EraseRootFromParent_Done,
     /* 168147 */   // Label 3156: @168147
     /* 168147 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(168180), // Rule ID 13215 //
     /* 168152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168171 */     // (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 168171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 168174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168178 */     GIR_RootConstrainSelectedInstOperands,
     /* 168179 */     // GIR_Coverage, 13215,
     /* 168179 */     GIR_EraseRootFromParent_Done,
     /* 168180 */   // Label 3157: @168180
     /* 168180 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(168295), // Rule ID 13216 //
     /* 168185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168204 */     // (intrinsic_wo_chain:{ *:[i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168204 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 168207 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 168211 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168216 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168222 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168225 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168229 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168248 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168294 */     // GIR_Coverage, 13216,
     /* 168294 */     GIR_EraseRootFromParent_Done,
     /* 168295 */   // Label 3158: @168295
     /* 168295 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(168414), // Rule ID 13217 //
     /* 168300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 168305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168319 */     // (intrinsic_wo_chain:{ *:[i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168319 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168322 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168326 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168331 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168335 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168341 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168344 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168348 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168373 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168396 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168413 */     // GIR_Coverage, 13217,
     /* 168413 */     GIR_EraseRootFromParent_Done,
     /* 168414 */   // Label 3159: @168414
     /* 168414 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(168529), // Rule ID 13218 //
     /* 168419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 168424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168438 */     // (intrinsic_wo_chain:{ *:[i64] } 669:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 168438 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168441 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 168445 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168450 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168456 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 168459 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168463 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 168473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168482 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168488 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168511 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168528 */     // GIR_Coverage, 13218,
     /* 168528 */     GIR_EraseRootFromParent_Done,
     /* 168529 */   // Label 3160: @168529
     /* 168529 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(168648), // Rule ID 13219 //
     /* 168534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168553 */     // (intrinsic_wo_chain:{ *:[i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168553 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168556 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168560 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168565 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168569 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168607 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168630 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168647 */     // GIR_Coverage, 13219,
     /* 168647 */     GIR_EraseRootFromParent_Done,
     /* 168648 */   // Label 3161: @168648
     /* 168648 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(168763), // Rule ID 13220 //
     /* 168653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168672 */     // (intrinsic_wo_chain:{ *:[i64] } 734:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 168672 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168675 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 168679 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168684 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 168693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 168707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168719 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168722 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168745 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168762 */     // GIR_Coverage, 13220,
     /* 168762 */     GIR_EraseRootFromParent_Done,
     /* 168763 */   // Label 3162: @168763
     /* 168763 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(168796), // Rule ID 13222 //
     /* 168768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168787 */     // (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 168787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 168790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168794 */     GIR_RootConstrainSelectedInstOperands,
     /* 168795 */     // GIR_Coverage, 13222,
     /* 168795 */     GIR_EraseRootFromParent_Done,
     /* 168796 */   // Label 3163: @168796
     /* 168796 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(168829), // Rule ID 13224 //
     /* 168801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168820 */     // (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 168820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 168823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168827 */     GIR_RootConstrainSelectedInstOperands,
     /* 168828 */     // GIR_Coverage, 13224,
     /* 168828 */     GIR_EraseRootFromParent_Done,
     /* 168829 */   // Label 3164: @168829
     /* 168829 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(168862), // Rule ID 13226 //
     /* 168834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168853 */     // (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 168853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 168856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168860 */     GIR_RootConstrainSelectedInstOperands,
     /* 168861 */     // GIR_Coverage, 13226,
     /* 168861 */     GIR_EraseRootFromParent_Done,
     /* 168862 */   // Label 3165: @168862
     /* 168862 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(168895), // Rule ID 13228 //
     /* 168867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168886 */     // (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 168886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 168889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168893 */     GIR_RootConstrainSelectedInstOperands,
     /* 168894 */     // GIR_Coverage, 13228,
     /* 168894 */     GIR_EraseRootFromParent_Done,
     /* 168895 */   // Label 3166: @168895
     /* 168895 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(169010), // Rule ID 13229 //
     /* 168900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168919 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168919 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 168922 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 168926 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168931 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168966 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168992 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169009 */     // GIR_Coverage, 13229,
     /* 169009 */     GIR_EraseRootFromParent_Done,
     /* 169010 */   // Label 3167: @169010
     /* 169010 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(169129), // Rule ID 13230 //
     /* 169015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 169020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169034 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169034 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169037 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 169041 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169046 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169050 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169082 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169085 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169111 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169128 */     // GIR_Coverage, 13230,
     /* 169128 */     GIR_EraseRootFromParent_Done,
     /* 169129 */   // Label 3168: @169129
     /* 169129 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(169162), // Rule ID 13232 //
     /* 169134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169153 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 169156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169160 */     GIR_RootConstrainSelectedInstOperands,
     /* 169161 */     // GIR_Coverage, 13232,
     /* 169161 */     GIR_EraseRootFromParent_Done,
     /* 169162 */   // Label 3169: @169162
     /* 169162 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(169195), // Rule ID 13234 //
     /* 169167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169186 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 169189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169193 */     GIR_RootConstrainSelectedInstOperands,
     /* 169194 */     // GIR_Coverage, 13234,
     /* 169194 */     GIR_EraseRootFromParent_Done,
     /* 169195 */   // Label 3170: @169195
     /* 169195 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(169228), // Rule ID 13236 //
     /* 169200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169219 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 169222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169226 */     GIR_RootConstrainSelectedInstOperands,
     /* 169227 */     // GIR_Coverage, 13236,
     /* 169227 */     GIR_EraseRootFromParent_Done,
     /* 169228 */   // Label 3171: @169228
     /* 169228 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(169261), // Rule ID 13238 //
     /* 169233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169252 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 169255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169259 */     GIR_RootConstrainSelectedInstOperands,
     /* 169260 */     // GIR_Coverage, 13238,
     /* 169260 */     GIR_EraseRootFromParent_Done,
     /* 169261 */   // Label 3172: @169261
     /* 169261 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(169376), // Rule ID 13239 //
     /* 169266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169285 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169285 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169288 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 169292 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169297 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169329 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169332 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169358 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169375 */     // GIR_Coverage, 13239,
     /* 169375 */     GIR_EraseRootFromParent_Done,
     /* 169376 */   // Label 3173: @169376
     /* 169376 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(169495), // Rule ID 13240 //
     /* 169381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169400 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 169407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169412 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169416 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169448 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169454 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169477 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169494 */     // GIR_Coverage, 13240,
     /* 169494 */     GIR_EraseRootFromParent_Done,
     /* 169495 */   // Label 3174: @169495
     /* 169495 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(169528), // Rule ID 13242 //
     /* 169500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169519 */     // (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 169522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169526 */     GIR_RootConstrainSelectedInstOperands,
     /* 169527 */     // GIR_Coverage, 13242,
     /* 169527 */     GIR_EraseRootFromParent_Done,
     /* 169528 */   // Label 3175: @169528
     /* 169528 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(169561), // Rule ID 13244 //
     /* 169533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169552 */     // (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 169555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169559 */     GIR_RootConstrainSelectedInstOperands,
     /* 169560 */     // GIR_Coverage, 13244,
     /* 169560 */     GIR_EraseRootFromParent_Done,
     /* 169561 */   // Label 3176: @169561
     /* 169561 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(169594), // Rule ID 13246 //
     /* 169566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169585 */     // (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 169588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169592 */     GIR_RootConstrainSelectedInstOperands,
     /* 169593 */     // GIR_Coverage, 13246,
     /* 169593 */     GIR_EraseRootFromParent_Done,
     /* 169594 */   // Label 3177: @169594
     /* 169594 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(169627), // Rule ID 13248 //
     /* 169599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169618 */     // (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 169621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169625 */     GIR_RootConstrainSelectedInstOperands,
     /* 169626 */     // GIR_Coverage, 13248,
     /* 169626 */     GIR_EraseRootFromParent_Done,
     /* 169627 */   // Label 3178: @169627
     /* 169627 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(169742), // Rule ID 13249 //
     /* 169632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169651 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169651 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169654 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 169658 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169663 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169695 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169698 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169701 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169724 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169741 */     // GIR_Coverage, 13249,
     /* 169741 */     GIR_EraseRootFromParent_Done,
     /* 169742 */   // Label 3179: @169742
     /* 169742 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(169861), // Rule ID 13250 //
     /* 169747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169766 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169766 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169769 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 169773 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169778 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169782 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169788 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169814 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169820 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169843 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169860 */     // GIR_Coverage, 13250,
     /* 169860 */     GIR_EraseRootFromParent_Done,
     /* 169861 */   // Label 3180: @169861
     /* 169861 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(169894), // Rule ID 13252 //
     /* 169866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169885 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 169888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169892 */     GIR_RootConstrainSelectedInstOperands,
     /* 169893 */     // GIR_Coverage, 13252,
     /* 169893 */     GIR_EraseRootFromParent_Done,
     /* 169894 */   // Label 3181: @169894
     /* 169894 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(169927), // Rule ID 13254 //
     /* 169899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169918 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 169921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169925 */     GIR_RootConstrainSelectedInstOperands,
     /* 169926 */     // GIR_Coverage, 13254,
     /* 169926 */     GIR_EraseRootFromParent_Done,
     /* 169927 */   // Label 3182: @169927
     /* 169927 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(169960), // Rule ID 13256 //
     /* 169932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169951 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 169954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169958 */     GIR_RootConstrainSelectedInstOperands,
     /* 169959 */     // GIR_Coverage, 13256,
     /* 169959 */     GIR_EraseRootFromParent_Done,
     /* 169960 */   // Label 3183: @169960
     /* 169960 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(169993), // Rule ID 13258 //
     /* 169965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169984 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 169987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169991 */     GIR_RootConstrainSelectedInstOperands,
     /* 169992 */     // GIR_Coverage, 13258,
     /* 169992 */     GIR_EraseRootFromParent_Done,
     /* 169993 */   // Label 3184: @169993
     /* 169993 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(170108), // Rule ID 13259 //
     /* 169998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 170003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170017 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170017 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170020 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 170024 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170029 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170061 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170064 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170067 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170090 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170107 */     // GIR_Coverage, 13259,
     /* 170107 */     GIR_EraseRootFromParent_Done,
     /* 170108 */   // Label 3185: @170108
     /* 170108 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(170227), // Rule ID 13260 //
     /* 170113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 170118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170132 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170132 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170135 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 170139 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170144 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170148 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170186 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170209 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170226 */     // GIR_Coverage, 13260,
     /* 170226 */     GIR_EraseRootFromParent_Done,
     /* 170227 */   // Label 3186: @170227
     /* 170227 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(170259), // Rule ID 2393 //
     /* 170232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 170240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170250 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1676:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 170253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170257 */     GIR_RootConstrainSelectedInstOperands,
     /* 170258 */     // GIR_Coverage, 2393,
     /* 170258 */     GIR_EraseRootFromParent_Done,
     /* 170259 */   // Label 3187: @170259
     /* 170259 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(170291), // Rule ID 2394 //
     /* 170264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 170272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170282 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1677:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 170285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170289 */     GIR_RootConstrainSelectedInstOperands,
     /* 170290 */     // GIR_Coverage, 2394,
     /* 170290 */     GIR_EraseRootFromParent_Done,
     /* 170291 */   // Label 3188: @170291
     /* 170291 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(170323), // Rule ID 2395 //
     /* 170296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 170304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170314 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1678:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 170317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170321 */     GIR_RootConstrainSelectedInstOperands,
     /* 170322 */     // GIR_Coverage, 2395,
     /* 170322 */     GIR_EraseRootFromParent_Done,
     /* 170323 */   // Label 3189: @170323
     /* 170323 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(170355), // Rule ID 3086 //
     /* 170328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 170339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 170342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1858:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 170346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 170349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170353 */     GIR_RootConstrainSelectedInstOperands,
     /* 170354 */     // GIR_Coverage, 3086,
     /* 170354 */     GIR_EraseRootFromParent_Done,
     /* 170355 */   // Label 3190: @170355
     /* 170355 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(170387), // Rule ID 3087 //
     /* 170360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 170371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 170374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1858:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 170378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 170381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170385 */     GIR_RootConstrainSelectedInstOperands,
     /* 170386 */     // GIR_Coverage, 3087,
     /* 170386 */     GIR_EraseRootFromParent_Done,
     /* 170387 */   // Label 3191: @170387
     /* 170387 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(170419), // Rule ID 3088 //
     /* 170392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 170403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 170406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1858:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 170410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 170413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170417 */     GIR_RootConstrainSelectedInstOperands,
     /* 170418 */     // GIR_Coverage, 3088,
     /* 170418 */     GIR_EraseRootFromParent_Done,
     /* 170419 */   // Label 3192: @170419
     /* 170419 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(170451), // Rule ID 3342 //
     /* 170424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 170435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170442 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1668:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 170442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170449 */     GIR_RootConstrainSelectedInstOperands,
     /* 170450 */     // GIR_Coverage, 3342,
     /* 170450 */     GIR_EraseRootFromParent_Done,
     /* 170451 */   // Label 3193: @170451
     /* 170451 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(170483), // Rule ID 3343 //
     /* 170456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 170467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 170470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170474 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1668:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 170474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170481 */     GIR_RootConstrainSelectedInstOperands,
     /* 170482 */     // GIR_Coverage, 3343,
     /* 170482 */     GIR_EraseRootFromParent_Done,
     /* 170483 */   // Label 3194: @170483
     /* 170483 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(170515), // Rule ID 3344 //
     /* 170488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 170499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 170502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170506 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1668:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 170506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170513 */     GIR_RootConstrainSelectedInstOperands,
     /* 170514 */     // GIR_Coverage, 3344,
     /* 170514 */     GIR_EraseRootFromParent_Done,
     /* 170515 */   // Label 3195: @170515
     /* 170515 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(170547), // Rule ID 3423 //
     /* 170520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 170531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 170534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170538 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 170538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 170541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170545 */     GIR_RootConstrainSelectedInstOperands,
     /* 170546 */     // GIR_Coverage, 3423,
     /* 170546 */     GIR_EraseRootFromParent_Done,
     /* 170547 */   // Label 3196: @170547
     /* 170547 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(170579), // Rule ID 3424 //
     /* 170552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 170563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 170566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170570 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 170570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 170573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170577 */     GIR_RootConstrainSelectedInstOperands,
     /* 170578 */     // GIR_Coverage, 3424,
     /* 170578 */     GIR_EraseRootFromParent_Done,
     /* 170579 */   // Label 3197: @170579
     /* 170579 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(170611), // Rule ID 3425 //
     /* 170584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 170595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 170598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170602 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 170602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 170605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170609 */     GIR_RootConstrainSelectedInstOperands,
     /* 170610 */     // GIR_Coverage, 3425,
     /* 170610 */     GIR_EraseRootFromParent_Done,
     /* 170611 */   // Label 3198: @170611
     /* 170611 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(170643), // Rule ID 3451 //
     /* 170616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 170619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 170624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 170627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 170630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1268:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 170634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 170637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 170639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170641 */     GIR_RootConstrainSelectedInstOperands,
     /* 170642 */     // GIR_Coverage, 3451,
     /* 170642 */     GIR_EraseRootFromParent_Done,
     /* 170643 */   // Label 3199: @170643
     /* 170643 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(170675), // Rule ID 4658 //
     /* 170648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170666 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 170666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 170669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170673 */     GIR_RootConstrainSelectedInstOperands,
     /* 170674 */     // GIR_Coverage, 4658,
     /* 170674 */     GIR_EraseRootFromParent_Done,
     /* 170675 */   // Label 3200: @170675
     /* 170675 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(170707), // Rule ID 4659 //
     /* 170680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170698 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 170698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 170701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170705 */     GIR_RootConstrainSelectedInstOperands,
     /* 170706 */     // GIR_Coverage, 4659,
     /* 170706 */     GIR_EraseRootFromParent_Done,
     /* 170707 */   // Label 3201: @170707
     /* 170707 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(170736), // Rule ID 4660 //
     /* 170712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170727 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 170727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 170730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170734 */     GIR_RootConstrainSelectedInstOperands,
     /* 170735 */     // GIR_Coverage, 4660,
     /* 170735 */     GIR_EraseRootFromParent_Done,
     /* 170736 */   // Label 3202: @170736
     /* 170736 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(170765), // Rule ID 4661 //
     /* 170741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170756 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 170756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 170759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170763 */     GIR_RootConstrainSelectedInstOperands,
     /* 170764 */     // GIR_Coverage, 4661,
     /* 170764 */     GIR_EraseRootFromParent_Done,
     /* 170765 */   // Label 3203: @170765
     /* 170765 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(170794), // Rule ID 4662 //
     /* 170770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170785 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 170785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 170788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170792 */     GIR_RootConstrainSelectedInstOperands,
     /* 170793 */     // GIR_Coverage, 4662,
     /* 170793 */     GIR_EraseRootFromParent_Done,
     /* 170794 */   // Label 3204: @170794
     /* 170794 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(170823), // Rule ID 4663 //
     /* 170799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170814 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 170814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 170817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170821 */     GIR_RootConstrainSelectedInstOperands,
     /* 170822 */     // GIR_Coverage, 4663,
     /* 170822 */     GIR_EraseRootFromParent_Done,
     /* 170823 */   // Label 3205: @170823
     /* 170823 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(170855), // Rule ID 4670 //
     /* 170828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170846 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 170846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 170849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170853 */     GIR_RootConstrainSelectedInstOperands,
     /* 170854 */     // GIR_Coverage, 4670,
     /* 170854 */     GIR_EraseRootFromParent_Done,
     /* 170855 */   // Label 3206: @170855
     /* 170855 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(170887), // Rule ID 4671 //
     /* 170860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170878 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 170878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 170881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170885 */     GIR_RootConstrainSelectedInstOperands,
     /* 170886 */     // GIR_Coverage, 4671,
     /* 170886 */     GIR_EraseRootFromParent_Done,
     /* 170887 */   // Label 3207: @170887
     /* 170887 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(170916), // Rule ID 4672 //
     /* 170892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170907 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 170907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 170910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170914 */     GIR_RootConstrainSelectedInstOperands,
     /* 170915 */     // GIR_Coverage, 4672,
     /* 170915 */     GIR_EraseRootFromParent_Done,
     /* 170916 */   // Label 3208: @170916
     /* 170916 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(170945), // Rule ID 4673 //
     /* 170921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170936 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 170936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 170939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170943 */     GIR_RootConstrainSelectedInstOperands,
     /* 170944 */     // GIR_Coverage, 4673,
     /* 170944 */     GIR_EraseRootFromParent_Done,
     /* 170945 */   // Label 3209: @170945
     /* 170945 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(170974), // Rule ID 4674 //
     /* 170950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170965 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 170965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 170968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170972 */     GIR_RootConstrainSelectedInstOperands,
     /* 170973 */     // GIR_Coverage, 4674,
     /* 170973 */     GIR_EraseRootFromParent_Done,
     /* 170974 */   // Label 3210: @170974
     /* 170974 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(171003), // Rule ID 4675 //
     /* 170979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170994 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 170994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 170997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171001 */     GIR_RootConstrainSelectedInstOperands,
     /* 171002 */     // GIR_Coverage, 4675,
     /* 171002 */     GIR_EraseRootFromParent_Done,
     /* 171003 */   // Label 3211: @171003
     /* 171003 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(171032), // Rule ID 4970 //
     /* 171008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171023 */     // (intrinsic_wo_chain:{ *:[v4i16] } 599:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 171023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 171026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171030 */     GIR_RootConstrainSelectedInstOperands,
     /* 171031 */     // GIR_Coverage, 4970,
     /* 171031 */     GIR_EraseRootFromParent_Done,
     /* 171032 */   // Label 3212: @171032
     /* 171032 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(171061), // Rule ID 4971 //
     /* 171037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171052 */     // (intrinsic_wo_chain:{ *:[v8i16] } 599:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 171052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 171055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171059 */     GIR_RootConstrainSelectedInstOperands,
     /* 171060 */     // GIR_Coverage, 4971,
     /* 171060 */     GIR_EraseRootFromParent_Done,
     /* 171061 */   // Label 3213: @171061
     /* 171061 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(171090), // Rule ID 4972 //
     /* 171066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171081 */     // (intrinsic_wo_chain:{ *:[v2i32] } 599:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 171081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 171084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171088 */     GIR_RootConstrainSelectedInstOperands,
     /* 171089 */     // GIR_Coverage, 4972,
     /* 171089 */     GIR_EraseRootFromParent_Done,
     /* 171090 */   // Label 3214: @171090
     /* 171090 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(171119), // Rule ID 4973 //
     /* 171095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171110 */     // (intrinsic_wo_chain:{ *:[v4i32] } 599:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 171110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 171113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171117 */     GIR_RootConstrainSelectedInstOperands,
     /* 171118 */     // GIR_Coverage, 4973,
     /* 171118 */     GIR_EraseRootFromParent_Done,
     /* 171119 */   // Label 3215: @171119
     /* 171119 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(171148), // Rule ID 4974 //
     /* 171124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171139 */     // (intrinsic_wo_chain:{ *:[v2i64] } 599:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 171139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 171142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171146 */     GIR_RootConstrainSelectedInstOperands,
     /* 171147 */     // GIR_Coverage, 4974,
     /* 171147 */     GIR_EraseRootFromParent_Done,
     /* 171148 */   // Label 3216: @171148
     /* 171148 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(171177), // Rule ID 4975 //
     /* 171153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171168 */     // (intrinsic_wo_chain:{ *:[v4i16] } 600:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 171168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 171171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171175 */     GIR_RootConstrainSelectedInstOperands,
     /* 171176 */     // GIR_Coverage, 4975,
     /* 171176 */     GIR_EraseRootFromParent_Done,
     /* 171177 */   // Label 3217: @171177
     /* 171177 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(171206), // Rule ID 4976 //
     /* 171182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171197 */     // (intrinsic_wo_chain:{ *:[v8i16] } 600:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 171197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 171200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171204 */     GIR_RootConstrainSelectedInstOperands,
     /* 171205 */     // GIR_Coverage, 4976,
     /* 171205 */     GIR_EraseRootFromParent_Done,
     /* 171206 */   // Label 3218: @171206
     /* 171206 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(171235), // Rule ID 4977 //
     /* 171211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171226 */     // (intrinsic_wo_chain:{ *:[v2i32] } 600:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 171226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 171229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171233 */     GIR_RootConstrainSelectedInstOperands,
     /* 171234 */     // GIR_Coverage, 4977,
     /* 171234 */     GIR_EraseRootFromParent_Done,
     /* 171235 */   // Label 3219: @171235
     /* 171235 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(171264), // Rule ID 4978 //
     /* 171240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171255 */     // (intrinsic_wo_chain:{ *:[v4i32] } 600:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 171255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 171258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171262 */     GIR_RootConstrainSelectedInstOperands,
     /* 171263 */     // GIR_Coverage, 4978,
     /* 171263 */     GIR_EraseRootFromParent_Done,
     /* 171264 */   // Label 3220: @171264
     /* 171264 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(171293), // Rule ID 4979 //
     /* 171269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171284 */     // (intrinsic_wo_chain:{ *:[v2i64] } 600:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 171284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 171287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171291 */     GIR_RootConstrainSelectedInstOperands,
     /* 171292 */     // GIR_Coverage, 4979,
     /* 171292 */     GIR_EraseRootFromParent_Done,
     /* 171293 */   // Label 3221: @171293
     /* 171293 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(171325), // Rule ID 8451 //
     /* 171298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 171309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171316 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1667:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 171316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171323 */     GIR_RootConstrainSelectedInstOperands,
     /* 171324 */     // GIR_Coverage, 8451,
     /* 171324 */     GIR_EraseRootFromParent_Done,
     /* 171325 */   // Label 3222: @171325
     /* 171325 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(171357), // Rule ID 8452 //
     /* 171330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 171341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 171344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171348 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1667:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 171348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171355 */     GIR_RootConstrainSelectedInstOperands,
     /* 171356 */     // GIR_Coverage, 8452,
     /* 171356 */     GIR_EraseRootFromParent_Done,
     /* 171357 */   // Label 3223: @171357
     /* 171357 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(171389), // Rule ID 8453 //
     /* 171362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 171373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 171376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171380 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1667:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 171380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171387 */     GIR_RootConstrainSelectedInstOperands,
     /* 171388 */     // GIR_Coverage, 8453,
     /* 171388 */     GIR_EraseRootFromParent_Done,
     /* 171389 */   // Label 3224: @171389
     /* 171389 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(171421), // Rule ID 11874 //
     /* 171394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2051:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 171415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171419 */     GIR_RootConstrainSelectedInstOperands,
     /* 171420 */     // GIR_Coverage, 11874,
     /* 171420 */     GIR_EraseRootFromParent_Done,
     /* 171421 */   // Label 3225: @171421
     /* 171421 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(171453), // Rule ID 11875 //
     /* 171426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2051:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 171447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171451 */     GIR_RootConstrainSelectedInstOperands,
     /* 171452 */     // GIR_Coverage, 11875,
     /* 171452 */     GIR_EraseRootFromParent_Done,
     /* 171453 */   // Label 3226: @171453
     /* 171453 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(171485), // Rule ID 11876 //
     /* 171458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2051:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 171479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171483 */     GIR_RootConstrainSelectedInstOperands,
     /* 171484 */     // GIR_Coverage, 11876,
     /* 171484 */     GIR_EraseRootFromParent_Done,
     /* 171485 */   // Label 3227: @171485
     /* 171485 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(171517), // Rule ID 11877 //
     /* 171490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171508 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1860:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 171511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171515 */     GIR_RootConstrainSelectedInstOperands,
     /* 171516 */     // GIR_Coverage, 11877,
     /* 171516 */     GIR_EraseRootFromParent_Done,
     /* 171517 */   // Label 3228: @171517
     /* 171517 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(171549), // Rule ID 11878 //
     /* 171522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1860:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 171543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171547 */     GIR_RootConstrainSelectedInstOperands,
     /* 171548 */     // GIR_Coverage, 11878,
     /* 171548 */     GIR_EraseRootFromParent_Done,
     /* 171549 */   // Label 3229: @171549
     /* 171549 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(171581), // Rule ID 11879 //
     /* 171554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1860:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 171575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171579 */     GIR_RootConstrainSelectedInstOperands,
     /* 171580 */     // GIR_Coverage, 11879,
     /* 171580 */     GIR_EraseRootFromParent_Done,
     /* 171581 */   // Label 3230: @171581
     /* 171581 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(171613), // Rule ID 12046 //
     /* 171586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 171589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 171594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 171600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1267:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 171604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 171607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 171609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171611 */     GIR_RootConstrainSelectedInstOperands,
     /* 171612 */     // GIR_Coverage, 12046,
     /* 171612 */     GIR_EraseRootFromParent_Done,
     /* 171613 */   // Label 3231: @171613
     /* 171613 */   GIM_Reject,
     /* 171614 */ // Label 2912: @171614
     /* 171614 */ GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(213916),
     /* 171619 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 171622 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(171806), // Rule ID 2561 //
     /* 171627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 171656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 171660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 171668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 171676 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 171679 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 171684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171688 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 171701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 171705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171709 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 171713 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 171717 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171721 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 171725 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 171730 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 171734 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 171738 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 171742 */     // MIs[5] Operand 1
     /* 171742 */     // No operand predicates
     /* 171742 */     // MIs[3] Operand 2
     /* 171742 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 171753 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 171757 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 171759 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 171759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 171777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 171790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 171794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 171801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 171804 */     GIR_RootConstrainSelectedInstOperands,
     /* 171805 */     // GIR_Coverage, 2561,
     /* 171805 */     GIR_EraseRootFromParent_Done,
     /* 171806 */   // Label 3233: @171806
     /* 171806 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(171990), // Rule ID 6299 //
     /* 171811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 171819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 171840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 171844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 171852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 171860 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 171863 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 171868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171872 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 171885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 171889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171893 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 171897 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 171901 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171905 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 171909 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 171914 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 171918 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 171922 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 171926 */     // MIs[5] Operand 1
     /* 171926 */     // No operand predicates
     /* 171926 */     // MIs[3] Operand 2
     /* 171926 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 171937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 171941 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 171943 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 171943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171955 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 171961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 171974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 171978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 171985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 171988 */     GIR_RootConstrainSelectedInstOperands,
     /* 171989 */     // GIR_Coverage, 6299,
     /* 171989 */     GIR_EraseRootFromParent_Done,
     /* 171990 */   // Label 3234: @171990
     /* 171990 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(172151), // Rule ID 2562 //
     /* 171995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 172028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 172036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 172040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172044 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 172047 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172056 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 172069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172073 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172077 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172081 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172094 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172098 */     // MIs[4] Operand 1
     /* 172098 */     // No operand predicates
     /* 172098 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 172102 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172104 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 172104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 172107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172116 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 172122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 172127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 172135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172149 */     GIR_RootConstrainSelectedInstOperands,
     /* 172150 */     // GIR_Coverage, 2562,
     /* 172150 */     GIR_EraseRootFromParent_Done,
     /* 172151 */   // Label 3235: @172151
     /* 172151 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(172312), // Rule ID 6300 //
     /* 172156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 172189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 172197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 172201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172205 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 172208 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172217 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 172230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172234 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172238 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172242 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172247 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172251 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172255 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172259 */     // MIs[4] Operand 1
     /* 172259 */     // No operand predicates
     /* 172259 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 172263 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172265 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 172265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 172268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172277 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 172283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 172288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 172296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172310 */     GIR_RootConstrainSelectedInstOperands,
     /* 172311 */     // GIR_Coverage, 6300,
     /* 172311 */     GIR_EraseRootFromParent_Done,
     /* 172312 */   // Label 3236: @172312
     /* 172312 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(172422), // Rule ID 2085 //
     /* 172317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 172354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 172366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 172375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172379 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172383 */     // MIs[3] Operand 1
     /* 172383 */     // No operand predicates
     /* 172383 */     // MIs[1] Operand 2
     /* 172383 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 172394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 172396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 172403 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 172406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 172417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 172420 */     GIR_RootConstrainSelectedInstOperands,
     /* 172421 */     // GIR_Coverage, 2085,
     /* 172421 */     GIR_EraseRootFromParent_Done,
     /* 172422 */   // Label 3237: @172422
     /* 172422 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(172532), // Rule ID 2088 //
     /* 172427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 172464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 172468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 172476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 172485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 172493 */     // MIs[3] Operand 1
     /* 172493 */     // No operand predicates
     /* 172493 */     // MIs[1] Operand 2
     /* 172493 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 172504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 172506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 172513 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 172516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 172527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 172530 */     GIR_RootConstrainSelectedInstOperands,
     /* 172531 */     // GIR_Coverage, 2088,
     /* 172531 */     GIR_EraseRootFromParent_Done,
     /* 172532 */   // Label 3238: @172532
     /* 172532 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(172654), // Rule ID 6953 //
     /* 172537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 172542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172572 */     // MIs[1] Operand 2
     /* 172572 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 172583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 172587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172591 */     // MIs[2] Rn
     /* 172591 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 172596 */     // MIs[2] Operand 2
     /* 172596 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 172607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 172609 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 172609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 172612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 172616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172636 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 172643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172653 */     // GIR_Coverage, 6953,
     /* 172653 */     GIR_EraseRootFromParent_Done,
     /* 172654 */   // Label 3239: @172654
     /* 172654 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(172776), // Rule ID 6955 //
     /* 172659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 172664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172694 */     // MIs[1] Operand 2
     /* 172694 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 172705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 172709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172713 */     // MIs[2] Rn
     /* 172713 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 172718 */     // MIs[2] Operand 2
     /* 172718 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 172729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 172731 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 172731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 172734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 172738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172758 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 172765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172775 */     // GIR_Coverage, 6955,
     /* 172775 */     GIR_EraseRootFromParent_Done,
     /* 172776 */   // Label 3240: @172776
     /* 172776 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(172898), // Rule ID 6957 //
     /* 172781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 172786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 172811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172816 */     // MIs[1] Operand 2
     /* 172816 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 172827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 172831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172835 */     // MIs[2] Rn
     /* 172835 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 172840 */     // MIs[2] Operand 2
     /* 172840 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 172851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 172853 */     // (intrinsic_wo_chain:{ *:[v8i8] } 577:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 172853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 172856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 172860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172880 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 172887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172897 */     // GIR_Coverage, 6957,
     /* 172897 */     GIR_EraseRootFromParent_Done,
     /* 172898 */   // Label 3241: @172898
     /* 172898 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(173020), // Rule ID 6959 //
     /* 172903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 172908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172938 */     // MIs[1] Operand 2
     /* 172938 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 172949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 172953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172957 */     // MIs[2] Rn
     /* 172957 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 172962 */     // MIs[2] Operand 2
     /* 172962 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 172973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 172975 */     // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 172975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 172978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 172982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173002 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 173009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173019 */     // GIR_Coverage, 6959,
     /* 173019 */     GIR_EraseRootFromParent_Done,
     /* 173020 */   // Label 3242: @173020
     /* 173020 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(173142), // Rule ID 6961 //
     /* 173025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 173030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173060 */     // MIs[1] Operand 2
     /* 173060 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 173071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 173075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173079 */     // MIs[2] Rn
     /* 173079 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 173084 */     // MIs[2] Operand 2
     /* 173084 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 173095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 173097 */     // (intrinsic_wo_chain:{ *:[v4f16] } 586:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 173097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 173100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 173104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173109 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 173113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 173117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 173119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173124 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 173131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173141 */     // GIR_Coverage, 6961,
     /* 173141 */     GIR_EraseRootFromParent_Done,
     /* 173142 */   // Label 3243: @173142
     /* 173142 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(173325), // Rule ID 2560 //
     /* 173147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173196 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173199 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173208 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173222 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 173228 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 173228 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 173231 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173235 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 173242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 173245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 173249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173254 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 173257 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 173261 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 173264 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173269 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173291 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173323 */     GIR_RootConstrainSelectedInstOperands,
     /* 173324 */     // GIR_Coverage, 2560,
     /* 173324 */     GIR_EraseRootFromParent_Done,
     /* 173325 */   // Label 3244: @173325
     /* 173325 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(173508), // Rule ID 6298 //
     /* 173330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173379 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173382 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173391 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173405 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 173411 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 173411 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 173414 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173418 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 173425 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 173428 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 173432 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173437 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 173440 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 173444 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 173447 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173452 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173457 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173474 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173506 */     GIR_RootConstrainSelectedInstOperands,
     /* 173507 */     // GIR_Coverage, 6298,
     /* 173507 */     GIR_EraseRootFromParent_Done,
     /* 173508 */   // Label 3245: @173508
     /* 173508 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(173612), // Rule ID 13515 //
     /* 173513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 173516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173575 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173579 */     // MIs[3] Operand 1
     /* 173579 */     // No operand predicates
     /* 173579 */     // MIs[1] Operand 2
     /* 173579 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 173590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173596 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 173599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173610 */     GIR_RootConstrainSelectedInstOperands,
     /* 173611 */     // GIR_Coverage, 13515,
     /* 173611 */     GIR_EraseRootFromParent_Done,
     /* 173612 */   // Label 3246: @173612
     /* 173612 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(173716), // Rule ID 13518 //
     /* 173617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 173658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 173683 */     // MIs[3] Operand 1
     /* 173683 */     // No operand predicates
     /* 173683 */     // MIs[1] Operand 2
     /* 173683 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 173694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173700 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 173703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173714 */     GIR_RootConstrainSelectedInstOperands,
     /* 173715 */     // GIR_Coverage, 13518,
     /* 173715 */     GIR_EraseRootFromParent_Done,
     /* 173716 */   // Label 3247: @173716
     /* 173716 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(173847), // Rule ID 2517 //
     /* 173721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 173724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 173732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 173735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 173738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 173771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173796 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173800 */     // MIs[3] Operand 1
     /* 173800 */     // No operand predicates
     /* 173800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173802 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173814 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 173833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173845 */     GIR_RootConstrainSelectedInstOperands,
     /* 173846 */     // GIR_Coverage, 2517,
     /* 173846 */     GIR_EraseRootFromParent_Done,
     /* 173847 */   // Label 3248: @173847
     /* 173847 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(173978), // Rule ID 2518 //
     /* 173852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173894 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 173902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173927 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 173931 */     // MIs[3] Operand 1
     /* 173931 */     // No operand predicates
     /* 173931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173933 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 173933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173945 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 173951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 173964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173976 */     GIR_RootConstrainSelectedInstOperands,
     /* 173977 */     // GIR_Coverage, 2518,
     /* 173977 */     GIR_EraseRootFromParent_Done,
     /* 173978 */   // Label 3249: @173978
     /* 173978 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(174109), // Rule ID 2519 //
     /* 173983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 173994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 173997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 174016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174025 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 174041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174058 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 174062 */     // MIs[3] Operand 1
     /* 174062 */     // No operand predicates
     /* 174062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174064 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 174064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174076 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 174082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 174095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174107 */     GIR_RootConstrainSelectedInstOperands,
     /* 174108 */     // GIR_Coverage, 2519,
     /* 174108 */     GIR_EraseRootFromParent_Done,
     /* 174109 */   // Label 3250: @174109
     /* 174109 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(174240), // Rule ID 13707 //
     /* 174114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 174117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 174125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 174128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 174131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 174160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174164 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 174168 */     // MIs[2] Operand 1
     /* 174168 */     // No operand predicates
     /* 174168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 174172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174176 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174180 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 174184 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174189 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 174193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174195 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 174195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174207 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 174226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 174235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 174238 */     GIR_RootConstrainSelectedInstOperands,
     /* 174239 */     // GIR_Coverage, 13707,
     /* 174239 */     GIR_EraseRootFromParent_Done,
     /* 174240 */   // Label 3251: @174240
     /* 174240 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(174371), // Rule ID 13708 //
     /* 174245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 174291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174295 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 174299 */     // MIs[2] Operand 1
     /* 174299 */     // No operand predicates
     /* 174299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 174303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174311 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 174315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174320 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 174324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174326 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 174326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 174344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 174357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 174366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 174369 */     GIR_RootConstrainSelectedInstOperands,
     /* 174370 */     // GIR_Coverage, 13708,
     /* 174370 */     GIR_EraseRootFromParent_Done,
     /* 174371 */   // Label 3252: @174371
     /* 174371 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(174502), // Rule ID 13709 //
     /* 174376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 174409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 174422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174426 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 174430 */     // MIs[2] Operand 1
     /* 174430 */     // No operand predicates
     /* 174430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 174434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 174442 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 174446 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174451 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 174455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174457 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 174457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174469 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 174475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 174488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 174497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 174500 */     GIR_RootConstrainSelectedInstOperands,
     /* 174501 */     // GIR_Coverage, 13709,
     /* 174501 */     GIR_EraseRootFromParent_Done,
     /* 174502 */   // Label 3253: @174502
     /* 174502 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(174616), // Rule ID 2061 //
     /* 174507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174540 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 174543 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 174548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 174552 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 174556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 174565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 174594 */     // MIs[3] Operand 1
     /* 174594 */     // No operand predicates
     /* 174594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174596 */     // (intrinsic_wo_chain:{ *:[i64] } 686:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 174599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 174607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174614 */     GIR_RootConstrainSelectedInstOperands,
     /* 174615 */     // GIR_Coverage, 2061,
     /* 174615 */     GIR_EraseRootFromParent_Done,
     /* 174616 */   // Label 3254: @174616
     /* 174616 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(174730), // Rule ID 2068 //
     /* 174621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174654 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 174657 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 174662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 174666 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 174670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 174679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174704 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 174708 */     // MIs[3] Operand 1
     /* 174708 */     // No operand predicates
     /* 174708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174710 */     // (intrinsic_wo_chain:{ *:[i64] } 705:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 174713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 174721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174728 */     GIR_RootConstrainSelectedInstOperands,
     /* 174729 */     // GIR_Coverage, 2068,
     /* 174729 */     GIR_EraseRootFromParent_Done,
     /* 174730 */   // Label 3255: @174730
     /* 174730 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(174834), // Rule ID 1987 //
     /* 174735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 174738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 174780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 174793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174801 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 174805 */     // MIs[3] Operand 1
     /* 174805 */     // No operand predicates
     /* 174805 */     // MIs[1] Operand 2
     /* 174805 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174818 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 174821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174832 */     GIR_RootConstrainSelectedInstOperands,
     /* 174833 */     // GIR_Coverage, 1987,
     /* 174833 */     GIR_EraseRootFromParent_Done,
     /* 174834 */   // Label 3256: @174834
     /* 174834 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(174938), // Rule ID 2017 //
     /* 174839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 174884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 174897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174905 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 174909 */     // MIs[3] Operand 1
     /* 174909 */     // No operand predicates
     /* 174909 */     // MIs[1] Operand 2
     /* 174909 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174922 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 174925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174936 */     GIR_RootConstrainSelectedInstOperands,
     /* 174937 */     // GIR_Coverage, 2017,
     /* 174937 */     GIR_EraseRootFromParent_Done,
     /* 174938 */   // Label 3257: @174938
     /* 174938 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(175042), // Rule ID 2024 //
     /* 174943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 174951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 174988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 175001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175013 */     // MIs[3] Operand 1
     /* 175013 */     // No operand predicates
     /* 175013 */     // MIs[1] Operand 2
     /* 175013 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175026 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 175029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175040 */     GIR_RootConstrainSelectedInstOperands,
     /* 175041 */     // GIR_Coverage, 2024,
     /* 175041 */     GIR_EraseRootFromParent_Done,
     /* 175042 */   // Label 3258: @175042
     /* 175042 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(175146), // Rule ID 2083 //
     /* 175047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 175092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 175105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175113 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175117 */     // MIs[3] Operand 1
     /* 175117 */     // No operand predicates
     /* 175117 */     // MIs[1] Operand 2
     /* 175117 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175130 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 175133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175144 */     GIR_RootConstrainSelectedInstOperands,
     /* 175145 */     // GIR_Coverage, 2083,
     /* 175145 */     GIR_EraseRootFromParent_Done,
     /* 175146 */   // Label 3259: @175146
     /* 175146 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(175250), // Rule ID 1990 //
     /* 175151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175217 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175221 */     // MIs[3] Operand 1
     /* 175221 */     // No operand predicates
     /* 175221 */     // MIs[1] Operand 2
     /* 175221 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175234 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 175237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175248 */     GIR_RootConstrainSelectedInstOperands,
     /* 175249 */     // GIR_Coverage, 1990,
     /* 175249 */     GIR_EraseRootFromParent_Done,
     /* 175250 */   // Label 3260: @175250
     /* 175250 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(175354), // Rule ID 2020 //
     /* 175255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 175263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175321 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175325 */     // MIs[3] Operand 1
     /* 175325 */     // No operand predicates
     /* 175325 */     // MIs[1] Operand 2
     /* 175325 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175338 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 175341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175352 */     GIR_RootConstrainSelectedInstOperands,
     /* 175353 */     // GIR_Coverage, 2020,
     /* 175353 */     GIR_EraseRootFromParent_Done,
     /* 175354 */   // Label 3261: @175354
     /* 175354 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(175458), // Rule ID 2027 //
     /* 175359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 175367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175429 */     // MIs[3] Operand 1
     /* 175429 */     // No operand predicates
     /* 175429 */     // MIs[1] Operand 2
     /* 175429 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175442 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 175445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175456 */     GIR_RootConstrainSelectedInstOperands,
     /* 175457 */     // GIR_Coverage, 2027,
     /* 175457 */     GIR_EraseRootFromParent_Done,
     /* 175458 */   // Label 3262: @175458
     /* 175458 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(175562), // Rule ID 2086 //
     /* 175463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175529 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175533 */     // MIs[3] Operand 1
     /* 175533 */     // No operand predicates
     /* 175533 */     // MIs[1] Operand 2
     /* 175533 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175546 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 175549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175560 */     GIR_RootConstrainSelectedInstOperands,
     /* 175561 */     // GIR_Coverage, 2086,
     /* 175561 */     GIR_EraseRootFromParent_Done,
     /* 175562 */   // Label 3263: @175562
     /* 175562 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(175619), // Rule ID 1751 //
     /* 175567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 175595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 175602 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 175605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 175612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 175617 */     GIR_RootConstrainSelectedInstOperands,
     /* 175618 */     // GIR_Coverage, 1751,
     /* 175618 */     GIR_EraseRootFromParent_Done,
     /* 175619 */   // Label 3264: @175619
     /* 175619 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(175676), // Rule ID 1753 //
     /* 175624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 175652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 175659 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 175662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 175669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 175674 */     GIR_RootConstrainSelectedInstOperands,
     /* 175675 */     // GIR_Coverage, 1753,
     /* 175675 */     GIR_EraseRootFromParent_Done,
     /* 175676 */   // Label 3265: @175676
     /* 175676 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(175786), // Rule ID 6317 //
     /* 175681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 175686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 175707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 175711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 175715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175720 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 175731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175739 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 175743 */     // MIs[2] Operand 1
     /* 175743 */     // No operand predicates
     /* 175743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 175745 */     // (intrinsic_wo_chain:{ *:[f16] } 773:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 175745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175757 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 175776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 175784 */     GIR_RootConstrainSelectedInstOperands,
     /* 175785 */     // GIR_Coverage, 6317,
     /* 175785 */     GIR_EraseRootFromParent_Done,
     /* 175786 */   // Label 3266: @175786
     /* 175786 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(175883), // Rule ID 13978 //
     /* 175791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 175794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175833 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175843 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 175843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175855 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 175861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 175874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175881 */     GIR_RootConstrainSelectedInstOperands,
     /* 175882 */     // GIR_Coverage, 13978,
     /* 175882 */     GIR_EraseRootFromParent_Done,
     /* 175883 */   // Label 3267: @175883
     /* 175883 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(175980), // Rule ID 13979 //
     /* 175888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 175891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175930 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175940 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 175940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175952 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 175958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 175971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175978 */     GIR_RootConstrainSelectedInstOperands,
     /* 175979 */     // GIR_Coverage, 13979,
     /* 175979 */     GIR_EraseRootFromParent_Done,
     /* 175980 */   // Label 3268: @175980
     /* 175980 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(176077), // Rule ID 13980 //
     /* 175985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 175988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 176018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176027 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 176031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176037 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 176037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 176040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176049 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 176055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 176068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176075 */     GIR_RootConstrainSelectedInstOperands,
     /* 176076 */     // GIR_Coverage, 13980,
     /* 176076 */     GIR_EraseRootFromParent_Done,
     /* 176077 */   // Label 3269: @176077
     /* 176077 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(176157), // Rule ID 5249 //
     /* 176082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 176087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176112 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176115 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176140 */     // (intrinsic_wo_chain:{ *:[i64] } 686:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 176143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 176155 */     GIR_RootConstrainSelectedInstOperands,
     /* 176156 */     // GIR_Coverage, 5249,
     /* 176156 */     GIR_EraseRootFromParent_Done,
     /* 176157 */   // Label 3270: @176157
     /* 176157 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(176237), // Rule ID 5250 //
     /* 176162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176192 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176195 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176204 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176220 */     // (intrinsic_wo_chain:{ *:[i64] } 705:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 176223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 176235 */     GIR_RootConstrainSelectedInstOperands,
     /* 176236 */     // GIR_Coverage, 5250,
     /* 176236 */     GIR_EraseRootFromParent_Done,
     /* 176237 */   // Label 3271: @176237
     /* 176237 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(176334), // Rule ID 5246 //
     /* 176242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 176245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 176253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176288 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 176292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176294 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 176294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 176297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176306 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 176312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 176325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176332 */     GIR_RootConstrainSelectedInstOperands,
     /* 176333 */     // GIR_Coverage, 5246,
     /* 176333 */     GIR_EraseRootFromParent_Done,
     /* 176334 */   // Label 3272: @176334
     /* 176334 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(176431), // Rule ID 5247 //
     /* 176339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 176342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176385 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 176389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176391 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 176391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 176394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176403 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 176409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 176422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176429 */     GIR_RootConstrainSelectedInstOperands,
     /* 176430 */     // GIR_Coverage, 5247,
     /* 176430 */     GIR_EraseRootFromParent_Done,
     /* 176431 */   // Label 3273: @176431
     /* 176431 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(176528), // Rule ID 5248 //
     /* 176436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 176439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 176473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176482 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 176486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176488 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 176488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 176491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 176506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 176519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176526 */     GIR_RootConstrainSelectedInstOperands,
     /* 176527 */     // GIR_Coverage, 5248,
     /* 176527 */     GIR_EraseRootFromParent_Done,
     /* 176528 */   // Label 3274: @176528
     /* 176528 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(176609), // Rule ID 13516 //
     /* 176533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176587 */     // MIs[2] Operand 1
     /* 176587 */     // No operand predicates
     /* 176587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176593 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 176596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176607 */     GIR_RootConstrainSelectedInstOperands,
     /* 176608 */     // GIR_Coverage, 13516,
     /* 176608 */     GIR_EraseRootFromParent_Done,
     /* 176609 */   // Label 3275: @176609
     /* 176609 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(176690), // Rule ID 13517 //
     /* 176614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176664 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176668 */     // MIs[2] Operand 1
     /* 176668 */     // No operand predicates
     /* 176668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176674 */     // (intrinsic_wo_chain:{ *:[v8f16] } 617:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 176677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176688 */     GIR_RootConstrainSelectedInstOperands,
     /* 176689 */     // GIR_Coverage, 13517,
     /* 176689 */     GIR_EraseRootFromParent_Done,
     /* 176690 */   // Label 3276: @176690
     /* 176690 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(176771), // Rule ID 13519 //
     /* 176695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176745 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176749 */     // MIs[2] Operand 1
     /* 176749 */     // No operand predicates
     /* 176749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176755 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 176758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176769 */     GIR_RootConstrainSelectedInstOperands,
     /* 176770 */     // GIR_Coverage, 13519,
     /* 176770 */     GIR_EraseRootFromParent_Done,
     /* 176771 */   // Label 3277: @176771
     /* 176771 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(176852), // Rule ID 13520 //
     /* 176776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176830 */     // MIs[2] Operand 1
     /* 176830 */     // No operand predicates
     /* 176830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176836 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 176839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176850 */     GIR_RootConstrainSelectedInstOperands,
     /* 176851 */     // GIR_Coverage, 13520,
     /* 176851 */     GIR_EraseRootFromParent_Done,
     /* 176852 */   // Label 3278: @176852
     /* 176852 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(176933), // Rule ID 13521 //
     /* 176857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 176886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 176890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 176911 */     // MIs[2] Operand 1
     /* 176911 */     // No operand predicates
     /* 176911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176917 */     // (intrinsic_wo_chain:{ *:[v2f64] } 617:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 176920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176931 */     GIR_RootConstrainSelectedInstOperands,
     /* 176932 */     // GIR_Coverage, 13521,
     /* 176932 */     GIR_EraseRootFromParent_Done,
     /* 176933 */   // Label 3279: @176933
     /* 176933 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(177014), // Rule ID 13522 //
     /* 176938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 176949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176988 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176992 */     // MIs[2] Operand 1
     /* 176992 */     // No operand predicates
     /* 176992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176998 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 177001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177012 */     GIR_RootConstrainSelectedInstOperands,
     /* 177013 */     // GIR_Coverage, 13522,
     /* 177013 */     GIR_EraseRootFromParent_Done,
     /* 177014 */   // Label 3280: @177014
     /* 177014 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(177095), // Rule ID 13523 //
     /* 177019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177069 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177073 */     // MIs[2] Operand 1
     /* 177073 */     // No operand predicates
     /* 177073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177079 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 177082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177093 */     GIR_RootConstrainSelectedInstOperands,
     /* 177094 */     // GIR_Coverage, 13523,
     /* 177094 */     GIR_EraseRootFromParent_Done,
     /* 177095 */   // Label 3281: @177095
     /* 177095 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(177176), // Rule ID 13524 //
     /* 177100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177150 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 177154 */     // MIs[2] Operand 1
     /* 177154 */     // No operand predicates
     /* 177154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177160 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 177163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177174 */     GIR_RootConstrainSelectedInstOperands,
     /* 177175 */     // GIR_Coverage, 13524,
     /* 177175 */     GIR_EraseRootFromParent_Done,
     /* 177176 */   // Label 3282: @177176
     /* 177176 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(177282), // Rule ID 6314 //
     /* 177181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 177186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 177207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 177211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177216 */     // MIs[1] Operand 2
     /* 177216 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 177227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 177231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 177239 */     // MIs[2] Operand 1
     /* 177239 */     // No operand predicates
     /* 177239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177241 */     // (intrinsic_wo_chain:{ *:[f16] } 772:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 177241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177253 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 177259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 177272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 177280 */     GIR_RootConstrainSelectedInstOperands,
     /* 177281 */     // GIR_Coverage, 6314,
     /* 177281 */     GIR_EraseRootFromParent_Done,
     /* 177282 */   // Label 3283: @177282
     /* 177282 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(177363), // Rule ID 1988 //
     /* 177287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 177290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177341 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177345 */     // MIs[2] Operand 1
     /* 177345 */     // No operand predicates
     /* 177345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177347 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 177350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177361 */     GIR_RootConstrainSelectedInstOperands,
     /* 177362 */     // GIR_Coverage, 1988,
     /* 177362 */     GIR_EraseRootFromParent_Done,
     /* 177363 */   // Label 3284: @177363
     /* 177363 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(177444), // Rule ID 1989 //
     /* 177368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 177371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177422 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177426 */     // MIs[2] Operand 1
     /* 177426 */     // No operand predicates
     /* 177426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177428 */     // (intrinsic_wo_chain:{ *:[v8f16] } 617:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 177431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177442 */     GIR_RootConstrainSelectedInstOperands,
     /* 177443 */     // GIR_Coverage, 1989,
     /* 177443 */     GIR_EraseRootFromParent_Done,
     /* 177444 */   // Label 3285: @177444
     /* 177444 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(177525), // Rule ID 2018 //
     /* 177449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177503 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177507 */     // MIs[2] Operand 1
     /* 177507 */     // No operand predicates
     /* 177507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177509 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 177512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177523 */     GIR_RootConstrainSelectedInstOperands,
     /* 177524 */     // GIR_Coverage, 2018,
     /* 177524 */     GIR_EraseRootFromParent_Done,
     /* 177525 */   // Label 3286: @177525
     /* 177525 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(177606), // Rule ID 2019 //
     /* 177530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177584 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177588 */     // MIs[2] Operand 1
     /* 177588 */     // No operand predicates
     /* 177588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177590 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 177593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177604 */     GIR_RootConstrainSelectedInstOperands,
     /* 177605 */     // GIR_Coverage, 2019,
     /* 177605 */     GIR_EraseRootFromParent_Done,
     /* 177606 */   // Label 3287: @177606
     /* 177606 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(177687), // Rule ID 2025 //
     /* 177611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 177619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177665 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177669 */     // MIs[2] Operand 1
     /* 177669 */     // No operand predicates
     /* 177669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177671 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 177674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177685 */     GIR_RootConstrainSelectedInstOperands,
     /* 177686 */     // GIR_Coverage, 2025,
     /* 177686 */     GIR_EraseRootFromParent_Done,
     /* 177687 */   // Label 3288: @177687
     /* 177687 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(177768), // Rule ID 2026 //
     /* 177692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 177700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177750 */     // MIs[2] Operand 1
     /* 177750 */     // No operand predicates
     /* 177750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177752 */     // (intrinsic_wo_chain:{ *:[v8i16] } 695:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 177755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177766 */     GIR_RootConstrainSelectedInstOperands,
     /* 177767 */     // GIR_Coverage, 2026,
     /* 177767 */     GIR_EraseRootFromParent_Done,
     /* 177768 */   // Label 3289: @177768
     /* 177768 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(177849), // Rule ID 2084 //
     /* 177773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177827 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177831 */     // MIs[2] Operand 1
     /* 177831 */     // No operand predicates
     /* 177831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177833 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 177836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177847 */     GIR_RootConstrainSelectedInstOperands,
     /* 177848 */     // GIR_Coverage, 2084,
     /* 177848 */     GIR_EraseRootFromParent_Done,
     /* 177849 */   // Label 3290: @177849
     /* 177849 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(177930), // Rule ID 1991 //
     /* 177854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177908 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177912 */     // MIs[2] Operand 1
     /* 177912 */     // No operand predicates
     /* 177912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177914 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 177917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177928 */     GIR_RootConstrainSelectedInstOperands,
     /* 177929 */     // GIR_Coverage, 1991,
     /* 177929 */     GIR_EraseRootFromParent_Done,
     /* 177930 */   // Label 3291: @177930
     /* 177930 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(178011), // Rule ID 1992 //
     /* 177935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177993 */     // MIs[2] Operand 1
     /* 177993 */     // No operand predicates
     /* 177993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177995 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 177998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178009 */     GIR_RootConstrainSelectedInstOperands,
     /* 178010 */     // GIR_Coverage, 1992,
     /* 178010 */     GIR_EraseRootFromParent_Done,
     /* 178011 */   // Label 3292: @178011
     /* 178011 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(178092), // Rule ID 2021 //
     /* 178016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178074 */     // MIs[2] Operand 1
     /* 178074 */     // No operand predicates
     /* 178074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178076 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 178079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178090 */     GIR_RootConstrainSelectedInstOperands,
     /* 178091 */     // GIR_Coverage, 2021,
     /* 178091 */     GIR_EraseRootFromParent_Done,
     /* 178092 */   // Label 3293: @178092
     /* 178092 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(178173), // Rule ID 2022 //
     /* 178097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178155 */     // MIs[2] Operand 1
     /* 178155 */     // No operand predicates
     /* 178155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178157 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 178160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178171 */     GIR_RootConstrainSelectedInstOperands,
     /* 178172 */     // GIR_Coverage, 2022,
     /* 178172 */     GIR_EraseRootFromParent_Done,
     /* 178173 */   // Label 3294: @178173
     /* 178173 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(178254), // Rule ID 2028 //
     /* 178178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 178186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178232 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178236 */     // MIs[2] Operand 1
     /* 178236 */     // No operand predicates
     /* 178236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178238 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 178241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178252 */     GIR_RootConstrainSelectedInstOperands,
     /* 178253 */     // GIR_Coverage, 2028,
     /* 178253 */     GIR_EraseRootFromParent_Done,
     /* 178254 */   // Label 3295: @178254
     /* 178254 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(178335), // Rule ID 2029 //
     /* 178259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 178267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178313 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178317 */     // MIs[2] Operand 1
     /* 178317 */     // No operand predicates
     /* 178317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178319 */     // (intrinsic_wo_chain:{ *:[v4i32] } 695:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 178322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178333 */     GIR_RootConstrainSelectedInstOperands,
     /* 178334 */     // GIR_Coverage, 2029,
     /* 178334 */     GIR_EraseRootFromParent_Done,
     /* 178335 */   // Label 3296: @178335
     /* 178335 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(178416), // Rule ID 2087 //
     /* 178340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178398 */     // MIs[2] Operand 1
     /* 178398 */     // No operand predicates
     /* 178398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178400 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 178403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178414 */     GIR_RootConstrainSelectedInstOperands,
     /* 178415 */     // GIR_Coverage, 2087,
     /* 178415 */     GIR_EraseRootFromParent_Done,
     /* 178416 */   // Label 3297: @178416
     /* 178416 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(178497), // Rule ID 1993 //
     /* 178421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 178454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178479 */     // MIs[2] Operand 1
     /* 178479 */     // No operand predicates
     /* 178479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178481 */     // (intrinsic_wo_chain:{ *:[v2f64] } 617:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 178484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178495 */     GIR_RootConstrainSelectedInstOperands,
     /* 178496 */     // GIR_Coverage, 1993,
     /* 178496 */     GIR_EraseRootFromParent_Done,
     /* 178497 */   // Label 3298: @178497
     /* 178497 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(178578), // Rule ID 1994 //
     /* 178502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178556 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178560 */     // MIs[2] Operand 1
     /* 178560 */     // No operand predicates
     /* 178560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178562 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 178565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178576 */     GIR_RootConstrainSelectedInstOperands,
     /* 178577 */     // GIR_Coverage, 1994,
     /* 178577 */     GIR_EraseRootFromParent_Done,
     /* 178578 */   // Label 3299: @178578
     /* 178578 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(178659), // Rule ID 1995 //
     /* 178583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178637 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178641 */     // MIs[2] Operand 1
     /* 178641 */     // No operand predicates
     /* 178641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178643 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 178646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178657 */     GIR_RootConstrainSelectedInstOperands,
     /* 178658 */     // GIR_Coverage, 1995,
     /* 178658 */     GIR_EraseRootFromParent_Done,
     /* 178659 */   // Label 3300: @178659
     /* 178659 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(178740), // Rule ID 1996 //
     /* 178664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178718 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178722 */     // MIs[2] Operand 1
     /* 178722 */     // No operand predicates
     /* 178722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178724 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 178727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178738 */     GIR_RootConstrainSelectedInstOperands,
     /* 178739 */     // GIR_Coverage, 1996,
     /* 178739 */     GIR_EraseRootFromParent_Done,
     /* 178740 */   // Label 3301: @178740
     /* 178740 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(178821), // Rule ID 2023 //
     /* 178745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178799 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178803 */     // MIs[2] Operand 1
     /* 178803 */     // No operand predicates
     /* 178803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178805 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 178808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178819 */     GIR_RootConstrainSelectedInstOperands,
     /* 178820 */     // GIR_Coverage, 2023,
     /* 178820 */     GIR_EraseRootFromParent_Done,
     /* 178821 */   // Label 3302: @178821
     /* 178821 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(178902), // Rule ID 2030 //
     /* 178826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 178834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178880 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178884 */     // MIs[2] Operand 1
     /* 178884 */     // No operand predicates
     /* 178884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178886 */     // (intrinsic_wo_chain:{ *:[i32] } 695:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 178889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178900 */     GIR_RootConstrainSelectedInstOperands,
     /* 178901 */     // GIR_Coverage, 2030,
     /* 178901 */     GIR_EraseRootFromParent_Done,
     /* 178902 */   // Label 3303: @178902
     /* 178902 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(178980), // Rule ID 6301 //
     /* 178907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 178912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178962 */     // MIs[2] Operand 1
     /* 178962 */     // No operand predicates
     /* 178962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178964 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 178964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 178967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 178975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178978 */     GIR_RootConstrainSelectedInstOperands,
     /* 178979 */     // GIR_Coverage, 6301,
     /* 178979 */     GIR_EraseRootFromParent_Done,
     /* 178980 */   // Label 3304: @178980
     /* 178980 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(179040), // Rule ID 6367 //
     /* 178985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 178990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 179011 */     // (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 179011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 179014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 179018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179023 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 179026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 179028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 179031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 179035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179038 */     GIR_RootConstrainSelectedInstOperands,
     /* 179039 */     // GIR_Coverage, 6367,
     /* 179039 */     GIR_EraseRootFromParent_Done,
     /* 179040 */   // Label 3305: @179040
     /* 179040 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(179100), // Rule ID 6368 //
     /* 179045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 179050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 179071 */     // (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 179071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 179074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 179078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179083 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 179086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 179088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 179091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 179095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179098 */     GIR_RootConstrainSelectedInstOperands,
     /* 179099 */     // GIR_Coverage, 6368,
     /* 179099 */     GIR_EraseRootFromParent_Done,
     /* 179100 */   // Label 3306: @179100
     /* 179100 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(179160), // Rule ID 6369 //
     /* 179105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 179110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 179131 */     // (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 179131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 179134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 179138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179143 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 179146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 179148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 179151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 179155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179158 */     GIR_RootConstrainSelectedInstOperands,
     /* 179159 */     // GIR_Coverage, 6369,
     /* 179159 */     GIR_EraseRootFromParent_Done,
     /* 179160 */   // Label 3307: @179160
     /* 179160 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(179207), // Rule ID 3894 //
     /* 179165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 179168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 179173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179187 */     // MIs[0] Operand 3
     /* 179187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 179198 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 179198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 179201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179205 */     GIR_RootConstrainSelectedInstOperands,
     /* 179206 */     // GIR_Coverage, 3894,
     /* 179206 */     GIR_EraseRootFromParent_Done,
     /* 179207 */   // Label 3308: @179207
     /* 179207 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(179254), // Rule ID 3895 //
     /* 179212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 179215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 179220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179234 */     // MIs[0] Operand 3
     /* 179234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 179245 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 179245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 179248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179252 */     GIR_RootConstrainSelectedInstOperands,
     /* 179253 */     // GIR_Coverage, 3895,
     /* 179253 */     GIR_EraseRootFromParent_Done,
     /* 179254 */   // Label 3309: @179254
     /* 179254 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(179301), // Rule ID 3896 //
     /* 179259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 179262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 179267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179281 */     // MIs[0] Operand 3
     /* 179281 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 179292 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 179292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 179295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179299 */     GIR_RootConstrainSelectedInstOperands,
     /* 179300 */     // GIR_Coverage, 3896,
     /* 179300 */     GIR_EraseRootFromParent_Done,
     /* 179301 */   // Label 3310: @179301
     /* 179301 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(179348), // Rule ID 3897 //
     /* 179306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 179309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 179314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179328 */     // MIs[0] Operand 3
     /* 179328 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 179339 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 179339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 179342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179346 */     GIR_RootConstrainSelectedInstOperands,
     /* 179347 */     // GIR_Coverage, 3897,
     /* 179347 */     GIR_EraseRootFromParent_Done,
     /* 179348 */   // Label 3311: @179348
     /* 179348 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(179394), // Rule ID 3537 //
     /* 179353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 179356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 179361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 179364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179375 */     // MIs[0] Idx
     /* 179375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 179378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 179383 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 179383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 179386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 179390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 179392 */     GIR_RootConstrainSelectedInstOperands,
     /* 179393 */     // GIR_Coverage, 3537,
     /* 179393 */     GIR_EraseRootFromParent_Done,
     /* 179394 */   // Label 3312: @179394
     /* 179394 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(179440), // Rule ID 3538 //
     /* 179399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 179402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 179407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 179410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179421 */     // MIs[0] Idx
     /* 179421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 179424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 179429 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 179429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 179432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 179436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 179438 */     GIR_RootConstrainSelectedInstOperands,
     /* 179439 */     // GIR_Coverage, 3538,
     /* 179439 */     GIR_EraseRootFromParent_Done,
     /* 179440 */   // Label 3313: @179440
     /* 179440 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(179486), // Rule ID 3539 //
     /* 179445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 179448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 179453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 179456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179467 */     // MIs[0] Idx
     /* 179467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 179470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 179475 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 179475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 179478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 179482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 179484 */     GIR_RootConstrainSelectedInstOperands,
     /* 179485 */     // GIR_Coverage, 3539,
     /* 179485 */     GIR_EraseRootFromParent_Done,
     /* 179486 */   // Label 3314: @179486
     /* 179486 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(179532), // Rule ID 3540 //
     /* 179491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 179494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 179499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 179502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179513 */     // MIs[0] Idx
     /* 179513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 179516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 179521 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 179521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 179524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 179528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 179530 */     GIR_RootConstrainSelectedInstOperands,
     /* 179531 */     // GIR_Coverage, 3540,
     /* 179531 */     GIR_EraseRootFromParent_Done,
     /* 179532 */   // Label 3315: @179532
     /* 179532 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(179588), // Rule ID 2109 //
     /* 179537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 179545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179574 */     // MIs[1] Operand 1
     /* 179574 */     // No operand predicates
     /* 179574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179576 */     // (intrinsic_wo_chain:{ *:[i32] } 699:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 179579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179586 */     GIR_RootConstrainSelectedInstOperands,
     /* 179587 */     // GIR_Coverage, 2109,
     /* 179587 */     GIR_EraseRootFromParent_Done,
     /* 179588 */   // Label 3316: @179588
     /* 179588 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(179644), // Rule ID 2110 //
     /* 179593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 179601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179630 */     // MIs[1] Operand 1
     /* 179630 */     // No operand predicates
     /* 179630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179632 */     // (intrinsic_wo_chain:{ *:[i32] } 700:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 179635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179642 */     GIR_RootConstrainSelectedInstOperands,
     /* 179643 */     // GIR_Coverage, 2110,
     /* 179643 */     GIR_EraseRootFromParent_Done,
     /* 179644 */   // Label 3317: @179644
     /* 179644 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(179700), // Rule ID 2115 //
     /* 179649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 179657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179686 */     // MIs[1] Operand 1
     /* 179686 */     // No operand predicates
     /* 179686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179688 */     // (intrinsic_wo_chain:{ *:[i32] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 179691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179698 */     GIR_RootConstrainSelectedInstOperands,
     /* 179699 */     // GIR_Coverage, 2115,
     /* 179699 */     GIR_EraseRootFromParent_Done,
     /* 179700 */   // Label 3318: @179700
     /* 179700 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(179756), // Rule ID 2116 //
     /* 179705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 179713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179742 */     // MIs[1] Operand 1
     /* 179742 */     // No operand predicates
     /* 179742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179744 */     // (intrinsic_wo_chain:{ *:[i32] } 704:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 179747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179754 */     GIR_RootConstrainSelectedInstOperands,
     /* 179755 */     // GIR_Coverage, 2116,
     /* 179755 */     GIR_EraseRootFromParent_Done,
     /* 179756 */   // Label 3319: @179756
     /* 179756 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(179812), // Rule ID 2123 //
     /* 179761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 179769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179798 */     // MIs[1] Operand 1
     /* 179798 */     // No operand predicates
     /* 179798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179800 */     // (intrinsic_wo_chain:{ *:[i32] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 179803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179810 */     GIR_RootConstrainSelectedInstOperands,
     /* 179811 */     // GIR_Coverage, 2123,
     /* 179811 */     GIR_EraseRootFromParent_Done,
     /* 179812 */   // Label 3320: @179812
     /* 179812 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(179868), // Rule ID 2126 //
     /* 179817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 179825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179854 */     // MIs[1] Operand 1
     /* 179854 */     // No operand predicates
     /* 179854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179856 */     // (intrinsic_wo_chain:{ *:[i32] } 750:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 179859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179866 */     GIR_RootConstrainSelectedInstOperands,
     /* 179867 */     // GIR_Coverage, 2126,
     /* 179867 */     GIR_EraseRootFromParent_Done,
     /* 179868 */   // Label 3321: @179868
     /* 179868 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(179924), // Rule ID 2148 //
     /* 179873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 179881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 179910 */     // MIs[1] Operand 1
     /* 179910 */     // No operand predicates
     /* 179910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179912 */     // (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 179915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179922 */     GIR_RootConstrainSelectedInstOperands,
     /* 179923 */     // GIR_Coverage, 2148,
     /* 179923 */     GIR_EraseRootFromParent_Done,
     /* 179924 */   // Label 3322: @179924
     /* 179924 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(179980), // Rule ID 2150 //
     /* 179929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 179937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 179966 */     // MIs[1] Operand 1
     /* 179966 */     // No operand predicates
     /* 179966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179968 */     // (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 179971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179978 */     GIR_RootConstrainSelectedInstOperands,
     /* 179979 */     // GIR_Coverage, 2150,
     /* 179979 */     GIR_EraseRootFromParent_Done,
     /* 179980 */   // Label 3323: @179980
     /* 179980 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(180036), // Rule ID 2152 //
     /* 179985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 179993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 180022 */     // MIs[1] Operand 1
     /* 180022 */     // No operand predicates
     /* 180022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180024 */     // (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 180024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 180027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180034 */     GIR_RootConstrainSelectedInstOperands,
     /* 180035 */     // GIR_Coverage, 2152,
     /* 180035 */     GIR_EraseRootFromParent_Done,
     /* 180036 */   // Label 3324: @180036
     /* 180036 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(180089), // Rule ID 6302 //
     /* 180041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 180046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 180075 */     // MIs[1] Operand 1
     /* 180075 */     // No operand predicates
     /* 180075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180077 */     // (intrinsic_wo_chain:{ *:[i32] } 769:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 180077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 180080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180087 */     GIR_RootConstrainSelectedInstOperands,
     /* 180088 */     // GIR_Coverage, 6302,
     /* 180088 */     GIR_EraseRootFromParent_Done,
     /* 180089 */   // Label 3325: @180089
     /* 180089 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(180142), // Rule ID 6303 //
     /* 180094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 180099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 180128 */     // MIs[1] Operand 1
     /* 180128 */     // No operand predicates
     /* 180128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180130 */     // (intrinsic_wo_chain:{ *:[i32] } 770:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 180130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 180133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180140 */     GIR_RootConstrainSelectedInstOperands,
     /* 180141 */     // GIR_Coverage, 6303,
     /* 180141 */     GIR_EraseRootFromParent_Done,
     /* 180142 */   // Label 3326: @180142
     /* 180142 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(180195), // Rule ID 6304 //
     /* 180147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 180152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180181 */     // MIs[1] Operand 1
     /* 180181 */     // No operand predicates
     /* 180181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180183 */     // (intrinsic_wo_chain:{ *:[i64] } 769:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 180186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180193 */     GIR_RootConstrainSelectedInstOperands,
     /* 180194 */     // GIR_Coverage, 6304,
     /* 180194 */     GIR_EraseRootFromParent_Done,
     /* 180195 */   // Label 3327: @180195
     /* 180195 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(180248), // Rule ID 6305 //
     /* 180200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 180205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180234 */     // MIs[1] Operand 1
     /* 180234 */     // No operand predicates
     /* 180234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180236 */     // (intrinsic_wo_chain:{ *:[i64] } 770:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 180239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180246 */     GIR_RootConstrainSelectedInstOperands,
     /* 180247 */     // GIR_Coverage, 6305,
     /* 180247 */     GIR_EraseRootFromParent_Done,
     /* 180248 */   // Label 3328: @180248
     /* 180248 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(180301), // Rule ID 6306 //
     /* 180253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 180258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180287 */     // MIs[1] Operand 1
     /* 180287 */     // No operand predicates
     /* 180287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180289 */     // (intrinsic_wo_chain:{ *:[v1i64] } 769:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 180292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180299 */     GIR_RootConstrainSelectedInstOperands,
     /* 180300 */     // GIR_Coverage, 6306,
     /* 180300 */     GIR_EraseRootFromParent_Done,
     /* 180301 */   // Label 3329: @180301
     /* 180301 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(180354), // Rule ID 6307 //
     /* 180306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 180311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180340 */     // MIs[1] Operand 1
     /* 180340 */     // No operand predicates
     /* 180340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180342 */     // (intrinsic_wo_chain:{ *:[v1i64] } 770:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 180345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180352 */     GIR_RootConstrainSelectedInstOperands,
     /* 180353 */     // GIR_Coverage, 6307,
     /* 180353 */     GIR_EraseRootFromParent_Done,
     /* 180354 */   // Label 3330: @180354
     /* 180354 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(180407), // Rule ID 6308 //
     /* 180359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 180364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 180393 */     // MIs[1] Operand 1
     /* 180393 */     // No operand predicates
     /* 180393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180395 */     // (intrinsic_wo_chain:{ *:[f32] } 773:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 180395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 180398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180405 */     GIR_RootConstrainSelectedInstOperands,
     /* 180406 */     // GIR_Coverage, 6308,
     /* 180406 */     GIR_EraseRootFromParent_Done,
     /* 180407 */   // Label 3331: @180407
     /* 180407 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(180460), // Rule ID 6309 //
     /* 180412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 180417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180446 */     // MIs[1] Operand 1
     /* 180446 */     // No operand predicates
     /* 180446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180448 */     // (intrinsic_wo_chain:{ *:[f64] } 773:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 180451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180458 */     GIR_RootConstrainSelectedInstOperands,
     /* 180459 */     // GIR_Coverage, 6309,
     /* 180459 */     GIR_EraseRootFromParent_Done,
     /* 180460 */   // Label 3332: @180460
     /* 180460 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(180513), // Rule ID 6310 //
     /* 180465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 180470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180499 */     // MIs[1] Operand 1
     /* 180499 */     // No operand predicates
     /* 180499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180501 */     // (intrinsic_wo_chain:{ *:[v1f64] } 772:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 180504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180511 */     GIR_RootConstrainSelectedInstOperands,
     /* 180512 */     // GIR_Coverage, 6310,
     /* 180512 */     GIR_EraseRootFromParent_Done,
     /* 180513 */   // Label 3333: @180513
     /* 180513 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(180566), // Rule ID 6311 //
     /* 180518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 180523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180552 */     // MIs[1] Operand 1
     /* 180552 */     // No operand predicates
     /* 180552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180554 */     // (intrinsic_wo_chain:{ *:[f64] } 772:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 180557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180564 */     GIR_RootConstrainSelectedInstOperands,
     /* 180565 */     // GIR_Coverage, 6311,
     /* 180565 */     GIR_EraseRootFromParent_Done,
     /* 180566 */   // Label 3334: @180566
     /* 180566 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(180619), // Rule ID 6312 //
     /* 180571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 180576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180605 */     // MIs[1] Operand 1
     /* 180605 */     // No operand predicates
     /* 180605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180607 */     // (intrinsic_wo_chain:{ *:[v1f64] } 773:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 180610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180617 */     GIR_RootConstrainSelectedInstOperands,
     /* 180618 */     // GIR_Coverage, 6312,
     /* 180618 */     GIR_EraseRootFromParent_Done,
     /* 180619 */   // Label 3335: @180619
     /* 180619 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(180672), // Rule ID 6313 //
     /* 180624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 180629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 180658 */     // MIs[1] Operand 1
     /* 180658 */     // No operand predicates
     /* 180658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180660 */     // (intrinsic_wo_chain:{ *:[f32] } 772:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 180660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 180663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180670 */     GIR_RootConstrainSelectedInstOperands,
     /* 180671 */     // GIR_Coverage, 6313,
     /* 180671 */     GIR_EraseRootFromParent_Done,
     /* 180672 */   // Label 3336: @180672
     /* 180672 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(180754), // Rule ID 6315 //
     /* 180677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 180682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 180711 */     // MIs[1] Operand 1
     /* 180711 */     // No operand predicates
     /* 180711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180713 */     // (intrinsic_wo_chain:{ *:[f16] } 772:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 180713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180725 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 180731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 180744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180752 */     GIR_RootConstrainSelectedInstOperands,
     /* 180753 */     // GIR_Coverage, 6315,
     /* 180753 */     GIR_EraseRootFromParent_Done,
     /* 180754 */   // Label 3337: @180754
     /* 180754 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(180836), // Rule ID 6316 //
     /* 180759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 180764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 180793 */     // MIs[1] Operand 1
     /* 180793 */     // No operand predicates
     /* 180793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180795 */     // (intrinsic_wo_chain:{ *:[f16] } 772:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 180795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180807 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 180813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 180826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180834 */     GIR_RootConstrainSelectedInstOperands,
     /* 180835 */     // GIR_Coverage, 6316,
     /* 180835 */     GIR_EraseRootFromParent_Done,
     /* 180836 */   // Label 3338: @180836
     /* 180836 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(180918), // Rule ID 6318 //
     /* 180841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 180846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 180875 */     // MIs[1] Operand 1
     /* 180875 */     // No operand predicates
     /* 180875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180877 */     // (intrinsic_wo_chain:{ *:[f16] } 773:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 180877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180889 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 180895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 180908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180916 */     GIR_RootConstrainSelectedInstOperands,
     /* 180917 */     // GIR_Coverage, 6318,
     /* 180917 */     GIR_EraseRootFromParent_Done,
     /* 180918 */   // Label 3339: @180918
     /* 180918 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(181000), // Rule ID 6319 //
     /* 180923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 180928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 180957 */     // MIs[1] Operand 1
     /* 180957 */     // No operand predicates
     /* 180957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180959 */     // (intrinsic_wo_chain:{ *:[f16] } 773:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 180959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180971 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 180977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 180990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180998 */     GIR_RootConstrainSelectedInstOperands,
     /* 180999 */     // GIR_Coverage, 6319,
     /* 180999 */     GIR_EraseRootFromParent_Done,
     /* 181000 */   // Label 3340: @181000
     /* 181000 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(181106), // Rule ID 6320 //
     /* 181005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 181016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181039 */     // MIs[1] Operand 1
     /* 181039 */     // No operand predicates
     /* 181039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181041 */     // (intrinsic_wo_chain:{ *:[i32] } 769:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 181041 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 181044 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 181048 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181053 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 181057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 181060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 181062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 181090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181105 */     // GIR_Coverage, 6320,
     /* 181105 */     GIR_EraseRootFromParent_Done,
     /* 181106 */   // Label 3341: @181106
     /* 181106 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(181212), // Rule ID 6321 //
     /* 181111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 181122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181145 */     // MIs[1] Operand 1
     /* 181145 */     // No operand predicates
     /* 181145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181147 */     // (intrinsic_wo_chain:{ *:[i64] } 769:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 181147 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 181150 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 181154 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181159 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 181163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 181166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 181168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 181196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181211 */     // GIR_Coverage, 6321,
     /* 181211 */     GIR_EraseRootFromParent_Done,
     /* 181212 */   // Label 3342: @181212
     /* 181212 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(181318), // Rule ID 6322 //
     /* 181217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 181228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181251 */     // MIs[1] Operand 1
     /* 181251 */     // No operand predicates
     /* 181251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181253 */     // (intrinsic_wo_chain:{ *:[i32] } 770:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 181253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 181256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 181260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181265 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 181269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 181272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 181274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 181302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181317 */     // GIR_Coverage, 6322,
     /* 181317 */     GIR_EraseRootFromParent_Done,
     /* 181318 */   // Label 3343: @181318
     /* 181318 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(181424), // Rule ID 6323 //
     /* 181323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 181334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181357 */     // MIs[1] Operand 1
     /* 181357 */     // No operand predicates
     /* 181357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181359 */     // (intrinsic_wo_chain:{ *:[i64] } 770:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 181359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 181362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 181366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 181375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 181378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 181380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 181408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181423 */     // GIR_Coverage, 6323,
     /* 181423 */     GIR_EraseRootFromParent_Done,
     /* 181424 */   // Label 3344: @181424
     /* 181424 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(181482), // Rule ID 7014 //
     /* 181429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 181434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 181463 */     // MIs[1] Operand 1
     /* 181463 */     // No operand predicates
     /* 181463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181465 */     // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 181465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 181468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181472 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 181477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 181480 */     GIR_RootConstrainSelectedInstOperands,
     /* 181481 */     // GIR_Coverage, 7014,
     /* 181481 */     GIR_EraseRootFromParent_Done,
     /* 181482 */   // Label 3345: @181482
     /* 181482 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(181524), // Rule ID 3038 //
     /* 181487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 181495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181505 */     // MIs[0] Op2
     /* 181505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 181513 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1871:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 181513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 181516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181522 */     GIR_RootConstrainSelectedInstOperands,
     /* 181523 */     // GIR_Coverage, 3038,
     /* 181523 */     GIR_EraseRootFromParent_Done,
     /* 181524 */   // Label 3346: @181524
     /* 181524 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(181566), // Rule ID 3039 //
     /* 181529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 181537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181547 */     // MIs[0] Op2
     /* 181547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 181555 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1871:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 181555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 181558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181564 */     GIR_RootConstrainSelectedInstOperands,
     /* 181565 */     // GIR_Coverage, 3039,
     /* 181565 */     GIR_EraseRootFromParent_Done,
     /* 181566 */   // Label 3347: @181566
     /* 181566 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(181608), // Rule ID 3040 //
     /* 181571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 181579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181589 */     // MIs[0] Op2
     /* 181589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 181597 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1871:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 181597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 181600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181606 */     GIR_RootConstrainSelectedInstOperands,
     /* 181607 */     // GIR_Coverage, 3040,
     /* 181607 */     GIR_EraseRootFromParent_Done,
     /* 181608 */   // Label 3348: @181608
     /* 181608 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(181650), // Rule ID 3074 //
     /* 181613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 181621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181631 */     // MIs[0] Op2
     /* 181631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 181639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 181639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 181642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181648 */     GIR_RootConstrainSelectedInstOperands,
     /* 181649 */     // GIR_Coverage, 3074,
     /* 181649 */     GIR_EraseRootFromParent_Done,
     /* 181650 */   // Label 3349: @181650
     /* 181650 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(181692), // Rule ID 3075 //
     /* 181655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 181663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181673 */     // MIs[0] Op2
     /* 181673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 181681 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 181681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 181684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181690 */     GIR_RootConstrainSelectedInstOperands,
     /* 181691 */     // GIR_Coverage, 3075,
     /* 181691 */     GIR_EraseRootFromParent_Done,
     /* 181692 */   // Label 3350: @181692
     /* 181692 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(181734), // Rule ID 3076 //
     /* 181697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 181705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181715 */     // MIs[0] Op2
     /* 181715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 181723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 181723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 181726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181732 */     GIR_RootConstrainSelectedInstOperands,
     /* 181733 */     // GIR_Coverage, 3076,
     /* 181733 */     GIR_EraseRootFromParent_Done,
     /* 181734 */   // Label 3351: @181734
     /* 181734 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(181776), // Rule ID 3523 //
     /* 181739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181757 */     // MIs[0] Op2
     /* 181757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 181765 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1352:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 181765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 181768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181774 */     GIR_RootConstrainSelectedInstOperands,
     /* 181775 */     // GIR_Coverage, 3523,
     /* 181775 */     GIR_EraseRootFromParent_Done,
     /* 181776 */   // Label 3352: @181776
     /* 181776 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(181818), // Rule ID 3524 //
     /* 181781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181799 */     // MIs[0] Op2
     /* 181799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 181807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1352:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 181807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 181810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181816 */     GIR_RootConstrainSelectedInstOperands,
     /* 181817 */     // GIR_Coverage, 3524,
     /* 181817 */     GIR_EraseRootFromParent_Done,
     /* 181818 */   // Label 3353: @181818
     /* 181818 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(181860), // Rule ID 3525 //
     /* 181823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181841 */     // MIs[0] Op2
     /* 181841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 181849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1352:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 181849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 181852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181858 */     GIR_RootConstrainSelectedInstOperands,
     /* 181859 */     // GIR_Coverage, 3525,
     /* 181859 */     GIR_EraseRootFromParent_Done,
     /* 181860 */   // Label 3354: @181860
     /* 181860 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(181902), // Rule ID 3526 //
     /* 181865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181883 */     // MIs[0] Op2
     /* 181883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 181891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1352:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 181891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 181894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181900 */     GIR_RootConstrainSelectedInstOperands,
     /* 181901 */     // GIR_Coverage, 3526,
     /* 181901 */     GIR_EraseRootFromParent_Done,
     /* 181902 */   // Label 3355: @181902
     /* 181902 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(181944), // Rule ID 3527 //
     /* 181907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181925 */     // MIs[0] Op2
     /* 181925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 181933 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1352:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 181933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 181936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181942 */     GIR_RootConstrainSelectedInstOperands,
     /* 181943 */     // GIR_Coverage, 3527,
     /* 181943 */     GIR_EraseRootFromParent_Done,
     /* 181944 */   // Label 3356: @181944
     /* 181944 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(181986), // Rule ID 3528 //
     /* 181949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181967 */     // MIs[0] Op2
     /* 181967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181970 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 181975 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1352:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 181975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 181978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181984 */     GIR_RootConstrainSelectedInstOperands,
     /* 181985 */     // GIR_Coverage, 3528,
     /* 181985 */     GIR_EraseRootFromParent_Done,
     /* 181986 */   // Label 3357: @181986
     /* 181986 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(182028), // Rule ID 3529 //
     /* 181991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182009 */     // MIs[0] Op2
     /* 182009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 182017 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1352:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 182017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 182020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182026 */     GIR_RootConstrainSelectedInstOperands,
     /* 182027 */     // GIR_Coverage, 3529,
     /* 182027 */     GIR_EraseRootFromParent_Done,
     /* 182028 */   // Label 3358: @182028
     /* 182028 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(182070), // Rule ID 11811 //
     /* 182033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 182041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182051 */     // MIs[0] Op2
     /* 182051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1846:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 182062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182068 */     GIR_RootConstrainSelectedInstOperands,
     /* 182069 */     // GIR_Coverage, 11811,
     /* 182069 */     GIR_EraseRootFromParent_Done,
     /* 182070 */   // Label 3359: @182070
     /* 182070 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(182112), // Rule ID 11812 //
     /* 182075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 182083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182093 */     // MIs[0] Op2
     /* 182093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1846:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 182104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182110 */     GIR_RootConstrainSelectedInstOperands,
     /* 182111 */     // GIR_Coverage, 11812,
     /* 182111 */     GIR_EraseRootFromParent_Done,
     /* 182112 */   // Label 3360: @182112
     /* 182112 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(182154), // Rule ID 11813 //
     /* 182117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 182125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182135 */     // MIs[0] Op2
     /* 182135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1846:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 182146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182152 */     GIR_RootConstrainSelectedInstOperands,
     /* 182153 */     // GIR_Coverage, 11813,
     /* 182153 */     GIR_EraseRootFromParent_Done,
     /* 182154 */   // Label 3361: @182154
     /* 182154 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(182196), // Rule ID 11814 //
     /* 182159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 182167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182177 */     // MIs[0] Op2
     /* 182177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182185 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 182188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182194 */     GIR_RootConstrainSelectedInstOperands,
     /* 182195 */     // GIR_Coverage, 11814,
     /* 182195 */     GIR_EraseRootFromParent_Done,
     /* 182196 */   // Label 3362: @182196
     /* 182196 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(182238), // Rule ID 11815 //
     /* 182201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 182209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182219 */     // MIs[0] Op2
     /* 182219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 182230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182236 */     GIR_RootConstrainSelectedInstOperands,
     /* 182237 */     // GIR_Coverage, 11815,
     /* 182237 */     GIR_EraseRootFromParent_Done,
     /* 182238 */   // Label 3363: @182238
     /* 182238 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(182280), // Rule ID 11816 //
     /* 182243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 182251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182261 */     // MIs[0] Op2
     /* 182261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 182272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182278 */     GIR_RootConstrainSelectedInstOperands,
     /* 182279 */     // GIR_Coverage, 11816,
     /* 182279 */     GIR_EraseRootFromParent_Done,
     /* 182280 */   // Label 3364: @182280
     /* 182280 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(182322), // Rule ID 11818 //
     /* 182285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 182293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182303 */     // MIs[0] Op2
     /* 182303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1683:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 182314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182320 */     GIR_RootConstrainSelectedInstOperands,
     /* 182321 */     // GIR_Coverage, 11818,
     /* 182321 */     GIR_EraseRootFromParent_Done,
     /* 182322 */   // Label 3365: @182322
     /* 182322 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(182364), // Rule ID 11820 //
     /* 182327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 182335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182345 */     // MIs[0] Op2
     /* 182345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 182356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182362 */     GIR_RootConstrainSelectedInstOperands,
     /* 182363 */     // GIR_Coverage, 11820,
     /* 182363 */     GIR_EraseRootFromParent_Done,
     /* 182364 */   // Label 3366: @182364
     /* 182364 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(182406), // Rule ID 11822 //
     /* 182369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 182377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182387 */     // MIs[0] Op2
     /* 182387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 182398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182404 */     GIR_RootConstrainSelectedInstOperands,
     /* 182405 */     // GIR_Coverage, 11822,
     /* 182405 */     GIR_EraseRootFromParent_Done,
     /* 182406 */   // Label 3367: @182406
     /* 182406 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(182448), // Rule ID 11823 //
     /* 182411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 182419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182429 */     // MIs[0] Op2
     /* 182429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 182440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182446 */     GIR_RootConstrainSelectedInstOperands,
     /* 182447 */     // GIR_Coverage, 11823,
     /* 182447 */     GIR_EraseRootFromParent_Done,
     /* 182448 */   // Label 3368: @182448
     /* 182448 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(182490), // Rule ID 11824 //
     /* 182453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 182461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182471 */     // MIs[0] Op2
     /* 182471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 182482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182488 */     GIR_RootConstrainSelectedInstOperands,
     /* 182489 */     // GIR_Coverage, 11824,
     /* 182489 */     GIR_EraseRootFromParent_Done,
     /* 182490 */   // Label 3369: @182490
     /* 182490 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(182532), // Rule ID 11825 //
     /* 182495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 182503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182513 */     // MIs[0] Op2
     /* 182513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 182524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182530 */     GIR_RootConstrainSelectedInstOperands,
     /* 182531 */     // GIR_Coverage, 11825,
     /* 182531 */     GIR_EraseRootFromParent_Done,
     /* 182532 */   // Label 3370: @182532
     /* 182532 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(182574), // Rule ID 11826 //
     /* 182537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 182545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182555 */     // MIs[0] Op2
     /* 182555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182563 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 182566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182572 */     GIR_RootConstrainSelectedInstOperands,
     /* 182573 */     // GIR_Coverage, 11826,
     /* 182573 */     GIR_EraseRootFromParent_Done,
     /* 182574 */   // Label 3371: @182574
     /* 182574 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(182616), // Rule ID 11827 //
     /* 182579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 182587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182597 */     // MIs[0] Op2
     /* 182597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 182608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182614 */     GIR_RootConstrainSelectedInstOperands,
     /* 182615 */     // GIR_Coverage, 11827,
     /* 182615 */     GIR_EraseRootFromParent_Done,
     /* 182616 */   // Label 3372: @182616
     /* 182616 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(182658), // Rule ID 11828 //
     /* 182621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 182629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182639 */     // MIs[0] Op2
     /* 182639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 182650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182656 */     GIR_RootConstrainSelectedInstOperands,
     /* 182657 */     // GIR_Coverage, 11828,
     /* 182657 */     GIR_EraseRootFromParent_Done,
     /* 182658 */   // Label 3373: @182658
     /* 182658 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(182700), // Rule ID 11829 //
     /* 182663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 182671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182681 */     // MIs[0] Op2
     /* 182681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182689 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 182692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182698 */     GIR_RootConstrainSelectedInstOperands,
     /* 182699 */     // GIR_Coverage, 11829,
     /* 182699 */     GIR_EraseRootFromParent_Done,
     /* 182700 */   // Label 3374: @182700
     /* 182700 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(182742), // Rule ID 11830 //
     /* 182705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 182713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182723 */     // MIs[0] Op2
     /* 182723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 182734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182740 */     GIR_RootConstrainSelectedInstOperands,
     /* 182741 */     // GIR_Coverage, 11830,
     /* 182741 */     GIR_EraseRootFromParent_Done,
     /* 182742 */   // Label 3375: @182742
     /* 182742 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(182784), // Rule ID 11831 //
     /* 182747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 182755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182765 */     // MIs[0] Op2
     /* 182765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 182776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182782 */     GIR_RootConstrainSelectedInstOperands,
     /* 182783 */     // GIR_Coverage, 11831,
     /* 182783 */     GIR_EraseRootFromParent_Done,
     /* 182784 */   // Label 3376: @182784
     /* 182784 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(182826), // Rule ID 11832 //
     /* 182789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 182797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182807 */     // MIs[0] Op2
     /* 182807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182815 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2042:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 182818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182824 */     GIR_RootConstrainSelectedInstOperands,
     /* 182825 */     // GIR_Coverage, 11832,
     /* 182825 */     GIR_EraseRootFromParent_Done,
     /* 182826 */   // Label 3377: @182826
     /* 182826 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(182868), // Rule ID 11833 //
     /* 182831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 182839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182849 */     // MIs[0] Op2
     /* 182849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2042:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 182860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182866 */     GIR_RootConstrainSelectedInstOperands,
     /* 182867 */     // GIR_Coverage, 11833,
     /* 182867 */     GIR_EraseRootFromParent_Done,
     /* 182868 */   // Label 3378: @182868
     /* 182868 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(182910), // Rule ID 11834 //
     /* 182873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 182881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182891 */     // MIs[0] Op2
     /* 182891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2042:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 182902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182908 */     GIR_RootConstrainSelectedInstOperands,
     /* 182909 */     // GIR_Coverage, 11834,
     /* 182909 */     GIR_EraseRootFromParent_Done,
     /* 182910 */   // Label 3379: @182910
     /* 182910 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(182952), // Rule ID 11892 //
     /* 182915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 182923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 182929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182933 */     // MIs[0] Op2
     /* 182933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 182941 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 182941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 182944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182950 */     GIR_RootConstrainSelectedInstOperands,
     /* 182951 */     // GIR_Coverage, 11892,
     /* 182951 */     GIR_EraseRootFromParent_Done,
     /* 182952 */   // Label 3380: @182952
     /* 182952 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(182994), // Rule ID 11893 //
     /* 182957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 182965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182975 */     // MIs[0] Op2
     /* 182975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 182983 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 182983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 182986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182992 */     GIR_RootConstrainSelectedInstOperands,
     /* 182993 */     // GIR_Coverage, 11893,
     /* 182993 */     GIR_EraseRootFromParent_Done,
     /* 182994 */   // Label 3381: @182994
     /* 182994 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(183036), // Rule ID 11894 //
     /* 182999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 183007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183017 */     // MIs[0] Op2
     /* 183017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 183028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183034 */     GIR_RootConstrainSelectedInstOperands,
     /* 183035 */     // GIR_Coverage, 11894,
     /* 183035 */     GIR_EraseRootFromParent_Done,
     /* 183036 */   // Label 3382: @183036
     /* 183036 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(183078), // Rule ID 11895 //
     /* 183041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 183049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183059 */     // MIs[0] Op2
     /* 183059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 183067 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 183067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 183070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183076 */     GIR_RootConstrainSelectedInstOperands,
     /* 183077 */     // GIR_Coverage, 11895,
     /* 183077 */     GIR_EraseRootFromParent_Done,
     /* 183078 */   // Label 3383: @183078
     /* 183078 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(183120), // Rule ID 11896 //
     /* 183083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 183091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183101 */     // MIs[0] Op2
     /* 183101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 183109 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 183109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 183112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183118 */     GIR_RootConstrainSelectedInstOperands,
     /* 183119 */     // GIR_Coverage, 11896,
     /* 183119 */     GIR_EraseRootFromParent_Done,
     /* 183120 */   // Label 3384: @183120
     /* 183120 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(183162), // Rule ID 11897 //
     /* 183125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 183133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183143 */     // MIs[0] Op2
     /* 183143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183151 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 183154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183160 */     GIR_RootConstrainSelectedInstOperands,
     /* 183161 */     // GIR_Coverage, 11897,
     /* 183161 */     GIR_EraseRootFromParent_Done,
     /* 183162 */   // Label 3385: @183162
     /* 183162 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(183204), // Rule ID 11898 //
     /* 183167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 183175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183185 */     // MIs[0] Op2
     /* 183185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 183193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 183193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 183196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183202 */     GIR_RootConstrainSelectedInstOperands,
     /* 183203 */     // GIR_Coverage, 11898,
     /* 183203 */     GIR_EraseRootFromParent_Done,
     /* 183204 */   // Label 3386: @183204
     /* 183204 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(183246), // Rule ID 11899 //
     /* 183209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 183217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183227 */     // MIs[0] Op2
     /* 183227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 183235 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 183235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 183238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183244 */     GIR_RootConstrainSelectedInstOperands,
     /* 183245 */     // GIR_Coverage, 11899,
     /* 183245 */     GIR_EraseRootFromParent_Done,
     /* 183246 */   // Label 3387: @183246
     /* 183246 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(183288), // Rule ID 11900 //
     /* 183251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 183259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183269 */     // MIs[0] Op2
     /* 183269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183272 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 183280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183286 */     GIR_RootConstrainSelectedInstOperands,
     /* 183287 */     // GIR_Coverage, 11900,
     /* 183287 */     GIR_EraseRootFromParent_Done,
     /* 183288 */   // Label 3388: @183288
     /* 183288 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(183340), // Rule ID 2132 //
     /* 183293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 183304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 183307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183326 */     // MIs[1] Operand 1
     /* 183326 */     // No operand predicates
     /* 183326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183328 */     // (intrinsic_wo_chain:{ *:[v4i16] } 769:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 183331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183338 */     GIR_RootConstrainSelectedInstOperands,
     /* 183339 */     // GIR_Coverage, 2132,
     /* 183339 */     GIR_EraseRootFromParent_Done,
     /* 183340 */   // Label 3389: @183340
     /* 183340 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(183392), // Rule ID 2133 //
     /* 183345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183378 */     // MIs[1] Operand 1
     /* 183378 */     // No operand predicates
     /* 183378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183380 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 183383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183390 */     GIR_RootConstrainSelectedInstOperands,
     /* 183391 */     // GIR_Coverage, 2133,
     /* 183391 */     GIR_EraseRootFromParent_Done,
     /* 183392 */   // Label 3390: @183392
     /* 183392 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(183444), // Rule ID 2134 //
     /* 183397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 183408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 183411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183430 */     // MIs[1] Operand 1
     /* 183430 */     // No operand predicates
     /* 183430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183432 */     // (intrinsic_wo_chain:{ *:[v2i32] } 769:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 183435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183442 */     GIR_RootConstrainSelectedInstOperands,
     /* 183443 */     // GIR_Coverage, 2134,
     /* 183443 */     GIR_EraseRootFromParent_Done,
     /* 183444 */   // Label 3391: @183444
     /* 183444 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(183496), // Rule ID 2135 //
     /* 183449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183482 */     // MIs[1] Operand 1
     /* 183482 */     // No operand predicates
     /* 183482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183484 */     // (intrinsic_wo_chain:{ *:[v4i32] } 769:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 183487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183494 */     GIR_RootConstrainSelectedInstOperands,
     /* 183495 */     // GIR_Coverage, 2135,
     /* 183495 */     GIR_EraseRootFromParent_Done,
     /* 183496 */   // Label 3392: @183496
     /* 183496 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(183548), // Rule ID 2136 //
     /* 183501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183534 */     // MIs[1] Operand 1
     /* 183534 */     // No operand predicates
     /* 183534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183536 */     // (intrinsic_wo_chain:{ *:[v2i64] } 769:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 183539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183546 */     GIR_RootConstrainSelectedInstOperands,
     /* 183547 */     // GIR_Coverage, 2136,
     /* 183547 */     GIR_EraseRootFromParent_Done,
     /* 183548 */   // Label 3393: @183548
     /* 183548 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(183600), // Rule ID 2137 //
     /* 183553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 183564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 183567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183586 */     // MIs[1] Operand 1
     /* 183586 */     // No operand predicates
     /* 183586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183588 */     // (intrinsic_wo_chain:{ *:[v4i16] } 770:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 183591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183598 */     GIR_RootConstrainSelectedInstOperands,
     /* 183599 */     // GIR_Coverage, 2137,
     /* 183599 */     GIR_EraseRootFromParent_Done,
     /* 183600 */   // Label 3394: @183600
     /* 183600 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(183652), // Rule ID 2138 //
     /* 183605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183638 */     // MIs[1] Operand 1
     /* 183638 */     // No operand predicates
     /* 183638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183640 */     // (intrinsic_wo_chain:{ *:[v8i16] } 770:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 183643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183650 */     GIR_RootConstrainSelectedInstOperands,
     /* 183651 */     // GIR_Coverage, 2138,
     /* 183651 */     GIR_EraseRootFromParent_Done,
     /* 183652 */   // Label 3395: @183652
     /* 183652 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(183704), // Rule ID 2139 //
     /* 183657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 183668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 183671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183690 */     // MIs[1] Operand 1
     /* 183690 */     // No operand predicates
     /* 183690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183692 */     // (intrinsic_wo_chain:{ *:[v2i32] } 770:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 183695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183702 */     GIR_RootConstrainSelectedInstOperands,
     /* 183703 */     // GIR_Coverage, 2139,
     /* 183703 */     GIR_EraseRootFromParent_Done,
     /* 183704 */   // Label 3396: @183704
     /* 183704 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(183756), // Rule ID 2140 //
     /* 183709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183742 */     // MIs[1] Operand 1
     /* 183742 */     // No operand predicates
     /* 183742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183744 */     // (intrinsic_wo_chain:{ *:[v4i32] } 770:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 183747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183754 */     GIR_RootConstrainSelectedInstOperands,
     /* 183755 */     // GIR_Coverage, 2140,
     /* 183755 */     GIR_EraseRootFromParent_Done,
     /* 183756 */   // Label 3397: @183756
     /* 183756 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(183808), // Rule ID 2141 //
     /* 183761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183794 */     // MIs[1] Operand 1
     /* 183794 */     // No operand predicates
     /* 183794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183796 */     // (intrinsic_wo_chain:{ *:[v2i64] } 770:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 183799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183806 */     GIR_RootConstrainSelectedInstOperands,
     /* 183807 */     // GIR_Coverage, 2141,
     /* 183807 */     GIR_EraseRootFromParent_Done,
     /* 183808 */   // Label 3398: @183808
     /* 183808 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(183860), // Rule ID 2142 //
     /* 183813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 183821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 183824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 183827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183846 */     // MIs[1] Operand 1
     /* 183846 */     // No operand predicates
     /* 183846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183848 */     // (intrinsic_wo_chain:{ *:[v4f16] } 772:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 183851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183858 */     GIR_RootConstrainSelectedInstOperands,
     /* 183859 */     // GIR_Coverage, 2142,
     /* 183859 */     GIR_EraseRootFromParent_Done,
     /* 183860 */   // Label 3399: @183860
     /* 183860 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(183912), // Rule ID 2143 //
     /* 183865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 183873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183898 */     // MIs[1] Operand 1
     /* 183898 */     // No operand predicates
     /* 183898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183900 */     // (intrinsic_wo_chain:{ *:[v8f16] } 772:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 183903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183910 */     GIR_RootConstrainSelectedInstOperands,
     /* 183911 */     // GIR_Coverage, 2143,
     /* 183911 */     GIR_EraseRootFromParent_Done,
     /* 183912 */   // Label 3400: @183912
     /* 183912 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(183964), // Rule ID 2144 //
     /* 183917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 183925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 183928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 183931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183950 */     // MIs[1] Operand 1
     /* 183950 */     // No operand predicates
     /* 183950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183952 */     // (intrinsic_wo_chain:{ *:[v2f32] } 772:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 183955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183962 */     GIR_RootConstrainSelectedInstOperands,
     /* 183963 */     // GIR_Coverage, 2144,
     /* 183963 */     GIR_EraseRootFromParent_Done,
     /* 183964 */   // Label 3401: @183964
     /* 183964 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(184016), // Rule ID 2145 //
     /* 183969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 183977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184002 */     // MIs[1] Operand 1
     /* 184002 */     // No operand predicates
     /* 184002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184004 */     // (intrinsic_wo_chain:{ *:[v4f32] } 772:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 184007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184014 */     GIR_RootConstrainSelectedInstOperands,
     /* 184015 */     // GIR_Coverage, 2145,
     /* 184015 */     GIR_EraseRootFromParent_Done,
     /* 184016 */   // Label 3402: @184016
     /* 184016 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(184068), // Rule ID 2146 //
     /* 184021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 184029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 184032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 184035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184054 */     // MIs[1] Operand 1
     /* 184054 */     // No operand predicates
     /* 184054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184056 */     // (intrinsic_wo_chain:{ *:[v2f64] } 772:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 184059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184066 */     GIR_RootConstrainSelectedInstOperands,
     /* 184067 */     // GIR_Coverage, 2146,
     /* 184067 */     GIR_EraseRootFromParent_Done,
     /* 184068 */   // Label 3403: @184068
     /* 184068 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(184120), // Rule ID 2244 //
     /* 184073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 184076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 184081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 184084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 184087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184106 */     // MIs[1] Operand 1
     /* 184106 */     // No operand predicates
     /* 184106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184108 */     // (intrinsic_wo_chain:{ *:[v4f16] } 773:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 184111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184118 */     GIR_RootConstrainSelectedInstOperands,
     /* 184119 */     // GIR_Coverage, 2244,
     /* 184119 */     GIR_EraseRootFromParent_Done,
     /* 184120 */   // Label 3404: @184120
     /* 184120 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(184172), // Rule ID 2245 //
     /* 184125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 184128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 184133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 184136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184158 */     // MIs[1] Operand 1
     /* 184158 */     // No operand predicates
     /* 184158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184160 */     // (intrinsic_wo_chain:{ *:[v8f16] } 773:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 184163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184170 */     GIR_RootConstrainSelectedInstOperands,
     /* 184171 */     // GIR_Coverage, 2245,
     /* 184171 */     GIR_EraseRootFromParent_Done,
     /* 184172 */   // Label 3405: @184172
     /* 184172 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(184224), // Rule ID 2246 //
     /* 184177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 184185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 184188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 184191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184210 */     // MIs[1] Operand 1
     /* 184210 */     // No operand predicates
     /* 184210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184212 */     // (intrinsic_wo_chain:{ *:[v2f32] } 773:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 184215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184222 */     GIR_RootConstrainSelectedInstOperands,
     /* 184223 */     // GIR_Coverage, 2246,
     /* 184223 */     GIR_EraseRootFromParent_Done,
     /* 184224 */   // Label 3406: @184224
     /* 184224 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(184276), // Rule ID 2247 //
     /* 184229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 184237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 184240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 184243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184262 */     // MIs[1] Operand 1
     /* 184262 */     // No operand predicates
     /* 184262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184264 */     // (intrinsic_wo_chain:{ *:[v4f32] } 773:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 184267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184274 */     GIR_RootConstrainSelectedInstOperands,
     /* 184275 */     // GIR_Coverage, 2247,
     /* 184275 */     GIR_EraseRootFromParent_Done,
     /* 184276 */   // Label 3407: @184276
     /* 184276 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(184328), // Rule ID 2248 //
     /* 184281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 184289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 184292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 184295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184314 */     // MIs[1] Operand 1
     /* 184314 */     // No operand predicates
     /* 184314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184316 */     // (intrinsic_wo_chain:{ *:[v2f64] } 773:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 184319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184326 */     GIR_RootConstrainSelectedInstOperands,
     /* 184327 */     // GIR_Coverage, 2248,
     /* 184327 */     GIR_EraseRootFromParent_Done,
     /* 184328 */   // Label 3408: @184328
     /* 184328 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(184373), // Rule ID 63 //
     /* 184333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 184336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 184341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 184362 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 184362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 184365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184371 */     GIR_RootConstrainSelectedInstOperands,
     /* 184372 */     // GIR_Coverage, 63,
     /* 184372 */     GIR_EraseRootFromParent_Done,
     /* 184373 */   // Label 3409: @184373
     /* 184373 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(184418), // Rule ID 129 //
     /* 184378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 184386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184407 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 184410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184416 */     GIR_RootConstrainSelectedInstOperands,
     /* 184417 */     // GIR_Coverage, 129,
     /* 184417 */     GIR_EraseRootFromParent_Done,
     /* 184418 */   // Label 3410: @184418
     /* 184418 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(184463), // Rule ID 130 //
     /* 184423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 184431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184452 */     // (intrinsic_wo_chain:{ *:[i32] } 515:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 184455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184461 */     GIR_RootConstrainSelectedInstOperands,
     /* 184462 */     // GIR_Coverage, 130,
     /* 184462 */     GIR_EraseRootFromParent_Done,
     /* 184463 */   // Label 3411: @184463
     /* 184463 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(184508), // Rule ID 131 //
     /* 184468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 184476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184497 */     // (intrinsic_wo_chain:{ *:[i32] } 516:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 184500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184506 */     GIR_RootConstrainSelectedInstOperands,
     /* 184507 */     // GIR_Coverage, 131,
     /* 184507 */     GIR_EraseRootFromParent_Done,
     /* 184508 */   // Label 3412: @184508
     /* 184508 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(184553), // Rule ID 132 //
     /* 184513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 184521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184542 */     // (intrinsic_wo_chain:{ *:[i32] } 517:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 184542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 184545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184551 */     GIR_RootConstrainSelectedInstOperands,
     /* 184552 */     // GIR_Coverage, 132,
     /* 184552 */     GIR_EraseRootFromParent_Done,
     /* 184553 */   // Label 3413: @184553
     /* 184553 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(184598), // Rule ID 133 //
     /* 184558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 184566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184587 */     // (intrinsic_wo_chain:{ *:[i32] } 511:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 184590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184596 */     GIR_RootConstrainSelectedInstOperands,
     /* 184597 */     // GIR_Coverage, 133,
     /* 184597 */     GIR_EraseRootFromParent_Done,
     /* 184598 */   // Label 3414: @184598
     /* 184598 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(184643), // Rule ID 134 //
     /* 184603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 184611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184632 */     // (intrinsic_wo_chain:{ *:[i32] } 512:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 184635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184641 */     GIR_RootConstrainSelectedInstOperands,
     /* 184642 */     // GIR_Coverage, 134,
     /* 184642 */     GIR_EraseRootFromParent_Done,
     /* 184643 */   // Label 3415: @184643
     /* 184643 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(184688), // Rule ID 135 //
     /* 184648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 184656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184677 */     // (intrinsic_wo_chain:{ *:[i32] } 513:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 184680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184686 */     GIR_RootConstrainSelectedInstOperands,
     /* 184687 */     // GIR_Coverage, 135,
     /* 184687 */     GIR_EraseRootFromParent_Done,
     /* 184688 */   // Label 3416: @184688
     /* 184688 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(184733), // Rule ID 136 //
     /* 184693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 184701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184722 */     // (intrinsic_wo_chain:{ *:[i32] } 514:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 184722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 184725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184731 */     GIR_RootConstrainSelectedInstOperands,
     /* 184732 */     // GIR_Coverage, 136,
     /* 184732 */     GIR_EraseRootFromParent_Done,
     /* 184733 */   // Label 3417: @184733
     /* 184733 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(184778), // Rule ID 1042 //
     /* 184738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 184749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 184752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 184755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184767 */     // (intrinsic_wo_chain:{ *:[v8i8] } 722:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 184767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 184770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184776 */     GIR_RootConstrainSelectedInstOperands,
     /* 184777 */     // GIR_Coverage, 1042,
     /* 184777 */     GIR_EraseRootFromParent_Done,
     /* 184778 */   // Label 3418: @184778
     /* 184778 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(184823), // Rule ID 1043 //
     /* 184783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 184794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 184800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184812 */     // (intrinsic_wo_chain:{ *:[v16i8] } 722:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 184812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 184815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184821 */     GIR_RootConstrainSelectedInstOperands,
     /* 184822 */     // GIR_Coverage, 1043,
     /* 184822 */     GIR_EraseRootFromParent_Done,
     /* 184823 */   // Label 3419: @184823
     /* 184823 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(184868), // Rule ID 1044 //
     /* 184828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 184839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 184842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 184845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184857 */     // (intrinsic_wo_chain:{ *:[v4i16] } 722:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 184857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 184860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184866 */     GIR_RootConstrainSelectedInstOperands,
     /* 184867 */     // GIR_Coverage, 1044,
     /* 184867 */     GIR_EraseRootFromParent_Done,
     /* 184868 */   // Label 3420: @184868
     /* 184868 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(184913), // Rule ID 1045 //
     /* 184873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 184884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 184890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184902 */     // (intrinsic_wo_chain:{ *:[v8i16] } 722:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 184902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 184905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184911 */     GIR_RootConstrainSelectedInstOperands,
     /* 184912 */     // GIR_Coverage, 1045,
     /* 184912 */     GIR_EraseRootFromParent_Done,
     /* 184913 */   // Label 3421: @184913
     /* 184913 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(184958), // Rule ID 1046 //
     /* 184918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 184929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 184932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 184935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184947 */     // (intrinsic_wo_chain:{ *:[v2i32] } 722:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 184947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 184950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184956 */     GIR_RootConstrainSelectedInstOperands,
     /* 184957 */     // GIR_Coverage, 1046,
     /* 184957 */     GIR_EraseRootFromParent_Done,
     /* 184958 */   // Label 3422: @184958
     /* 184958 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(185003), // Rule ID 1047 //
     /* 184963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 184974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 184977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 184980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184992 */     // (intrinsic_wo_chain:{ *:[v4i32] } 722:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 184992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 184995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185001 */     GIR_RootConstrainSelectedInstOperands,
     /* 185002 */     // GIR_Coverage, 1047,
     /* 185002 */     GIR_EraseRootFromParent_Done,
     /* 185003 */   // Label 3423: @185003
     /* 185003 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(185048), // Rule ID 1048 //
     /* 185008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 185016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 185025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185037 */     // (intrinsic_wo_chain:{ *:[v2i64] } 722:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 185037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 185040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185046 */     GIR_RootConstrainSelectedInstOperands,
     /* 185047 */     // GIR_Coverage, 1048,
     /* 185047 */     GIR_EraseRootFromParent_Done,
     /* 185048 */   // Label 3424: @185048
     /* 185048 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(185093), // Rule ID 1090 //
     /* 185053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 185064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 185067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 185070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185082 */     // (intrinsic_wo_chain:{ *:[v8i8] } 761:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 185082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 185085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185091 */     GIR_RootConstrainSelectedInstOperands,
     /* 185092 */     // GIR_Coverage, 1090,
     /* 185092 */     GIR_EraseRootFromParent_Done,
     /* 185093 */   // Label 3425: @185093
     /* 185093 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(185138), // Rule ID 1091 //
     /* 185098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 185109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 185112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 185115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185127 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 185127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 185130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185136 */     GIR_RootConstrainSelectedInstOperands,
     /* 185137 */     // GIR_Coverage, 1091,
     /* 185137 */     GIR_EraseRootFromParent_Done,
     /* 185138 */   // Label 3426: @185138
     /* 185138 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(185183), // Rule ID 1092 //
     /* 185143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 185160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185172 */     // (intrinsic_wo_chain:{ *:[v4i16] } 761:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 185172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 185175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185181 */     GIR_RootConstrainSelectedInstOperands,
     /* 185182 */     // GIR_Coverage, 1092,
     /* 185182 */     GIR_EraseRootFromParent_Done,
     /* 185183 */   // Label 3427: @185183
     /* 185183 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(185228), // Rule ID 1093 //
     /* 185188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 185205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185217 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 185217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 185220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185226 */     GIR_RootConstrainSelectedInstOperands,
     /* 185227 */     // GIR_Coverage, 1093,
     /* 185227 */     GIR_EraseRootFromParent_Done,
     /* 185228 */   // Label 3428: @185228
     /* 185228 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(185273), // Rule ID 1094 //
     /* 185233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 185250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185262 */     // (intrinsic_wo_chain:{ *:[v2i32] } 761:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 185262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 185265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185271 */     GIR_RootConstrainSelectedInstOperands,
     /* 185272 */     // GIR_Coverage, 1094,
     /* 185272 */     GIR_EraseRootFromParent_Done,
     /* 185273 */   // Label 3429: @185273
     /* 185273 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(185318), // Rule ID 1095 //
     /* 185278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 185295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185307 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 185307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 185310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185316 */     GIR_RootConstrainSelectedInstOperands,
     /* 185317 */     // GIR_Coverage, 1095,
     /* 185317 */     GIR_EraseRootFromParent_Done,
     /* 185318 */   // Label 3430: @185318
     /* 185318 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(185363), // Rule ID 1096 //
     /* 185323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 185340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185352 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 185352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 185355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185361 */     GIR_RootConstrainSelectedInstOperands,
     /* 185362 */     // GIR_Coverage, 1096,
     /* 185362 */     GIR_EraseRootFromParent_Done,
     /* 185363 */   // Label 3431: @185363
     /* 185363 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(185408), // Rule ID 1108 //
     /* 185368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 185379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 185382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 185385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185397 */     // (intrinsic_wo_chain:{ *:[v8i8] } 577:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 185397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 185400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185406 */     GIR_RootConstrainSelectedInstOperands,
     /* 185407 */     // GIR_Coverage, 1108,
     /* 185407 */     GIR_EraseRootFromParent_Done,
     /* 185408 */   // Label 3432: @185408
     /* 185408 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(185453), // Rule ID 1110 //
     /* 185413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 185424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 185427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 185430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185442 */     // (intrinsic_wo_chain:{ *:[v16i8] } 577:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 185442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 185445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185451 */     GIR_RootConstrainSelectedInstOperands,
     /* 185452 */     // GIR_Coverage, 1110,
     /* 185452 */     GIR_EraseRootFromParent_Done,
     /* 185453 */   // Label 3433: @185453
     /* 185453 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(185498), // Rule ID 1112 //
     /* 185458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 185475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185487 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 185487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 185490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185496 */     GIR_RootConstrainSelectedInstOperands,
     /* 185497 */     // GIR_Coverage, 1112,
     /* 185497 */     GIR_EraseRootFromParent_Done,
     /* 185498 */   // Label 3434: @185498
     /* 185498 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(185543), // Rule ID 1114 //
     /* 185503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 185520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185532 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 185532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 185535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185541 */     GIR_RootConstrainSelectedInstOperands,
     /* 185542 */     // GIR_Coverage, 1114,
     /* 185542 */     GIR_EraseRootFromParent_Done,
     /* 185543 */   // Label 3435: @185543
     /* 185543 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(185588), // Rule ID 1116 //
     /* 185548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 185565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185577 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 185577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 185580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185586 */     GIR_RootConstrainSelectedInstOperands,
     /* 185587 */     // GIR_Coverage, 1116,
     /* 185587 */     GIR_EraseRootFromParent_Done,
     /* 185588 */   // Label 3436: @185588
     /* 185588 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(185633), // Rule ID 1118 //
     /* 185593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 185610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185622 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 185622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 185625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185631 */     GIR_RootConstrainSelectedInstOperands,
     /* 185632 */     // GIR_Coverage, 1118,
     /* 185632 */     GIR_EraseRootFromParent_Done,
     /* 185633 */   // Label 3437: @185633
     /* 185633 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(185678), // Rule ID 1120 //
     /* 185638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 185655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185667 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 185667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 185670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185676 */     GIR_RootConstrainSelectedInstOperands,
     /* 185677 */     // GIR_Coverage, 1120,
     /* 185677 */     GIR_EraseRootFromParent_Done,
     /* 185678 */   // Label 3438: @185678
     /* 185678 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(185723), // Rule ID 1163 //
     /* 185683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 185691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 185700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185712 */     // (intrinsic_wo_chain:{ *:[v4f16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 185712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 185715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185721 */     GIR_RootConstrainSelectedInstOperands,
     /* 185722 */     // GIR_Coverage, 1163,
     /* 185722 */     GIR_EraseRootFromParent_Done,
     /* 185723 */   // Label 3439: @185723
     /* 185723 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(185768), // Rule ID 1164 //
     /* 185728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 185736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 185745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185757 */     // (intrinsic_wo_chain:{ *:[v8f16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 185757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 185760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185766 */     GIR_RootConstrainSelectedInstOperands,
     /* 185767 */     // GIR_Coverage, 1164,
     /* 185767 */     GIR_EraseRootFromParent_Done,
     /* 185768 */   // Label 3440: @185768
     /* 185768 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(185813), // Rule ID 1165 //
     /* 185773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 185781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 185790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185802 */     // (intrinsic_wo_chain:{ *:[v2f32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 185802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 185805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185811 */     GIR_RootConstrainSelectedInstOperands,
     /* 185812 */     // GIR_Coverage, 1165,
     /* 185812 */     GIR_EraseRootFromParent_Done,
     /* 185813 */   // Label 3441: @185813
     /* 185813 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(185858), // Rule ID 1166 //
     /* 185818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 185826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 185835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185847 */     // (intrinsic_wo_chain:{ *:[v4f32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 185847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 185850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185856 */     GIR_RootConstrainSelectedInstOperands,
     /* 185857 */     // GIR_Coverage, 1166,
     /* 185857 */     GIR_EraseRootFromParent_Done,
     /* 185858 */   // Label 3442: @185858
     /* 185858 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(185903), // Rule ID 1167 //
     /* 185863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 185871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 185880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185892 */     // (intrinsic_wo_chain:{ *:[v2f64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 185892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 185895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185901 */     GIR_RootConstrainSelectedInstOperands,
     /* 185902 */     // GIR_Coverage, 1167,
     /* 185902 */     GIR_EraseRootFromParent_Done,
     /* 185903 */   // Label 3443: @185903
     /* 185903 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(185948), // Rule ID 1169 //
     /* 185908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 185916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 185925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185937 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 185937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 185940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185946 */     GIR_RootConstrainSelectedInstOperands,
     /* 185947 */     // GIR_Coverage, 1169,
     /* 185947 */     GIR_EraseRootFromParent_Done,
     /* 185948 */   // Label 3444: @185948
     /* 185948 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(185993), // Rule ID 1171 //
     /* 185953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 185961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 185970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185982 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 185982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 185985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185991 */     GIR_RootConstrainSelectedInstOperands,
     /* 185992 */     // GIR_Coverage, 1171,
     /* 185992 */     GIR_EraseRootFromParent_Done,
     /* 185993 */   // Label 3445: @185993
     /* 185993 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(186038), // Rule ID 1173 //
     /* 185998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 186006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186027 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 186027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 186030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186036 */     GIR_RootConstrainSelectedInstOperands,
     /* 186037 */     // GIR_Coverage, 1173,
     /* 186037 */     GIR_EraseRootFromParent_Done,
     /* 186038 */   // Label 3446: @186038
     /* 186038 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(186083), // Rule ID 1175 //
     /* 186043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 186051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186072 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 186072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 186075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186081 */     GIR_RootConstrainSelectedInstOperands,
     /* 186082 */     // GIR_Coverage, 1175,
     /* 186082 */     GIR_EraseRootFromParent_Done,
     /* 186083 */   // Label 3447: @186083
     /* 186083 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(186128), // Rule ID 1177 //
     /* 186088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 186096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186117 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 186117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 186120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186126 */     GIR_RootConstrainSelectedInstOperands,
     /* 186127 */     // GIR_Coverage, 1177,
     /* 186127 */     GIR_EraseRootFromParent_Done,
     /* 186128 */   // Label 3448: @186128
     /* 186128 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(186173), // Rule ID 1179 //
     /* 186133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 186141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186162 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 186162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 186165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186171 */     GIR_RootConstrainSelectedInstOperands,
     /* 186172 */     // GIR_Coverage, 1179,
     /* 186172 */     GIR_EraseRootFromParent_Done,
     /* 186173 */   // Label 3449: @186173
     /* 186173 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(186218), // Rule ID 1181 //
     /* 186178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 186186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186207 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 186207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 186210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186216 */     GIR_RootConstrainSelectedInstOperands,
     /* 186217 */     // GIR_Coverage, 1181,
     /* 186217 */     GIR_EraseRootFromParent_Done,
     /* 186218 */   // Label 3450: @186218
     /* 186218 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(186263), // Rule ID 1183 //
     /* 186223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 186231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186252 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 186252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 186255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186261 */     GIR_RootConstrainSelectedInstOperands,
     /* 186262 */     // GIR_Coverage, 1183,
     /* 186262 */     GIR_EraseRootFromParent_Done,
     /* 186263 */   // Label 3451: @186263
     /* 186263 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(186308), // Rule ID 1185 //
     /* 186268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 186276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186297 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 186297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 186300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186306 */     GIR_RootConstrainSelectedInstOperands,
     /* 186307 */     // GIR_Coverage, 1185,
     /* 186307 */     GIR_EraseRootFromParent_Done,
     /* 186308 */   // Label 3452: @186308
     /* 186308 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(186353), // Rule ID 1187 //
     /* 186313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 186321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186342 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 186342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 186345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186351 */     GIR_RootConstrainSelectedInstOperands,
     /* 186352 */     // GIR_Coverage, 1187,
     /* 186352 */     GIR_EraseRootFromParent_Done,
     /* 186353 */   // Label 3453: @186353
     /* 186353 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(186398), // Rule ID 1189 //
     /* 186358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 186366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186387 */     // (intrinsic_wo_chain:{ *:[v4f16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 186387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 186390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186396 */     GIR_RootConstrainSelectedInstOperands,
     /* 186397 */     // GIR_Coverage, 1189,
     /* 186397 */     GIR_EraseRootFromParent_Done,
     /* 186398 */   // Label 3454: @186398
     /* 186398 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(186443), // Rule ID 1191 //
     /* 186403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 186411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186432 */     // (intrinsic_wo_chain:{ *:[v8f16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 186432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 186435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186441 */     GIR_RootConstrainSelectedInstOperands,
     /* 186442 */     // GIR_Coverage, 1191,
     /* 186442 */     GIR_EraseRootFromParent_Done,
     /* 186443 */   // Label 3455: @186443
     /* 186443 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(186488), // Rule ID 1193 //
     /* 186448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 186456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186477 */     // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 186477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 186480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186486 */     GIR_RootConstrainSelectedInstOperands,
     /* 186487 */     // GIR_Coverage, 1193,
     /* 186487 */     GIR_EraseRootFromParent_Done,
     /* 186488 */   // Label 3456: @186488
     /* 186488 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(186533), // Rule ID 1195 //
     /* 186493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 186501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186522 */     // (intrinsic_wo_chain:{ *:[v4f32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 186522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 186525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186531 */     GIR_RootConstrainSelectedInstOperands,
     /* 186532 */     // GIR_Coverage, 1195,
     /* 186532 */     GIR_EraseRootFromParent_Done,
     /* 186533 */   // Label 3457: @186533
     /* 186533 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(186578), // Rule ID 1197 //
     /* 186538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 186546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186567 */     // (intrinsic_wo_chain:{ *:[v2f64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 186567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 186570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186576 */     GIR_RootConstrainSelectedInstOperands,
     /* 186577 */     // GIR_Coverage, 1197,
     /* 186577 */     GIR_EraseRootFromParent_Done,
     /* 186578 */   // Label 3458: @186578
     /* 186578 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(186623), // Rule ID 1233 //
     /* 186583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 186591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186612 */     // (intrinsic_wo_chain:{ *:[v4f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 186612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 186615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186621 */     GIR_RootConstrainSelectedInstOperands,
     /* 186622 */     // GIR_Coverage, 1233,
     /* 186622 */     GIR_EraseRootFromParent_Done,
     /* 186623 */   // Label 3459: @186623
     /* 186623 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(186668), // Rule ID 1234 //
     /* 186628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 186636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186657 */     // (intrinsic_wo_chain:{ *:[v8f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 186657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 186660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186666 */     GIR_RootConstrainSelectedInstOperands,
     /* 186667 */     // GIR_Coverage, 1234,
     /* 186667 */     GIR_EraseRootFromParent_Done,
     /* 186668 */   // Label 3460: @186668
     /* 186668 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(186713), // Rule ID 1235 //
     /* 186673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 186681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186702 */     // (intrinsic_wo_chain:{ *:[v2f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 186702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 186705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186711 */     GIR_RootConstrainSelectedInstOperands,
     /* 186712 */     // GIR_Coverage, 1235,
     /* 186712 */     GIR_EraseRootFromParent_Done,
     /* 186713 */   // Label 3461: @186713
     /* 186713 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(186758), // Rule ID 1236 //
     /* 186718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 186726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186747 */     // (intrinsic_wo_chain:{ *:[v4f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 186747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 186750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186756 */     GIR_RootConstrainSelectedInstOperands,
     /* 186757 */     // GIR_Coverage, 1236,
     /* 186757 */     GIR_EraseRootFromParent_Done,
     /* 186758 */   // Label 3462: @186758
     /* 186758 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(186803), // Rule ID 1237 //
     /* 186763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 186771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186792 */     // (intrinsic_wo_chain:{ *:[v2f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 186792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 186795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186801 */     GIR_RootConstrainSelectedInstOperands,
     /* 186802 */     // GIR_Coverage, 1237,
     /* 186802 */     GIR_EraseRootFromParent_Done,
     /* 186803 */   // Label 3463: @186803
     /* 186803 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(186848), // Rule ID 1248 //
     /* 186808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 186816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186837 */     // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 186837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 186840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186846 */     GIR_RootConstrainSelectedInstOperands,
     /* 186847 */     // GIR_Coverage, 1248,
     /* 186847 */     GIR_EraseRootFromParent_Done,
     /* 186848 */   // Label 3464: @186848
     /* 186848 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(186893), // Rule ID 1249 //
     /* 186853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 186861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186882 */     // (intrinsic_wo_chain:{ *:[v8f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 186882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 186885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186891 */     GIR_RootConstrainSelectedInstOperands,
     /* 186892 */     // GIR_Coverage, 1249,
     /* 186892 */     GIR_EraseRootFromParent_Done,
     /* 186893 */   // Label 3465: @186893
     /* 186893 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(186938), // Rule ID 1250 //
     /* 186898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 186906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186927 */     // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 186927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 186930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186936 */     GIR_RootConstrainSelectedInstOperands,
     /* 186937 */     // GIR_Coverage, 1250,
     /* 186937 */     GIR_EraseRootFromParent_Done,
     /* 186938 */   // Label 3466: @186938
     /* 186938 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(186983), // Rule ID 1251 //
     /* 186943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 186951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186972 */     // (intrinsic_wo_chain:{ *:[v4f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 186972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 186975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186981 */     GIR_RootConstrainSelectedInstOperands,
     /* 186982 */     // GIR_Coverage, 1251,
     /* 186982 */     GIR_EraseRootFromParent_Done,
     /* 186983 */   // Label 3467: @186983
     /* 186983 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(187028), // Rule ID 1252 //
     /* 186988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 186996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187017 */     // (intrinsic_wo_chain:{ *:[v2f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 187020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187026 */     GIR_RootConstrainSelectedInstOperands,
     /* 187027 */     // GIR_Coverage, 1252,
     /* 187027 */     GIR_EraseRootFromParent_Done,
     /* 187028 */   // Label 3468: @187028
     /* 187028 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(187073), // Rule ID 1263 //
     /* 187033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 187041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187062 */     // (intrinsic_wo_chain:{ *:[v4f16] } 609:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 187065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187071 */     GIR_RootConstrainSelectedInstOperands,
     /* 187072 */     // GIR_Coverage, 1263,
     /* 187072 */     GIR_EraseRootFromParent_Done,
     /* 187073 */   // Label 3469: @187073
     /* 187073 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(187118), // Rule ID 1264 //
     /* 187078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 187086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187107 */     // (intrinsic_wo_chain:{ *:[v8f16] } 609:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 187110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187116 */     GIR_RootConstrainSelectedInstOperands,
     /* 187117 */     // GIR_Coverage, 1264,
     /* 187117 */     GIR_EraseRootFromParent_Done,
     /* 187118 */   // Label 3470: @187118
     /* 187118 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(187163), // Rule ID 1265 //
     /* 187123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 187131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187152 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 187155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187161 */     GIR_RootConstrainSelectedInstOperands,
     /* 187162 */     // GIR_Coverage, 1265,
     /* 187162 */     GIR_EraseRootFromParent_Done,
     /* 187163 */   // Label 3471: @187163
     /* 187163 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(187208), // Rule ID 1266 //
     /* 187168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 187176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187197 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 187200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187206 */     GIR_RootConstrainSelectedInstOperands,
     /* 187207 */     // GIR_Coverage, 1266,
     /* 187207 */     GIR_EraseRootFromParent_Done,
     /* 187208 */   // Label 3472: @187208
     /* 187208 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(187253), // Rule ID 1267 //
     /* 187213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 187221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187242 */     // (intrinsic_wo_chain:{ *:[v2f64] } 609:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 187245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187251 */     GIR_RootConstrainSelectedInstOperands,
     /* 187252 */     // GIR_Coverage, 1267,
     /* 187252 */     GIR_EraseRootFromParent_Done,
     /* 187253 */   // Label 3473: @187253
     /* 187253 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(187298), // Rule ID 1278 //
     /* 187258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 187266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187287 */     // (intrinsic_wo_chain:{ *:[v4f16] } 611:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 187290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187296 */     GIR_RootConstrainSelectedInstOperands,
     /* 187297 */     // GIR_Coverage, 1278,
     /* 187297 */     GIR_EraseRootFromParent_Done,
     /* 187298 */   // Label 3474: @187298
     /* 187298 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(187343), // Rule ID 1279 //
     /* 187303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 187311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187332 */     // (intrinsic_wo_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 187335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187341 */     GIR_RootConstrainSelectedInstOperands,
     /* 187342 */     // GIR_Coverage, 1279,
     /* 187342 */     GIR_EraseRootFromParent_Done,
     /* 187343 */   // Label 3475: @187343
     /* 187343 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(187388), // Rule ID 1280 //
     /* 187348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 187356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187377 */     // (intrinsic_wo_chain:{ *:[v2f32] } 611:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 187380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187386 */     GIR_RootConstrainSelectedInstOperands,
     /* 187387 */     // GIR_Coverage, 1280,
     /* 187387 */     GIR_EraseRootFromParent_Done,
     /* 187388 */   // Label 3476: @187388
     /* 187388 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(187433), // Rule ID 1281 //
     /* 187393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 187401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187422 */     // (intrinsic_wo_chain:{ *:[v4f32] } 611:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 187425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187431 */     GIR_RootConstrainSelectedInstOperands,
     /* 187432 */     // GIR_Coverage, 1281,
     /* 187432 */     GIR_EraseRootFromParent_Done,
     /* 187433 */   // Label 3477: @187433
     /* 187433 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(187478), // Rule ID 1282 //
     /* 187438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 187446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187467 */     // (intrinsic_wo_chain:{ *:[v2f64] } 611:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 187470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187476 */     GIR_RootConstrainSelectedInstOperands,
     /* 187477 */     // GIR_Coverage, 1282,
     /* 187477 */     GIR_EraseRootFromParent_Done,
     /* 187478 */   // Label 3478: @187478
     /* 187478 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(187523), // Rule ID 1313 //
     /* 187483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 187491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187512 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 187515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187521 */     GIR_RootConstrainSelectedInstOperands,
     /* 187522 */     // GIR_Coverage, 1313,
     /* 187522 */     GIR_EraseRootFromParent_Done,
     /* 187523 */   // Label 3479: @187523
     /* 187523 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(187568), // Rule ID 1314 //
     /* 187528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 187536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187557 */     // (intrinsic_wo_chain:{ *:[v8f16] } 617:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 187560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187566 */     GIR_RootConstrainSelectedInstOperands,
     /* 187567 */     // GIR_Coverage, 1314,
     /* 187567 */     GIR_EraseRootFromParent_Done,
     /* 187568 */   // Label 3480: @187568
     /* 187568 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(187613), // Rule ID 1315 //
     /* 187573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 187581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187602 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 187605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187611 */     GIR_RootConstrainSelectedInstOperands,
     /* 187612 */     // GIR_Coverage, 1315,
     /* 187612 */     GIR_EraseRootFromParent_Done,
     /* 187613 */   // Label 3481: @187613
     /* 187613 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(187658), // Rule ID 1316 //
     /* 187618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 187626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187647 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 187650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187656 */     GIR_RootConstrainSelectedInstOperands,
     /* 187657 */     // GIR_Coverage, 1316,
     /* 187657 */     GIR_EraseRootFromParent_Done,
     /* 187658 */   // Label 3482: @187658
     /* 187658 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(187703), // Rule ID 1317 //
     /* 187663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 187671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187692 */     // (intrinsic_wo_chain:{ *:[v2f64] } 617:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 187695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187701 */     GIR_RootConstrainSelectedInstOperands,
     /* 187702 */     // GIR_Coverage, 1317,
     /* 187702 */     GIR_EraseRootFromParent_Done,
     /* 187703 */   // Label 3483: @187703
     /* 187703 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(187748), // Rule ID 1328 //
     /* 187708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 187716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187737 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 187740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187746 */     GIR_RootConstrainSelectedInstOperands,
     /* 187747 */     // GIR_Coverage, 1328,
     /* 187747 */     GIR_EraseRootFromParent_Done,
     /* 187748 */   // Label 3484: @187748
     /* 187748 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(187793), // Rule ID 1329 //
     /* 187753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 187761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187782 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 187785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187791 */     GIR_RootConstrainSelectedInstOperands,
     /* 187792 */     // GIR_Coverage, 1329,
     /* 187792 */     GIR_EraseRootFromParent_Done,
     /* 187793 */   // Label 3485: @187793
     /* 187793 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(187838), // Rule ID 1330 //
     /* 187798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 187806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187827 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 187830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187836 */     GIR_RootConstrainSelectedInstOperands,
     /* 187837 */     // GIR_Coverage, 1330,
     /* 187837 */     GIR_EraseRootFromParent_Done,
     /* 187838 */   // Label 3486: @187838
     /* 187838 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(187883), // Rule ID 1331 //
     /* 187843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 187851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187872 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 187875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187881 */     GIR_RootConstrainSelectedInstOperands,
     /* 187882 */     // GIR_Coverage, 1331,
     /* 187882 */     GIR_EraseRootFromParent_Done,
     /* 187883 */   // Label 3487: @187883
     /* 187883 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(187928), // Rule ID 1332 //
     /* 187888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 187896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187917 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 187920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187926 */     GIR_RootConstrainSelectedInstOperands,
     /* 187927 */     // GIR_Coverage, 1332,
     /* 187927 */     GIR_EraseRootFromParent_Done,
     /* 187928 */   // Label 3488: @187928
     /* 187928 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(187973), // Rule ID 1333 //
     /* 187933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 187941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187962 */     // (intrinsic_wo_chain:{ *:[v4f16] } 647:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 187965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187971 */     GIR_RootConstrainSelectedInstOperands,
     /* 187972 */     // GIR_Coverage, 1333,
     /* 187972 */     GIR_EraseRootFromParent_Done,
     /* 187973 */   // Label 3489: @187973
     /* 187973 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(188018), // Rule ID 1334 //
     /* 187978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 187986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188007 */     // (intrinsic_wo_chain:{ *:[v8f16] } 647:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 188010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188016 */     GIR_RootConstrainSelectedInstOperands,
     /* 188017 */     // GIR_Coverage, 1334,
     /* 188017 */     GIR_EraseRootFromParent_Done,
     /* 188018 */   // Label 3490: @188018
     /* 188018 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(188063), // Rule ID 1335 //
     /* 188023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 188031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188052 */     // (intrinsic_wo_chain:{ *:[v2f32] } 647:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 188055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188061 */     GIR_RootConstrainSelectedInstOperands,
     /* 188062 */     // GIR_Coverage, 1335,
     /* 188062 */     GIR_EraseRootFromParent_Done,
     /* 188063 */   // Label 3491: @188063
     /* 188063 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(188108), // Rule ID 1336 //
     /* 188068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 188076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188097 */     // (intrinsic_wo_chain:{ *:[v4f32] } 647:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 188100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188106 */     GIR_RootConstrainSelectedInstOperands,
     /* 188107 */     // GIR_Coverage, 1336,
     /* 188107 */     GIR_EraseRootFromParent_Done,
     /* 188108 */   // Label 3492: @188108
     /* 188108 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(188153), // Rule ID 1337 //
     /* 188113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 188121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188142 */     // (intrinsic_wo_chain:{ *:[v2f64] } 647:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 188145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188151 */     GIR_RootConstrainSelectedInstOperands,
     /* 188152 */     // GIR_Coverage, 1337,
     /* 188152 */     GIR_EraseRootFromParent_Done,
     /* 188153 */   // Label 3493: @188153
     /* 188153 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(188198), // Rule ID 1354 //
     /* 188158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 188166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 188169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 188172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 188175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188187 */     // (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 188187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 188190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188196 */     GIR_RootConstrainSelectedInstOperands,
     /* 188197 */     // GIR_Coverage, 1354,
     /* 188197 */     GIR_EraseRootFromParent_Done,
     /* 188198 */   // Label 3494: @188198
     /* 188198 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(188243), // Rule ID 1355 //
     /* 188203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 188211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 188214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 188220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188232 */     // (intrinsic_wo_chain:{ *:[v16i8] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 188232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 188235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188241 */     GIR_RootConstrainSelectedInstOperands,
     /* 188242 */     // GIR_Coverage, 1355,
     /* 188242 */     GIR_EraseRootFromParent_Done,
     /* 188243 */   // Label 3495: @188243
     /* 188243 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(188288), // Rule ID 1369 //
     /* 188248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 188259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 188262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 188265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188277 */     // (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 188277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 188280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188286 */     GIR_RootConstrainSelectedInstOperands,
     /* 188287 */     // GIR_Coverage, 1369,
     /* 188287 */     GIR_EraseRootFromParent_Done,
     /* 188288 */   // Label 3496: @188288
     /* 188288 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(188333), // Rule ID 1371 //
     /* 188293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 188304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 188310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188322 */     // (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 188322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 188325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188331 */     GIR_RootConstrainSelectedInstOperands,
     /* 188332 */     // GIR_Coverage, 1371,
     /* 188332 */     GIR_EraseRootFromParent_Done,
     /* 188333 */   // Label 3497: @188333
     /* 188333 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(188378), // Rule ID 1373 //
     /* 188338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188367 */     // (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 188367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 188370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188376 */     GIR_RootConstrainSelectedInstOperands,
     /* 188377 */     // GIR_Coverage, 1373,
     /* 188377 */     GIR_EraseRootFromParent_Done,
     /* 188378 */   // Label 3498: @188378
     /* 188378 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(188423), // Rule ID 1375 //
     /* 188383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188412 */     // (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 188412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 188415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188421 */     GIR_RootConstrainSelectedInstOperands,
     /* 188422 */     // GIR_Coverage, 1375,
     /* 188422 */     GIR_EraseRootFromParent_Done,
     /* 188423 */   // Label 3499: @188423
     /* 188423 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(188468), // Rule ID 1377 //
     /* 188428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188457 */     // (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 188457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 188460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188466 */     GIR_RootConstrainSelectedInstOperands,
     /* 188467 */     // GIR_Coverage, 1377,
     /* 188467 */     GIR_EraseRootFromParent_Done,
     /* 188468 */   // Label 3500: @188468
     /* 188468 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(188513), // Rule ID 1379 //
     /* 188473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188502 */     // (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 188502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 188505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188511 */     GIR_RootConstrainSelectedInstOperands,
     /* 188512 */     // GIR_Coverage, 1379,
     /* 188512 */     GIR_EraseRootFromParent_Done,
     /* 188513 */   // Label 3501: @188513
     /* 188513 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(188558), // Rule ID 1386 //
     /* 188518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 188529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 188532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 188535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188547 */     // (intrinsic_wo_chain:{ *:[v8i8] } 676:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 188547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 188550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188556 */     GIR_RootConstrainSelectedInstOperands,
     /* 188557 */     // GIR_Coverage, 1386,
     /* 188557 */     GIR_EraseRootFromParent_Done,
     /* 188558 */   // Label 3502: @188558
     /* 188558 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(188603), // Rule ID 1387 //
     /* 188563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 188574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 188580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188592 */     // (intrinsic_wo_chain:{ *:[v16i8] } 676:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 188592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 188595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188601 */     GIR_RootConstrainSelectedInstOperands,
     /* 188602 */     // GIR_Coverage, 1387,
     /* 188602 */     GIR_EraseRootFromParent_Done,
     /* 188603 */   // Label 3503: @188603
     /* 188603 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(188648), // Rule ID 1388 //
     /* 188608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188637 */     // (intrinsic_wo_chain:{ *:[v4i16] } 676:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 188637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 188640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188646 */     GIR_RootConstrainSelectedInstOperands,
     /* 188647 */     // GIR_Coverage, 1388,
     /* 188647 */     GIR_EraseRootFromParent_Done,
     /* 188648 */   // Label 3504: @188648
     /* 188648 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(188693), // Rule ID 1389 //
     /* 188653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188682 */     // (intrinsic_wo_chain:{ *:[v8i16] } 676:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 188682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 188685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188691 */     GIR_RootConstrainSelectedInstOperands,
     /* 188692 */     // GIR_Coverage, 1389,
     /* 188692 */     GIR_EraseRootFromParent_Done,
     /* 188693 */   // Label 3505: @188693
     /* 188693 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(188738), // Rule ID 1390 //
     /* 188698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188727 */     // (intrinsic_wo_chain:{ *:[v2i32] } 676:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 188727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 188730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188736 */     GIR_RootConstrainSelectedInstOperands,
     /* 188737 */     // GIR_Coverage, 1390,
     /* 188737 */     GIR_EraseRootFromParent_Done,
     /* 188738 */   // Label 3506: @188738
     /* 188738 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(188783), // Rule ID 1391 //
     /* 188743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188772 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 188772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 188775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188781 */     GIR_RootConstrainSelectedInstOperands,
     /* 188782 */     // GIR_Coverage, 1391,
     /* 188782 */     GIR_EraseRootFromParent_Done,
     /* 188783 */   // Label 3507: @188783
     /* 188783 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(188828), // Rule ID 1392 //
     /* 188788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 188796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 188799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 188802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 188805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188817 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 188817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 188820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188826 */     GIR_RootConstrainSelectedInstOperands,
     /* 188827 */     // GIR_Coverage, 1392,
     /* 188827 */     GIR_EraseRootFromParent_Done,
     /* 188828 */   // Label 3508: @188828
     /* 188828 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(188873), // Rule ID 1393 //
     /* 188833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 188841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 188844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 188850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188862 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 188862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 188865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188871 */     GIR_RootConstrainSelectedInstOperands,
     /* 188872 */     // GIR_Coverage, 1393,
     /* 188872 */     GIR_EraseRootFromParent_Done,
     /* 188873 */   // Label 3509: @188873
     /* 188873 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(188918), // Rule ID 1394 //
     /* 188878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 188886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188907 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 188907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 188910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188916 */     GIR_RootConstrainSelectedInstOperands,
     /* 188917 */     // GIR_Coverage, 1394,
     /* 188917 */     GIR_EraseRootFromParent_Done,
     /* 188918 */   // Label 3510: @188918
     /* 188918 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(188963), // Rule ID 1395 //
     /* 188923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 188931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188952 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 188952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 188955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188961 */     GIR_RootConstrainSelectedInstOperands,
     /* 188962 */     // GIR_Coverage, 1395,
     /* 188962 */     GIR_EraseRootFromParent_Done,
     /* 188963 */   // Label 3511: @188963
     /* 188963 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(189008), // Rule ID 1396 //
     /* 188968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 188976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188997 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 188997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 189000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189006 */     GIR_RootConstrainSelectedInstOperands,
     /* 189007 */     // GIR_Coverage, 1396,
     /* 189007 */     GIR_EraseRootFromParent_Done,
     /* 189008 */   // Label 3512: @189008
     /* 189008 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(189053), // Rule ID 1397 //
     /* 189013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 189021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189042 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 189045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189051 */     GIR_RootConstrainSelectedInstOperands,
     /* 189052 */     // GIR_Coverage, 1397,
     /* 189052 */     GIR_EraseRootFromParent_Done,
     /* 189053 */   // Label 3513: @189053
     /* 189053 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(189098), // Rule ID 1404 //
     /* 189058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 189069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 189072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 189075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189087 */     // (intrinsic_wo_chain:{ *:[v8i8] } 681:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 189087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 189090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189096 */     GIR_RootConstrainSelectedInstOperands,
     /* 189097 */     // GIR_Coverage, 1404,
     /* 189097 */     GIR_EraseRootFromParent_Done,
     /* 189098 */   // Label 3514: @189098
     /* 189098 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(189143), // Rule ID 1405 //
     /* 189103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 189117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 189120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189132 */     // (intrinsic_wo_chain:{ *:[v16i8] } 681:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 189132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 189135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189141 */     GIR_RootConstrainSelectedInstOperands,
     /* 189142 */     // GIR_Coverage, 1405,
     /* 189142 */     GIR_EraseRootFromParent_Done,
     /* 189143 */   // Label 3515: @189143
     /* 189143 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(189188), // Rule ID 1406 //
     /* 189148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189177 */     // (intrinsic_wo_chain:{ *:[v4i16] } 681:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 189180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189186 */     GIR_RootConstrainSelectedInstOperands,
     /* 189187 */     // GIR_Coverage, 1406,
     /* 189187 */     GIR_EraseRootFromParent_Done,
     /* 189188 */   // Label 3516: @189188
     /* 189188 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(189233), // Rule ID 1407 //
     /* 189193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189222 */     // (intrinsic_wo_chain:{ *:[v8i16] } 681:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 189225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189231 */     GIR_RootConstrainSelectedInstOperands,
     /* 189232 */     // GIR_Coverage, 1407,
     /* 189232 */     GIR_EraseRootFromParent_Done,
     /* 189233 */   // Label 3517: @189233
     /* 189233 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(189278), // Rule ID 1408 //
     /* 189238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189267 */     // (intrinsic_wo_chain:{ *:[v2i32] } 681:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 189270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189276 */     GIR_RootConstrainSelectedInstOperands,
     /* 189277 */     // GIR_Coverage, 1408,
     /* 189277 */     GIR_EraseRootFromParent_Done,
     /* 189278 */   // Label 3518: @189278
     /* 189278 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(189323), // Rule ID 1409 //
     /* 189283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189312 */     // (intrinsic_wo_chain:{ *:[v4i32] } 681:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 189315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189321 */     GIR_RootConstrainSelectedInstOperands,
     /* 189322 */     // GIR_Coverage, 1409,
     /* 189322 */     GIR_EraseRootFromParent_Done,
     /* 189323 */   // Label 3519: @189323
     /* 189323 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(189368), // Rule ID 1423 //
     /* 189328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 189336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189357 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 189360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189366 */     GIR_RootConstrainSelectedInstOperands,
     /* 189367 */     // GIR_Coverage, 1423,
     /* 189367 */     GIR_EraseRootFromParent_Done,
     /* 189368 */   // Label 3520: @189368
     /* 189368 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(189413), // Rule ID 1424 //
     /* 189373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 189381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189402 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 189405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189411 */     GIR_RootConstrainSelectedInstOperands,
     /* 189412 */     // GIR_Coverage, 1424,
     /* 189412 */     GIR_EraseRootFromParent_Done,
     /* 189413 */   // Label 3521: @189413
     /* 189413 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(189458), // Rule ID 1425 //
     /* 189418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 189426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189447 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 189450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189456 */     GIR_RootConstrainSelectedInstOperands,
     /* 189457 */     // GIR_Coverage, 1425,
     /* 189457 */     GIR_EraseRootFromParent_Done,
     /* 189458 */   // Label 3522: @189458
     /* 189458 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(189503), // Rule ID 1426 //
     /* 189463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 189471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 189495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189501 */     GIR_RootConstrainSelectedInstOperands,
     /* 189502 */     // GIR_Coverage, 1426,
     /* 189502 */     GIR_EraseRootFromParent_Done,
     /* 189503 */   // Label 3523: @189503
     /* 189503 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(189548), // Rule ID 1427 //
     /* 189508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 189516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189537 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 189540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189546 */     GIR_RootConstrainSelectedInstOperands,
     /* 189547 */     // GIR_Coverage, 1427,
     /* 189547 */     GIR_EraseRootFromParent_Done,
     /* 189548 */   // Label 3524: @189548
     /* 189548 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(189593), // Rule ID 1428 //
     /* 189553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 189561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189582 */     // (intrinsic_wo_chain:{ *:[v8i16] } 695:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 189585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189591 */     GIR_RootConstrainSelectedInstOperands,
     /* 189592 */     // GIR_Coverage, 1428,
     /* 189592 */     GIR_EraseRootFromParent_Done,
     /* 189593 */   // Label 3525: @189593
     /* 189593 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(189638), // Rule ID 1429 //
     /* 189598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 189606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189627 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 189630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189636 */     GIR_RootConstrainSelectedInstOperands,
     /* 189637 */     // GIR_Coverage, 1429,
     /* 189637 */     GIR_EraseRootFromParent_Done,
     /* 189638 */   // Label 3526: @189638
     /* 189638 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(189683), // Rule ID 1430 //
     /* 189643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 189651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189672 */     // (intrinsic_wo_chain:{ *:[v4i32] } 695:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 189675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189681 */     GIR_RootConstrainSelectedInstOperands,
     /* 189682 */     // GIR_Coverage, 1430,
     /* 189682 */     GIR_EraseRootFromParent_Done,
     /* 189683 */   // Label 3527: @189683
     /* 189683 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(189728), // Rule ID 1431 //
     /* 189688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 189699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 189702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 189705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189717 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 189717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 189720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189726 */     GIR_RootConstrainSelectedInstOperands,
     /* 189727 */     // GIR_Coverage, 1431,
     /* 189727 */     GIR_EraseRootFromParent_Done,
     /* 189728 */   // Label 3528: @189728
     /* 189728 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(189773), // Rule ID 1432 //
     /* 189733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 189747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 189750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189762 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 189762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 189765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189771 */     GIR_RootConstrainSelectedInstOperands,
     /* 189772 */     // GIR_Coverage, 1432,
     /* 189772 */     GIR_EraseRootFromParent_Done,
     /* 189773 */   // Label 3529: @189773
     /* 189773 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(189818), // Rule ID 1433 //
     /* 189778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189807 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 189810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189816 */     GIR_RootConstrainSelectedInstOperands,
     /* 189817 */     // GIR_Coverage, 1433,
     /* 189817 */     GIR_EraseRootFromParent_Done,
     /* 189818 */   // Label 3530: @189818
     /* 189818 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(189863), // Rule ID 1434 //
     /* 189823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189852 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 189855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189861 */     GIR_RootConstrainSelectedInstOperands,
     /* 189862 */     // GIR_Coverage, 1434,
     /* 189862 */     GIR_EraseRootFromParent_Done,
     /* 189863 */   // Label 3531: @189863
     /* 189863 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(189908), // Rule ID 1435 //
     /* 189868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189897 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 189900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189906 */     GIR_RootConstrainSelectedInstOperands,
     /* 189907 */     // GIR_Coverage, 1435,
     /* 189907 */     GIR_EraseRootFromParent_Done,
     /* 189908 */   // Label 3532: @189908
     /* 189908 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(189953), // Rule ID 1436 //
     /* 189913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189942 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 189945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189951 */     GIR_RootConstrainSelectedInstOperands,
     /* 189952 */     // GIR_Coverage, 1436,
     /* 189952 */     GIR_EraseRootFromParent_Done,
     /* 189953 */   // Label 3533: @189953
     /* 189953 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(189998), // Rule ID 1437 //
     /* 189958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189987 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 189987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 189990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189996 */     GIR_RootConstrainSelectedInstOperands,
     /* 189997 */     // GIR_Coverage, 1437,
     /* 189997 */     GIR_EraseRootFromParent_Done,
     /* 189998 */   // Label 3534: @189998
     /* 189998 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(190043), // Rule ID 1438 //
     /* 190003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190032 */     // (intrinsic_wo_chain:{ *:[v8i8] } 701:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 190035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190041 */     GIR_RootConstrainSelectedInstOperands,
     /* 190042 */     // GIR_Coverage, 1438,
     /* 190042 */     GIR_EraseRootFromParent_Done,
     /* 190043 */   // Label 3535: @190043
     /* 190043 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(190088), // Rule ID 1439 //
     /* 190048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190077 */     // (intrinsic_wo_chain:{ *:[v16i8] } 701:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 190080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190086 */     GIR_RootConstrainSelectedInstOperands,
     /* 190087 */     // GIR_Coverage, 1439,
     /* 190087 */     GIR_EraseRootFromParent_Done,
     /* 190088 */   // Label 3536: @190088
     /* 190088 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(190133), // Rule ID 1440 //
     /* 190093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190122 */     // (intrinsic_wo_chain:{ *:[v4i16] } 701:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 190125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190131 */     GIR_RootConstrainSelectedInstOperands,
     /* 190132 */     // GIR_Coverage, 1440,
     /* 190132 */     GIR_EraseRootFromParent_Done,
     /* 190133 */   // Label 3537: @190133
     /* 190133 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(190178), // Rule ID 1441 //
     /* 190138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190167 */     // (intrinsic_wo_chain:{ *:[v8i16] } 701:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 190170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190176 */     GIR_RootConstrainSelectedInstOperands,
     /* 190177 */     // GIR_Coverage, 1441,
     /* 190177 */     GIR_EraseRootFromParent_Done,
     /* 190178 */   // Label 3538: @190178
     /* 190178 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(190223), // Rule ID 1442 //
     /* 190183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190212 */     // (intrinsic_wo_chain:{ *:[v2i32] } 701:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 190215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190221 */     GIR_RootConstrainSelectedInstOperands,
     /* 190222 */     // GIR_Coverage, 1442,
     /* 190222 */     GIR_EraseRootFromParent_Done,
     /* 190223 */   // Label 3539: @190223
     /* 190223 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(190268), // Rule ID 1443 //
     /* 190228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190257 */     // (intrinsic_wo_chain:{ *:[v4i32] } 701:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 190260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190266 */     GIR_RootConstrainSelectedInstOperands,
     /* 190267 */     // GIR_Coverage, 1443,
     /* 190267 */     GIR_EraseRootFromParent_Done,
     /* 190268 */   // Label 3540: @190268
     /* 190268 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(190313), // Rule ID 1444 //
     /* 190273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 190287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 190290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190302 */     // (intrinsic_wo_chain:{ *:[v2i64] } 701:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 190302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 190305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190311 */     GIR_RootConstrainSelectedInstOperands,
     /* 190312 */     // GIR_Coverage, 1444,
     /* 190312 */     GIR_EraseRootFromParent_Done,
     /* 190313 */   // Label 3541: @190313
     /* 190313 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(190358), // Rule ID 1458 //
     /* 190318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190347 */     // (intrinsic_wo_chain:{ *:[v8i8] } 709:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 190350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190356 */     GIR_RootConstrainSelectedInstOperands,
     /* 190357 */     // GIR_Coverage, 1458,
     /* 190357 */     GIR_EraseRootFromParent_Done,
     /* 190358 */   // Label 3542: @190358
     /* 190358 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(190403), // Rule ID 1459 //
     /* 190363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190392 */     // (intrinsic_wo_chain:{ *:[v16i8] } 709:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 190395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190401 */     GIR_RootConstrainSelectedInstOperands,
     /* 190402 */     // GIR_Coverage, 1459,
     /* 190402 */     GIR_EraseRootFromParent_Done,
     /* 190403 */   // Label 3543: @190403
     /* 190403 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(190448), // Rule ID 1460 //
     /* 190408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190437 */     // (intrinsic_wo_chain:{ *:[v4i16] } 709:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 190440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190446 */     GIR_RootConstrainSelectedInstOperands,
     /* 190447 */     // GIR_Coverage, 1460,
     /* 190447 */     GIR_EraseRootFromParent_Done,
     /* 190448 */   // Label 3544: @190448
     /* 190448 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(190493), // Rule ID 1461 //
     /* 190453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190482 */     // (intrinsic_wo_chain:{ *:[v8i16] } 709:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 190485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190491 */     GIR_RootConstrainSelectedInstOperands,
     /* 190492 */     // GIR_Coverage, 1461,
     /* 190492 */     GIR_EraseRootFromParent_Done,
     /* 190493 */   // Label 3545: @190493
     /* 190493 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(190538), // Rule ID 1462 //
     /* 190498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190527 */     // (intrinsic_wo_chain:{ *:[v2i32] } 709:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 190530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190536 */     GIR_RootConstrainSelectedInstOperands,
     /* 190537 */     // GIR_Coverage, 1462,
     /* 190537 */     GIR_EraseRootFromParent_Done,
     /* 190538 */   // Label 3546: @190538
     /* 190538 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(190583), // Rule ID 1463 //
     /* 190543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190572 */     // (intrinsic_wo_chain:{ *:[v4i32] } 709:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 190575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190581 */     GIR_RootConstrainSelectedInstOperands,
     /* 190582 */     // GIR_Coverage, 1463,
     /* 190582 */     GIR_EraseRootFromParent_Done,
     /* 190583 */   // Label 3547: @190583
     /* 190583 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(190628), // Rule ID 1464 //
     /* 190588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 190602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 190605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190617 */     // (intrinsic_wo_chain:{ *:[v2i64] } 709:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 190617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 190620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190626 */     GIR_RootConstrainSelectedInstOperands,
     /* 190627 */     // GIR_Coverage, 1464,
     /* 190627 */     GIR_EraseRootFromParent_Done,
     /* 190628 */   // Label 3548: @190628
     /* 190628 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(190673), // Rule ID 1465 //
     /* 190633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190662 */     // (intrinsic_wo_chain:{ *:[v8i8] } 710:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 190665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190671 */     GIR_RootConstrainSelectedInstOperands,
     /* 190672 */     // GIR_Coverage, 1465,
     /* 190672 */     GIR_EraseRootFromParent_Done,
     /* 190673 */   // Label 3549: @190673
     /* 190673 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(190718), // Rule ID 1466 //
     /* 190678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190707 */     // (intrinsic_wo_chain:{ *:[v16i8] } 710:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 190710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190716 */     GIR_RootConstrainSelectedInstOperands,
     /* 190717 */     // GIR_Coverage, 1466,
     /* 190717 */     GIR_EraseRootFromParent_Done,
     /* 190718 */   // Label 3550: @190718
     /* 190718 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(190763), // Rule ID 1467 //
     /* 190723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190752 */     // (intrinsic_wo_chain:{ *:[v4i16] } 710:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 190755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190761 */     GIR_RootConstrainSelectedInstOperands,
     /* 190762 */     // GIR_Coverage, 1467,
     /* 190762 */     GIR_EraseRootFromParent_Done,
     /* 190763 */   // Label 3551: @190763
     /* 190763 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(190808), // Rule ID 1468 //
     /* 190768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190797 */     // (intrinsic_wo_chain:{ *:[v8i16] } 710:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 190800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190806 */     GIR_RootConstrainSelectedInstOperands,
     /* 190807 */     // GIR_Coverage, 1468,
     /* 190807 */     GIR_EraseRootFromParent_Done,
     /* 190808 */   // Label 3552: @190808
     /* 190808 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(190853), // Rule ID 1469 //
     /* 190813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190842 */     // (intrinsic_wo_chain:{ *:[v2i32] } 710:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 190845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190851 */     GIR_RootConstrainSelectedInstOperands,
     /* 190852 */     // GIR_Coverage, 1469,
     /* 190852 */     GIR_EraseRootFromParent_Done,
     /* 190853 */   // Label 3553: @190853
     /* 190853 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(190898), // Rule ID 1470 //
     /* 190858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190887 */     // (intrinsic_wo_chain:{ *:[v4i32] } 710:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 190890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190896 */     GIR_RootConstrainSelectedInstOperands,
     /* 190897 */     // GIR_Coverage, 1470,
     /* 190897 */     GIR_EraseRootFromParent_Done,
     /* 190898 */   // Label 3554: @190898
     /* 190898 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(190943), // Rule ID 1471 //
     /* 190903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 190917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 190920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190932 */     // (intrinsic_wo_chain:{ *:[v2i64] } 710:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 190932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 190935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190941 */     GIR_RootConstrainSelectedInstOperands,
     /* 190942 */     // GIR_Coverage, 1471,
     /* 190942 */     GIR_EraseRootFromParent_Done,
     /* 190943 */   // Label 3555: @190943
     /* 190943 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(190988), // Rule ID 1492 //
     /* 190948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 190956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190977 */     // (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 190980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190986 */     GIR_RootConstrainSelectedInstOperands,
     /* 190987 */     // GIR_Coverage, 1492,
     /* 190987 */     GIR_EraseRootFromParent_Done,
     /* 190988 */   // Label 3556: @190988
     /* 190988 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(191033), // Rule ID 1494 //
     /* 190993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 191001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191022 */     // (intrinsic_wo_chain:{ *:[v16i8] } 731:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 191025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191031 */     GIR_RootConstrainSelectedInstOperands,
     /* 191032 */     // GIR_Coverage, 1494,
     /* 191032 */     GIR_EraseRootFromParent_Done,
     /* 191033 */   // Label 3557: @191033
     /* 191033 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(191078), // Rule ID 1496 //
     /* 191038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 191046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191067 */     // (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 191070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191076 */     GIR_RootConstrainSelectedInstOperands,
     /* 191077 */     // GIR_Coverage, 1496,
     /* 191077 */     GIR_EraseRootFromParent_Done,
     /* 191078 */   // Label 3558: @191078
     /* 191078 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(191123), // Rule ID 1498 //
     /* 191083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 191091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191112 */     // (intrinsic_wo_chain:{ *:[v8i16] } 731:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 191115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191121 */     GIR_RootConstrainSelectedInstOperands,
     /* 191122 */     // GIR_Coverage, 1498,
     /* 191122 */     GIR_EraseRootFromParent_Done,
     /* 191123 */   // Label 3559: @191123
     /* 191123 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(191168), // Rule ID 1500 //
     /* 191128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 191136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191157 */     // (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 191160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191166 */     GIR_RootConstrainSelectedInstOperands,
     /* 191167 */     // GIR_Coverage, 1500,
     /* 191167 */     GIR_EraseRootFromParent_Done,
     /* 191168 */   // Label 3560: @191168
     /* 191168 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(191213), // Rule ID 1502 //
     /* 191173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 191181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191202 */     // (intrinsic_wo_chain:{ *:[v4i32] } 731:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 191205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191211 */     GIR_RootConstrainSelectedInstOperands,
     /* 191212 */     // GIR_Coverage, 1502,
     /* 191212 */     GIR_EraseRootFromParent_Done,
     /* 191213 */   // Label 3561: @191213
     /* 191213 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(191258), // Rule ID 1509 //
     /* 191218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191247 */     // (intrinsic_wo_chain:{ *:[v8i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 191250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191256 */     GIR_RootConstrainSelectedInstOperands,
     /* 191257 */     // GIR_Coverage, 1509,
     /* 191257 */     GIR_EraseRootFromParent_Done,
     /* 191258 */   // Label 3562: @191258
     /* 191258 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(191303), // Rule ID 1510 //
     /* 191263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191292 */     // (intrinsic_wo_chain:{ *:[v16i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 191295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191301 */     GIR_RootConstrainSelectedInstOperands,
     /* 191302 */     // GIR_Coverage, 1510,
     /* 191302 */     GIR_EraseRootFromParent_Done,
     /* 191303 */   // Label 3563: @191303
     /* 191303 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(191348), // Rule ID 1511 //
     /* 191308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191337 */     // (intrinsic_wo_chain:{ *:[v4i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 191340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191346 */     GIR_RootConstrainSelectedInstOperands,
     /* 191347 */     // GIR_Coverage, 1511,
     /* 191347 */     GIR_EraseRootFromParent_Done,
     /* 191348 */   // Label 3564: @191348
     /* 191348 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(191393), // Rule ID 1512 //
     /* 191353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191382 */     // (intrinsic_wo_chain:{ *:[v8i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 191385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191391 */     GIR_RootConstrainSelectedInstOperands,
     /* 191392 */     // GIR_Coverage, 1512,
     /* 191392 */     GIR_EraseRootFromParent_Done,
     /* 191393 */   // Label 3565: @191393
     /* 191393 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(191438), // Rule ID 1513 //
     /* 191398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191427 */     // (intrinsic_wo_chain:{ *:[v2i32] } 737:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 191430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191436 */     GIR_RootConstrainSelectedInstOperands,
     /* 191437 */     // GIR_Coverage, 1513,
     /* 191437 */     GIR_EraseRootFromParent_Done,
     /* 191438 */   // Label 3566: @191438
     /* 191438 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(191483), // Rule ID 1514 //
     /* 191443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191472 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 191475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191481 */     GIR_RootConstrainSelectedInstOperands,
     /* 191482 */     // GIR_Coverage, 1514,
     /* 191482 */     GIR_EraseRootFromParent_Done,
     /* 191483 */   // Label 3567: @191483
     /* 191483 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(191528), // Rule ID 1515 //
     /* 191488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191517 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 191520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191526 */     GIR_RootConstrainSelectedInstOperands,
     /* 191527 */     // GIR_Coverage, 1515,
     /* 191527 */     GIR_EraseRootFromParent_Done,
     /* 191528 */   // Label 3568: @191528
     /* 191528 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(191573), // Rule ID 1516 //
     /* 191533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191562 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 191565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191571 */     GIR_RootConstrainSelectedInstOperands,
     /* 191572 */     // GIR_Coverage, 1516,
     /* 191572 */     GIR_EraseRootFromParent_Done,
     /* 191573 */   // Label 3569: @191573
     /* 191573 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(191618), // Rule ID 1517 //
     /* 191578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191607 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 191610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191616 */     GIR_RootConstrainSelectedInstOperands,
     /* 191617 */     // GIR_Coverage, 1517,
     /* 191617 */     GIR_EraseRootFromParent_Done,
     /* 191618 */   // Label 3570: @191618
     /* 191618 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(191663), // Rule ID 1518 //
     /* 191623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 191655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191661 */     GIR_RootConstrainSelectedInstOperands,
     /* 191662 */     // GIR_Coverage, 1518,
     /* 191662 */     GIR_EraseRootFromParent_Done,
     /* 191663 */   // Label 3571: @191663
     /* 191663 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(191708), // Rule ID 1519 //
     /* 191668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191697 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 191700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191706 */     GIR_RootConstrainSelectedInstOperands,
     /* 191707 */     // GIR_Coverage, 1519,
     /* 191707 */     GIR_EraseRootFromParent_Done,
     /* 191708 */   // Label 3572: @191708
     /* 191708 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(191753), // Rule ID 1520 //
     /* 191713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191742 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 191745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191751 */     GIR_RootConstrainSelectedInstOperands,
     /* 191752 */     // GIR_Coverage, 1520,
     /* 191752 */     GIR_EraseRootFromParent_Done,
     /* 191753 */   // Label 3573: @191753
     /* 191753 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(191798), // Rule ID 1527 //
     /* 191758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191787 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 191790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191796 */     GIR_RootConstrainSelectedInstOperands,
     /* 191797 */     // GIR_Coverage, 1527,
     /* 191797 */     GIR_EraseRootFromParent_Done,
     /* 191798 */   // Label 3574: @191798
     /* 191798 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(191843), // Rule ID 1528 //
     /* 191803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191832 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 191835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191841 */     GIR_RootConstrainSelectedInstOperands,
     /* 191842 */     // GIR_Coverage, 1528,
     /* 191842 */     GIR_EraseRootFromParent_Done,
     /* 191843 */   // Label 3575: @191843
     /* 191843 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(191888), // Rule ID 1529 //
     /* 191848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191877 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 191880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191886 */     GIR_RootConstrainSelectedInstOperands,
     /* 191887 */     // GIR_Coverage, 1529,
     /* 191887 */     GIR_EraseRootFromParent_Done,
     /* 191888 */   // Label 3576: @191888
     /* 191888 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(191933), // Rule ID 1530 //
     /* 191893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191922 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 191925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191931 */     GIR_RootConstrainSelectedInstOperands,
     /* 191932 */     // GIR_Coverage, 1530,
     /* 191932 */     GIR_EraseRootFromParent_Done,
     /* 191933 */   // Label 3577: @191933
     /* 191933 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(191978), // Rule ID 1531 //
     /* 191938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191967 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 191970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191976 */     GIR_RootConstrainSelectedInstOperands,
     /* 191977 */     // GIR_Coverage, 1531,
     /* 191977 */     GIR_EraseRootFromParent_Done,
     /* 191978 */   // Label 3578: @191978
     /* 191978 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(192023), // Rule ID 1532 //
     /* 191983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192012 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 192015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192021 */     GIR_RootConstrainSelectedInstOperands,
     /* 192022 */     // GIR_Coverage, 1532,
     /* 192022 */     GIR_EraseRootFromParent_Done,
     /* 192023 */   // Label 3579: @192023
     /* 192023 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(192068), // Rule ID 1546 //
     /* 192028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192057 */     // (intrinsic_wo_chain:{ *:[v8i8] } 747:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 192060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192066 */     GIR_RootConstrainSelectedInstOperands,
     /* 192067 */     // GIR_Coverage, 1546,
     /* 192067 */     GIR_EraseRootFromParent_Done,
     /* 192068 */   // Label 3580: @192068
     /* 192068 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(192113), // Rule ID 1547 //
     /* 192073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192102 */     // (intrinsic_wo_chain:{ *:[v16i8] } 747:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 192105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192111 */     GIR_RootConstrainSelectedInstOperands,
     /* 192112 */     // GIR_Coverage, 1547,
     /* 192112 */     GIR_EraseRootFromParent_Done,
     /* 192113 */   // Label 3581: @192113
     /* 192113 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(192158), // Rule ID 1548 //
     /* 192118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192147 */     // (intrinsic_wo_chain:{ *:[v4i16] } 747:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 192150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192156 */     GIR_RootConstrainSelectedInstOperands,
     /* 192157 */     // GIR_Coverage, 1548,
     /* 192157 */     GIR_EraseRootFromParent_Done,
     /* 192158 */   // Label 3582: @192158
     /* 192158 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(192203), // Rule ID 1549 //
     /* 192163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192192 */     // (intrinsic_wo_chain:{ *:[v8i16] } 747:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 192195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192201 */     GIR_RootConstrainSelectedInstOperands,
     /* 192202 */     // GIR_Coverage, 1549,
     /* 192202 */     GIR_EraseRootFromParent_Done,
     /* 192203 */   // Label 3583: @192203
     /* 192203 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(192248), // Rule ID 1550 //
     /* 192208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192237 */     // (intrinsic_wo_chain:{ *:[v2i32] } 747:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 192240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192246 */     GIR_RootConstrainSelectedInstOperands,
     /* 192247 */     // GIR_Coverage, 1550,
     /* 192247 */     GIR_EraseRootFromParent_Done,
     /* 192248 */   // Label 3584: @192248
     /* 192248 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(192293), // Rule ID 1551 //
     /* 192253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192282 */     // (intrinsic_wo_chain:{ *:[v4i32] } 747:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 192285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192291 */     GIR_RootConstrainSelectedInstOperands,
     /* 192292 */     // GIR_Coverage, 1551,
     /* 192292 */     GIR_EraseRootFromParent_Done,
     /* 192293 */   // Label 3585: @192293
     /* 192293 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(192338), // Rule ID 1552 //
     /* 192298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192327 */     // (intrinsic_wo_chain:{ *:[v2i64] } 747:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 192330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192336 */     GIR_RootConstrainSelectedInstOperands,
     /* 192337 */     // GIR_Coverage, 1552,
     /* 192337 */     GIR_EraseRootFromParent_Done,
     /* 192338 */   // Label 3586: @192338
     /* 192338 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(192383), // Rule ID 1553 //
     /* 192343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192372 */     // (intrinsic_wo_chain:{ *:[v8i8] } 749:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 192375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192381 */     GIR_RootConstrainSelectedInstOperands,
     /* 192382 */     // GIR_Coverage, 1553,
     /* 192382 */     GIR_EraseRootFromParent_Done,
     /* 192383 */   // Label 3587: @192383
     /* 192383 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(192428), // Rule ID 1554 //
     /* 192388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192417 */     // (intrinsic_wo_chain:{ *:[v16i8] } 749:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 192420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192426 */     GIR_RootConstrainSelectedInstOperands,
     /* 192427 */     // GIR_Coverage, 1554,
     /* 192427 */     GIR_EraseRootFromParent_Done,
     /* 192428 */   // Label 3588: @192428
     /* 192428 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(192473), // Rule ID 1555 //
     /* 192433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192462 */     // (intrinsic_wo_chain:{ *:[v4i16] } 749:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 192465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192471 */     GIR_RootConstrainSelectedInstOperands,
     /* 192472 */     // GIR_Coverage, 1555,
     /* 192472 */     GIR_EraseRootFromParent_Done,
     /* 192473 */   // Label 3589: @192473
     /* 192473 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(192518), // Rule ID 1556 //
     /* 192478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192507 */     // (intrinsic_wo_chain:{ *:[v8i16] } 749:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 192510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192516 */     GIR_RootConstrainSelectedInstOperands,
     /* 192517 */     // GIR_Coverage, 1556,
     /* 192517 */     GIR_EraseRootFromParent_Done,
     /* 192518 */   // Label 3590: @192518
     /* 192518 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(192563), // Rule ID 1557 //
     /* 192523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 192555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192561 */     GIR_RootConstrainSelectedInstOperands,
     /* 192562 */     // GIR_Coverage, 1557,
     /* 192562 */     GIR_EraseRootFromParent_Done,
     /* 192563 */   // Label 3591: @192563
     /* 192563 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(192608), // Rule ID 1558 //
     /* 192568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192597 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 192600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192606 */     GIR_RootConstrainSelectedInstOperands,
     /* 192607 */     // GIR_Coverage, 1558,
     /* 192607 */     GIR_EraseRootFromParent_Done,
     /* 192608 */   // Label 3592: @192608
     /* 192608 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(192653), // Rule ID 1559 //
     /* 192613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192642 */     // (intrinsic_wo_chain:{ *:[v2i64] } 749:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 192645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192651 */     GIR_RootConstrainSelectedInstOperands,
     /* 192652 */     // GIR_Coverage, 1559,
     /* 192652 */     GIR_EraseRootFromParent_Done,
     /* 192653 */   // Label 3593: @192653
     /* 192653 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(192698), // Rule ID 1573 //
     /* 192658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192687 */     // (intrinsic_wo_chain:{ *:[v8i8] } 755:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 192690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192696 */     GIR_RootConstrainSelectedInstOperands,
     /* 192697 */     // GIR_Coverage, 1573,
     /* 192697 */     GIR_EraseRootFromParent_Done,
     /* 192698 */   // Label 3594: @192698
     /* 192698 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(192743), // Rule ID 1574 //
     /* 192703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192732 */     // (intrinsic_wo_chain:{ *:[v16i8] } 755:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 192735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192741 */     GIR_RootConstrainSelectedInstOperands,
     /* 192742 */     // GIR_Coverage, 1574,
     /* 192742 */     GIR_EraseRootFromParent_Done,
     /* 192743 */   // Label 3595: @192743
     /* 192743 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(192788), // Rule ID 1575 //
     /* 192748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192777 */     // (intrinsic_wo_chain:{ *:[v4i16] } 755:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 192780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192786 */     GIR_RootConstrainSelectedInstOperands,
     /* 192787 */     // GIR_Coverage, 1575,
     /* 192787 */     GIR_EraseRootFromParent_Done,
     /* 192788 */   // Label 3596: @192788
     /* 192788 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(192833), // Rule ID 1576 //
     /* 192793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192822 */     // (intrinsic_wo_chain:{ *:[v8i16] } 755:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 192825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192831 */     GIR_RootConstrainSelectedInstOperands,
     /* 192832 */     // GIR_Coverage, 1576,
     /* 192832 */     GIR_EraseRootFromParent_Done,
     /* 192833 */   // Label 3597: @192833
     /* 192833 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(192878), // Rule ID 1577 //
     /* 192838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192867 */     // (intrinsic_wo_chain:{ *:[v2i32] } 755:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 192870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192876 */     GIR_RootConstrainSelectedInstOperands,
     /* 192877 */     // GIR_Coverage, 1577,
     /* 192877 */     GIR_EraseRootFromParent_Done,
     /* 192878 */   // Label 3598: @192878
     /* 192878 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(192923), // Rule ID 1578 //
     /* 192883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192912 */     // (intrinsic_wo_chain:{ *:[v4i32] } 755:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 192915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192921 */     GIR_RootConstrainSelectedInstOperands,
     /* 192922 */     // GIR_Coverage, 1578,
     /* 192922 */     GIR_EraseRootFromParent_Done,
     /* 192923 */   // Label 3599: @192923
     /* 192923 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(192968), // Rule ID 1579 //
     /* 192928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192957 */     // (intrinsic_wo_chain:{ *:[v2i64] } 755:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 192960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192966 */     GIR_RootConstrainSelectedInstOperands,
     /* 192967 */     // GIR_Coverage, 1579,
     /* 192967 */     GIR_EraseRootFromParent_Done,
     /* 192968 */   // Label 3600: @192968
     /* 192968 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(193013), // Rule ID 1580 //
     /* 192973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 192981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193002 */     // (intrinsic_wo_chain:{ *:[v8i8] } 758:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 193005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193011 */     GIR_RootConstrainSelectedInstOperands,
     /* 193012 */     // GIR_Coverage, 1580,
     /* 193012 */     GIR_EraseRootFromParent_Done,
     /* 193013 */   // Label 3601: @193013
     /* 193013 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(193058), // Rule ID 1581 //
     /* 193018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193047 */     // (intrinsic_wo_chain:{ *:[v16i8] } 758:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 193050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193056 */     GIR_RootConstrainSelectedInstOperands,
     /* 193057 */     // GIR_Coverage, 1581,
     /* 193057 */     GIR_EraseRootFromParent_Done,
     /* 193058 */   // Label 3602: @193058
     /* 193058 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(193103), // Rule ID 1582 //
     /* 193063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193092 */     // (intrinsic_wo_chain:{ *:[v4i16] } 758:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 193095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193101 */     GIR_RootConstrainSelectedInstOperands,
     /* 193102 */     // GIR_Coverage, 1582,
     /* 193102 */     GIR_EraseRootFromParent_Done,
     /* 193103 */   // Label 3603: @193103
     /* 193103 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(193148), // Rule ID 1583 //
     /* 193108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193137 */     // (intrinsic_wo_chain:{ *:[v8i16] } 758:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 193140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193146 */     GIR_RootConstrainSelectedInstOperands,
     /* 193147 */     // GIR_Coverage, 1583,
     /* 193147 */     GIR_EraseRootFromParent_Done,
     /* 193148 */   // Label 3604: @193148
     /* 193148 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(193193), // Rule ID 1584 //
     /* 193153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193182 */     // (intrinsic_wo_chain:{ *:[v2i32] } 758:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 193185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193191 */     GIR_RootConstrainSelectedInstOperands,
     /* 193192 */     // GIR_Coverage, 1584,
     /* 193192 */     GIR_EraseRootFromParent_Done,
     /* 193193 */   // Label 3605: @193193
     /* 193193 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(193238), // Rule ID 1585 //
     /* 193198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193227 */     // (intrinsic_wo_chain:{ *:[v4i32] } 758:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 193230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193236 */     GIR_RootConstrainSelectedInstOperands,
     /* 193237 */     // GIR_Coverage, 1585,
     /* 193237 */     GIR_EraseRootFromParent_Done,
     /* 193238 */   // Label 3606: @193238
     /* 193238 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(193283), // Rule ID 1586 //
     /* 193243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193272 */     // (intrinsic_wo_chain:{ *:[v2i64] } 758:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 193275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193281 */     GIR_RootConstrainSelectedInstOperands,
     /* 193282 */     // GIR_Coverage, 1586,
     /* 193282 */     GIR_EraseRootFromParent_Done,
     /* 193283 */   // Label 3607: @193283
     /* 193283 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(193328), // Rule ID 1614 //
     /* 193288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 193296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193317 */     // (intrinsic_wo_chain:{ *:[f64] } 792:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 193320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193326 */     GIR_RootConstrainSelectedInstOperands,
     /* 193327 */     // GIR_Coverage, 1614,
     /* 193327 */     GIR_EraseRootFromParent_Done,
     /* 193328 */   // Label 3608: @193328
     /* 193328 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(193373), // Rule ID 1615 //
     /* 193333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 193341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193362 */     // (intrinsic_wo_chain:{ *:[f32] } 792:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 193365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193371 */     GIR_RootConstrainSelectedInstOperands,
     /* 193372 */     // GIR_Coverage, 1615,
     /* 193372 */     GIR_EraseRootFromParent_Done,
     /* 193373 */   // Label 3609: @193373
     /* 193373 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(193418), // Rule ID 1616 //
     /* 193378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 193381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 193386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 193389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 193392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 193395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193407 */     // (intrinsic_wo_chain:{ *:[f16] } 792:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 193407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 193410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193416 */     GIR_RootConstrainSelectedInstOperands,
     /* 193417 */     // GIR_Coverage, 1616,
     /* 193417 */     GIR_EraseRootFromParent_Done,
     /* 193418 */   // Label 3610: @193418
     /* 193418 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(193463), // Rule ID 1617 //
     /* 193423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 193431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193452 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 193455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193461 */     GIR_RootConstrainSelectedInstOperands,
     /* 193462 */     // GIR_Coverage, 1617,
     /* 193462 */     GIR_EraseRootFromParent_Done,
     /* 193463 */   // Label 3611: @193463
     /* 193463 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(193508), // Rule ID 1618 //
     /* 193468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 193476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193497 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 193500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193506 */     GIR_RootConstrainSelectedInstOperands,
     /* 193507 */     // GIR_Coverage, 1618,
     /* 193507 */     GIR_EraseRootFromParent_Done,
     /* 193508 */   // Label 3612: @193508
     /* 193508 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(193553), // Rule ID 1619 //
     /* 193513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 193521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193542 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 193545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193551 */     GIR_RootConstrainSelectedInstOperands,
     /* 193552 */     // GIR_Coverage, 1619,
     /* 193552 */     GIR_EraseRootFromParent_Done,
     /* 193553 */   // Label 3613: @193553
     /* 193553 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(193598), // Rule ID 1620 //
     /* 193558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 193566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193587 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 193590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193596 */     GIR_RootConstrainSelectedInstOperands,
     /* 193597 */     // GIR_Coverage, 1620,
     /* 193597 */     GIR_EraseRootFromParent_Done,
     /* 193598 */   // Label 3614: @193598
     /* 193598 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(193643), // Rule ID 1627 //
     /* 193603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 193611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193632 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 193635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193641 */     GIR_RootConstrainSelectedInstOperands,
     /* 193642 */     // GIR_Coverage, 1627,
     /* 193642 */     GIR_EraseRootFromParent_Done,
     /* 193643 */   // Label 3615: @193643
     /* 193643 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(193688), // Rule ID 1628 //
     /* 193648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 193656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193677 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 193680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193686 */     GIR_RootConstrainSelectedInstOperands,
     /* 193687 */     // GIR_Coverage, 1628,
     /* 193687 */     GIR_EraseRootFromParent_Done,
     /* 193688 */   // Label 3616: @193688
     /* 193688 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(193733), // Rule ID 1629 //
     /* 193693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 193696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 193701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 193704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 193707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 193710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193722 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 193722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 193725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193731 */     GIR_RootConstrainSelectedInstOperands,
     /* 193732 */     // GIR_Coverage, 1629,
     /* 193732 */     GIR_EraseRootFromParent_Done,
     /* 193733 */   // Label 3617: @193733
     /* 193733 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(193778), // Rule ID 1630 //
     /* 193738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 193746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193767 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 193770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193776 */     GIR_RootConstrainSelectedInstOperands,
     /* 193777 */     // GIR_Coverage, 1630,
     /* 193777 */     GIR_EraseRootFromParent_Done,
     /* 193778 */   // Label 3618: @193778
     /* 193778 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(193823), // Rule ID 1631 //
     /* 193783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 193791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193812 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 193815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193821 */     GIR_RootConstrainSelectedInstOperands,
     /* 193822 */     // GIR_Coverage, 1631,
     /* 193822 */     GIR_EraseRootFromParent_Done,
     /* 193823 */   // Label 3619: @193823
     /* 193823 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(193868), // Rule ID 1632 //
     /* 193828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 193831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 193836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 193839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 193842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 193845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193857 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 193857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 193860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193866 */     GIR_RootConstrainSelectedInstOperands,
     /* 193867 */     // GIR_Coverage, 1632,
     /* 193867 */     GIR_EraseRootFromParent_Done,
     /* 193868 */   // Label 3620: @193868
     /* 193868 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(193913), // Rule ID 1633 //
     /* 193873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 193881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193902 */     // (intrinsic_wo_chain:{ *:[f64] } 647:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 193905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193911 */     GIR_RootConstrainSelectedInstOperands,
     /* 193912 */     // GIR_Coverage, 1633,
     /* 193912 */     GIR_EraseRootFromParent_Done,
     /* 193913 */   // Label 3621: @193913
     /* 193913 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(193958), // Rule ID 1634 //
     /* 193918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 193926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193947 */     // (intrinsic_wo_chain:{ *:[f32] } 647:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 193950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193956 */     GIR_RootConstrainSelectedInstOperands,
     /* 193957 */     // GIR_Coverage, 1634,
     /* 193957 */     GIR_EraseRootFromParent_Done,
     /* 193958 */   // Label 3622: @193958
     /* 193958 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(194003), // Rule ID 1635 //
     /* 193963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 193966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 193971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 193974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 193977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 193980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193992 */     // (intrinsic_wo_chain:{ *:[f16] } 647:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 193992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 193995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194001 */     GIR_RootConstrainSelectedInstOperands,
     /* 194002 */     // GIR_Coverage, 1635,
     /* 194002 */     GIR_EraseRootFromParent_Done,
     /* 194003 */   // Label 3623: @194003
     /* 194003 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(194048), // Rule ID 1637 //
     /* 194008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 194016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194037 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 194037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 194040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194046 */     GIR_RootConstrainSelectedInstOperands,
     /* 194047 */     // GIR_Coverage, 1637,
     /* 194047 */     GIR_EraseRootFromParent_Done,
     /* 194048 */   // Label 3624: @194048
     /* 194048 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(194093), // Rule ID 1638 //
     /* 194053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 194061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194082 */     // (intrinsic_wo_chain:{ *:[i32] } 695:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 194082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 194085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194091 */     GIR_RootConstrainSelectedInstOperands,
     /* 194092 */     // GIR_Coverage, 1638,
     /* 194092 */     GIR_EraseRootFromParent_Done,
     /* 194093 */   // Label 3625: @194093
     /* 194093 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(194138), // Rule ID 1639 //
     /* 194098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 194106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194127 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 194130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194136 */     GIR_RootConstrainSelectedInstOperands,
     /* 194137 */     // GIR_Coverage, 1639,
     /* 194137 */     GIR_EraseRootFromParent_Done,
     /* 194138 */   // Label 3626: @194138
     /* 194138 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(194183), // Rule ID 1640 //
     /* 194143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 194151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194172 */     // (intrinsic_wo_chain:{ *:[v1i64] } 701:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 194175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194181 */     GIR_RootConstrainSelectedInstOperands,
     /* 194182 */     // GIR_Coverage, 1640,
     /* 194182 */     GIR_EraseRootFromParent_Done,
     /* 194183 */   // Label 3627: @194183
     /* 194183 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(194228), // Rule ID 1642 //
     /* 194188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 194196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194217 */     // (intrinsic_wo_chain:{ *:[v1i64] } 709:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 194220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194226 */     GIR_RootConstrainSelectedInstOperands,
     /* 194227 */     // GIR_Coverage, 1642,
     /* 194227 */     GIR_EraseRootFromParent_Done,
     /* 194228 */   // Label 3628: @194228
     /* 194228 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(194273), // Rule ID 1643 //
     /* 194233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 194241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194262 */     // (intrinsic_wo_chain:{ *:[v1i64] } 710:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 194265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194271 */     GIR_RootConstrainSelectedInstOperands,
     /* 194272 */     // GIR_Coverage, 1643,
     /* 194272 */     GIR_EraseRootFromParent_Done,
     /* 194273 */   // Label 3629: @194273
     /* 194273 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(194318), // Rule ID 1646 //
     /* 194278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 194286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194307 */     // (intrinsic_wo_chain:{ *:[v1i64] } 747:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 194310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194316 */     GIR_RootConstrainSelectedInstOperands,
     /* 194317 */     // GIR_Coverage, 1646,
     /* 194317 */     GIR_EraseRootFromParent_Done,
     /* 194318 */   // Label 3630: @194318
     /* 194318 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(194363), // Rule ID 1647 //
     /* 194323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194352 */     // (intrinsic_wo_chain:{ *:[v1i64] } 749:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 194355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194361 */     GIR_RootConstrainSelectedInstOperands,
     /* 194362 */     // GIR_Coverage, 1647,
     /* 194362 */     GIR_EraseRootFromParent_Done,
     /* 194363 */   // Label 3631: @194363
     /* 194363 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(194408), // Rule ID 1649 //
     /* 194368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194397 */     // (intrinsic_wo_chain:{ *:[v1i64] } 755:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 194400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194406 */     GIR_RootConstrainSelectedInstOperands,
     /* 194407 */     // GIR_Coverage, 1649,
     /* 194407 */     GIR_EraseRootFromParent_Done,
     /* 194408 */   // Label 3632: @194408
     /* 194408 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(194453), // Rule ID 1650 //
     /* 194413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194442 */     // (intrinsic_wo_chain:{ *:[v1i64] } 758:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 194445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194451 */     GIR_RootConstrainSelectedInstOperands,
     /* 194452 */     // GIR_Coverage, 1650,
     /* 194452 */     GIR_EraseRootFromParent_Done,
     /* 194453 */   // Label 3633: @194453
     /* 194453 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(194498), // Rule ID 1651 //
     /* 194458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 194466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194487 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 194487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 194490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194496 */     GIR_RootConstrainSelectedInstOperands,
     /* 194497 */     // GIR_Coverage, 1651,
     /* 194497 */     GIR_EraseRootFromParent_Done,
     /* 194498 */   // Label 3634: @194498
     /* 194498 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(194543), // Rule ID 1665 //
     /* 194503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 194511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194532 */     // (intrinsic_wo_chain:{ *:[i64] } 722:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 194532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 194535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194541 */     GIR_RootConstrainSelectedInstOperands,
     /* 194542 */     // GIR_Coverage, 1665,
     /* 194542 */     GIR_EraseRootFromParent_Done,
     /* 194543 */   // Label 3635: @194543
     /* 194543 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(194588), // Rule ID 1666 //
     /* 194548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 194556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194577 */     // (intrinsic_wo_chain:{ *:[i32] } 722:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 194577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 194580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194586 */     GIR_RootConstrainSelectedInstOperands,
     /* 194587 */     // GIR_Coverage, 1666,
     /* 194587 */     GIR_EraseRootFromParent_Done,
     /* 194588 */   // Label 3636: @194588
     /* 194588 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(194633), // Rule ID 1671 //
     /* 194593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 194601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194622 */     // (intrinsic_wo_chain:{ *:[i64] } 761:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 194622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 194625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194631 */     GIR_RootConstrainSelectedInstOperands,
     /* 194632 */     // GIR_Coverage, 1671,
     /* 194632 */     GIR_EraseRootFromParent_Done,
     /* 194633 */   // Label 3637: @194633
     /* 194633 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(194678), // Rule ID 1672 //
     /* 194638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 194646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194667 */     // (intrinsic_wo_chain:{ *:[i32] } 761:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 194667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 194670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194676 */     GIR_RootConstrainSelectedInstOperands,
     /* 194677 */     // GIR_Coverage, 1672,
     /* 194677 */     GIR_EraseRootFromParent_Done,
     /* 194678 */   // Label 3638: @194678
     /* 194678 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(194723), // Rule ID 1673 //
     /* 194683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 194691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194712 */     // (intrinsic_wo_chain:{ *:[v8i8] } 576:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 194715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194721 */     GIR_RootConstrainSelectedInstOperands,
     /* 194722 */     // GIR_Coverage, 1673,
     /* 194722 */     GIR_EraseRootFromParent_Done,
     /* 194723 */   // Label 3639: @194723
     /* 194723 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(194768), // Rule ID 1674 //
     /* 194728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 194736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194757 */     // (intrinsic_wo_chain:{ *:[v4i16] } 576:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 194760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194766 */     GIR_RootConstrainSelectedInstOperands,
     /* 194767 */     // GIR_Coverage, 1674,
     /* 194767 */     GIR_EraseRootFromParent_Done,
     /* 194768 */   // Label 3640: @194768
     /* 194768 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(194813), // Rule ID 1675 //
     /* 194773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 194781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194802 */     // (intrinsic_wo_chain:{ *:[v2i32] } 576:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 194805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194811 */     GIR_RootConstrainSelectedInstOperands,
     /* 194812 */     // GIR_Coverage, 1675,
     /* 194812 */     GIR_EraseRootFromParent_Done,
     /* 194813 */   // Label 3641: @194813
     /* 194813 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(194858), // Rule ID 1676 //
     /* 194818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 194826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194847 */     // (intrinsic_wo_chain:{ *:[v8i8] } 721:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 194850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194856 */     GIR_RootConstrainSelectedInstOperands,
     /* 194857 */     // GIR_Coverage, 1676,
     /* 194857 */     GIR_EraseRootFromParent_Done,
     /* 194858 */   // Label 3642: @194858
     /* 194858 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(194903), // Rule ID 1677 //
     /* 194863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 194871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194892 */     // (intrinsic_wo_chain:{ *:[v4i16] } 721:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 194895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194901 */     GIR_RootConstrainSelectedInstOperands,
     /* 194902 */     // GIR_Coverage, 1677,
     /* 194902 */     GIR_EraseRootFromParent_Done,
     /* 194903 */   // Label 3643: @194903
     /* 194903 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(194948), // Rule ID 1678 //
     /* 194908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 194916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194937 */     // (intrinsic_wo_chain:{ *:[v2i32] } 721:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 194940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194946 */     GIR_RootConstrainSelectedInstOperands,
     /* 194947 */     // GIR_Coverage, 1678,
     /* 194947 */     GIR_EraseRootFromParent_Done,
     /* 194948 */   // Label 3644: @194948
     /* 194948 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(194993), // Rule ID 1679 //
     /* 194953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 194961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194982 */     // (intrinsic_wo_chain:{ *:[v8i8] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 194985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194991 */     GIR_RootConstrainSelectedInstOperands,
     /* 194992 */     // GIR_Coverage, 1679,
     /* 194992 */     GIR_EraseRootFromParent_Done,
     /* 194993 */   // Label 3645: @194993
     /* 194993 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(195038), // Rule ID 1680 //
     /* 194998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 195006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195027 */     // (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 195030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195036 */     GIR_RootConstrainSelectedInstOperands,
     /* 195037 */     // GIR_Coverage, 1680,
     /* 195037 */     GIR_EraseRootFromParent_Done,
     /* 195038 */   // Label 3646: @195038
     /* 195038 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(195083), // Rule ID 1681 //
     /* 195043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 195051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195072 */     // (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 195075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195081 */     GIR_RootConstrainSelectedInstOperands,
     /* 195082 */     // GIR_Coverage, 1681,
     /* 195082 */     GIR_EraseRootFromParent_Done,
     /* 195083 */   // Label 3647: @195083
     /* 195083 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(195128), // Rule ID 1682 //
     /* 195088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 195096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 195099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195117 */     // (intrinsic_wo_chain:{ *:[v8i8] } 665:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 195120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195126 */     GIR_RootConstrainSelectedInstOperands,
     /* 195127 */     // GIR_Coverage, 1682,
     /* 195127 */     GIR_EraseRootFromParent_Done,
     /* 195128 */   // Label 3648: @195128
     /* 195128 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(195173), // Rule ID 1683 //
     /* 195133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 195141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195162 */     // (intrinsic_wo_chain:{ *:[v4i16] } 665:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 195165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195171 */     GIR_RootConstrainSelectedInstOperands,
     /* 195172 */     // GIR_Coverage, 1683,
     /* 195172 */     GIR_EraseRootFromParent_Done,
     /* 195173 */   // Label 3649: @195173
     /* 195173 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(195218), // Rule ID 1684 //
     /* 195178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 195186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195207 */     // (intrinsic_wo_chain:{ *:[v2i32] } 665:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 195210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195216 */     GIR_RootConstrainSelectedInstOperands,
     /* 195217 */     // GIR_Coverage, 1684,
     /* 195217 */     GIR_EraseRootFromParent_Done,
     /* 195218 */   // Label 3650: @195218
     /* 195218 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(195263), // Rule ID 1750 //
     /* 195223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 195231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195252 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 195255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195261 */     GIR_RootConstrainSelectedInstOperands,
     /* 195262 */     // GIR_Coverage, 1750,
     /* 195262 */     GIR_EraseRootFromParent_Done,
     /* 195263 */   // Label 3651: @195263
     /* 195263 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(195308), // Rule ID 1752 //
     /* 195268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 195276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195297 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 195300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195306 */     GIR_RootConstrainSelectedInstOperands,
     /* 195307 */     // GIR_Coverage, 1752,
     /* 195307 */     GIR_EraseRootFromParent_Done,
     /* 195308 */   // Label 3652: @195308
     /* 195308 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(195353), // Rule ID 2303 //
     /* 195313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 195316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 195321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 195327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 195330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195342 */     // (intrinsic_wo_chain:{ *:[v16i8] } 519:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 195342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 195345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195351 */     GIR_RootConstrainSelectedInstOperands,
     /* 195352 */     // GIR_Coverage, 2303,
     /* 195352 */     GIR_EraseRootFromParent_Done,
     /* 195353 */   // Label 3653: @195353
     /* 195353 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(195398), // Rule ID 2304 //
     /* 195358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 195361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 195366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 195372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 195375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195387 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 195387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 195390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195396 */     GIR_RootConstrainSelectedInstOperands,
     /* 195397 */     // GIR_Coverage, 2304,
     /* 195397 */     GIR_EraseRootFromParent_Done,
     /* 195398 */   // Label 3654: @195398
     /* 195398 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(195443), // Rule ID 2315 //
     /* 195403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 195406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 195411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195432 */     // (intrinsic_wo_chain:{ *:[v4i32] } 532:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 195432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 195435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195441 */     GIR_RootConstrainSelectedInstOperands,
     /* 195442 */     // GIR_Coverage, 2315,
     /* 195442 */     GIR_EraseRootFromParent_Done,
     /* 195443 */   // Label 3655: @195443
     /* 195443 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(195488), // Rule ID 2316 //
     /* 195448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 195451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 195456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195477 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 195477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 195480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195486 */     GIR_RootConstrainSelectedInstOperands,
     /* 195487 */     // GIR_Coverage, 2316,
     /* 195487 */     GIR_EraseRootFromParent_Done,
     /* 195488 */   // Label 3656: @195488
     /* 195488 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(195533), // Rule ID 2339 //
     /* 195493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 195496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 195501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195522 */     // (intrinsic_wo_chain:{ *:[v4f16] } 638:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 195525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195531 */     GIR_RootConstrainSelectedInstOperands,
     /* 195532 */     // GIR_Coverage, 2339,
     /* 195532 */     GIR_EraseRootFromParent_Done,
     /* 195533 */   // Label 3657: @195533
     /* 195533 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(195578), // Rule ID 2340 //
     /* 195538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 195541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 195546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195567 */     // (intrinsic_wo_chain:{ *:[v8f16] } 638:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 195570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195576 */     GIR_RootConstrainSelectedInstOperands,
     /* 195577 */     // GIR_Coverage, 2340,
     /* 195577 */     GIR_EraseRootFromParent_Done,
     /* 195578 */   // Label 3658: @195578
     /* 195578 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(195623), // Rule ID 2341 //
     /* 195583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 195586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 195591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195612 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 195615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195621 */     GIR_RootConstrainSelectedInstOperands,
     /* 195622 */     // GIR_Coverage, 2341,
     /* 195622 */     GIR_EraseRootFromParent_Done,
     /* 195623 */   // Label 3659: @195623
     /* 195623 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(195668), // Rule ID 2342 //
     /* 195628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 195631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 195636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195657 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 195660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195666 */     GIR_RootConstrainSelectedInstOperands,
     /* 195667 */     // GIR_Coverage, 2342,
     /* 195667 */     GIR_EraseRootFromParent_Done,
     /* 195668 */   // Label 3660: @195668
     /* 195668 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(195713), // Rule ID 2343 //
     /* 195673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 195676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 195681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195702 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 195705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195711 */     GIR_RootConstrainSelectedInstOperands,
     /* 195712 */     // GIR_Coverage, 2343,
     /* 195712 */     GIR_EraseRootFromParent_Done,
     /* 195713 */   // Label 3661: @195713
     /* 195713 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(195758), // Rule ID 2344 //
     /* 195718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 195721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 195726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195747 */     // (intrinsic_wo_chain:{ *:[v4f16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 195747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 195750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195756 */     GIR_RootConstrainSelectedInstOperands,
     /* 195757 */     // GIR_Coverage, 2344,
     /* 195757 */     GIR_EraseRootFromParent_Done,
     /* 195758 */   // Label 3662: @195758
     /* 195758 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(195803), // Rule ID 2347 //
     /* 195763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 195766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 195771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195792 */     // (intrinsic_wo_chain:{ *:[v8f16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 195792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 195795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195801 */     GIR_RootConstrainSelectedInstOperands,
     /* 195802 */     // GIR_Coverage, 2347,
     /* 195802 */     GIR_EraseRootFromParent_Done,
     /* 195803 */   // Label 3663: @195803
     /* 195803 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(195848), // Rule ID 2350 //
     /* 195808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 195811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 195816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195837 */     // (intrinsic_wo_chain:{ *:[v2f32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 195837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 195840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195846 */     GIR_RootConstrainSelectedInstOperands,
     /* 195847 */     // GIR_Coverage, 2350,
     /* 195847 */     GIR_EraseRootFromParent_Done,
     /* 195848 */   // Label 3664: @195848
     /* 195848 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(195893), // Rule ID 2353 //
     /* 195853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 195856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 195861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195882 */     // (intrinsic_wo_chain:{ *:[v4f32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 195882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 195885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195891 */     GIR_RootConstrainSelectedInstOperands,
     /* 195892 */     // GIR_Coverage, 2353,
     /* 195892 */     GIR_EraseRootFromParent_Done,
     /* 195893 */   // Label 3665: @195893
     /* 195893 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(195938), // Rule ID 2356 //
     /* 195898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 195901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 195906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195927 */     // (intrinsic_wo_chain:{ *:[v2f64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 195927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 195930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195936 */     GIR_RootConstrainSelectedInstOperands,
     /* 195937 */     // GIR_Coverage, 2356,
     /* 195937 */     GIR_EraseRootFromParent_Done,
     /* 195938 */   // Label 3666: @195938
     /* 195938 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(195983), // Rule ID 2359 //
     /* 195943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 195946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 195951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195972 */     // (intrinsic_wo_chain:{ *:[v4f16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 195972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 195975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195981 */     GIR_RootConstrainSelectedInstOperands,
     /* 195982 */     // GIR_Coverage, 2359,
     /* 195982 */     GIR_EraseRootFromParent_Done,
     /* 195983 */   // Label 3667: @195983
     /* 195983 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(196028), // Rule ID 2362 //
     /* 195988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 195991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 195996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196017 */     // (intrinsic_wo_chain:{ *:[v8f16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 196017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 196020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196026 */     GIR_RootConstrainSelectedInstOperands,
     /* 196027 */     // GIR_Coverage, 2362,
     /* 196027 */     GIR_EraseRootFromParent_Done,
     /* 196028 */   // Label 3668: @196028
     /* 196028 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(196073), // Rule ID 2365 //
     /* 196033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 196036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 196041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196062 */     // (intrinsic_wo_chain:{ *:[v2f32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 196062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 196065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196071 */     GIR_RootConstrainSelectedInstOperands,
     /* 196072 */     // GIR_Coverage, 2365,
     /* 196072 */     GIR_EraseRootFromParent_Done,
     /* 196073 */   // Label 3669: @196073
     /* 196073 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(196118), // Rule ID 2368 //
     /* 196078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 196081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 196086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196107 */     // (intrinsic_wo_chain:{ *:[v4f32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 196107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 196110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196116 */     GIR_RootConstrainSelectedInstOperands,
     /* 196117 */     // GIR_Coverage, 2368,
     /* 196117 */     GIR_EraseRootFromParent_Done,
     /* 196118 */   // Label 3670: @196118
     /* 196118 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(196163), // Rule ID 2371 //
     /* 196123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 196126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 196131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196152 */     // (intrinsic_wo_chain:{ *:[v2f64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 196152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 196155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196161 */     GIR_RootConstrainSelectedInstOperands,
     /* 196162 */     // GIR_Coverage, 2371,
     /* 196162 */     GIR_EraseRootFromParent_Done,
     /* 196163 */   // Label 3671: @196163
     /* 196163 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(196208), // Rule ID 2501 //
     /* 196168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 196176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196197 */     // (intrinsic_wo_chain:{ *:[i64] } 686:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 196197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 196200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196206 */     GIR_RootConstrainSelectedInstOperands,
     /* 196207 */     // GIR_Coverage, 2501,
     /* 196207 */     GIR_EraseRootFromParent_Done,
     /* 196208 */   // Label 3672: @196208
     /* 196208 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(196253), // Rule ID 2502 //
     /* 196213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 196221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196242 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 196242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 196245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196251 */     GIR_RootConstrainSelectedInstOperands,
     /* 196252 */     // GIR_Coverage, 2502,
     /* 196252 */     GIR_EraseRootFromParent_Done,
     /* 196253 */   // Label 3673: @196253
     /* 196253 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(196298), // Rule ID 2503 //
     /* 196258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 196266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196287 */     // (intrinsic_wo_chain:{ *:[v1f64] } 792:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 196287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 196290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196296 */     GIR_RootConstrainSelectedInstOperands,
     /* 196297 */     // GIR_Coverage, 2503,
     /* 196297 */     GIR_EraseRootFromParent_Done,
     /* 196298 */   // Label 3674: @196298
     /* 196298 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(196343), // Rule ID 2504 //
     /* 196303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 196311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196332 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 196332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 196335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196341 */     GIR_RootConstrainSelectedInstOperands,
     /* 196342 */     // GIR_Coverage, 2504,
     /* 196342 */     GIR_EraseRootFromParent_Done,
     /* 196343 */   // Label 3675: @196343
     /* 196343 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(196388), // Rule ID 2509 //
     /* 196348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 196356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196377 */     // (intrinsic_wo_chain:{ *:[v1i64] } 722:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 196377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 196380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196386 */     GIR_RootConstrainSelectedInstOperands,
     /* 196387 */     // GIR_Coverage, 2509,
     /* 196387 */     GIR_EraseRootFromParent_Done,
     /* 196388 */   // Label 3676: @196388
     /* 196388 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(196433), // Rule ID 2627 //
     /* 196393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 196401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 196410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196422 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 196422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 196425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196431 */     GIR_RootConstrainSelectedInstOperands,
     /* 196432 */     // GIR_Coverage, 2627,
     /* 196432 */     GIR_EraseRootFromParent_Done,
     /* 196433 */   // Label 3677: @196433
     /* 196433 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(196478), // Rule ID 2628 //
     /* 196438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 196446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 196455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196467 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 196467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 196470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196476 */     GIR_RootConstrainSelectedInstOperands,
     /* 196477 */     // GIR_Coverage, 2628,
     /* 196477 */     GIR_EraseRootFromParent_Done,
     /* 196478 */   // Label 3678: @196478
     /* 196478 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(196523), // Rule ID 2629 //
     /* 196483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 196491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 196500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196512 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 196512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 196515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196521 */     GIR_RootConstrainSelectedInstOperands,
     /* 196522 */     // GIR_Coverage, 2629,
     /* 196522 */     GIR_EraseRootFromParent_Done,
     /* 196523 */   // Label 3679: @196523
     /* 196523 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(196568), // Rule ID 2630 //
     /* 196528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 196536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 196545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196557 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 196557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 196560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196566 */     GIR_RootConstrainSelectedInstOperands,
     /* 196567 */     // GIR_Coverage, 2630,
     /* 196567 */     GIR_EraseRootFromParent_Done,
     /* 196568 */   // Label 3680: @196568
     /* 196568 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(196613), // Rule ID 2631 //
     /* 196573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 196581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 196590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196602 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 196602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 196605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196611 */     GIR_RootConstrainSelectedInstOperands,
     /* 196612 */     // GIR_Coverage, 2631,
     /* 196612 */     GIR_EraseRootFromParent_Done,
     /* 196613 */   // Label 3681: @196613
     /* 196613 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(196658), // Rule ID 2632 //
     /* 196618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 196626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 196635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196647 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 196647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 196650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196656 */     GIR_RootConstrainSelectedInstOperands,
     /* 196657 */     // GIR_Coverage, 2632,
     /* 196657 */     GIR_EraseRootFromParent_Done,
     /* 196658 */   // Label 3682: @196658
     /* 196658 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(196703), // Rule ID 2633 //
     /* 196663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 196671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 196680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196692 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 196692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 196695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196701 */     GIR_RootConstrainSelectedInstOperands,
     /* 196702 */     // GIR_Coverage, 2633,
     /* 196702 */     GIR_EraseRootFromParent_Done,
     /* 196703 */   // Label 3683: @196703
     /* 196703 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(196748), // Rule ID 2634 //
     /* 196708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 196716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 196725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196737 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 196737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 196740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196746 */     GIR_RootConstrainSelectedInstOperands,
     /* 196747 */     // GIR_Coverage, 2634,
     /* 196747 */     GIR_EraseRootFromParent_Done,
     /* 196748 */   // Label 3684: @196748
     /* 196748 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(196793), // Rule ID 3812 //
     /* 196753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 196756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 196761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196782 */     // (intrinsic_wo_chain:{ *:[v2i64] } 539:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 196782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 196785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 196787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 196789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 196791 */     GIR_RootConstrainSelectedInstOperands,
     /* 196792 */     // GIR_Coverage, 3812,
     /* 196792 */     GIR_EraseRootFromParent_Done,
     /* 196793 */   // Label 3685: @196793
     /* 196793 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(196838), // Rule ID 3840 //
     /* 196798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 196801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 196806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196827 */     // (intrinsic_wo_chain:{ *:[v2i64] } 526:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 196827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 196830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 196834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 196836 */     GIR_RootConstrainSelectedInstOperands,
     /* 196837 */     // GIR_Coverage, 3840,
     /* 196837 */     GIR_EraseRootFromParent_Done,
     /* 196838 */   // Label 3686: @196838
     /* 196838 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(196883), // Rule ID 3850 //
     /* 196843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 196846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 196851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196872 */     // (intrinsic_wo_chain:{ *:[v4i32] } 549:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 196872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 196875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 196879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 196881 */     GIR_RootConstrainSelectedInstOperands,
     /* 196882 */     // GIR_Coverage, 3850,
     /* 196882 */     GIR_EraseRootFromParent_Done,
     /* 196883 */   // Label 3687: @196883
     /* 196883 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(196928), // Rule ID 3851 //
     /* 196888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 196891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 196896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196917 */     // (intrinsic_wo_chain:{ *:[v4i32] } 548:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 196917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 196920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 196922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 196924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 196926 */     GIR_RootConstrainSelectedInstOperands,
     /* 196927 */     // GIR_Coverage, 3851,
     /* 196927 */     GIR_EraseRootFromParent_Done,
     /* 196928 */   // Label 3688: @196928
     /* 196928 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(196976), // Rule ID 3852 //
     /* 196933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 196936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 196941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196962 */     // (intrinsic_wo_chain:{ *:[v4f16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 196962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 196965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196974 */     GIR_RootConstrainSelectedInstOperands,
     /* 196975 */     // GIR_Coverage, 3852,
     /* 196975 */     GIR_EraseRootFromParent_Done,
     /* 196976 */   // Label 3689: @196976
     /* 196976 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(197024), // Rule ID 3853 //
     /* 196981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 196984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 196989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197010 */     // (intrinsic_wo_chain:{ *:[v4f16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 197010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 197013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197022 */     GIR_RootConstrainSelectedInstOperands,
     /* 197023 */     // GIR_Coverage, 3853,
     /* 197023 */     GIR_EraseRootFromParent_Done,
     /* 197024 */   // Label 3690: @197024
     /* 197024 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(197072), // Rule ID 3854 //
     /* 197029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 197032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 197037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197058 */     // (intrinsic_wo_chain:{ *:[v8f16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 197058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 197061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197070 */     GIR_RootConstrainSelectedInstOperands,
     /* 197071 */     // GIR_Coverage, 3854,
     /* 197071 */     GIR_EraseRootFromParent_Done,
     /* 197072 */   // Label 3691: @197072
     /* 197072 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(197120), // Rule ID 3855 //
     /* 197077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 197080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 197085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197106 */     // (intrinsic_wo_chain:{ *:[v8f16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 197106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 197109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197118 */     GIR_RootConstrainSelectedInstOperands,
     /* 197119 */     // GIR_Coverage, 3855,
     /* 197119 */     GIR_EraseRootFromParent_Done,
     /* 197120 */   // Label 3692: @197120
     /* 197120 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(197168), // Rule ID 3856 //
     /* 197125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 197133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197154 */     // (intrinsic_wo_chain:{ *:[v2f32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 197154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 197157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197166 */     GIR_RootConstrainSelectedInstOperands,
     /* 197167 */     // GIR_Coverage, 3856,
     /* 197167 */     GIR_EraseRootFromParent_Done,
     /* 197168 */   // Label 3693: @197168
     /* 197168 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(197216), // Rule ID 3857 //
     /* 197173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 197181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197202 */     // (intrinsic_wo_chain:{ *:[v2f32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 197202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 197205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197214 */     GIR_RootConstrainSelectedInstOperands,
     /* 197215 */     // GIR_Coverage, 3857,
     /* 197215 */     GIR_EraseRootFromParent_Done,
     /* 197216 */   // Label 3694: @197216
     /* 197216 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(197264), // Rule ID 3858 //
     /* 197221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 197229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197250 */     // (intrinsic_wo_chain:{ *:[v4f32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 197250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 197253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197262 */     GIR_RootConstrainSelectedInstOperands,
     /* 197263 */     // GIR_Coverage, 3858,
     /* 197263 */     GIR_EraseRootFromParent_Done,
     /* 197264 */   // Label 3695: @197264
     /* 197264 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(197312), // Rule ID 3859 //
     /* 197269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 197277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197298 */     // (intrinsic_wo_chain:{ *:[v4f32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 197298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 197301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197310 */     GIR_RootConstrainSelectedInstOperands,
     /* 197311 */     // GIR_Coverage, 3859,
     /* 197311 */     GIR_EraseRootFromParent_Done,
     /* 197312 */   // Label 3696: @197312
     /* 197312 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(197360), // Rule ID 3860 //
     /* 197317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 197325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197346 */     // (intrinsic_wo_chain:{ *:[v2f64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 197346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 197349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197358 */     GIR_RootConstrainSelectedInstOperands,
     /* 197359 */     // GIR_Coverage, 3860,
     /* 197359 */     GIR_EraseRootFromParent_Done,
     /* 197360 */   // Label 3697: @197360
     /* 197360 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(197408), // Rule ID 3861 //
     /* 197365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 197373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197394 */     // (intrinsic_wo_chain:{ *:[v2f64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 197394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 197397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197406 */     GIR_RootConstrainSelectedInstOperands,
     /* 197407 */     // GIR_Coverage, 3861,
     /* 197407 */     GIR_EraseRootFromParent_Done,
     /* 197408 */   // Label 3698: @197408
     /* 197408 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(197450), // Rule ID 3926 //
     /* 197413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 197418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197439 */     // (intrinsic_wo_chain:{ *:[i32] } 2176:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 197439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 197442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197448 */     GIR_RootConstrainSelectedInstOperands,
     /* 197449 */     // GIR_Coverage, 3926,
     /* 197449 */     GIR_EraseRootFromParent_Done,
     /* 197450 */   // Label 3699: @197450
     /* 197450 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(197492), // Rule ID 3927 //
     /* 197455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 197460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197481 */     // (intrinsic_wo_chain:{ *:[i64] } 2176:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 197481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 197484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197490 */     GIR_RootConstrainSelectedInstOperands,
     /* 197491 */     // GIR_Coverage, 3927,
     /* 197491 */     GIR_EraseRootFromParent_Done,
     /* 197492 */   // Label 3700: @197492
     /* 197492 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(197534), // Rule ID 3928 //
     /* 197497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 197502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197523 */     // (intrinsic_wo_chain:{ *:[i32] } 786:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 197523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 197526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197532 */     GIR_RootConstrainSelectedInstOperands,
     /* 197533 */     // GIR_Coverage, 3928,
     /* 197533 */     GIR_EraseRootFromParent_Done,
     /* 197534 */   // Label 3701: @197534
     /* 197534 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(197576), // Rule ID 3929 //
     /* 197539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 197544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197565 */     // (intrinsic_wo_chain:{ *:[i64] } 786:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 197565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 197568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197574 */     GIR_RootConstrainSelectedInstOperands,
     /* 197575 */     // GIR_Coverage, 3929,
     /* 197575 */     GIR_EraseRootFromParent_Done,
     /* 197576 */   // Label 3702: @197576
     /* 197576 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(197618), // Rule ID 5219 //
     /* 197581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 197586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197607 */     // (intrinsic_wo_chain:{ *:[v1f64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 197610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197616 */     GIR_RootConstrainSelectedInstOperands,
     /* 197617 */     // GIR_Coverage, 5219,
     /* 197617 */     GIR_EraseRootFromParent_Done,
     /* 197618 */   // Label 3703: @197618
     /* 197618 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(197663), // Rule ID 5223 //
     /* 197623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 197631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197652 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 197655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197661 */     GIR_RootConstrainSelectedInstOperands,
     /* 197662 */     // GIR_Coverage, 5223,
     /* 197662 */     GIR_EraseRootFromParent_Done,
     /* 197663 */   // Label 3704: @197663
     /* 197663 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(197708), // Rule ID 5227 //
     /* 197668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 197676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197697 */     // (intrinsic_wo_chain:{ *:[v1f64] } 617:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 197700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197706 */     GIR_RootConstrainSelectedInstOperands,
     /* 197707 */     // GIR_Coverage, 5227,
     /* 197707 */     GIR_EraseRootFromParent_Done,
     /* 197708 */   // Label 3705: @197708
     /* 197708 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(197753), // Rule ID 5228 //
     /* 197713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 197721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197742 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 197745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197751 */     GIR_RootConstrainSelectedInstOperands,
     /* 197752 */     // GIR_Coverage, 5228,
     /* 197752 */     GIR_EraseRootFromParent_Done,
     /* 197753 */   // Label 3706: @197753
     /* 197753 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(197798), // Rule ID 5229 //
     /* 197758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 197766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197787 */     // (intrinsic_wo_chain:{ *:[v1f64] } 647:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 197790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197796 */     GIR_RootConstrainSelectedInstOperands,
     /* 197797 */     // GIR_Coverage, 5229,
     /* 197797 */     GIR_EraseRootFromParent_Done,
     /* 197798 */   // Label 3707: @197798
     /* 197798 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(197843), // Rule ID 5230 //
     /* 197803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 197811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197832 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 197832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 197835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197841 */     GIR_RootConstrainSelectedInstOperands,
     /* 197842 */     // GIR_Coverage, 5230,
     /* 197842 */     GIR_EraseRootFromParent_Done,
     /* 197843 */   // Label 3708: @197843
     /* 197843 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(197888), // Rule ID 5231 //
     /* 197848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 197856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197877 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 197877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 197880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197886 */     GIR_RootConstrainSelectedInstOperands,
     /* 197887 */     // GIR_Coverage, 5231,
     /* 197887 */     GIR_EraseRootFromParent_Done,
     /* 197888 */   // Label 3709: @197888
     /* 197888 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(197933), // Rule ID 5232 //
     /* 197893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 197901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197922 */     // (intrinsic_wo_chain:{ *:[i64] } 701:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 197922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 197925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197931 */     GIR_RootConstrainSelectedInstOperands,
     /* 197932 */     // GIR_Coverage, 5232,
     /* 197932 */     GIR_EraseRootFromParent_Done,
     /* 197933 */   // Label 3710: @197933
     /* 197933 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(197978), // Rule ID 5233 //
     /* 197938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 197946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197967 */     // (intrinsic_wo_chain:{ *:[i32] } 701:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 197967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 197970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197976 */     GIR_RootConstrainSelectedInstOperands,
     /* 197977 */     // GIR_Coverage, 5233,
     /* 197977 */     GIR_EraseRootFromParent_Done,
     /* 197978 */   // Label 3711: @197978
     /* 197978 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(198023), // Rule ID 5234 //
     /* 197983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 197991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198012 */     // (intrinsic_wo_chain:{ *:[i64] } 705:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 198015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198021 */     GIR_RootConstrainSelectedInstOperands,
     /* 198022 */     // GIR_Coverage, 5234,
     /* 198022 */     GIR_EraseRootFromParent_Done,
     /* 198023 */   // Label 3712: @198023
     /* 198023 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(198068), // Rule ID 5235 //
     /* 198028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 198036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198057 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 198060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198066 */     GIR_RootConstrainSelectedInstOperands,
     /* 198067 */     // GIR_Coverage, 5235,
     /* 198067 */     GIR_EraseRootFromParent_Done,
     /* 198068 */   // Label 3713: @198068
     /* 198068 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(198113), // Rule ID 5236 //
     /* 198073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 198081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198102 */     // (intrinsic_wo_chain:{ *:[i64] } 746:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 198105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198111 */     GIR_RootConstrainSelectedInstOperands,
     /* 198112 */     // GIR_Coverage, 5236,
     /* 198112 */     GIR_EraseRootFromParent_Done,
     /* 198113 */   // Label 3714: @198113
     /* 198113 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(198158), // Rule ID 5237 //
     /* 198118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 198126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198147 */     // (intrinsic_wo_chain:{ *:[i32] } 746:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 198150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198156 */     GIR_RootConstrainSelectedInstOperands,
     /* 198157 */     // GIR_Coverage, 5237,
     /* 198157 */     GIR_EraseRootFromParent_Done,
     /* 198158 */   // Label 3715: @198158
     /* 198158 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(198203), // Rule ID 5238 //
     /* 198163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 198171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198192 */     // (intrinsic_wo_chain:{ *:[i64] } 747:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 198195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198201 */     GIR_RootConstrainSelectedInstOperands,
     /* 198202 */     // GIR_Coverage, 5238,
     /* 198202 */     GIR_EraseRootFromParent_Done,
     /* 198203 */   // Label 3716: @198203
     /* 198203 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(198248), // Rule ID 5239 //
     /* 198208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 198216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198237 */     // (intrinsic_wo_chain:{ *:[i32] } 747:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 198240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198246 */     GIR_RootConstrainSelectedInstOperands,
     /* 198247 */     // GIR_Coverage, 5239,
     /* 198247 */     GIR_EraseRootFromParent_Done,
     /* 198248 */   // Label 3717: @198248
     /* 198248 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(198293), // Rule ID 5240 //
     /* 198253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 198261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198282 */     // (intrinsic_wo_chain:{ *:[i64] } 749:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 198285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198291 */     GIR_RootConstrainSelectedInstOperands,
     /* 198292 */     // GIR_Coverage, 5240,
     /* 198292 */     GIR_EraseRootFromParent_Done,
     /* 198293 */   // Label 3718: @198293
     /* 198293 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(198338), // Rule ID 5241 //
     /* 198298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 198306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198327 */     // (intrinsic_wo_chain:{ *:[i32] } 749:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 198330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198336 */     GIR_RootConstrainSelectedInstOperands,
     /* 198337 */     // GIR_Coverage, 5241,
     /* 198337 */     GIR_EraseRootFromParent_Done,
     /* 198338 */   // Label 3719: @198338
     /* 198338 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(198383), // Rule ID 5242 //
     /* 198343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 198351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198372 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 198375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198381 */     GIR_RootConstrainSelectedInstOperands,
     /* 198382 */     // GIR_Coverage, 5242,
     /* 198382 */     GIR_EraseRootFromParent_Done,
     /* 198383 */   // Label 3720: @198383
     /* 198383 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(198428), // Rule ID 5243 //
     /* 198388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 198396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198417 */     // (intrinsic_wo_chain:{ *:[i32] } 751:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 198420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198426 */     GIR_RootConstrainSelectedInstOperands,
     /* 198427 */     // GIR_Coverage, 5243,
     /* 198427 */     GIR_EraseRootFromParent_Done,
     /* 198428 */   // Label 3721: @198428
     /* 198428 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(198473), // Rule ID 5262 //
     /* 198433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 198441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198462 */     // (intrinsic_wo_chain:{ *:[v1i64] } 761:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 198462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 198465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198471 */     GIR_RootConstrainSelectedInstOperands,
     /* 198472 */     // GIR_Coverage, 5262,
     /* 198472 */     GIR_EraseRootFromParent_Done,
     /* 198473 */   // Label 3722: @198473
     /* 198473 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(198515), // Rule ID 5596 //
     /* 198478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 198483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 198486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 198489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 198492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198504 */     // (intrinsic_wo_chain:{ *:[v8i8] } 723:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 198504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 198507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 198513 */     GIR_RootConstrainSelectedInstOperands,
     /* 198514 */     // GIR_Coverage, 5596,
     /* 198514 */     GIR_EraseRootFromParent_Done,
     /* 198515 */   // Label 3723: @198515
     /* 198515 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(198557), // Rule ID 5597 //
     /* 198520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 198525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 198528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 198531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 198534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198546 */     // (intrinsic_wo_chain:{ *:[v16i8] } 723:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 198546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 198549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 198553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198555 */     GIR_RootConstrainSelectedInstOperands,
     /* 198556 */     // GIR_Coverage, 5597,
     /* 198556 */     GIR_EraseRootFromParent_Done,
     /* 198557 */   // Label 3724: @198557
     /* 198557 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(198654), // Rule ID 6324 //
     /* 198562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 198567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 198573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 198576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198588 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 198588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 198591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 198595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198600 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 198604 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 198608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 198610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 198613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 198624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 198635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 198638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198653 */     // GIR_Coverage, 6324,
     /* 198653 */     GIR_EraseRootFromParent_Done,
     /* 198654 */   // Label 3725: @198654
     /* 198654 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(198751), // Rule ID 6325 //
     /* 198659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 198664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 198670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 198673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198685 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 198685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 198688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 198692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198697 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 198701 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 198705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 198707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 198710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 198721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 198732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 198735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198750 */     // GIR_Coverage, 6325,
     /* 198750 */     GIR_EraseRootFromParent_Done,
     /* 198751 */   // Label 3726: @198751
     /* 198751 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(198793), // Rule ID 6972 //
     /* 198756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 198761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198782 */     // (intrinsic_wo_chain:{ *:[i64] } 710:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 198785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198791 */     GIR_RootConstrainSelectedInstOperands,
     /* 198792 */     // GIR_Coverage, 6972,
     /* 198792 */     GIR_EraseRootFromParent_Done,
     /* 198793 */   // Label 3727: @198793
     /* 198793 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(198835), // Rule ID 6973 //
     /* 198798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 198803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198824 */     // (intrinsic_wo_chain:{ *:[i64] } 758:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 198827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198833 */     GIR_RootConstrainSelectedInstOperands,
     /* 198834 */     // GIR_Coverage, 6973,
     /* 198834 */     GIR_EraseRootFromParent_Done,
     /* 198835 */   // Label 3728: @198835
     /* 198835 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(198877), // Rule ID 6974 //
     /* 198840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 198845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198866 */     // (intrinsic_wo_chain:{ *:[i64] } 709:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 198869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198875 */     GIR_RootConstrainSelectedInstOperands,
     /* 198876 */     // GIR_Coverage, 6974,
     /* 198876 */     GIR_EraseRootFromParent_Done,
     /* 198877 */   // Label 3729: @198877
     /* 198877 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(198919), // Rule ID 6975 //
     /* 198882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 198887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198908 */     // (intrinsic_wo_chain:{ *:[i64] } 755:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 198911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198917 */     GIR_RootConstrainSelectedInstOperands,
     /* 198918 */     // GIR_Coverage, 6975,
     /* 198918 */     GIR_EraseRootFromParent_Done,
     /* 198919 */   // Label 3730: @198919
     /* 198919 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(198967), // Rule ID 7015 //
     /* 198924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 198929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198950 */     // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 198950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 198953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 198962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 198965 */     GIR_RootConstrainSelectedInstOperands,
     /* 198966 */     // GIR_Coverage, 7015,
     /* 198966 */     GIR_EraseRootFromParent_Done,
     /* 198967 */   // Label 3731: @198967
     /* 198967 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(199012), // Rule ID 10073 //
     /* 198972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 198980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 198989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199001 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 199004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199010 */     GIR_RootConstrainSelectedInstOperands,
     /* 199011 */     // GIR_Coverage, 10073,
     /* 199011 */     GIR_EraseRootFromParent_Done,
     /* 199012 */   // Label 3732: @199012
     /* 199012 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(199057), // Rule ID 10074 //
     /* 199017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 199025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 199034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199046 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 199049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199055 */     GIR_RootConstrainSelectedInstOperands,
     /* 199056 */     // GIR_Coverage, 10074,
     /* 199056 */     GIR_EraseRootFromParent_Done,
     /* 199057 */   // Label 3733: @199057
     /* 199057 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(199102), // Rule ID 10075 //
     /* 199062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 199070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 199079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199091 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 199094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199100 */     GIR_RootConstrainSelectedInstOperands,
     /* 199101 */     // GIR_Coverage, 10075,
     /* 199101 */     GIR_EraseRootFromParent_Done,
     /* 199102 */   // Label 3734: @199102
     /* 199102 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(199147), // Rule ID 10076 //
     /* 199107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 199115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 199124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199136 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 199139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199145 */     GIR_RootConstrainSelectedInstOperands,
     /* 199146 */     // GIR_Coverage, 10076,
     /* 199146 */     GIR_EraseRootFromParent_Done,
     /* 199147 */   // Label 3735: @199147
     /* 199147 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(199192), // Rule ID 10085 //
     /* 199152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 199160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199181 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 199184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199190 */     GIR_RootConstrainSelectedInstOperands,
     /* 199191 */     // GIR_Coverage, 10085,
     /* 199191 */     GIR_EraseRootFromParent_Done,
     /* 199192 */   // Label 3736: @199192
     /* 199192 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(199237), // Rule ID 10086 //
     /* 199197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 199205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 199214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199226 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 199229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199235 */     GIR_RootConstrainSelectedInstOperands,
     /* 199236 */     // GIR_Coverage, 10086,
     /* 199236 */     GIR_EraseRootFromParent_Done,
     /* 199237 */   // Label 3737: @199237
     /* 199237 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(199282), // Rule ID 10087 //
     /* 199242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 199250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 199259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199271 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 199274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199280 */     GIR_RootConstrainSelectedInstOperands,
     /* 199281 */     // GIR_Coverage, 10087,
     /* 199281 */     GIR_EraseRootFromParent_Done,
     /* 199282 */   // Label 3738: @199282
     /* 199282 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(199327), // Rule ID 10088 //
     /* 199287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 199295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 199304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199316 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 199319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199325 */     GIR_RootConstrainSelectedInstOperands,
     /* 199326 */     // GIR_Coverage, 10088,
     /* 199326 */     GIR_EraseRootFromParent_Done,
     /* 199327 */   // Label 3739: @199327
     /* 199327 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(199372), // Rule ID 10089 //
     /* 199332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 199340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199361 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 199361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 199364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199370 */     GIR_RootConstrainSelectedInstOperands,
     /* 199371 */     // GIR_Coverage, 10089,
     /* 199371 */     GIR_EraseRootFromParent_Done,
     /* 199372 */   // Label 3740: @199372
     /* 199372 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(199417), // Rule ID 10090 //
     /* 199377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 199385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 199394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199406 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 199406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 199409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199415 */     GIR_RootConstrainSelectedInstOperands,
     /* 199416 */     // GIR_Coverage, 10090,
     /* 199416 */     GIR_EraseRootFromParent_Done,
     /* 199417 */   // Label 3741: @199417
     /* 199417 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(199462), // Rule ID 10091 //
     /* 199422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 199430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 199439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199451 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 199451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 199454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199460 */     GIR_RootConstrainSelectedInstOperands,
     /* 199461 */     // GIR_Coverage, 10091,
     /* 199461 */     GIR_EraseRootFromParent_Done,
     /* 199462 */   // Label 3742: @199462
     /* 199462 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(199507), // Rule ID 10092 //
     /* 199467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 199475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 199484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199496 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 199496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 199499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199505 */     GIR_RootConstrainSelectedInstOperands,
     /* 199506 */     // GIR_Coverage, 10092,
     /* 199506 */     GIR_EraseRootFromParent_Done,
     /* 199507 */   // Label 3743: @199507
     /* 199507 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(199552), // Rule ID 10093 //
     /* 199512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 199520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199541 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 199544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199550 */     GIR_RootConstrainSelectedInstOperands,
     /* 199551 */     // GIR_Coverage, 10093,
     /* 199551 */     GIR_EraseRootFromParent_Done,
     /* 199552 */   // Label 3744: @199552
     /* 199552 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(199597), // Rule ID 10094 //
     /* 199557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 199565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 199574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199586 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 199589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199595 */     GIR_RootConstrainSelectedInstOperands,
     /* 199596 */     // GIR_Coverage, 10094,
     /* 199596 */     GIR_EraseRootFromParent_Done,
     /* 199597 */   // Label 3745: @199597
     /* 199597 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(199642), // Rule ID 10095 //
     /* 199602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 199610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 199619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199631 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 199634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199640 */     GIR_RootConstrainSelectedInstOperands,
     /* 199641 */     // GIR_Coverage, 10095,
     /* 199641 */     GIR_EraseRootFromParent_Done,
     /* 199642 */   // Label 3746: @199642
     /* 199642 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(199687), // Rule ID 10096 //
     /* 199647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 199655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 199664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199676 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 199679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199685 */     GIR_RootConstrainSelectedInstOperands,
     /* 199686 */     // GIR_Coverage, 10096,
     /* 199686 */     GIR_EraseRootFromParent_Done,
     /* 199687 */   // Label 3747: @199687
     /* 199687 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(199733), // Rule ID 138 //
     /* 199692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 199695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 199700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199710 */     // MIs[0] Rn
     /* 199710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 199714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 199718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199722 */     // (intrinsic_wo_chain:{ *:[i64] } 562:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 199722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 199725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199731 */     GIR_RootConstrainSelectedInstOperands,
     /* 199732 */     // GIR_Coverage, 138,
     /* 199732 */     GIR_EraseRootFromParent_Done,
     /* 199733 */   // Label 3748: @199733
     /* 199733 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(199780), // Rule ID 139 //
     /* 199738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 199741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 199746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199753 */     // MIs[0] Rn
     /* 199753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 199757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 199761 */     // MIs[0] Rm
     /* 199761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 199765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 199769 */     // (intrinsic_wo_chain:{ *:[i64] } 1249:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 199769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 199772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199778 */     GIR_RootConstrainSelectedInstOperands,
     /* 199779 */     // GIR_Coverage, 139,
     /* 199779 */     GIR_EraseRootFromParent_Done,
     /* 199780 */   // Label 3749: @199780
     /* 199780 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(199817), // Rule ID 2399 //
     /* 199785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 199793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 199796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199806 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 199806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 199809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 199813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 199815 */     GIR_RootConstrainSelectedInstOperands,
     /* 199816 */     // GIR_Coverage, 2399,
     /* 199816 */     GIR_EraseRootFromParent_Done,
     /* 199817 */   // Label 3750: @199817
     /* 199817 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(199854), // Rule ID 2400 //
     /* 199822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 199830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 199833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199843 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2159:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 199843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 199846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 199850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 199852 */     GIR_RootConstrainSelectedInstOperands,
     /* 199853 */     // GIR_Coverage, 2400,
     /* 199853 */     GIR_EraseRootFromParent_Done,
     /* 199854 */   // Label 3751: @199854
     /* 199854 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(199891), // Rule ID 2401 //
     /* 199859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 199867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 199870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199880 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2160:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 199880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 199883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 199887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 199889 */     GIR_RootConstrainSelectedInstOperands,
     /* 199890 */     // GIR_Coverage, 2401,
     /* 199890 */     GIR_EraseRootFromParent_Done,
     /* 199891 */   // Label 3752: @199891
     /* 199891 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(199928), // Rule ID 2403 //
     /* 199896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 199904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 199907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199917 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2163:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 199917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 199920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 199924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 199926 */     GIR_RootConstrainSelectedInstOperands,
     /* 199927 */     // GIR_Coverage, 2403,
     /* 199927 */     GIR_EraseRootFromParent_Done,
     /* 199928 */   // Label 3753: @199928
     /* 199928 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(199965), // Rule ID 2404 //
     /* 199933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 199941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 199944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199954 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2164:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 199954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 199957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 199961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 199963 */     GIR_RootConstrainSelectedInstOperands,
     /* 199964 */     // GIR_Coverage, 2404,
     /* 199964 */     GIR_EraseRootFromParent_Done,
     /* 199965 */   // Label 3754: @199965
     /* 199965 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(200002), // Rule ID 2405 //
     /* 199970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 199978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 199981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199991 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2165:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 199991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 199994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 199998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200000 */     GIR_RootConstrainSelectedInstOperands,
     /* 200001 */     // GIR_Coverage, 2405,
     /* 200001 */     GIR_EraseRootFromParent_Done,
     /* 200002 */   // Label 3755: @200002
     /* 200002 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(200039), // Rule ID 2407 //
     /* 200007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 200015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200028 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2084:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 200031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200037 */     GIR_RootConstrainSelectedInstOperands,
     /* 200038 */     // GIR_Coverage, 2407,
     /* 200038 */     GIR_EraseRootFromParent_Done,
     /* 200039 */   // Label 3756: @200039
     /* 200039 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(200076), // Rule ID 2408 //
     /* 200044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 200052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200065 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2085:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 200068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200074 */     GIR_RootConstrainSelectedInstOperands,
     /* 200075 */     // GIR_Coverage, 2408,
     /* 200075 */     GIR_EraseRootFromParent_Done,
     /* 200076 */   // Label 3757: @200076
     /* 200076 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(200113), // Rule ID 2409 //
     /* 200081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 200089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200102 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2086:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 200105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200111 */     GIR_RootConstrainSelectedInstOperands,
     /* 200112 */     // GIR_Coverage, 2409,
     /* 200112 */     GIR_EraseRootFromParent_Done,
     /* 200113 */   // Label 3758: @200113
     /* 200113 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(200150), // Rule ID 2411 //
     /* 200118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 200126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200139 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2089:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 200142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200148 */     GIR_RootConstrainSelectedInstOperands,
     /* 200149 */     // GIR_Coverage, 2411,
     /* 200149 */     GIR_EraseRootFromParent_Done,
     /* 200150 */   // Label 3759: @200150
     /* 200150 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(200187), // Rule ID 2412 //
     /* 200155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 200163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200176 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 200179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200185 */     GIR_RootConstrainSelectedInstOperands,
     /* 200186 */     // GIR_Coverage, 2412,
     /* 200186 */     GIR_EraseRootFromParent_Done,
     /* 200187 */   // Label 3760: @200187
     /* 200187 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(200224), // Rule ID 2413 //
     /* 200192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 200200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200213 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2091:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 200216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200222 */     GIR_RootConstrainSelectedInstOperands,
     /* 200223 */     // GIR_Coverage, 2413,
     /* 200223 */     GIR_EraseRootFromParent_Done,
     /* 200224 */   // Label 3761: @200224
     /* 200224 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(200261), // Rule ID 2415 //
     /* 200229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 200237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200250 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1928:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 200253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200259 */     GIR_RootConstrainSelectedInstOperands,
     /* 200260 */     // GIR_Coverage, 2415,
     /* 200260 */     GIR_EraseRootFromParent_Done,
     /* 200261 */   // Label 3762: @200261
     /* 200261 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(200298), // Rule ID 2416 //
     /* 200266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 200274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200287 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1929:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 200290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200296 */     GIR_RootConstrainSelectedInstOperands,
     /* 200297 */     // GIR_Coverage, 2416,
     /* 200297 */     GIR_EraseRootFromParent_Done,
     /* 200298 */   // Label 3763: @200298
     /* 200298 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(200335), // Rule ID 2417 //
     /* 200303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 200311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200324 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1930:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 200327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200333 */     GIR_RootConstrainSelectedInstOperands,
     /* 200334 */     // GIR_Coverage, 2417,
     /* 200334 */     GIR_EraseRootFromParent_Done,
     /* 200335 */   // Label 3764: @200335
     /* 200335 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(200372), // Rule ID 2419 //
     /* 200340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 200348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200361 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 200364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200370 */     GIR_RootConstrainSelectedInstOperands,
     /* 200371 */     // GIR_Coverage, 2419,
     /* 200371 */     GIR_EraseRootFromParent_Done,
     /* 200372 */   // Label 3765: @200372
     /* 200372 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(200409), // Rule ID 2420 //
     /* 200377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 200385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200398 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1934:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 200401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200407 */     GIR_RootConstrainSelectedInstOperands,
     /* 200408 */     // GIR_Coverage, 2420,
     /* 200408 */     GIR_EraseRootFromParent_Done,
     /* 200409 */   // Label 3766: @200409
     /* 200409 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(200446), // Rule ID 2421 //
     /* 200414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 200422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200435 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1935:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 200438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200444 */     GIR_RootConstrainSelectedInstOperands,
     /* 200445 */     // GIR_Coverage, 2421,
     /* 200445 */     GIR_EraseRootFromParent_Done,
     /* 200446 */   // Label 3767: @200446
     /* 200446 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(200483), // Rule ID 2422 //
     /* 200451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 200454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 200459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 200462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 200465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 200468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200472 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1553:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 200472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 200475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 200479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 200481 */     GIR_RootConstrainSelectedInstOperands,
     /* 200482 */     // GIR_Coverage, 2422,
     /* 200482 */     GIR_EraseRootFromParent_Done,
     /* 200483 */   // Label 3768: @200483
     /* 200483 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(200523), // Rule ID 2614 //
     /* 200488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 200496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200509 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1632:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 200509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 200512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 200514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200521 */     GIR_RootConstrainSelectedInstOperands,
     /* 200522 */     // GIR_Coverage, 2614,
     /* 200522 */     GIR_EraseRootFromParent_Done,
     /* 200523 */   // Label 3769: @200523
     /* 200523 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(200563), // Rule ID 2615 //
     /* 200528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 200536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200549 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1640:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 200549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 200552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 200554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200561 */     GIR_RootConstrainSelectedInstOperands,
     /* 200562 */     // GIR_Coverage, 2615,
     /* 200562 */     GIR_EraseRootFromParent_Done,
     /* 200563 */   // Label 3770: @200563
     /* 200563 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(200603), // Rule ID 2616 //
     /* 200568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 200576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 200579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200589 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1640:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 200589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 200592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 200594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200601 */     GIR_RootConstrainSelectedInstOperands,
     /* 200602 */     // GIR_Coverage, 2616,
     /* 200602 */     GIR_EraseRootFromParent_Done,
     /* 200603 */   // Label 3771: @200603
     /* 200603 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(200643), // Rule ID 2617 //
     /* 200608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 200616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 200619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200629 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1640:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 200629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 200632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 200634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200641 */     GIR_RootConstrainSelectedInstOperands,
     /* 200642 */     // GIR_Coverage, 2617,
     /* 200642 */     GIR_EraseRootFromParent_Done,
     /* 200643 */   // Label 3772: @200643
     /* 200643 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(200683), // Rule ID 2618 //
     /* 200648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 200656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 200659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200669 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1640:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 200669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 200672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 200674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200681 */     GIR_RootConstrainSelectedInstOperands,
     /* 200682 */     // GIR_Coverage, 2618,
     /* 200682 */     GIR_EraseRootFromParent_Done,
     /* 200683 */   // Label 3773: @200683
     /* 200683 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(200720), // Rule ID 2635 //
     /* 200688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 200696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200709 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 200709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 200712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200718 */     GIR_RootConstrainSelectedInstOperands,
     /* 200719 */     // GIR_Coverage, 2635,
     /* 200719 */     GIR_EraseRootFromParent_Done,
     /* 200720 */   // Label 3774: @200720
     /* 200720 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(200757), // Rule ID 2636 //
     /* 200725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 200733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 200739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1820:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 200746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 200749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200755 */     GIR_RootConstrainSelectedInstOperands,
     /* 200756 */     // GIR_Coverage, 2636,
     /* 200756 */     GIR_EraseRootFromParent_Done,
     /* 200757 */   // Label 3775: @200757
     /* 200757 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(200794), // Rule ID 2637 //
     /* 200762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 200770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 200776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200783 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1820:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 200783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 200786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200792 */     GIR_RootConstrainSelectedInstOperands,
     /* 200793 */     // GIR_Coverage, 2637,
     /* 200793 */     GIR_EraseRootFromParent_Done,
     /* 200794 */   // Label 3776: @200794
     /* 200794 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(200831), // Rule ID 2638 //
     /* 200799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 200807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200820 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 200820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 200823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200829 */     GIR_RootConstrainSelectedInstOperands,
     /* 200830 */     // GIR_Coverage, 2638,
     /* 200830 */     GIR_EraseRootFromParent_Done,
     /* 200831 */   // Label 3777: @200831
     /* 200831 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(200868), // Rule ID 2639 //
     /* 200836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 200844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200857 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 200857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 200860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200866 */     GIR_RootConstrainSelectedInstOperands,
     /* 200867 */     // GIR_Coverage, 2639,
     /* 200867 */     GIR_EraseRootFromParent_Done,
     /* 200868 */   // Label 3778: @200868
     /* 200868 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(200905), // Rule ID 2640 //
     /* 200873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 200881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200894 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 200894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 200897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200903 */     GIR_RootConstrainSelectedInstOperands,
     /* 200904 */     // GIR_Coverage, 2640,
     /* 200904 */     GIR_EraseRootFromParent_Done,
     /* 200905 */   // Label 3779: @200905
     /* 200905 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(200942), // Rule ID 2641 //
     /* 200910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 200918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200931 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 200931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 200934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200940 */     GIR_RootConstrainSelectedInstOperands,
     /* 200941 */     // GIR_Coverage, 2641,
     /* 200941 */     GIR_EraseRootFromParent_Done,
     /* 200942 */   // Label 3780: @200942
     /* 200942 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(200979), // Rule ID 2819 //
     /* 200947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 200950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 200955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200968 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1550:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 200968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 200971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200977 */     GIR_RootConstrainSelectedInstOperands,
     /* 200978 */     // GIR_Coverage, 2819,
     /* 200978 */     GIR_EraseRootFromParent_Done,
     /* 200979 */   // Label 3781: @200979
     /* 200979 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(201016), // Rule ID 2820 //
     /* 200984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 200987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 200992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 200998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201005 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1550:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 201008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201014 */     GIR_RootConstrainSelectedInstOperands,
     /* 201015 */     // GIR_Coverage, 2820,
     /* 201015 */     GIR_EraseRootFromParent_Done,
     /* 201016 */   // Label 3782: @201016
     /* 201016 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(201053), // Rule ID 2821 //
     /* 201021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 201024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 201029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201042 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1550:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 201045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201051 */     GIR_RootConstrainSelectedInstOperands,
     /* 201052 */     // GIR_Coverage, 2821,
     /* 201052 */     GIR_EraseRootFromParent_Done,
     /* 201053 */   // Label 3783: @201053
     /* 201053 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(201090), // Rule ID 2992 //
     /* 201058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 201066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201079 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1802:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 201082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201088 */     GIR_RootConstrainSelectedInstOperands,
     /* 201089 */     // GIR_Coverage, 2992,
     /* 201089 */     GIR_EraseRootFromParent_Done,
     /* 201090 */   // Label 3784: @201090
     /* 201090 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(201127), // Rule ID 2993 //
     /* 201095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 201103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 201119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201125 */     GIR_RootConstrainSelectedInstOperands,
     /* 201126 */     // GIR_Coverage, 2993,
     /* 201126 */     GIR_EraseRootFromParent_Done,
     /* 201127 */   // Label 3785: @201127
     /* 201127 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(201164), // Rule ID 2994 //
     /* 201132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 201140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201153 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 201156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201162 */     GIR_RootConstrainSelectedInstOperands,
     /* 201163 */     // GIR_Coverage, 2994,
     /* 201163 */     GIR_EraseRootFromParent_Done,
     /* 201164 */   // Label 3786: @201164
     /* 201164 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(201201), // Rule ID 2995 //
     /* 201169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 201177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 201193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201199 */     GIR_RootConstrainSelectedInstOperands,
     /* 201200 */     // GIR_Coverage, 2995,
     /* 201200 */     GIR_EraseRootFromParent_Done,
     /* 201201 */   // Label 3787: @201201
     /* 201201 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(201238), // Rule ID 2996 //
     /* 201206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 201214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201227 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1637:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 201230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201236 */     GIR_RootConstrainSelectedInstOperands,
     /* 201237 */     // GIR_Coverage, 2996,
     /* 201237 */     GIR_EraseRootFromParent_Done,
     /* 201238 */   // Label 3788: @201238
     /* 201238 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(201275), // Rule ID 3018 //
     /* 201243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 201251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1695:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 201267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201273 */     GIR_RootConstrainSelectedInstOperands,
     /* 201274 */     // GIR_Coverage, 3018,
     /* 201274 */     GIR_EraseRootFromParent_Done,
     /* 201275 */   // Label 3789: @201275
     /* 201275 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(201312), // Rule ID 3019 //
     /* 201280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 201288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201301 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 201304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201310 */     GIR_RootConstrainSelectedInstOperands,
     /* 201311 */     // GIR_Coverage, 3019,
     /* 201311 */     GIR_EraseRootFromParent_Done,
     /* 201312 */   // Label 3790: @201312
     /* 201312 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(201349), // Rule ID 3020 //
     /* 201317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 201325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 201341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201347 */     GIR_RootConstrainSelectedInstOperands,
     /* 201348 */     // GIR_Coverage, 3020,
     /* 201348 */     GIR_EraseRootFromParent_Done,
     /* 201349 */   // Label 3791: @201349
     /* 201349 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(201386), // Rule ID 3024 //
     /* 201354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 201357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 201362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201375 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1638:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 201378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201384 */     GIR_RootConstrainSelectedInstOperands,
     /* 201385 */     // GIR_Coverage, 3024,
     /* 201385 */     GIR_EraseRootFromParent_Done,
     /* 201386 */   // Label 3792: @201386
     /* 201386 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(201423), // Rule ID 3025 //
     /* 201391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 201399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1638:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 201415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201421 */     GIR_RootConstrainSelectedInstOperands,
     /* 201422 */     // GIR_Coverage, 3025,
     /* 201422 */     GIR_EraseRootFromParent_Done,
     /* 201423 */   // Label 3793: @201423
     /* 201423 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(201460), // Rule ID 3026 //
     /* 201428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 201436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201449 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1638:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 201452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201458 */     GIR_RootConstrainSelectedInstOperands,
     /* 201459 */     // GIR_Coverage, 3026,
     /* 201459 */     GIR_EraseRootFromParent_Done,
     /* 201460 */   // Label 3794: @201460
     /* 201460 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(201497), // Rule ID 3027 //
     /* 201465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 201468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 201473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201486 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1280:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 201489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201495 */     GIR_RootConstrainSelectedInstOperands,
     /* 201496 */     // GIR_Coverage, 3027,
     /* 201496 */     GIR_EraseRootFromParent_Done,
     /* 201497 */   // Label 3795: @201497
     /* 201497 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(201534), // Rule ID 3028 //
     /* 201502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 201505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 201510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201523 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1280:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 201526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201532 */     GIR_RootConstrainSelectedInstOperands,
     /* 201533 */     // GIR_Coverage, 3028,
     /* 201533 */     GIR_EraseRootFromParent_Done,
     /* 201534 */   // Label 3796: @201534
     /* 201534 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(201571), // Rule ID 3029 //
     /* 201539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 201542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 201547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1280:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 201563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201569 */     GIR_RootConstrainSelectedInstOperands,
     /* 201570 */     // GIR_Coverage, 3029,
     /* 201570 */     GIR_EraseRootFromParent_Done,
     /* 201571 */   // Label 3797: @201571
     /* 201571 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(201608), // Rule ID 3030 //
     /* 201576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 201579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 201584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201597 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1280:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 201600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201606 */     GIR_RootConstrainSelectedInstOperands,
     /* 201607 */     // GIR_Coverage, 3030,
     /* 201607 */     GIR_EraseRootFromParent_Done,
     /* 201608 */   // Label 3798: @201608
     /* 201608 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(201645), // Rule ID 3031 //
     /* 201613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 201621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201634 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 201637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201643 */     GIR_RootConstrainSelectedInstOperands,
     /* 201644 */     // GIR_Coverage, 3031,
     /* 201644 */     GIR_EraseRootFromParent_Done,
     /* 201645 */   // Label 3799: @201645
     /* 201645 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(201682), // Rule ID 3032 //
     /* 201650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 201658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 201674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201680 */     GIR_RootConstrainSelectedInstOperands,
     /* 201681 */     // GIR_Coverage, 3032,
     /* 201681 */     GIR_EraseRootFromParent_Done,
     /* 201682 */   // Label 3800: @201682
     /* 201682 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(201719), // Rule ID 3033 //
     /* 201687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 201695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 201711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201717 */     GIR_RootConstrainSelectedInstOperands,
     /* 201718 */     // GIR_Coverage, 3033,
     /* 201718 */     GIR_EraseRootFromParent_Done,
     /* 201719 */   // Label 3801: @201719
     /* 201719 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(201756), // Rule ID 3080 //
     /* 201724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 201732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201745 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1257:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 201748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201754 */     GIR_RootConstrainSelectedInstOperands,
     /* 201755 */     // GIR_Coverage, 3080,
     /* 201755 */     GIR_EraseRootFromParent_Done,
     /* 201756 */   // Label 3802: @201756
     /* 201756 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(201793), // Rule ID 3081 //
     /* 201761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 201769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 201785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201791 */     GIR_RootConstrainSelectedInstOperands,
     /* 201792 */     // GIR_Coverage, 3081,
     /* 201792 */     GIR_EraseRootFromParent_Done,
     /* 201793 */   // Label 3803: @201793
     /* 201793 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(201830), // Rule ID 3082 //
     /* 201798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 201806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 201822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201828 */     GIR_RootConstrainSelectedInstOperands,
     /* 201829 */     // GIR_Coverage, 3082,
     /* 201829 */     GIR_EraseRootFromParent_Done,
     /* 201830 */   // Label 3804: @201830
     /* 201830 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(201867), // Rule ID 3089 //
     /* 201835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 201843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1859:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 201859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201865 */     GIR_RootConstrainSelectedInstOperands,
     /* 201866 */     // GIR_Coverage, 3089,
     /* 201866 */     GIR_EraseRootFromParent_Done,
     /* 201867 */   // Label 3805: @201867
     /* 201867 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(201904), // Rule ID 3090 //
     /* 201872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 201880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1859:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 201896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201902 */     GIR_RootConstrainSelectedInstOperands,
     /* 201903 */     // GIR_Coverage, 3090,
     /* 201903 */     GIR_EraseRootFromParent_Done,
     /* 201904 */   // Label 3806: @201904
     /* 201904 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(201941), // Rule ID 3091 //
     /* 201909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 201917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1859:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 201933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201939 */     GIR_RootConstrainSelectedInstOperands,
     /* 201940 */     // GIR_Coverage, 3091,
     /* 201940 */     GIR_EraseRootFromParent_Done,
     /* 201941 */   // Label 3807: @201941
     /* 201941 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(201981), // Rule ID 3195 //
     /* 201946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 201954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201967 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 201967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 201970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 201979 */     GIR_RootConstrainSelectedInstOperands,
     /* 201980 */     // GIR_Coverage, 3195,
     /* 201980 */     GIR_EraseRootFromParent_Done,
     /* 201981 */   // Label 3808: @201981
     /* 201981 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(202021), // Rule ID 3196 //
     /* 201986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 201994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 201997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 202003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202007 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 202007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 202010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202019 */     GIR_RootConstrainSelectedInstOperands,
     /* 202020 */     // GIR_Coverage, 3196,
     /* 202020 */     GIR_EraseRootFromParent_Done,
     /* 202021 */   // Label 3809: @202021
     /* 202021 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(202061), // Rule ID 3197 //
     /* 202026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 202037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 202043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202047 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 202047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 202050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202059 */     GIR_RootConstrainSelectedInstOperands,
     /* 202060 */     // GIR_Coverage, 3197,
     /* 202060 */     GIR_EraseRootFromParent_Done,
     /* 202061 */   // Label 3810: @202061
     /* 202061 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(202101), // Rule ID 3198 //
     /* 202066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 202077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 202083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202087 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 202087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 202090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202099 */     GIR_RootConstrainSelectedInstOperands,
     /* 202100 */     // GIR_Coverage, 3198,
     /* 202100 */     GIR_EraseRootFromParent_Done,
     /* 202101 */   // Label 3811: @202101
     /* 202101 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(202141), // Rule ID 3203 //
     /* 202106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202127 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 202127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 202130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202139 */     GIR_RootConstrainSelectedInstOperands,
     /* 202140 */     // GIR_Coverage, 3203,
     /* 202140 */     GIR_EraseRootFromParent_Done,
     /* 202141 */   // Label 3812: @202141
     /* 202141 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(202181), // Rule ID 3204 //
     /* 202146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 202157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202167 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 202167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 202170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202179 */     GIR_RootConstrainSelectedInstOperands,
     /* 202180 */     // GIR_Coverage, 3204,
     /* 202180 */     GIR_EraseRootFromParent_Done,
     /* 202181 */   // Label 3813: @202181
     /* 202181 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(202221), // Rule ID 3205 //
     /* 202186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 202197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202207 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 202207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 202210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202219 */     GIR_RootConstrainSelectedInstOperands,
     /* 202220 */     // GIR_Coverage, 3205,
     /* 202220 */     GIR_EraseRootFromParent_Done,
     /* 202221 */   // Label 3814: @202221
     /* 202221 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(202261), // Rule ID 3206 //
     /* 202226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 202237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202247 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 202247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 202250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202259 */     GIR_RootConstrainSelectedInstOperands,
     /* 202260 */     // GIR_Coverage, 3206,
     /* 202260 */     GIR_EraseRootFromParent_Done,
     /* 202261 */   // Label 3815: @202261
     /* 202261 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(202298), // Rule ID 3395 //
     /* 202266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 202269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 202274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 202290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202296 */     GIR_RootConstrainSelectedInstOperands,
     /* 202297 */     // GIR_Coverage, 3395,
     /* 202297 */     GIR_EraseRootFromParent_Done,
     /* 202298 */   // Label 3816: @202298
     /* 202298 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(202335), // Rule ID 3396 //
     /* 202303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 202306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 202311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202324 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 202324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 202327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202333 */     GIR_RootConstrainSelectedInstOperands,
     /* 202334 */     // GIR_Coverage, 3396,
     /* 202334 */     GIR_EraseRootFromParent_Done,
     /* 202335 */   // Label 3817: @202335
     /* 202335 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(202372), // Rule ID 3397 //
     /* 202340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 202343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 202348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 202364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202370 */     GIR_RootConstrainSelectedInstOperands,
     /* 202371 */     // GIR_Coverage, 3397,
     /* 202371 */     GIR_EraseRootFromParent_Done,
     /* 202372 */   // Label 3818: @202372
     /* 202372 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(202409), // Rule ID 3398 //
     /* 202377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 202380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 202385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202398 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 202398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 202401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202407 */     GIR_RootConstrainSelectedInstOperands,
     /* 202408 */     // GIR_Coverage, 3398,
     /* 202408 */     GIR_EraseRootFromParent_Done,
     /* 202409 */   // Label 3819: @202409
     /* 202409 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(202446), // Rule ID 3420 //
     /* 202414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 202422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202435 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 202438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202444 */     GIR_RootConstrainSelectedInstOperands,
     /* 202445 */     // GIR_Coverage, 3420,
     /* 202445 */     GIR_EraseRootFromParent_Done,
     /* 202446 */   // Label 3820: @202446
     /* 202446 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(202483), // Rule ID 3421 //
     /* 202451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 202459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202472 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 202475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202481 */     GIR_RootConstrainSelectedInstOperands,
     /* 202482 */     // GIR_Coverage, 3421,
     /* 202482 */     GIR_EraseRootFromParent_Done,
     /* 202483 */   // Label 3821: @202483
     /* 202483 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(202520), // Rule ID 3422 //
     /* 202488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 202496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202509 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 202512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202518 */     GIR_RootConstrainSelectedInstOperands,
     /* 202519 */     // GIR_Coverage, 3422,
     /* 202519 */     GIR_EraseRootFromParent_Done,
     /* 202520 */   // Label 3822: @202520
     /* 202520 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(202557), // Rule ID 3444 //
     /* 202525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 202533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202546 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1301:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 202549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202555 */     GIR_RootConstrainSelectedInstOperands,
     /* 202556 */     // GIR_Coverage, 3444,
     /* 202556 */     GIR_EraseRootFromParent_Done,
     /* 202557 */   // Label 3823: @202557
     /* 202557 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(202594), // Rule ID 3449 //
     /* 202562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 202565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 202570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202583 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 202586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202592 */     GIR_RootConstrainSelectedInstOperands,
     /* 202593 */     // GIR_Coverage, 3449,
     /* 202593 */     GIR_EraseRootFromParent_Done,
     /* 202594 */   // Label 3824: @202594
     /* 202594 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(202631), // Rule ID 3450 //
     /* 202599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 202602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 202607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1266:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 202623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202629 */     GIR_RootConstrainSelectedInstOperands,
     /* 202630 */     // GIR_Coverage, 3450,
     /* 202630 */     GIR_EraseRootFromParent_Done,
     /* 202631 */   // Label 3825: @202631
     /* 202631 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(202668), // Rule ID 3459 //
     /* 202636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202657 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2161:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202666 */     GIR_RootConstrainSelectedInstOperands,
     /* 202667 */     // GIR_Coverage, 3459,
     /* 202667 */     GIR_EraseRootFromParent_Done,
     /* 202668 */   // Label 3826: @202668
     /* 202668 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(202705), // Rule ID 3460 //
     /* 202673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2161:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202703 */     GIR_RootConstrainSelectedInstOperands,
     /* 202704 */     // GIR_Coverage, 3460,
     /* 202704 */     GIR_EraseRootFromParent_Done,
     /* 202705 */   // Label 3827: @202705
     /* 202705 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(202742), // Rule ID 3461 //
     /* 202710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202731 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2161:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 202731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202740 */     GIR_RootConstrainSelectedInstOperands,
     /* 202741 */     // GIR_Coverage, 3461,
     /* 202741 */     GIR_EraseRootFromParent_Done,
     /* 202742 */   // Label 3828: @202742
     /* 202742 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(202779), // Rule ID 3462 //
     /* 202747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2161:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202777 */     GIR_RootConstrainSelectedInstOperands,
     /* 202778 */     // GIR_Coverage, 3462,
     /* 202778 */     GIR_EraseRootFromParent_Done,
     /* 202779 */   // Label 3829: @202779
     /* 202779 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(202816), // Rule ID 3463 //
     /* 202784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202805 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2161:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 202805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202814 */     GIR_RootConstrainSelectedInstOperands,
     /* 202815 */     // GIR_Coverage, 3463,
     /* 202815 */     GIR_EraseRootFromParent_Done,
     /* 202816 */   // Label 3830: @202816
     /* 202816 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(202853), // Rule ID 3464 //
     /* 202821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202842 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2161:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202851 */     GIR_RootConstrainSelectedInstOperands,
     /* 202852 */     // GIR_Coverage, 3464,
     /* 202852 */     GIR_EraseRootFromParent_Done,
     /* 202853 */   // Label 3831: @202853
     /* 202853 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(202890), // Rule ID 3465 //
     /* 202858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202879 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2161:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 202879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202888 */     GIR_RootConstrainSelectedInstOperands,
     /* 202889 */     // GIR_Coverage, 3465,
     /* 202889 */     GIR_EraseRootFromParent_Done,
     /* 202890 */   // Label 3832: @202890
     /* 202890 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(202927), // Rule ID 3520 //
     /* 202895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 202898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 202903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 202906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202916 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1374:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 202916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 202919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 202921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202925 */     GIR_RootConstrainSelectedInstOperands,
     /* 202926 */     // GIR_Coverage, 3520,
     /* 202926 */     GIR_EraseRootFromParent_Done,
     /* 202927 */   // Label 3833: @202927
     /* 202927 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(202964), // Rule ID 3521 //
     /* 202932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 202935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 202940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202953 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 202953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 202956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 202958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202962 */     GIR_RootConstrainSelectedInstOperands,
     /* 202963 */     // GIR_Coverage, 3521,
     /* 202963 */     GIR_EraseRootFromParent_Done,
     /* 202964 */   // Label 3834: @202964
     /* 202964 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(203001), // Rule ID 3522 //
     /* 202969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 202972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 202977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 202980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202990 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 202990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 202993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 202995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202999 */     GIR_RootConstrainSelectedInstOperands,
     /* 203000 */     // GIR_Coverage, 3522,
     /* 203000 */     GIR_EraseRootFromParent_Done,
     /* 203001 */   // Label 3835: @203001
     /* 203001 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(203038), // Rule ID 3552 //
     /* 203006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 203014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 203017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203027 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 203030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203036 */     GIR_RootConstrainSelectedInstOperands,
     /* 203037 */     // GIR_Coverage, 3552,
     /* 203037 */     GIR_EraseRootFromParent_Done,
     /* 203038 */   // Label 3836: @203038
     /* 203038 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(203075), // Rule ID 3553 //
     /* 203043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 203051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203064 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1625:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 203067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203073 */     GIR_RootConstrainSelectedInstOperands,
     /* 203074 */     // GIR_Coverage, 3553,
     /* 203074 */     GIR_EraseRootFromParent_Done,
     /* 203075 */   // Label 3837: @203075
     /* 203075 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(203112), // Rule ID 3554 //
     /* 203080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 203088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203101 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1625:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 203104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203110 */     GIR_RootConstrainSelectedInstOperands,
     /* 203111 */     // GIR_Coverage, 3554,
     /* 203111 */     GIR_EraseRootFromParent_Done,
     /* 203112 */   // Label 3838: @203112
     /* 203112 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(203149), // Rule ID 3555 //
     /* 203117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 203125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 203128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203138 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1625:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 203141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203147 */     GIR_RootConstrainSelectedInstOperands,
     /* 203148 */     // GIR_Coverage, 3555,
     /* 203148 */     GIR_EraseRootFromParent_Done,
     /* 203149 */   // Label 3839: @203149
     /* 203149 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(203186), // Rule ID 3556 //
     /* 203154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203175 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2169:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 203178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203184 */     GIR_RootConstrainSelectedInstOperands,
     /* 203185 */     // GIR_Coverage, 3556,
     /* 203185 */     GIR_EraseRootFromParent_Done,
     /* 203186 */   // Label 3840: @203186
     /* 203186 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(203223), // Rule ID 3557 //
     /* 203191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2169:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 203215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203221 */     GIR_RootConstrainSelectedInstOperands,
     /* 203222 */     // GIR_Coverage, 3557,
     /* 203222 */     GIR_EraseRootFromParent_Done,
     /* 203223 */   // Label 3841: @203223
     /* 203223 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(203260), // Rule ID 3558 //
     /* 203228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203249 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2169:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 203252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203258 */     GIR_RootConstrainSelectedInstOperands,
     /* 203259 */     // GIR_Coverage, 3558,
     /* 203259 */     GIR_EraseRootFromParent_Done,
     /* 203260 */   // Label 3842: @203260
     /* 203260 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(203297), // Rule ID 3559 //
     /* 203265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2169:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 203289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203295 */     GIR_RootConstrainSelectedInstOperands,
     /* 203296 */     // GIR_Coverage, 3559,
     /* 203296 */     GIR_EraseRootFromParent_Done,
     /* 203297 */   // Label 3843: @203297
     /* 203297 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(203334), // Rule ID 3560 //
     /* 203302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203323 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2169:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 203323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 203326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203332 */     GIR_RootConstrainSelectedInstOperands,
     /* 203333 */     // GIR_Coverage, 3560,
     /* 203333 */     GIR_EraseRootFromParent_Done,
     /* 203334 */   // Label 3844: @203334
     /* 203334 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(203371), // Rule ID 3561 //
     /* 203339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203360 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2169:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 203360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 203363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203369 */     GIR_RootConstrainSelectedInstOperands,
     /* 203370 */     // GIR_Coverage, 3561,
     /* 203370 */     GIR_EraseRootFromParent_Done,
     /* 203371 */   // Label 3845: @203371
     /* 203371 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(203408), // Rule ID 3562 //
     /* 203376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203397 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2169:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 203397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 203400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203406 */     GIR_RootConstrainSelectedInstOperands,
     /* 203407 */     // GIR_Coverage, 3562,
     /* 203407 */     GIR_EraseRootFromParent_Done,
     /* 203408 */   // Label 3846: @203408
     /* 203408 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(203445), // Rule ID 3563 //
     /* 203413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 203437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203443 */     GIR_RootConstrainSelectedInstOperands,
     /* 203444 */     // GIR_Coverage, 3563,
     /* 203444 */     GIR_EraseRootFromParent_Done,
     /* 203445 */   // Label 3847: @203445
     /* 203445 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(203482), // Rule ID 3564 //
     /* 203450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 203474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203480 */     GIR_RootConstrainSelectedInstOperands,
     /* 203481 */     // GIR_Coverage, 3564,
     /* 203481 */     GIR_EraseRootFromParent_Done,
     /* 203482 */   // Label 3848: @203482
     /* 203482 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(203519), // Rule ID 3565 //
     /* 203487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 203511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203517 */     GIR_RootConstrainSelectedInstOperands,
     /* 203518 */     // GIR_Coverage, 3565,
     /* 203518 */     GIR_EraseRootFromParent_Done,
     /* 203519 */   // Label 3849: @203519
     /* 203519 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(203556), // Rule ID 3566 //
     /* 203524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203545 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 203548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203554 */     GIR_RootConstrainSelectedInstOperands,
     /* 203555 */     // GIR_Coverage, 3566,
     /* 203555 */     GIR_EraseRootFromParent_Done,
     /* 203556 */   // Label 3850: @203556
     /* 203556 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(203593), // Rule ID 3567 //
     /* 203561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203582 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1924:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 203585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203591 */     GIR_RootConstrainSelectedInstOperands,
     /* 203592 */     // GIR_Coverage, 3567,
     /* 203592 */     GIR_EraseRootFromParent_Done,
     /* 203593 */   // Label 3851: @203593
     /* 203593 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(203630), // Rule ID 3568 //
     /* 203598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203619 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1924:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 203622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203628 */     GIR_RootConstrainSelectedInstOperands,
     /* 203629 */     // GIR_Coverage, 3568,
     /* 203629 */     GIR_EraseRootFromParent_Done,
     /* 203630 */   // Label 3852: @203630
     /* 203630 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(203667), // Rule ID 3569 //
     /* 203635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203656 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1924:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 203659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203665 */     GIR_RootConstrainSelectedInstOperands,
     /* 203666 */     // GIR_Coverage, 3569,
     /* 203666 */     GIR_EraseRootFromParent_Done,
     /* 203667 */   // Label 3853: @203667
     /* 203667 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(203704), // Rule ID 8456 //
     /* 203672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 203680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203693 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1303:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 203693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 203696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203702 */     GIR_RootConstrainSelectedInstOperands,
     /* 203703 */     // GIR_Coverage, 8456,
     /* 203703 */     GIR_EraseRootFromParent_Done,
     /* 203704 */   // Label 3854: @203704
     /* 203704 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(203741), // Rule ID 8932 //
     /* 203709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 203717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1261:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 203733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203739 */     GIR_RootConstrainSelectedInstOperands,
     /* 203740 */     // GIR_Coverage, 8932,
     /* 203740 */     GIR_EraseRootFromParent_Done,
     /* 203741 */   // Label 3855: @203741
     /* 203741 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(203778), // Rule ID 8933 //
     /* 203746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 203754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1263:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 203770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203776 */     GIR_RootConstrainSelectedInstOperands,
     /* 203777 */     // GIR_Coverage, 8933,
     /* 203777 */     GIR_EraseRootFromParent_Done,
     /* 203778 */   // Label 3856: @203778
     /* 203778 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(203815), // Rule ID 8934 //
     /* 203783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 203791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1264:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 203807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203813 */     GIR_RootConstrainSelectedInstOperands,
     /* 203814 */     // GIR_Coverage, 8934,
     /* 203814 */     GIR_EraseRootFromParent_Done,
     /* 203815 */   // Label 3857: @203815
     /* 203815 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(203852), // Rule ID 8935 //
     /* 203820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 203828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203841 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1262:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 203844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203850 */     GIR_RootConstrainSelectedInstOperands,
     /* 203851 */     // GIR_Coverage, 8935,
     /* 203851 */     GIR_EraseRootFromParent_Done,
     /* 203852 */   // Label 3858: @203852
     /* 203852 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(203889), // Rule ID 8936 //
     /* 203857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 203865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1261:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 203881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203887 */     GIR_RootConstrainSelectedInstOperands,
     /* 203888 */     // GIR_Coverage, 8936,
     /* 203888 */     GIR_EraseRootFromParent_Done,
     /* 203889 */   // Label 3859: @203889
     /* 203889 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(203926), // Rule ID 8937 //
     /* 203894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 203902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203915 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1263:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 203918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203924 */     GIR_RootConstrainSelectedInstOperands,
     /* 203925 */     // GIR_Coverage, 8937,
     /* 203925 */     GIR_EraseRootFromParent_Done,
     /* 203926 */   // Label 3860: @203926
     /* 203926 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(203963), // Rule ID 8938 //
     /* 203931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 203939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203952 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1264:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 203955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203961 */     GIR_RootConstrainSelectedInstOperands,
     /* 203962 */     // GIR_Coverage, 8938,
     /* 203962 */     GIR_EraseRootFromParent_Done,
     /* 203963 */   // Label 3861: @203963
     /* 203963 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(204000), // Rule ID 8939 //
     /* 203968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 203976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1262:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 203992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203998 */     GIR_RootConstrainSelectedInstOperands,
     /* 203999 */     // GIR_Coverage, 8939,
     /* 203999 */     GIR_EraseRootFromParent_Done,
     /* 204000 */   // Label 3862: @204000
     /* 204000 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(204040), // Rule ID 9939 //
     /* 204005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204026 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 204029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204038 */     GIR_RootConstrainSelectedInstOperands,
     /* 204039 */     // GIR_Coverage, 9939,
     /* 204039 */     GIR_EraseRootFromParent_Done,
     /* 204040 */   // Label 3863: @204040
     /* 204040 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(204080), // Rule ID 9940 //
     /* 204045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204066 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 204069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204078 */     GIR_RootConstrainSelectedInstOperands,
     /* 204079 */     // GIR_Coverage, 9940,
     /* 204079 */     GIR_EraseRootFromParent_Done,
     /* 204080 */   // Label 3864: @204080
     /* 204080 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(204120), // Rule ID 9941 //
     /* 204085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 204109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204118 */     GIR_RootConstrainSelectedInstOperands,
     /* 204119 */     // GIR_Coverage, 9941,
     /* 204119 */     GIR_EraseRootFromParent_Done,
     /* 204120 */   // Label 3865: @204120
     /* 204120 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(204160), // Rule ID 9942 //
     /* 204125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204146 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 204149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204158 */     GIR_RootConstrainSelectedInstOperands,
     /* 204159 */     // GIR_Coverage, 9942,
     /* 204159 */     GIR_EraseRootFromParent_Done,
     /* 204160 */   // Label 3866: @204160
     /* 204160 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(204200), // Rule ID 9951 //
     /* 204165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204186 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 204189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204198 */     GIR_RootConstrainSelectedInstOperands,
     /* 204199 */     // GIR_Coverage, 9951,
     /* 204199 */     GIR_EraseRootFromParent_Done,
     /* 204200 */   // Label 3867: @204200
     /* 204200 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(204240), // Rule ID 9952 //
     /* 204205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204226 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 204229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204238 */     GIR_RootConstrainSelectedInstOperands,
     /* 204239 */     // GIR_Coverage, 9952,
     /* 204239 */     GIR_EraseRootFromParent_Done,
     /* 204240 */   // Label 3868: @204240
     /* 204240 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(204280), // Rule ID 9953 //
     /* 204245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204266 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 204269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204278 */     GIR_RootConstrainSelectedInstOperands,
     /* 204279 */     // GIR_Coverage, 9953,
     /* 204279 */     GIR_EraseRootFromParent_Done,
     /* 204280 */   // Label 3869: @204280
     /* 204280 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(204320), // Rule ID 9954 //
     /* 204285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204306 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 204309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204318 */     GIR_RootConstrainSelectedInstOperands,
     /* 204319 */     // GIR_Coverage, 9954,
     /* 204319 */     GIR_EraseRootFromParent_Done,
     /* 204320 */   // Label 3870: @204320
     /* 204320 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(204360), // Rule ID 9955 //
     /* 204325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204346 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 204349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204358 */     GIR_RootConstrainSelectedInstOperands,
     /* 204359 */     // GIR_Coverage, 9955,
     /* 204359 */     GIR_EraseRootFromParent_Done,
     /* 204360 */   // Label 3871: @204360
     /* 204360 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(204400), // Rule ID 9956 //
     /* 204365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204386 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 204389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204398 */     GIR_RootConstrainSelectedInstOperands,
     /* 204399 */     // GIR_Coverage, 9956,
     /* 204399 */     GIR_EraseRootFromParent_Done,
     /* 204400 */   // Label 3872: @204400
     /* 204400 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(204440), // Rule ID 9957 //
     /* 204405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204426 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 204429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204438 */     GIR_RootConstrainSelectedInstOperands,
     /* 204439 */     // GIR_Coverage, 9957,
     /* 204439 */     GIR_EraseRootFromParent_Done,
     /* 204440 */   // Label 3873: @204440
     /* 204440 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(204480), // Rule ID 9958 //
     /* 204445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204466 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 204469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204478 */     GIR_RootConstrainSelectedInstOperands,
     /* 204479 */     // GIR_Coverage, 9958,
     /* 204479 */     GIR_EraseRootFromParent_Done,
     /* 204480 */   // Label 3874: @204480
     /* 204480 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(204520), // Rule ID 9967 //
     /* 204485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204506 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 204509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204518 */     GIR_RootConstrainSelectedInstOperands,
     /* 204519 */     // GIR_Coverage, 9967,
     /* 204519 */     GIR_EraseRootFromParent_Done,
     /* 204520 */   // Label 3875: @204520
     /* 204520 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(204560), // Rule ID 9968 //
     /* 204525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204546 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 204549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204558 */     GIR_RootConstrainSelectedInstOperands,
     /* 204559 */     // GIR_Coverage, 9968,
     /* 204559 */     GIR_EraseRootFromParent_Done,
     /* 204560 */   // Label 3876: @204560
     /* 204560 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(204600), // Rule ID 9969 //
     /* 204565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204586 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 204589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204598 */     GIR_RootConstrainSelectedInstOperands,
     /* 204599 */     // GIR_Coverage, 9969,
     /* 204599 */     GIR_EraseRootFromParent_Done,
     /* 204600 */   // Label 3877: @204600
     /* 204600 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(204640), // Rule ID 9970 //
     /* 204605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204626 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 204629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204638 */     GIR_RootConstrainSelectedInstOperands,
     /* 204639 */     // GIR_Coverage, 9970,
     /* 204639 */     GIR_EraseRootFromParent_Done,
     /* 204640 */   // Label 3878: @204640
     /* 204640 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(204677), // Rule ID 10129 //
     /* 204645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 204653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204666 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 204669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204675 */     GIR_RootConstrainSelectedInstOperands,
     /* 204676 */     // GIR_Coverage, 10129,
     /* 204676 */     GIR_EraseRootFromParent_Done,
     /* 204677 */   // Label 3879: @204677
     /* 204677 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(204714), // Rule ID 10130 //
     /* 204682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 204690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204703 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2031:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 204706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204712 */     GIR_RootConstrainSelectedInstOperands,
     /* 204713 */     // GIR_Coverage, 10130,
     /* 204713 */     GIR_EraseRootFromParent_Done,
     /* 204714 */   // Label 3880: @204714
     /* 204714 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(204751), // Rule ID 10131 //
     /* 204719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 204727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204740 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2031:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 204740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 204743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204749 */     GIR_RootConstrainSelectedInstOperands,
     /* 204750 */     // GIR_Coverage, 10131,
     /* 204750 */     GIR_EraseRootFromParent_Done,
     /* 204751 */   // Label 3881: @204751
     /* 204751 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(204788), // Rule ID 10132 //
     /* 204756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 204764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204777 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1786:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 204780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204786 */     GIR_RootConstrainSelectedInstOperands,
     /* 204787 */     // GIR_Coverage, 10132,
     /* 204787 */     GIR_EraseRootFromParent_Done,
     /* 204788 */   // Label 3882: @204788
     /* 204788 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(204825), // Rule ID 10133 //
     /* 204793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 204801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 204817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204823 */     GIR_RootConstrainSelectedInstOperands,
     /* 204824 */     // GIR_Coverage, 10133,
     /* 204824 */     GIR_EraseRootFromParent_Done,
     /* 204825 */   // Label 3883: @204825
     /* 204825 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(204862), // Rule ID 10134 //
     /* 204830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 204838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204851 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1786:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 204851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 204854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204860 */     GIR_RootConstrainSelectedInstOperands,
     /* 204861 */     // GIR_Coverage, 10134,
     /* 204861 */     GIR_EraseRootFromParent_Done,
     /* 204862 */   // Label 3884: @204862
     /* 204862 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(204899), // Rule ID 10135 //
     /* 204867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 204875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204888 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2017:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 204891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204897 */     GIR_RootConstrainSelectedInstOperands,
     /* 204898 */     // GIR_Coverage, 10135,
     /* 204898 */     GIR_EraseRootFromParent_Done,
     /* 204899 */   // Label 3885: @204899
     /* 204899 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(204936), // Rule ID 10136 //
     /* 204904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 204912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2017:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 204928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204934 */     GIR_RootConstrainSelectedInstOperands,
     /* 204935 */     // GIR_Coverage, 10136,
     /* 204935 */     GIR_EraseRootFromParent_Done,
     /* 204936 */   // Label 3886: @204936
     /* 204936 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(204973), // Rule ID 10137 //
     /* 204941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 204949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2017:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 204962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 204965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204971 */     GIR_RootConstrainSelectedInstOperands,
     /* 204972 */     // GIR_Coverage, 10137,
     /* 204972 */     GIR_EraseRootFromParent_Done,
     /* 204973 */   // Label 3887: @204973
     /* 204973 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(205010), // Rule ID 11325 //
     /* 204978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 204986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204999 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2166:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205008 */     GIR_RootConstrainSelectedInstOperands,
     /* 205009 */     // GIR_Coverage, 11325,
     /* 205009 */     GIR_EraseRootFromParent_Done,
     /* 205010 */   // Label 3888: @205010
     /* 205010 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(205047), // Rule ID 11326 //
     /* 205015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2166:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205045 */     GIR_RootConstrainSelectedInstOperands,
     /* 205046 */     // GIR_Coverage, 11326,
     /* 205046 */     GIR_EraseRootFromParent_Done,
     /* 205047 */   // Label 3889: @205047
     /* 205047 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(205084), // Rule ID 11327 //
     /* 205052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205073 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2166:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 205073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205082 */     GIR_RootConstrainSelectedInstOperands,
     /* 205083 */     // GIR_Coverage, 11327,
     /* 205083 */     GIR_EraseRootFromParent_Done,
     /* 205084 */   // Label 3890: @205084
     /* 205084 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(205121), // Rule ID 11328 //
     /* 205089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2166:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205119 */     GIR_RootConstrainSelectedInstOperands,
     /* 205120 */     // GIR_Coverage, 11328,
     /* 205120 */     GIR_EraseRootFromParent_Done,
     /* 205121 */   // Label 3891: @205121
     /* 205121 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(205158), // Rule ID 11329 //
     /* 205126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205147 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2166:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205156 */     GIR_RootConstrainSelectedInstOperands,
     /* 205157 */     // GIR_Coverage, 11329,
     /* 205157 */     GIR_EraseRootFromParent_Done,
     /* 205158 */   // Label 3892: @205158
     /* 205158 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(205195), // Rule ID 11330 //
     /* 205163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2166:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205193 */     GIR_RootConstrainSelectedInstOperands,
     /* 205194 */     // GIR_Coverage, 11330,
     /* 205194 */     GIR_EraseRootFromParent_Done,
     /* 205195 */   // Label 3893: @205195
     /* 205195 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(205232), // Rule ID 11331 //
     /* 205200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205221 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2166:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205230 */     GIR_RootConstrainSelectedInstOperands,
     /* 205231 */     // GIR_Coverage, 11331,
     /* 205231 */     GIR_EraseRootFromParent_Done,
     /* 205232 */   // Label 3894: @205232
     /* 205232 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(205269), // Rule ID 11332 //
     /* 205237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205258 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2087:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205267 */     GIR_RootConstrainSelectedInstOperands,
     /* 205268 */     // GIR_Coverage, 11332,
     /* 205268 */     GIR_EraseRootFromParent_Done,
     /* 205269 */   // Label 3895: @205269
     /* 205269 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(205306), // Rule ID 11333 //
     /* 205274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205295 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2087:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205304 */     GIR_RootConstrainSelectedInstOperands,
     /* 205305 */     // GIR_Coverage, 11333,
     /* 205305 */     GIR_EraseRootFromParent_Done,
     /* 205306 */   // Label 3896: @205306
     /* 205306 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(205343), // Rule ID 11334 //
     /* 205311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205332 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2087:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 205332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205341 */     GIR_RootConstrainSelectedInstOperands,
     /* 205342 */     // GIR_Coverage, 11334,
     /* 205342 */     GIR_EraseRootFromParent_Done,
     /* 205343 */   // Label 3897: @205343
     /* 205343 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(205380), // Rule ID 11335 //
     /* 205348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205369 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2087:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205378 */     GIR_RootConstrainSelectedInstOperands,
     /* 205379 */     // GIR_Coverage, 11335,
     /* 205379 */     GIR_EraseRootFromParent_Done,
     /* 205380 */   // Label 3898: @205380
     /* 205380 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(205417), // Rule ID 11336 //
     /* 205385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205406 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2087:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205415 */     GIR_RootConstrainSelectedInstOperands,
     /* 205416 */     // GIR_Coverage, 11336,
     /* 205416 */     GIR_EraseRootFromParent_Done,
     /* 205417 */   // Label 3899: @205417
     /* 205417 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(205454), // Rule ID 11337 //
     /* 205422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2087:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205452 */     GIR_RootConstrainSelectedInstOperands,
     /* 205453 */     // GIR_Coverage, 11337,
     /* 205453 */     GIR_EraseRootFromParent_Done,
     /* 205454 */   // Label 3900: @205454
     /* 205454 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(205491), // Rule ID 11338 //
     /* 205459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205480 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2087:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205489 */     GIR_RootConstrainSelectedInstOperands,
     /* 205490 */     // GIR_Coverage, 11338,
     /* 205490 */     GIR_EraseRootFromParent_Done,
     /* 205491 */   // Label 3901: @205491
     /* 205491 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(205528), // Rule ID 11339 //
     /* 205496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205517 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2092:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205526 */     GIR_RootConstrainSelectedInstOperands,
     /* 205527 */     // GIR_Coverage, 11339,
     /* 205527 */     GIR_EraseRootFromParent_Done,
     /* 205528 */   // Label 3902: @205528
     /* 205528 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(205565), // Rule ID 11340 //
     /* 205533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205554 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2092:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205563 */     GIR_RootConstrainSelectedInstOperands,
     /* 205564 */     // GIR_Coverage, 11340,
     /* 205564 */     GIR_EraseRootFromParent_Done,
     /* 205565 */   // Label 3903: @205565
     /* 205565 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(205602), // Rule ID 11341 //
     /* 205570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205591 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2092:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 205591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205600 */     GIR_RootConstrainSelectedInstOperands,
     /* 205601 */     // GIR_Coverage, 11341,
     /* 205601 */     GIR_EraseRootFromParent_Done,
     /* 205602 */   // Label 3904: @205602
     /* 205602 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(205639), // Rule ID 11342 //
     /* 205607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2092:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205637 */     GIR_RootConstrainSelectedInstOperands,
     /* 205638 */     // GIR_Coverage, 11342,
     /* 205638 */     GIR_EraseRootFromParent_Done,
     /* 205639 */   // Label 3905: @205639
     /* 205639 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(205676), // Rule ID 11343 //
     /* 205644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205665 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2092:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205674 */     GIR_RootConstrainSelectedInstOperands,
     /* 205675 */     // GIR_Coverage, 11343,
     /* 205675 */     GIR_EraseRootFromParent_Done,
     /* 205676 */   // Label 3906: @205676
     /* 205676 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(205713), // Rule ID 11344 //
     /* 205681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2092:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205711 */     GIR_RootConstrainSelectedInstOperands,
     /* 205712 */     // GIR_Coverage, 11344,
     /* 205712 */     GIR_EraseRootFromParent_Done,
     /* 205713 */   // Label 3907: @205713
     /* 205713 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(205750), // Rule ID 11345 //
     /* 205718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205739 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2092:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205748 */     GIR_RootConstrainSelectedInstOperands,
     /* 205749 */     // GIR_Coverage, 11345,
     /* 205749 */     GIR_EraseRootFromParent_Done,
     /* 205750 */   // Label 3908: @205750
     /* 205750 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(205787), // Rule ID 11346 //
     /* 205755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 205763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1931:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 205779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205785 */     GIR_RootConstrainSelectedInstOperands,
     /* 205786 */     // GIR_Coverage, 11346,
     /* 205786 */     GIR_EraseRootFromParent_Done,
     /* 205787 */   // Label 3909: @205787
     /* 205787 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(205824), // Rule ID 11347 //
     /* 205792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 205800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205813 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1931:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 205816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205822 */     GIR_RootConstrainSelectedInstOperands,
     /* 205823 */     // GIR_Coverage, 11347,
     /* 205823 */     GIR_EraseRootFromParent_Done,
     /* 205824 */   // Label 3910: @205824
     /* 205824 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(205861), // Rule ID 11348 //
     /* 205829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 205837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205850 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1931:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 205850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 205853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205859 */     GIR_RootConstrainSelectedInstOperands,
     /* 205860 */     // GIR_Coverage, 11348,
     /* 205860 */     GIR_EraseRootFromParent_Done,
     /* 205861 */   // Label 3911: @205861
     /* 205861 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(205898), // Rule ID 11349 //
     /* 205866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 205874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1931:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 205890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205896 */     GIR_RootConstrainSelectedInstOperands,
     /* 205897 */     // GIR_Coverage, 11349,
     /* 205897 */     GIR_EraseRootFromParent_Done,
     /* 205898 */   // Label 3912: @205898
     /* 205898 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(205935), // Rule ID 11350 //
     /* 205903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 205911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205924 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1931:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 205927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205933 */     GIR_RootConstrainSelectedInstOperands,
     /* 205934 */     // GIR_Coverage, 11350,
     /* 205934 */     GIR_EraseRootFromParent_Done,
     /* 205935 */   // Label 3913: @205935
     /* 205935 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(205972), // Rule ID 11351 //
     /* 205940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 205948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1931:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 205964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205970 */     GIR_RootConstrainSelectedInstOperands,
     /* 205971 */     // GIR_Coverage, 11351,
     /* 205971 */     GIR_EraseRootFromParent_Done,
     /* 205972 */   // Label 3914: @205972
     /* 205972 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(206009), // Rule ID 11352 //
     /* 205977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 205985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205998 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1931:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 206001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206007 */     GIR_RootConstrainSelectedInstOperands,
     /* 206008 */     // GIR_Coverage, 11352,
     /* 206008 */     GIR_EraseRootFromParent_Done,
     /* 206009 */   // Label 3915: @206009
     /* 206009 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(206046), // Rule ID 11353 //
     /* 206014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206035 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1936:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206044 */     GIR_RootConstrainSelectedInstOperands,
     /* 206045 */     // GIR_Coverage, 11353,
     /* 206045 */     GIR_EraseRootFromParent_Done,
     /* 206046 */   // Label 3916: @206046
     /* 206046 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(206083), // Rule ID 11354 //
     /* 206051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206081 */     GIR_RootConstrainSelectedInstOperands,
     /* 206082 */     // GIR_Coverage, 11354,
     /* 206082 */     GIR_EraseRootFromParent_Done,
     /* 206083 */   // Label 3917: @206083
     /* 206083 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(206120), // Rule ID 11355 //
     /* 206088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206109 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1936:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206118 */     GIR_RootConstrainSelectedInstOperands,
     /* 206119 */     // GIR_Coverage, 11355,
     /* 206119 */     GIR_EraseRootFromParent_Done,
     /* 206120 */   // Label 3918: @206120
     /* 206120 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(206157), // Rule ID 11356 //
     /* 206125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206155 */     GIR_RootConstrainSelectedInstOperands,
     /* 206156 */     // GIR_Coverage, 11356,
     /* 206156 */     GIR_EraseRootFromParent_Done,
     /* 206157 */   // Label 3919: @206157
     /* 206157 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(206194), // Rule ID 11357 //
     /* 206162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206183 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1936:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206192 */     GIR_RootConstrainSelectedInstOperands,
     /* 206193 */     // GIR_Coverage, 11357,
     /* 206193 */     GIR_EraseRootFromParent_Done,
     /* 206194 */   // Label 3920: @206194
     /* 206194 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(206231), // Rule ID 11358 //
     /* 206199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206229 */     GIR_RootConstrainSelectedInstOperands,
     /* 206230 */     // GIR_Coverage, 11358,
     /* 206230 */     GIR_EraseRootFromParent_Done,
     /* 206231 */   // Label 3921: @206231
     /* 206231 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(206268), // Rule ID 11359 //
     /* 206236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206257 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1936:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206266 */     GIR_RootConstrainSelectedInstOperands,
     /* 206267 */     // GIR_Coverage, 11359,
     /* 206267 */     GIR_EraseRootFromParent_Done,
     /* 206268 */   // Label 3922: @206268
     /* 206268 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(206305), // Rule ID 11379 //
     /* 206273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 206281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206294 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 206297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206303 */     GIR_RootConstrainSelectedInstOperands,
     /* 206304 */     // GIR_Coverage, 11379,
     /* 206304 */     GIR_EraseRootFromParent_Done,
     /* 206305 */   // Label 3923: @206305
     /* 206305 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(206342), // Rule ID 11380 //
     /* 206310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 206318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 206334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206340 */     GIR_RootConstrainSelectedInstOperands,
     /* 206341 */     // GIR_Coverage, 11380,
     /* 206341 */     GIR_EraseRootFromParent_Done,
     /* 206342 */   // Label 3924: @206342
     /* 206342 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(206379), // Rule ID 11381 //
     /* 206347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 206355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 206371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206377 */     GIR_RootConstrainSelectedInstOperands,
     /* 206378 */     // GIR_Coverage, 11381,
     /* 206378 */     GIR_EraseRootFromParent_Done,
     /* 206379 */   // Label 3925: @206379
     /* 206379 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(206416), // Rule ID 11382 //
     /* 206384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 206392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206405 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 206408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206414 */     GIR_RootConstrainSelectedInstOperands,
     /* 206415 */     // GIR_Coverage, 11382,
     /* 206415 */     GIR_EraseRootFromParent_Done,
     /* 206416 */   // Label 3926: @206416
     /* 206416 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(206453), // Rule ID 11670 //
     /* 206421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 206429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1697:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 206445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206451 */     GIR_RootConstrainSelectedInstOperands,
     /* 206452 */     // GIR_Coverage, 11670,
     /* 206452 */     GIR_EraseRootFromParent_Done,
     /* 206453 */   // Label 3927: @206453
     /* 206453 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(206490), // Rule ID 11671 //
     /* 206458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 206466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206479 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 206482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206488 */     GIR_RootConstrainSelectedInstOperands,
     /* 206489 */     // GIR_Coverage, 11671,
     /* 206489 */     GIR_EraseRootFromParent_Done,
     /* 206490 */   // Label 3928: @206490
     /* 206490 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(206527), // Rule ID 11672 //
     /* 206495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 206503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 206519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206525 */     GIR_RootConstrainSelectedInstOperands,
     /* 206526 */     // GIR_Coverage, 11672,
     /* 206526 */     GIR_EraseRootFromParent_Done,
     /* 206527 */   // Label 3929: @206527
     /* 206527 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(206564), // Rule ID 11673 //
     /* 206532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 206540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206553 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 206556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206562 */     GIR_RootConstrainSelectedInstOperands,
     /* 206563 */     // GIR_Coverage, 11673,
     /* 206563 */     GIR_EraseRootFromParent_Done,
     /* 206564 */   // Label 3930: @206564
     /* 206564 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(206601), // Rule ID 11674 //
     /* 206569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 206577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 206593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206599 */     GIR_RootConstrainSelectedInstOperands,
     /* 206600 */     // GIR_Coverage, 11674,
     /* 206600 */     GIR_EraseRootFromParent_Done,
     /* 206601 */   // Label 3931: @206601
     /* 206601 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(206638), // Rule ID 11675 //
     /* 206606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 206614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206627 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 206630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206636 */     GIR_RootConstrainSelectedInstOperands,
     /* 206637 */     // GIR_Coverage, 11675,
     /* 206637 */     GIR_EraseRootFromParent_Done,
     /* 206638 */   // Label 3932: @206638
     /* 206638 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(206675), // Rule ID 11676 //
     /* 206643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 206651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 206667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206673 */     GIR_RootConstrainSelectedInstOperands,
     /* 206674 */     // GIR_Coverage, 11676,
     /* 206674 */     GIR_EraseRootFromParent_Done,
     /* 206675 */   // Label 3933: @206675
     /* 206675 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(206712), // Rule ID 11677 //
     /* 206680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 206688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206701 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 206704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206710 */     GIR_RootConstrainSelectedInstOperands,
     /* 206711 */     // GIR_Coverage, 11677,
     /* 206711 */     GIR_EraseRootFromParent_Done,
     /* 206712 */   // Label 3934: @206712
     /* 206712 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(206749), // Rule ID 11678 //
     /* 206717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 206725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206738 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 206741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206747 */     GIR_RootConstrainSelectedInstOperands,
     /* 206748 */     // GIR_Coverage, 11678,
     /* 206748 */     GIR_EraseRootFromParent_Done,
     /* 206749 */   // Label 3935: @206749
     /* 206749 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(206786), // Rule ID 11679 //
     /* 206754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 206762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206775 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1874:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 206778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206784 */     GIR_RootConstrainSelectedInstOperands,
     /* 206785 */     // GIR_Coverage, 11679,
     /* 206785 */     GIR_EraseRootFromParent_Done,
     /* 206786 */   // Label 3936: @206786
     /* 206786 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(206823), // Rule ID 11680 //
     /* 206791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 206799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1874:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 206815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206821 */     GIR_RootConstrainSelectedInstOperands,
     /* 206822 */     // GIR_Coverage, 11680,
     /* 206822 */     GIR_EraseRootFromParent_Done,
     /* 206823 */   // Label 3937: @206823
     /* 206823 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(206860), // Rule ID 11681 //
     /* 206828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 206836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1874:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 206852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206858 */     GIR_RootConstrainSelectedInstOperands,
     /* 206859 */     // GIR_Coverage, 11681,
     /* 206859 */     GIR_EraseRootFromParent_Done,
     /* 206860 */   // Label 3938: @206860
     /* 206860 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(206897), // Rule ID 11682 //
     /* 206865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 206873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1876:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 206889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206895 */     GIR_RootConstrainSelectedInstOperands,
     /* 206896 */     // GIR_Coverage, 11682,
     /* 206896 */     GIR_EraseRootFromParent_Done,
     /* 206897 */   // Label 3939: @206897
     /* 206897 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(206934), // Rule ID 11683 //
     /* 206902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 206910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206923 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1876:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 206926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206932 */     GIR_RootConstrainSelectedInstOperands,
     /* 206933 */     // GIR_Coverage, 11683,
     /* 206933 */     GIR_EraseRootFromParent_Done,
     /* 206934 */   // Label 3940: @206934
     /* 206934 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(206971), // Rule ID 11684 //
     /* 206939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 206947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206960 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1876:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 206963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206969 */     GIR_RootConstrainSelectedInstOperands,
     /* 206970 */     // GIR_Coverage, 11684,
     /* 206970 */     GIR_EraseRootFromParent_Done,
     /* 206971 */   // Label 3941: @206971
     /* 206971 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(207008), // Rule ID 11685 //
     /* 206976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 206984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206997 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2070:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 207000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207006 */     GIR_RootConstrainSelectedInstOperands,
     /* 207007 */     // GIR_Coverage, 11685,
     /* 207007 */     GIR_EraseRootFromParent_Done,
     /* 207008 */   // Label 3942: @207008
     /* 207008 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(207045), // Rule ID 11686 //
     /* 207013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 207021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2070:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 207037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207043 */     GIR_RootConstrainSelectedInstOperands,
     /* 207044 */     // GIR_Coverage, 11686,
     /* 207044 */     GIR_EraseRootFromParent_Done,
     /* 207045 */   // Label 3943: @207045
     /* 207045 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(207082), // Rule ID 11687 //
     /* 207050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 207058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207071 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2070:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 207074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207080 */     GIR_RootConstrainSelectedInstOperands,
     /* 207081 */     // GIR_Coverage, 11687,
     /* 207081 */     GIR_EraseRootFromParent_Done,
     /* 207082 */   // Label 3944: @207082
     /* 207082 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(207119), // Rule ID 11688 //
     /* 207087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 207095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2071:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 207111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207117 */     GIR_RootConstrainSelectedInstOperands,
     /* 207118 */     // GIR_Coverage, 11688,
     /* 207118 */     GIR_EraseRootFromParent_Done,
     /* 207119 */   // Label 3945: @207119
     /* 207119 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(207156), // Rule ID 11689 //
     /* 207124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 207132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207145 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2071:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 207148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207154 */     GIR_RootConstrainSelectedInstOperands,
     /* 207155 */     // GIR_Coverage, 11689,
     /* 207155 */     GIR_EraseRootFromParent_Done,
     /* 207156 */   // Label 3946: @207156
     /* 207156 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(207193), // Rule ID 11690 //
     /* 207161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 207169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2071:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 207185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207191 */     GIR_RootConstrainSelectedInstOperands,
     /* 207192 */     // GIR_Coverage, 11690,
     /* 207192 */     GIR_EraseRootFromParent_Done,
     /* 207193 */   // Label 3947: @207193
     /* 207193 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(207230), // Rule ID 11691 //
     /* 207198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 207206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207219 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1692:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 207222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207228 */     GIR_RootConstrainSelectedInstOperands,
     /* 207229 */     // GIR_Coverage, 11691,
     /* 207229 */     GIR_EraseRootFromParent_Done,
     /* 207230 */   // Label 3948: @207230
     /* 207230 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(207267), // Rule ID 11692 //
     /* 207235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 207243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 207259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207265 */     GIR_RootConstrainSelectedInstOperands,
     /* 207266 */     // GIR_Coverage, 11692,
     /* 207266 */     GIR_EraseRootFromParent_Done,
     /* 207267 */   // Label 3949: @207267
     /* 207267 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(207304), // Rule ID 11693 //
     /* 207272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 207280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207293 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 207296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207302 */     GIR_RootConstrainSelectedInstOperands,
     /* 207303 */     // GIR_Coverage, 11693,
     /* 207303 */     GIR_EraseRootFromParent_Done,
     /* 207304 */   // Label 3950: @207304
     /* 207304 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(207341), // Rule ID 11694 //
     /* 207309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 207317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207330 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 207333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207339 */     GIR_RootConstrainSelectedInstOperands,
     /* 207340 */     // GIR_Coverage, 11694,
     /* 207340 */     GIR_EraseRootFromParent_Done,
     /* 207341 */   // Label 3951: @207341
     /* 207341 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(207378), // Rule ID 11695 //
     /* 207346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 207354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207367 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 207370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207376 */     GIR_RootConstrainSelectedInstOperands,
     /* 207377 */     // GIR_Coverage, 11695,
     /* 207377 */     GIR_EraseRootFromParent_Done,
     /* 207378 */   // Label 3952: @207378
     /* 207378 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(207415), // Rule ID 11696 //
     /* 207383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 207391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207404 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 207407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207413 */     GIR_RootConstrainSelectedInstOperands,
     /* 207414 */     // GIR_Coverage, 11696,
     /* 207414 */     GIR_EraseRootFromParent_Done,
     /* 207415 */   // Label 3953: @207415
     /* 207415 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(207452), // Rule ID 11697 //
     /* 207420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 207428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207441 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 207444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207450 */     GIR_RootConstrainSelectedInstOperands,
     /* 207451 */     // GIR_Coverage, 11697,
     /* 207451 */     GIR_EraseRootFromParent_Done,
     /* 207452 */   // Label 3954: @207452
     /* 207452 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(207489), // Rule ID 11698 //
     /* 207457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 207465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207478 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 207481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207487 */     GIR_RootConstrainSelectedInstOperands,
     /* 207488 */     // GIR_Coverage, 11698,
     /* 207488 */     GIR_EraseRootFromParent_Done,
     /* 207489 */   // Label 3955: @207489
     /* 207489 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(207526), // Rule ID 11699 //
     /* 207494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 207502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207515 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 207518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207524 */     GIR_RootConstrainSelectedInstOperands,
     /* 207525 */     // GIR_Coverage, 11699,
     /* 207525 */     GIR_EraseRootFromParent_Done,
     /* 207526 */   // Label 3956: @207526
     /* 207526 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(207563), // Rule ID 11700 //
     /* 207531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 207539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 207555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207561 */     GIR_RootConstrainSelectedInstOperands,
     /* 207562 */     // GIR_Coverage, 11700,
     /* 207562 */     GIR_EraseRootFromParent_Done,
     /* 207563 */   // Label 3957: @207563
     /* 207563 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(207600), // Rule ID 11701 //
     /* 207568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 207576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 207592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207598 */     GIR_RootConstrainSelectedInstOperands,
     /* 207599 */     // GIR_Coverage, 11701,
     /* 207599 */     GIR_EraseRootFromParent_Done,
     /* 207600 */   // Label 3958: @207600
     /* 207600 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(207637), // Rule ID 11702 //
     /* 207605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 207613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207626 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 207629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207635 */     GIR_RootConstrainSelectedInstOperands,
     /* 207636 */     // GIR_Coverage, 11702,
     /* 207636 */     GIR_EraseRootFromParent_Done,
     /* 207637 */   // Label 3959: @207637
     /* 207637 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(207674), // Rule ID 11712 //
     /* 207642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 207650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207663 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1878:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 207666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207672 */     GIR_RootConstrainSelectedInstOperands,
     /* 207673 */     // GIR_Coverage, 11712,
     /* 207673 */     GIR_EraseRootFromParent_Done,
     /* 207674 */   // Label 3960: @207674
     /* 207674 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(207711), // Rule ID 11713 //
     /* 207679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 207687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1878:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 207703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207709 */     GIR_RootConstrainSelectedInstOperands,
     /* 207710 */     // GIR_Coverage, 11713,
     /* 207710 */     GIR_EraseRootFromParent_Done,
     /* 207711 */   // Label 3961: @207711
     /* 207711 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(207748), // Rule ID 11714 //
     /* 207716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 207724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207737 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1878:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 207740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207746 */     GIR_RootConstrainSelectedInstOperands,
     /* 207747 */     // GIR_Coverage, 11714,
     /* 207747 */     GIR_EraseRootFromParent_Done,
     /* 207748 */   // Label 3962: @207748
     /* 207748 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(207785), // Rule ID 11715 //
     /* 207753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 207761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207774 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1879:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 207777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207783 */     GIR_RootConstrainSelectedInstOperands,
     /* 207784 */     // GIR_Coverage, 11715,
     /* 207784 */     GIR_EraseRootFromParent_Done,
     /* 207785 */   // Label 3963: @207785
     /* 207785 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(207822), // Rule ID 11716 //
     /* 207790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 207798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1879:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 207814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207820 */     GIR_RootConstrainSelectedInstOperands,
     /* 207821 */     // GIR_Coverage, 11716,
     /* 207821 */     GIR_EraseRootFromParent_Done,
     /* 207822 */   // Label 3964: @207822
     /* 207822 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(207859), // Rule ID 11717 //
     /* 207827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 207835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207848 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1879:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 207851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207857 */     GIR_RootConstrainSelectedInstOperands,
     /* 207858 */     // GIR_Coverage, 11717,
     /* 207858 */     GIR_EraseRootFromParent_Done,
     /* 207859 */   // Label 3965: @207859
     /* 207859 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(207896), // Rule ID 11718 //
     /* 207864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 207872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207885 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2072:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 207888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207894 */     GIR_RootConstrainSelectedInstOperands,
     /* 207895 */     // GIR_Coverage, 11718,
     /* 207895 */     GIR_EraseRootFromParent_Done,
     /* 207896 */   // Label 3966: @207896
     /* 207896 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(207933), // Rule ID 11719 //
     /* 207901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 207909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2072:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 207925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207931 */     GIR_RootConstrainSelectedInstOperands,
     /* 207932 */     // GIR_Coverage, 11719,
     /* 207932 */     GIR_EraseRootFromParent_Done,
     /* 207933 */   // Label 3967: @207933
     /* 207933 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(207970), // Rule ID 11720 //
     /* 207938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 207946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2072:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 207962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207968 */     GIR_RootConstrainSelectedInstOperands,
     /* 207969 */     // GIR_Coverage, 11720,
     /* 207969 */     GIR_EraseRootFromParent_Done,
     /* 207970 */   // Label 3968: @207970
     /* 207970 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(208007), // Rule ID 11721 //
     /* 207975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 207983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2073:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 207999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208005 */     GIR_RootConstrainSelectedInstOperands,
     /* 208006 */     // GIR_Coverage, 11721,
     /* 208006 */     GIR_EraseRootFromParent_Done,
     /* 208007 */   // Label 3969: @208007
     /* 208007 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(208044), // Rule ID 11722 //
     /* 208012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 208020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208033 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2073:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 208036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208042 */     GIR_RootConstrainSelectedInstOperands,
     /* 208043 */     // GIR_Coverage, 11722,
     /* 208043 */     GIR_EraseRootFromParent_Done,
     /* 208044 */   // Label 3970: @208044
     /* 208044 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(208081), // Rule ID 11723 //
     /* 208049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 208057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2073:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 208073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208079 */     GIR_RootConstrainSelectedInstOperands,
     /* 208080 */     // GIR_Coverage, 11723,
     /* 208080 */     GIR_EraseRootFromParent_Done,
     /* 208081 */   // Label 3971: @208081
     /* 208081 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(208118), // Rule ID 11736 //
     /* 208086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 208094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208107 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1808:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 208110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208116 */     GIR_RootConstrainSelectedInstOperands,
     /* 208117 */     // GIR_Coverage, 11736,
     /* 208117 */     GIR_EraseRootFromParent_Done,
     /* 208118 */   // Label 3972: @208118
     /* 208118 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(208155), // Rule ID 11737 //
     /* 208123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 208131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1808:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 208147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208153 */     GIR_RootConstrainSelectedInstOperands,
     /* 208154 */     // GIR_Coverage, 11737,
     /* 208154 */     GIR_EraseRootFromParent_Done,
     /* 208155 */   // Label 3973: @208155
     /* 208155 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(208192), // Rule ID 11738 //
     /* 208160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 208168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208181 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1808:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 208184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208190 */     GIR_RootConstrainSelectedInstOperands,
     /* 208191 */     // GIR_Coverage, 11738,
     /* 208191 */     GIR_EraseRootFromParent_Done,
     /* 208192 */   // Label 3974: @208192
     /* 208192 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(208229), // Rule ID 11739 //
     /* 208197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 208205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 208221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208227 */     GIR_RootConstrainSelectedInstOperands,
     /* 208228 */     // GIR_Coverage, 11739,
     /* 208228 */     GIR_EraseRootFromParent_Done,
     /* 208229 */   // Label 3975: @208229
     /* 208229 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(208266), // Rule ID 11740 //
     /* 208234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 208242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 208258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208264 */     GIR_RootConstrainSelectedInstOperands,
     /* 208265 */     // GIR_Coverage, 11740,
     /* 208265 */     GIR_EraseRootFromParent_Done,
     /* 208266 */   // Label 3976: @208266
     /* 208266 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(208303), // Rule ID 11741 //
     /* 208271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 208279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 208295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208301 */     GIR_RootConstrainSelectedInstOperands,
     /* 208302 */     // GIR_Coverage, 11741,
     /* 208302 */     GIR_EraseRootFromParent_Done,
     /* 208303 */   // Label 3977: @208303
     /* 208303 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(208340), // Rule ID 11742 //
     /* 208308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 208316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208329 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1761:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 208332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208338 */     GIR_RootConstrainSelectedInstOperands,
     /* 208339 */     // GIR_Coverage, 11742,
     /* 208339 */     GIR_EraseRootFromParent_Done,
     /* 208340 */   // Label 3978: @208340
     /* 208340 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(208377), // Rule ID 11743 //
     /* 208345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 208353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 208369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208375 */     GIR_RootConstrainSelectedInstOperands,
     /* 208376 */     // GIR_Coverage, 11743,
     /* 208376 */     GIR_EraseRootFromParent_Done,
     /* 208377 */   // Label 3979: @208377
     /* 208377 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(208414), // Rule ID 11744 //
     /* 208382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 208390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208403 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1761:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 208406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208412 */     GIR_RootConstrainSelectedInstOperands,
     /* 208413 */     // GIR_Coverage, 11744,
     /* 208413 */     GIR_EraseRootFromParent_Done,
     /* 208414 */   // Label 3980: @208414
     /* 208414 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(208451), // Rule ID 11745 //
     /* 208419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 208427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1763:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 208443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208449 */     GIR_RootConstrainSelectedInstOperands,
     /* 208450 */     // GIR_Coverage, 11745,
     /* 208450 */     GIR_EraseRootFromParent_Done,
     /* 208451 */   // Label 3981: @208451
     /* 208451 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(208488), // Rule ID 11746 //
     /* 208456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 208464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208477 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1763:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 208480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208486 */     GIR_RootConstrainSelectedInstOperands,
     /* 208487 */     // GIR_Coverage, 11746,
     /* 208487 */     GIR_EraseRootFromParent_Done,
     /* 208488 */   // Label 3982: @208488
     /* 208488 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(208525), // Rule ID 11747 //
     /* 208493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 208501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208514 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1763:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 208517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208523 */     GIR_RootConstrainSelectedInstOperands,
     /* 208524 */     // GIR_Coverage, 11747,
     /* 208524 */     GIR_EraseRootFromParent_Done,
     /* 208525 */   // Label 3983: @208525
     /* 208525 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(208562), // Rule ID 11748 //
     /* 208530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 208538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1999:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 208554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208560 */     GIR_RootConstrainSelectedInstOperands,
     /* 208561 */     // GIR_Coverage, 11748,
     /* 208561 */     GIR_EraseRootFromParent_Done,
     /* 208562 */   // Label 3984: @208562
     /* 208562 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(208599), // Rule ID 11749 //
     /* 208567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 208575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1999:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 208591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208597 */     GIR_RootConstrainSelectedInstOperands,
     /* 208598 */     // GIR_Coverage, 11749,
     /* 208598 */     GIR_EraseRootFromParent_Done,
     /* 208599 */   // Label 3985: @208599
     /* 208599 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(208636), // Rule ID 11750 //
     /* 208604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 208612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208625 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1999:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 208628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208634 */     GIR_RootConstrainSelectedInstOperands,
     /* 208635 */     // GIR_Coverage, 11750,
     /* 208635 */     GIR_EraseRootFromParent_Done,
     /* 208636 */   // Label 3986: @208636
     /* 208636 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(208673), // Rule ID 11751 //
     /* 208641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 208649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208662 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2001:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 208665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208671 */     GIR_RootConstrainSelectedInstOperands,
     /* 208672 */     // GIR_Coverage, 11751,
     /* 208672 */     GIR_EraseRootFromParent_Done,
     /* 208673 */   // Label 3987: @208673
     /* 208673 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(208710), // Rule ID 11752 //
     /* 208678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 208686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2001:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 208702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208708 */     GIR_RootConstrainSelectedInstOperands,
     /* 208709 */     // GIR_Coverage, 11752,
     /* 208709 */     GIR_EraseRootFromParent_Done,
     /* 208710 */   // Label 3988: @208710
     /* 208710 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(208747), // Rule ID 11753 //
     /* 208715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 208723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2001:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 208739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208745 */     GIR_RootConstrainSelectedInstOperands,
     /* 208746 */     // GIR_Coverage, 11753,
     /* 208746 */     GIR_EraseRootFromParent_Done,
     /* 208747 */   // Label 3989: @208747
     /* 208747 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(208784), // Rule ID 11754 //
     /* 208752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 208760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208773 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1639:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 208776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208782 */     GIR_RootConstrainSelectedInstOperands,
     /* 208783 */     // GIR_Coverage, 11754,
     /* 208783 */     GIR_EraseRootFromParent_Done,
     /* 208784 */   // Label 3990: @208784
     /* 208784 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(208821), // Rule ID 11755 //
     /* 208789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 208797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1639:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 208813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208819 */     GIR_RootConstrainSelectedInstOperands,
     /* 208820 */     // GIR_Coverage, 11755,
     /* 208820 */     GIR_EraseRootFromParent_Done,
     /* 208821 */   // Label 3991: @208821
     /* 208821 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(208858), // Rule ID 11856 //
     /* 208826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 208834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208847 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1669:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 208850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208856 */     GIR_RootConstrainSelectedInstOperands,
     /* 208857 */     // GIR_Coverage, 11856,
     /* 208857 */     GIR_EraseRootFromParent_Done,
     /* 208858 */   // Label 3992: @208858
     /* 208858 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(208895), // Rule ID 11857 //
     /* 208863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 208871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1669:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 208887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208893 */     GIR_RootConstrainSelectedInstOperands,
     /* 208894 */     // GIR_Coverage, 11857,
     /* 208894 */     GIR_EraseRootFromParent_Done,
     /* 208895 */   // Label 3993: @208895
     /* 208895 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(208932), // Rule ID 11858 //
     /* 208900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 208908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1669:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 208921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 208924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208930 */     GIR_RootConstrainSelectedInstOperands,
     /* 208931 */     // GIR_Coverage, 11858,
     /* 208931 */     GIR_EraseRootFromParent_Done,
     /* 208932 */   // Label 3994: @208932
     /* 208932 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(208969), // Rule ID 11859 //
     /* 208937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 208945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208958 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1910:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 208961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208967 */     GIR_RootConstrainSelectedInstOperands,
     /* 208968 */     // GIR_Coverage, 11859,
     /* 208968 */     GIR_EraseRootFromParent_Done,
     /* 208969 */   // Label 3995: @208969
     /* 208969 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(209006), // Rule ID 11860 //
     /* 208974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 208982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208995 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1910:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 208998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209004 */     GIR_RootConstrainSelectedInstOperands,
     /* 209005 */     // GIR_Coverage, 11860,
     /* 209005 */     GIR_EraseRootFromParent_Done,
     /* 209006 */   // Label 3996: @209006
     /* 209006 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(209043), // Rule ID 11861 //
     /* 209011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 209019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1910:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 209035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209041 */     GIR_RootConstrainSelectedInstOperands,
     /* 209042 */     // GIR_Coverage, 11861,
     /* 209042 */     GIR_EraseRootFromParent_Done,
     /* 209043 */   // Label 3997: @209043
     /* 209043 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(209080), // Rule ID 11862 //
     /* 209048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 209056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209069 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 209072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209078 */     GIR_RootConstrainSelectedInstOperands,
     /* 209079 */     // GIR_Coverage, 11862,
     /* 209079 */     GIR_EraseRootFromParent_Done,
     /* 209080 */   // Label 3998: @209080
     /* 209080 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(209117), // Rule ID 11863 //
     /* 209085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 209093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209106 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 209109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209115 */     GIR_RootConstrainSelectedInstOperands,
     /* 209116 */     // GIR_Coverage, 11863,
     /* 209116 */     GIR_EraseRootFromParent_Done,
     /* 209117 */   // Label 3999: @209117
     /* 209117 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(209154), // Rule ID 11864 //
     /* 209122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 209130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 209146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209152 */     GIR_RootConstrainSelectedInstOperands,
     /* 209153 */     // GIR_Coverage, 11864,
     /* 209153 */     GIR_EraseRootFromParent_Done,
     /* 209154 */   // Label 4000: @209154
     /* 209154 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(209191), // Rule ID 11880 //
     /* 209159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 209167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2052:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 209183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209189 */     GIR_RootConstrainSelectedInstOperands,
     /* 209190 */     // GIR_Coverage, 11880,
     /* 209190 */     GIR_EraseRootFromParent_Done,
     /* 209191 */   // Label 4001: @209191
     /* 209191 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(209228), // Rule ID 11881 //
     /* 209196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 209204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209217 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2052:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 209220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209226 */     GIR_RootConstrainSelectedInstOperands,
     /* 209227 */     // GIR_Coverage, 11881,
     /* 209227 */     GIR_EraseRootFromParent_Done,
     /* 209228 */   // Label 4002: @209228
     /* 209228 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(209265), // Rule ID 11882 //
     /* 209233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 209241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209254 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2052:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 209257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209263 */     GIR_RootConstrainSelectedInstOperands,
     /* 209264 */     // GIR_Coverage, 11882,
     /* 209264 */     GIR_EraseRootFromParent_Done,
     /* 209265 */   // Label 4003: @209265
     /* 209265 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(209302), // Rule ID 11883 //
     /* 209270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 209278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209291 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1861:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 209294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209300 */     GIR_RootConstrainSelectedInstOperands,
     /* 209301 */     // GIR_Coverage, 11883,
     /* 209301 */     GIR_EraseRootFromParent_Done,
     /* 209302 */   // Label 4004: @209302
     /* 209302 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(209339), // Rule ID 11884 //
     /* 209307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 209315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209328 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1861:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 209331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209337 */     GIR_RootConstrainSelectedInstOperands,
     /* 209338 */     // GIR_Coverage, 11884,
     /* 209338 */     GIR_EraseRootFromParent_Done,
     /* 209339 */   // Label 4005: @209339
     /* 209339 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(209376), // Rule ID 11885 //
     /* 209344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 209352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 209368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209374 */     GIR_RootConstrainSelectedInstOperands,
     /* 209375 */     // GIR_Coverage, 11885,
     /* 209375 */     GIR_EraseRootFromParent_Done,
     /* 209376 */   // Label 4006: @209376
     /* 209376 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(209413), // Rule ID 11901 //
     /* 209381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 209389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1875:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 209405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209411 */     GIR_RootConstrainSelectedInstOperands,
     /* 209412 */     // GIR_Coverage, 11901,
     /* 209412 */     GIR_EraseRootFromParent_Done,
     /* 209413 */   // Label 4007: @209413
     /* 209413 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(209450), // Rule ID 11902 //
     /* 209418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 209426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 209442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209448 */     GIR_RootConstrainSelectedInstOperands,
     /* 209449 */     // GIR_Coverage, 11902,
     /* 209449 */     GIR_EraseRootFromParent_Done,
     /* 209450 */   // Label 4008: @209450
     /* 209450 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(209487), // Rule ID 11903 //
     /* 209455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 209463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 209479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209485 */     GIR_RootConstrainSelectedInstOperands,
     /* 209486 */     // GIR_Coverage, 11903,
     /* 209486 */     GIR_EraseRootFromParent_Done,
     /* 209487 */   // Label 4009: @209487
     /* 209487 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(209524), // Rule ID 11904 //
     /* 209492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 209500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209513 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1877:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 209516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209522 */     GIR_RootConstrainSelectedInstOperands,
     /* 209523 */     // GIR_Coverage, 11904,
     /* 209523 */     GIR_EraseRootFromParent_Done,
     /* 209524 */   // Label 4010: @209524
     /* 209524 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(209561), // Rule ID 11905 //
     /* 209529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 209537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1877:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 209553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209559 */     GIR_RootConstrainSelectedInstOperands,
     /* 209560 */     // GIR_Coverage, 11905,
     /* 209560 */     GIR_EraseRootFromParent_Done,
     /* 209561 */   // Label 4011: @209561
     /* 209561 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(209598), // Rule ID 11906 //
     /* 209566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 209574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209587 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1877:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 209590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209596 */     GIR_RootConstrainSelectedInstOperands,
     /* 209597 */     // GIR_Coverage, 11906,
     /* 209597 */     GIR_EraseRootFromParent_Done,
     /* 209598 */   // Label 4012: @209598
     /* 209598 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(209638), // Rule ID 11993 //
     /* 209603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 209611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209624 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 209627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209636 */     GIR_RootConstrainSelectedInstOperands,
     /* 209637 */     // GIR_Coverage, 11993,
     /* 209637 */     GIR_EraseRootFromParent_Done,
     /* 209638 */   // Label 4013: @209638
     /* 209638 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(209678), // Rule ID 11994 //
     /* 209643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 209651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 209654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 209667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209676 */     GIR_RootConstrainSelectedInstOperands,
     /* 209677 */     // GIR_Coverage, 11994,
     /* 209677 */     GIR_EraseRootFromParent_Done,
     /* 209678 */   // Label 4014: @209678
     /* 209678 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(209718), // Rule ID 11995 //
     /* 209683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 209691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 209694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209704 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 209707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209713 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209716 */     GIR_RootConstrainSelectedInstOperands,
     /* 209717 */     // GIR_Coverage, 11995,
     /* 209717 */     GIR_EraseRootFromParent_Done,
     /* 209718 */   // Label 4015: @209718
     /* 209718 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(209758), // Rule ID 11996 //
     /* 209723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 209731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 209734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209744 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 209747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209756 */     GIR_RootConstrainSelectedInstOperands,
     /* 209757 */     // GIR_Coverage, 11996,
     /* 209757 */     GIR_EraseRootFromParent_Done,
     /* 209758 */   // Label 4016: @209758
     /* 209758 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(209798), // Rule ID 11997 //
     /* 209763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 209771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209784 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 209787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209796 */     GIR_RootConstrainSelectedInstOperands,
     /* 209797 */     // GIR_Coverage, 11997,
     /* 209797 */     GIR_EraseRootFromParent_Done,
     /* 209798 */   // Label 4017: @209798
     /* 209798 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(209838), // Rule ID 11998 //
     /* 209803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 209811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 209814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 209827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209836 */     GIR_RootConstrainSelectedInstOperands,
     /* 209837 */     // GIR_Coverage, 11998,
     /* 209837 */     GIR_EraseRootFromParent_Done,
     /* 209838 */   // Label 4018: @209838
     /* 209838 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(209878), // Rule ID 11999 //
     /* 209843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 209851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 209854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 209867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209876 */     GIR_RootConstrainSelectedInstOperands,
     /* 209877 */     // GIR_Coverage, 11999,
     /* 209877 */     GIR_EraseRootFromParent_Done,
     /* 209878 */   // Label 4019: @209878
     /* 209878 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(209918), // Rule ID 12000 //
     /* 209883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 209891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 209894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209904 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 209907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209916 */     GIR_RootConstrainSelectedInstOperands,
     /* 209917 */     // GIR_Coverage, 12000,
     /* 209917 */     GIR_EraseRootFromParent_Done,
     /* 209918 */   // Label 4020: @209918
     /* 209918 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(209958), // Rule ID 12005 //
     /* 209923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 209931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209944 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 209947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209956 */     GIR_RootConstrainSelectedInstOperands,
     /* 209957 */     // GIR_Coverage, 12005,
     /* 209957 */     GIR_EraseRootFromParent_Done,
     /* 209958 */   // Label 4021: @209958
     /* 209958 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(209998), // Rule ID 12006 //
     /* 209963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 209971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 209974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209984 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 209987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209996 */     GIR_RootConstrainSelectedInstOperands,
     /* 209997 */     // GIR_Coverage, 12006,
     /* 209997 */     GIR_EraseRootFromParent_Done,
     /* 209998 */   // Label 4022: @209998
     /* 209998 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(210038), // Rule ID 12007 //
     /* 210003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210024 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 210027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210036 */     GIR_RootConstrainSelectedInstOperands,
     /* 210037 */     // GIR_Coverage, 12007,
     /* 210037 */     GIR_EraseRootFromParent_Done,
     /* 210038 */   // Label 4023: @210038
     /* 210038 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(210078), // Rule ID 12008 //
     /* 210043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210064 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 210067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210076 */     GIR_RootConstrainSelectedInstOperands,
     /* 210077 */     // GIR_Coverage, 12008,
     /* 210077 */     GIR_EraseRootFromParent_Done,
     /* 210078 */   // Label 4024: @210078
     /* 210078 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(210118), // Rule ID 12009 //
     /* 210083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210104 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 210107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210116 */     GIR_RootConstrainSelectedInstOperands,
     /* 210117 */     // GIR_Coverage, 12009,
     /* 210117 */     GIR_EraseRootFromParent_Done,
     /* 210118 */   // Label 4025: @210118
     /* 210118 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(210158), // Rule ID 12010 //
     /* 210123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210144 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 210147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210156 */     GIR_RootConstrainSelectedInstOperands,
     /* 210157 */     // GIR_Coverage, 12010,
     /* 210157 */     GIR_EraseRootFromParent_Done,
     /* 210158 */   // Label 4026: @210158
     /* 210158 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(210198), // Rule ID 12011 //
     /* 210163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210184 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 210187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210196 */     GIR_RootConstrainSelectedInstOperands,
     /* 210197 */     // GIR_Coverage, 12011,
     /* 210197 */     GIR_EraseRootFromParent_Done,
     /* 210198 */   // Label 4027: @210198
     /* 210198 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(210238), // Rule ID 12012 //
     /* 210203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210224 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 210227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210236 */     GIR_RootConstrainSelectedInstOperands,
     /* 210237 */     // GIR_Coverage, 12012,
     /* 210237 */     GIR_EraseRootFromParent_Done,
     /* 210238 */   // Label 4028: @210238
     /* 210238 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(210278), // Rule ID 12017 //
     /* 210243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 210251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210264 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 210267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210276 */     GIR_RootConstrainSelectedInstOperands,
     /* 210277 */     // GIR_Coverage, 12017,
     /* 210277 */     GIR_EraseRootFromParent_Done,
     /* 210278 */   // Label 4029: @210278
     /* 210278 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(210318), // Rule ID 12018 //
     /* 210283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 210291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210304 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 210307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210316 */     GIR_RootConstrainSelectedInstOperands,
     /* 210317 */     // GIR_Coverage, 12018,
     /* 210317 */     GIR_EraseRootFromParent_Done,
     /* 210318 */   // Label 4030: @210318
     /* 210318 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(210358), // Rule ID 12019 //
     /* 210323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 210331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 210347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210356 */     GIR_RootConstrainSelectedInstOperands,
     /* 210357 */     // GIR_Coverage, 12019,
     /* 210357 */     GIR_EraseRootFromParent_Done,
     /* 210358 */   // Label 4031: @210358
     /* 210358 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(210398), // Rule ID 12020 //
     /* 210363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 210371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210384 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 210387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210396 */     GIR_RootConstrainSelectedInstOperands,
     /* 210397 */     // GIR_Coverage, 12020,
     /* 210397 */     GIR_EraseRootFromParent_Done,
     /* 210398 */   // Label 4032: @210398
     /* 210398 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(210438), // Rule ID 12021 //
     /* 210403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 210411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210424 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 210427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210436 */     GIR_RootConstrainSelectedInstOperands,
     /* 210437 */     // GIR_Coverage, 12021,
     /* 210437 */     GIR_EraseRootFromParent_Done,
     /* 210438 */   // Label 4033: @210438
     /* 210438 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(210478), // Rule ID 12022 //
     /* 210443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 210451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210464 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 210467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210476 */     GIR_RootConstrainSelectedInstOperands,
     /* 210477 */     // GIR_Coverage, 12022,
     /* 210477 */     GIR_EraseRootFromParent_Done,
     /* 210478 */   // Label 4034: @210478
     /* 210478 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(210518), // Rule ID 12023 //
     /* 210483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 210491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 210507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210516 */     GIR_RootConstrainSelectedInstOperands,
     /* 210517 */     // GIR_Coverage, 12023,
     /* 210517 */     GIR_EraseRootFromParent_Done,
     /* 210518 */   // Label 4035: @210518
     /* 210518 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(210558), // Rule ID 12024 //
     /* 210523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 210531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 210547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210556 */     GIR_RootConstrainSelectedInstOperands,
     /* 210557 */     // GIR_Coverage, 12024,
     /* 210557 */     GIR_EraseRootFromParent_Done,
     /* 210558 */   // Label 4036: @210558
     /* 210558 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(210598), // Rule ID 12029 //
     /* 210563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210584 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 210587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210596 */     GIR_RootConstrainSelectedInstOperands,
     /* 210597 */     // GIR_Coverage, 12029,
     /* 210597 */     GIR_EraseRootFromParent_Done,
     /* 210598 */   // Label 4037: @210598
     /* 210598 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(210638), // Rule ID 12030 //
     /* 210603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210624 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 210627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210636 */     GIR_RootConstrainSelectedInstOperands,
     /* 210637 */     // GIR_Coverage, 12030,
     /* 210637 */     GIR_EraseRootFromParent_Done,
     /* 210638 */   // Label 4038: @210638
     /* 210638 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(210678), // Rule ID 12031 //
     /* 210643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210664 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 210667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210676 */     GIR_RootConstrainSelectedInstOperands,
     /* 210677 */     // GIR_Coverage, 12031,
     /* 210677 */     GIR_EraseRootFromParent_Done,
     /* 210678 */   // Label 4039: @210678
     /* 210678 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(210718), // Rule ID 12032 //
     /* 210683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 210707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210713 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210716 */     GIR_RootConstrainSelectedInstOperands,
     /* 210717 */     // GIR_Coverage, 12032,
     /* 210717 */     GIR_EraseRootFromParent_Done,
     /* 210718 */   // Label 4040: @210718
     /* 210718 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(210758), // Rule ID 12033 //
     /* 210723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 210747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210756 */     GIR_RootConstrainSelectedInstOperands,
     /* 210757 */     // GIR_Coverage, 12033,
     /* 210757 */     GIR_EraseRootFromParent_Done,
     /* 210758 */   // Label 4041: @210758
     /* 210758 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(210798), // Rule ID 12034 //
     /* 210763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210784 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 210787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210796 */     GIR_RootConstrainSelectedInstOperands,
     /* 210797 */     // GIR_Coverage, 12034,
     /* 210797 */     GIR_EraseRootFromParent_Done,
     /* 210798 */   // Label 4042: @210798
     /* 210798 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(210838), // Rule ID 12035 //
     /* 210803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 210827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210836 */     GIR_RootConstrainSelectedInstOperands,
     /* 210837 */     // GIR_Coverage, 12035,
     /* 210837 */     GIR_EraseRootFromParent_Done,
     /* 210838 */   // Label 4043: @210838
     /* 210838 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(210878), // Rule ID 12036 //
     /* 210843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210864 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 210867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210876 */     GIR_RootConstrainSelectedInstOperands,
     /* 210877 */     // GIR_Coverage, 12036,
     /* 210877 */     GIR_EraseRootFromParent_Done,
     /* 210878 */   // Label 4044: @210878
     /* 210878 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(210915), // Rule ID 12045 //
     /* 210883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 210886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 210891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210904 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1265:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 210907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210913 */     GIR_RootConstrainSelectedInstOperands,
     /* 210914 */     // GIR_Coverage, 12045,
     /* 210914 */     GIR_EraseRootFromParent_Done,
     /* 210915 */   // Label 4045: @210915
     /* 210915 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(210952), // Rule ID 12047 //
     /* 210920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 210923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 210928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210941 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1639:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 210944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210950 */     GIR_RootConstrainSelectedInstOperands,
     /* 210951 */     // GIR_Coverage, 12047,
     /* 210951 */     GIR_EraseRootFromParent_Done,
     /* 210952 */   // Label 4046: @210952
     /* 210952 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(210989), // Rule ID 12048 //
     /* 210957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 210960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 210965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210978 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 210981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210987 */     GIR_RootConstrainSelectedInstOperands,
     /* 210988 */     // GIR_Coverage, 12048,
     /* 210988 */     GIR_EraseRootFromParent_Done,
     /* 210989 */   // Label 4047: @210989
     /* 210989 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(211026), // Rule ID 12049 //
     /* 210994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 210997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 211002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1671:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 211018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211024 */     GIR_RootConstrainSelectedInstOperands,
     /* 211025 */     // GIR_Coverage, 12049,
     /* 211025 */     GIR_EraseRootFromParent_Done,
     /* 211026 */   // Label 4048: @211026
     /* 211026 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(211063), // Rule ID 12050 //
     /* 211031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 211039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1279:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 211055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211061 */     GIR_RootConstrainSelectedInstOperands,
     /* 211062 */     // GIR_Coverage, 12050,
     /* 211062 */     GIR_EraseRootFromParent_Done,
     /* 211063 */   // Label 4049: @211063
     /* 211063 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(211100), // Rule ID 12051 //
     /* 211068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 211076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1279:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 211092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211098 */     GIR_RootConstrainSelectedInstOperands,
     /* 211099 */     // GIR_Coverage, 12051,
     /* 211099 */     GIR_EraseRootFromParent_Done,
     /* 211100 */   // Label 4050: @211100
     /* 211100 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(211137), // Rule ID 12052 //
     /* 211105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 211113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1279:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 211129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211135 */     GIR_RootConstrainSelectedInstOperands,
     /* 211136 */     // GIR_Coverage, 12052,
     /* 211136 */     GIR_EraseRootFromParent_Done,
     /* 211137 */   // Label 4051: @211137
     /* 211137 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(211174), // Rule ID 12053 //
     /* 211142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 211150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211163 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1279:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 211166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211172 */     GIR_RootConstrainSelectedInstOperands,
     /* 211173 */     // GIR_Coverage, 12053,
     /* 211173 */     GIR_EraseRootFromParent_Done,
     /* 211174 */   // Label 4052: @211174
     /* 211174 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(211211), // Rule ID 12054 //
     /* 211179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 211187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1296:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 211203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211209 */     GIR_RootConstrainSelectedInstOperands,
     /* 211210 */     // GIR_Coverage, 12054,
     /* 211210 */     GIR_EraseRootFromParent_Done,
     /* 211211 */   // Label 4053: @211211
     /* 211211 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(211248), // Rule ID 12055 //
     /* 211216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 211224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211237 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1296:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 211240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211246 */     GIR_RootConstrainSelectedInstOperands,
     /* 211247 */     // GIR_Coverage, 12055,
     /* 211247 */     GIR_EraseRootFromParent_Done,
     /* 211248 */   // Label 4054: @211248
     /* 211248 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(211285), // Rule ID 12056 //
     /* 211253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 211261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1296:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 211277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211283 */     GIR_RootConstrainSelectedInstOperands,
     /* 211284 */     // GIR_Coverage, 12056,
     /* 211284 */     GIR_EraseRootFromParent_Done,
     /* 211285 */   // Label 4055: @211285
     /* 211285 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(211322), // Rule ID 12057 //
     /* 211290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 211298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1296:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 211314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211320 */     GIR_RootConstrainSelectedInstOperands,
     /* 211321 */     // GIR_Coverage, 12057,
     /* 211321 */     GIR_EraseRootFromParent_Done,
     /* 211322 */   // Label 4056: @211322
     /* 211322 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(211359), // Rule ID 12170 //
     /* 211327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 211335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211348 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1445:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 211348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 211351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211357 */     GIR_RootConstrainSelectedInstOperands,
     /* 211358 */     // GIR_Coverage, 12170,
     /* 211358 */     GIR_EraseRootFromParent_Done,
     /* 211359 */   // Label 4057: @211359
     /* 211359 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(211396), // Rule ID 12171 //
     /* 211364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 211372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211385 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1445:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 211385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 211388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211394 */     GIR_RootConstrainSelectedInstOperands,
     /* 211395 */     // GIR_Coverage, 12171,
     /* 211395 */     GIR_EraseRootFromParent_Done,
     /* 211396 */   // Label 4058: @211396
     /* 211396 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(211433), // Rule ID 12172 //
     /* 211401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 211409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211422 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1445:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 211422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 211425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211431 */     GIR_RootConstrainSelectedInstOperands,
     /* 211432 */     // GIR_Coverage, 12172,
     /* 211432 */     GIR_EraseRootFromParent_Done,
     /* 211433 */   // Label 4059: @211433
     /* 211433 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(211470), // Rule ID 12173 //
     /* 211438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 211446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211459 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1463:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 211459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 211462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211468 */     GIR_RootConstrainSelectedInstOperands,
     /* 211469 */     // GIR_Coverage, 12173,
     /* 211469 */     GIR_EraseRootFromParent_Done,
     /* 211470 */   // Label 4060: @211470
     /* 211470 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(211507), // Rule ID 12174 //
     /* 211475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 211483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211496 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1463:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 211496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 211499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211505 */     GIR_RootConstrainSelectedInstOperands,
     /* 211506 */     // GIR_Coverage, 12174,
     /* 211506 */     GIR_EraseRootFromParent_Done,
     /* 211507 */   // Label 4061: @211507
     /* 211507 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(211544), // Rule ID 12175 //
     /* 211512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 211520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211533 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1463:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 211533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 211536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211542 */     GIR_RootConstrainSelectedInstOperands,
     /* 211543 */     // GIR_Coverage, 12175,
     /* 211543 */     GIR_EraseRootFromParent_Done,
     /* 211544 */   // Label 4062: @211544
     /* 211544 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(211581), // Rule ID 12176 //
     /* 211549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 211557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211570 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1448:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 211570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 211573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211579 */     GIR_RootConstrainSelectedInstOperands,
     /* 211580 */     // GIR_Coverage, 12176,
     /* 211580 */     GIR_EraseRootFromParent_Done,
     /* 211581 */   // Label 4063: @211581
     /* 211581 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(211618), // Rule ID 12177 //
     /* 211586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 211594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211607 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1448:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 211607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 211610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211616 */     GIR_RootConstrainSelectedInstOperands,
     /* 211617 */     // GIR_Coverage, 12177,
     /* 211617 */     GIR_EraseRootFromParent_Done,
     /* 211618 */   // Label 4064: @211618
     /* 211618 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(211655), // Rule ID 12178 //
     /* 211623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 211631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211644 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1448:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 211644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 211647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211653 */     GIR_RootConstrainSelectedInstOperands,
     /* 211654 */     // GIR_Coverage, 12178,
     /* 211654 */     GIR_EraseRootFromParent_Done,
     /* 211655 */   // Label 4065: @211655
     /* 211655 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(211692), // Rule ID 12179 //
     /* 211660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 211668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211681 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1466:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 211681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 211684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211690 */     GIR_RootConstrainSelectedInstOperands,
     /* 211691 */     // GIR_Coverage, 12179,
     /* 211691 */     GIR_EraseRootFromParent_Done,
     /* 211692 */   // Label 4066: @211692
     /* 211692 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(211729), // Rule ID 12180 //
     /* 211697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 211705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211718 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1466:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 211718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 211721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211727 */     GIR_RootConstrainSelectedInstOperands,
     /* 211728 */     // GIR_Coverage, 12180,
     /* 211728 */     GIR_EraseRootFromParent_Done,
     /* 211729 */   // Label 4067: @211729
     /* 211729 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(211766), // Rule ID 12181 //
     /* 211734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 211742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211755 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1466:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 211755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 211758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211764 */     GIR_RootConstrainSelectedInstOperands,
     /* 211765 */     // GIR_Coverage, 12181,
     /* 211765 */     GIR_EraseRootFromParent_Done,
     /* 211766 */   // Label 4068: @211766
     /* 211766 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(211803), // Rule ID 12182 //
     /* 211771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 211779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 211782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211792 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1360:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 211795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211801 */     GIR_RootConstrainSelectedInstOperands,
     /* 211802 */     // GIR_Coverage, 12182,
     /* 211802 */     GIR_EraseRootFromParent_Done,
     /* 211803 */   // Label 4069: @211803
     /* 211803 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(211840), // Rule ID 12183 //
     /* 211808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 211816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211829 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1360:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 211832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211838 */     GIR_RootConstrainSelectedInstOperands,
     /* 211839 */     // GIR_Coverage, 12183,
     /* 211839 */     GIR_EraseRootFromParent_Done,
     /* 211840 */   // Label 4070: @211840
     /* 211840 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(211877), // Rule ID 12184 //
     /* 211845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 211853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211866 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1360:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 211869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211875 */     GIR_RootConstrainSelectedInstOperands,
     /* 211876 */     // GIR_Coverage, 12184,
     /* 211876 */     GIR_EraseRootFromParent_Done,
     /* 211877 */   // Label 4071: @211877
     /* 211877 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(211914), // Rule ID 12185 //
     /* 211882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 211890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211903 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 211906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211912 */     GIR_RootConstrainSelectedInstOperands,
     /* 211913 */     // GIR_Coverage, 12185,
     /* 211913 */     GIR_EraseRootFromParent_Done,
     /* 211914 */   // Label 4072: @211914
     /* 211914 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(211951), // Rule ID 12186 //
     /* 211919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 211927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 211930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211940 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1272:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 211943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211949 */     GIR_RootConstrainSelectedInstOperands,
     /* 211950 */     // GIR_Coverage, 12186,
     /* 211950 */     GIR_EraseRootFromParent_Done,
     /* 211951 */   // Label 4073: @211951
     /* 211951 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(211988), // Rule ID 12187 //
     /* 211956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 211964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211977 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1272:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 211980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211986 */     GIR_RootConstrainSelectedInstOperands,
     /* 211987 */     // GIR_Coverage, 12187,
     /* 211987 */     GIR_EraseRootFromParent_Done,
     /* 211988 */   // Label 4074: @211988
     /* 211988 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(212025), // Rule ID 12188 //
     /* 211993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 212001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212014 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1272:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 212017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212023 */     GIR_RootConstrainSelectedInstOperands,
     /* 212024 */     // GIR_Coverage, 12188,
     /* 212024 */     GIR_EraseRootFromParent_Done,
     /* 212025 */   // Label 4075: @212025
     /* 212025 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(212062), // Rule ID 12189 //
     /* 212030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 212038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212051 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1272:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 212054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212060 */     GIR_RootConstrainSelectedInstOperands,
     /* 212061 */     // GIR_Coverage, 12189,
     /* 212061 */     GIR_EraseRootFromParent_Done,
     /* 212062 */   // Label 4076: @212062
     /* 212062 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(212099), // Rule ID 12190 //
     /* 212067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 212075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212088 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1260:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 212091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212097 */     GIR_RootConstrainSelectedInstOperands,
     /* 212098 */     // GIR_Coverage, 12190,
     /* 212098 */     GIR_EraseRootFromParent_Done,
     /* 212099 */   // Label 4077: @212099
     /* 212099 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(212136), // Rule ID 12191 //
     /* 212104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 212112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212125 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1260:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 212128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212134 */     GIR_RootConstrainSelectedInstOperands,
     /* 212135 */     // GIR_Coverage, 12191,
     /* 212135 */     GIR_EraseRootFromParent_Done,
     /* 212136 */   // Label 4078: @212136
     /* 212136 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(212173), // Rule ID 12192 //
     /* 212141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 212149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212162 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1260:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 212165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212171 */     GIR_RootConstrainSelectedInstOperands,
     /* 212172 */     // GIR_Coverage, 12192,
     /* 212172 */     GIR_EraseRootFromParent_Done,
     /* 212173 */   // Label 4079: @212173
     /* 212173 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(212210), // Rule ID 12193 //
     /* 212178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 212186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212199 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1260:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 212202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212208 */     GIR_RootConstrainSelectedInstOperands,
     /* 212209 */     // GIR_Coverage, 12193,
     /* 212209 */     GIR_EraseRootFromParent_Done,
     /* 212210 */   // Label 4080: @212210
     /* 212210 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(212247), // Rule ID 12194 //
     /* 212215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 212223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212236 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1739:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 212239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212245 */     GIR_RootConstrainSelectedInstOperands,
     /* 212246 */     // GIR_Coverage, 12194,
     /* 212246 */     GIR_EraseRootFromParent_Done,
     /* 212247 */   // Label 4081: @212247
     /* 212247 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(212284), // Rule ID 12195 //
     /* 212252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 212260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212273 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1739:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 212276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212282 */     GIR_RootConstrainSelectedInstOperands,
     /* 212283 */     // GIR_Coverage, 12195,
     /* 212283 */     GIR_EraseRootFromParent_Done,
     /* 212284 */   // Label 4082: @212284
     /* 212284 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(212321), // Rule ID 12196 //
     /* 212289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 212297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212310 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1739:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 212313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212319 */     GIR_RootConstrainSelectedInstOperands,
     /* 212320 */     // GIR_Coverage, 12196,
     /* 212320 */     GIR_EraseRootFromParent_Done,
     /* 212321 */   // Label 4083: @212321
     /* 212321 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(212358), // Rule ID 12197 //
     /* 212326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 212334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212347 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1739:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 212350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212356 */     GIR_RootConstrainSelectedInstOperands,
     /* 212357 */     // GIR_Coverage, 12197,
     /* 212357 */     GIR_EraseRootFromParent_Done,
     /* 212358 */   // Label 4084: @212358
     /* 212358 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(212395), // Rule ID 12198 //
     /* 212363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 212371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212384 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1977:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 212387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212393 */     GIR_RootConstrainSelectedInstOperands,
     /* 212394 */     // GIR_Coverage, 12198,
     /* 212394 */     GIR_EraseRootFromParent_Done,
     /* 212395 */   // Label 4085: @212395
     /* 212395 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(212432), // Rule ID 12199 //
     /* 212400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 212408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212421 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1977:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 212424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212430 */     GIR_RootConstrainSelectedInstOperands,
     /* 212431 */     // GIR_Coverage, 12199,
     /* 212431 */     GIR_EraseRootFromParent_Done,
     /* 212432 */   // Label 4086: @212432
     /* 212432 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(212469), // Rule ID 12200 //
     /* 212437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 212445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212458 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1977:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 212461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212467 */     GIR_RootConstrainSelectedInstOperands,
     /* 212468 */     // GIR_Coverage, 12200,
     /* 212468 */     GIR_EraseRootFromParent_Done,
     /* 212469 */   // Label 4087: @212469
     /* 212469 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(212506), // Rule ID 12201 //
     /* 212474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 212482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212495 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1977:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 212498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212504 */     GIR_RootConstrainSelectedInstOperands,
     /* 212505 */     // GIR_Coverage, 12201,
     /* 212505 */     GIR_EraseRootFromParent_Done,
     /* 212506 */   // Label 4088: @212506
     /* 212506 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(212543), // Rule ID 12202 //
     /* 212511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 212519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212532 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1748:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 212535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212541 */     GIR_RootConstrainSelectedInstOperands,
     /* 212542 */     // GIR_Coverage, 12202,
     /* 212542 */     GIR_EraseRootFromParent_Done,
     /* 212543 */   // Label 4089: @212543
     /* 212543 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(212580), // Rule ID 12203 //
     /* 212548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 212556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212569 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1748:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 212572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212578 */     GIR_RootConstrainSelectedInstOperands,
     /* 212579 */     // GIR_Coverage, 12203,
     /* 212579 */     GIR_EraseRootFromParent_Done,
     /* 212580 */   // Label 4090: @212580
     /* 212580 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(212617), // Rule ID 12204 //
     /* 212585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 212593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212606 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1748:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 212609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212615 */     GIR_RootConstrainSelectedInstOperands,
     /* 212616 */     // GIR_Coverage, 12204,
     /* 212616 */     GIR_EraseRootFromParent_Done,
     /* 212617 */   // Label 4091: @212617
     /* 212617 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(212654), // Rule ID 12205 //
     /* 212622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 212630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212643 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1748:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 212646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212652 */     GIR_RootConstrainSelectedInstOperands,
     /* 212653 */     // GIR_Coverage, 12205,
     /* 212653 */     GIR_EraseRootFromParent_Done,
     /* 212654 */   // Label 4092: @212654
     /* 212654 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(212691), // Rule ID 12206 //
     /* 212659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 212667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212680 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1986:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 212683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212689 */     GIR_RootConstrainSelectedInstOperands,
     /* 212690 */     // GIR_Coverage, 12206,
     /* 212690 */     GIR_EraseRootFromParent_Done,
     /* 212691 */   // Label 4093: @212691
     /* 212691 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(212728), // Rule ID 12207 //
     /* 212696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 212704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212717 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1986:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 212720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212726 */     GIR_RootConstrainSelectedInstOperands,
     /* 212727 */     // GIR_Coverage, 12207,
     /* 212727 */     GIR_EraseRootFromParent_Done,
     /* 212728 */   // Label 4094: @212728
     /* 212728 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(212765), // Rule ID 12208 //
     /* 212733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 212741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212754 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1986:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 212757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212763 */     GIR_RootConstrainSelectedInstOperands,
     /* 212764 */     // GIR_Coverage, 12208,
     /* 212764 */     GIR_EraseRootFromParent_Done,
     /* 212765 */   // Label 4095: @212765
     /* 212765 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(212802), // Rule ID 12209 //
     /* 212770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 212778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212791 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1986:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 212794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212800 */     GIR_RootConstrainSelectedInstOperands,
     /* 212801 */     // GIR_Coverage, 12209,
     /* 212801 */     GIR_EraseRootFromParent_Done,
     /* 212802 */   // Label 4096: @212802
     /* 212802 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(212839), // Rule ID 12210 //
     /* 212807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 212815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212828 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2170:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 212831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212837 */     GIR_RootConstrainSelectedInstOperands,
     /* 212838 */     // GIR_Coverage, 12210,
     /* 212838 */     GIR_EraseRootFromParent_Done,
     /* 212839 */   // Label 4097: @212839
     /* 212839 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(212876), // Rule ID 12211 //
     /* 212844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 212852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212865 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2170:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 212868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212874 */     GIR_RootConstrainSelectedInstOperands,
     /* 212875 */     // GIR_Coverage, 12211,
     /* 212875 */     GIR_EraseRootFromParent_Done,
     /* 212876 */   // Label 4098: @212876
     /* 212876 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(212913), // Rule ID 12212 //
     /* 212881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 212889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2170:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 212905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212911 */     GIR_RootConstrainSelectedInstOperands,
     /* 212912 */     // GIR_Coverage, 12212,
     /* 212912 */     GIR_EraseRootFromParent_Done,
     /* 212913 */   // Label 4099: @212913
     /* 212913 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(212950), // Rule ID 12213 //
     /* 212918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 212926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212939 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2170:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 212942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212948 */     GIR_RootConstrainSelectedInstOperands,
     /* 212949 */     // GIR_Coverage, 12213,
     /* 212949 */     GIR_EraseRootFromParent_Done,
     /* 212950 */   // Label 4100: @212950
     /* 212950 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(212987), // Rule ID 12214 //
     /* 212955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 212963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212976 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2170:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 212976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 212979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212985 */     GIR_RootConstrainSelectedInstOperands,
     /* 212986 */     // GIR_Coverage, 12214,
     /* 212986 */     GIR_EraseRootFromParent_Done,
     /* 212987 */   // Label 4101: @212987
     /* 212987 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(213024), // Rule ID 12215 //
     /* 212992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 213000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213013 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2170:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 213016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213022 */     GIR_RootConstrainSelectedInstOperands,
     /* 213023 */     // GIR_Coverage, 12215,
     /* 213023 */     GIR_EraseRootFromParent_Done,
     /* 213024 */   // Label 4102: @213024
     /* 213024 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(213061), // Rule ID 12216 //
     /* 213029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 213037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213050 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2170:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 213053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213059 */     GIR_RootConstrainSelectedInstOperands,
     /* 213060 */     // GIR_Coverage, 12216,
     /* 213060 */     GIR_EraseRootFromParent_Done,
     /* 213061 */   // Label 4103: @213061
     /* 213061 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(213098), // Rule ID 12217 //
     /* 213066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213087 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2095:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 213090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213096 */     GIR_RootConstrainSelectedInstOperands,
     /* 213097 */     // GIR_Coverage, 12217,
     /* 213097 */     GIR_EraseRootFromParent_Done,
     /* 213098 */   // Label 4104: @213098
     /* 213098 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(213135), // Rule ID 12218 //
     /* 213103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2095:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 213127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213133 */     GIR_RootConstrainSelectedInstOperands,
     /* 213134 */     // GIR_Coverage, 12218,
     /* 213134 */     GIR_EraseRootFromParent_Done,
     /* 213135 */   // Label 4105: @213135
     /* 213135 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(213172), // Rule ID 12219 //
     /* 213140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2095:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 213164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213170 */     GIR_RootConstrainSelectedInstOperands,
     /* 213171 */     // GIR_Coverage, 12219,
     /* 213171 */     GIR_EraseRootFromParent_Done,
     /* 213172 */   // Label 4106: @213172
     /* 213172 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(213209), // Rule ID 12220 //
     /* 213177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2095:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 213201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213207 */     GIR_RootConstrainSelectedInstOperands,
     /* 213208 */     // GIR_Coverage, 12220,
     /* 213208 */     GIR_EraseRootFromParent_Done,
     /* 213209 */   // Label 4107: @213209
     /* 213209 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(213246), // Rule ID 12221 //
     /* 213214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213235 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2095:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 213238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213244 */     GIR_RootConstrainSelectedInstOperands,
     /* 213245 */     // GIR_Coverage, 12221,
     /* 213245 */     GIR_EraseRootFromParent_Done,
     /* 213246 */   // Label 4108: @213246
     /* 213246 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(213283), // Rule ID 12222 //
     /* 213251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213272 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2095:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 213275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213281 */     GIR_RootConstrainSelectedInstOperands,
     /* 213282 */     // GIR_Coverage, 12222,
     /* 213282 */     GIR_EraseRootFromParent_Done,
     /* 213283 */   // Label 4109: @213283
     /* 213283 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(213320), // Rule ID 12223 //
     /* 213288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213309 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2095:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 213312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213318 */     GIR_RootConstrainSelectedInstOperands,
     /* 213319 */     // GIR_Coverage, 12223,
     /* 213319 */     GIR_EraseRootFromParent_Done,
     /* 213320 */   // Label 4110: @213320
     /* 213320 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(213357), // Rule ID 12224 //
     /* 213325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2096:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 213349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213355 */     GIR_RootConstrainSelectedInstOperands,
     /* 213356 */     // GIR_Coverage, 12224,
     /* 213356 */     GIR_EraseRootFromParent_Done,
     /* 213357 */   // Label 4111: @213357
     /* 213357 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(213394), // Rule ID 12225 //
     /* 213362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2096:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 213386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213392 */     GIR_RootConstrainSelectedInstOperands,
     /* 213393 */     // GIR_Coverage, 12225,
     /* 213393 */     GIR_EraseRootFromParent_Done,
     /* 213394 */   // Label 4112: @213394
     /* 213394 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(213431), // Rule ID 12226 //
     /* 213399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2096:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 213423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213429 */     GIR_RootConstrainSelectedInstOperands,
     /* 213430 */     // GIR_Coverage, 12226,
     /* 213430 */     GIR_EraseRootFromParent_Done,
     /* 213431 */   // Label 4113: @213431
     /* 213431 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(213468), // Rule ID 12227 //
     /* 213436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213457 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2096:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 213460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213466 */     GIR_RootConstrainSelectedInstOperands,
     /* 213467 */     // GIR_Coverage, 12227,
     /* 213467 */     GIR_EraseRootFromParent_Done,
     /* 213468 */   // Label 4114: @213468
     /* 213468 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(213505), // Rule ID 12228 //
     /* 213473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213494 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2096:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 213497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213503 */     GIR_RootConstrainSelectedInstOperands,
     /* 213504 */     // GIR_Coverage, 12228,
     /* 213504 */     GIR_EraseRootFromParent_Done,
     /* 213505 */   // Label 4115: @213505
     /* 213505 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(213542), // Rule ID 12229 //
     /* 213510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213531 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2096:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 213534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213540 */     GIR_RootConstrainSelectedInstOperands,
     /* 213541 */     // GIR_Coverage, 12229,
     /* 213541 */     GIR_EraseRootFromParent_Done,
     /* 213542 */   // Label 4116: @213542
     /* 213542 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(213579), // Rule ID 12230 //
     /* 213547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213568 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2096:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 213571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213577 */     GIR_RootConstrainSelectedInstOperands,
     /* 213578 */     // GIR_Coverage, 12230,
     /* 213578 */     GIR_EraseRootFromParent_Done,
     /* 213579 */   // Label 4117: @213579
     /* 213579 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(213621), // Rule ID 3211 //
     /* 213584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 213592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213599 */     // MIs[0] Op1
     /* 213599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213603 */     // MIs[0] Op2
     /* 213603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213607 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2149:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 213610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213619 */     GIR_RootConstrainSelectedInstOperands,
     /* 213620 */     // GIR_Coverage, 3211,
     /* 213620 */     GIR_EraseRootFromParent_Done,
     /* 213621 */   // Label 4118: @213621
     /* 213621 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(213663), // Rule ID 3212 //
     /* 213626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 213634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213641 */     // MIs[0] Op1
     /* 213641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213645 */     // MIs[0] Op2
     /* 213645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213649 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2151:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 213652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213661 */     GIR_RootConstrainSelectedInstOperands,
     /* 213662 */     // GIR_Coverage, 3212,
     /* 213662 */     GIR_EraseRootFromParent_Done,
     /* 213663 */   // Label 4119: @213663
     /* 213663 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(213705), // Rule ID 3213 //
     /* 213668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 213676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 213679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213683 */     // MIs[0] Op1
     /* 213683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213687 */     // MIs[0] Op2
     /* 213687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213691 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2152:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 213694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213703 */     GIR_RootConstrainSelectedInstOperands,
     /* 213704 */     // GIR_Coverage, 3213,
     /* 213704 */     GIR_EraseRootFromParent_Done,
     /* 213705 */   // Label 4120: @213705
     /* 213705 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(213747), // Rule ID 3214 //
     /* 213710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 213718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 213721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213725 */     // MIs[0] Op1
     /* 213725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213729 */     // MIs[0] Op2
     /* 213729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213733 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2150:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 213736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213745 */     GIR_RootConstrainSelectedInstOperands,
     /* 213746 */     // GIR_Coverage, 3214,
     /* 213746 */     GIR_EraseRootFromParent_Done,
     /* 213747 */   // Label 4121: @213747
     /* 213747 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(213789), // Rule ID 12041 //
     /* 213752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 213760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213767 */     // MIs[0] Op1
     /* 213767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213771 */     // MIs[0] Op2
     /* 213771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213775 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2145:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 213778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213787 */     GIR_RootConstrainSelectedInstOperands,
     /* 213788 */     // GIR_Coverage, 12041,
     /* 213788 */     GIR_EraseRootFromParent_Done,
     /* 213789 */   // Label 4122: @213789
     /* 213789 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(213831), // Rule ID 12042 //
     /* 213794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 213802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213809 */     // MIs[0] Op1
     /* 213809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213813 */     // MIs[0] Op2
     /* 213813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213817 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2147:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 213820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213829 */     GIR_RootConstrainSelectedInstOperands,
     /* 213830 */     // GIR_Coverage, 12042,
     /* 213830 */     GIR_EraseRootFromParent_Done,
     /* 213831 */   // Label 4123: @213831
     /* 213831 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(213873), // Rule ID 12043 //
     /* 213836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 213844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 213847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213851 */     // MIs[0] Op1
     /* 213851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213855 */     // MIs[0] Op2
     /* 213855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213859 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2148:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 213862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213871 */     GIR_RootConstrainSelectedInstOperands,
     /* 213872 */     // GIR_Coverage, 12043,
     /* 213872 */     GIR_EraseRootFromParent_Done,
     /* 213873 */   // Label 4124: @213873
     /* 213873 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(213915), // Rule ID 12044 //
     /* 213878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 213886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 213889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213893 */     // MIs[0] Op1
     /* 213893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213897 */     // MIs[0] Op2
     /* 213897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213901 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2146:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 213904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213913 */     GIR_RootConstrainSelectedInstOperands,
     /* 213914 */     // GIR_Coverage, 12044,
     /* 213914 */     GIR_EraseRootFromParent_Done,
     /* 213915 */   // Label 4125: @213915
     /* 213915 */   GIM_Reject,
     /* 213916 */ // Label 3232: @213916
     /* 213916 */ GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(257027),
     /* 213921 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 213924 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(214037), // Rule ID 2069 //
     /* 213929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 213932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 213937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 213940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 213943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 213965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 213969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 213973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 213977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 213981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 213985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 213989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 213994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 213998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214002 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 214006 */     // MIs[3] Operand 1
     /* 214006 */     // No operand predicates
     /* 214006 */     // MIs[1] Operand 2
     /* 214006 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 214017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214019 */     // (intrinsic_wo_chain:{ *:[v4i16] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 214019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 214022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214035 */     GIR_RootConstrainSelectedInstOperands,
     /* 214036 */     // GIR_Coverage, 2069,
     /* 214036 */     GIR_EraseRootFromParent_Done,
     /* 214037 */   // Label 4127: @214037
     /* 214037 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(214150), // Rule ID 2076 //
     /* 214042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 214082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 214086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 214094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 214098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 214107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214115 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 214119 */     // MIs[3] Operand 1
     /* 214119 */     // No operand predicates
     /* 214119 */     // MIs[1] Operand 2
     /* 214119 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 214130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214132 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 214132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 214135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214148 */     GIR_RootConstrainSelectedInstOperands,
     /* 214149 */     // GIR_Coverage, 2076,
     /* 214149 */     GIR_EraseRootFromParent_Done,
     /* 214150 */   // Label 4128: @214150
     /* 214150 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(214263), // Rule ID 2072 //
     /* 214155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 214172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 214175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 214195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214228 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 214232 */     // MIs[3] Operand 1
     /* 214232 */     // No operand predicates
     /* 214232 */     // MIs[1] Operand 2
     /* 214232 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 214243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214245 */     // (intrinsic_wo_chain:{ *:[v2i32] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 214245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 214248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214261 */     GIR_RootConstrainSelectedInstOperands,
     /* 214262 */     // GIR_Coverage, 2072,
     /* 214262 */     GIR_EraseRootFromParent_Done,
     /* 214263 */   // Label 4129: @214263
     /* 214263 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(214376), // Rule ID 2079 //
     /* 214268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 214285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 214288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 214308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214341 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 214345 */     // MIs[3] Operand 1
     /* 214345 */     // No operand predicates
     /* 214345 */     // MIs[1] Operand 2
     /* 214345 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 214356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214358 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 214358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 214361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214374 */     GIR_RootConstrainSelectedInstOperands,
     /* 214375 */     // GIR_Coverage, 2079,
     /* 214375 */     GIR_EraseRootFromParent_Done,
     /* 214376 */   // Label 4130: @214376
     /* 214376 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(214481), // Rule ID 3866 //
     /* 214381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 214389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 214421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 214425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214454 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 214458 */     // MIs[3] Operand 1
     /* 214458 */     // No operand predicates
     /* 214458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214460 */     // (intrinsic_wo_chain:{ *:[v4f16] } 764:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 214460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 214463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214479 */     GIR_RootConstrainSelectedInstOperands,
     /* 214480 */     // GIR_Coverage, 3866,
     /* 214480 */     GIR_EraseRootFromParent_Done,
     /* 214481 */   // Label 4131: @214481
     /* 214481 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(214586), // Rule ID 3867 //
     /* 214486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 214494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 214526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 214530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214559 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 214563 */     // MIs[3] Operand 1
     /* 214563 */     // No operand predicates
     /* 214563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214565 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 214565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 214568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214584 */     GIR_RootConstrainSelectedInstOperands,
     /* 214585 */     // GIR_Coverage, 3867,
     /* 214585 */     GIR_EraseRootFromParent_Done,
     /* 214586 */   // Label 4132: @214586
     /* 214586 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(214691), // Rule ID 3868 //
     /* 214591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 214599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 214631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 214635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214664 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 214668 */     // MIs[3] Operand 1
     /* 214668 */     // No operand predicates
     /* 214668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214670 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 214670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 214673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 214689 */     GIR_RootConstrainSelectedInstOperands,
     /* 214690 */     // GIR_Coverage, 3868,
     /* 214690 */     GIR_EraseRootFromParent_Done,
     /* 214691 */   // Label 4133: @214691
     /* 214691 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(214796), // Rule ID 3869 //
     /* 214696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 214704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 214736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 214740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214769 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 214773 */     // MIs[3] Operand 1
     /* 214773 */     // No operand predicates
     /* 214773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214775 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 214775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 214778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 214794 */     GIR_RootConstrainSelectedInstOperands,
     /* 214795 */     // GIR_Coverage, 3869,
     /* 214795 */     GIR_EraseRootFromParent_Done,
     /* 214796 */   // Label 4134: @214796
     /* 214796 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(214901), // Rule ID 3874 //
     /* 214801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 214809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 214841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214874 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 214878 */     // MIs[3] Operand 1
     /* 214878 */     // No operand predicates
     /* 214878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214880 */     // (intrinsic_wo_chain:{ *:[v8f16] } 764:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 214880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 214883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214899 */     GIR_RootConstrainSelectedInstOperands,
     /* 214900 */     // GIR_Coverage, 3874,
     /* 214900 */     GIR_EraseRootFromParent_Done,
     /* 214901 */   // Label 4135: @214901
     /* 214901 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(215006), // Rule ID 3875 //
     /* 214906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 214914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 214946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214979 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 214983 */     // MIs[3] Operand 1
     /* 214983 */     // No operand predicates
     /* 214983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214985 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 214985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 214988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215004 */     GIR_RootConstrainSelectedInstOperands,
     /* 215005 */     // GIR_Coverage, 3875,
     /* 215005 */     GIR_EraseRootFromParent_Done,
     /* 215006 */   // Label 4136: @215006
     /* 215006 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(215111), // Rule ID 3876 //
     /* 215011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 215019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215084 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215088 */     // MIs[3] Operand 1
     /* 215088 */     // No operand predicates
     /* 215088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215090 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 215090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 215093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 215109 */     GIR_RootConstrainSelectedInstOperands,
     /* 215110 */     // GIR_Coverage, 3876,
     /* 215110 */     GIR_EraseRootFromParent_Done,
     /* 215111 */   // Label 4137: @215111
     /* 215111 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(215216), // Rule ID 3877 //
     /* 215116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 215124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215189 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215193 */     // MIs[3] Operand 1
     /* 215193 */     // No operand predicates
     /* 215193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215195 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 215195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 215198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 215214 */     GIR_RootConstrainSelectedInstOperands,
     /* 215215 */     // GIR_Coverage, 3877,
     /* 215215 */     GIR_EraseRootFromParent_Done,
     /* 215216 */   // Label 4138: @215216
     /* 215216 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(215321), // Rule ID 3890 //
     /* 215221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 215224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 215229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 215273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215294 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 215298 */     // MIs[3] Operand 1
     /* 215298 */     // No operand predicates
     /* 215298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215300 */     // (intrinsic_wo_chain:{ *:[v4f32] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 215300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 215303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215319 */     GIR_RootConstrainSelectedInstOperands,
     /* 215320 */     // GIR_Coverage, 3890,
     /* 215320 */     GIR_EraseRootFromParent_Done,
     /* 215321 */   // Label 4139: @215321
     /* 215321 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(215426), // Rule ID 3891 //
     /* 215326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 215329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 215334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 215378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215399 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 215403 */     // MIs[3] Operand 1
     /* 215403 */     // No operand predicates
     /* 215403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215405 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 215405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 215408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215424 */     GIR_RootConstrainSelectedInstOperands,
     /* 215425 */     // GIR_Coverage, 3891,
     /* 215425 */     GIR_EraseRootFromParent_Done,
     /* 215426 */   // Label 4140: @215426
     /* 215426 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(215531), // Rule ID 3892 //
     /* 215431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 215434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 215439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 215483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215504 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 215508 */     // MIs[3] Operand 1
     /* 215508 */     // No operand predicates
     /* 215508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215510 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 215510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 215513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 215529 */     GIR_RootConstrainSelectedInstOperands,
     /* 215530 */     // GIR_Coverage, 3892,
     /* 215530 */     GIR_EraseRootFromParent_Done,
     /* 215531 */   // Label 4141: @215531
     /* 215531 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(215636), // Rule ID 3893 //
     /* 215536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 215539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 215544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 215588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 215613 */     // MIs[3] Operand 1
     /* 215613 */     // No operand predicates
     /* 215613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215615 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 215615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 215618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 215634 */     GIR_RootConstrainSelectedInstOperands,
     /* 215635 */     // GIR_Coverage, 3893,
     /* 215635 */     GIR_EraseRootFromParent_Done,
     /* 215636 */   // Label 4142: @215636
     /* 215636 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(215690), // Rule ID 59 //
     /* 215641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 215644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 215649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 215652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 215658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215666 */     // MIs[0] Operand 3
     /* 215666 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 215677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 215681 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 215681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 215684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215688 */     GIR_RootConstrainSelectedInstOperands,
     /* 215689 */     // GIR_Coverage, 59,
     /* 215689 */     GIR_EraseRootFromParent_Done,
     /* 215690 */   // Label 4143: @215690
     /* 215690 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(215744), // Rule ID 60 //
     /* 215695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 215698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 215703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 215706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 215712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215720 */     // MIs[0] Operand 3
     /* 215720 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 215731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 215735 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 215735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 215738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215742 */     GIR_RootConstrainSelectedInstOperands,
     /* 215743 */     // GIR_Coverage, 60,
     /* 215743 */     GIR_EraseRootFromParent_Done,
     /* 215744 */   // Label 4144: @215744
     /* 215744 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(215798), // Rule ID 61 //
     /* 215749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 215752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 215757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 215760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 215766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215774 */     // MIs[0] Operand 3
     /* 215774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 215785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 215789 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 215789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 215792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215796 */     GIR_RootConstrainSelectedInstOperands,
     /* 215797 */     // GIR_Coverage, 61,
     /* 215797 */     GIR_EraseRootFromParent_Done,
     /* 215798 */   // Label 4145: @215798
     /* 215798 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(215852), // Rule ID 62 //
     /* 215803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 215806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 215811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 215814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 215820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215828 */     // MIs[0] Operand 3
     /* 215828 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 215839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 215843 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 215843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 215846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215850 */     GIR_RootConstrainSelectedInstOperands,
     /* 215851 */     // GIR_Coverage, 62,
     /* 215851 */     GIR_EraseRootFromParent_Done,
     /* 215852 */   // Label 4146: @215852
     /* 215852 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(215908), // Rule ID 2645 //
     /* 215857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 215865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215879 */     // MIs[0] pattern
     /* 215879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 215882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 215887 */     // MIs[0] imm4
     /* 215887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 215890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 215895 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1817:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 215895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 215898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 215902 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 215904 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 215906 */     GIR_RootConstrainSelectedInstOperands,
     /* 215907 */     // GIR_Coverage, 2645,
     /* 215907 */     GIR_EraseRootFromParent_Done,
     /* 215908 */   // Label 4147: @215908
     /* 215908 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(215964), // Rule ID 2654 //
     /* 215913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 215921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 215924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 215927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 215931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 215935 */     // MIs[0] pattern
     /* 215935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 215938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 215943 */     // MIs[0] imm4
     /* 215943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 215946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 215951 */     // (intrinsic_wo_chain:{ *:[i32] } 2023:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 215951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 215954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 215956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 215958 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 215960 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 215962 */     GIR_RootConstrainSelectedInstOperands,
     /* 215963 */     // GIR_Coverage, 2654,
     /* 215963 */     GIR_EraseRootFromParent_Done,
     /* 215964 */   // Label 4148: @215964
     /* 215964 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(216020), // Rule ID 2655 //
     /* 215969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 215977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 215980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215991 */     // MIs[0] pattern
     /* 215991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 215994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 215999 */     // MIs[0] imm4
     /* 215999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216007 */     // (intrinsic_wo_chain:{ *:[i64] } 1813:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 216010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216014 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216016 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216018 */     GIR_RootConstrainSelectedInstOperands,
     /* 216019 */     // GIR_Coverage, 2655,
     /* 216019 */     GIR_EraseRootFromParent_Done,
     /* 216020 */   // Label 4149: @216020
     /* 216020 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(216076), // Rule ID 10028 //
     /* 216025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 216033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216047 */     // MIs[0] pattern
     /* 216047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216055 */     // MIs[0] imm4
     /* 216055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216063 */     // (intrinsic_wo_chain:{ *:[i32] } 2009:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 216066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216070 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216072 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216074 */     GIR_RootConstrainSelectedInstOperands,
     /* 216075 */     // GIR_Coverage, 10028,
     /* 216075 */     GIR_EraseRootFromParent_Done,
     /* 216076 */   // Label 4150: @216076
     /* 216076 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(216132), // Rule ID 10029 //
     /* 216081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 216089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216103 */     // MIs[0] pattern
     /* 216103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216111 */     // MIs[0] imm4
     /* 216111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216119 */     // (intrinsic_wo_chain:{ *:[i64] } 2024:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 216122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216126 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216128 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216130 */     GIR_RootConstrainSelectedInstOperands,
     /* 216131 */     // GIR_Coverage, 10029,
     /* 216131 */     GIR_EraseRootFromParent_Done,
     /* 216132 */   // Label 4151: @216132
     /* 216132 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(216188), // Rule ID 10030 //
     /* 216137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 216145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216159 */     // MIs[0] pattern
     /* 216159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216167 */     // MIs[0] imm4
     /* 216167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216175 */     // (intrinsic_wo_chain:{ *:[i64] } 1779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 216178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216182 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216184 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216186 */     GIR_RootConstrainSelectedInstOperands,
     /* 216187 */     // GIR_Coverage, 10030,
     /* 216187 */     GIR_EraseRootFromParent_Done,
     /* 216188 */   // Label 4152: @216188
     /* 216188 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(216244), // Rule ID 10031 //
     /* 216193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 216201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216215 */     // MIs[0] pattern
     /* 216215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216223 */     // MIs[0] imm4
     /* 216223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216231 */     // (intrinsic_wo_chain:{ *:[i64] } 2010:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 216234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216238 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216240 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216242 */     GIR_RootConstrainSelectedInstOperands,
     /* 216243 */     // GIR_Coverage, 10031,
     /* 216243 */     GIR_EraseRootFromParent_Done,
     /* 216244 */   // Label 4153: @216244
     /* 216244 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(216300), // Rule ID 10034 //
     /* 216249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 216257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216271 */     // MIs[0] pattern
     /* 216271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216279 */     // MIs[0] imm4
     /* 216279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216287 */     // (intrinsic_wo_chain:{ *:[i32] } 2029:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 216290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216294 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216296 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216298 */     GIR_RootConstrainSelectedInstOperands,
     /* 216299 */     // GIR_Coverage, 10034,
     /* 216299 */     GIR_EraseRootFromParent_Done,
     /* 216300 */   // Label 4154: @216300
     /* 216300 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(216356), // Rule ID 10037 //
     /* 216305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 216313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216327 */     // MIs[0] pattern
     /* 216327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216335 */     // MIs[0] imm4
     /* 216335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216343 */     // (intrinsic_wo_chain:{ *:[i32] } 2015:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 216346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216350 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216352 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216354 */     GIR_RootConstrainSelectedInstOperands,
     /* 216355 */     // GIR_Coverage, 10037,
     /* 216355 */     GIR_EraseRootFromParent_Done,
     /* 216356 */   // Label 4155: @216356
     /* 216356 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(216412), // Rule ID 10038 //
     /* 216361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 216369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216383 */     // MIs[0] pattern
     /* 216383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216391 */     // MIs[0] imm4
     /* 216391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216399 */     // (intrinsic_wo_chain:{ *:[i64] } 1819:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 216402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216406 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216408 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216410 */     GIR_RootConstrainSelectedInstOperands,
     /* 216411 */     // GIR_Coverage, 10038,
     /* 216411 */     GIR_EraseRootFromParent_Done,
     /* 216412 */   // Label 4156: @216412
     /* 216412 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(216468), // Rule ID 10039 //
     /* 216417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 216425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216439 */     // MIs[0] pattern
     /* 216439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216447 */     // MIs[0] imm4
     /* 216447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216455 */     // (intrinsic_wo_chain:{ *:[i64] } 2030:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 216458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216462 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216464 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216466 */     GIR_RootConstrainSelectedInstOperands,
     /* 216467 */     // GIR_Coverage, 10039,
     /* 216467 */     GIR_EraseRootFromParent_Done,
     /* 216468 */   // Label 4157: @216468
     /* 216468 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(216524), // Rule ID 10040 //
     /* 216473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 216481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216495 */     // MIs[0] pattern
     /* 216495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216503 */     // MIs[0] imm4
     /* 216503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216511 */     // (intrinsic_wo_chain:{ *:[i64] } 1785:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 216514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216518 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216520 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216522 */     GIR_RootConstrainSelectedInstOperands,
     /* 216523 */     // GIR_Coverage, 10040,
     /* 216523 */     GIR_EraseRootFromParent_Done,
     /* 216524 */   // Label 4158: @216524
     /* 216524 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(216580), // Rule ID 10041 //
     /* 216529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 216537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216551 */     // MIs[0] pattern
     /* 216551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216559 */     // MIs[0] imm4
     /* 216559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216567 */     // (intrinsic_wo_chain:{ *:[i64] } 2016:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 216570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216574 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216576 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216578 */     GIR_RootConstrainSelectedInstOperands,
     /* 216579 */     // GIR_Coverage, 10041,
     /* 216579 */     GIR_EraseRootFromParent_Done,
     /* 216580 */   // Label 4159: @216580
     /* 216580 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(216636), // Rule ID 10044 //
     /* 216585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 216593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216607 */     // MIs[0] pattern
     /* 216607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216615 */     // MIs[0] imm4
     /* 216615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216623 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 216626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216630 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216632 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216634 */     GIR_RootConstrainSelectedInstOperands,
     /* 216635 */     // GIR_Coverage, 10044,
     /* 216635 */     GIR_EraseRootFromParent_Done,
     /* 216636 */   // Label 4160: @216636
     /* 216636 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(216692), // Rule ID 10047 //
     /* 216641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 216649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216663 */     // MIs[0] pattern
     /* 216663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216671 */     // MIs[0] imm4
     /* 216671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216679 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 216682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216686 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216688 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216690 */     GIR_RootConstrainSelectedInstOperands,
     /* 216691 */     // GIR_Coverage, 10047,
     /* 216691 */     GIR_EraseRootFromParent_Done,
     /* 216692 */   // Label 4161: @216692
     /* 216692 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(216748), // Rule ID 10048 //
     /* 216697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 216705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216719 */     // MIs[0] pattern
     /* 216719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216727 */     // MIs[0] imm4
     /* 216727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216735 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 216738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216742 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216744 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216746 */     GIR_RootConstrainSelectedInstOperands,
     /* 216747 */     // GIR_Coverage, 10048,
     /* 216747 */     GIR_EraseRootFromParent_Done,
     /* 216748 */   // Label 4162: @216748
     /* 216748 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(216804), // Rule ID 10049 //
     /* 216753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 216761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216775 */     // MIs[0] pattern
     /* 216775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216783 */     // MIs[0] imm4
     /* 216783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216791 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 216794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216798 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216800 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216802 */     GIR_RootConstrainSelectedInstOperands,
     /* 216803 */     // GIR_Coverage, 10049,
     /* 216803 */     GIR_EraseRootFromParent_Done,
     /* 216804 */   // Label 4163: @216804
     /* 216804 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(216860), // Rule ID 10050 //
     /* 216809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 216817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216831 */     // MIs[0] pattern
     /* 216831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216839 */     // MIs[0] imm4
     /* 216839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216847 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 216850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216854 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216856 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216858 */     GIR_RootConstrainSelectedInstOperands,
     /* 216859 */     // GIR_Coverage, 10050,
     /* 216859 */     GIR_EraseRootFromParent_Done,
     /* 216860 */   // Label 4164: @216860
     /* 216860 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(216916), // Rule ID 10051 //
     /* 216865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 216873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216887 */     // MIs[0] pattern
     /* 216887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216895 */     // MIs[0] imm4
     /* 216895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216903 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 216906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216910 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216912 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216914 */     GIR_RootConstrainSelectedInstOperands,
     /* 216915 */     // GIR_Coverage, 10051,
     /* 216915 */     GIR_EraseRootFromParent_Done,
     /* 216916 */   // Label 4165: @216916
     /* 216916 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(216972), // Rule ID 10054 //
     /* 216921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 216929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216943 */     // MIs[0] pattern
     /* 216943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216951 */     // MIs[0] imm4
     /* 216951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216959 */     // (intrinsic_wo_chain:{ *:[i32] } 2026:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 216962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216966 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216968 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216970 */     GIR_RootConstrainSelectedInstOperands,
     /* 216971 */     // GIR_Coverage, 10054,
     /* 216971 */     GIR_EraseRootFromParent_Done,
     /* 216972 */   // Label 4166: @216972
     /* 216972 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(217028), // Rule ID 10057 //
     /* 216977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 216985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216999 */     // MIs[0] pattern
     /* 216999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217007 */     // MIs[0] imm4
     /* 217007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217015 */     // (intrinsic_wo_chain:{ *:[i32] } 2012:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 217018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217022 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217024 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217026 */     GIR_RootConstrainSelectedInstOperands,
     /* 217027 */     // GIR_Coverage, 10057,
     /* 217027 */     GIR_EraseRootFromParent_Done,
     /* 217028 */   // Label 4167: @217028
     /* 217028 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(217084), // Rule ID 10058 //
     /* 217033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 217041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217055 */     // MIs[0] pattern
     /* 217055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217063 */     // MIs[0] imm4
     /* 217063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217071 */     // (intrinsic_wo_chain:{ *:[i64] } 1816:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 217074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217078 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217080 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217082 */     GIR_RootConstrainSelectedInstOperands,
     /* 217083 */     // GIR_Coverage, 10058,
     /* 217083 */     GIR_EraseRootFromParent_Done,
     /* 217084 */   // Label 4168: @217084
     /* 217084 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(217140), // Rule ID 10059 //
     /* 217089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 217097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217111 */     // MIs[0] pattern
     /* 217111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217119 */     // MIs[0] imm4
     /* 217119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217127 */     // (intrinsic_wo_chain:{ *:[i64] } 2027:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 217130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217134 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217136 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217138 */     GIR_RootConstrainSelectedInstOperands,
     /* 217139 */     // GIR_Coverage, 10059,
     /* 217139 */     GIR_EraseRootFromParent_Done,
     /* 217140 */   // Label 4169: @217140
     /* 217140 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(217196), // Rule ID 10060 //
     /* 217145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 217153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217167 */     // MIs[0] pattern
     /* 217167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217175 */     // MIs[0] imm4
     /* 217175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217183 */     // (intrinsic_wo_chain:{ *:[i64] } 1782:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 217186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217190 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217192 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217194 */     GIR_RootConstrainSelectedInstOperands,
     /* 217195 */     // GIR_Coverage, 10060,
     /* 217195 */     GIR_EraseRootFromParent_Done,
     /* 217196 */   // Label 4170: @217196
     /* 217196 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(217252), // Rule ID 10061 //
     /* 217201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 217209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217223 */     // MIs[0] pattern
     /* 217223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217231 */     // MIs[0] imm4
     /* 217231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217239 */     // (intrinsic_wo_chain:{ *:[i64] } 2013:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 217242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217246 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217248 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217250 */     GIR_RootConstrainSelectedInstOperands,
     /* 217251 */     // GIR_Coverage, 10061,
     /* 217251 */     GIR_EraseRootFromParent_Done,
     /* 217252 */   // Label 4171: @217252
     /* 217252 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(217308), // Rule ID 10062 //
     /* 217257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 217265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217279 */     // MIs[0] pattern
     /* 217279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217287 */     // MIs[0] imm4
     /* 217287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217295 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2028:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 217298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217302 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217304 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217306 */     GIR_RootConstrainSelectedInstOperands,
     /* 217307 */     // GIR_Coverage, 10062,
     /* 217307 */     GIR_EraseRootFromParent_Done,
     /* 217308 */   // Label 4172: @217308
     /* 217308 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(217364), // Rule ID 10063 //
     /* 217313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 217321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217335 */     // MIs[0] pattern
     /* 217335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217343 */     // MIs[0] imm4
     /* 217343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217351 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1783:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 217354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217358 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217360 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217362 */     GIR_RootConstrainSelectedInstOperands,
     /* 217363 */     // GIR_Coverage, 10063,
     /* 217363 */     GIR_EraseRootFromParent_Done,
     /* 217364 */   // Label 4173: @217364
     /* 217364 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(217420), // Rule ID 10064 //
     /* 217369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 217377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217391 */     // MIs[0] pattern
     /* 217391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217399 */     // MIs[0] imm4
     /* 217399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217407 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2014:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 217410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217414 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217416 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217418 */     GIR_RootConstrainSelectedInstOperands,
     /* 217419 */     // GIR_Coverage, 10064,
     /* 217419 */     GIR_EraseRootFromParent_Done,
     /* 217420 */   // Label 4174: @217420
     /* 217420 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(217476), // Rule ID 10065 //
     /* 217425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 217433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217447 */     // MIs[0] pattern
     /* 217447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217455 */     // MIs[0] imm4
     /* 217455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 217466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217470 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217472 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217474 */     GIR_RootConstrainSelectedInstOperands,
     /* 217475 */     // GIR_Coverage, 10065,
     /* 217475 */     GIR_EraseRootFromParent_Done,
     /* 217476 */   // Label 4175: @217476
     /* 217476 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(217532), // Rule ID 10066 //
     /* 217481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 217489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217503 */     // MIs[0] pattern
     /* 217503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217511 */     // MIs[0] imm4
     /* 217511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2034:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 217522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217526 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217528 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217530 */     GIR_RootConstrainSelectedInstOperands,
     /* 217531 */     // GIR_Coverage, 10066,
     /* 217531 */     GIR_EraseRootFromParent_Done,
     /* 217532 */   // Label 4176: @217532
     /* 217532 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(217588), // Rule ID 10067 //
     /* 217537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 217545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217559 */     // MIs[0] pattern
     /* 217559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217567 */     // MIs[0] imm4
     /* 217567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217570 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 217578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217582 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217584 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217586 */     GIR_RootConstrainSelectedInstOperands,
     /* 217587 */     // GIR_Coverage, 10067,
     /* 217587 */     GIR_EraseRootFromParent_Done,
     /* 217588 */   // Label 4177: @217588
     /* 217588 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(217644), // Rule ID 10068 //
     /* 217593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 217601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217615 */     // MIs[0] pattern
     /* 217615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217623 */     // MIs[0] imm4
     /* 217623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217631 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2020:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 217634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217638 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217640 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217642 */     GIR_RootConstrainSelectedInstOperands,
     /* 217643 */     // GIR_Coverage, 10068,
     /* 217643 */     GIR_EraseRootFromParent_Done,
     /* 217644 */   // Label 4178: @217644
     /* 217644 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(217700), // Rule ID 10069 //
     /* 217649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 217657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217671 */     // MIs[0] pattern
     /* 217671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217679 */     // MIs[0] imm4
     /* 217679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217687 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 217690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217694 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217696 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217698 */     GIR_RootConstrainSelectedInstOperands,
     /* 217699 */     // GIR_Coverage, 10069,
     /* 217699 */     GIR_EraseRootFromParent_Done,
     /* 217700 */   // Label 4179: @217700
     /* 217700 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(217756), // Rule ID 10070 //
     /* 217705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 217713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217727 */     // MIs[0] pattern
     /* 217727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217735 */     // MIs[0] imm4
     /* 217735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2025:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 217746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217750 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217752 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217754 */     GIR_RootConstrainSelectedInstOperands,
     /* 217755 */     // GIR_Coverage, 10070,
     /* 217755 */     GIR_EraseRootFromParent_Done,
     /* 217756 */   // Label 4180: @217756
     /* 217756 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(217812), // Rule ID 10071 //
     /* 217761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 217769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217783 */     // MIs[0] pattern
     /* 217783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217791 */     // MIs[0] imm4
     /* 217791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1780:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 217802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217806 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217808 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217810 */     GIR_RootConstrainSelectedInstOperands,
     /* 217811 */     // GIR_Coverage, 10071,
     /* 217811 */     GIR_EraseRootFromParent_Done,
     /* 217812 */   // Label 4181: @217812
     /* 217812 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(217868), // Rule ID 10072 //
     /* 217817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 217825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217839 */     // MIs[0] pattern
     /* 217839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217847 */     // MIs[0] imm4
     /* 217847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217855 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2011:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 217858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217862 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217864 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217866 */     GIR_RootConstrainSelectedInstOperands,
     /* 217867 */     // GIR_Coverage, 10072,
     /* 217867 */     GIR_EraseRootFromParent_Done,
     /* 217868 */   // Label 4182: @217868
     /* 217868 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(217958), // Rule ID 47 //
     /* 217873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 217876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 217881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 217913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 217921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 217926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 217930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217934 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 217938 */     // MIs[2] Operand 1
     /* 217938 */     // No operand predicates
     /* 217938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 217940 */     // (intrinsic_wo_chain:{ *:[v2f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 217940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 217943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 217953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 217956 */     GIR_RootConstrainSelectedInstOperands,
     /* 217957 */     // GIR_Coverage, 47,
     /* 217957 */     GIR_EraseRootFromParent_Done,
     /* 217958 */   // Label 4183: @217958
     /* 217958 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(218048), // Rule ID 48 //
     /* 217963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 217966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 217971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218024 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218028 */     // MIs[2] Operand 1
     /* 218028 */     // No operand predicates
     /* 218028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218030 */     // (intrinsic_wo_chain:{ *:[v4f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 218033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218046 */     GIR_RootConstrainSelectedInstOperands,
     /* 218047 */     // GIR_Coverage, 48,
     /* 218047 */     GIR_EraseRootFromParent_Done,
     /* 218048 */   // Label 4184: @218048
     /* 218048 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(218138), // Rule ID 49 //
     /* 218053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 218061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218114 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218118 */     // MIs[2] Operand 1
     /* 218118 */     // No operand predicates
     /* 218118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218120 */     // (intrinsic_wo_chain:{ *:[v2f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 218123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218136 */     GIR_RootConstrainSelectedInstOperands,
     /* 218137 */     // GIR_Coverage, 49,
     /* 218137 */     GIR_EraseRootFromParent_Done,
     /* 218138 */   // Label 4185: @218138
     /* 218138 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(218228), // Rule ID 50 //
     /* 218143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 218151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218204 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218208 */     // MIs[2] Operand 1
     /* 218208 */     // No operand predicates
     /* 218208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218210 */     // (intrinsic_wo_chain:{ *:[v4f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 218213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218226 */     GIR_RootConstrainSelectedInstOperands,
     /* 218227 */     // GIR_Coverage, 50,
     /* 218227 */     GIR_EraseRootFromParent_Done,
     /* 218228 */   // Label 4186: @218228
     /* 218228 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(218318), // Rule ID 51 //
     /* 218233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 218241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218294 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218298 */     // MIs[2] Operand 1
     /* 218298 */     // No operand predicates
     /* 218298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218300 */     // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 218303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218316 */     GIR_RootConstrainSelectedInstOperands,
     /* 218317 */     // GIR_Coverage, 51,
     /* 218317 */     GIR_EraseRootFromParent_Done,
     /* 218318 */   // Label 4187: @218318
     /* 218318 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(218408), // Rule ID 52 //
     /* 218323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 218331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218388 */     // MIs[2] Operand 1
     /* 218388 */     // No operand predicates
     /* 218388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218390 */     // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 218393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218406 */     GIR_RootConstrainSelectedInstOperands,
     /* 218407 */     // GIR_Coverage, 52,
     /* 218407 */     GIR_EraseRootFromParent_Done,
     /* 218408 */   // Label 4188: @218408
     /* 218408 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(218498), // Rule ID 53 //
     /* 218413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 218421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218474 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218478 */     // MIs[2] Operand 1
     /* 218478 */     // No operand predicates
     /* 218478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218480 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 218483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218496 */     GIR_RootConstrainSelectedInstOperands,
     /* 218497 */     // GIR_Coverage, 53,
     /* 218497 */     GIR_EraseRootFromParent_Done,
     /* 218498 */   // Label 4189: @218498
     /* 218498 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(218588), // Rule ID 54 //
     /* 218503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 218511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218564 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218568 */     // MIs[2] Operand 1
     /* 218568 */     // No operand predicates
     /* 218568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218570 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 218573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218586 */     GIR_RootConstrainSelectedInstOperands,
     /* 218587 */     // GIR_Coverage, 54,
     /* 218587 */     GIR_EraseRootFromParent_Done,
     /* 218588 */   // Label 4190: @218588
     /* 218588 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(218678), // Rule ID 2070 //
     /* 218593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 218596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 218601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218654 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218658 */     // MIs[2] Operand 1
     /* 218658 */     // No operand predicates
     /* 218658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218660 */     // (intrinsic_wo_chain:{ *:[v4i16] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 218663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218676 */     GIR_RootConstrainSelectedInstOperands,
     /* 218677 */     // GIR_Coverage, 2070,
     /* 218677 */     GIR_EraseRootFromParent_Done,
     /* 218678 */   // Label 4191: @218678
     /* 218678 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(218768), // Rule ID 2071 //
     /* 218683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 218686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 218691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218748 */     // MIs[2] Operand 1
     /* 218748 */     // No operand predicates
     /* 218748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218750 */     // (intrinsic_wo_chain:{ *:[v8i16] } 693:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 218753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218766 */     GIR_RootConstrainSelectedInstOperands,
     /* 218767 */     // GIR_Coverage, 2071,
     /* 218767 */     GIR_EraseRootFromParent_Done,
     /* 218768 */   // Label 4192: @218768
     /* 218768 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(218858), // Rule ID 2077 //
     /* 218773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 218776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 218781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218834 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218838 */     // MIs[2] Operand 1
     /* 218838 */     // No operand predicates
     /* 218838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218840 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 218843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218856 */     GIR_RootConstrainSelectedInstOperands,
     /* 218857 */     // GIR_Coverage, 2077,
     /* 218857 */     GIR_EraseRootFromParent_Done,
     /* 218858 */   // Label 4193: @218858
     /* 218858 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(218948), // Rule ID 2078 //
     /* 218863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 218866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 218871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218924 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218928 */     // MIs[2] Operand 1
     /* 218928 */     // No operand predicates
     /* 218928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218930 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 218933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218946 */     GIR_RootConstrainSelectedInstOperands,
     /* 218947 */     // GIR_Coverage, 2078,
     /* 218947 */     GIR_EraseRootFromParent_Done,
     /* 218948 */   // Label 4194: @218948
     /* 218948 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(219038), // Rule ID 2073 //
     /* 218953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 218956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 218961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 218970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 218973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219014 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219018 */     // MIs[2] Operand 1
     /* 219018 */     // No operand predicates
     /* 219018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219020 */     // (intrinsic_wo_chain:{ *:[v2i32] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 219023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219036 */     GIR_RootConstrainSelectedInstOperands,
     /* 219037 */     // GIR_Coverage, 2073,
     /* 219037 */     GIR_EraseRootFromParent_Done,
     /* 219038 */   // Label 4195: @219038
     /* 219038 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(219128), // Rule ID 2074 //
     /* 219043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 219051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 219083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219108 */     // MIs[2] Operand 1
     /* 219108 */     // No operand predicates
     /* 219108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219110 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 219113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219126 */     GIR_RootConstrainSelectedInstOperands,
     /* 219127 */     // GIR_Coverage, 2074,
     /* 219127 */     GIR_EraseRootFromParent_Done,
     /* 219128 */   // Label 4196: @219128
     /* 219128 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(219218), // Rule ID 2080 //
     /* 219133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 219141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 219173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219194 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219198 */     // MIs[2] Operand 1
     /* 219198 */     // No operand predicates
     /* 219198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219200 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 219203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219216 */     GIR_RootConstrainSelectedInstOperands,
     /* 219217 */     // GIR_Coverage, 2080,
     /* 219217 */     GIR_EraseRootFromParent_Done,
     /* 219218 */   // Label 4197: @219218
     /* 219218 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(219308), // Rule ID 2081 //
     /* 219223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 219231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 219263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219288 */     // MIs[2] Operand 1
     /* 219288 */     // No operand predicates
     /* 219288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219290 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 219293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219306 */     GIR_RootConstrainSelectedInstOperands,
     /* 219307 */     // GIR_Coverage, 2081,
     /* 219307 */     GIR_EraseRootFromParent_Done,
     /* 219308 */   // Label 4198: @219308
     /* 219308 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(219398), // Rule ID 2075 //
     /* 219313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 219321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 219324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 219327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 219330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 219333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 219353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219374 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219378 */     // MIs[2] Operand 1
     /* 219378 */     // No operand predicates
     /* 219378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219380 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 219383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219396 */     GIR_RootConstrainSelectedInstOperands,
     /* 219397 */     // GIR_Coverage, 2075,
     /* 219397 */     GIR_EraseRootFromParent_Done,
     /* 219398 */   // Label 4199: @219398
     /* 219398 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(219488), // Rule ID 2082 //
     /* 219403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 219411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 219414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 219417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 219420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 219423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 219443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219464 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219468 */     // MIs[2] Operand 1
     /* 219468 */     // No operand predicates
     /* 219468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219470 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 219473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219486 */     GIR_RootConstrainSelectedInstOperands,
     /* 219487 */     // GIR_Coverage, 2082,
     /* 219487 */     GIR_EraseRootFromParent_Done,
     /* 219488 */   // Label 4200: @219488
     /* 219488 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(219565), // Rule ID 2774 //
     /* 219493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 219537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 219545 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 219549 */     // MIs[2] Operand 1
     /* 219549 */     // No operand predicates
     /* 219549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219551 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 219551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 219554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 219558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 219560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219563 */     GIR_RootConstrainSelectedInstOperands,
     /* 219564 */     // GIR_Coverage, 2774,
     /* 219564 */     GIR_EraseRootFromParent_Done,
     /* 219565 */   // Label 4201: @219565
     /* 219565 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(219642), // Rule ID 2775 //
     /* 219570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 219614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 219622 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 219626 */     // MIs[2] Operand 1
     /* 219626 */     // No operand predicates
     /* 219626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219628 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 219628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 219631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 219635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 219637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219640 */     GIR_RootConstrainSelectedInstOperands,
     /* 219641 */     // GIR_Coverage, 2775,
     /* 219641 */     GIR_EraseRootFromParent_Done,
     /* 219642 */   // Label 4202: @219642
     /* 219642 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(219719), // Rule ID 2776 //
     /* 219647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 219691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 219699 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 219703 */     // MIs[2] Operand 1
     /* 219703 */     // No operand predicates
     /* 219703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219705 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 219705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 219708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 219712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 219714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219717 */     GIR_RootConstrainSelectedInstOperands,
     /* 219718 */     // GIR_Coverage, 2776,
     /* 219718 */     GIR_EraseRootFromParent_Done,
     /* 219719 */   // Label 4203: @219719
     /* 219719 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(219796), // Rule ID 2777 //
     /* 219724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 219768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 219776 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 219780 */     // MIs[2] Operand 1
     /* 219780 */     // No operand predicates
     /* 219780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219782 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 219782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 219785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 219789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 219791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219794 */     GIR_RootConstrainSelectedInstOperands,
     /* 219795 */     // GIR_Coverage, 2777,
     /* 219795 */     GIR_EraseRootFromParent_Done,
     /* 219796 */   // Label 4204: @219796
     /* 219796 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(219873), // Rule ID 2778 //
     /* 219801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 219845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 219853 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 219857 */     // MIs[2] Operand 1
     /* 219857 */     // No operand predicates
     /* 219857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219859 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 219859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 219862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 219866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 219868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219871 */     GIR_RootConstrainSelectedInstOperands,
     /* 219872 */     // GIR_Coverage, 2778,
     /* 219872 */     GIR_EraseRootFromParent_Done,
     /* 219873 */   // Label 4205: @219873
     /* 219873 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(219950), // Rule ID 2779 //
     /* 219878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 219922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 219930 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 219934 */     // MIs[2] Operand 1
     /* 219934 */     // No operand predicates
     /* 219934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 219936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 219939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 219943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 219945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219948 */     GIR_RootConstrainSelectedInstOperands,
     /* 219949 */     // GIR_Coverage, 2779,
     /* 219949 */     GIR_EraseRootFromParent_Done,
     /* 219950 */   // Label 4206: @219950
     /* 219950 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(220027), // Rule ID 7915 //
     /* 219955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 219963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 219999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220007 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220011 */     // MIs[2] Operand 1
     /* 220011 */     // No operand predicates
     /* 220011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220013 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 220013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 220016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220025 */     GIR_RootConstrainSelectedInstOperands,
     /* 220026 */     // GIR_Coverage, 7915,
     /* 220026 */     GIR_EraseRootFromParent_Done,
     /* 220027 */   // Label 4207: @220027
     /* 220027 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(220104), // Rule ID 7916 //
     /* 220032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 220076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220084 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 220088 */     // MIs[2] Operand 1
     /* 220088 */     // No operand predicates
     /* 220088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220090 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 220090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 220093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220102 */     GIR_RootConstrainSelectedInstOperands,
     /* 220103 */     // GIR_Coverage, 7916,
     /* 220103 */     GIR_EraseRootFromParent_Done,
     /* 220104 */   // Label 4208: @220104
     /* 220104 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(220181), // Rule ID 7917 //
     /* 220109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 220153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220161 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220165 */     // MIs[2] Operand 1
     /* 220165 */     // No operand predicates
     /* 220165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220167 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 220167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 220170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220179 */     GIR_RootConstrainSelectedInstOperands,
     /* 220180 */     // GIR_Coverage, 7917,
     /* 220180 */     GIR_EraseRootFromParent_Done,
     /* 220181 */   // Label 4209: @220181
     /* 220181 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(220258), // Rule ID 7918 //
     /* 220186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 220230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220238 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 220242 */     // MIs[2] Operand 1
     /* 220242 */     // No operand predicates
     /* 220242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220244 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 220244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 220247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220256 */     GIR_RootConstrainSelectedInstOperands,
     /* 220257 */     // GIR_Coverage, 7918,
     /* 220257 */     GIR_EraseRootFromParent_Done,
     /* 220258 */   // Label 4210: @220258
     /* 220258 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(220335), // Rule ID 7919 //
     /* 220263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 220307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220315 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220319 */     // MIs[2] Operand 1
     /* 220319 */     // No operand predicates
     /* 220319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220321 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 220321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 220324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220333 */     GIR_RootConstrainSelectedInstOperands,
     /* 220334 */     // GIR_Coverage, 7919,
     /* 220334 */     GIR_EraseRootFromParent_Done,
     /* 220335 */   // Label 4211: @220335
     /* 220335 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(220412), // Rule ID 7920 //
     /* 220340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 220384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220392 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 220396 */     // MIs[2] Operand 1
     /* 220396 */     // No operand predicates
     /* 220396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220398 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 220398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 220401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220410 */     GIR_RootConstrainSelectedInstOperands,
     /* 220411 */     // GIR_Coverage, 7920,
     /* 220411 */     GIR_EraseRootFromParent_Done,
     /* 220412 */   // Label 4212: @220412
     /* 220412 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(220489), // Rule ID 7921 //
     /* 220417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 220461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220469 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220473 */     // MIs[2] Operand 1
     /* 220473 */     // No operand predicates
     /* 220473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220475 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 220475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 220478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220487 */     GIR_RootConstrainSelectedInstOperands,
     /* 220488 */     // GIR_Coverage, 7921,
     /* 220488 */     GIR_EraseRootFromParent_Done,
     /* 220489 */   // Label 4213: @220489
     /* 220489 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(220566), // Rule ID 7922 //
     /* 220494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 220538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220546 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 220550 */     // MIs[2] Operand 1
     /* 220550 */     // No operand predicates
     /* 220550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 220552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 220555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220564 */     GIR_RootConstrainSelectedInstOperands,
     /* 220565 */     // GIR_Coverage, 7922,
     /* 220565 */     GIR_EraseRootFromParent_Done,
     /* 220566 */   // Label 4214: @220566
     /* 220566 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(220643), // Rule ID 7923 //
     /* 220571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 220615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220623 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220627 */     // MIs[2] Operand 1
     /* 220627 */     // No operand predicates
     /* 220627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220629 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 220629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 220632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220641 */     GIR_RootConstrainSelectedInstOperands,
     /* 220642 */     // GIR_Coverage, 7923,
     /* 220642 */     GIR_EraseRootFromParent_Done,
     /* 220643 */   // Label 4215: @220643
     /* 220643 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(220720), // Rule ID 7924 //
     /* 220648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 220692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220700 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 220704 */     // MIs[2] Operand 1
     /* 220704 */     // No operand predicates
     /* 220704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220706 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 220706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 220709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220718 */     GIR_RootConstrainSelectedInstOperands,
     /* 220719 */     // GIR_Coverage, 7924,
     /* 220719 */     GIR_EraseRootFromParent_Done,
     /* 220720 */   // Label 4216: @220720
     /* 220720 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(220797), // Rule ID 7925 //
     /* 220725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 220769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220777 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220781 */     // MIs[2] Operand 1
     /* 220781 */     // No operand predicates
     /* 220781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220783 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 220783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 220786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220795 */     GIR_RootConstrainSelectedInstOperands,
     /* 220796 */     // GIR_Coverage, 7925,
     /* 220796 */     GIR_EraseRootFromParent_Done,
     /* 220797 */   // Label 4217: @220797
     /* 220797 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(220874), // Rule ID 7926 //
     /* 220802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 220846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220854 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 220858 */     // MIs[2] Operand 1
     /* 220858 */     // No operand predicates
     /* 220858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220860 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 220860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 220863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220872 */     GIR_RootConstrainSelectedInstOperands,
     /* 220873 */     // GIR_Coverage, 7926,
     /* 220873 */     GIR_EraseRootFromParent_Done,
     /* 220874 */   // Label 4218: @220874
     /* 220874 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(220951), // Rule ID 7927 //
     /* 220879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 220887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 220923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220931 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220935 */     // MIs[2] Operand 1
     /* 220935 */     // No operand predicates
     /* 220935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220937 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 220937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 220940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220949 */     GIR_RootConstrainSelectedInstOperands,
     /* 220950 */     // GIR_Coverage, 7927,
     /* 220950 */     GIR_EraseRootFromParent_Done,
     /* 220951 */   // Label 4219: @220951
     /* 220951 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(221028), // Rule ID 7928 //
     /* 220956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 220964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221008 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221012 */     // MIs[2] Operand 1
     /* 221012 */     // No operand predicates
     /* 221012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221014 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 221017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221026 */     GIR_RootConstrainSelectedInstOperands,
     /* 221027 */     // GIR_Coverage, 7928,
     /* 221027 */     GIR_EraseRootFromParent_Done,
     /* 221028 */   // Label 4220: @221028
     /* 221028 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(221105), // Rule ID 7929 //
     /* 221033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221085 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221089 */     // MIs[2] Operand 1
     /* 221089 */     // No operand predicates
     /* 221089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221091 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 221094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221103 */     GIR_RootConstrainSelectedInstOperands,
     /* 221104 */     // GIR_Coverage, 7929,
     /* 221104 */     GIR_EraseRootFromParent_Done,
     /* 221105 */   // Label 4221: @221105
     /* 221105 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(221182), // Rule ID 7930 //
     /* 221110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221162 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221166 */     // MIs[2] Operand 1
     /* 221166 */     // No operand predicates
     /* 221166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221168 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 221171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221180 */     GIR_RootConstrainSelectedInstOperands,
     /* 221181 */     // GIR_Coverage, 7930,
     /* 221181 */     GIR_EraseRootFromParent_Done,
     /* 221182 */   // Label 4222: @221182
     /* 221182 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(221259), // Rule ID 7931 //
     /* 221187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221239 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221243 */     // MIs[2] Operand 1
     /* 221243 */     // No operand predicates
     /* 221243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221245 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 221248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221257 */     GIR_RootConstrainSelectedInstOperands,
     /* 221258 */     // GIR_Coverage, 7931,
     /* 221258 */     GIR_EraseRootFromParent_Done,
     /* 221259 */   // Label 4223: @221259
     /* 221259 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(221336), // Rule ID 7932 //
     /* 221264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221316 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221320 */     // MIs[2] Operand 1
     /* 221320 */     // No operand predicates
     /* 221320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221322 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 221322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 221325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221334 */     GIR_RootConstrainSelectedInstOperands,
     /* 221335 */     // GIR_Coverage, 7932,
     /* 221335 */     GIR_EraseRootFromParent_Done,
     /* 221336 */   // Label 4224: @221336
     /* 221336 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(221413), // Rule ID 7933 //
     /* 221341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221393 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 221397 */     // MIs[2] Operand 1
     /* 221397 */     // No operand predicates
     /* 221397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221399 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 221402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221411 */     GIR_RootConstrainSelectedInstOperands,
     /* 221412 */     // GIR_Coverage, 7933,
     /* 221412 */     GIR_EraseRootFromParent_Done,
     /* 221413 */   // Label 4225: @221413
     /* 221413 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(221490), // Rule ID 7934 //
     /* 221418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221470 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221474 */     // MIs[2] Operand 1
     /* 221474 */     // No operand predicates
     /* 221474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221476 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 221479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221488 */     GIR_RootConstrainSelectedInstOperands,
     /* 221489 */     // GIR_Coverage, 7934,
     /* 221489 */     GIR_EraseRootFromParent_Done,
     /* 221490 */   // Label 4226: @221490
     /* 221490 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(221567), // Rule ID 7935 //
     /* 221495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221547 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 221551 */     // MIs[2] Operand 1
     /* 221551 */     // No operand predicates
     /* 221551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221553 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 221556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221565 */     GIR_RootConstrainSelectedInstOperands,
     /* 221566 */     // GIR_Coverage, 7935,
     /* 221566 */     GIR_EraseRootFromParent_Done,
     /* 221567 */   // Label 4227: @221567
     /* 221567 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(221644), // Rule ID 7936 //
     /* 221572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221624 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221628 */     // MIs[2] Operand 1
     /* 221628 */     // No operand predicates
     /* 221628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221630 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 221633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221642 */     GIR_RootConstrainSelectedInstOperands,
     /* 221643 */     // GIR_Coverage, 7936,
     /* 221643 */     GIR_EraseRootFromParent_Done,
     /* 221644 */   // Label 4228: @221644
     /* 221644 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(221721), // Rule ID 7937 //
     /* 221649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221701 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 221705 */     // MIs[2] Operand 1
     /* 221705 */     // No operand predicates
     /* 221705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221707 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 221710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221719 */     GIR_RootConstrainSelectedInstOperands,
     /* 221720 */     // GIR_Coverage, 7937,
     /* 221720 */     GIR_EraseRootFromParent_Done,
     /* 221721 */   // Label 4229: @221721
     /* 221721 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(221798), // Rule ID 7938 //
     /* 221726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221778 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221782 */     // MIs[2] Operand 1
     /* 221782 */     // No operand predicates
     /* 221782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 221784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 221787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221796 */     GIR_RootConstrainSelectedInstOperands,
     /* 221797 */     // GIR_Coverage, 7938,
     /* 221797 */     GIR_EraseRootFromParent_Done,
     /* 221798 */   // Label 4230: @221798
     /* 221798 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(221875), // Rule ID 7939 //
     /* 221803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 221811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221855 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 221859 */     // MIs[2] Operand 1
     /* 221859 */     // No operand predicates
     /* 221859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221861 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 221864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221873 */     GIR_RootConstrainSelectedInstOperands,
     /* 221874 */     // GIR_Coverage, 7939,
     /* 221874 */     GIR_EraseRootFromParent_Done,
     /* 221875 */   // Label 4231: @221875
     /* 221875 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(221952), // Rule ID 7940 //
     /* 221880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 221888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221932 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221936 */     // MIs[2] Operand 1
     /* 221936 */     // No operand predicates
     /* 221936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221938 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 221941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221950 */     GIR_RootConstrainSelectedInstOperands,
     /* 221951 */     // GIR_Coverage, 7940,
     /* 221951 */     GIR_EraseRootFromParent_Done,
     /* 221952 */   // Label 4232: @221952
     /* 221952 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(222029), // Rule ID 7941 //
     /* 221957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 221965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222009 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222013 */     // MIs[2] Operand 1
     /* 222013 */     // No operand predicates
     /* 222013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222015 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 222018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222027 */     GIR_RootConstrainSelectedInstOperands,
     /* 222028 */     // GIR_Coverage, 7941,
     /* 222028 */     GIR_EraseRootFromParent_Done,
     /* 222029 */   // Label 4233: @222029
     /* 222029 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(222106), // Rule ID 7942 //
     /* 222034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 222042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222086 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222090 */     // MIs[2] Operand 1
     /* 222090 */     // No operand predicates
     /* 222090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222092 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 222095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222104 */     GIR_RootConstrainSelectedInstOperands,
     /* 222105 */     // GIR_Coverage, 7942,
     /* 222105 */     GIR_EraseRootFromParent_Done,
     /* 222106 */   // Label 4234: @222106
     /* 222106 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(222183), // Rule ID 7943 //
     /* 222111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 222119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222163 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222167 */     // MIs[2] Operand 1
     /* 222167 */     // No operand predicates
     /* 222167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222169 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 222172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222181 */     GIR_RootConstrainSelectedInstOperands,
     /* 222182 */     // GIR_Coverage, 7943,
     /* 222182 */     GIR_EraseRootFromParent_Done,
     /* 222183 */   // Label 4235: @222183
     /* 222183 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(222260), // Rule ID 7944 //
     /* 222188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 222196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222240 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222244 */     // MIs[2] Operand 1
     /* 222244 */     // No operand predicates
     /* 222244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222246 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 222249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222258 */     GIR_RootConstrainSelectedInstOperands,
     /* 222259 */     // GIR_Coverage, 7944,
     /* 222259 */     GIR_EraseRootFromParent_Done,
     /* 222260 */   // Label 4236: @222260
     /* 222260 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(222337), // Rule ID 7945 //
     /* 222265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222317 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222321 */     // MIs[2] Operand 1
     /* 222321 */     // No operand predicates
     /* 222321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222323 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 222326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222335 */     GIR_RootConstrainSelectedInstOperands,
     /* 222336 */     // GIR_Coverage, 7945,
     /* 222336 */     GIR_EraseRootFromParent_Done,
     /* 222337 */   // Label 4237: @222337
     /* 222337 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(222414), // Rule ID 7946 //
     /* 222342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222394 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222398 */     // MIs[2] Operand 1
     /* 222398 */     // No operand predicates
     /* 222398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222400 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 222403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222412 */     GIR_RootConstrainSelectedInstOperands,
     /* 222413 */     // GIR_Coverage, 7946,
     /* 222413 */     GIR_EraseRootFromParent_Done,
     /* 222414 */   // Label 4238: @222414
     /* 222414 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(222491), // Rule ID 7947 //
     /* 222419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222471 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222475 */     // MIs[2] Operand 1
     /* 222475 */     // No operand predicates
     /* 222475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222477 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 222480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222489 */     GIR_RootConstrainSelectedInstOperands,
     /* 222490 */     // GIR_Coverage, 7947,
     /* 222490 */     GIR_EraseRootFromParent_Done,
     /* 222491 */   // Label 4239: @222491
     /* 222491 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(222568), // Rule ID 7948 //
     /* 222496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222548 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222552 */     // MIs[2] Operand 1
     /* 222552 */     // No operand predicates
     /* 222552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222554 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 222557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222566 */     GIR_RootConstrainSelectedInstOperands,
     /* 222567 */     // GIR_Coverage, 7948,
     /* 222567 */     GIR_EraseRootFromParent_Done,
     /* 222568 */   // Label 4240: @222568
     /* 222568 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(222645), // Rule ID 7949 //
     /* 222573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222625 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222629 */     // MIs[2] Operand 1
     /* 222629 */     // No operand predicates
     /* 222629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222631 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 222634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222643 */     GIR_RootConstrainSelectedInstOperands,
     /* 222644 */     // GIR_Coverage, 7949,
     /* 222644 */     GIR_EraseRootFromParent_Done,
     /* 222645 */   // Label 4241: @222645
     /* 222645 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(222722), // Rule ID 7950 //
     /* 222650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222702 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222706 */     // MIs[2] Operand 1
     /* 222706 */     // No operand predicates
     /* 222706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222708 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 222711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222720 */     GIR_RootConstrainSelectedInstOperands,
     /* 222721 */     // GIR_Coverage, 7950,
     /* 222721 */     GIR_EraseRootFromParent_Done,
     /* 222722 */   // Label 4242: @222722
     /* 222722 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(222799), // Rule ID 7951 //
     /* 222727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 222735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222779 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222783 */     // MIs[2] Operand 1
     /* 222783 */     // No operand predicates
     /* 222783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222785 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 222788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222797 */     GIR_RootConstrainSelectedInstOperands,
     /* 222798 */     // GIR_Coverage, 7951,
     /* 222798 */     GIR_EraseRootFromParent_Done,
     /* 222799 */   // Label 4243: @222799
     /* 222799 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(222876), // Rule ID 7952 //
     /* 222804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 222812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222856 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222860 */     // MIs[2] Operand 1
     /* 222860 */     // No operand predicates
     /* 222860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222862 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 222865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222874 */     GIR_RootConstrainSelectedInstOperands,
     /* 222875 */     // GIR_Coverage, 7952,
     /* 222875 */     GIR_EraseRootFromParent_Done,
     /* 222876 */   // Label 4244: @222876
     /* 222876 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(222953), // Rule ID 7953 //
     /* 222881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 222889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222933 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222937 */     // MIs[2] Operand 1
     /* 222937 */     // No operand predicates
     /* 222937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222939 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 222942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222951 */     GIR_RootConstrainSelectedInstOperands,
     /* 222952 */     // GIR_Coverage, 7953,
     /* 222952 */     GIR_EraseRootFromParent_Done,
     /* 222953 */   // Label 4245: @222953
     /* 222953 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(223030), // Rule ID 7954 //
     /* 222958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 222966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223010 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223014 */     // MIs[2] Operand 1
     /* 223014 */     // No operand predicates
     /* 223014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223016 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 223019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223028 */     GIR_RootConstrainSelectedInstOperands,
     /* 223029 */     // GIR_Coverage, 7954,
     /* 223029 */     GIR_EraseRootFromParent_Done,
     /* 223030 */   // Label 4246: @223030
     /* 223030 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(223107), // Rule ID 7955 //
     /* 223035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 223043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223087 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223091 */     // MIs[2] Operand 1
     /* 223091 */     // No operand predicates
     /* 223091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223093 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 223096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223105 */     GIR_RootConstrainSelectedInstOperands,
     /* 223106 */     // GIR_Coverage, 7955,
     /* 223106 */     GIR_EraseRootFromParent_Done,
     /* 223107 */   // Label 4247: @223107
     /* 223107 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(223184), // Rule ID 7956 //
     /* 223112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 223120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223164 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223168 */     // MIs[2] Operand 1
     /* 223168 */     // No operand predicates
     /* 223168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223170 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 223173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223182 */     GIR_RootConstrainSelectedInstOperands,
     /* 223183 */     // GIR_Coverage, 7956,
     /* 223183 */     GIR_EraseRootFromParent_Done,
     /* 223184 */   // Label 4248: @223184
     /* 223184 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(223240), // Rule ID 55 //
     /* 223189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 223192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 223197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 223200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 223203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 223206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223214 */     // MIs[0] Operand 3
     /* 223214 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 223225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 223229 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 223229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 223232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 223238 */     GIR_RootConstrainSelectedInstOperands,
     /* 223239 */     // GIR_Coverage, 55,
     /* 223239 */     GIR_EraseRootFromParent_Done,
     /* 223240 */   // Label 4249: @223240
     /* 223240 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(223296), // Rule ID 56 //
     /* 223245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 223248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 223253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 223256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 223259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 223262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223270 */     // MIs[0] Operand 3
     /* 223270 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 223281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 223285 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 223285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 223288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 223294 */     GIR_RootConstrainSelectedInstOperands,
     /* 223295 */     // GIR_Coverage, 56,
     /* 223295 */     GIR_EraseRootFromParent_Done,
     /* 223296 */   // Label 4250: @223296
     /* 223296 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(223352), // Rule ID 57 //
     /* 223301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 223304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 223309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 223312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 223315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 223318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223326 */     // MIs[0] Operand 3
     /* 223326 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 223337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 223341 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 223341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 223344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 223350 */     GIR_RootConstrainSelectedInstOperands,
     /* 223351 */     // GIR_Coverage, 57,
     /* 223351 */     GIR_EraseRootFromParent_Done,
     /* 223352 */   // Label 4251: @223352
     /* 223352 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(223408), // Rule ID 58 //
     /* 223357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 223360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 223365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 223368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 223371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 223374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223382 */     // MIs[0] Operand 3
     /* 223382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 223393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 223397 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 223397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 223400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 223406 */     GIR_RootConstrainSelectedInstOperands,
     /* 223407 */     // GIR_Coverage, 58,
     /* 223407 */     GIR_EraseRootFromParent_Done,
     /* 223408 */   // Label 4252: @223408
     /* 223408 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(223463), // Rule ID 2792 //
     /* 223413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 223416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 223421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223442 */     // MIs[0] imm
     /* 223442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 223450 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 223450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 223453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 223457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 223459 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 223461 */     GIR_RootConstrainSelectedInstOperands,
     /* 223462 */     // GIR_Coverage, 2792,
     /* 223462 */     GIR_EraseRootFromParent_Done,
     /* 223463 */   // Label 4253: @223463
     /* 223463 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(223518), // Rule ID 2793 //
     /* 223468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 223471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 223476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223497 */     // MIs[0] imm
     /* 223497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 223505 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 223505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 223508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 223512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 223514 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 223516 */     GIR_RootConstrainSelectedInstOperands,
     /* 223517 */     // GIR_Coverage, 2793,
     /* 223517 */     GIR_EraseRootFromParent_Done,
     /* 223518 */   // Label 4254: @223518
     /* 223518 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(223573), // Rule ID 2794 //
     /* 223523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 223526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 223531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223552 */     // MIs[0] imm
     /* 223552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223555 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 223560 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 223560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 223563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 223567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 223569 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 223571 */     GIR_RootConstrainSelectedInstOperands,
     /* 223572 */     // GIR_Coverage, 2794,
     /* 223572 */     GIR_EraseRootFromParent_Done,
     /* 223573 */   // Label 4255: @223573
     /* 223573 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(223628), // Rule ID 3545 //
     /* 223578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 223581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 223586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223607 */     // MIs[0] Idx
     /* 223607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 223615 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1635:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 223615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 223618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 223622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 223624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 223626 */     GIR_RootConstrainSelectedInstOperands,
     /* 223627 */     // GIR_Coverage, 3545,
     /* 223627 */     GIR_EraseRootFromParent_Done,
     /* 223628 */   // Label 4256: @223628
     /* 223628 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(223683), // Rule ID 3546 //
     /* 223633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 223636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 223641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223662 */     // MIs[0] Idx
     /* 223662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223665 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 223670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1635:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 223670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 223673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 223677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 223679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 223681 */     GIR_RootConstrainSelectedInstOperands,
     /* 223682 */     // GIR_Coverage, 3546,
     /* 223682 */     GIR_EraseRootFromParent_Done,
     /* 223683 */   // Label 4257: @223683
     /* 223683 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(223738), // Rule ID 3547 //
     /* 223688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 223691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 223696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223717 */     // MIs[0] Idx
     /* 223717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223720 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 223725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1635:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 223725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 223728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 223732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 223734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 223736 */     GIR_RootConstrainSelectedInstOperands,
     /* 223737 */     // GIR_Coverage, 3547,
     /* 223737 */     GIR_EraseRootFromParent_Done,
     /* 223738 */   // Label 4258: @223738
     /* 223738 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(223793), // Rule ID 3841 //
     /* 223743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 223746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 223751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 223754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 223757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 223760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223772 */     // MIs[0] imm
     /* 223772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 223780 */     // (intrinsic_wo_chain:{ *:[v2i64] } 550:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 223780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 223783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 223785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 223787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 223789 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 223791 */     GIR_RootConstrainSelectedInstOperands,
     /* 223792 */     // GIR_Coverage, 3841,
     /* 223792 */     GIR_EraseRootFromParent_Done,
     /* 223793 */   // Label 4259: @223793
     /* 223793 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(223840), // Rule ID 2846 //
     /* 223798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 223806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223819 */     // MIs[0] idx
     /* 223819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 223827 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1485:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 223827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 223830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223836 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 223838 */     GIR_RootConstrainSelectedInstOperands,
     /* 223839 */     // GIR_Coverage, 2846,
     /* 223839 */     GIR_EraseRootFromParent_Done,
     /* 223840 */   // Label 4260: @223840
     /* 223840 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(223887), // Rule ID 2847 //
     /* 223845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 223853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223866 */     // MIs[0] idx
     /* 223866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 223874 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 223874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 223877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223883 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 223885 */     GIR_RootConstrainSelectedInstOperands,
     /* 223886 */     // GIR_Coverage, 2847,
     /* 223886 */     GIR_EraseRootFromParent_Done,
     /* 223887 */   // Label 4261: @223887
     /* 223887 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(223934), // Rule ID 2848 //
     /* 223892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 223900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223913 */     // MIs[0] idx
     /* 223913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 223921 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 223921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 223924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223930 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 223932 */     GIR_RootConstrainSelectedInstOperands,
     /* 223933 */     // GIR_Coverage, 2848,
     /* 223933 */     GIR_EraseRootFromParent_Done,
     /* 223934 */   // Label 4262: @223934
     /* 223934 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(223981), // Rule ID 2997 //
     /* 223939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 223947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223960 */     // MIs[0] Op3
     /* 223960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 223968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 223968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 223971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223979 */     GIR_RootConstrainSelectedInstOperands,
     /* 223980 */     // GIR_Coverage, 2997,
     /* 223980 */     GIR_EraseRootFromParent_Done,
     /* 223981 */   // Label 4263: @223981
     /* 223981 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(224028), // Rule ID 2998 //
     /* 223986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 223994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224007 */     // MIs[0] Op3
     /* 224007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 224015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 224015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 224018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224026 */     GIR_RootConstrainSelectedInstOperands,
     /* 224027 */     // GIR_Coverage, 2998,
     /* 224027 */     GIR_EraseRootFromParent_Done,
     /* 224028 */   // Label 4264: @224028
     /* 224028 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(224075), // Rule ID 2999 //
     /* 224033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 224041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224054 */     // MIs[0] Op3
     /* 224054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 224062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 224062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 224065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224073 */     GIR_RootConstrainSelectedInstOperands,
     /* 224074 */     // GIR_Coverage, 2999,
     /* 224074 */     GIR_EraseRootFromParent_Done,
     /* 224075 */   // Label 4265: @224075
     /* 224075 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(224122), // Rule ID 3000 //
     /* 224080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 224088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224101 */     // MIs[0] Op3
     /* 224101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 224109 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1762:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 224109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 224112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224120 */     GIR_RootConstrainSelectedInstOperands,
     /* 224121 */     // GIR_Coverage, 3000,
     /* 224121 */     GIR_EraseRootFromParent_Done,
     /* 224122 */   // Label 4266: @224122
     /* 224122 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(224169), // Rule ID 3001 //
     /* 224127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 224135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224148 */     // MIs[0] Op3
     /* 224148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 224156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1762:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 224156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 224159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224167 */     GIR_RootConstrainSelectedInstOperands,
     /* 224168 */     // GIR_Coverage, 3001,
     /* 224168 */     GIR_EraseRootFromParent_Done,
     /* 224169 */   // Label 4267: @224169
     /* 224169 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(224216), // Rule ID 3049 //
     /* 224174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 224182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224195 */     // MIs[0] Op3
     /* 224195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 224203 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1873:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 224203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 224206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224214 */     GIR_RootConstrainSelectedInstOperands,
     /* 224215 */     // GIR_Coverage, 3049,
     /* 224215 */     GIR_EraseRootFromParent_Done,
     /* 224216 */   // Label 4268: @224216
     /* 224216 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(224263), // Rule ID 3051 //
     /* 224221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 224229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224242 */     // MIs[0] Op3
     /* 224242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 224250 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1873:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 224250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 224253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224261 */     GIR_RootConstrainSelectedInstOperands,
     /* 224262 */     // GIR_Coverage, 3051,
     /* 224262 */     GIR_EraseRootFromParent_Done,
     /* 224263 */   // Label 4269: @224263
     /* 224263 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(224310), // Rule ID 3053 //
     /* 224268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 224276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224289 */     // MIs[0] Op3
     /* 224289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 224297 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1873:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 224297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 224300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224308 */     GIR_RootConstrainSelectedInstOperands,
     /* 224309 */     // GIR_Coverage, 3053,
     /* 224309 */     GIR_EraseRootFromParent_Done,
     /* 224310 */   // Label 4270: @224310
     /* 224310 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(224357), // Rule ID 3055 //
     /* 224315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 224323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224336 */     // MIs[0] Op3
     /* 224336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 224344 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1873:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 224344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 224347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224355 */     GIR_RootConstrainSelectedInstOperands,
     /* 224356 */     // GIR_Coverage, 3055,
     /* 224356 */     GIR_EraseRootFromParent_Done,
     /* 224357 */   // Label 4271: @224357
     /* 224357 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(224404), // Rule ID 3077 //
     /* 224362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 224370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224383 */     // MIs[0] Op3
     /* 224383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 224391 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 224391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 224394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224402 */     GIR_RootConstrainSelectedInstOperands,
     /* 224403 */     // GIR_Coverage, 3077,
     /* 224403 */     GIR_EraseRootFromParent_Done,
     /* 224404 */   // Label 4272: @224404
     /* 224404 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(224451), // Rule ID 3078 //
     /* 224409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 224417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224430 */     // MIs[0] Op3
     /* 224430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 224438 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 224438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 224441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224449 */     GIR_RootConstrainSelectedInstOperands,
     /* 224450 */     // GIR_Coverage, 3078,
     /* 224450 */     GIR_EraseRootFromParent_Done,
     /* 224451 */   // Label 4273: @224451
     /* 224451 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(224498), // Rule ID 3079 //
     /* 224456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 224464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224477 */     // MIs[0] Op3
     /* 224477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 224485 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 224485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 224488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224496 */     GIR_RootConstrainSelectedInstOperands,
     /* 224497 */     // GIR_Coverage, 3079,
     /* 224497 */     GIR_EraseRootFromParent_Done,
     /* 224498 */   // Label 4274: @224498
     /* 224498 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(224545), // Rule ID 3148 //
     /* 224503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 224511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224524 */     // MIs[0] Op3
     /* 224524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 224532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2154:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 224532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 224535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224543 */     GIR_RootConstrainSelectedInstOperands,
     /* 224544 */     // GIR_Coverage, 3148,
     /* 224544 */     GIR_EraseRootFromParent_Done,
     /* 224545 */   // Label 4275: @224545
     /* 224545 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(224592), // Rule ID 3149 //
     /* 224550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 224558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224571 */     // MIs[0] Op3
     /* 224571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 224579 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2154:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 224579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 224582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224590 */     GIR_RootConstrainSelectedInstOperands,
     /* 224591 */     // GIR_Coverage, 3149,
     /* 224591 */     GIR_EraseRootFromParent_Done,
     /* 224592 */   // Label 4276: @224592
     /* 224592 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(224639), // Rule ID 3150 //
     /* 224597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 224605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224618 */     // MIs[0] Op3
     /* 224618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 224626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2154:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 224626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 224629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224637 */     GIR_RootConstrainSelectedInstOperands,
     /* 224638 */     // GIR_Coverage, 3150,
     /* 224638 */     GIR_EraseRootFromParent_Done,
     /* 224639 */   // Label 4277: @224639
     /* 224639 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(224686), // Rule ID 3151 //
     /* 224644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 224652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224665 */     // MIs[0] Op3
     /* 224665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 224673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2154:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 224673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 224676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224684 */     GIR_RootConstrainSelectedInstOperands,
     /* 224685 */     // GIR_Coverage, 3151,
     /* 224685 */     GIR_EraseRootFromParent_Done,
     /* 224686 */   // Label 4278: @224686
     /* 224686 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(224733), // Rule ID 3530 //
     /* 224691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 224694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 224699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224712 */     // MIs[0] Op3
     /* 224712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 224720 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1364:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 224720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 224723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224731 */     GIR_RootConstrainSelectedInstOperands,
     /* 224732 */     // GIR_Coverage, 3530,
     /* 224732 */     GIR_EraseRootFromParent_Done,
     /* 224733 */   // Label 4279: @224733
     /* 224733 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(224780), // Rule ID 3578 //
     /* 224738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 224741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 224746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224759 */     // MIs[0] Op3
     /* 224759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224762 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 224767 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 224767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 224770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224778 */     GIR_RootConstrainSelectedInstOperands,
     /* 224779 */     // GIR_Coverage, 3578,
     /* 224779 */     GIR_EraseRootFromParent_Done,
     /* 224780 */   // Label 4280: @224780
     /* 224780 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(224827), // Rule ID 3579 //
     /* 224785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 224788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 224793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224806 */     // MIs[0] Op3
     /* 224806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 224814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 224814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 224817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224825 */     GIR_RootConstrainSelectedInstOperands,
     /* 224826 */     // GIR_Coverage, 3579,
     /* 224826 */     GIR_EraseRootFromParent_Done,
     /* 224827 */   // Label 4281: @224827
     /* 224827 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(224874), // Rule ID 3580 //
     /* 224832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 224835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 224840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224853 */     // MIs[0] Op3
     /* 224853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 224861 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1603:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 224861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 224864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224872 */     GIR_RootConstrainSelectedInstOperands,
     /* 224873 */     // GIR_Coverage, 3580,
     /* 224873 */     GIR_EraseRootFromParent_Done,
     /* 224874 */   // Label 4282: @224874
     /* 224874 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(224921), // Rule ID 3581 //
     /* 224879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 224882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 224887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224900 */     // MIs[0] Op3
     /* 224900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 224908 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1604:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 224908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 224911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224919 */     GIR_RootConstrainSelectedInstOperands,
     /* 224920 */     // GIR_Coverage, 3581,
     /* 224920 */     GIR_EraseRootFromParent_Done,
     /* 224921 */   // Label 4283: @224921
     /* 224921 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(224968), // Rule ID 3582 //
     /* 224926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 224929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 224934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224947 */     // MIs[0] Op3
     /* 224947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 224955 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1604:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 224955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 224958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224966 */     GIR_RootConstrainSelectedInstOperands,
     /* 224967 */     // GIR_Coverage, 3582,
     /* 224967 */     GIR_EraseRootFromParent_Done,
     /* 224968 */   // Label 4284: @224968
     /* 224968 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(225015), // Rule ID 3583 //
     /* 224973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 224976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 224981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224994 */     // MIs[0] Op3
     /* 224994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 225002 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1604:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 225002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 225005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225013 */     GIR_RootConstrainSelectedInstOperands,
     /* 225014 */     // GIR_Coverage, 3583,
     /* 225014 */     GIR_EraseRootFromParent_Done,
     /* 225015 */   // Label 4285: @225015
     /* 225015 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(225062), // Rule ID 11373 //
     /* 225020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 225028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225041 */     // MIs[0] Op3
     /* 225041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225049 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 225052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225060 */     GIR_RootConstrainSelectedInstOperands,
     /* 225061 */     // GIR_Coverage, 11373,
     /* 225061 */     GIR_EraseRootFromParent_Done,
     /* 225062 */   // Label 4286: @225062
     /* 225062 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(225109), // Rule ID 11374 //
     /* 225067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 225075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225088 */     // MIs[0] Op3
     /* 225088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 225099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225107 */     GIR_RootConstrainSelectedInstOperands,
     /* 225108 */     // GIR_Coverage, 11374,
     /* 225108 */     GIR_EraseRootFromParent_Done,
     /* 225109 */   // Label 4287: @225109
     /* 225109 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(225156), // Rule ID 11375 //
     /* 225114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 225122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225135 */     // MIs[0] Op3
     /* 225135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 225143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 225146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225154 */     GIR_RootConstrainSelectedInstOperands,
     /* 225155 */     // GIR_Coverage, 11375,
     /* 225155 */     GIR_EraseRootFromParent_Done,
     /* 225156 */   // Label 4288: @225156
     /* 225156 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(225203), // Rule ID 11376 //
     /* 225161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 225169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225182 */     // MIs[0] Op3
     /* 225182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 225193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225201 */     GIR_RootConstrainSelectedInstOperands,
     /* 225202 */     // GIR_Coverage, 11376,
     /* 225202 */     GIR_EraseRootFromParent_Done,
     /* 225203 */   // Label 4289: @225203
     /* 225203 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(225250), // Rule ID 11377 //
     /* 225208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 225216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225229 */     // MIs[0] Op3
     /* 225229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225237 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 225240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225248 */     GIR_RootConstrainSelectedInstOperands,
     /* 225249 */     // GIR_Coverage, 11377,
     /* 225249 */     GIR_EraseRootFromParent_Done,
     /* 225250 */   // Label 4290: @225250
     /* 225250 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(225297), // Rule ID 11378 //
     /* 225255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 225263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225276 */     // MIs[0] Op3
     /* 225276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1834:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 225284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 225287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225295 */     GIR_RootConstrainSelectedInstOperands,
     /* 225296 */     // GIR_Coverage, 11378,
     /* 225296 */     GIR_EraseRootFromParent_Done,
     /* 225297 */   // Label 4291: @225297
     /* 225297 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(225344), // Rule ID 11401 //
     /* 225302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 225310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225323 */     // MIs[0] Op3
     /* 225323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225331 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1764:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 225334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225342 */     GIR_RootConstrainSelectedInstOperands,
     /* 225343 */     // GIR_Coverage, 11401,
     /* 225343 */     GIR_EraseRootFromParent_Done,
     /* 225344 */   // Label 4292: @225344
     /* 225344 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(225391), // Rule ID 11402 //
     /* 225349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 225357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225370 */     // MIs[0] Op3
     /* 225370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225373 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1764:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 225381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225387 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225389 */     GIR_RootConstrainSelectedInstOperands,
     /* 225390 */     // GIR_Coverage, 11402,
     /* 225390 */     GIR_EraseRootFromParent_Done,
     /* 225391 */   // Label 4293: @225391
     /* 225391 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(225438), // Rule ID 11403 //
     /* 225396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 225404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225417 */     // MIs[0] Op3
     /* 225417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2000:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 225428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225436 */     GIR_RootConstrainSelectedInstOperands,
     /* 225437 */     // GIR_Coverage, 11403,
     /* 225437 */     GIR_EraseRootFromParent_Done,
     /* 225438 */   // Label 4294: @225438
     /* 225438 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(225485), // Rule ID 11404 //
     /* 225443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 225451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225464 */     // MIs[0] Op3
     /* 225464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2000:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 225475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225483 */     GIR_RootConstrainSelectedInstOperands,
     /* 225484 */     // GIR_Coverage, 11404,
     /* 225484 */     GIR_EraseRootFromParent_Done,
     /* 225485 */   // Label 4295: @225485
     /* 225485 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(225532), // Rule ID 11405 //
     /* 225490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 225498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225511 */     // MIs[0] Op3
     /* 225511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2002:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 225522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225530 */     GIR_RootConstrainSelectedInstOperands,
     /* 225531 */     // GIR_Coverage, 11405,
     /* 225531 */     GIR_EraseRootFromParent_Done,
     /* 225532 */   // Label 4296: @225532
     /* 225532 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(225579), // Rule ID 11406 //
     /* 225537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 225545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225558 */     // MIs[0] Op3
     /* 225558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2002:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 225569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225577 */     GIR_RootConstrainSelectedInstOperands,
     /* 225578 */     // GIR_Coverage, 11406,
     /* 225578 */     GIR_EraseRootFromParent_Done,
     /* 225579 */   // Label 4297: @225579
     /* 225579 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(225626), // Rule ID 11407 //
     /* 225584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 225592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225605 */     // MIs[0] Op3
     /* 225605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225613 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 225616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225624 */     GIR_RootConstrainSelectedInstOperands,
     /* 225625 */     // GIR_Coverage, 11407,
     /* 225625 */     GIR_EraseRootFromParent_Done,
     /* 225626 */   // Label 4298: @225626
     /* 225626 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(225673), // Rule ID 11408 //
     /* 225631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 225639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225652 */     // MIs[0] Op3
     /* 225652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 225663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225671 */     GIR_RootConstrainSelectedInstOperands,
     /* 225672 */     // GIR_Coverage, 11408,
     /* 225672 */     GIR_EraseRootFromParent_Done,
     /* 225673 */   // Label 4299: @225673
     /* 225673 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(225720), // Rule ID 11409 //
     /* 225678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 225686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225699 */     // MIs[0] Op3
     /* 225699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225707 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 225710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225718 */     GIR_RootConstrainSelectedInstOperands,
     /* 225719 */     // GIR_Coverage, 11409,
     /* 225719 */     GIR_EraseRootFromParent_Done,
     /* 225720 */   // Label 4300: @225720
     /* 225720 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(225767), // Rule ID 11410 //
     /* 225725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 225733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225746 */     // MIs[0] Op3
     /* 225746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 225757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225765 */     GIR_RootConstrainSelectedInstOperands,
     /* 225766 */     // GIR_Coverage, 11410,
     /* 225766 */     GIR_EraseRootFromParent_Done,
     /* 225767 */   // Label 4301: @225767
     /* 225767 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(225814), // Rule ID 11654 //
     /* 225772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 225780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225793 */     // MIs[0] Op3
     /* 225793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 225801 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1869:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 225801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 225804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225812 */     GIR_RootConstrainSelectedInstOperands,
     /* 225813 */     // GIR_Coverage, 11654,
     /* 225813 */     GIR_EraseRootFromParent_Done,
     /* 225814 */   // Label 4302: @225814
     /* 225814 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(225861), // Rule ID 11655 //
     /* 225819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 225827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225840 */     // MIs[0] Op3
     /* 225840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 225848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1869:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 225848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 225851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225859 */     GIR_RootConstrainSelectedInstOperands,
     /* 225860 */     // GIR_Coverage, 11655,
     /* 225860 */     GIR_EraseRootFromParent_Done,
     /* 225861 */   // Label 4303: @225861
     /* 225861 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(225908), // Rule ID 11656 //
     /* 225866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 225874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225887 */     // MIs[0] Op3
     /* 225887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 225895 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 225895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 225898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225906 */     GIR_RootConstrainSelectedInstOperands,
     /* 225907 */     // GIR_Coverage, 11656,
     /* 225907 */     GIR_EraseRootFromParent_Done,
     /* 225908 */   // Label 4304: @225908
     /* 225908 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(225955), // Rule ID 11657 //
     /* 225913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 225921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225934 */     // MIs[0] Op3
     /* 225934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 225942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1869:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 225942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 225945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225953 */     GIR_RootConstrainSelectedInstOperands,
     /* 225954 */     // GIR_Coverage, 11657,
     /* 225954 */     GIR_EraseRootFromParent_Done,
     /* 225955 */   // Label 4305: @225955
     /* 225955 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(226002), // Rule ID 11658 //
     /* 225960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 225968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225981 */     // MIs[0] Op3
     /* 225981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 225989 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2060:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 225989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 225992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226000 */     GIR_RootConstrainSelectedInstOperands,
     /* 226001 */     // GIR_Coverage, 11658,
     /* 226001 */     GIR_EraseRootFromParent_Done,
     /* 226002 */   // Label 4306: @226002
     /* 226002 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(226049), // Rule ID 11660 //
     /* 226007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 226015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226028 */     // MIs[0] Op3
     /* 226028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2060:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 226039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226047 */     GIR_RootConstrainSelectedInstOperands,
     /* 226048 */     // GIR_Coverage, 11660,
     /* 226048 */     GIR_EraseRootFromParent_Done,
     /* 226049 */   // Label 4307: @226049
     /* 226049 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(226096), // Rule ID 11662 //
     /* 226054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 226062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226075 */     // MIs[0] Op3
     /* 226075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 226086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226094 */     GIR_RootConstrainSelectedInstOperands,
     /* 226095 */     // GIR_Coverage, 11662,
     /* 226095 */     GIR_EraseRootFromParent_Done,
     /* 226096 */   // Label 4308: @226096
     /* 226096 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(226143), // Rule ID 11664 //
     /* 226101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 226109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226122 */     // MIs[0] Op3
     /* 226122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2060:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 226133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226141 */     GIR_RootConstrainSelectedInstOperands,
     /* 226142 */     // GIR_Coverage, 11664,
     /* 226142 */     GIR_EraseRootFromParent_Done,
     /* 226143 */   // Label 4309: @226143
     /* 226143 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(226190), // Rule ID 11666 //
     /* 226148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 226156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226169 */     // MIs[0] Op3
     /* 226169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 226177 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 226177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 226180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226188 */     GIR_RootConstrainSelectedInstOperands,
     /* 226189 */     // GIR_Coverage, 11666,
     /* 226189 */     GIR_EraseRootFromParent_Done,
     /* 226190 */   // Label 4310: @226190
     /* 226190 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(226237), // Rule ID 11667 //
     /* 226195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 226203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226216 */     // MIs[0] Op3
     /* 226216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 226224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 226224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 226227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226235 */     GIR_RootConstrainSelectedInstOperands,
     /* 226236 */     // GIR_Coverage, 11667,
     /* 226236 */     GIR_EraseRootFromParent_Done,
     /* 226237 */   // Label 4311: @226237
     /* 226237 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(226284), // Rule ID 11668 //
     /* 226242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 226250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226263 */     // MIs[0] Op3
     /* 226263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 226271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 226271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 226274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226282 */     GIR_RootConstrainSelectedInstOperands,
     /* 226283 */     // GIR_Coverage, 11668,
     /* 226283 */     GIR_EraseRootFromParent_Done,
     /* 226284 */   // Label 4312: @226284
     /* 226284 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(226331), // Rule ID 11669 //
     /* 226289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 226297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226310 */     // MIs[0] Op3
     /* 226310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 226318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 226318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 226321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226329 */     GIR_RootConstrainSelectedInstOperands,
     /* 226330 */     // GIR_Coverage, 11669,
     /* 226330 */     GIR_EraseRootFromParent_Done,
     /* 226331 */   // Label 4313: @226331
     /* 226331 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(226378), // Rule ID 11756 //
     /* 226336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 226344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226357 */     // MIs[0] Op3
     /* 226357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226365 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2069:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 226368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226376 */     GIR_RootConstrainSelectedInstOperands,
     /* 226377 */     // GIR_Coverage, 11756,
     /* 226377 */     GIR_EraseRootFromParent_Done,
     /* 226378 */   // Label 4314: @226378
     /* 226378 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(226425), // Rule ID 11758 //
     /* 226383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 226391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226404 */     // MIs[0] Op3
     /* 226404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2069:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 226415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226423 */     GIR_RootConstrainSelectedInstOperands,
     /* 226424 */     // GIR_Coverage, 11758,
     /* 226424 */     GIR_EraseRootFromParent_Done,
     /* 226425 */   // Label 4315: @226425
     /* 226425 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(226472), // Rule ID 11760 //
     /* 226430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 226438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226451 */     // MIs[0] Op3
     /* 226451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2069:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 226462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226470 */     GIR_RootConstrainSelectedInstOperands,
     /* 226471 */     // GIR_Coverage, 11760,
     /* 226471 */     GIR_EraseRootFromParent_Done,
     /* 226472 */   // Label 4316: @226472
     /* 226472 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(226519), // Rule ID 11762 //
     /* 226477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 226485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226498 */     // MIs[0] Op3
     /* 226498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2069:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 226509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226517 */     GIR_RootConstrainSelectedInstOperands,
     /* 226518 */     // GIR_Coverage, 11762,
     /* 226518 */     GIR_EraseRootFromParent_Done,
     /* 226519 */   // Label 4317: @226519
     /* 226519 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(226566), // Rule ID 11764 //
     /* 226524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 226532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226545 */     // MIs[0] Op3
     /* 226545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226553 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1870:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 226556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226564 */     GIR_RootConstrainSelectedInstOperands,
     /* 226565 */     // GIR_Coverage, 11764,
     /* 226565 */     GIR_EraseRootFromParent_Done,
     /* 226566 */   // Label 4318: @226566
     /* 226566 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(226613), // Rule ID 11765 //
     /* 226571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 226579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226592 */     // MIs[0] Op3
     /* 226592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1870:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 226603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226611 */     GIR_RootConstrainSelectedInstOperands,
     /* 226612 */     // GIR_Coverage, 11765,
     /* 226612 */     GIR_EraseRootFromParent_Done,
     /* 226613 */   // Label 4319: @226613
     /* 226613 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(226660), // Rule ID 11766 //
     /* 226618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 226626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226639 */     // MIs[0] Op3
     /* 226639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1870:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 226650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226658 */     GIR_RootConstrainSelectedInstOperands,
     /* 226659 */     // GIR_Coverage, 11766,
     /* 226659 */     GIR_EraseRootFromParent_Done,
     /* 226660 */   // Label 4320: @226660
     /* 226660 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(226707), // Rule ID 11767 //
     /* 226665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 226673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226686 */     // MIs[0] Op3
     /* 226686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1870:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 226697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226705 */     GIR_RootConstrainSelectedInstOperands,
     /* 226706 */     // GIR_Coverage, 11767,
     /* 226706 */     GIR_EraseRootFromParent_Done,
     /* 226707 */   // Label 4321: @226707
     /* 226707 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(226754), // Rule ID 11772 //
     /* 226712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 226720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226733 */     // MIs[0] Op3
     /* 226733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226741 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2062:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 226744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226752 */     GIR_RootConstrainSelectedInstOperands,
     /* 226753 */     // GIR_Coverage, 11772,
     /* 226753 */     GIR_EraseRootFromParent_Done,
     /* 226754 */   // Label 4322: @226754
     /* 226754 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(226801), // Rule ID 11773 //
     /* 226759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 226767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226780 */     // MIs[0] Op3
     /* 226780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226788 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2062:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 226791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226799 */     GIR_RootConstrainSelectedInstOperands,
     /* 226800 */     // GIR_Coverage, 11773,
     /* 226800 */     GIR_EraseRootFromParent_Done,
     /* 226801 */   // Label 4323: @226801
     /* 226801 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(226848), // Rule ID 11774 //
     /* 226806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 226814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226827 */     // MIs[0] Op3
     /* 226827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2062:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 226838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226846 */     GIR_RootConstrainSelectedInstOperands,
     /* 226847 */     // GIR_Coverage, 11774,
     /* 226847 */     GIR_EraseRootFromParent_Done,
     /* 226848 */   // Label 4324: @226848
     /* 226848 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(226895), // Rule ID 11775 //
     /* 226853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 226861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226874 */     // MIs[0] Op3
     /* 226874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2062:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 226885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226893 */     GIR_RootConstrainSelectedInstOperands,
     /* 226894 */     // GIR_Coverage, 11775,
     /* 226894 */     GIR_EraseRootFromParent_Done,
     /* 226895 */   // Label 4325: @226895
     /* 226895 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(226942), // Rule ID 11835 //
     /* 226900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 226908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226921 */     // MIs[0] Op3
     /* 226921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226929 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1847:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 226932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226940 */     GIR_RootConstrainSelectedInstOperands,
     /* 226941 */     // GIR_Coverage, 11835,
     /* 226941 */     GIR_EraseRootFromParent_Done,
     /* 226942 */   // Label 4326: @226942
     /* 226942 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(226989), // Rule ID 11836 //
     /* 226947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 226955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226968 */     // MIs[0] Op3
     /* 226968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1847:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 226979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226987 */     GIR_RootConstrainSelectedInstOperands,
     /* 226988 */     // GIR_Coverage, 11836,
     /* 226988 */     GIR_EraseRootFromParent_Done,
     /* 226989 */   // Label 4327: @226989
     /* 226989 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(227036), // Rule ID 11837 //
     /* 226994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 227002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227015 */     // MIs[0] Op3
     /* 227015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1847:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 227026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227034 */     GIR_RootConstrainSelectedInstOperands,
     /* 227035 */     // GIR_Coverage, 11837,
     /* 227035 */     GIR_EraseRootFromParent_Done,
     /* 227036 */   // Label 4328: @227036
     /* 227036 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(227083), // Rule ID 11838 //
     /* 227041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 227049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227062 */     // MIs[0] Op3
     /* 227062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227070 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1726:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 227073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227081 */     GIR_RootConstrainSelectedInstOperands,
     /* 227082 */     // GIR_Coverage, 11838,
     /* 227082 */     GIR_EraseRootFromParent_Done,
     /* 227083 */   // Label 4329: @227083
     /* 227083 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(227130), // Rule ID 11839 //
     /* 227088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 227096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227109 */     // MIs[0] Op3
     /* 227109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1726:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 227120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227128 */     GIR_RootConstrainSelectedInstOperands,
     /* 227129 */     // GIR_Coverage, 11839,
     /* 227129 */     GIR_EraseRootFromParent_Done,
     /* 227130 */   // Label 4330: @227130
     /* 227130 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(227177), // Rule ID 11840 //
     /* 227135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 227143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227156 */     // MIs[0] Op3
     /* 227156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1726:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 227167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227175 */     GIR_RootConstrainSelectedInstOperands,
     /* 227176 */     // GIR_Coverage, 11840,
     /* 227176 */     GIR_EraseRootFromParent_Done,
     /* 227177 */   // Label 4331: @227177
     /* 227177 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(227224), // Rule ID 11841 //
     /* 227182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 227190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227203 */     // MIs[0] Op3
     /* 227203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227211 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1684:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 227214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227222 */     GIR_RootConstrainSelectedInstOperands,
     /* 227223 */     // GIR_Coverage, 11841,
     /* 227223 */     GIR_EraseRootFromParent_Done,
     /* 227224 */   // Label 4332: @227224
     /* 227224 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(227271), // Rule ID 11842 //
     /* 227229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 227237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227250 */     // MIs[0] Op3
     /* 227250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227258 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1684:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 227261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227269 */     GIR_RootConstrainSelectedInstOperands,
     /* 227270 */     // GIR_Coverage, 11842,
     /* 227270 */     GIR_EraseRootFromParent_Done,
     /* 227271 */   // Label 4333: @227271
     /* 227271 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(227318), // Rule ID 11843 //
     /* 227276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 227284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227297 */     // MIs[0] Op3
     /* 227297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1684:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 227308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227316 */     GIR_RootConstrainSelectedInstOperands,
     /* 227317 */     // GIR_Coverage, 11843,
     /* 227317 */     GIR_EraseRootFromParent_Done,
     /* 227318 */   // Label 4334: @227318
     /* 227318 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(227365), // Rule ID 11844 //
     /* 227323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 227331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227344 */     // MIs[0] Op3
     /* 227344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 227355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227363 */     GIR_RootConstrainSelectedInstOperands,
     /* 227364 */     // GIR_Coverage, 11844,
     /* 227364 */     GIR_EraseRootFromParent_Done,
     /* 227365 */   // Label 4335: @227365
     /* 227365 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(227412), // Rule ID 11845 //
     /* 227370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 227378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227391 */     // MIs[0] Op3
     /* 227391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227399 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 227402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227410 */     GIR_RootConstrainSelectedInstOperands,
     /* 227411 */     // GIR_Coverage, 11845,
     /* 227411 */     GIR_EraseRootFromParent_Done,
     /* 227412 */   // Label 4336: @227412
     /* 227412 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(227459), // Rule ID 11846 //
     /* 227417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 227425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227438 */     // MIs[0] Op3
     /* 227438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 227449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227457 */     GIR_RootConstrainSelectedInstOperands,
     /* 227458 */     // GIR_Coverage, 11846,
     /* 227458 */     GIR_EraseRootFromParent_Done,
     /* 227459 */   // Label 4337: @227459
     /* 227459 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(227506), // Rule ID 11847 //
     /* 227464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 227472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227485 */     // MIs[0] Op3
     /* 227485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 227496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227504 */     GIR_RootConstrainSelectedInstOperands,
     /* 227505 */     // GIR_Coverage, 11847,
     /* 227505 */     GIR_EraseRootFromParent_Done,
     /* 227506 */   // Label 4338: @227506
     /* 227506 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(227553), // Rule ID 11848 //
     /* 227511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 227519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227532 */     // MIs[0] Op3
     /* 227532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 227543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227551 */     GIR_RootConstrainSelectedInstOperands,
     /* 227552 */     // GIR_Coverage, 11848,
     /* 227552 */     GIR_EraseRootFromParent_Done,
     /* 227553 */   // Label 4339: @227553
     /* 227553 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(227600), // Rule ID 11849 //
     /* 227558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 227566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227579 */     // MIs[0] Op3
     /* 227579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 227590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227598 */     GIR_RootConstrainSelectedInstOperands,
     /* 227599 */     // GIR_Coverage, 11849,
     /* 227599 */     GIR_EraseRootFromParent_Done,
     /* 227600 */   // Label 4340: @227600
     /* 227600 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(227647), // Rule ID 11850 //
     /* 227605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 227613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227626 */     // MIs[0] Op3
     /* 227626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2046:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 227637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227645 */     GIR_RootConstrainSelectedInstOperands,
     /* 227646 */     // GIR_Coverage, 11850,
     /* 227646 */     GIR_EraseRootFromParent_Done,
     /* 227647 */   // Label 4341: @227647
     /* 227647 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(227694), // Rule ID 11851 //
     /* 227652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 227660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227673 */     // MIs[0] Op3
     /* 227673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227681 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2046:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 227684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227692 */     GIR_RootConstrainSelectedInstOperands,
     /* 227693 */     // GIR_Coverage, 11851,
     /* 227693 */     GIR_EraseRootFromParent_Done,
     /* 227694 */   // Label 4342: @227694
     /* 227694 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(227741), // Rule ID 11852 //
     /* 227699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 227707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227720 */     // MIs[0] Op3
     /* 227720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227728 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 227731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227739 */     GIR_RootConstrainSelectedInstOperands,
     /* 227740 */     // GIR_Coverage, 11852,
     /* 227740 */     GIR_EraseRootFromParent_Done,
     /* 227741 */   // Label 4343: @227741
     /* 227741 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(227788), // Rule ID 11853 //
     /* 227746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 227754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227767 */     // MIs[0] Op3
     /* 227767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227775 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2043:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 227778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227786 */     GIR_RootConstrainSelectedInstOperands,
     /* 227787 */     // GIR_Coverage, 11853,
     /* 227787 */     GIR_EraseRootFromParent_Done,
     /* 227788 */   // Label 4344: @227788
     /* 227788 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(227835), // Rule ID 11854 //
     /* 227793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 227801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227814 */     // MIs[0] Op3
     /* 227814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2043:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 227825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227833 */     GIR_RootConstrainSelectedInstOperands,
     /* 227834 */     // GIR_Coverage, 11854,
     /* 227834 */     GIR_EraseRootFromParent_Done,
     /* 227835 */   // Label 4345: @227835
     /* 227835 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(227882), // Rule ID 11855 //
     /* 227840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 227848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227861 */     // MIs[0] Op3
     /* 227861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 227872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227880 */     GIR_RootConstrainSelectedInstOperands,
     /* 227881 */     // GIR_Coverage, 11855,
     /* 227881 */     GIR_EraseRootFromParent_Done,
     /* 227882 */   // Label 4346: @227882
     /* 227882 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(227949), // Rule ID 2597 //
     /* 227887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 227895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 227919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 227921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 227924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 227938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 227945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 227947 */     GIR_RootConstrainSelectedInstOperands,
     /* 227948 */     // GIR_Coverage, 2597,
     /* 227948 */     GIR_EraseRootFromParent_Done,
     /* 227949 */   // Label 4347: @227949
     /* 227949 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(228016), // Rule ID 7754 //
     /* 227954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 227962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 227971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 227986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 227988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 227991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 228005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228014 */     GIR_RootConstrainSelectedInstOperands,
     /* 228015 */     // GIR_Coverage, 7754,
     /* 228015 */     GIR_EraseRootFromParent_Done,
     /* 228016 */   // Label 4348: @228016
     /* 228016 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(228083), // Rule ID 7756 //
     /* 228021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 228029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228055 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 228055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 228072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228081 */     GIR_RootConstrainSelectedInstOperands,
     /* 228082 */     // GIR_Coverage, 7756,
     /* 228082 */     GIR_EraseRootFromParent_Done,
     /* 228083 */   // Label 4349: @228083
     /* 228083 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(228150), // Rule ID 7758 //
     /* 228088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 228096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 228122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 228139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228148 */     GIR_RootConstrainSelectedInstOperands,
     /* 228149 */     // GIR_Coverage, 7758,
     /* 228149 */     GIR_EraseRootFromParent_Done,
     /* 228150 */   // Label 4350: @228150
     /* 228150 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(228217), // Rule ID 7760 //
     /* 228155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 228163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 228189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 228206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228215 */     GIR_RootConstrainSelectedInstOperands,
     /* 228216 */     // GIR_Coverage, 7760,
     /* 228216 */     GIR_EraseRootFromParent_Done,
     /* 228217 */   // Label 4351: @228217
     /* 228217 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(228284), // Rule ID 7790 //
     /* 228222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 228230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 228256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 228273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228282 */     GIR_RootConstrainSelectedInstOperands,
     /* 228283 */     // GIR_Coverage, 7790,
     /* 228283 */     GIR_EraseRootFromParent_Done,
     /* 228284 */   // Label 4352: @228284
     /* 228284 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(228351), // Rule ID 7792 //
     /* 228289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 228297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228323 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 228323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 228340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228349 */     GIR_RootConstrainSelectedInstOperands,
     /* 228350 */     // GIR_Coverage, 7792,
     /* 228350 */     GIR_EraseRootFromParent_Done,
     /* 228351 */   // Label 4353: @228351
     /* 228351 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(228418), // Rule ID 7794 //
     /* 228356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 228364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 228390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 228407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228416 */     GIR_RootConstrainSelectedInstOperands,
     /* 228417 */     // GIR_Coverage, 7794,
     /* 228417 */     GIR_EraseRootFromParent_Done,
     /* 228418 */   // Label 4354: @228418
     /* 228418 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(228485), // Rule ID 7796 //
     /* 228423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 228431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228457 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 228457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 228474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228483 */     GIR_RootConstrainSelectedInstOperands,
     /* 228484 */     // GIR_Coverage, 7796,
     /* 228484 */     GIR_EraseRootFromParent_Done,
     /* 228485 */   // Label 4355: @228485
     /* 228485 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(228552), // Rule ID 7802 //
     /* 228490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 228498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228524 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 228524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 228541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228550 */     GIR_RootConstrainSelectedInstOperands,
     /* 228551 */     // GIR_Coverage, 7802,
     /* 228551 */     GIR_EraseRootFromParent_Done,
     /* 228552 */   // Label 4356: @228552
     /* 228552 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(228619), // Rule ID 7804 //
     /* 228557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 228565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228591 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 228591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 228608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228617 */     GIR_RootConstrainSelectedInstOperands,
     /* 228618 */     // GIR_Coverage, 7804,
     /* 228618 */     GIR_EraseRootFromParent_Done,
     /* 228619 */   // Label 4357: @228619
     /* 228619 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(228686), // Rule ID 7806 //
     /* 228624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 228632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 228658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 228675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228684 */     GIR_RootConstrainSelectedInstOperands,
     /* 228685 */     // GIR_Coverage, 7806,
     /* 228685 */     GIR_EraseRootFromParent_Done,
     /* 228686 */   // Label 4358: @228686
     /* 228686 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(228753), // Rule ID 7808 //
     /* 228691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 228699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 228725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 228742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228751 */     GIR_RootConstrainSelectedInstOperands,
     /* 228752 */     // GIR_Coverage, 7808,
     /* 228752 */     GIR_EraseRootFromParent_Done,
     /* 228753 */   // Label 4359: @228753
     /* 228753 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(228820), // Rule ID 11536 //
     /* 228758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 228766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 228792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 228809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228818 */     GIR_RootConstrainSelectedInstOperands,
     /* 228819 */     // GIR_Coverage, 11536,
     /* 228819 */     GIR_EraseRootFromParent_Done,
     /* 228820 */   // Label 4360: @228820
     /* 228820 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(228887), // Rule ID 11538 //
     /* 228825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 228833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228859 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 228859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 228876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228885 */     GIR_RootConstrainSelectedInstOperands,
     /* 228886 */     // GIR_Coverage, 11538,
     /* 228886 */     GIR_EraseRootFromParent_Done,
     /* 228887 */   // Label 4361: @228887
     /* 228887 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(228954), // Rule ID 11540 //
     /* 228892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 228900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228926 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 228926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 228943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228952 */     GIR_RootConstrainSelectedInstOperands,
     /* 228953 */     // GIR_Coverage, 11540,
     /* 228953 */     GIR_EraseRootFromParent_Done,
     /* 228954 */   // Label 4362: @228954
     /* 228954 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(229021), // Rule ID 11542 //
     /* 228959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 228967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228993 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 228993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 229010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229019 */     GIR_RootConstrainSelectedInstOperands,
     /* 229020 */     // GIR_Coverage, 11542,
     /* 229020 */     GIR_EraseRootFromParent_Done,
     /* 229021 */   // Label 4363: @229021
     /* 229021 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(229088), // Rule ID 11544 //
     /* 229026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 229034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229060 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 229060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 229077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229086 */     GIR_RootConstrainSelectedInstOperands,
     /* 229087 */     // GIR_Coverage, 11544,
     /* 229087 */     GIR_EraseRootFromParent_Done,
     /* 229088 */   // Label 4364: @229088
     /* 229088 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(229155), // Rule ID 11550 //
     /* 229093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 229101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229127 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 229127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 229144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229153 */     GIR_RootConstrainSelectedInstOperands,
     /* 229154 */     // GIR_Coverage, 11550,
     /* 229154 */     GIR_EraseRootFromParent_Done,
     /* 229155 */   // Label 4365: @229155
     /* 229155 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(229222), // Rule ID 11552 //
     /* 229160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 229168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 229194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 229211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229220 */     GIR_RootConstrainSelectedInstOperands,
     /* 229221 */     // GIR_Coverage, 11552,
     /* 229221 */     GIR_EraseRootFromParent_Done,
     /* 229222 */   // Label 4366: @229222
     /* 229222 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(229289), // Rule ID 11554 //
     /* 229227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 229235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 229278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229287 */     GIR_RootConstrainSelectedInstOperands,
     /* 229288 */     // GIR_Coverage, 11554,
     /* 229288 */     GIR_EraseRootFromParent_Done,
     /* 229289 */   // Label 4367: @229289
     /* 229289 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(229356), // Rule ID 11556 //
     /* 229294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 229302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229328 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 229328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 229345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229354 */     GIR_RootConstrainSelectedInstOperands,
     /* 229355 */     // GIR_Coverage, 11556,
     /* 229355 */     GIR_EraseRootFromParent_Done,
     /* 229356 */   // Label 4368: @229356
     /* 229356 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(229410), // Rule ID 30 //
     /* 229361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 229364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 229369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 229378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 229381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229397 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 229397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 229400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229408 */     GIR_RootConstrainSelectedInstOperands,
     /* 229409 */     // GIR_Coverage, 30,
     /* 229409 */     GIR_EraseRootFromParent_Done,
     /* 229410 */   // Label 4369: @229410
     /* 229410 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(229464), // Rule ID 31 //
     /* 229415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 229418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 229423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 229432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 229435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229451 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 229451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 229454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229462 */     GIR_RootConstrainSelectedInstOperands,
     /* 229463 */     // GIR_Coverage, 31,
     /* 229463 */     GIR_EraseRootFromParent_Done,
     /* 229464 */   // Label 4370: @229464
     /* 229464 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(229518), // Rule ID 32 //
     /* 229469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 229472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 229477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 229486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 229489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229505 */     // (intrinsic_wo_chain:{ *:[v4i32] } 760:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 229505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 229508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229516 */     GIR_RootConstrainSelectedInstOperands,
     /* 229517 */     // GIR_Coverage, 32,
     /* 229517 */     GIR_EraseRootFromParent_Done,
     /* 229518 */   // Label 4371: @229518
     /* 229518 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(229572), // Rule ID 39 //
     /* 229523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 229531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 229534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 229537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 229540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 229543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229559 */     // (intrinsic_wo_chain:{ *:[v2f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 229559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 229562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229570 */     GIR_RootConstrainSelectedInstOperands,
     /* 229571 */     // GIR_Coverage, 39,
     /* 229571 */     GIR_EraseRootFromParent_Done,
     /* 229572 */   // Label 4372: @229572
     /* 229572 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(229626), // Rule ID 40 //
     /* 229577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 229585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 229594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 229597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229613 */     // (intrinsic_wo_chain:{ *:[v4f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 229613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 229616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229624 */     GIR_RootConstrainSelectedInstOperands,
     /* 229625 */     // GIR_Coverage, 40,
     /* 229625 */     GIR_EraseRootFromParent_Done,
     /* 229626 */   // Label 4373: @229626
     /* 229626 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(229680), // Rule ID 41 //
     /* 229631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 229639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 229642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 229645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 229648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 229651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229667 */     // (intrinsic_wo_chain:{ *:[v2f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 229667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 229670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229678 */     GIR_RootConstrainSelectedInstOperands,
     /* 229679 */     // GIR_Coverage, 41,
     /* 229679 */     GIR_EraseRootFromParent_Done,
     /* 229680 */   // Label 4374: @229680
     /* 229680 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(229734), // Rule ID 42 //
     /* 229685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 229693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 229702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 229705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229721 */     // (intrinsic_wo_chain:{ *:[v4f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 229721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 229724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229732 */     GIR_RootConstrainSelectedInstOperands,
     /* 229733 */     // GIR_Coverage, 42,
     /* 229733 */     GIR_EraseRootFromParent_Done,
     /* 229734 */   // Label 4375: @229734
     /* 229734 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(229788), // Rule ID 43 //
     /* 229739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 229747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 229750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 229753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 229756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 229759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229775 */     // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 229775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 229778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229786 */     GIR_RootConstrainSelectedInstOperands,
     /* 229787 */     // GIR_Coverage, 43,
     /* 229787 */     GIR_EraseRootFromParent_Done,
     /* 229788 */   // Label 4376: @229788
     /* 229788 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(229842), // Rule ID 44 //
     /* 229793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 229801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 229810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 229813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229829 */     // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 229829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 229832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229840 */     GIR_RootConstrainSelectedInstOperands,
     /* 229841 */     // GIR_Coverage, 44,
     /* 229841 */     GIR_EraseRootFromParent_Done,
     /* 229842 */   // Label 4377: @229842
     /* 229842 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(229896), // Rule ID 45 //
     /* 229847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 229855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 229858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 229861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 229864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 229867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229883 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 229883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 229886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229894 */     GIR_RootConstrainSelectedInstOperands,
     /* 229895 */     // GIR_Coverage, 45,
     /* 229895 */     GIR_EraseRootFromParent_Done,
     /* 229896 */   // Label 4378: @229896
     /* 229896 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(229950), // Rule ID 46 //
     /* 229901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 229909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 229918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 229921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229937 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 229937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 229940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229948 */     GIR_RootConstrainSelectedInstOperands,
     /* 229949 */     // GIR_Coverage, 46,
     /* 229949 */     GIR_EraseRootFromParent_Done,
     /* 229950 */   // Label 4379: @229950
     /* 229950 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(230004), // Rule ID 1587 //
     /* 229955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 229958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 229963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 229966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 229969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 229972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 229975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229991 */     // (intrinsic_wo_chain:{ *:[v4i16] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 229991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 229994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230002 */     GIR_RootConstrainSelectedInstOperands,
     /* 230003 */     // GIR_Coverage, 1587,
     /* 230003 */     GIR_EraseRootFromParent_Done,
     /* 230004 */   // Label 4380: @230004
     /* 230004 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(230058), // Rule ID 1588 //
     /* 230009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 230017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 230020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 230023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 230026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 230029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230045 */     // (intrinsic_wo_chain:{ *:[v8i16] } 693:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 230045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 230048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230056 */     GIR_RootConstrainSelectedInstOperands,
     /* 230057 */     // GIR_Coverage, 1588,
     /* 230057 */     GIR_EraseRootFromParent_Done,
     /* 230058 */   // Label 4381: @230058
     /* 230058 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(230112), // Rule ID 1589 //
     /* 230063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 230071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 230074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 230077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 230080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 230083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230099 */     // (intrinsic_wo_chain:{ *:[v2i32] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 230099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 230102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230110 */     GIR_RootConstrainSelectedInstOperands,
     /* 230111 */     // GIR_Coverage, 1589,
     /* 230111 */     GIR_EraseRootFromParent_Done,
     /* 230112 */   // Label 4382: @230112
     /* 230112 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(230166), // Rule ID 1590 //
     /* 230117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 230125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230153 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 230156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230164 */     GIR_RootConstrainSelectedInstOperands,
     /* 230165 */     // GIR_Coverage, 1590,
     /* 230165 */     GIR_EraseRootFromParent_Done,
     /* 230166 */   // Label 4383: @230166
     /* 230166 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(230220), // Rule ID 1591 //
     /* 230171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 230179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 230182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 230185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 230188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 230191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230207 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 230207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 230210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230218 */     GIR_RootConstrainSelectedInstOperands,
     /* 230219 */     // GIR_Coverage, 1591,
     /* 230219 */     GIR_EraseRootFromParent_Done,
     /* 230220 */   // Label 4384: @230220
     /* 230220 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(230274), // Rule ID 1592 //
     /* 230225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 230233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 230236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 230239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 230242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 230245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230261 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 230261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 230264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230272 */     GIR_RootConstrainSelectedInstOperands,
     /* 230273 */     // GIR_Coverage, 1592,
     /* 230273 */     GIR_EraseRootFromParent_Done,
     /* 230274 */   // Label 4385: @230274
     /* 230274 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(230328), // Rule ID 1593 //
     /* 230279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 230287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 230290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 230293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 230296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 230299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230315 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 230315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 230318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230326 */     GIR_RootConstrainSelectedInstOperands,
     /* 230327 */     // GIR_Coverage, 1593,
     /* 230327 */     GIR_EraseRootFromParent_Done,
     /* 230328 */   // Label 4386: @230328
     /* 230328 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(230382), // Rule ID 1594 //
     /* 230333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 230341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230369 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 230372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230380 */     GIR_RootConstrainSelectedInstOperands,
     /* 230381 */     // GIR_Coverage, 1594,
     /* 230381 */     GIR_EraseRootFromParent_Done,
     /* 230382 */   // Label 4387: @230382
     /* 230382 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(230436), // Rule ID 2307 //
     /* 230387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 230395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 230419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230423 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 230426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230434 */     GIR_RootConstrainSelectedInstOperands,
     /* 230435 */     // GIR_Coverage, 2307,
     /* 230435 */     GIR_EraseRootFromParent_Done,
     /* 230436 */   // Label 4388: @230436
     /* 230436 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(230490), // Rule ID 2308 //
     /* 230441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 230449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 230473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230477 */     // (intrinsic_wo_chain:{ *:[v4i32] } 530:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 230480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230488 */     GIR_RootConstrainSelectedInstOperands,
     /* 230489 */     // GIR_Coverage, 2308,
     /* 230489 */     GIR_EraseRootFromParent_Done,
     /* 230490 */   // Label 4389: @230490
     /* 230490 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(230544), // Rule ID 2309 //
     /* 230495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 230503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 230527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230531 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 230534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230542 */     GIR_RootConstrainSelectedInstOperands,
     /* 230543 */     // GIR_Coverage, 2309,
     /* 230543 */     GIR_EraseRootFromParent_Done,
     /* 230544 */   // Label 4390: @230544
     /* 230544 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(230598), // Rule ID 2310 //
     /* 230549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 230557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230585 */     // (intrinsic_wo_chain:{ *:[v4i32] } 531:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 230588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230596 */     GIR_RootConstrainSelectedInstOperands,
     /* 230597 */     // GIR_Coverage, 2310,
     /* 230597 */     GIR_EraseRootFromParent_Done,
     /* 230598 */   // Label 4391: @230598
     /* 230598 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(230652), // Rule ID 2311 //
     /* 230603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 230611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230639 */     // (intrinsic_wo_chain:{ *:[v4i32] } 533:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 230642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230650 */     GIR_RootConstrainSelectedInstOperands,
     /* 230651 */     // GIR_Coverage, 2311,
     /* 230651 */     GIR_EraseRootFromParent_Done,
     /* 230652 */   // Label 4392: @230652
     /* 230652 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(230706), // Rule ID 2312 //
     /* 230657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 230665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230693 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 230696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230704 */     GIR_RootConstrainSelectedInstOperands,
     /* 230705 */     // GIR_Coverage, 2312,
     /* 230705 */     GIR_EraseRootFromParent_Done,
     /* 230706 */   // Label 4393: @230706
     /* 230706 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(230760), // Rule ID 2313 //
     /* 230711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 230719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230747 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 230750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230758 */     GIR_RootConstrainSelectedInstOperands,
     /* 230759 */     // GIR_Coverage, 2313,
     /* 230759 */     GIR_EraseRootFromParent_Done,
     /* 230760 */   // Label 4394: @230760
     /* 230760 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(230817), // Rule ID 3633 //
     /* 230765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 230768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 230773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 230785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 230789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 230801 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 230801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 230804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 230808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 230810 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 230812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230815 */     GIR_RootConstrainSelectedInstOperands,
     /* 230816 */     // GIR_Coverage, 3633,
     /* 230816 */     GIR_EraseRootFromParent_Done,
     /* 230817 */   // Label 4395: @230817
     /* 230817 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(230874), // Rule ID 3634 //
     /* 230822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 230825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 230830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 230842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 230846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 230858 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 230858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 230861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 230865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 230867 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 230869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230872 */     GIR_RootConstrainSelectedInstOperands,
     /* 230873 */     // GIR_Coverage, 3634,
     /* 230873 */     GIR_EraseRootFromParent_Done,
     /* 230874 */   // Label 4396: @230874
     /* 230874 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(230931), // Rule ID 3635 //
     /* 230879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 230882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 230887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 230899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 230903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 230915 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 230915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 230918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 230922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 230924 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 230926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230929 */     GIR_RootConstrainSelectedInstOperands,
     /* 230930 */     // GIR_Coverage, 3635,
     /* 230930 */     GIR_EraseRootFromParent_Done,
     /* 230931 */   // Label 4397: @230931
     /* 230931 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(230988), // Rule ID 3636 //
     /* 230936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 230939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 230944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 230956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 230960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 230972 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 230972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 230975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 230979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 230981 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 230983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230986 */     GIR_RootConstrainSelectedInstOperands,
     /* 230987 */     // GIR_Coverage, 3636,
     /* 230987 */     GIR_EraseRootFromParent_Done,
     /* 230988 */   // Label 4398: @230988
     /* 230988 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(231042), // Rule ID 3813 //
     /* 230993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 230996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 231001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231029 */     // (intrinsic_wo_chain:{ *:[v2i64] } 537:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 231032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 231034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231040 */     GIR_RootConstrainSelectedInstOperands,
     /* 231041 */     // GIR_Coverage, 3813,
     /* 231041 */     GIR_EraseRootFromParent_Done,
     /* 231042 */   // Label 4399: @231042
     /* 231042 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(231096), // Rule ID 3814 //
     /* 231047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 231055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231083 */     // (intrinsic_wo_chain:{ *:[v2i64] } 538:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 231086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 231088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231094 */     GIR_RootConstrainSelectedInstOperands,
     /* 231095 */     // GIR_Coverage, 3814,
     /* 231095 */     GIR_EraseRootFromParent_Done,
     /* 231096 */   // Label 4400: @231096
     /* 231096 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(231150), // Rule ID 3815 //
     /* 231101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 231109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231137 */     // (intrinsic_wo_chain:{ *:[v2i64] } 540:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 231140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 231142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231148 */     GIR_RootConstrainSelectedInstOperands,
     /* 231149 */     // GIR_Coverage, 3815,
     /* 231149 */     GIR_EraseRootFromParent_Done,
     /* 231150 */   // Label 4401: @231150
     /* 231150 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(231204), // Rule ID 3816 //
     /* 231155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 231163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 231166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 231169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231191 */     // (intrinsic_wo_chain:{ *:[v16i8] } 525:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 231191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231202 */     GIR_RootConstrainSelectedInstOperands,
     /* 231203 */     // GIR_Coverage, 3816,
     /* 231203 */     GIR_EraseRootFromParent_Done,
     /* 231204 */   // Label 4402: @231204
     /* 231204 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(231258), // Rule ID 3817 //
     /* 231209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 231217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231245 */     // (intrinsic_wo_chain:{ *:[v8i16] } 525:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 231245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231256 */     GIR_RootConstrainSelectedInstOperands,
     /* 231257 */     // GIR_Coverage, 3817,
     /* 231257 */     GIR_EraseRootFromParent_Done,
     /* 231258 */   // Label 4403: @231258
     /* 231258 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(231312), // Rule ID 3818 //
     /* 231263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 231271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231299 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 231299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231310 */     GIR_RootConstrainSelectedInstOperands,
     /* 231311 */     // GIR_Coverage, 3818,
     /* 231311 */     GIR_EraseRootFromParent_Done,
     /* 231312 */   // Label 4404: @231312
     /* 231312 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(231366), // Rule ID 3819 //
     /* 231317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 231325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231353 */     // (intrinsic_wo_chain:{ *:[v2i64] } 525:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231364 */     GIR_RootConstrainSelectedInstOperands,
     /* 231365 */     // GIR_Coverage, 3819,
     /* 231365 */     GIR_EraseRootFromParent_Done,
     /* 231366 */   // Label 4405: @231366
     /* 231366 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(231420), // Rule ID 3828 //
     /* 231371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 231379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 231382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 231385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231407 */     // (intrinsic_wo_chain:{ *:[v16i8] } 523:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 231407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231418 */     GIR_RootConstrainSelectedInstOperands,
     /* 231419 */     // GIR_Coverage, 3828,
     /* 231419 */     GIR_EraseRootFromParent_Done,
     /* 231420 */   // Label 4406: @231420
     /* 231420 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(231474), // Rule ID 3829 //
     /* 231425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 231433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231461 */     // (intrinsic_wo_chain:{ *:[v8i16] } 523:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 231461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231472 */     GIR_RootConstrainSelectedInstOperands,
     /* 231473 */     // GIR_Coverage, 3829,
     /* 231473 */     GIR_EraseRootFromParent_Done,
     /* 231474 */   // Label 4407: @231474
     /* 231474 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(231528), // Rule ID 3830 //
     /* 231479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 231487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231515 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 231515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231526 */     GIR_RootConstrainSelectedInstOperands,
     /* 231527 */     // GIR_Coverage, 3830,
     /* 231527 */     GIR_EraseRootFromParent_Done,
     /* 231528 */   // Label 4408: @231528
     /* 231528 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(231582), // Rule ID 3831 //
     /* 231533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 231541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231569 */     // (intrinsic_wo_chain:{ *:[v2i64] } 523:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231580 */     GIR_RootConstrainSelectedInstOperands,
     /* 231581 */     // GIR_Coverage, 3831,
     /* 231581 */     GIR_EraseRootFromParent_Done,
     /* 231582 */   // Label 4409: @231582
     /* 231582 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(231636), // Rule ID 3832 //
     /* 231587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 231595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 231598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 231601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231623 */     // (intrinsic_wo_chain:{ *:[v16i8] } 524:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 231623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231634 */     GIR_RootConstrainSelectedInstOperands,
     /* 231635 */     // GIR_Coverage, 3832,
     /* 231635 */     GIR_EraseRootFromParent_Done,
     /* 231636 */   // Label 4410: @231636
     /* 231636 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(231690), // Rule ID 3833 //
     /* 231641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 231649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231677 */     // (intrinsic_wo_chain:{ *:[v8i16] } 524:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 231677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231688 */     GIR_RootConstrainSelectedInstOperands,
     /* 231689 */     // GIR_Coverage, 3833,
     /* 231689 */     GIR_EraseRootFromParent_Done,
     /* 231690 */   // Label 4411: @231690
     /* 231690 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(231744), // Rule ID 3834 //
     /* 231695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 231703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231731 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 231731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231742 */     GIR_RootConstrainSelectedInstOperands,
     /* 231743 */     // GIR_Coverage, 3834,
     /* 231743 */     GIR_EraseRootFromParent_Done,
     /* 231744 */   // Label 4412: @231744
     /* 231744 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(231798), // Rule ID 3835 //
     /* 231749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 231757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231785 */     // (intrinsic_wo_chain:{ *:[v2i64] } 524:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231796 */     GIR_RootConstrainSelectedInstOperands,
     /* 231797 */     // GIR_Coverage, 3835,
     /* 231797 */     GIR_EraseRootFromParent_Done,
     /* 231798 */   // Label 4413: @231798
     /* 231798 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(231852), // Rule ID 3836 //
     /* 231803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 231811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 231814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 231817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231839 */     // (intrinsic_wo_chain:{ *:[v16i8] } 522:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 231839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231850 */     GIR_RootConstrainSelectedInstOperands,
     /* 231851 */     // GIR_Coverage, 3836,
     /* 231851 */     GIR_EraseRootFromParent_Done,
     /* 231852 */   // Label 4414: @231852
     /* 231852 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(231906), // Rule ID 3837 //
     /* 231857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 231865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231893 */     // (intrinsic_wo_chain:{ *:[v8i16] } 522:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 231893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231904 */     GIR_RootConstrainSelectedInstOperands,
     /* 231905 */     // GIR_Coverage, 3837,
     /* 231905 */     GIR_EraseRootFromParent_Done,
     /* 231906 */   // Label 4415: @231906
     /* 231906 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(231960), // Rule ID 3838 //
     /* 231911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 231919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231947 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 231947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231958 */     GIR_RootConstrainSelectedInstOperands,
     /* 231959 */     // GIR_Coverage, 3838,
     /* 231959 */     GIR_EraseRootFromParent_Done,
     /* 231960 */   // Label 4416: @231960
     /* 231960 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(232014), // Rule ID 3839 //
     /* 231965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 231973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232001 */     // (intrinsic_wo_chain:{ *:[v2i64] } 522:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 232004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232012 */     GIR_RootConstrainSelectedInstOperands,
     /* 232013 */     // GIR_Coverage, 3839,
     /* 232013 */     GIR_EraseRootFromParent_Done,
     /* 232014 */   // Label 4417: @232014
     /* 232014 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(232068), // Rule ID 3843 //
     /* 232019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 232022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 232027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232055 */     // (intrinsic_wo_chain:{ *:[v4i32] } 543:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 232055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 232058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 232062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 232064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 232066 */     GIR_RootConstrainSelectedInstOperands,
     /* 232067 */     // GIR_Coverage, 3843,
     /* 232067 */     GIR_EraseRootFromParent_Done,
     /* 232068 */   // Label 4418: @232068
     /* 232068 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(232122), // Rule ID 3844 //
     /* 232073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 232076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 232081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232109 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 232109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 232112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232120 */     GIR_RootConstrainSelectedInstOperands,
     /* 232121 */     // GIR_Coverage, 3844,
     /* 232121 */     GIR_EraseRootFromParent_Done,
     /* 232122 */   // Label 4419: @232122
     /* 232122 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(232176), // Rule ID 3845 //
     /* 232127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 232130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 232135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232163 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 232163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 232166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232174 */     GIR_RootConstrainSelectedInstOperands,
     /* 232175 */     // GIR_Coverage, 3845,
     /* 232175 */     GIR_EraseRootFromParent_Done,
     /* 232176 */   // Label 4420: @232176
     /* 232176 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(232233), // Rule ID 3862 //
     /* 232181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 232189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 232192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 232195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 232198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 232201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232217 */     // (intrinsic_wo_chain:{ *:[v4f16] } 764:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 232217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 232220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232231 */     GIR_RootConstrainSelectedInstOperands,
     /* 232232 */     // GIR_Coverage, 3862,
     /* 232232 */     GIR_EraseRootFromParent_Done,
     /* 232233 */   // Label 4421: @232233
     /* 232233 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(232290), // Rule ID 3863 //
     /* 232238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 232246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 232249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 232252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 232255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 232258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232274 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 232274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 232277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 232288 */     GIR_RootConstrainSelectedInstOperands,
     /* 232289 */     // GIR_Coverage, 3863,
     /* 232289 */     GIR_EraseRootFromParent_Done,
     /* 232290 */   // Label 4422: @232290
     /* 232290 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(232347), // Rule ID 3864 //
     /* 232295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 232303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 232306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 232309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 232312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 232315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232331 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 232331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 232334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 232345 */     GIR_RootConstrainSelectedInstOperands,
     /* 232346 */     // GIR_Coverage, 3864,
     /* 232346 */     GIR_EraseRootFromParent_Done,
     /* 232347 */   // Label 4423: @232347
     /* 232347 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(232404), // Rule ID 3865 //
     /* 232352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 232360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 232363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 232366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 232369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 232372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232388 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 232388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 232391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 232402 */     GIR_RootConstrainSelectedInstOperands,
     /* 232403 */     // GIR_Coverage, 3865,
     /* 232403 */     GIR_EraseRootFromParent_Done,
     /* 232404 */   // Label 4424: @232404
     /* 232404 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(232461), // Rule ID 3870 //
     /* 232409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 232417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232445 */     // (intrinsic_wo_chain:{ *:[v8f16] } 764:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 232445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 232448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232459 */     GIR_RootConstrainSelectedInstOperands,
     /* 232460 */     // GIR_Coverage, 3870,
     /* 232460 */     GIR_EraseRootFromParent_Done,
     /* 232461 */   // Label 4425: @232461
     /* 232461 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(232518), // Rule ID 3871 //
     /* 232466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 232474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232502 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 232502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 232505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 232516 */     GIR_RootConstrainSelectedInstOperands,
     /* 232517 */     // GIR_Coverage, 3871,
     /* 232517 */     GIR_EraseRootFromParent_Done,
     /* 232518 */   // Label 4426: @232518
     /* 232518 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(232575), // Rule ID 3872 //
     /* 232523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 232531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232559 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 232559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 232562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 232573 */     GIR_RootConstrainSelectedInstOperands,
     /* 232574 */     // GIR_Coverage, 3872,
     /* 232574 */     GIR_EraseRootFromParent_Done,
     /* 232575 */   // Label 4427: @232575
     /* 232575 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(232632), // Rule ID 3873 //
     /* 232580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 232588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232616 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 232616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 232619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 232630 */     GIR_RootConstrainSelectedInstOperands,
     /* 232631 */     // GIR_Coverage, 3873,
     /* 232631 */     GIR_EraseRootFromParent_Done,
     /* 232632 */   // Label 4428: @232632
     /* 232632 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(232689), // Rule ID 3878 //
     /* 232637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 232645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 232648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 232651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 232654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 232657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232673 */     // (intrinsic_wo_chain:{ *:[v2f32] } 764:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 232673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 232676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232687 */     GIR_RootConstrainSelectedInstOperands,
     /* 232688 */     // GIR_Coverage, 3878,
     /* 232688 */     GIR_EraseRootFromParent_Done,
     /* 232689 */   // Label 4429: @232689
     /* 232689 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(232746), // Rule ID 3879 //
     /* 232694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 232702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 232705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 232708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 232711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 232714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232730 */     // (intrinsic_wo_chain:{ *:[v2f32] } 767:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 232730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 232733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 232744 */     GIR_RootConstrainSelectedInstOperands,
     /* 232745 */     // GIR_Coverage, 3879,
     /* 232745 */     GIR_EraseRootFromParent_Done,
     /* 232746 */   // Label 4430: @232746
     /* 232746 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(232803), // Rule ID 3880 //
     /* 232751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 232759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 232762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 232765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 232768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 232771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232787 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 232787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 232790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 232801 */     GIR_RootConstrainSelectedInstOperands,
     /* 232802 */     // GIR_Coverage, 3880,
     /* 232802 */     GIR_EraseRootFromParent_Done,
     /* 232803 */   // Label 4431: @232803
     /* 232803 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(232860), // Rule ID 3881 //
     /* 232808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 232816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 232819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 232822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 232825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 232828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232844 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 232844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 232847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 232858 */     GIR_RootConstrainSelectedInstOperands,
     /* 232859 */     // GIR_Coverage, 3881,
     /* 232859 */     GIR_EraseRootFromParent_Done,
     /* 232860 */   // Label 4432: @232860
     /* 232860 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(232917), // Rule ID 3882 //
     /* 232865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 232873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232901 */     // (intrinsic_wo_chain:{ *:[v4f32] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 232901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 232904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232915 */     GIR_RootConstrainSelectedInstOperands,
     /* 232916 */     // GIR_Coverage, 3882,
     /* 232916 */     GIR_EraseRootFromParent_Done,
     /* 232917 */   // Label 4433: @232917
     /* 232917 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(232974), // Rule ID 3883 //
     /* 232922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 232930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232958 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 232958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 232961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 232972 */     GIR_RootConstrainSelectedInstOperands,
     /* 232973 */     // GIR_Coverage, 3883,
     /* 232973 */     GIR_EraseRootFromParent_Done,
     /* 232974 */   // Label 4434: @232974
     /* 232974 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(233031), // Rule ID 3884 //
     /* 232979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 232987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233015 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 233015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 233018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 233029 */     GIR_RootConstrainSelectedInstOperands,
     /* 233030 */     // GIR_Coverage, 3884,
     /* 233030 */     GIR_EraseRootFromParent_Done,
     /* 233031 */   // Label 4435: @233031
     /* 233031 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(233088), // Rule ID 3885 //
     /* 233036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 233044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233072 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 233072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 233075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 233086 */     GIR_RootConstrainSelectedInstOperands,
     /* 233087 */     // GIR_Coverage, 3885,
     /* 233087 */     GIR_EraseRootFromParent_Done,
     /* 233088 */   // Label 4436: @233088
     /* 233088 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(233145), // Rule ID 3886 //
     /* 233093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 233101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233129 */     // (intrinsic_wo_chain:{ *:[v2f64] } 764:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 233129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 233132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233143 */     GIR_RootConstrainSelectedInstOperands,
     /* 233144 */     // GIR_Coverage, 3886,
     /* 233144 */     GIR_EraseRootFromParent_Done,
     /* 233145 */   // Label 4437: @233145
     /* 233145 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(233202), // Rule ID 3887 //
     /* 233150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 233158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233186 */     // (intrinsic_wo_chain:{ *:[v2f64] } 767:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 233186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 233189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 233200 */     GIR_RootConstrainSelectedInstOperands,
     /* 233201 */     // GIR_Coverage, 3887,
     /* 233201 */     GIR_EraseRootFromParent_Done,
     /* 233202 */   // Label 4438: @233202
     /* 233202 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(233259), // Rule ID 3888 //
     /* 233207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 233215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233243 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 233243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 233246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 233257 */     GIR_RootConstrainSelectedInstOperands,
     /* 233258 */     // GIR_Coverage, 3888,
     /* 233258 */     GIR_EraseRootFromParent_Done,
     /* 233259 */   // Label 4439: @233259
     /* 233259 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(233316), // Rule ID 3889 //
     /* 233264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 233272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233300 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 233300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 233303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 233314 */     GIR_RootConstrainSelectedInstOperands,
     /* 233315 */     // GIR_Coverage, 3889,
     /* 233315 */     GIR_EraseRootFromParent_Done,
     /* 233316 */   // Label 4440: @233316
     /* 233316 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(233370), // Rule ID 5244 //
     /* 233321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 233324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 233329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233357 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 233357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 233360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233368 */     GIR_RootConstrainSelectedInstOperands,
     /* 233369 */     // GIR_Coverage, 5244,
     /* 233369 */     GIR_EraseRootFromParent_Done,
     /* 233370 */   // Label 4441: @233370
     /* 233370 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(233424), // Rule ID 5245 //
     /* 233375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 233378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 233383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233411 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 233411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 233414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233422 */     GIR_RootConstrainSelectedInstOperands,
     /* 233423 */     // GIR_Coverage, 5245,
     /* 233423 */     GIR_EraseRootFromParent_Done,
     /* 233424 */   // Label 4442: @233424
     /* 233424 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(233475), // Rule ID 5598 //
     /* 233429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 233434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 233437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 233440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 233446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233462 */     // (intrinsic_wo_chain:{ *:[v8i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 233462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 233465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 233473 */     GIR_RootConstrainSelectedInstOperands,
     /* 233474 */     // GIR_Coverage, 5598,
     /* 233474 */     GIR_EraseRootFromParent_Done,
     /* 233475 */   // Label 4443: @233475
     /* 233475 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(233526), // Rule ID 5599 //
     /* 233480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 233485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233513 */     // (intrinsic_wo_chain:{ *:[v16i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 233513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 233516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 233522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 233524 */     GIR_RootConstrainSelectedInstOperands,
     /* 233525 */     // GIR_Coverage, 5599,
     /* 233525 */     GIR_EraseRootFromParent_Done,
     /* 233526 */   // Label 4444: @233526
     /* 233526 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(233568), // Rule ID 2692 //
     /* 233531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233555 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1925:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 233558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233566 */     GIR_RootConstrainSelectedInstOperands,
     /* 233567 */     // GIR_Coverage, 2692,
     /* 233567 */     GIR_EraseRootFromParent_Done,
     /* 233568 */   // Label 4445: @233568
     /* 233568 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(233610), // Rule ID 2693 //
     /* 233573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1925:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 233600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233608 */     GIR_RootConstrainSelectedInstOperands,
     /* 233609 */     // GIR_Coverage, 2693,
     /* 233609 */     GIR_EraseRootFromParent_Done,
     /* 233610 */   // Label 4446: @233610
     /* 233610 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(233652), // Rule ID 2694 //
     /* 233615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1925:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 233642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233650 */     GIR_RootConstrainSelectedInstOperands,
     /* 233651 */     // GIR_Coverage, 2694,
     /* 233651 */     GIR_EraseRootFromParent_Done,
     /* 233652 */   // Label 4447: @233652
     /* 233652 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(233694), // Rule ID 2695 //
     /* 233657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1925:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 233684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233692 */     GIR_RootConstrainSelectedInstOperands,
     /* 233693 */     // GIR_Coverage, 2695,
     /* 233693 */     GIR_EraseRootFromParent_Done,
     /* 233694 */   // Label 4448: @233694
     /* 233694 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(233736), // Rule ID 2696 //
     /* 233699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233723 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1925:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 233726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233734 */     GIR_RootConstrainSelectedInstOperands,
     /* 233735 */     // GIR_Coverage, 2696,
     /* 233735 */     GIR_EraseRootFromParent_Done,
     /* 233736 */   // Label 4449: @233736
     /* 233736 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(233778), // Rule ID 2697 //
     /* 233741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233765 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1925:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 233768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233776 */     GIR_RootConstrainSelectedInstOperands,
     /* 233777 */     // GIR_Coverage, 2697,
     /* 233777 */     GIR_EraseRootFromParent_Done,
     /* 233778 */   // Label 4450: @233778
     /* 233778 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(233820), // Rule ID 2698 //
     /* 233783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233807 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1925:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 233810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233818 */     GIR_RootConstrainSelectedInstOperands,
     /* 233819 */     // GIR_Coverage, 2698,
     /* 233819 */     GIR_EraseRootFromParent_Done,
     /* 233820 */   // Label 4451: @233820
     /* 233820 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(233862), // Rule ID 2737 //
     /* 233825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 233828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 233833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 233836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 233842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 233845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 233849 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1271:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 233849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 233852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 233854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233860 */     GIR_RootConstrainSelectedInstOperands,
     /* 233861 */     // GIR_Coverage, 2737,
     /* 233861 */     GIR_EraseRootFromParent_Done,
     /* 233862 */   // Label 4452: @233862
     /* 233862 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(233904), // Rule ID 2738 //
     /* 233867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 233870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 233875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 233878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 233884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 233887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 233891 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1271:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 233891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 233894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 233896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233902 */     GIR_RootConstrainSelectedInstOperands,
     /* 233903 */     // GIR_Coverage, 2738,
     /* 233903 */     GIR_EraseRootFromParent_Done,
     /* 233904 */   // Label 4453: @233904
     /* 233904 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(233946), // Rule ID 2739 //
     /* 233909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 233912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 233917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 233920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 233926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 233929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 233933 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1271:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 233933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 233936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 233938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233944 */     GIR_RootConstrainSelectedInstOperands,
     /* 233945 */     // GIR_Coverage, 2739,
     /* 233945 */     GIR_EraseRootFromParent_Done,
     /* 233946 */   // Label 4454: @233946
     /* 233946 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(233988), // Rule ID 2740 //
     /* 233951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 233954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 233959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 233962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 233968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 233971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 233975 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1271:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 233975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 233978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 233980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233986 */     GIR_RootConstrainSelectedInstOperands,
     /* 233987 */     // GIR_Coverage, 2740,
     /* 233987 */     GIR_EraseRootFromParent_Done,
     /* 233988 */   // Label 4455: @233988
     /* 233988 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(234030), // Rule ID 2741 //
     /* 233993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 233996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 234001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 234004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 234007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 234010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 234013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234017 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1271:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 234017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 234020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234028 */     GIR_RootConstrainSelectedInstOperands,
     /* 234029 */     // GIR_Coverage, 2741,
     /* 234029 */     GIR_EraseRootFromParent_Done,
     /* 234030 */   // Label 4456: @234030
     /* 234030 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(234072), // Rule ID 2780 //
     /* 234035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 234043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234059 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 234062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234070 */     GIR_RootConstrainSelectedInstOperands,
     /* 234071 */     // GIR_Coverage, 2780,
     /* 234071 */     GIR_EraseRootFromParent_Done,
     /* 234072 */   // Label 4457: @234072
     /* 234072 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(234114), // Rule ID 2782 //
     /* 234077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 234085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234101 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 234104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234112 */     GIR_RootConstrainSelectedInstOperands,
     /* 234113 */     // GIR_Coverage, 2782,
     /* 234113 */     GIR_EraseRootFromParent_Done,
     /* 234114 */   // Label 4458: @234114
     /* 234114 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(234156), // Rule ID 2784 //
     /* 234119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 234127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234143 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 234146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234154 */     GIR_RootConstrainSelectedInstOperands,
     /* 234155 */     // GIR_Coverage, 2784,
     /* 234155 */     GIR_EraseRootFromParent_Done,
     /* 234156 */   // Label 4459: @234156
     /* 234156 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(234198), // Rule ID 2786 //
     /* 234161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 234169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234185 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1544:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 234188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234196 */     GIR_RootConstrainSelectedInstOperands,
     /* 234197 */     // GIR_Coverage, 2786,
     /* 234197 */     GIR_EraseRootFromParent_Done,
     /* 234198 */   // Label 4460: @234198
     /* 234198 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(234240), // Rule ID 2787 //
     /* 234203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 234211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234227 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1544:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 234230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234238 */     GIR_RootConstrainSelectedInstOperands,
     /* 234239 */     // GIR_Coverage, 2787,
     /* 234239 */     GIR_EraseRootFromParent_Done,
     /* 234240 */   // Label 4461: @234240
     /* 234240 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(234282), // Rule ID 2788 //
     /* 234245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 234253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234269 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1544:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 234272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234280 */     GIR_RootConstrainSelectedInstOperands,
     /* 234281 */     // GIR_Coverage, 2788,
     /* 234281 */     GIR_EraseRootFromParent_Done,
     /* 234282 */   // Label 4462: @234282
     /* 234282 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(234324), // Rule ID 2857 //
     /* 234287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 234295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234311 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1406:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 234314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234322 */     GIR_RootConstrainSelectedInstOperands,
     /* 234323 */     // GIR_Coverage, 2857,
     /* 234323 */     GIR_EraseRootFromParent_Done,
     /* 234324 */   // Label 4463: @234324
     /* 234324 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(234366), // Rule ID 2858 //
     /* 234329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 234337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234353 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1407:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 234356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234364 */     GIR_RootConstrainSelectedInstOperands,
     /* 234365 */     // GIR_Coverage, 2858,
     /* 234365 */     GIR_EraseRootFromParent_Done,
     /* 234366 */   // Label 4464: @234366
     /* 234366 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(234408), // Rule ID 2859 //
     /* 234371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 234379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234395 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1402:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 234398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234406 */     GIR_RootConstrainSelectedInstOperands,
     /* 234407 */     // GIR_Coverage, 2859,
     /* 234407 */     GIR_EraseRootFromParent_Done,
     /* 234408 */   // Label 4465: @234408
     /* 234408 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(234450), // Rule ID 2860 //
     /* 234413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 234421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234437 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1403:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 234440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234448 */     GIR_RootConstrainSelectedInstOperands,
     /* 234449 */     // GIR_Coverage, 2860,
     /* 234449 */     GIR_EraseRootFromParent_Done,
     /* 234450 */   // Label 4466: @234450
     /* 234450 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(234492), // Rule ID 2861 //
     /* 234455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 234463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234479 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1409:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 234482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234490 */     GIR_RootConstrainSelectedInstOperands,
     /* 234491 */     // GIR_Coverage, 2861,
     /* 234491 */     GIR_EraseRootFromParent_Done,
     /* 234492 */   // Label 4467: @234492
     /* 234492 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(234534), // Rule ID 2862 //
     /* 234497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 234505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234521 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 234524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234532 */     GIR_RootConstrainSelectedInstOperands,
     /* 234533 */     // GIR_Coverage, 2862,
     /* 234533 */     GIR_EraseRootFromParent_Done,
     /* 234534 */   // Label 4468: @234534
     /* 234534 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(234576), // Rule ID 2863 //
     /* 234539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 234547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234563 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 234566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234574 */     GIR_RootConstrainSelectedInstOperands,
     /* 234575 */     // GIR_Coverage, 2863,
     /* 234575 */     GIR_EraseRootFromParent_Done,
     /* 234576 */   // Label 4469: @234576
     /* 234576 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(234618), // Rule ID 2864 //
     /* 234581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 234589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234605 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 234608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234616 */     GIR_RootConstrainSelectedInstOperands,
     /* 234617 */     // GIR_Coverage, 2864,
     /* 234617 */     GIR_EraseRootFromParent_Done,
     /* 234618 */   // Label 4470: @234618
     /* 234618 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(234660), // Rule ID 2875 //
     /* 234623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 234631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234647 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1395:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 234650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234658 */     GIR_RootConstrainSelectedInstOperands,
     /* 234659 */     // GIR_Coverage, 2875,
     /* 234659 */     GIR_EraseRootFromParent_Done,
     /* 234660 */   // Label 4471: @234660
     /* 234660 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(234702), // Rule ID 2877 //
     /* 234665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 234673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234689 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1393:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 234692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234700 */     GIR_RootConstrainSelectedInstOperands,
     /* 234701 */     // GIR_Coverage, 2877,
     /* 234701 */     GIR_EraseRootFromParent_Done,
     /* 234702 */   // Label 4472: @234702
     /* 234702 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(234744), // Rule ID 2885 //
     /* 234707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 234715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 234724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1430:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 234734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234742 */     GIR_RootConstrainSelectedInstOperands,
     /* 234743 */     // GIR_Coverage, 2885,
     /* 234743 */     GIR_EraseRootFromParent_Done,
     /* 234744 */   // Label 4473: @234744
     /* 234744 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(234786), // Rule ID 2886 //
     /* 234749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 234757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1430:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 234776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234784 */     GIR_RootConstrainSelectedInstOperands,
     /* 234785 */     // GIR_Coverage, 2886,
     /* 234785 */     GIR_EraseRootFromParent_Done,
     /* 234786 */   // Label 4474: @234786
     /* 234786 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(234828), // Rule ID 2887 //
     /* 234791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 234799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234815 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1430:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 234818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234826 */     GIR_RootConstrainSelectedInstOperands,
     /* 234827 */     // GIR_Coverage, 2887,
     /* 234827 */     GIR_EraseRootFromParent_Done,
     /* 234828 */   // Label 4475: @234828
     /* 234828 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(234870), // Rule ID 2891 //
     /* 234833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 234841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234857 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1408:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 234860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234868 */     GIR_RootConstrainSelectedInstOperands,
     /* 234869 */     // GIR_Coverage, 2891,
     /* 234869 */     GIR_EraseRootFromParent_Done,
     /* 234870 */   // Label 4476: @234870
     /* 234870 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(234912), // Rule ID 2936 //
     /* 234875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 234883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1713:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 234902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234910 */     GIR_RootConstrainSelectedInstOperands,
     /* 234911 */     // GIR_Coverage, 2936,
     /* 234911 */     GIR_EraseRootFromParent_Done,
     /* 234912 */   // Label 4477: @234912
     /* 234912 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(234954), // Rule ID 2937 //
     /* 234917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 234925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234941 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1713:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 234944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234952 */     GIR_RootConstrainSelectedInstOperands,
     /* 234953 */     // GIR_Coverage, 2937,
     /* 234953 */     GIR_EraseRootFromParent_Done,
     /* 234954 */   // Label 4478: @234954
     /* 234954 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(234996), // Rule ID 2966 //
     /* 234959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 234967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 234973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234983 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 234986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234994 */     GIR_RootConstrainSelectedInstOperands,
     /* 234995 */     // GIR_Coverage, 2966,
     /* 234995 */     GIR_EraseRootFromParent_Done,
     /* 234996 */   // Label 4479: @234996
     /* 234996 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(235038), // Rule ID 2967 //
     /* 235001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 235009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235025 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 235028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235036 */     GIR_RootConstrainSelectedInstOperands,
     /* 235037 */     // GIR_Coverage, 2967,
     /* 235037 */     GIR_EraseRootFromParent_Done,
     /* 235038 */   // Label 4480: @235038
     /* 235038 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(235080), // Rule ID 2968 //
     /* 235043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 235051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 235070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235078 */     GIR_RootConstrainSelectedInstOperands,
     /* 235079 */     // GIR_Coverage, 2968,
     /* 235079 */     GIR_EraseRootFromParent_Done,
     /* 235080 */   // Label 4481: @235080
     /* 235080 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(235122), // Rule ID 2969 //
     /* 235085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 235093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1829:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 235112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235120 */     GIR_RootConstrainSelectedInstOperands,
     /* 235121 */     // GIR_Coverage, 2969,
     /* 235121 */     GIR_EraseRootFromParent_Done,
     /* 235122 */   // Label 4482: @235122
     /* 235122 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(235164), // Rule ID 2970 //
     /* 235127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 235135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235151 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 235154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235162 */     GIR_RootConstrainSelectedInstOperands,
     /* 235163 */     // GIR_Coverage, 2970,
     /* 235163 */     GIR_EraseRootFromParent_Done,
     /* 235164 */   // Label 4483: @235164
     /* 235164 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(235206), // Rule ID 2971 //
     /* 235169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 235177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235193 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 235196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235204 */     GIR_RootConstrainSelectedInstOperands,
     /* 235205 */     // GIR_Coverage, 2971,
     /* 235205 */     GIR_EraseRootFromParent_Done,
     /* 235206 */   // Label 4484: @235206
     /* 235206 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(235248), // Rule ID 2972 //
     /* 235211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 235219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235235 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 235238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235246 */     GIR_RootConstrainSelectedInstOperands,
     /* 235247 */     // GIR_Coverage, 2972,
     /* 235247 */     GIR_EraseRootFromParent_Done,
     /* 235248 */   // Label 4485: @235248
     /* 235248 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(235290), // Rule ID 3002 //
     /* 235253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 235261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235277 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1724:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 235280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235288 */     GIR_RootConstrainSelectedInstOperands,
     /* 235289 */     // GIR_Coverage, 3002,
     /* 235289 */     GIR_EraseRootFromParent_Done,
     /* 235290 */   // Label 4486: @235290
     /* 235290 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(235332), // Rule ID 3004 //
     /* 235295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 235303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235319 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1724:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 235322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235330 */     GIR_RootConstrainSelectedInstOperands,
     /* 235331 */     // GIR_Coverage, 3004,
     /* 235331 */     GIR_EraseRootFromParent_Done,
     /* 235332 */   // Label 4487: @235332
     /* 235332 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(235374), // Rule ID 3006 //
     /* 235337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 235345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 235364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235372 */     GIR_RootConstrainSelectedInstOperands,
     /* 235373 */     // GIR_Coverage, 3006,
     /* 235373 */     GIR_EraseRootFromParent_Done,
     /* 235374 */   // Label 4488: @235374
     /* 235374 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(235416), // Rule ID 3008 //
     /* 235379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 235387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235403 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1724:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 235406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235414 */     GIR_RootConstrainSelectedInstOperands,
     /* 235415 */     // GIR_Coverage, 3008,
     /* 235415 */     GIR_EraseRootFromParent_Done,
     /* 235416 */   // Label 4489: @235416
     /* 235416 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(235458), // Rule ID 3010 //
     /* 235421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 235429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235445 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1694:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 235448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235456 */     GIR_RootConstrainSelectedInstOperands,
     /* 235457 */     // GIR_Coverage, 3010,
     /* 235457 */     GIR_EraseRootFromParent_Done,
     /* 235458 */   // Label 4490: @235458
     /* 235458 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(235500), // Rule ID 3011 //
     /* 235463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 235471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235487 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 235490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235498 */     GIR_RootConstrainSelectedInstOperands,
     /* 235499 */     // GIR_Coverage, 3011,
     /* 235499 */     GIR_EraseRootFromParent_Done,
     /* 235500 */   // Label 4491: @235500
     /* 235500 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(235542), // Rule ID 3012 //
     /* 235505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 235513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235529 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 235532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235540 */     GIR_RootConstrainSelectedInstOperands,
     /* 235541 */     // GIR_Coverage, 3012,
     /* 235541 */     GIR_EraseRootFromParent_Done,
     /* 235542 */   // Label 4492: @235542
     /* 235542 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(235584), // Rule ID 3013 //
     /* 235547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 235555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 235574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235582 */     GIR_RootConstrainSelectedInstOperands,
     /* 235583 */     // GIR_Coverage, 3013,
     /* 235583 */     GIR_EraseRootFromParent_Done,
     /* 235584 */   // Label 4493: @235584
     /* 235584 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(235626), // Rule ID 3014 //
     /* 235589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 235597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 235606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235613 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1766:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 235616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235624 */     GIR_RootConstrainSelectedInstOperands,
     /* 235625 */     // GIR_Coverage, 3014,
     /* 235625 */     GIR_EraseRootFromParent_Done,
     /* 235626 */   // Label 4494: @235626
     /* 235626 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(235668), // Rule ID 3015 //
     /* 235631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 235639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 235648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235655 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1766:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 235658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235666 */     GIR_RootConstrainSelectedInstOperands,
     /* 235667 */     // GIR_Coverage, 3015,
     /* 235667 */     GIR_EraseRootFromParent_Done,
     /* 235668 */   // Label 4495: @235668
     /* 235668 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(235710), // Rule ID 3016 //
     /* 235673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 235681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1766:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 235700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235708 */     GIR_RootConstrainSelectedInstOperands,
     /* 235709 */     // GIR_Coverage, 3016,
     /* 235709 */     GIR_EraseRootFromParent_Done,
     /* 235710 */   // Label 4496: @235710
     /* 235710 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(235752), // Rule ID 3017 //
     /* 235715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 235723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235739 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1766:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 235742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235750 */     GIR_RootConstrainSelectedInstOperands,
     /* 235751 */     // GIR_Coverage, 3017,
     /* 235751 */     GIR_EraseRootFromParent_Done,
     /* 235752 */   // Label 4497: @235752
     /* 235752 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(235794), // Rule ID 3034 //
     /* 235757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 235765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235781 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1359:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 235784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235792 */     GIR_RootConstrainSelectedInstOperands,
     /* 235793 */     // GIR_Coverage, 3034,
     /* 235793 */     GIR_EraseRootFromParent_Done,
     /* 235794 */   // Label 4498: @235794
     /* 235794 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(235836), // Rule ID 3035 //
     /* 235799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 235807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1359:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 235826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235834 */     GIR_RootConstrainSelectedInstOperands,
     /* 235835 */     // GIR_Coverage, 3035,
     /* 235835 */     GIR_EraseRootFromParent_Done,
     /* 235836 */   // Label 4499: @235836
     /* 235836 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(235878), // Rule ID 3036 //
     /* 235841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 235849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1359:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 235868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235876 */     GIR_RootConstrainSelectedInstOperands,
     /* 235877 */     // GIR_Coverage, 3036,
     /* 235877 */     GIR_EraseRootFromParent_Done,
     /* 235878 */   // Label 4500: @235878
     /* 235878 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(235920), // Rule ID 3037 //
     /* 235883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 235891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235907 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1359:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 235910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235918 */     GIR_RootConstrainSelectedInstOperands,
     /* 235919 */     // GIR_Coverage, 3037,
     /* 235919 */     GIR_EraseRootFromParent_Done,
     /* 235920 */   // Label 4501: @235920
     /* 235920 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(235962), // Rule ID 3061 //
     /* 235925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 235933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235949 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1687:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 235952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235960 */     GIR_RootConstrainSelectedInstOperands,
     /* 235961 */     // GIR_Coverage, 3061,
     /* 235961 */     GIR_EraseRootFromParent_Done,
     /* 235962 */   // Label 4502: @235962
     /* 235962 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(236004), // Rule ID 3063 //
     /* 235967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 235975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 235994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236002 */     GIR_RootConstrainSelectedInstOperands,
     /* 236003 */     // GIR_Coverage, 3063,
     /* 236003 */     GIR_EraseRootFromParent_Done,
     /* 236004 */   // Label 4503: @236004
     /* 236004 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(236046), // Rule ID 3065 //
     /* 236009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 236017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236033 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 236036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236044 */     GIR_RootConstrainSelectedInstOperands,
     /* 236045 */     // GIR_Coverage, 3065,
     /* 236045 */     GIR_EraseRootFromParent_Done,
     /* 236046 */   // Label 4504: @236046
     /* 236046 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(236088), // Rule ID 3067 //
     /* 236051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 236059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236075 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 236078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236086 */     GIR_RootConstrainSelectedInstOperands,
     /* 236087 */     // GIR_Coverage, 3067,
     /* 236087 */     GIR_EraseRootFromParent_Done,
     /* 236088 */   // Label 4505: @236088
     /* 236088 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(236130), // Rule ID 3069 //
     /* 236093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 236101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 236120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236128 */     GIR_RootConstrainSelectedInstOperands,
     /* 236129 */     // GIR_Coverage, 3069,
     /* 236129 */     GIR_EraseRootFromParent_Done,
     /* 236130 */   // Label 4506: @236130
     /* 236130 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(236172), // Rule ID 3070 //
     /* 236135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 236143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 236162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236170 */     GIR_RootConstrainSelectedInstOperands,
     /* 236171 */     // GIR_Coverage, 3070,
     /* 236171 */     GIR_EraseRootFromParent_Done,
     /* 236172 */   // Label 4507: @236172
     /* 236172 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(236214), // Rule ID 3071 //
     /* 236177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 236185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236201 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 236204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236212 */     GIR_RootConstrainSelectedInstOperands,
     /* 236213 */     // GIR_Coverage, 3071,
     /* 236213 */     GIR_EraseRootFromParent_Done,
     /* 236214 */   // Label 4508: @236214
     /* 236214 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(236256), // Rule ID 3072 //
     /* 236219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 236227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236243 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 236246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236254 */     GIR_RootConstrainSelectedInstOperands,
     /* 236255 */     // GIR_Coverage, 3072,
     /* 236255 */     GIR_EraseRootFromParent_Done,
     /* 236256 */   // Label 4509: @236256
     /* 236256 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(236298), // Rule ID 3073 //
     /* 236261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 236269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236285 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1251:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 236288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236296 */     GIR_RootConstrainSelectedInstOperands,
     /* 236297 */     // GIR_Coverage, 3073,
     /* 236297 */     GIR_EraseRootFromParent_Done,
     /* 236298 */   // Label 4510: @236298
     /* 236298 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(236340), // Rule ID 3083 //
     /* 236303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 236311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236327 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 236330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236338 */     GIR_RootConstrainSelectedInstOperands,
     /* 236339 */     // GIR_Coverage, 3083,
     /* 236339 */     GIR_EraseRootFromParent_Done,
     /* 236340 */   // Label 4511: @236340
     /* 236340 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(236382), // Rule ID 3084 //
     /* 236345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 236353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1258:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 236372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236380 */     GIR_RootConstrainSelectedInstOperands,
     /* 236381 */     // GIR_Coverage, 3084,
     /* 236381 */     GIR_EraseRootFromParent_Done,
     /* 236382 */   // Label 4512: @236382
     /* 236382 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(236424), // Rule ID 3085 //
     /* 236387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 236395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 236414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236422 */     GIR_RootConstrainSelectedInstOperands,
     /* 236423 */     // GIR_Coverage, 3085,
     /* 236423 */     GIR_EraseRootFromParent_Done,
     /* 236424 */   // Label 4513: @236424
     /* 236424 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(236466), // Rule ID 3102 //
     /* 236429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 236437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 236446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236453 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1317:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 236453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 236456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 236460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 236462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 236464 */     GIR_RootConstrainSelectedInstOperands,
     /* 236465 */     // GIR_Coverage, 3102,
     /* 236465 */     GIR_EraseRootFromParent_Done,
     /* 236466 */   // Label 4514: @236466
     /* 236466 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(236508), // Rule ID 3103 //
     /* 236471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 236479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 236488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236495 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1317:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 236495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 236498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 236502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 236504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 236506 */     GIR_RootConstrainSelectedInstOperands,
     /* 236507 */     // GIR_Coverage, 3103,
     /* 236507 */     GIR_EraseRootFromParent_Done,
     /* 236508 */   // Label 4515: @236508
     /* 236508 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(236550), // Rule ID 3104 //
     /* 236513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 236521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236537 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1317:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 236537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 236540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 236544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 236546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 236548 */     GIR_RootConstrainSelectedInstOperands,
     /* 236549 */     // GIR_Coverage, 3104,
     /* 236549 */     GIR_EraseRootFromParent_Done,
     /* 236550 */   // Label 4516: @236550
     /* 236550 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(236592), // Rule ID 3105 //
     /* 236555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 236563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236579 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1317:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 236579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 236582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 236586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 236588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 236590 */     GIR_RootConstrainSelectedInstOperands,
     /* 236591 */     // GIR_Coverage, 3105,
     /* 236591 */     GIR_EraseRootFromParent_Done,
     /* 236592 */   // Label 4517: @236592
     /* 236592 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(236634), // Rule ID 3140 //
     /* 236597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 236605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236621 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1358:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 236624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236632 */     GIR_RootConstrainSelectedInstOperands,
     /* 236633 */     // GIR_Coverage, 3140,
     /* 236633 */     GIR_EraseRootFromParent_Done,
     /* 236634 */   // Label 4518: @236634
     /* 236634 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(236676), // Rule ID 3142 //
     /* 236639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 236647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236663 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1358:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 236666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236674 */     GIR_RootConstrainSelectedInstOperands,
     /* 236675 */     // GIR_Coverage, 3142,
     /* 236675 */     GIR_EraseRootFromParent_Done,
     /* 236676 */   // Label 4519: @236676
     /* 236676 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(236718), // Rule ID 3144 //
     /* 236681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 236689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236705 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1358:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 236708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236716 */     GIR_RootConstrainSelectedInstOperands,
     /* 236717 */     // GIR_Coverage, 3144,
     /* 236717 */     GIR_EraseRootFromParent_Done,
     /* 236718 */   // Label 4520: @236718
     /* 236718 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(236760), // Rule ID 3146 //
     /* 236723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 236731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236747 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1358:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 236750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236758 */     GIR_RootConstrainSelectedInstOperands,
     /* 236759 */     // GIR_Coverage, 3146,
     /* 236759 */     GIR_EraseRootFromParent_Done,
     /* 236760 */   // Label 4521: @236760
     /* 236760 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(236805), // Rule ID 3185 //
     /* 236765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 236773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 236776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 236789 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1322:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 236792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 236794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 236803 */     GIR_RootConstrainSelectedInstOperands,
     /* 236804 */     // GIR_Coverage, 3185,
     /* 236804 */     GIR_EraseRootFromParent_Done,
     /* 236805 */   // Label 4522: @236805
     /* 236805 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(236850), // Rule ID 3186 //
     /* 236810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 236818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 236821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 236834 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1322:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 236837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 236839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236843 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 236848 */     GIR_RootConstrainSelectedInstOperands,
     /* 236849 */     // GIR_Coverage, 3186,
     /* 236849 */     GIR_EraseRootFromParent_Done,
     /* 236850 */   // Label 4523: @236850
     /* 236850 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(236895), // Rule ID 3187 //
     /* 236855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 236863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 236866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 236879 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1322:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 236882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 236884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 236893 */     GIR_RootConstrainSelectedInstOperands,
     /* 236894 */     // GIR_Coverage, 3187,
     /* 236894 */     GIR_EraseRootFromParent_Done,
     /* 236895 */   // Label 4524: @236895
     /* 236895 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(236940), // Rule ID 3188 //
     /* 236900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 236908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 236911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 236924 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1324:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 236927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 236929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 236938 */     GIR_RootConstrainSelectedInstOperands,
     /* 236939 */     // GIR_Coverage, 3188,
     /* 236939 */     GIR_EraseRootFromParent_Done,
     /* 236940 */   // Label 4525: @236940
     /* 236940 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(236985), // Rule ID 3189 //
     /* 236945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 236953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 236956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 236969 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1324:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 236972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 236974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 236983 */     GIR_RootConstrainSelectedInstOperands,
     /* 236984 */     // GIR_Coverage, 3189,
     /* 236984 */     GIR_EraseRootFromParent_Done,
     /* 236985 */   // Label 4526: @236985
     /* 236985 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(237030), // Rule ID 3190 //
     /* 236990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 236998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 237001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237014 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1324:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 237017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237028 */     GIR_RootConstrainSelectedInstOperands,
     /* 237029 */     // GIR_Coverage, 3190,
     /* 237029 */     GIR_EraseRootFromParent_Done,
     /* 237030 */   // Label 4527: @237030
     /* 237030 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(237072), // Rule ID 3245 //
     /* 237035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 237043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237059 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1368:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 237062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237070 */     GIR_RootConstrainSelectedInstOperands,
     /* 237071 */     // GIR_Coverage, 3245,
     /* 237071 */     GIR_EraseRootFromParent_Done,
     /* 237072 */   // Label 4528: @237072
     /* 237072 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(237114), // Rule ID 3246 //
     /* 237077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 237085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 237088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237101 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1368:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 237101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 237104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237112 */     GIR_RootConstrainSelectedInstOperands,
     /* 237113 */     // GIR_Coverage, 3246,
     /* 237113 */     GIR_EraseRootFromParent_Done,
     /* 237114 */   // Label 4529: @237114
     /* 237114 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(237156), // Rule ID 3247 //
     /* 237119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 237127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 237130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237143 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1368:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 237146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237154 */     GIR_RootConstrainSelectedInstOperands,
     /* 237155 */     // GIR_Coverage, 3247,
     /* 237155 */     GIR_EraseRootFromParent_Done,
     /* 237156 */   // Label 4530: @237156
     /* 237156 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(237198), // Rule ID 3299 //
     /* 237161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 237169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237185 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1274:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 237188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237196 */     GIR_RootConstrainSelectedInstOperands,
     /* 237197 */     // GIR_Coverage, 3299,
     /* 237197 */     GIR_EraseRootFromParent_Done,
     /* 237198 */   // Label 4531: @237198
     /* 237198 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(237240), // Rule ID 3300 //
     /* 237203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 237211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1274:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 237230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237238 */     GIR_RootConstrainSelectedInstOperands,
     /* 237239 */     // GIR_Coverage, 3300,
     /* 237239 */     GIR_EraseRootFromParent_Done,
     /* 237240 */   // Label 4532: @237240
     /* 237240 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(237282), // Rule ID 3301 //
     /* 237245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 237253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1274:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 237272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237280 */     GIR_RootConstrainSelectedInstOperands,
     /* 237281 */     // GIR_Coverage, 3301,
     /* 237281 */     GIR_EraseRootFromParent_Done,
     /* 237282 */   // Label 4533: @237282
     /* 237282 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(237324), // Rule ID 3302 //
     /* 237287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 237295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1274:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 237314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237322 */     GIR_RootConstrainSelectedInstOperands,
     /* 237323 */     // GIR_Coverage, 3302,
     /* 237323 */     GIR_EraseRootFromParent_Done,
     /* 237324 */   // Label 4534: @237324
     /* 237324 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(237366), // Rule ID 3311 //
     /* 237329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 237337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237353 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1276:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 237356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237364 */     GIR_RootConstrainSelectedInstOperands,
     /* 237365 */     // GIR_Coverage, 3311,
     /* 237365 */     GIR_EraseRootFromParent_Done,
     /* 237366 */   // Label 4535: @237366
     /* 237366 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(237408), // Rule ID 3312 //
     /* 237371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 237379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237395 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1276:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 237398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237406 */     GIR_RootConstrainSelectedInstOperands,
     /* 237407 */     // GIR_Coverage, 3312,
     /* 237407 */     GIR_EraseRootFromParent_Done,
     /* 237408 */   // Label 4536: @237408
     /* 237408 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(237450), // Rule ID 3313 //
     /* 237413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 237421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237437 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 237440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237448 */     GIR_RootConstrainSelectedInstOperands,
     /* 237449 */     // GIR_Coverage, 3313,
     /* 237449 */     GIR_EraseRootFromParent_Done,
     /* 237450 */   // Label 4537: @237450
     /* 237450 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(237492), // Rule ID 3352 //
     /* 237455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237479 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1313:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 237482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237490 */     GIR_RootConstrainSelectedInstOperands,
     /* 237491 */     // GIR_Coverage, 3352,
     /* 237491 */     GIR_EraseRootFromParent_Done,
     /* 237492 */   // Label 4538: @237492
     /* 237492 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(237534), // Rule ID 3353 //
     /* 237497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1313:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 237524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237532 */     GIR_RootConstrainSelectedInstOperands,
     /* 237533 */     // GIR_Coverage, 3353,
     /* 237533 */     GIR_EraseRootFromParent_Done,
     /* 237534 */   // Label 4539: @237534
     /* 237534 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(237576), // Rule ID 3354 //
     /* 237539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1313:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 237566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237574 */     GIR_RootConstrainSelectedInstOperands,
     /* 237575 */     // GIR_Coverage, 3354,
     /* 237575 */     GIR_EraseRootFromParent_Done,
     /* 237576 */   // Label 4540: @237576
     /* 237576 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(237618), // Rule ID 3355 //
     /* 237581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237605 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1313:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 237608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237616 */     GIR_RootConstrainSelectedInstOperands,
     /* 237617 */     // GIR_Coverage, 3355,
     /* 237617 */     GIR_EraseRootFromParent_Done,
     /* 237618 */   // Label 4541: @237618
     /* 237618 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(237660), // Rule ID 3356 //
     /* 237623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237647 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1313:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 237650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237658 */     GIR_RootConstrainSelectedInstOperands,
     /* 237659 */     // GIR_Coverage, 3356,
     /* 237659 */     GIR_EraseRootFromParent_Done,
     /* 237660 */   // Label 4542: @237660
     /* 237660 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(237702), // Rule ID 3357 //
     /* 237665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237689 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1313:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 237689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 237692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237700 */     GIR_RootConstrainSelectedInstOperands,
     /* 237701 */     // GIR_Coverage, 3357,
     /* 237701 */     GIR_EraseRootFromParent_Done,
     /* 237702 */   // Label 4543: @237702
     /* 237702 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(237744), // Rule ID 3358 //
     /* 237707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237731 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1313:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 237734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237742 */     GIR_RootConstrainSelectedInstOperands,
     /* 237743 */     // GIR_Coverage, 3358,
     /* 237743 */     GIR_EraseRootFromParent_Done,
     /* 237744 */   // Label 4544: @237744
     /* 237744 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(237786), // Rule ID 3441 //
     /* 237749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 237757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 237769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237773 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1305:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 237773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 237776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237784 */     GIR_RootConstrainSelectedInstOperands,
     /* 237785 */     // GIR_Coverage, 3441,
     /* 237785 */     GIR_EraseRootFromParent_Done,
     /* 237786 */   // Label 4545: @237786
     /* 237786 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(237828), // Rule ID 3442 //
     /* 237791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 237799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 237811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237815 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1304:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 237815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 237818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 237820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237826 */     GIR_RootConstrainSelectedInstOperands,
     /* 237827 */     // GIR_Coverage, 3442,
     /* 237827 */     GIR_EraseRootFromParent_Done,
     /* 237828 */   // Label 4546: @237828
     /* 237828 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(237870), // Rule ID 3443 //
     /* 237833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 237841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 237853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237857 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1300:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 237857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 237860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237868 */     GIR_RootConstrainSelectedInstOperands,
     /* 237869 */     // GIR_Coverage, 3443,
     /* 237869 */     GIR_EraseRootFromParent_Done,
     /* 237870 */   // Label 4547: @237870
     /* 237870 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(237915), // Rule ID 3445 //
     /* 237875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 237883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237899 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 237902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237913 */     GIR_RootConstrainSelectedInstOperands,
     /* 237914 */     // GIR_Coverage, 3445,
     /* 237914 */     GIR_EraseRootFromParent_Done,
     /* 237915 */   // Label 4548: @237915
     /* 237915 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(237960), // Rule ID 3446 //
     /* 237920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 237928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237944 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 237947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237958 */     GIR_RootConstrainSelectedInstOperands,
     /* 237959 */     // GIR_Coverage, 3446,
     /* 237959 */     GIR_EraseRootFromParent_Done,
     /* 237960 */   // Label 4549: @237960
     /* 237960 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(238002), // Rule ID 3447 //
     /* 237965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 237973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237989 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1552:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 237992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238000 */     GIR_RootConstrainSelectedInstOperands,
     /* 238001 */     // GIR_Coverage, 3447,
     /* 238001 */     GIR_EraseRootFromParent_Done,
     /* 238002 */   // Label 4550: @238002
     /* 238002 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(238044), // Rule ID 3448 //
     /* 238007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 238010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 238015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238031 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1552:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 238034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238042 */     GIR_RootConstrainSelectedInstOperands,
     /* 238043 */     // GIR_Coverage, 3448,
     /* 238043 */     GIR_EraseRootFromParent_Done,
     /* 238044 */   // Label 4551: @238044
     /* 238044 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(238086), // Rule ID 3453 //
     /* 238049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 238052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 238057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238073 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 238076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238084 */     GIR_RootConstrainSelectedInstOperands,
     /* 238085 */     // GIR_Coverage, 3453,
     /* 238085 */     GIR_EraseRootFromParent_Done,
     /* 238086 */   // Label 4552: @238086
     /* 238086 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(238128), // Rule ID 3492 //
     /* 238091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 238094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 238099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238115 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1381:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 238118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238126 */     GIR_RootConstrainSelectedInstOperands,
     /* 238127 */     // GIR_Coverage, 3492,
     /* 238127 */     GIR_EraseRootFromParent_Done,
     /* 238128 */   // Label 4553: @238128
     /* 238128 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(238170), // Rule ID 3494 //
     /* 238133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 238136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 238141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238157 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 238160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238168 */     GIR_RootConstrainSelectedInstOperands,
     /* 238169 */     // GIR_Coverage, 3494,
     /* 238169 */     GIR_EraseRootFromParent_Done,
     /* 238170 */   // Label 4554: @238170
     /* 238170 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(238212), // Rule ID 3496 //
     /* 238175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 238178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 238183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238199 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1381:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 238202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238210 */     GIR_RootConstrainSelectedInstOperands,
     /* 238211 */     // GIR_Coverage, 3496,
     /* 238211 */     GIR_EraseRootFromParent_Done,
     /* 238212 */   // Label 4555: @238212
     /* 238212 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(238254), // Rule ID 3498 //
     /* 238217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 238220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 238225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 238244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238252 */     GIR_RootConstrainSelectedInstOperands,
     /* 238253 */     // GIR_Coverage, 3498,
     /* 238253 */     GIR_EraseRootFromParent_Done,
     /* 238254 */   // Label 4556: @238254
     /* 238254 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(238296), // Rule ID 3625 //
     /* 238259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 238267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238283 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1703:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 238286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238294 */     GIR_RootConstrainSelectedInstOperands,
     /* 238295 */     // GIR_Coverage, 3625,
     /* 238295 */     GIR_EraseRootFromParent_Done,
     /* 238296 */   // Label 4557: @238296
     /* 238296 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(238338), // Rule ID 3627 //
     /* 238301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 238309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238325 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1703:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 238328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238336 */     GIR_RootConstrainSelectedInstOperands,
     /* 238337 */     // GIR_Coverage, 3627,
     /* 238337 */     GIR_EraseRootFromParent_Done,
     /* 238338 */   // Label 4558: @238338
     /* 238338 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(238380), // Rule ID 3629 //
     /* 238343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 238351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238367 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1703:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 238370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238378 */     GIR_RootConstrainSelectedInstOperands,
     /* 238379 */     // GIR_Coverage, 3629,
     /* 238379 */     GIR_EraseRootFromParent_Done,
     /* 238380 */   // Label 4559: @238380
     /* 238380 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(238422), // Rule ID 3631 //
     /* 238385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 238393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238409 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1703:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 238412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238420 */     GIR_RootConstrainSelectedInstOperands,
     /* 238421 */     // GIR_Coverage, 3631,
     /* 238421 */     GIR_EraseRootFromParent_Done,
     /* 238422 */   // Label 4560: @238422
     /* 238422 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(238464), // Rule ID 7536 //
     /* 238427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 238435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238451 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1912:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 238454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238462 */     GIR_RootConstrainSelectedInstOperands,
     /* 238463 */     // GIR_Coverage, 7536,
     /* 238463 */     GIR_EraseRootFromParent_Done,
     /* 238464 */   // Label 4561: @238464
     /* 238464 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(238506), // Rule ID 7538 //
     /* 238469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 238477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238493 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1912:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 238496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238504 */     GIR_RootConstrainSelectedInstOperands,
     /* 238505 */     // GIR_Coverage, 7538,
     /* 238505 */     GIR_EraseRootFromParent_Done,
     /* 238506 */   // Label 4562: @238506
     /* 238506 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(238548), // Rule ID 7540 //
     /* 238511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 238519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238535 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1912:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 238538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238546 */     GIR_RootConstrainSelectedInstOperands,
     /* 238547 */     // GIR_Coverage, 7540,
     /* 238547 */     GIR_EraseRootFromParent_Done,
     /* 238548 */   // Label 4563: @238548
     /* 238548 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(238590), // Rule ID 7542 //
     /* 238553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 238561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238577 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1912:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 238580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238588 */     GIR_RootConstrainSelectedInstOperands,
     /* 238589 */     // GIR_Coverage, 7542,
     /* 238589 */     GIR_EraseRootFromParent_Done,
     /* 238590 */   // Label 4564: @238590
     /* 238590 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(238632), // Rule ID 7560 //
     /* 238595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 238603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238619 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1297:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 238622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238630 */     GIR_RootConstrainSelectedInstOperands,
     /* 238631 */     // GIR_Coverage, 7560,
     /* 238631 */     GIR_EraseRootFromParent_Done,
     /* 238632 */   // Label 4565: @238632
     /* 238632 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(238674), // Rule ID 7561 //
     /* 238637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 238645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238661 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1297:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 238664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238672 */     GIR_RootConstrainSelectedInstOperands,
     /* 238673 */     // GIR_Coverage, 7561,
     /* 238673 */     GIR_EraseRootFromParent_Done,
     /* 238674 */   // Label 4566: @238674
     /* 238674 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(238716), // Rule ID 7562 //
     /* 238679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 238687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238703 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1297:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 238706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238714 */     GIR_RootConstrainSelectedInstOperands,
     /* 238715 */     // GIR_Coverage, 7562,
     /* 238715 */     GIR_EraseRootFromParent_Done,
     /* 238716 */   // Label 4567: @238716
     /* 238716 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(238758), // Rule ID 7563 //
     /* 238721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 238729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238745 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1297:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 238748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238756 */     GIR_RootConstrainSelectedInstOperands,
     /* 238757 */     // GIR_Coverage, 7563,
     /* 238757 */     GIR_EraseRootFromParent_Done,
     /* 238758 */   // Label 4568: @238758
     /* 238758 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(238800), // Rule ID 7676 //
     /* 238763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 238771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238787 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 238790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238798 */     GIR_RootConstrainSelectedInstOperands,
     /* 238799 */     // GIR_Coverage, 7676,
     /* 238799 */     GIR_EraseRootFromParent_Done,
     /* 238800 */   // Label 4569: @238800
     /* 238800 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(238842), // Rule ID 7677 //
     /* 238805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 238813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238829 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 238832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238840 */     GIR_RootConstrainSelectedInstOperands,
     /* 238841 */     // GIR_Coverage, 7677,
     /* 238841 */     GIR_EraseRootFromParent_Done,
     /* 238842 */   // Label 4570: @238842
     /* 238842 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(238884), // Rule ID 7678 //
     /* 238847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 238855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 238874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238882 */     GIR_RootConstrainSelectedInstOperands,
     /* 238883 */     // GIR_Coverage, 7678,
     /* 238883 */     GIR_EraseRootFromParent_Done,
     /* 238884 */   // Label 4571: @238884
     /* 238884 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(238926), // Rule ID 7679 //
     /* 238889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 238897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 238916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238924 */     GIR_RootConstrainSelectedInstOperands,
     /* 238925 */     // GIR_Coverage, 7679,
     /* 238925 */     GIR_EraseRootFromParent_Done,
     /* 238926 */   // Label 4572: @238926
     /* 238926 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(238968), // Rule ID 7680 //
     /* 238931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 238939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238955 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1997:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 238958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238966 */     GIR_RootConstrainSelectedInstOperands,
     /* 238967 */     // GIR_Coverage, 7680,
     /* 238967 */     GIR_EraseRootFromParent_Done,
     /* 238968 */   // Label 4573: @238968
     /* 238968 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(239010), // Rule ID 7681 //
     /* 238973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 238981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238997 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1997:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 239000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239008 */     GIR_RootConstrainSelectedInstOperands,
     /* 239009 */     // GIR_Coverage, 7681,
     /* 239009 */     GIR_EraseRootFromParent_Done,
     /* 239010 */   // Label 4574: @239010
     /* 239010 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(239052), // Rule ID 7682 //
     /* 239015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 239023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1997:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 239042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239050 */     GIR_RootConstrainSelectedInstOperands,
     /* 239051 */     // GIR_Coverage, 7682,
     /* 239051 */     GIR_EraseRootFromParent_Done,
     /* 239052 */   // Label 4575: @239052
     /* 239052 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(239094), // Rule ID 7683 //
     /* 239057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 239065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1997:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 239084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239092 */     GIR_RootConstrainSelectedInstOperands,
     /* 239093 */     // GIR_Coverage, 7683,
     /* 239093 */     GIR_EraseRootFromParent_Done,
     /* 239094 */   // Label 4576: @239094
     /* 239094 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(239136), // Rule ID 7692 //
     /* 239099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 239107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239123 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 239126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239134 */     GIR_RootConstrainSelectedInstOperands,
     /* 239135 */     // GIR_Coverage, 7692,
     /* 239135 */     GIR_EraseRootFromParent_Done,
     /* 239136 */   // Label 4577: @239136
     /* 239136 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(239178), // Rule ID 7693 //
     /* 239141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 239149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1960:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 239168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239176 */     GIR_RootConstrainSelectedInstOperands,
     /* 239177 */     // GIR_Coverage, 7693,
     /* 239177 */     GIR_EraseRootFromParent_Done,
     /* 239178 */   // Label 4578: @239178
     /* 239178 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(239220), // Rule ID 7694 //
     /* 239183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 239191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1715:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 239210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239218 */     GIR_RootConstrainSelectedInstOperands,
     /* 239219 */     // GIR_Coverage, 7694,
     /* 239219 */     GIR_EraseRootFromParent_Done,
     /* 239220 */   // Label 4579: @239220
     /* 239220 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(239262), // Rule ID 7695 //
     /* 239225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 239233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1715:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 239252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239260 */     GIR_RootConstrainSelectedInstOperands,
     /* 239261 */     // GIR_Coverage, 7695,
     /* 239261 */     GIR_EraseRootFromParent_Done,
     /* 239262 */   // Label 4580: @239262
     /* 239262 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(239304), // Rule ID 7696 //
     /* 239267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 239275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239291 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1962:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 239294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239302 */     GIR_RootConstrainSelectedInstOperands,
     /* 239303 */     // GIR_Coverage, 7696,
     /* 239303 */     GIR_EraseRootFromParent_Done,
     /* 239304 */   // Label 4581: @239304
     /* 239304 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(239346), // Rule ID 7697 //
     /* 239309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 239317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239333 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1962:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 239336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239344 */     GIR_RootConstrainSelectedInstOperands,
     /* 239345 */     // GIR_Coverage, 7697,
     /* 239345 */     GIR_EraseRootFromParent_Done,
     /* 239346 */   // Label 4582: @239346
     /* 239346 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(239388), // Rule ID 7786 //
     /* 239351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 239359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239375 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1337:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 239375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 239378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239386 */     GIR_RootConstrainSelectedInstOperands,
     /* 239387 */     // GIR_Coverage, 7786,
     /* 239387 */     GIR_EraseRootFromParent_Done,
     /* 239388 */   // Label 4583: @239388
     /* 239388 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(239430), // Rule ID 7787 //
     /* 239393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 239401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 239410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239417 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1337:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 239417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 239420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239428 */     GIR_RootConstrainSelectedInstOperands,
     /* 239429 */     // GIR_Coverage, 7787,
     /* 239429 */     GIR_EraseRootFromParent_Done,
     /* 239430 */   // Label 4584: @239430
     /* 239430 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(239472), // Rule ID 7788 //
     /* 239435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 239443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 239452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1337:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 239459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 239462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239470 */     GIR_RootConstrainSelectedInstOperands,
     /* 239471 */     // GIR_Coverage, 7788,
     /* 239471 */     GIR_EraseRootFromParent_Done,
     /* 239472 */   // Label 4585: @239472
     /* 239472 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(239514), // Rule ID 7789 //
     /* 239477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 239485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 239494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239501 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1337:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 239501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 239504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239512 */     GIR_RootConstrainSelectedInstOperands,
     /* 239513 */     // GIR_Coverage, 7789,
     /* 239513 */     GIR_EraseRootFromParent_Done,
     /* 239514 */   // Label 4586: @239514
     /* 239514 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(239556), // Rule ID 7798 //
     /* 239519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 239527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239543 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 239543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 239546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239554 */     GIR_RootConstrainSelectedInstOperands,
     /* 239555 */     // GIR_Coverage, 7798,
     /* 239555 */     GIR_EraseRootFromParent_Done,
     /* 239556 */   // Label 4587: @239556
     /* 239556 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(239598), // Rule ID 7799 //
     /* 239561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 239569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 239578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239585 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 239585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 239588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239596 */     GIR_RootConstrainSelectedInstOperands,
     /* 239597 */     // GIR_Coverage, 7799,
     /* 239597 */     GIR_EraseRootFromParent_Done,
     /* 239598 */   // Label 4588: @239598
     /* 239598 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(239640), // Rule ID 7800 //
     /* 239603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 239611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 239620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 239627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 239630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239638 */     GIR_RootConstrainSelectedInstOperands,
     /* 239639 */     // GIR_Coverage, 7800,
     /* 239639 */     GIR_EraseRootFromParent_Done,
     /* 239640 */   // Label 4589: @239640
     /* 239640 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(239682), // Rule ID 7801 //
     /* 239645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 239653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 239662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 239669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 239672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239680 */     GIR_RootConstrainSelectedInstOperands,
     /* 239681 */     // GIR_Coverage, 7801,
     /* 239681 */     GIR_EraseRootFromParent_Done,
     /* 239682 */   // Label 4590: @239682
     /* 239682 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(239724), // Rule ID 7880 //
     /* 239687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 239695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239711 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1690:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 239714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239722 */     GIR_RootConstrainSelectedInstOperands,
     /* 239723 */     // GIR_Coverage, 7880,
     /* 239723 */     GIR_EraseRootFromParent_Done,
     /* 239724 */   // Label 4591: @239724
     /* 239724 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(239766), // Rule ID 7881 //
     /* 239729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 239737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239753 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 239756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239764 */     GIR_RootConstrainSelectedInstOperands,
     /* 239765 */     // GIR_Coverage, 7881,
     /* 239765 */     GIR_EraseRootFromParent_Done,
     /* 239766 */   // Label 4592: @239766
     /* 239766 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(239808), // Rule ID 7882 //
     /* 239771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 239779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 239798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239806 */     GIR_RootConstrainSelectedInstOperands,
     /* 239807 */     // GIR_Coverage, 7882,
     /* 239807 */     GIR_EraseRootFromParent_Done,
     /* 239808 */   // Label 4593: @239808
     /* 239808 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(239850), // Rule ID 7883 //
     /* 239813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 239821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239837 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 239840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239848 */     GIR_RootConstrainSelectedInstOperands,
     /* 239849 */     // GIR_Coverage, 7883,
     /* 239849 */     GIR_EraseRootFromParent_Done,
     /* 239850 */   // Label 4594: @239850
     /* 239850 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(239892), // Rule ID 7884 //
     /* 239855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 239863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239879 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1940:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 239882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239890 */     GIR_RootConstrainSelectedInstOperands,
     /* 239891 */     // GIR_Coverage, 7884,
     /* 239891 */     GIR_EraseRootFromParent_Done,
     /* 239892 */   // Label 4595: @239892
     /* 239892 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(239934), // Rule ID 7885 //
     /* 239897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 239905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1940:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 239924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239932 */     GIR_RootConstrainSelectedInstOperands,
     /* 239933 */     // GIR_Coverage, 7885,
     /* 239933 */     GIR_EraseRootFromParent_Done,
     /* 239934 */   // Label 4596: @239934
     /* 239934 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(239976), // Rule ID 7886 //
     /* 239939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 239947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1940:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 239966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239974 */     GIR_RootConstrainSelectedInstOperands,
     /* 239975 */     // GIR_Coverage, 7886,
     /* 239975 */     GIR_EraseRootFromParent_Done,
     /* 239976 */   // Label 4597: @239976
     /* 239976 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(240018), // Rule ID 7887 //
     /* 239981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 239989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240005 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1940:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 240008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240016 */     GIR_RootConstrainSelectedInstOperands,
     /* 240017 */     // GIR_Coverage, 7887,
     /* 240017 */     GIR_EraseRootFromParent_Done,
     /* 240018 */   // Label 4598: @240018
     /* 240018 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(240060), // Rule ID 8083 //
     /* 240023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 240031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240047 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1546:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 240050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240058 */     GIR_RootConstrainSelectedInstOperands,
     /* 240059 */     // GIR_Coverage, 8083,
     /* 240059 */     GIR_EraseRootFromParent_Done,
     /* 240060 */   // Label 4599: @240060
     /* 240060 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(240102), // Rule ID 8085 //
     /* 240065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 240073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240089 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1546:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 240092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240100 */     GIR_RootConstrainSelectedInstOperands,
     /* 240101 */     // GIR_Coverage, 8085,
     /* 240101 */     GIR_EraseRootFromParent_Done,
     /* 240102 */   // Label 4600: @240102
     /* 240102 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(240144), // Rule ID 8087 //
     /* 240107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 240115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240131 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1546:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 240134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240142 */     GIR_RootConstrainSelectedInstOperands,
     /* 240143 */     // GIR_Coverage, 8087,
     /* 240143 */     GIR_EraseRootFromParent_Done,
     /* 240144 */   // Label 4601: @240144
     /* 240144 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(240186), // Rule ID 8095 //
     /* 240149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 240157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240173 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1548:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 240176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240184 */     GIR_RootConstrainSelectedInstOperands,
     /* 240185 */     // GIR_Coverage, 8095,
     /* 240185 */     GIR_EraseRootFromParent_Done,
     /* 240186 */   // Label 4602: @240186
     /* 240186 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(240228), // Rule ID 8097 //
     /* 240191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 240199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240215 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1548:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 240218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240226 */     GIR_RootConstrainSelectedInstOperands,
     /* 240227 */     // GIR_Coverage, 8097,
     /* 240227 */     GIR_EraseRootFromParent_Done,
     /* 240228 */   // Label 4603: @240228
     /* 240228 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(240270), // Rule ID 8099 //
     /* 240233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 240241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240257 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1548:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 240260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240268 */     GIR_RootConstrainSelectedInstOperands,
     /* 240269 */     // GIR_Coverage, 8099,
     /* 240269 */     GIR_EraseRootFromParent_Done,
     /* 240270 */   // Label 4604: @240270
     /* 240270 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(240312), // Rule ID 8137 //
     /* 240275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 240283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240299 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1365:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 240302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240310 */     GIR_RootConstrainSelectedInstOperands,
     /* 240311 */     // GIR_Coverage, 8137,
     /* 240311 */     GIR_EraseRootFromParent_Done,
     /* 240312 */   // Label 4605: @240312
     /* 240312 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(240354), // Rule ID 8138 //
     /* 240317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 240325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240341 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1365:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 240344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240352 */     GIR_RootConstrainSelectedInstOperands,
     /* 240353 */     // GIR_Coverage, 8138,
     /* 240353 */     GIR_EraseRootFromParent_Done,
     /* 240354 */   // Label 4606: @240354
     /* 240354 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(240396), // Rule ID 8139 //
     /* 240359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 240367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240383 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1365:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 240386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240394 */     GIR_RootConstrainSelectedInstOperands,
     /* 240395 */     // GIR_Coverage, 8139,
     /* 240395 */     GIR_EraseRootFromParent_Done,
     /* 240396 */   // Label 4607: @240396
     /* 240396 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(240438), // Rule ID 8140 //
     /* 240401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 240409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240425 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 240428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240436 */     GIR_RootConstrainSelectedInstOperands,
     /* 240437 */     // GIR_Coverage, 8140,
     /* 240437 */     GIR_EraseRootFromParent_Done,
     /* 240438 */   // Label 4608: @240438
     /* 240438 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(240480), // Rule ID 8141 //
     /* 240443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 240451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240467 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 240470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240478 */     GIR_RootConstrainSelectedInstOperands,
     /* 240479 */     // GIR_Coverage, 8141,
     /* 240479 */     GIR_EraseRootFromParent_Done,
     /* 240480 */   // Label 4609: @240480
     /* 240480 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(240522), // Rule ID 8142 //
     /* 240485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 240493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240509 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 240512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240520 */     GIR_RootConstrainSelectedInstOperands,
     /* 240521 */     // GIR_Coverage, 8142,
     /* 240521 */     GIR_EraseRootFromParent_Done,
     /* 240522 */   // Label 4610: @240522
     /* 240522 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(240564), // Rule ID 8143 //
     /* 240527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 240535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240551 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1426:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 240554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240562 */     GIR_RootConstrainSelectedInstOperands,
     /* 240563 */     // GIR_Coverage, 8143,
     /* 240563 */     GIR_EraseRootFromParent_Done,
     /* 240564 */   // Label 4611: @240564
     /* 240564 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(240606), // Rule ID 8144 //
     /* 240569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 240577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240593 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1426:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 240596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240604 */     GIR_RootConstrainSelectedInstOperands,
     /* 240605 */     // GIR_Coverage, 8144,
     /* 240605 */     GIR_EraseRootFromParent_Done,
     /* 240606 */   // Label 4612: @240606
     /* 240606 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(240648), // Rule ID 8145 //
     /* 240611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 240619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240635 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1426:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 240638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240646 */     GIR_RootConstrainSelectedInstOperands,
     /* 240647 */     // GIR_Coverage, 8145,
     /* 240647 */     GIR_EraseRootFromParent_Done,
     /* 240648 */   // Label 4613: @240648
     /* 240648 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(240690), // Rule ID 8146 //
     /* 240653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 240661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240677 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 240680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240688 */     GIR_RootConstrainSelectedInstOperands,
     /* 240689 */     // GIR_Coverage, 8146,
     /* 240689 */     GIR_EraseRootFromParent_Done,
     /* 240690 */   // Label 4614: @240690
     /* 240690 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(240732), // Rule ID 8147 //
     /* 240695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 240703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240719 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 240722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240730 */     GIR_RootConstrainSelectedInstOperands,
     /* 240731 */     // GIR_Coverage, 8147,
     /* 240731 */     GIR_EraseRootFromParent_Done,
     /* 240732 */   // Label 4615: @240732
     /* 240732 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(240774), // Rule ID 8148 //
     /* 240737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 240745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240761 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 240764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240772 */     GIR_RootConstrainSelectedInstOperands,
     /* 240773 */     // GIR_Coverage, 8148,
     /* 240773 */     GIR_EraseRootFromParent_Done,
     /* 240774 */   // Label 4616: @240774
     /* 240774 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(240816), // Rule ID 8185 //
     /* 240779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 240787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240803 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1366:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 240806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240814 */     GIR_RootConstrainSelectedInstOperands,
     /* 240815 */     // GIR_Coverage, 8185,
     /* 240815 */     GIR_EraseRootFromParent_Done,
     /* 240816 */   // Label 4617: @240816
     /* 240816 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(240858), // Rule ID 8187 //
     /* 240821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 240829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 240832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 240838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 240841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240845 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 240845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 240848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240856 */     GIR_RootConstrainSelectedInstOperands,
     /* 240857 */     // GIR_Coverage, 8187,
     /* 240857 */     GIR_EraseRootFromParent_Done,
     /* 240858 */   // Label 4618: @240858
     /* 240858 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(240900), // Rule ID 8189 //
     /* 240863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 240871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 240874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 240880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 240883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240887 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 240887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 240890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240898 */     GIR_RootConstrainSelectedInstOperands,
     /* 240899 */     // GIR_Coverage, 8189,
     /* 240899 */     GIR_EraseRootFromParent_Done,
     /* 240900 */   // Label 4619: @240900
     /* 240900 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(240942), // Rule ID 8191 //
     /* 240905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 240913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240929 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 240932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240940 */     GIR_RootConstrainSelectedInstOperands,
     /* 240941 */     // GIR_Coverage, 8191,
     /* 240941 */     GIR_EraseRootFromParent_Done,
     /* 240942 */   // Label 4620: @240942
     /* 240942 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(240984), // Rule ID 8193 //
     /* 240947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 240955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240971 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 240971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 240974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240982 */     GIR_RootConstrainSelectedInstOperands,
     /* 240983 */     // GIR_Coverage, 8193,
     /* 240983 */     GIR_EraseRootFromParent_Done,
     /* 240984 */   // Label 4621: @240984
     /* 240984 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(241026), // Rule ID 8195 //
     /* 240989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 240997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 241016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241024 */     GIR_RootConstrainSelectedInstOperands,
     /* 241025 */     // GIR_Coverage, 8195,
     /* 241025 */     GIR_EraseRootFromParent_Done,
     /* 241026 */   // Label 4622: @241026
     /* 241026 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(241068), // Rule ID 8197 //
     /* 241031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241055 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 241058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241066 */     GIR_RootConstrainSelectedInstOperands,
     /* 241067 */     // GIR_Coverage, 8197,
     /* 241067 */     GIR_EraseRootFromParent_Done,
     /* 241068 */   // Label 4623: @241068
     /* 241068 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(241110), // Rule ID 8198 //
     /* 241073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241097 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 241097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 241100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241108 */     GIR_RootConstrainSelectedInstOperands,
     /* 241109 */     // GIR_Coverage, 8198,
     /* 241109 */     GIR_EraseRootFromParent_Done,
     /* 241110 */   // Label 4624: @241110
     /* 241110 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(241152), // Rule ID 8199 //
     /* 241115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241139 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 241139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 241142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241150 */     GIR_RootConstrainSelectedInstOperands,
     /* 241151 */     // GIR_Coverage, 8199,
     /* 241151 */     GIR_EraseRootFromParent_Done,
     /* 241152 */   // Label 4625: @241152
     /* 241152 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(241194), // Rule ID 8200 //
     /* 241157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241181 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 241184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241192 */     GIR_RootConstrainSelectedInstOperands,
     /* 241193 */     // GIR_Coverage, 8200,
     /* 241193 */     GIR_EraseRootFromParent_Done,
     /* 241194 */   // Label 4626: @241194
     /* 241194 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(241236), // Rule ID 8201 //
     /* 241199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241223 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 241223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 241226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241234 */     GIR_RootConstrainSelectedInstOperands,
     /* 241235 */     // GIR_Coverage, 8201,
     /* 241235 */     GIR_EraseRootFromParent_Done,
     /* 241236 */   // Label 4627: @241236
     /* 241236 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(241278), // Rule ID 8202 //
     /* 241241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241265 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 241268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241276 */     GIR_RootConstrainSelectedInstOperands,
     /* 241277 */     // GIR_Coverage, 8202,
     /* 241277 */     GIR_EraseRootFromParent_Done,
     /* 241278 */   // Label 4628: @241278
     /* 241278 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(241320), // Rule ID 8455 //
     /* 241283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 241291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241307 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 241310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241318 */     GIR_RootConstrainSelectedInstOperands,
     /* 241319 */     // GIR_Coverage, 8455,
     /* 241319 */     GIR_EraseRootFromParent_Done,
     /* 241320 */   // Label 4629: @241320
     /* 241320 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(241362), // Rule ID 8457 //
     /* 241325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 241333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241349 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1302:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 241352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241360 */     GIR_RootConstrainSelectedInstOperands,
     /* 241361 */     // GIR_Coverage, 8457,
     /* 241361 */     GIR_EraseRootFromParent_Done,
     /* 241362 */   // Label 4630: @241362
     /* 241362 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(241404), // Rule ID 8458 //
     /* 241367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 241375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241391 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1299:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 241394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241402 */     GIR_RootConstrainSelectedInstOperands,
     /* 241403 */     // GIR_Coverage, 8458,
     /* 241403 */     GIR_EraseRootFromParent_Done,
     /* 241404 */   // Label 4631: @241404
     /* 241404 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(241446), // Rule ID 8459 //
     /* 241409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 241417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 241420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 241429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241433 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1299:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 241433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 241436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241444 */     GIR_RootConstrainSelectedInstOperands,
     /* 241445 */     // GIR_Coverage, 8459,
     /* 241445 */     GIR_EraseRootFromParent_Done,
     /* 241446 */   // Label 4632: @241446
     /* 241446 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(241488), // Rule ID 8460 //
     /* 241451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 241459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 241462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 241471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241475 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1299:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 241475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 241478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241486 */     GIR_RootConstrainSelectedInstOperands,
     /* 241487 */     // GIR_Coverage, 8460,
     /* 241487 */     GIR_EraseRootFromParent_Done,
     /* 241488 */   // Label 4633: @241488
     /* 241488 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(241530), // Rule ID 8461 //
     /* 241493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 241501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 241504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 241513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241517 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1299:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 241517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 241520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241528 */     GIR_RootConstrainSelectedInstOperands,
     /* 241529 */     // GIR_Coverage, 8461,
     /* 241529 */     GIR_EraseRootFromParent_Done,
     /* 241530 */   // Label 4634: @241530
     /* 241530 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(241572), // Rule ID 8462 //
     /* 241535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 241543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 241546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 241549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 241552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 241555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241559 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1299:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 241559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 241562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241570 */     GIR_RootConstrainSelectedInstOperands,
     /* 241571 */     // GIR_Coverage, 8462,
     /* 241571 */     GIR_EraseRootFromParent_Done,
     /* 241572 */   // Label 4635: @241572
     /* 241572 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(241614), // Rule ID 8483 //
     /* 241577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 241585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241601 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1357:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 241604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241612 */     GIR_RootConstrainSelectedInstOperands,
     /* 241613 */     // GIR_Coverage, 8483,
     /* 241613 */     GIR_EraseRootFromParent_Done,
     /* 241614 */   // Label 4636: @241614
     /* 241614 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(241656), // Rule ID 8484 //
     /* 241619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 241627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 241630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 241639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241643 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1357:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 241643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 241646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241654 */     GIR_RootConstrainSelectedInstOperands,
     /* 241655 */     // GIR_Coverage, 8484,
     /* 241655 */     GIR_EraseRootFromParent_Done,
     /* 241656 */   // Label 4637: @241656
     /* 241656 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(241698), // Rule ID 8485 //
     /* 241661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 241669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 241672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 241681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241685 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1357:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 241685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 241688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241696 */     GIR_RootConstrainSelectedInstOperands,
     /* 241697 */     // GIR_Coverage, 8485,
     /* 241697 */     GIR_EraseRootFromParent_Done,
     /* 241698 */   // Label 4638: @241698
     /* 241698 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(241740), // Rule ID 8486 //
     /* 241703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 241711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 241714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 241723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241727 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1357:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 241727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 241730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241738 */     GIR_RootConstrainSelectedInstOperands,
     /* 241739 */     // GIR_Coverage, 8486,
     /* 241739 */     GIR_EraseRootFromParent_Done,
     /* 241740 */   // Label 4639: @241740
     /* 241740 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(241782), // Rule ID 8487 //
     /* 241745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 241753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 241756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 241759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 241762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 241765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241769 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1357:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 241769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 241772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241780 */     GIR_RootConstrainSelectedInstOperands,
     /* 241781 */     // GIR_Coverage, 8487,
     /* 241781 */     GIR_EraseRootFromParent_Done,
     /* 241782 */   // Label 4640: @241782
     /* 241782 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(241824), // Rule ID 8503 //
     /* 241787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 241795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241811 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1628:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 241814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241822 */     GIR_RootConstrainSelectedInstOperands,
     /* 241823 */     // GIR_Coverage, 8503,
     /* 241823 */     GIR_EraseRootFromParent_Done,
     /* 241824 */   // Label 4641: @241824
     /* 241824 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(241866), // Rule ID 8504 //
     /* 241829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 241837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 241840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 241849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241853 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1628:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 241853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 241856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241864 */     GIR_RootConstrainSelectedInstOperands,
     /* 241865 */     // GIR_Coverage, 8504,
     /* 241865 */     GIR_EraseRootFromParent_Done,
     /* 241866 */   // Label 4642: @241866
     /* 241866 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(241908), // Rule ID 8505 //
     /* 241871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 241879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 241882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 241891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241895 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1628:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 241895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 241898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241906 */     GIR_RootConstrainSelectedInstOperands,
     /* 241907 */     // GIR_Coverage, 8505,
     /* 241907 */     GIR_EraseRootFromParent_Done,
     /* 241908 */   // Label 4643: @241908
     /* 241908 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(241950), // Rule ID 8506 //
     /* 241913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 241921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 241924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 241933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241937 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1628:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 241937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 241940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241948 */     GIR_RootConstrainSelectedInstOperands,
     /* 241949 */     // GIR_Coverage, 8506,
     /* 241949 */     GIR_EraseRootFromParent_Done,
     /* 241950 */   // Label 4644: @241950
     /* 241950 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(241992), // Rule ID 8507 //
     /* 241955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 241963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 241966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 241969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 241972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 241975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241979 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1628:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 241979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 241982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241990 */     GIR_RootConstrainSelectedInstOperands,
     /* 241991 */     // GIR_Coverage, 8507,
     /* 241991 */     GIR_EraseRootFromParent_Done,
     /* 241992 */   // Label 4645: @241992
     /* 241992 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(242034), // Rule ID 8508 //
     /* 241997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 242005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242021 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1624:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 242024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242032 */     GIR_RootConstrainSelectedInstOperands,
     /* 242033 */     // GIR_Coverage, 8508,
     /* 242033 */     GIR_EraseRootFromParent_Done,
     /* 242034 */   // Label 4646: @242034
     /* 242034 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(242076), // Rule ID 8509 //
     /* 242039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 242047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 242050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 242056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 242059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242063 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1624:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 242063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 242066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242074 */     GIR_RootConstrainSelectedInstOperands,
     /* 242075 */     // GIR_Coverage, 8509,
     /* 242075 */     GIR_EraseRootFromParent_Done,
     /* 242076 */   // Label 4647: @242076
     /* 242076 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(242118), // Rule ID 8510 //
     /* 242081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 242089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 242092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 242098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 242101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242105 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1624:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 242105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 242108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242116 */     GIR_RootConstrainSelectedInstOperands,
     /* 242117 */     // GIR_Coverage, 8510,
     /* 242117 */     GIR_EraseRootFromParent_Done,
     /* 242118 */   // Label 4648: @242118
     /* 242118 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(242160), // Rule ID 8511 //
     /* 242123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 242131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 242134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 242140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 242143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242147 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1624:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 242147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 242150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242158 */     GIR_RootConstrainSelectedInstOperands,
     /* 242159 */     // GIR_Coverage, 8511,
     /* 242159 */     GIR_EraseRootFromParent_Done,
     /* 242160 */   // Label 4649: @242160
     /* 242160 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(242202), // Rule ID 8512 //
     /* 242165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 242173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 242176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 242179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 242182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 242185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242189 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1624:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 242189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 242192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242200 */     GIR_RootConstrainSelectedInstOperands,
     /* 242201 */     // GIR_Coverage, 8512,
     /* 242201 */     GIR_EraseRootFromParent_Done,
     /* 242202 */   // Label 4650: @242202
     /* 242202 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(242244), // Rule ID 8513 //
     /* 242207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 242215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242231 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1622:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 242234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242242 */     GIR_RootConstrainSelectedInstOperands,
     /* 242243 */     // GIR_Coverage, 8513,
     /* 242243 */     GIR_EraseRootFromParent_Done,
     /* 242244 */   // Label 4651: @242244
     /* 242244 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(242286), // Rule ID 8514 //
     /* 242249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 242257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 242260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 242266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 242269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242273 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1622:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 242273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 242276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242284 */     GIR_RootConstrainSelectedInstOperands,
     /* 242285 */     // GIR_Coverage, 8514,
     /* 242285 */     GIR_EraseRootFromParent_Done,
     /* 242286 */   // Label 4652: @242286
     /* 242286 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(242328), // Rule ID 8515 //
     /* 242291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 242299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 242302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 242308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 242311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242315 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1622:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 242315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 242318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242326 */     GIR_RootConstrainSelectedInstOperands,
     /* 242327 */     // GIR_Coverage, 8515,
     /* 242327 */     GIR_EraseRootFromParent_Done,
     /* 242328 */   // Label 4653: @242328
     /* 242328 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(242370), // Rule ID 8516 //
     /* 242333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 242341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 242344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 242350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 242353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242357 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1622:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 242357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 242360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242368 */     GIR_RootConstrainSelectedInstOperands,
     /* 242369 */     // GIR_Coverage, 8516,
     /* 242369 */     GIR_EraseRootFromParent_Done,
     /* 242370 */   // Label 4654: @242370
     /* 242370 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(242412), // Rule ID 8517 //
     /* 242375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 242383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 242386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 242389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 242392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 242395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242399 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1622:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 242399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 242402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242410 */     GIR_RootConstrainSelectedInstOperands,
     /* 242411 */     // GIR_Coverage, 8517,
     /* 242411 */     GIR_EraseRootFromParent_Done,
     /* 242412 */   // Label 4655: @242412
     /* 242412 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(242454), // Rule ID 8518 //
     /* 242417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 242425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242441 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1618:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 242444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242452 */     GIR_RootConstrainSelectedInstOperands,
     /* 242453 */     // GIR_Coverage, 8518,
     /* 242453 */     GIR_EraseRootFromParent_Done,
     /* 242454 */   // Label 4656: @242454
     /* 242454 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(242496), // Rule ID 8519 //
     /* 242459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 242467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 242470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 242476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 242479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242483 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1618:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 242483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 242486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242494 */     GIR_RootConstrainSelectedInstOperands,
     /* 242495 */     // GIR_Coverage, 8519,
     /* 242495 */     GIR_EraseRootFromParent_Done,
     /* 242496 */   // Label 4657: @242496
     /* 242496 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(242538), // Rule ID 8520 //
     /* 242501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 242509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 242512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 242518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 242521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242525 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1618:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 242525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 242528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242536 */     GIR_RootConstrainSelectedInstOperands,
     /* 242537 */     // GIR_Coverage, 8520,
     /* 242537 */     GIR_EraseRootFromParent_Done,
     /* 242538 */   // Label 4658: @242538
     /* 242538 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(242580), // Rule ID 8521 //
     /* 242543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 242551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 242554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 242560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 242563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242567 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1618:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 242567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 242570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242578 */     GIR_RootConstrainSelectedInstOperands,
     /* 242579 */     // GIR_Coverage, 8521,
     /* 242579 */     GIR_EraseRootFromParent_Done,
     /* 242580 */   // Label 4659: @242580
     /* 242580 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(242622), // Rule ID 8522 //
     /* 242585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 242593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 242596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 242599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 242602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 242605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242609 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1618:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 242609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 242612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242620 */     GIR_RootConstrainSelectedInstOperands,
     /* 242621 */     // GIR_Coverage, 8522,
     /* 242621 */     GIR_EraseRootFromParent_Done,
     /* 242622 */   // Label 4660: @242622
     /* 242622 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(242664), // Rule ID 8530 //
     /* 242627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242651 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 242654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242662 */     GIR_RootConstrainSelectedInstOperands,
     /* 242663 */     // GIR_Coverage, 8530,
     /* 242663 */     GIR_EraseRootFromParent_Done,
     /* 242664 */   // Label 4661: @242664
     /* 242664 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(242706), // Rule ID 8531 //
     /* 242669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242693 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 242696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242704 */     GIR_RootConstrainSelectedInstOperands,
     /* 242705 */     // GIR_Coverage, 8531,
     /* 242705 */     GIR_EraseRootFromParent_Done,
     /* 242706 */   // Label 4662: @242706
     /* 242706 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(242748), // Rule ID 8532 //
     /* 242711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242735 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 242738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242746 */     GIR_RootConstrainSelectedInstOperands,
     /* 242747 */     // GIR_Coverage, 8532,
     /* 242747 */     GIR_EraseRootFromParent_Done,
     /* 242748 */   // Label 4663: @242748
     /* 242748 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(242790), // Rule ID 8533 //
     /* 242753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1315:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 242780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242788 */     GIR_RootConstrainSelectedInstOperands,
     /* 242789 */     // GIR_Coverage, 8533,
     /* 242789 */     GIR_EraseRootFromParent_Done,
     /* 242790 */   // Label 4664: @242790
     /* 242790 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(242832), // Rule ID 8534 //
     /* 242795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242819 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 242822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242830 */     GIR_RootConstrainSelectedInstOperands,
     /* 242831 */     // GIR_Coverage, 8534,
     /* 242831 */     GIR_EraseRootFromParent_Done,
     /* 242832 */   // Label 4665: @242832
     /* 242832 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(242874), // Rule ID 8535 //
     /* 242837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242861 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 242864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242872 */     GIR_RootConstrainSelectedInstOperands,
     /* 242873 */     // GIR_Coverage, 8535,
     /* 242873 */     GIR_EraseRootFromParent_Done,
     /* 242874 */   // Label 4666: @242874
     /* 242874 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(242916), // Rule ID 8536 //
     /* 242879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242903 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1315:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 242906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242914 */     GIR_RootConstrainSelectedInstOperands,
     /* 242915 */     // GIR_Coverage, 8536,
     /* 242915 */     GIR_EraseRootFromParent_Done,
     /* 242916 */   // Label 4667: @242916
     /* 242916 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(242961), // Rule ID 9232 //
     /* 242921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 242929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 242945 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1336:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 242948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 242959 */     GIR_RootConstrainSelectedInstOperands,
     /* 242960 */     // GIR_Coverage, 9232,
     /* 242960 */     GIR_EraseRootFromParent_Done,
     /* 242961 */   // Label 4668: @242961
     /* 242961 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(243006), // Rule ID 9233 //
     /* 242966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 242974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 242977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 242990 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 242993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243004 */     GIR_RootConstrainSelectedInstOperands,
     /* 243005 */     // GIR_Coverage, 9233,
     /* 243005 */     GIR_EraseRootFromParent_Done,
     /* 243006 */   // Label 4669: @243006
     /* 243006 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(243051), // Rule ID 9234 //
     /* 243011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 243019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243035 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 243038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243049 */     GIR_RootConstrainSelectedInstOperands,
     /* 243050 */     // GIR_Coverage, 9234,
     /* 243050 */     GIR_EraseRootFromParent_Done,
     /* 243051 */   // Label 4670: @243051
     /* 243051 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(243096), // Rule ID 9235 //
     /* 243056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 243064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243080 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1326:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 243083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243094 */     GIR_RootConstrainSelectedInstOperands,
     /* 243095 */     // GIR_Coverage, 9235,
     /* 243095 */     GIR_EraseRootFromParent_Done,
     /* 243096 */   // Label 4671: @243096
     /* 243096 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(243141), // Rule ID 9236 //
     /* 243101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 243109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243125 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1326:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 243128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243139 */     GIR_RootConstrainSelectedInstOperands,
     /* 243140 */     // GIR_Coverage, 9236,
     /* 243140 */     GIR_EraseRootFromParent_Done,
     /* 243141 */   // Label 4672: @243141
     /* 243141 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(243186), // Rule ID 9237 //
     /* 243146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 243154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243170 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1326:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 243173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243184 */     GIR_RootConstrainSelectedInstOperands,
     /* 243185 */     // GIR_Coverage, 9237,
     /* 243185 */     GIR_EraseRootFromParent_Done,
     /* 243186 */   // Label 4673: @243186
     /* 243186 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(243231), // Rule ID 9238 //
     /* 243191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 243199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243215 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1334:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 243218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243229 */     GIR_RootConstrainSelectedInstOperands,
     /* 243230 */     // GIR_Coverage, 9238,
     /* 243230 */     GIR_EraseRootFromParent_Done,
     /* 243231 */   // Label 4674: @243231
     /* 243231 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(243276), // Rule ID 9239 //
     /* 243236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 243244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243260 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1334:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 243263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243274 */     GIR_RootConstrainSelectedInstOperands,
     /* 243275 */     // GIR_Coverage, 9239,
     /* 243275 */     GIR_EraseRootFromParent_Done,
     /* 243276 */   // Label 4675: @243276
     /* 243276 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(243321), // Rule ID 9240 //
     /* 243281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 243289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243305 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1334:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 243308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243319 */     GIR_RootConstrainSelectedInstOperands,
     /* 243320 */     // GIR_Coverage, 9240,
     /* 243320 */     GIR_EraseRootFromParent_Done,
     /* 243321 */   // Label 4676: @243321
     /* 243321 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(243366), // Rule ID 9241 //
     /* 243326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 243334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243350 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1331:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 243353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243364 */     GIR_RootConstrainSelectedInstOperands,
     /* 243365 */     // GIR_Coverage, 9241,
     /* 243365 */     GIR_EraseRootFromParent_Done,
     /* 243366 */   // Label 4677: @243366
     /* 243366 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(243411), // Rule ID 9242 //
     /* 243371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 243379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243395 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1331:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 243398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243409 */     GIR_RootConstrainSelectedInstOperands,
     /* 243410 */     // GIR_Coverage, 9242,
     /* 243410 */     GIR_EraseRootFromParent_Done,
     /* 243411 */   // Label 4678: @243411
     /* 243411 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(243456), // Rule ID 9243 //
     /* 243416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 243424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243440 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1331:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 243443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243454 */     GIR_RootConstrainSelectedInstOperands,
     /* 243455 */     // GIR_Coverage, 9243,
     /* 243455 */     GIR_EraseRootFromParent_Done,
     /* 243456 */   // Label 4679: @243456
     /* 243456 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(243501), // Rule ID 9244 //
     /* 243461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 243469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243485 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1330:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 243488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243499 */     GIR_RootConstrainSelectedInstOperands,
     /* 243500 */     // GIR_Coverage, 9244,
     /* 243500 */     GIR_EraseRootFromParent_Done,
     /* 243501 */   // Label 4680: @243501
     /* 243501 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(243546), // Rule ID 9245 //
     /* 243506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 243514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243530 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1330:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 243533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243544 */     GIR_RootConstrainSelectedInstOperands,
     /* 243545 */     // GIR_Coverage, 9245,
     /* 243545 */     GIR_EraseRootFromParent_Done,
     /* 243546 */   // Label 4681: @243546
     /* 243546 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(243591), // Rule ID 9246 //
     /* 243551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 243559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243575 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1330:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 243578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243589 */     GIR_RootConstrainSelectedInstOperands,
     /* 243590 */     // GIR_Coverage, 9246,
     /* 243590 */     GIR_EraseRootFromParent_Done,
     /* 243591 */   // Label 4682: @243591
     /* 243591 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(243636), // Rule ID 9247 //
     /* 243596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 243604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243620 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1328:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 243623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243634 */     GIR_RootConstrainSelectedInstOperands,
     /* 243635 */     // GIR_Coverage, 9247,
     /* 243635 */     GIR_EraseRootFromParent_Done,
     /* 243636 */   // Label 4683: @243636
     /* 243636 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(243681), // Rule ID 9248 //
     /* 243641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 243649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243665 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1328:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 243668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243679 */     GIR_RootConstrainSelectedInstOperands,
     /* 243680 */     // GIR_Coverage, 9248,
     /* 243680 */     GIR_EraseRootFromParent_Done,
     /* 243681 */   // Label 4684: @243681
     /* 243681 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(243726), // Rule ID 9249 //
     /* 243686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 243694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243710 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1328:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 243713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243724 */     GIR_RootConstrainSelectedInstOperands,
     /* 243725 */     // GIR_Coverage, 9249,
     /* 243725 */     GIR_EraseRootFromParent_Done,
     /* 243726 */   // Label 4685: @243726
     /* 243726 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(243771), // Rule ID 9250 //
     /* 243731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 243739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243755 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1332:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 243758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243769 */     GIR_RootConstrainSelectedInstOperands,
     /* 243770 */     // GIR_Coverage, 9250,
     /* 243770 */     GIR_EraseRootFromParent_Done,
     /* 243771 */   // Label 4686: @243771
     /* 243771 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(243816), // Rule ID 9251 //
     /* 243776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 243784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243800 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1332:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 243803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243814 */     GIR_RootConstrainSelectedInstOperands,
     /* 243815 */     // GIR_Coverage, 9251,
     /* 243815 */     GIR_EraseRootFromParent_Done,
     /* 243816 */   // Label 4687: @243816
     /* 243816 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(243861), // Rule ID 9252 //
     /* 243821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 243829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243845 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1332:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 243848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243859 */     GIR_RootConstrainSelectedInstOperands,
     /* 243860 */     // GIR_Coverage, 9252,
     /* 243860 */     GIR_EraseRootFromParent_Done,
     /* 243861 */   // Label 4688: @243861
     /* 243861 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(243906), // Rule ID 9253 //
     /* 243866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 243874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243890 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1333:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 243893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243904 */     GIR_RootConstrainSelectedInstOperands,
     /* 243905 */     // GIR_Coverage, 9253,
     /* 243905 */     GIR_EraseRootFromParent_Done,
     /* 243906 */   // Label 4689: @243906
     /* 243906 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(243951), // Rule ID 9254 //
     /* 243911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 243919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243935 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1333:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 243938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243949 */     GIR_RootConstrainSelectedInstOperands,
     /* 243950 */     // GIR_Coverage, 9254,
     /* 243950 */     GIR_EraseRootFromParent_Done,
     /* 243951 */   // Label 4690: @243951
     /* 243951 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(243996), // Rule ID 9255 //
     /* 243956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 243964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243980 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1333:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 243983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243994 */     GIR_RootConstrainSelectedInstOperands,
     /* 243995 */     // GIR_Coverage, 9255,
     /* 243995 */     GIR_EraseRootFromParent_Done,
     /* 243996 */   // Label 4691: @243996
     /* 243996 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(244038), // Rule ID 9652 //
     /* 244001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 244009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244025 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 244028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244036 */     GIR_RootConstrainSelectedInstOperands,
     /* 244037 */     // GIR_Coverage, 9652,
     /* 244037 */     GIR_EraseRootFromParent_Done,
     /* 244038 */   // Label 4692: @244038
     /* 244038 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(244080), // Rule ID 9653 //
     /* 244043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 244051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244067 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 244070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244078 */     GIR_RootConstrainSelectedInstOperands,
     /* 244079 */     // GIR_Coverage, 9653,
     /* 244079 */     GIR_EraseRootFromParent_Done,
     /* 244080 */   // Label 4693: @244080
     /* 244080 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(244122), // Rule ID 9654 //
     /* 244085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 244093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 244096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244109 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 244112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244120 */     GIR_RootConstrainSelectedInstOperands,
     /* 244121 */     // GIR_Coverage, 9654,
     /* 244121 */     GIR_EraseRootFromParent_Done,
     /* 244122 */   // Label 4694: @244122
     /* 244122 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(244164), // Rule ID 10192 //
     /* 244127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 244135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244151 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 244151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 244154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244162 */     GIR_RootConstrainSelectedInstOperands,
     /* 244163 */     // GIR_Coverage, 10192,
     /* 244163 */     GIR_EraseRootFromParent_Done,
     /* 244164 */   // Label 4695: @244164
     /* 244164 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(244206), // Rule ID 10193 //
     /* 244169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 244177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 244193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 244196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244204 */     GIR_RootConstrainSelectedInstOperands,
     /* 244205 */     // GIR_Coverage, 10193,
     /* 244205 */     GIR_EraseRootFromParent_Done,
     /* 244206 */   // Label 4696: @244206
     /* 244206 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(244248), // Rule ID 10194 //
     /* 244211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 244219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244235 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 244238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244246 */     GIR_RootConstrainSelectedInstOperands,
     /* 244247 */     // GIR_Coverage, 10194,
     /* 244247 */     GIR_EraseRootFromParent_Done,
     /* 244248 */   // Label 4697: @244248
     /* 244248 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(244290), // Rule ID 10195 //
     /* 244253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 244261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 244280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244288 */     GIR_RootConstrainSelectedInstOperands,
     /* 244289 */     // GIR_Coverage, 10195,
     /* 244289 */     GIR_EraseRootFromParent_Done,
     /* 244290 */   // Label 4698: @244290
     /* 244290 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(244332), // Rule ID 10196 //
     /* 244295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 244303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244319 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1597:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 244319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 244322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244330 */     GIR_RootConstrainSelectedInstOperands,
     /* 244331 */     // GIR_Coverage, 10196,
     /* 244331 */     GIR_EraseRootFromParent_Done,
     /* 244332 */   // Label 4699: @244332
     /* 244332 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(244374), // Rule ID 10197 //
     /* 244337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 244345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 244361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 244364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244372 */     GIR_RootConstrainSelectedInstOperands,
     /* 244373 */     // GIR_Coverage, 10197,
     /* 244373 */     GIR_EraseRootFromParent_Done,
     /* 244374 */   // Label 4700: @244374
     /* 244374 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(244416), // Rule ID 10198 //
     /* 244379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 244387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244403 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1597:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 244406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244414 */     GIR_RootConstrainSelectedInstOperands,
     /* 244415 */     // GIR_Coverage, 10198,
     /* 244415 */     GIR_EraseRootFromParent_Done,
     /* 244416 */   // Label 4701: @244416
     /* 244416 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(244458), // Rule ID 10199 //
     /* 244421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 244429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244445 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1597:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 244448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244456 */     GIR_RootConstrainSelectedInstOperands,
     /* 244457 */     // GIR_Coverage, 10199,
     /* 244457 */     GIR_EraseRootFromParent_Done,
     /* 244458 */   // Label 4702: @244458
     /* 244458 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(244500), // Rule ID 10212 //
     /* 244463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 244471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244487 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 244490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244498 */     GIR_RootConstrainSelectedInstOperands,
     /* 244499 */     // GIR_Coverage, 10212,
     /* 244499 */     GIR_EraseRootFromParent_Done,
     /* 244500 */   // Label 4703: @244500
     /* 244500 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(244542), // Rule ID 10213 //
     /* 244505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 244513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244529 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 244532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244540 */     GIR_RootConstrainSelectedInstOperands,
     /* 244541 */     // GIR_Coverage, 10213,
     /* 244541 */     GIR_EraseRootFromParent_Done,
     /* 244542 */   // Label 4704: @244542
     /* 244542 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(244584), // Rule ID 10214 //
     /* 244547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 244555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 244574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244582 */     GIR_RootConstrainSelectedInstOperands,
     /* 244583 */     // GIR_Coverage, 10214,
     /* 244583 */     GIR_EraseRootFromParent_Done,
     /* 244584 */   // Label 4705: @244584
     /* 244584 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(244626), // Rule ID 10215 //
     /* 244589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 244597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244613 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1599:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 244616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244624 */     GIR_RootConstrainSelectedInstOperands,
     /* 244625 */     // GIR_Coverage, 10215,
     /* 244625 */     GIR_EraseRootFromParent_Done,
     /* 244626 */   // Label 4706: @244626
     /* 244626 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(244668), // Rule ID 10216 //
     /* 244631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 244639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244655 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1599:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 244658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244666 */     GIR_RootConstrainSelectedInstOperands,
     /* 244667 */     // GIR_Coverage, 10216,
     /* 244667 */     GIR_EraseRootFromParent_Done,
     /* 244668 */   // Label 4707: @244668
     /* 244668 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(244710), // Rule ID 10217 //
     /* 244673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 244681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1599:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 244700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244708 */     GIR_RootConstrainSelectedInstOperands,
     /* 244709 */     // GIR_Coverage, 10217,
     /* 244709 */     GIR_EraseRootFromParent_Done,
     /* 244710 */   // Label 4708: @244710
     /* 244710 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(244752), // Rule ID 10244 //
     /* 244715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 244723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244739 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1394:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 244742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244750 */     GIR_RootConstrainSelectedInstOperands,
     /* 244751 */     // GIR_Coverage, 10244,
     /* 244751 */     GIR_EraseRootFromParent_Done,
     /* 244752 */   // Label 4709: @244752
     /* 244752 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(244794), // Rule ID 10248 //
     /* 244757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 244765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244781 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1397:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 244784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244792 */     GIR_RootConstrainSelectedInstOperands,
     /* 244793 */     // GIR_Coverage, 10248,
     /* 244793 */     GIR_EraseRootFromParent_Done,
     /* 244794 */   // Label 4710: @244794
     /* 244794 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(244836), // Rule ID 10252 //
     /* 244799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 244807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244823 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1396:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 244826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244834 */     GIR_RootConstrainSelectedInstOperands,
     /* 244835 */     // GIR_Coverage, 10252,
     /* 244835 */     GIR_EraseRootFromParent_Done,
     /* 244836 */   // Label 4711: @244836
     /* 244836 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(244878), // Rule ID 10256 //
     /* 244841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 244849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244865 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1398:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 244868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244876 */     GIR_RootConstrainSelectedInstOperands,
     /* 244877 */     // GIR_Coverage, 10256,
     /* 244877 */     GIR_EraseRootFromParent_Done,
     /* 244878 */   // Label 4712: @244878
     /* 244878 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(244920), // Rule ID 10260 //
     /* 244883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 244891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244907 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1710:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 244910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244918 */     GIR_RootConstrainSelectedInstOperands,
     /* 244919 */     // GIR_Coverage, 10260,
     /* 244919 */     GIR_EraseRootFromParent_Done,
     /* 244920 */   // Label 4713: @244920
     /* 244920 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(244962), // Rule ID 10261 //
     /* 244925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 244933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244949 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1957:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 244952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244960 */     GIR_RootConstrainSelectedInstOperands,
     /* 244961 */     // GIR_Coverage, 10261,
     /* 244961 */     GIR_EraseRootFromParent_Done,
     /* 244962 */   // Label 4714: @244962
     /* 244962 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(245004), // Rule ID 10262 //
     /* 244967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 244975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 244984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244991 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1954:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 244994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245002 */     GIR_RootConstrainSelectedInstOperands,
     /* 245003 */     // GIR_Coverage, 10262,
     /* 245003 */     GIR_EraseRootFromParent_Done,
     /* 245004 */   // Label 4715: @245004
     /* 245004 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(245046), // Rule ID 10266 //
     /* 245009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 245017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245033 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1709:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 245036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245044 */     GIR_RootConstrainSelectedInstOperands,
     /* 245045 */     // GIR_Coverage, 10266,
     /* 245045 */     GIR_EraseRootFromParent_Done,
     /* 245046 */   // Label 4716: @245046
     /* 245046 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(245088), // Rule ID 10270 //
     /* 245051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 245059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245075 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1707:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 245078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245086 */     GIR_RootConstrainSelectedInstOperands,
     /* 245087 */     // GIR_Coverage, 10270,
     /* 245087 */     GIR_EraseRootFromParent_Done,
     /* 245088 */   // Label 4717: @245088
     /* 245088 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(245130), // Rule ID 10274 //
     /* 245093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 245101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245117 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1708:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 245120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245128 */     GIR_RootConstrainSelectedInstOperands,
     /* 245129 */     // GIR_Coverage, 10274,
     /* 245129 */     GIR_EraseRootFromParent_Done,
     /* 245130 */   // Label 4718: @245130
     /* 245130 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(245172), // Rule ID 10278 //
     /* 245135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 245143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245159 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1956:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 245162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245170 */     GIR_RootConstrainSelectedInstOperands,
     /* 245171 */     // GIR_Coverage, 10278,
     /* 245171 */     GIR_EraseRootFromParent_Done,
     /* 245172 */   // Label 4719: @245172
     /* 245172 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(245214), // Rule ID 10282 //
     /* 245177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 245185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245201 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1955:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 245204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245212 */     GIR_RootConstrainSelectedInstOperands,
     /* 245213 */     // GIR_Coverage, 10282,
     /* 245213 */     GIR_EraseRootFromParent_Done,
     /* 245214 */   // Label 4720: @245214
     /* 245214 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(245256), // Rule ID 10292 //
     /* 245219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 245227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245243 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1412:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 245246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245254 */     GIR_RootConstrainSelectedInstOperands,
     /* 245255 */     // GIR_Coverage, 10292,
     /* 245255 */     GIR_EraseRootFromParent_Done,
     /* 245256 */   // Label 4721: @245256
     /* 245256 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(245298), // Rule ID 10293 //
     /* 245261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 245269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245285 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1419:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 245288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245296 */     GIR_RootConstrainSelectedInstOperands,
     /* 245297 */     // GIR_Coverage, 10293,
     /* 245297 */     GIR_EraseRootFromParent_Done,
     /* 245298 */   // Label 4722: @245298
     /* 245298 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(245340), // Rule ID 10294 //
     /* 245303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 245311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245327 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1414:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 245330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245338 */     GIR_RootConstrainSelectedInstOperands,
     /* 245339 */     // GIR_Coverage, 10294,
     /* 245339 */     GIR_EraseRootFromParent_Done,
     /* 245340 */   // Label 4723: @245340
     /* 245340 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(245382), // Rule ID 10298 //
     /* 245345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 245353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245369 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1411:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 245372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245380 */     GIR_RootConstrainSelectedInstOperands,
     /* 245381 */     // GIR_Coverage, 10298,
     /* 245381 */     GIR_EraseRootFromParent_Done,
     /* 245382 */   // Label 4724: @245382
     /* 245382 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(245424), // Rule ID 10302 //
     /* 245387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 245395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245411 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1413:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 245414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245422 */     GIR_RootConstrainSelectedInstOperands,
     /* 245423 */     // GIR_Coverage, 10302,
     /* 245423 */     GIR_EraseRootFromParent_Done,
     /* 245424 */   // Label 4725: @245424
     /* 245424 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(245466), // Rule ID 10306 //
     /* 245429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 245437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245453 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1418:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 245456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245464 */     GIR_RootConstrainSelectedInstOperands,
     /* 245465 */     // GIR_Coverage, 10306,
     /* 245465 */     GIR_EraseRootFromParent_Done,
     /* 245466 */   // Label 4726: @245466
     /* 245466 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(245508), // Rule ID 10310 //
     /* 245471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 245479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245495 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1420:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 245498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245506 */     GIR_RootConstrainSelectedInstOperands,
     /* 245507 */     // GIR_Coverage, 10310,
     /* 245507 */     GIR_EraseRootFromParent_Done,
     /* 245508 */   // Label 4727: @245508
     /* 245508 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(245550), // Rule ID 10314 //
     /* 245513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 245521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245537 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1421:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 245540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245548 */     GIR_RootConstrainSelectedInstOperands,
     /* 245549 */     // GIR_Coverage, 10314,
     /* 245549 */     GIR_EraseRootFromParent_Done,
     /* 245550 */   // Label 4728: @245550
     /* 245550 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(245592), // Rule ID 11311 //
     /* 245555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 245558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 245563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245579 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 245582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245590 */     GIR_RootConstrainSelectedInstOperands,
     /* 245591 */     // GIR_Coverage, 11311,
     /* 245591 */     GIR_EraseRootFromParent_Done,
     /* 245592 */   // Label 4729: @245592
     /* 245592 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(245634), // Rule ID 11312 //
     /* 245597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 245600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 245605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245621 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2067:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 245624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245632 */     GIR_RootConstrainSelectedInstOperands,
     /* 245633 */     // GIR_Coverage, 11312,
     /* 245633 */     GIR_EraseRootFromParent_Done,
     /* 245634 */   // Label 4730: @245634
     /* 245634 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(245676), // Rule ID 11314 //
     /* 245639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 245642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 245647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245663 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1482:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 245666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245674 */     GIR_RootConstrainSelectedInstOperands,
     /* 245675 */     // GIR_Coverage, 11314,
     /* 245675 */     GIR_EraseRootFromParent_Done,
     /* 245676 */   // Label 4731: @245676
     /* 245676 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(245718), // Rule ID 11315 //
     /* 245681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 245684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 245689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245705 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1482:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 245708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245716 */     GIR_RootConstrainSelectedInstOperands,
     /* 245717 */     // GIR_Coverage, 11315,
     /* 245717 */     GIR_EraseRootFromParent_Done,
     /* 245718 */   // Label 4732: @245718
     /* 245718 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(245760), // Rule ID 11369 //
     /* 245723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 245731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 245737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245747 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1831:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 245750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245758 */     GIR_RootConstrainSelectedInstOperands,
     /* 245759 */     // GIR_Coverage, 11369,
     /* 245759 */     GIR_EraseRootFromParent_Done,
     /* 245760 */   // Label 4733: @245760
     /* 245760 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(245802), // Rule ID 11370 //
     /* 245765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 245773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245789 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1831:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 245789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 245792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245800 */     GIR_RootConstrainSelectedInstOperands,
     /* 245801 */     // GIR_Coverage, 11370,
     /* 245801 */     GIR_EraseRootFromParent_Done,
     /* 245802 */   // Label 4734: @245802
     /* 245802 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(245844), // Rule ID 11371 //
     /* 245807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 245815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1831:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 245834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245842 */     GIR_RootConstrainSelectedInstOperands,
     /* 245843 */     // GIR_Coverage, 11371,
     /* 245843 */     GIR_EraseRootFromParent_Done,
     /* 245844 */   // Label 4735: @245844
     /* 245844 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(245886), // Rule ID 11372 //
     /* 245849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 245857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245873 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1831:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 245876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245884 */     GIR_RootConstrainSelectedInstOperands,
     /* 245885 */     // GIR_Coverage, 11372,
     /* 245885 */     GIR_EraseRootFromParent_Done,
     /* 245886 */   // Label 4736: @245886
     /* 245886 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(245928), // Rule ID 11425 //
     /* 245891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 245899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245915 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 245918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245926 */     GIR_RootConstrainSelectedInstOperands,
     /* 245927 */     // GIR_Coverage, 11425,
     /* 245927 */     GIR_EraseRootFromParent_Done,
     /* 245928 */   // Label 4737: @245928
     /* 245928 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(245970), // Rule ID 11426 //
     /* 245933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 245941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245957 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 245957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 245960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245968 */     GIR_RootConstrainSelectedInstOperands,
     /* 245969 */     // GIR_Coverage, 11426,
     /* 245969 */     GIR_EraseRootFromParent_Done,
     /* 245970 */   // Label 4738: @245970
     /* 245970 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(246012), // Rule ID 11427 //
     /* 245975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 245983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245999 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 246002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246010 */     GIR_RootConstrainSelectedInstOperands,
     /* 246011 */     // GIR_Coverage, 11427,
     /* 246011 */     GIR_EraseRootFromParent_Done,
     /* 246012 */   // Label 4739: @246012
     /* 246012 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(246054), // Rule ID 11428 //
     /* 246017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 246025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246041 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1988:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 246044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246052 */     GIR_RootConstrainSelectedInstOperands,
     /* 246053 */     // GIR_Coverage, 11428,
     /* 246053 */     GIR_EraseRootFromParent_Done,
     /* 246054 */   // Label 4740: @246054
     /* 246054 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(246096), // Rule ID 11429 //
     /* 246059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 246067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 246086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246094 */     GIR_RootConstrainSelectedInstOperands,
     /* 246095 */     // GIR_Coverage, 11429,
     /* 246095 */     GIR_EraseRootFromParent_Done,
     /* 246096 */   // Label 4741: @246096
     /* 246096 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(246138), // Rule ID 11430 //
     /* 246101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 246109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246125 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 246128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246136 */     GIR_RootConstrainSelectedInstOperands,
     /* 246137 */     // GIR_Coverage, 11430,
     /* 246137 */     GIR_EraseRootFromParent_Done,
     /* 246138 */   // Label 4742: @246138
     /* 246138 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(246180), // Rule ID 11431 //
     /* 246143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 246151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246167 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1990:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 246170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246178 */     GIR_RootConstrainSelectedInstOperands,
     /* 246179 */     // GIR_Coverage, 11431,
     /* 246179 */     GIR_EraseRootFromParent_Done,
     /* 246180 */   // Label 4743: @246180
     /* 246180 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(246222), // Rule ID 11432 //
     /* 246185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 246193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246209 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1990:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 246212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246220 */     GIR_RootConstrainSelectedInstOperands,
     /* 246221 */     // GIR_Coverage, 11432,
     /* 246221 */     GIR_EraseRootFromParent_Done,
     /* 246222 */   // Label 4744: @246222
     /* 246222 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(246264), // Rule ID 11433 //
     /* 246227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 246235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 246254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246262 */     GIR_RootConstrainSelectedInstOperands,
     /* 246263 */     // GIR_Coverage, 11433,
     /* 246263 */     GIR_EraseRootFromParent_Done,
     /* 246264 */   // Label 4745: @246264
     /* 246264 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(246306), // Rule ID 11434 //
     /* 246269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 246277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1754:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 246296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246304 */     GIR_RootConstrainSelectedInstOperands,
     /* 246305 */     // GIR_Coverage, 11434,
     /* 246305 */     GIR_EraseRootFromParent_Done,
     /* 246306 */   // Label 4746: @246306
     /* 246306 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(246348), // Rule ID 11435 //
     /* 246311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 246319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246335 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 246338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246346 */     GIR_RootConstrainSelectedInstOperands,
     /* 246347 */     // GIR_Coverage, 11435,
     /* 246347 */     GIR_EraseRootFromParent_Done,
     /* 246348 */   // Label 4747: @246348
     /* 246348 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(246390), // Rule ID 11436 //
     /* 246353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 246361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 246380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246386 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246388 */     GIR_RootConstrainSelectedInstOperands,
     /* 246389 */     // GIR_Coverage, 11436,
     /* 246389 */     GIR_EraseRootFromParent_Done,
     /* 246390 */   // Label 4748: @246390
     /* 246390 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(246432), // Rule ID 11437 //
     /* 246395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 246403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246419 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 246422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246430 */     GIR_RootConstrainSelectedInstOperands,
     /* 246431 */     // GIR_Coverage, 11437,
     /* 246431 */     GIR_EraseRootFromParent_Done,
     /* 246432 */   // Label 4749: @246432
     /* 246432 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(246474), // Rule ID 11438 //
     /* 246437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 246445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246461 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 246464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246472 */     GIR_RootConstrainSelectedInstOperands,
     /* 246473 */     // GIR_Coverage, 11438,
     /* 246473 */     GIR_EraseRootFromParent_Done,
     /* 246474 */   // Label 4750: @246474
     /* 246474 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(246516), // Rule ID 11439 //
     /* 246479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 246487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246503 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 246506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246512 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246514 */     GIR_RootConstrainSelectedInstOperands,
     /* 246515 */     // GIR_Coverage, 11439,
     /* 246515 */     GIR_EraseRootFromParent_Done,
     /* 246516 */   // Label 4751: @246516
     /* 246516 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(246558), // Rule ID 11440 //
     /* 246521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 246529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246545 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1992:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 246548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246556 */     GIR_RootConstrainSelectedInstOperands,
     /* 246557 */     // GIR_Coverage, 11440,
     /* 246557 */     GIR_EraseRootFromParent_Done,
     /* 246558 */   // Label 4752: @246558
     /* 246558 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(246600), // Rule ID 11441 //
     /* 246563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 246571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 246590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246598 */     GIR_RootConstrainSelectedInstOperands,
     /* 246599 */     // GIR_Coverage, 11441,
     /* 246599 */     GIR_EraseRootFromParent_Done,
     /* 246600 */   // Label 4753: @246600
     /* 246600 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(246642), // Rule ID 11442 //
     /* 246605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 246613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246629 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 246632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246640 */     GIR_RootConstrainSelectedInstOperands,
     /* 246641 */     // GIR_Coverage, 11442,
     /* 246641 */     GIR_EraseRootFromParent_Done,
     /* 246642 */   // Label 4754: @246642
     /* 246642 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(246684), // Rule ID 11443 //
     /* 246647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 246655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 246674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246682 */     GIR_RootConstrainSelectedInstOperands,
     /* 246683 */     // GIR_Coverage, 11443,
     /* 246683 */     GIR_EraseRootFromParent_Done,
     /* 246684 */   // Label 4755: @246684
     /* 246684 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(246726), // Rule ID 11444 //
     /* 246689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 246697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246713 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 246716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246724 */     GIR_RootConstrainSelectedInstOperands,
     /* 246725 */     // GIR_Coverage, 11444,
     /* 246725 */     GIR_EraseRootFromParent_Done,
     /* 246726 */   // Label 4756: @246726
     /* 246726 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(246768), // Rule ID 11445 //
     /* 246731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 246739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 246758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246766 */     GIR_RootConstrainSelectedInstOperands,
     /* 246767 */     // GIR_Coverage, 11445,
     /* 246767 */     GIR_EraseRootFromParent_Done,
     /* 246768 */   // Label 4757: @246768
     /* 246768 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(246810), // Rule ID 11454 //
     /* 246773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 246781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246797 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1792:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 246800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246808 */     GIR_RootConstrainSelectedInstOperands,
     /* 246809 */     // GIR_Coverage, 11454,
     /* 246809 */     GIR_EraseRootFromParent_Done,
     /* 246810 */   // Label 4758: @246810
     /* 246810 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(246852), // Rule ID 11455 //
     /* 246815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 246823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 246842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246850 */     GIR_RootConstrainSelectedInstOperands,
     /* 246851 */     // GIR_Coverage, 11455,
     /* 246851 */     GIR_EraseRootFromParent_Done,
     /* 246852 */   // Label 4759: @246852
     /* 246852 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(246894), // Rule ID 11456 //
     /* 246857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 246865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246881 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1792:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 246884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246892 */     GIR_RootConstrainSelectedInstOperands,
     /* 246893 */     // GIR_Coverage, 11456,
     /* 246893 */     GIR_EraseRootFromParent_Done,
     /* 246894 */   // Label 4760: @246894
     /* 246894 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(246936), // Rule ID 11457 //
     /* 246899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 246907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246923 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 246926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246934 */     GIR_RootConstrainSelectedInstOperands,
     /* 246935 */     // GIR_Coverage, 11457,
     /* 246935 */     GIR_EraseRootFromParent_Done,
     /* 246936 */   // Label 4761: @246936
     /* 246936 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(246978), // Rule ID 11458 //
     /* 246941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 246949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246965 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 246968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246976 */     GIR_RootConstrainSelectedInstOperands,
     /* 246977 */     // GIR_Coverage, 11458,
     /* 246977 */     GIR_EraseRootFromParent_Done,
     /* 246978 */   // Label 4762: @246978
     /* 246978 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(247020), // Rule ID 11459 //
     /* 246983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 246991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247007 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 247010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247018 */     GIR_RootConstrainSelectedInstOperands,
     /* 247019 */     // GIR_Coverage, 11459,
     /* 247019 */     GIR_EraseRootFromParent_Done,
     /* 247020 */   // Label 4763: @247020
     /* 247020 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(247062), // Rule ID 11460 //
     /* 247025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 247033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247049 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1797:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 247052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247060 */     GIR_RootConstrainSelectedInstOperands,
     /* 247061 */     // GIR_Coverage, 11460,
     /* 247061 */     GIR_EraseRootFromParent_Done,
     /* 247062 */   // Label 4764: @247062
     /* 247062 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(247104), // Rule ID 11461 //
     /* 247067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 247075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247091 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1797:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 247094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247102 */     GIR_RootConstrainSelectedInstOperands,
     /* 247103 */     // GIR_Coverage, 11461,
     /* 247103 */     GIR_EraseRootFromParent_Done,
     /* 247104 */   // Label 4765: @247104
     /* 247104 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(247146), // Rule ID 11462 //
     /* 247109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 247117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247133 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1797:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 247136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247144 */     GIR_RootConstrainSelectedInstOperands,
     /* 247145 */     // GIR_Coverage, 11462,
     /* 247145 */     GIR_EraseRootFromParent_Done,
     /* 247146 */   // Label 4766: @247146
     /* 247146 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(247188), // Rule ID 11463 //
     /* 247151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 247159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247175 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1800:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 247178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247186 */     GIR_RootConstrainSelectedInstOperands,
     /* 247187 */     // GIR_Coverage, 11463,
     /* 247187 */     GIR_EraseRootFromParent_Done,
     /* 247188 */   // Label 4767: @247188
     /* 247188 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(247230), // Rule ID 11464 //
     /* 247193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 247201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247217 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1800:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 247220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247228 */     GIR_RootConstrainSelectedInstOperands,
     /* 247229 */     // GIR_Coverage, 11464,
     /* 247229 */     GIR_EraseRootFromParent_Done,
     /* 247230 */   // Label 4768: @247230
     /* 247230 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(247272), // Rule ID 11465 //
     /* 247235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 247243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247259 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1800:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 247262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247270 */     GIR_RootConstrainSelectedInstOperands,
     /* 247271 */     // GIR_Coverage, 11465,
     /* 247271 */     GIR_EraseRootFromParent_Done,
     /* 247272 */   // Label 4769: @247272
     /* 247272 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(247314), // Rule ID 11466 //
     /* 247277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 247285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247301 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1794:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 247304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247312 */     GIR_RootConstrainSelectedInstOperands,
     /* 247313 */     // GIR_Coverage, 11466,
     /* 247313 */     GIR_EraseRootFromParent_Done,
     /* 247314 */   // Label 4770: @247314
     /* 247314 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(247356), // Rule ID 11467 //
     /* 247319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 247327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1794:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 247346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247354 */     GIR_RootConstrainSelectedInstOperands,
     /* 247355 */     // GIR_Coverage, 11467,
     /* 247355 */     GIR_EraseRootFromParent_Done,
     /* 247356 */   // Label 4771: @247356
     /* 247356 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(247398), // Rule ID 11468 //
     /* 247361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 247369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247385 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1794:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 247388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247396 */     GIR_RootConstrainSelectedInstOperands,
     /* 247397 */     // GIR_Coverage, 11468,
     /* 247397 */     GIR_EraseRootFromParent_Done,
     /* 247398 */   // Label 4772: @247398
     /* 247398 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(247440), // Rule ID 11469 //
     /* 247403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 247411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247427 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1799:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 247430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247438 */     GIR_RootConstrainSelectedInstOperands,
     /* 247439 */     // GIR_Coverage, 11469,
     /* 247439 */     GIR_EraseRootFromParent_Done,
     /* 247440 */   // Label 4773: @247440
     /* 247440 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(247482), // Rule ID 11470 //
     /* 247445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 247453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247469 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 247472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247480 */     GIR_RootConstrainSelectedInstOperands,
     /* 247481 */     // GIR_Coverage, 11470,
     /* 247481 */     GIR_EraseRootFromParent_Done,
     /* 247482 */   // Label 4774: @247482
     /* 247482 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(247524), // Rule ID 11471 //
     /* 247487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 247495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 247514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247522 */     GIR_RootConstrainSelectedInstOperands,
     /* 247523 */     // GIR_Coverage, 11471,
     /* 247523 */     GIR_EraseRootFromParent_Done,
     /* 247524 */   // Label 4775: @247524
     /* 247524 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(247566), // Rule ID 11472 //
     /* 247529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 247537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247553 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1967:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 247556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247564 */     GIR_RootConstrainSelectedInstOperands,
     /* 247565 */     // GIR_Coverage, 11472,
     /* 247565 */     GIR_EraseRootFromParent_Done,
     /* 247566 */   // Label 4776: @247566
     /* 247566 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(247608), // Rule ID 11474 //
     /* 247571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 247579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247595 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1967:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 247598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247606 */     GIR_RootConstrainSelectedInstOperands,
     /* 247607 */     // GIR_Coverage, 11474,
     /* 247607 */     GIR_EraseRootFromParent_Done,
     /* 247608 */   // Label 4777: @247608
     /* 247608 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(247650), // Rule ID 11476 //
     /* 247613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 247621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247637 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 247640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247648 */     GIR_RootConstrainSelectedInstOperands,
     /* 247649 */     // GIR_Coverage, 11476,
     /* 247649 */     GIR_EraseRootFromParent_Done,
     /* 247650 */   // Label 4778: @247650
     /* 247650 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(247692), // Rule ID 11478 //
     /* 247655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 247663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247679 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 247682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247690 */     GIR_RootConstrainSelectedInstOperands,
     /* 247691 */     // GIR_Coverage, 11478,
     /* 247691 */     GIR_EraseRootFromParent_Done,
     /* 247692 */   // Label 4779: @247692
     /* 247692 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(247734), // Rule ID 11480 //
     /* 247697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 247705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247721 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1727:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 247724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247732 */     GIR_RootConstrainSelectedInstOperands,
     /* 247733 */     // GIR_Coverage, 11480,
     /* 247733 */     GIR_EraseRootFromParent_Done,
     /* 247734 */   // Label 4780: @247734
     /* 247734 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(247776), // Rule ID 11481 //
     /* 247739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 247747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247763 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1727:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 247766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247774 */     GIR_RootConstrainSelectedInstOperands,
     /* 247775 */     // GIR_Coverage, 11481,
     /* 247775 */     GIR_EraseRootFromParent_Done,
     /* 247776 */   // Label 4781: @247776
     /* 247776 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(247818), // Rule ID 11482 //
     /* 247781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 247789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1727:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 247808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247816 */     GIR_RootConstrainSelectedInstOperands,
     /* 247817 */     // GIR_Coverage, 11482,
     /* 247817 */     GIR_EraseRootFromParent_Done,
     /* 247818 */   // Label 4782: @247818
     /* 247818 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(247860), // Rule ID 11483 //
     /* 247823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 247831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247847 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1727:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 247850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247858 */     GIR_RootConstrainSelectedInstOperands,
     /* 247859 */     // GIR_Coverage, 11483,
     /* 247859 */     GIR_EraseRootFromParent_Done,
     /* 247860 */   // Label 4783: @247860
     /* 247860 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(247902), // Rule ID 11484 //
     /* 247865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 247873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247889 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1968:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 247892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247900 */     GIR_RootConstrainSelectedInstOperands,
     /* 247901 */     // GIR_Coverage, 11484,
     /* 247901 */     GIR_EraseRootFromParent_Done,
     /* 247902 */   // Label 4784: @247902
     /* 247902 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(247944), // Rule ID 11485 //
     /* 247907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 247915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247931 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1968:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 247934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247942 */     GIR_RootConstrainSelectedInstOperands,
     /* 247943 */     // GIR_Coverage, 11485,
     /* 247943 */     GIR_EraseRootFromParent_Done,
     /* 247944 */   // Label 4785: @247944
     /* 247944 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(247986), // Rule ID 11486 //
     /* 247949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 247957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 247976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247984 */     GIR_RootConstrainSelectedInstOperands,
     /* 247985 */     // GIR_Coverage, 11486,
     /* 247985 */     GIR_EraseRootFromParent_Done,
     /* 247986 */   // Label 4786: @247986
     /* 247986 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(248028), // Rule ID 11487 //
     /* 247991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 247999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 248018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248026 */     GIR_RootConstrainSelectedInstOperands,
     /* 248027 */     // GIR_Coverage, 11487,
     /* 248027 */     GIR_EraseRootFromParent_Done,
     /* 248028 */   // Label 4787: @248028
     /* 248028 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(248070), // Rule ID 11488 //
     /* 248033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 248041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248057 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 248060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248068 */     GIR_RootConstrainSelectedInstOperands,
     /* 248069 */     // GIR_Coverage, 11488,
     /* 248069 */     GIR_EraseRootFromParent_Done,
     /* 248070 */   // Label 4788: @248070
     /* 248070 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(248112), // Rule ID 11490 //
     /* 248075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 248083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248099 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 248102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248110 */     GIR_RootConstrainSelectedInstOperands,
     /* 248111 */     // GIR_Coverage, 11490,
     /* 248111 */     GIR_EraseRootFromParent_Done,
     /* 248112 */   // Label 4789: @248112
     /* 248112 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(248154), // Rule ID 11492 //
     /* 248117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 248125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 248144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248152 */     GIR_RootConstrainSelectedInstOperands,
     /* 248153 */     // GIR_Coverage, 11492,
     /* 248153 */     GIR_EraseRootFromParent_Done,
     /* 248154 */   // Label 4790: @248154
     /* 248154 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(248196), // Rule ID 11494 //
     /* 248159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 248167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248183 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1862:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 248186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248194 */     GIR_RootConstrainSelectedInstOperands,
     /* 248195 */     // GIR_Coverage, 11494,
     /* 248195 */     GIR_EraseRootFromParent_Done,
     /* 248196 */   // Label 4791: @248196
     /* 248196 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(248238), // Rule ID 11496 //
     /* 248201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 248209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248225 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2054:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 248228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248236 */     GIR_RootConstrainSelectedInstOperands,
     /* 248237 */     // GIR_Coverage, 11496,
     /* 248237 */     GIR_EraseRootFromParent_Done,
     /* 248238 */   // Label 4792: @248238
     /* 248238 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(248280), // Rule ID 11498 //
     /* 248243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 248251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248267 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2054:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 248270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248278 */     GIR_RootConstrainSelectedInstOperands,
     /* 248279 */     // GIR_Coverage, 11498,
     /* 248279 */     GIR_EraseRootFromParent_Done,
     /* 248280 */   // Label 4793: @248280
     /* 248280 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(248322), // Rule ID 11500 //
     /* 248285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 248293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 248312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248320 */     GIR_RootConstrainSelectedInstOperands,
     /* 248321 */     // GIR_Coverage, 11500,
     /* 248321 */     GIR_EraseRootFromParent_Done,
     /* 248322 */   // Label 4794: @248322
     /* 248322 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(248364), // Rule ID 11502 //
     /* 248327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 248335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2054:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 248354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248362 */     GIR_RootConstrainSelectedInstOperands,
     /* 248363 */     // GIR_Coverage, 11502,
     /* 248363 */     GIR_EraseRootFromParent_Done,
     /* 248364 */   // Label 4795: @248364
     /* 248364 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(248406), // Rule ID 11504 //
     /* 248369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 248377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248393 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1728:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 248396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248402 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248404 */     GIR_RootConstrainSelectedInstOperands,
     /* 248405 */     // GIR_Coverage, 11504,
     /* 248405 */     GIR_EraseRootFromParent_Done,
     /* 248406 */   // Label 4796: @248406
     /* 248406 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(248448), // Rule ID 11505 //
     /* 248411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 248419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248435 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1728:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 248438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248446 */     GIR_RootConstrainSelectedInstOperands,
     /* 248447 */     // GIR_Coverage, 11505,
     /* 248447 */     GIR_EraseRootFromParent_Done,
     /* 248448 */   // Label 4797: @248448
     /* 248448 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(248490), // Rule ID 11506 //
     /* 248453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 248461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248477 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1728:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 248480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248488 */     GIR_RootConstrainSelectedInstOperands,
     /* 248489 */     // GIR_Coverage, 11506,
     /* 248489 */     GIR_EraseRootFromParent_Done,
     /* 248490 */   // Label 4798: @248490
     /* 248490 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(248532), // Rule ID 11507 //
     /* 248495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 248503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248519 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1728:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 248522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248530 */     GIR_RootConstrainSelectedInstOperands,
     /* 248531 */     // GIR_Coverage, 11507,
     /* 248531 */     GIR_EraseRootFromParent_Done,
     /* 248532 */   // Label 4799: @248532
     /* 248532 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(248574), // Rule ID 11508 //
     /* 248537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 248545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248561 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1969:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 248564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248572 */     GIR_RootConstrainSelectedInstOperands,
     /* 248573 */     // GIR_Coverage, 11508,
     /* 248573 */     GIR_EraseRootFromParent_Done,
     /* 248574 */   // Label 4800: @248574
     /* 248574 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(248616), // Rule ID 11509 //
     /* 248579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 248587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248603 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 248606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248614 */     GIR_RootConstrainSelectedInstOperands,
     /* 248615 */     // GIR_Coverage, 11509,
     /* 248615 */     GIR_EraseRootFromParent_Done,
     /* 248616 */   // Label 4801: @248616
     /* 248616 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(248658), // Rule ID 11510 //
     /* 248621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 248629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248645 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 248648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248656 */     GIR_RootConstrainSelectedInstOperands,
     /* 248657 */     // GIR_Coverage, 11510,
     /* 248657 */     GIR_EraseRootFromParent_Done,
     /* 248658 */   // Label 4802: @248658
     /* 248658 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(248700), // Rule ID 11511 //
     /* 248663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 248671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248687 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 248690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248698 */     GIR_RootConstrainSelectedInstOperands,
     /* 248699 */     // GIR_Coverage, 11511,
     /* 248699 */     GIR_EraseRootFromParent_Done,
     /* 248700 */   // Label 4803: @248700
     /* 248700 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(248742), // Rule ID 11512 //
     /* 248705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 248713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248729 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1944:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 248732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248740 */     GIR_RootConstrainSelectedInstOperands,
     /* 248741 */     // GIR_Coverage, 11512,
     /* 248741 */     GIR_EraseRootFromParent_Done,
     /* 248742 */   // Label 4804: @248742
     /* 248742 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(248784), // Rule ID 11513 //
     /* 248747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 248755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 248774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248782 */     GIR_RootConstrainSelectedInstOperands,
     /* 248783 */     // GIR_Coverage, 11513,
     /* 248783 */     GIR_EraseRootFromParent_Done,
     /* 248784 */   // Label 4805: @248784
     /* 248784 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(248826), // Rule ID 11514 //
     /* 248789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 248797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248813 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1944:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 248816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248824 */     GIR_RootConstrainSelectedInstOperands,
     /* 248825 */     // GIR_Coverage, 11514,
     /* 248825 */     GIR_EraseRootFromParent_Done,
     /* 248826 */   // Label 4806: @248826
     /* 248826 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(248868), // Rule ID 11515 //
     /* 248831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 248839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248855 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 248858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248866 */     GIR_RootConstrainSelectedInstOperands,
     /* 248867 */     // GIR_Coverage, 11515,
     /* 248867 */     GIR_EraseRootFromParent_Done,
     /* 248868 */   // Label 4807: @248868
     /* 248868 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(248910), // Rule ID 11516 //
     /* 248873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 248881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248897 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1259:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 248900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248908 */     GIR_RootConstrainSelectedInstOperands,
     /* 248909 */     // GIR_Coverage, 11516,
     /* 248909 */     GIR_EraseRootFromParent_Done,
     /* 248910 */   // Label 4808: @248910
     /* 248910 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(248952), // Rule ID 11517 //
     /* 248915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 248923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1259:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 248942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248950 */     GIR_RootConstrainSelectedInstOperands,
     /* 248951 */     // GIR_Coverage, 11517,
     /* 248951 */     GIR_EraseRootFromParent_Done,
     /* 248952 */   // Label 4809: @248952
     /* 248952 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(248994), // Rule ID 11518 //
     /* 248957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 248965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248981 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1259:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 248984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248992 */     GIR_RootConstrainSelectedInstOperands,
     /* 248993 */     // GIR_Coverage, 11518,
     /* 248993 */     GIR_EraseRootFromParent_Done,
     /* 248994 */   // Label 4810: @248994
     /* 248994 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(249036), // Rule ID 11519 //
     /* 248999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 249007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249023 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1738:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 249026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249034 */     GIR_RootConstrainSelectedInstOperands,
     /* 249035 */     // GIR_Coverage, 11519,
     /* 249035 */     GIR_EraseRootFromParent_Done,
     /* 249036 */   // Label 4811: @249036
     /* 249036 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(249078), // Rule ID 11520 //
     /* 249041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 249049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249065 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1738:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 249068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249076 */     GIR_RootConstrainSelectedInstOperands,
     /* 249077 */     // GIR_Coverage, 11520,
     /* 249077 */     GIR_EraseRootFromParent_Done,
     /* 249078 */   // Label 4812: @249078
     /* 249078 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(249120), // Rule ID 11521 //
     /* 249083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 249091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249107 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1738:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 249110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249118 */     GIR_RootConstrainSelectedInstOperands,
     /* 249119 */     // GIR_Coverage, 11521,
     /* 249119 */     GIR_EraseRootFromParent_Done,
     /* 249120 */   // Label 4813: @249120
     /* 249120 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(249162), // Rule ID 11522 //
     /* 249125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 249133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249149 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1738:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 249152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249160 */     GIR_RootConstrainSelectedInstOperands,
     /* 249161 */     // GIR_Coverage, 11522,
     /* 249161 */     GIR_EraseRootFromParent_Done,
     /* 249162 */   // Label 4814: @249162
     /* 249162 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(249204), // Rule ID 11523 //
     /* 249167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 249175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249191 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1976:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 249194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249202 */     GIR_RootConstrainSelectedInstOperands,
     /* 249203 */     // GIR_Coverage, 11523,
     /* 249203 */     GIR_EraseRootFromParent_Done,
     /* 249204 */   // Label 4815: @249204
     /* 249204 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(249246), // Rule ID 11524 //
     /* 249209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 249217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1976:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 249236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249244 */     GIR_RootConstrainSelectedInstOperands,
     /* 249245 */     // GIR_Coverage, 11524,
     /* 249245 */     GIR_EraseRootFromParent_Done,
     /* 249246 */   // Label 4816: @249246
     /* 249246 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(249288), // Rule ID 11525 //
     /* 249251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 249259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1976:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 249278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249286 */     GIR_RootConstrainSelectedInstOperands,
     /* 249287 */     // GIR_Coverage, 11525,
     /* 249287 */     GIR_EraseRootFromParent_Done,
     /* 249288 */   // Label 4817: @249288
     /* 249288 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(249330), // Rule ID 11526 //
     /* 249293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 249301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1976:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 249320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249328 */     GIR_RootConstrainSelectedInstOperands,
     /* 249329 */     // GIR_Coverage, 11526,
     /* 249329 */     GIR_EraseRootFromParent_Done,
     /* 249330 */   // Label 4818: @249330
     /* 249330 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(249372), // Rule ID 11527 //
     /* 249335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 249343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1747:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 249362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249370 */     GIR_RootConstrainSelectedInstOperands,
     /* 249371 */     // GIR_Coverage, 11527,
     /* 249371 */     GIR_EraseRootFromParent_Done,
     /* 249372 */   // Label 4819: @249372
     /* 249372 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(249414), // Rule ID 11528 //
     /* 249377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 249385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249401 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 249404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249412 */     GIR_RootConstrainSelectedInstOperands,
     /* 249413 */     // GIR_Coverage, 11528,
     /* 249413 */     GIR_EraseRootFromParent_Done,
     /* 249414 */   // Label 4820: @249414
     /* 249414 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(249456), // Rule ID 11529 //
     /* 249419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 249427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249443 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 249446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249454 */     GIR_RootConstrainSelectedInstOperands,
     /* 249455 */     // GIR_Coverage, 11529,
     /* 249455 */     GIR_EraseRootFromParent_Done,
     /* 249456 */   // Label 4821: @249456
     /* 249456 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(249498), // Rule ID 11530 //
     /* 249461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 249469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249485 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 249488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249496 */     GIR_RootConstrainSelectedInstOperands,
     /* 249497 */     // GIR_Coverage, 11530,
     /* 249497 */     GIR_EraseRootFromParent_Done,
     /* 249498 */   // Label 4822: @249498
     /* 249498 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(249540), // Rule ID 11531 //
     /* 249503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 249511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249527 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1985:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 249530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249538 */     GIR_RootConstrainSelectedInstOperands,
     /* 249539 */     // GIR_Coverage, 11531,
     /* 249539 */     GIR_EraseRootFromParent_Done,
     /* 249540 */   // Label 4823: @249540
     /* 249540 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(249582), // Rule ID 11532 //
     /* 249545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 249553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249569 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1985:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 249572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249580 */     GIR_RootConstrainSelectedInstOperands,
     /* 249581 */     // GIR_Coverage, 11532,
     /* 249581 */     GIR_EraseRootFromParent_Done,
     /* 249582 */   // Label 4824: @249582
     /* 249582 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(249624), // Rule ID 11533 //
     /* 249587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 249595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249611 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1985:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 249614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249622 */     GIR_RootConstrainSelectedInstOperands,
     /* 249623 */     // GIR_Coverage, 11533,
     /* 249623 */     GIR_EraseRootFromParent_Done,
     /* 249624 */   // Label 4825: @249624
     /* 249624 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(249666), // Rule ID 11534 //
     /* 249629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 249637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249653 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1985:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 249656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249664 */     GIR_RootConstrainSelectedInstOperands,
     /* 249665 */     // GIR_Coverage, 11534,
     /* 249665 */     GIR_EraseRootFromParent_Done,
     /* 249666 */   // Label 4826: @249666
     /* 249666 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(249708), // Rule ID 11535 //
     /* 249671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 249679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 249688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249695 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 249698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249706 */     GIR_RootConstrainSelectedInstOperands,
     /* 249707 */     // GIR_Coverage, 11535,
     /* 249707 */     GIR_EraseRootFromParent_Done,
     /* 249708 */   // Label 4827: @249708
     /* 249708 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(249750), // Rule ID 11546 //
     /* 249713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 249721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 249727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 249730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249737 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 249740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249748 */     GIR_RootConstrainSelectedInstOperands,
     /* 249749 */     // GIR_Coverage, 11546,
     /* 249749 */     GIR_EraseRootFromParent_Done,
     /* 249750 */   // Label 4828: @249750
     /* 249750 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(249792), // Rule ID 11547 //
     /* 249755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 249763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 249772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249779 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 249782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249790 */     GIR_RootConstrainSelectedInstOperands,
     /* 249791 */     // GIR_Coverage, 11547,
     /* 249791 */     GIR_EraseRootFromParent_Done,
     /* 249792 */   // Label 4829: @249792
     /* 249792 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(249834), // Rule ID 11548 //
     /* 249797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 249805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 249814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249821 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 249824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249832 */     GIR_RootConstrainSelectedInstOperands,
     /* 249833 */     // GIR_Coverage, 11548,
     /* 249833 */     GIR_EraseRootFromParent_Done,
     /* 249834 */   // Label 4830: @249834
     /* 249834 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(249876), // Rule ID 11549 //
     /* 249839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 249847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249863 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 249866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249872 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249874 */     GIR_RootConstrainSelectedInstOperands,
     /* 249875 */     // GIR_Coverage, 11549,
     /* 249875 */     GIR_EraseRootFromParent_Done,
     /* 249876 */   // Label 4831: @249876
     /* 249876 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(249918), // Rule ID 11558 //
     /* 249881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 249889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249905 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1767:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 249908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249916 */     GIR_RootConstrainSelectedInstOperands,
     /* 249917 */     // GIR_Coverage, 11558,
     /* 249917 */     GIR_EraseRootFromParent_Done,
     /* 249918 */   // Label 4832: @249918
     /* 249918 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(249960), // Rule ID 11559 //
     /* 249923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 249931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249947 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1767:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 249950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249958 */     GIR_RootConstrainSelectedInstOperands,
     /* 249959 */     // GIR_Coverage, 11559,
     /* 249959 */     GIR_EraseRootFromParent_Done,
     /* 249960 */   // Label 4833: @249960
     /* 249960 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(250002), // Rule ID 11560 //
     /* 249965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 249973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249989 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1767:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 249992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250000 */     GIR_RootConstrainSelectedInstOperands,
     /* 250001 */     // GIR_Coverage, 11560,
     /* 250001 */     GIR_EraseRootFromParent_Done,
     /* 250002 */   // Label 4834: @250002
     /* 250002 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(250044), // Rule ID 11561 //
     /* 250007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 250015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250031 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1767:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 250034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250042 */     GIR_RootConstrainSelectedInstOperands,
     /* 250043 */     // GIR_Coverage, 11561,
     /* 250043 */     GIR_EraseRootFromParent_Done,
     /* 250044 */   // Label 4835: @250044
     /* 250044 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(250086), // Rule ID 11562 //
     /* 250049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 250057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250073 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2003:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 250076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250084 */     GIR_RootConstrainSelectedInstOperands,
     /* 250085 */     // GIR_Coverage, 11562,
     /* 250085 */     GIR_EraseRootFromParent_Done,
     /* 250086 */   // Label 4836: @250086
     /* 250086 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(250128), // Rule ID 11563 //
     /* 250091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 250099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2003:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 250118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250126 */     GIR_RootConstrainSelectedInstOperands,
     /* 250127 */     // GIR_Coverage, 11563,
     /* 250127 */     GIR_EraseRootFromParent_Done,
     /* 250128 */   // Label 4837: @250128
     /* 250128 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(250170), // Rule ID 11564 //
     /* 250133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 250141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250157 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2003:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 250160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250168 */     GIR_RootConstrainSelectedInstOperands,
     /* 250169 */     // GIR_Coverage, 11564,
     /* 250169 */     GIR_EraseRootFromParent_Done,
     /* 250170 */   // Label 4838: @250170
     /* 250170 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(250212), // Rule ID 11565 //
     /* 250175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 250183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250199 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2003:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 250202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250210 */     GIR_RootConstrainSelectedInstOperands,
     /* 250211 */     // GIR_Coverage, 11565,
     /* 250211 */     GIR_EraseRootFromParent_Done,
     /* 250212 */   // Label 4839: @250212
     /* 250212 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(250254), // Rule ID 11566 //
     /* 250217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 250225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250241 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 250244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250252 */     GIR_RootConstrainSelectedInstOperands,
     /* 250253 */     // GIR_Coverage, 11566,
     /* 250253 */     GIR_EraseRootFromParent_Done,
     /* 250254 */   // Label 4840: @250254
     /* 250254 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(250296), // Rule ID 11567 //
     /* 250259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 250267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250283 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 250286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250294 */     GIR_RootConstrainSelectedInstOperands,
     /* 250295 */     // GIR_Coverage, 11567,
     /* 250295 */     GIR_EraseRootFromParent_Done,
     /* 250296 */   // Label 4841: @250296
     /* 250296 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(250338), // Rule ID 11568 //
     /* 250301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 250309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 250328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250336 */     GIR_RootConstrainSelectedInstOperands,
     /* 250337 */     // GIR_Coverage, 11568,
     /* 250337 */     GIR_EraseRootFromParent_Done,
     /* 250338 */   // Label 4842: @250338
     /* 250338 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(250380), // Rule ID 11569 //
     /* 250343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 250351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250367 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1854:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 250370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250378 */     GIR_RootConstrainSelectedInstOperands,
     /* 250379 */     // GIR_Coverage, 11569,
     /* 250379 */     GIR_EraseRootFromParent_Done,
     /* 250380 */   // Label 4843: @250380
     /* 250380 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(250422), // Rule ID 11570 //
     /* 250385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 250393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250409 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 250412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250420 */     GIR_RootConstrainSelectedInstOperands,
     /* 250421 */     // GIR_Coverage, 11570,
     /* 250421 */     GIR_EraseRootFromParent_Done,
     /* 250422 */   // Label 4844: @250422
     /* 250422 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(250464), // Rule ID 11571 //
     /* 250427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 250435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250451 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 250454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250462 */     GIR_RootConstrainSelectedInstOperands,
     /* 250463 */     // GIR_Coverage, 11571,
     /* 250463 */     GIR_EraseRootFromParent_Done,
     /* 250464 */   // Label 4845: @250464
     /* 250464 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(250506), // Rule ID 11572 //
     /* 250469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 250477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 250496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250504 */     GIR_RootConstrainSelectedInstOperands,
     /* 250505 */     // GIR_Coverage, 11572,
     /* 250505 */     GIR_EraseRootFromParent_Done,
     /* 250506 */   // Label 4846: @250506
     /* 250506 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(250548), // Rule ID 11573 //
     /* 250511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 250519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250535 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 250538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250546 */     GIR_RootConstrainSelectedInstOperands,
     /* 250547 */     // GIR_Coverage, 11573,
     /* 250547 */     GIR_EraseRootFromParent_Done,
     /* 250548 */   // Label 4847: @250548
     /* 250548 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(250590), // Rule ID 11574 //
     /* 250553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 250561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250577 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1918:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 250580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250588 */     GIR_RootConstrainSelectedInstOperands,
     /* 250589 */     // GIR_Coverage, 11574,
     /* 250589 */     GIR_EraseRootFromParent_Done,
     /* 250590 */   // Label 4848: @250590
     /* 250590 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(250632), // Rule ID 11575 //
     /* 250595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 250603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250619 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 250622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250630 */     GIR_RootConstrainSelectedInstOperands,
     /* 250631 */     // GIR_Coverage, 11575,
     /* 250631 */     GIR_EraseRootFromParent_Done,
     /* 250632 */   // Label 4849: @250632
     /* 250632 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(250674), // Rule ID 11576 //
     /* 250637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 250645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 250664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250672 */     GIR_RootConstrainSelectedInstOperands,
     /* 250673 */     // GIR_Coverage, 11576,
     /* 250673 */     GIR_EraseRootFromParent_Done,
     /* 250674 */   // Label 4850: @250674
     /* 250674 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(250716), // Rule ID 11577 //
     /* 250679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 250687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250703 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 250706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250714 */     GIR_RootConstrainSelectedInstOperands,
     /* 250715 */     // GIR_Coverage, 11577,
     /* 250715 */     GIR_EraseRootFromParent_Done,
     /* 250716 */   // Label 4851: @250716
     /* 250716 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(250758), // Rule ID 11578 //
     /* 250721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 250729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250745 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2068:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 250748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250756 */     GIR_RootConstrainSelectedInstOperands,
     /* 250757 */     // GIR_Coverage, 11578,
     /* 250757 */     GIR_EraseRootFromParent_Done,
     /* 250758 */   // Label 4852: @250758
     /* 250758 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(250800), // Rule ID 11579 //
     /* 250763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 250771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250787 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2068:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 250790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250798 */     GIR_RootConstrainSelectedInstOperands,
     /* 250799 */     // GIR_Coverage, 11579,
     /* 250799 */     GIR_EraseRootFromParent_Done,
     /* 250800 */   // Label 4853: @250800
     /* 250800 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(250842), // Rule ID 11580 //
     /* 250805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 250813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250829 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2068:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 250832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250840 */     GIR_RootConstrainSelectedInstOperands,
     /* 250841 */     // GIR_Coverage, 11580,
     /* 250841 */     GIR_EraseRootFromParent_Done,
     /* 250842 */   // Label 4854: @250842
     /* 250842 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(250884), // Rule ID 11581 //
     /* 250847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 250855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250871 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2068:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 250874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250882 */     GIR_RootConstrainSelectedInstOperands,
     /* 250883 */     // GIR_Coverage, 11581,
     /* 250883 */     GIR_EraseRootFromParent_Done,
     /* 250884 */   // Label 4855: @250884
     /* 250884 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(250926), // Rule ID 11582 //
     /* 250889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 250897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250913 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 250916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250924 */     GIR_RootConstrainSelectedInstOperands,
     /* 250925 */     // GIR_Coverage, 11582,
     /* 250925 */     GIR_EraseRootFromParent_Done,
     /* 250926 */   // Label 4856: @250926
     /* 250926 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(250968), // Rule ID 11583 //
     /* 250931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 250939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250955 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 250958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250966 */     GIR_RootConstrainSelectedInstOperands,
     /* 250967 */     // GIR_Coverage, 11583,
     /* 250967 */     GIR_EraseRootFromParent_Done,
     /* 250968 */   // Label 4857: @250968
     /* 250968 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(251010), // Rule ID 11584 //
     /* 250973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 250981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250997 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 251000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251008 */     GIR_RootConstrainSelectedInstOperands,
     /* 251009 */     // GIR_Coverage, 11584,
     /* 251009 */     GIR_EraseRootFromParent_Done,
     /* 251010 */   // Label 4858: @251010
     /* 251010 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(251052), // Rule ID 11585 //
     /* 251015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 251023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251039 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 251042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251050 */     GIR_RootConstrainSelectedInstOperands,
     /* 251051 */     // GIR_Coverage, 11585,
     /* 251051 */     GIR_EraseRootFromParent_Done,
     /* 251052 */   // Label 4859: @251052
     /* 251052 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(251094), // Rule ID 11586 //
     /* 251057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 251065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251081 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2050:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 251084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251092 */     GIR_RootConstrainSelectedInstOperands,
     /* 251093 */     // GIR_Coverage, 11586,
     /* 251093 */     GIR_EraseRootFromParent_Done,
     /* 251094 */   // Label 4860: @251094
     /* 251094 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(251136), // Rule ID 11587 //
     /* 251099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 251107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2050:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 251126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251134 */     GIR_RootConstrainSelectedInstOperands,
     /* 251135 */     // GIR_Coverage, 11587,
     /* 251135 */     GIR_EraseRootFromParent_Done,
     /* 251136 */   // Label 4861: @251136
     /* 251136 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(251178), // Rule ID 11588 //
     /* 251141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 251149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251165 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2050:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 251168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251176 */     GIR_RootConstrainSelectedInstOperands,
     /* 251177 */     // GIR_Coverage, 11588,
     /* 251177 */     GIR_EraseRootFromParent_Done,
     /* 251178 */   // Label 4862: @251178
     /* 251178 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(251220), // Rule ID 11589 //
     /* 251183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 251191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251207 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2050:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 251210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251218 */     GIR_RootConstrainSelectedInstOperands,
     /* 251219 */     // GIR_Coverage, 11589,
     /* 251219 */     GIR_EraseRootFromParent_Done,
     /* 251220 */   // Label 4863: @251220
     /* 251220 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(251262), // Rule ID 11590 //
     /* 251225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 251233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251249 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1864:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 251252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251260 */     GIR_RootConstrainSelectedInstOperands,
     /* 251261 */     // GIR_Coverage, 11590,
     /* 251261 */     GIR_EraseRootFromParent_Done,
     /* 251262 */   // Label 4864: @251262
     /* 251262 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(251304), // Rule ID 11591 //
     /* 251267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 251275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251291 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 251294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251302 */     GIR_RootConstrainSelectedInstOperands,
     /* 251303 */     // GIR_Coverage, 11591,
     /* 251303 */     GIR_EraseRootFromParent_Done,
     /* 251304 */   // Label 4865: @251304
     /* 251304 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(251346), // Rule ID 11592 //
     /* 251309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 251317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251333 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 251336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251344 */     GIR_RootConstrainSelectedInstOperands,
     /* 251345 */     // GIR_Coverage, 11592,
     /* 251345 */     GIR_EraseRootFromParent_Done,
     /* 251346 */   // Label 4866: @251346
     /* 251346 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(251388), // Rule ID 11593 //
     /* 251351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 251359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251375 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 251378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251386 */     GIR_RootConstrainSelectedInstOperands,
     /* 251387 */     // GIR_Coverage, 11593,
     /* 251387 */     GIR_EraseRootFromParent_Done,
     /* 251388 */   // Label 4867: @251388
     /* 251388 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(251430), // Rule ID 11594 //
     /* 251393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 251401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251417 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 251420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251428 */     GIR_RootConstrainSelectedInstOperands,
     /* 251429 */     // GIR_Coverage, 11594,
     /* 251429 */     GIR_EraseRootFromParent_Done,
     /* 251430 */   // Label 4868: @251430
     /* 251430 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(251472), // Rule ID 11595 //
     /* 251435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 251443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251459 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 251462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251470 */     GIR_RootConstrainSelectedInstOperands,
     /* 251471 */     // GIR_Coverage, 11595,
     /* 251471 */     GIR_EraseRootFromParent_Done,
     /* 251472 */   // Label 4869: @251472
     /* 251472 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(251514), // Rule ID 11596 //
     /* 251477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 251485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 251504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251512 */     GIR_RootConstrainSelectedInstOperands,
     /* 251513 */     // GIR_Coverage, 11596,
     /* 251513 */     GIR_EraseRootFromParent_Done,
     /* 251514 */   // Label 4870: @251514
     /* 251514 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(251556), // Rule ID 11597 //
     /* 251519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 251527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2055:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 251546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251554 */     GIR_RootConstrainSelectedInstOperands,
     /* 251555 */     // GIR_Coverage, 11597,
     /* 251555 */     GIR_EraseRootFromParent_Done,
     /* 251556 */   // Label 4871: @251556
     /* 251556 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(251598), // Rule ID 11598 //
     /* 251561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 251569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251585 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1848:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 251588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251596 */     GIR_RootConstrainSelectedInstOperands,
     /* 251597 */     // GIR_Coverage, 11598,
     /* 251597 */     GIR_EraseRootFromParent_Done,
     /* 251598 */   // Label 4872: @251598
     /* 251598 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(251640), // Rule ID 11599 //
     /* 251603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 251611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251627 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1848:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 251630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251638 */     GIR_RootConstrainSelectedInstOperands,
     /* 251639 */     // GIR_Coverage, 11599,
     /* 251639 */     GIR_EraseRootFromParent_Done,
     /* 251640 */   // Label 4873: @251640
     /* 251640 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(251682), // Rule ID 11600 //
     /* 251645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 251653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1848:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 251672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251680 */     GIR_RootConstrainSelectedInstOperands,
     /* 251681 */     // GIR_Coverage, 11600,
     /* 251681 */     GIR_EraseRootFromParent_Done,
     /* 251682 */   // Label 4874: @251682
     /* 251682 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(251724), // Rule ID 11601 //
     /* 251687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 251695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251711 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1848:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 251714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251722 */     GIR_RootConstrainSelectedInstOperands,
     /* 251723 */     // GIR_Coverage, 11601,
     /* 251723 */     GIR_EraseRootFromParent_Done,
     /* 251724 */   // Label 4875: @251724
     /* 251724 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(251766), // Rule ID 11602 //
     /* 251729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 251737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251753 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2044:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 251756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251764 */     GIR_RootConstrainSelectedInstOperands,
     /* 251765 */     // GIR_Coverage, 11602,
     /* 251765 */     GIR_EraseRootFromParent_Done,
     /* 251766 */   // Label 4876: @251766
     /* 251766 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(251808), // Rule ID 11603 //
     /* 251771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 251779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 251798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251806 */     GIR_RootConstrainSelectedInstOperands,
     /* 251807 */     // GIR_Coverage, 11603,
     /* 251807 */     GIR_EraseRootFromParent_Done,
     /* 251808 */   // Label 4877: @251808
     /* 251808 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(251850), // Rule ID 11604 //
     /* 251813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 251821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251837 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 251840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251848 */     GIR_RootConstrainSelectedInstOperands,
     /* 251849 */     // GIR_Coverage, 11604,
     /* 251849 */     GIR_EraseRootFromParent_Done,
     /* 251850 */   // Label 4878: @251850
     /* 251850 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(251892), // Rule ID 11605 //
     /* 251855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 251863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251879 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2044:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 251882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251890 */     GIR_RootConstrainSelectedInstOperands,
     /* 251891 */     // GIR_Coverage, 11605,
     /* 251891 */     GIR_EraseRootFromParent_Done,
     /* 251892 */   // Label 4879: @251892
     /* 251892 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(251934), // Rule ID 11606 //
     /* 251897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 251905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1835:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 251924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251932 */     GIR_RootConstrainSelectedInstOperands,
     /* 251933 */     // GIR_Coverage, 11606,
     /* 251933 */     GIR_EraseRootFromParent_Done,
     /* 251934 */   // Label 4880: @251934
     /* 251934 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(251976), // Rule ID 11607 //
     /* 251939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 251947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251963 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 251966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251974 */     GIR_RootConstrainSelectedInstOperands,
     /* 251975 */     // GIR_Coverage, 11607,
     /* 251975 */     GIR_EraseRootFromParent_Done,
     /* 251976 */   // Label 4881: @251976
     /* 251976 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(252018), // Rule ID 11608 //
     /* 251981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 251989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252005 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 252008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252016 */     GIR_RootConstrainSelectedInstOperands,
     /* 252017 */     // GIR_Coverage, 11608,
     /* 252017 */     GIR_EraseRootFromParent_Done,
     /* 252018 */   // Label 4882: @252018
     /* 252018 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(252060), // Rule ID 11609 //
     /* 252023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 252031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252047 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 252050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252058 */     GIR_RootConstrainSelectedInstOperands,
     /* 252059 */     // GIR_Coverage, 11609,
     /* 252059 */     GIR_EraseRootFromParent_Done,
     /* 252060 */   // Label 4883: @252060
     /* 252060 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(252102), // Rule ID 11610 //
     /* 252065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 252073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252089 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2037:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 252092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252100 */     GIR_RootConstrainSelectedInstOperands,
     /* 252101 */     // GIR_Coverage, 11610,
     /* 252101 */     GIR_EraseRootFromParent_Done,
     /* 252102 */   // Label 4884: @252102
     /* 252102 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(252144), // Rule ID 11611 //
     /* 252107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 252115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252131 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2037:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 252134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252142 */     GIR_RootConstrainSelectedInstOperands,
     /* 252143 */     // GIR_Coverage, 11611,
     /* 252143 */     GIR_EraseRootFromParent_Done,
     /* 252144 */   // Label 4885: @252144
     /* 252144 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(252186), // Rule ID 11612 //
     /* 252149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 252157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252173 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 252176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252184 */     GIR_RootConstrainSelectedInstOperands,
     /* 252185 */     // GIR_Coverage, 11612,
     /* 252185 */     GIR_EraseRootFromParent_Done,
     /* 252186 */   // Label 4886: @252186
     /* 252186 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(252228), // Rule ID 11613 //
     /* 252191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 252199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252215 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2037:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 252218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252226 */     GIR_RootConstrainSelectedInstOperands,
     /* 252227 */     // GIR_Coverage, 11613,
     /* 252227 */     GIR_EraseRootFromParent_Done,
     /* 252228 */   // Label 4887: @252228
     /* 252228 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(252270), // Rule ID 11788 //
     /* 252233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 252241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252257 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1937:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 252260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252268 */     GIR_RootConstrainSelectedInstOperands,
     /* 252269 */     // GIR_Coverage, 11788,
     /* 252269 */     GIR_EraseRootFromParent_Done,
     /* 252270 */   // Label 4888: @252270
     /* 252270 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(252312), // Rule ID 11790 //
     /* 252275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 252283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252299 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1937:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 252302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252310 */     GIR_RootConstrainSelectedInstOperands,
     /* 252311 */     // GIR_Coverage, 11790,
     /* 252311 */     GIR_EraseRootFromParent_Done,
     /* 252312 */   // Label 4889: @252312
     /* 252312 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(252354), // Rule ID 11792 //
     /* 252317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 252325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252341 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1937:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 252344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252352 */     GIR_RootConstrainSelectedInstOperands,
     /* 252353 */     // GIR_Coverage, 11792,
     /* 252353 */     GIR_EraseRootFromParent_Done,
     /* 252354 */   // Label 4890: @252354
     /* 252354 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(252396), // Rule ID 11794 //
     /* 252359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 252367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252383 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1937:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 252386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252394 */     GIR_RootConstrainSelectedInstOperands,
     /* 252395 */     // GIR_Coverage, 11794,
     /* 252395 */     GIR_EraseRootFromParent_Done,
     /* 252396 */   // Label 4891: @252396
     /* 252396 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(252438), // Rule ID 11796 //
     /* 252401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 252409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252425 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 252428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252436 */     GIR_RootConstrainSelectedInstOperands,
     /* 252437 */     // GIR_Coverage, 11796,
     /* 252437 */     GIR_EraseRootFromParent_Done,
     /* 252438 */   // Label 4892: @252438
     /* 252438 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(252480), // Rule ID 11797 //
     /* 252443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 252451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252467 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 252470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252478 */     GIR_RootConstrainSelectedInstOperands,
     /* 252479 */     // GIR_Coverage, 11797,
     /* 252479 */     GIR_EraseRootFromParent_Done,
     /* 252480 */   // Label 4893: @252480
     /* 252480 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(252522), // Rule ID 11798 //
     /* 252485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 252493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252509 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1689:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 252512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252520 */     GIR_RootConstrainSelectedInstOperands,
     /* 252521 */     // GIR_Coverage, 11798,
     /* 252521 */     GIR_EraseRootFromParent_Done,
     /* 252522 */   // Label 4894: @252522
     /* 252522 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(252564), // Rule ID 11799 //
     /* 252527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 252535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1938:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 252554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252562 */     GIR_RootConstrainSelectedInstOperands,
     /* 252563 */     // GIR_Coverage, 11799,
     /* 252563 */     GIR_EraseRootFromParent_Done,
     /* 252564 */   // Label 4895: @252564
     /* 252564 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(252606), // Rule ID 11800 //
     /* 252569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 252577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1938:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 252596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252604 */     GIR_RootConstrainSelectedInstOperands,
     /* 252605 */     // GIR_Coverage, 11800,
     /* 252605 */     GIR_EraseRootFromParent_Done,
     /* 252606 */   // Label 4896: @252606
     /* 252606 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(252648), // Rule ID 11801 //
     /* 252611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 252619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252635 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1938:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 252638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252646 */     GIR_RootConstrainSelectedInstOperands,
     /* 252647 */     // GIR_Coverage, 11801,
     /* 252647 */     GIR_EraseRootFromParent_Done,
     /* 252648 */   // Label 4897: @252648
     /* 252648 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(252690), // Rule ID 11802 //
     /* 252653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 252661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252677 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 252680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252688 */     GIR_RootConstrainSelectedInstOperands,
     /* 252689 */     // GIR_Coverage, 11802,
     /* 252689 */     GIR_EraseRootFromParent_Done,
     /* 252690 */   // Label 4898: @252690
     /* 252690 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(252732), // Rule ID 11803 //
     /* 252695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 252703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 252722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252730 */     GIR_RootConstrainSelectedInstOperands,
     /* 252731 */     // GIR_Coverage, 11803,
     /* 252731 */     GIR_EraseRootFromParent_Done,
     /* 252732 */   // Label 4899: @252732
     /* 252732 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(252774), // Rule ID 11804 //
     /* 252737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 252745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252761 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 252764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252772 */     GIR_RootConstrainSelectedInstOperands,
     /* 252773 */     // GIR_Coverage, 11804,
     /* 252773 */     GIR_EraseRootFromParent_Done,
     /* 252774 */   // Label 4900: @252774
     /* 252774 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(252816), // Rule ID 11805 //
     /* 252779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 252787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1252:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 252806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252814 */     GIR_RootConstrainSelectedInstOperands,
     /* 252815 */     // GIR_Coverage, 11805,
     /* 252815 */     GIR_EraseRootFromParent_Done,
     /* 252816 */   // Label 4901: @252816
     /* 252816 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(252858), // Rule ID 11806 //
     /* 252821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 252829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252845 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1252:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 252848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252856 */     GIR_RootConstrainSelectedInstOperands,
     /* 252857 */     // GIR_Coverage, 11806,
     /* 252857 */     GIR_EraseRootFromParent_Done,
     /* 252858 */   // Label 4902: @252858
     /* 252858 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(252900), // Rule ID 11807 //
     /* 252863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 252871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1701:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 252890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252898 */     GIR_RootConstrainSelectedInstOperands,
     /* 252899 */     // GIR_Coverage, 11807,
     /* 252899 */     GIR_EraseRootFromParent_Done,
     /* 252900 */   // Label 4903: @252900
     /* 252900 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(252942), // Rule ID 11808 //
     /* 252905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 252913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252929 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1701:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 252932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252940 */     GIR_RootConstrainSelectedInstOperands,
     /* 252941 */     // GIR_Coverage, 11808,
     /* 252941 */     GIR_EraseRootFromParent_Done,
     /* 252942 */   // Label 4904: @252942
     /* 252942 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(252984), // Rule ID 11809 //
     /* 252947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 252955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1702:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 252974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252982 */     GIR_RootConstrainSelectedInstOperands,
     /* 252983 */     // GIR_Coverage, 11809,
     /* 252983 */     GIR_EraseRootFromParent_Done,
     /* 252984 */   // Label 4905: @252984
     /* 252984 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(253026), // Rule ID 11810 //
     /* 252989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 252997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253013 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1702:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 253016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253024 */     GIR_RootConstrainSelectedInstOperands,
     /* 253025 */     // GIR_Coverage, 11810,
     /* 253025 */     GIR_EraseRootFromParent_Done,
     /* 253026 */   // Label 4906: @253026
     /* 253026 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(253068), // Rule ID 11865 //
     /* 253031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 253039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253055 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1670:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 253058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253066 */     GIR_RootConstrainSelectedInstOperands,
     /* 253067 */     // GIR_Coverage, 11865,
     /* 253067 */     GIR_EraseRootFromParent_Done,
     /* 253068 */   // Label 4907: @253068
     /* 253068 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(253110), // Rule ID 11866 //
     /* 253073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 253081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253097 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1670:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 253100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253108 */     GIR_RootConstrainSelectedInstOperands,
     /* 253109 */     // GIR_Coverage, 11866,
     /* 253109 */     GIR_EraseRootFromParent_Done,
     /* 253110 */   // Label 4908: @253110
     /* 253110 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(253152), // Rule ID 11867 //
     /* 253115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 253123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1670:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 253142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253150 */     GIR_RootConstrainSelectedInstOperands,
     /* 253151 */     // GIR_Coverage, 11867,
     /* 253151 */     GIR_EraseRootFromParent_Done,
     /* 253152 */   // Label 4909: @253152
     /* 253152 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(253194), // Rule ID 11868 //
     /* 253157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 253165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253181 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1911:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 253184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253192 */     GIR_RootConstrainSelectedInstOperands,
     /* 253193 */     // GIR_Coverage, 11868,
     /* 253193 */     GIR_EraseRootFromParent_Done,
     /* 253194 */   // Label 4910: @253194
     /* 253194 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(253236), // Rule ID 11869 //
     /* 253199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 253207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253223 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1911:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 253226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253234 */     GIR_RootConstrainSelectedInstOperands,
     /* 253235 */     // GIR_Coverage, 11869,
     /* 253235 */     GIR_EraseRootFromParent_Done,
     /* 253236 */   // Label 4911: @253236
     /* 253236 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(253278), // Rule ID 11870 //
     /* 253241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 253249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253265 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1911:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 253268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253276 */     GIR_RootConstrainSelectedInstOperands,
     /* 253277 */     // GIR_Coverage, 11870,
     /* 253277 */     GIR_EraseRootFromParent_Done,
     /* 253278 */   // Label 4912: @253278
     /* 253278 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(253320), // Rule ID 11871 //
     /* 253283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 253291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253307 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1686:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 253310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253318 */     GIR_RootConstrainSelectedInstOperands,
     /* 253319 */     // GIR_Coverage, 11871,
     /* 253319 */     GIR_EraseRootFromParent_Done,
     /* 253320 */   // Label 4913: @253320
     /* 253320 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(253362), // Rule ID 11872 //
     /* 253325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 253333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253349 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 253352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253360 */     GIR_RootConstrainSelectedInstOperands,
     /* 253361 */     // GIR_Coverage, 11872,
     /* 253361 */     GIR_EraseRootFromParent_Done,
     /* 253362 */   // Label 4914: @253362
     /* 253362 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(253404), // Rule ID 11873 //
     /* 253367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 253375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 253394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253402 */     GIR_RootConstrainSelectedInstOperands,
     /* 253403 */     // GIR_Coverage, 11873,
     /* 253403 */     GIR_EraseRootFromParent_Done,
     /* 253404 */   // Label 4915: @253404
     /* 253404 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(253449), // Rule ID 11886 //
     /* 253409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 253412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 253417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 253420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 253433 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 253436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 253438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 253447 */     GIR_RootConstrainSelectedInstOperands,
     /* 253448 */     // GIR_Coverage, 11886,
     /* 253448 */     GIR_EraseRootFromParent_Done,
     /* 253449 */   // Label 4916: @253449
     /* 253449 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(253494), // Rule ID 11887 //
     /* 253454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 253457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 253462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 253465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 253478 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 253481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 253483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 253492 */     GIR_RootConstrainSelectedInstOperands,
     /* 253493 */     // GIR_Coverage, 11887,
     /* 253493 */     GIR_EraseRootFromParent_Done,
     /* 253494 */   // Label 4917: @253494
     /* 253494 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(253536), // Rule ID 11888 //
     /* 253499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 253507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253523 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1361:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 253526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253534 */     GIR_RootConstrainSelectedInstOperands,
     /* 253535 */     // GIR_Coverage, 11888,
     /* 253535 */     GIR_EraseRootFromParent_Done,
     /* 253536 */   // Label 4918: @253536
     /* 253536 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(253578), // Rule ID 11889 //
     /* 253541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 253549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253565 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1361:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 253568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253576 */     GIR_RootConstrainSelectedInstOperands,
     /* 253577 */     // GIR_Coverage, 11889,
     /* 253577 */     GIR_EraseRootFromParent_Done,
     /* 253578 */   // Label 4919: @253578
     /* 253578 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(253620), // Rule ID 11890 //
     /* 253583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 253591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253607 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1361:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 253610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253616 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253618 */     GIR_RootConstrainSelectedInstOperands,
     /* 253619 */     // GIR_Coverage, 11890,
     /* 253619 */     GIR_EraseRootFromParent_Done,
     /* 253620 */   // Label 4920: @253620
     /* 253620 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(253662), // Rule ID 11891 //
     /* 253625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 253633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1361:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 253652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253660 */     GIR_RootConstrainSelectedInstOperands,
     /* 253661 */     // GIR_Coverage, 11891,
     /* 253661 */     GIR_EraseRootFromParent_Done,
     /* 253662 */   // Label 4921: @253662
     /* 253662 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(253704), // Rule ID 11907 //
     /* 253667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 253675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253691 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1444:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 253691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 253694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253702 */     GIR_RootConstrainSelectedInstOperands,
     /* 253703 */     // GIR_Coverage, 11907,
     /* 253703 */     GIR_EraseRootFromParent_Done,
     /* 253704 */   // Label 4922: @253704
     /* 253704 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(253746), // Rule ID 11908 //
     /* 253709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 253717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253733 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1444:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 253733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 253736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253744 */     GIR_RootConstrainSelectedInstOperands,
     /* 253745 */     // GIR_Coverage, 11908,
     /* 253745 */     GIR_EraseRootFromParent_Done,
     /* 253746 */   // Label 4923: @253746
     /* 253746 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(253788), // Rule ID 11909 //
     /* 253751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 253759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253775 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1444:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 253775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 253778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253786 */     GIR_RootConstrainSelectedInstOperands,
     /* 253787 */     // GIR_Coverage, 11909,
     /* 253787 */     GIR_EraseRootFromParent_Done,
     /* 253788 */   // Label 4924: @253788
     /* 253788 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(253830), // Rule ID 11910 //
     /* 253793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 253801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253817 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 253817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 253820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253828 */     GIR_RootConstrainSelectedInstOperands,
     /* 253829 */     // GIR_Coverage, 11910,
     /* 253829 */     GIR_EraseRootFromParent_Done,
     /* 253830 */   // Label 4925: @253830
     /* 253830 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(253872), // Rule ID 11911 //
     /* 253835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 253843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253859 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 253859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 253862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253870 */     GIR_RootConstrainSelectedInstOperands,
     /* 253871 */     // GIR_Coverage, 11911,
     /* 253871 */     GIR_EraseRootFromParent_Done,
     /* 253872 */   // Label 4926: @253872
     /* 253872 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(253914), // Rule ID 11912 //
     /* 253877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 253885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253901 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 253901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 253904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253912 */     GIR_RootConstrainSelectedInstOperands,
     /* 253913 */     // GIR_Coverage, 11912,
     /* 253913 */     GIR_EraseRootFromParent_Done,
     /* 253914 */   // Label 4927: @253914
     /* 253914 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(253956), // Rule ID 11913 //
     /* 253919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 253927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253943 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 253943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 253946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253954 */     GIR_RootConstrainSelectedInstOperands,
     /* 253955 */     // GIR_Coverage, 11913,
     /* 253955 */     GIR_EraseRootFromParent_Done,
     /* 253956 */   // Label 4928: @253956
     /* 253956 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(253998), // Rule ID 11914 //
     /* 253961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 253969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253985 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 253985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 253988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253996 */     GIR_RootConstrainSelectedInstOperands,
     /* 253997 */     // GIR_Coverage, 11914,
     /* 253997 */     GIR_EraseRootFromParent_Done,
     /* 253998 */   // Label 4929: @253998
     /* 253998 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(254040), // Rule ID 11915 //
     /* 254003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 254011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254027 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 254027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 254030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254038 */     GIR_RootConstrainSelectedInstOperands,
     /* 254039 */     // GIR_Coverage, 11915,
     /* 254039 */     GIR_EraseRootFromParent_Done,
     /* 254040 */   // Label 4930: @254040
     /* 254040 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(254082), // Rule ID 11916 //
     /* 254045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 254053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254069 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1465:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 254072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254080 */     GIR_RootConstrainSelectedInstOperands,
     /* 254081 */     // GIR_Coverage, 11916,
     /* 254081 */     GIR_EraseRootFromParent_Done,
     /* 254082 */   // Label 4931: @254082
     /* 254082 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(254124), // Rule ID 11917 //
     /* 254087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 254095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254111 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 254111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 254114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254122 */     GIR_RootConstrainSelectedInstOperands,
     /* 254123 */     // GIR_Coverage, 11917,
     /* 254123 */     GIR_EraseRootFromParent_Done,
     /* 254124 */   // Label 4932: @254124
     /* 254124 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(254166), // Rule ID 11918 //
     /* 254129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 254137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254153 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1465:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 254153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 254156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254164 */     GIR_RootConstrainSelectedInstOperands,
     /* 254165 */     // GIR_Coverage, 11918,
     /* 254165 */     GIR_EraseRootFromParent_Done,
     /* 254166 */   // Label 4933: @254166
     /* 254166 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(254208), // Rule ID 11923 //
     /* 254171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 254179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254195 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 254198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254206 */     GIR_RootConstrainSelectedInstOperands,
     /* 254207 */     // GIR_Coverage, 11923,
     /* 254207 */     GIR_EraseRootFromParent_Done,
     /* 254208 */   // Label 4934: @254208
     /* 254208 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(254250), // Rule ID 11924 //
     /* 254213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 254221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254237 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 254240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254248 */     GIR_RootConstrainSelectedInstOperands,
     /* 254249 */     // GIR_Coverage, 11924,
     /* 254249 */     GIR_EraseRootFromParent_Done,
     /* 254250 */   // Label 4935: @254250
     /* 254250 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(254292), // Rule ID 11925 //
     /* 254255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 254263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254279 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 254282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254290 */     GIR_RootConstrainSelectedInstOperands,
     /* 254291 */     // GIR_Coverage, 11925,
     /* 254291 */     GIR_EraseRootFromParent_Done,
     /* 254292 */   // Label 4936: @254292
     /* 254292 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(254334), // Rule ID 11926 //
     /* 254297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 254305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254321 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 254324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254332 */     GIR_RootConstrainSelectedInstOperands,
     /* 254333 */     // GIR_Coverage, 11926,
     /* 254333 */     GIR_EraseRootFromParent_Done,
     /* 254334 */   // Label 4937: @254334
     /* 254334 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(254376), // Rule ID 11927 //
     /* 254339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 254347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254363 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1278:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 254366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254374 */     GIR_RootConstrainSelectedInstOperands,
     /* 254375 */     // GIR_Coverage, 11927,
     /* 254375 */     GIR_EraseRootFromParent_Done,
     /* 254376 */   // Label 4938: @254376
     /* 254376 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(254418), // Rule ID 11929 //
     /* 254381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 254389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254405 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1278:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 254408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254416 */     GIR_RootConstrainSelectedInstOperands,
     /* 254417 */     // GIR_Coverage, 11929,
     /* 254417 */     GIR_EraseRootFromParent_Done,
     /* 254418 */   // Label 4939: @254418
     /* 254418 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(254460), // Rule ID 11931 //
     /* 254423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 254431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1278:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 254450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254458 */     GIR_RootConstrainSelectedInstOperands,
     /* 254459 */     // GIR_Coverage, 11931,
     /* 254459 */     GIR_EraseRootFromParent_Done,
     /* 254460 */   // Label 4940: @254460
     /* 254460 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(254502), // Rule ID 11933 //
     /* 254465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 254473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1278:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 254492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254500 */     GIR_RootConstrainSelectedInstOperands,
     /* 254501 */     // GIR_Coverage, 11933,
     /* 254501 */     GIR_EraseRootFromParent_Done,
     /* 254502 */   // Label 4941: @254502
     /* 254502 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(254544), // Rule ID 12058 //
     /* 254507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 254510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 254515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254531 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1950:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 254534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254542 */     GIR_RootConstrainSelectedInstOperands,
     /* 254543 */     // GIR_Coverage, 12058,
     /* 254543 */     GIR_EraseRootFromParent_Done,
     /* 254544 */   // Label 4942: @254544
     /* 254544 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(254586), // Rule ID 12060 //
     /* 254549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 254552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 254557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1950:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 254576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254584 */     GIR_RootConstrainSelectedInstOperands,
     /* 254585 */     // GIR_Coverage, 12060,
     /* 254585 */     GIR_EraseRootFromParent_Done,
     /* 254586 */   // Label 4943: @254586
     /* 254586 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(254628), // Rule ID 12062 //
     /* 254591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 254594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 254599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254615 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1950:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 254618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254626 */     GIR_RootConstrainSelectedInstOperands,
     /* 254627 */     // GIR_Coverage, 12062,
     /* 254627 */     GIR_EraseRootFromParent_Done,
     /* 254628 */   // Label 4944: @254628
     /* 254628 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(254670), // Rule ID 12064 //
     /* 254633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 254636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 254641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254657 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1950:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 254660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254668 */     GIR_RootConstrainSelectedInstOperands,
     /* 254669 */     // GIR_Coverage, 12064,
     /* 254669 */     GIR_EraseRootFromParent_Done,
     /* 254670 */   // Label 4945: @254670
     /* 254670 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(254712), // Rule ID 12066 //
     /* 254675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 254678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 254683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254699 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1428:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 254702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254710 */     GIR_RootConstrainSelectedInstOperands,
     /* 254711 */     // GIR_Coverage, 12066,
     /* 254711 */     GIR_EraseRootFromParent_Done,
     /* 254712 */   // Label 4946: @254712
     /* 254712 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(254754), // Rule ID 12068 //
     /* 254717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 254720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 254725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1966:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 254744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254752 */     GIR_RootConstrainSelectedInstOperands,
     /* 254753 */     // GIR_Coverage, 12068,
     /* 254753 */     GIR_EraseRootFromParent_Done,
     /* 254754 */   // Label 4947: @254754
     /* 254754 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(254796), // Rule ID 12231 //
     /* 254759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 254762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 254767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254783 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1926:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 254786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254794 */     GIR_RootConstrainSelectedInstOperands,
     /* 254795 */     // GIR_Coverage, 12231,
     /* 254795 */     GIR_EraseRootFromParent_Done,
     /* 254796 */   // Label 4948: @254796
     /* 254796 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(254838), // Rule ID 12232 //
     /* 254801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 254804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 254809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254825 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1926:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 254828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254836 */     GIR_RootConstrainSelectedInstOperands,
     /* 254837 */     // GIR_Coverage, 12232,
     /* 254837 */     GIR_EraseRootFromParent_Done,
     /* 254838 */   // Label 4949: @254838
     /* 254838 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(254880), // Rule ID 12233 //
     /* 254843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 254846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 254851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1926:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 254870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254878 */     GIR_RootConstrainSelectedInstOperands,
     /* 254879 */     // GIR_Coverage, 12233,
     /* 254879 */     GIR_EraseRootFromParent_Done,
     /* 254880 */   // Label 4950: @254880
     /* 254880 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(254922), // Rule ID 12234 //
     /* 254885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 254888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 254893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1926:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 254912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254920 */     GIR_RootConstrainSelectedInstOperands,
     /* 254921 */     // GIR_Coverage, 12234,
     /* 254921 */     GIR_EraseRootFromParent_Done,
     /* 254922 */   // Label 4951: @254922
     /* 254922 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(254964), // Rule ID 12235 //
     /* 254927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 254930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 254935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254951 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1926:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 254954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254962 */     GIR_RootConstrainSelectedInstOperands,
     /* 254963 */     // GIR_Coverage, 12235,
     /* 254963 */     GIR_EraseRootFromParent_Done,
     /* 254964 */   // Label 4952: @254964
     /* 254964 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(255006), // Rule ID 12236 //
     /* 254969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 254972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 254977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254993 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1926:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 254996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255004 */     GIR_RootConstrainSelectedInstOperands,
     /* 255005 */     // GIR_Coverage, 12236,
     /* 255005 */     GIR_EraseRootFromParent_Done,
     /* 255006 */   // Label 4953: @255006
     /* 255006 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(255048), // Rule ID 12237 //
     /* 255011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 255014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 255019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255035 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1926:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 255038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255046 */     GIR_RootConstrainSelectedInstOperands,
     /* 255047 */     // GIR_Coverage, 12237,
     /* 255047 */     GIR_EraseRootFromParent_Done,
     /* 255048 */   // Label 4954: @255048
     /* 255048 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(255090), // Rule ID 12582 //
     /* 255053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 255061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255077 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1378:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 255080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255088 */     GIR_RootConstrainSelectedInstOperands,
     /* 255089 */     // GIR_Coverage, 12582,
     /* 255089 */     GIR_EraseRootFromParent_Done,
     /* 255090 */   // Label 4955: @255090
     /* 255090 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(255132), // Rule ID 12583 //
     /* 255095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 255103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255119 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1378:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 255122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255130 */     GIR_RootConstrainSelectedInstOperands,
     /* 255131 */     // GIR_Coverage, 12583,
     /* 255131 */     GIR_EraseRootFromParent_Done,
     /* 255132 */   // Label 4956: @255132
     /* 255132 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(255174), // Rule ID 12584 //
     /* 255137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 255145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255161 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1378:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 255164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255172 */     GIR_RootConstrainSelectedInstOperands,
     /* 255173 */     // GIR_Coverage, 12584,
     /* 255173 */     GIR_EraseRootFromParent_Done,
     /* 255174 */   // Label 4957: @255174
     /* 255174 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(255216), // Rule ID 12585 //
     /* 255179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 255187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255203 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1376:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 255206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255214 */     GIR_RootConstrainSelectedInstOperands,
     /* 255215 */     // GIR_Coverage, 12585,
     /* 255215 */     GIR_EraseRootFromParent_Done,
     /* 255216 */   // Label 4958: @255216
     /* 255216 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(255258), // Rule ID 12586 //
     /* 255221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 255229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255245 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 255248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255256 */     GIR_RootConstrainSelectedInstOperands,
     /* 255257 */     // GIR_Coverage, 12586,
     /* 255257 */     GIR_EraseRootFromParent_Done,
     /* 255258 */   // Label 4959: @255258
     /* 255258 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(255300), // Rule ID 12587 //
     /* 255263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 255271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255287 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 255290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255298 */     GIR_RootConstrainSelectedInstOperands,
     /* 255299 */     // GIR_Coverage, 12587,
     /* 255299 */     GIR_EraseRootFromParent_Done,
     /* 255300 */   // Label 4960: @255300
     /* 255300 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(255342), // Rule ID 12588 //
     /* 255305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255329 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1377:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 255332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255340 */     GIR_RootConstrainSelectedInstOperands,
     /* 255341 */     // GIR_Coverage, 12588,
     /* 255341 */     GIR_EraseRootFromParent_Done,
     /* 255342 */   // Label 4961: @255342
     /* 255342 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(255384), // Rule ID 12591 //
     /* 255347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 255358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 255364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 255367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255371 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1377:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 255371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 255374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255382 */     GIR_RootConstrainSelectedInstOperands,
     /* 255383 */     // GIR_Coverage, 12591,
     /* 255383 */     GIR_EraseRootFromParent_Done,
     /* 255384 */   // Label 4962: @255384
     /* 255384 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(255426), // Rule ID 12594 //
     /* 255389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 255400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 255406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 255409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255413 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 255413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 255416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255424 */     GIR_RootConstrainSelectedInstOperands,
     /* 255425 */     // GIR_Coverage, 12594,
     /* 255425 */     GIR_EraseRootFromParent_Done,
     /* 255426 */   // Label 4963: @255426
     /* 255426 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(255468), // Rule ID 12597 //
     /* 255431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255455 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1377:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 255458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255466 */     GIR_RootConstrainSelectedInstOperands,
     /* 255467 */     // GIR_Coverage, 12597,
     /* 255467 */     GIR_EraseRootFromParent_Done,
     /* 255468 */   // Label 4964: @255468
     /* 255468 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(255510), // Rule ID 12600 //
     /* 255473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 255484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 255490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 255493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255497 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 255497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 255500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255508 */     GIR_RootConstrainSelectedInstOperands,
     /* 255509 */     // GIR_Coverage, 12600,
     /* 255509 */     GIR_EraseRootFromParent_Done,
     /* 255510 */   // Label 4965: @255510
     /* 255510 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(255552), // Rule ID 12603 //
     /* 255515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255539 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 255542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255550 */     GIR_RootConstrainSelectedInstOperands,
     /* 255551 */     // GIR_Coverage, 12603,
     /* 255551 */     GIR_EraseRootFromParent_Done,
     /* 255552 */   // Label 4966: @255552
     /* 255552 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(255594), // Rule ID 12606 //
     /* 255557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255581 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1379:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 255584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255592 */     GIR_RootConstrainSelectedInstOperands,
     /* 255593 */     // GIR_Coverage, 12606,
     /* 255593 */     GIR_EraseRootFromParent_Done,
     /* 255594 */   // Label 4967: @255594
     /* 255594 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(255636), // Rule ID 12609 //
     /* 255599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 255610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 255616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 255619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255623 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1379:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 255623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 255626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255634 */     GIR_RootConstrainSelectedInstOperands,
     /* 255635 */     // GIR_Coverage, 12609,
     /* 255635 */     GIR_EraseRootFromParent_Done,
     /* 255636 */   // Label 4968: @255636
     /* 255636 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(255678), // Rule ID 12612 //
     /* 255641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 255652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 255658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 255661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255665 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 255665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 255668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255676 */     GIR_RootConstrainSelectedInstOperands,
     /* 255677 */     // GIR_Coverage, 12612,
     /* 255677 */     GIR_EraseRootFromParent_Done,
     /* 255678 */   // Label 4969: @255678
     /* 255678 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(255720), // Rule ID 12615 //
     /* 255683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255707 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1379:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 255710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255718 */     GIR_RootConstrainSelectedInstOperands,
     /* 255719 */     // GIR_Coverage, 12615,
     /* 255719 */     GIR_EraseRootFromParent_Done,
     /* 255720 */   // Label 4970: @255720
     /* 255720 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(255762), // Rule ID 12618 //
     /* 255725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 255736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 255742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 255745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255749 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 255749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 255752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255760 */     GIR_RootConstrainSelectedInstOperands,
     /* 255761 */     // GIR_Coverage, 12618,
     /* 255761 */     GIR_EraseRootFromParent_Done,
     /* 255762 */   // Label 4971: @255762
     /* 255762 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(255804), // Rule ID 12621 //
     /* 255767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255791 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 255794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255802 */     GIR_RootConstrainSelectedInstOperands,
     /* 255803 */     // GIR_Coverage, 12621,
     /* 255803 */     GIR_EraseRootFromParent_Done,
     /* 255804 */   // Label 4972: @255804
     /* 255804 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(255947), // Rule ID 5600 //
     /* 255809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 255812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 255817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 255820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 255823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 255826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255830 */     // MIs[0] idx
     /* 255830 */     // No operand predicates
     /* 255830 */     // (intrinsic_wo_chain:{ *:[v16i8] } 775:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 255830 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 255833 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255837 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 255844 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 255847 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255851 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255856 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 255859 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 255863 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 255866 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255871 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255876 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 255884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 255895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 255898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255907 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 255910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 255914 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 255917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 255935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 255943 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 255945 */     GIR_RootConstrainSelectedInstOperands,
     /* 255946 */     // GIR_Coverage, 5600,
     /* 255946 */     GIR_EraseRootFromParent_Done,
     /* 255947 */   // Label 4973: @255947
     /* 255947 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(256038), // Rule ID 5601 //
     /* 255952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 255955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 255960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 255963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 255966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 255969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255973 */     // MIs[0] idx
     /* 255973 */     // No operand predicates
     /* 255973 */     // (intrinsic_wo_chain:{ *:[v16i8] } 776:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 255973 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 255976 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255980 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 255987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 255990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255999 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256006 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 256027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256034 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256036 */     GIR_RootConstrainSelectedInstOperands,
     /* 256037 */     // GIR_Coverage, 5601,
     /* 256037 */     GIR_EraseRootFromParent_Done,
     /* 256038 */   // Label 4974: @256038
     /* 256038 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(256129), // Rule ID 5602 //
     /* 256043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 256051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256064 */     // MIs[0] idx
     /* 256064 */     // No operand predicates
     /* 256064 */     // (intrinsic_wo_chain:{ *:[v16i8] } 775:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256064 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256067 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256071 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256090 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256097 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 256118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256125 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256127 */     GIR_RootConstrainSelectedInstOperands,
     /* 256128 */     // GIR_Coverage, 5602,
     /* 256128 */     GIR_EraseRootFromParent_Done,
     /* 256129 */   // Label 4975: @256129
     /* 256129 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(256168), // Rule ID 5603 //
     /* 256134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 256142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256155 */     // MIs[0] idx
     /* 256155 */     // No operand predicates
     /* 256155 */     // (intrinsic_wo_chain:{ *:[v16i8] } 776:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 256158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256164 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256166 */     GIR_RootConstrainSelectedInstOperands,
     /* 256167 */     // GIR_Coverage, 5603,
     /* 256167 */     GIR_EraseRootFromParent_Done,
     /* 256168 */   // Label 4976: @256168
     /* 256168 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(256311), // Rule ID 5604 //
     /* 256173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 256181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256194 */     // MIs[0] idx
     /* 256194 */     // No operand predicates
     /* 256194 */     // (intrinsic_wo_chain:{ *:[v8i16] } 775:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256194 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 256197 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256201 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 256208 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 256211 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256215 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256220 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 256223 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256227 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 256230 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256235 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256240 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256248 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256252 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256271 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 256307 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256309 */     GIR_RootConstrainSelectedInstOperands,
     /* 256310 */     // GIR_Coverage, 5604,
     /* 256310 */     GIR_EraseRootFromParent_Done,
     /* 256311 */   // Label 4977: @256311
     /* 256311 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(256402), // Rule ID 5605 //
     /* 256316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 256324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256337 */     // MIs[0] idx
     /* 256337 */     // No operand predicates
     /* 256337 */     // (intrinsic_wo_chain:{ *:[v8i16] } 776:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256337 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256340 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256344 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256370 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256398 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256400 */     GIR_RootConstrainSelectedInstOperands,
     /* 256401 */     // GIR_Coverage, 5605,
     /* 256401 */     GIR_EraseRootFromParent_Done,
     /* 256402 */   // Label 4978: @256402
     /* 256402 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(256493), // Rule ID 5606 //
     /* 256407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 256415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256428 */     // MIs[0] idx
     /* 256428 */     // No operand predicates
     /* 256428 */     // (intrinsic_wo_chain:{ *:[v8i16] } 775:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256428 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256431 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256435 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256454 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256489 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256491 */     GIR_RootConstrainSelectedInstOperands,
     /* 256492 */     // GIR_Coverage, 5606,
     /* 256492 */     GIR_EraseRootFromParent_Done,
     /* 256493 */   // Label 4979: @256493
     /* 256493 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(256532), // Rule ID 5607 //
     /* 256498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 256506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256519 */     // MIs[0] idx
     /* 256519 */     // No operand predicates
     /* 256519 */     // (intrinsic_wo_chain:{ *:[v8i16] } 776:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256528 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256530 */     GIR_RootConstrainSelectedInstOperands,
     /* 256531 */     // GIR_Coverage, 5607,
     /* 256531 */     GIR_EraseRootFromParent_Done,
     /* 256532 */   // Label 4980: @256532
     /* 256532 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(256675), // Rule ID 5608 //
     /* 256537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 256545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256558 */     // MIs[0] idx
     /* 256558 */     // No operand predicates
     /* 256558 */     // (intrinsic_wo_chain:{ *:[v8f16] } 775:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256558 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 256561 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256565 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 256572 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 256575 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256579 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256584 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 256587 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256591 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 256594 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256599 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256604 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256609 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256612 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256616 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256642 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 256671 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256673 */     GIR_RootConstrainSelectedInstOperands,
     /* 256674 */     // GIR_Coverage, 5608,
     /* 256674 */     GIR_EraseRootFromParent_Done,
     /* 256675 */   // Label 4981: @256675
     /* 256675 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(256766), // Rule ID 5609 //
     /* 256680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 256688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256701 */     // MIs[0] idx
     /* 256701 */     // No operand predicates
     /* 256701 */     // (intrinsic_wo_chain:{ *:[v8f16] } 776:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256701 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256704 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256708 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256727 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256762 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256764 */     GIR_RootConstrainSelectedInstOperands,
     /* 256765 */     // GIR_Coverage, 5609,
     /* 256765 */     GIR_EraseRootFromParent_Done,
     /* 256766 */   // Label 4982: @256766
     /* 256766 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(256857), // Rule ID 5610 //
     /* 256771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 256779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256792 */     // MIs[0] idx
     /* 256792 */     // No operand predicates
     /* 256792 */     // (intrinsic_wo_chain:{ *:[v8f16] } 775:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256792 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256795 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256799 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256818 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256853 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256855 */     GIR_RootConstrainSelectedInstOperands,
     /* 256856 */     // GIR_Coverage, 5610,
     /* 256856 */     GIR_EraseRootFromParent_Done,
     /* 256857 */   // Label 4983: @256857
     /* 256857 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(256896), // Rule ID 5611 //
     /* 256862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 256870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256883 */     // MIs[0] idx
     /* 256883 */     // No operand predicates
     /* 256883 */     // (intrinsic_wo_chain:{ *:[v8f16] } 776:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256892 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256894 */     GIR_RootConstrainSelectedInstOperands,
     /* 256895 */     // GIR_Coverage, 5611,
     /* 256895 */     GIR_EraseRootFromParent_Done,
     /* 256896 */   // Label 4984: @256896
     /* 256896 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(256935), // Rule ID 5612 //
     /* 256901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 256909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256922 */     // MIs[0] idx
     /* 256922 */     // No operand predicates
     /* 256922 */     // (intrinsic_wo_chain:{ *:[v16i8] } 779:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 256922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 256925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256931 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256933 */     GIR_RootConstrainSelectedInstOperands,
     /* 256934 */     // GIR_Coverage, 5612,
     /* 256934 */     GIR_EraseRootFromParent_Done,
     /* 256935 */   // Label 4985: @256935
     /* 256935 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(257026), // Rule ID 5613 //
     /* 256940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 256948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256961 */     // MIs[0] idx
     /* 256961 */     // No operand predicates
     /* 256961 */     // (intrinsic_wo_chain:{ *:[v16i8] } 777:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 256961 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256964 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256968 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256987 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256994 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 257015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257022 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257024 */     GIR_RootConstrainSelectedInstOperands,
     /* 257025 */     // GIR_Coverage, 5613,
     /* 257025 */     GIR_EraseRootFromParent_Done,
     /* 257026 */   // Label 4986: @257026
     /* 257026 */   GIM_Reject,
     /* 257027 */ // Label 4126: @257027
     /* 257027 */ GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(264138),
     /* 257032 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 257035 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(257082), // Rule ID 2958 //
     /* 257040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 257048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 257051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 257054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 257063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257067 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1610:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 257067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 257070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257078 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257080 */     GIR_RootConstrainSelectedInstOperands,
     /* 257081 */     // GIR_Coverage, 2958,
     /* 257081 */     GIR_EraseRootFromParent_Done,
     /* 257082 */   // Label 4988: @257082
     /* 257082 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(257129), // Rule ID 2960 //
     /* 257087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 257095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 257110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1610:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 257114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 257117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257125 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257127 */     GIR_RootConstrainSelectedInstOperands,
     /* 257128 */     // GIR_Coverage, 2960,
     /* 257128 */     GIR_EraseRootFromParent_Done,
     /* 257129 */   // Label 4989: @257129
     /* 257129 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(257176), // Rule ID 2962 //
     /* 257134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 257142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 257157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1610:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 257161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 257164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257172 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257174 */     GIR_RootConstrainSelectedInstOperands,
     /* 257175 */     // GIR_Coverage, 2962,
     /* 257175 */     GIR_EraseRootFromParent_Done,
     /* 257176 */   // Label 4990: @257176
     /* 257176 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(257223), // Rule ID 2964 //
     /* 257181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 257189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 257204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1610:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 257208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 257211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257219 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257221 */     GIR_RootConstrainSelectedInstOperands,
     /* 257222 */     // GIR_Coverage, 2964,
     /* 257222 */     GIR_EraseRootFromParent_Done,
     /* 257223 */   // Label 4991: @257223
     /* 257223 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(257270), // Rule ID 7632 //
     /* 257228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 257236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 257239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 257242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 257251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257255 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1613:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 257255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 257258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257266 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257268 */     GIR_RootConstrainSelectedInstOperands,
     /* 257269 */     // GIR_Coverage, 7632,
     /* 257269 */     GIR_EraseRootFromParent_Done,
     /* 257270 */   // Label 4992: @257270
     /* 257270 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(257317), // Rule ID 7634 //
     /* 257275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 257283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 257298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1613:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 257302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 257305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257313 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257315 */     GIR_RootConstrainSelectedInstOperands,
     /* 257316 */     // GIR_Coverage, 7634,
     /* 257316 */     GIR_EraseRootFromParent_Done,
     /* 257317 */   // Label 4993: @257317
     /* 257317 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(257364), // Rule ID 7636 //
     /* 257322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 257330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 257345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257349 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1613:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 257349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 257352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257360 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257362 */     GIR_RootConstrainSelectedInstOperands,
     /* 257363 */     // GIR_Coverage, 7636,
     /* 257363 */     GIR_EraseRootFromParent_Done,
     /* 257364 */   // Label 4994: @257364
     /* 257364 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(257411), // Rule ID 7638 //
     /* 257369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 257377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 257392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257396 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1613:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 257396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 257399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257407 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257409 */     GIR_RootConstrainSelectedInstOperands,
     /* 257410 */     // GIR_Coverage, 7638,
     /* 257410 */     GIR_EraseRootFromParent_Done,
     /* 257411 */   // Label 4995: @257411
     /* 257411 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(257491), // Rule ID 5722 //
     /* 257416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 257421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 257436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 257456 */     // MIs[1] Operand 1
     /* 257456 */     // No operand predicates
     /* 257456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 257464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257468 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 257472 */     // MIs[2] Operand 1
     /* 257472 */     // No operand predicates
     /* 257472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257474 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 257474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 257477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 257484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 257486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 257489 */     GIR_RootConstrainSelectedInstOperands,
     /* 257490 */     // GIR_Coverage, 5722,
     /* 257490 */     GIR_EraseRootFromParent_Done,
     /* 257491 */   // Label 4996: @257491
     /* 257491 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(257571), // Rule ID 5723 //
     /* 257496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 257501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 257513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 257516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257536 */     // MIs[1] Operand 1
     /* 257536 */     // No operand predicates
     /* 257536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 257544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257548 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257552 */     // MIs[2] Operand 1
     /* 257552 */     // No operand predicates
     /* 257552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257554 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 257554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 257557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 257564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 257566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 257569 */     GIR_RootConstrainSelectedInstOperands,
     /* 257570 */     // GIR_Coverage, 5723,
     /* 257570 */     GIR_EraseRootFromParent_Done,
     /* 257571 */   // Label 4997: @257571
     /* 257571 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(257651), // Rule ID 5724 //
     /* 257576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 257581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 257596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 257616 */     // MIs[1] Operand 1
     /* 257616 */     // No operand predicates
     /* 257616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 257624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 257632 */     // MIs[2] Operand 1
     /* 257632 */     // No operand predicates
     /* 257632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257634 */     // (intrinsic_wo_chain:{ *:[v4i32] } 768:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 257634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 257637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 257644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 257646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 257649 */     GIR_RootConstrainSelectedInstOperands,
     /* 257650 */     // GIR_Coverage, 5724,
     /* 257650 */     GIR_EraseRootFromParent_Done,
     /* 257651 */   // Label 4998: @257651
     /* 257651 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(257731), // Rule ID 5725 //
     /* 257656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 257661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 257664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 257667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 257673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 257676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 257696 */     // MIs[1] Operand 1
     /* 257696 */     // No operand predicates
     /* 257696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 257704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257708 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 257712 */     // MIs[2] Operand 1
     /* 257712 */     // No operand predicates
     /* 257712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257714 */     // (intrinsic_wo_chain:{ *:[v2i64] } 768:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 257714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 257717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 257724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 257726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 257729 */     GIR_RootConstrainSelectedInstOperands,
     /* 257730 */     // GIR_Coverage, 5725,
     /* 257730 */     GIR_EraseRootFromParent_Done,
     /* 257731 */   // Label 4999: @257731
     /* 257731 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(257795), // Rule ID 3846 //
     /* 257736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 257739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 257744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257772 */     // MIs[0] imm
     /* 257772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 257780 */     // (intrinsic_wo_chain:{ *:[v4i32] } 544:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 257780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 257783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 257785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 257789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 257791 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 257793 */     GIR_RootConstrainSelectedInstOperands,
     /* 257794 */     // GIR_Coverage, 3846,
     /* 257794 */     GIR_EraseRootFromParent_Done,
     /* 257795 */   // Label 5000: @257795
     /* 257795 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(257859), // Rule ID 3847 //
     /* 257800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 257803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 257808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257836 */     // MIs[0] imm
     /* 257836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257839 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 257844 */     // (intrinsic_wo_chain:{ *:[v4i32] } 545:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 257844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 257847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 257849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 257853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 257855 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 257857 */     GIR_RootConstrainSelectedInstOperands,
     /* 257858 */     // GIR_Coverage, 3847,
     /* 257858 */     GIR_EraseRootFromParent_Done,
     /* 257859 */   // Label 5001: @257859
     /* 257859 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(257923), // Rule ID 3848 //
     /* 257864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 257867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 257872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257900 */     // MIs[0] imm
     /* 257900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 257908 */     // (intrinsic_wo_chain:{ *:[v4i32] } 546:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 257908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 257911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 257913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 257917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 257919 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 257921 */     GIR_RootConstrainSelectedInstOperands,
     /* 257922 */     // GIR_Coverage, 3848,
     /* 257922 */     GIR_EraseRootFromParent_Done,
     /* 257923 */   // Label 5002: @257923
     /* 257923 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(257987), // Rule ID 3849 //
     /* 257928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 257931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 257936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257964 */     // MIs[0] imm
     /* 257964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 257972 */     // (intrinsic_wo_chain:{ *:[v4i32] } 547:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 257972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 257975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 257977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 257981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 257983 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 257985 */     GIR_RootConstrainSelectedInstOperands,
     /* 257986 */     // GIR_Coverage, 3849,
     /* 257986 */     GIR_EraseRootFromParent_Done,
     /* 257987 */   // Label 5003: @257987
     /* 257987 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(258039), // Rule ID 2843 //
     /* 257992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 258000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258016 */     // MIs[0] idx
     /* 258016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258024 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 258024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 258027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258035 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258037 */     GIR_RootConstrainSelectedInstOperands,
     /* 258038 */     // GIR_Coverage, 2843,
     /* 258038 */     GIR_EraseRootFromParent_Done,
     /* 258039 */   // Label 5004: @258039
     /* 258039 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(258091), // Rule ID 2844 //
     /* 258044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 258052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258068 */     // MIs[0] idx
     /* 258068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258076 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 258079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258087 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258089 */     GIR_RootConstrainSelectedInstOperands,
     /* 258090 */     // GIR_Coverage, 2844,
     /* 258090 */     GIR_EraseRootFromParent_Done,
     /* 258091 */   // Label 5005: @258091
     /* 258091 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(258143), // Rule ID 2845 //
     /* 258096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 258104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258120 */     // MIs[0] idx
     /* 258120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 258128 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 258131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258139 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258141 */     GIR_RootConstrainSelectedInstOperands,
     /* 258142 */     // GIR_Coverage, 2845,
     /* 258142 */     GIR_EraseRootFromParent_Done,
     /* 258143 */   // Label 5006: @258143
     /* 258143 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(258195), // Rule ID 2973 //
     /* 258148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 258156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258172 */     // MIs[0] Op4
     /* 258172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 258180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 258183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258191 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258193 */     GIR_RootConstrainSelectedInstOperands,
     /* 258194 */     // GIR_Coverage, 2973,
     /* 258194 */     GIR_EraseRootFromParent_Done,
     /* 258195 */   // Label 5007: @258195
     /* 258195 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(258247), // Rule ID 2974 //
     /* 258200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 258208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258224 */     // MIs[0] Op4
     /* 258224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 258235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258243 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258245 */     GIR_RootConstrainSelectedInstOperands,
     /* 258246 */     // GIR_Coverage, 2974,
     /* 258246 */     GIR_EraseRootFromParent_Done,
     /* 258247 */   // Label 5008: @258247
     /* 258247 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(258299), // Rule ID 2975 //
     /* 258252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 258260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258276 */     // MIs[0] Op4
     /* 258276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 258284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 258284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 258287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258295 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258297 */     GIR_RootConstrainSelectedInstOperands,
     /* 258298 */     // GIR_Coverage, 2975,
     /* 258298 */     GIR_EraseRootFromParent_Done,
     /* 258299 */   // Label 5009: @258299
     /* 258299 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(258351), // Rule ID 2976 //
     /* 258304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 258312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258328 */     // MIs[0] Op4
     /* 258328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 258336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 258339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258347 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258349 */     GIR_RootConstrainSelectedInstOperands,
     /* 258350 */     // GIR_Coverage, 2976,
     /* 258350 */     GIR_EraseRootFromParent_Done,
     /* 258351 */   // Label 5010: @258351
     /* 258351 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(258403), // Rule ID 2977 //
     /* 258356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 258364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258380 */     // MIs[0] Op4
     /* 258380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258383 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258388 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 258391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258399 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258401 */     GIR_RootConstrainSelectedInstOperands,
     /* 258402 */     // GIR_Coverage, 2977,
     /* 258402 */     GIR_EraseRootFromParent_Done,
     /* 258403 */   // Label 5011: @258403
     /* 258403 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(258455), // Rule ID 2980 //
     /* 258408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 258416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258432 */     // MIs[0] Op4
     /* 258432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 258443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258451 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258453 */     GIR_RootConstrainSelectedInstOperands,
     /* 258454 */     // GIR_Coverage, 2980,
     /* 258454 */     GIR_EraseRootFromParent_Done,
     /* 258455 */   // Label 5012: @258455
     /* 258455 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(258507), // Rule ID 2981 //
     /* 258460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 258468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258484 */     // MIs[0] Op4
     /* 258484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258487 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 258492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 258492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 258495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258503 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258505 */     GIR_RootConstrainSelectedInstOperands,
     /* 258506 */     // GIR_Coverage, 2981,
     /* 258506 */     GIR_EraseRootFromParent_Done,
     /* 258507 */   // Label 5013: @258507
     /* 258507 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(258559), // Rule ID 3455 //
     /* 258512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 258515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 258520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258536 */     // MIs[0] Op4
     /* 258536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 258547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258555 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258557 */     GIR_RootConstrainSelectedInstOperands,
     /* 258558 */     // GIR_Coverage, 3455,
     /* 258558 */     GIR_EraseRootFromParent_Done,
     /* 258559 */   // Label 5014: @258559
     /* 258559 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(258611), // Rule ID 3499 //
     /* 258564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 258567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 258572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258588 */     // MIs[0] Op4
     /* 258588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258591 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 258599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258607 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258609 */     GIR_RootConstrainSelectedInstOperands,
     /* 258610 */     // GIR_Coverage, 3499,
     /* 258610 */     GIR_EraseRootFromParent_Done,
     /* 258611 */   // Label 5015: @258611
     /* 258611 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(258663), // Rule ID 7706 //
     /* 258616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 258624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258640 */     // MIs[0] Op4
     /* 258640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1964:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 258651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258659 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258661 */     GIR_RootConstrainSelectedInstOperands,
     /* 258662 */     // GIR_Coverage, 7706,
     /* 258662 */     GIR_EraseRootFromParent_Done,
     /* 258663 */   // Label 5016: @258663
     /* 258663 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(258715), // Rule ID 7707 //
     /* 258668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 258676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258692 */     // MIs[0] Op4
     /* 258692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 258700 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1964:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 258700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 258703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258711 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258713 */     GIR_RootConstrainSelectedInstOperands,
     /* 258714 */     // GIR_Coverage, 7707,
     /* 258714 */     GIR_EraseRootFromParent_Done,
     /* 258715 */   // Label 5017: @258715
     /* 258715 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(258767), // Rule ID 8347 //
     /* 258720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 258728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258744 */     // MIs[0] idx
     /* 258744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258752 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1476:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 258752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 258755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258763 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258765 */     GIR_RootConstrainSelectedInstOperands,
     /* 258766 */     // GIR_Coverage, 8347,
     /* 258766 */     GIR_EraseRootFromParent_Done,
     /* 258767 */   // Label 5018: @258767
     /* 258767 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(258819), // Rule ID 8348 //
     /* 258772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 258780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258796 */     // MIs[0] idx
     /* 258796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258804 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 258807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258815 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258817 */     GIR_RootConstrainSelectedInstOperands,
     /* 258818 */     // GIR_Coverage, 8348,
     /* 258818 */     GIR_EraseRootFromParent_Done,
     /* 258819 */   // Label 5019: @258819
     /* 258819 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(258871), // Rule ID 8349 //
     /* 258824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 258832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258848 */     // MIs[0] idx
     /* 258848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 258856 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1476:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 258859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258867 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258869 */     GIR_RootConstrainSelectedInstOperands,
     /* 258870 */     // GIR_Coverage, 8349,
     /* 258870 */     GIR_EraseRootFromParent_Done,
     /* 258871 */   // Label 5020: @258871
     /* 258871 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(258923), // Rule ID 11313 //
     /* 258876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 258879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 258884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258900 */     // MIs[0] Op4
     /* 258900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1913:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 258911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258919 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258921 */     GIR_RootConstrainSelectedInstOperands,
     /* 258922 */     // GIR_Coverage, 11313,
     /* 258922 */     GIR_EraseRootFromParent_Done,
     /* 258923 */   // Label 5021: @258923
     /* 258923 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(258975), // Rule ID 11360 //
     /* 258928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 258936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258952 */     // MIs[0] Op4
     /* 258952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258960 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1612:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 258960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 258963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258971 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258973 */     GIR_RootConstrainSelectedInstOperands,
     /* 258974 */     // GIR_Coverage, 11360,
     /* 258974 */     GIR_EraseRootFromParent_Done,
     /* 258975 */   // Label 5022: @258975
     /* 258975 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(259027), // Rule ID 11361 //
     /* 258980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 258988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259004 */     // MIs[0] Op4
     /* 259004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259007 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259012 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 259015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259023 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259025 */     GIR_RootConstrainSelectedInstOperands,
     /* 259026 */     // GIR_Coverage, 11361,
     /* 259026 */     GIR_EraseRootFromParent_Done,
     /* 259027 */   // Label 5023: @259027
     /* 259027 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(259079), // Rule ID 11362 //
     /* 259032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 259040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259056 */     // MIs[0] Op4
     /* 259056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259064 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 259064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 259067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259073 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259075 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259077 */     GIR_RootConstrainSelectedInstOperands,
     /* 259078 */     // GIR_Coverage, 11362,
     /* 259078 */     GIR_EraseRootFromParent_Done,
     /* 259079 */   // Label 5024: @259079
     /* 259079 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(259131), // Rule ID 11363 //
     /* 259084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 259092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259108 */     // MIs[0] Op4
     /* 259108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259111 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1830:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 259119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259127 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259129 */     GIR_RootConstrainSelectedInstOperands,
     /* 259130 */     // GIR_Coverage, 11363,
     /* 259130 */     GIR_EraseRootFromParent_Done,
     /* 259131 */   // Label 5025: @259131
     /* 259131 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(259183), // Rule ID 11364 //
     /* 259136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 259144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259160 */     // MIs[0] Op4
     /* 259160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1830:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 259171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259179 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259181 */     GIR_RootConstrainSelectedInstOperands,
     /* 259182 */     // GIR_Coverage, 11364,
     /* 259182 */     GIR_EraseRootFromParent_Done,
     /* 259183 */   // Label 5026: @259183
     /* 259183 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(259235), // Rule ID 11365 //
     /* 259188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 259196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259212 */     // MIs[0] Op4
     /* 259212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259215 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1830:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 259220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 259223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259231 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259233 */     GIR_RootConstrainSelectedInstOperands,
     /* 259234 */     // GIR_Coverage, 11365,
     /* 259234 */     GIR_EraseRootFromParent_Done,
     /* 259235 */   // Label 5027: @259235
     /* 259235 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(259287), // Rule ID 11366 //
     /* 259240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 259248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259264 */     // MIs[0] Op4
     /* 259264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259272 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1832:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 259275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259283 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259285 */     GIR_RootConstrainSelectedInstOperands,
     /* 259286 */     // GIR_Coverage, 11366,
     /* 259286 */     GIR_EraseRootFromParent_Done,
     /* 259287 */   // Label 5028: @259287
     /* 259287 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(259339), // Rule ID 11367 //
     /* 259292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 259300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259316 */     // MIs[0] Op4
     /* 259316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259319 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1832:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 259327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259335 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259337 */     GIR_RootConstrainSelectedInstOperands,
     /* 259338 */     // GIR_Coverage, 11367,
     /* 259338 */     GIR_EraseRootFromParent_Done,
     /* 259339 */   // Label 5029: @259339
     /* 259339 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(259391), // Rule ID 11368 //
     /* 259344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 259352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259368 */     // MIs[0] Op4
     /* 259368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1832:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 259376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 259379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259387 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259389 */     GIR_RootConstrainSelectedInstOperands,
     /* 259390 */     // GIR_Coverage, 11368,
     /* 259390 */     GIR_EraseRootFromParent_Done,
     /* 259391 */   // Label 5030: @259391
     /* 259391 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(259443), // Rule ID 11411 //
     /* 259396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 259404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259420 */     // MIs[0] Op4
     /* 259420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 259431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259439 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259441 */     GIR_RootConstrainSelectedInstOperands,
     /* 259442 */     // GIR_Coverage, 11411,
     /* 259442 */     GIR_EraseRootFromParent_Done,
     /* 259443 */   // Label 5031: @259443
     /* 259443 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(259495), // Rule ID 11412 //
     /* 259448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 259456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259472 */     // MIs[0] Op4
     /* 259472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259480 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 259483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259491 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259493 */     GIR_RootConstrainSelectedInstOperands,
     /* 259494 */     // GIR_Coverage, 11412,
     /* 259494 */     GIR_EraseRootFromParent_Done,
     /* 259495 */   // Label 5032: @259495
     /* 259495 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(259547), // Rule ID 11413 //
     /* 259500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 259508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259524 */     // MIs[0] Op4
     /* 259524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1989:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 259535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259543 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259545 */     GIR_RootConstrainSelectedInstOperands,
     /* 259546 */     // GIR_Coverage, 11413,
     /* 259546 */     GIR_EraseRootFromParent_Done,
     /* 259547 */   // Label 5033: @259547
     /* 259547 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(259599), // Rule ID 11414 //
     /* 259552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 259560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259576 */     // MIs[0] Op4
     /* 259576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1989:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 259587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259595 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259597 */     GIR_RootConstrainSelectedInstOperands,
     /* 259598 */     // GIR_Coverage, 11414,
     /* 259598 */     GIR_EraseRootFromParent_Done,
     /* 259599 */   // Label 5034: @259599
     /* 259599 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(259651), // Rule ID 11415 //
     /* 259604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 259612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259628 */     // MIs[0] Op4
     /* 259628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 259639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259647 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259649 */     GIR_RootConstrainSelectedInstOperands,
     /* 259650 */     // GIR_Coverage, 11415,
     /* 259650 */     GIR_EraseRootFromParent_Done,
     /* 259651 */   // Label 5035: @259651
     /* 259651 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(259703), // Rule ID 11416 //
     /* 259656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 259664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259680 */     // MIs[0] Op4
     /* 259680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259683 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 259691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259699 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259701 */     GIR_RootConstrainSelectedInstOperands,
     /* 259702 */     // GIR_Coverage, 11416,
     /* 259702 */     GIR_EraseRootFromParent_Done,
     /* 259703 */   // Label 5036: @259703
     /* 259703 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(259755), // Rule ID 11417 //
     /* 259708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 259716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259732 */     // MIs[0] Op4
     /* 259732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 259743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259751 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259753 */     GIR_RootConstrainSelectedInstOperands,
     /* 259754 */     // GIR_Coverage, 11417,
     /* 259754 */     GIR_EraseRootFromParent_Done,
     /* 259755 */   // Label 5037: @259755
     /* 259755 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(259807), // Rule ID 11418 //
     /* 259760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 259768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259784 */     // MIs[0] Op4
     /* 259784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259792 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 259795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259803 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259805 */     GIR_RootConstrainSelectedInstOperands,
     /* 259806 */     // GIR_Coverage, 11418,
     /* 259806 */     GIR_EraseRootFromParent_Done,
     /* 259807 */   // Label 5038: @259807
     /* 259807 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(259859), // Rule ID 11419 //
     /* 259812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 259820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259836 */     // MIs[0] Op4
     /* 259836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259839 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 259847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259855 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259857 */     GIR_RootConstrainSelectedInstOperands,
     /* 259858 */     // GIR_Coverage, 11419,
     /* 259858 */     GIR_EraseRootFromParent_Done,
     /* 259859 */   // Label 5039: @259859
     /* 259859 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(259911), // Rule ID 11420 //
     /* 259864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 259872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259888 */     // MIs[0] Op4
     /* 259888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 259899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259907 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259909 */     GIR_RootConstrainSelectedInstOperands,
     /* 259910 */     // GIR_Coverage, 11420,
     /* 259910 */     GIR_EraseRootFromParent_Done,
     /* 259911 */   // Label 5040: @259911
     /* 259911 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(259963), // Rule ID 11421 //
     /* 259916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 259924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259940 */     // MIs[0] Op4
     /* 259940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 259951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259959 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259961 */     GIR_RootConstrainSelectedInstOperands,
     /* 259962 */     // GIR_Coverage, 11421,
     /* 259962 */     GIR_EraseRootFromParent_Done,
     /* 259963 */   // Label 5041: @259963
     /* 259963 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(260015), // Rule ID 11422 //
     /* 259968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 259976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259992 */     // MIs[0] Op4
     /* 259992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260000 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 260003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260011 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260013 */     GIR_RootConstrainSelectedInstOperands,
     /* 260014 */     // GIR_Coverage, 11422,
     /* 260014 */     GIR_EraseRootFromParent_Done,
     /* 260015 */   // Label 5042: @260015
     /* 260015 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(260067), // Rule ID 11423 //
     /* 260020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 260028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260044 */     // MIs[0] Op4
     /* 260044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260047 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 260055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260063 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260065 */     GIR_RootConstrainSelectedInstOperands,
     /* 260066 */     // GIR_Coverage, 11423,
     /* 260066 */     GIR_EraseRootFromParent_Done,
     /* 260067 */   // Label 5043: @260067
     /* 260067 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(260119), // Rule ID 11424 //
     /* 260072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 260080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260096 */     // MIs[0] Op4
     /* 260096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 260107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260115 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260117 */     GIR_RootConstrainSelectedInstOperands,
     /* 260118 */     // GIR_Coverage, 11424,
     /* 260118 */     GIR_EraseRootFromParent_Done,
     /* 260119 */   // Label 5044: @260119
     /* 260119 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(260171), // Rule ID 11446 //
     /* 260124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 260132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260148 */     // MIs[0] Op4
     /* 260148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1793:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 260159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260167 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260169 */     GIR_RootConstrainSelectedInstOperands,
     /* 260170 */     // GIR_Coverage, 11446,
     /* 260170 */     GIR_EraseRootFromParent_Done,
     /* 260171 */   // Label 5045: @260171
     /* 260171 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(260223), // Rule ID 11447 //
     /* 260176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 260184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260200 */     // MIs[0] Op4
     /* 260200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 260211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260219 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260221 */     GIR_RootConstrainSelectedInstOperands,
     /* 260222 */     // GIR_Coverage, 11447,
     /* 260222 */     GIR_EraseRootFromParent_Done,
     /* 260223 */   // Label 5046: @260223
     /* 260223 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(260275), // Rule ID 11448 //
     /* 260228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 260236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260252 */     // MIs[0] Op4
     /* 260252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 260263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260271 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260273 */     GIR_RootConstrainSelectedInstOperands,
     /* 260274 */     // GIR_Coverage, 11448,
     /* 260274 */     GIR_EraseRootFromParent_Done,
     /* 260275 */   // Label 5047: @260275
     /* 260275 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(260327), // Rule ID 11449 //
     /* 260280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 260288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260304 */     // MIs[0] Op4
     /* 260304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260307 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260312 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 260315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260323 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260325 */     GIR_RootConstrainSelectedInstOperands,
     /* 260326 */     // GIR_Coverage, 11449,
     /* 260326 */     GIR_EraseRootFromParent_Done,
     /* 260327 */   // Label 5048: @260327
     /* 260327 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(260379), // Rule ID 11450 //
     /* 260332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 260340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260356 */     // MIs[0] Op4
     /* 260356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1798:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 260367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260373 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260375 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260377 */     GIR_RootConstrainSelectedInstOperands,
     /* 260378 */     // GIR_Coverage, 11450,
     /* 260378 */     GIR_EraseRootFromParent_Done,
     /* 260379 */   // Label 5049: @260379
     /* 260379 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(260431), // Rule ID 11451 //
     /* 260384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 260392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260408 */     // MIs[0] Op4
     /* 260408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1798:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 260419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260427 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260429 */     GIR_RootConstrainSelectedInstOperands,
     /* 260430 */     // GIR_Coverage, 11451,
     /* 260430 */     GIR_EraseRootFromParent_Done,
     /* 260431 */   // Label 5050: @260431
     /* 260431 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(260483), // Rule ID 11452 //
     /* 260436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 260444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260460 */     // MIs[0] Op4
     /* 260460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 260471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260479 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260481 */     GIR_RootConstrainSelectedInstOperands,
     /* 260482 */     // GIR_Coverage, 11452,
     /* 260482 */     GIR_EraseRootFromParent_Done,
     /* 260483 */   // Label 5051: @260483
     /* 260483 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(260535), // Rule ID 11453 //
     /* 260488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 260496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260512 */     // MIs[0] Op4
     /* 260512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260520 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 260523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260531 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260533 */     GIR_RootConstrainSelectedInstOperands,
     /* 260534 */     // GIR_Coverage, 11453,
     /* 260534 */     GIR_EraseRootFromParent_Done,
     /* 260535 */   // Label 5052: @260535
     /* 260535 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(260587), // Rule ID 11919 //
     /* 260540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 260548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260564 */     // MIs[0] Op4
     /* 260564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260572 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 260575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260583 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260585 */     GIR_RootConstrainSelectedInstOperands,
     /* 260586 */     // GIR_Coverage, 11919,
     /* 260586 */     GIR_EraseRootFromParent_Done,
     /* 260587 */   // Label 5053: @260587
     /* 260587 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(260639), // Rule ID 11920 //
     /* 260592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 260600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260616 */     // MIs[0] Op4
     /* 260616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260624 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 260627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260633 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260635 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260637 */     GIR_RootConstrainSelectedInstOperands,
     /* 260638 */     // GIR_Coverage, 11920,
     /* 260638 */     GIR_EraseRootFromParent_Done,
     /* 260639 */   // Label 5054: @260639
     /* 260639 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(260691), // Rule ID 11921 //
     /* 260644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 260652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260668 */     // MIs[0] Op4
     /* 260668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260676 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1479:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 260679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260687 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260689 */     GIR_RootConstrainSelectedInstOperands,
     /* 260690 */     // GIR_Coverage, 11921,
     /* 260690 */     GIR_EraseRootFromParent_Done,
     /* 260691 */   // Label 5055: @260691
     /* 260691 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(260743), // Rule ID 11922 //
     /* 260696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 260704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260720 */     // MIs[0] Op4
     /* 260720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260728 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 260731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260739 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260741 */     GIR_RootConstrainSelectedInstOperands,
     /* 260742 */     // GIR_Coverage, 11922,
     /* 260742 */     GIR_EraseRootFromParent_Done,
     /* 260743 */   // Label 5056: @260743
     /* 260743 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(260795), // Rule ID 12067 //
     /* 260748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 260751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 260756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260772 */     // MIs[0] Op4
     /* 260772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260780 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1427:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 260783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260791 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260793 */     GIR_RootConstrainSelectedInstOperands,
     /* 260794 */     // GIR_Coverage, 12067,
     /* 260794 */     GIR_EraseRootFromParent_Done,
     /* 260795 */   // Label 5057: @260795
     /* 260795 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(260847), // Rule ID 12069 //
     /* 260800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 260803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 260808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260824 */     // MIs[0] Op4
     /* 260824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 260835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260843 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260845 */     GIR_RootConstrainSelectedInstOperands,
     /* 260846 */     // GIR_Coverage, 12069,
     /* 260846 */     GIR_EraseRootFromParent_Done,
     /* 260847 */   // Label 5058: @260847
     /* 260847 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(260894), // Rule ID 2822 //
     /* 260852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 260860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260879 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 260879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 260882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260890 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260892 */     GIR_RootConstrainSelectedInstOperands,
     /* 260893 */     // GIR_Coverage, 2822,
     /* 260893 */     GIR_EraseRootFromParent_Done,
     /* 260894 */   // Label 5059: @260894
     /* 260894 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(260941), // Rule ID 2825 //
     /* 260899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 260907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 260910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 260913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 260916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 260919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 260922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260926 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 260926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 260929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260937 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260939 */     GIR_RootConstrainSelectedInstOperands,
     /* 260940 */     // GIR_Coverage, 2825,
     /* 260940 */     GIR_EraseRootFromParent_Done,
     /* 260941 */   // Label 5060: @260941
     /* 260941 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(260988), // Rule ID 2828 //
     /* 260946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 260954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 260957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 260960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 260963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 260966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 260969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260973 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 260973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 260976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260984 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260986 */     GIR_RootConstrainSelectedInstOperands,
     /* 260987 */     // GIR_Coverage, 2828,
     /* 260987 */     GIR_EraseRootFromParent_Done,
     /* 260988 */   // Label 5061: @260988
     /* 260988 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(261035), // Rule ID 2831 //
     /* 260993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 261001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261020 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 261020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 261023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261031 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261033 */     GIR_RootConstrainSelectedInstOperands,
     /* 261034 */     // GIR_Coverage, 2831,
     /* 261034 */     GIR_EraseRootFromParent_Done,
     /* 261035 */   // Label 5062: @261035
     /* 261035 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(261082), // Rule ID 2834 //
     /* 261040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 261048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 261051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 261057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 261060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 261063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261067 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 261067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 261070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261078 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261080 */     GIR_RootConstrainSelectedInstOperands,
     /* 261081 */     // GIR_Coverage, 2834,
     /* 261081 */     GIR_EraseRootFromParent_Done,
     /* 261082 */   // Label 5063: @261082
     /* 261082 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(261129), // Rule ID 2837 //
     /* 261087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 261095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261114 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 261114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 261117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261125 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261127 */     GIR_RootConstrainSelectedInstOperands,
     /* 261128 */     // GIR_Coverage, 2837,
     /* 261128 */     GIR_EraseRootFromParent_Done,
     /* 261129 */   // Label 5064: @261129
     /* 261129 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(261176), // Rule ID 2840 //
     /* 261134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 261142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261161 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 261161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 261164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261172 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261174 */     GIR_RootConstrainSelectedInstOperands,
     /* 261175 */     // GIR_Coverage, 2840,
     /* 261175 */     GIR_EraseRootFromParent_Done,
     /* 261176 */   // Label 5065: @261176
     /* 261176 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(261223), // Rule ID 2841 //
     /* 261181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 261189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261208 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 261208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 261211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261219 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261221 */     GIR_RootConstrainSelectedInstOperands,
     /* 261222 */     // GIR_Coverage, 2841,
     /* 261222 */     GIR_EraseRootFromParent_Done,
     /* 261223 */   // Label 5066: @261223
     /* 261223 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(261270), // Rule ID 2842 //
     /* 261228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 261236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261255 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 261255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 261258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261266 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261268 */     GIR_RootConstrainSelectedInstOperands,
     /* 261269 */     // GIR_Coverage, 2842,
     /* 261269 */     GIR_EraseRootFromParent_Done,
     /* 261270 */   // Label 5067: @261270
     /* 261270 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(261317), // Rule ID 2938 //
     /* 261275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 261283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 261286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261302 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 261302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 261305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261313 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261315 */     GIR_RootConstrainSelectedInstOperands,
     /* 261316 */     // GIR_Coverage, 2938,
     /* 261316 */     GIR_EraseRootFromParent_Done,
     /* 261317 */   // Label 5068: @261317
     /* 261317 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(261364), // Rule ID 2941 //
     /* 261322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 261330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261349 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 261349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 261352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261360 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261362 */     GIR_RootConstrainSelectedInstOperands,
     /* 261363 */     // GIR_Coverage, 2941,
     /* 261363 */     GIR_EraseRootFromParent_Done,
     /* 261364 */   // Label 5069: @261364
     /* 261364 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(261411), // Rule ID 2944 //
     /* 261369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 261377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1606:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 261396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 261399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261407 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261409 */     GIR_RootConstrainSelectedInstOperands,
     /* 261410 */     // GIR_Coverage, 2944,
     /* 261410 */     GIR_EraseRootFromParent_Done,
     /* 261411 */   // Label 5070: @261411
     /* 261411 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(261458), // Rule ID 2947 //
     /* 261416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 261424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1606:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 261443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 261446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261454 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261456 */     GIR_RootConstrainSelectedInstOperands,
     /* 261457 */     // GIR_Coverage, 2947,
     /* 261457 */     GIR_EraseRootFromParent_Done,
     /* 261458 */   // Label 5071: @261458
     /* 261458 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(261505), // Rule ID 2950 //
     /* 261463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 261471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 261474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261490 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1608:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 261490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 261493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261501 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261503 */     GIR_RootConstrainSelectedInstOperands,
     /* 261504 */     // GIR_Coverage, 2950,
     /* 261504 */     GIR_EraseRootFromParent_Done,
     /* 261505 */   // Label 5072: @261505
     /* 261505 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(261552), // Rule ID 2952 //
     /* 261510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 261518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261537 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1608:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 261537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 261540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261548 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261550 */     GIR_RootConstrainSelectedInstOperands,
     /* 261551 */     // GIR_Coverage, 2952,
     /* 261551 */     GIR_EraseRootFromParent_Done,
     /* 261552 */   // Label 5073: @261552
     /* 261552 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(261599), // Rule ID 2954 //
     /* 261557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 261565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261584 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1608:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 261584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 261587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261595 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261597 */     GIR_RootConstrainSelectedInstOperands,
     /* 261598 */     // GIR_Coverage, 2954,
     /* 261598 */     GIR_EraseRootFromParent_Done,
     /* 261599 */   // Label 5074: @261599
     /* 261599 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(261646), // Rule ID 2956 //
     /* 261604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 261612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1608:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 261631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 261634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261642 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261644 */     GIR_RootConstrainSelectedInstOperands,
     /* 261645 */     // GIR_Coverage, 2956,
     /* 261645 */     GIR_EraseRootFromParent_Done,
     /* 261646 */   // Label 5075: @261646
     /* 261646 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(261693), // Rule ID 7612 //
     /* 261651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 261659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 261662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 261678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 261681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261689 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261691 */     GIR_RootConstrainSelectedInstOperands,
     /* 261692 */     // GIR_Coverage, 7612,
     /* 261692 */     GIR_EraseRootFromParent_Done,
     /* 261693 */   // Label 5076: @261693
     /* 261693 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(261740), // Rule ID 7615 //
     /* 261698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 261706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 261725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 261728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261736 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261738 */     GIR_RootConstrainSelectedInstOperands,
     /* 261739 */     // GIR_Coverage, 7615,
     /* 261739 */     GIR_EraseRootFromParent_Done,
     /* 261740 */   // Label 5077: @261740
     /* 261740 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(261787), // Rule ID 7618 //
     /* 261745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 261753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 261772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 261775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261783 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261785 */     GIR_RootConstrainSelectedInstOperands,
     /* 261786 */     // GIR_Coverage, 7618,
     /* 261786 */     GIR_EraseRootFromParent_Done,
     /* 261787 */   // Label 5078: @261787
     /* 261787 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(261834), // Rule ID 7621 //
     /* 261792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 261800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261819 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 261819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 261822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261830 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261832 */     GIR_RootConstrainSelectedInstOperands,
     /* 261833 */     // GIR_Coverage, 7621,
     /* 261833 */     GIR_EraseRootFromParent_Done,
     /* 261834 */   // Label 5079: @261834
     /* 261834 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(261881), // Rule ID 7624 //
     /* 261839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 261847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 261850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261866 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 261866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 261869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261877 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261879 */     GIR_RootConstrainSelectedInstOperands,
     /* 261880 */     // GIR_Coverage, 7624,
     /* 261880 */     GIR_EraseRootFromParent_Done,
     /* 261881 */   // Label 5080: @261881
     /* 261881 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(261928), // Rule ID 7626 //
     /* 261886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 261894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261913 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 261913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 261916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261924 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261926 */     GIR_RootConstrainSelectedInstOperands,
     /* 261927 */     // GIR_Coverage, 7626,
     /* 261927 */     GIR_EraseRootFromParent_Done,
     /* 261928 */   // Label 5081: @261928
     /* 261928 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(261975), // Rule ID 7628 //
     /* 261933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 261941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 261960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 261963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261971 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261973 */     GIR_RootConstrainSelectedInstOperands,
     /* 261974 */     // GIR_Coverage, 7628,
     /* 261974 */     GIR_EraseRootFromParent_Done,
     /* 261975 */   // Label 5082: @261975
     /* 261975 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(262022), // Rule ID 7630 //
     /* 261980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 261988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262007 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 262007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 262010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262018 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262020 */     GIR_RootConstrainSelectedInstOperands,
     /* 262021 */     // GIR_Coverage, 7630,
     /* 262021 */     GIR_EraseRootFromParent_Done,
     /* 262022 */   // Label 5083: @262022
     /* 262022 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(262069), // Rule ID 8260 //
     /* 262027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262054 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1475:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 262057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262065 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262067 */     GIR_RootConstrainSelectedInstOperands,
     /* 262068 */     // GIR_Coverage, 8260,
     /* 262068 */     GIR_EraseRootFromParent_Done,
     /* 262069 */   // Label 5084: @262069
     /* 262069 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(262116), // Rule ID 8263 //
     /* 262074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 262085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 262091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 262094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 262097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262101 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1475:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 262101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 262104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262112 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262114 */     GIR_RootConstrainSelectedInstOperands,
     /* 262115 */     // GIR_Coverage, 8263,
     /* 262115 */     GIR_EraseRootFromParent_Done,
     /* 262116 */   // Label 5085: @262116
     /* 262116 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(262163), // Rule ID 8266 //
     /* 262121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 262132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 262138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 262141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 262144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262148 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1475:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 262148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 262151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262159 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262161 */     GIR_RootConstrainSelectedInstOperands,
     /* 262162 */     // GIR_Coverage, 8266,
     /* 262162 */     GIR_EraseRootFromParent_Done,
     /* 262163 */   // Label 5086: @262163
     /* 262163 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(262210), // Rule ID 8269 //
     /* 262168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262195 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 262198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262206 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262208 */     GIR_RootConstrainSelectedInstOperands,
     /* 262209 */     // GIR_Coverage, 8269,
     /* 262209 */     GIR_EraseRootFromParent_Done,
     /* 262210 */   // Label 5087: @262210
     /* 262210 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(262257), // Rule ID 8272 //
     /* 262215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 262226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 262232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 262235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 262238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262242 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1475:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 262242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 262245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262253 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262255 */     GIR_RootConstrainSelectedInstOperands,
     /* 262256 */     // GIR_Coverage, 8272,
     /* 262256 */     GIR_EraseRootFromParent_Done,
     /* 262257 */   // Label 5088: @262257
     /* 262257 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(262304), // Rule ID 8275 //
     /* 262262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262289 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1475:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 262292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262300 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262302 */     GIR_RootConstrainSelectedInstOperands,
     /* 262303 */     // GIR_Coverage, 8275,
     /* 262303 */     GIR_EraseRootFromParent_Done,
     /* 262304 */   // Label 5089: @262304
     /* 262304 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(262351), // Rule ID 8278 //
     /* 262309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262336 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 262339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262347 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262349 */     GIR_RootConstrainSelectedInstOperands,
     /* 262350 */     // GIR_Coverage, 8278,
     /* 262350 */     GIR_EraseRootFromParent_Done,
     /* 262351 */   // Label 5090: @262351
     /* 262351 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(262398), // Rule ID 8279 //
     /* 262356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 262367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 262373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 262376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 262379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262383 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 262383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 262386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262394 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262396 */     GIR_RootConstrainSelectedInstOperands,
     /* 262397 */     // GIR_Coverage, 8279,
     /* 262397 */     GIR_EraseRootFromParent_Done,
     /* 262398 */   // Label 5091: @262398
     /* 262398 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(262445), // Rule ID 8280 //
     /* 262403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 262414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 262420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 262423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 262426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262430 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 262430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 262433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262441 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262443 */     GIR_RootConstrainSelectedInstOperands,
     /* 262444 */     // GIR_Coverage, 8280,
     /* 262444 */     GIR_EraseRootFromParent_Done,
     /* 262445 */   // Label 5092: @262445
     /* 262445 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(262492), // Rule ID 8281 //
     /* 262450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262477 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 262480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262488 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262490 */     GIR_RootConstrainSelectedInstOperands,
     /* 262491 */     // GIR_Coverage, 8281,
     /* 262491 */     GIR_EraseRootFromParent_Done,
     /* 262492 */   // Label 5093: @262492
     /* 262492 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(262539), // Rule ID 8282 //
     /* 262497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 262508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 262514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 262517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 262520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 262524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 262527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262535 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262537 */     GIR_RootConstrainSelectedInstOperands,
     /* 262538 */     // GIR_Coverage, 8282,
     /* 262538 */     GIR_EraseRootFromParent_Done,
     /* 262539 */   // Label 5094: @262539
     /* 262539 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(262586), // Rule ID 8283 //
     /* 262544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262571 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 262574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262582 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262584 */     GIR_RootConstrainSelectedInstOperands,
     /* 262585 */     // GIR_Coverage, 8283,
     /* 262585 */     GIR_EraseRootFromParent_Done,
     /* 262586 */   // Label 5095: @262586
     /* 262586 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(262633), // Rule ID 8284 //
     /* 262591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262618 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 262621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262629 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262631 */     GIR_RootConstrainSelectedInstOperands,
     /* 262632 */     // GIR_Coverage, 8284,
     /* 262632 */     GIR_EraseRootFromParent_Done,
     /* 262633 */   // Label 5096: @262633
     /* 262633 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(262680), // Rule ID 8285 //
     /* 262638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 262649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 262655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 262658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 262661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262665 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1493:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 262665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 262668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262676 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262678 */     GIR_RootConstrainSelectedInstOperands,
     /* 262679 */     // GIR_Coverage, 8285,
     /* 262679 */     GIR_EraseRootFromParent_Done,
     /* 262680 */   // Label 5097: @262680
     /* 262680 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(262727), // Rule ID 8286 //
     /* 262685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 262696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 262702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 262705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 262708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262712 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 262712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 262715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262723 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262725 */     GIR_RootConstrainSelectedInstOperands,
     /* 262726 */     // GIR_Coverage, 8286,
     /* 262726 */     GIR_EraseRootFromParent_Done,
     /* 262727 */   // Label 5098: @262727
     /* 262727 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(262774), // Rule ID 8287 //
     /* 262732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262759 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1493:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 262762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262770 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262772 */     GIR_RootConstrainSelectedInstOperands,
     /* 262773 */     // GIR_Coverage, 8287,
     /* 262773 */     GIR_EraseRootFromParent_Done,
     /* 262774 */   // Label 5099: @262774
     /* 262774 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(262821), // Rule ID 8288 //
     /* 262779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 262790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 262796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 262799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 262802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262806 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 262806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 262809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262817 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262819 */     GIR_RootConstrainSelectedInstOperands,
     /* 262820 */     // GIR_Coverage, 8288,
     /* 262820 */     GIR_EraseRootFromParent_Done,
     /* 262821 */   // Label 5100: @262821
     /* 262821 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(262868), // Rule ID 8289 //
     /* 262826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262853 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 262856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262864 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262866 */     GIR_RootConstrainSelectedInstOperands,
     /* 262867 */     // GIR_Coverage, 8289,
     /* 262867 */     GIR_EraseRootFromParent_Done,
     /* 262868 */   // Label 5101: @262868
     /* 262868 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(262915), // Rule ID 8290 //
     /* 262873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 262881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262900 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 262903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262911 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262913 */     GIR_RootConstrainSelectedInstOperands,
     /* 262914 */     // GIR_Coverage, 8290,
     /* 262914 */     GIR_EraseRootFromParent_Done,
     /* 262915 */   // Label 5102: @262915
     /* 262915 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(262962), // Rule ID 8291 //
     /* 262920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 262928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262947 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 262950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262958 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262960 */     GIR_RootConstrainSelectedInstOperands,
     /* 262961 */     // GIR_Coverage, 8291,
     /* 262961 */     GIR_EraseRootFromParent_Done,
     /* 262962 */   // Label 5103: @262962
     /* 262962 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(263009), // Rule ID 8292 //
     /* 262967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 262975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262994 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1483:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 262997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263005 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263007 */     GIR_RootConstrainSelectedInstOperands,
     /* 263008 */     // GIR_Coverage, 8292,
     /* 263008 */     GIR_EraseRootFromParent_Done,
     /* 263009 */   // Label 5104: @263009
     /* 263009 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(263056), // Rule ID 8293 //
     /* 263014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 263022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263041 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1490:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 263044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263052 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263054 */     GIR_RootConstrainSelectedInstOperands,
     /* 263055 */     // GIR_Coverage, 8293,
     /* 263055 */     GIR_EraseRootFromParent_Done,
     /* 263056 */   // Label 5105: @263056
     /* 263056 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(263103), // Rule ID 8294 //
     /* 263061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 263069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263088 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1490:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 263091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263099 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263101 */     GIR_RootConstrainSelectedInstOperands,
     /* 263102 */     // GIR_Coverage, 8294,
     /* 263102 */     GIR_EraseRootFromParent_Done,
     /* 263103 */   // Label 5106: @263103
     /* 263103 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(263150), // Rule ID 8295 //
     /* 263108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 263116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263135 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1490:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 263138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263146 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263148 */     GIR_RootConstrainSelectedInstOperands,
     /* 263149 */     // GIR_Coverage, 8295,
     /* 263149 */     GIR_EraseRootFromParent_Done,
     /* 263150 */   // Label 5107: @263150
     /* 263150 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(263197), // Rule ID 8296 //
     /* 263155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 263163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263182 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1495:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 263185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263193 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263195 */     GIR_RootConstrainSelectedInstOperands,
     /* 263196 */     // GIR_Coverage, 8296,
     /* 263196 */     GIR_EraseRootFromParent_Done,
     /* 263197 */   // Label 5108: @263197
     /* 263197 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(263244), // Rule ID 8297 //
     /* 263202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 263210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263229 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1495:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 263232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263240 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263242 */     GIR_RootConstrainSelectedInstOperands,
     /* 263243 */     // GIR_Coverage, 8297,
     /* 263243 */     GIR_EraseRootFromParent_Done,
     /* 263244 */   // Label 5109: @263244
     /* 263244 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(263291), // Rule ID 8298 //
     /* 263249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 263257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263276 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 263279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263287 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263289 */     GIR_RootConstrainSelectedInstOperands,
     /* 263290 */     // GIR_Coverage, 8298,
     /* 263290 */     GIR_EraseRootFromParent_Done,
     /* 263291 */   // Label 5110: @263291
     /* 263291 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(263338), // Rule ID 8299 //
     /* 263296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263323 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 263326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263334 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263336 */     GIR_RootConstrainSelectedInstOperands,
     /* 263337 */     // GIR_Coverage, 8299,
     /* 263337 */     GIR_EraseRootFromParent_Done,
     /* 263338 */   // Label 5111: @263338
     /* 263338 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(263385), // Rule ID 8302 //
     /* 263343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263370 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1477:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 263373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263381 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263383 */     GIR_RootConstrainSelectedInstOperands,
     /* 263384 */     // GIR_Coverage, 8302,
     /* 263384 */     GIR_EraseRootFromParent_Done,
     /* 263385 */   // Label 5112: @263385
     /* 263385 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(263432), // Rule ID 8305 //
     /* 263390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 263401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 263407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 263410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 263413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263417 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 263417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 263420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263428 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263430 */     GIR_RootConstrainSelectedInstOperands,
     /* 263431 */     // GIR_Coverage, 8305,
     /* 263431 */     GIR_EraseRootFromParent_Done,
     /* 263432 */   // Label 5113: @263432
     /* 263432 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(263479), // Rule ID 8308 //
     /* 263437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263464 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 263467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263475 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263477 */     GIR_RootConstrainSelectedInstOperands,
     /* 263478 */     // GIR_Coverage, 8308,
     /* 263478 */     GIR_EraseRootFromParent_Done,
     /* 263479 */   // Label 5114: @263479
     /* 263479 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(263526), // Rule ID 8311 //
     /* 263484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 263495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 263501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 263504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 263507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263511 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 263511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 263514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263522 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263524 */     GIR_RootConstrainSelectedInstOperands,
     /* 263525 */     // GIR_Coverage, 8311,
     /* 263525 */     GIR_EraseRootFromParent_Done,
     /* 263526 */   // Label 5115: @263526
     /* 263526 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(263573), // Rule ID 8314 //
     /* 263531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263558 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 263561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263569 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263571 */     GIR_RootConstrainSelectedInstOperands,
     /* 263572 */     // GIR_Coverage, 8314,
     /* 263572 */     GIR_EraseRootFromParent_Done,
     /* 263573 */   // Label 5116: @263573
     /* 263573 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(263620), // Rule ID 8317 //
     /* 263578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263605 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1492:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 263608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263616 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263618 */     GIR_RootConstrainSelectedInstOperands,
     /* 263619 */     // GIR_Coverage, 8317,
     /* 263619 */     GIR_EraseRootFromParent_Done,
     /* 263620 */   // Label 5117: @263620
     /* 263620 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(263667), // Rule ID 8320 //
     /* 263625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263652 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1492:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 263655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263663 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263665 */     GIR_RootConstrainSelectedInstOperands,
     /* 263666 */     // GIR_Coverage, 8320,
     /* 263666 */     GIR_EraseRootFromParent_Done,
     /* 263667 */   // Label 5118: @263667
     /* 263667 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(263714), // Rule ID 8323 //
     /* 263672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 263683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 263689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 263692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 263695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263699 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1492:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 263699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 263702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263710 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263712 */     GIR_RootConstrainSelectedInstOperands,
     /* 263713 */     // GIR_Coverage, 8323,
     /* 263713 */     GIR_EraseRootFromParent_Done,
     /* 263714 */   // Label 5119: @263714
     /* 263714 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(263761), // Rule ID 8326 //
     /* 263719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263746 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1492:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 263749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263757 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263759 */     GIR_RootConstrainSelectedInstOperands,
     /* 263760 */     // GIR_Coverage, 8326,
     /* 263760 */     GIR_EraseRootFromParent_Done,
     /* 263761 */   // Label 5120: @263761
     /* 263761 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(263808), // Rule ID 8329 //
     /* 263766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 263777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 263783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 263786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 263789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263793 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1492:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 263793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 263796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263804 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263806 */     GIR_RootConstrainSelectedInstOperands,
     /* 263807 */     // GIR_Coverage, 8329,
     /* 263807 */     GIR_EraseRootFromParent_Done,
     /* 263808 */   // Label 5121: @263808
     /* 263808 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(263855), // Rule ID 8332 //
     /* 263813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263840 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1492:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 263843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263851 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263853 */     GIR_RootConstrainSelectedInstOperands,
     /* 263854 */     // GIR_Coverage, 8332,
     /* 263854 */     GIR_EraseRootFromParent_Done,
     /* 263855 */   // Label 5122: @263855
     /* 263855 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(263902), // Rule ID 8335 //
     /* 263860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 263868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263887 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1494:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 263890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263898 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263900 */     GIR_RootConstrainSelectedInstOperands,
     /* 263901 */     // GIR_Coverage, 8335,
     /* 263901 */     GIR_EraseRootFromParent_Done,
     /* 263902 */   // Label 5123: @263902
     /* 263902 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(263949), // Rule ID 8337 //
     /* 263907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 263915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263934 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 263937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263945 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263947 */     GIR_RootConstrainSelectedInstOperands,
     /* 263948 */     // GIR_Coverage, 8337,
     /* 263948 */     GIR_EraseRootFromParent_Done,
     /* 263949 */   // Label 5124: @263949
     /* 263949 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(263996), // Rule ID 8339 //
     /* 263954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 263962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 263965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 263971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 263974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 263977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263981 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 263981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 263984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263992 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263994 */     GIR_RootConstrainSelectedInstOperands,
     /* 263995 */     // GIR_Coverage, 8339,
     /* 263995 */     GIR_EraseRootFromParent_Done,
     /* 263996 */   // Label 5125: @263996
     /* 263996 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(264043), // Rule ID 8341 //
     /* 264001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 264009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264028 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 264031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264039 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264041 */     GIR_RootConstrainSelectedInstOperands,
     /* 264042 */     // GIR_Coverage, 8341,
     /* 264042 */     GIR_EraseRootFromParent_Done,
     /* 264043 */   // Label 5126: @264043
     /* 264043 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(264090), // Rule ID 8343 //
     /* 264048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 264056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264075 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 264078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264086 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264088 */     GIR_RootConstrainSelectedInstOperands,
     /* 264089 */     // GIR_Coverage, 8343,
     /* 264089 */     GIR_EraseRootFromParent_Done,
     /* 264090 */   // Label 5127: @264090
     /* 264090 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(264137), // Rule ID 8345 //
     /* 264095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 264103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264122 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 264125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264133 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264135 */     GIR_RootConstrainSelectedInstOperands,
     /* 264136 */     // GIR_Coverage, 8345,
     /* 264136 */     GIR_EraseRootFromParent_Done,
     /* 264137 */   // Label 5128: @264137
     /* 264137 */   GIM_Reject,
     /* 264138 */ // Label 4987: @264138
     /* 264138 */ GIM_Reject,
     /* 264139 */ // Label 38: @264139
     /* 264139 */ GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(264217),
     /* 264144 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 264147 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(264169), // Rule ID 78 //
     /* 264152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 264155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 264160 */     // (intrinsic_void 2173:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 264160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 264163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264167 */     GIR_RootConstrainSelectedInstOperands,
     /* 264168 */     // GIR_Coverage, 78,
     /* 264168 */     GIR_EraseRootFromParent_Done,
     /* 264169 */   // Label 5130: @264169
     /* 264169 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(264194), // Rule ID 2386 //
     /* 264174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 264177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 264182 */     // (intrinsic_void 1723:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 264182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 264185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 264188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264192 */     GIR_RootConstrainSelectedInstOperands,
     /* 264193 */     // GIR_Coverage, 2386,
     /* 264193 */     GIR_EraseRootFromParent_Done,
     /* 264194 */   // Label 5131: @264194
     /* 264194 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(264216), // Rule ID 7166 //
     /* 264199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 264204 */     // (intrinsic_void 507:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 264204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 264207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 264210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264214 */     GIR_RootConstrainSelectedInstOperands,
     /* 264215 */     // GIR_Coverage, 7166,
     /* 264215 */     GIR_EraseRootFromParent_Done,
     /* 264216 */   // Label 5132: @264216
     /* 264216 */   GIM_Reject,
     /* 264217 */ // Label 5129: @264217
     /* 264217 */ GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(264817),
     /* 264222 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 264225 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(264257), // Rule ID 79 //
     /* 264230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 264233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 264238 */     // MIs[0] imm
     /* 264238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 264241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 264246 */     // (intrinsic_void 2172:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 264246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 264249 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 264251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264255 */     GIR_RootConstrainSelectedInstOperands,
     /* 264256 */     // GIR_Coverage, 79,
     /* 264256 */     GIR_EraseRootFromParent_Done,
     /* 264257 */   // Label 5134: @264257
     /* 264257 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(264282), // Rule ID 227 //
     /* 264262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 264267 */     // MIs[0] imm
     /* 264267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 264270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 264275 */     // (intrinsic_void 505:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 264275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 264278 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 264280 */     GIR_RootConstrainSelectedInstOperands,
     /* 264281 */     // GIR_Coverage, 227,
     /* 264281 */     GIR_EraseRootFromParent_Done,
     /* 264282 */   // Label 5135: @264282
     /* 264282 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(264307), // Rule ID 228 //
     /* 264287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 264292 */     // MIs[0] imm
     /* 264292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 264295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 264300 */     // (intrinsic_void 564:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 264300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 264303 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 264305 */     GIR_RootConstrainSelectedInstOperands,
     /* 264306 */     // GIR_Coverage, 228,
     /* 264306 */     GIR_EraseRootFromParent_Done,
     /* 264307 */   // Label 5136: @264307
     /* 264307 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(264339), // Rule ID 3617 //
     /* 264312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 264315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 264320 */     // MIs[0] imm
     /* 264320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 264323 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 264328 */     // (intrinsic_void 1229:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 264328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 264331 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 264333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264337 */     GIR_RootConstrainSelectedInstOperands,
     /* 264338 */     // GIR_Coverage, 3617,
     /* 264338 */     GIR_EraseRootFromParent_Done,
     /* 264339 */   // Label 5137: @264339
     /* 264339 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(264379), // Rule ID 16 //
     /* 264344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 264349 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 264364 */     // MIs[1] Operand 1
     /* 264364 */     // No operand predicates
     /* 264364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264366 */     // (intrinsic_void 563:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 264366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 264369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 264372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 264377 */     GIR_RootConstrainSelectedInstOperands,
     /* 264378 */     // GIR_Coverage, 16,
     /* 264378 */     GIR_EraseRootFromParent_Done,
     /* 264379 */   // Label 5138: @264379
     /* 264379 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(264419), // Rule ID 17 //
     /* 264384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 264389 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 264404 */     // MIs[1] Operand 1
     /* 264404 */     // No operand predicates
     /* 264404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264406 */     // (intrinsic_void 551:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 264406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 264409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 264412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 264417 */     GIR_RootConstrainSelectedInstOperands,
     /* 264418 */     // GIR_Coverage, 17,
     /* 264418 */     GIR_EraseRootFromParent_Done,
     /* 264419 */   // Label 5139: @264419
     /* 264419 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(264459), // Rule ID 18 //
     /* 264424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 264429 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 264444 */     // MIs[1] Operand 1
     /* 264444 */     // No operand predicates
     /* 264444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264446 */     // (intrinsic_void 552:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 264446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 264449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 264452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 264457 */     GIR_RootConstrainSelectedInstOperands,
     /* 264458 */     // GIR_Coverage, 18,
     /* 264458 */     GIR_EraseRootFromParent_Done,
     /* 264459 */   // Label 5140: @264459
     /* 264459 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(264499), // Rule ID 19 //
     /* 264464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 264469 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 264484 */     // MIs[1] Operand 1
     /* 264484 */     // No operand predicates
     /* 264484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264486 */     // (intrinsic_void 567:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 264486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 264489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 264492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 264497 */     GIR_RootConstrainSelectedInstOperands,
     /* 264498 */     // GIR_Coverage, 19,
     /* 264498 */     GIR_EraseRootFromParent_Done,
     /* 264499 */   // Label 5141: @264499
     /* 264499 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(264523), // Rule ID 72 //
     /* 264504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 264509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264516 */     // (intrinsic_w_chain:{ *:[i64] } 560:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 264516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 264519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264521 */     GIR_RootConstrainSelectedInstOperands,
     /* 264522 */     // GIR_Coverage, 72,
     /* 264522 */     GIR_EraseRootFromParent_Done,
     /* 264523 */   // Label 5142: @264523
     /* 264523 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(264547), // Rule ID 74 //
     /* 264528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 264533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264540 */     // (intrinsic_w_chain:{ *:[i64] } 561:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 264540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 264543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264545 */     GIR_RootConstrainSelectedInstOperands,
     /* 264546 */     // GIR_Coverage, 74,
     /* 264546 */     GIR_EraseRootFromParent_Done,
     /* 264547 */   // Label 5143: @264547
     /* 264547 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(264578), // Rule ID 77 //
     /* 264552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 264555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 264560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264567 */     // (intrinsic_w_chain:{ *:[i64] } 2174:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 264567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 264570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 264572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264576 */     GIR_RootConstrainSelectedInstOperands,
     /* 264577 */     // GIR_Coverage, 77,
     /* 264577 */     GIR_EraseRootFromParent_Done,
     /* 264578 */   // Label 5144: @264578
     /* 264578 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(264605), // Rule ID 80 //
     /* 264583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 264586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 264591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264598 */     // (intrinsic_w_chain:{ *:[i64] } 2175:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 264598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 264601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 264603 */     GIR_RootConstrainSelectedInstOperands,
     /* 264604 */     // GIR_Coverage, 80,
     /* 264604 */     GIR_EraseRootFromParent_Done,
     /* 264605 */   // Label 5145: @264605
     /* 264605 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(264636), // Rule ID 2385 //
     /* 264610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 264613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 264618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 264621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 264625 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1673:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 264625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 264628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 264630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264634 */     GIR_RootConstrainSelectedInstOperands,
     /* 264635 */     // GIR_Coverage, 2385,
     /* 264635 */     GIR_EraseRootFromParent_Done,
     /* 264636 */   // Label 5146: @264636
     /* 264636 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(264676), // Rule ID 12853 //
     /* 264641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 264644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 264649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264656 */     // (intrinsic_w_chain:{ *:[i64] } 898:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 264656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 264659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 264661 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 264671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 264674 */     GIR_RootConstrainSelectedInstOperands,
     /* 264675 */     // GIR_Coverage, 12853,
     /* 264675 */     GIR_EraseRootFromParent_Done,
     /* 264676 */   // Label 5147: @264676
     /* 264676 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(264710), // Rule ID 2387 //
     /* 264681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 264684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 264689 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 264692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 264696 */     // (intrinsic_void 2153:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 264696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 264699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 264701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 264704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264708 */     GIR_RootConstrainSelectedInstOperands,
     /* 264709 */     // GIR_Coverage, 2387,
     /* 264709 */     GIR_EraseRootFromParent_Done,
     /* 264710 */   // Label 5148: @264710
     /* 264710 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(264733), // Rule ID 73 //
     /* 264715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 264720 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264723 */     // (intrinsic_void 787:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 264723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 264726 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 264728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 264731 */     GIR_RootConstrainSelectedInstOperands,
     /* 264732 */     // GIR_Coverage, 73,
     /* 264732 */     GIR_EraseRootFromParent_Done,
     /* 264733 */   // Label 5149: @264733
     /* 264733 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(264756), // Rule ID 75 //
     /* 264738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 264743 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264746 */     // (intrinsic_void 789:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 264746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 264749 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 264751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 264754 */     GIR_RootConstrainSelectedInstOperands,
     /* 264755 */     // GIR_Coverage, 75,
     /* 264755 */     GIR_EraseRootFromParent_Done,
     /* 264756 */   // Label 5150: @264756
     /* 264756 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(264783), // Rule ID 76 //
     /* 264761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 264766 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264769 */     // (intrinsic_void 788:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 264769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 264772 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 264774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 264777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264781 */     GIR_RootConstrainSelectedInstOperands,
     /* 264782 */     // GIR_Coverage, 76,
     /* 264782 */     GIR_EraseRootFromParent_Done,
     /* 264783 */   // Label 5151: @264783
     /* 264783 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(264816), // Rule ID 12852 //
     /* 264788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 264791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 264796 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264799 */     // (intrinsic_void 973:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 264799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 264802 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 264812 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 264814 */     GIR_RootConstrainSelectedInstOperands,
     /* 264815 */     // GIR_Coverage, 12852,
     /* 264815 */     GIR_EraseRootFromParent_Done,
     /* 264816 */   // Label 5152: @264816
     /* 264816 */   GIM_Reject,
     /* 264817 */ // Label 5133: @264817
     /* 264817 */ GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(265788),
     /* 264822 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 264825 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(264901), // Rule ID 7132 //
     /* 264830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 264835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264842 */     // MIs[0] addr
     /* 264842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 264846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 264850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 264854 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 264854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 264857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 264861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 264870 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 264876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 264890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264900 */     // GIR_Coverage, 7132,
     /* 264900 */     GIR_EraseRootFromParent_Done,
     /* 264901 */   // Label 5154: @264901
     /* 264901 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(264977), // Rule ID 7133 //
     /* 264906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 264911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264918 */     // MIs[0] addr
     /* 264918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 264922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 264926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 264930 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 264930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 264933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 264937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 264946 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 264952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 264966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264976 */     // GIR_Coverage, 7133,
     /* 264976 */     GIR_EraseRootFromParent_Done,
     /* 264977 */   // Label 5155: @264977
     /* 264977 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(265053), // Rule ID 7134 //
     /* 264982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 264987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264994 */     // MIs[0] addr
     /* 264994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 264998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 265006 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 265006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 265013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 265022 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 265042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265052 */     // GIR_Coverage, 7134,
     /* 265052 */     GIR_EraseRootFromParent_Done,
     /* 265053 */   // Label 5156: @265053
     /* 265053 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(265095), // Rule ID 7135 //
     /* 265058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 265063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265070 */     // MIs[0] addr
     /* 265070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 265082 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 265082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 265085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 265087 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 265089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265093 */     GIR_RootConstrainSelectedInstOperands,
     /* 265094 */     // GIR_Coverage, 7135,
     /* 265094 */     GIR_EraseRootFromParent_Done,
     /* 265095 */   // Label 5157: @265095
     /* 265095 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(265171), // Rule ID 7139 //
     /* 265100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 265105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265112 */     // MIs[0] addr
     /* 265112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265120 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 265124 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 265124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 265131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 265140 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 265160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265170 */     // GIR_Coverage, 7139,
     /* 265170 */     GIR_EraseRootFromParent_Done,
     /* 265171 */   // Label 5158: @265171
     /* 265171 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(265247), // Rule ID 7140 //
     /* 265176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 265181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265188 */     // MIs[0] addr
     /* 265188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 265200 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 265200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 265207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 265216 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 265236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265246 */     // GIR_Coverage, 7140,
     /* 265246 */     GIR_EraseRootFromParent_Done,
     /* 265247 */   // Label 5159: @265247
     /* 265247 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(265323), // Rule ID 7141 //
     /* 265252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 265257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265264 */     // MIs[0] addr
     /* 265264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 265276 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 265276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 265283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265288 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 265292 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 265312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265322 */     // GIR_Coverage, 7141,
     /* 265322 */     GIR_EraseRootFromParent_Done,
     /* 265323 */   // Label 5160: @265323
     /* 265323 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(265365), // Rule ID 7142 //
     /* 265328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 265333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265340 */     // MIs[0] addr
     /* 265340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 265352 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 265352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 265355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 265357 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 265359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265363 */     GIR_RootConstrainSelectedInstOperands,
     /* 265364 */     // GIR_Coverage, 7142,
     /* 265364 */     GIR_EraseRootFromParent_Done,
     /* 265365 */   // Label 5161: @265365
     /* 265365 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(265405), // Rule ID 20 //
     /* 265370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 265373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 265378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265392 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 265392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 265395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 265397 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 265399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265403 */     GIR_RootConstrainSelectedInstOperands,
     /* 265404 */     // GIR_Coverage, 20,
     /* 265404 */     GIR_EraseRootFromParent_Done,
     /* 265405 */   // Label 5162: @265405
     /* 265405 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(265445), // Rule ID 2384 //
     /* 265410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 265413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 265418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 265421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 265424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 265428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 265432 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1674:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 265432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 265435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 265437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 265439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265443 */     GIR_RootConstrainSelectedInstOperands,
     /* 265444 */     // GIR_Coverage, 2384,
     /* 265444 */     GIR_EraseRootFromParent_Done,
     /* 265445 */   // Label 5163: @265445
     /* 265445 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(265485), // Rule ID 2488 //
     /* 265450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 265453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 265458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 265461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 265464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265472 */     // (intrinsic_w_chain:{ *:[v8f16] } 618:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 265472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 265475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265483 */     GIR_RootConstrainSelectedInstOperands,
     /* 265484 */     // GIR_Coverage, 2488,
     /* 265484 */     GIR_EraseRootFromParent_Done,
     /* 265485 */   // Label 5164: @265485
     /* 265485 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(265525), // Rule ID 2489 //
     /* 265490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 265493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 265498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 265501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 265504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265512 */     // (intrinsic_w_chain:{ *:[v8f16] } 618:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 265512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 265515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265523 */     GIR_RootConstrainSelectedInstOperands,
     /* 265524 */     // GIR_Coverage, 2489,
     /* 265524 */     GIR_EraseRootFromParent_Done,
     /* 265525 */   // Label 5165: @265525
     /* 265525 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(265565), // Rule ID 7019 //
     /* 265530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 265533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 265538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 265541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 265544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265552 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 265552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 265555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265563 */     GIR_RootConstrainSelectedInstOperands,
     /* 265564 */     // GIR_Coverage, 7019,
     /* 265564 */     GIR_EraseRootFromParent_Done,
     /* 265565 */   // Label 5166: @265565
     /* 265565 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(265605), // Rule ID 7020 //
     /* 265570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 265573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 265578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 265581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 265584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265592 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 265592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 265595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265603 */     GIR_RootConstrainSelectedInstOperands,
     /* 265604 */     // GIR_Coverage, 7020,
     /* 265604 */     GIR_EraseRootFromParent_Done,
     /* 265605 */   // Label 5167: @265605
     /* 265605 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(265641), // Rule ID 3570 //
     /* 265610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 265613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 265618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 265624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265628 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 265628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 265631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265639 */     GIR_RootConstrainSelectedInstOperands,
     /* 265640 */     // GIR_Coverage, 3570,
     /* 265640 */     GIR_EraseRootFromParent_Done,
     /* 265641 */   // Label 5168: @265641
     /* 265641 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(265679), // Rule ID 3998 //
     /* 265646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 265649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 265654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265664 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 265664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 265667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 265675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 265677 */     GIR_RootConstrainSelectedInstOperands,
     /* 265678 */     // GIR_Coverage, 3998,
     /* 265678 */     GIR_EraseRootFromParent_Done,
     /* 265679 */   // Label 5169: @265679
     /* 265679 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(265715), // Rule ID 12578 //
     /* 265684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 265687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 265692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 265698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265702 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1500:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 265702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 265705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265713 */     GIR_RootConstrainSelectedInstOperands,
     /* 265714 */     // GIR_Coverage, 12578,
     /* 265714 */     GIR_EraseRootFromParent_Done,
     /* 265715 */   // Label 5170: @265715
     /* 265715 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(265751), // Rule ID 12579 //
     /* 265720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 265723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 265728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 265734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265738 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1504:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 265738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 265741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265749 */     GIR_RootConstrainSelectedInstOperands,
     /* 265750 */     // GIR_Coverage, 12579,
     /* 265750 */     GIR_EraseRootFromParent_Done,
     /* 265751 */   // Label 5171: @265751
     /* 265751 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(265787), // Rule ID 12580 //
     /* 265756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 265759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 265764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 265770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265774 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1505:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 265774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 265777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265785 */     GIR_RootConstrainSelectedInstOperands,
     /* 265786 */     // GIR_Coverage, 12580,
     /* 265786 */     GIR_EraseRootFromParent_Done,
     /* 265787 */   // Label 5172: @265787
     /* 265787 */   GIM_Reject,
     /* 265788 */ // Label 5153: @265788
     /* 265788 */ GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(269956),
     /* 265793 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 265796 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(265893), // Rule ID 7150 //
     /* 265801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 265806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 265809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 265824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 265836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 265840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 265844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265849 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 265860 */     // MIs[0] addr
     /* 265860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 265864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 265872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265874 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 265874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 265877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 265879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 265883 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 265885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 265891 */     GIR_RootConstrainSelectedInstOperands,
     /* 265892 */     // GIR_Coverage, 7150,
     /* 265892 */     GIR_EraseRootFromParent_Done,
     /* 265893 */   // Label 5174: @265893
     /* 265893 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(265990), // Rule ID 7151 //
     /* 265898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 265903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 265906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 265921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 265933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 265937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 265941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265946 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 265957 */     // MIs[0] addr
     /* 265957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 265961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 265969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265971 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 265971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 265974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 265976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 265980 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 265982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 265988 */     GIR_RootConstrainSelectedInstOperands,
     /* 265989 */     // GIR_Coverage, 7151,
     /* 265989 */     GIR_EraseRootFromParent_Done,
     /* 265990 */   // Label 5175: @265990
     /* 265990 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(266087), // Rule ID 7160 //
     /* 265995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 266000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 266018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 266026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 266034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 266038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266043 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 266054 */     // MIs[0] addr
     /* 266054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 266066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266068 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 266068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 266071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 266077 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 266085 */     GIR_RootConstrainSelectedInstOperands,
     /* 266086 */     // GIR_Coverage, 7160,
     /* 266086 */     GIR_EraseRootFromParent_Done,
     /* 266087 */   // Label 5176: @266087
     /* 266087 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(266184), // Rule ID 7161 //
     /* 266092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 266097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 266115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 266123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 266131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 266135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266140 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 266151 */     // MIs[0] addr
     /* 266151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 266163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266165 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 266165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 266168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 266174 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 266182 */     GIR_RootConstrainSelectedInstOperands,
     /* 266183 */     // GIR_Coverage, 7161,
     /* 266183 */     GIR_EraseRootFromParent_Done,
     /* 266184 */   // Label 5177: @266184
     /* 266184 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(266295), // Rule ID 7153 //
     /* 266189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 266194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266225 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 266236 */     // MIs[0] addr
     /* 266236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 266248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266250 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266262 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 266281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266286 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266293 */     GIR_RootConstrainSelectedInstOperands,
     /* 266294 */     // GIR_Coverage, 7153,
     /* 266294 */     GIR_EraseRootFromParent_Done,
     /* 266295 */   // Label 5178: @266295
     /* 266295 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(266406), // Rule ID 7154 //
     /* 266300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 266305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266336 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 266347 */     // MIs[0] addr
     /* 266347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 266359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266361 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266373 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 266392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266397 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266404 */     GIR_RootConstrainSelectedInstOperands,
     /* 266405 */     // GIR_Coverage, 7154,
     /* 266405 */     GIR_EraseRootFromParent_Done,
     /* 266406 */   // Label 5179: @266406
     /* 266406 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(266517), // Rule ID 7155 //
     /* 266411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 266416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266447 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 266458 */     // MIs[0] addr
     /* 266458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 266470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266472 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266484 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 266503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266508 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266515 */     GIR_RootConstrainSelectedInstOperands,
     /* 266516 */     // GIR_Coverage, 7155,
     /* 266516 */     GIR_EraseRootFromParent_Done,
     /* 266517 */   // Label 5180: @266517
     /* 266517 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(266628), // Rule ID 7163 //
     /* 266522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 266527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266558 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 266569 */     // MIs[0] addr
     /* 266569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266577 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 266581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266583 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266595 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 266614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266619 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266626 */     GIR_RootConstrainSelectedInstOperands,
     /* 266627 */     // GIR_Coverage, 7163,
     /* 266627 */     GIR_EraseRootFromParent_Done,
     /* 266628 */   // Label 5181: @266628
     /* 266628 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(266739), // Rule ID 7164 //
     /* 266633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 266638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266669 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 266680 */     // MIs[0] addr
     /* 266680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 266692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266694 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266706 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 266725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266730 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266737 */     GIR_RootConstrainSelectedInstOperands,
     /* 266738 */     // GIR_Coverage, 7164,
     /* 266738 */     GIR_EraseRootFromParent_Done,
     /* 266739 */   // Label 5182: @266739
     /* 266739 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(266850), // Rule ID 7165 //
     /* 266744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 266749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266780 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 266791 */     // MIs[0] addr
     /* 266791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 266803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266805 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266817 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 266836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266841 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266848 */     GIR_RootConstrainSelectedInstOperands,
     /* 266849 */     // GIR_Coverage, 7165,
     /* 266849 */     GIR_EraseRootFromParent_Done,
     /* 266850 */   // Label 5183: @266850
     /* 266850 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(266901), // Rule ID 70 //
     /* 266855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 266860 */     // MIs[0] ptr
     /* 266860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 266864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 266868 */     // MIs[0] accessinfo
     /* 266868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 266871 */     // MIs[0] fixed_shadow
     /* 266871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 266874 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 266874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 266877 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 266879 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 266881 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 266883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 266886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 266889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 266892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 266895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266899 */     GIR_RootConstrainSelectedInstOperands,
     /* 266900 */     // GIR_Coverage, 70,
     /* 266900 */     GIR_EraseRootFromParent_Done,
     /* 266901 */   // Label 5184: @266901
     /* 266901 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(266952), // Rule ID 71 //
     /* 266906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 266911 */     // MIs[0] ptr
     /* 266911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 266915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 266919 */     // MIs[0] accessinfo
     /* 266919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 266922 */     // MIs[0] fixed_shadow
     /* 266922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 266925 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 266925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 266928 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 266930 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 266932 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 266934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 266937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 266940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 266943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 266946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266950 */     GIR_RootConstrainSelectedInstOperands,
     /* 266951 */     // GIR_Coverage, 71,
     /* 266951 */     GIR_EraseRootFromParent_Done,
     /* 266952 */   // Label 5185: @266952
     /* 266952 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(267021), // Rule ID 7152 //
     /* 266957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 266962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 266980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266989 */     // MIs[0] addr
     /* 266989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 267001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267003 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 267006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 267012 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 267019 */     GIR_RootConstrainSelectedInstOperands,
     /* 267020 */     // GIR_Coverage, 7152,
     /* 267020 */     GIR_EraseRootFromParent_Done,
     /* 267021 */   // Label 5186: @267021
     /* 267021 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(267090), // Rule ID 7162 //
     /* 267026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 267031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267058 */     // MIs[0] addr
     /* 267058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 267070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267072 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 267075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 267081 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 267088 */     GIR_RootConstrainSelectedInstOperands,
     /* 267089 */     // GIR_Coverage, 7162,
     /* 267089 */     GIR_EraseRootFromParent_Done,
     /* 267090 */   // Label 5187: @267090
     /* 267090 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(267132), // Rule ID 3594 //
     /* 267095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 267103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267109 */     // MIs[0] tile
     /* 267109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267117 */     // (intrinsic_void 1022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 267120 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267130 */     GIR_RootConstrainSelectedInstOperands,
     /* 267131 */     // GIR_Coverage, 3594,
     /* 267131 */     GIR_EraseRootFromParent_Done,
     /* 267132 */   // Label 5188: @267132
     /* 267132 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(267174), // Rule ID 3598 //
     /* 267137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 267145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267151 */     // MIs[0] tile
     /* 267151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267159 */     // (intrinsic_void 1022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 267162 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267172 */     GIR_RootConstrainSelectedInstOperands,
     /* 267173 */     // GIR_Coverage, 3598,
     /* 267173 */     GIR_EraseRootFromParent_Done,
     /* 267174 */   // Label 5189: @267174
     /* 267174 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(267216), // Rule ID 3602 //
     /* 267179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 267182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 267187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267193 */     // MIs[0] tile
     /* 267193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 267201 */     // (intrinsic_void 1026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 267204 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267214 */     GIR_RootConstrainSelectedInstOperands,
     /* 267215 */     // GIR_Coverage, 3602,
     /* 267215 */     GIR_EraseRootFromParent_Done,
     /* 267216 */   // Label 5190: @267216
     /* 267216 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(267258), // Rule ID 3772 //
     /* 267221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 267224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 267229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267235 */     // MIs[0] tile
     /* 267235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 267243 */     // (intrinsic_void 919:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 267243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 267246 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267256 */     GIR_RootConstrainSelectedInstOperands,
     /* 267257 */     // GIR_Coverage, 3772,
     /* 267257 */     GIR_EraseRootFromParent_Done,
     /* 267258 */   // Label 5191: @267258
     /* 267258 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(267300), // Rule ID 3776 //
     /* 267263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 267266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 267271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267277 */     // MIs[0] tile
     /* 267277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267285 */     // (intrinsic_void 882:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 267288 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267298 */     GIR_RootConstrainSelectedInstOperands,
     /* 267299 */     // GIR_Coverage, 3776,
     /* 267299 */     GIR_EraseRootFromParent_Done,
     /* 267300 */   // Label 5192: @267300
     /* 267300 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(267342), // Rule ID 3780 //
     /* 267305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 267313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 267316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 267319 */     // MIs[0] tile
     /* 267319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267327 */     // (intrinsic_void 919:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 267327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 267330 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267340 */     GIR_RootConstrainSelectedInstOperands,
     /* 267341 */     // GIR_Coverage, 3780,
     /* 267341 */     GIR_EraseRootFromParent_Done,
     /* 267342 */   // Label 5193: @267342
     /* 267342 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(267384), // Rule ID 3784 //
     /* 267347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 267350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 267355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 267358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 267361 */     // MIs[0] tile
     /* 267361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 267369 */     // (intrinsic_void 919:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 267369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 267372 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267382 */     GIR_RootConstrainSelectedInstOperands,
     /* 267383 */     // GIR_Coverage, 3784,
     /* 267383 */     GIR_EraseRootFromParent_Done,
     /* 267384 */   // Label 5194: @267384
     /* 267384 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(267426), // Rule ID 3788 //
     /* 267389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 267397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267403 */     // MIs[0] tile
     /* 267403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267411 */     // (intrinsic_void 923:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 267411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 267414 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267424 */     GIR_RootConstrainSelectedInstOperands,
     /* 267425 */     // GIR_Coverage, 3788,
     /* 267425 */     GIR_EraseRootFromParent_Done,
     /* 267426 */   // Label 5195: @267426
     /* 267426 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(267468), // Rule ID 3792 //
     /* 267431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 267434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 267439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267445 */     // MIs[0] tile
     /* 267445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 267453 */     // (intrinsic_void 878:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 267456 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267466 */     GIR_RootConstrainSelectedInstOperands,
     /* 267467 */     // GIR_Coverage, 3792,
     /* 267467 */     GIR_EraseRootFromParent_Done,
     /* 267468 */   // Label 5196: @267468
     /* 267468 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(267510), // Rule ID 12657 //
     /* 267473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 267481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267487 */     // MIs[0] tile
     /* 267487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267495 */     // (intrinsic_void 1030:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 267498 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267508 */     GIR_RootConstrainSelectedInstOperands,
     /* 267509 */     // GIR_Coverage, 12657,
     /* 267509 */     GIR_EraseRootFromParent_Done,
     /* 267510 */   // Label 5197: @267510
     /* 267510 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(267552), // Rule ID 12661 //
     /* 267515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 267523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267529 */     // MIs[0] tile
     /* 267529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267537 */     // (intrinsic_void 1074:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 267540 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267550 */     GIR_RootConstrainSelectedInstOperands,
     /* 267551 */     // GIR_Coverage, 12661,
     /* 267551 */     GIR_EraseRootFromParent_Done,
     /* 267552 */   // Label 5198: @267552
     /* 267552 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(267594), // Rule ID 12665 //
     /* 267557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 267565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267571 */     // MIs[0] tile
     /* 267571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267579 */     // (intrinsic_void 1082:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 267582 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267592 */     GIR_RootConstrainSelectedInstOperands,
     /* 267593 */     // GIR_Coverage, 12665,
     /* 267593 */     GIR_EraseRootFromParent_Done,
     /* 267594 */   // Label 5199: @267594
     /* 267594 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(267636), // Rule ID 12669 //
     /* 267599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 267607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267613 */     // MIs[0] tile
     /* 267613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267621 */     // (intrinsic_void 1191:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 267624 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267634 */     GIR_RootConstrainSelectedInstOperands,
     /* 267635 */     // GIR_Coverage, 12669,
     /* 267635 */     GIR_EraseRootFromParent_Done,
     /* 267636 */   // Label 5200: @267636
     /* 267636 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(267678), // Rule ID 12673 //
     /* 267641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 267649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267655 */     // MIs[0] tile
     /* 267655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267663 */     // (intrinsic_void 1199:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 267666 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267676 */     GIR_RootConstrainSelectedInstOperands,
     /* 267677 */     // GIR_Coverage, 12673,
     /* 267677 */     GIR_EraseRootFromParent_Done,
     /* 267678 */   // Label 5201: @267678
     /* 267678 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(267720), // Rule ID 12677 //
     /* 267683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 267691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267697 */     // MIs[0] tile
     /* 267697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267705 */     // (intrinsic_void 1157:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 267708 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267718 */     GIR_RootConstrainSelectedInstOperands,
     /* 267719 */     // GIR_Coverage, 12677,
     /* 267719 */     GIR_EraseRootFromParent_Done,
     /* 267720 */   // Label 5202: @267720
     /* 267720 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(267762), // Rule ID 12681 //
     /* 267725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 267733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267739 */     // MIs[0] tile
     /* 267739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267747 */     // (intrinsic_void 1165:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 267750 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267760 */     GIR_RootConstrainSelectedInstOperands,
     /* 267761 */     // GIR_Coverage, 12681,
     /* 267761 */     GIR_EraseRootFromParent_Done,
     /* 267762 */   // Label 5203: @267762
     /* 267762 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(267804), // Rule ID 12685 //
     /* 267767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 267775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267781 */     // MIs[0] tile
     /* 267781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267784 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267789 */     // (intrinsic_void 1030:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 267792 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267802 */     GIR_RootConstrainSelectedInstOperands,
     /* 267803 */     // GIR_Coverage, 12685,
     /* 267803 */     GIR_EraseRootFromParent_Done,
     /* 267804 */   // Label 5204: @267804
     /* 267804 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(267846), // Rule ID 12689 //
     /* 267809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 267817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267823 */     // MIs[0] tile
     /* 267823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267831 */     // (intrinsic_void 1157:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 267834 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267844 */     GIR_RootConstrainSelectedInstOperands,
     /* 267845 */     // GIR_Coverage, 12689,
     /* 267845 */     GIR_EraseRootFromParent_Done,
     /* 267846 */   // Label 5205: @267846
     /* 267846 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(267888), // Rule ID 12693 //
     /* 267851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 267859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267865 */     // MIs[0] tile
     /* 267865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267873 */     // (intrinsic_void 1165:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 267876 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267886 */     GIR_RootConstrainSelectedInstOperands,
     /* 267887 */     // GIR_Coverage, 12693,
     /* 267887 */     GIR_EraseRootFromParent_Done,
     /* 267888 */   // Label 5206: @267888
     /* 267888 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(267930), // Rule ID 12697 //
     /* 267893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 267896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 267901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267907 */     // MIs[0] tile
     /* 267907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 267915 */     // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 267918 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267928 */     GIR_RootConstrainSelectedInstOperands,
     /* 267929 */     // GIR_Coverage, 12697,
     /* 267929 */     GIR_EraseRootFromParent_Done,
     /* 267930 */   // Label 5207: @267930
     /* 267930 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(267972), // Rule ID 12701 //
     /* 267935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 267938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 267943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267949 */     // MIs[0] tile
     /* 267949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 267957 */     // (intrinsic_void 1078:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 267960 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267970 */     GIR_RootConstrainSelectedInstOperands,
     /* 267971 */     // GIR_Coverage, 12701,
     /* 267971 */     GIR_EraseRootFromParent_Done,
     /* 267972 */   // Label 5208: @267972
     /* 267972 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(268014), // Rule ID 12705 //
     /* 267977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 267980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 267985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267991 */     // MIs[0] tile
     /* 267991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 267999 */     // (intrinsic_void 1086:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 268002 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268012 */     GIR_RootConstrainSelectedInstOperands,
     /* 268013 */     // GIR_Coverage, 12705,
     /* 268013 */     GIR_EraseRootFromParent_Done,
     /* 268014 */   // Label 5209: @268014
     /* 268014 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(268056), // Rule ID 12709 //
     /* 268019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 268027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268033 */     // MIs[0] tile
     /* 268033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268041 */     // (intrinsic_void 1161:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 268044 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268054 */     GIR_RootConstrainSelectedInstOperands,
     /* 268055 */     // GIR_Coverage, 12709,
     /* 268055 */     GIR_EraseRootFromParent_Done,
     /* 268056 */   // Label 5210: @268056
     /* 268056 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(268098), // Rule ID 12713 //
     /* 268061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 268069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268075 */     // MIs[0] tile
     /* 268075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268083 */     // (intrinsic_void 1169:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 268086 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268096 */     GIR_RootConstrainSelectedInstOperands,
     /* 268097 */     // GIR_Coverage, 12713,
     /* 268097 */     GIR_EraseRootFromParent_Done,
     /* 268098 */   // Label 5211: @268098
     /* 268098 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(268140), // Rule ID 12717 //
     /* 268103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 268111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268117 */     // MIs[0] tile
     /* 268117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268125 */     // (intrinsic_void 1195:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 268128 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268138 */     GIR_RootConstrainSelectedInstOperands,
     /* 268139 */     // GIR_Coverage, 12717,
     /* 268139 */     GIR_EraseRootFromParent_Done,
     /* 268140 */   // Label 5212: @268140
     /* 268140 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(268182), // Rule ID 12721 //
     /* 268145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 268153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268159 */     // MIs[0] tile
     /* 268159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268167 */     // (intrinsic_void 1203:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 268170 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268180 */     GIR_RootConstrainSelectedInstOperands,
     /* 268181 */     // GIR_Coverage, 12721,
     /* 268181 */     GIR_EraseRootFromParent_Done,
     /* 268182 */   // Label 5213: @268182
     /* 268182 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(268224), // Rule ID 13176 //
     /* 268187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 268195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268201 */     // MIs[0] tile
     /* 268201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268209 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 268209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 268212 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268222 */     GIR_RootConstrainSelectedInstOperands,
     /* 268223 */     // GIR_Coverage, 13176,
     /* 268223 */     GIR_EraseRootFromParent_Done,
     /* 268224 */   // Label 5214: @268224
     /* 268224 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(268266), // Rule ID 13180 //
     /* 268229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 268237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 268240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 268243 */     // MIs[0] tile
     /* 268243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268251 */     // (intrinsic_void 927:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 268251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 268254 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268264 */     GIR_RootConstrainSelectedInstOperands,
     /* 268265 */     // GIR_Coverage, 13180,
     /* 268265 */     GIR_EraseRootFromParent_Done,
     /* 268266 */   // Label 5215: @268266
     /* 268266 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(268308), // Rule ID 13184 //
     /* 268271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 268274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 268279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268285 */     // MIs[0] tile
     /* 268285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 268293 */     // (intrinsic_void 927:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 268293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 268296 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268306 */     GIR_RootConstrainSelectedInstOperands,
     /* 268307 */     // GIR_Coverage, 13184,
     /* 268307 */     GIR_EraseRootFromParent_Done,
     /* 268308 */   // Label 5216: @268308
     /* 268308 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(268350), // Rule ID 13188 //
     /* 268313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 268316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 268321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 268324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 268327 */     // MIs[0] tile
     /* 268327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268335 */     // (intrinsic_void 927:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 268335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 268338 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268348 */     GIR_RootConstrainSelectedInstOperands,
     /* 268349 */     // GIR_Coverage, 13188,
     /* 268349 */     GIR_EraseRootFromParent_Done,
     /* 268350 */   // Label 5217: @268350
     /* 268350 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(268404), // Rule ID 8899 //
     /* 268355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 268363 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 268366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 268370 */     // MIs[0] base
     /* 268370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268378 */     // MIs[0] prfop
     /* 268378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 268386 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 268386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 268389 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 268391 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 268393 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 268395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268402 */     GIR_RootConstrainSelectedInstOperands,
     /* 268403 */     // GIR_Coverage, 8899,
     /* 268403 */     GIR_EraseRootFromParent_Done,
     /* 268404 */   // Label 5218: @268404
     /* 268404 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(268458), // Rule ID 8902 //
     /* 268409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 268417 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 268420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 268424 */     // MIs[0] base
     /* 268424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268432 */     // MIs[0] prfop
     /* 268432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 268440 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 268440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 268443 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 268445 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 268447 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 268449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268456 */     GIR_RootConstrainSelectedInstOperands,
     /* 268457 */     // GIR_Coverage, 8902,
     /* 268457 */     GIR_EraseRootFromParent_Done,
     /* 268458 */   // Label 5219: @268458
     /* 268458 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(268512), // Rule ID 8905 //
     /* 268463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 268471 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 268474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 268478 */     // MIs[0] base
     /* 268478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268486 */     // MIs[0] prfop
     /* 268486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 268494 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 268494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 268497 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 268499 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 268501 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 268503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268510 */     GIR_RootConstrainSelectedInstOperands,
     /* 268511 */     // GIR_Coverage, 8905,
     /* 268511 */     GIR_EraseRootFromParent_Done,
     /* 268512 */   // Label 5220: @268512
     /* 268512 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(268566), // Rule ID 8908 //
     /* 268517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 268525 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 268528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 268532 */     // MIs[0] base
     /* 268532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268540 */     // MIs[0] prfop
     /* 268540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 268548 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 268548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 268551 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 268553 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 268555 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 268557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268564 */     GIR_RootConstrainSelectedInstOperands,
     /* 268565 */     // GIR_Coverage, 8908,
     /* 268565 */     GIR_EraseRootFromParent_Done,
     /* 268566 */   // Label 5221: @268566
     /* 268566 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(268620), // Rule ID 15 //
     /* 268571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 268576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 268582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 268585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268597 */     // MIs[1] Operand 1
     /* 268597 */     // No operand predicates
     /* 268597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268603 */     // (intrinsic_w_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 268603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 268606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 268611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268618 */     GIR_RootConstrainSelectedInstOperands,
     /* 268619 */     // GIR_Coverage, 15,
     /* 268619 */     GIR_EraseRootFromParent_Done,
     /* 268620 */   // Label 5222: @268620
     /* 268620 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(268688), // Rule ID 68 //
     /* 268625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 268630 */     // MIs[0] Operand 1
     /* 268630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 268638 */     // MIs[0] ptr
     /* 268638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268646 */     // MIs[0] accessinfo
     /* 268646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268649 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 268649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268653 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268659 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 268663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 268666 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 268668 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 268670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268686 */     GIR_RootConstrainSelectedInstOperands,
     /* 268687 */     // GIR_Coverage, 68,
     /* 268687 */     GIR_EraseRootFromParent_Done,
     /* 268688 */   // Label 5223: @268688
     /* 268688 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(268756), // Rule ID 69 //
     /* 268693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 268698 */     // MIs[0] Operand 1
     /* 268698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 268706 */     // MIs[0] ptr
     /* 268706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268714 */     // MIs[0] accessinfo
     /* 268714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268717 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 268717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268721 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 268731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 268734 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 268736 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 268738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268754 */     GIR_RootConstrainSelectedInstOperands,
     /* 268755 */     // GIR_Coverage, 69,
     /* 268755 */     GIR_EraseRootFromParent_Done,
     /* 268756 */   // Label 5224: @268756
     /* 268756 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(268836), // Rule ID 7146 //
     /* 268761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268780 */     // MIs[0] addr
     /* 268780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268788 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 268792 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268804 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 268823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268828 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268834 */     GIR_RootConstrainSelectedInstOperands,
     /* 268835 */     // GIR_Coverage, 7146,
     /* 268835 */     GIR_EraseRootFromParent_Done,
     /* 268836 */   // Label 5225: @268836
     /* 268836 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(268916), // Rule ID 7147 //
     /* 268841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268860 */     // MIs[0] addr
     /* 268860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 268872 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268884 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 268903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268908 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268914 */     GIR_RootConstrainSelectedInstOperands,
     /* 268915 */     // GIR_Coverage, 7147,
     /* 268915 */     GIR_EraseRootFromParent_Done,
     /* 268916 */   // Label 5226: @268916
     /* 268916 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(268996), // Rule ID 7148 //
     /* 268921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268940 */     // MIs[0] addr
     /* 268940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268948 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 268952 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268964 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 268983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268988 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268994 */     GIR_RootConstrainSelectedInstOperands,
     /* 268995 */     // GIR_Coverage, 7148,
     /* 268995 */     GIR_EraseRootFromParent_Done,
     /* 268996 */   // Label 5227: @268996
     /* 268996 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(269047), // Rule ID 7149 //
     /* 269001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 269006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269020 */     // MIs[0] addr
     /* 269020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 269032 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 269035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269037 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 269039 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269045 */     GIR_RootConstrainSelectedInstOperands,
     /* 269046 */     // GIR_Coverage, 7149,
     /* 269046 */     GIR_EraseRootFromParent_Done,
     /* 269047 */   // Label 5228: @269047
     /* 269047 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(269127), // Rule ID 7156 //
     /* 269052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269071 */     // MIs[0] addr
     /* 269071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269079 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 269083 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 269083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269095 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 269101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 269114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269119 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269125 */     GIR_RootConstrainSelectedInstOperands,
     /* 269126 */     // GIR_Coverage, 7156,
     /* 269126 */     GIR_EraseRootFromParent_Done,
     /* 269127 */   // Label 5229: @269127
     /* 269127 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(269207), // Rule ID 7157 //
     /* 269132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269151 */     // MIs[0] addr
     /* 269151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 269163 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 269163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269175 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 269181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 269194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269199 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269205 */     GIR_RootConstrainSelectedInstOperands,
     /* 269206 */     // GIR_Coverage, 7157,
     /* 269206 */     GIR_EraseRootFromParent_Done,
     /* 269207 */   // Label 5230: @269207
     /* 269207 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(269287), // Rule ID 7158 //
     /* 269212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269231 */     // MIs[0] addr
     /* 269231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 269243 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 269243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269255 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 269261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 269274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269279 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269285 */     GIR_RootConstrainSelectedInstOperands,
     /* 269286 */     // GIR_Coverage, 7158,
     /* 269286 */     GIR_EraseRootFromParent_Done,
     /* 269287 */   // Label 5231: @269287
     /* 269287 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(269338), // Rule ID 7159 //
     /* 269292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269311 */     // MIs[0] addr
     /* 269311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 269323 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 269326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269328 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 269330 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269336 */     GIR_RootConstrainSelectedInstOperands,
     /* 269337 */     // GIR_Coverage, 7159,
     /* 269337 */     GIR_EraseRootFromParent_Done,
     /* 269338 */   // Label 5232: @269338
     /* 269338 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(269387), // Rule ID 2481 //
     /* 269343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 269351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 269354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 269360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269372 */     // (intrinsic_w_chain:{ *:[v8i8] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 269372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 269375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269385 */     GIR_RootConstrainSelectedInstOperands,
     /* 269386 */     // GIR_Coverage, 2481,
     /* 269386 */     GIR_EraseRootFromParent_Done,
     /* 269387 */   // Label 5233: @269387
     /* 269387 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(269436), // Rule ID 2482 //
     /* 269392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 269400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 269403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 269409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269421 */     // (intrinsic_w_chain:{ *:[v16i8] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 269421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 269424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269434 */     GIR_RootConstrainSelectedInstOperands,
     /* 269435 */     // GIR_Coverage, 2482,
     /* 269435 */     GIR_EraseRootFromParent_Done,
     /* 269436 */   // Label 5234: @269436
     /* 269436 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(269485), // Rule ID 2483 //
     /* 269441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 269449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 269452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 269458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269470 */     // (intrinsic_w_chain:{ *:[v8i8] } 620:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 269470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 269473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269483 */     GIR_RootConstrainSelectedInstOperands,
     /* 269484 */     // GIR_Coverage, 2483,
     /* 269484 */     GIR_EraseRootFromParent_Done,
     /* 269485 */   // Label 5235: @269485
     /* 269485 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(269538), // Rule ID 8785 //
     /* 269490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 269498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 269501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269512 */     // MIs[0] base
     /* 269512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269520 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1574:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 269523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 269525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269527 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269536 */     GIR_RootConstrainSelectedInstOperands,
     /* 269537 */     // GIR_Coverage, 8785,
     /* 269537 */     GIR_EraseRootFromParent_Done,
     /* 269538 */   // Label 5236: @269538
     /* 269538 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(269591), // Rule ID 8788 //
     /* 269543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 269551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 269554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269565 */     // MIs[0] base
     /* 269565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269573 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1574:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 269576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 269578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269580 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269589 */     GIR_RootConstrainSelectedInstOperands,
     /* 269590 */     // GIR_Coverage, 8788,
     /* 269590 */     GIR_EraseRootFromParent_Done,
     /* 269591 */   // Label 5237: @269591
     /* 269591 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(269644), // Rule ID 8797 //
     /* 269596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 269604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 269607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269618 */     // MIs[0] base
     /* 269618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269626 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1573:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 269629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 269631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269633 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269642 */     GIR_RootConstrainSelectedInstOperands,
     /* 269643 */     // GIR_Coverage, 8797,
     /* 269643 */     GIR_EraseRootFromParent_Done,
     /* 269644 */   // Label 5238: @269644
     /* 269644 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(269697), // Rule ID 8800 //
     /* 269649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 269657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 269660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269671 */     // MIs[0] base
     /* 269671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269679 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1573:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 269682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 269684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269686 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269695 */     GIR_RootConstrainSelectedInstOperands,
     /* 269696 */     // GIR_Coverage, 8800,
     /* 269696 */     GIR_EraseRootFromParent_Done,
     /* 269697 */   // Label 5239: @269697
     /* 269697 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(269743), // Rule ID 137 //
     /* 269702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 269705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 269710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269720 */     // MIs[0] Rn
     /* 269720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269732 */     // (intrinsic_w_chain:{ *:[i64] } 565:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 269732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 269735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269741 */     GIR_RootConstrainSelectedInstOperands,
     /* 269742 */     // GIR_Coverage, 137,
     /* 269742 */     GIR_EraseRootFromParent_Done,
     /* 269743 */   // Label 5240: @269743
     /* 269743 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(269796), // Rule ID 8791 //
     /* 269748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 269756 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 269759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269770 */     // MIs[0] base
     /* 269770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269778 */     // (intrinsic_void 1894:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 269781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 269783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269785 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269794 */     GIR_RootConstrainSelectedInstOperands,
     /* 269795 */     // GIR_Coverage, 8791,
     /* 269795 */     GIR_EraseRootFromParent_Done,
     /* 269796 */   // Label 5241: @269796
     /* 269796 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(269849), // Rule ID 8794 //
     /* 269801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 269809 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 269812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269823 */     // MIs[0] base
     /* 269823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269831 */     // (intrinsic_void 1894:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 269834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 269836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269838 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269847 */     GIR_RootConstrainSelectedInstOperands,
     /* 269848 */     // GIR_Coverage, 8794,
     /* 269848 */     GIR_EraseRootFromParent_Done,
     /* 269849 */   // Label 5242: @269849
     /* 269849 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(269902), // Rule ID 8803 //
     /* 269854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 269862 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 269865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269876 */     // MIs[0] base
     /* 269876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269884 */     // (intrinsic_void 1890:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 269887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 269889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269891 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269900 */     GIR_RootConstrainSelectedInstOperands,
     /* 269901 */     // GIR_Coverage, 8803,
     /* 269901 */     GIR_EraseRootFromParent_Done,
     /* 269902 */   // Label 5243: @269902
     /* 269902 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(269955), // Rule ID 8806 //
     /* 269907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 269915 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 269918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269929 */     // MIs[0] base
     /* 269929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269937 */     // (intrinsic_void 1890:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 269940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 269942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269944 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269953 */     GIR_RootConstrainSelectedInstOperands,
     /* 269954 */     // GIR_Coverage, 8806,
     /* 269954 */     GIR_EraseRootFromParent_Done,
     /* 269955 */   // Label 5244: @269955
     /* 269955 */   GIM_Reject,
     /* 269956 */ // Label 5173: @269956
     /* 269956 */ GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(272661),
     /* 269961 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 269964 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(270035), // Rule ID 3406 //
     /* 269969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 269972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 269977 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270006 */     // MIs[1] Operand 1
     /* 270006 */     // No operand predicates
     /* 270006 */     // MIs[0] prfop
     /* 270006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270016 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 270016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 270019 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270033 */     GIR_RootConstrainSelectedInstOperands,
     /* 270034 */     // GIR_Coverage, 3406,
     /* 270034 */     GIR_EraseRootFromParent_Done,
     /* 270035 */   // Label 5246: @270035
     /* 270035 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(270106), // Rule ID 3419 //
     /* 270040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 270048 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 270054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270077 */     // MIs[1] Operand 1
     /* 270077 */     // No operand predicates
     /* 270077 */     // MIs[0] prfop
     /* 270077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270087 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 270087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 270090 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270104 */     GIR_RootConstrainSelectedInstOperands,
     /* 270105 */     // GIR_Coverage, 3419,
     /* 270105 */     GIR_EraseRootFromParent_Done,
     /* 270106 */   // Label 5247: @270106
     /* 270106 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(270165), // Rule ID 3606 //
     /* 270111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 270114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 270119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 270122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 270125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 270128 */     // MIs[0] tile
     /* 270128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 270136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270148 */     // (intrinsic_void 804:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 270148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 270151 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270153 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 270155 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 270157 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 270159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270163 */     GIR_RootConstrainSelectedInstOperands,
     /* 270164 */     // GIR_Coverage, 3606,
     /* 270164 */     GIR_EraseRootFromParent_Done,
     /* 270165 */   // Label 5248: @270165
     /* 270165 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(270224), // Rule ID 3607 //
     /* 270170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 270173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 270178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 270181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 270184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 270187 */     // MIs[0] tile
     /* 270187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 270195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270207 */     // (intrinsic_void 804:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 270207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 270210 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270212 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 270214 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 270216 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 270218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270222 */     GIR_RootConstrainSelectedInstOperands,
     /* 270223 */     // GIR_Coverage, 3607,
     /* 270223 */     GIR_EraseRootFromParent_Done,
     /* 270224 */   // Label 5249: @270224
     /* 270224 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(270283), // Rule ID 12638 //
     /* 270229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 270232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 270237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 270240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 270243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 270246 */     // MIs[0] tile
     /* 270246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270249 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 270254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270266 */     // (intrinsic_void 805:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 270266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 270269 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270271 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 270273 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 270275 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 270277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270281 */     GIR_RootConstrainSelectedInstOperands,
     /* 270282 */     // GIR_Coverage, 12638,
     /* 270282 */     GIR_EraseRootFromParent_Done,
     /* 270283 */   // Label 5250: @270283
     /* 270283 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(270342), // Rule ID 12639 //
     /* 270288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 270291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 270296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 270299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 270302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 270305 */     // MIs[0] tile
     /* 270305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270308 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 270313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270325 */     // (intrinsic_void 805:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 270325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 270328 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270330 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 270332 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 270334 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 270336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270340 */     GIR_RootConstrainSelectedInstOperands,
     /* 270341 */     // GIR_Coverage, 12639,
     /* 270341 */     GIR_EraseRootFromParent_Done,
     /* 270342 */   // Label 5251: @270342
     /* 270342 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(270402), // Rule ID 3404 //
     /* 270347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 270355 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270365 */     // MIs[0] Rn
     /* 270365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270377 */     // MIs[0] prfop
     /* 270377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270385 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 270385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 270388 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270400 */     GIR_RootConstrainSelectedInstOperands,
     /* 270401 */     // GIR_Coverage, 3404,
     /* 270401 */     GIR_EraseRootFromParent_Done,
     /* 270402 */   // Label 5252: @270402
     /* 270402 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(270462), // Rule ID 3405 //
     /* 270407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 270415 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270425 */     // MIs[0] Rn
     /* 270425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270437 */     // MIs[0] prfop
     /* 270437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270440 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270445 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 270445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 270448 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270460 */     GIR_RootConstrainSelectedInstOperands,
     /* 270461 */     // GIR_Coverage, 3405,
     /* 270461 */     GIR_EraseRootFromParent_Done,
     /* 270462 */   // Label 5253: @270462
     /* 270462 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(270522), // Rule ID 3416 //
     /* 270467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 270475 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 270481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270485 */     // MIs[0] Rn
     /* 270485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270497 */     // MIs[0] prfop
     /* 270497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270505 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 270505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 270508 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270520 */     GIR_RootConstrainSelectedInstOperands,
     /* 270521 */     // GIR_Coverage, 3416,
     /* 270521 */     GIR_EraseRootFromParent_Done,
     /* 270522 */   // Label 5254: @270522
     /* 270522 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(270582), // Rule ID 3417 //
     /* 270527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 270535 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 270541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270545 */     // MIs[0] Rn
     /* 270545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270557 */     // MIs[0] prfop
     /* 270557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270560 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270565 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 270565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 270568 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270580 */     GIR_RootConstrainSelectedInstOperands,
     /* 270581 */     // GIR_Coverage, 3417,
     /* 270581 */     GIR_EraseRootFromParent_Done,
     /* 270582 */   // Label 5255: @270582
     /* 270582 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(270642), // Rule ID 3418 //
     /* 270587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 270595 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 270601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270605 */     // MIs[0] Rn
     /* 270605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270617 */     // MIs[0] prfop
     /* 270617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270625 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 270625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 270628 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270640 */     GIR_RootConstrainSelectedInstOperands,
     /* 270641 */     // GIR_Coverage, 3418,
     /* 270641 */     GIR_EraseRootFromParent_Done,
     /* 270642 */   // Label 5256: @270642
     /* 270642 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(270702), // Rule ID 8911 //
     /* 270647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 270655 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270665 */     // MIs[0] Rn
     /* 270665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270677 */     // MIs[0] prfop
     /* 270677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270685 */     // (intrinsic_void 1653:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 270685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 270688 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270700 */     GIR_RootConstrainSelectedInstOperands,
     /* 270701 */     // GIR_Coverage, 8911,
     /* 270701 */     GIR_EraseRootFromParent_Done,
     /* 270702 */   // Label 5257: @270702
     /* 270702 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(270762), // Rule ID 8912 //
     /* 270707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 270715 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270725 */     // MIs[0] Rn
     /* 270725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270737 */     // MIs[0] prfop
     /* 270737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270745 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 270745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 270748 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270760 */     GIR_RootConstrainSelectedInstOperands,
     /* 270761 */     // GIR_Coverage, 8912,
     /* 270761 */     GIR_EraseRootFromParent_Done,
     /* 270762 */   // Label 5258: @270762
     /* 270762 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(270822), // Rule ID 8913 //
     /* 270767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 270775 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270785 */     // MIs[0] Rn
     /* 270785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270797 */     // MIs[0] prfop
     /* 270797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270805 */     // (intrinsic_void 1657:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 270805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 270808 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270820 */     GIR_RootConstrainSelectedInstOperands,
     /* 270821 */     // GIR_Coverage, 8913,
     /* 270821 */     GIR_EraseRootFromParent_Done,
     /* 270822 */   // Label 5259: @270822
     /* 270822 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(270882), // Rule ID 8914 //
     /* 270827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 270835 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270845 */     // MIs[0] Rn
     /* 270845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270857 */     // MIs[0] prfop
     /* 270857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270865 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 270865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 270868 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270880 */     GIR_RootConstrainSelectedInstOperands,
     /* 270881 */     // GIR_Coverage, 8914,
     /* 270881 */     GIR_EraseRootFromParent_Done,
     /* 270882 */   // Label 5260: @270882
     /* 270882 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(270942), // Rule ID 8915 //
     /* 270887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 270895 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270905 */     // MIs[0] Rn
     /* 270905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270917 */     // MIs[0] prfop
     /* 270917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270920 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270925 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 270925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 270928 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270940 */     GIR_RootConstrainSelectedInstOperands,
     /* 270941 */     // GIR_Coverage, 8915,
     /* 270941 */     GIR_EraseRootFromParent_Done,
     /* 270942 */   // Label 5261: @270942
     /* 270942 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(271002), // Rule ID 8916 //
     /* 270947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 270955 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270965 */     // MIs[0] Rn
     /* 270965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270977 */     // MIs[0] prfop
     /* 270977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270985 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 270985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 270988 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271000 */     GIR_RootConstrainSelectedInstOperands,
     /* 271001 */     // GIR_Coverage, 8916,
     /* 271001 */     GIR_EraseRootFromParent_Done,
     /* 271002 */   // Label 5262: @271002
     /* 271002 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(271062), // Rule ID 8917 //
     /* 271007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 271015 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271025 */     // MIs[0] Rn
     /* 271025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271037 */     // MIs[0] prfop
     /* 271037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271040 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271045 */     // (intrinsic_void 1653:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 271045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 271048 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271060 */     GIR_RootConstrainSelectedInstOperands,
     /* 271061 */     // GIR_Coverage, 8917,
     /* 271061 */     GIR_EraseRootFromParent_Done,
     /* 271062 */   // Label 5263: @271062
     /* 271062 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(271122), // Rule ID 8918 //
     /* 271067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 271075 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271085 */     // MIs[0] Rn
     /* 271085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271097 */     // MIs[0] prfop
     /* 271097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271100 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271105 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 271105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 271108 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271120 */     GIR_RootConstrainSelectedInstOperands,
     /* 271121 */     // GIR_Coverage, 8918,
     /* 271121 */     GIR_EraseRootFromParent_Done,
     /* 271122 */   // Label 5264: @271122
     /* 271122 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(271182), // Rule ID 8919 //
     /* 271127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 271135 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271145 */     // MIs[0] Rn
     /* 271145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271157 */     // MIs[0] prfop
     /* 271157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271160 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271165 */     // (intrinsic_void 1657:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 271165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 271168 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271180 */     GIR_RootConstrainSelectedInstOperands,
     /* 271181 */     // GIR_Coverage, 8919,
     /* 271181 */     GIR_EraseRootFromParent_Done,
     /* 271182 */   // Label 5265: @271182
     /* 271182 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(271242), // Rule ID 8920 //
     /* 271187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 271195 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271205 */     // MIs[0] Rn
     /* 271205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271217 */     // MIs[0] prfop
     /* 271217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271225 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 271225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 271228 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271240 */     GIR_RootConstrainSelectedInstOperands,
     /* 271241 */     // GIR_Coverage, 8920,
     /* 271241 */     GIR_EraseRootFromParent_Done,
     /* 271242 */   // Label 5266: @271242
     /* 271242 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(271302), // Rule ID 8921 //
     /* 271247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 271255 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271265 */     // MIs[0] Rn
     /* 271265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271277 */     // MIs[0] prfop
     /* 271277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271285 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 271285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 271288 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271300 */     GIR_RootConstrainSelectedInstOperands,
     /* 271301 */     // GIR_Coverage, 8921,
     /* 271301 */     GIR_EraseRootFromParent_Done,
     /* 271302 */   // Label 5267: @271302
     /* 271302 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(271362), // Rule ID 8922 //
     /* 271307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 271315 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271325 */     // MIs[0] Rn
     /* 271325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271337 */     // MIs[0] prfop
     /* 271337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271345 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 271345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 271348 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271360 */     GIR_RootConstrainSelectedInstOperands,
     /* 271361 */     // GIR_Coverage, 8922,
     /* 271361 */     GIR_EraseRootFromParent_Done,
     /* 271362 */   // Label 5268: @271362
     /* 271362 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(271422), // Rule ID 8923 //
     /* 271367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 271375 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271385 */     // MIs[0] Rn
     /* 271385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271397 */     // MIs[0] prfop
     /* 271397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271405 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 271405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 271408 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271420 */     GIR_RootConstrainSelectedInstOperands,
     /* 271421 */     // GIR_Coverage, 8923,
     /* 271421 */     GIR_EraseRootFromParent_Done,
     /* 271422 */   // Label 5269: @271422
     /* 271422 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(271482), // Rule ID 8924 //
     /* 271427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 271435 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271445 */     // MIs[0] Rn
     /* 271445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271457 */     // MIs[0] prfop
     /* 271457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271465 */     // (intrinsic_void 1654:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 271465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 271468 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271480 */     GIR_RootConstrainSelectedInstOperands,
     /* 271481 */     // GIR_Coverage, 8924,
     /* 271481 */     GIR_EraseRootFromParent_Done,
     /* 271482 */   // Label 5270: @271482
     /* 271482 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(271542), // Rule ID 8925 //
     /* 271487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 271495 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271505 */     // MIs[0] Rn
     /* 271505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271517 */     // MIs[0] prfop
     /* 271517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271525 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 271525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 271528 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271540 */     GIR_RootConstrainSelectedInstOperands,
     /* 271541 */     // GIR_Coverage, 8925,
     /* 271541 */     GIR_EraseRootFromParent_Done,
     /* 271542 */   // Label 5271: @271542
     /* 271542 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(271600), // Rule ID 2374 //
     /* 271547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 271555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 271558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271583 */     // (intrinsic_w_chain:{ *:[v8f16] } 626:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 271586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271598 */     GIR_RootConstrainSelectedInstOperands,
     /* 271599 */     // GIR_Coverage, 2374,
     /* 271599 */     GIR_EraseRootFromParent_Done,
     /* 271600 */   // Label 5272: @271600
     /* 271600 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(271658), // Rule ID 2375 //
     /* 271605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 271613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 271616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271641 */     // (intrinsic_w_chain:{ *:[v8f16] } 636:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 271644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271656 */     GIR_RootConstrainSelectedInstOperands,
     /* 271657 */     // GIR_Coverage, 2375,
     /* 271657 */     GIR_EraseRootFromParent_Done,
     /* 271658 */   // Label 5273: @271658
     /* 271658 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(271716), // Rule ID 2376 //
     /* 271663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 271671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271699 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 271702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271714 */     GIR_RootConstrainSelectedInstOperands,
     /* 271715 */     // GIR_Coverage, 2376,
     /* 271715 */     GIR_EraseRootFromParent_Done,
     /* 271716 */   // Label 5274: @271716
     /* 271716 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(271774), // Rule ID 2377 //
     /* 271721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 271729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271757 */     // (intrinsic_w_chain:{ *:[v4f32] } 630:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 271760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271772 */     GIR_RootConstrainSelectedInstOperands,
     /* 271773 */     // GIR_Coverage, 2377,
     /* 271773 */     GIR_EraseRootFromParent_Done,
     /* 271774 */   // Label 5275: @271774
     /* 271774 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(271832), // Rule ID 2378 //
     /* 271779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 271787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271815 */     // (intrinsic_w_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 271818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271830 */     GIR_RootConstrainSelectedInstOperands,
     /* 271831 */     // GIR_Coverage, 2378,
     /* 271831 */     GIR_EraseRootFromParent_Done,
     /* 271832 */   // Label 5276: @271832
     /* 271832 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(271890), // Rule ID 2379 //
     /* 271837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 271845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271873 */     // (intrinsic_w_chain:{ *:[v4f32] } 634:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 271876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271888 */     GIR_RootConstrainSelectedInstOperands,
     /* 271889 */     // GIR_Coverage, 2379,
     /* 271889 */     GIR_EraseRootFromParent_Done,
     /* 271890 */   // Label 5277: @271890
     /* 271890 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(271948), // Rule ID 2380 //
     /* 271895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 271898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 271903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 271906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 271912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 271915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271931 */     // (intrinsic_w_chain:{ *:[v4f16] } 622:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 271931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 271934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271946 */     GIR_RootConstrainSelectedInstOperands,
     /* 271947 */     // GIR_Coverage, 2380,
     /* 271947 */     GIR_EraseRootFromParent_Done,
     /* 271948 */   // Label 5278: @271948
     /* 271948 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(272006), // Rule ID 2381 //
     /* 271953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 271956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 271961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 271964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271989 */     // (intrinsic_w_chain:{ *:[v8f16] } 622:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 271992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272004 */     GIR_RootConstrainSelectedInstOperands,
     /* 272005 */     // GIR_Coverage, 2381,
     /* 272005 */     GIR_EraseRootFromParent_Done,
     /* 272006 */   // Label 5279: @272006
     /* 272006 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(272064), // Rule ID 2382 //
     /* 272011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 272014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 272019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 272022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 272025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 272028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 272031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272047 */     // (intrinsic_w_chain:{ *:[v2f32] } 624:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 272047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 272050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272062 */     GIR_RootConstrainSelectedInstOperands,
     /* 272063 */     // GIR_Coverage, 2382,
     /* 272063 */     GIR_EraseRootFromParent_Done,
     /* 272064 */   // Label 5280: @272064
     /* 272064 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(272122), // Rule ID 2383 //
     /* 272069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 272072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 272077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 272086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272105 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 272105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 272108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272120 */     GIR_RootConstrainSelectedInstOperands,
     /* 272121 */     // GIR_Coverage, 2383,
     /* 272121 */     GIR_EraseRootFromParent_Done,
     /* 272122 */   // Label 5281: @272122
     /* 272122 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(272180), // Rule ID 2484 //
     /* 272127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 272130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 272135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 272138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 272141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272163 */     // (intrinsic_w_chain:{ *:[v16i8] } 621:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 272163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 272166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272168 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 272170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272178 */     GIR_RootConstrainSelectedInstOperands,
     /* 272179 */     // GIR_Coverage, 2484,
     /* 272179 */     GIR_EraseRootFromParent_Done,
     /* 272180 */   // Label 5282: @272180
     /* 272180 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(272236), // Rule ID 13197 //
     /* 272185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 272190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272211 */     // MIs[0] addr
     /* 272211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 272215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272219 */     // (intrinsic_w_chain:{ *:[i32] } 1245:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 272219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 272222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272224 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 272226 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 272228 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 272230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272234 */     GIR_RootConstrainSelectedInstOperands,
     /* 272235 */     // GIR_Coverage, 13197,
     /* 272235 */     GIR_EraseRootFromParent_Done,
     /* 272236 */   // Label 5283: @272236
     /* 272236 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(272292), // Rule ID 13198 //
     /* 272241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 272246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272267 */     // MIs[0] addr
     /* 272267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 272271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272275 */     // (intrinsic_w_chain:{ *:[i32] } 1247:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 272275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 272278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272280 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 272282 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 272284 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 272286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272290 */     GIR_RootConstrainSelectedInstOperands,
     /* 272291 */     // GIR_Coverage, 13198,
     /* 272291 */     GIR_EraseRootFromParent_Done,
     /* 272292 */   // Label 5284: @272292
     /* 272292 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(272338), // Rule ID 3452 //
     /* 272297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 272300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 272305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 272308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272321 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1510:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 272324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272336 */     GIR_RootConstrainSelectedInstOperands,
     /* 272337 */     // GIR_Coverage, 3452,
     /* 272337 */     GIR_EraseRootFromParent_Done,
     /* 272338 */   // Label 5285: @272338
     /* 272338 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(272384), // Rule ID 3574 //
     /* 272343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 272351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 272354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272367 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1512:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 272370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272382 */     GIR_RootConstrainSelectedInstOperands,
     /* 272383 */     // GIR_Coverage, 3574,
     /* 272383 */     GIR_EraseRootFromParent_Done,
     /* 272384 */   // Label 5286: @272384
     /* 272384 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(272430), // Rule ID 12625 //
     /* 272389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 272397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 272400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272413 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1522:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 272416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272428 */     GIR_RootConstrainSelectedInstOperands,
     /* 272429 */     // GIR_Coverage, 12625,
     /* 272429 */     GIR_EraseRootFromParent_Done,
     /* 272430 */   // Label 5287: @272430
     /* 272430 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(272476), // Rule ID 12629 //
     /* 272435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 272443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 272446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272459 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 272462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272474 */     GIR_RootConstrainSelectedInstOperands,
     /* 272475 */     // GIR_Coverage, 12629,
     /* 272475 */     GIR_EraseRootFromParent_Done,
     /* 272476 */   // Label 5288: @272476
     /* 272476 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(272522), // Rule ID 12630 //
     /* 272481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 272489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 272492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272505 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1516:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 272508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272520 */     GIR_RootConstrainSelectedInstOperands,
     /* 272521 */     // GIR_Coverage, 12630,
     /* 272521 */     GIR_EraseRootFromParent_Done,
     /* 272522 */   // Label 5289: @272522
     /* 272522 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(272568), // Rule ID 12631 //
     /* 272527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 272535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 272538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272551 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1518:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 272554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272566 */     GIR_RootConstrainSelectedInstOperands,
     /* 272567 */     // GIR_Coverage, 12631,
     /* 272567 */     GIR_EraseRootFromParent_Done,
     /* 272568 */   // Label 5290: @272568
     /* 272568 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(272614), // Rule ID 12632 //
     /* 272573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 272581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 272584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272597 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1520:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 272600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272612 */     GIR_RootConstrainSelectedInstOperands,
     /* 272613 */     // GIR_Coverage, 12632,
     /* 272613 */     GIR_EraseRootFromParent_Done,
     /* 272614 */   // Label 5291: @272614
     /* 272614 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(272660), // Rule ID 12633 //
     /* 272619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 272622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 272627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 272630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272643 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1510:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 272646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272658 */     GIR_RootConstrainSelectedInstOperands,
     /* 272659 */     // GIR_Coverage, 12633,
     /* 272659 */     GIR_EraseRootFromParent_Done,
     /* 272660 */   // Label 5292: @272660
     /* 272660 */   GIM_Reject,
     /* 272661 */ // Label 5245: @272661
     /* 272661 */ GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(275654),
     /* 272666 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 272669 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(272737), // Rule ID 2511 //
     /* 272674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 272677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 272682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 272685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 272688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 272691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 272710 */     // MIs[0] Idx
     /* 272710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 272718 */     // (intrinsic_w_chain:{ *:[v8f16] } 627:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 272718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 272721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272729 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 272731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272735 */     GIR_RootConstrainSelectedInstOperands,
     /* 272736 */     // GIR_Coverage, 2511,
     /* 272736 */     GIR_EraseRootFromParent_Done,
     /* 272737 */   // Label 5294: @272737
     /* 272737 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(272805), // Rule ID 2512 //
     /* 272742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 272745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 272750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 272759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 272778 */     // MIs[0] Idx
     /* 272778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 272786 */     // (intrinsic_w_chain:{ *:[v4f32] } 629:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 272786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 272789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272797 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 272799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272803 */     GIR_RootConstrainSelectedInstOperands,
     /* 272804 */     // GIR_Coverage, 2512,
     /* 272804 */     GIR_EraseRootFromParent_Done,
     /* 272805 */   // Label 5295: @272805
     /* 272805 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(272873), // Rule ID 2513 //
     /* 272810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 272813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 272818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 272821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 272824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 272827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272846 */     // MIs[0] Idx
     /* 272846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 272854 */     // (intrinsic_w_chain:{ *:[v2f32] } 625:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 272854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 272857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272865 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 272867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272871 */     GIR_RootConstrainSelectedInstOperands,
     /* 272872 */     // GIR_Coverage, 2513,
     /* 272872 */     GIR_EraseRootFromParent_Done,
     /* 272873 */   // Label 5296: @272873
     /* 272873 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(272941), // Rule ID 2514 //
     /* 272878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 272881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 272886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 272895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272914 */     // MIs[0] Idx
     /* 272914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 272922 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 272922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 272925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272933 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 272935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272939 */     GIR_RootConstrainSelectedInstOperands,
     /* 272940 */     // GIR_Coverage, 2514,
     /* 272940 */     GIR_EraseRootFromParent_Done,
     /* 272941 */   // Label 5297: @272941
     /* 272941 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(273009), // Rule ID 2515 //
     /* 272946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 272949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 272954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 272957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 272960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 272963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 272982 */     // MIs[0] Idx
     /* 272982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 272990 */     // (intrinsic_w_chain:{ *:[v4f16] } 623:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 272990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 272993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273001 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273007 */     GIR_RootConstrainSelectedInstOperands,
     /* 273008 */     // GIR_Coverage, 2515,
     /* 273008 */     GIR_EraseRootFromParent_Done,
     /* 273009 */   // Label 5298: @273009
     /* 273009 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(273077), // Rule ID 2516 //
     /* 273014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 273022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 273050 */     // MIs[0] Idx
     /* 273050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273053 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 273058 */     // (intrinsic_w_chain:{ *:[v8f16] } 623:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 273061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273069 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273075 */     GIR_RootConstrainSelectedInstOperands,
     /* 273076 */     // GIR_Coverage, 2516,
     /* 273076 */     GIR_EraseRootFromParent_Done,
     /* 273077 */   // Label 5299: @273077
     /* 273077 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(273145), // Rule ID 7021 //
     /* 273082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 273090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 273118 */     // MIs[0] Idx
     /* 273118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 273126 */     // (intrinsic_w_chain:{ *:[v8f16] } 637:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 273129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273137 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273143 */     GIR_RootConstrainSelectedInstOperands,
     /* 273144 */     // GIR_Coverage, 7021,
     /* 273144 */     GIR_EraseRootFromParent_Done,
     /* 273145 */   // Label 5300: @273145
     /* 273145 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(273213), // Rule ID 7022 //
     /* 273150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 273158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 273186 */     // MIs[0] Idx
     /* 273186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 273194 */     // (intrinsic_w_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 273197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273205 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273211 */     GIR_RootConstrainSelectedInstOperands,
     /* 273212 */     // GIR_Coverage, 7022,
     /* 273212 */     GIR_EraseRootFromParent_Done,
     /* 273213 */   // Label 5301: @273213
     /* 273213 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(273281), // Rule ID 7023 //
     /* 273218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 273226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 273254 */     // MIs[0] Idx
     /* 273254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 273262 */     // (intrinsic_w_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 273265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273273 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273279 */     GIR_RootConstrainSelectedInstOperands,
     /* 273280 */     // GIR_Coverage, 7023,
     /* 273280 */     GIR_EraseRootFromParent_Done,
     /* 273281 */   // Label 5302: @273281
     /* 273281 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(273349), // Rule ID 7024 //
     /* 273286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 273294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 273322 */     // MIs[0] Idx
     /* 273322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273325 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 273330 */     // (intrinsic_w_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 273333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273341 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273347 */     GIR_RootConstrainSelectedInstOperands,
     /* 273348 */     // GIR_Coverage, 7024,
     /* 273348 */     GIR_EraseRootFromParent_Done,
     /* 273349 */   // Label 5303: @273349
     /* 273349 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(273409), // Rule ID 3586 //
     /* 273354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 273357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 273362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 273365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 273368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 273371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 273374 */     // MIs[0] tile
     /* 273374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273390 */     // (intrinsic_void 935:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 273390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 273393 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273401 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273407 */     GIR_RootConstrainSelectedInstOperands,
     /* 273408 */     // GIR_Coverage, 3586,
     /* 273408 */     GIR_EraseRootFromParent_Done,
     /* 273409 */   // Label 5304: @273409
     /* 273409 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(273469), // Rule ID 3587 //
     /* 273414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 273417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 273422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 273425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 273428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 273434 */     // MIs[0] tile
     /* 273434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273450 */     // (intrinsic_void 887:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 273450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 273453 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273461 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273467 */     GIR_RootConstrainSelectedInstOperands,
     /* 273468 */     // GIR_Coverage, 3587,
     /* 273468 */     GIR_EraseRootFromParent_Done,
     /* 273469 */   // Label 5305: @273469
     /* 273469 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(273529), // Rule ID 3588 //
     /* 273474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 273477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 273482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 273485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 273488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 273491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 273494 */     // MIs[0] tile
     /* 273494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 273502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273510 */     // (intrinsic_void 935:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 273510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 273513 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273521 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273527 */     GIR_RootConstrainSelectedInstOperands,
     /* 273528 */     // GIR_Coverage, 3588,
     /* 273528 */     GIR_EraseRootFromParent_Done,
     /* 273529 */   // Label 5306: @273529
     /* 273529 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(273589), // Rule ID 3589 //
     /* 273534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 273537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 273542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 273545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 273548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 273554 */     // MIs[0] tile
     /* 273554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 273562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273570 */     // (intrinsic_void 886:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 273570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 273573 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273581 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273587 */     GIR_RootConstrainSelectedInstOperands,
     /* 273588 */     // GIR_Coverage, 3589,
     /* 273588 */     GIR_EraseRootFromParent_Done,
     /* 273589 */   // Label 5307: @273589
     /* 273589 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(273649), // Rule ID 3590 //
     /* 273594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 273597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 273602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 273605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 273608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 273611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 273614 */     // MIs[0] tile
     /* 273614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 273622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273630 */     // (intrinsic_void 935:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 273630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 273633 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273641 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273647 */     GIR_RootConstrainSelectedInstOperands,
     /* 273648 */     // GIR_Coverage, 3590,
     /* 273648 */     GIR_EraseRootFromParent_Done,
     /* 273649 */   // Label 5308: @273649
     /* 273649 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(273709), // Rule ID 3591 //
     /* 273654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 273657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 273662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 273665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 273668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 273674 */     // MIs[0] tile
     /* 273674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273690 */     // (intrinsic_void 1038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 273690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 273693 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273701 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273707 */     GIR_RootConstrainSelectedInstOperands,
     /* 273708 */     // GIR_Coverage, 3591,
     /* 273708 */     GIR_EraseRootFromParent_Done,
     /* 273709 */   // Label 5309: @273709
     /* 273709 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(273769), // Rule ID 3592 //
     /* 273714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 273717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 273722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 273725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 273728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 273731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 273734 */     // MIs[0] tile
     /* 273734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 273742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273750 */     // (intrinsic_void 1038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 273750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 273753 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273767 */     GIR_RootConstrainSelectedInstOperands,
     /* 273768 */     // GIR_Coverage, 3592,
     /* 273768 */     GIR_EraseRootFromParent_Done,
     /* 273769 */   // Label 5310: @273769
     /* 273769 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(273829), // Rule ID 3593 //
     /* 273774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 273777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 273782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 273785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 273788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 273791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 273794 */     // MIs[0] tile
     /* 273794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273810 */     // (intrinsic_void 937:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 273810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 273813 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273821 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273827 */     GIR_RootConstrainSelectedInstOperands,
     /* 273828 */     // GIR_Coverage, 3593,
     /* 273828 */     GIR_EraseRootFromParent_Done,
     /* 273829 */   // Label 5311: @273829
     /* 273829 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(273889), // Rule ID 3687 //
     /* 273834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 273837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 273842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 273845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 273848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 273851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 273854 */     // MIs[0] tile
     /* 273854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273857 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273870 */     // (intrinsic_void 1039:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 273870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 273873 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273881 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273887 */     GIR_RootConstrainSelectedInstOperands,
     /* 273888 */     // GIR_Coverage, 3687,
     /* 273888 */     GIR_EraseRootFromParent_Done,
     /* 273889 */   // Label 5312: @273889
     /* 273889 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(273949), // Rule ID 3688 //
     /* 273894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 273897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 273902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 273905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 273908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 273911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 273914 */     // MIs[0] tile
     /* 273914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273930 */     // (intrinsic_void 806:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 273930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 273933 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273941 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273947 */     GIR_RootConstrainSelectedInstOperands,
     /* 273948 */     // GIR_Coverage, 3688,
     /* 273948 */     GIR_EraseRootFromParent_Done,
     /* 273949 */   // Label 5313: @273949
     /* 273949 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(274009), // Rule ID 12640 //
     /* 273954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 273957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 273962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 273965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 273968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 273971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 273974 */     // MIs[0] tile
     /* 273974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273990 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 273990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 273993 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274001 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274007 */     GIR_RootConstrainSelectedInstOperands,
     /* 274008 */     // GIR_Coverage, 12640,
     /* 274008 */     GIR_EraseRootFromParent_Done,
     /* 274009 */   // Label 5314: @274009
     /* 274009 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(274069), // Rule ID 12641 //
     /* 274014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 274017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 274022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 274025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 274028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 274031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 274034 */     // MIs[0] tile
     /* 274034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274050 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 274050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 274053 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274061 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274067 */     GIR_RootConstrainSelectedInstOperands,
     /* 274068 */     // GIR_Coverage, 12641,
     /* 274068 */     GIR_EraseRootFromParent_Done,
     /* 274069 */   // Label 5315: @274069
     /* 274069 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(274129), // Rule ID 12642 //
     /* 274074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 274082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274094 */     // MIs[0] tile
     /* 274094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274110 */     // (intrinsic_void 940:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 274110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 274113 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274121 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274127 */     GIR_RootConstrainSelectedInstOperands,
     /* 274128 */     // GIR_Coverage, 12642,
     /* 274128 */     GIR_EraseRootFromParent_Done,
     /* 274129 */   // Label 5316: @274129
     /* 274129 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(274189), // Rule ID 12643 //
     /* 274134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 274142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274154 */     // MIs[0] tile
     /* 274154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274170 */     // (intrinsic_void 1040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 274173 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274181 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274187 */     GIR_RootConstrainSelectedInstOperands,
     /* 274188 */     // GIR_Coverage, 12643,
     /* 274188 */     GIR_EraseRootFromParent_Done,
     /* 274189 */   // Label 5317: @274189
     /* 274189 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(274249), // Rule ID 12644 //
     /* 274194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 274202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274214 */     // MIs[0] tile
     /* 274214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274230 */     // (intrinsic_void 1173:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 274233 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274241 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274247 */     GIR_RootConstrainSelectedInstOperands,
     /* 274248 */     // GIR_Coverage, 12644,
     /* 274248 */     GIR_EraseRootFromParent_Done,
     /* 274249 */   // Label 5318: @274249
     /* 274249 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(274309), // Rule ID 12645 //
     /* 274254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 274262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274274 */     // MIs[0] tile
     /* 274274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274290 */     // (intrinsic_void 1175:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 274293 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274301 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274307 */     GIR_RootConstrainSelectedInstOperands,
     /* 274308 */     // GIR_Coverage, 12645,
     /* 274308 */     GIR_EraseRootFromParent_Done,
     /* 274309 */   // Label 5319: @274309
     /* 274309 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(274369), // Rule ID 12646 //
     /* 274314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 274322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274334 */     // MIs[0] tile
     /* 274334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274350 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 274353 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274361 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274367 */     GIR_RootConstrainSelectedInstOperands,
     /* 274368 */     // GIR_Coverage, 12646,
     /* 274368 */     GIR_EraseRootFromParent_Done,
     /* 274369 */   // Label 5320: @274369
     /* 274369 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(274429), // Rule ID 12647 //
     /* 274374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 274382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274394 */     // MIs[0] tile
     /* 274394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274397 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274410 */     // (intrinsic_void 1091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 274413 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274421 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274427 */     GIR_RootConstrainSelectedInstOperands,
     /* 274428 */     // GIR_Coverage, 12647,
     /* 274428 */     GIR_EraseRootFromParent_Done,
     /* 274429 */   // Label 5321: @274429
     /* 274429 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(274489), // Rule ID 12648 //
     /* 274434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 274442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274454 */     // MIs[0] tile
     /* 274454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274470 */     // (intrinsic_void 1207:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 274473 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274481 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274487 */     GIR_RootConstrainSelectedInstOperands,
     /* 274488 */     // GIR_Coverage, 12648,
     /* 274488 */     GIR_EraseRootFromParent_Done,
     /* 274489 */   // Label 5322: @274489
     /* 274489 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(274549), // Rule ID 12649 //
     /* 274494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 274502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274514 */     // MIs[0] tile
     /* 274514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274530 */     // (intrinsic_void 1208:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 274533 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274541 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274547 */     GIR_RootConstrainSelectedInstOperands,
     /* 274548 */     // GIR_Coverage, 12649,
     /* 274548 */     GIR_EraseRootFromParent_Done,
     /* 274549 */   // Label 5323: @274549
     /* 274549 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(274609), // Rule ID 12650 //
     /* 274554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 274562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274574 */     // MIs[0] tile
     /* 274574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274590 */     // (intrinsic_void 1040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 274593 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274601 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274607 */     GIR_RootConstrainSelectedInstOperands,
     /* 274608 */     // GIR_Coverage, 12650,
     /* 274608 */     GIR_EraseRootFromParent_Done,
     /* 274609 */   // Label 5324: @274609
     /* 274609 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(274669), // Rule ID 12651 //
     /* 274614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 274622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274634 */     // MIs[0] tile
     /* 274634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274650 */     // (intrinsic_void 1173:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 274653 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274661 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274667 */     GIR_RootConstrainSelectedInstOperands,
     /* 274668 */     // GIR_Coverage, 12651,
     /* 274668 */     GIR_EraseRootFromParent_Done,
     /* 274669 */   // Label 5325: @274669
     /* 274669 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(274729), // Rule ID 12652 //
     /* 274674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 274682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274694 */     // MIs[0] tile
     /* 274694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274697 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274710 */     // (intrinsic_void 1175:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 274713 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274721 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274727 */     GIR_RootConstrainSelectedInstOperands,
     /* 274728 */     // GIR_Coverage, 12652,
     /* 274728 */     GIR_EraseRootFromParent_Done,
     /* 274729 */   // Label 5326: @274729
     /* 274729 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(274789), // Rule ID 12653 //
     /* 274734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 274742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274754 */     // MIs[0] tile
     /* 274754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274770 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 274773 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274781 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274787 */     GIR_RootConstrainSelectedInstOperands,
     /* 274788 */     // GIR_Coverage, 12653,
     /* 274788 */     GIR_EraseRootFromParent_Done,
     /* 274789 */   // Label 5327: @274789
     /* 274789 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(274849), // Rule ID 12654 //
     /* 274794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 274802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274814 */     // MIs[0] tile
     /* 274814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274830 */     // (intrinsic_void 1091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 274833 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274841 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274847 */     GIR_RootConstrainSelectedInstOperands,
     /* 274848 */     // GIR_Coverage, 12654,
     /* 274848 */     GIR_EraseRootFromParent_Done,
     /* 274849 */   // Label 5328: @274849
     /* 274849 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(274909), // Rule ID 12655 //
     /* 274854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 274862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274874 */     // MIs[0] tile
     /* 274874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274890 */     // (intrinsic_void 1207:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 274893 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274901 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274907 */     GIR_RootConstrainSelectedInstOperands,
     /* 274908 */     // GIR_Coverage, 12655,
     /* 274908 */     GIR_EraseRootFromParent_Done,
     /* 274909 */   // Label 5329: @274909
     /* 274909 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(274969), // Rule ID 12656 //
     /* 274914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 274922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274934 */     // MIs[0] tile
     /* 274934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274950 */     // (intrinsic_void 1208:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 274953 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274961 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274967 */     GIR_RootConstrainSelectedInstOperands,
     /* 274968 */     // GIR_Coverage, 12656,
     /* 274968 */     GIR_EraseRootFromParent_Done,
     /* 274969 */   // Label 5330: @274969
     /* 274969 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(275029), // Rule ID 13030 //
     /* 274974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 274977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 274982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 274985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 274988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 274991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 274994 */     // MIs[0] tile
     /* 274994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275010 */     // (intrinsic_void 807:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 275010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 275013 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275021 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275027 */     GIR_RootConstrainSelectedInstOperands,
     /* 275028 */     // GIR_Coverage, 13030,
     /* 275028 */     GIR_EraseRootFromParent_Done,
     /* 275029 */   // Label 5331: @275029
     /* 275029 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(275089), // Rule ID 13031 //
     /* 275034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 275042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275054 */     // MIs[0] tile
     /* 275054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275070 */     // (intrinsic_void 1041:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 275073 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275081 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275087 */     GIR_RootConstrainSelectedInstOperands,
     /* 275088 */     // GIR_Coverage, 13031,
     /* 275088 */     GIR_EraseRootFromParent_Done,
     /* 275089 */   // Label 5332: @275089
     /* 275089 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(275149), // Rule ID 13032 //
     /* 275094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 275102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275114 */     // MIs[0] tile
     /* 275114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275130 */     // (intrinsic_void 1174:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 275133 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275141 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275147 */     GIR_RootConstrainSelectedInstOperands,
     /* 275148 */     // GIR_Coverage, 13032,
     /* 275148 */     GIR_EraseRootFromParent_Done,
     /* 275149 */   // Label 5333: @275149
     /* 275149 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(275209), // Rule ID 13033 //
     /* 275154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 275162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275174 */     // MIs[0] tile
     /* 275174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275190 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 275193 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275201 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275207 */     GIR_RootConstrainSelectedInstOperands,
     /* 275208 */     // GIR_Coverage, 13033,
     /* 275208 */     GIR_EraseRootFromParent_Done,
     /* 275209 */   // Label 5334: @275209
     /* 275209 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(275269), // Rule ID 13144 //
     /* 275214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 275217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 275222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275234 */     // MIs[0] tile
     /* 275234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 275242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275250 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 275253 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275261 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275267 */     GIR_RootConstrainSelectedInstOperands,
     /* 275268 */     // GIR_Coverage, 13144,
     /* 275268 */     GIR_EraseRootFromParent_Done,
     /* 275269 */   // Label 5335: @275269
     /* 275269 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(275317), // Rule ID 3573 //
     /* 275274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 275282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 275285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 275288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275298 */     // MIs[0] Op4
     /* 275298 */     // No operand predicates
     /* 275298 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1513:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 275301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275309 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275315 */     GIR_RootConstrainSelectedInstOperands,
     /* 275316 */     // GIR_Coverage, 3573,
     /* 275316 */     GIR_EraseRootFromParent_Done,
     /* 275317 */   // Label 5336: @275317
     /* 275317 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(275365), // Rule ID 3575 //
     /* 275322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 275330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 275333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275346 */     // MIs[0] Op4
     /* 275346 */     // No operand predicates
     /* 275346 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1515:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 275349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275357 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275363 */     GIR_RootConstrainSelectedInstOperands,
     /* 275364 */     // GIR_Coverage, 3575,
     /* 275364 */     GIR_EraseRootFromParent_Done,
     /* 275365 */   // Label 5337: @275365
     /* 275365 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(275413), // Rule ID 3576 //
     /* 275370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 275373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 275378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 275381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 275384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275394 */     // MIs[0] Op4
     /* 275394 */     // No operand predicates
     /* 275394 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1511:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 275397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275405 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275411 */     GIR_RootConstrainSelectedInstOperands,
     /* 275412 */     // GIR_Coverage, 3576,
     /* 275412 */     GIR_EraseRootFromParent_Done,
     /* 275413 */   // Label 5338: @275413
     /* 275413 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(275461), // Rule ID 3577 //
     /* 275418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 275421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 275426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 275429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275442 */     // MIs[0] Op4
     /* 275442 */     // No operand predicates
     /* 275442 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1511:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 275445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275453 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275459 */     GIR_RootConstrainSelectedInstOperands,
     /* 275460 */     // GIR_Coverage, 3577,
     /* 275460 */     GIR_EraseRootFromParent_Done,
     /* 275461 */   // Label 5339: @275461
     /* 275461 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(275509), // Rule ID 12624 //
     /* 275466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 275474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 275477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 275480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275490 */     // MIs[0] Op4
     /* 275490 */     // No operand predicates
     /* 275490 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1523:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 275493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275501 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275507 */     GIR_RootConstrainSelectedInstOperands,
     /* 275508 */     // GIR_Coverage, 12624,
     /* 275508 */     GIR_EraseRootFromParent_Done,
     /* 275509 */   // Label 5340: @275509
     /* 275509 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(275557), // Rule ID 12626 //
     /* 275514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 275522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 275525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275538 */     // MIs[0] Op4
     /* 275538 */     // No operand predicates
     /* 275538 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1517:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 275541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275549 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275555 */     GIR_RootConstrainSelectedInstOperands,
     /* 275556 */     // GIR_Coverage, 12626,
     /* 275556 */     GIR_EraseRootFromParent_Done,
     /* 275557 */   // Label 5341: @275557
     /* 275557 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(275605), // Rule ID 12627 //
     /* 275562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 275570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 275573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275586 */     // MIs[0] Op4
     /* 275586 */     // No operand predicates
     /* 275586 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1519:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 275589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275597 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275603 */     GIR_RootConstrainSelectedInstOperands,
     /* 275604 */     // GIR_Coverage, 12627,
     /* 275604 */     GIR_EraseRootFromParent_Done,
     /* 275605 */   // Label 5342: @275605
     /* 275605 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(275653), // Rule ID 12628 //
     /* 275610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 275618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 275621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275634 */     // MIs[0] Op4
     /* 275634 */     // No operand predicates
     /* 275634 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1521:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 275637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275645 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275651 */     GIR_RootConstrainSelectedInstOperands,
     /* 275652 */     // GIR_Coverage, 12628,
     /* 275652 */     GIR_EraseRootFromParent_Done,
     /* 275653 */   // Label 5343: @275653
     /* 275653 */   GIM_Reject,
     /* 275654 */ // Label 5293: @275654
     /* 275654 */ GIM_Reject,
     /* 275655 */ // Label 39: @275655
     /* 275655 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5348*/ GIMT_Encode4(275944),
     /* 275666 */ /*GILLT_s64*//*Label 5344*/ GIMT_Encode4(275698), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 275678 */ /*GILLT_v2s64*//*Label 5345*/ GIMT_Encode4(275758), GIMT_Encode4(0),
     /* 275686 */ /*GILLT_v4s32*//*Label 5346*/ GIMT_Encode4(275820), GIMT_Encode4(0),
     /* 275694 */ /*GILLT_v8s16*//*Label 5347*/ GIMT_Encode4(275882),
     /* 275698 */ // Label 5344: @275698
     /* 275698 */ GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(275757), // Rule ID 6533 //
     /* 275703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 275706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 275710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 275714 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 275714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 275717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 275721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 275731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275736 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 275738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 275741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 275746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 275751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 275756 */   // GIR_Coverage, 6533,
     /* 275756 */   GIR_EraseRootFromParent_Done,
     /* 275757 */ // Label 5349: @275757
     /* 275757 */ GIM_Reject,
     /* 275758 */ // Label 5345: @275758
     /* 275758 */ GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(275819),
     /* 275763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 275766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275770 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(275797), // Rule ID 6403 //
     /* 275775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 275782 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 275782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 275785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 275792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275795 */     GIR_RootConstrainSelectedInstOperands,
     /* 275796 */     // GIR_Coverage, 6403,
     /* 275796 */     GIR_EraseRootFromParent_Done,
     /* 275797 */   // Label 5351: @275797
     /* 275797 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(275818), // Rule ID 6396 //
     /* 275802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275806 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 275806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 275809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275816 */     GIR_RootConstrainSelectedInstOperands,
     /* 275817 */     // GIR_Coverage, 6396,
     /* 275817 */     GIR_EraseRootFromParent_Done,
     /* 275818 */   // Label 5352: @275818
     /* 275818 */   GIM_Reject,
     /* 275819 */ // Label 5350: @275819
     /* 275819 */ GIM_Reject,
     /* 275820 */ // Label 5346: @275820
     /* 275820 */ GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(275881),
     /* 275825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 275828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275832 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(275859), // Rule ID 6400 //
     /* 275837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 275844 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 275844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 275847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 275854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275857 */     GIR_RootConstrainSelectedInstOperands,
     /* 275858 */     // GIR_Coverage, 6400,
     /* 275858 */     GIR_EraseRootFromParent_Done,
     /* 275859 */   // Label 5354: @275859
     /* 275859 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(275880), // Rule ID 6393 //
     /* 275864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275868 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 275868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 275871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275878 */     GIR_RootConstrainSelectedInstOperands,
     /* 275879 */     // GIR_Coverage, 6393,
     /* 275879 */     GIR_EraseRootFromParent_Done,
     /* 275880 */   // Label 5355: @275880
     /* 275880 */   GIM_Reject,
     /* 275881 */ // Label 5353: @275881
     /* 275881 */ GIM_Reject,
     /* 275882 */ // Label 5347: @275882
     /* 275882 */ GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(275943),
     /* 275887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 275890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275894 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(275921), // Rule ID 6397 //
     /* 275899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 275906 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 275906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 275909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 275916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275919 */     GIR_RootConstrainSelectedInstOperands,
     /* 275920 */     // GIR_Coverage, 6397,
     /* 275920 */     GIR_EraseRootFromParent_Done,
     /* 275921 */   // Label 5357: @275921
     /* 275921 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(275942), // Rule ID 6390 //
     /* 275926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275930 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 275930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 275933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275940 */     GIR_RootConstrainSelectedInstOperands,
     /* 275941 */     // GIR_Coverage, 6390,
     /* 275941 */     GIR_EraseRootFromParent_Done,
     /* 275942 */   // Label 5358: @275942
     /* 275942 */   GIM_Reject,
     /* 275943 */ // Label 5356: @275943
     /* 275943 */ GIM_Reject,
     /* 275944 */ // Label 5348: @275944
     /* 275944 */ GIM_Reject,
     /* 275945 */ // Label 40: @275945
     /* 275945 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5363*/ GIMT_Encode4(277381),
     /* 275956 */ /*GILLT_s32*//*Label 5359*/ GIMT_Encode4(275988), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 275968 */ /*GILLT_v2s32*//*Label 5360*/ GIMT_Encode4(276027), GIMT_Encode4(0),
     /* 275976 */ /*GILLT_v4s16*//*Label 5361*/ GIMT_Encode4(276383), GIMT_Encode4(0),
     /* 275984 */ /*GILLT_v8s8*//*Label 5362*/ GIMT_Encode4(276882),
     /* 275988 */ // Label 5359: @275988
     /* 275988 */ GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(276026), // Rule ID 6554 //
     /* 275993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 275996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 276000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 276004 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 276004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276009 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 276015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 276020 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 276025 */   // GIR_Coverage, 6554,
     /* 276025 */   GIR_EraseRootFromParent_Done,
     /* 276026 */ // Label 5364: @276026
     /* 276026 */ GIM_Reject,
     /* 276027 */ // Label 5360: @276027
     /* 276027 */ GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(276382),
     /* 276032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276039 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(276117), // Rule ID 5442 //
     /* 276044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 276064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 276072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276081 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276087 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 276089 */     // MIs[1] Operand 2
     /* 276089 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 276100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276102 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 276102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 276105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276115 */     GIR_RootConstrainSelectedInstOperands,
     /* 276116 */     // GIR_Coverage, 5442,
     /* 276116 */     GIR_EraseRootFromParent_Done,
     /* 276117 */   // Label 5366: @276117
     /* 276117 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(276188), // Rule ID 5438 //
     /* 276122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 276142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 276150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276160 */     // MIs[1] Operand 2
     /* 276160 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 276171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276173 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 276176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276186 */     GIR_RootConstrainSelectedInstOperands,
     /* 276187 */     // GIR_Coverage, 5438,
     /* 276187 */     GIR_EraseRootFromParent_Done,
     /* 276188 */   // Label 5367: @276188
     /* 276188 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(276259), // Rule ID 5440 //
     /* 276193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 276213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 276221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276231 */     // MIs[1] Operand 2
     /* 276231 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 276242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276244 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 276247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276257 */     GIR_RootConstrainSelectedInstOperands,
     /* 276258 */     // GIR_Coverage, 5440,
     /* 276258 */     GIR_EraseRootFromParent_Done,
     /* 276259 */   // Label 5368: @276259
     /* 276259 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(276312), // Rule ID 2162 //
     /* 276264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 276275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276284 */     // MIs[1] imm
     /* 276284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276292 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 276296 */     // MIs[2] Operand 1
     /* 276296 */     // No operand predicates
     /* 276296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276298 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 276298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 276301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 276310 */     GIR_RootConstrainSelectedInstOperands,
     /* 276311 */     // GIR_Coverage, 2162,
     /* 276311 */     GIR_EraseRootFromParent_Done,
     /* 276312 */   // Label 5369: @276312
     /* 276312 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(276362), // Rule ID 6378 //
     /* 276317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276334 */     // MIs[1] imm
     /* 276334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276342 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 276346 */     // MIs[2] Operand 1
     /* 276346 */     // No operand predicates
     /* 276346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276348 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 276348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 276351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 276360 */     GIR_RootConstrainSelectedInstOperands,
     /* 276361 */     // GIR_Coverage, 6378,
     /* 276361 */     GIR_EraseRootFromParent_Done,
     /* 276362 */   // Label 5370: @276362
     /* 276362 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(276381), // Rule ID 1099 //
     /* 276367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276374 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 276374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 276379 */     GIR_RootConstrainSelectedInstOperands,
     /* 276380 */     // GIR_Coverage, 1099,
     /* 276380 */     GIR_Done,
     /* 276381 */   // Label 5371: @276381
     /* 276381 */   GIM_Reject,
     /* 276382 */ // Label 5365: @276382
     /* 276382 */ GIM_Reject,
     /* 276383 */ // Label 5361: @276383
     /* 276383 */ GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(276881),
     /* 276388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276395 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(276473), // Rule ID 5436 //
     /* 276400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 276420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 276445 */     // MIs[1] Operand 2
     /* 276445 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 276456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276458 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 276461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276471 */     GIR_RootConstrainSelectedInstOperands,
     /* 276472 */     // GIR_Coverage, 5436,
     /* 276472 */     GIR_EraseRootFromParent_Done,
     /* 276473 */   // Label 5373: @276473
     /* 276473 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(276544), // Rule ID 5432 //
     /* 276478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 276498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276516 */     // MIs[1] Operand 2
     /* 276516 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 276527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276529 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 276532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276542 */     GIR_RootConstrainSelectedInstOperands,
     /* 276543 */     // GIR_Coverage, 5432,
     /* 276543 */     GIR_EraseRootFromParent_Done,
     /* 276544 */   // Label 5374: @276544
     /* 276544 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(276615), // Rule ID 5434 //
     /* 276549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 276569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276587 */     // MIs[1] Operand 2
     /* 276587 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 276598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276600 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 276603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276613 */     GIR_RootConstrainSelectedInstOperands,
     /* 276614 */     // GIR_Coverage, 5434,
     /* 276614 */     GIR_EraseRootFromParent_Done,
     /* 276615 */   // Label 5375: @276615
     /* 276615 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(276707), // Rule ID 5558 //
     /* 276620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 276628 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 276631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 276635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 276639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 276647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 276660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 276664 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276668 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276675 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 276675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 276678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 276682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 276691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 276695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 276697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 276700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276705 */     GIR_RootConstrainSelectedInstOperands,
     /* 276706 */     // GIR_Coverage, 5558,
     /* 276706 */     GIR_EraseRootFromParent_Done,
     /* 276707 */   // Label 5376: @276707
     /* 276707 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(276760), // Rule ID 2161 //
     /* 276712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 276723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276732 */     // MIs[1] imm
     /* 276732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276740 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 276744 */     // MIs[2] Operand 1
     /* 276744 */     // No operand predicates
     /* 276744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276746 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 276746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 276749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 276758 */     GIR_RootConstrainSelectedInstOperands,
     /* 276759 */     // GIR_Coverage, 2161,
     /* 276759 */     GIR_EraseRootFromParent_Done,
     /* 276760 */   // Label 5377: @276760
     /* 276760 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(276810), // Rule ID 6377 //
     /* 276765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276782 */     // MIs[1] imm
     /* 276782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276790 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 276794 */     // MIs[2] Operand 1
     /* 276794 */     // No operand predicates
     /* 276794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276796 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 276796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 276799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 276808 */     GIR_RootConstrainSelectedInstOperands,
     /* 276809 */     // GIR_Coverage, 6377,
     /* 276809 */     GIR_EraseRootFromParent_Done,
     /* 276810 */   // Label 5378: @276810
     /* 276810 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(276861), // Rule ID 5586 //
     /* 276815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 276823 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 276826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 276830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 276834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276846 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 276846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 276849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 276855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 276859 */     GIR_RootConstrainSelectedInstOperands,
     /* 276860 */     // GIR_Coverage, 5586,
     /* 276860 */     GIR_EraseRootFromParent_Done,
     /* 276861 */   // Label 5379: @276861
     /* 276861 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(276880), // Rule ID 1098 //
     /* 276866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276873 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 276873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 276878 */     GIR_RootConstrainSelectedInstOperands,
     /* 276879 */     // GIR_Coverage, 1098,
     /* 276879 */     GIR_Done,
     /* 276880 */   // Label 5380: @276880
     /* 276880 */   GIM_Reject,
     /* 276881 */ // Label 5372: @276881
     /* 276881 */ GIM_Reject,
     /* 276882 */ // Label 5362: @276882
     /* 276882 */ GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(277380),
     /* 276887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 276890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276894 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(276972), // Rule ID 5430 //
     /* 276899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 276911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 276919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 276923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 276927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276936 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 276944 */     // MIs[1] Operand 2
     /* 276944 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 276955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276957 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 276957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 276960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276970 */     GIR_RootConstrainSelectedInstOperands,
     /* 276971 */     // GIR_Coverage, 5430,
     /* 276971 */     GIR_EraseRootFromParent_Done,
     /* 276972 */   // Label 5382: @276972
     /* 276972 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(277043), // Rule ID 5426 //
     /* 276977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 276989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 276997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277015 */     // MIs[1] Operand 2
     /* 277015 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 277026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277028 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 277031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277041 */     GIR_RootConstrainSelectedInstOperands,
     /* 277042 */     // GIR_Coverage, 5426,
     /* 277042 */     GIR_EraseRootFromParent_Done,
     /* 277043 */   // Label 5383: @277043
     /* 277043 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(277114), // Rule ID 5428 //
     /* 277048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 277068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277086 */     // MIs[1] Operand 2
     /* 277086 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 277097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277099 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 277102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277112 */     GIR_RootConstrainSelectedInstOperands,
     /* 277113 */     // GIR_Coverage, 5428,
     /* 277113 */     GIR_EraseRootFromParent_Done,
     /* 277114 */   // Label 5384: @277114
     /* 277114 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(277206), // Rule ID 5531 //
     /* 277119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 277127 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 277130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 277138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 277146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 277159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 277163 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277167 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277174 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 277174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 277177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 277181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 277190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 277194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 277199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277204 */     GIR_RootConstrainSelectedInstOperands,
     /* 277205 */     // GIR_Coverage, 5531,
     /* 277205 */     GIR_EraseRootFromParent_Done,
     /* 277206 */   // Label 5385: @277206
     /* 277206 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(277259), // Rule ID 2160 //
     /* 277211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 277222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277231 */     // MIs[1] imm
     /* 277231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277239 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 277243 */     // MIs[2] Operand 1
     /* 277243 */     // No operand predicates
     /* 277243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277245 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 277245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 277248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 277254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 277257 */     GIR_RootConstrainSelectedInstOperands,
     /* 277258 */     // GIR_Coverage, 2160,
     /* 277258 */     GIR_EraseRootFromParent_Done,
     /* 277259 */   // Label 5386: @277259
     /* 277259 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(277309), // Rule ID 6376 //
     /* 277264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277281 */     // MIs[1] imm
     /* 277281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 277293 */     // MIs[2] Operand 1
     /* 277293 */     // No operand predicates
     /* 277293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277295 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 277295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 277298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 277304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 277307 */     GIR_RootConstrainSelectedInstOperands,
     /* 277308 */     // GIR_Coverage, 6376,
     /* 277308 */     GIR_EraseRootFromParent_Done,
     /* 277309 */   // Label 5387: @277309
     /* 277309 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(277360), // Rule ID 5585 //
     /* 277314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 277322 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 277325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 277333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277345 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 277345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 277348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 277354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 277358 */     GIR_RootConstrainSelectedInstOperands,
     /* 277359 */     // GIR_Coverage, 5585,
     /* 277359 */     GIR_EraseRootFromParent_Done,
     /* 277360 */   // Label 5388: @277360
     /* 277360 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(277379), // Rule ID 1097 //
     /* 277365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277372 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 277372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 277377 */     GIR_RootConstrainSelectedInstOperands,
     /* 277378 */     // GIR_Coverage, 1097,
     /* 277378 */     GIR_Done,
     /* 277379 */   // Label 5389: @277379
     /* 277379 */   GIM_Reject,
     /* 277380 */ // Label 5381: @277380
     /* 277380 */ GIM_Reject,
     /* 277381 */ // Label 5363: @277381
     /* 277381 */ GIM_Reject,
     /* 277382 */ // Label 41: @277382
     /* 277382 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5392*/ GIMT_Encode4(277501),
     /* 277393 */ /*GILLT_s32*//*Label 5390*/ GIMT_Encode4(277401),
     /* 277397 */ /*GILLT_s64*//*Label 5391*/ GIMT_Encode4(277421),
     /* 277401 */ // Label 5390: @277401
     /* 277401 */ GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(277420), // Rule ID 81 //
     /* 277406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277410 */   // MIs[0] Operand 1
     /* 277410 */   // No operand predicates
     /* 277410 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 277410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 277413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277415 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 277418 */   GIR_RootConstrainSelectedInstOperands,
     /* 277419 */   // GIR_Coverage, 81,
     /* 277419 */   GIR_EraseRootFromParent_Done,
     /* 277420 */ // Label 5393: @277420
     /* 277420 */ GIM_Reject,
     /* 277421 */ // Label 5391: @277421
     /* 277421 */ GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(277481), // Rule ID 3902 //
     /* 277426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 277429 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 277433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277437 */   // MIs[0] Operand 1
     /* 277437 */   // No operand predicates
     /* 277437 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 277437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 277440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 277444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277449 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 277454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 277459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 277470 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277480 */   // GIR_Coverage, 3902,
     /* 277480 */   GIR_EraseRootFromParent_Done,
     /* 277481 */ // Label 5394: @277481
     /* 277481 */ GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(277500), // Rule ID 82 //
     /* 277486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 277490 */   // MIs[0] Operand 1
     /* 277490 */   // No operand predicates
     /* 277490 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 277490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 277493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277495 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 277498 */   GIR_RootConstrainSelectedInstOperands,
     /* 277499 */   // GIR_Coverage, 82,
     /* 277499 */   GIR_EraseRootFromParent_Done,
     /* 277500 */ // Label 5395: @277500
     /* 277500 */ GIM_Reject,
     /* 277501 */ // Label 5392: @277501
     /* 277501 */ GIM_Reject,
     /* 277502 */ // Label 42: @277502
     /* 277502 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5399*/ GIMT_Encode4(277742),
     /* 277513 */ /*GILLT_s16*//*Label 5396*/ GIMT_Encode4(277525),
     /* 277517 */ /*GILLT_s32*//*Label 5397*/ GIMT_Encode4(277577),
     /* 277521 */ /*GILLT_s64*//*Label 5398*/ GIMT_Encode4(277690),
     /* 277525 */ // Label 5396: @277525
     /* 277525 */ GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(277548), // Rule ID 506 //
     /* 277530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277533 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 277537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 277541 */   // MIs[0] Operand 1
     /* 277541 */   // No operand predicates
     /* 277541 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 277541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 277544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277546 */   GIR_RootConstrainSelectedInstOperands,
     /* 277547 */   // GIR_Coverage, 506,
     /* 277547 */   GIR_EraseRootFromParent_Done,
     /* 277548 */ // Label 5400: @277548
     /* 277548 */ GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(277576), // Rule ID 688 //
     /* 277553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 277556 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 277560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 277564 */   // MIs[0] Operand 1
     /* 277564 */   // No operand predicates
     /* 277564 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 277564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 277567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277569 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 277574 */   GIR_RootConstrainSelectedInstOperands,
     /* 277575 */   // GIR_Coverage, 688,
     /* 277575 */   GIR_EraseRootFromParent_Done,
     /* 277576 */ // Label 5401: @277576
     /* 277576 */ GIM_Reject,
     /* 277577 */ // Label 5397: @277577
     /* 277577 */ GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(277600), // Rule ID 507 //
     /* 277582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277585 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 277589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277593 */   // MIs[0] Operand 1
     /* 277593 */   // No operand predicates
     /* 277593 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 277593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 277596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277598 */   GIR_RootConstrainSelectedInstOperands,
     /* 277599 */   // GIR_Coverage, 507,
     /* 277599 */   GIR_EraseRootFromParent_Done,
     /* 277600 */ // Label 5402: @277600
     /* 277600 */ GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(277628), // Rule ID 689 //
     /* 277605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277608 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 277612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277616 */   // MIs[0] Operand 1
     /* 277616 */   // No operand predicates
     /* 277616 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 277616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 277619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277621 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 277626 */   GIR_RootConstrainSelectedInstOperands,
     /* 277627 */   // GIR_Coverage, 689,
     /* 277627 */   GIR_EraseRootFromParent_Done,
     /* 277628 */ // Label 5403: @277628
     /* 277628 */ GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(277689), // Rule ID 6065 //
     /* 277633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277636 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 277640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277644 */   // MIs[0] Operand 1
     /* 277644 */   // No operand predicates
     /* 277644 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 277644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 277647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 277651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277656 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 277661 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 277664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277671 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 277678 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277688 */   // GIR_Coverage, 6065,
     /* 277688 */   GIR_EraseRootFromParent_Done,
     /* 277689 */ // Label 5404: @277689
     /* 277689 */ GIM_Reject,
     /* 277690 */ // Label 5398: @277690
     /* 277690 */ GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(277713), // Rule ID 508 //
     /* 277695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277698 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 277702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277706 */   // MIs[0] Operand 1
     /* 277706 */   // No operand predicates
     /* 277706 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 277706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 277709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277711 */   GIR_RootConstrainSelectedInstOperands,
     /* 277712 */   // GIR_Coverage, 508,
     /* 277712 */   GIR_EraseRootFromParent_Done,
     /* 277713 */ // Label 5405: @277713
     /* 277713 */ GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(277741), // Rule ID 690 //
     /* 277718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277721 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 277725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277729 */   // MIs[0] Operand 1
     /* 277729 */   // No operand predicates
     /* 277729 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 277729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 277732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277734 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 277739 */   GIR_RootConstrainSelectedInstOperands,
     /* 277740 */   // GIR_Coverage, 690,
     /* 277740 */   GIR_EraseRootFromParent_Done,
     /* 277741 */ // Label 5406: @277741
     /* 277741 */ GIM_Reject,
     /* 277742 */ // Label 5399: @277742
     /* 277742 */ GIM_Reject,
     /* 277743 */ // Label 43: @277743
     /* 277743 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5412*/ GIMT_Encode4(279640),
     /* 277754 */ /*GILLT_s32*//*Label 5407*/ GIMT_Encode4(277790),
     /* 277758 */ /*GILLT_s64*//*Label 5408*/ GIMT_Encode4(279231), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277770 */ /*GILLT_v2s64*//*Label 5409*/ GIMT_Encode4(279454), GIMT_Encode4(0),
     /* 277778 */ /*GILLT_v4s32*//*Label 5410*/ GIMT_Encode4(279516), GIMT_Encode4(0),
     /* 277786 */ /*GILLT_v8s16*//*Label 5411*/ GIMT_Encode4(279578),
     /* 277790 */ // Label 5407: @277790
     /* 277790 */ GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(277910), // Rule ID 13199 //
     /* 277795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 277798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277802 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277806 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 277810 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 277813 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 277818 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 277822 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277827 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277829 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277829 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 277832 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 277836 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277841 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 277845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 277847 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 277850 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277854 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 277864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277873 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277876 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 277879 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 277882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277887 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 277897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 277900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277908 */   GIR_RootConstrainSelectedInstOperands,
     /* 277909 */   // GIR_Coverage, 13199,
     /* 277909 */   GIR_EraseRootFromParent_Done,
     /* 277910 */ // Label 5413: @277910
     /* 277910 */ GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(278030), // Rule ID 13201 //
     /* 277915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 277918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277922 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 277930 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 277933 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 277938 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 277942 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277947 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277949 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277949 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 277952 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 277956 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277961 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 277965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 277967 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 277970 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277974 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277981 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 277984 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277988 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277993 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277996 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 277999 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 278002 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278012 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 278017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 278020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278028 */   GIR_RootConstrainSelectedInstOperands,
     /* 278029 */   // GIR_Coverage, 13201,
     /* 278029 */   GIR_EraseRootFromParent_Done,
     /* 278030 */ // Label 5414: @278030
     /* 278030 */ GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(278150), // Rule ID 13203 //
     /* 278035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278042 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278046 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278050 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278053 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 278058 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278062 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278069 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278069 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 278072 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 278076 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278081 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278087 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278090 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278094 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278101 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278104 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278108 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278113 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278116 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278119 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 278122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278132 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 278140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278148 */   GIR_RootConstrainSelectedInstOperands,
     /* 278149 */   // GIR_Coverage, 13203,
     /* 278149 */   GIR_EraseRootFromParent_Done,
     /* 278150 */ // Label 5415: @278150
     /* 278150 */ GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(278270), // Rule ID 13205 //
     /* 278155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278162 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278170 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278173 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 278178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278182 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278189 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278189 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 278192 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 278196 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278201 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278207 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278210 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278214 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278233 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278236 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278239 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 278242 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278247 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278252 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 278260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278268 */   GIR_RootConstrainSelectedInstOperands,
     /* 278269 */   // GIR_Coverage, 13205,
     /* 278269 */   GIR_EraseRootFromParent_Done,
     /* 278270 */ // Label 5416: @278270
     /* 278270 */ GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(278390), // Rule ID 13221 //
     /* 278275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 278278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278282 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278286 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278290 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278293 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 278298 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 278302 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278309 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278309 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 278312 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 278316 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278321 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278327 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278330 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278334 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278353 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278356 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278359 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 278362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278367 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 278377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 278380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278388 */   GIR_RootConstrainSelectedInstOperands,
     /* 278389 */   // GIR_Coverage, 13221,
     /* 278389 */   GIR_EraseRootFromParent_Done,
     /* 278390 */ // Label 5417: @278390
     /* 278390 */ GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(278510), // Rule ID 13223 //
     /* 278395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 278398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278402 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278406 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278410 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278413 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 278418 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278422 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278427 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278429 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278429 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 278432 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 278436 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278441 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278447 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278450 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278454 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278461 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278464 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278468 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278473 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278476 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278479 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 278482 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278487 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278492 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 278497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 278500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278508 */   GIR_RootConstrainSelectedInstOperands,
     /* 278509 */   // GIR_Coverage, 13223,
     /* 278509 */   GIR_EraseRootFromParent_Done,
     /* 278510 */ // Label 5418: @278510
     /* 278510 */ GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(278630), // Rule ID 13225 //
     /* 278515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278522 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278530 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278533 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 278538 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278542 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278547 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278549 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278549 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 278552 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 278556 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278561 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278567 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278570 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278574 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278581 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278584 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278588 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278593 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278596 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278599 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 278602 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278607 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278612 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 278620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278628 */   GIR_RootConstrainSelectedInstOperands,
     /* 278629 */   // GIR_Coverage, 13225,
     /* 278629 */   GIR_EraseRootFromParent_Done,
     /* 278630 */ // Label 5419: @278630
     /* 278630 */ GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(278750), // Rule ID 13227 //
     /* 278635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278642 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278646 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278650 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278653 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 278658 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278662 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278669 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278669 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 278672 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 278676 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278681 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278687 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278690 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278694 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278713 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278716 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278719 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 278722 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278727 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 278740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278748 */   GIR_RootConstrainSelectedInstOperands,
     /* 278749 */   // GIR_Coverage, 13227,
     /* 278749 */   GIR_EraseRootFromParent_Done,
     /* 278750 */ // Label 5420: @278750
     /* 278750 */ GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(278870), // Rule ID 13231 //
     /* 278755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 278758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278762 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278770 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278773 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 278778 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 278782 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278787 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278789 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278789 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 278792 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 278796 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278801 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278807 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278810 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278814 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278833 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278836 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278839 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 278842 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278847 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278852 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 278857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 278860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278868 */   GIR_RootConstrainSelectedInstOperands,
     /* 278869 */   // GIR_Coverage, 13231,
     /* 278869 */   GIR_EraseRootFromParent_Done,
     /* 278870 */ // Label 5421: @278870
     /* 278870 */ GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(278990), // Rule ID 13233 //
     /* 278875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 278878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278882 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278886 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278890 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278893 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 278898 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278902 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278907 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278909 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278909 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 278912 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 278916 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278921 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278927 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278930 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278934 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278953 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278956 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278959 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 278962 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278967 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 278977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 278980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278988 */   GIR_RootConstrainSelectedInstOperands,
     /* 278989 */   // GIR_Coverage, 13233,
     /* 278989 */   GIR_EraseRootFromParent_Done,
     /* 278990 */ // Label 5422: @278990
     /* 278990 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(279110), // Rule ID 13235 //
     /* 278995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279002 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279006 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279010 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279013 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 279018 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 279022 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279029 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279029 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 279032 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 279036 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279041 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279047 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279050 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279054 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279061 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279064 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279068 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279073 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279076 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279079 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 279082 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279087 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279092 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279108 */   GIR_RootConstrainSelectedInstOperands,
     /* 279109 */   // GIR_Coverage, 13235,
     /* 279109 */   GIR_EraseRootFromParent_Done,
     /* 279110 */ // Label 5423: @279110
     /* 279110 */ GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(279230), // Rule ID 13237 //
     /* 279115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279122 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279130 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279133 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 279138 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 279142 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279147 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279149 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279149 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 279152 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 279156 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279161 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279167 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279170 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279174 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279193 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279196 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279199 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 279202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279212 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279228 */   GIR_RootConstrainSelectedInstOperands,
     /* 279229 */   // GIR_Coverage, 13237,
     /* 279229 */   GIR_EraseRootFromParent_Done,
     /* 279230 */ // Label 5424: @279230
     /* 279230 */ GIM_Reject,
     /* 279231 */ // Label 5408: @279231
     /* 279231 */ GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(279453),
     /* 279236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 279239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 279243 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(279297), // Rule ID 5671 //
     /* 279248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279277 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 279281 */     // MIs[2] Operand 1
     /* 279281 */     // No operand predicates
     /* 279281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279283 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 279283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 279286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279295 */     GIR_RootConstrainSelectedInstOperands,
     /* 279296 */     // GIR_Coverage, 5671,
     /* 279296 */     GIR_EraseRootFromParent_Done,
     /* 279297 */   // Label 5426: @279297
     /* 279297 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(279376), // Rule ID 11280 //
     /* 279302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 279317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279329 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 279333 */     // MIs[2] Operand 1
     /* 279333 */     // No operand predicates
     /* 279333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279335 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 279335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 279338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279347 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 279353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 279366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 279374 */     GIR_RootConstrainSelectedInstOperands,
     /* 279375 */     // GIR_Coverage, 11280,
     /* 279375 */     GIR_EraseRootFromParent_Done,
     /* 279376 */   // Label 5427: @279376
     /* 279376 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(279452), // Rule ID 6535 //
     /* 279381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279385 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 279385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 279388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279411 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 279418 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 279421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 279439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 279450 */     GIR_RootConstrainSelectedInstOperands,
     /* 279451 */     // GIR_Coverage, 6535,
     /* 279451 */     GIR_EraseRootFromParent_Done,
     /* 279452 */   // Label 5428: @279452
     /* 279452 */   GIM_Reject,
     /* 279453 */ // Label 5425: @279453
     /* 279453 */ GIM_Reject,
     /* 279454 */ // Label 5409: @279454
     /* 279454 */ GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(279515),
     /* 279459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 279462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279466 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(279493), // Rule ID 6405 //
     /* 279471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 279478 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 279478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 279481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279491 */     GIR_RootConstrainSelectedInstOperands,
     /* 279492 */     // GIR_Coverage, 6405,
     /* 279492 */     GIR_EraseRootFromParent_Done,
     /* 279493 */   // Label 5430: @279493
     /* 279493 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(279514), // Rule ID 6394 //
     /* 279498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279502 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 279502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 279505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279512 */     GIR_RootConstrainSelectedInstOperands,
     /* 279513 */     // GIR_Coverage, 6394,
     /* 279513 */     GIR_EraseRootFromParent_Done,
     /* 279514 */   // Label 5431: @279514
     /* 279514 */   GIM_Reject,
     /* 279515 */ // Label 5429: @279515
     /* 279515 */ GIM_Reject,
     /* 279516 */ // Label 5410: @279516
     /* 279516 */ GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(279577),
     /* 279521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 279524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279528 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(279555), // Rule ID 6402 //
     /* 279533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 279540 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 279540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 279543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279553 */     GIR_RootConstrainSelectedInstOperands,
     /* 279554 */     // GIR_Coverage, 6402,
     /* 279554 */     GIR_EraseRootFromParent_Done,
     /* 279555 */   // Label 5433: @279555
     /* 279555 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(279576), // Rule ID 6391 //
     /* 279560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279564 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 279564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 279567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279574 */     GIR_RootConstrainSelectedInstOperands,
     /* 279575 */     // GIR_Coverage, 6391,
     /* 279575 */     GIR_EraseRootFromParent_Done,
     /* 279576 */   // Label 5434: @279576
     /* 279576 */   GIM_Reject,
     /* 279577 */ // Label 5432: @279577
     /* 279577 */ GIM_Reject,
     /* 279578 */ // Label 5411: @279578
     /* 279578 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(279639),
     /* 279583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 279586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279590 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(279617), // Rule ID 6399 //
     /* 279595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 279602 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 279602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 279605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279615 */     GIR_RootConstrainSelectedInstOperands,
     /* 279616 */     // GIR_Coverage, 6399,
     /* 279616 */     GIR_EraseRootFromParent_Done,
     /* 279617 */   // Label 5436: @279617
     /* 279617 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(279638), // Rule ID 6388 //
     /* 279622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279626 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 279626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 279629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279636 */     GIR_RootConstrainSelectedInstOperands,
     /* 279637 */     // GIR_Coverage, 6388,
     /* 279637 */     GIR_EraseRootFromParent_Done,
     /* 279638 */   // Label 5437: @279638
     /* 279638 */   GIM_Reject,
     /* 279639 */ // Label 5435: @279639
     /* 279639 */ GIM_Reject,
     /* 279640 */ // Label 5412: @279640
     /* 279640 */ GIM_Reject,
     /* 279641 */ // Label 44: @279641
     /* 279641 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5443*/ GIMT_Encode4(281294),
     /* 279652 */ /*GILLT_s32*//*Label 5438*/ GIMT_Encode4(279732),
     /* 279656 */ /*GILLT_s64*//*Label 5439*/ GIMT_Encode4(280226), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279708 */ /*GILLT_nxv2s64*//*Label 5440*/ GIMT_Encode4(280868), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279720 */ /*GILLT_nxv4s32*//*Label 5441*/ GIMT_Encode4(281077), GIMT_Encode4(0),
     /* 279728 */ /*GILLT_nxv8s16*//*Label 5442*/ GIMT_Encode4(281221),
     /* 279732 */ // Label 5438: @279732
     /* 279732 */ GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(280225),
     /* 279737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 279740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279744 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(279809), // Rule ID 5666 //
     /* 279749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 279761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279778 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 279782 */     // MIs[2] Operand 1
     /* 279782 */     // No operand predicates
     /* 279782 */     // MIs[0] Operand 2
     /* 279782 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 279793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279795 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 279795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279807 */     GIR_RootConstrainSelectedInstOperands,
     /* 279808 */     // GIR_Coverage, 5666,
     /* 279808 */     GIR_EraseRootFromParent_Done,
     /* 279809 */   // Label 5445: @279809
     /* 279809 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(279874), // Rule ID 5668 //
     /* 279814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279843 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279847 */     // MIs[2] Operand 1
     /* 279847 */     // No operand predicates
     /* 279847 */     // MIs[0] Operand 2
     /* 279847 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 279858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279860 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279872 */     GIR_RootConstrainSelectedInstOperands,
     /* 279873 */     // GIR_Coverage, 5668,
     /* 279873 */     GIR_EraseRootFromParent_Done,
     /* 279874 */   // Label 5446: @279874
     /* 279874 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(279939), // Rule ID 5670 //
     /* 279879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279908 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279912 */     // MIs[2] Operand 1
     /* 279912 */     // No operand predicates
     /* 279912 */     // MIs[0] Operand 2
     /* 279912 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 279923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279925 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279937 */     GIR_RootConstrainSelectedInstOperands,
     /* 279938 */     // GIR_Coverage, 5670,
     /* 279938 */     GIR_EraseRootFromParent_Done,
     /* 279939 */   // Label 5447: @279939
     /* 279939 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(280029), // Rule ID 11276 //
     /* 279944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 279959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 279975 */     // MIs[2] Operand 1
     /* 279975 */     // No operand predicates
     /* 279975 */     // MIs[0] Operand 2
     /* 279975 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 279986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279988 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 279988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280000 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 280027 */     GIR_RootConstrainSelectedInstOperands,
     /* 280028 */     // GIR_Coverage, 11276,
     /* 280028 */     GIR_EraseRootFromParent_Done,
     /* 280029 */   // Label 5448: @280029
     /* 280029 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(280119), // Rule ID 11278 //
     /* 280034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 280049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280061 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280065 */     // MIs[2] Operand 1
     /* 280065 */     // No operand predicates
     /* 280065 */     // MIs[0] Operand 2
     /* 280065 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280078 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 280078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 280081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280090 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 280117 */     GIR_RootConstrainSelectedInstOperands,
     /* 280118 */     // GIR_Coverage, 11278,
     /* 280118 */     GIR_EraseRootFromParent_Done,
     /* 280119 */   // Label 5449: @280119
     /* 280119 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(280154), // Rule ID 6540 //
     /* 280124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280128 */     // MIs[0] Operand 2
     /* 280128 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280139 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 280139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 280142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 280152 */     GIR_RootConstrainSelectedInstOperands,
     /* 280153 */     // GIR_Coverage, 6540,
     /* 280153 */     GIR_EraseRootFromParent_Done,
     /* 280154 */   // Label 5450: @280154
     /* 280154 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(280189), // Rule ID 6541 //
     /* 280159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280163 */     // MIs[0] Operand 2
     /* 280163 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280174 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 280174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 280177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 280187 */     GIR_RootConstrainSelectedInstOperands,
     /* 280188 */     // GIR_Coverage, 6541,
     /* 280188 */     GIR_EraseRootFromParent_Done,
     /* 280189 */   // Label 5451: @280189
     /* 280189 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(280224), // Rule ID 6542 //
     /* 280194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280198 */     // MIs[0] Operand 2
     /* 280198 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 280209 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 280209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 280212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280222 */     GIR_RootConstrainSelectedInstOperands,
     /* 280223 */     // GIR_Coverage, 6542,
     /* 280223 */     GIR_EraseRootFromParent_Done,
     /* 280224 */   // Label 5452: @280224
     /* 280224 */   GIM_Reject,
     /* 280225 */ // Label 5444: @280225
     /* 280225 */ GIM_Reject,
     /* 280226 */ // Label 5439: @280226
     /* 280226 */ GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(280867),
     /* 280231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 280234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280238 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(280315), // Rule ID 5672 //
     /* 280243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 280251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 280267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280284 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 280288 */     // MIs[3] Operand 1
     /* 280288 */     // No operand predicates
     /* 280288 */     // MIs[0] Operand 2
     /* 280288 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280301 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 280301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 280304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 280313 */     GIR_RootConstrainSelectedInstOperands,
     /* 280314 */     // GIR_Coverage, 5672,
     /* 280314 */     GIR_EraseRootFromParent_Done,
     /* 280315 */   // Label 5454: @280315
     /* 280315 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(280392), // Rule ID 5673 //
     /* 280320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 280328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280361 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280365 */     // MIs[3] Operand 1
     /* 280365 */     // No operand predicates
     /* 280365 */     // MIs[0] Operand 2
     /* 280365 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280376 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280378 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 280381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 280390 */     GIR_RootConstrainSelectedInstOperands,
     /* 280391 */     // GIR_Coverage, 5673,
     /* 280391 */     GIR_EraseRootFromParent_Done,
     /* 280392 */   // Label 5455: @280392
     /* 280392 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(280494), // Rule ID 11277 //
     /* 280397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 280408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 280424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280436 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 280440 */     // MIs[3] Operand 1
     /* 280440 */     // No operand predicates
     /* 280440 */     // MIs[0] Operand 2
     /* 280440 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280453 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 280453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280465 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 280484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 280492 */     GIR_RootConstrainSelectedInstOperands,
     /* 280493 */     // GIR_Coverage, 11277,
     /* 280493 */     GIR_EraseRootFromParent_Done,
     /* 280494 */   // Label 5456: @280494
     /* 280494 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(280596), // Rule ID 11279 //
     /* 280499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 280510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 280526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280542 */     // MIs[3] Operand 1
     /* 280542 */     // No operand predicates
     /* 280542 */     // MIs[0] Operand 2
     /* 280542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280555 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 280555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 280558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280567 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 280586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 280594 */     GIR_RootConstrainSelectedInstOperands,
     /* 280595 */     // GIR_Coverage, 11279,
     /* 280595 */     GIR_EraseRootFromParent_Done,
     /* 280596 */   // Label 5457: @280596
     /* 280596 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(280661), // Rule ID 5667 //
     /* 280601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 280613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280630 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 280634 */     // MIs[2] Operand 1
     /* 280634 */     // No operand predicates
     /* 280634 */     // MIs[0] Operand 2
     /* 280634 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280647 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 280647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 280650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280659 */     GIR_RootConstrainSelectedInstOperands,
     /* 280660 */     // GIR_Coverage, 5667,
     /* 280660 */     GIR_EraseRootFromParent_Done,
     /* 280661 */   // Label 5458: @280661
     /* 280661 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(280726), // Rule ID 5669 //
     /* 280666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280695 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280699 */     // MIs[2] Operand 1
     /* 280699 */     // No operand predicates
     /* 280699 */     // MIs[0] Operand 2
     /* 280699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280712 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 280715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280724 */     GIR_RootConstrainSelectedInstOperands,
     /* 280725 */     // GIR_Coverage, 5669,
     /* 280725 */     GIR_EraseRootFromParent_Done,
     /* 280726 */   // Label 5459: @280726
     /* 280726 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(280761), // Rule ID 6536 //
     /* 280731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280735 */     // MIs[0] Operand 2
     /* 280735 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 280746 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 280746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 280749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 280759 */     GIR_RootConstrainSelectedInstOperands,
     /* 280760 */     // GIR_Coverage, 6536,
     /* 280760 */     GIR_EraseRootFromParent_Done,
     /* 280761 */   // Label 5460: @280761
     /* 280761 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(280796), // Rule ID 6537 //
     /* 280766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280770 */     // MIs[0] Operand 2
     /* 280770 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280781 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 280781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 280784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 280794 */     GIR_RootConstrainSelectedInstOperands,
     /* 280795 */     // GIR_Coverage, 6537,
     /* 280795 */     GIR_EraseRootFromParent_Done,
     /* 280796 */   // Label 5461: @280796
     /* 280796 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(280831), // Rule ID 6538 //
     /* 280801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280805 */     // MIs[0] Operand 2
     /* 280805 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280816 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 280816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 280819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 280829 */     GIR_RootConstrainSelectedInstOperands,
     /* 280830 */     // GIR_Coverage, 6538,
     /* 280830 */     GIR_EraseRootFromParent_Done,
     /* 280831 */   // Label 5462: @280831
     /* 280831 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(280866), // Rule ID 6539 //
     /* 280836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280840 */     // MIs[0] Operand 2
     /* 280840 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 280851 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 280851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 280854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280856 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280864 */     GIR_RootConstrainSelectedInstOperands,
     /* 280865 */     // GIR_Coverage, 6539,
     /* 280865 */     GIR_EraseRootFromParent_Done,
     /* 280866 */   // Label 5463: @280866
     /* 280866 */   GIM_Reject,
     /* 280867 */ // Label 5453: @280867
     /* 280867 */ GIM_Reject,
     /* 280868 */ // Label 5440: @280868
     /* 280868 */ GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(281076),
     /* 280873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 280876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280880 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(280945), // Rule ID 10548 //
     /* 280885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280888 */     // MIs[0] Operand 2
     /* 280888 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 280899 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 280899 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 280902 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 280906 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280911 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 280914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 280919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 280933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 280943 */     GIR_RootConstrainSelectedInstOperands,
     /* 280944 */     // GIR_Coverage, 10548,
     /* 280944 */     GIR_EraseRootFromParent_Done,
     /* 280945 */   // Label 5465: @280945
     /* 280945 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(281010), // Rule ID 10549 //
     /* 280950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280953 */     // MIs[0] Operand 2
     /* 280953 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280964 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 280964 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 280967 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 280971 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280976 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 280979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 280984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 280998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281008 */     GIR_RootConstrainSelectedInstOperands,
     /* 281009 */     // GIR_Coverage, 10549,
     /* 281009 */     GIR_EraseRootFromParent_Done,
     /* 281010 */   // Label 5466: @281010
     /* 281010 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(281075), // Rule ID 10550 //
     /* 281015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281018 */     // MIs[0] Operand 2
     /* 281018 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281029 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 281029 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 281032 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 281036 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281041 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 281049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 281063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281073 */     GIR_RootConstrainSelectedInstOperands,
     /* 281074 */     // GIR_Coverage, 10550,
     /* 281074 */     GIR_EraseRootFromParent_Done,
     /* 281075 */   // Label 5467: @281075
     /* 281075 */   GIM_Reject,
     /* 281076 */ // Label 5464: @281076
     /* 281076 */ GIM_Reject,
     /* 281077 */ // Label 5441: @281077
     /* 281077 */ GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(281220),
     /* 281082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 281085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281089 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(281154), // Rule ID 10551 //
     /* 281094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281097 */     // MIs[0] Operand 2
     /* 281097 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281108 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 281108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 281111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 281115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281120 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 281128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 281142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281152 */     GIR_RootConstrainSelectedInstOperands,
     /* 281153 */     // GIR_Coverage, 10551,
     /* 281153 */     GIR_EraseRootFromParent_Done,
     /* 281154 */   // Label 5469: @281154
     /* 281154 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(281219), // Rule ID 10552 //
     /* 281159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281162 */     // MIs[0] Operand 2
     /* 281162 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281173 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 281173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 281176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 281180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281185 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 281193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 281207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281217 */     GIR_RootConstrainSelectedInstOperands,
     /* 281218 */     // GIR_Coverage, 10552,
     /* 281218 */     GIR_EraseRootFromParent_Done,
     /* 281219 */   // Label 5470: @281219
     /* 281219 */   GIM_Reject,
     /* 281220 */ // Label 5468: @281220
     /* 281220 */ GIM_Reject,
     /* 281221 */ // Label 5442: @281221
     /* 281221 */ GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(281293), // Rule ID 10553 //
     /* 281226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281236 */   // MIs[0] Operand 2
     /* 281236 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281247 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 281247 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 281250 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 281254 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281259 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 281267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 281281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281289 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281291 */   GIR_RootConstrainSelectedInstOperands,
     /* 281292 */   // GIR_Coverage, 10553,
     /* 281292 */   GIR_EraseRootFromParent_Done,
     /* 281293 */ // Label 5471: @281293
     /* 281293 */ GIM_Reject,
     /* 281294 */ // Label 5443: @281294
     /* 281294 */ GIM_Reject,
     /* 281295 */ // Label 45: @281295
     /* 281295 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5476*/ GIMT_Encode4(284073),
     /* 281306 */ /*GILLT_s32*//*Label 5472*/ GIMT_Encode4(281342), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281322 */ /*GILLT_v2s64*//*Label 5473*/ GIMT_Encode4(283143), GIMT_Encode4(0),
     /* 281330 */ /*GILLT_v4s32*//*Label 5474*/ GIMT_Encode4(283453), GIMT_Encode4(0),
     /* 281338 */ /*GILLT_v8s16*//*Label 5475*/ GIMT_Encode4(283763),
     /* 281342 */ // Label 5472: @281342
     /* 281342 */ GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(281492), // Rule ID 13208 //
     /* 281347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 281350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281354 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281362 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281365 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 281370 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 281374 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281379 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281381 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 281381 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 281384 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 281388 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281393 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281399 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 281402 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281406 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281413 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281416 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281420 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281425 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 281428 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 281431 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 281434 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281439 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281444 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 281449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281461 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 281468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281491 */   // GIR_Coverage, 13208,
     /* 281491 */   GIR_EraseRootFromParent_Done,
     /* 281492 */ // Label 5477: @281492
     /* 281492 */ GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(281642), // Rule ID 13210 //
     /* 281497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 281500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281504 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281512 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281515 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 281520 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281524 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281529 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281531 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 281531 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 281534 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 281538 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281543 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281549 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 281552 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281556 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281563 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281566 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281570 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281575 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 281578 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 281581 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 281584 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281589 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281594 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 281599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281611 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 281618 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281623 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281633 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281641 */   // GIR_Coverage, 13210,
     /* 281641 */   GIR_EraseRootFromParent_Done,
     /* 281642 */ // Label 5478: @281642
     /* 281642 */ GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(281792), // Rule ID 13212 //
     /* 281647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281654 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281658 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281662 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281665 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 281670 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281674 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281681 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 281681 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 281684 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 281688 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281693 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281699 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 281702 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281706 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281713 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281716 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281720 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281725 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 281728 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 281731 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 281734 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281739 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281744 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281761 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 281768 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281773 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281783 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281786 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281791 */   // GIR_Coverage, 13212,
     /* 281791 */   GIR_EraseRootFromParent_Done,
     /* 281792 */ // Label 5479: @281792
     /* 281792 */ GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(281942), // Rule ID 13214 //
     /* 281797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281804 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281812 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281815 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 281820 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281824 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281831 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 281831 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 281834 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 281838 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281843 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281849 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 281852 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281856 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281863 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281866 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281870 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281875 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 281878 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 281881 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 281884 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281889 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281894 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281911 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 281918 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281923 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281941 */   // GIR_Coverage, 13214,
     /* 281941 */   GIR_EraseRootFromParent_Done,
     /* 281942 */ // Label 5480: @281942
     /* 281942 */ GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(282092), // Rule ID 13241 //
     /* 281947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 281950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281954 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281962 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281965 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 281970 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 281974 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281979 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281981 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 281981 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 281984 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 281988 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281993 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281999 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282002 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282006 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282013 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282016 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282020 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282025 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282028 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282031 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 282034 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282039 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282044 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282061 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282068 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282073 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282091 */   // GIR_Coverage, 13241,
     /* 282091 */   GIR_EraseRootFromParent_Done,
     /* 282092 */ // Label 5481: @282092
     /* 282092 */ GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(282242), // Rule ID 13243 //
     /* 282097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282104 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282108 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282112 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282115 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 282120 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282124 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282129 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282131 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282131 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 282134 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 282138 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282143 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282149 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282152 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282156 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282163 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282166 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282170 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282175 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282178 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282181 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 282184 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282189 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282194 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282211 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282218 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282241 */   // GIR_Coverage, 13243,
     /* 282241 */   GIR_EraseRootFromParent_Done,
     /* 282242 */ // Label 5482: @282242
     /* 282242 */ GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(282392), // Rule ID 13245 //
     /* 282247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282254 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282262 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282265 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 282270 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282274 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282279 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282281 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282281 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 282284 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 282288 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282293 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282299 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282302 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282306 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282313 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282316 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282320 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282325 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282328 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282331 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 282334 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282339 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282344 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282361 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282368 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282373 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282391 */   // GIR_Coverage, 13245,
     /* 282391 */   GIR_EraseRootFromParent_Done,
     /* 282392 */ // Label 5483: @282392
     /* 282392 */ GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(282542), // Rule ID 13247 //
     /* 282397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282404 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282412 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282415 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 282420 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282424 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282429 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282431 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282431 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 282434 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 282438 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282443 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282449 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282452 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282456 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282475 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282478 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282481 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 282484 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282489 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282494 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282511 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282536 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282541 */   // GIR_Coverage, 13247,
     /* 282541 */   GIR_EraseRootFromParent_Done,
     /* 282542 */ // Label 5484: @282542
     /* 282542 */ GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(282692), // Rule ID 13251 //
     /* 282547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282554 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282562 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282565 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 282570 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282574 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282579 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282581 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282581 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 282584 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 282588 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282593 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282599 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282602 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282606 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282613 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282616 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282620 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282625 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282628 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282631 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 282634 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282639 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282644 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282661 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282668 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282673 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282686 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282691 */   // GIR_Coverage, 13251,
     /* 282691 */   GIR_EraseRootFromParent_Done,
     /* 282692 */ // Label 5485: @282692
     /* 282692 */ GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(282842), // Rule ID 13253 //
     /* 282697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282704 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282712 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282715 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 282720 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282724 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282729 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282731 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282731 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 282734 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 282738 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282743 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282749 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282752 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282756 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282763 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282766 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282770 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282775 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282778 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282781 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 282784 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282789 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282794 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282811 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282818 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282823 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282836 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282841 */   // GIR_Coverage, 13253,
     /* 282841 */   GIR_EraseRootFromParent_Done,
     /* 282842 */ // Label 5486: @282842
     /* 282842 */ GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(282992), // Rule ID 13255 //
     /* 282847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282854 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282862 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282865 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 282870 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282881 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282881 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 282884 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 282888 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282893 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282899 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282902 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282906 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282913 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282916 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282920 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282925 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282928 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282931 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 282934 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282939 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282944 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282961 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282968 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282986 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282991 */   // GIR_Coverage, 13255,
     /* 282991 */   GIR_EraseRootFromParent_Done,
     /* 282992 */ // Label 5487: @282992
     /* 282992 */ GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(283142), // Rule ID 13257 //
     /* 282997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283004 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283008 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283012 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283015 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 283020 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283024 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283031 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283031 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283034 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 283038 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283043 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283049 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283052 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283056 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283063 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283066 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283070 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283075 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283078 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283081 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283084 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283089 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283094 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283111 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283118 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283123 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283141 */   // GIR_Coverage, 13257,
     /* 283141 */   GIR_EraseRootFromParent_Done,
     /* 283142 */ // Label 5488: @283142
     /* 283142 */ GIM_Reject,
     /* 283143 */ // Label 5473: @283143
     /* 283143 */ GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(283452),
     /* 283148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283155 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(283220), // Rule ID 702 //
     /* 283160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283171 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283174 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283183 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 283187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283203 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 283203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 283206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 283218 */     GIR_RootConstrainSelectedInstOperands,
     /* 283219 */     // GIR_Coverage, 702,
     /* 283219 */     GIR_EraseRootFromParent_Done,
     /* 283220 */   // Label 5490: @283220
     /* 283220 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(283285), // Rule ID 1711 //
     /* 283225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283236 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283239 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 283244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283248 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 283252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283268 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 283268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 283271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 283283 */     GIR_RootConstrainSelectedInstOperands,
     /* 283284 */     // GIR_Coverage, 1711,
     /* 283284 */     GIR_EraseRootFromParent_Done,
     /* 283285 */   // Label 5491: @283285
     /* 283285 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(283344), // Rule ID 700 //
     /* 283290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283301 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283304 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283313 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 283317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283329 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 283329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 283332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 283342 */     GIR_RootConstrainSelectedInstOperands,
     /* 283343 */     // GIR_Coverage, 700,
     /* 283343 */     GIR_EraseRootFromParent_Done,
     /* 283344 */   // Label 5492: @283344
     /* 283344 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(283403), // Rule ID 1709 //
     /* 283349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283360 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283363 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 283368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283372 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 283376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283388 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 283388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 283391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 283401 */     GIR_RootConstrainSelectedInstOperands,
     /* 283402 */     // GIR_Coverage, 1709,
     /* 283402 */     GIR_EraseRootFromParent_Done,
     /* 283403 */   // Label 5493: @283403
     /* 283403 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(283430), // Rule ID 6404 //
     /* 283408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283415 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 283415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 283418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283428 */     GIR_RootConstrainSelectedInstOperands,
     /* 283429 */     // GIR_Coverage, 6404,
     /* 283429 */     GIR_EraseRootFromParent_Done,
     /* 283430 */   // Label 5494: @283430
     /* 283430 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(283451), // Rule ID 6395 //
     /* 283435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283439 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 283439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 283442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283449 */     GIR_RootConstrainSelectedInstOperands,
     /* 283450 */     // GIR_Coverage, 6395,
     /* 283450 */     GIR_EraseRootFromParent_Done,
     /* 283451 */   // Label 5495: @283451
     /* 283451 */   GIM_Reject,
     /* 283452 */ // Label 5489: @283452
     /* 283452 */ GIM_Reject,
     /* 283453 */ // Label 5474: @283453
     /* 283453 */ GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(283762),
     /* 283458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 283461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283465 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(283530), // Rule ID 698 //
     /* 283470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283481 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283484 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283493 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 283497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283513 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 283513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 283516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 283528 */     GIR_RootConstrainSelectedInstOperands,
     /* 283529 */     // GIR_Coverage, 698,
     /* 283529 */     GIR_EraseRootFromParent_Done,
     /* 283530 */   // Label 5497: @283530
     /* 283530 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(283595), // Rule ID 1707 //
     /* 283535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283546 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283549 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 283554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283558 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 283562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283578 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 283578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 283581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 283593 */     GIR_RootConstrainSelectedInstOperands,
     /* 283594 */     // GIR_Coverage, 1707,
     /* 283594 */     GIR_EraseRootFromParent_Done,
     /* 283595 */   // Label 5498: @283595
     /* 283595 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(283654), // Rule ID 696 //
     /* 283600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283611 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283614 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283623 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 283627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283639 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 283639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 283642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 283652 */     GIR_RootConstrainSelectedInstOperands,
     /* 283653 */     // GIR_Coverage, 696,
     /* 283653 */     GIR_EraseRootFromParent_Done,
     /* 283654 */   // Label 5499: @283654
     /* 283654 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(283713), // Rule ID 1705 //
     /* 283659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283670 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283673 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 283678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283682 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 283686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283698 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 283698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 283701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 283711 */     GIR_RootConstrainSelectedInstOperands,
     /* 283712 */     // GIR_Coverage, 1705,
     /* 283712 */     GIR_EraseRootFromParent_Done,
     /* 283713 */   // Label 5500: @283713
     /* 283713 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(283740), // Rule ID 6401 //
     /* 283718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283725 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 283725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 283728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283738 */     GIR_RootConstrainSelectedInstOperands,
     /* 283739 */     // GIR_Coverage, 6401,
     /* 283739 */     GIR_EraseRootFromParent_Done,
     /* 283740 */   // Label 5501: @283740
     /* 283740 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(283761), // Rule ID 6392 //
     /* 283745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283749 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 283749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 283752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283759 */     GIR_RootConstrainSelectedInstOperands,
     /* 283760 */     // GIR_Coverage, 6392,
     /* 283760 */     GIR_EraseRootFromParent_Done,
     /* 283761 */   // Label 5502: @283761
     /* 283761 */   GIM_Reject,
     /* 283762 */ // Label 5496: @283762
     /* 283762 */ GIM_Reject,
     /* 283763 */ // Label 5475: @283763
     /* 283763 */ GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(284072),
     /* 283768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 283771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283775 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(283840), // Rule ID 694 //
     /* 283780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283791 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283794 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283803 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 283807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 283816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 283823 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 283823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 283826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 283838 */     GIR_RootConstrainSelectedInstOperands,
     /* 283839 */     // GIR_Coverage, 694,
     /* 283839 */     GIR_EraseRootFromParent_Done,
     /* 283840 */   // Label 5504: @283840
     /* 283840 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(283905), // Rule ID 1703 //
     /* 283845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283856 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283859 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 283864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283868 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 283872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 283881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 283888 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 283888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 283891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 283903 */     GIR_RootConstrainSelectedInstOperands,
     /* 283904 */     // GIR_Coverage, 1703,
     /* 283904 */     GIR_EraseRootFromParent_Done,
     /* 283905 */   // Label 5505: @283905
     /* 283905 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(283964), // Rule ID 692 //
     /* 283910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283921 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283924 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283933 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 283937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283949 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 283949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 283952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 283962 */     GIR_RootConstrainSelectedInstOperands,
     /* 283963 */     // GIR_Coverage, 692,
     /* 283963 */     GIR_EraseRootFromParent_Done,
     /* 283964 */   // Label 5506: @283964
     /* 283964 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(284023), // Rule ID 1701 //
     /* 283969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283980 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283983 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 283988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283992 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 283996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284008 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 284008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 284011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 284021 */     GIR_RootConstrainSelectedInstOperands,
     /* 284022 */     // GIR_Coverage, 1701,
     /* 284022 */     GIR_EraseRootFromParent_Done,
     /* 284023 */   // Label 5507: @284023
     /* 284023 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(284050), // Rule ID 6398 //
     /* 284028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 284035 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 284035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 284038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284048 */     GIR_RootConstrainSelectedInstOperands,
     /* 284049 */     // GIR_Coverage, 6398,
     /* 284049 */     GIR_EraseRootFromParent_Done,
     /* 284050 */   // Label 5508: @284050
     /* 284050 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(284071), // Rule ID 6389 //
     /* 284055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284059 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 284059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 284062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284069 */     GIR_RootConstrainSelectedInstOperands,
     /* 284070 */     // GIR_Coverage, 6389,
     /* 284070 */     GIR_EraseRootFromParent_Done,
     /* 284071 */   // Label 5509: @284071
     /* 284071 */   GIM_Reject,
     /* 284072 */ // Label 5503: @284072
     /* 284072 */ GIM_Reject,
     /* 284073 */ // Label 5476: @284073
     /* 284073 */ GIM_Reject,
     /* 284074 */ // Label 46: @284074
     /* 284074 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5515*/ GIMT_Encode4(284898),
     /* 284085 */ /*GILLT_s32*//*Label 5510*/ GIMT_Encode4(284121),
     /* 284089 */ /*GILLT_s64*//*Label 5511*/ GIMT_Encode4(284298), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284101 */ /*GILLT_v2s64*//*Label 5512*/ GIMT_Encode4(284471), GIMT_Encode4(0),
     /* 284109 */ /*GILLT_v4s32*//*Label 5513*/ GIMT_Encode4(284616), GIMT_Encode4(0),
     /* 284117 */ /*GILLT_v8s16*//*Label 5514*/ GIMT_Encode4(284757),
     /* 284121 */ // Label 5510: @284121
     /* 284121 */ GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(284297),
     /* 284126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 284132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284140 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(284177), // Rule ID 3932 //
     /* 284145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 284153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284164 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 284164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 284167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284175 */     GIR_RootConstrainSelectedInstOperands,
     /* 284176 */     // GIR_Coverage, 3932,
     /* 284176 */     GIR_EraseRootFromParent_Done,
     /* 284177 */   // Label 5517: @284177
     /* 284177 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(284214), // Rule ID 3933 //
     /* 284182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 284190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284201 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 284201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 284204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284212 */     GIR_RootConstrainSelectedInstOperands,
     /* 284213 */     // GIR_Coverage, 3933,
     /* 284213 */     GIR_EraseRootFromParent_Done,
     /* 284214 */   // Label 5518: @284214
     /* 284214 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(284251), // Rule ID 3931 //
     /* 284219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 284227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284238 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 284238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 284241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284249 */     GIR_RootConstrainSelectedInstOperands,
     /* 284250 */     // GIR_Coverage, 3931,
     /* 284250 */     GIR_EraseRootFromParent_Done,
     /* 284251 */   // Label 5519: @284251
     /* 284251 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(284296), // Rule ID 3930 //
     /* 284256 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 284256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284268 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 284274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 284287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284294 */     GIR_RootConstrainSelectedInstOperands,
     /* 284295 */     // GIR_Coverage, 3930,
     /* 284295 */     GIR_EraseRootFromParent_Done,
     /* 284296 */   // Label 5520: @284296
     /* 284296 */   GIM_Reject,
     /* 284297 */ // Label 5516: @284297
     /* 284297 */ GIM_Reject,
     /* 284298 */ // Label 5511: @284298
     /* 284298 */ GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(284470),
     /* 284303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 284306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 284309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284317 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(284385), // Rule ID 3934 //
     /* 284322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 284330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284341 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 284341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 284344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 284348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 284356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284360 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 284363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 284368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 284376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284383 */     GIR_RootConstrainSelectedInstOperands,
     /* 284384 */     // GIR_Coverage, 3934,
     /* 284384 */     GIR_EraseRootFromParent_Done,
     /* 284385 */   // Label 5522: @284385
     /* 284385 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(284453), // Rule ID 3935 //
     /* 284390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 284398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284409 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 284409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 284412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 284416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284421 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 284424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284428 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 284431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 284436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 284444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284451 */     GIR_RootConstrainSelectedInstOperands,
     /* 284452 */     // GIR_Coverage, 3935,
     /* 284452 */     GIR_EraseRootFromParent_Done,
     /* 284453 */   // Label 5523: @284453
     /* 284453 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(284469), // Rule ID 120 //
     /* 284458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284462 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 284462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 284467 */     GIR_RootConstrainSelectedInstOperands,
     /* 284468 */     // GIR_Coverage, 120,
     /* 284468 */     GIR_Done,
     /* 284469 */   // Label 5524: @284469
     /* 284469 */   GIM_Reject,
     /* 284470 */ // Label 5521: @284470
     /* 284470 */ GIM_Reject,
     /* 284471 */ // Label 5512: @284471
     /* 284471 */ GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(284615),
     /* 284476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284486 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(284550), // Rule ID 6387 //
     /* 284491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 284499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 284520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284528 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 284532 */     // MIs[3] Operand 1
     /* 284532 */     // No operand predicates
     /* 284532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284534 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 284534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 284537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284543 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 284548 */     GIR_RootConstrainSelectedInstOperands,
     /* 284549 */     // GIR_Coverage, 6387,
     /* 284549 */     GIR_EraseRootFromParent_Done,
     /* 284550 */   // Label 5526: @284550
     /* 284550 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(284614), // Rule ID 6384 //
     /* 284555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 284563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 284584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284592 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 284596 */     // MIs[3] Operand 1
     /* 284596 */     // No operand predicates
     /* 284596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284598 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 284598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 284601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284607 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 284612 */     GIR_RootConstrainSelectedInstOperands,
     /* 284613 */     // GIR_Coverage, 6384,
     /* 284613 */     GIR_EraseRootFromParent_Done,
     /* 284614 */   // Label 5527: @284614
     /* 284614 */   GIM_Reject,
     /* 284615 */ // Label 5525: @284615
     /* 284615 */ GIM_Reject,
     /* 284616 */ // Label 5513: @284616
     /* 284616 */ GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(284756),
     /* 284621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284631 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(284693), // Rule ID 6386 //
     /* 284636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 284644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284673 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 284677 */     // MIs[3] Operand 1
     /* 284677 */     // No operand predicates
     /* 284677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284679 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 284679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 284682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 284691 */     GIR_RootConstrainSelectedInstOperands,
     /* 284692 */     // GIR_Coverage, 6386,
     /* 284692 */     GIR_EraseRootFromParent_Done,
     /* 284693 */   // Label 5529: @284693
     /* 284693 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(284755), // Rule ID 6383 //
     /* 284698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 284706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284735 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 284739 */     // MIs[3] Operand 1
     /* 284739 */     // No operand predicates
     /* 284739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284741 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 284741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 284744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 284753 */     GIR_RootConstrainSelectedInstOperands,
     /* 284754 */     // GIR_Coverage, 6383,
     /* 284754 */     GIR_EraseRootFromParent_Done,
     /* 284755 */   // Label 5530: @284755
     /* 284755 */   GIM_Reject,
     /* 284756 */ // Label 5528: @284756
     /* 284756 */ GIM_Reject,
     /* 284757 */ // Label 5514: @284757
     /* 284757 */ GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(284897),
     /* 284762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284772 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(284834), // Rule ID 6385 //
     /* 284777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 284785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 284789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284814 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 284818 */     // MIs[3] Operand 1
     /* 284818 */     // No operand predicates
     /* 284818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284820 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 284820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 284823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 284832 */     GIR_RootConstrainSelectedInstOperands,
     /* 284833 */     // GIR_Coverage, 6385,
     /* 284833 */     GIR_EraseRootFromParent_Done,
     /* 284834 */   // Label 5532: @284834
     /* 284834 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(284896), // Rule ID 6382 //
     /* 284839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 284847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 284851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284876 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 284880 */     // MIs[3] Operand 1
     /* 284880 */     // No operand predicates
     /* 284880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284882 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 284882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 284885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 284894 */     GIR_RootConstrainSelectedInstOperands,
     /* 284895 */     // GIR_Coverage, 6382,
     /* 284895 */     GIR_EraseRootFromParent_Done,
     /* 284896 */   // Label 5533: @284896
     /* 284896 */   GIM_Reject,
     /* 284897 */ // Label 5531: @284897
     /* 284897 */ GIM_Reject,
     /* 284898 */ // Label 5515: @284898
     /* 284898 */ GIM_Reject,
     /* 284899 */ // Label 47: @284899
     /* 284899 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5536*/ GIMT_Encode4(285336),
     /* 284910 */ /*GILLT_s32*//*Label 5534*/ GIMT_Encode4(284918),
     /* 284914 */ /*GILLT_s64*//*Label 5535*/ GIMT_Encode4(285129),
     /* 284918 */ // Label 5534: @284918
     /* 284918 */ GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(285128),
     /* 284923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 284929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284937 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(284971), // Rule ID 4021 //
     /* 284942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 284954 */     // MIs[1] Operand 1
     /* 284954 */     // No operand predicates
     /* 284954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284956 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 284956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 284959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 284966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 284969 */     GIR_RootConstrainSelectedInstOperands,
     /* 284970 */     // GIR_Coverage, 4021,
     /* 284970 */     GIR_EraseRootFromParent_Done,
     /* 284971 */   // Label 5538: @284971
     /* 284971 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(285008), // Rule ID 3938 //
     /* 284976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 284984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284995 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 284995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 284998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285006 */     GIR_RootConstrainSelectedInstOperands,
     /* 285007 */     // GIR_Coverage, 3938,
     /* 285007 */     GIR_EraseRootFromParent_Done,
     /* 285008 */   // Label 5539: @285008
     /* 285008 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(285045), // Rule ID 3939 //
     /* 285013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285032 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 285035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285043 */     GIR_RootConstrainSelectedInstOperands,
     /* 285044 */     // GIR_Coverage, 3939,
     /* 285044 */     GIR_EraseRootFromParent_Done,
     /* 285045 */   // Label 5540: @285045
     /* 285045 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(285082), // Rule ID 3937 //
     /* 285050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285069 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 285072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285080 */     GIR_RootConstrainSelectedInstOperands,
     /* 285081 */     // GIR_Coverage, 3937,
     /* 285081 */     GIR_EraseRootFromParent_Done,
     /* 285082 */   // Label 5541: @285082
     /* 285082 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(285127), // Rule ID 3936 //
     /* 285087 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 285087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285099 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 285105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 285118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285125 */     GIR_RootConstrainSelectedInstOperands,
     /* 285126 */     // GIR_Coverage, 3936,
     /* 285126 */     GIR_EraseRootFromParent_Done,
     /* 285127 */   // Label 5542: @285127
     /* 285127 */   GIM_Reject,
     /* 285128 */ // Label 5537: @285128
     /* 285128 */ GIM_Reject,
     /* 285129 */ // Label 5535: @285129
     /* 285129 */ GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(285335),
     /* 285134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285148 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(285182), // Rule ID 4022 //
     /* 285153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 285165 */     // MIs[1] Operand 1
     /* 285165 */     // No operand predicates
     /* 285165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285167 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 285167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 285170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 285177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 285180 */     GIR_RootConstrainSelectedInstOperands,
     /* 285181 */     // GIR_Coverage, 4022,
     /* 285181 */     GIR_EraseRootFromParent_Done,
     /* 285182 */   // Label 5544: @285182
     /* 285182 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(285250), // Rule ID 3940 //
     /* 285187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285206 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 285206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 285213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285218 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 285221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285225 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 285228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 285233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 285241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285248 */     GIR_RootConstrainSelectedInstOperands,
     /* 285249 */     // GIR_Coverage, 3940,
     /* 285249 */     GIR_EraseRootFromParent_Done,
     /* 285250 */   // Label 5545: @285250
     /* 285250 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(285318), // Rule ID 3941 //
     /* 285255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285274 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 285274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 285281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 285289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285293 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 285296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 285301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 285309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285316 */     GIR_RootConstrainSelectedInstOperands,
     /* 285317 */     // GIR_Coverage, 3941,
     /* 285317 */     GIR_EraseRootFromParent_Done,
     /* 285318 */   // Label 5546: @285318
     /* 285318 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(285334), // Rule ID 121 //
     /* 285323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285327 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 285327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 285332 */     GIR_RootConstrainSelectedInstOperands,
     /* 285333 */     // GIR_Coverage, 121,
     /* 285333 */     GIR_Done,
     /* 285334 */   // Label 5547: @285334
     /* 285334 */   GIM_Reject,
     /* 285335 */ // Label 5543: @285335
     /* 285335 */ GIM_Reject,
     /* 285336 */ // Label 5536: @285336
     /* 285336 */ GIM_Reject,
     /* 285337 */ // Label 48: @285337
     /* 285337 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5550*/ GIMT_Encode4(286161),
     /* 285348 */ /*GILLT_s32*//*Label 5548*/ GIMT_Encode4(285356),
     /* 285352 */ /*GILLT_s64*//*Label 5549*/ GIMT_Encode4(285711),
     /* 285356 */ // Label 5548: @285356
     /* 285356 */ GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(285710),
     /* 285361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 285364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285371 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(285435), // Rule ID 6549 //
     /* 285376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 285384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285393 */     // MIs[1] Operand 2
     /* 285393 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 285404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285412 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 285416 */     // MIs[2] Operand 1
     /* 285416 */     // No operand predicates
     /* 285416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285418 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 285418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 285421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 285430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 285433 */     GIR_RootConstrainSelectedInstOperands,
     /* 285434 */     // GIR_Coverage, 6549,
     /* 285434 */     GIR_EraseRootFromParent_Done,
     /* 285435 */   // Label 5552: @285435
     /* 285435 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(285499), // Rule ID 6551 //
     /* 285440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 285448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285457 */     // MIs[1] Operand 2
     /* 285457 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 285468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285476 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 285480 */     // MIs[2] Operand 1
     /* 285480 */     // No operand predicates
     /* 285480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285482 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 285482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 285485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 285494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 285497 */     GIR_RootConstrainSelectedInstOperands,
     /* 285498 */     // GIR_Coverage, 6551,
     /* 285498 */     GIR_EraseRootFromParent_Done,
     /* 285499 */   // Label 5553: @285499
     /* 285499 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(285537), // Rule ID 4019 //
     /* 285504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 285520 */     // MIs[1] Operand 1
     /* 285520 */     // No operand predicates
     /* 285520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285522 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 285522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 285525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 285532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 285535 */     GIR_RootConstrainSelectedInstOperands,
     /* 285536 */     // GIR_Coverage, 4019,
     /* 285536 */     GIR_EraseRootFromParent_Done,
     /* 285537 */   // Label 5554: @285537
     /* 285537 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(285578), // Rule ID 2435 //
     /* 285542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 285554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285565 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 285568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285576 */     GIR_RootConstrainSelectedInstOperands,
     /* 285577 */     // GIR_Coverage, 2435,
     /* 285577 */     GIR_EraseRootFromParent_Done,
     /* 285578 */   // Label 5555: @285578
     /* 285578 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(285619), // Rule ID 2436 //
     /* 285583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285606 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 285609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285617 */     GIR_RootConstrainSelectedInstOperands,
     /* 285618 */     // GIR_Coverage, 2436,
     /* 285618 */     GIR_EraseRootFromParent_Done,
     /* 285619 */   // Label 5556: @285619
     /* 285619 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(285660), // Rule ID 2434 //
     /* 285624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285647 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 285650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285658 */     GIR_RootConstrainSelectedInstOperands,
     /* 285659 */     // GIR_Coverage, 2434,
     /* 285659 */     GIR_EraseRootFromParent_Done,
     /* 285660 */   // Label 5557: @285660
     /* 285660 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(285709), // Rule ID 2433 //
     /* 285665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285669 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 285669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285681 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 285687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 285700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285707 */     GIR_RootConstrainSelectedInstOperands,
     /* 285708 */     // GIR_Coverage, 2433,
     /* 285708 */     GIR_EraseRootFromParent_Done,
     /* 285709 */   // Label 5558: @285709
     /* 285709 */   GIM_Reject,
     /* 285710 */ // Label 5551: @285710
     /* 285710 */ GIM_Reject,
     /* 285711 */ // Label 5549: @285711
     /* 285711 */ GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(286160),
     /* 285716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285726 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(285790), // Rule ID 6550 //
     /* 285731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 285739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 285743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285748 */     // MIs[1] Operand 2
     /* 285748 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 285759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285767 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 285771 */     // MIs[2] Operand 1
     /* 285771 */     // No operand predicates
     /* 285771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285773 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 285773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 285776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 285785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 285788 */     GIR_RootConstrainSelectedInstOperands,
     /* 285789 */     // GIR_Coverage, 6550,
     /* 285789 */     GIR_EraseRootFromParent_Done,
     /* 285790 */   // Label 5560: @285790
     /* 285790 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(285854), // Rule ID 6552 //
     /* 285795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 285803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 285807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285812 */     // MIs[1] Operand 2
     /* 285812 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 285823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285831 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 285835 */     // MIs[2] Operand 1
     /* 285835 */     // No operand predicates
     /* 285835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285837 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 285837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 285840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 285849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 285852 */     GIR_RootConstrainSelectedInstOperands,
     /* 285853 */     // GIR_Coverage, 6552,
     /* 285853 */     GIR_EraseRootFromParent_Done,
     /* 285854 */   // Label 5561: @285854
     /* 285854 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(285957), // Rule ID 6553 //
     /* 285859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 285888 */     // MIs[2] Operand 1
     /* 285888 */     // No operand predicates
     /* 285888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285890 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 285890 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 285893 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285897 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285916 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 285919 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285923 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 285926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 285931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 285936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 285944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 285952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 285955 */     GIR_RootConstrainSelectedInstOperands,
     /* 285956 */     // GIR_Coverage, 6553,
     /* 285956 */     GIR_EraseRootFromParent_Done,
     /* 285957 */   // Label 5562: @285957
     /* 285957 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(285995), // Rule ID 4020 //
     /* 285962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 285978 */     // MIs[1] Operand 1
     /* 285978 */     // No operand predicates
     /* 285978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285980 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 285980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 285983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 285990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 285993 */     GIR_RootConstrainSelectedInstOperands,
     /* 285994 */     // GIR_Coverage, 4020,
     /* 285994 */     GIR_EraseRootFromParent_Done,
     /* 285995 */   // Label 5563: @285995
     /* 285995 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(286067), // Rule ID 2437 //
     /* 286000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286023 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 286058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286065 */     GIR_RootConstrainSelectedInstOperands,
     /* 286066 */     // GIR_Coverage, 2437,
     /* 286066 */     GIR_EraseRootFromParent_Done,
     /* 286067 */   // Label 5564: @286067
     /* 286067 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(286139), // Rule ID 2438 //
     /* 286072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286095 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286107 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 286130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286137 */     GIR_RootConstrainSelectedInstOperands,
     /* 286138 */     // GIR_Coverage, 2438,
     /* 286138 */     GIR_EraseRootFromParent_Done,
     /* 286139 */   // Label 5565: @286139
     /* 286139 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(286159), // Rule ID 119 //
     /* 286144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286152 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 286152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 286157 */     GIR_RootConstrainSelectedInstOperands,
     /* 286158 */     // GIR_Coverage, 119,
     /* 286158 */     GIR_Done,
     /* 286159 */   // Label 5566: @286159
     /* 286159 */   GIM_Reject,
     /* 286160 */ // Label 5559: @286160
     /* 286160 */ GIM_Reject,
     /* 286161 */ // Label 5550: @286161
     /* 286161 */ GIM_Reject,
     /* 286162 */ // Label 49: @286162
     /* 286162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5569*/ GIMT_Encode4(286291),
     /* 286173 */ /*GILLT_s32*//*Label 5567*/ GIMT_Encode4(286181),
     /* 286177 */ /*GILLT_s64*//*Label 5568*/ GIMT_Encode4(286236),
     /* 286181 */ // Label 5567: @286181
     /* 286181 */ GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(286235), // Rule ID 188 //
     /* 286186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 286192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 286195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286207 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 286211 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286215 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286219 */   // MIs[1] Operand 1
     /* 286219 */   // No operand predicates
     /* 286219 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286221 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 286221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 286224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286226 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286228 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 286230 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286233 */   GIR_RootConstrainSelectedInstOperands,
     /* 286234 */   // GIR_Coverage, 188,
     /* 286234 */   GIR_EraseRootFromParent_Done,
     /* 286235 */ // Label 5570: @286235
     /* 286235 */ GIM_Reject,
     /* 286236 */ // Label 5568: @286236
     /* 286236 */ GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(286290), // Rule ID 189 //
     /* 286241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286247 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 286250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286262 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 286266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286270 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 286274 */   // MIs[1] Operand 1
     /* 286274 */   // No operand predicates
     /* 286274 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286276 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 286276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 286279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286281 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286283 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 286285 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286288 */   GIR_RootConstrainSelectedInstOperands,
     /* 286289 */   // GIR_Coverage, 189,
     /* 286289 */   GIR_EraseRootFromParent_Done,
     /* 286290 */ // Label 5571: @286290
     /* 286290 */ GIM_Reject,
     /* 286291 */ // Label 5569: @286291
     /* 286291 */ GIM_Reject,
     /* 286292 */ // Label 50: @286292
     /* 286292 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5574*/ GIMT_Encode4(286833),
     /* 286303 */ /*GILLT_s32*//*Label 5572*/ GIMT_Encode4(286311),
     /* 286307 */ /*GILLT_s64*//*Label 5573*/ GIMT_Encode4(286576),
     /* 286311 */ // Label 5572: @286311
     /* 286311 */ GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(286575),
     /* 286316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286326 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(286365), // Rule ID 184 //
     /* 286331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 286352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286354 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 286354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 286357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286363 */     GIR_RootConstrainSelectedInstOperands,
     /* 286364 */     // GIR_Coverage, 184,
     /* 286364 */     GIR_EraseRootFromParent_Done,
     /* 286365 */   // Label 5576: @286365
     /* 286365 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(286402), // Rule ID 4015 //
     /* 286370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286386 */     // MIs[1] Operand 1
     /* 286386 */     // No operand predicates
     /* 286386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286388 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 286388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 286391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286400 */     GIR_RootConstrainSelectedInstOperands,
     /* 286401 */     // GIR_Coverage, 4015,
     /* 286401 */     GIR_EraseRootFromParent_Done,
     /* 286402 */   // Label 5577: @286402
     /* 286402 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(286443), // Rule ID 3944 //
     /* 286407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 286419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286430 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 286433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286441 */     GIR_RootConstrainSelectedInstOperands,
     /* 286442 */     // GIR_Coverage, 3944,
     /* 286442 */     GIR_EraseRootFromParent_Done,
     /* 286443 */   // Label 5578: @286443
     /* 286443 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(286484), // Rule ID 3945 //
     /* 286448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286471 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 286474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286482 */     GIR_RootConstrainSelectedInstOperands,
     /* 286483 */     // GIR_Coverage, 3945,
     /* 286483 */     GIR_EraseRootFromParent_Done,
     /* 286484 */   // Label 5579: @286484
     /* 286484 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(286525), // Rule ID 3943 //
     /* 286489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286512 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 286515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286523 */     GIR_RootConstrainSelectedInstOperands,
     /* 286524 */     // GIR_Coverage, 3943,
     /* 286524 */     GIR_EraseRootFromParent_Done,
     /* 286525 */   // Label 5580: @286525
     /* 286525 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(286574), // Rule ID 3942 //
     /* 286530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286534 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 286534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286546 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 286552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 286565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286572 */     GIR_RootConstrainSelectedInstOperands,
     /* 286573 */     // GIR_Coverage, 3942,
     /* 286573 */     GIR_EraseRootFromParent_Done,
     /* 286574 */   // Label 5581: @286574
     /* 286574 */   GIM_Reject,
     /* 286575 */ // Label 5575: @286575
     /* 286575 */ GIM_Reject,
     /* 286576 */ // Label 5573: @286576
     /* 286576 */ GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(286832),
     /* 286581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286591 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(286630), // Rule ID 187 //
     /* 286596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 286617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286619 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 286619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 286622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286628 */     GIR_RootConstrainSelectedInstOperands,
     /* 286629 */     // GIR_Coverage, 187,
     /* 286629 */     GIR_EraseRootFromParent_Done,
     /* 286630 */   // Label 5583: @286630
     /* 286630 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(286667), // Rule ID 4016 //
     /* 286635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 286651 */     // MIs[1] Operand 1
     /* 286651 */     // No operand predicates
     /* 286651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286653 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 286653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 286656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286665 */     GIR_RootConstrainSelectedInstOperands,
     /* 286666 */     // GIR_Coverage, 4016,
     /* 286666 */     GIR_EraseRootFromParent_Done,
     /* 286667 */   // Label 5584: @286667
     /* 286667 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(286739), // Rule ID 3946 //
     /* 286672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286695 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286707 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286714 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 286730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286737 */     GIR_RootConstrainSelectedInstOperands,
     /* 286738 */     // GIR_Coverage, 3946,
     /* 286738 */     GIR_EraseRootFromParent_Done,
     /* 286739 */   // Label 5585: @286739
     /* 286739 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(286811), // Rule ID 3947 //
     /* 286744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286767 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286779 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286786 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 286802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286809 */     GIR_RootConstrainSelectedInstOperands,
     /* 286810 */     // GIR_Coverage, 3947,
     /* 286810 */     GIR_EraseRootFromParent_Done,
     /* 286811 */   // Label 5586: @286811
     /* 286811 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(286831), // Rule ID 122 //
     /* 286816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286824 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 286824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 286829 */     GIR_RootConstrainSelectedInstOperands,
     /* 286830 */     // GIR_Coverage, 122,
     /* 286830 */     GIR_Done,
     /* 286831 */   // Label 5587: @286831
     /* 286831 */   GIM_Reject,
     /* 286832 */ // Label 5582: @286832
     /* 286832 */ GIM_Reject,
     /* 286833 */ // Label 5574: @286833
     /* 286833 */ GIM_Reject,
     /* 286834 */ // Label 51: @286834
     /* 286834 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5596*/ GIMT_Encode4(294610),
     /* 286845 */ /*GILLT_s64*//*Label 5588*/ GIMT_Encode4(286881), GIMT_Encode4(0),
     /* 286853 */ /*GILLT_v2s32*//*Label 5589*/ GIMT_Encode4(287274),
     /* 286857 */ /*GILLT_v2s64*//*Label 5590*/ GIMT_Encode4(288322),
     /* 286861 */ /*GILLT_v4s16*//*Label 5591*/ GIMT_Encode4(289370),
     /* 286865 */ /*GILLT_v4s32*//*Label 5592*/ GIMT_Encode4(290418),
     /* 286869 */ /*GILLT_v8s8*//*Label 5593*/ GIMT_Encode4(291466),
     /* 286873 */ /*GILLT_v8s16*//*Label 5594*/ GIMT_Encode4(292514),
     /* 286877 */ /*GILLT_v16s8*//*Label 5595*/ GIMT_Encode4(293562),
     /* 286881 */ // Label 5588: @286881
     /* 286881 */ GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(287273),
     /* 286886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286889 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 286892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286896 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(286932), // Rule ID 5254 //
     /* 286901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286904 */     // MIs[0] Operand 1
     /* 286904 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 286909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286913 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 286919 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 286921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286923 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 286923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 286926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 286930 */     GIR_RootConstrainSelectedInstOperands,
     /* 286931 */     // GIR_Coverage, 5254,
     /* 286931 */     GIR_EraseRootFromParent_Done,
     /* 286932 */   // Label 5598: @286932
     /* 286932 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(286968), // Rule ID 5255 //
     /* 286937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286940 */     // MIs[0] Operand 1
     /* 286940 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 286945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286949 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 286955 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 286957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286959 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 286959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 286962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 286966 */     GIR_RootConstrainSelectedInstOperands,
     /* 286967 */     // GIR_Coverage, 5255,
     /* 286967 */     GIR_EraseRootFromParent_Done,
     /* 286968 */   // Label 5599: @286968
     /* 286968 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(287004), // Rule ID 2505 //
     /* 286973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286976 */     // MIs[0] Operand 1
     /* 286976 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 286981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 286985 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 286991 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 286993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286995 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 286995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 286998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287002 */     GIR_RootConstrainSelectedInstOperands,
     /* 287003 */     // GIR_Coverage, 2505,
     /* 287003 */     GIR_EraseRootFromParent_Done,
     /* 287004 */   // Label 5600: @287004
     /* 287004 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(287040), // Rule ID 5251 //
     /* 287009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287012 */     // MIs[0] Operand 1
     /* 287012 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287021 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287027 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287031 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 287031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 287034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287038 */     GIR_RootConstrainSelectedInstOperands,
     /* 287039 */     // GIR_Coverage, 5251,
     /* 287039 */     GIR_EraseRootFromParent_Done,
     /* 287040 */   // Label 5601: @287040
     /* 287040 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(287076), // Rule ID 5252 //
     /* 287045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287048 */     // MIs[0] Operand 1
     /* 287048 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287057 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287063 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 287065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287067 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 287067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 287070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287074 */     GIR_RootConstrainSelectedInstOperands,
     /* 287075 */     // GIR_Coverage, 5252,
     /* 287075 */     GIR_EraseRootFromParent_Done,
     /* 287076 */   // Label 5602: @287076
     /* 287076 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(287112), // Rule ID 5253 //
     /* 287081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287084 */     // MIs[0] Operand 1
     /* 287084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287103 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 287103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 287106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287110 */     GIR_RootConstrainSelectedInstOperands,
     /* 287111 */     // GIR_Coverage, 5253,
     /* 287111 */     GIR_EraseRootFromParent_Done,
     /* 287112 */   // Label 5603: @287112
     /* 287112 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(287144), // Rule ID 1608 //
     /* 287117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287120 */     // MIs[0] Operand 1
     /* 287120 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 287125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287133 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 287133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 287136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287142 */     GIR_RootConstrainSelectedInstOperands,
     /* 287143 */     // GIR_Coverage, 1608,
     /* 287143 */     GIR_EraseRootFromParent_Done,
     /* 287144 */   // Label 5604: @287144
     /* 287144 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(287176), // Rule ID 1609 //
     /* 287149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287152 */     // MIs[0] Operand 1
     /* 287152 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287165 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 287165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 287168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287174 */     GIR_RootConstrainSelectedInstOperands,
     /* 287175 */     // GIR_Coverage, 1609,
     /* 287175 */     GIR_EraseRootFromParent_Done,
     /* 287176 */   // Label 5605: @287176
     /* 287176 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(287208), // Rule ID 1610 //
     /* 287181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287184 */     // MIs[0] Operand 1
     /* 287184 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287197 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 287197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 287200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287206 */     GIR_RootConstrainSelectedInstOperands,
     /* 287207 */     // GIR_Coverage, 1610,
     /* 287207 */     GIR_EraseRootFromParent_Done,
     /* 287208 */   // Label 5606: @287208
     /* 287208 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(287240), // Rule ID 1611 //
     /* 287213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287216 */     // MIs[0] Operand 1
     /* 287216 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 287221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287229 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 287229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 287232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287238 */     GIR_RootConstrainSelectedInstOperands,
     /* 287239 */     // GIR_Coverage, 1611,
     /* 287239 */     GIR_EraseRootFromParent_Done,
     /* 287240 */   // Label 5607: @287240
     /* 287240 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(287272), // Rule ID 1612 //
     /* 287245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287248 */     // MIs[0] Operand 1
     /* 287248 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 287253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287261 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 287261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 287264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287270 */     GIR_RootConstrainSelectedInstOperands,
     /* 287271 */     // GIR_Coverage, 1612,
     /* 287271 */     GIR_EraseRootFromParent_Done,
     /* 287272 */   // Label 5608: @287272
     /* 287272 */   GIM_Reject,
     /* 287273 */ // Label 5597: @287273
     /* 287273 */ GIM_Reject,
     /* 287274 */ // Label 5589: @287274
     /* 287274 */ GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(288321),
     /* 287279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 287285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287289 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(287329), // Rule ID 754 //
     /* 287294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287297 */     // MIs[0] Operand 1
     /* 287297 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287306 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287312 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287320 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 287323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287327 */     GIR_RootConstrainSelectedInstOperands,
     /* 287328 */     // GIR_Coverage, 754,
     /* 287328 */     GIR_EraseRootFromParent_Done,
     /* 287329 */   // Label 5610: @287329
     /* 287329 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(287369), // Rule ID 761 //
     /* 287334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287337 */     // MIs[0] Operand 1
     /* 287337 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287346 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287352 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287360 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 287363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287367 */     GIR_RootConstrainSelectedInstOperands,
     /* 287368 */     // GIR_Coverage, 761,
     /* 287368 */     GIR_EraseRootFromParent_Done,
     /* 287369 */   // Label 5611: @287369
     /* 287369 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(287406), // Rule ID 5188 //
     /* 287374 */     // MIs[0] Operand 1
     /* 287374 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 287379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287383 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287389 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287397 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 287400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287404 */     GIR_RootConstrainSelectedInstOperands,
     /* 287405 */     // GIR_Coverage, 5188,
     /* 287405 */     GIR_EraseRootFromParent_Done,
     /* 287406 */   // Label 5612: @287406
     /* 287406 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(287443), // Rule ID 5195 //
     /* 287411 */     // MIs[0] Operand 1
     /* 287411 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287420 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287426 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287434 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 287437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287441 */     GIR_RootConstrainSelectedInstOperands,
     /* 287442 */     // GIR_Coverage, 5195,
     /* 287442 */     GIR_EraseRootFromParent_Done,
     /* 287443 */   // Label 5613: @287443
     /* 287443 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(287480), // Rule ID 5202 //
     /* 287448 */     // MIs[0] Operand 1
     /* 287448 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287457 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287463 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287471 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 287474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287478 */     GIR_RootConstrainSelectedInstOperands,
     /* 287479 */     // GIR_Coverage, 5202,
     /* 287479 */     GIR_EraseRootFromParent_Done,
     /* 287480 */   // Label 5614: @287480
     /* 287480 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(287517), // Rule ID 5209 //
     /* 287485 */     // MIs[0] Operand 1
     /* 287485 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 287490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287494 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287500 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287508 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 287511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287515 */     GIR_RootConstrainSelectedInstOperands,
     /* 287516 */     // GIR_Coverage, 5209,
     /* 287516 */     GIR_EraseRootFromParent_Done,
     /* 287517 */   // Label 5615: @287517
     /* 287517 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(287554), // Rule ID 5216 //
     /* 287522 */     // MIs[0] Operand 1
     /* 287522 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 287527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287531 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287537 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287545 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 287548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287552 */     GIR_RootConstrainSelectedInstOperands,
     /* 287553 */     // GIR_Coverage, 5216,
     /* 287553 */     GIR_EraseRootFromParent_Done,
     /* 287554 */   // Label 5616: @287554
     /* 287554 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(287594), // Rule ID 726 //
     /* 287559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287562 */     // MIs[0] Operand 1
     /* 287562 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 287567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287575 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287581 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287585 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 287588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287592 */     GIR_RootConstrainSelectedInstOperands,
     /* 287593 */     // GIR_Coverage, 726,
     /* 287593 */     GIR_EraseRootFromParent_Done,
     /* 287594 */   // Label 5617: @287594
     /* 287594 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(287634), // Rule ID 737 //
     /* 287599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287602 */     // MIs[0] Operand 1
     /* 287602 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287615 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287621 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287625 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 287628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287632 */     GIR_RootConstrainSelectedInstOperands,
     /* 287633 */     // GIR_Coverage, 737,
     /* 287633 */     GIR_EraseRootFromParent_Done,
     /* 287634 */   // Label 5618: @287634
     /* 287634 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(287674), // Rule ID 738 //
     /* 287639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287642 */     // MIs[0] Operand 1
     /* 287642 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287655 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287661 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 287663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287665 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 287668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287672 */     GIR_RootConstrainSelectedInstOperands,
     /* 287673 */     // GIR_Coverage, 738,
     /* 287673 */     GIR_EraseRootFromParent_Done,
     /* 287674 */   // Label 5619: @287674
     /* 287674 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(287714), // Rule ID 747 //
     /* 287679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287682 */     // MIs[0] Operand 1
     /* 287682 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287695 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287701 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287705 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 287708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287712 */     GIR_RootConstrainSelectedInstOperands,
     /* 287713 */     // GIR_Coverage, 747,
     /* 287713 */     GIR_EraseRootFromParent_Done,
     /* 287714 */   // Label 5620: @287714
     /* 287714 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(287751), // Rule ID 5153 //
     /* 287719 */     // MIs[0] Operand 1
     /* 287719 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 287724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287732 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287738 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287742 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 287745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287749 */     GIR_RootConstrainSelectedInstOperands,
     /* 287750 */     // GIR_Coverage, 5153,
     /* 287750 */     GIR_EraseRootFromParent_Done,
     /* 287751 */   // Label 5621: @287751
     /* 287751 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(287788), // Rule ID 5160 //
     /* 287756 */     // MIs[0] Operand 1
     /* 287756 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287769 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287775 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287779 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 287782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287786 */     GIR_RootConstrainSelectedInstOperands,
     /* 287787 */     // GIR_Coverage, 5160,
     /* 287787 */     GIR_EraseRootFromParent_Done,
     /* 287788 */   // Label 5622: @287788
     /* 287788 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(287825), // Rule ID 5167 //
     /* 287793 */     // MIs[0] Operand 1
     /* 287793 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287806 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287812 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287816 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 287819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287823 */     GIR_RootConstrainSelectedInstOperands,
     /* 287824 */     // GIR_Coverage, 5167,
     /* 287824 */     GIR_EraseRootFromParent_Done,
     /* 287825 */   // Label 5623: @287825
     /* 287825 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(287862), // Rule ID 5174 //
     /* 287830 */     // MIs[0] Operand 1
     /* 287830 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 287835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287843 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287849 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287853 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 287856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287860 */     GIR_RootConstrainSelectedInstOperands,
     /* 287861 */     // GIR_Coverage, 5174,
     /* 287861 */     GIR_EraseRootFromParent_Done,
     /* 287862 */   // Label 5624: @287862
     /* 287862 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(287899), // Rule ID 5181 //
     /* 287867 */     // MIs[0] Operand 1
     /* 287867 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 287872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287880 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287886 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287890 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 287893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287897 */     GIR_RootConstrainSelectedInstOperands,
     /* 287898 */     // GIR_Coverage, 5181,
     /* 287898 */     GIR_EraseRootFromParent_Done,
     /* 287899 */   // Label 5625: @287899
     /* 287899 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(287931), // Rule ID 1125 //
     /* 287904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287907 */     // MIs[0] Operand 1
     /* 287907 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 287912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287920 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 287920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 287923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287929 */     GIR_RootConstrainSelectedInstOperands,
     /* 287930 */     // GIR_Coverage, 1125,
     /* 287930 */     GIR_EraseRootFromParent_Done,
     /* 287931 */   // Label 5626: @287931
     /* 287931 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(287963), // Rule ID 1132 //
     /* 287936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287939 */     // MIs[0] Operand 1
     /* 287939 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287952 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 287952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 287955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287961 */     GIR_RootConstrainSelectedInstOperands,
     /* 287962 */     // GIR_Coverage, 1132,
     /* 287962 */     GIR_EraseRootFromParent_Done,
     /* 287963 */   // Label 5627: @287963
     /* 287963 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(287995), // Rule ID 1139 //
     /* 287968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287971 */     // MIs[0] Operand 1
     /* 287971 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287984 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 287984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 287987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287993 */     GIR_RootConstrainSelectedInstOperands,
     /* 287994 */     // GIR_Coverage, 1139,
     /* 287994 */     GIR_EraseRootFromParent_Done,
     /* 287995 */   // Label 5628: @287995
     /* 287995 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(288027), // Rule ID 1146 //
     /* 288000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288003 */     // MIs[0] Operand 1
     /* 288003 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 288008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288016 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 288019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288025 */     GIR_RootConstrainSelectedInstOperands,
     /* 288026 */     // GIR_Coverage, 1146,
     /* 288026 */     GIR_EraseRootFromParent_Done,
     /* 288027 */   // Label 5629: @288027
     /* 288027 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(288059), // Rule ID 1153 //
     /* 288032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288035 */     // MIs[0] Operand 1
     /* 288035 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 288040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288048 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 288051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288057 */     GIR_RootConstrainSelectedInstOperands,
     /* 288058 */     // GIR_Coverage, 1153,
     /* 288058 */     GIR_EraseRootFromParent_Done,
     /* 288059 */   // Label 5630: @288059
     /* 288059 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(288088), // Rule ID 5090 //
     /* 288064 */     // MIs[0] Operand 1
     /* 288064 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288077 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 288080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288086 */     GIR_RootConstrainSelectedInstOperands,
     /* 288087 */     // GIR_Coverage, 5090,
     /* 288087 */     GIR_EraseRootFromParent_Done,
     /* 288088 */   // Label 5631: @288088
     /* 288088 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(288117), // Rule ID 5097 //
     /* 288093 */     // MIs[0] Operand 1
     /* 288093 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288106 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 288109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288115 */     GIR_RootConstrainSelectedInstOperands,
     /* 288116 */     // GIR_Coverage, 5097,
     /* 288116 */     GIR_EraseRootFromParent_Done,
     /* 288117 */   // Label 5632: @288117
     /* 288117 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(288146), // Rule ID 5104 //
     /* 288122 */     // MIs[0] Operand 1
     /* 288122 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288135 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 288138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288144 */     GIR_RootConstrainSelectedInstOperands,
     /* 288145 */     // GIR_Coverage, 5104,
     /* 288145 */     GIR_EraseRootFromParent_Done,
     /* 288146 */   // Label 5633: @288146
     /* 288146 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(288175), // Rule ID 5111 //
     /* 288151 */     // MIs[0] Operand 1
     /* 288151 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 288156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288164 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 288167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288173 */     GIR_RootConstrainSelectedInstOperands,
     /* 288174 */     // GIR_Coverage, 5111,
     /* 288174 */     GIR_EraseRootFromParent_Done,
     /* 288175 */   // Label 5634: @288175
     /* 288175 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(288204), // Rule ID 5118 //
     /* 288180 */     // MIs[0] Operand 1
     /* 288180 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 288185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288193 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 288196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288202 */     GIR_RootConstrainSelectedInstOperands,
     /* 288203 */     // GIR_Coverage, 5118,
     /* 288203 */     GIR_EraseRootFromParent_Done,
     /* 288204 */   // Label 5635: @288204
     /* 288204 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(288233), // Rule ID 5125 //
     /* 288209 */     // MIs[0] Operand 1
     /* 288209 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 288214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288222 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 288222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 288225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288231 */     GIR_RootConstrainSelectedInstOperands,
     /* 288232 */     // GIR_Coverage, 5125,
     /* 288232 */     GIR_EraseRootFromParent_Done,
     /* 288233 */   // Label 5636: @288233
     /* 288233 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(288262), // Rule ID 5132 //
     /* 288238 */     // MIs[0] Operand 1
     /* 288238 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 288243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288251 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 288251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 288254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288260 */     GIR_RootConstrainSelectedInstOperands,
     /* 288261 */     // GIR_Coverage, 5132,
     /* 288261 */     GIR_EraseRootFromParent_Done,
     /* 288262 */   // Label 5637: @288262
     /* 288262 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(288291), // Rule ID 5139 //
     /* 288267 */     // MIs[0] Operand 1
     /* 288267 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 288272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288280 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 288280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 288283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288289 */     GIR_RootConstrainSelectedInstOperands,
     /* 288290 */     // GIR_Coverage, 5139,
     /* 288290 */     GIR_EraseRootFromParent_Done,
     /* 288291 */   // Label 5638: @288291
     /* 288291 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(288320), // Rule ID 5146 //
     /* 288296 */     // MIs[0] Operand 1
     /* 288296 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 288301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288309 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 288309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 288312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288318 */     GIR_RootConstrainSelectedInstOperands,
     /* 288319 */     // GIR_Coverage, 5146,
     /* 288319 */     GIR_EraseRootFromParent_Done,
     /* 288320 */   // Label 5639: @288320
     /* 288320 */   GIM_Reject,
     /* 288321 */ // Label 5609: @288321
     /* 288321 */ GIM_Reject,
     /* 288322 */ // Label 5590: @288322
     /* 288322 */ GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(289369),
     /* 288327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 288330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 288333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288337 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(288377), // Rule ID 756 //
     /* 288342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288345 */     // MIs[0] Operand 1
     /* 288345 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288354 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288360 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288368 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 288371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288375 */     GIR_RootConstrainSelectedInstOperands,
     /* 288376 */     // GIR_Coverage, 756,
     /* 288376 */     GIR_EraseRootFromParent_Done,
     /* 288377 */   // Label 5641: @288377
     /* 288377 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(288417), // Rule ID 763 //
     /* 288382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288385 */     // MIs[0] Operand 1
     /* 288385 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288394 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288400 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288408 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 288411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288415 */     GIR_RootConstrainSelectedInstOperands,
     /* 288416 */     // GIR_Coverage, 763,
     /* 288416 */     GIR_EraseRootFromParent_Done,
     /* 288417 */   // Label 5642: @288417
     /* 288417 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(288454), // Rule ID 5190 //
     /* 288422 */     // MIs[0] Operand 1
     /* 288422 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288431 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288437 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288445 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 288448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288452 */     GIR_RootConstrainSelectedInstOperands,
     /* 288453 */     // GIR_Coverage, 5190,
     /* 288453 */     GIR_EraseRootFromParent_Done,
     /* 288454 */   // Label 5643: @288454
     /* 288454 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(288491), // Rule ID 5197 //
     /* 288459 */     // MIs[0] Operand 1
     /* 288459 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288468 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288474 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288482 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 288485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288489 */     GIR_RootConstrainSelectedInstOperands,
     /* 288490 */     // GIR_Coverage, 5197,
     /* 288490 */     GIR_EraseRootFromParent_Done,
     /* 288491 */   // Label 5644: @288491
     /* 288491 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(288528), // Rule ID 5204 //
     /* 288496 */     // MIs[0] Operand 1
     /* 288496 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288505 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288511 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288519 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 288522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288526 */     GIR_RootConstrainSelectedInstOperands,
     /* 288527 */     // GIR_Coverage, 5204,
     /* 288527 */     GIR_EraseRootFromParent_Done,
     /* 288528 */   // Label 5645: @288528
     /* 288528 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(288565), // Rule ID 5211 //
     /* 288533 */     // MIs[0] Operand 1
     /* 288533 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 288538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288542 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288548 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288556 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 288559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288563 */     GIR_RootConstrainSelectedInstOperands,
     /* 288564 */     // GIR_Coverage, 5211,
     /* 288564 */     GIR_EraseRootFromParent_Done,
     /* 288565 */   // Label 5646: @288565
     /* 288565 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(288602), // Rule ID 5218 //
     /* 288570 */     // MIs[0] Operand 1
     /* 288570 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 288575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288579 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288585 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288593 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 288596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288600 */     GIR_RootConstrainSelectedInstOperands,
     /* 288601 */     // GIR_Coverage, 5218,
     /* 288601 */     GIR_EraseRootFromParent_Done,
     /* 288602 */   // Label 5647: @288602
     /* 288602 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(288642), // Rule ID 728 //
     /* 288607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288610 */     // MIs[0] Operand 1
     /* 288610 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288623 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288629 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288633 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 288636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288640 */     GIR_RootConstrainSelectedInstOperands,
     /* 288641 */     // GIR_Coverage, 728,
     /* 288641 */     GIR_EraseRootFromParent_Done,
     /* 288642 */   // Label 5648: @288642
     /* 288642 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(288682), // Rule ID 741 //
     /* 288647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288650 */     // MIs[0] Operand 1
     /* 288650 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288663 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288669 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288673 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 288676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288680 */     GIR_RootConstrainSelectedInstOperands,
     /* 288681 */     // GIR_Coverage, 741,
     /* 288681 */     GIR_EraseRootFromParent_Done,
     /* 288682 */   // Label 5649: @288682
     /* 288682 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(288722), // Rule ID 742 //
     /* 288687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288690 */     // MIs[0] Operand 1
     /* 288690 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288709 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 288711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288713 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 288716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288720 */     GIR_RootConstrainSelectedInstOperands,
     /* 288721 */     // GIR_Coverage, 742,
     /* 288721 */     GIR_EraseRootFromParent_Done,
     /* 288722 */   // Label 5650: @288722
     /* 288722 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(288762), // Rule ID 749 //
     /* 288727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288730 */     // MIs[0] Operand 1
     /* 288730 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288743 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288749 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288753 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 288756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288760 */     GIR_RootConstrainSelectedInstOperands,
     /* 288761 */     // GIR_Coverage, 749,
     /* 288761 */     GIR_EraseRootFromParent_Done,
     /* 288762 */   // Label 5651: @288762
     /* 288762 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(288799), // Rule ID 5155 //
     /* 288767 */     // MIs[0] Operand 1
     /* 288767 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288780 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288786 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288790 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 288793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288797 */     GIR_RootConstrainSelectedInstOperands,
     /* 288798 */     // GIR_Coverage, 5155,
     /* 288798 */     GIR_EraseRootFromParent_Done,
     /* 288799 */   // Label 5652: @288799
     /* 288799 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(288836), // Rule ID 5162 //
     /* 288804 */     // MIs[0] Operand 1
     /* 288804 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288817 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288823 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288827 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 288830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288834 */     GIR_RootConstrainSelectedInstOperands,
     /* 288835 */     // GIR_Coverage, 5162,
     /* 288835 */     GIR_EraseRootFromParent_Done,
     /* 288836 */   // Label 5653: @288836
     /* 288836 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(288873), // Rule ID 5169 //
     /* 288841 */     // MIs[0] Operand 1
     /* 288841 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288854 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288860 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288864 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 288867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288871 */     GIR_RootConstrainSelectedInstOperands,
     /* 288872 */     // GIR_Coverage, 5169,
     /* 288872 */     GIR_EraseRootFromParent_Done,
     /* 288873 */   // Label 5654: @288873
     /* 288873 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(288910), // Rule ID 5176 //
     /* 288878 */     // MIs[0] Operand 1
     /* 288878 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 288883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288891 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288897 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288901 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 288904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288908 */     GIR_RootConstrainSelectedInstOperands,
     /* 288909 */     // GIR_Coverage, 5176,
     /* 288909 */     GIR_EraseRootFromParent_Done,
     /* 288910 */   // Label 5655: @288910
     /* 288910 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(288947), // Rule ID 5183 //
     /* 288915 */     // MIs[0] Operand 1
     /* 288915 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 288920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288928 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288934 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288938 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 288941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288945 */     GIR_RootConstrainSelectedInstOperands,
     /* 288946 */     // GIR_Coverage, 5183,
     /* 288946 */     GIR_EraseRootFromParent_Done,
     /* 288947 */   // Label 5656: @288947
     /* 288947 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(288979), // Rule ID 1127 //
     /* 288952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288955 */     // MIs[0] Operand 1
     /* 288955 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288968 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 288968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 288971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288977 */     GIR_RootConstrainSelectedInstOperands,
     /* 288978 */     // GIR_Coverage, 1127,
     /* 288978 */     GIR_EraseRootFromParent_Done,
     /* 288979 */   // Label 5657: @288979
     /* 288979 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(289011), // Rule ID 1134 //
     /* 288984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288987 */     // MIs[0] Operand 1
     /* 288987 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289000 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 289003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289009 */     GIR_RootConstrainSelectedInstOperands,
     /* 289010 */     // GIR_Coverage, 1134,
     /* 289010 */     GIR_EraseRootFromParent_Done,
     /* 289011 */   // Label 5658: @289011
     /* 289011 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(289043), // Rule ID 1141 //
     /* 289016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289019 */     // MIs[0] Operand 1
     /* 289019 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289032 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 289035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289041 */     GIR_RootConstrainSelectedInstOperands,
     /* 289042 */     // GIR_Coverage, 1141,
     /* 289042 */     GIR_EraseRootFromParent_Done,
     /* 289043 */   // Label 5659: @289043
     /* 289043 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(289075), // Rule ID 1148 //
     /* 289048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289051 */     // MIs[0] Operand 1
     /* 289051 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289064 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 289067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289073 */     GIR_RootConstrainSelectedInstOperands,
     /* 289074 */     // GIR_Coverage, 1148,
     /* 289074 */     GIR_EraseRootFromParent_Done,
     /* 289075 */   // Label 5660: @289075
     /* 289075 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(289107), // Rule ID 1155 //
     /* 289080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289083 */     // MIs[0] Operand 1
     /* 289083 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289096 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 289099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289105 */     GIR_RootConstrainSelectedInstOperands,
     /* 289106 */     // GIR_Coverage, 1155,
     /* 289106 */     GIR_EraseRootFromParent_Done,
     /* 289107 */   // Label 5661: @289107
     /* 289107 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(289136), // Rule ID 5092 //
     /* 289112 */     // MIs[0] Operand 1
     /* 289112 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289125 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 289128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289134 */     GIR_RootConstrainSelectedInstOperands,
     /* 289135 */     // GIR_Coverage, 5092,
     /* 289135 */     GIR_EraseRootFromParent_Done,
     /* 289136 */   // Label 5662: @289136
     /* 289136 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(289165), // Rule ID 5099 //
     /* 289141 */     // MIs[0] Operand 1
     /* 289141 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289154 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 289157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289163 */     GIR_RootConstrainSelectedInstOperands,
     /* 289164 */     // GIR_Coverage, 5099,
     /* 289164 */     GIR_EraseRootFromParent_Done,
     /* 289165 */   // Label 5663: @289165
     /* 289165 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(289194), // Rule ID 5106 //
     /* 289170 */     // MIs[0] Operand 1
     /* 289170 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289183 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 289186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289192 */     GIR_RootConstrainSelectedInstOperands,
     /* 289193 */     // GIR_Coverage, 5106,
     /* 289193 */     GIR_EraseRootFromParent_Done,
     /* 289194 */   // Label 5664: @289194
     /* 289194 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(289223), // Rule ID 5113 //
     /* 289199 */     // MIs[0] Operand 1
     /* 289199 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289212 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 289215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289221 */     GIR_RootConstrainSelectedInstOperands,
     /* 289222 */     // GIR_Coverage, 5113,
     /* 289222 */     GIR_EraseRootFromParent_Done,
     /* 289223 */   // Label 5665: @289223
     /* 289223 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(289252), // Rule ID 5120 //
     /* 289228 */     // MIs[0] Operand 1
     /* 289228 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289241 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 289244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289250 */     GIR_RootConstrainSelectedInstOperands,
     /* 289251 */     // GIR_Coverage, 5120,
     /* 289251 */     GIR_EraseRootFromParent_Done,
     /* 289252 */   // Label 5666: @289252
     /* 289252 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(289281), // Rule ID 5127 //
     /* 289257 */     // MIs[0] Operand 1
     /* 289257 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289270 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 289270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 289273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289279 */     GIR_RootConstrainSelectedInstOperands,
     /* 289280 */     // GIR_Coverage, 5127,
     /* 289280 */     GIR_EraseRootFromParent_Done,
     /* 289281 */   // Label 5667: @289281
     /* 289281 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(289310), // Rule ID 5134 //
     /* 289286 */     // MIs[0] Operand 1
     /* 289286 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289299 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 289299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 289302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289308 */     GIR_RootConstrainSelectedInstOperands,
     /* 289309 */     // GIR_Coverage, 5134,
     /* 289309 */     GIR_EraseRootFromParent_Done,
     /* 289310 */   // Label 5668: @289310
     /* 289310 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(289339), // Rule ID 5141 //
     /* 289315 */     // MIs[0] Operand 1
     /* 289315 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 289320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289328 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 289328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 289331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289337 */     GIR_RootConstrainSelectedInstOperands,
     /* 289338 */     // GIR_Coverage, 5141,
     /* 289338 */     GIR_EraseRootFromParent_Done,
     /* 289339 */   // Label 5669: @289339
     /* 289339 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(289368), // Rule ID 5148 //
     /* 289344 */     // MIs[0] Operand 1
     /* 289344 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 289349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289357 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 289357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 289360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289366 */     GIR_RootConstrainSelectedInstOperands,
     /* 289367 */     // GIR_Coverage, 5148,
     /* 289367 */     GIR_EraseRootFromParent_Done,
     /* 289368 */   // Label 5670: @289368
     /* 289368 */   GIM_Reject,
     /* 289369 */ // Label 5640: @289369
     /* 289369 */ GIM_Reject,
     /* 289370 */ // Label 5591: @289370
     /* 289370 */ GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(290417),
     /* 289375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 289378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 289381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289385 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(289425), // Rule ID 752 //
     /* 289390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289393 */     // MIs[0] Operand 1
     /* 289393 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289402 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289408 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289416 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 289419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289423 */     GIR_RootConstrainSelectedInstOperands,
     /* 289424 */     // GIR_Coverage, 752,
     /* 289424 */     GIR_EraseRootFromParent_Done,
     /* 289425 */   // Label 5672: @289425
     /* 289425 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(289465), // Rule ID 759 //
     /* 289430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289433 */     // MIs[0] Operand 1
     /* 289433 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289442 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289448 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289456 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 289459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289463 */     GIR_RootConstrainSelectedInstOperands,
     /* 289464 */     // GIR_Coverage, 759,
     /* 289464 */     GIR_EraseRootFromParent_Done,
     /* 289465 */   // Label 5673: @289465
     /* 289465 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(289502), // Rule ID 5186 //
     /* 289470 */     // MIs[0] Operand 1
     /* 289470 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289479 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289485 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289493 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 289496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289500 */     GIR_RootConstrainSelectedInstOperands,
     /* 289501 */     // GIR_Coverage, 5186,
     /* 289501 */     GIR_EraseRootFromParent_Done,
     /* 289502 */   // Label 5674: @289502
     /* 289502 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(289539), // Rule ID 5193 //
     /* 289507 */     // MIs[0] Operand 1
     /* 289507 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289516 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289522 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289530 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 289533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289537 */     GIR_RootConstrainSelectedInstOperands,
     /* 289538 */     // GIR_Coverage, 5193,
     /* 289538 */     GIR_EraseRootFromParent_Done,
     /* 289539 */   // Label 5675: @289539
     /* 289539 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(289576), // Rule ID 5200 //
     /* 289544 */     // MIs[0] Operand 1
     /* 289544 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289553 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289559 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289567 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 289570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289574 */     GIR_RootConstrainSelectedInstOperands,
     /* 289575 */     // GIR_Coverage, 5200,
     /* 289575 */     GIR_EraseRootFromParent_Done,
     /* 289576 */   // Label 5676: @289576
     /* 289576 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(289613), // Rule ID 5207 //
     /* 289581 */     // MIs[0] Operand 1
     /* 289581 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289590 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289596 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289604 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 289607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289611 */     GIR_RootConstrainSelectedInstOperands,
     /* 289612 */     // GIR_Coverage, 5207,
     /* 289612 */     GIR_EraseRootFromParent_Done,
     /* 289613 */   // Label 5677: @289613
     /* 289613 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(289650), // Rule ID 5214 //
     /* 289618 */     // MIs[0] Operand 1
     /* 289618 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289627 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289633 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289641 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 289644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289648 */     GIR_RootConstrainSelectedInstOperands,
     /* 289649 */     // GIR_Coverage, 5214,
     /* 289649 */     GIR_EraseRootFromParent_Done,
     /* 289650 */   // Label 5678: @289650
     /* 289650 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(289690), // Rule ID 724 //
     /* 289655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289658 */     // MIs[0] Operand 1
     /* 289658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289677 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289681 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 289684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289688 */     GIR_RootConstrainSelectedInstOperands,
     /* 289689 */     // GIR_Coverage, 724,
     /* 289689 */     GIR_EraseRootFromParent_Done,
     /* 289690 */   // Label 5679: @289690
     /* 289690 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(289730), // Rule ID 733 //
     /* 289695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289698 */     // MIs[0] Operand 1
     /* 289698 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289721 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 289724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289728 */     GIR_RootConstrainSelectedInstOperands,
     /* 289729 */     // GIR_Coverage, 733,
     /* 289729 */     GIR_EraseRootFromParent_Done,
     /* 289730 */   // Label 5680: @289730
     /* 289730 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(289770), // Rule ID 734 //
     /* 289735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289738 */     // MIs[0] Operand 1
     /* 289738 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289751 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289757 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 289759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289761 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 289764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289768 */     GIR_RootConstrainSelectedInstOperands,
     /* 289769 */     // GIR_Coverage, 734,
     /* 289769 */     GIR_EraseRootFromParent_Done,
     /* 289770 */   // Label 5681: @289770
     /* 289770 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(289810), // Rule ID 745 //
     /* 289775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289778 */     // MIs[0] Operand 1
     /* 289778 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289791 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289797 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289801 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 289804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289808 */     GIR_RootConstrainSelectedInstOperands,
     /* 289809 */     // GIR_Coverage, 745,
     /* 289809 */     GIR_EraseRootFromParent_Done,
     /* 289810 */   // Label 5682: @289810
     /* 289810 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(289847), // Rule ID 5151 //
     /* 289815 */     // MIs[0] Operand 1
     /* 289815 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289828 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289834 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289838 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 289841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289845 */     GIR_RootConstrainSelectedInstOperands,
     /* 289846 */     // GIR_Coverage, 5151,
     /* 289846 */     GIR_EraseRootFromParent_Done,
     /* 289847 */   // Label 5683: @289847
     /* 289847 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(289884), // Rule ID 5158 //
     /* 289852 */     // MIs[0] Operand 1
     /* 289852 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289865 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289871 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289875 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 289878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289882 */     GIR_RootConstrainSelectedInstOperands,
     /* 289883 */     // GIR_Coverage, 5158,
     /* 289883 */     GIR_EraseRootFromParent_Done,
     /* 289884 */   // Label 5684: @289884
     /* 289884 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(289921), // Rule ID 5165 //
     /* 289889 */     // MIs[0] Operand 1
     /* 289889 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289902 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289908 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289912 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 289915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289919 */     GIR_RootConstrainSelectedInstOperands,
     /* 289920 */     // GIR_Coverage, 5165,
     /* 289920 */     GIR_EraseRootFromParent_Done,
     /* 289921 */   // Label 5685: @289921
     /* 289921 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(289958), // Rule ID 5172 //
     /* 289926 */     // MIs[0] Operand 1
     /* 289926 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289939 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289945 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289949 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 289952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289956 */     GIR_RootConstrainSelectedInstOperands,
     /* 289957 */     // GIR_Coverage, 5172,
     /* 289957 */     GIR_EraseRootFromParent_Done,
     /* 289958 */   // Label 5686: @289958
     /* 289958 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(289995), // Rule ID 5179 //
     /* 289963 */     // MIs[0] Operand 1
     /* 289963 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289976 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289982 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289986 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 289989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289993 */     GIR_RootConstrainSelectedInstOperands,
     /* 289994 */     // GIR_Coverage, 5179,
     /* 289994 */     GIR_EraseRootFromParent_Done,
     /* 289995 */   // Label 5687: @289995
     /* 289995 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(290027), // Rule ID 1123 //
     /* 290000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290003 */     // MIs[0] Operand 1
     /* 290003 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290016 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 290019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290025 */     GIR_RootConstrainSelectedInstOperands,
     /* 290026 */     // GIR_Coverage, 1123,
     /* 290026 */     GIR_EraseRootFromParent_Done,
     /* 290027 */   // Label 5688: @290027
     /* 290027 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(290059), // Rule ID 1130 //
     /* 290032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290035 */     // MIs[0] Operand 1
     /* 290035 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290048 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 290051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290057 */     GIR_RootConstrainSelectedInstOperands,
     /* 290058 */     // GIR_Coverage, 1130,
     /* 290058 */     GIR_EraseRootFromParent_Done,
     /* 290059 */   // Label 5689: @290059
     /* 290059 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(290091), // Rule ID 1137 //
     /* 290064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290067 */     // MIs[0] Operand 1
     /* 290067 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290080 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 290083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290089 */     GIR_RootConstrainSelectedInstOperands,
     /* 290090 */     // GIR_Coverage, 1137,
     /* 290090 */     GIR_EraseRootFromParent_Done,
     /* 290091 */   // Label 5690: @290091
     /* 290091 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(290123), // Rule ID 1144 //
     /* 290096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290099 */     // MIs[0] Operand 1
     /* 290099 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290112 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 290115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290121 */     GIR_RootConstrainSelectedInstOperands,
     /* 290122 */     // GIR_Coverage, 1144,
     /* 290122 */     GIR_EraseRootFromParent_Done,
     /* 290123 */   // Label 5691: @290123
     /* 290123 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(290155), // Rule ID 1151 //
     /* 290128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290131 */     // MIs[0] Operand 1
     /* 290131 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290144 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 290147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290153 */     GIR_RootConstrainSelectedInstOperands,
     /* 290154 */     // GIR_Coverage, 1151,
     /* 290154 */     GIR_EraseRootFromParent_Done,
     /* 290155 */   // Label 5692: @290155
     /* 290155 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(290184), // Rule ID 5088 //
     /* 290160 */     // MIs[0] Operand 1
     /* 290160 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290173 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 290176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290182 */     GIR_RootConstrainSelectedInstOperands,
     /* 290183 */     // GIR_Coverage, 5088,
     /* 290183 */     GIR_EraseRootFromParent_Done,
     /* 290184 */   // Label 5693: @290184
     /* 290184 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(290213), // Rule ID 5095 //
     /* 290189 */     // MIs[0] Operand 1
     /* 290189 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290202 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 290205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290211 */     GIR_RootConstrainSelectedInstOperands,
     /* 290212 */     // GIR_Coverage, 5095,
     /* 290212 */     GIR_EraseRootFromParent_Done,
     /* 290213 */   // Label 5694: @290213
     /* 290213 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(290242), // Rule ID 5102 //
     /* 290218 */     // MIs[0] Operand 1
     /* 290218 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290231 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 290234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290240 */     GIR_RootConstrainSelectedInstOperands,
     /* 290241 */     // GIR_Coverage, 5102,
     /* 290241 */     GIR_EraseRootFromParent_Done,
     /* 290242 */   // Label 5695: @290242
     /* 290242 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(290271), // Rule ID 5109 //
     /* 290247 */     // MIs[0] Operand 1
     /* 290247 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290260 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 290263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290269 */     GIR_RootConstrainSelectedInstOperands,
     /* 290270 */     // GIR_Coverage, 5109,
     /* 290270 */     GIR_EraseRootFromParent_Done,
     /* 290271 */   // Label 5696: @290271
     /* 290271 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(290300), // Rule ID 5116 //
     /* 290276 */     // MIs[0] Operand 1
     /* 290276 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290289 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 290292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290298 */     GIR_RootConstrainSelectedInstOperands,
     /* 290299 */     // GIR_Coverage, 5116,
     /* 290299 */     GIR_EraseRootFromParent_Done,
     /* 290300 */   // Label 5697: @290300
     /* 290300 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(290329), // Rule ID 5123 //
     /* 290305 */     // MIs[0] Operand 1
     /* 290305 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290318 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 290318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 290321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290327 */     GIR_RootConstrainSelectedInstOperands,
     /* 290328 */     // GIR_Coverage, 5123,
     /* 290328 */     GIR_EraseRootFromParent_Done,
     /* 290329 */   // Label 5698: @290329
     /* 290329 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(290358), // Rule ID 5130 //
     /* 290334 */     // MIs[0] Operand 1
     /* 290334 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290347 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 290347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 290350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290356 */     GIR_RootConstrainSelectedInstOperands,
     /* 290357 */     // GIR_Coverage, 5130,
     /* 290357 */     GIR_EraseRootFromParent_Done,
     /* 290358 */   // Label 5699: @290358
     /* 290358 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(290387), // Rule ID 5137 //
     /* 290363 */     // MIs[0] Operand 1
     /* 290363 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 290368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290376 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 290376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 290379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290385 */     GIR_RootConstrainSelectedInstOperands,
     /* 290386 */     // GIR_Coverage, 5137,
     /* 290386 */     GIR_EraseRootFromParent_Done,
     /* 290387 */   // Label 5700: @290387
     /* 290387 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(290416), // Rule ID 5144 //
     /* 290392 */     // MIs[0] Operand 1
     /* 290392 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 290397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290405 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 290405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 290408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290414 */     GIR_RootConstrainSelectedInstOperands,
     /* 290415 */     // GIR_Coverage, 5144,
     /* 290415 */     GIR_EraseRootFromParent_Done,
     /* 290416 */   // Label 5701: @290416
     /* 290416 */   GIM_Reject,
     /* 290417 */ // Label 5671: @290417
     /* 290417 */ GIM_Reject,
     /* 290418 */ // Label 5592: @290418
     /* 290418 */ GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(291465),
     /* 290423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 290426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 290429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290433 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(290473), // Rule ID 755 //
     /* 290438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290441 */     // MIs[0] Operand 1
     /* 290441 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290450 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290456 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290464 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 290467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290471 */     GIR_RootConstrainSelectedInstOperands,
     /* 290472 */     // GIR_Coverage, 755,
     /* 290472 */     GIR_EraseRootFromParent_Done,
     /* 290473 */   // Label 5703: @290473
     /* 290473 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(290513), // Rule ID 762 //
     /* 290478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290481 */     // MIs[0] Operand 1
     /* 290481 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290504 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 290507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290511 */     GIR_RootConstrainSelectedInstOperands,
     /* 290512 */     // GIR_Coverage, 762,
     /* 290512 */     GIR_EraseRootFromParent_Done,
     /* 290513 */   // Label 5704: @290513
     /* 290513 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(290550), // Rule ID 5189 //
     /* 290518 */     // MIs[0] Operand 1
     /* 290518 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290527 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290533 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290541 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 290544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290548 */     GIR_RootConstrainSelectedInstOperands,
     /* 290549 */     // GIR_Coverage, 5189,
     /* 290549 */     GIR_EraseRootFromParent_Done,
     /* 290550 */   // Label 5705: @290550
     /* 290550 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(290587), // Rule ID 5196 //
     /* 290555 */     // MIs[0] Operand 1
     /* 290555 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290564 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290570 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290578 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 290581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290585 */     GIR_RootConstrainSelectedInstOperands,
     /* 290586 */     // GIR_Coverage, 5196,
     /* 290586 */     GIR_EraseRootFromParent_Done,
     /* 290587 */   // Label 5706: @290587
     /* 290587 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(290624), // Rule ID 5203 //
     /* 290592 */     // MIs[0] Operand 1
     /* 290592 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290601 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290607 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290615 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 290618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290622 */     GIR_RootConstrainSelectedInstOperands,
     /* 290623 */     // GIR_Coverage, 5203,
     /* 290623 */     GIR_EraseRootFromParent_Done,
     /* 290624 */   // Label 5707: @290624
     /* 290624 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(290661), // Rule ID 5210 //
     /* 290629 */     // MIs[0] Operand 1
     /* 290629 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290638 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290644 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290652 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 290655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290659 */     GIR_RootConstrainSelectedInstOperands,
     /* 290660 */     // GIR_Coverage, 5210,
     /* 290660 */     GIR_EraseRootFromParent_Done,
     /* 290661 */   // Label 5708: @290661
     /* 290661 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(290698), // Rule ID 5217 //
     /* 290666 */     // MIs[0] Operand 1
     /* 290666 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290675 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290681 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290689 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 290692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290696 */     GIR_RootConstrainSelectedInstOperands,
     /* 290697 */     // GIR_Coverage, 5217,
     /* 290697 */     GIR_EraseRootFromParent_Done,
     /* 290698 */   // Label 5709: @290698
     /* 290698 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(290738), // Rule ID 727 //
     /* 290703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290706 */     // MIs[0] Operand 1
     /* 290706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290719 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290725 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290729 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 290732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290736 */     GIR_RootConstrainSelectedInstOperands,
     /* 290737 */     // GIR_Coverage, 727,
     /* 290737 */     GIR_EraseRootFromParent_Done,
     /* 290738 */   // Label 5710: @290738
     /* 290738 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(290778), // Rule ID 739 //
     /* 290743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290746 */     // MIs[0] Operand 1
     /* 290746 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290759 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290765 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290769 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 290772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290776 */     GIR_RootConstrainSelectedInstOperands,
     /* 290777 */     // GIR_Coverage, 739,
     /* 290777 */     GIR_EraseRootFromParent_Done,
     /* 290778 */   // Label 5711: @290778
     /* 290778 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(290818), // Rule ID 740 //
     /* 290783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290786 */     // MIs[0] Operand 1
     /* 290786 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290799 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290805 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 290807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290809 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 290812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290816 */     GIR_RootConstrainSelectedInstOperands,
     /* 290817 */     // GIR_Coverage, 740,
     /* 290817 */     GIR_EraseRootFromParent_Done,
     /* 290818 */   // Label 5712: @290818
     /* 290818 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(290858), // Rule ID 748 //
     /* 290823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290826 */     // MIs[0] Operand 1
     /* 290826 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290839 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290845 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290849 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 290852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290856 */     GIR_RootConstrainSelectedInstOperands,
     /* 290857 */     // GIR_Coverage, 748,
     /* 290857 */     GIR_EraseRootFromParent_Done,
     /* 290858 */   // Label 5713: @290858
     /* 290858 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(290895), // Rule ID 5154 //
     /* 290863 */     // MIs[0] Operand 1
     /* 290863 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290886 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 290889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290893 */     GIR_RootConstrainSelectedInstOperands,
     /* 290894 */     // GIR_Coverage, 5154,
     /* 290894 */     GIR_EraseRootFromParent_Done,
     /* 290895 */   // Label 5714: @290895
     /* 290895 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(290932), // Rule ID 5161 //
     /* 290900 */     // MIs[0] Operand 1
     /* 290900 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290913 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290919 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290923 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 290926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290930 */     GIR_RootConstrainSelectedInstOperands,
     /* 290931 */     // GIR_Coverage, 5161,
     /* 290931 */     GIR_EraseRootFromParent_Done,
     /* 290932 */   // Label 5715: @290932
     /* 290932 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(290969), // Rule ID 5168 //
     /* 290937 */     // MIs[0] Operand 1
     /* 290937 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290950 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290956 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290960 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 290963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290967 */     GIR_RootConstrainSelectedInstOperands,
     /* 290968 */     // GIR_Coverage, 5168,
     /* 290968 */     GIR_EraseRootFromParent_Done,
     /* 290969 */   // Label 5716: @290969
     /* 290969 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(291006), // Rule ID 5175 //
     /* 290974 */     // MIs[0] Operand 1
     /* 290974 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290987 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290993 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290997 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 291000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291004 */     GIR_RootConstrainSelectedInstOperands,
     /* 291005 */     // GIR_Coverage, 5175,
     /* 291005 */     GIR_EraseRootFromParent_Done,
     /* 291006 */   // Label 5717: @291006
     /* 291006 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(291043), // Rule ID 5182 //
     /* 291011 */     // MIs[0] Operand 1
     /* 291011 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291024 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291030 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291034 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 291034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 291037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291041 */     GIR_RootConstrainSelectedInstOperands,
     /* 291042 */     // GIR_Coverage, 5182,
     /* 291042 */     GIR_EraseRootFromParent_Done,
     /* 291043 */   // Label 5718: @291043
     /* 291043 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(291075), // Rule ID 1126 //
     /* 291048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291051 */     // MIs[0] Operand 1
     /* 291051 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291064 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 291067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291073 */     GIR_RootConstrainSelectedInstOperands,
     /* 291074 */     // GIR_Coverage, 1126,
     /* 291074 */     GIR_EraseRootFromParent_Done,
     /* 291075 */   // Label 5719: @291075
     /* 291075 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(291107), // Rule ID 1133 //
     /* 291080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291083 */     // MIs[0] Operand 1
     /* 291083 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291096 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 291099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291105 */     GIR_RootConstrainSelectedInstOperands,
     /* 291106 */     // GIR_Coverage, 1133,
     /* 291106 */     GIR_EraseRootFromParent_Done,
     /* 291107 */   // Label 5720: @291107
     /* 291107 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(291139), // Rule ID 1140 //
     /* 291112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291115 */     // MIs[0] Operand 1
     /* 291115 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291128 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 291131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291137 */     GIR_RootConstrainSelectedInstOperands,
     /* 291138 */     // GIR_Coverage, 1140,
     /* 291138 */     GIR_EraseRootFromParent_Done,
     /* 291139 */   // Label 5721: @291139
     /* 291139 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(291171), // Rule ID 1147 //
     /* 291144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291147 */     // MIs[0] Operand 1
     /* 291147 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291160 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 291163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291169 */     GIR_RootConstrainSelectedInstOperands,
     /* 291170 */     // GIR_Coverage, 1147,
     /* 291170 */     GIR_EraseRootFromParent_Done,
     /* 291171 */   // Label 5722: @291171
     /* 291171 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(291203), // Rule ID 1154 //
     /* 291176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291179 */     // MIs[0] Operand 1
     /* 291179 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291192 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 291195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291201 */     GIR_RootConstrainSelectedInstOperands,
     /* 291202 */     // GIR_Coverage, 1154,
     /* 291202 */     GIR_EraseRootFromParent_Done,
     /* 291203 */   // Label 5723: @291203
     /* 291203 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(291232), // Rule ID 5091 //
     /* 291208 */     // MIs[0] Operand 1
     /* 291208 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291221 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 291224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291230 */     GIR_RootConstrainSelectedInstOperands,
     /* 291231 */     // GIR_Coverage, 5091,
     /* 291231 */     GIR_EraseRootFromParent_Done,
     /* 291232 */   // Label 5724: @291232
     /* 291232 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(291261), // Rule ID 5098 //
     /* 291237 */     // MIs[0] Operand 1
     /* 291237 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291250 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 291253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291259 */     GIR_RootConstrainSelectedInstOperands,
     /* 291260 */     // GIR_Coverage, 5098,
     /* 291260 */     GIR_EraseRootFromParent_Done,
     /* 291261 */   // Label 5725: @291261
     /* 291261 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(291290), // Rule ID 5105 //
     /* 291266 */     // MIs[0] Operand 1
     /* 291266 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291279 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 291282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291288 */     GIR_RootConstrainSelectedInstOperands,
     /* 291289 */     // GIR_Coverage, 5105,
     /* 291289 */     GIR_EraseRootFromParent_Done,
     /* 291290 */   // Label 5726: @291290
     /* 291290 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(291319), // Rule ID 5112 //
     /* 291295 */     // MIs[0] Operand 1
     /* 291295 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291308 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 291311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291317 */     GIR_RootConstrainSelectedInstOperands,
     /* 291318 */     // GIR_Coverage, 5112,
     /* 291318 */     GIR_EraseRootFromParent_Done,
     /* 291319 */   // Label 5727: @291319
     /* 291319 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(291348), // Rule ID 5119 //
     /* 291324 */     // MIs[0] Operand 1
     /* 291324 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291337 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 291340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291346 */     GIR_RootConstrainSelectedInstOperands,
     /* 291347 */     // GIR_Coverage, 5119,
     /* 291347 */     GIR_EraseRootFromParent_Done,
     /* 291348 */   // Label 5728: @291348
     /* 291348 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(291377), // Rule ID 5126 //
     /* 291353 */     // MIs[0] Operand 1
     /* 291353 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291366 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 291366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 291369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291375 */     GIR_RootConstrainSelectedInstOperands,
     /* 291376 */     // GIR_Coverage, 5126,
     /* 291376 */     GIR_EraseRootFromParent_Done,
     /* 291377 */   // Label 5729: @291377
     /* 291377 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(291406), // Rule ID 5133 //
     /* 291382 */     // MIs[0] Operand 1
     /* 291382 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291395 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 291395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 291398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291404 */     GIR_RootConstrainSelectedInstOperands,
     /* 291405 */     // GIR_Coverage, 5133,
     /* 291405 */     GIR_EraseRootFromParent_Done,
     /* 291406 */   // Label 5730: @291406
     /* 291406 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(291435), // Rule ID 5140 //
     /* 291411 */     // MIs[0] Operand 1
     /* 291411 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 291416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291424 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 291424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 291427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291433 */     GIR_RootConstrainSelectedInstOperands,
     /* 291434 */     // GIR_Coverage, 5140,
     /* 291434 */     GIR_EraseRootFromParent_Done,
     /* 291435 */   // Label 5731: @291435
     /* 291435 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(291464), // Rule ID 5147 //
     /* 291440 */     // MIs[0] Operand 1
     /* 291440 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 291445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291453 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 291453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 291456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291462 */     GIR_RootConstrainSelectedInstOperands,
     /* 291463 */     // GIR_Coverage, 5147,
     /* 291463 */     GIR_EraseRootFromParent_Done,
     /* 291464 */   // Label 5732: @291464
     /* 291464 */   GIM_Reject,
     /* 291465 */ // Label 5702: @291465
     /* 291465 */ GIM_Reject,
     /* 291466 */ // Label 5593: @291466
     /* 291466 */ GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(292513),
     /* 291471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 291474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 291477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291481 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(291521), // Rule ID 750 //
     /* 291486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291489 */     // MIs[0] Operand 1
     /* 291489 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291498 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291504 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291512 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 291515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291519 */     GIR_RootConstrainSelectedInstOperands,
     /* 291520 */     // GIR_Coverage, 750,
     /* 291520 */     GIR_EraseRootFromParent_Done,
     /* 291521 */   // Label 5734: @291521
     /* 291521 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(291561), // Rule ID 757 //
     /* 291526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291529 */     // MIs[0] Operand 1
     /* 291529 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291552 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 291555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291559 */     GIR_RootConstrainSelectedInstOperands,
     /* 291560 */     // GIR_Coverage, 757,
     /* 291560 */     GIR_EraseRootFromParent_Done,
     /* 291561 */   // Label 5735: @291561
     /* 291561 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(291598), // Rule ID 5184 //
     /* 291566 */     // MIs[0] Operand 1
     /* 291566 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291575 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291581 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291589 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 291592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291596 */     GIR_RootConstrainSelectedInstOperands,
     /* 291597 */     // GIR_Coverage, 5184,
     /* 291597 */     GIR_EraseRootFromParent_Done,
     /* 291598 */   // Label 5736: @291598
     /* 291598 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(291635), // Rule ID 5191 //
     /* 291603 */     // MIs[0] Operand 1
     /* 291603 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291612 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291618 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291626 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 291629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291633 */     GIR_RootConstrainSelectedInstOperands,
     /* 291634 */     // GIR_Coverage, 5191,
     /* 291634 */     GIR_EraseRootFromParent_Done,
     /* 291635 */   // Label 5737: @291635
     /* 291635 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(291672), // Rule ID 5198 //
     /* 291640 */     // MIs[0] Operand 1
     /* 291640 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291649 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291655 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291663 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 291666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291670 */     GIR_RootConstrainSelectedInstOperands,
     /* 291671 */     // GIR_Coverage, 5198,
     /* 291671 */     GIR_EraseRootFromParent_Done,
     /* 291672 */   // Label 5738: @291672
     /* 291672 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(291709), // Rule ID 5205 //
     /* 291677 */     // MIs[0] Operand 1
     /* 291677 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291686 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291692 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291700 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 291703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291707 */     GIR_RootConstrainSelectedInstOperands,
     /* 291708 */     // GIR_Coverage, 5205,
     /* 291708 */     GIR_EraseRootFromParent_Done,
     /* 291709 */   // Label 5739: @291709
     /* 291709 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(291746), // Rule ID 5212 //
     /* 291714 */     // MIs[0] Operand 1
     /* 291714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291723 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291729 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291737 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 291740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291744 */     GIR_RootConstrainSelectedInstOperands,
     /* 291745 */     // GIR_Coverage, 5212,
     /* 291745 */     GIR_EraseRootFromParent_Done,
     /* 291746 */   // Label 5740: @291746
     /* 291746 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(291786), // Rule ID 722 //
     /* 291751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291754 */     // MIs[0] Operand 1
     /* 291754 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291767 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291773 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291777 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 291780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291784 */     GIR_RootConstrainSelectedInstOperands,
     /* 291785 */     // GIR_Coverage, 722,
     /* 291785 */     GIR_EraseRootFromParent_Done,
     /* 291786 */   // Label 5741: @291786
     /* 291786 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(291826), // Rule ID 729 //
     /* 291791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291794 */     // MIs[0] Operand 1
     /* 291794 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291807 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291813 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291817 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 291820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291824 */     GIR_RootConstrainSelectedInstOperands,
     /* 291825 */     // GIR_Coverage, 729,
     /* 291825 */     GIR_EraseRootFromParent_Done,
     /* 291826 */   // Label 5742: @291826
     /* 291826 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(291866), // Rule ID 730 //
     /* 291831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291834 */     // MIs[0] Operand 1
     /* 291834 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291847 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291853 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 291855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291857 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 291860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291864 */     GIR_RootConstrainSelectedInstOperands,
     /* 291865 */     // GIR_Coverage, 730,
     /* 291865 */     GIR_EraseRootFromParent_Done,
     /* 291866 */   // Label 5743: @291866
     /* 291866 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(291906), // Rule ID 743 //
     /* 291871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291874 */     // MIs[0] Operand 1
     /* 291874 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291887 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291893 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291897 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 291900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291904 */     GIR_RootConstrainSelectedInstOperands,
     /* 291905 */     // GIR_Coverage, 743,
     /* 291905 */     GIR_EraseRootFromParent_Done,
     /* 291906 */   // Label 5744: @291906
     /* 291906 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(291943), // Rule ID 5149 //
     /* 291911 */     // MIs[0] Operand 1
     /* 291911 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291924 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291930 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291934 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 291937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291941 */     GIR_RootConstrainSelectedInstOperands,
     /* 291942 */     // GIR_Coverage, 5149,
     /* 291942 */     GIR_EraseRootFromParent_Done,
     /* 291943 */   // Label 5745: @291943
     /* 291943 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(291980), // Rule ID 5156 //
     /* 291948 */     // MIs[0] Operand 1
     /* 291948 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291961 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291967 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291971 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 291974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291978 */     GIR_RootConstrainSelectedInstOperands,
     /* 291979 */     // GIR_Coverage, 5156,
     /* 291979 */     GIR_EraseRootFromParent_Done,
     /* 291980 */   // Label 5746: @291980
     /* 291980 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(292017), // Rule ID 5163 //
     /* 291985 */     // MIs[0] Operand 1
     /* 291985 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291998 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292004 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292008 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 292008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 292011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292015 */     GIR_RootConstrainSelectedInstOperands,
     /* 292016 */     // GIR_Coverage, 5163,
     /* 292016 */     GIR_EraseRootFromParent_Done,
     /* 292017 */   // Label 5747: @292017
     /* 292017 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(292054), // Rule ID 5170 //
     /* 292022 */     // MIs[0] Operand 1
     /* 292022 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292035 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292041 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292045 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 292045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 292048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292052 */     GIR_RootConstrainSelectedInstOperands,
     /* 292053 */     // GIR_Coverage, 5170,
     /* 292053 */     GIR_EraseRootFromParent_Done,
     /* 292054 */   // Label 5748: @292054
     /* 292054 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(292091), // Rule ID 5177 //
     /* 292059 */     // MIs[0] Operand 1
     /* 292059 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292072 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292078 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292082 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 292082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 292085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292089 */     GIR_RootConstrainSelectedInstOperands,
     /* 292090 */     // GIR_Coverage, 5177,
     /* 292090 */     GIR_EraseRootFromParent_Done,
     /* 292091 */   // Label 5749: @292091
     /* 292091 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(292123), // Rule ID 1121 //
     /* 292096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292099 */     // MIs[0] Operand 1
     /* 292099 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292112 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 292115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292121 */     GIR_RootConstrainSelectedInstOperands,
     /* 292122 */     // GIR_Coverage, 1121,
     /* 292122 */     GIR_EraseRootFromParent_Done,
     /* 292123 */   // Label 5750: @292123
     /* 292123 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(292155), // Rule ID 1128 //
     /* 292128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292131 */     // MIs[0] Operand 1
     /* 292131 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292144 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 292147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292153 */     GIR_RootConstrainSelectedInstOperands,
     /* 292154 */     // GIR_Coverage, 1128,
     /* 292154 */     GIR_EraseRootFromParent_Done,
     /* 292155 */   // Label 5751: @292155
     /* 292155 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(292187), // Rule ID 1135 //
     /* 292160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292163 */     // MIs[0] Operand 1
     /* 292163 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292176 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 292179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292185 */     GIR_RootConstrainSelectedInstOperands,
     /* 292186 */     // GIR_Coverage, 1135,
     /* 292186 */     GIR_EraseRootFromParent_Done,
     /* 292187 */   // Label 5752: @292187
     /* 292187 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(292219), // Rule ID 1142 //
     /* 292192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292195 */     // MIs[0] Operand 1
     /* 292195 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292208 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 292211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292217 */     GIR_RootConstrainSelectedInstOperands,
     /* 292218 */     // GIR_Coverage, 1142,
     /* 292218 */     GIR_EraseRootFromParent_Done,
     /* 292219 */   // Label 5753: @292219
     /* 292219 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(292251), // Rule ID 1149 //
     /* 292224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292227 */     // MIs[0] Operand 1
     /* 292227 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292240 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 292243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292249 */     GIR_RootConstrainSelectedInstOperands,
     /* 292250 */     // GIR_Coverage, 1149,
     /* 292250 */     GIR_EraseRootFromParent_Done,
     /* 292251 */   // Label 5754: @292251
     /* 292251 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(292280), // Rule ID 5086 //
     /* 292256 */     // MIs[0] Operand 1
     /* 292256 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292269 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 292272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292278 */     GIR_RootConstrainSelectedInstOperands,
     /* 292279 */     // GIR_Coverage, 5086,
     /* 292279 */     GIR_EraseRootFromParent_Done,
     /* 292280 */   // Label 5755: @292280
     /* 292280 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(292309), // Rule ID 5093 //
     /* 292285 */     // MIs[0] Operand 1
     /* 292285 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292298 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 292301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292307 */     GIR_RootConstrainSelectedInstOperands,
     /* 292308 */     // GIR_Coverage, 5093,
     /* 292308 */     GIR_EraseRootFromParent_Done,
     /* 292309 */   // Label 5756: @292309
     /* 292309 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(292338), // Rule ID 5100 //
     /* 292314 */     // MIs[0] Operand 1
     /* 292314 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292327 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 292330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292336 */     GIR_RootConstrainSelectedInstOperands,
     /* 292337 */     // GIR_Coverage, 5100,
     /* 292337 */     GIR_EraseRootFromParent_Done,
     /* 292338 */   // Label 5757: @292338
     /* 292338 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(292367), // Rule ID 5107 //
     /* 292343 */     // MIs[0] Operand 1
     /* 292343 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292356 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 292359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292365 */     GIR_RootConstrainSelectedInstOperands,
     /* 292366 */     // GIR_Coverage, 5107,
     /* 292366 */     GIR_EraseRootFromParent_Done,
     /* 292367 */   // Label 5758: @292367
     /* 292367 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(292396), // Rule ID 5114 //
     /* 292372 */     // MIs[0] Operand 1
     /* 292372 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292385 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 292388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292394 */     GIR_RootConstrainSelectedInstOperands,
     /* 292395 */     // GIR_Coverage, 5114,
     /* 292395 */     GIR_EraseRootFromParent_Done,
     /* 292396 */   // Label 5759: @292396
     /* 292396 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(292425), // Rule ID 5121 //
     /* 292401 */     // MIs[0] Operand 1
     /* 292401 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292414 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 292414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 292417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292423 */     GIR_RootConstrainSelectedInstOperands,
     /* 292424 */     // GIR_Coverage, 5121,
     /* 292424 */     GIR_EraseRootFromParent_Done,
     /* 292425 */   // Label 5760: @292425
     /* 292425 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(292454), // Rule ID 5128 //
     /* 292430 */     // MIs[0] Operand 1
     /* 292430 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292443 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 292443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 292446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292452 */     GIR_RootConstrainSelectedInstOperands,
     /* 292453 */     // GIR_Coverage, 5128,
     /* 292453 */     GIR_EraseRootFromParent_Done,
     /* 292454 */   // Label 5761: @292454
     /* 292454 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(292483), // Rule ID 5135 //
     /* 292459 */     // MIs[0] Operand 1
     /* 292459 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 292464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292472 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 292472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 292475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292481 */     GIR_RootConstrainSelectedInstOperands,
     /* 292482 */     // GIR_Coverage, 5135,
     /* 292482 */     GIR_EraseRootFromParent_Done,
     /* 292483 */   // Label 5762: @292483
     /* 292483 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(292512), // Rule ID 5142 //
     /* 292488 */     // MIs[0] Operand 1
     /* 292488 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 292493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292501 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 292501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 292504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292510 */     GIR_RootConstrainSelectedInstOperands,
     /* 292511 */     // GIR_Coverage, 5142,
     /* 292511 */     GIR_EraseRootFromParent_Done,
     /* 292512 */   // Label 5763: @292512
     /* 292512 */   GIM_Reject,
     /* 292513 */ // Label 5733: @292513
     /* 292513 */ GIM_Reject,
     /* 292514 */ // Label 5594: @292514
     /* 292514 */ GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(293561),
     /* 292519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 292522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 292525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292529 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(292569), // Rule ID 753 //
     /* 292534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292537 */     // MIs[0] Operand 1
     /* 292537 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292546 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292552 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292560 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 292563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292567 */     GIR_RootConstrainSelectedInstOperands,
     /* 292568 */     // GIR_Coverage, 753,
     /* 292568 */     GIR_EraseRootFromParent_Done,
     /* 292569 */   // Label 5765: @292569
     /* 292569 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(292609), // Rule ID 760 //
     /* 292574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292577 */     // MIs[0] Operand 1
     /* 292577 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292586 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292592 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292600 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 292603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292607 */     GIR_RootConstrainSelectedInstOperands,
     /* 292608 */     // GIR_Coverage, 760,
     /* 292608 */     GIR_EraseRootFromParent_Done,
     /* 292609 */   // Label 5766: @292609
     /* 292609 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(292646), // Rule ID 5187 //
     /* 292614 */     // MIs[0] Operand 1
     /* 292614 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292623 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292629 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292637 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 292640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292644 */     GIR_RootConstrainSelectedInstOperands,
     /* 292645 */     // GIR_Coverage, 5187,
     /* 292645 */     GIR_EraseRootFromParent_Done,
     /* 292646 */   // Label 5767: @292646
     /* 292646 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(292683), // Rule ID 5194 //
     /* 292651 */     // MIs[0] Operand 1
     /* 292651 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292660 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292666 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292674 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 292677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292681 */     GIR_RootConstrainSelectedInstOperands,
     /* 292682 */     // GIR_Coverage, 5194,
     /* 292682 */     GIR_EraseRootFromParent_Done,
     /* 292683 */   // Label 5768: @292683
     /* 292683 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(292720), // Rule ID 5201 //
     /* 292688 */     // MIs[0] Operand 1
     /* 292688 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292697 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292703 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292711 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 292714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292718 */     GIR_RootConstrainSelectedInstOperands,
     /* 292719 */     // GIR_Coverage, 5201,
     /* 292719 */     GIR_EraseRootFromParent_Done,
     /* 292720 */   // Label 5769: @292720
     /* 292720 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(292757), // Rule ID 5208 //
     /* 292725 */     // MIs[0] Operand 1
     /* 292725 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292734 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292740 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292748 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 292751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292755 */     GIR_RootConstrainSelectedInstOperands,
     /* 292756 */     // GIR_Coverage, 5208,
     /* 292756 */     GIR_EraseRootFromParent_Done,
     /* 292757 */   // Label 5770: @292757
     /* 292757 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(292794), // Rule ID 5215 //
     /* 292762 */     // MIs[0] Operand 1
     /* 292762 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292771 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292777 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292785 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 292788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292792 */     GIR_RootConstrainSelectedInstOperands,
     /* 292793 */     // GIR_Coverage, 5215,
     /* 292793 */     GIR_EraseRootFromParent_Done,
     /* 292794 */   // Label 5771: @292794
     /* 292794 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(292834), // Rule ID 725 //
     /* 292799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292802 */     // MIs[0] Operand 1
     /* 292802 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292815 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292821 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292825 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 292828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292832 */     GIR_RootConstrainSelectedInstOperands,
     /* 292833 */     // GIR_Coverage, 725,
     /* 292833 */     GIR_EraseRootFromParent_Done,
     /* 292834 */   // Label 5772: @292834
     /* 292834 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(292874), // Rule ID 735 //
     /* 292839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292842 */     // MIs[0] Operand 1
     /* 292842 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292855 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292861 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292865 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 292868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292872 */     GIR_RootConstrainSelectedInstOperands,
     /* 292873 */     // GIR_Coverage, 735,
     /* 292873 */     GIR_EraseRootFromParent_Done,
     /* 292874 */   // Label 5773: @292874
     /* 292874 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(292914), // Rule ID 736 //
     /* 292879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292882 */     // MIs[0] Operand 1
     /* 292882 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292895 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 292903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292905 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 292908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292912 */     GIR_RootConstrainSelectedInstOperands,
     /* 292913 */     // GIR_Coverage, 736,
     /* 292913 */     GIR_EraseRootFromParent_Done,
     /* 292914 */   // Label 5774: @292914
     /* 292914 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(292954), // Rule ID 746 //
     /* 292919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292922 */     // MIs[0] Operand 1
     /* 292922 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292935 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292941 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292945 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 292948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292952 */     GIR_RootConstrainSelectedInstOperands,
     /* 292953 */     // GIR_Coverage, 746,
     /* 292953 */     GIR_EraseRootFromParent_Done,
     /* 292954 */   // Label 5775: @292954
     /* 292954 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(292991), // Rule ID 5152 //
     /* 292959 */     // MIs[0] Operand 1
     /* 292959 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292972 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292978 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292982 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 292985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292989 */     GIR_RootConstrainSelectedInstOperands,
     /* 292990 */     // GIR_Coverage, 5152,
     /* 292990 */     GIR_EraseRootFromParent_Done,
     /* 292991 */   // Label 5776: @292991
     /* 292991 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(293028), // Rule ID 5159 //
     /* 292996 */     // MIs[0] Operand 1
     /* 292996 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293009 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293015 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293019 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 293022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293026 */     GIR_RootConstrainSelectedInstOperands,
     /* 293027 */     // GIR_Coverage, 5159,
     /* 293027 */     GIR_EraseRootFromParent_Done,
     /* 293028 */   // Label 5777: @293028
     /* 293028 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(293065), // Rule ID 5166 //
     /* 293033 */     // MIs[0] Operand 1
     /* 293033 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293046 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293052 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293056 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 293059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293063 */     GIR_RootConstrainSelectedInstOperands,
     /* 293064 */     // GIR_Coverage, 5166,
     /* 293064 */     GIR_EraseRootFromParent_Done,
     /* 293065 */   // Label 5778: @293065
     /* 293065 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(293102), // Rule ID 5173 //
     /* 293070 */     // MIs[0] Operand 1
     /* 293070 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293083 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293089 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293093 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 293096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293100 */     GIR_RootConstrainSelectedInstOperands,
     /* 293101 */     // GIR_Coverage, 5173,
     /* 293101 */     GIR_EraseRootFromParent_Done,
     /* 293102 */   // Label 5779: @293102
     /* 293102 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(293139), // Rule ID 5180 //
     /* 293107 */     // MIs[0] Operand 1
     /* 293107 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293120 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293126 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293130 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 293133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293137 */     GIR_RootConstrainSelectedInstOperands,
     /* 293138 */     // GIR_Coverage, 5180,
     /* 293138 */     GIR_EraseRootFromParent_Done,
     /* 293139 */   // Label 5780: @293139
     /* 293139 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(293171), // Rule ID 1124 //
     /* 293144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293147 */     // MIs[0] Operand 1
     /* 293147 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293160 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 293163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293169 */     GIR_RootConstrainSelectedInstOperands,
     /* 293170 */     // GIR_Coverage, 1124,
     /* 293170 */     GIR_EraseRootFromParent_Done,
     /* 293171 */   // Label 5781: @293171
     /* 293171 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(293203), // Rule ID 1131 //
     /* 293176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293179 */     // MIs[0] Operand 1
     /* 293179 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293192 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 293195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293201 */     GIR_RootConstrainSelectedInstOperands,
     /* 293202 */     // GIR_Coverage, 1131,
     /* 293202 */     GIR_EraseRootFromParent_Done,
     /* 293203 */   // Label 5782: @293203
     /* 293203 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(293235), // Rule ID 1138 //
     /* 293208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293211 */     // MIs[0] Operand 1
     /* 293211 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293224 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 293227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293233 */     GIR_RootConstrainSelectedInstOperands,
     /* 293234 */     // GIR_Coverage, 1138,
     /* 293234 */     GIR_EraseRootFromParent_Done,
     /* 293235 */   // Label 5783: @293235
     /* 293235 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(293267), // Rule ID 1145 //
     /* 293240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293243 */     // MIs[0] Operand 1
     /* 293243 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293256 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 293259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293265 */     GIR_RootConstrainSelectedInstOperands,
     /* 293266 */     // GIR_Coverage, 1145,
     /* 293266 */     GIR_EraseRootFromParent_Done,
     /* 293267 */   // Label 5784: @293267
     /* 293267 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(293299), // Rule ID 1152 //
     /* 293272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293275 */     // MIs[0] Operand 1
     /* 293275 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293288 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 293291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293297 */     GIR_RootConstrainSelectedInstOperands,
     /* 293298 */     // GIR_Coverage, 1152,
     /* 293298 */     GIR_EraseRootFromParent_Done,
     /* 293299 */   // Label 5785: @293299
     /* 293299 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(293328), // Rule ID 5089 //
     /* 293304 */     // MIs[0] Operand 1
     /* 293304 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293317 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 293320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293326 */     GIR_RootConstrainSelectedInstOperands,
     /* 293327 */     // GIR_Coverage, 5089,
     /* 293327 */     GIR_EraseRootFromParent_Done,
     /* 293328 */   // Label 5786: @293328
     /* 293328 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(293357), // Rule ID 5096 //
     /* 293333 */     // MIs[0] Operand 1
     /* 293333 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293346 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 293349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293355 */     GIR_RootConstrainSelectedInstOperands,
     /* 293356 */     // GIR_Coverage, 5096,
     /* 293356 */     GIR_EraseRootFromParent_Done,
     /* 293357 */   // Label 5787: @293357
     /* 293357 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(293386), // Rule ID 5103 //
     /* 293362 */     // MIs[0] Operand 1
     /* 293362 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293375 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 293378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293384 */     GIR_RootConstrainSelectedInstOperands,
     /* 293385 */     // GIR_Coverage, 5103,
     /* 293385 */     GIR_EraseRootFromParent_Done,
     /* 293386 */   // Label 5788: @293386
     /* 293386 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(293415), // Rule ID 5110 //
     /* 293391 */     // MIs[0] Operand 1
     /* 293391 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293404 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 293407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293413 */     GIR_RootConstrainSelectedInstOperands,
     /* 293414 */     // GIR_Coverage, 5110,
     /* 293414 */     GIR_EraseRootFromParent_Done,
     /* 293415 */   // Label 5789: @293415
     /* 293415 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(293444), // Rule ID 5117 //
     /* 293420 */     // MIs[0] Operand 1
     /* 293420 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293433 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 293436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293442 */     GIR_RootConstrainSelectedInstOperands,
     /* 293443 */     // GIR_Coverage, 5117,
     /* 293443 */     GIR_EraseRootFromParent_Done,
     /* 293444 */   // Label 5790: @293444
     /* 293444 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(293473), // Rule ID 5124 //
     /* 293449 */     // MIs[0] Operand 1
     /* 293449 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293462 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 293462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 293465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293471 */     GIR_RootConstrainSelectedInstOperands,
     /* 293472 */     // GIR_Coverage, 5124,
     /* 293472 */     GIR_EraseRootFromParent_Done,
     /* 293473 */   // Label 5791: @293473
     /* 293473 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(293502), // Rule ID 5131 //
     /* 293478 */     // MIs[0] Operand 1
     /* 293478 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293491 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 293491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 293494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293500 */     GIR_RootConstrainSelectedInstOperands,
     /* 293501 */     // GIR_Coverage, 5131,
     /* 293501 */     GIR_EraseRootFromParent_Done,
     /* 293502 */   // Label 5792: @293502
     /* 293502 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(293531), // Rule ID 5138 //
     /* 293507 */     // MIs[0] Operand 1
     /* 293507 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 293512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293520 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 293520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 293523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293529 */     GIR_RootConstrainSelectedInstOperands,
     /* 293530 */     // GIR_Coverage, 5138,
     /* 293530 */     GIR_EraseRootFromParent_Done,
     /* 293531 */   // Label 5793: @293531
     /* 293531 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(293560), // Rule ID 5145 //
     /* 293536 */     // MIs[0] Operand 1
     /* 293536 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 293541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293549 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 293549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 293552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293558 */     GIR_RootConstrainSelectedInstOperands,
     /* 293559 */     // GIR_Coverage, 5145,
     /* 293559 */     GIR_EraseRootFromParent_Done,
     /* 293560 */   // Label 5794: @293560
     /* 293560 */   GIM_Reject,
     /* 293561 */ // Label 5764: @293561
     /* 293561 */ GIM_Reject,
     /* 293562 */ // Label 5595: @293562
     /* 293562 */ GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(294609),
     /* 293567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 293570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 293573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293577 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(293617), // Rule ID 751 //
     /* 293582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293585 */     // MIs[0] Operand 1
     /* 293585 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293594 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293600 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293608 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 293611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293615 */     GIR_RootConstrainSelectedInstOperands,
     /* 293616 */     // GIR_Coverage, 751,
     /* 293616 */     GIR_EraseRootFromParent_Done,
     /* 293617 */   // Label 5796: @293617
     /* 293617 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(293657), // Rule ID 758 //
     /* 293622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293625 */     // MIs[0] Operand 1
     /* 293625 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293648 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 293651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293655 */     GIR_RootConstrainSelectedInstOperands,
     /* 293656 */     // GIR_Coverage, 758,
     /* 293656 */     GIR_EraseRootFromParent_Done,
     /* 293657 */   // Label 5797: @293657
     /* 293657 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(293694), // Rule ID 5185 //
     /* 293662 */     // MIs[0] Operand 1
     /* 293662 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293677 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293685 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 293688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293692 */     GIR_RootConstrainSelectedInstOperands,
     /* 293693 */     // GIR_Coverage, 5185,
     /* 293693 */     GIR_EraseRootFromParent_Done,
     /* 293694 */   // Label 5798: @293694
     /* 293694 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(293731), // Rule ID 5192 //
     /* 293699 */     // MIs[0] Operand 1
     /* 293699 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293708 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293714 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293722 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 293725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293729 */     GIR_RootConstrainSelectedInstOperands,
     /* 293730 */     // GIR_Coverage, 5192,
     /* 293730 */     GIR_EraseRootFromParent_Done,
     /* 293731 */   // Label 5799: @293731
     /* 293731 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(293768), // Rule ID 5199 //
     /* 293736 */     // MIs[0] Operand 1
     /* 293736 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293745 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293751 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293759 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 293762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293766 */     GIR_RootConstrainSelectedInstOperands,
     /* 293767 */     // GIR_Coverage, 5199,
     /* 293767 */     GIR_EraseRootFromParent_Done,
     /* 293768 */   // Label 5800: @293768
     /* 293768 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(293805), // Rule ID 5206 //
     /* 293773 */     // MIs[0] Operand 1
     /* 293773 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293782 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293788 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293796 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 293799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293803 */     GIR_RootConstrainSelectedInstOperands,
     /* 293804 */     // GIR_Coverage, 5206,
     /* 293804 */     GIR_EraseRootFromParent_Done,
     /* 293805 */   // Label 5801: @293805
     /* 293805 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(293842), // Rule ID 5213 //
     /* 293810 */     // MIs[0] Operand 1
     /* 293810 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293833 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 293836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293840 */     GIR_RootConstrainSelectedInstOperands,
     /* 293841 */     // GIR_Coverage, 5213,
     /* 293841 */     GIR_EraseRootFromParent_Done,
     /* 293842 */   // Label 5802: @293842
     /* 293842 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(293882), // Rule ID 723 //
     /* 293847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293850 */     // MIs[0] Operand 1
     /* 293850 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293863 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293869 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293873 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 293876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293880 */     GIR_RootConstrainSelectedInstOperands,
     /* 293881 */     // GIR_Coverage, 723,
     /* 293881 */     GIR_EraseRootFromParent_Done,
     /* 293882 */   // Label 5803: @293882
     /* 293882 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(293922), // Rule ID 731 //
     /* 293887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293890 */     // MIs[0] Operand 1
     /* 293890 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293909 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293913 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 293916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293920 */     GIR_RootConstrainSelectedInstOperands,
     /* 293921 */     // GIR_Coverage, 731,
     /* 293921 */     GIR_EraseRootFromParent_Done,
     /* 293922 */   // Label 5804: @293922
     /* 293922 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(293962), // Rule ID 732 //
     /* 293927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293930 */     // MIs[0] Operand 1
     /* 293930 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293943 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 293951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293953 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 293956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293960 */     GIR_RootConstrainSelectedInstOperands,
     /* 293961 */     // GIR_Coverage, 732,
     /* 293961 */     GIR_EraseRootFromParent_Done,
     /* 293962 */   // Label 5805: @293962
     /* 293962 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(294002), // Rule ID 744 //
     /* 293967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293970 */     // MIs[0] Operand 1
     /* 293970 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293983 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293989 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293993 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 293996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294000 */     GIR_RootConstrainSelectedInstOperands,
     /* 294001 */     // GIR_Coverage, 744,
     /* 294001 */     GIR_EraseRootFromParent_Done,
     /* 294002 */   // Label 5806: @294002
     /* 294002 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(294039), // Rule ID 5150 //
     /* 294007 */     // MIs[0] Operand 1
     /* 294007 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294020 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294026 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294030 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 294033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294037 */     GIR_RootConstrainSelectedInstOperands,
     /* 294038 */     // GIR_Coverage, 5150,
     /* 294038 */     GIR_EraseRootFromParent_Done,
     /* 294039 */   // Label 5807: @294039
     /* 294039 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(294076), // Rule ID 5157 //
     /* 294044 */     // MIs[0] Operand 1
     /* 294044 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294057 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294063 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294067 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 294070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294074 */     GIR_RootConstrainSelectedInstOperands,
     /* 294075 */     // GIR_Coverage, 5157,
     /* 294075 */     GIR_EraseRootFromParent_Done,
     /* 294076 */   // Label 5808: @294076
     /* 294076 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(294113), // Rule ID 5164 //
     /* 294081 */     // MIs[0] Operand 1
     /* 294081 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294094 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294100 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294104 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 294107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294111 */     GIR_RootConstrainSelectedInstOperands,
     /* 294112 */     // GIR_Coverage, 5164,
     /* 294112 */     GIR_EraseRootFromParent_Done,
     /* 294113 */   // Label 5809: @294113
     /* 294113 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(294150), // Rule ID 5171 //
     /* 294118 */     // MIs[0] Operand 1
     /* 294118 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294131 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294137 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294141 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 294144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294148 */     GIR_RootConstrainSelectedInstOperands,
     /* 294149 */     // GIR_Coverage, 5171,
     /* 294149 */     GIR_EraseRootFromParent_Done,
     /* 294150 */   // Label 5810: @294150
     /* 294150 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(294187), // Rule ID 5178 //
     /* 294155 */     // MIs[0] Operand 1
     /* 294155 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294168 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294174 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294178 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 294181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294185 */     GIR_RootConstrainSelectedInstOperands,
     /* 294186 */     // GIR_Coverage, 5178,
     /* 294186 */     GIR_EraseRootFromParent_Done,
     /* 294187 */   // Label 5811: @294187
     /* 294187 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(294219), // Rule ID 1122 //
     /* 294192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294195 */     // MIs[0] Operand 1
     /* 294195 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294208 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 294211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294217 */     GIR_RootConstrainSelectedInstOperands,
     /* 294218 */     // GIR_Coverage, 1122,
     /* 294218 */     GIR_EraseRootFromParent_Done,
     /* 294219 */   // Label 5812: @294219
     /* 294219 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(294251), // Rule ID 1129 //
     /* 294224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294227 */     // MIs[0] Operand 1
     /* 294227 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294240 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 294243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294249 */     GIR_RootConstrainSelectedInstOperands,
     /* 294250 */     // GIR_Coverage, 1129,
     /* 294250 */     GIR_EraseRootFromParent_Done,
     /* 294251 */   // Label 5813: @294251
     /* 294251 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(294283), // Rule ID 1136 //
     /* 294256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294259 */     // MIs[0] Operand 1
     /* 294259 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294272 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 294275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294281 */     GIR_RootConstrainSelectedInstOperands,
     /* 294282 */     // GIR_Coverage, 1136,
     /* 294282 */     GIR_EraseRootFromParent_Done,
     /* 294283 */   // Label 5814: @294283
     /* 294283 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(294315), // Rule ID 1143 //
     /* 294288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294291 */     // MIs[0] Operand 1
     /* 294291 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294304 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 294307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294313 */     GIR_RootConstrainSelectedInstOperands,
     /* 294314 */     // GIR_Coverage, 1143,
     /* 294314 */     GIR_EraseRootFromParent_Done,
     /* 294315 */   // Label 5815: @294315
     /* 294315 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(294347), // Rule ID 1150 //
     /* 294320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294323 */     // MIs[0] Operand 1
     /* 294323 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294336 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 294339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294345 */     GIR_RootConstrainSelectedInstOperands,
     /* 294346 */     // GIR_Coverage, 1150,
     /* 294346 */     GIR_EraseRootFromParent_Done,
     /* 294347 */   // Label 5816: @294347
     /* 294347 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(294376), // Rule ID 5087 //
     /* 294352 */     // MIs[0] Operand 1
     /* 294352 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294365 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 294368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294374 */     GIR_RootConstrainSelectedInstOperands,
     /* 294375 */     // GIR_Coverage, 5087,
     /* 294375 */     GIR_EraseRootFromParent_Done,
     /* 294376 */   // Label 5817: @294376
     /* 294376 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(294405), // Rule ID 5094 //
     /* 294381 */     // MIs[0] Operand 1
     /* 294381 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294394 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 294397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294403 */     GIR_RootConstrainSelectedInstOperands,
     /* 294404 */     // GIR_Coverage, 5094,
     /* 294404 */     GIR_EraseRootFromParent_Done,
     /* 294405 */   // Label 5818: @294405
     /* 294405 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(294434), // Rule ID 5101 //
     /* 294410 */     // MIs[0] Operand 1
     /* 294410 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294423 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 294426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294432 */     GIR_RootConstrainSelectedInstOperands,
     /* 294433 */     // GIR_Coverage, 5101,
     /* 294433 */     GIR_EraseRootFromParent_Done,
     /* 294434 */   // Label 5819: @294434
     /* 294434 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(294463), // Rule ID 5108 //
     /* 294439 */     // MIs[0] Operand 1
     /* 294439 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294452 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 294455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294461 */     GIR_RootConstrainSelectedInstOperands,
     /* 294462 */     // GIR_Coverage, 5108,
     /* 294462 */     GIR_EraseRootFromParent_Done,
     /* 294463 */   // Label 5820: @294463
     /* 294463 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(294492), // Rule ID 5115 //
     /* 294468 */     // MIs[0] Operand 1
     /* 294468 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294481 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 294484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294490 */     GIR_RootConstrainSelectedInstOperands,
     /* 294491 */     // GIR_Coverage, 5115,
     /* 294491 */     GIR_EraseRootFromParent_Done,
     /* 294492 */   // Label 5821: @294492
     /* 294492 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(294521), // Rule ID 5122 //
     /* 294497 */     // MIs[0] Operand 1
     /* 294497 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294510 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 294510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 294513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294519 */     GIR_RootConstrainSelectedInstOperands,
     /* 294520 */     // GIR_Coverage, 5122,
     /* 294520 */     GIR_EraseRootFromParent_Done,
     /* 294521 */   // Label 5822: @294521
     /* 294521 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(294550), // Rule ID 5129 //
     /* 294526 */     // MIs[0] Operand 1
     /* 294526 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294539 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 294539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 294542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294548 */     GIR_RootConstrainSelectedInstOperands,
     /* 294549 */     // GIR_Coverage, 5129,
     /* 294549 */     GIR_EraseRootFromParent_Done,
     /* 294550 */   // Label 5823: @294550
     /* 294550 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(294579), // Rule ID 5136 //
     /* 294555 */     // MIs[0] Operand 1
     /* 294555 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 294560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294568 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 294568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 294571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294577 */     GIR_RootConstrainSelectedInstOperands,
     /* 294578 */     // GIR_Coverage, 5136,
     /* 294578 */     GIR_EraseRootFromParent_Done,
     /* 294579 */   // Label 5824: @294579
     /* 294579 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(294608), // Rule ID 5143 //
     /* 294584 */     // MIs[0] Operand 1
     /* 294584 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 294589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294597 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 294597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 294600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294606 */     GIR_RootConstrainSelectedInstOperands,
     /* 294607 */     // GIR_Coverage, 5143,
     /* 294607 */     GIR_EraseRootFromParent_Done,
     /* 294608 */   // Label 5825: @294608
     /* 294608 */   GIM_Reject,
     /* 294609 */ // Label 5795: @294609
     /* 294609 */ GIM_Reject,
     /* 294610 */ // Label 5596: @294610
     /* 294610 */ GIM_Reject,
     /* 294611 */ // Label 52: @294611
     /* 294611 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5838*/ GIMT_Encode4(295655),
     /* 294622 */ /*GILLT_nxv1s1*//*Label 5826*/ GIMT_Encode4(294670),
     /* 294626 */ /*GILLT_nxv2s1*//*Label 5827*/ GIMT_Encode4(294699),
     /* 294630 */ /*GILLT_nxv2s16*//*Label 5828*/ GIMT_Encode4(294728),
     /* 294634 */ /*GILLT_nxv2s32*//*Label 5829*/ GIMT_Encode4(294813),
     /* 294638 */ /*GILLT_nxv2s64*//*Label 5830*/ GIMT_Encode4(294898),
     /* 294642 */ /*GILLT_nxv4s1*//*Label 5831*/ GIMT_Encode4(295064),
     /* 294646 */ /*GILLT_nxv4s16*//*Label 5832*/ GIMT_Encode4(295093),
     /* 294650 */ /*GILLT_nxv4s32*//*Label 5833*/ GIMT_Encode4(295178),
     /* 294654 */ /*GILLT_nxv8s1*//*Label 5834*/ GIMT_Encode4(295344),
     /* 294658 */ /*GILLT_nxv8s16*//*Label 5835*/ GIMT_Encode4(295373),
     /* 294662 */ /*GILLT_nxv16s1*//*Label 5836*/ GIMT_Encode4(295539),
     /* 294666 */ /*GILLT_nxv16s8*//*Label 5837*/ GIMT_Encode4(295568),
     /* 294670 */ // Label 5826: @294670
     /* 294670 */ GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(294698), // Rule ID 8497 //
     /* 294675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 294681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 294684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 294687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 294691 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 294691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 294696 */   GIR_RootConstrainSelectedInstOperands,
     /* 294697 */   // GIR_Coverage, 8497,
     /* 294697 */   GIR_Done,
     /* 294698 */ // Label 5839: @294698
     /* 294698 */ GIM_Reject,
     /* 294699 */ // Label 5827: @294699
     /* 294699 */ GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(294727), // Rule ID 8496 //
     /* 294704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 294710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 294713 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 294716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 294720 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 294720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 294725 */   GIR_RootConstrainSelectedInstOperands,
     /* 294726 */   // GIR_Coverage, 8496,
     /* 294726 */   GIR_Done,
     /* 294727 */ // Label 5840: @294727
     /* 294727 */ GIM_Reject,
     /* 294728 */ // Label 5828: @294728
     /* 294728 */ GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(294812),
     /* 294733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 294736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 294739 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 294742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 294746 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(294796), // Rule ID 3154 //
     /* 294751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 294762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 294774 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 294778 */     // MIs[2] Operand 1
     /* 294778 */     // No operand predicates
     /* 294778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294780 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 294780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 294783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 294785 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 294787 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 294789 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 294794 */     GIR_RootConstrainSelectedInstOperands,
     /* 294795 */     // GIR_Coverage, 3154,
     /* 294795 */     GIR_EraseRootFromParent_Done,
     /* 294796 */   // Label 5842: @294796
     /* 294796 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(294811), // Rule ID 2734 //
     /* 294801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294804 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 294804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 294809 */     GIR_RootConstrainSelectedInstOperands,
     /* 294810 */     // GIR_Coverage, 2734,
     /* 294810 */     GIR_Done,
     /* 294811 */   // Label 5843: @294811
     /* 294811 */   GIM_Reject,
     /* 294812 */ // Label 5841: @294812
     /* 294812 */ GIM_Reject,
     /* 294813 */ // Label 5829: @294813
     /* 294813 */ GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(294897),
     /* 294818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 294821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 294824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 294827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 294831 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(294881), // Rule ID 3156 //
     /* 294836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 294847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 294859 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 294863 */     // MIs[2] Operand 1
     /* 294863 */     // No operand predicates
     /* 294863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294865 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 294865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 294868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 294870 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 294872 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 294874 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 294879 */     GIR_RootConstrainSelectedInstOperands,
     /* 294880 */     // GIR_Coverage, 3156,
     /* 294880 */     GIR_EraseRootFromParent_Done,
     /* 294881 */   // Label 5845: @294881
     /* 294881 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(294896), // Rule ID 2735 //
     /* 294886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294889 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 294889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 294894 */     GIR_RootConstrainSelectedInstOperands,
     /* 294895 */     // GIR_Coverage, 2735,
     /* 294895 */     GIR_Done,
     /* 294896 */   // Label 5846: @294896
     /* 294896 */   GIM_Reject,
     /* 294897 */ // Label 5844: @294897
     /* 294897 */ GIM_Reject,
     /* 294898 */ // Label 5830: @294898
     /* 294898 */ GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(295063),
     /* 294903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 294906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 294909 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(294966), // Rule ID 3157 //
     /* 294914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 294920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 294924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 294932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 294944 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 294948 */     // MIs[2] Operand 1
     /* 294948 */     // No operand predicates
     /* 294948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294950 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 294950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 294953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 294955 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 294957 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 294959 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 294964 */     GIR_RootConstrainSelectedInstOperands,
     /* 294965 */     // GIR_Coverage, 3157,
     /* 294965 */     GIR_EraseRootFromParent_Done,
     /* 294966 */   // Label 5848: @294966
     /* 294966 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(295018), // Rule ID 7543 //
     /* 294971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 294978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 294986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 294990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 294994 */     // MIs[0] Op2
     /* 294994 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 294999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295001 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 295001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 295004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 295006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 295008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 295012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 295016 */     GIR_RootConstrainSelectedInstOperands,
     /* 295017 */     // GIR_Coverage, 7543,
     /* 295017 */     GIR_EraseRootFromParent_Done,
     /* 295018 */   // Label 5849: @295018
     /* 295018 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(295040), // Rule ID 2730 //
     /* 295023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 295029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295033 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 295033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 295038 */     GIR_RootConstrainSelectedInstOperands,
     /* 295039 */     // GIR_Coverage, 2730,
     /* 295039 */     GIR_Done,
     /* 295040 */   // Label 5850: @295040
     /* 295040 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(295062), // Rule ID 2736 //
     /* 295045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 295051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295055 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 295055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 295060 */     GIR_RootConstrainSelectedInstOperands,
     /* 295061 */     // GIR_Coverage, 2736,
     /* 295061 */     GIR_Done,
     /* 295062 */   // Label 5851: @295062
     /* 295062 */   GIM_Reject,
     /* 295063 */ // Label 5847: @295063
     /* 295063 */ GIM_Reject,
     /* 295064 */ // Label 5831: @295064
     /* 295064 */ GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(295092), // Rule ID 8495 //
     /* 295069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 295075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 295078 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 295081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 295085 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 295085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 295090 */   GIR_RootConstrainSelectedInstOperands,
     /* 295091 */   // GIR_Coverage, 8495,
     /* 295091 */   GIR_Done,
     /* 295092 */ // Label 5852: @295092
     /* 295092 */ GIM_Reject,
     /* 295093 */ // Label 5832: @295093
     /* 295093 */ GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(295177),
     /* 295098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 295101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 295104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 295107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295111 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(295161), // Rule ID 3153 //
     /* 295116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 295127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295139 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 295143 */     // MIs[2] Operand 1
     /* 295143 */     // No operand predicates
     /* 295143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295145 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 295145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 295148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 295150 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 295152 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 295154 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 295159 */     GIR_RootConstrainSelectedInstOperands,
     /* 295160 */     // GIR_Coverage, 3153,
     /* 295160 */     GIR_EraseRootFromParent_Done,
     /* 295161 */   // Label 5854: @295161
     /* 295161 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(295176), // Rule ID 2732 //
     /* 295166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295169 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 295169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 295174 */     GIR_RootConstrainSelectedInstOperands,
     /* 295175 */     // GIR_Coverage, 2732,
     /* 295175 */     GIR_Done,
     /* 295176 */   // Label 5855: @295176
     /* 295176 */   GIM_Reject,
     /* 295177 */ // Label 5853: @295177
     /* 295177 */ GIM_Reject,
     /* 295178 */ // Label 5833: @295178
     /* 295178 */ GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(295343),
     /* 295183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 295186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 295189 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(295246), // Rule ID 3155 //
     /* 295194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 295200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 295212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295224 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 295228 */     // MIs[2] Operand 1
     /* 295228 */     // No operand predicates
     /* 295228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295230 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 295230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 295233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 295235 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 295237 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 295239 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 295244 */     GIR_RootConstrainSelectedInstOperands,
     /* 295245 */     // GIR_Coverage, 3155,
     /* 295245 */     GIR_EraseRootFromParent_Done,
     /* 295246 */   // Label 5857: @295246
     /* 295246 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(295298), // Rule ID 7541 //
     /* 295251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 295266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 295270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 295274 */     // MIs[0] Op2
     /* 295274 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 295279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295281 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 295281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 295284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 295286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 295288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 295292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 295296 */     GIR_RootConstrainSelectedInstOperands,
     /* 295297 */     // GIR_Coverage, 7541,
     /* 295297 */     GIR_EraseRootFromParent_Done,
     /* 295298 */   // Label 5858: @295298
     /* 295298 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(295320), // Rule ID 2729 //
     /* 295303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 295309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295313 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 295313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 295318 */     GIR_RootConstrainSelectedInstOperands,
     /* 295319 */     // GIR_Coverage, 2729,
     /* 295319 */     GIR_Done,
     /* 295320 */   // Label 5859: @295320
     /* 295320 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(295342), // Rule ID 2733 //
     /* 295325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 295331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295335 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 295335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 295340 */     GIR_RootConstrainSelectedInstOperands,
     /* 295341 */     // GIR_Coverage, 2733,
     /* 295341 */     GIR_Done,
     /* 295342 */   // Label 5860: @295342
     /* 295342 */   GIM_Reject,
     /* 295343 */ // Label 5856: @295343
     /* 295343 */ GIM_Reject,
     /* 295344 */ // Label 5834: @295344
     /* 295344 */ GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(295372), // Rule ID 8494 //
     /* 295349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 295355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 295358 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 295361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 295365 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 295365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 295370 */   GIR_RootConstrainSelectedInstOperands,
     /* 295371 */   // GIR_Coverage, 8494,
     /* 295371 */   GIR_Done,
     /* 295372 */ // Label 5861: @295372
     /* 295372 */ GIM_Reject,
     /* 295373 */ // Label 5835: @295373
     /* 295373 */ GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(295538),
     /* 295378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 295381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 295384 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(295441), // Rule ID 3152 //
     /* 295389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 295395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 295407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295419 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 295423 */     // MIs[2] Operand 1
     /* 295423 */     // No operand predicates
     /* 295423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295425 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 295425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 295428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 295430 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 295432 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 295434 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 295439 */     GIR_RootConstrainSelectedInstOperands,
     /* 295440 */     // GIR_Coverage, 3152,
     /* 295440 */     GIR_EraseRootFromParent_Done,
     /* 295441 */   // Label 5863: @295441
     /* 295441 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(295493), // Rule ID 7539 //
     /* 295446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 295461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 295465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 295469 */     // MIs[0] Op2
     /* 295469 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 295474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295476 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 295476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 295479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 295481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 295483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 295487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 295491 */     GIR_RootConstrainSelectedInstOperands,
     /* 295492 */     // GIR_Coverage, 7539,
     /* 295492 */     GIR_EraseRootFromParent_Done,
     /* 295493 */   // Label 5864: @295493
     /* 295493 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(295515), // Rule ID 2728 //
     /* 295498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 295504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295508 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 295508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 295513 */     GIR_RootConstrainSelectedInstOperands,
     /* 295514 */     // GIR_Coverage, 2728,
     /* 295514 */     GIR_Done,
     /* 295515 */   // Label 5865: @295515
     /* 295515 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(295537), // Rule ID 2731 //
     /* 295520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 295526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295530 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 295530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 295535 */     GIR_RootConstrainSelectedInstOperands,
     /* 295536 */     // GIR_Coverage, 2731,
     /* 295536 */     GIR_Done,
     /* 295537 */   // Label 5866: @295537
     /* 295537 */   GIM_Reject,
     /* 295538 */ // Label 5862: @295538
     /* 295538 */ GIM_Reject,
     /* 295539 */ // Label 5836: @295539
     /* 295539 */ GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(295567), // Rule ID 8493 //
     /* 295544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 295550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 295553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 295556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 295560 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 295560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 295565 */   GIR_RootConstrainSelectedInstOperands,
     /* 295566 */   // GIR_Coverage, 8493,
     /* 295566 */   GIR_Done,
     /* 295567 */ // Label 5867: @295567
     /* 295567 */ GIM_Reject,
     /* 295568 */ // Label 5837: @295568
     /* 295568 */ GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(295654),
     /* 295573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 295576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 295579 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(295631), // Rule ID 7537 //
     /* 295584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 295599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 295603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 295607 */     // MIs[0] Op2
     /* 295607 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 295612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295614 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 295614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 295617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 295619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 295621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 295625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 295629 */     GIR_RootConstrainSelectedInstOperands,
     /* 295630 */     // GIR_Coverage, 7537,
     /* 295630 */     GIR_EraseRootFromParent_Done,
     /* 295631 */   // Label 5869: @295631
     /* 295631 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(295653), // Rule ID 2727 //
     /* 295636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 295642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295646 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 295646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 295651 */     GIR_RootConstrainSelectedInstOperands,
     /* 295652 */     // GIR_Coverage, 2727,
     /* 295652 */     GIR_Done,
     /* 295653 */   // Label 5870: @295653
     /* 295653 */   GIM_Reject,
     /* 295654 */ // Label 5868: @295654
     /* 295654 */ GIM_Reject,
     /* 295655 */ // Label 5838: @295655
     /* 295655 */ GIM_Reject,
     /* 295656 */ // Label 53: @295656
     /* 295656 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5875*/ GIMT_Encode4(296139),
     /* 295667 */ /*GILLT_s64*//*Label 5871*/ GIMT_Encode4(295703), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 295687 */ /*GILLT_v4s32*//*Label 5872*/ GIMT_Encode4(295734), GIMT_Encode4(0),
     /* 295695 */ /*GILLT_v8s16*//*Label 5873*/ GIMT_Encode4(295869),
     /* 295699 */ /*GILLT_v16s8*//*Label 5874*/ GIMT_Encode4(296004),
     /* 295703 */ // Label 5871: @295703
     /* 295703 */ GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(295733), // Rule ID 128 //
     /* 295708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 295711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 295714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 295718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 295722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 295726 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 295726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 295731 */   GIR_RootConstrainSelectedInstOperands,
     /* 295732 */   // GIR_Coverage, 128,
     /* 295732 */   GIR_Done,
     /* 295733 */ // Label 5876: @295733
     /* 295733 */ GIM_Reject,
     /* 295734 */ // Label 5872: @295734
     /* 295734 */ GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(295868), // Rule ID 6563 //
     /* 295739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 295745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295757 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 295757 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 295760 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 295764 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295769 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 295773 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 295777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 295779 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 295782 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295786 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295791 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 295797 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295802 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295807 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 295810 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295814 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295819 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 295825 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295830 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 295838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 295842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295847 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 295850 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 295853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 295858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 295866 */   GIR_RootConstrainSelectedInstOperands,
     /* 295867 */   // GIR_Coverage, 6563,
     /* 295867 */   GIR_EraseRootFromParent_Done,
     /* 295868 */ // Label 5877: @295868
     /* 295868 */ GIM_Reject,
     /* 295869 */ // Label 5873: @295869
     /* 295869 */ GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(296003), // Rule ID 6562 //
     /* 295874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 295880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295892 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 295892 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 295895 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 295899 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295904 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 295908 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 295912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 295914 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 295917 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295921 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295926 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 295932 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295937 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295942 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 295945 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295949 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295954 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 295960 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295965 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 295973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 295977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295982 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 295985 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 295988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 295993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296001 */   GIR_RootConstrainSelectedInstOperands,
     /* 296002 */   // GIR_Coverage, 6562,
     /* 296002 */   GIR_EraseRootFromParent_Done,
     /* 296003 */ // Label 5878: @296003
     /* 296003 */ GIM_Reject,
     /* 296004 */ // Label 5874: @296004
     /* 296004 */ GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(296138), // Rule ID 6561 //
     /* 296009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 296012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 296015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296027 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 296027 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 296030 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 296034 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296039 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296043 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 296047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 296049 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 296052 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296056 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296061 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296067 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296072 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296077 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296080 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296084 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296089 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296095 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296100 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 296112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296117 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296120 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 296125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 296128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296136 */   GIR_RootConstrainSelectedInstOperands,
     /* 296137 */   // GIR_Coverage, 6561,
     /* 296137 */   GIR_EraseRootFromParent_Done,
     /* 296138 */ // Label 5879: @296138
     /* 296138 */ GIM_Reject,
     /* 296139 */ // Label 5875: @296139
     /* 296139 */ GIM_Reject,
     /* 296140 */ // Label 54: @296140
     /* 296140 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5884*/ GIMT_Encode4(296623),
     /* 296151 */ /*GILLT_s64*//*Label 5880*/ GIMT_Encode4(296187), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 296171 */ /*GILLT_v4s32*//*Label 5881*/ GIMT_Encode4(296218), GIMT_Encode4(0),
     /* 296179 */ /*GILLT_v8s16*//*Label 5882*/ GIMT_Encode4(296353),
     /* 296183 */ /*GILLT_v16s8*//*Label 5883*/ GIMT_Encode4(296488),
     /* 296187 */ // Label 5880: @296187
     /* 296187 */ GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(296217), // Rule ID 127 //
     /* 296192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 296195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 296198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 296202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 296206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 296210 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 296210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 296215 */   GIR_RootConstrainSelectedInstOperands,
     /* 296216 */   // GIR_Coverage, 127,
     /* 296216 */   GIR_Done,
     /* 296217 */ // Label 5885: @296217
     /* 296217 */ GIM_Reject,
     /* 296218 */ // Label 5881: @296218
     /* 296218 */ GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(296352), // Rule ID 6560 //
     /* 296223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 296229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296241 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 296241 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 296244 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 296248 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296253 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296257 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 296261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 296263 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 296266 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296270 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296275 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296281 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296286 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296291 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296294 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296298 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296303 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296309 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296314 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 296326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296331 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296334 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 296339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 296342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296344 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296350 */   GIR_RootConstrainSelectedInstOperands,
     /* 296351 */   // GIR_Coverage, 6560,
     /* 296351 */   GIR_EraseRootFromParent_Done,
     /* 296352 */ // Label 5886: @296352
     /* 296352 */ GIM_Reject,
     /* 296353 */ // Label 5882: @296353
     /* 296353 */ GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(296487), // Rule ID 6559 //
     /* 296358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 296364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296376 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 296376 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 296379 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 296383 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296388 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296392 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 296396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 296398 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 296401 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296405 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296410 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296416 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296421 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296426 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296429 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296433 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296438 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296444 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296449 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 296461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296466 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296469 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 296474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 296477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296485 */   GIR_RootConstrainSelectedInstOperands,
     /* 296486 */   // GIR_Coverage, 6559,
     /* 296486 */   GIR_EraseRootFromParent_Done,
     /* 296487 */ // Label 5887: @296487
     /* 296487 */ GIM_Reject,
     /* 296488 */ // Label 5883: @296488
     /* 296488 */ GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(296622), // Rule ID 6558 //
     /* 296493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 296496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 296499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296511 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 296511 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 296514 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 296518 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296523 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296527 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 296531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 296533 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 296536 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296540 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296545 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296551 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296556 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296561 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296564 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296568 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296573 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296579 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296584 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 296596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296601 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296604 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 296609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 296612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296620 */   GIR_RootConstrainSelectedInstOperands,
     /* 296621 */   // GIR_Coverage, 6558,
     /* 296621 */   GIR_EraseRootFromParent_Done,
     /* 296622 */ // Label 5888: @296622
     /* 296622 */ GIM_Reject,
     /* 296623 */ // Label 5884: @296623
     /* 296623 */ GIM_Reject,
     /* 296624 */ // Label 55: @296624
     /* 296624 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5901*/ GIMT_Encode4(297095),
     /* 296635 */ /*GILLT_s64*//*Label 5889*/ GIMT_Encode4(296719), GIMT_Encode4(0),
     /* 296643 */ /*GILLT_v2s32*//*Label 5890*/ GIMT_Encode4(296753),
     /* 296647 */ /*GILLT_v2s64*//*Label 5891*/ GIMT_Encode4(296787),
     /* 296651 */ /*GILLT_v4s16*//*Label 5892*/ GIMT_Encode4(296821),
     /* 296655 */ /*GILLT_v4s32*//*Label 5893*/ GIMT_Encode4(296855),
     /* 296659 */ /*GILLT_v8s8*//*Label 5894*/ GIMT_Encode4(296889),
     /* 296663 */ /*GILLT_v8s16*//*Label 5895*/ GIMT_Encode4(296923),
     /* 296667 */ /*GILLT_v16s8*//*Label 5896*/ GIMT_Encode4(296957), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 296687 */ /*GILLT_nxv2s64*//*Label 5897*/ GIMT_Encode4(296991), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 296699 */ /*GILLT_nxv4s32*//*Label 5898*/ GIMT_Encode4(297017), GIMT_Encode4(0),
     /* 296707 */ /*GILLT_nxv8s16*//*Label 5899*/ GIMT_Encode4(297043), GIMT_Encode4(0),
     /* 296715 */ /*GILLT_nxv16s8*//*Label 5900*/ GIMT_Encode4(297069),
     /* 296719 */ // Label 5889: @296719
     /* 296719 */ GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(296752), // Rule ID 1645 //
     /* 296724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 296730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 296733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296745 */   // (uaddsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 296745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 296750 */   GIR_RootConstrainSelectedInstOperands,
     /* 296751 */   // GIR_Coverage, 1645,
     /* 296751 */   GIR_Done,
     /* 296752 */ // Label 5902: @296752
     /* 296752 */ GIM_Reject,
     /* 296753 */ // Label 5890: @296753
     /* 296753 */ GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(296786), // Rule ID 1543 //
     /* 296758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 296764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 296767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296779 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 296779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 296784 */   GIR_RootConstrainSelectedInstOperands,
     /* 296785 */   // GIR_Coverage, 1543,
     /* 296785 */   GIR_Done,
     /* 296786 */ // Label 5903: @296786
     /* 296786 */ GIM_Reject,
     /* 296787 */ // Label 5891: @296787
     /* 296787 */ GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(296820), // Rule ID 1545 //
     /* 296792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 296801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296813 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 296813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 296818 */   GIR_RootConstrainSelectedInstOperands,
     /* 296819 */   // GIR_Coverage, 1545,
     /* 296819 */   GIR_Done,
     /* 296820 */ // Label 5904: @296820
     /* 296820 */ GIM_Reject,
     /* 296821 */ // Label 5892: @296821
     /* 296821 */ GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(296854), // Rule ID 1541 //
     /* 296826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 296832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 296835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296847 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 296847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 296852 */   GIR_RootConstrainSelectedInstOperands,
     /* 296853 */   // GIR_Coverage, 1541,
     /* 296853 */   GIR_Done,
     /* 296854 */ // Label 5905: @296854
     /* 296854 */ GIM_Reject,
     /* 296855 */ // Label 5893: @296855
     /* 296855 */ GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(296888), // Rule ID 1544 //
     /* 296860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 296869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296881 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 296881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 296886 */   GIR_RootConstrainSelectedInstOperands,
     /* 296887 */   // GIR_Coverage, 1544,
     /* 296887 */   GIR_Done,
     /* 296888 */ // Label 5906: @296888
     /* 296888 */ GIM_Reject,
     /* 296889 */ // Label 5894: @296889
     /* 296889 */ GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(296922), // Rule ID 1539 //
     /* 296894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 296900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 296903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296915 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 296920 */   GIR_RootConstrainSelectedInstOperands,
     /* 296921 */   // GIR_Coverage, 1539,
     /* 296921 */   GIR_Done,
     /* 296922 */ // Label 5907: @296922
     /* 296922 */ GIM_Reject,
     /* 296923 */ // Label 5895: @296923
     /* 296923 */ GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(296956), // Rule ID 1542 //
     /* 296928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 296937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296949 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 296949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 296954 */   GIR_RootConstrainSelectedInstOperands,
     /* 296955 */   // GIR_Coverage, 1542,
     /* 296955 */   GIR_Done,
     /* 296956 */ // Label 5908: @296956
     /* 296956 */ GIM_Reject,
     /* 296957 */ // Label 5896: @296957
     /* 296957 */ GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(296990), // Rule ID 1540 //
     /* 296962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 296968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 296971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296983 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 296988 */   GIR_RootConstrainSelectedInstOperands,
     /* 296989 */   // GIR_Coverage, 1540,
     /* 296989 */   GIR_Done,
     /* 296990 */ // Label 5909: @296990
     /* 296990 */ GIM_Reject,
     /* 296991 */ // Label 5897: @296991
     /* 296991 */ GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(297016), // Rule ID 7495 //
     /* 296996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 297002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 297005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297009 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 297009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 297014 */   GIR_RootConstrainSelectedInstOperands,
     /* 297015 */   // GIR_Coverage, 7495,
     /* 297015 */   GIR_Done,
     /* 297016 */ // Label 5910: @297016
     /* 297016 */ GIM_Reject,
     /* 297017 */ // Label 5898: @297017
     /* 297017 */ GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(297042), // Rule ID 7494 //
     /* 297022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 297028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 297031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297035 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 297035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 297040 */   GIR_RootConstrainSelectedInstOperands,
     /* 297041 */   // GIR_Coverage, 7494,
     /* 297041 */   GIR_Done,
     /* 297042 */ // Label 5911: @297042
     /* 297042 */ GIM_Reject,
     /* 297043 */ // Label 5899: @297043
     /* 297043 */ GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(297068), // Rule ID 7493 //
     /* 297048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 297054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 297057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297061 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 297061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 297066 */   GIR_RootConstrainSelectedInstOperands,
     /* 297067 */   // GIR_Coverage, 7493,
     /* 297067 */   GIR_Done,
     /* 297068 */ // Label 5912: @297068
     /* 297068 */ GIM_Reject,
     /* 297069 */ // Label 5900: @297069
     /* 297069 */ GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(297094), // Rule ID 7492 //
     /* 297074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 297080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 297083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297087 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 297087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 297092 */   GIR_RootConstrainSelectedInstOperands,
     /* 297093 */   // GIR_Coverage, 7492,
     /* 297093 */   GIR_Done,
     /* 297094 */ // Label 5913: @297094
     /* 297094 */ GIM_Reject,
     /* 297095 */ // Label 5901: @297095
     /* 297095 */ GIM_Reject,
     /* 297096 */ // Label 56: @297096
     /* 297096 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5926*/ GIMT_Encode4(299471),
     /* 297107 */ /*GILLT_s64*//*Label 5914*/ GIMT_Encode4(297191), GIMT_Encode4(0),
     /* 297115 */ /*GILLT_v2s32*//*Label 5915*/ GIMT_Encode4(297225),
     /* 297119 */ /*GILLT_v2s64*//*Label 5916*/ GIMT_Encode4(297259),
     /* 297123 */ /*GILLT_v4s16*//*Label 5917*/ GIMT_Encode4(298245),
     /* 297127 */ /*GILLT_v4s32*//*Label 5918*/ GIMT_Encode4(298279),
     /* 297131 */ /*GILLT_v8s8*//*Label 5919*/ GIMT_Encode4(299265),
     /* 297135 */ /*GILLT_v8s16*//*Label 5920*/ GIMT_Encode4(299299),
     /* 297139 */ /*GILLT_v16s8*//*Label 5921*/ GIMT_Encode4(299333), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297159 */ /*GILLT_nxv2s64*//*Label 5922*/ GIMT_Encode4(299367), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297171 */ /*GILLT_nxv4s32*//*Label 5923*/ GIMT_Encode4(299393), GIMT_Encode4(0),
     /* 297179 */ /*GILLT_nxv8s16*//*Label 5924*/ GIMT_Encode4(299419), GIMT_Encode4(0),
     /* 297187 */ /*GILLT_nxv16s8*//*Label 5925*/ GIMT_Encode4(299445),
     /* 297191 */ // Label 5914: @297191
     /* 297191 */ GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(297224), // Rule ID 1636 //
     /* 297196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297217 */   // (saddsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 297217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 297222 */   GIR_RootConstrainSelectedInstOperands,
     /* 297223 */   // GIR_Coverage, 1636,
     /* 297223 */   GIR_Done,
     /* 297224 */ // Label 5927: @297224
     /* 297224 */ GIM_Reject,
     /* 297225 */ // Label 5915: @297225
     /* 297225 */ GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(297258), // Rule ID 1420 //
     /* 297230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 297236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297251 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 297251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 297256 */   GIR_RootConstrainSelectedInstOperands,
     /* 297257 */   // GIR_Coverage, 1420,
     /* 297257 */   GIR_Done,
     /* 297258 */ // Label 5928: @297258
     /* 297258 */ GIM_Reject,
     /* 297259 */ // Label 5916: @297259
     /* 297259 */ GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(298244),
     /* 297264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 297270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297274 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(297396), // Rule ID 13586 //
     /* 297279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297290 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297293 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297302 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 297310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 297314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 297322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 297326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297330 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297334 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297347 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297351 */     // MIs[4] Operand 1
     /* 297351 */     // No operand predicates
     /* 297351 */     // MIs[2] Operand 2
     /* 297351 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 297362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297366 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297375 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 297375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 297378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 297382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 297387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297394 */     GIR_RootConstrainSelectedInstOperands,
     /* 297395 */     // GIR_Coverage, 13586,
     /* 297395 */     GIR_EraseRootFromParent_Done,
     /* 297396 */   // Label 5930: @297396
     /* 297396 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(297518), // Rule ID 2060 //
     /* 297401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297416 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297419 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297428 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 297436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 297440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 297448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 297452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297456 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297460 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297465 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297469 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297473 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297477 */     // MIs[4] Operand 1
     /* 297477 */     // No operand predicates
     /* 297477 */     // MIs[2] Operand 2
     /* 297477 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 297488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297497 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 297497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 297500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 297504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 297509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297516 */     GIR_RootConstrainSelectedInstOperands,
     /* 297517 */     // GIR_Coverage, 2060,
     /* 297517 */     GIR_EraseRootFromParent_Done,
     /* 297518 */   // Label 5931: @297518
     /* 297518 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(297637), // Rule ID 13584 //
     /* 297523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297534 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297537 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297546 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 297559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 297563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 297571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 297575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297583 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297596 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297600 */     // MIs[4] Operand 1
     /* 297600 */     // No operand predicates
     /* 297600 */     // MIs[2] Operand 2
     /* 297600 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 297611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297615 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297617 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 297617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 297620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 297624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 297628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297635 */     GIR_RootConstrainSelectedInstOperands,
     /* 297636 */     // GIR_Coverage, 13584,
     /* 297636 */     GIR_EraseRootFromParent_Done,
     /* 297637 */   // Label 5932: @297637
     /* 297637 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(297756), // Rule ID 2058 //
     /* 297642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297657 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297660 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297669 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 297682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 297686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 297694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 297698 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297702 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297706 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297711 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297715 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297719 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297723 */     // MIs[4] Operand 1
     /* 297723 */     // No operand predicates
     /* 297723 */     // MIs[2] Operand 2
     /* 297723 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 297734 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297736 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 297736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 297739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 297743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 297747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297754 */     GIR_RootConstrainSelectedInstOperands,
     /* 297755 */     // GIR_Coverage, 2058,
     /* 297755 */     GIR_EraseRootFromParent_Done,
     /* 297756 */   // Label 5933: @297756
     /* 297756 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(297827), // Rule ID 13484 //
     /* 297761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297772 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297775 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297784 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297808 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 297808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 297811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 297815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 297820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 297825 */     GIR_RootConstrainSelectedInstOperands,
     /* 297826 */     // GIR_Coverage, 13484,
     /* 297826 */     GIR_EraseRootFromParent_Done,
     /* 297827 */   // Label 5934: @297827
     /* 297827 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(297898), // Rule ID 1745 //
     /* 297832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297847 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297850 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297859 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297879 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 297879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 297882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 297886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 297891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 297896 */     GIR_RootConstrainSelectedInstOperands,
     /* 297897 */     // GIR_Coverage, 1745,
     /* 297897 */     GIR_EraseRootFromParent_Done,
     /* 297898 */   // Label 5935: @297898
     /* 297898 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(297994), // Rule ID 13585 //
     /* 297903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297914 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297917 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297926 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 297939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 297943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297964 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297968 */     // MIs[3] Operand 1
     /* 297968 */     // No operand predicates
     /* 297968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297974 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 297974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 297977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 297981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 297985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297992 */     GIR_RootConstrainSelectedInstOperands,
     /* 297993 */     // GIR_Coverage, 13585,
     /* 297993 */     GIR_EraseRootFromParent_Done,
     /* 297994 */   // Label 5936: @297994
     /* 297994 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(298090), // Rule ID 2059 //
     /* 297999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298014 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298017 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298026 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 298030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 298043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298064 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298068 */     // MIs[3] Operand 1
     /* 298068 */     // No operand predicates
     /* 298068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298070 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 298073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 298077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298088 */     GIR_RootConstrainSelectedInstOperands,
     /* 298089 */     // GIR_Coverage, 2059,
     /* 298089 */     GIR_EraseRootFromParent_Done,
     /* 298090 */   // Label 5937: @298090
     /* 298090 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(298155), // Rule ID 13483 //
     /* 298095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298106 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298109 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298118 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 298122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298138 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 298141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 298145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 298153 */     GIR_RootConstrainSelectedInstOperands,
     /* 298154 */     // GIR_Coverage, 13483,
     /* 298154 */     GIR_EraseRootFromParent_Done,
     /* 298155 */   // Label 5938: @298155
     /* 298155 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(298220), // Rule ID 1744 //
     /* 298160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 298191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298203 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 298206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 298210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 298218 */     GIR_RootConstrainSelectedInstOperands,
     /* 298219 */     // GIR_Coverage, 1744,
     /* 298219 */     GIR_EraseRootFromParent_Done,
     /* 298220 */   // Label 5939: @298220
     /* 298220 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(298243), // Rule ID 1422 //
     /* 298225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298236 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 298236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 298241 */     GIR_RootConstrainSelectedInstOperands,
     /* 298242 */     // GIR_Coverage, 1422,
     /* 298242 */     GIR_Done,
     /* 298243 */   // Label 5940: @298243
     /* 298243 */   GIM_Reject,
     /* 298244 */ // Label 5929: @298244
     /* 298244 */ GIM_Reject,
     /* 298245 */ // Label 5917: @298245
     /* 298245 */ GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(298278), // Rule ID 1418 //
     /* 298250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298271 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 298271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 298276 */   GIR_RootConstrainSelectedInstOperands,
     /* 298277 */   // GIR_Coverage, 1418,
     /* 298277 */   GIR_Done,
     /* 298278 */ // Label 5941: @298278
     /* 298278 */ GIM_Reject,
     /* 298279 */ // Label 5918: @298279
     /* 298279 */ GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(299264),
     /* 298284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 298290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298294 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(298416), // Rule ID 13583 //
     /* 298299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298310 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298313 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298322 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 298334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298346 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298350 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298354 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298359 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 298363 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298367 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298371 */     // MIs[4] Operand 1
     /* 298371 */     // No operand predicates
     /* 298371 */     // MIs[2] Operand 2
     /* 298371 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 298382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298386 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 298388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298395 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 298398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 298402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 298407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 298411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 298414 */     GIR_RootConstrainSelectedInstOperands,
     /* 298415 */     // GIR_Coverage, 13583,
     /* 298415 */     GIR_EraseRootFromParent_Done,
     /* 298416 */   // Label 5943: @298416
     /* 298416 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(298538), // Rule ID 2057 //
     /* 298421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298436 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298439 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298448 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 298460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298472 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298476 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298480 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298485 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 298489 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298493 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298497 */     // MIs[4] Operand 1
     /* 298497 */     // No operand predicates
     /* 298497 */     // MIs[2] Operand 2
     /* 298497 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 298508 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 298510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298517 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 298520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 298524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 298529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 298533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 298536 */     GIR_RootConstrainSelectedInstOperands,
     /* 298537 */     // GIR_Coverage, 2057,
     /* 298537 */     GIR_EraseRootFromParent_Done,
     /* 298538 */   // Label 5944: @298538
     /* 298538 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(298657), // Rule ID 13581 //
     /* 298543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298554 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298557 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298566 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 298583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298595 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298599 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298603 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 298612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298616 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298620 */     // MIs[4] Operand 1
     /* 298620 */     // No operand predicates
     /* 298620 */     // MIs[2] Operand 2
     /* 298620 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 298631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298635 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 298637 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 298640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 298644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 298652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 298655 */     GIR_RootConstrainSelectedInstOperands,
     /* 298656 */     // GIR_Coverage, 13581,
     /* 298656 */     GIR_EraseRootFromParent_Done,
     /* 298657 */   // Label 5945: @298657
     /* 298657 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(298776), // Rule ID 2055 //
     /* 298662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298677 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298680 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298689 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 298706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298718 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298722 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298726 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 298735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298739 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298743 */     // MIs[4] Operand 1
     /* 298743 */     // No operand predicates
     /* 298743 */     // MIs[2] Operand 2
     /* 298743 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 298754 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 298756 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 298759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 298763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 298771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 298774 */     GIR_RootConstrainSelectedInstOperands,
     /* 298775 */     // GIR_Coverage, 2055,
     /* 298775 */     GIR_EraseRootFromParent_Done,
     /* 298776 */   // Label 5946: @298776
     /* 298776 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(298847), // Rule ID 13482 //
     /* 298781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298792 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298795 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298804 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298828 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 298828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 298831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 298835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 298840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 298845 */     GIR_RootConstrainSelectedInstOperands,
     /* 298846 */     // GIR_Coverage, 13482,
     /* 298846 */     GIR_EraseRootFromParent_Done,
     /* 298847 */   // Label 5947: @298847
     /* 298847 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(298918), // Rule ID 1743 //
     /* 298852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298867 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298870 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298899 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 298899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 298902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 298906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 298911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 298916 */     GIR_RootConstrainSelectedInstOperands,
     /* 298917 */     // GIR_Coverage, 1743,
     /* 298917 */     GIR_EraseRootFromParent_Done,
     /* 298918 */   // Label 5948: @298918
     /* 298918 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(299014), // Rule ID 13582 //
     /* 298923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298934 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298937 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298946 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298971 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298984 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298988 */     // MIs[3] Operand 1
     /* 298988 */     // No operand predicates
     /* 298988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298994 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 298997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299012 */     GIR_RootConstrainSelectedInstOperands,
     /* 299013 */     // GIR_Coverage, 13582,
     /* 299013 */     GIR_EraseRootFromParent_Done,
     /* 299014 */   // Label 5949: @299014
     /* 299014 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(299110), // Rule ID 2056 //
     /* 299019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299034 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299037 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299046 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 299050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 299063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 299076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299084 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 299088 */     // MIs[3] Operand 1
     /* 299088 */     // No operand predicates
     /* 299088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299090 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 299093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299108 */     GIR_RootConstrainSelectedInstOperands,
     /* 299109 */     // GIR_Coverage, 2056,
     /* 299109 */     GIR_EraseRootFromParent_Done,
     /* 299110 */   // Label 5950: @299110
     /* 299110 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(299175), // Rule ID 13481 //
     /* 299115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299126 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299129 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299138 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 299142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299158 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 299158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 299161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 299173 */     GIR_RootConstrainSelectedInstOperands,
     /* 299174 */     // GIR_Coverage, 13481,
     /* 299174 */     GIR_EraseRootFromParent_Done,
     /* 299175 */   // Label 5951: @299175
     /* 299175 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(299240), // Rule ID 1742 //
     /* 299180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299195 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299198 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299207 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 299211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299223 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 299223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 299226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 299238 */     GIR_RootConstrainSelectedInstOperands,
     /* 299239 */     // GIR_Coverage, 1742,
     /* 299239 */     GIR_EraseRootFromParent_Done,
     /* 299240 */   // Label 5952: @299240
     /* 299240 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(299263), // Rule ID 1421 //
     /* 299245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299256 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 299261 */     GIR_RootConstrainSelectedInstOperands,
     /* 299262 */     // GIR_Coverage, 1421,
     /* 299262 */     GIR_Done,
     /* 299263 */   // Label 5953: @299263
     /* 299263 */   GIM_Reject,
     /* 299264 */ // Label 5942: @299264
     /* 299264 */ GIM_Reject,
     /* 299265 */ // Label 5919: @299265
     /* 299265 */ GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(299298), // Rule ID 1416 //
     /* 299270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 299276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 299279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299291 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 299291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 299296 */   GIR_RootConstrainSelectedInstOperands,
     /* 299297 */   // GIR_Coverage, 1416,
     /* 299297 */   GIR_Done,
     /* 299298 */ // Label 5954: @299298
     /* 299298 */ GIM_Reject,
     /* 299299 */ // Label 5920: @299299
     /* 299299 */ GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(299332), // Rule ID 1419 //
     /* 299304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 299313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299325 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 299325 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 299330 */   GIR_RootConstrainSelectedInstOperands,
     /* 299331 */   // GIR_Coverage, 1419,
     /* 299331 */   GIR_Done,
     /* 299332 */ // Label 5955: @299332
     /* 299332 */ GIM_Reject,
     /* 299333 */ // Label 5921: @299333
     /* 299333 */ GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(299366), // Rule ID 1417 //
     /* 299338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 299344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 299347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299359 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 299359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 299364 */   GIR_RootConstrainSelectedInstOperands,
     /* 299365 */   // GIR_Coverage, 1417,
     /* 299365 */   GIR_Done,
     /* 299366 */ // Label 5956: @299366
     /* 299366 */ GIM_Reject,
     /* 299367 */ // Label 5922: @299367
     /* 299367 */ GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(299392), // Rule ID 7491 //
     /* 299372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 299378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 299381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299385 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 299385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 299390 */   GIR_RootConstrainSelectedInstOperands,
     /* 299391 */   // GIR_Coverage, 7491,
     /* 299391 */   GIR_Done,
     /* 299392 */ // Label 5957: @299392
     /* 299392 */ GIM_Reject,
     /* 299393 */ // Label 5923: @299393
     /* 299393 */ GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(299418), // Rule ID 7490 //
     /* 299398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 299404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 299407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299411 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 299411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 299416 */   GIR_RootConstrainSelectedInstOperands,
     /* 299417 */   // GIR_Coverage, 7490,
     /* 299417 */   GIR_Done,
     /* 299418 */ // Label 5958: @299418
     /* 299418 */ GIM_Reject,
     /* 299419 */ // Label 5924: @299419
     /* 299419 */ GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(299444), // Rule ID 7489 //
     /* 299424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 299430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 299433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299437 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 299437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 299442 */   GIR_RootConstrainSelectedInstOperands,
     /* 299443 */   // GIR_Coverage, 7489,
     /* 299443 */   GIR_Done,
     /* 299444 */ // Label 5959: @299444
     /* 299444 */ GIM_Reject,
     /* 299445 */ // Label 5925: @299445
     /* 299445 */ GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(299470), // Rule ID 7488 //
     /* 299450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 299456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 299459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299463 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 299463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 299468 */   GIR_RootConstrainSelectedInstOperands,
     /* 299469 */   // GIR_Coverage, 7488,
     /* 299469 */   GIR_Done,
     /* 299470 */ // Label 5960: @299470
     /* 299470 */ GIM_Reject,
     /* 299471 */ // Label 5926: @299471
     /* 299471 */ GIM_Reject,
     /* 299472 */ // Label 57: @299472
     /* 299472 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5973*/ GIMT_Encode4(299943),
     /* 299483 */ /*GILLT_s64*//*Label 5961*/ GIMT_Encode4(299567), GIMT_Encode4(0),
     /* 299491 */ /*GILLT_v2s32*//*Label 5962*/ GIMT_Encode4(299601),
     /* 299495 */ /*GILLT_v2s64*//*Label 5963*/ GIMT_Encode4(299635),
     /* 299499 */ /*GILLT_v4s16*//*Label 5964*/ GIMT_Encode4(299669),
     /* 299503 */ /*GILLT_v4s32*//*Label 5965*/ GIMT_Encode4(299703),
     /* 299507 */ /*GILLT_v8s8*//*Label 5966*/ GIMT_Encode4(299737),
     /* 299511 */ /*GILLT_v8s16*//*Label 5967*/ GIMT_Encode4(299771),
     /* 299515 */ /*GILLT_v16s8*//*Label 5968*/ GIMT_Encode4(299805), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299535 */ /*GILLT_nxv2s64*//*Label 5969*/ GIMT_Encode4(299839), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299547 */ /*GILLT_nxv4s32*//*Label 5970*/ GIMT_Encode4(299865), GIMT_Encode4(0),
     /* 299555 */ /*GILLT_nxv8s16*//*Label 5971*/ GIMT_Encode4(299891), GIMT_Encode4(0),
     /* 299563 */ /*GILLT_nxv16s8*//*Label 5972*/ GIMT_Encode4(299917),
     /* 299567 */ // Label 5961: @299567
     /* 299567 */ GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(299600), // Rule ID 1648 //
     /* 299572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 299581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299593 */   // (usubsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 299593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 299598 */   GIR_RootConstrainSelectedInstOperands,
     /* 299599 */   // GIR_Coverage, 1648,
     /* 299599 */   GIR_Done,
     /* 299600 */ // Label 5974: @299600
     /* 299600 */ GIM_Reject,
     /* 299601 */ // Label 5962: @299601
     /* 299601 */ GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(299634), // Rule ID 1564 //
     /* 299606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299627 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 299627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 299632 */   GIR_RootConstrainSelectedInstOperands,
     /* 299633 */   // GIR_Coverage, 1564,
     /* 299633 */   GIR_Done,
     /* 299634 */ // Label 5975: @299634
     /* 299634 */ GIM_Reject,
     /* 299635 */ // Label 5963: @299635
     /* 299635 */ GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(299668), // Rule ID 1566 //
     /* 299640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 299649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299661 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 299661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 299666 */   GIR_RootConstrainSelectedInstOperands,
     /* 299667 */   // GIR_Coverage, 1566,
     /* 299667 */   GIR_Done,
     /* 299668 */ // Label 5976: @299668
     /* 299668 */ GIM_Reject,
     /* 299669 */ // Label 5964: @299669
     /* 299669 */ GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(299702), // Rule ID 1562 //
     /* 299674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299695 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 299695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 299700 */   GIR_RootConstrainSelectedInstOperands,
     /* 299701 */   // GIR_Coverage, 1562,
     /* 299701 */   GIR_Done,
     /* 299702 */ // Label 5977: @299702
     /* 299702 */ GIM_Reject,
     /* 299703 */ // Label 5965: @299703
     /* 299703 */ GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(299736), // Rule ID 1565 //
     /* 299708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 299717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299729 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 299734 */   GIR_RootConstrainSelectedInstOperands,
     /* 299735 */   // GIR_Coverage, 1565,
     /* 299735 */   GIR_Done,
     /* 299736 */ // Label 5978: @299736
     /* 299736 */ GIM_Reject,
     /* 299737 */ // Label 5966: @299737
     /* 299737 */ GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(299770), // Rule ID 1560 //
     /* 299742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 299748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 299751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299763 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 299763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 299768 */   GIR_RootConstrainSelectedInstOperands,
     /* 299769 */   // GIR_Coverage, 1560,
     /* 299769 */   GIR_Done,
     /* 299770 */ // Label 5979: @299770
     /* 299770 */ GIM_Reject,
     /* 299771 */ // Label 5967: @299771
     /* 299771 */ GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(299804), // Rule ID 1563 //
     /* 299776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 299785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299797 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 299797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 299802 */   GIR_RootConstrainSelectedInstOperands,
     /* 299803 */   // GIR_Coverage, 1563,
     /* 299803 */   GIR_Done,
     /* 299804 */ // Label 5980: @299804
     /* 299804 */ GIM_Reject,
     /* 299805 */ // Label 5968: @299805
     /* 299805 */ GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(299838), // Rule ID 1561 //
     /* 299810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 299816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 299819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299831 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 299831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 299836 */   GIR_RootConstrainSelectedInstOperands,
     /* 299837 */   // GIR_Coverage, 1561,
     /* 299837 */   GIR_Done,
     /* 299838 */ // Label 5981: @299838
     /* 299838 */ GIM_Reject,
     /* 299839 */ // Label 5969: @299839
     /* 299839 */ GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(299864), // Rule ID 7503 //
     /* 299844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 299850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 299853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299857 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 299857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 299862 */   GIR_RootConstrainSelectedInstOperands,
     /* 299863 */   // GIR_Coverage, 7503,
     /* 299863 */   GIR_Done,
     /* 299864 */ // Label 5982: @299864
     /* 299864 */ GIM_Reject,
     /* 299865 */ // Label 5970: @299865
     /* 299865 */ GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(299890), // Rule ID 7502 //
     /* 299870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 299876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 299879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299883 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 299883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 299888 */   GIR_RootConstrainSelectedInstOperands,
     /* 299889 */   // GIR_Coverage, 7502,
     /* 299889 */   GIR_Done,
     /* 299890 */ // Label 5983: @299890
     /* 299890 */ GIM_Reject,
     /* 299891 */ // Label 5971: @299891
     /* 299891 */ GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(299916), // Rule ID 7501 //
     /* 299896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 299902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 299905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299909 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 299909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 299914 */   GIR_RootConstrainSelectedInstOperands,
     /* 299915 */   // GIR_Coverage, 7501,
     /* 299915 */   GIR_Done,
     /* 299916 */ // Label 5984: @299916
     /* 299916 */ GIM_Reject,
     /* 299917 */ // Label 5972: @299917
     /* 299917 */ GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(299942), // Rule ID 7500 //
     /* 299922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 299928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 299931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299935 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 299935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 299940 */   GIR_RootConstrainSelectedInstOperands,
     /* 299941 */   // GIR_Coverage, 7500,
     /* 299941 */   GIR_Done,
     /* 299942 */ // Label 5985: @299942
     /* 299942 */ GIM_Reject,
     /* 299943 */ // Label 5973: @299943
     /* 299943 */ GIM_Reject,
     /* 299944 */ // Label 58: @299944
     /* 299944 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5998*/ GIMT_Encode4(301333),
     /* 299955 */ /*GILLT_s64*//*Label 5986*/ GIMT_Encode4(300039), GIMT_Encode4(0),
     /* 299963 */ /*GILLT_v2s32*//*Label 5987*/ GIMT_Encode4(300073),
     /* 299967 */ /*GILLT_v2s64*//*Label 5988*/ GIMT_Encode4(300107),
     /* 299971 */ /*GILLT_v4s16*//*Label 5989*/ GIMT_Encode4(300600),
     /* 299975 */ /*GILLT_v4s32*//*Label 5990*/ GIMT_Encode4(300634),
     /* 299979 */ /*GILLT_v8s8*//*Label 5991*/ GIMT_Encode4(301127),
     /* 299983 */ /*GILLT_v8s16*//*Label 5992*/ GIMT_Encode4(301161),
     /* 299987 */ /*GILLT_v16s8*//*Label 5993*/ GIMT_Encode4(301195), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300007 */ /*GILLT_nxv2s64*//*Label 5994*/ GIMT_Encode4(301229), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300019 */ /*GILLT_nxv4s32*//*Label 5995*/ GIMT_Encode4(301255), GIMT_Encode4(0),
     /* 300027 */ /*GILLT_nxv8s16*//*Label 5996*/ GIMT_Encode4(301281), GIMT_Encode4(0),
     /* 300035 */ /*GILLT_nxv16s8*//*Label 5997*/ GIMT_Encode4(301307),
     /* 300039 */ // Label 5986: @300039
     /* 300039 */ GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(300072), // Rule ID 1641 //
     /* 300044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 300053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300065 */   // (ssubsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 300065 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 300070 */   GIR_RootConstrainSelectedInstOperands,
     /* 300071 */   // GIR_Coverage, 1641,
     /* 300071 */   GIR_Done,
     /* 300072 */ // Label 5999: @300072
     /* 300072 */ GIM_Reject,
     /* 300073 */ // Label 5987: @300073
     /* 300073 */ GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(300106), // Rule ID 1449 //
     /* 300078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300099 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 300099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 300104 */   GIR_RootConstrainSelectedInstOperands,
     /* 300105 */   // GIR_Coverage, 1449,
     /* 300105 */   GIR_Done,
     /* 300106 */ // Label 6000: @300106
     /* 300106 */ GIM_Reject,
     /* 300107 */ // Label 5988: @300107
     /* 300107 */ GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(300599),
     /* 300112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 300118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300126 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(300244), // Rule ID 2067 //
     /* 300131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300142 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300145 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300154 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300178 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300182 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300186 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300191 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300195 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300199 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300203 */     // MIs[4] Operand 1
     /* 300203 */     // No operand predicates
     /* 300203 */     // MIs[2] Operand 2
     /* 300203 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 300214 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 300223 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 300226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300242 */     GIR_RootConstrainSelectedInstOperands,
     /* 300243 */     // GIR_Coverage, 2067,
     /* 300243 */     GIR_EraseRootFromParent_Done,
     /* 300244 */   // Label 6002: @300244
     /* 300244 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(300359), // Rule ID 2065 //
     /* 300249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300260 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300263 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300272 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300301 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300305 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300309 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300314 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300318 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300322 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300326 */     // MIs[4] Operand 1
     /* 300326 */     // No operand predicates
     /* 300326 */     // MIs[2] Operand 2
     /* 300326 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300337 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300339 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 300342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300357 */     GIR_RootConstrainSelectedInstOperands,
     /* 300358 */     // GIR_Coverage, 2065,
     /* 300358 */     GIR_EraseRootFromParent_Done,
     /* 300359 */   // Label 6003: @300359
     /* 300359 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(300426), // Rule ID 1749 //
     /* 300364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300375 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300378 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 300400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 300407 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 300407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 300410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300424 */     GIR_RootConstrainSelectedInstOperands,
     /* 300425 */     // GIR_Coverage, 1749,
     /* 300425 */     GIR_EraseRootFromParent_Done,
     /* 300426 */   // Label 6004: @300426
     /* 300426 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(300518), // Rule ID 2066 //
     /* 300431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300442 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300445 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300454 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300492 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300496 */     // MIs[3] Operand 1
     /* 300496 */     // No operand predicates
     /* 300496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300498 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 300501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300516 */     GIR_RootConstrainSelectedInstOperands,
     /* 300517 */     // GIR_Coverage, 2066,
     /* 300517 */     GIR_EraseRootFromParent_Done,
     /* 300518 */   // Label 6005: @300518
     /* 300518 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(300579), // Rule ID 1748 //
     /* 300523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300534 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300537 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300546 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300562 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 300562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 300565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 300577 */     GIR_RootConstrainSelectedInstOperands,
     /* 300578 */     // GIR_Coverage, 1748,
     /* 300578 */     GIR_EraseRootFromParent_Done,
     /* 300579 */   // Label 6006: @300579
     /* 300579 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(300598), // Rule ID 1451 //
     /* 300584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300591 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 300591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 300596 */     GIR_RootConstrainSelectedInstOperands,
     /* 300597 */     // GIR_Coverage, 1451,
     /* 300597 */     GIR_Done,
     /* 300598 */   // Label 6007: @300598
     /* 300598 */   GIM_Reject,
     /* 300599 */ // Label 6001: @300599
     /* 300599 */ GIM_Reject,
     /* 300600 */ // Label 5989: @300600
     /* 300600 */ GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(300633), // Rule ID 1447 //
     /* 300605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 300611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300626 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 300626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 300631 */   GIR_RootConstrainSelectedInstOperands,
     /* 300632 */   // GIR_Coverage, 1447,
     /* 300632 */   GIR_Done,
     /* 300633 */ // Label 6008: @300633
     /* 300633 */ GIM_Reject,
     /* 300634 */ // Label 5990: @300634
     /* 300634 */ GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(301126),
     /* 300639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 300645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300653 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(300771), // Rule ID 2064 //
     /* 300658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300669 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300672 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300681 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300709 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300713 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300718 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300722 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300726 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300730 */     // MIs[4] Operand 1
     /* 300730 */     // No operand predicates
     /* 300730 */     // MIs[2] Operand 2
     /* 300730 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 300741 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300750 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 300753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300769 */     GIR_RootConstrainSelectedInstOperands,
     /* 300770 */     // GIR_Coverage, 2064,
     /* 300770 */     GIR_EraseRootFromParent_Done,
     /* 300771 */   // Label 6010: @300771
     /* 300771 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(300886), // Rule ID 2062 //
     /* 300776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300787 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300790 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300799 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300828 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300832 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300836 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300841 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300845 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300849 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300853 */     // MIs[4] Operand 1
     /* 300853 */     // No operand predicates
     /* 300853 */     // MIs[2] Operand 2
     /* 300853 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300866 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 300869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300884 */     GIR_RootConstrainSelectedInstOperands,
     /* 300885 */     // GIR_Coverage, 2062,
     /* 300885 */     GIR_EraseRootFromParent_Done,
     /* 300886 */   // Label 6011: @300886
     /* 300886 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(300953), // Rule ID 1747 //
     /* 300891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300902 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300905 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300914 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300934 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 300934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 300937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300951 */     GIR_RootConstrainSelectedInstOperands,
     /* 300952 */     // GIR_Coverage, 1747,
     /* 300952 */     GIR_EraseRootFromParent_Done,
     /* 300953 */   // Label 6012: @300953
     /* 300953 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(301045), // Rule ID 2063 //
     /* 300958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300969 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300972 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300981 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 301011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301019 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 301023 */     // MIs[3] Operand 1
     /* 301023 */     // No operand predicates
     /* 301023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301025 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 301025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 301028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 301036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301043 */     GIR_RootConstrainSelectedInstOperands,
     /* 301044 */     // GIR_Coverage, 2063,
     /* 301044 */     GIR_EraseRootFromParent_Done,
     /* 301045 */   // Label 6013: @301045
     /* 301045 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(301106), // Rule ID 1746 //
     /* 301050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301061 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301064 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301073 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 301077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301089 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 301089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 301092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 301100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 301104 */     GIR_RootConstrainSelectedInstOperands,
     /* 301105 */     // GIR_Coverage, 1746,
     /* 301105 */     GIR_EraseRootFromParent_Done,
     /* 301106 */   // Label 6014: @301106
     /* 301106 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(301125), // Rule ID 1450 //
     /* 301111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301118 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 301118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 301123 */     GIR_RootConstrainSelectedInstOperands,
     /* 301124 */     // GIR_Coverage, 1450,
     /* 301124 */     GIR_Done,
     /* 301125 */   // Label 6015: @301125
     /* 301125 */   GIM_Reject,
     /* 301126 */ // Label 6009: @301126
     /* 301126 */ GIM_Reject,
     /* 301127 */ // Label 5991: @301127
     /* 301127 */ GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(301160), // Rule ID 1445 //
     /* 301132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301153 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 301153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 301158 */   GIR_RootConstrainSelectedInstOperands,
     /* 301159 */   // GIR_Coverage, 1445,
     /* 301159 */   GIR_Done,
     /* 301160 */ // Label 6016: @301160
     /* 301160 */ GIM_Reject,
     /* 301161 */ // Label 5992: @301161
     /* 301161 */ GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(301194), // Rule ID 1448 //
     /* 301166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301187 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 301187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 301192 */   GIR_RootConstrainSelectedInstOperands,
     /* 301193 */   // GIR_Coverage, 1448,
     /* 301193 */   GIR_Done,
     /* 301194 */ // Label 6017: @301194
     /* 301194 */ GIM_Reject,
     /* 301195 */ // Label 5993: @301195
     /* 301195 */ GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(301228), // Rule ID 1446 //
     /* 301200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301221 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 301221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 301226 */   GIR_RootConstrainSelectedInstOperands,
     /* 301227 */   // GIR_Coverage, 1446,
     /* 301227 */   GIR_Done,
     /* 301228 */ // Label 6018: @301228
     /* 301228 */ GIM_Reject,
     /* 301229 */ // Label 5994: @301229
     /* 301229 */ GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(301254), // Rule ID 7499 //
     /* 301234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301247 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301247 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 301252 */   GIR_RootConstrainSelectedInstOperands,
     /* 301253 */   // GIR_Coverage, 7499,
     /* 301253 */   GIR_Done,
     /* 301254 */ // Label 6019: @301254
     /* 301254 */ GIM_Reject,
     /* 301255 */ // Label 5995: @301255
     /* 301255 */ GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(301280), // Rule ID 7498 //
     /* 301260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301273 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 301278 */   GIR_RootConstrainSelectedInstOperands,
     /* 301279 */   // GIR_Coverage, 7498,
     /* 301279 */   GIR_Done,
     /* 301280 */ // Label 6020: @301280
     /* 301280 */ GIM_Reject,
     /* 301281 */ // Label 5996: @301281
     /* 301281 */ GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(301306), // Rule ID 7497 //
     /* 301286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301299 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301299 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 301304 */   GIR_RootConstrainSelectedInstOperands,
     /* 301305 */   // GIR_Coverage, 7497,
     /* 301305 */   GIR_Done,
     /* 301306 */ // Label 6021: @301306
     /* 301306 */ GIM_Reject,
     /* 301307 */ // Label 5997: @301307
     /* 301307 */ GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(301332), // Rule ID 7496 //
     /* 301312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301325 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301325 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 301330 */   GIR_RootConstrainSelectedInstOperands,
     /* 301331 */   // GIR_Coverage, 7496,
     /* 301331 */   GIR_Done,
     /* 301332 */ // Label 6022: @301332
     /* 301332 */ GIM_Reject,
     /* 301333 */ // Label 5998: @301333
     /* 301333 */ GIM_Reject,
     /* 301334 */ // Label 59: @301334
     /* 301334 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6034*/ GIMT_Encode4(303131),
     /* 301345 */ /*GILLT_s16*//*Label 6023*/ GIMT_Encode4(301429),
     /* 301349 */ /*GILLT_s32*//*Label 6024*/ GIMT_Encode4(301655),
     /* 301353 */ /*GILLT_s64*//*Label 6025*/ GIMT_Encode4(302009), GIMT_Encode4(0),
     /* 301361 */ /*GILLT_v2s32*//*Label 6026*/ GIMT_Encode4(302181),
     /* 301365 */ /*GILLT_v2s64*//*Label 6027*/ GIMT_Encode4(302219),
     /* 301369 */ /*GILLT_v4s16*//*Label 6028*/ GIMT_Encode4(302395),
     /* 301373 */ /*GILLT_v4s32*//*Label 6029*/ GIMT_Encode4(302433), GIMT_Encode4(0),
     /* 301381 */ /*GILLT_v8s16*//*Label 6030*/ GIMT_Encode4(302609), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301405 */ /*GILLT_nxv2s64*//*Label 6031*/ GIMT_Encode4(303053), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301417 */ /*GILLT_nxv4s32*//*Label 6032*/ GIMT_Encode4(303079), GIMT_Encode4(0),
     /* 301425 */ /*GILLT_nxv8s16*//*Label 6033*/ GIMT_Encode4(303105),
     /* 301429 */ // Label 6023: @301429
     /* 301429 */ GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(301654),
     /* 301434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 301440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301444 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(301535), // Rule ID 6951 //
     /* 301449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 301474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301486 */     // MIs[2] Rn
     /* 301486 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301491 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 301495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301497 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 301497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301509 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 301528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301533 */     GIR_RootConstrainSelectedInstOperands,
     /* 301534 */     // GIR_Coverage, 6951,
     /* 301534 */     GIR_EraseRootFromParent_Done,
     /* 301535 */   // Label 6036: @301535
     /* 301535 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(301626), // Rule ID 14020 //
     /* 301540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301561 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 301565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301577 */     // MIs[2] Rn
     /* 301577 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301582 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301588 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 301588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301600 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 301619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301624 */     GIR_RootConstrainSelectedInstOperands,
     /* 301625 */     // GIR_Coverage, 14020,
     /* 301625 */     GIR_EraseRootFromParent_Done,
     /* 301626 */   // Label 6037: @301626
     /* 301626 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(301653), // Rule ID 584 //
     /* 301631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 301634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301642 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 301642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 301647 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301651 */     GIR_RootConstrainSelectedInstOperands,
     /* 301652 */     // GIR_Coverage, 584,
     /* 301652 */     GIR_Done,
     /* 301653 */   // Label 6038: @301653
     /* 301653 */   GIM_Reject,
     /* 301654 */ // Label 6035: @301654
     /* 301654 */ GIM_Reject,
     /* 301655 */ // Label 6024: @301655
     /* 301655 */ GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(302008),
     /* 301660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 301666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301670 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(301761), // Rule ID 6949 //
     /* 301675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301696 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 301700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301712 */     // MIs[2] Rn
     /* 301712 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301717 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 301721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301723 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 301723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301735 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 301754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301759 */     GIR_RootConstrainSelectedInstOperands,
     /* 301760 */     // GIR_Coverage, 6949,
     /* 301760 */     GIR_EraseRootFromParent_Done,
     /* 301761 */   // Label 6040: @301761
     /* 301761 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(301825), // Rule ID 13192 //
     /* 301766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301787 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 301791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301803 */     // MIs[2] Rn
     /* 301803 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 301812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301814 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 301814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 301817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301823 */     GIR_RootConstrainSelectedInstOperands,
     /* 301824 */     // GIR_Coverage, 13192,
     /* 301824 */     GIR_EraseRootFromParent_Done,
     /* 301825 */   // Label 6041: @301825
     /* 301825 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(301916), // Rule ID 14018 //
     /* 301830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301851 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 301855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301867 */     // MIs[2] Rn
     /* 301867 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301872 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301878 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 301878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301890 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 301909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301914 */     GIR_RootConstrainSelectedInstOperands,
     /* 301915 */     // GIR_Coverage, 14018,
     /* 301915 */     GIR_EraseRootFromParent_Done,
     /* 301916 */   // Label 6042: @301916
     /* 301916 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(301980), // Rule ID 15845 //
     /* 301921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301942 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 301946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301958 */     // MIs[2] Rn
     /* 301958 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301963 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301969 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 301969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 301972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301978 */     GIR_RootConstrainSelectedInstOperands,
     /* 301979 */     // GIR_Coverage, 15845,
     /* 301979 */     GIR_EraseRootFromParent_Done,
     /* 301980 */   // Label 6043: @301980
     /* 301980 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(302007), // Rule ID 586 //
     /* 301985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301996 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 301996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 302001 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302005 */     GIR_RootConstrainSelectedInstOperands,
     /* 302006 */     // GIR_Coverage, 586,
     /* 302006 */     GIR_Done,
     /* 302007 */   // Label 6044: @302007
     /* 302007 */   GIM_Reject,
     /* 302008 */ // Label 6039: @302008
     /* 302008 */ GIM_Reject,
     /* 302009 */ // Label 6025: @302009
     /* 302009 */ GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(302180),
     /* 302014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 302020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302024 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(302088), // Rule ID 6947 //
     /* 302029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302050 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 302054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302066 */     // MIs[2] Rn
     /* 302066 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302071 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 302075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302077 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 302077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 302080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302086 */     GIR_RootConstrainSelectedInstOperands,
     /* 302087 */     // GIR_Coverage, 6947,
     /* 302087 */     GIR_EraseRootFromParent_Done,
     /* 302088 */   // Label 6046: @302088
     /* 302088 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(302152), // Rule ID 14016 //
     /* 302093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302114 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 302118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302130 */     // MIs[2] Rn
     /* 302130 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302135 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302141 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 302141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 302144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302150 */     GIR_RootConstrainSelectedInstOperands,
     /* 302151 */     // GIR_Coverage, 14016,
     /* 302151 */     GIR_EraseRootFromParent_Done,
     /* 302152 */   // Label 6047: @302152
     /* 302152 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(302179), // Rule ID 588 //
     /* 302157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302168 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 302168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 302173 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302177 */     GIR_RootConstrainSelectedInstOperands,
     /* 302178 */     // GIR_Coverage, 588,
     /* 302178 */     GIR_Done,
     /* 302179 */   // Label 6048: @302179
     /* 302179 */   GIM_Reject,
     /* 302180 */ // Label 6045: @302180
     /* 302180 */ GIM_Reject,
     /* 302181 */ // Label 6026: @302181
     /* 302181 */ GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(302218), // Rule ID 1203 //
     /* 302186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302207 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 302207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 302212 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302216 */   GIR_RootConstrainSelectedInstOperands,
     /* 302217 */   // GIR_Coverage, 1203,
     /* 302217 */   GIR_Done,
     /* 302218 */ // Label 6049: @302218
     /* 302218 */ GIM_Reject,
     /* 302219 */ // Label 6027: @302219
     /* 302219 */ GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(302394),
     /* 302224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 302230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302234 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(302300), // Rule ID 6969 //
     /* 302239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 302247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 302255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 302273 */     // MIs[2] Rn
     /* 302273 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302278 */     // MIs[2] Rm
     /* 302278 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302285 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 302285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 302288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302298 */     GIR_RootConstrainSelectedInstOperands,
     /* 302299 */     // GIR_Coverage, 6969,
     /* 302299 */     GIR_EraseRootFromParent_Done,
     /* 302300 */   // Label 6051: @302300
     /* 302300 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(302366), // Rule ID 14028 //
     /* 302305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 302313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 302321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 302339 */     // MIs[2] Rn
     /* 302339 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302344 */     // MIs[2] Rm
     /* 302344 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302351 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 302351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 302354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302364 */     GIR_RootConstrainSelectedInstOperands,
     /* 302365 */     // GIR_Coverage, 14028,
     /* 302365 */     GIR_EraseRootFromParent_Done,
     /* 302366 */   // Label 6052: @302366
     /* 302366 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(302393), // Rule ID 1207 //
     /* 302371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302382 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 302387 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302391 */     GIR_RootConstrainSelectedInstOperands,
     /* 302392 */     // GIR_Coverage, 1207,
     /* 302392 */     GIR_Done,
     /* 302393 */   // Label 6053: @302393
     /* 302393 */   GIM_Reject,
     /* 302394 */ // Label 6050: @302394
     /* 302394 */ GIM_Reject,
     /* 302395 */ // Label 6028: @302395
     /* 302395 */ GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(302432), // Rule ID 1199 //
     /* 302400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302421 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 302421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 302426 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302430 */   GIR_RootConstrainSelectedInstOperands,
     /* 302431 */   // GIR_Coverage, 1199,
     /* 302431 */   GIR_Done,
     /* 302432 */ // Label 6054: @302432
     /* 302432 */ GIM_Reject,
     /* 302433 */ // Label 6029: @302433
     /* 302433 */ GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(302608),
     /* 302438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302448 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(302514), // Rule ID 6970 //
     /* 302453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 302461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 302487 */     // MIs[2] Rn
     /* 302487 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302492 */     // MIs[2] Rm
     /* 302492 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302499 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 302499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 302502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302512 */     GIR_RootConstrainSelectedInstOperands,
     /* 302513 */     // GIR_Coverage, 6970,
     /* 302513 */     GIR_EraseRootFromParent_Done,
     /* 302514 */   // Label 6056: @302514
     /* 302514 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(302580), // Rule ID 14029 //
     /* 302519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 302527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 302553 */     // MIs[2] Rn
     /* 302553 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302558 */     // MIs[2] Rm
     /* 302558 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302565 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 302565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 302568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302578 */     GIR_RootConstrainSelectedInstOperands,
     /* 302579 */     // GIR_Coverage, 14029,
     /* 302579 */     GIR_EraseRootFromParent_Done,
     /* 302580 */   // Label 6057: @302580
     /* 302580 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(302607), // Rule ID 1205 //
     /* 302585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302596 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 302596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 302601 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302605 */     GIR_RootConstrainSelectedInstOperands,
     /* 302606 */     // GIR_Coverage, 1205,
     /* 302606 */     GIR_Done,
     /* 302607 */   // Label 6058: @302607
     /* 302607 */   GIM_Reject,
     /* 302608 */ // Label 6055: @302608
     /* 302608 */ GIM_Reject,
     /* 302609 */ // Label 6030: @302609
     /* 302609 */ GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(303052),
     /* 302614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302624 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(302693), // Rule ID 6971 //
     /* 302629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 302640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 302666 */     // MIs[2] Rn
     /* 302666 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302671 */     // MIs[2] Rm
     /* 302671 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302678 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 302678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 302681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302691 */     GIR_RootConstrainSelectedInstOperands,
     /* 302692 */     // GIR_Coverage, 6971,
     /* 302692 */     GIR_EraseRootFromParent_Done,
     /* 302693 */   // Label 6060: @302693
     /* 302693 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(302762), // Rule ID 14030 //
     /* 302698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 302709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 302735 */     // MIs[2] Rn
     /* 302735 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302740 */     // MIs[2] Rm
     /* 302740 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302747 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 302747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 302750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302760 */     GIR_RootConstrainSelectedInstOperands,
     /* 302761 */     // GIR_Coverage, 14030,
     /* 302761 */     GIR_EraseRootFromParent_Done,
     /* 302762 */   // Label 6061: @302762
     /* 302762 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(302789), // Rule ID 1201 //
     /* 302767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302778 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 302778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 302783 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302787 */     GIR_RootConstrainSelectedInstOperands,
     /* 302788 */     // GIR_Coverage, 1201,
     /* 302788 */     GIR_Done,
     /* 302789 */   // Label 6062: @302789
     /* 302789 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(303051), // Rule ID 7040 //
     /* 302794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 302797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302805 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 302805 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 302808 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 302812 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302817 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 302821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 302823 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 302826 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 302830 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302835 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 302839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 302841 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 302844 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 302848 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302853 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 302856 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 302859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 302861 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 302864 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302868 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302873 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 302879 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302884 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302889 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 302892 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 302896 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302901 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 302904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 302906 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 302909 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302913 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302918 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302924 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302929 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302934 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 302937 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 302941 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302946 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 302949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 302951 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 302954 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 302958 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302963 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 302966 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 302969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302971 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 302974 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 302978 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302983 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 302986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 302988 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 302991 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302995 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303014 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 303017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 303020 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 303023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 303041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 303049 */     GIR_RootConstrainSelectedInstOperands,
     /* 303050 */     // GIR_Coverage, 7040,
     /* 303050 */     GIR_EraseRootFromParent_Done,
     /* 303051 */   // Label 6063: @303051
     /* 303051 */   GIM_Reject,
     /* 303052 */ // Label 6059: @303052
     /* 303052 */ GIM_Reject,
     /* 303053 */ // Label 6031: @303053
     /* 303053 */ GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(303078), // Rule ID 2817 //
     /* 303058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 303064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 303067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303071 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 303071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 303076 */   GIR_RootConstrainSelectedInstOperands,
     /* 303077 */   // GIR_Coverage, 2817,
     /* 303077 */   GIR_Done,
     /* 303078 */ // Label 6064: @303078
     /* 303078 */ GIM_Reject,
     /* 303079 */ // Label 6032: @303079
     /* 303079 */ GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(303104), // Rule ID 2815 //
     /* 303084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 303090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 303093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303097 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 303097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 303102 */   GIR_RootConstrainSelectedInstOperands,
     /* 303103 */   // GIR_Coverage, 2815,
     /* 303103 */   GIR_Done,
     /* 303104 */ // Label 6065: @303104
     /* 303104 */ GIM_Reject,
     /* 303105 */ // Label 6033: @303105
     /* 303105 */ GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(303130), // Rule ID 2813 //
     /* 303110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 303116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 303119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303123 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 303123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 303128 */   GIR_RootConstrainSelectedInstOperands,
     /* 303129 */   // GIR_Coverage, 2813,
     /* 303129 */   GIR_Done,
     /* 303130 */ // Label 6066: @303130
     /* 303130 */ GIM_Reject,
     /* 303131 */ // Label 6034: @303131
     /* 303131 */ GIM_Reject,
     /* 303132 */ // Label 60: @303132
     /* 303132 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6078*/ GIMT_Encode4(303869),
     /* 303143 */ /*GILLT_s16*//*Label 6067*/ GIMT_Encode4(303227),
     /* 303147 */ /*GILLT_s32*//*Label 6068*/ GIMT_Encode4(303265),
     /* 303151 */ /*GILLT_s64*//*Label 6069*/ GIMT_Encode4(303303), GIMT_Encode4(0),
     /* 303159 */ /*GILLT_v2s32*//*Label 6070*/ GIMT_Encode4(303341),
     /* 303163 */ /*GILLT_v2s64*//*Label 6071*/ GIMT_Encode4(303379),
     /* 303167 */ /*GILLT_v4s16*//*Label 6072*/ GIMT_Encode4(303417),
     /* 303171 */ /*GILLT_v4s32*//*Label 6073*/ GIMT_Encode4(303455), GIMT_Encode4(0),
     /* 303179 */ /*GILLT_v8s16*//*Label 6074*/ GIMT_Encode4(303493), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303203 */ /*GILLT_nxv2s64*//*Label 6075*/ GIMT_Encode4(303791), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303215 */ /*GILLT_nxv4s32*//*Label 6076*/ GIMT_Encode4(303817), GIMT_Encode4(0),
     /* 303223 */ /*GILLT_nxv8s16*//*Label 6077*/ GIMT_Encode4(303843),
     /* 303227 */ // Label 6067: @303227
     /* 303227 */ GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(303264), // Rule ID 632 //
     /* 303232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 303241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303253 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 303253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 303258 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303262 */   GIR_RootConstrainSelectedInstOperands,
     /* 303263 */   // GIR_Coverage, 632,
     /* 303263 */   GIR_Done,
     /* 303264 */ // Label 6079: @303264
     /* 303264 */ GIM_Reject,
     /* 303265 */ // Label 6068: @303265
     /* 303265 */ GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(303302), // Rule ID 634 //
     /* 303270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 303279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303291 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 303291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 303296 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303300 */   GIR_RootConstrainSelectedInstOperands,
     /* 303301 */   // GIR_Coverage, 634,
     /* 303301 */   GIR_Done,
     /* 303302 */ // Label 6080: @303302
     /* 303302 */ GIM_Reject,
     /* 303303 */ // Label 6069: @303303
     /* 303303 */ GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(303340), // Rule ID 636 //
     /* 303308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 303317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303329 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 303329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 303334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303338 */   GIR_RootConstrainSelectedInstOperands,
     /* 303339 */   // GIR_Coverage, 636,
     /* 303339 */   GIR_Done,
     /* 303340 */ // Label 6081: @303340
     /* 303340 */ GIM_Reject,
     /* 303341 */ // Label 6070: @303341
     /* 303341 */ GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(303378), // Rule ID 1343 //
     /* 303346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 303355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303367 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 303372 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303376 */   GIR_RootConstrainSelectedInstOperands,
     /* 303377 */   // GIR_Coverage, 1343,
     /* 303377 */   GIR_Done,
     /* 303378 */ // Label 6082: @303378
     /* 303378 */ GIM_Reject,
     /* 303379 */ // Label 6071: @303379
     /* 303379 */ GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(303416), // Rule ID 1347 //
     /* 303384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303405 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 303405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 303410 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303414 */   GIR_RootConstrainSelectedInstOperands,
     /* 303415 */   // GIR_Coverage, 1347,
     /* 303415 */   GIR_Done,
     /* 303416 */ // Label 6083: @303416
     /* 303416 */ GIM_Reject,
     /* 303417 */ // Label 6072: @303417
     /* 303417 */ GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(303454), // Rule ID 1339 //
     /* 303422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 303431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303443 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 303448 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303452 */   GIR_RootConstrainSelectedInstOperands,
     /* 303453 */   // GIR_Coverage, 1339,
     /* 303453 */   GIR_Done,
     /* 303454 */ // Label 6084: @303454
     /* 303454 */ GIM_Reject,
     /* 303455 */ // Label 6073: @303455
     /* 303455 */ GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(303492), // Rule ID 1345 //
     /* 303460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303481 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 303481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 303486 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303490 */   GIR_RootConstrainSelectedInstOperands,
     /* 303491 */   // GIR_Coverage, 1345,
     /* 303491 */   GIR_Done,
     /* 303492 */ // Label 6085: @303492
     /* 303492 */ GIM_Reject,
     /* 303493 */ // Label 6074: @303493
     /* 303493 */ GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(303790),
     /* 303498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 303504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303516 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(303535), // Rule ID 1341 //
     /* 303521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303524 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 303524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 303529 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303533 */     GIR_RootConstrainSelectedInstOperands,
     /* 303534 */     // GIR_Coverage, 1341,
     /* 303534 */     GIR_Done,
     /* 303535 */   // Label 6087: @303535
     /* 303535 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(303789), // Rule ID 7046 //
     /* 303540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 303543 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 303543 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 303546 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 303550 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303555 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 303559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 303561 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 303564 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 303568 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303573 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 303577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 303579 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 303582 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 303586 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303591 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 303594 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 303597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 303599 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 303602 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303606 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303611 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 303617 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303622 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303627 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 303630 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 303634 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303639 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 303642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 303644 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 303647 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303651 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303656 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303662 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303667 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303672 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 303675 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 303679 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303684 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303689 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 303692 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 303696 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303701 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303704 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 303707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303709 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 303712 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 303716 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303721 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 303726 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303729 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303733 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303752 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 303755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 303758 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 303761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 303779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 303787 */     GIR_RootConstrainSelectedInstOperands,
     /* 303788 */     // GIR_Coverage, 7046,
     /* 303788 */     GIR_EraseRootFromParent_Done,
     /* 303789 */   // Label 6088: @303789
     /* 303789 */   GIM_Reject,
     /* 303790 */ // Label 6086: @303790
     /* 303790 */ GIM_Reject,
     /* 303791 */ // Label 6075: @303791
     /* 303791 */ GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(303816), // Rule ID 8246 //
     /* 303796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 303802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 303805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303809 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 303809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 303814 */   GIR_RootConstrainSelectedInstOperands,
     /* 303815 */   // GIR_Coverage, 8246,
     /* 303815 */   GIR_Done,
     /* 303816 */ // Label 6089: @303816
     /* 303816 */ GIM_Reject,
     /* 303817 */ // Label 6076: @303817
     /* 303817 */ GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(303842), // Rule ID 8244 //
     /* 303822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 303828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 303831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303835 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 303835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 303840 */   GIR_RootConstrainSelectedInstOperands,
     /* 303841 */   // GIR_Coverage, 8244,
     /* 303841 */   GIR_Done,
     /* 303842 */ // Label 6090: @303842
     /* 303842 */ GIM_Reject,
     /* 303843 */ // Label 6077: @303843
     /* 303843 */ GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(303868), // Rule ID 8242 //
     /* 303848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 303854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 303857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303861 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 303861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 303866 */   GIR_RootConstrainSelectedInstOperands,
     /* 303867 */   // GIR_Coverage, 8242,
     /* 303867 */   GIR_Done,
     /* 303868 */ // Label 6091: @303868
     /* 303868 */ GIM_Reject,
     /* 303869 */ // Label 6078: @303869
     /* 303869 */ GIM_Reject,
     /* 303870 */ // Label 61: @303870
     /* 303870 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6103*/ GIMT_Encode4(307965),
     /* 303881 */ /*GILLT_s16*//*Label 6092*/ GIMT_Encode4(303965),
     /* 303885 */ /*GILLT_s32*//*Label 6093*/ GIMT_Encode4(304607),
     /* 303889 */ /*GILLT_s64*//*Label 6094*/ GIMT_Encode4(305237), GIMT_Encode4(0),
     /* 303897 */ /*GILLT_v2s32*//*Label 6095*/ GIMT_Encode4(305867),
     /* 303901 */ /*GILLT_v2s64*//*Label 6096*/ GIMT_Encode4(306397),
     /* 303905 */ /*GILLT_v4s16*//*Label 6097*/ GIMT_Encode4(306755),
     /* 303909 */ /*GILLT_v4s32*//*Label 6098*/ GIMT_Encode4(307097), GIMT_Encode4(0),
     /* 303917 */ /*GILLT_v8s16*//*Label 6099*/ GIMT_Encode4(307455), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303941 */ /*GILLT_nxv2s64*//*Label 6100*/ GIMT_Encode4(307887), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303953 */ /*GILLT_nxv4s32*//*Label 6101*/ GIMT_Encode4(307913), GIMT_Encode4(0),
     /* 303961 */ /*GILLT_nxv8s16*//*Label 6102*/ GIMT_Encode4(307939),
     /* 303965 */ // Label 6092: @303965
     /* 303965 */ GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(304606),
     /* 303970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 303976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303980 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(304093), // Rule ID 6279 //
     /* 303985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304042 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304046 */     // MIs[3] Operand 1
     /* 304046 */     // No operand predicates
     /* 304046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304048 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304060 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 304066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304091 */     GIR_RootConstrainSelectedInstOperands,
     /* 304092 */     // GIR_Coverage, 6279,
     /* 304092 */     GIR_EraseRootFromParent_Done,
     /* 304093 */   // Label 6105: @304093
     /* 304093 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(304206), // Rule ID 13997 //
     /* 304098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304134 */     // MIs[2] Operand 1
     /* 304134 */     // No operand predicates
     /* 304134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 304138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304142 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304146 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 304150 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304155 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 304159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304161 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304173 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 304179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304204 */     GIR_RootConstrainSelectedInstOperands,
     /* 304205 */     // GIR_Coverage, 13997,
     /* 304205 */     GIR_EraseRootFromParent_Done,
     /* 304206 */   // Label 6106: @304206
     /* 304206 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(304285), // Rule ID 13931 //
     /* 304211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304235 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304245 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 304245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304257 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 304263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 304276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304283 */     GIR_RootConstrainSelectedInstOperands,
     /* 304284 */     // GIR_Coverage, 13931,
     /* 304284 */     GIR_EraseRootFromParent_Done,
     /* 304285 */   // Label 6107: @304285
     /* 304285 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(304364), // Rule ID 4836 //
     /* 304290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304318 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304324 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 304324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304336 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 304342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 304355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304362 */     GIR_RootConstrainSelectedInstOperands,
     /* 304363 */     // GIR_Coverage, 4836,
     /* 304363 */     GIR_EraseRootFromParent_Done,
     /* 304364 */   // Label 6108: @304364
     /* 304364 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(304427), // Rule ID 13540 //
     /* 304369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304401 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304405 */     // MIs[2] Operand 1
     /* 304405 */     // No operand predicates
     /* 304405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304411 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 304411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304425 */     GIR_RootConstrainSelectedInstOperands,
     /* 304426 */     // GIR_Coverage, 13540,
     /* 304426 */     GIR_EraseRootFromParent_Done,
     /* 304427 */   // Label 6109: @304427
     /* 304427 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(304490), // Rule ID 2012 //
     /* 304432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304468 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304472 */     // MIs[2] Operand 1
     /* 304472 */     // No operand predicates
     /* 304472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304474 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 304474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304488 */     GIR_RootConstrainSelectedInstOperands,
     /* 304489 */     // GIR_Coverage, 2012,
     /* 304489 */     GIR_EraseRootFromParent_Done,
     /* 304490 */   // Label 6110: @304490
     /* 304490 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(304534), // Rule ID 4841 //
     /* 304495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 304510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304521 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 304521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 304524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 304530 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 304532 */     GIR_RootConstrainSelectedInstOperands,
     /* 304533 */     // GIR_Coverage, 4841,
     /* 304533 */     GIR_EraseRootFromParent_Done,
     /* 304534 */   // Label 6111: @304534
     /* 304534 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(304578), // Rule ID 13936 //
     /* 304539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 304558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304565 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 304565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 304568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 304574 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 304576 */     GIR_RootConstrainSelectedInstOperands,
     /* 304577 */     // GIR_Coverage, 13936,
     /* 304577 */     GIR_EraseRootFromParent_Done,
     /* 304578 */   // Label 6112: @304578
     /* 304578 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(304605), // Rule ID 620 //
     /* 304583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304594 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 304594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 304599 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304603 */     GIR_RootConstrainSelectedInstOperands,
     /* 304604 */     // GIR_Coverage, 620,
     /* 304604 */     GIR_Done,
     /* 304605 */   // Label 6113: @304605
     /* 304605 */   GIM_Reject,
     /* 304606 */ // Label 6104: @304606
     /* 304606 */ GIM_Reject,
     /* 304607 */ // Label 6093: @304607
     /* 304607 */ GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(305236),
     /* 304612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 304618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304622 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(304735), // Rule ID 6281 //
     /* 304627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304651 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304684 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304688 */     // MIs[3] Operand 1
     /* 304688 */     // No operand predicates
     /* 304688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304690 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304702 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 304708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 304721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304733 */     GIR_RootConstrainSelectedInstOperands,
     /* 304734 */     // GIR_Coverage, 6281,
     /* 304734 */     GIR_EraseRootFromParent_Done,
     /* 304735 */   // Label 6115: @304735
     /* 304735 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(304848), // Rule ID 13999 //
     /* 304740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304772 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304776 */     // MIs[2] Operand 1
     /* 304776 */     // No operand predicates
     /* 304776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 304780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 304792 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304797 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 304801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304803 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304815 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 304821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 304834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304846 */     GIR_RootConstrainSelectedInstOperands,
     /* 304847 */     // GIR_Coverage, 13999,
     /* 304847 */     GIR_EraseRootFromParent_Done,
     /* 304848 */   // Label 6116: @304848
     /* 304848 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(304924), // Rule ID 13933 //
     /* 304853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304874 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304884 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 304884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304896 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 304902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 304915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304922 */     GIR_RootConstrainSelectedInstOperands,
     /* 304923 */     // GIR_Coverage, 13933,
     /* 304923 */     GIR_EraseRootFromParent_Done,
     /* 304924 */   // Label 6117: @304924
     /* 304924 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(305000), // Rule ID 4838 //
     /* 304929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304954 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304960 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 304960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304972 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 304978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 304991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304998 */     GIR_RootConstrainSelectedInstOperands,
     /* 304999 */     // GIR_Coverage, 4838,
     /* 304999 */     GIR_EraseRootFromParent_Done,
     /* 305000 */   // Label 6118: @305000
     /* 305000 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(305063), // Rule ID 13542 //
     /* 305005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305037 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305041 */     // MIs[2] Operand 1
     /* 305041 */     // No operand predicates
     /* 305041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305047 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305061 */     GIR_RootConstrainSelectedInstOperands,
     /* 305062 */     // GIR_Coverage, 13542,
     /* 305062 */     GIR_EraseRootFromParent_Done,
     /* 305063 */   // Label 6119: @305063
     /* 305063 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(305126), // Rule ID 2014 //
     /* 305068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305108 */     // MIs[2] Operand 1
     /* 305108 */     // No operand predicates
     /* 305108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305110 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305124 */     GIR_RootConstrainSelectedInstOperands,
     /* 305125 */     // GIR_Coverage, 2014,
     /* 305125 */     GIR_EraseRootFromParent_Done,
     /* 305126 */   // Label 6120: @305126
     /* 305126 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(305167), // Rule ID 4842 //
     /* 305131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305154 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 305154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 305157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305163 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 305165 */     GIR_RootConstrainSelectedInstOperands,
     /* 305166 */     // GIR_Coverage, 4842,
     /* 305166 */     GIR_EraseRootFromParent_Done,
     /* 305167 */   // Label 6121: @305167
     /* 305167 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(305208), // Rule ID 13937 //
     /* 305172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305195 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 305195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 305198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305204 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 305206 */     GIR_RootConstrainSelectedInstOperands,
     /* 305207 */     // GIR_Coverage, 13937,
     /* 305207 */     GIR_EraseRootFromParent_Done,
     /* 305208 */   // Label 6122: @305208
     /* 305208 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(305235), // Rule ID 622 //
     /* 305213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305224 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 305224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 305229 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305233 */     GIR_RootConstrainSelectedInstOperands,
     /* 305234 */     // GIR_Coverage, 622,
     /* 305234 */     GIR_Done,
     /* 305235 */   // Label 6123: @305235
     /* 305235 */   GIM_Reject,
     /* 305236 */ // Label 6114: @305236
     /* 305236 */ GIM_Reject,
     /* 305237 */ // Label 6094: @305237
     /* 305237 */ GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(305866),
     /* 305242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 305248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305252 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(305365), // Rule ID 6283 //
     /* 305257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305281 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305314 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 305318 */     // MIs[3] Operand 1
     /* 305318 */     // No operand predicates
     /* 305318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305320 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 305320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305332 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 305351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305363 */     GIR_RootConstrainSelectedInstOperands,
     /* 305364 */     // GIR_Coverage, 6283,
     /* 305364 */     GIR_EraseRootFromParent_Done,
     /* 305365 */   // Label 6125: @305365
     /* 305365 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(305478), // Rule ID 14001 //
     /* 305370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305402 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 305406 */     // MIs[2] Operand 1
     /* 305406 */     // No operand predicates
     /* 305406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 305410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305414 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 305422 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305427 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 305431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305433 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 305433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305445 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 305464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305476 */     GIR_RootConstrainSelectedInstOperands,
     /* 305477 */     // GIR_Coverage, 14001,
     /* 305477 */     GIR_EraseRootFromParent_Done,
     /* 305478 */   // Label 6126: @305478
     /* 305478 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(305554), // Rule ID 13935 //
     /* 305483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305504 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305514 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 305514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305526 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 305545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305552 */     GIR_RootConstrainSelectedInstOperands,
     /* 305553 */     // GIR_Coverage, 13935,
     /* 305553 */     GIR_EraseRootFromParent_Done,
     /* 305554 */   // Label 6127: @305554
     /* 305554 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(305630), // Rule ID 4840 //
     /* 305559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305584 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305590 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 305590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305602 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 305621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305628 */     GIR_RootConstrainSelectedInstOperands,
     /* 305629 */     // GIR_Coverage, 4840,
     /* 305629 */     GIR_EraseRootFromParent_Done,
     /* 305630 */   // Label 6128: @305630
     /* 305630 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(305693), // Rule ID 13544 //
     /* 305635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305667 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 305671 */     // MIs[2] Operand 1
     /* 305671 */     // No operand predicates
     /* 305671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305677 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 305680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305691 */     GIR_RootConstrainSelectedInstOperands,
     /* 305692 */     // GIR_Coverage, 13544,
     /* 305692 */     GIR_EraseRootFromParent_Done,
     /* 305693 */   // Label 6129: @305693
     /* 305693 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(305756), // Rule ID 2016 //
     /* 305698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305734 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 305738 */     // MIs[2] Operand 1
     /* 305738 */     // No operand predicates
     /* 305738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305740 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 305743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305754 */     GIR_RootConstrainSelectedInstOperands,
     /* 305755 */     // GIR_Coverage, 2016,
     /* 305755 */     GIR_EraseRootFromParent_Done,
     /* 305756 */   // Label 6130: @305756
     /* 305756 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(305797), // Rule ID 4843 //
     /* 305761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305784 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 305784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 305787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305793 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 305795 */     GIR_RootConstrainSelectedInstOperands,
     /* 305796 */     // GIR_Coverage, 4843,
     /* 305796 */     GIR_EraseRootFromParent_Done,
     /* 305797 */   // Label 6131: @305797
     /* 305797 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(305838), // Rule ID 13938 //
     /* 305802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305825 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 305825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 305828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305834 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 305836 */     GIR_RootConstrainSelectedInstOperands,
     /* 305837 */     // GIR_Coverage, 13938,
     /* 305837 */     GIR_EraseRootFromParent_Done,
     /* 305838 */   // Label 6132: @305838
     /* 305838 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(305865), // Rule ID 624 //
     /* 305843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305854 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 305854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 305859 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305863 */     GIR_RootConstrainSelectedInstOperands,
     /* 305864 */     // GIR_Coverage, 624,
     /* 305864 */     GIR_Done,
     /* 305865 */   // Label 6133: @305865
     /* 305865 */   GIM_Reject,
     /* 305866 */ // Label 6124: @305866
     /* 305866 */ GIM_Reject,
     /* 305867 */ // Label 6095: @305867
     /* 305867 */ GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(306396),
     /* 305872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 305875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 305878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305882 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(305968), // Rule ID 13533 //
     /* 305887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 305898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 305910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305931 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305935 */     // MIs[3] Operand 1
     /* 305935 */     // No operand predicates
     /* 305935 */     // MIs[1] Operand 2
     /* 305935 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 305946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305952 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 305955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305966 */     GIR_RootConstrainSelectedInstOperands,
     /* 305967 */     // GIR_Coverage, 13533,
     /* 305967 */     GIR_EraseRootFromParent_Done,
     /* 305968 */   // Label 6135: @305968
     /* 305968 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(306054), // Rule ID 2005 //
     /* 305973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 305988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306021 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306025 */     // MIs[3] Operand 1
     /* 306025 */     // No operand predicates
     /* 306025 */     // MIs[1] Operand 2
     /* 306025 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 306036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306038 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306052 */     GIR_RootConstrainSelectedInstOperands,
     /* 306053 */     // GIR_Coverage, 2005,
     /* 306053 */     GIR_EraseRootFromParent_Done,
     /* 306054 */   // Label 6136: @306054
     /* 306054 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(306117), // Rule ID 13534 //
     /* 306059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306091 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306095 */     // MIs[2] Operand 1
     /* 306095 */     // No operand predicates
     /* 306095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306101 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306115 */     GIR_RootConstrainSelectedInstOperands,
     /* 306116 */     // GIR_Coverage, 13534,
     /* 306116 */     GIR_EraseRootFromParent_Done,
     /* 306117 */   // Label 6137: @306117
     /* 306117 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(306180), // Rule ID 2006 //
     /* 306122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306158 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306162 */     // MIs[2] Operand 1
     /* 306162 */     // No operand predicates
     /* 306162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306164 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306178 */     GIR_RootConstrainSelectedInstOperands,
     /* 306179 */     // GIR_Coverage, 2006,
     /* 306179 */     GIR_EraseRootFromParent_Done,
     /* 306180 */   // Label 6138: @306180
     /* 306180 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(306274), // Rule ID 14003 //
     /* 306185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306208 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306208 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 306211 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306215 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 306225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306234 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306241 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306272 */     GIR_RootConstrainSelectedInstOperands,
     /* 306273 */     // GIR_Coverage, 14003,
     /* 306273 */     GIR_EraseRootFromParent_Done,
     /* 306274 */   // Label 6139: @306274
     /* 306274 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(306368), // Rule ID 6285 //
     /* 306279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306302 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 306305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 306319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306328 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306366 */     GIR_RootConstrainSelectedInstOperands,
     /* 306367 */     // GIR_Coverage, 6285,
     /* 306367 */     GIR_EraseRootFromParent_Done,
     /* 306368 */   // Label 6140: @306368
     /* 306368 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(306395), // Rule ID 1323 //
     /* 306373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306384 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 306384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 306389 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306393 */     GIR_RootConstrainSelectedInstOperands,
     /* 306394 */     // GIR_Coverage, 1323,
     /* 306394 */     GIR_Done,
     /* 306395 */   // Label 6141: @306395
     /* 306395 */   GIM_Reject,
     /* 306396 */ // Label 6134: @306396
     /* 306396 */ GIM_Reject,
     /* 306397 */ // Label 6096: @306397
     /* 306397 */ GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(306754),
     /* 306402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 306408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306412 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(306475), // Rule ID 13538 //
     /* 306417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 306428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306449 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306453 */     // MIs[2] Operand 1
     /* 306453 */     // No operand predicates
     /* 306453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306459 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 306462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306473 */     GIR_RootConstrainSelectedInstOperands,
     /* 306474 */     // GIR_Coverage, 13538,
     /* 306474 */     GIR_EraseRootFromParent_Done,
     /* 306475 */   // Label 6143: @306475
     /* 306475 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(306538), // Rule ID 2010 //
     /* 306480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 306495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306516 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306520 */     // MIs[2] Operand 1
     /* 306520 */     // No operand predicates
     /* 306520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306522 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 306525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306536 */     GIR_RootConstrainSelectedInstOperands,
     /* 306537 */     // GIR_Coverage, 2010,
     /* 306537 */     GIR_EraseRootFromParent_Done,
     /* 306538 */   // Label 6144: @306538
     /* 306538 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(306632), // Rule ID 14007 //
     /* 306543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306566 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 306569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 306583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 306602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 306620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306630 */     GIR_RootConstrainSelectedInstOperands,
     /* 306631 */     // GIR_Coverage, 14007,
     /* 306631 */     GIR_EraseRootFromParent_Done,
     /* 306632 */   // Label 6145: @306632
     /* 306632 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(306726), // Rule ID 6289 //
     /* 306637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306660 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 306663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 306677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306686 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306693 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 306696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 306714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306724 */     GIR_RootConstrainSelectedInstOperands,
     /* 306725 */     // GIR_Coverage, 6289,
     /* 306725 */     GIR_EraseRootFromParent_Done,
     /* 306726 */   // Label 6146: @306726
     /* 306726 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(306753), // Rule ID 1327 //
     /* 306731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306742 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 306742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 306747 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306751 */     GIR_RootConstrainSelectedInstOperands,
     /* 306752 */     // GIR_Coverage, 1327,
     /* 306752 */     GIR_Done,
     /* 306753 */   // Label 6147: @306753
     /* 306753 */   GIM_Reject,
     /* 306754 */ // Label 6142: @306754
     /* 306754 */ GIM_Reject,
     /* 306755 */ // Label 6097: @306755
     /* 306755 */ GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(307096),
     /* 306760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 306763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 306766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306770 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(306856), // Rule ID 13527 //
     /* 306775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 306786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306819 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306823 */     // MIs[3] Operand 1
     /* 306823 */     // No operand predicates
     /* 306823 */     // MIs[1] Operand 2
     /* 306823 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 306834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306840 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 306843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306854 */     GIR_RootConstrainSelectedInstOperands,
     /* 306855 */     // GIR_Coverage, 13527,
     /* 306855 */     GIR_EraseRootFromParent_Done,
     /* 306856 */   // Label 6149: @306856
     /* 306856 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(306942), // Rule ID 1999 //
     /* 306861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 306876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306909 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306913 */     // MIs[3] Operand 1
     /* 306913 */     // No operand predicates
     /* 306913 */     // MIs[1] Operand 2
     /* 306913 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 306924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306926 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 306929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306940 */     GIR_RootConstrainSelectedInstOperands,
     /* 306941 */     // GIR_Coverage, 1999,
     /* 306941 */     GIR_EraseRootFromParent_Done,
     /* 306942 */   // Label 6150: @306942
     /* 306942 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(307005), // Rule ID 13528 //
     /* 306947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306979 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306983 */     // MIs[2] Operand 1
     /* 306983 */     // No operand predicates
     /* 306983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306989 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 306992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307003 */     GIR_RootConstrainSelectedInstOperands,
     /* 307004 */     // GIR_Coverage, 13528,
     /* 307004 */     GIR_EraseRootFromParent_Done,
     /* 307005 */   // Label 6151: @307005
     /* 307005 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(307068), // Rule ID 2000 //
     /* 307010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307046 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307050 */     // MIs[2] Operand 1
     /* 307050 */     // No operand predicates
     /* 307050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307052 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307066 */     GIR_RootConstrainSelectedInstOperands,
     /* 307067 */     // GIR_Coverage, 2000,
     /* 307067 */     GIR_EraseRootFromParent_Done,
     /* 307068 */   // Label 6152: @307068
     /* 307068 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(307095), // Rule ID 1319 //
     /* 307073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307084 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 307084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 307089 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307093 */     GIR_RootConstrainSelectedInstOperands,
     /* 307094 */     // GIR_Coverage, 1319,
     /* 307094 */     GIR_Done,
     /* 307095 */   // Label 6153: @307095
     /* 307095 */   GIM_Reject,
     /* 307096 */ // Label 6148: @307096
     /* 307096 */ GIM_Reject,
     /* 307097 */ // Label 6098: @307097
     /* 307097 */ GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(307454),
     /* 307102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 307108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307112 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(307175), // Rule ID 13536 //
     /* 307117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307149 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307153 */     // MIs[2] Operand 1
     /* 307153 */     // No operand predicates
     /* 307153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307159 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 307162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307173 */     GIR_RootConstrainSelectedInstOperands,
     /* 307174 */     // GIR_Coverage, 13536,
     /* 307174 */     GIR_EraseRootFromParent_Done,
     /* 307175 */   // Label 6155: @307175
     /* 307175 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(307238), // Rule ID 2008 //
     /* 307180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307216 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307220 */     // MIs[2] Operand 1
     /* 307220 */     // No operand predicates
     /* 307220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307222 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 307225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307236 */     GIR_RootConstrainSelectedInstOperands,
     /* 307237 */     // GIR_Coverage, 2008,
     /* 307237 */     GIR_EraseRootFromParent_Done,
     /* 307238 */   // Label 6156: @307238
     /* 307238 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(307332), // Rule ID 14005 //
     /* 307243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307266 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307266 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307269 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307273 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307292 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307295 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307299 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 307320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307330 */     GIR_RootConstrainSelectedInstOperands,
     /* 307331 */     // GIR_Coverage, 14005,
     /* 307331 */     GIR_EraseRootFromParent_Done,
     /* 307332 */   // Label 6157: @307332
     /* 307332 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(307426), // Rule ID 6287 //
     /* 307337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307360 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307386 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307389 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307393 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 307414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307424 */     GIR_RootConstrainSelectedInstOperands,
     /* 307425 */     // GIR_Coverage, 6287,
     /* 307425 */     GIR_EraseRootFromParent_Done,
     /* 307426 */   // Label 6158: @307426
     /* 307426 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(307453), // Rule ID 1325 //
     /* 307431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307442 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 307442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 307447 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307451 */     GIR_RootConstrainSelectedInstOperands,
     /* 307452 */     // GIR_Coverage, 1325,
     /* 307452 */     GIR_Done,
     /* 307453 */   // Label 6159: @307453
     /* 307453 */   GIM_Reject,
     /* 307454 */ // Label 6154: @307454
     /* 307454 */ GIM_Reject,
     /* 307455 */ // Label 6099: @307455
     /* 307455 */ GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(307886),
     /* 307460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 307466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307470 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(307533), // Rule ID 13530 //
     /* 307475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307511 */     // MIs[2] Operand 1
     /* 307511 */     // No operand predicates
     /* 307511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307517 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 307520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307531 */     GIR_RootConstrainSelectedInstOperands,
     /* 307532 */     // GIR_Coverage, 13530,
     /* 307532 */     GIR_EraseRootFromParent_Done,
     /* 307533 */   // Label 6161: @307533
     /* 307533 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(307596), // Rule ID 2002 //
     /* 307538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307578 */     // MIs[2] Operand 1
     /* 307578 */     // No operand predicates
     /* 307578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307580 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 307583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307594 */     GIR_RootConstrainSelectedInstOperands,
     /* 307595 */     // GIR_Coverage, 2002,
     /* 307595 */     GIR_EraseRootFromParent_Done,
     /* 307596 */   // Label 6162: @307596
     /* 307596 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(307623), // Rule ID 1321 //
     /* 307601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307612 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 307612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 307617 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307621 */     GIR_RootConstrainSelectedInstOperands,
     /* 307622 */     // GIR_Coverage, 1321,
     /* 307622 */     GIR_Done,
     /* 307623 */   // Label 6163: @307623
     /* 307623 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(307885), // Rule ID 7044 //
     /* 307628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 307631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307639 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 307639 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 307642 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 307646 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307651 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 307655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 307657 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 307660 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 307664 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307669 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 307673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 307675 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 307678 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 307682 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307687 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 307690 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 307693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 307695 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 307698 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307702 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307707 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307713 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307718 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307723 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 307726 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 307730 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307735 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 307738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 307740 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 307743 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307747 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307752 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 307758 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307763 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307768 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 307771 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 307775 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307780 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 307783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 307785 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 307788 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 307792 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307797 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 307800 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 307803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 307805 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 307808 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 307812 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307817 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 307820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 307825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307848 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307851 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307854 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 307857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 307875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 307883 */     GIR_RootConstrainSelectedInstOperands,
     /* 307884 */     // GIR_Coverage, 7044,
     /* 307884 */     GIR_EraseRootFromParent_Done,
     /* 307885 */   // Label 6164: @307885
     /* 307885 */   GIM_Reject,
     /* 307886 */ // Label 6160: @307886
     /* 307886 */ GIM_Reject,
     /* 307887 */ // Label 6100: @307887
     /* 307887 */ GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(307912), // Rule ID 8252 //
     /* 307892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 307895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 307898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 307901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 307905 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 307905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 307910 */   GIR_RootConstrainSelectedInstOperands,
     /* 307911 */   // GIR_Coverage, 8252,
     /* 307911 */   GIR_Done,
     /* 307912 */ // Label 6165: @307912
     /* 307912 */ GIM_Reject,
     /* 307913 */ // Label 6101: @307913
     /* 307913 */ GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(307938), // Rule ID 8250 //
     /* 307918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 307921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 307924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 307927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 307931 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 307931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 307936 */   GIR_RootConstrainSelectedInstOperands,
     /* 307937 */   // GIR_Coverage, 8250,
     /* 307937 */   GIR_Done,
     /* 307938 */ // Label 6166: @307938
     /* 307938 */ GIM_Reject,
     /* 307939 */ // Label 6102: @307939
     /* 307939 */ GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(307964), // Rule ID 8248 //
     /* 307944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 307947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 307950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 307953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 307957 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 307957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 307962 */   GIR_RootConstrainSelectedInstOperands,
     /* 307963 */   // GIR_Coverage, 8248,
     /* 307963 */   GIR_Done,
     /* 307964 */ // Label 6167: @307964
     /* 307964 */ GIM_Reject,
     /* 307965 */ // Label 6103: @307965
     /* 307965 */ GIM_Reject,
     /* 307966 */ // Label 62: @307966
     /* 307966 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6176*/ GIMT_Encode4(324238),
     /* 307977 */ /*GILLT_s16*//*Label 6168*/ GIMT_Encode4(308017),
     /* 307981 */ /*GILLT_s32*//*Label 6169*/ GIMT_Encode4(311021),
     /* 307985 */ /*GILLT_s64*//*Label 6170*/ GIMT_Encode4(314169), GIMT_Encode4(0),
     /* 307993 */ /*GILLT_v2s32*//*Label 6171*/ GIMT_Encode4(317317),
     /* 307997 */ /*GILLT_v2s64*//*Label 6172*/ GIMT_Encode4(318838),
     /* 308001 */ /*GILLT_v4s16*//*Label 6173*/ GIMT_Encode4(320359),
     /* 308005 */ /*GILLT_v4s32*//*Label 6174*/ GIMT_Encode4(321538), GIMT_Encode4(0),
     /* 308013 */ /*GILLT_v8s16*//*Label 6175*/ GIMT_Encode4(323059),
     /* 308017 */ // Label 6168: @308017
     /* 308017 */ GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(311020),
     /* 308022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 308028 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 308031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308035 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(308185), // Rule ID 4898 //
     /* 308040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308064 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308089 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 308097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308101 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 308105 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308112 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308112 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 308115 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308119 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308124 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308152 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 308171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 308183 */     GIR_RootConstrainSelectedInstOperands,
     /* 308184 */     // GIR_Coverage, 4898,
     /* 308184 */     GIR_EraseRootFromParent_Done,
     /* 308185 */   // Label 6178: @308185
     /* 308185 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(308332), // Rule ID 4862 //
     /* 308190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308214 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 308234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308238 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308242 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308246 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308251 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308261 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 308264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308273 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308279 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308301 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 308320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 308330 */     GIR_RootConstrainSelectedInstOperands,
     /* 308331 */     // GIR_Coverage, 4862,
     /* 308331 */     GIR_EraseRootFromParent_Done,
     /* 308332 */   // Label 6179: @308332
     /* 308332 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(308479), // Rule ID 13944 //
     /* 308337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308373 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 308381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308385 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308389 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308393 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308398 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308408 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308408 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 308411 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308415 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308420 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308426 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308448 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 308467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 308477 */     GIR_RootConstrainSelectedInstOperands,
     /* 308478 */     // GIR_Coverage, 13944,
     /* 308478 */     GIR_EraseRootFromParent_Done,
     /* 308479 */   // Label 6180: @308479
     /* 308479 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(308610), // Rule ID 6117 //
     /* 308484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 308528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 308549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308553 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308557 */     // MIs[4] Operand 1
     /* 308557 */     // No operand predicates
     /* 308557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308561 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 308563 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 308563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308575 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 308594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 308605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 308608 */     GIR_RootConstrainSelectedInstOperands,
     /* 308609 */     // GIR_Coverage, 6117,
     /* 308609 */     GIR_EraseRootFromParent_Done,
     /* 308610 */   // Label 6181: @308610
     /* 308610 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(308741), // Rule ID 6149 //
     /* 308615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308647 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308651 */     // MIs[2] Operand 1
     /* 308651 */     // No operand predicates
     /* 308651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 308655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308659 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 308663 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 308667 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308671 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308675 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 308679 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308684 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 308688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308692 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 308694 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 308694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308706 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 308725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308739 */     GIR_RootConstrainSelectedInstOperands,
     /* 308740 */     // GIR_Coverage, 6149,
     /* 308740 */     GIR_EraseRootFromParent_Done,
     /* 308741 */   // Label 6182: @308741
     /* 308741 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(308872), // Rule ID 6213 //
     /* 308746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308782 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 308790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308794 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308798 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308802 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 308811 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308815 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308819 */     // MIs[4] Operand 1
     /* 308819 */     // No operand predicates
     /* 308819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308823 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 308825 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 308825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308837 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 308856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 308867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 308870 */     GIR_RootConstrainSelectedInstOperands,
     /* 308871 */     // GIR_Coverage, 6213,
     /* 308871 */     GIR_EraseRootFromParent_Done,
     /* 308872 */   // Label 6183: @308872
     /* 308872 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(309003), // Rule ID 6181 //
     /* 308877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308921 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308925 */     // MIs[3] Operand 1
     /* 308925 */     // No operand predicates
     /* 308925 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 308929 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308933 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308937 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 308941 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308946 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 308950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308954 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 308956 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 308956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308968 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 308987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 309001 */     GIR_RootConstrainSelectedInstOperands,
     /* 309002 */     // GIR_Coverage, 6181,
     /* 309002 */     GIR_EraseRootFromParent_Done,
     /* 309003 */   // Label 6184: @309003
     /* 309003 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(309138), // Rule ID 2456 //
     /* 309008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309032 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309057 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309067 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309067 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309070 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309074 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309079 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309085 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309107 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 309126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309136 */     GIR_RootConstrainSelectedInstOperands,
     /* 309137 */     // GIR_Coverage, 2456,
     /* 309137 */     GIR_EraseRootFromParent_Done,
     /* 309138 */   // Label 6185: @309138
     /* 309138 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(309257), // Rule ID 6085 //
     /* 309143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309167 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309200 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309204 */     // MIs[3] Operand 1
     /* 309204 */     // No operand predicates
     /* 309204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309210 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309222 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 309241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 309252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 309255 */     GIR_RootConstrainSelectedInstOperands,
     /* 309256 */     // GIR_Coverage, 6085,
     /* 309256 */     GIR_EraseRootFromParent_Done,
     /* 309257 */   // Label 6186: @309257
     /* 309257 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(309376), // Rule ID 2531 //
     /* 309262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309294 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309298 */     // MIs[2] Operand 1
     /* 309298 */     // No operand predicates
     /* 309298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 309302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309306 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309310 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309314 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309319 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309329 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309341 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 309360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309374 */     GIR_RootConstrainSelectedInstOperands,
     /* 309375 */     // GIR_Coverage, 2531,
     /* 309375 */     GIR_EraseRootFromParent_Done,
     /* 309376 */   // Label 6187: @309376
     /* 309376 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(309476), // Rule ID 4860 //
     /* 309381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309405 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309432 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 309432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309444 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 309472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309474 */     GIR_RootConstrainSelectedInstOperands,
     /* 309475 */     // GIR_Coverage, 4860,
     /* 309475 */     GIR_EraseRootFromParent_Done,
     /* 309476 */   // Label 6188: @309476
     /* 309476 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(309576), // Rule ID 4896 //
     /* 309481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 309517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309532 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 309532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309544 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 309563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 309570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 309574 */     GIR_RootConstrainSelectedInstOperands,
     /* 309575 */     // GIR_Coverage, 4896,
     /* 309575 */     GIR_EraseRootFromParent_Done,
     /* 309576 */   // Label 6189: @309576
     /* 309576 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(309673), // Rule ID 13940 //
     /* 309581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309617 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309631 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309643 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309671 */     GIR_RootConstrainSelectedInstOperands,
     /* 309672 */     // GIR_Coverage, 13940,
     /* 309672 */     GIR_EraseRootFromParent_Done,
     /* 309673 */   // Label 6190: @309673
     /* 309673 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(309773), // Rule ID 13942 //
     /* 309678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309719 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309729 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 309729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309741 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309771 */     GIR_RootConstrainSelectedInstOperands,
     /* 309772 */     // GIR_Coverage, 13942,
     /* 309772 */     GIR_EraseRootFromParent_Done,
     /* 309773 */   // Label 6191: @309773
     /* 309773 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(309873), // Rule ID 4894 //
     /* 309778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309806 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 309814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309829 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309841 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 309860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 309871 */     GIR_RootConstrainSelectedInstOperands,
     /* 309872 */     // GIR_Coverage, 4894,
     /* 309872 */     GIR_EraseRootFromParent_Done,
     /* 309873 */   // Label 6192: @309873
     /* 309873 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(309970), // Rule ID 4858 //
     /* 309878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309918 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309928 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309940 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309968 */     GIR_RootConstrainSelectedInstOperands,
     /* 309969 */     // GIR_Coverage, 4858,
     /* 309969 */     GIR_EraseRootFromParent_Done,
     /* 309970 */   // Label 6193: @309970
     /* 309970 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(310054), // Rule ID 6147 //
     /* 309975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310007 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310011 */     // MIs[2] Operand 1
     /* 310011 */     // No operand predicates
     /* 310011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310019 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 310023 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310034 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 310045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310052 */     GIR_RootConstrainSelectedInstOperands,
     /* 310053 */     // GIR_Coverage, 6147,
     /* 310053 */     GIR_EraseRootFromParent_Done,
     /* 310054 */   // Label 6194: @310054
     /* 310054 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(310135), // Rule ID 6179 //
     /* 310059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310103 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310107 */     // MIs[3] Operand 1
     /* 310107 */     // No operand predicates
     /* 310107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310117 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 310126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310133 */     GIR_RootConstrainSelectedInstOperands,
     /* 310134 */     // GIR_Coverage, 6179,
     /* 310134 */     GIR_EraseRootFromParent_Done,
     /* 310135 */   // Label 6195: @310135
     /* 310135 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(310219), // Rule ID 6211 //
     /* 310140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310189 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310193 */     // MIs[3] Operand 1
     /* 310193 */     // No operand predicates
     /* 310193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310199 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310217 */     GIR_RootConstrainSelectedInstOperands,
     /* 310218 */     // GIR_Coverage, 6211,
     /* 310218 */     GIR_EraseRootFromParent_Done,
     /* 310219 */   // Label 6196: @310219
     /* 310219 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(310300), // Rule ID 6115 //
     /* 310224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310272 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310276 */     // MIs[3] Operand 1
     /* 310276 */     // No operand predicates
     /* 310276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310282 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310298 */     GIR_RootConstrainSelectedInstOperands,
     /* 310299 */     // GIR_Coverage, 6115,
     /* 310299 */     GIR_EraseRootFromParent_Done,
     /* 310300 */   // Label 6197: @310300
     /* 310300 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(310385), // Rule ID 2454 //
     /* 310305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310329 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310343 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310355 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 310374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 310381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310383 */     GIR_RootConstrainSelectedInstOperands,
     /* 310384 */     // GIR_Coverage, 2454,
     /* 310384 */     GIR_EraseRootFromParent_Done,
     /* 310385 */   // Label 6198: @310385
     /* 310385 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(310470), // Rule ID 2452 //
     /* 310390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310418 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310428 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310440 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 310459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310468 */     GIR_RootConstrainSelectedInstOperands,
     /* 310469 */     // GIR_Coverage, 2452,
     /* 310469 */     GIR_EraseRootFromParent_Done,
     /* 310470 */   // Label 6199: @310470
     /* 310470 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(310539), // Rule ID 2529 //
     /* 310475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310511 */     // MIs[2] Operand 1
     /* 310511 */     // No operand predicates
     /* 310511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310521 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 310524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 310530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310537 */     GIR_RootConstrainSelectedInstOperands,
     /* 310538 */     // GIR_Coverage, 2529,
     /* 310538 */     GIR_EraseRootFromParent_Done,
     /* 310539 */   // Label 6200: @310539
     /* 310539 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(310608), // Rule ID 6083 //
     /* 310544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310580 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310584 */     // MIs[2] Operand 1
     /* 310584 */     // No operand predicates
     /* 310584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310590 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 310593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310606 */     GIR_RootConstrainSelectedInstOperands,
     /* 310607 */     // GIR_Coverage, 6083,
     /* 310607 */     GIR_EraseRootFromParent_Done,
     /* 310608 */   // Label 6201: @310608
     /* 310608 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(310673), // Rule ID 4914 //
     /* 310613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 310641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310656 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 310667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 310671 */     GIR_RootConstrainSelectedInstOperands,
     /* 310672 */     // GIR_Coverage, 4914,
     /* 310672 */     GIR_EraseRootFromParent_Done,
     /* 310673 */   // Label 6202: @310673
     /* 310673 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(310738), // Rule ID 13960 //
     /* 310678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 310706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310721 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 310732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 310736 */     GIR_RootConstrainSelectedInstOperands,
     /* 310737 */     // GIR_Coverage, 13960,
     /* 310737 */     GIR_EraseRootFromParent_Done,
     /* 310738 */   // Label 6203: @310738
     /* 310738 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(310788), // Rule ID 4911 //
     /* 310743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310773 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 310784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310786 */     GIR_RootConstrainSelectedInstOperands,
     /* 310787 */     // GIR_Coverage, 4911,
     /* 310787 */     GIR_EraseRootFromParent_Done,
     /* 310788 */   // Label 6204: @310788
     /* 310788 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(310838), // Rule ID 13376 //
     /* 310793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310823 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 310830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310836 */     GIR_RootConstrainSelectedInstOperands,
     /* 310837 */     // GIR_Coverage, 13376,
     /* 310837 */     GIR_EraseRootFromParent_Done,
     /* 310838 */   // Label 6205: @310838
     /* 310838 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(310888), // Rule ID 644 //
     /* 310843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310873 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310886 */     GIR_RootConstrainSelectedInstOperands,
     /* 310887 */     // GIR_Coverage, 644,
     /* 310887 */     GIR_EraseRootFromParent_Done,
     /* 310888 */   // Label 6206: @310888
     /* 310888 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(310938), // Rule ID 13957 //
     /* 310893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310923 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 310934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310936 */     GIR_RootConstrainSelectedInstOperands,
     /* 310937 */     // GIR_Coverage, 13957,
     /* 310937 */     GIR_EraseRootFromParent_Done,
     /* 310938 */   // Label 6207: @310938
     /* 310938 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(310988), // Rule ID 656 //
     /* 310943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 310958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310973 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 310976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 310982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 310986 */     GIR_RootConstrainSelectedInstOperands,
     /* 310987 */     // GIR_Coverage, 656,
     /* 310987 */     GIR_EraseRootFromParent_Done,
     /* 310988 */   // Label 6208: @310988
     /* 310988 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(311019), // Rule ID 638 //
     /* 310993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311008 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311013 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311017 */     GIR_RootConstrainSelectedInstOperands,
     /* 311018 */     // GIR_Coverage, 638,
     /* 311018 */     GIR_Done,
     /* 311019 */   // Label 6209: @311019
     /* 311019 */   GIM_Reject,
     /* 311020 */ // Label 6177: @311020
     /* 311020 */ GIM_Reject,
     /* 311021 */ // Label 6169: @311021
     /* 311021 */ GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(314168),
     /* 311026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 311032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 311035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311039 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(311189), // Rule ID 4904 //
     /* 311044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311068 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311093 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 311101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 311109 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311116 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311116 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 311119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311123 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311128 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311134 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311139 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311156 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 311175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 311187 */     GIR_RootConstrainSelectedInstOperands,
     /* 311188 */     // GIR_Coverage, 4904,
     /* 311188 */     GIR_EraseRootFromParent_Done,
     /* 311189 */   // Label 6211: @311189
     /* 311189 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(311336), // Rule ID 4868 //
     /* 311194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311218 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 311234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 311238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311242 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311246 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311250 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311255 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311265 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311265 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 311268 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311272 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311277 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311305 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 311324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311334 */     GIR_RootConstrainSelectedInstOperands,
     /* 311335 */     // GIR_Coverage, 4868,
     /* 311335 */     GIR_EraseRootFromParent_Done,
     /* 311336 */   // Label 6212: @311336
     /* 311336 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(311483), // Rule ID 13950 //
     /* 311341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311377 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311389 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311393 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311397 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311402 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311412 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 311415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311424 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311430 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311435 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 311471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311481 */     GIR_RootConstrainSelectedInstOperands,
     /* 311482 */     // GIR_Coverage, 13950,
     /* 311482 */     GIR_EraseRootFromParent_Done,
     /* 311483 */   // Label 6213: @311483
     /* 311483 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(311614), // Rule ID 6133 //
     /* 311488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 311528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 311532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311536 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311540 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311544 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311549 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 311553 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311557 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 311561 */     // MIs[4] Operand 1
     /* 311561 */     // No operand predicates
     /* 311561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311565 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311567 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 311567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 311598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 311609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 311612 */     GIR_RootConstrainSelectedInstOperands,
     /* 311613 */     // GIR_Coverage, 6133,
     /* 311613 */     GIR_EraseRootFromParent_Done,
     /* 311614 */   // Label 6214: @311614
     /* 311614 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(311745), // Rule ID 6165 //
     /* 311619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311651 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 311655 */     // MIs[2] Operand 1
     /* 311655 */     // No operand predicates
     /* 311655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 311667 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 311671 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311675 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311679 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 311683 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311688 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 311692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311696 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311698 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 311698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311710 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 311729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311743 */     GIR_RootConstrainSelectedInstOperands,
     /* 311744 */     // GIR_Coverage, 6165,
     /* 311744 */     GIR_EraseRootFromParent_Done,
     /* 311745 */   // Label 6215: @311745
     /* 311745 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(311876), // Rule ID 6229 //
     /* 311750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311786 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311806 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311811 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 311815 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311819 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 311823 */     // MIs[4] Operand 1
     /* 311823 */     // No operand predicates
     /* 311823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311827 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311829 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 311829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311841 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 311860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 311871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 311874 */     GIR_RootConstrainSelectedInstOperands,
     /* 311875 */     // GIR_Coverage, 6229,
     /* 311875 */     GIR_EraseRootFromParent_Done,
     /* 311876 */   // Label 6216: @311876
     /* 311876 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(312007), // Rule ID 6197 //
     /* 311881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311925 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 311929 */     // MIs[3] Operand 1
     /* 311929 */     // No operand predicates
     /* 311929 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 311933 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311937 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311941 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 311945 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311950 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 311954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311958 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311960 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 311960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311972 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 311991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312005 */     GIR_RootConstrainSelectedInstOperands,
     /* 312006 */     // GIR_Coverage, 6197,
     /* 312006 */     GIR_EraseRootFromParent_Done,
     /* 312007 */   // Label 6217: @312007
     /* 312007 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(312142), // Rule ID 2462 //
     /* 312012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312036 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312061 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312071 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312083 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312111 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 312130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312140 */     GIR_RootConstrainSelectedInstOperands,
     /* 312141 */     // GIR_Coverage, 2462,
     /* 312141 */     GIR_EraseRootFromParent_Done,
     /* 312142 */   // Label 6218: @312142
     /* 312142 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(312261), // Rule ID 6101 //
     /* 312147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312171 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312204 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312208 */     // MIs[3] Operand 1
     /* 312208 */     // No operand predicates
     /* 312208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312212 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312214 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312226 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 312245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312259 */     GIR_RootConstrainSelectedInstOperands,
     /* 312260 */     // GIR_Coverage, 6101,
     /* 312260 */     GIR_EraseRootFromParent_Done,
     /* 312261 */   // Label 6219: @312261
     /* 312261 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(312380), // Rule ID 2547 //
     /* 312266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312298 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312302 */     // MIs[2] Operand 1
     /* 312302 */     // No operand predicates
     /* 312302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312310 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312314 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312318 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312323 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 312327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312333 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312345 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 312364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312378 */     GIR_RootConstrainSelectedInstOperands,
     /* 312379 */     // GIR_Coverage, 2547,
     /* 312379 */     GIR_EraseRootFromParent_Done,
     /* 312380 */   // Label 6220: @312380
     /* 312380 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(312480), // Rule ID 4866 //
     /* 312385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312409 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312436 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 312436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312448 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312478 */     GIR_RootConstrainSelectedInstOperands,
     /* 312479 */     // GIR_Coverage, 4866,
     /* 312479 */     GIR_EraseRootFromParent_Done,
     /* 312480 */   // Label 6221: @312480
     /* 312480 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(312580), // Rule ID 4902 //
     /* 312485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312509 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312536 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 312536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312548 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 312567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312578 */     GIR_RootConstrainSelectedInstOperands,
     /* 312579 */     // GIR_Coverage, 4902,
     /* 312579 */     GIR_EraseRootFromParent_Done,
     /* 312580 */   // Label 6222: @312580
     /* 312580 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(312677), // Rule ID 13946 //
     /* 312585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312635 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312647 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 312670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312675 */     GIR_RootConstrainSelectedInstOperands,
     /* 312676 */     // GIR_Coverage, 13946,
     /* 312676 */     GIR_EraseRootFromParent_Done,
     /* 312677 */   // Label 6223: @312677
     /* 312677 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(312777), // Rule ID 13948 //
     /* 312682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312723 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312733 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 312733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312775 */     GIR_RootConstrainSelectedInstOperands,
     /* 312776 */     // GIR_Coverage, 13948,
     /* 312776 */     GIR_EraseRootFromParent_Done,
     /* 312777 */   // Label 6224: @312777
     /* 312777 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(312877), // Rule ID 4900 //
     /* 312782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312810 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312833 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312845 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 312864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312875 */     GIR_RootConstrainSelectedInstOperands,
     /* 312876 */     // GIR_Coverage, 4900,
     /* 312876 */     GIR_EraseRootFromParent_Done,
     /* 312877 */   // Label 6225: @312877
     /* 312877 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(312974), // Rule ID 4864 //
     /* 312882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312922 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312932 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312944 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312972 */     GIR_RootConstrainSelectedInstOperands,
     /* 312973 */     // GIR_Coverage, 4864,
     /* 312973 */     GIR_EraseRootFromParent_Done,
     /* 312974 */   // Label 6226: @312974
     /* 312974 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(313052), // Rule ID 6251 //
     /* 312979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 313016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313020 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313024 */     // MIs[3] Operand 1
     /* 313024 */     // No operand predicates
     /* 313024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313034 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313050 */     GIR_RootConstrainSelectedInstOperands,
     /* 313051 */     // GIR_Coverage, 6251,
     /* 313051 */     GIR_EraseRootFromParent_Done,
     /* 313052 */   // Label 6227: @313052
     /* 313052 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(313136), // Rule ID 6163 //
     /* 313057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313089 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313093 */     // MIs[2] Operand 1
     /* 313093 */     // No operand predicates
     /* 313093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313101 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 313105 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313116 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 313127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313134 */     GIR_RootConstrainSelectedInstOperands,
     /* 313135 */     // GIR_Coverage, 6163,
     /* 313135 */     GIR_EraseRootFromParent_Done,
     /* 313136 */   // Label 6228: @313136
     /* 313136 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(313217), // Rule ID 6195 //
     /* 313141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313185 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313189 */     // MIs[3] Operand 1
     /* 313189 */     // No operand predicates
     /* 313189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313199 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313215 */     GIR_RootConstrainSelectedInstOperands,
     /* 313216 */     // GIR_Coverage, 6195,
     /* 313216 */     GIR_EraseRootFromParent_Done,
     /* 313217 */   // Label 6229: @313217
     /* 313217 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(313301), // Rule ID 6227 //
     /* 313222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313271 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313275 */     // MIs[3] Operand 1
     /* 313275 */     // No operand predicates
     /* 313275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313281 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313299 */     GIR_RootConstrainSelectedInstOperands,
     /* 313300 */     // GIR_Coverage, 6227,
     /* 313300 */     GIR_EraseRootFromParent_Done,
     /* 313301 */   // Label 6230: @313301
     /* 313301 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(313379), // Rule ID 6273 //
     /* 313306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 313347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313351 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313355 */     // MIs[3] Operand 1
     /* 313355 */     // No operand predicates
     /* 313355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313361 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313377 */     GIR_RootConstrainSelectedInstOperands,
     /* 313378 */     // GIR_Coverage, 6273,
     /* 313378 */     GIR_EraseRootFromParent_Done,
     /* 313379 */   // Label 6231: @313379
     /* 313379 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(313460), // Rule ID 6131 //
     /* 313384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313432 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313436 */     // MIs[3] Operand 1
     /* 313436 */     // No operand predicates
     /* 313436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313442 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313458 */     GIR_RootConstrainSelectedInstOperands,
     /* 313459 */     // GIR_Coverage, 6131,
     /* 313459 */     GIR_EraseRootFromParent_Done,
     /* 313460 */   // Label 6232: @313460
     /* 313460 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(313545), // Rule ID 2460 //
     /* 313465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313489 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313503 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313515 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 313534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313543 */     GIR_RootConstrainSelectedInstOperands,
     /* 313544 */     // GIR_Coverage, 2460,
     /* 313544 */     GIR_EraseRootFromParent_Done,
     /* 313545 */   // Label 6233: @313545
     /* 313545 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(313630), // Rule ID 2458 //
     /* 313550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313578 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313588 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313600 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 313619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313628 */     GIR_RootConstrainSelectedInstOperands,
     /* 313629 */     // GIR_Coverage, 2458,
     /* 313629 */     GIR_EraseRootFromParent_Done,
     /* 313630 */   // Label 6234: @313630
     /* 313630 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(313699), // Rule ID 2545 //
     /* 313635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313667 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313671 */     // MIs[2] Operand 1
     /* 313671 */     // No operand predicates
     /* 313671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313681 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 313684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313697 */     GIR_RootConstrainSelectedInstOperands,
     /* 313698 */     // GIR_Coverage, 2545,
     /* 313698 */     GIR_EraseRootFromParent_Done,
     /* 313699 */   // Label 6235: @313699
     /* 313699 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(313768), // Rule ID 6099 //
     /* 313704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313740 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313744 */     // MIs[2] Operand 1
     /* 313744 */     // No operand predicates
     /* 313744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313750 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 313753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313766 */     GIR_RootConstrainSelectedInstOperands,
     /* 313767 */     // GIR_Coverage, 6099,
     /* 313767 */     GIR_EraseRootFromParent_Done,
     /* 313768 */   // Label 6236: @313768
     /* 313768 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(313830), // Rule ID 4915 //
     /* 313773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 313798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313813 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 313816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 313828 */     GIR_RootConstrainSelectedInstOperands,
     /* 313829 */     // GIR_Coverage, 4915,
     /* 313829 */     GIR_EraseRootFromParent_Done,
     /* 313830 */   // Label 6237: @313830
     /* 313830 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(313892), // Rule ID 13961 //
     /* 313835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 313860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313875 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 313878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 313886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 313890 */     GIR_RootConstrainSelectedInstOperands,
     /* 313891 */     // GIR_Coverage, 13961,
     /* 313891 */     GIR_EraseRootFromParent_Done,
     /* 313892 */   // Label 6238: @313892
     /* 313892 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(313939), // Rule ID 4912 //
     /* 313897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313924 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313937 */     GIR_RootConstrainSelectedInstOperands,
     /* 313938 */     // GIR_Coverage, 4912,
     /* 313938 */     GIR_EraseRootFromParent_Done,
     /* 313939 */   // Label 6239: @313939
     /* 313939 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(313989), // Rule ID 13378 //
     /* 313944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313974 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313987 */     GIR_RootConstrainSelectedInstOperands,
     /* 313988 */     // GIR_Coverage, 13378,
     /* 313988 */     GIR_EraseRootFromParent_Done,
     /* 313989 */   // Label 6240: @313989
     /* 313989 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(314039), // Rule ID 646 //
     /* 313994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314024 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314037 */     GIR_RootConstrainSelectedInstOperands,
     /* 314038 */     // GIR_Coverage, 646,
     /* 314038 */     GIR_EraseRootFromParent_Done,
     /* 314039 */   // Label 6241: @314039
     /* 314039 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(314086), // Rule ID 13958 //
     /* 314044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314071 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 314082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314084 */     GIR_RootConstrainSelectedInstOperands,
     /* 314085 */     // GIR_Coverage, 13958,
     /* 314085 */     GIR_EraseRootFromParent_Done,
     /* 314086 */   // Label 6242: @314086
     /* 314086 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(314136), // Rule ID 658 //
     /* 314091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 314106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314121 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 314124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 314134 */     GIR_RootConstrainSelectedInstOperands,
     /* 314135 */     // GIR_Coverage, 658,
     /* 314135 */     GIR_EraseRootFromParent_Done,
     /* 314136 */   // Label 6243: @314136
     /* 314136 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(314167), // Rule ID 640 //
     /* 314141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314156 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 314161 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314165 */     GIR_RootConstrainSelectedInstOperands,
     /* 314166 */     // GIR_Coverage, 640,
     /* 314166 */     GIR_Done,
     /* 314167 */   // Label 6244: @314167
     /* 314167 */   GIM_Reject,
     /* 314168 */ // Label 6210: @314168
     /* 314168 */ GIM_Reject,
     /* 314169 */ // Label 6170: @314169
     /* 314169 */ GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(317316),
     /* 314174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 314180 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 314183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314187 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(314337), // Rule ID 4910 //
     /* 314192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314216 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314241 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 314249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314253 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 314257 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314264 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 314264 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 314267 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314271 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314276 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 314282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314287 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314304 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 314323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 314331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 314335 */     GIR_RootConstrainSelectedInstOperands,
     /* 314336 */     // GIR_Coverage, 4910,
     /* 314336 */     GIR_EraseRootFromParent_Done,
     /* 314337 */   // Label 6246: @314337
     /* 314337 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(314484), // Rule ID 4874 //
     /* 314342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314366 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 314382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314390 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314394 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314398 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314403 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 314407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314413 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 314413 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 314416 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314420 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314425 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 314431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314453 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 314472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 314480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314482 */     GIR_RootConstrainSelectedInstOperands,
     /* 314483 */     // GIR_Coverage, 4874,
     /* 314483 */     GIR_EraseRootFromParent_Done,
     /* 314484 */   // Label 6247: @314484
     /* 314484 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(314631), // Rule ID 13956 //
     /* 314489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314525 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314541 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314550 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 314554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314560 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 314560 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 314563 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314567 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314572 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 314578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314600 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 314619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 314627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314629 */     GIR_RootConstrainSelectedInstOperands,
     /* 314630 */     // GIR_Coverage, 13956,
     /* 314630 */     GIR_EraseRootFromParent_Done,
     /* 314631 */   // Label 6248: @314631
     /* 314631 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(314762), // Rule ID 6137 //
     /* 314636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314660 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 314676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314684 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314688 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314692 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314697 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 314701 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314705 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 314709 */     // MIs[4] Operand 1
     /* 314709 */     // No operand predicates
     /* 314709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314713 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314715 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 314715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314727 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 314746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 314757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 314760 */     GIR_RootConstrainSelectedInstOperands,
     /* 314761 */     // GIR_Coverage, 6137,
     /* 314761 */     GIR_EraseRootFromParent_Done,
     /* 314762 */   // Label 6249: @314762
     /* 314762 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(314893), // Rule ID 6169 //
     /* 314767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314799 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 314803 */     // MIs[2] Operand 1
     /* 314803 */     // No operand predicates
     /* 314803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314811 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 314815 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 314819 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314823 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314827 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 314831 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314836 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 314840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314844 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314846 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 314846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314858 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 314877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314891 */     GIR_RootConstrainSelectedInstOperands,
     /* 314892 */     // GIR_Coverage, 6169,
     /* 314892 */     GIR_EraseRootFromParent_Done,
     /* 314893 */   // Label 6250: @314893
     /* 314893 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(315024), // Rule ID 6233 //
     /* 314898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314934 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314946 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314950 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314954 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314959 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 314963 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314967 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 314971 */     // MIs[4] Operand 1
     /* 314971 */     // No operand predicates
     /* 314971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314975 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314977 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 314977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314989 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 315019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 315022 */     GIR_RootConstrainSelectedInstOperands,
     /* 315023 */     // GIR_Coverage, 6233,
     /* 315023 */     GIR_EraseRootFromParent_Done,
     /* 315024 */   // Label 6251: @315024
     /* 315024 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(315155), // Rule ID 6201 //
     /* 315029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315073 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315077 */     // MIs[3] Operand 1
     /* 315077 */     // No operand predicates
     /* 315077 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 315081 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315085 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315089 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 315093 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315098 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 315102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315106 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 315108 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315120 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315153 */     GIR_RootConstrainSelectedInstOperands,
     /* 315154 */     // GIR_Coverage, 6201,
     /* 315154 */     GIR_EraseRootFromParent_Done,
     /* 315155 */   // Label 6252: @315155
     /* 315155 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(315290), // Rule ID 2468 //
     /* 315160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315184 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315209 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315219 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315231 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315237 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315242 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315259 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 315278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 315286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315288 */     GIR_RootConstrainSelectedInstOperands,
     /* 315289 */     // GIR_Coverage, 2468,
     /* 315289 */     GIR_EraseRootFromParent_Done,
     /* 315290 */   // Label 6253: @315290
     /* 315290 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(315409), // Rule ID 6105 //
     /* 315295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315319 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315352 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315356 */     // MIs[3] Operand 1
     /* 315356 */     // No operand predicates
     /* 315356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315362 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315374 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 315393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315407 */     GIR_RootConstrainSelectedInstOperands,
     /* 315408 */     // GIR_Coverage, 6105,
     /* 315408 */     GIR_EraseRootFromParent_Done,
     /* 315409 */   // Label 6254: @315409
     /* 315409 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(315528), // Rule ID 2551 //
     /* 315414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315446 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315450 */     // MIs[2] Operand 1
     /* 315450 */     // No operand predicates
     /* 315450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 315454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315458 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315462 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 315466 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315471 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 315475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315481 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315493 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 315512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315526 */     GIR_RootConstrainSelectedInstOperands,
     /* 315527 */     // GIR_Coverage, 2551,
     /* 315527 */     GIR_EraseRootFromParent_Done,
     /* 315528 */   // Label 6255: @315528
     /* 315528 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(315628), // Rule ID 4872 //
     /* 315533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315557 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315584 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 315584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315596 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 315615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315626 */     GIR_RootConstrainSelectedInstOperands,
     /* 315627 */     // GIR_Coverage, 4872,
     /* 315627 */     GIR_EraseRootFromParent_Done,
     /* 315628 */   // Label 6256: @315628
     /* 315628 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(315728), // Rule ID 4908 //
     /* 315633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315657 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315684 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 315684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315696 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 315715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 315726 */     GIR_RootConstrainSelectedInstOperands,
     /* 315727 */     // GIR_Coverage, 4908,
     /* 315727 */     GIR_EraseRootFromParent_Done,
     /* 315728 */   // Label 6257: @315728
     /* 315728 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(315825), // Rule ID 13952 //
     /* 315733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315769 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315783 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315795 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 315814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315823 */     GIR_RootConstrainSelectedInstOperands,
     /* 315824 */     // GIR_Coverage, 13952,
     /* 315824 */     GIR_EraseRootFromParent_Done,
     /* 315825 */   // Label 6258: @315825
     /* 315825 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(315925), // Rule ID 13954 //
     /* 315830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315871 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315881 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 315881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315893 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 315912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315923 */     GIR_RootConstrainSelectedInstOperands,
     /* 315924 */     // GIR_Coverage, 13954,
     /* 315924 */     GIR_EraseRootFromParent_Done,
     /* 315925 */   // Label 6259: @315925
     /* 315925 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(316025), // Rule ID 4906 //
     /* 315930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315958 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315981 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315993 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 316012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316023 */     GIR_RootConstrainSelectedInstOperands,
     /* 316024 */     // GIR_Coverage, 4906,
     /* 316024 */     GIR_EraseRootFromParent_Done,
     /* 316025 */   // Label 6260: @316025
     /* 316025 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(316122), // Rule ID 4870 //
     /* 316030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316070 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316080 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316092 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316120 */     GIR_RootConstrainSelectedInstOperands,
     /* 316121 */     // GIR_Coverage, 4870,
     /* 316121 */     GIR_EraseRootFromParent_Done,
     /* 316122 */   // Label 6261: @316122
     /* 316122 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(316200), // Rule ID 6255 //
     /* 316127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316168 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 316172 */     // MIs[3] Operand 1
     /* 316172 */     // No operand predicates
     /* 316172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316182 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 316182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316198 */     GIR_RootConstrainSelectedInstOperands,
     /* 316199 */     // GIR_Coverage, 6255,
     /* 316199 */     GIR_EraseRootFromParent_Done,
     /* 316200 */   // Label 6262: @316200
     /* 316200 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(316284), // Rule ID 6167 //
     /* 316205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316237 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316241 */     // MIs[2] Operand 1
     /* 316241 */     // No operand predicates
     /* 316241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316249 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 316253 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316264 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 316275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316282 */     GIR_RootConstrainSelectedInstOperands,
     /* 316283 */     // GIR_Coverage, 6167,
     /* 316283 */     GIR_EraseRootFromParent_Done,
     /* 316284 */   // Label 6263: @316284
     /* 316284 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(316365), // Rule ID 6199 //
     /* 316289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316316 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316333 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316337 */     // MIs[3] Operand 1
     /* 316337 */     // No operand predicates
     /* 316337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316347 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316363 */     GIR_RootConstrainSelectedInstOperands,
     /* 316364 */     // GIR_Coverage, 6199,
     /* 316364 */     GIR_EraseRootFromParent_Done,
     /* 316365 */   // Label 6264: @316365
     /* 316365 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(316449), // Rule ID 6231 //
     /* 316370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316419 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316423 */     // MIs[3] Operand 1
     /* 316423 */     // No operand predicates
     /* 316423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316429 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316447 */     GIR_RootConstrainSelectedInstOperands,
     /* 316448 */     // GIR_Coverage, 6231,
     /* 316448 */     GIR_EraseRootFromParent_Done,
     /* 316449 */   // Label 6265: @316449
     /* 316449 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(316527), // Rule ID 6277 //
     /* 316454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316499 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 316503 */     // MIs[3] Operand 1
     /* 316503 */     // No operand predicates
     /* 316503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316509 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 316509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316525 */     GIR_RootConstrainSelectedInstOperands,
     /* 316526 */     // GIR_Coverage, 6277,
     /* 316526 */     GIR_EraseRootFromParent_Done,
     /* 316527 */   // Label 6266: @316527
     /* 316527 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(316608), // Rule ID 6135 //
     /* 316532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316580 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316584 */     // MIs[3] Operand 1
     /* 316584 */     // No operand predicates
     /* 316584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316590 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316606 */     GIR_RootConstrainSelectedInstOperands,
     /* 316607 */     // GIR_Coverage, 6135,
     /* 316607 */     GIR_EraseRootFromParent_Done,
     /* 316608 */   // Label 6267: @316608
     /* 316608 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(316693), // Rule ID 2466 //
     /* 316613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316637 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316651 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 316651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 316682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316691 */     GIR_RootConstrainSelectedInstOperands,
     /* 316692 */     // GIR_Coverage, 2466,
     /* 316692 */     GIR_EraseRootFromParent_Done,
     /* 316693 */   // Label 6268: @316693
     /* 316693 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(316778), // Rule ID 2464 //
     /* 316698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316726 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316736 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316748 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 316767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316776 */     GIR_RootConstrainSelectedInstOperands,
     /* 316777 */     // GIR_Coverage, 2464,
     /* 316777 */     GIR_EraseRootFromParent_Done,
     /* 316778 */   // Label 6269: @316778
     /* 316778 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(316847), // Rule ID 2549 //
     /* 316783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316815 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316819 */     // MIs[2] Operand 1
     /* 316819 */     // No operand predicates
     /* 316819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316829 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 316832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316845 */     GIR_RootConstrainSelectedInstOperands,
     /* 316846 */     // GIR_Coverage, 2549,
     /* 316846 */     GIR_EraseRootFromParent_Done,
     /* 316847 */   // Label 6270: @316847
     /* 316847 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(316916), // Rule ID 6103 //
     /* 316852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316892 */     // MIs[2] Operand 1
     /* 316892 */     // No operand predicates
     /* 316892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316898 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 316901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316914 */     GIR_RootConstrainSelectedInstOperands,
     /* 316915 */     // GIR_Coverage, 6103,
     /* 316915 */     GIR_EraseRootFromParent_Done,
     /* 316916 */   // Label 6271: @316916
     /* 316916 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(316978), // Rule ID 4916 //
     /* 316921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 316946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316961 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 316961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 316964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316976 */     GIR_RootConstrainSelectedInstOperands,
     /* 316977 */     // GIR_Coverage, 4916,
     /* 316977 */     GIR_EraseRootFromParent_Done,
     /* 316978 */   // Label 6272: @316978
     /* 316978 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(317040), // Rule ID 13962 //
     /* 316983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317023 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 317026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 317034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317038 */     GIR_RootConstrainSelectedInstOperands,
     /* 317039 */     // GIR_Coverage, 13962,
     /* 317039 */     GIR_EraseRootFromParent_Done,
     /* 317040 */   // Label 6273: @317040
     /* 317040 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(317087), // Rule ID 4913 //
     /* 317045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317072 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317085 */     GIR_RootConstrainSelectedInstOperands,
     /* 317086 */     // GIR_Coverage, 4913,
     /* 317086 */     GIR_EraseRootFromParent_Done,
     /* 317087 */   // Label 6274: @317087
     /* 317087 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(317137), // Rule ID 13380 //
     /* 317092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317122 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317135 */     GIR_RootConstrainSelectedInstOperands,
     /* 317136 */     // GIR_Coverage, 13380,
     /* 317136 */     GIR_EraseRootFromParent_Done,
     /* 317137 */   // Label 6275: @317137
     /* 317137 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(317187), // Rule ID 648 //
     /* 317142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317172 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317185 */     GIR_RootConstrainSelectedInstOperands,
     /* 317186 */     // GIR_Coverage, 648,
     /* 317186 */     GIR_EraseRootFromParent_Done,
     /* 317187 */   // Label 6276: @317187
     /* 317187 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(317234), // Rule ID 13959 //
     /* 317192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317219 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 317230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317232 */     GIR_RootConstrainSelectedInstOperands,
     /* 317233 */     // GIR_Coverage, 13959,
     /* 317233 */     GIR_EraseRootFromParent_Done,
     /* 317234 */   // Label 6277: @317234
     /* 317234 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(317284), // Rule ID 660 //
     /* 317239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 317254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317269 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 317272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 317282 */     GIR_RootConstrainSelectedInstOperands,
     /* 317283 */     // GIR_Coverage, 660,
     /* 317283 */     GIR_EraseRootFromParent_Done,
     /* 317284 */   // Label 6278: @317284
     /* 317284 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(317315), // Rule ID 642 //
     /* 317289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317304 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 317309 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317313 */     GIR_RootConstrainSelectedInstOperands,
     /* 317314 */     // GIR_Coverage, 642,
     /* 317314 */     GIR_Done,
     /* 317315 */   // Label 6279: @317315
     /* 317315 */   GIM_Reject,
     /* 317316 */ // Label 6245: @317316
     /* 317316 */ GIM_Reject,
     /* 317317 */ // Label 6171: @317317
     /* 317317 */ GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(318837),
     /* 317322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 317328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 317331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317335 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(317413), // Rule ID 6235 //
     /* 317340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317381 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317385 */     // MIs[3] Operand 1
     /* 317385 */     // No operand predicates
     /* 317385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317395 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317411 */     GIR_RootConstrainSelectedInstOperands,
     /* 317412 */     // GIR_Coverage, 6235,
     /* 317412 */     GIR_EraseRootFromParent_Done,
     /* 317413 */   // Label 6281: @317413
     /* 317413 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(317497), // Rule ID 6151 //
     /* 317418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317450 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317454 */     // MIs[2] Operand 1
     /* 317454 */     // No operand predicates
     /* 317454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317466 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317477 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 317488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317495 */     GIR_RootConstrainSelectedInstOperands,
     /* 317496 */     // GIR_Coverage, 6151,
     /* 317496 */     GIR_EraseRootFromParent_Done,
     /* 317497 */   // Label 6282: @317497
     /* 317497 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(317578), // Rule ID 6183 //
     /* 317502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317546 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317550 */     // MIs[3] Operand 1
     /* 317550 */     // No operand predicates
     /* 317550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317560 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317576 */     GIR_RootConstrainSelectedInstOperands,
     /* 317577 */     // GIR_Coverage, 6183,
     /* 317577 */     GIR_EraseRootFromParent_Done,
     /* 317578 */   // Label 6283: @317578
     /* 317578 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(317662), // Rule ID 6215 //
     /* 317583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317632 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317636 */     // MIs[3] Operand 1
     /* 317636 */     // No operand predicates
     /* 317636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317642 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317660 */     GIR_RootConstrainSelectedInstOperands,
     /* 317661 */     // GIR_Coverage, 6215,
     /* 317661 */     GIR_EraseRootFromParent_Done,
     /* 317662 */   // Label 6284: @317662
     /* 317662 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(317740), // Rule ID 6257 //
     /* 317667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317712 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317716 */     // MIs[3] Operand 1
     /* 317716 */     // No operand predicates
     /* 317716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317722 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317738 */     GIR_RootConstrainSelectedInstOperands,
     /* 317739 */     // GIR_Coverage, 6257,
     /* 317739 */     GIR_EraseRootFromParent_Done,
     /* 317740 */   // Label 6285: @317740
     /* 317740 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(317821), // Rule ID 6119 //
     /* 317745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317793 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317797 */     // MIs[3] Operand 1
     /* 317797 */     // No operand predicates
     /* 317797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317803 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317819 */     GIR_RootConstrainSelectedInstOperands,
     /* 317820 */     // GIR_Coverage, 6119,
     /* 317820 */     GIR_EraseRootFromParent_Done,
     /* 317821 */   // Label 6286: @317821
     /* 317821 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(317890), // Rule ID 2533 //
     /* 317826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317858 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317862 */     // MIs[2] Operand 1
     /* 317862 */     // No operand predicates
     /* 317862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317872 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 317875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317888 */     GIR_RootConstrainSelectedInstOperands,
     /* 317889 */     // GIR_Coverage, 2533,
     /* 317889 */     GIR_EraseRootFromParent_Done,
     /* 317890 */   // Label 6287: @317890
     /* 317890 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(317959), // Rule ID 6087 //
     /* 317895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317931 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317935 */     // MIs[2] Operand 1
     /* 317935 */     // No operand predicates
     /* 317935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317941 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 317944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317957 */     GIR_RootConstrainSelectedInstOperands,
     /* 317958 */     // GIR_Coverage, 6087,
     /* 317958 */     GIR_EraseRootFromParent_Done,
     /* 317959 */   // Label 6288: @317959
     /* 317959 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(318052), // Rule ID 6239 //
     /* 317964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 317972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 317976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 317988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318003 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318022 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318050 */     GIR_RootConstrainSelectedInstOperands,
     /* 318051 */     // GIR_Coverage, 6239,
     /* 318051 */     GIR_EraseRootFromParent_Done,
     /* 318052 */   // Label 6289: @318052
     /* 318052 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(318151), // Rule ID 6153 //
     /* 318057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318100 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318112 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318119 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 318143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318149 */     GIR_RootConstrainSelectedInstOperands,
     /* 318150 */     // GIR_Coverage, 6153,
     /* 318150 */     GIR_EraseRootFromParent_Done,
     /* 318151 */   // Label 6290: @318151
     /* 318151 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(318247), // Rule ID 6185 //
     /* 318156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 318179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318198 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318217 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318245 */     GIR_RootConstrainSelectedInstOperands,
     /* 318246 */     // GIR_Coverage, 6185,
     /* 318246 */     GIR_EraseRootFromParent_Done,
     /* 318247 */   // Label 6291: @318247
     /* 318247 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(318346), // Rule ID 6217 //
     /* 318252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 318280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318295 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318314 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318344 */     GIR_RootConstrainSelectedInstOperands,
     /* 318345 */     // GIR_Coverage, 6217,
     /* 318345 */     GIR_EraseRootFromParent_Done,
     /* 318346 */   // Label 6292: @318346
     /* 318346 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(318439), // Rule ID 6261 //
     /* 318351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318379 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318390 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318402 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318405 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318409 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318437 */     GIR_RootConstrainSelectedInstOperands,
     /* 318438 */     // GIR_Coverage, 6261,
     /* 318438 */     GIR_EraseRootFromParent_Done,
     /* 318439 */   // Label 6293: @318439
     /* 318439 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(318535), // Rule ID 6121 //
     /* 318444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 318471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318486 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318505 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318533 */     GIR_RootConstrainSelectedInstOperands,
     /* 318534 */     // GIR_Coverage, 6121,
     /* 318534 */     GIR_EraseRootFromParent_Done,
     /* 318535 */   // Label 6294: @318535
     /* 318535 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(318619), // Rule ID 2535 //
     /* 318540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318570 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318582 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318585 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318589 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 318605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318617 */     GIR_RootConstrainSelectedInstOperands,
     /* 318618 */     // GIR_Coverage, 2535,
     /* 318618 */     GIR_EraseRootFromParent_Done,
     /* 318619 */   // Label 6295: @318619
     /* 318619 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(318669), // Rule ID 13410 //
     /* 318624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318654 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 318654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 318657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318667 */     GIR_RootConstrainSelectedInstOperands,
     /* 318668 */     // GIR_Coverage, 13410,
     /* 318668 */     GIR_EraseRootFromParent_Done,
     /* 318669 */   // Label 6296: @318669
     /* 318669 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(318753), // Rule ID 6089 //
     /* 318674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318704 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318716 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318723 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 318739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318751 */     GIR_RootConstrainSelectedInstOperands,
     /* 318752 */     // GIR_Coverage, 6089,
     /* 318752 */     GIR_EraseRootFromParent_Done,
     /* 318753 */   // Label 6297: @318753
     /* 318753 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(318803), // Rule ID 1308 //
     /* 318758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318788 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 318788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 318791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318801 */     GIR_RootConstrainSelectedInstOperands,
     /* 318802 */     // GIR_Coverage, 1308,
     /* 318802 */     GIR_EraseRootFromParent_Done,
     /* 318803 */   // Label 6298: @318803
     /* 318803 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(318836), // Rule ID 1298 //
     /* 318808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318823 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 318823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 318826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 318834 */     GIR_RootConstrainSelectedInstOperands,
     /* 318835 */     // GIR_Coverage, 1298,
     /* 318835 */     GIR_EraseRootFromParent_Done,
     /* 318836 */   // Label 6299: @318836
     /* 318836 */   GIM_Reject,
     /* 318837 */ // Label 6280: @318837
     /* 318837 */ GIM_Reject,
     /* 318838 */ // Label 6172: @318838
     /* 318838 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(320358),
     /* 318843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 318849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 318852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318856 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(318934), // Rule ID 6247 //
     /* 318861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 318869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318902 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318906 */     // MIs[3] Operand 1
     /* 318906 */     // No operand predicates
     /* 318906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318916 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 318919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318932 */     GIR_RootConstrainSelectedInstOperands,
     /* 318933 */     // GIR_Coverage, 6247,
     /* 318933 */     GIR_EraseRootFromParent_Done,
     /* 318934 */   // Label 6301: @318934
     /* 318934 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(319018), // Rule ID 6159 //
     /* 318939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 318950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318975 */     // MIs[2] Operand 1
     /* 318975 */     // No operand predicates
     /* 318975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 318979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318983 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318987 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318998 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 319009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319016 */     GIR_RootConstrainSelectedInstOperands,
     /* 319017 */     // GIR_Coverage, 6159,
     /* 319017 */     GIR_EraseRootFromParent_Done,
     /* 319018 */   // Label 6302: @319018
     /* 319018 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(319099), // Rule ID 6191 //
     /* 319023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319067 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319071 */     // MIs[3] Operand 1
     /* 319071 */     // No operand predicates
     /* 319071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319079 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319081 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319097 */     GIR_RootConstrainSelectedInstOperands,
     /* 319098 */     // GIR_Coverage, 6191,
     /* 319098 */     GIR_EraseRootFromParent_Done,
     /* 319099 */   // Label 6303: @319099
     /* 319099 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(319183), // Rule ID 6223 //
     /* 319104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319153 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319157 */     // MIs[3] Operand 1
     /* 319157 */     // No operand predicates
     /* 319157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319163 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319181 */     GIR_RootConstrainSelectedInstOperands,
     /* 319182 */     // GIR_Coverage, 6223,
     /* 319182 */     GIR_EraseRootFromParent_Done,
     /* 319183 */   // Label 6304: @319183
     /* 319183 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(319261), // Rule ID 6269 //
     /* 319188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319233 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319237 */     // MIs[3] Operand 1
     /* 319237 */     // No operand predicates
     /* 319237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319243 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319259 */     GIR_RootConstrainSelectedInstOperands,
     /* 319260 */     // GIR_Coverage, 6269,
     /* 319260 */     GIR_EraseRootFromParent_Done,
     /* 319261 */   // Label 6305: @319261
     /* 319261 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(319342), // Rule ID 6127 //
     /* 319266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319314 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319318 */     // MIs[3] Operand 1
     /* 319318 */     // No operand predicates
     /* 319318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319324 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319340 */     GIR_RootConstrainSelectedInstOperands,
     /* 319341 */     // GIR_Coverage, 6127,
     /* 319341 */     GIR_EraseRootFromParent_Done,
     /* 319342 */   // Label 6306: @319342
     /* 319342 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(319411), // Rule ID 2541 //
     /* 319347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319383 */     // MIs[2] Operand 1
     /* 319383 */     // No operand predicates
     /* 319383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319393 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 319396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319409 */     GIR_RootConstrainSelectedInstOperands,
     /* 319410 */     // GIR_Coverage, 2541,
     /* 319410 */     GIR_EraseRootFromParent_Done,
     /* 319411 */   // Label 6307: @319411
     /* 319411 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(319480), // Rule ID 6095 //
     /* 319416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319452 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319456 */     // MIs[2] Operand 1
     /* 319456 */     // No operand predicates
     /* 319456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319462 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 319465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319478 */     GIR_RootConstrainSelectedInstOperands,
     /* 319479 */     // GIR_Coverage, 6095,
     /* 319479 */     GIR_EraseRootFromParent_Done,
     /* 319480 */   // Label 6308: @319480
     /* 319480 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(319573), // Rule ID 6249 //
     /* 319485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319524 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319543 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 319546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319571 */     GIR_RootConstrainSelectedInstOperands,
     /* 319572 */     // GIR_Coverage, 6249,
     /* 319572 */     GIR_EraseRootFromParent_Done,
     /* 319573 */   // Label 6309: @319573
     /* 319573 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(319672), // Rule ID 6161 //
     /* 319578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319621 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319633 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319640 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 319643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 319664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319670 */     GIR_RootConstrainSelectedInstOperands,
     /* 319671 */     // GIR_Coverage, 6161,
     /* 319671 */     GIR_EraseRootFromParent_Done,
     /* 319672 */   // Label 6310: @319672
     /* 319672 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(319768), // Rule ID 6193 //
     /* 319677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319719 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319731 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319738 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 319741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319766 */     GIR_RootConstrainSelectedInstOperands,
     /* 319767 */     // GIR_Coverage, 6193,
     /* 319767 */     GIR_EraseRootFromParent_Done,
     /* 319768 */   // Label 6311: @319768
     /* 319768 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(319867), // Rule ID 6225 //
     /* 319773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319816 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 319838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319865 */     GIR_RootConstrainSelectedInstOperands,
     /* 319866 */     // GIR_Coverage, 6225,
     /* 319866 */     GIR_EraseRootFromParent_Done,
     /* 319867 */   // Label 6312: @319867
     /* 319867 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(319960), // Rule ID 6271 //
     /* 319872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319911 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319923 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319926 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319930 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 319933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319958 */     GIR_RootConstrainSelectedInstOperands,
     /* 319959 */     // GIR_Coverage, 6271,
     /* 319959 */     GIR_EraseRootFromParent_Done,
     /* 319960 */   // Label 6313: @319960
     /* 319960 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(320056), // Rule ID 6129 //
     /* 319965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320007 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320026 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320054 */     GIR_RootConstrainSelectedInstOperands,
     /* 320055 */     // GIR_Coverage, 6129,
     /* 320055 */     GIR_EraseRootFromParent_Done,
     /* 320056 */   // Label 6314: @320056
     /* 320056 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(320140), // Rule ID 2543 //
     /* 320061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320091 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320103 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 320126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320138 */     GIR_RootConstrainSelectedInstOperands,
     /* 320139 */     // GIR_Coverage, 2543,
     /* 320139 */     GIR_EraseRootFromParent_Done,
     /* 320140 */   // Label 6315: @320140
     /* 320140 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(320190), // Rule ID 13414 //
     /* 320145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320175 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 320175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 320178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320188 */     GIR_RootConstrainSelectedInstOperands,
     /* 320189 */     // GIR_Coverage, 13414,
     /* 320189 */     GIR_EraseRootFromParent_Done,
     /* 320190 */   // Label 6316: @320190
     /* 320190 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(320274), // Rule ID 6097 //
     /* 320195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320225 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 320260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320272 */     GIR_RootConstrainSelectedInstOperands,
     /* 320273 */     // GIR_Coverage, 6097,
     /* 320273 */     GIR_EraseRootFromParent_Done,
     /* 320274 */   // Label 6317: @320274
     /* 320274 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(320324), // Rule ID 1312 //
     /* 320279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320309 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 320309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 320312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320322 */     GIR_RootConstrainSelectedInstOperands,
     /* 320323 */     // GIR_Coverage, 1312,
     /* 320323 */     GIR_EraseRootFromParent_Done,
     /* 320324 */   // Label 6318: @320324
     /* 320324 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(320357), // Rule ID 1302 //
     /* 320329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320344 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 320344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 320347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 320355 */     GIR_RootConstrainSelectedInstOperands,
     /* 320356 */     // GIR_Coverage, 1302,
     /* 320356 */     GIR_EraseRootFromParent_Done,
     /* 320357 */   // Label 6319: @320357
     /* 320357 */   GIM_Reject,
     /* 320358 */ // Label 6300: @320358
     /* 320358 */ GIM_Reject,
     /* 320359 */ // Label 6173: @320359
     /* 320359 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(321537),
     /* 320364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 320370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 320373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320377 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(320461), // Rule ID 6143 //
     /* 320382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320414 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320418 */     // MIs[2] Operand 1
     /* 320418 */     // No operand predicates
     /* 320418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 320422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320430 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320441 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 320444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 320452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320459 */     GIR_RootConstrainSelectedInstOperands,
     /* 320460 */     // GIR_Coverage, 6143,
     /* 320460 */     GIR_EraseRootFromParent_Done,
     /* 320461 */   // Label 6321: @320461
     /* 320461 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(320542), // Rule ID 6175 //
     /* 320466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320510 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320514 */     // MIs[3] Operand 1
     /* 320514 */     // No operand predicates
     /* 320514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320524 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 320527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320540 */     GIR_RootConstrainSelectedInstOperands,
     /* 320541 */     // GIR_Coverage, 6175,
     /* 320541 */     GIR_EraseRootFromParent_Done,
     /* 320542 */   // Label 6322: @320542
     /* 320542 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(320626), // Rule ID 6207 //
     /* 320547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320596 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320600 */     // MIs[3] Operand 1
     /* 320600 */     // No operand predicates
     /* 320600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320606 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 320609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320624 */     GIR_RootConstrainSelectedInstOperands,
     /* 320625 */     // GIR_Coverage, 6207,
     /* 320625 */     GIR_EraseRootFromParent_Done,
     /* 320626 */   // Label 6323: @320626
     /* 320626 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(320707), // Rule ID 6111 //
     /* 320631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320683 */     // MIs[3] Operand 1
     /* 320683 */     // No operand predicates
     /* 320683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320689 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 320692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320705 */     GIR_RootConstrainSelectedInstOperands,
     /* 320706 */     // GIR_Coverage, 6111,
     /* 320706 */     GIR_EraseRootFromParent_Done,
     /* 320707 */   // Label 6324: @320707
     /* 320707 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(320776), // Rule ID 2525 //
     /* 320712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320748 */     // MIs[2] Operand 1
     /* 320748 */     // No operand predicates
     /* 320748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320758 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 320761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320774 */     GIR_RootConstrainSelectedInstOperands,
     /* 320775 */     // GIR_Coverage, 2525,
     /* 320775 */     GIR_EraseRootFromParent_Done,
     /* 320776 */   // Label 6325: @320776
     /* 320776 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(320845), // Rule ID 6079 //
     /* 320781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320817 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320821 */     // MIs[2] Operand 1
     /* 320821 */     // No operand predicates
     /* 320821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320827 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 320830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320843 */     GIR_RootConstrainSelectedInstOperands,
     /* 320844 */     // GIR_Coverage, 6079,
     /* 320844 */     GIR_EraseRootFromParent_Done,
     /* 320845 */   // Label 6326: @320845
     /* 320845 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(320944), // Rule ID 6145 //
     /* 320850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 320870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320893 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 320896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320905 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320912 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 320925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 320928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 320936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320942 */     GIR_RootConstrainSelectedInstOperands,
     /* 320943 */     // GIR_Coverage, 6145,
     /* 320943 */     GIR_EraseRootFromParent_Done,
     /* 320944 */   // Label 6327: @320944
     /* 320944 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(321040), // Rule ID 6177 //
     /* 320949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 320981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320991 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 320994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321010 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321038 */     GIR_RootConstrainSelectedInstOperands,
     /* 321039 */     // GIR_Coverage, 6177,
     /* 321039 */     GIR_EraseRootFromParent_Done,
     /* 321040 */   // Label 6328: @321040
     /* 321040 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(321139), // Rule ID 6209 //
     /* 321045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321088 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321100 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321107 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321137 */     GIR_RootConstrainSelectedInstOperands,
     /* 321138 */     // GIR_Coverage, 6209,
     /* 321138 */     GIR_EraseRootFromParent_Done,
     /* 321139 */   // Label 6329: @321139
     /* 321139 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(321235), // Rule ID 6113 //
     /* 321144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321186 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321205 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321233 */     GIR_RootConstrainSelectedInstOperands,
     /* 321234 */     // GIR_Coverage, 6113,
     /* 321234 */     GIR_EraseRootFromParent_Done,
     /* 321235 */   // Label 6330: @321235
     /* 321235 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(321319), // Rule ID 2527 //
     /* 321240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321270 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321282 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321289 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 321305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321317 */     GIR_RootConstrainSelectedInstOperands,
     /* 321318 */     // GIR_Coverage, 2527,
     /* 321318 */     GIR_EraseRootFromParent_Done,
     /* 321319 */   // Label 6331: @321319
     /* 321319 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(321369), // Rule ID 13406 //
     /* 321324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321354 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 321354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 321357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321367 */     GIR_RootConstrainSelectedInstOperands,
     /* 321368 */     // GIR_Coverage, 13406,
     /* 321368 */     GIR_EraseRootFromParent_Done,
     /* 321369 */   // Label 6332: @321369
     /* 321369 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(321453), // Rule ID 6081 //
     /* 321374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321404 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321416 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321423 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 321439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321451 */     GIR_RootConstrainSelectedInstOperands,
     /* 321452 */     // GIR_Coverage, 6081,
     /* 321452 */     GIR_EraseRootFromParent_Done,
     /* 321453 */   // Label 6333: @321453
     /* 321453 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(321503), // Rule ID 1304 //
     /* 321458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321488 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 321488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 321491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321501 */     GIR_RootConstrainSelectedInstOperands,
     /* 321502 */     // GIR_Coverage, 1304,
     /* 321502 */     GIR_EraseRootFromParent_Done,
     /* 321503 */   // Label 6334: @321503
     /* 321503 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(321536), // Rule ID 1294 //
     /* 321508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321523 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 321523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 321526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 321534 */     GIR_RootConstrainSelectedInstOperands,
     /* 321535 */     // GIR_Coverage, 1294,
     /* 321535 */     GIR_EraseRootFromParent_Done,
     /* 321536 */   // Label 6335: @321536
     /* 321536 */   GIM_Reject,
     /* 321537 */ // Label 6320: @321537
     /* 321537 */ GIM_Reject,
     /* 321538 */ // Label 6174: @321538
     /* 321538 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(323058),
     /* 321543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 321549 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 321552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321556 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(321634), // Rule ID 6241 //
     /* 321561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 321598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321602 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 321606 */     // MIs[3] Operand 1
     /* 321606 */     // No operand predicates
     /* 321606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321616 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 321619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321632 */     GIR_RootConstrainSelectedInstOperands,
     /* 321633 */     // GIR_Coverage, 6241,
     /* 321633 */     GIR_EraseRootFromParent_Done,
     /* 321634 */   // Label 6337: @321634
     /* 321634 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(321718), // Rule ID 6155 //
     /* 321639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321671 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 321675 */     // MIs[2] Operand 1
     /* 321675 */     // No operand predicates
     /* 321675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321687 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321698 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 321701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 321709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321716 */     GIR_RootConstrainSelectedInstOperands,
     /* 321717 */     // GIR_Coverage, 6155,
     /* 321717 */     GIR_EraseRootFromParent_Done,
     /* 321718 */   // Label 6338: @321718
     /* 321718 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(321799), // Rule ID 6187 //
     /* 321723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321754 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321767 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 321771 */     // MIs[3] Operand 1
     /* 321771 */     // No operand predicates
     /* 321771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321781 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 321784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321797 */     GIR_RootConstrainSelectedInstOperands,
     /* 321798 */     // GIR_Coverage, 6187,
     /* 321798 */     GIR_EraseRootFromParent_Done,
     /* 321799 */   // Label 6339: @321799
     /* 321799 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(321883), // Rule ID 6219 //
     /* 321804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321853 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 321857 */     // MIs[3] Operand 1
     /* 321857 */     // No operand predicates
     /* 321857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321863 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 321866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321881 */     GIR_RootConstrainSelectedInstOperands,
     /* 321882 */     // GIR_Coverage, 6219,
     /* 321882 */     GIR_EraseRootFromParent_Done,
     /* 321883 */   // Label 6340: @321883
     /* 321883 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(321961), // Rule ID 6263 //
     /* 321888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 321929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321933 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 321937 */     // MIs[3] Operand 1
     /* 321937 */     // No operand predicates
     /* 321937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321943 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 321946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321959 */     GIR_RootConstrainSelectedInstOperands,
     /* 321960 */     // GIR_Coverage, 6263,
     /* 321960 */     GIR_EraseRootFromParent_Done,
     /* 321961 */   // Label 6341: @321961
     /* 321961 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(322042), // Rule ID 6123 //
     /* 321966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322014 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322018 */     // MIs[3] Operand 1
     /* 322018 */     // No operand predicates
     /* 322018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322024 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322040 */     GIR_RootConstrainSelectedInstOperands,
     /* 322041 */     // GIR_Coverage, 6123,
     /* 322041 */     GIR_EraseRootFromParent_Done,
     /* 322042 */   // Label 6342: @322042
     /* 322042 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(322111), // Rule ID 2537 //
     /* 322047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322083 */     // MIs[2] Operand 1
     /* 322083 */     // No operand predicates
     /* 322083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322093 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 322096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322109 */     GIR_RootConstrainSelectedInstOperands,
     /* 322110 */     // GIR_Coverage, 2537,
     /* 322110 */     GIR_EraseRootFromParent_Done,
     /* 322111 */   // Label 6343: @322111
     /* 322111 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(322180), // Rule ID 6091 //
     /* 322116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322156 */     // MIs[2] Operand 1
     /* 322156 */     // No operand predicates
     /* 322156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322162 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 322165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322178 */     GIR_RootConstrainSelectedInstOperands,
     /* 322179 */     // GIR_Coverage, 6091,
     /* 322179 */     GIR_EraseRootFromParent_Done,
     /* 322180 */   // Label 6344: @322180
     /* 322180 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(322273), // Rule ID 6245 //
     /* 322185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322224 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322236 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322243 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322271 */     GIR_RootConstrainSelectedInstOperands,
     /* 322272 */     // GIR_Coverage, 6245,
     /* 322272 */     GIR_EraseRootFromParent_Done,
     /* 322273 */   // Label 6345: @322273
     /* 322273 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(322372), // Rule ID 6157 //
     /* 322278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322321 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322333 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322340 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 322364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322370 */     GIR_RootConstrainSelectedInstOperands,
     /* 322371 */     // GIR_Coverage, 6157,
     /* 322371 */     GIR_EraseRootFromParent_Done,
     /* 322372 */   // Label 6346: @322372
     /* 322372 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(322468), // Rule ID 6189 //
     /* 322377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322419 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322431 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322438 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322466 */     GIR_RootConstrainSelectedInstOperands,
     /* 322467 */     // GIR_Coverage, 6189,
     /* 322467 */     GIR_EraseRootFromParent_Done,
     /* 322468 */   // Label 6347: @322468
     /* 322468 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(322567), // Rule ID 6221 //
     /* 322473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322516 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322528 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322531 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322535 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322565 */     GIR_RootConstrainSelectedInstOperands,
     /* 322566 */     // GIR_Coverage, 6221,
     /* 322566 */     GIR_EraseRootFromParent_Done,
     /* 322567 */   // Label 6348: @322567
     /* 322567 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(322660), // Rule ID 6267 //
     /* 322572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322611 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322630 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322658 */     GIR_RootConstrainSelectedInstOperands,
     /* 322659 */     // GIR_Coverage, 6267,
     /* 322659 */     GIR_EraseRootFromParent_Done,
     /* 322660 */   // Label 6349: @322660
     /* 322660 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(322756), // Rule ID 6125 //
     /* 322665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322707 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322726 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322754 */     GIR_RootConstrainSelectedInstOperands,
     /* 322755 */     // GIR_Coverage, 6125,
     /* 322755 */     GIR_EraseRootFromParent_Done,
     /* 322756 */   // Label 6350: @322756
     /* 322756 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(322840), // Rule ID 2539 //
     /* 322761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322791 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322803 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322806 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322810 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 322826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322838 */     GIR_RootConstrainSelectedInstOperands,
     /* 322839 */     // GIR_Coverage, 2539,
     /* 322839 */     GIR_EraseRootFromParent_Done,
     /* 322840 */   // Label 6351: @322840
     /* 322840 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(322890), // Rule ID 13412 //
     /* 322845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322875 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 322875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 322878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322888 */     GIR_RootConstrainSelectedInstOperands,
     /* 322889 */     // GIR_Coverage, 13412,
     /* 322889 */     GIR_EraseRootFromParent_Done,
     /* 322890 */   // Label 6352: @322890
     /* 322890 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(322974), // Rule ID 6093 //
     /* 322895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322925 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322937 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322944 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 322960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322972 */     GIR_RootConstrainSelectedInstOperands,
     /* 322973 */     // GIR_Coverage, 6093,
     /* 322973 */     GIR_EraseRootFromParent_Done,
     /* 322974 */   // Label 6353: @322974
     /* 322974 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(323024), // Rule ID 1310 //
     /* 322979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323009 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 323012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323022 */     GIR_RootConstrainSelectedInstOperands,
     /* 323023 */     // GIR_Coverage, 1310,
     /* 323023 */     GIR_EraseRootFromParent_Done,
     /* 323024 */   // Label 6354: @323024
     /* 323024 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(323057), // Rule ID 1300 //
     /* 323029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323044 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 323047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 323055 */     GIR_RootConstrainSelectedInstOperands,
     /* 323056 */     // GIR_Coverage, 1300,
     /* 323056 */     GIR_EraseRootFromParent_Done,
     /* 323057 */   // Label 6355: @323057
     /* 323057 */   GIM_Reject,
     /* 323058 */ // Label 6336: @323058
     /* 323058 */ GIM_Reject,
     /* 323059 */ // Label 6175: @323059
     /* 323059 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(324237),
     /* 323064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323070 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 323073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323077 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(323161), // Rule ID 6139 //
     /* 323082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323114 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323118 */     // MIs[2] Operand 1
     /* 323118 */     // No operand predicates
     /* 323118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323126 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323130 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323141 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 323152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323159 */     GIR_RootConstrainSelectedInstOperands,
     /* 323160 */     // GIR_Coverage, 6139,
     /* 323160 */     GIR_EraseRootFromParent_Done,
     /* 323161 */   // Label 6357: @323161
     /* 323161 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(323242), // Rule ID 6171 //
     /* 323166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323210 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323214 */     // MIs[3] Operand 1
     /* 323214 */     // No operand predicates
     /* 323214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323224 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323240 */     GIR_RootConstrainSelectedInstOperands,
     /* 323241 */     // GIR_Coverage, 6171,
     /* 323241 */     GIR_EraseRootFromParent_Done,
     /* 323242 */   // Label 6358: @323242
     /* 323242 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(323326), // Rule ID 6203 //
     /* 323247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323296 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323300 */     // MIs[3] Operand 1
     /* 323300 */     // No operand predicates
     /* 323300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323306 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323324 */     GIR_RootConstrainSelectedInstOperands,
     /* 323325 */     // GIR_Coverage, 6203,
     /* 323325 */     GIR_EraseRootFromParent_Done,
     /* 323326 */   // Label 6359: @323326
     /* 323326 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(323407), // Rule ID 6107 //
     /* 323331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323379 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323383 */     // MIs[3] Operand 1
     /* 323383 */     // No operand predicates
     /* 323383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323389 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323405 */     GIR_RootConstrainSelectedInstOperands,
     /* 323406 */     // GIR_Coverage, 6107,
     /* 323406 */     GIR_EraseRootFromParent_Done,
     /* 323407 */   // Label 6360: @323407
     /* 323407 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(323476), // Rule ID 2521 //
     /* 323412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323444 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323448 */     // MIs[2] Operand 1
     /* 323448 */     // No operand predicates
     /* 323448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323458 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 323461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323474 */     GIR_RootConstrainSelectedInstOperands,
     /* 323475 */     // GIR_Coverage, 2521,
     /* 323475 */     GIR_EraseRootFromParent_Done,
     /* 323476 */   // Label 6361: @323476
     /* 323476 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(323545), // Rule ID 6075 //
     /* 323481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323517 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323521 */     // MIs[2] Operand 1
     /* 323521 */     // No operand predicates
     /* 323521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323527 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 323530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323543 */     GIR_RootConstrainSelectedInstOperands,
     /* 323544 */     // GIR_Coverage, 6075,
     /* 323544 */     GIR_EraseRootFromParent_Done,
     /* 323545 */   // Label 6362: @323545
     /* 323545 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(323644), // Rule ID 6141 //
     /* 323550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323593 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323605 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323612 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 323636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323642 */     GIR_RootConstrainSelectedInstOperands,
     /* 323643 */     // GIR_Coverage, 6141,
     /* 323643 */     GIR_EraseRootFromParent_Done,
     /* 323644 */   // Label 6363: @323644
     /* 323644 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(323740), // Rule ID 6173 //
     /* 323649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323691 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323703 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323710 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323738 */     GIR_RootConstrainSelectedInstOperands,
     /* 323739 */     // GIR_Coverage, 6173,
     /* 323739 */     GIR_EraseRootFromParent_Done,
     /* 323740 */   // Label 6364: @323740
     /* 323740 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(323839), // Rule ID 6205 //
     /* 323745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323788 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323800 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323837 */     GIR_RootConstrainSelectedInstOperands,
     /* 323838 */     // GIR_Coverage, 6205,
     /* 323838 */     GIR_EraseRootFromParent_Done,
     /* 323839 */   // Label 6365: @323839
     /* 323839 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(323935), // Rule ID 6109 //
     /* 323844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323886 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323898 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323905 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323933 */     GIR_RootConstrainSelectedInstOperands,
     /* 323934 */     // GIR_Coverage, 6109,
     /* 323934 */     GIR_EraseRootFromParent_Done,
     /* 323935 */   // Label 6366: @323935
     /* 323935 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(324019), // Rule ID 2523 //
     /* 323940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323970 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323982 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323989 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324017 */     GIR_RootConstrainSelectedInstOperands,
     /* 324018 */     // GIR_Coverage, 2523,
     /* 324018 */     GIR_EraseRootFromParent_Done,
     /* 324019 */   // Label 6367: @324019
     /* 324019 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(324069), // Rule ID 13408 //
     /* 324024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324054 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 324057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324067 */     GIR_RootConstrainSelectedInstOperands,
     /* 324068 */     // GIR_Coverage, 13408,
     /* 324068 */     GIR_EraseRootFromParent_Done,
     /* 324069 */   // Label 6368: @324069
     /* 324069 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(324153), // Rule ID 6077 //
     /* 324074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324104 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324116 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324119 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324123 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324151 */     GIR_RootConstrainSelectedInstOperands,
     /* 324152 */     // GIR_Coverage, 6077,
     /* 324152 */     GIR_EraseRootFromParent_Done,
     /* 324153 */   // Label 6369: @324153
     /* 324153 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(324203), // Rule ID 1306 //
     /* 324158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324188 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 324191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324201 */     GIR_RootConstrainSelectedInstOperands,
     /* 324202 */     // GIR_Coverage, 1306,
     /* 324202 */     GIR_EraseRootFromParent_Done,
     /* 324203 */   // Label 6370: @324203
     /* 324203 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(324236), // Rule ID 1296 //
     /* 324208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324223 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 324226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 324234 */     GIR_RootConstrainSelectedInstOperands,
     /* 324235 */     // GIR_Coverage, 1296,
     /* 324235 */     GIR_EraseRootFromParent_Done,
     /* 324236 */   // Label 6371: @324236
     /* 324236 */   GIM_Reject,
     /* 324237 */ // Label 6356: @324237
     /* 324237 */ GIM_Reject,
     /* 324238 */ // Label 6176: @324238
     /* 324238 */ GIM_Reject,
     /* 324239 */ // Label 63: @324239
     /* 324239 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6380*/ GIMT_Encode4(324854),
     /* 324250 */ /*GILLT_s16*//*Label 6372*/ GIMT_Encode4(324290),
     /* 324254 */ /*GILLT_s32*//*Label 6373*/ GIMT_Encode4(324328),
     /* 324258 */ /*GILLT_s64*//*Label 6374*/ GIMT_Encode4(324366), GIMT_Encode4(0),
     /* 324266 */ /*GILLT_v2s32*//*Label 6375*/ GIMT_Encode4(324404),
     /* 324270 */ /*GILLT_v2s64*//*Label 6376*/ GIMT_Encode4(324442),
     /* 324274 */ /*GILLT_v4s16*//*Label 6377*/ GIMT_Encode4(324480),
     /* 324278 */ /*GILLT_v4s32*//*Label 6378*/ GIMT_Encode4(324518), GIMT_Encode4(0),
     /* 324286 */ /*GILLT_v8s16*//*Label 6379*/ GIMT_Encode4(324556),
     /* 324290 */ // Label 6372: @324290
     /* 324290 */ GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(324327), // Rule ID 590 //
     /* 324295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324316 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 324316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 324321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324325 */   GIR_RootConstrainSelectedInstOperands,
     /* 324326 */   // GIR_Coverage, 590,
     /* 324326 */   GIR_Done,
     /* 324327 */ // Label 6381: @324327
     /* 324327 */ GIM_Reject,
     /* 324328 */ // Label 6373: @324328
     /* 324328 */ GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(324365), // Rule ID 592 //
     /* 324333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324354 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 324354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 324359 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324363 */   GIR_RootConstrainSelectedInstOperands,
     /* 324364 */   // GIR_Coverage, 592,
     /* 324364 */   GIR_Done,
     /* 324365 */ // Label 6382: @324365
     /* 324365 */ GIM_Reject,
     /* 324366 */ // Label 6374: @324366
     /* 324366 */ GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(324403), // Rule ID 594 //
     /* 324371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324392 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 324392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 324397 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324401 */   GIR_RootConstrainSelectedInstOperands,
     /* 324402 */   // GIR_Coverage, 594,
     /* 324402 */   GIR_Done,
     /* 324403 */ // Label 6383: @324403
     /* 324403 */ GIM_Reject,
     /* 324404 */ // Label 6375: @324404
     /* 324404 */ GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(324441), // Rule ID 1228 //
     /* 324409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324430 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 324435 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324439 */   GIR_RootConstrainSelectedInstOperands,
     /* 324440 */   // GIR_Coverage, 1228,
     /* 324440 */   GIR_Done,
     /* 324441 */ // Label 6384: @324441
     /* 324441 */ GIM_Reject,
     /* 324442 */ // Label 6376: @324442
     /* 324442 */ GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(324479), // Rule ID 1232 //
     /* 324447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324468 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 324473 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324477 */   GIR_RootConstrainSelectedInstOperands,
     /* 324478 */   // GIR_Coverage, 1232,
     /* 324478 */   GIR_Done,
     /* 324479 */ // Label 6385: @324479
     /* 324479 */ GIM_Reject,
     /* 324480 */ // Label 6377: @324480
     /* 324480 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(324517), // Rule ID 1224 //
     /* 324485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324506 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 324511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324515 */   GIR_RootConstrainSelectedInstOperands,
     /* 324516 */   // GIR_Coverage, 1224,
     /* 324516 */   GIR_Done,
     /* 324517 */ // Label 6386: @324517
     /* 324517 */ GIM_Reject,
     /* 324518 */ // Label 6378: @324518
     /* 324518 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(324555), // Rule ID 1230 //
     /* 324523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324544 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 324549 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324553 */   GIR_RootConstrainSelectedInstOperands,
     /* 324554 */   // GIR_Coverage, 1230,
     /* 324554 */   GIR_Done,
     /* 324555 */ // Label 6387: @324555
     /* 324555 */ GIM_Reject,
     /* 324556 */ // Label 6379: @324556
     /* 324556 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(324853),
     /* 324561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324579 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(324598), // Rule ID 1226 //
     /* 324584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324587 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 324592 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324596 */     GIR_RootConstrainSelectedInstOperands,
     /* 324597 */     // GIR_Coverage, 1226,
     /* 324597 */     GIR_Done,
     /* 324598 */   // Label 6389: @324598
     /* 324598 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(324852), // Rule ID 7042 //
     /* 324603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 324606 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 324606 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 324609 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 324613 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324618 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 324622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 324624 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 324627 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 324631 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324636 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 324642 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 324645 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 324649 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324654 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 324657 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 324660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 324662 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 324665 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324669 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324674 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 324680 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324685 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324690 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 324693 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 324697 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324702 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 324705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 324707 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 324710 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324714 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324719 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 324725 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324730 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324735 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 324738 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 324742 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324747 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 324750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 324752 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 324755 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 324759 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324764 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 324767 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 324770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 324772 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 324775 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 324779 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324784 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 324787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 324789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 324792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 324796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 324810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324818 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 324821 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 324824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 324842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 324850 */     GIR_RootConstrainSelectedInstOperands,
     /* 324851 */     // GIR_Coverage, 7042,
     /* 324851 */     GIR_EraseRootFromParent_Done,
     /* 324852 */   // Label 6390: @324852
     /* 324852 */   GIM_Reject,
     /* 324853 */ // Label 6388: @324853
     /* 324853 */ GIM_Reject,
     /* 324854 */ // Label 6380: @324854
     /* 324854 */ GIM_Reject,
     /* 324855 */ // Label 64: @324855
     /* 324855 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6399*/ GIMT_Encode4(328361),
     /* 324866 */ /*GILLT_s16*//*Label 6391*/ GIMT_Encode4(324906),
     /* 324870 */ /*GILLT_s32*//*Label 6392*/ GIMT_Encode4(326074),
     /* 324874 */ /*GILLT_s64*//*Label 6393*/ GIMT_Encode4(327097), GIMT_Encode4(0),
     /* 324882 */ /*GILLT_v2s32*//*Label 6394*/ GIMT_Encode4(328120),
     /* 324886 */ /*GILLT_v2s64*//*Label 6395*/ GIMT_Encode4(328147),
     /* 324890 */ /*GILLT_v4s16*//*Label 6396*/ GIMT_Encode4(328174),
     /* 324894 */ /*GILLT_v4s32*//*Label 6397*/ GIMT_Encode4(328254), GIMT_Encode4(0),
     /* 324902 */ /*GILLT_v8s16*//*Label 6398*/ GIMT_Encode4(328281),
     /* 324906 */ // Label 6391: @324906
     /* 324906 */ GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(326073),
     /* 324911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324918 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(325076), // Rule ID 4880 //
     /* 324923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 324934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324942 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 324946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 324954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324967 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 324971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 324975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 324979 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324983 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 324987 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324992 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 324996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325003 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 325006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325015 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325021 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325043 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 325070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325074 */     GIR_RootConstrainSelectedInstOperands,
     /* 325075 */     // GIR_Coverage, 4880,
     /* 325075 */     GIR_EraseRootFromParent_Done,
     /* 325076 */   // Label 6401: @325076
     /* 325076 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(325234), // Rule ID 4879 //
     /* 325081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 325092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325100 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325125 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 325133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325137 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325141 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 325145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325150 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 325154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325161 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 325164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325173 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325184 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325201 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 325228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325232 */     GIR_RootConstrainSelectedInstOperands,
     /* 325233 */     // GIR_Coverage, 4879,
     /* 325233 */     GIR_EraseRootFromParent_Done,
     /* 325234 */   // Label 6402: @325234
     /* 325234 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(325345), // Rule ID 4878 //
     /* 325239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 325250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325258 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325283 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325299 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 325299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325311 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325343 */     GIR_RootConstrainSelectedInstOperands,
     /* 325344 */     // GIR_Coverage, 4878,
     /* 325344 */     GIR_EraseRootFromParent_Done,
     /* 325345 */   // Label 6403: @325345
     /* 325345 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(325456), // Rule ID 4876 //
     /* 325350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 325361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325369 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325399 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325410 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325422 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325454 */     GIR_RootConstrainSelectedInstOperands,
     /* 325455 */     // GIR_Coverage, 4876,
     /* 325455 */     GIR_EraseRootFromParent_Done,
     /* 325456 */   // Label 6404: @325456
     /* 325456 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(325567), // Rule ID 4877 //
     /* 325461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 325472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325505 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325521 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 325521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325533 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325565 */     GIR_RootConstrainSelectedInstOperands,
     /* 325566 */     // GIR_Coverage, 4877,
     /* 325566 */     GIR_EraseRootFromParent_Done,
     /* 325567 */   // Label 6405: @325567
     /* 325567 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(325678), // Rule ID 4875 //
     /* 325572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 325583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325591 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325632 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325644 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325676 */     GIR_RootConstrainSelectedInstOperands,
     /* 325677 */     // GIR_Coverage, 4875,
     /* 325677 */     GIR_EraseRootFromParent_Done,
     /* 325678 */   // Label 6406: @325678
     /* 325678 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(325742), // Rule ID 650 //
     /* 325683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 325694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325702 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325723 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 325723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325740 */     GIR_RootConstrainSelectedInstOperands,
     /* 325741 */     // GIR_Coverage, 650,
     /* 325741 */     GIR_EraseRootFromParent_Done,
     /* 325742 */   // Label 6407: @325742
     /* 325742 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(325806), // Rule ID 649 //
     /* 325747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 325758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325766 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325787 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 325787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325804 */     GIR_RootConstrainSelectedInstOperands,
     /* 325805 */     // GIR_Coverage, 649,
     /* 325805 */     GIR_EraseRootFromParent_Done,
     /* 325806 */   // Label 6408: @325806
     /* 325806 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(325857), // Rule ID 626 //
     /* 325811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 325822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325842 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 325845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325855 */     GIR_RootConstrainSelectedInstOperands,
     /* 325856 */     // GIR_Coverage, 626,
     /* 325856 */     GIR_EraseRootFromParent_Done,
     /* 325857 */   // Label 6409: @325857
     /* 325857 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(325908), // Rule ID 625 //
     /* 325862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 325873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325893 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 325896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325906 */     GIR_RootConstrainSelectedInstOperands,
     /* 325907 */     // GIR_Coverage, 625,
     /* 325907 */     GIR_EraseRootFromParent_Done,
     /* 325908 */   // Label 6410: @325908
     /* 325908 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(325927), // Rule ID 524 //
     /* 325913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325920 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 325920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 325925 */     GIR_RootConstrainSelectedInstOperands,
     /* 325926 */     // GIR_Coverage, 524,
     /* 325926 */     GIR_Done,
     /* 325927 */   // Label 6411: @325927
     /* 325927 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(326072), // Rule ID 6407 //
     /* 325932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325936 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 325936 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 325939 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325943 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 325950 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 325953 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 325957 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325962 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 325965 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325969 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 325972 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325977 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325982 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325987 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 325990 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325994 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325999 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 326002 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 326010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 326014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326019 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326022 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 326027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326041 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326054 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 326061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326071 */     // GIR_Coverage, 6407,
     /* 326071 */     GIR_EraseRootFromParent_Done,
     /* 326072 */   // Label 6412: @326072
     /* 326072 */   GIM_Reject,
     /* 326073 */ // Label 6400: @326073
     /* 326073 */ GIM_Reject,
     /* 326074 */ // Label 6392: @326074
     /* 326074 */ GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(327096),
     /* 326079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326086 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(326244), // Rule ID 4886 //
     /* 326091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326110 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326135 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326147 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326151 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 326155 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326160 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 326164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326171 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 326171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 326174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326183 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 326189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326194 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326211 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 326217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 326238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326242 */     GIR_RootConstrainSelectedInstOperands,
     /* 326243 */     // GIR_Coverage, 4886,
     /* 326243 */     GIR_EraseRootFromParent_Done,
     /* 326244 */   // Label 6414: @326244
     /* 326244 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(326402), // Rule ID 4885 //
     /* 326249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326268 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326293 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326305 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 326313 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326318 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 326322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326329 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 326329 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 326332 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326336 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326341 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 326347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326352 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 326375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 326396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326400 */     GIR_RootConstrainSelectedInstOperands,
     /* 326401 */     // GIR_Coverage, 4885,
     /* 326401 */     GIR_EraseRootFromParent_Done,
     /* 326402 */   // Label 6415: @326402
     /* 326402 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(326513), // Rule ID 4884 //
     /* 326407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326426 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326451 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326467 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 326467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326479 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 326485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326511 */     GIR_RootConstrainSelectedInstOperands,
     /* 326512 */     // GIR_Coverage, 4884,
     /* 326512 */     GIR_EraseRootFromParent_Done,
     /* 326513 */   // Label 6416: @326513
     /* 326513 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(326624), // Rule ID 4882 //
     /* 326518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326537 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326567 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326578 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 326578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326590 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 326596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326622 */     GIR_RootConstrainSelectedInstOperands,
     /* 326623 */     // GIR_Coverage, 4882,
     /* 326623 */     GIR_EraseRootFromParent_Done,
     /* 326624 */   // Label 6417: @326624
     /* 326624 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(326735), // Rule ID 4883 //
     /* 326629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326648 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326673 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326689 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 326689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326701 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 326707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326733 */     GIR_RootConstrainSelectedInstOperands,
     /* 326734 */     // GIR_Coverage, 4883,
     /* 326734 */     GIR_EraseRootFromParent_Done,
     /* 326735 */   // Label 6418: @326735
     /* 326735 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(326846), // Rule ID 4881 //
     /* 326740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326759 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326789 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326800 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 326800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326812 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 326818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326844 */     GIR_RootConstrainSelectedInstOperands,
     /* 326845 */     // GIR_Coverage, 4881,
     /* 326845 */     GIR_EraseRootFromParent_Done,
     /* 326846 */   // Label 6419: @326846
     /* 326846 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(326910), // Rule ID 652 //
     /* 326851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326870 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326891 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 326891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326908 */     GIR_RootConstrainSelectedInstOperands,
     /* 326909 */     // GIR_Coverage, 652,
     /* 326909 */     GIR_EraseRootFromParent_Done,
     /* 326910 */   // Label 6420: @326910
     /* 326910 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(326974), // Rule ID 651 //
     /* 326915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326934 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326955 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 326955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326972 */     GIR_RootConstrainSelectedInstOperands,
     /* 326973 */     // GIR_Coverage, 651,
     /* 326973 */     GIR_EraseRootFromParent_Done,
     /* 326974 */   // Label 6421: @326974
     /* 326974 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(327025), // Rule ID 628 //
     /* 326979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 326990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327010 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 327013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327023 */     GIR_RootConstrainSelectedInstOperands,
     /* 327024 */     // GIR_Coverage, 628,
     /* 327024 */     GIR_EraseRootFromParent_Done,
     /* 327025 */   // Label 6422: @327025
     /* 327025 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(327076), // Rule ID 627 //
     /* 327030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 327041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327061 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 327064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327074 */     GIR_RootConstrainSelectedInstOperands,
     /* 327075 */     // GIR_Coverage, 627,
     /* 327075 */     GIR_EraseRootFromParent_Done,
     /* 327076 */   // Label 6423: @327076
     /* 327076 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(327095), // Rule ID 525 //
     /* 327081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327088 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 327088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 327093 */     GIR_RootConstrainSelectedInstOperands,
     /* 327094 */     // GIR_Coverage, 525,
     /* 327094 */     GIR_Done,
     /* 327095 */   // Label 6424: @327095
     /* 327095 */   GIM_Reject,
     /* 327096 */ // Label 6413: @327096
     /* 327096 */ GIM_Reject,
     /* 327097 */ // Label 6393: @327097
     /* 327097 */ GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(328119),
     /* 327102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327109 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(327267), // Rule ID 4892 //
     /* 327114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327133 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327158 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327170 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327174 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327178 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327183 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327194 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 327194 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 327197 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327201 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327206 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 327212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327217 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327234 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 327240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327265 */     GIR_RootConstrainSelectedInstOperands,
     /* 327266 */     // GIR_Coverage, 4892,
     /* 327266 */     GIR_EraseRootFromParent_Done,
     /* 327267 */   // Label 6426: @327267
     /* 327267 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(327425), // Rule ID 4891 //
     /* 327272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327332 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327336 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327341 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327352 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 327352 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 327355 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327359 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327364 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 327370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327392 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 327398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327423 */     GIR_RootConstrainSelectedInstOperands,
     /* 327424 */     // GIR_Coverage, 4891,
     /* 327424 */     GIR_EraseRootFromParent_Done,
     /* 327425 */   // Label 6427: @327425
     /* 327425 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(327536), // Rule ID 4890 //
     /* 327430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327449 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327474 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327490 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 327490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327502 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 327508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327534 */     GIR_RootConstrainSelectedInstOperands,
     /* 327535 */     // GIR_Coverage, 4890,
     /* 327535 */     GIR_EraseRootFromParent_Done,
     /* 327536 */   // Label 6428: @327536
     /* 327536 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(327647), // Rule ID 4888 //
     /* 327541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327560 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327590 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327601 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 327601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327613 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 327619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327645 */     GIR_RootConstrainSelectedInstOperands,
     /* 327646 */     // GIR_Coverage, 4888,
     /* 327646 */     GIR_EraseRootFromParent_Done,
     /* 327647 */   // Label 6429: @327647
     /* 327647 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(327758), // Rule ID 4889 //
     /* 327652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327671 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327696 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327712 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 327712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327724 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 327730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327756 */     GIR_RootConstrainSelectedInstOperands,
     /* 327757 */     // GIR_Coverage, 4889,
     /* 327757 */     GIR_EraseRootFromParent_Done,
     /* 327758 */   // Label 6430: @327758
     /* 327758 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(327869), // Rule ID 4887 //
     /* 327763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327782 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327812 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327823 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 327823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327835 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 327841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327867 */     GIR_RootConstrainSelectedInstOperands,
     /* 327868 */     // GIR_Coverage, 4887,
     /* 327868 */     GIR_EraseRootFromParent_Done,
     /* 327869 */   // Label 6431: @327869
     /* 327869 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(327933), // Rule ID 654 //
     /* 327874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327893 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327914 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 327914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327931 */     GIR_RootConstrainSelectedInstOperands,
     /* 327932 */     // GIR_Coverage, 654,
     /* 327932 */     GIR_EraseRootFromParent_Done,
     /* 327933 */   // Label 6432: @327933
     /* 327933 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(327997), // Rule ID 653 //
     /* 327938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327957 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327978 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 327978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327995 */     GIR_RootConstrainSelectedInstOperands,
     /* 327996 */     // GIR_Coverage, 653,
     /* 327996 */     GIR_EraseRootFromParent_Done,
     /* 327997 */   // Label 6433: @327997
     /* 327997 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(328048), // Rule ID 630 //
     /* 328002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 328013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328033 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 328033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 328036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328046 */     GIR_RootConstrainSelectedInstOperands,
     /* 328047 */     // GIR_Coverage, 630,
     /* 328047 */     GIR_EraseRootFromParent_Done,
     /* 328048 */   // Label 6434: @328048
     /* 328048 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(328099), // Rule ID 629 //
     /* 328053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 328064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328084 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 328084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 328087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328097 */     GIR_RootConstrainSelectedInstOperands,
     /* 328098 */     // GIR_Coverage, 629,
     /* 328098 */     GIR_EraseRootFromParent_Done,
     /* 328099 */   // Label 6435: @328099
     /* 328099 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(328118), // Rule ID 526 //
     /* 328104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328111 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 328111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 328116 */     GIR_RootConstrainSelectedInstOperands,
     /* 328117 */     // GIR_Coverage, 526,
     /* 328117 */     GIR_Done,
     /* 328118 */   // Label 6436: @328118
     /* 328118 */   GIM_Reject,
     /* 328119 */ // Label 6425: @328119
     /* 328119 */ GIM_Reject,
     /* 328120 */ // Label 6394: @328120
     /* 328120 */ GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(328146), // Rule ID 860 //
     /* 328125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328139 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 328139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 328144 */   GIR_RootConstrainSelectedInstOperands,
     /* 328145 */   // GIR_Coverage, 860,
     /* 328145 */   GIR_Done,
     /* 328146 */ // Label 6437: @328146
     /* 328146 */ GIM_Reject,
     /* 328147 */ // Label 6395: @328147
     /* 328147 */ GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(328173), // Rule ID 862 //
     /* 328152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328166 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 328166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 328171 */   GIR_RootConstrainSelectedInstOperands,
     /* 328172 */   // GIR_Coverage, 862,
     /* 328172 */   GIR_Done,
     /* 328173 */ // Label 6438: @328173
     /* 328173 */ GIM_Reject,
     /* 328174 */ // Label 6396: @328174
     /* 328174 */ GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(328253),
     /* 328179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328190 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(328205), // Rule ID 858 //
     /* 328195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 328198 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 328198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 328203 */     GIR_RootConstrainSelectedInstOperands,
     /* 328204 */     // GIR_Coverage, 858,
     /* 328204 */     GIR_Done,
     /* 328205 */   // Label 6440: @328205
     /* 328205 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(328252), // Rule ID 6410 //
     /* 328210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328213 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 328213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 328220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328225 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 328235 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 328243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328250 */     GIR_RootConstrainSelectedInstOperands,
     /* 328251 */     // GIR_Coverage, 6410,
     /* 328251 */     GIR_EraseRootFromParent_Done,
     /* 328252 */   // Label 6441: @328252
     /* 328252 */   GIM_Reject,
     /* 328253 */ // Label 6439: @328253
     /* 328253 */ GIM_Reject,
     /* 328254 */ // Label 6397: @328254
     /* 328254 */ GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(328280), // Rule ID 861 //
     /* 328259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328273 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 328273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 328278 */   GIR_RootConstrainSelectedInstOperands,
     /* 328279 */   // GIR_Coverage, 861,
     /* 328279 */   GIR_Done,
     /* 328280 */ // Label 6442: @328280
     /* 328280 */ GIM_Reject,
     /* 328281 */ // Label 6398: @328281
     /* 328281 */ GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(328360),
     /* 328286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328297 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(328312), // Rule ID 859 //
     /* 328302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 328305 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 328305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 328310 */     GIR_RootConstrainSelectedInstOperands,
     /* 328311 */     // GIR_Coverage, 859,
     /* 328311 */     GIR_Done,
     /* 328312 */   // Label 6444: @328312
     /* 328312 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(328359), // Rule ID 6411 //
     /* 328317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328320 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 328320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 328327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328332 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 328342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 328350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328357 */     GIR_RootConstrainSelectedInstOperands,
     /* 328358 */     // GIR_Coverage, 6411,
     /* 328358 */     GIR_EraseRootFromParent_Done,
     /* 328359 */   // Label 6445: @328359
     /* 328359 */   GIM_Reject,
     /* 328360 */ // Label 6443: @328360
     /* 328360 */ GIM_Reject,
     /* 328361 */ // Label 6399: @328361
     /* 328361 */ GIM_Reject,
     /* 328362 */ // Label 65: @328362
     /* 328362 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6450*/ GIMT_Encode4(328609),
     /* 328373 */ /*GILLT_s32*//*Label 6446*/ GIMT_Encode4(328401),
     /* 328377 */ /*GILLT_s64*//*Label 6447*/ GIMT_Encode4(328432), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 328389 */ /*GILLT_v2s64*//*Label 6448*/ GIMT_Encode4(328493), GIMT_Encode4(0),
     /* 328397 */ /*GILLT_v4s32*//*Label 6449*/ GIMT_Encode4(328551),
     /* 328401 */ // Label 6446: @328401
     /* 328401 */ GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(328431), // Rule ID 516 //
     /* 328406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 328412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328420 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 328420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 328425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328429 */   GIR_RootConstrainSelectedInstOperands,
     /* 328430 */   // GIR_Coverage, 516,
     /* 328430 */   GIR_Done,
     /* 328431 */ // Label 6451: @328431
     /* 328431 */ GIM_Reject,
     /* 328432 */ // Label 6447: @328432
     /* 328432 */ GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(328462), // Rule ID 514 //
     /* 328437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 328443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328451 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 328451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 328456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328460 */   GIR_RootConstrainSelectedInstOperands,
     /* 328461 */   // GIR_Coverage, 514,
     /* 328461 */   GIR_Done,
     /* 328462 */ // Label 6452: @328462
     /* 328462 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(328492), // Rule ID 518 //
     /* 328467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328481 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 328481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 328486 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328490 */   GIR_RootConstrainSelectedInstOperands,
     /* 328491 */   // GIR_Coverage, 518,
     /* 328491 */   GIR_Done,
     /* 328492 */ // Label 6453: @328492
     /* 328492 */ GIM_Reject,
     /* 328493 */ // Label 6448: @328493
     /* 328493 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(328550),
     /* 328498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328505 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(328529), // Rule ID 4935 //
     /* 328510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 328517 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 328517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 328520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328527 */     GIR_RootConstrainSelectedInstOperands,
     /* 328528 */     // GIR_Coverage, 4935,
     /* 328528 */     GIR_EraseRootFromParent_Done,
     /* 328529 */   // Label 6455: @328529
     /* 328529 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(328549), // Rule ID 4933 //
     /* 328534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328538 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 328538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 328543 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328547 */     GIR_RootConstrainSelectedInstOperands,
     /* 328548 */     // GIR_Coverage, 4933,
     /* 328548 */     GIR_Done,
     /* 328549 */   // Label 6456: @328549
     /* 328549 */   GIM_Reject,
     /* 328550 */ // Label 6454: @328550
     /* 328550 */ GIM_Reject,
     /* 328551 */ // Label 6449: @328551
     /* 328551 */ GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(328608),
     /* 328556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328563 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(328587), // Rule ID 4939 //
     /* 328568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 328575 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 328575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 328578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328585 */     GIR_RootConstrainSelectedInstOperands,
     /* 328586 */     // GIR_Coverage, 4939,
     /* 328586 */     GIR_EraseRootFromParent_Done,
     /* 328587 */   // Label 6458: @328587
     /* 328587 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(328607), // Rule ID 4937 //
     /* 328592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328596 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 328596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 328601 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328605 */     GIR_RootConstrainSelectedInstOperands,
     /* 328606 */     // GIR_Coverage, 4937,
     /* 328606 */     GIR_Done,
     /* 328607 */   // Label 6459: @328607
     /* 328607 */   GIM_Reject,
     /* 328608 */ // Label 6457: @328608
     /* 328608 */ GIM_Reject,
     /* 328609 */ // Label 6450: @328609
     /* 328609 */ GIM_Reject,
     /* 328610 */ // Label 66: @328610
     /* 328610 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6464*/ GIMT_Encode4(328797),
     /* 328621 */ /*GILLT_s16*//*Label 6460*/ GIMT_Encode4(328649),
     /* 328625 */ /*GILLT_s32*//*Label 6461*/ GIMT_Encode4(328710), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 328637 */ /*GILLT_v2s32*//*Label 6462*/ GIMT_Encode4(328741), GIMT_Encode4(0),
     /* 328645 */ /*GILLT_v4s16*//*Label 6463*/ GIMT_Encode4(328769),
     /* 328649 */ // Label 6460: @328649
     /* 328649 */ GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(328679), // Rule ID 510 //
     /* 328654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328668 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 328668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 328673 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328677 */   GIR_RootConstrainSelectedInstOperands,
     /* 328678 */   // GIR_Coverage, 510,
     /* 328678 */   GIR_Done,
     /* 328679 */ // Label 6465: @328679
     /* 328679 */ GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(328709), // Rule ID 520 //
     /* 328684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328698 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 328698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 328703 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328707 */   GIR_RootConstrainSelectedInstOperands,
     /* 328708 */   // GIR_Coverage, 520,
     /* 328708 */   GIR_Done,
     /* 328709 */ // Label 6466: @328709
     /* 328709 */ GIM_Reject,
     /* 328710 */ // Label 6461: @328710
     /* 328710 */ GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(328740), // Rule ID 512 //
     /* 328715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328729 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 328729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 328734 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328738 */   GIR_RootConstrainSelectedInstOperands,
     /* 328739 */   // GIR_Coverage, 512,
     /* 328739 */   GIR_Done,
     /* 328740 */ // Label 6467: @328740
     /* 328740 */ GIM_Reject,
     /* 328741 */ // Label 6462: @328741
     /* 328741 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(328768), // Rule ID 4943 //
     /* 328746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328757 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 328757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 328762 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328766 */   GIR_RootConstrainSelectedInstOperands,
     /* 328767 */   // GIR_Coverage, 4943,
     /* 328767 */   GIR_Done,
     /* 328768 */ // Label 6468: @328768
     /* 328768 */ GIM_Reject,
     /* 328769 */ // Label 6463: @328769
     /* 328769 */ GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(328796), // Rule ID 4945 //
     /* 328774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328785 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 328785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 328790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328794 */   GIR_RootConstrainSelectedInstOperands,
     /* 328795 */   // GIR_Coverage, 4945,
     /* 328795 */   GIR_Done,
     /* 328796 */ // Label 6469: @328796
     /* 328796 */ GIM_Reject,
     /* 328797 */ // Label 6464: @328797
     /* 328797 */ GIM_Reject,
     /* 328798 */ // Label 67: @328798
     /* 328798 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6477*/ GIMT_Encode4(329774),
     /* 328809 */ /*GILLT_s32*//*Label 6470*/ GIMT_Encode4(328845),
     /* 328813 */ /*GILLT_s64*//*Label 6471*/ GIMT_Encode4(329232), GIMT_Encode4(0),
     /* 328821 */ /*GILLT_v2s32*//*Label 6472*/ GIMT_Encode4(329619),
     /* 328825 */ /*GILLT_v2s64*//*Label 6473*/ GIMT_Encode4(329650),
     /* 328829 */ /*GILLT_v4s16*//*Label 6474*/ GIMT_Encode4(329681),
     /* 328833 */ /*GILLT_v4s32*//*Label 6475*/ GIMT_Encode4(329712), GIMT_Encode4(0),
     /* 328841 */ /*GILLT_v8s16*//*Label 6476*/ GIMT_Encode4(329743),
     /* 328845 */ // Label 6470: @328845
     /* 328845 */ GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(328882), // Rule ID 4682 //
     /* 328850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 328865 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328869 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328871 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 328871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 328874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328876 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328880 */   GIR_RootConstrainSelectedInstOperands,
     /* 328881 */   // GIR_Coverage, 4682,
     /* 328881 */   GIR_EraseRootFromParent_Done,
     /* 328882 */ // Label 6478: @328882
     /* 328882 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(328919), // Rule ID 4684 //
     /* 328887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328894 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328898 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 328902 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328906 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328908 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 328908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 328911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328913 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328917 */   GIR_RootConstrainSelectedInstOperands,
     /* 328918 */   // GIR_Coverage, 4684,
     /* 328918 */   GIR_EraseRootFromParent_Done,
     /* 328919 */ // Label 6479: @328919
     /* 328919 */ GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(328956), // Rule ID 4702 //
     /* 328924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328931 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 328939 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328945 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 328945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 328948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328950 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328954 */   GIR_RootConstrainSelectedInstOperands,
     /* 328955 */   // GIR_Coverage, 4702,
     /* 328955 */   GIR_EraseRootFromParent_Done,
     /* 328956 */ // Label 6480: @328956
     /* 328956 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(328993), // Rule ID 4704 //
     /* 328961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 328976 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328980 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328982 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 328982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 328985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328987 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328991 */   GIR_RootConstrainSelectedInstOperands,
     /* 328992 */   // GIR_Coverage, 4704,
     /* 328992 */   GIR_EraseRootFromParent_Done,
     /* 328993 */ // Label 6481: @328993
     /* 328993 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(329030), // Rule ID 4742 //
     /* 328998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329013 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329017 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329019 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 329022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329024 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329028 */   GIR_RootConstrainSelectedInstOperands,
     /* 329029 */   // GIR_Coverage, 4742,
     /* 329029 */   GIR_EraseRootFromParent_Done,
     /* 329030 */ // Label 6482: @329030
     /* 329030 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(329067), // Rule ID 4744 //
     /* 329035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329042 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329046 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329050 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329056 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 329059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329061 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329065 */   GIR_RootConstrainSelectedInstOperands,
     /* 329066 */   // GIR_Coverage, 4744,
     /* 329066 */   GIR_EraseRootFromParent_Done,
     /* 329067 */ // Label 6483: @329067
     /* 329067 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(329104), // Rule ID 4722 //
     /* 329072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 329087 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329091 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329093 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 329096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329098 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329102 */   GIR_RootConstrainSelectedInstOperands,
     /* 329103 */   // GIR_Coverage, 4722,
     /* 329103 */   GIR_EraseRootFromParent_Done,
     /* 329104 */ // Label 6484: @329104
     /* 329104 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(329141), // Rule ID 4724 //
     /* 329109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 329124 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329130 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 329133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329135 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329139 */   GIR_RootConstrainSelectedInstOperands,
     /* 329140 */   // GIR_Coverage, 4724,
     /* 329140 */   GIR_EraseRootFromParent_Done,
     /* 329141 */ // Label 6485: @329141
     /* 329141 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(329171), // Rule ID 395 //
     /* 329146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 329149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329160 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 329160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 329165 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329169 */   GIR_RootConstrainSelectedInstOperands,
     /* 329170 */   // GIR_Coverage, 395,
     /* 329170 */   GIR_Done,
     /* 329171 */ // Label 6486: @329171
     /* 329171 */ GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(329201), // Rule ID 399 //
     /* 329176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329190 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 329190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 329195 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329199 */   GIR_RootConstrainSelectedInstOperands,
     /* 329200 */   // GIR_Coverage, 399,
     /* 329200 */   GIR_Done,
     /* 329201 */ // Label 6487: @329201
     /* 329201 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(329231), // Rule ID 403 //
     /* 329206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329220 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 329220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 329225 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329229 */   GIR_RootConstrainSelectedInstOperands,
     /* 329230 */   // GIR_Coverage, 403,
     /* 329230 */   GIR_Done,
     /* 329231 */ // Label 6488: @329231
     /* 329231 */ GIM_Reject,
     /* 329232 */ // Label 6471: @329232
     /* 329232 */ GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(329269), // Rule ID 4683 //
     /* 329237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329244 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329252 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329256 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329258 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 329261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329263 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329267 */   GIR_RootConstrainSelectedInstOperands,
     /* 329268 */   // GIR_Coverage, 4683,
     /* 329268 */   GIR_EraseRootFromParent_Done,
     /* 329269 */ // Label 6489: @329269
     /* 329269 */ GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(329306), // Rule ID 4685 //
     /* 329274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329281 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329285 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329289 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329293 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329295 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 329298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329300 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329304 */   GIR_RootConstrainSelectedInstOperands,
     /* 329305 */   // GIR_Coverage, 4685,
     /* 329305 */   GIR_EraseRootFromParent_Done,
     /* 329306 */ // Label 6490: @329306
     /* 329306 */ GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(329343), // Rule ID 4703 //
     /* 329311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329318 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329322 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329326 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329332 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 329335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329337 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329341 */   GIR_RootConstrainSelectedInstOperands,
     /* 329342 */   // GIR_Coverage, 4703,
     /* 329342 */   GIR_EraseRootFromParent_Done,
     /* 329343 */ // Label 6491: @329343
     /* 329343 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(329380), // Rule ID 4705 //
     /* 329348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329355 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329363 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329367 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329369 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 329372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329374 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329378 */   GIR_RootConstrainSelectedInstOperands,
     /* 329379 */   // GIR_Coverage, 4705,
     /* 329379 */   GIR_EraseRootFromParent_Done,
     /* 329380 */ // Label 6492: @329380
     /* 329380 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(329417), // Rule ID 4743 //
     /* 329385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329392 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329400 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329404 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329406 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 329409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329411 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329415 */   GIR_RootConstrainSelectedInstOperands,
     /* 329416 */   // GIR_Coverage, 4743,
     /* 329416 */   GIR_EraseRootFromParent_Done,
     /* 329417 */ // Label 6493: @329417
     /* 329417 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(329454), // Rule ID 4745 //
     /* 329422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329429 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329433 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329437 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329441 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329443 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 329446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329448 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329452 */   GIR_RootConstrainSelectedInstOperands,
     /* 329453 */   // GIR_Coverage, 4745,
     /* 329453 */   GIR_EraseRootFromParent_Done,
     /* 329454 */ // Label 6494: @329454
     /* 329454 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(329491), // Rule ID 4723 //
     /* 329459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 329474 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329478 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329480 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 329483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329485 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329489 */   GIR_RootConstrainSelectedInstOperands,
     /* 329490 */   // GIR_Coverage, 4723,
     /* 329490 */   GIR_EraseRootFromParent_Done,
     /* 329491 */ // Label 6495: @329491
     /* 329491 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(329528), // Rule ID 4725 //
     /* 329496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329503 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 329511 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329517 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 329520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329522 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329526 */   GIR_RootConstrainSelectedInstOperands,
     /* 329527 */   // GIR_Coverage, 4725,
     /* 329527 */   GIR_EraseRootFromParent_Done,
     /* 329528 */ // Label 6496: @329528
     /* 329528 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(329558), // Rule ID 397 //
     /* 329533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 329536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329547 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 329547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 329552 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329556 */   GIR_RootConstrainSelectedInstOperands,
     /* 329557 */   // GIR_Coverage, 397,
     /* 329557 */   GIR_Done,
     /* 329558 */ // Label 6497: @329558
     /* 329558 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(329588), // Rule ID 401 //
     /* 329563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329577 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 329577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 329582 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329586 */   GIR_RootConstrainSelectedInstOperands,
     /* 329587 */   // GIR_Coverage, 401,
     /* 329587 */   GIR_Done,
     /* 329588 */ // Label 6498: @329588
     /* 329588 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(329618), // Rule ID 405 //
     /* 329593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329607 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 329607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 329612 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329616 */   GIR_RootConstrainSelectedInstOperands,
     /* 329617 */   // GIR_Coverage, 405,
     /* 329617 */   GIR_Done,
     /* 329618 */ // Label 6499: @329618
     /* 329618 */ GIM_Reject,
     /* 329619 */ // Label 6472: @329619
     /* 329619 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(329649), // Rule ID 843 //
     /* 329624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329638 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 329638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 329643 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329647 */   GIR_RootConstrainSelectedInstOperands,
     /* 329648 */   // GIR_Coverage, 843,
     /* 329648 */   GIR_Done,
     /* 329649 */ // Label 6500: @329649
     /* 329649 */ GIM_Reject,
     /* 329650 */ // Label 6473: @329650
     /* 329650 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(329680), // Rule ID 847 //
     /* 329655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329669 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 329669 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 329674 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329678 */   GIR_RootConstrainSelectedInstOperands,
     /* 329679 */   // GIR_Coverage, 847,
     /* 329679 */   GIR_Done,
     /* 329680 */ // Label 6501: @329680
     /* 329680 */ GIM_Reject,
     /* 329681 */ // Label 6474: @329681
     /* 329681 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(329711), // Rule ID 839 //
     /* 329686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 329689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329700 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 329700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 329705 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329709 */   GIR_RootConstrainSelectedInstOperands,
     /* 329710 */   // GIR_Coverage, 839,
     /* 329710 */   GIR_Done,
     /* 329711 */ // Label 6502: @329711
     /* 329711 */ GIM_Reject,
     /* 329712 */ // Label 6475: @329712
     /* 329712 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(329742), // Rule ID 845 //
     /* 329717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329731 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 329731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 329736 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329740 */   GIR_RootConstrainSelectedInstOperands,
     /* 329741 */   // GIR_Coverage, 845,
     /* 329741 */   GIR_Done,
     /* 329742 */ // Label 6503: @329742
     /* 329742 */ GIM_Reject,
     /* 329743 */ // Label 6476: @329743
     /* 329743 */ GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(329773), // Rule ID 841 //
     /* 329748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 329751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329762 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 329762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 329767 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329771 */   GIR_RootConstrainSelectedInstOperands,
     /* 329772 */   // GIR_Coverage, 841,
     /* 329772 */   GIR_Done,
     /* 329773 */ // Label 6504: @329773
     /* 329773 */ GIM_Reject,
     /* 329774 */ // Label 6477: @329774
     /* 329774 */ GIM_Reject,
     /* 329775 */ // Label 68: @329775
     /* 329775 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6512*/ GIMT_Encode4(330751),
     /* 329786 */ /*GILLT_s32*//*Label 6505*/ GIMT_Encode4(329822),
     /* 329790 */ /*GILLT_s64*//*Label 6506*/ GIMT_Encode4(330209), GIMT_Encode4(0),
     /* 329798 */ /*GILLT_v2s32*//*Label 6507*/ GIMT_Encode4(330596),
     /* 329802 */ /*GILLT_v2s64*//*Label 6508*/ GIMT_Encode4(330627),
     /* 329806 */ /*GILLT_v4s16*//*Label 6509*/ GIMT_Encode4(330658),
     /* 329810 */ /*GILLT_v4s32*//*Label 6510*/ GIMT_Encode4(330689), GIMT_Encode4(0),
     /* 329818 */ /*GILLT_v8s16*//*Label 6511*/ GIMT_Encode4(330720),
     /* 329822 */ // Label 6505: @329822
     /* 329822 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(329859), // Rule ID 4692 //
     /* 329827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329842 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329846 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329848 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 329851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329853 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329857 */   GIR_RootConstrainSelectedInstOperands,
     /* 329858 */   // GIR_Coverage, 4692,
     /* 329858 */   GIR_EraseRootFromParent_Done,
     /* 329859 */ // Label 6513: @329859
     /* 329859 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(329896), // Rule ID 4694 //
     /* 329864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329879 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329885 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 329888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329890 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329894 */   GIR_RootConstrainSelectedInstOperands,
     /* 329895 */   // GIR_Coverage, 4694,
     /* 329895 */   GIR_EraseRootFromParent_Done,
     /* 329896 */ // Label 6514: @329896
     /* 329896 */ GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(329933), // Rule ID 4712 //
     /* 329901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329916 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329922 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 329925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329927 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329931 */   GIR_RootConstrainSelectedInstOperands,
     /* 329932 */   // GIR_Coverage, 4712,
     /* 329932 */   GIR_EraseRootFromParent_Done,
     /* 329933 */ // Label 6515: @329933
     /* 329933 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(329970), // Rule ID 4714 //
     /* 329938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329957 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329959 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 329962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329964 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329968 */   GIR_RootConstrainSelectedInstOperands,
     /* 329969 */   // GIR_Coverage, 4714,
     /* 329969 */   GIR_EraseRootFromParent_Done,
     /* 329970 */ // Label 6516: @329970
     /* 329970 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(330007), // Rule ID 4752 //
     /* 329975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329982 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329986 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329990 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329994 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329996 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 329999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330001 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330005 */   GIR_RootConstrainSelectedInstOperands,
     /* 330006 */   // GIR_Coverage, 4752,
     /* 330006 */   GIR_EraseRootFromParent_Done,
     /* 330007 */ // Label 6517: @330007
     /* 330007 */ GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(330044), // Rule ID 4754 //
     /* 330012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330019 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330023 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330027 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330031 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330033 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 330036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330038 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330042 */   GIR_RootConstrainSelectedInstOperands,
     /* 330043 */   // GIR_Coverage, 4754,
     /* 330043 */   GIR_EraseRootFromParent_Done,
     /* 330044 */ // Label 6518: @330044
     /* 330044 */ GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(330081), // Rule ID 4732 //
     /* 330049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330064 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330070 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 330073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330075 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330079 */   GIR_RootConstrainSelectedInstOperands,
     /* 330080 */   // GIR_Coverage, 4732,
     /* 330080 */   GIR_EraseRootFromParent_Done,
     /* 330081 */ // Label 6519: @330081
     /* 330081 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(330118), // Rule ID 4734 //
     /* 330086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330093 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330097 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330101 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330105 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330107 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 330110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330112 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330116 */   GIR_RootConstrainSelectedInstOperands,
     /* 330117 */   // GIR_Coverage, 4734,
     /* 330117 */   GIR_EraseRootFromParent_Done,
     /* 330118 */ // Label 6520: @330118
     /* 330118 */ GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(330148), // Rule ID 407 //
     /* 330123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330137 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 330137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 330142 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330146 */   GIR_RootConstrainSelectedInstOperands,
     /* 330147 */   // GIR_Coverage, 407,
     /* 330147 */   GIR_Done,
     /* 330148 */ // Label 6521: @330148
     /* 330148 */ GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(330178), // Rule ID 411 //
     /* 330153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330167 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 330167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 330172 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330176 */   GIR_RootConstrainSelectedInstOperands,
     /* 330177 */   // GIR_Coverage, 411,
     /* 330177 */   GIR_Done,
     /* 330178 */ // Label 6522: @330178
     /* 330178 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(330208), // Rule ID 415 //
     /* 330183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330197 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 330197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 330202 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330206 */   GIR_RootConstrainSelectedInstOperands,
     /* 330207 */   // GIR_Coverage, 415,
     /* 330207 */   GIR_Done,
     /* 330208 */ // Label 6523: @330208
     /* 330208 */ GIM_Reject,
     /* 330209 */ // Label 6506: @330209
     /* 330209 */ GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(330246), // Rule ID 4693 //
     /* 330214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330221 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330229 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330235 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 330238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330240 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330244 */   GIR_RootConstrainSelectedInstOperands,
     /* 330245 */   // GIR_Coverage, 4693,
     /* 330245 */   GIR_EraseRootFromParent_Done,
     /* 330246 */ // Label 6524: @330246
     /* 330246 */ GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(330283), // Rule ID 4695 //
     /* 330251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330266 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330272 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 330275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330277 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330281 */   GIR_RootConstrainSelectedInstOperands,
     /* 330282 */   // GIR_Coverage, 4695,
     /* 330282 */   GIR_EraseRootFromParent_Done,
     /* 330283 */ // Label 6525: @330283
     /* 330283 */ GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(330320), // Rule ID 4713 //
     /* 330288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330295 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330303 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330309 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 330312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330314 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330318 */   GIR_RootConstrainSelectedInstOperands,
     /* 330319 */   // GIR_Coverage, 4713,
     /* 330319 */   GIR_EraseRootFromParent_Done,
     /* 330320 */ // Label 6526: @330320
     /* 330320 */ GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(330357), // Rule ID 4715 //
     /* 330325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330332 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330336 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330340 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330346 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 330349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330351 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330355 */   GIR_RootConstrainSelectedInstOperands,
     /* 330356 */   // GIR_Coverage, 4715,
     /* 330356 */   GIR_EraseRootFromParent_Done,
     /* 330357 */ // Label 6527: @330357
     /* 330357 */ GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(330394), // Rule ID 4753 //
     /* 330362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330369 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330373 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330377 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330381 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330383 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 330386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330388 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330392 */   GIR_RootConstrainSelectedInstOperands,
     /* 330393 */   // GIR_Coverage, 4753,
     /* 330393 */   GIR_EraseRootFromParent_Done,
     /* 330394 */ // Label 6528: @330394
     /* 330394 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(330431), // Rule ID 4755 //
     /* 330399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330406 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330410 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330414 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330418 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330420 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 330423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330425 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330429 */   GIR_RootConstrainSelectedInstOperands,
     /* 330430 */   // GIR_Coverage, 4755,
     /* 330430 */   GIR_EraseRootFromParent_Done,
     /* 330431 */ // Label 6529: @330431
     /* 330431 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(330468), // Rule ID 4733 //
     /* 330436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330443 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330447 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330451 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330455 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330457 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 330460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330462 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330466 */   GIR_RootConstrainSelectedInstOperands,
     /* 330467 */   // GIR_Coverage, 4733,
     /* 330467 */   GIR_EraseRootFromParent_Done,
     /* 330468 */ // Label 6530: @330468
     /* 330468 */ GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(330505), // Rule ID 4735 //
     /* 330473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330480 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330488 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330492 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330494 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 330497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330499 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330503 */   GIR_RootConstrainSelectedInstOperands,
     /* 330504 */   // GIR_Coverage, 4735,
     /* 330504 */   GIR_EraseRootFromParent_Done,
     /* 330505 */ // Label 6531: @330505
     /* 330505 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(330535), // Rule ID 409 //
     /* 330510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330524 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 330524 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 330529 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330533 */   GIR_RootConstrainSelectedInstOperands,
     /* 330534 */   // GIR_Coverage, 409,
     /* 330534 */   GIR_Done,
     /* 330535 */ // Label 6532: @330535
     /* 330535 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(330565), // Rule ID 413 //
     /* 330540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330554 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 330554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 330559 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330563 */   GIR_RootConstrainSelectedInstOperands,
     /* 330564 */   // GIR_Coverage, 413,
     /* 330564 */   GIR_Done,
     /* 330565 */ // Label 6533: @330565
     /* 330565 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(330595), // Rule ID 417 //
     /* 330570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330584 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 330584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 330589 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330593 */   GIR_RootConstrainSelectedInstOperands,
     /* 330594 */   // GIR_Coverage, 417,
     /* 330594 */   GIR_Done,
     /* 330595 */ // Label 6534: @330595
     /* 330595 */ GIM_Reject,
     /* 330596 */ // Label 6507: @330596
     /* 330596 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(330626), // Rule ID 853 //
     /* 330601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330615 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 330615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 330620 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330624 */   GIR_RootConstrainSelectedInstOperands,
     /* 330625 */   // GIR_Coverage, 853,
     /* 330625 */   GIR_Done,
     /* 330626 */ // Label 6535: @330626
     /* 330626 */ GIM_Reject,
     /* 330627 */ // Label 6508: @330627
     /* 330627 */ GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(330657), // Rule ID 857 //
     /* 330632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330646 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 330646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 330651 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330655 */   GIR_RootConstrainSelectedInstOperands,
     /* 330656 */   // GIR_Coverage, 857,
     /* 330656 */   GIR_Done,
     /* 330657 */ // Label 6536: @330657
     /* 330657 */ GIM_Reject,
     /* 330658 */ // Label 6509: @330658
     /* 330658 */ GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(330688), // Rule ID 849 //
     /* 330663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330677 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 330677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 330682 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330686 */   GIR_RootConstrainSelectedInstOperands,
     /* 330687 */   // GIR_Coverage, 849,
     /* 330687 */   GIR_Done,
     /* 330688 */ // Label 6537: @330688
     /* 330688 */ GIM_Reject,
     /* 330689 */ // Label 6510: @330689
     /* 330689 */ GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(330719), // Rule ID 855 //
     /* 330694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330708 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 330708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 330713 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330717 */   GIR_RootConstrainSelectedInstOperands,
     /* 330718 */   // GIR_Coverage, 855,
     /* 330718 */   GIR_Done,
     /* 330719 */ // Label 6538: @330719
     /* 330719 */ GIM_Reject,
     /* 330720 */ // Label 6511: @330720
     /* 330720 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(330750), // Rule ID 851 //
     /* 330725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330739 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 330739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 330744 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330748 */   GIR_RootConstrainSelectedInstOperands,
     /* 330749 */   // GIR_Coverage, 851,
     /* 330749 */   GIR_Done,
     /* 330750 */ // Label 6539: @330750
     /* 330750 */ GIM_Reject,
     /* 330751 */ // Label 6512: @330751
     /* 330751 */ GIM_Reject,
     /* 330752 */ // Label 69: @330752
     /* 330752 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6548*/ GIMT_Encode4(335379),
     /* 330763 */ /*GILLT_s16*//*Label 6540*/ GIMT_Encode4(330803),
     /* 330767 */ /*GILLT_s32*//*Label 6541*/ GIMT_Encode4(331244),
     /* 330771 */ /*GILLT_s64*//*Label 6542*/ GIMT_Encode4(333240), GIMT_Encode4(0),
     /* 330779 */ /*GILLT_v2s32*//*Label 6543*/ GIMT_Encode4(335224),
     /* 330783 */ /*GILLT_v2s64*//*Label 6544*/ GIMT_Encode4(335255),
     /* 330787 */ /*GILLT_v4s16*//*Label 6545*/ GIMT_Encode4(335286),
     /* 330791 */ /*GILLT_v4s32*//*Label 6546*/ GIMT_Encode4(335317), GIMT_Encode4(0),
     /* 330799 */ /*GILLT_v8s16*//*Label 6547*/ GIMT_Encode4(335348),
     /* 330803 */ // Label 6540: @330803
     /* 330803 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(330906), // Rule ID 5335 //
     /* 330808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 330811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 330826 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330830 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330834 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330838 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330842 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 330846 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330851 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 330855 */   // MIs[1] Operand 2
     /* 330855 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 330866 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330868 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 330868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330880 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 330886 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330891 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 330899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330904 */   GIR_RootConstrainSelectedInstOperands,
     /* 330905 */   // GIR_Coverage, 5335,
     /* 330905 */   GIR_EraseRootFromParent_Done,
     /* 330906 */ // Label 6549: @330906
     /* 330906 */ GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(330986), // Rule ID 2444 //
     /* 330911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 330914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330921 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330925 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330929 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330933 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330937 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330942 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 330946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330948 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 330948 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 330951 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330955 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330960 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 330966 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330971 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 330979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330984 */   GIR_RootConstrainSelectedInstOperands,
     /* 330985 */   // GIR_Coverage, 2444,
     /* 330985 */   GIR_EraseRootFromParent_Done,
     /* 330986 */ // Label 6550: @330986
     /* 330986 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(331066), // Rule ID 2448 //
     /* 330991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 330994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331001 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331005 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331009 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331013 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331017 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331022 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 331026 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331028 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 331028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 331031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331040 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331046 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331051 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 331059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331064 */   GIR_RootConstrainSelectedInstOperands,
     /* 331065 */   // GIR_Coverage, 2448,
     /* 331065 */   GIR_EraseRootFromParent_Done,
     /* 331066 */ // Label 6551: @331066
     /* 331066 */ GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(331123), // Rule ID 5326 //
     /* 331071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 331074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331081 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331085 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 331089 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331095 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 331095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 331102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331107 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 331116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331121 */   GIR_RootConstrainSelectedInstOperands,
     /* 331122 */   // GIR_Coverage, 5326,
     /* 331122 */   GIR_EraseRootFromParent_Done,
     /* 331123 */ // Label 6552: @331123
     /* 331123 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(331153), // Rule ID 443 //
     /* 331128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331142 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 331142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 331147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331151 */   GIR_RootConstrainSelectedInstOperands,
     /* 331152 */   // GIR_Coverage, 443,
     /* 331152 */   GIR_Done,
     /* 331153 */ // Label 6553: @331153
     /* 331153 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(331183), // Rule ID 449 //
     /* 331158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331172 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 331172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 331177 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331181 */   GIR_RootConstrainSelectedInstOperands,
     /* 331182 */   // GIR_Coverage, 449,
     /* 331182 */   GIR_Done,
     /* 331183 */ // Label 6554: @331183
     /* 331183 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(331213), // Rule ID 491 //
     /* 331188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331202 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 331202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 331207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331211 */   GIR_RootConstrainSelectedInstOperands,
     /* 331212 */   // GIR_Coverage, 491,
     /* 331212 */   GIR_Done,
     /* 331213 */ // Label 6555: @331213
     /* 331213 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(331243), // Rule ID 495 //
     /* 331218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331232 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 331232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 331237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331241 */   GIR_RootConstrainSelectedInstOperands,
     /* 331242 */   // GIR_Coverage, 495,
     /* 331242 */   GIR_Done,
     /* 331243 */ // Label 6556: @331243
     /* 331243 */ GIM_Reject,
     /* 331244 */ // Label 6541: @331244
     /* 331244 */ GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(331482), // Rule ID 6412 //
     /* 331249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 331252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331259 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331263 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 331267 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331270 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 331277 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 331281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331283 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 331290 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 331290 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 331293 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 331297 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 331317 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 331322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 331324 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 331327 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331331 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 331338 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 331341 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 331345 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331350 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 331353 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 331356 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 331359 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331364 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331369 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 331374 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 331377 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 331381 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331386 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 331389 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 331392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 331394 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 331397 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331401 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331406 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331413 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331418 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331423 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 331426 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 331430 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331435 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331438 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 331441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331455 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 331462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 331475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331480 */   GIR_RootConstrainSelectedInstOperands,
     /* 331481 */   // GIR_Coverage, 6412,
     /* 331481 */   GIR_EraseRootFromParent_Done,
     /* 331482 */ // Label 6557: @331482
     /* 331482 */ GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(331720), // Rule ID 6413 //
     /* 331487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 331490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331497 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 331505 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331508 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 331515 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 331519 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331521 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 331528 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 331528 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 331531 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 331535 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 331555 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 331560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 331562 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 331565 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331569 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 331576 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 331579 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 331583 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331588 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 331591 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 331594 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 331597 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331602 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331607 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 331612 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 331615 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 331619 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331624 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 331627 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 331630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 331632 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 331635 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331639 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331644 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331651 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331656 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331661 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 331664 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 331668 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331673 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331676 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 331679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331693 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 331700 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331705 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 331713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331718 */   GIR_RootConstrainSelectedInstOperands,
     /* 331719 */   // GIR_Coverage, 6413,
     /* 331719 */   GIR_EraseRootFromParent_Done,
     /* 331720 */ // Label 6558: @331720
     /* 331720 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(331909), // Rule ID 6416 //
     /* 331725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 331728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331735 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 331743 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331746 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331753 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 331757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331759 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 331766 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 331766 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 331769 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 331773 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 331793 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 331798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 331800 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 331803 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331807 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 331814 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 331817 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 331821 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331826 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 331829 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 331832 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 331835 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331840 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331845 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331850 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 331853 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 331857 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331862 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331865 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 331868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331882 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 331889 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 331902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331907 */   GIR_RootConstrainSelectedInstOperands,
     /* 331908 */   // GIR_Coverage, 6416,
     /* 331908 */   GIR_EraseRootFromParent_Done,
     /* 331909 */ // Label 6559: @331909
     /* 331909 */ GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(332098), // Rule ID 6417 //
     /* 331914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 331917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331924 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331928 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 331932 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331935 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331942 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 331946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331948 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 331955 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 331955 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 331958 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 331962 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 331982 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 331987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 331989 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 331992 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331996 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332003 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332006 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332010 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332015 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 332018 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 332021 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 332024 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332029 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332034 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332039 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332042 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332046 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332051 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332054 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332071 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332083 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332096 */   GIR_RootConstrainSelectedInstOperands,
     /* 332097 */   // GIR_Coverage, 6417,
     /* 332097 */   GIR_EraseRootFromParent_Done,
     /* 332098 */ // Label 6560: @332098
     /* 332098 */ GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(332331), // Rule ID 6414 //
     /* 332103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332121 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332124 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332131 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332135 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332137 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 332144 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332144 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 332147 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 332151 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 332166 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 332173 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 332176 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332180 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 332187 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 332190 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332194 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332199 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 332202 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 332205 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 332208 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332213 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332218 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 332223 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 332226 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 332230 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332235 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332238 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 332241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332243 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332246 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332250 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332255 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332262 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332267 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332272 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332275 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332279 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332284 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332287 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332292 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332299 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332304 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332311 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332316 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332329 */   GIR_RootConstrainSelectedInstOperands,
     /* 332330 */   // GIR_Coverage, 6414,
     /* 332330 */   GIR_EraseRootFromParent_Done,
     /* 332331 */ // Label 6561: @332331
     /* 332331 */ GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(332564), // Rule ID 6415 //
     /* 332336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332354 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332357 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332364 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332370 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 332377 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332377 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 332380 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 332384 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 332399 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 332406 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 332409 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332413 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 332420 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 332423 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332427 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332432 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 332435 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 332438 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 332441 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332446 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332451 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 332456 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 332459 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 332463 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332468 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332471 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 332474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332476 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332479 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332483 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332488 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332495 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332500 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332505 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332508 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332512 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332517 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332520 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332537 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332544 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332549 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332562 */   GIR_RootConstrainSelectedInstOperands,
     /* 332563 */   // GIR_Coverage, 6415,
     /* 332563 */   GIR_EraseRootFromParent_Done,
     /* 332564 */ // Label 6562: @332564
     /* 332564 */ GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(332748), // Rule ID 6418 //
     /* 332569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332579 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332587 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332590 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332597 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332603 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 332610 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332610 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 332613 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 332617 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 332632 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332639 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 332642 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332646 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332653 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332656 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332660 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332665 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 332668 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 332671 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 332674 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332679 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332684 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332689 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332692 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332696 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332701 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332704 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332721 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332728 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332733 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332743 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332746 */   GIR_RootConstrainSelectedInstOperands,
     /* 332747 */   // GIR_Coverage, 6418,
     /* 332747 */   GIR_EraseRootFromParent_Done,
     /* 332748 */ // Label 6563: @332748
     /* 332748 */ GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(332932), // Rule ID 6419 //
     /* 332753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332771 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332774 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332781 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332787 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 332794 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332794 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 332797 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 332801 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 332816 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332823 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 332826 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332830 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332837 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332840 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332844 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332849 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 332852 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 332855 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 332858 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332863 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332868 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332873 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332876 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332880 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332885 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332888 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332905 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332912 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332930 */   GIR_RootConstrainSelectedInstOperands,
     /* 332931 */   // GIR_Coverage, 6419,
     /* 332931 */   GIR_EraseRootFromParent_Done,
     /* 332932 */ // Label 6564: @332932
     /* 332932 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(333012), // Rule ID 2450 //
     /* 332937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332947 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332955 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 332959 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332963 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332968 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 332972 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332974 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 332974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 332977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332986 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332997 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 333005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333007 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333010 */   GIR_RootConstrainSelectedInstOperands,
     /* 333011 */   // GIR_Coverage, 2450,
     /* 333011 */   GIR_EraseRootFromParent_Done,
     /* 333012 */ // Label 6565: @333012
     /* 333012 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(333092), // Rule ID 5331 //
     /* 333017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 333020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333027 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333031 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333035 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 333039 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333043 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333048 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 333052 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333054 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 333054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333066 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 333072 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333077 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333087 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333090 */   GIR_RootConstrainSelectedInstOperands,
     /* 333091 */   // GIR_Coverage, 5331,
     /* 333091 */   GIR_EraseRootFromParent_Done,
     /* 333092 */ // Label 6566: @333092
     /* 333092 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(333149), // Rule ID 5314 //
     /* 333097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 333100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333107 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333111 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 333115 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 333119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333121 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 333121 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333124 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 333128 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333133 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333147 */   GIR_RootConstrainSelectedInstOperands,
     /* 333148 */   // GIR_Coverage, 5314,
     /* 333148 */   GIR_EraseRootFromParent_Done,
     /* 333149 */ // Label 6567: @333149
     /* 333149 */ GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(333179), // Rule ID 445 //
     /* 333154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 333157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 333168 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 333168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 333173 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333177 */   GIR_RootConstrainSelectedInstOperands,
     /* 333178 */   // GIR_Coverage, 445,
     /* 333178 */   GIR_Done,
     /* 333179 */ // Label 6568: @333179
     /* 333179 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(333209), // Rule ID 451 //
     /* 333184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 333187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333198 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 333198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 333203 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333207 */   GIR_RootConstrainSelectedInstOperands,
     /* 333208 */   // GIR_Coverage, 451,
     /* 333208 */   GIR_Done,
     /* 333209 */ // Label 6569: @333209
     /* 333209 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(333239), // Rule ID 497 //
     /* 333214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333228 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 333228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 333233 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333237 */   GIR_RootConstrainSelectedInstOperands,
     /* 333238 */   // GIR_Coverage, 497,
     /* 333238 */   GIR_Done,
     /* 333239 */ // Label 6570: @333239
     /* 333239 */ GIM_Reject,
     /* 333240 */ // Label 6542: @333240
     /* 333240 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(333426), // Rule ID 6424 //
     /* 333245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333263 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333266 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 333270 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333274 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333276 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333283 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 333283 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 333286 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333290 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333310 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333317 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333320 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333324 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333331 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333334 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333338 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333343 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333346 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333349 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 333352 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333357 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333362 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333367 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333370 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 333374 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333379 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333382 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 333390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333399 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333406 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333411 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 333419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333424 */   GIR_RootConstrainSelectedInstOperands,
     /* 333425 */   // GIR_Coverage, 6424,
     /* 333425 */   GIR_EraseRootFromParent_Done,
     /* 333426 */ // Label 6571: @333426
     /* 333426 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(333612), // Rule ID 6425 //
     /* 333431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333449 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 333456 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333460 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333462 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 333469 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 333469 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 333472 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 333476 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333496 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333503 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333506 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333510 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333517 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333520 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333524 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333529 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333532 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333535 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 333538 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333543 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333548 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333553 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333556 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 333560 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333565 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333568 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 333576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333585 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333592 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333597 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 333605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333610 */   GIR_RootConstrainSelectedInstOperands,
     /* 333611 */   // GIR_Coverage, 6425,
     /* 333611 */   GIR_EraseRootFromParent_Done,
     /* 333612 */ // Label 6572: @333612
     /* 333612 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(333850), // Rule ID 6420 //
     /* 333617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333627 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333631 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333635 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333638 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333645 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333649 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333651 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 333658 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 333658 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 333661 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 333665 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333685 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333692 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333695 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333699 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333706 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333709 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333713 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333718 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333721 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333724 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 333727 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333732 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333737 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333742 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333745 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333749 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333754 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333757 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333762 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333765 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333769 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333774 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333781 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333786 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333791 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333794 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 333798 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333803 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333806 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 333814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333823 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 333843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333848 */   GIR_RootConstrainSelectedInstOperands,
     /* 333849 */   // GIR_Coverage, 6420,
     /* 333849 */   GIR_EraseRootFromParent_Done,
     /* 333850 */ // Label 6573: @333850
     /* 333850 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(334088), // Rule ID 6421 //
     /* 333855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333873 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333876 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333883 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333889 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 333896 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 333896 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 333899 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 333903 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333923 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333930 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333933 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333937 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333944 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333947 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333951 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333956 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333959 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333962 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 333965 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333970 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333975 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333980 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333983 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333987 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333992 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333995 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334012 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334019 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334024 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334029 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334032 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334036 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334041 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334044 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334061 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334068 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334073 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334086 */   GIR_RootConstrainSelectedInstOperands,
     /* 334087 */   // GIR_Coverage, 6421,
     /* 334087 */   GIR_EraseRootFromParent_Done,
     /* 334088 */ // Label 6574: @334088
     /* 334088 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(334269), // Rule ID 6426 //
     /* 334093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334111 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334114 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 334118 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334122 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334124 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334131 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334131 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 334134 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334138 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334153 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334160 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334163 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334167 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334174 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334177 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334181 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334186 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334189 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334192 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 334195 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334200 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334205 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334210 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334213 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334217 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334222 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334225 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334242 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334249 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334254 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334267 */   GIR_RootConstrainSelectedInstOperands,
     /* 334268 */   // GIR_Coverage, 6426,
     /* 334268 */   GIR_EraseRootFromParent_Done,
     /* 334269 */ // Label 6575: @334269
     /* 334269 */ GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(334450), // Rule ID 6427 //
     /* 334274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334284 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334288 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334292 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334295 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 334299 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334303 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334305 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334312 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334312 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 334315 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334319 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334334 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334341 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334344 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334348 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334355 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334358 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334362 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334367 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334370 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334373 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 334376 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334381 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334386 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334391 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334394 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334398 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334403 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334406 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334423 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334430 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334435 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334448 */   GIR_RootConstrainSelectedInstOperands,
     /* 334449 */   // GIR_Coverage, 6427,
     /* 334449 */   GIR_EraseRootFromParent_Done,
     /* 334450 */ // Label 6576: @334450
     /* 334450 */ GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(334683), // Rule ID 6422 //
     /* 334455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334465 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334469 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334473 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334476 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334483 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334489 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 334496 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334496 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 334499 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 334503 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334518 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334525 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334528 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334532 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334539 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334542 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334546 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334551 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334554 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334557 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 334560 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334565 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334570 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334575 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334578 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334582 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334587 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334590 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334595 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334598 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334602 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334607 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334614 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334619 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334624 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334627 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334631 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334636 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334639 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334656 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334663 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334668 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334681 */   GIR_RootConstrainSelectedInstOperands,
     /* 334682 */   // GIR_Coverage, 6422,
     /* 334682 */   GIR_EraseRootFromParent_Done,
     /* 334683 */ // Label 6577: @334683
     /* 334683 */ GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(334916), // Rule ID 6423 //
     /* 334688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334698 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334706 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334709 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334716 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334720 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334722 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 334729 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334729 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 334732 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 334736 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334751 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334758 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334761 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334765 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334772 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334775 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334779 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334784 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334787 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334790 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 334793 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334798 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334803 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334808 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334811 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334815 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334820 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334823 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334828 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334831 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334835 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334840 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334847 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334852 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334857 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334860 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334864 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334869 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334872 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334889 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334896 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334901 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334914 */   GIR_RootConstrainSelectedInstOperands,
     /* 334915 */   // GIR_Coverage, 6423,
     /* 334915 */   GIR_EraseRootFromParent_Done,
     /* 334916 */ // Label 6578: @334916
     /* 334916 */ GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(334996), // Rule ID 2446 //
     /* 334921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 334924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334931 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334939 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 334943 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334947 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334952 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 334956 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334958 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 334958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334970 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 334976 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334981 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 334989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334994 */   GIR_RootConstrainSelectedInstOperands,
     /* 334995 */   // GIR_Coverage, 2446,
     /* 334995 */   GIR_EraseRootFromParent_Done,
     /* 334996 */ // Label 6579: @334996
     /* 334996 */ GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(335076), // Rule ID 5333 //
     /* 335001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335019 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335023 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335027 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335032 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335036 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335038 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 335038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335050 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 335056 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335061 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335074 */   GIR_RootConstrainSelectedInstOperands,
     /* 335075 */   // GIR_Coverage, 5333,
     /* 335075 */   GIR_EraseRootFromParent_Done,
     /* 335076 */ // Label 6580: @335076
     /* 335076 */ GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(335133), // Rule ID 5310 //
     /* 335081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 335099 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 335103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335105 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 335105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 335112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335117 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335131 */   GIR_RootConstrainSelectedInstOperands,
     /* 335132 */   // GIR_Coverage, 5310,
     /* 335132 */   GIR_EraseRootFromParent_Done,
     /* 335133 */ // Label 6581: @335133
     /* 335133 */ GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(335163), // Rule ID 447 //
     /* 335138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 335141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 335152 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 335152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 335157 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335161 */   GIR_RootConstrainSelectedInstOperands,
     /* 335162 */   // GIR_Coverage, 447,
     /* 335162 */   GIR_Done,
     /* 335163 */ // Label 6582: @335163
     /* 335163 */ GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(335193), // Rule ID 453 //
     /* 335168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 335171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 335182 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 335182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 335187 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335191 */   GIR_RootConstrainSelectedInstOperands,
     /* 335192 */   // GIR_Coverage, 453,
     /* 335192 */   GIR_Done,
     /* 335193 */ // Label 6583: @335193
     /* 335193 */ GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(335223), // Rule ID 493 //
     /* 335198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335212 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 335212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 335217 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335221 */   GIR_RootConstrainSelectedInstOperands,
     /* 335222 */   // GIR_Coverage, 493,
     /* 335222 */   GIR_Done,
     /* 335223 */ // Label 6584: @335223
     /* 335223 */ GIM_Reject,
     /* 335224 */ // Label 6543: @335224
     /* 335224 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(335254), // Rule ID 1017 //
     /* 335229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 335235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335243 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 335243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 335248 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335252 */   GIR_RootConstrainSelectedInstOperands,
     /* 335253 */   // GIR_Coverage, 1017,
     /* 335253 */   GIR_Done,
     /* 335254 */ // Label 6585: @335254
     /* 335254 */ GIM_Reject,
     /* 335255 */ // Label 6544: @335255
     /* 335255 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(335285), // Rule ID 1021 //
     /* 335260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335274 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 335274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 335279 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335283 */   GIR_RootConstrainSelectedInstOperands,
     /* 335284 */   // GIR_Coverage, 1021,
     /* 335284 */   GIR_Done,
     /* 335285 */ // Label 6586: @335285
     /* 335285 */ GIM_Reject,
     /* 335286 */ // Label 6545: @335286
     /* 335286 */ GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(335316), // Rule ID 1013 //
     /* 335291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 335294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 335297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335305 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 335305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 335310 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335314 */   GIR_RootConstrainSelectedInstOperands,
     /* 335315 */   // GIR_Coverage, 1013,
     /* 335315 */   GIR_Done,
     /* 335316 */ // Label 6587: @335316
     /* 335316 */ GIM_Reject,
     /* 335317 */ // Label 6546: @335317
     /* 335317 */ GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(335347), // Rule ID 1019 //
     /* 335322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335336 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 335336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 335341 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335345 */   GIR_RootConstrainSelectedInstOperands,
     /* 335346 */   // GIR_Coverage, 1019,
     /* 335346 */   GIR_Done,
     /* 335347 */ // Label 6588: @335347
     /* 335347 */ GIM_Reject,
     /* 335348 */ // Label 6547: @335348
     /* 335348 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(335378), // Rule ID 1015 //
     /* 335353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 335356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 335359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335367 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 335367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 335372 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335376 */   GIR_RootConstrainSelectedInstOperands,
     /* 335377 */   // GIR_Coverage, 1015,
     /* 335377 */   GIR_Done,
     /* 335378 */ // Label 6589: @335378
     /* 335378 */ GIM_Reject,
     /* 335379 */ // Label 6548: @335379
     /* 335379 */ GIM_Reject,
     /* 335380 */ // Label 70: @335380
     /* 335380 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6598*/ GIMT_Encode4(339385),
     /* 335391 */ /*GILLT_s16*//*Label 6590*/ GIMT_Encode4(335431),
     /* 335395 */ /*GILLT_s32*//*Label 6591*/ GIMT_Encode4(335876),
     /* 335399 */ /*GILLT_s64*//*Label 6592*/ GIMT_Encode4(337284), GIMT_Encode4(0),
     /* 335407 */ /*GILLT_v2s32*//*Label 6593*/ GIMT_Encode4(339230),
     /* 335411 */ /*GILLT_v2s64*//*Label 6594*/ GIMT_Encode4(339261),
     /* 335415 */ /*GILLT_v4s16*//*Label 6595*/ GIMT_Encode4(339292),
     /* 335419 */ /*GILLT_v4s32*//*Label 6596*/ GIMT_Encode4(339323), GIMT_Encode4(0),
     /* 335427 */ /*GILLT_v8s16*//*Label 6597*/ GIMT_Encode4(339354),
     /* 335431 */ // Label 6590: @335431
     /* 335431 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(335538), // Rule ID 5336 //
     /* 335436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 335439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335446 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335450 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 335454 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 335458 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 335462 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 335466 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335470 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 335474 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 335478 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335483 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 335487 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 335498 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335500 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 335500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 335503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335512 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 335518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 335531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335536 */   GIR_RootConstrainSelectedInstOperands,
     /* 335537 */   // GIR_Coverage, 5336,
     /* 335537 */   GIR_EraseRootFromParent_Done,
     /* 335538 */ // Label 6599: @335538
     /* 335538 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(335618), // Rule ID 4781 //
     /* 335543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335553 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335557 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335561 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335565 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335569 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335574 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335578 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335580 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 335580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335592 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 335598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 335611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335616 */   GIR_RootConstrainSelectedInstOperands,
     /* 335617 */   // GIR_Coverage, 4781,
     /* 335617 */   GIR_EraseRootFromParent_Done,
     /* 335618 */ // Label 6600: @335618
     /* 335618 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(335698), // Rule ID 4785 //
     /* 335623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335641 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335645 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335649 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335654 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335658 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335660 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 335660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335672 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 335678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 335691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335696 */   GIR_RootConstrainSelectedInstOperands,
     /* 335697 */   // GIR_Coverage, 4785,
     /* 335697 */   GIR_EraseRootFromParent_Done,
     /* 335698 */ // Label 6601: @335698
     /* 335698 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(335755), // Rule ID 5330 //
     /* 335703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 335706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335713 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335717 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 335721 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335727 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 335727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 335730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 335734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335739 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 335748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335750 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335753 */   GIR_RootConstrainSelectedInstOperands,
     /* 335754 */   // GIR_Coverage, 5330,
     /* 335754 */   GIR_EraseRootFromParent_Done,
     /* 335755 */ // Label 6602: @335755
     /* 335755 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(335785), // Rule ID 467 //
     /* 335760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 335763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 335774 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 335774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 335779 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335783 */   GIR_RootConstrainSelectedInstOperands,
     /* 335784 */   // GIR_Coverage, 467,
     /* 335784 */   GIR_Done,
     /* 335785 */ // Label 6603: @335785
     /* 335785 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(335815), // Rule ID 473 //
     /* 335790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 335793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 335804 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 335804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 335809 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335813 */   GIR_RootConstrainSelectedInstOperands,
     /* 335814 */   // GIR_Coverage, 473,
     /* 335814 */   GIR_Done,
     /* 335815 */ // Label 6604: @335815
     /* 335815 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(335845), // Rule ID 499 //
     /* 335820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335834 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 335834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 335839 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335843 */   GIR_RootConstrainSelectedInstOperands,
     /* 335844 */   // GIR_Coverage, 499,
     /* 335844 */   GIR_Done,
     /* 335845 */ // Label 6605: @335845
     /* 335845 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(335875), // Rule ID 503 //
     /* 335850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335864 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 335864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 335869 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335873 */   GIR_RootConstrainSelectedInstOperands,
     /* 335874 */   // GIR_Coverage, 503,
     /* 335874 */   GIR_Done,
     /* 335875 */ // Label 6606: @335875
     /* 335875 */ GIM_Reject,
     /* 335876 */ // Label 6591: @335876
     /* 335876 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(336016), // Rule ID 5337 //
     /* 335881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 335899 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335902 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 335909 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335913 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335915 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 335922 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 335922 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 335925 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 335929 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335949 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 335956 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 335959 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335963 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335982 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335985 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 335988 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 335991 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335996 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336001 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336014 */   GIR_RootConstrainSelectedInstOperands,
     /* 336015 */   // GIR_Coverage, 5337,
     /* 336015 */   GIR_EraseRootFromParent_Done,
     /* 336016 */ // Label 6607: @336016
     /* 336016 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(336156), // Rule ID 5338 //
     /* 336021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336031 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336035 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336039 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336042 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336049 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336053 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336055 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 336062 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 336062 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 336065 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 336069 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336089 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336096 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336099 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336103 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336122 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336125 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336128 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 336131 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336136 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336141 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336154 */   GIR_RootConstrainSelectedInstOperands,
     /* 336155 */   // GIR_Coverage, 5338,
     /* 336155 */   GIR_EraseRootFromParent_Done,
     /* 336156 */ // Label 6608: @336156
     /* 336156 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(336296), // Rule ID 5341 //
     /* 336161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336171 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336175 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336179 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336182 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336189 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336195 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 336202 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 336202 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 336205 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 336209 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336224 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336229 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336236 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336239 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336243 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336262 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336265 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336268 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 336271 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336276 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336281 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336294 */   GIR_RootConstrainSelectedInstOperands,
     /* 336295 */   // GIR_Coverage, 5341,
     /* 336295 */   GIR_EraseRootFromParent_Done,
     /* 336296 */ // Label 6609: @336296
     /* 336296 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(336436), // Rule ID 5342 //
     /* 336301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336319 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336322 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336329 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336335 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 336342 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 336342 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 336345 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 336349 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336369 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336376 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336379 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336383 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336402 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336405 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336408 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 336411 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336416 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336421 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336431 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336434 */   GIR_RootConstrainSelectedInstOperands,
     /* 336435 */   // GIR_Coverage, 5342,
     /* 336435 */   GIR_EraseRootFromParent_Done,
     /* 336436 */ // Label 6610: @336436
     /* 336436 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(336571), // Rule ID 5339 //
     /* 336441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336451 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336455 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336459 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336462 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336469 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336473 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336475 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 336482 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 336482 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 336485 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 336489 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336504 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336511 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336514 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336518 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336537 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336540 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336543 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 336546 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336569 */   GIR_RootConstrainSelectedInstOperands,
     /* 336570 */   // GIR_Coverage, 5339,
     /* 336570 */   GIR_EraseRootFromParent_Done,
     /* 336571 */ // Label 6611: @336571
     /* 336571 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(336706), // Rule ID 5340 //
     /* 336576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336586 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336590 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336594 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336597 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336604 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336608 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336610 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 336617 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 336617 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 336620 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 336624 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336639 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336646 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336649 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336653 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336672 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336675 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336678 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 336681 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336686 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336691 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336704 */   GIR_RootConstrainSelectedInstOperands,
     /* 336705 */   // GIR_Coverage, 5340,
     /* 336705 */   GIR_EraseRootFromParent_Done,
     /* 336706 */ // Label 6612: @336706
     /* 336706 */ GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(336841), // Rule ID 5343 //
     /* 336711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336721 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336729 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336732 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336739 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336743 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336745 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 336752 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 336752 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 336755 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 336759 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336774 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336781 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336784 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336788 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336807 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336810 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336813 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 336816 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336821 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336826 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336839 */   GIR_RootConstrainSelectedInstOperands,
     /* 336840 */   // GIR_Coverage, 5343,
     /* 336840 */   GIR_EraseRootFromParent_Done,
     /* 336841 */ // Label 6613: @336841
     /* 336841 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(336976), // Rule ID 5344 //
     /* 336846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336864 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336867 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336874 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336878 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336880 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 336887 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 336887 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 336890 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 336894 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336909 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336916 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336919 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336923 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336942 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336945 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336948 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 336951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336956 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336961 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336974 */   GIR_RootConstrainSelectedInstOperands,
     /* 336975 */   // GIR_Coverage, 5344,
     /* 336975 */   GIR_EraseRootFromParent_Done,
     /* 336976 */ // Label 6614: @336976
     /* 336976 */ GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(337056), // Rule ID 4787 //
     /* 336981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336991 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336999 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337003 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337007 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337012 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337016 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337018 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 337018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337030 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 337036 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337041 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 337049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337054 */   GIR_RootConstrainSelectedInstOperands,
     /* 337055 */   // GIR_Coverage, 4787,
     /* 337055 */   GIR_EraseRootFromParent_Done,
     /* 337056 */ // Label 6615: @337056
     /* 337056 */ GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(337136), // Rule ID 5332 //
     /* 337061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337079 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337083 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337087 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337092 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337098 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 337098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337110 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 337116 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337134 */   GIR_RootConstrainSelectedInstOperands,
     /* 337135 */   // GIR_Coverage, 5332,
     /* 337135 */   GIR_EraseRootFromParent_Done,
     /* 337136 */ // Label 6616: @337136
     /* 337136 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(337193), // Rule ID 5322 //
     /* 337141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 337159 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 337163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337165 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 337165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 337172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337177 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337191 */   GIR_RootConstrainSelectedInstOperands,
     /* 337192 */   // GIR_Coverage, 5322,
     /* 337192 */   GIR_EraseRootFromParent_Done,
     /* 337193 */ // Label 6617: @337193
     /* 337193 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(337223), // Rule ID 469 //
     /* 337198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 337201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337212 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 337212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 337217 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337221 */   GIR_RootConstrainSelectedInstOperands,
     /* 337222 */   // GIR_Coverage, 469,
     /* 337222 */   GIR_Done,
     /* 337223 */ // Label 6618: @337223
     /* 337223 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(337253), // Rule ID 475 //
     /* 337228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 337231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337242 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 337242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 337247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337251 */   GIR_RootConstrainSelectedInstOperands,
     /* 337252 */   // GIR_Coverage, 475,
     /* 337252 */   GIR_Done,
     /* 337253 */ // Label 6619: @337253
     /* 337253 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(337283), // Rule ID 505 //
     /* 337258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337272 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 337272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 337277 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337281 */   GIR_RootConstrainSelectedInstOperands,
     /* 337282 */   // GIR_Coverage, 505,
     /* 337282 */   GIR_Done,
     /* 337283 */ // Label 6620: @337283
     /* 337283 */ GIM_Reject,
     /* 337284 */ // Label 6592: @337284
     /* 337284 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(337421), // Rule ID 5353 //
     /* 337289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337299 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337307 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337310 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337314 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337320 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 337327 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 337327 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 337330 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 337334 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337354 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337361 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 337364 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337368 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337387 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337390 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337393 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 337396 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337401 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337406 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 337414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337419 */   GIR_RootConstrainSelectedInstOperands,
     /* 337420 */   // GIR_Coverage, 5353,
     /* 337420 */   GIR_EraseRootFromParent_Done,
     /* 337421 */ // Label 6621: @337421
     /* 337421 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(337558), // Rule ID 5354 //
     /* 337426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337444 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337447 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337451 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337455 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337457 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 337464 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 337464 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 337467 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 337471 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337491 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337498 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 337501 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337505 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 337533 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337538 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337543 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 337551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337556 */   GIR_RootConstrainSelectedInstOperands,
     /* 337557 */   // GIR_Coverage, 5354,
     /* 337557 */   GIR_EraseRootFromParent_Done,
     /* 337558 */ // Label 6622: @337558
     /* 337558 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(337698), // Rule ID 5345 //
     /* 337563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337581 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337584 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337591 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337595 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337597 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 337604 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 337604 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337607 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 337611 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337631 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337638 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 337641 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337645 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337652 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337655 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337659 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337664 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337667 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337670 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337673 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 337691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337696 */   GIR_RootConstrainSelectedInstOperands,
     /* 337697 */   // GIR_Coverage, 5345,
     /* 337697 */   GIR_EraseRootFromParent_Done,
     /* 337698 */ // Label 6623: @337698
     /* 337698 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(337838), // Rule ID 5346 //
     /* 337703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337713 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337717 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337721 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337724 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337731 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337735 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337737 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 337744 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 337744 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337747 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 337751 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337771 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337778 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 337781 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337785 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337792 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337795 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337799 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337804 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337807 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337810 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337813 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337818 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337823 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 337831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337836 */   GIR_RootConstrainSelectedInstOperands,
     /* 337837 */   // GIR_Coverage, 5346,
     /* 337837 */   GIR_EraseRootFromParent_Done,
     /* 337838 */ // Label 6624: @337838
     /* 337838 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(337978), // Rule ID 5349 //
     /* 337843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337853 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337861 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337864 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337871 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337875 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337877 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 337884 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 337884 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337887 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 337891 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337911 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337918 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 337921 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337925 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337944 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337947 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337950 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337953 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337958 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337963 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 337971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337976 */   GIR_RootConstrainSelectedInstOperands,
     /* 337977 */   // GIR_Coverage, 5349,
     /* 337977 */   GIR_EraseRootFromParent_Done,
     /* 337978 */ // Label 6625: @337978
     /* 337978 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(338118), // Rule ID 5350 //
     /* 337983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337993 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337997 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338001 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338004 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338011 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338015 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338017 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338024 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338024 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338027 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338031 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338051 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338056 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338058 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338061 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338065 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338084 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338087 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338090 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338093 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338103 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338116 */   GIR_RootConstrainSelectedInstOperands,
     /* 338117 */   // GIR_Coverage, 5350,
     /* 338117 */   GIR_EraseRootFromParent_Done,
     /* 338118 */ // Label 6626: @338118
     /* 338118 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(338250), // Rule ID 5355 //
     /* 338123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338133 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338137 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338141 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338144 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338148 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338152 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338154 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338161 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 338161 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338164 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338168 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338183 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338190 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338193 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338197 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338216 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338219 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338222 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338225 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338230 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338235 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338248 */   GIR_RootConstrainSelectedInstOperands,
     /* 338249 */   // GIR_Coverage, 5355,
     /* 338249 */   GIR_EraseRootFromParent_Done,
     /* 338250 */ // Label 6627: @338250
     /* 338250 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(338382), // Rule ID 5356 //
     /* 338255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338265 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338269 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338273 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338276 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338280 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338284 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338286 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 338293 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 338293 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338296 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 338300 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338315 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338322 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338325 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338329 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338348 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338351 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338354 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338367 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338380 */   GIR_RootConstrainSelectedInstOperands,
     /* 338381 */   // GIR_Coverage, 5356,
     /* 338381 */   GIR_EraseRootFromParent_Done,
     /* 338382 */ // Label 6628: @338382
     /* 338382 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(338517), // Rule ID 5347 //
     /* 338387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338405 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338408 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338415 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338419 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338421 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 338428 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 338428 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338431 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 338435 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338450 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338457 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338460 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338464 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338483 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338486 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338489 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338492 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338502 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338515 */   GIR_RootConstrainSelectedInstOperands,
     /* 338516 */   // GIR_Coverage, 5347,
     /* 338516 */   GIR_EraseRootFromParent_Done,
     /* 338517 */ // Label 6629: @338517
     /* 338517 */ GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(338652), // Rule ID 5348 //
     /* 338522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338532 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338536 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338540 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338543 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338550 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338554 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338556 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 338563 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 338563 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338566 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 338570 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338585 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338592 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338595 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338599 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338618 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338621 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338624 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338627 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338632 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338637 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338650 */   GIR_RootConstrainSelectedInstOperands,
     /* 338651 */   // GIR_Coverage, 5348,
     /* 338651 */   GIR_EraseRootFromParent_Done,
     /* 338652 */ // Label 6630: @338652
     /* 338652 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(338787), // Rule ID 5351 //
     /* 338657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338675 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338678 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338685 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338689 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338691 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 338698 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 338698 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338701 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 338705 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338720 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338727 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338730 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338734 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338753 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338756 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338759 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338762 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338782 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338785 */   GIR_RootConstrainSelectedInstOperands,
     /* 338786 */   // GIR_Coverage, 5351,
     /* 338786 */   GIR_EraseRootFromParent_Done,
     /* 338787 */ // Label 6631: @338787
     /* 338787 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(338922), // Rule ID 5352 //
     /* 338792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338802 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338806 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338810 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338813 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338820 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338826 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 338833 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 338833 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338836 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 338840 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338855 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338888 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338891 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338894 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338902 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338907 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338920 */   GIR_RootConstrainSelectedInstOperands,
     /* 338921 */   // GIR_Coverage, 5352,
     /* 338921 */   GIR_EraseRootFromParent_Done,
     /* 338922 */ // Label 6632: @338922
     /* 338922 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(339002), // Rule ID 4783 //
     /* 338927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338945 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 338949 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338953 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338958 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 338962 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338964 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 338964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338976 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 338982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 338995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339000 */   GIR_RootConstrainSelectedInstOperands,
     /* 339001 */   // GIR_Coverage, 4783,
     /* 339001 */   GIR_EraseRootFromParent_Done,
     /* 339002 */ // Label 6633: @339002
     /* 339002 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(339082), // Rule ID 5334 //
     /* 339007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339029 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339033 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339038 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 339042 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339044 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 339044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339056 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 339062 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339067 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339080 */   GIR_RootConstrainSelectedInstOperands,
     /* 339081 */   // GIR_Coverage, 5334,
     /* 339081 */   GIR_EraseRootFromParent_Done,
     /* 339082 */ // Label 6634: @339082
     /* 339082 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(339139), // Rule ID 5318 //
     /* 339087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339097 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339101 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 339105 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339109 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339111 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 339111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 339118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339123 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339137 */   GIR_RootConstrainSelectedInstOperands,
     /* 339138 */   // GIR_Coverage, 5318,
     /* 339138 */   GIR_EraseRootFromParent_Done,
     /* 339139 */ // Label 6635: @339139
     /* 339139 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(339169), // Rule ID 471 //
     /* 339144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 339147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339158 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 339158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 339163 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339167 */   GIR_RootConstrainSelectedInstOperands,
     /* 339168 */   // GIR_Coverage, 471,
     /* 339168 */   GIR_Done,
     /* 339169 */ // Label 6636: @339169
     /* 339169 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(339199), // Rule ID 477 //
     /* 339174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 339177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339188 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 339188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 339193 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339197 */   GIR_RootConstrainSelectedInstOperands,
     /* 339198 */   // GIR_Coverage, 477,
     /* 339198 */   GIR_Done,
     /* 339199 */ // Label 6637: @339199
     /* 339199 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(339229), // Rule ID 501 //
     /* 339204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 339207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339218 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 339218 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 339223 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339227 */   GIR_RootConstrainSelectedInstOperands,
     /* 339228 */   // GIR_Coverage, 501,
     /* 339228 */   GIR_Done,
     /* 339229 */ // Label 6638: @339229
     /* 339229 */ GIM_Reject,
     /* 339230 */ // Label 6593: @339230
     /* 339230 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(339260), // Rule ID 1078 //
     /* 339235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339249 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 339249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 339254 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339258 */   GIR_RootConstrainSelectedInstOperands,
     /* 339259 */   // GIR_Coverage, 1078,
     /* 339259 */   GIR_Done,
     /* 339260 */ // Label 6639: @339260
     /* 339260 */ GIM_Reject,
     /* 339261 */ // Label 6594: @339261
     /* 339261 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(339291), // Rule ID 1082 //
     /* 339266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339280 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 339280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 339285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339289 */   GIR_RootConstrainSelectedInstOperands,
     /* 339290 */   // GIR_Coverage, 1082,
     /* 339290 */   GIR_Done,
     /* 339291 */ // Label 6640: @339291
     /* 339291 */ GIM_Reject,
     /* 339292 */ // Label 6595: @339292
     /* 339292 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(339322), // Rule ID 1074 //
     /* 339297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 339300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 339303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339311 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 339311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 339316 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339320 */   GIR_RootConstrainSelectedInstOperands,
     /* 339321 */   // GIR_Coverage, 1074,
     /* 339321 */   GIR_Done,
     /* 339322 */ // Label 6641: @339322
     /* 339322 */ GIM_Reject,
     /* 339323 */ // Label 6596: @339323
     /* 339323 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(339353), // Rule ID 1080 //
     /* 339328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339342 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 339342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 339347 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339351 */   GIR_RootConstrainSelectedInstOperands,
     /* 339352 */   // GIR_Coverage, 1080,
     /* 339352 */   GIR_Done,
     /* 339353 */ // Label 6642: @339353
     /* 339353 */ GIM_Reject,
     /* 339354 */ // Label 6597: @339354
     /* 339354 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(339384), // Rule ID 1076 //
     /* 339359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 339362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339373 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 339373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 339378 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339382 */   GIR_RootConstrainSelectedInstOperands,
     /* 339383 */   // GIR_Coverage, 1076,
     /* 339383 */   GIR_Done,
     /* 339384 */ // Label 6643: @339384
     /* 339384 */ GIM_Reject,
     /* 339385 */ // Label 6598: @339385
     /* 339385 */ GIM_Reject,
     /* 339386 */ // Label 71: @339386
     /* 339386 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6651*/ GIMT_Encode4(339705),
     /* 339397 */ /*GILLT_s32*//*Label 6644*/ GIMT_Encode4(339433),
     /* 339401 */ /*GILLT_s64*//*Label 6645*/ GIMT_Encode4(339506), GIMT_Encode4(0),
     /* 339409 */ /*GILLT_v2s32*//*Label 6646*/ GIMT_Encode4(339579),
     /* 339413 */ /*GILLT_v2s64*//*Label 6647*/ GIMT_Encode4(339603),
     /* 339417 */ /*GILLT_v4s16*//*Label 6648*/ GIMT_Encode4(339627),
     /* 339421 */ /*GILLT_v4s32*//*Label 6649*/ GIMT_Encode4(339654), GIMT_Encode4(0),
     /* 339429 */ /*GILLT_v8s16*//*Label 6650*/ GIMT_Encode4(339678),
     /* 339433 */ // Label 6644: @339433
     /* 339433 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(339459), // Rule ID 4616 //
     /* 339438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 339444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339448 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 339448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 339453 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339457 */   GIR_RootConstrainSelectedInstOperands,
     /* 339458 */   // GIR_Coverage, 4616,
     /* 339458 */   GIR_Done,
     /* 339459 */ // Label 6652: @339459
     /* 339459 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(339482), // Rule ID 4618 //
     /* 339464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339471 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 339471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 339476 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339480 */   GIR_RootConstrainSelectedInstOperands,
     /* 339481 */   // GIR_Coverage, 4618,
     /* 339481 */   GIR_Done,
     /* 339482 */ // Label 6653: @339482
     /* 339482 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(339505), // Rule ID 4620 //
     /* 339487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339494 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 339494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 339499 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339503 */   GIR_RootConstrainSelectedInstOperands,
     /* 339504 */   // GIR_Coverage, 4620,
     /* 339504 */   GIR_Done,
     /* 339505 */ // Label 6654: @339505
     /* 339505 */ GIM_Reject,
     /* 339506 */ // Label 6645: @339506
     /* 339506 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(339532), // Rule ID 4617 //
     /* 339511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 339517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339521 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 339521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 339526 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339530 */   GIR_RootConstrainSelectedInstOperands,
     /* 339531 */   // GIR_Coverage, 4617,
     /* 339531 */   GIR_Done,
     /* 339532 */ // Label 6655: @339532
     /* 339532 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(339555), // Rule ID 4619 //
     /* 339537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339544 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 339544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 339549 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339553 */   GIR_RootConstrainSelectedInstOperands,
     /* 339554 */   // GIR_Coverage, 4619,
     /* 339554 */   GIR_Done,
     /* 339555 */ // Label 6656: @339555
     /* 339555 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(339578), // Rule ID 4621 //
     /* 339560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339567 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 339567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 339572 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339576 */   GIR_RootConstrainSelectedInstOperands,
     /* 339577 */   // GIR_Coverage, 4621,
     /* 339577 */   GIR_Done,
     /* 339578 */ // Label 6657: @339578
     /* 339578 */ GIM_Reject,
     /* 339579 */ // Label 6646: @339579
     /* 339579 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(339602), // Rule ID 4957 //
     /* 339584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339591 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 339591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 339596 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339600 */   GIR_RootConstrainSelectedInstOperands,
     /* 339601 */   // GIR_Coverage, 4957,
     /* 339601 */   GIR_Done,
     /* 339602 */ // Label 6658: @339602
     /* 339602 */ GIM_Reject,
     /* 339603 */ // Label 6647: @339603
     /* 339603 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(339626), // Rule ID 4959 //
     /* 339608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339615 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 339615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 339620 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339624 */   GIR_RootConstrainSelectedInstOperands,
     /* 339625 */   // GIR_Coverage, 4959,
     /* 339625 */   GIR_Done,
     /* 339626 */ // Label 6659: @339626
     /* 339626 */ GIM_Reject,
     /* 339627 */ // Label 6648: @339627
     /* 339627 */ GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(339653), // Rule ID 4952 //
     /* 339632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 339638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339642 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 339642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 339647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339651 */   GIR_RootConstrainSelectedInstOperands,
     /* 339652 */   // GIR_Coverage, 4952,
     /* 339652 */   GIR_Done,
     /* 339653 */ // Label 6660: @339653
     /* 339653 */ GIM_Reject,
     /* 339654 */ // Label 6649: @339654
     /* 339654 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(339677), // Rule ID 4958 //
     /* 339659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339666 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 339666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 339671 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339675 */   GIR_RootConstrainSelectedInstOperands,
     /* 339676 */   // GIR_Coverage, 4958,
     /* 339676 */   GIR_Done,
     /* 339677 */ // Label 6661: @339677
     /* 339677 */ GIM_Reject,
     /* 339678 */ // Label 6650: @339678
     /* 339678 */ GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(339704), // Rule ID 4953 //
     /* 339683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339693 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 339693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 339698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339702 */   GIR_RootConstrainSelectedInstOperands,
     /* 339703 */   // GIR_Coverage, 4953,
     /* 339703 */   GIR_Done,
     /* 339704 */ // Label 6662: @339704
     /* 339704 */ GIM_Reject,
     /* 339705 */ // Label 6651: @339705
     /* 339705 */ GIM_Reject,
     /* 339706 */ // Label 72: @339706
     /* 339706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6670*/ GIMT_Encode4(340025),
     /* 339717 */ /*GILLT_s32*//*Label 6663*/ GIMT_Encode4(339753),
     /* 339721 */ /*GILLT_s64*//*Label 6664*/ GIMT_Encode4(339826), GIMT_Encode4(0),
     /* 339729 */ /*GILLT_v2s32*//*Label 6665*/ GIMT_Encode4(339899),
     /* 339733 */ /*GILLT_v2s64*//*Label 6666*/ GIMT_Encode4(339923),
     /* 339737 */ /*GILLT_v4s16*//*Label 6667*/ GIMT_Encode4(339947),
     /* 339741 */ /*GILLT_v4s32*//*Label 6668*/ GIMT_Encode4(339974), GIMT_Encode4(0),
     /* 339749 */ /*GILLT_v8s16*//*Label 6669*/ GIMT_Encode4(339998),
     /* 339753 */ // Label 6663: @339753
     /* 339753 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(339779), // Rule ID 4640 //
     /* 339758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 339764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339768 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 339768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 339773 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339777 */   GIR_RootConstrainSelectedInstOperands,
     /* 339778 */   // GIR_Coverage, 4640,
     /* 339778 */   GIR_Done,
     /* 339779 */ // Label 6671: @339779
     /* 339779 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(339802), // Rule ID 4642 //
     /* 339784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339791 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 339791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 339796 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339800 */   GIR_RootConstrainSelectedInstOperands,
     /* 339801 */   // GIR_Coverage, 4642,
     /* 339801 */   GIR_Done,
     /* 339802 */ // Label 6672: @339802
     /* 339802 */ GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(339825), // Rule ID 4644 //
     /* 339807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339814 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 339814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 339819 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339823 */   GIR_RootConstrainSelectedInstOperands,
     /* 339824 */   // GIR_Coverage, 4644,
     /* 339824 */   GIR_Done,
     /* 339825 */ // Label 6673: @339825
     /* 339825 */ GIM_Reject,
     /* 339826 */ // Label 6664: @339826
     /* 339826 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(339852), // Rule ID 4641 //
     /* 339831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 339837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339841 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 339841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 339846 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339850 */   GIR_RootConstrainSelectedInstOperands,
     /* 339851 */   // GIR_Coverage, 4641,
     /* 339851 */   GIR_Done,
     /* 339852 */ // Label 6674: @339852
     /* 339852 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(339875), // Rule ID 4643 //
     /* 339857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339864 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 339864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 339869 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339873 */   GIR_RootConstrainSelectedInstOperands,
     /* 339874 */   // GIR_Coverage, 4643,
     /* 339874 */   GIR_Done,
     /* 339875 */ // Label 6675: @339875
     /* 339875 */ GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(339898), // Rule ID 4645 //
     /* 339880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339887 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 339887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 339892 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339896 */   GIR_RootConstrainSelectedInstOperands,
     /* 339897 */   // GIR_Coverage, 4645,
     /* 339897 */   GIR_Done,
     /* 339898 */ // Label 6676: @339898
     /* 339898 */ GIM_Reject,
     /* 339899 */ // Label 6665: @339899
     /* 339899 */ GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(339922), // Rule ID 4967 //
     /* 339904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339911 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 339911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 339916 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339920 */   GIR_RootConstrainSelectedInstOperands,
     /* 339921 */   // GIR_Coverage, 4967,
     /* 339921 */   GIR_Done,
     /* 339922 */ // Label 6677: @339922
     /* 339922 */ GIM_Reject,
     /* 339923 */ // Label 6666: @339923
     /* 339923 */ GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(339946), // Rule ID 4969 //
     /* 339928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339935 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 339935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 339940 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339944 */   GIR_RootConstrainSelectedInstOperands,
     /* 339945 */   // GIR_Coverage, 4969,
     /* 339945 */   GIR_Done,
     /* 339946 */ // Label 6678: @339946
     /* 339946 */ GIM_Reject,
     /* 339947 */ // Label 6667: @339947
     /* 339947 */ GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(339973), // Rule ID 4962 //
     /* 339952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 339958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339962 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 339962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 339967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339971 */   GIR_RootConstrainSelectedInstOperands,
     /* 339972 */   // GIR_Coverage, 4962,
     /* 339972 */   GIR_Done,
     /* 339973 */ // Label 6679: @339973
     /* 339973 */ GIM_Reject,
     /* 339974 */ // Label 6668: @339974
     /* 339974 */ GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(339997), // Rule ID 4968 //
     /* 339979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339986 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 339986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 339991 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339995 */   GIR_RootConstrainSelectedInstOperands,
     /* 339996 */   // GIR_Coverage, 4968,
     /* 339996 */   GIR_Done,
     /* 339997 */ // Label 6680: @339997
     /* 339997 */ GIM_Reject,
     /* 339998 */ // Label 6669: @339998
     /* 339998 */ GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(340024), // Rule ID 4963 //
     /* 340003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340013 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 340013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 340018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340022 */   GIR_RootConstrainSelectedInstOperands,
     /* 340023 */   // GIR_Coverage, 4963,
     /* 340023 */   GIR_Done,
     /* 340024 */ // Label 6681: @340024
     /* 340024 */ GIM_Reject,
     /* 340025 */ // Label 6670: @340025
     /* 340025 */ GIM_Reject,
     /* 340026 */ // Label 73: @340026
     /* 340026 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6690*/ GIMT_Encode4(340882),
     /* 340037 */ /*GILLT_s16*//*Label 6682*/ GIMT_Encode4(340077),
     /* 340041 */ /*GILLT_s32*//*Label 6683*/ GIMT_Encode4(340296),
     /* 340045 */ /*GILLT_s64*//*Label 6684*/ GIMT_Encode4(340370), GIMT_Encode4(0),
     /* 340053 */ /*GILLT_v2s32*//*Label 6685*/ GIMT_Encode4(340444),
     /* 340057 */ /*GILLT_v2s64*//*Label 6686*/ GIMT_Encode4(340518),
     /* 340061 */ /*GILLT_v4s16*//*Label 6687*/ GIMT_Encode4(340592),
     /* 340065 */ /*GILLT_v4s32*//*Label 6688*/ GIMT_Encode4(340700), GIMT_Encode4(0),
     /* 340073 */ /*GILLT_v8s16*//*Label 6689*/ GIMT_Encode4(340774),
     /* 340077 */ // Label 6682: @340077
     /* 340077 */ GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(340295),
     /* 340082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340089 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(340130), // Rule ID 5220 //
     /* 340094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340115 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 340115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 340118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340128 */     GIR_RootConstrainSelectedInstOperands,
     /* 340129 */     // GIR_Coverage, 5220,
     /* 340129 */     GIR_EraseRootFromParent_Done,
     /* 340130 */   // Label 6692: @340130
     /* 340130 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(340149), // Rule ID 521 //
     /* 340135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340142 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 340142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 340147 */     GIR_RootConstrainSelectedInstOperands,
     /* 340148 */     // GIR_Coverage, 521,
     /* 340148 */     GIR_Done,
     /* 340149 */   // Label 6693: @340149
     /* 340149 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(340294), // Rule ID 6406 //
     /* 340154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340158 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 340158 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 340161 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340165 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 340172 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 340175 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340179 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340184 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 340187 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340191 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 340194 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340199 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340204 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340209 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 340212 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340216 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340221 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 340224 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340229 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 340232 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 340236 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340241 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340244 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 340249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340263 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340276 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 340283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340293 */     // GIR_Coverage, 6406,
     /* 340293 */     GIR_EraseRootFromParent_Done,
     /* 340294 */   // Label 6694: @340294
     /* 340294 */   GIM_Reject,
     /* 340295 */ // Label 6691: @340295
     /* 340295 */ GIM_Reject,
     /* 340296 */ // Label 6683: @340296
     /* 340296 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(340369),
     /* 340301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340308 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(340349), // Rule ID 5221 //
     /* 340313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 340328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 340332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340334 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 340334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 340337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340347 */     GIR_RootConstrainSelectedInstOperands,
     /* 340348 */     // GIR_Coverage, 5221,
     /* 340348 */     GIR_EraseRootFromParent_Done,
     /* 340349 */   // Label 6696: @340349
     /* 340349 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(340368), // Rule ID 522 //
     /* 340354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 340357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340361 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 340361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 340366 */     GIR_RootConstrainSelectedInstOperands,
     /* 340367 */     // GIR_Coverage, 522,
     /* 340367 */     GIR_Done,
     /* 340368 */   // Label 6697: @340368
     /* 340368 */   GIM_Reject,
     /* 340369 */ // Label 6695: @340369
     /* 340369 */ GIM_Reject,
     /* 340370 */ // Label 6684: @340370
     /* 340370 */ GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(340443),
     /* 340375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340382 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(340423), // Rule ID 5222 //
     /* 340387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340408 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 340408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 340411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340421 */     GIR_RootConstrainSelectedInstOperands,
     /* 340422 */     // GIR_Coverage, 5222,
     /* 340422 */     GIR_EraseRootFromParent_Done,
     /* 340423 */   // Label 6699: @340423
     /* 340423 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(340442), // Rule ID 523 //
     /* 340428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 340431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340435 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 340435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 340440 */     GIR_RootConstrainSelectedInstOperands,
     /* 340441 */     // GIR_Coverage, 523,
     /* 340441 */     GIR_Done,
     /* 340442 */   // Label 6700: @340442
     /* 340442 */   GIM_Reject,
     /* 340443 */ // Label 6698: @340443
     /* 340443 */ GIM_Reject,
     /* 340444 */ // Label 6685: @340444
     /* 340444 */ GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(340517),
     /* 340449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340456 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(340497), // Rule ID 5034 //
     /* 340461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 340480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340482 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 340482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 340485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340495 */     GIR_RootConstrainSelectedInstOperands,
     /* 340496 */     // GIR_Coverage, 5034,
     /* 340496 */     GIR_EraseRootFromParent_Done,
     /* 340497 */   // Label 6702: @340497
     /* 340497 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(340516), // Rule ID 768 //
     /* 340502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340509 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 340509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 340514 */     GIR_RootConstrainSelectedInstOperands,
     /* 340515 */     // GIR_Coverage, 768,
     /* 340515 */     GIR_Done,
     /* 340516 */   // Label 6703: @340516
     /* 340516 */   GIM_Reject,
     /* 340517 */ // Label 6701: @340517
     /* 340517 */ GIM_Reject,
     /* 340518 */ // Label 6686: @340518
     /* 340518 */ GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(340591),
     /* 340523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340530 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(340571), // Rule ID 5036 //
     /* 340535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 340554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340556 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 340556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 340559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340569 */     GIR_RootConstrainSelectedInstOperands,
     /* 340570 */     // GIR_Coverage, 5036,
     /* 340570 */     GIR_EraseRootFromParent_Done,
     /* 340571 */   // Label 6705: @340571
     /* 340571 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(340590), // Rule ID 770 //
     /* 340576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340583 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 340583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 340588 */     GIR_RootConstrainSelectedInstOperands,
     /* 340589 */     // GIR_Coverage, 770,
     /* 340589 */     GIR_Done,
     /* 340590 */   // Label 6706: @340590
     /* 340590 */   GIM_Reject,
     /* 340591 */ // Label 6704: @340591
     /* 340591 */ GIM_Reject,
     /* 340592 */ // Label 6687: @340592
     /* 340592 */ GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(340699),
     /* 340597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340604 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(340645), // Rule ID 5037 //
     /* 340609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 340628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340630 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 340630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 340633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340643 */     GIR_RootConstrainSelectedInstOperands,
     /* 340644 */     // GIR_Coverage, 5037,
     /* 340644 */     GIR_EraseRootFromParent_Done,
     /* 340645 */   // Label 6708: @340645
     /* 340645 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(340664), // Rule ID 766 //
     /* 340650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340657 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 340657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 340662 */     GIR_RootConstrainSelectedInstOperands,
     /* 340663 */     // GIR_Coverage, 766,
     /* 340663 */     GIR_Done,
     /* 340664 */   // Label 6709: @340664
     /* 340664 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(340698), // Rule ID 6408 //
     /* 340669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340676 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 340676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 340679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340683 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 340693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 340696 */     GIR_RootConstrainSelectedInstOperands,
     /* 340697 */     // GIR_Coverage, 6408,
     /* 340697 */     GIR_EraseRootFromParent_Done,
     /* 340698 */   // Label 6710: @340698
     /* 340698 */   GIM_Reject,
     /* 340699 */ // Label 6707: @340699
     /* 340699 */ GIM_Reject,
     /* 340700 */ // Label 6688: @340700
     /* 340700 */ GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(340773),
     /* 340705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340712 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(340753), // Rule ID 5035 //
     /* 340717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 340736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340738 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 340738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 340741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340751 */     GIR_RootConstrainSelectedInstOperands,
     /* 340752 */     // GIR_Coverage, 5035,
     /* 340752 */     GIR_EraseRootFromParent_Done,
     /* 340753 */   // Label 6712: @340753
     /* 340753 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(340772), // Rule ID 769 //
     /* 340758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340765 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 340765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 340770 */     GIR_RootConstrainSelectedInstOperands,
     /* 340771 */     // GIR_Coverage, 769,
     /* 340771 */     GIR_Done,
     /* 340772 */   // Label 6713: @340772
     /* 340772 */   GIM_Reject,
     /* 340773 */ // Label 6711: @340773
     /* 340773 */ GIM_Reject,
     /* 340774 */ // Label 6689: @340774
     /* 340774 */ GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(340881),
     /* 340779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340786 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(340827), // Rule ID 5038 //
     /* 340791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 340810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340812 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 340812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 340815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340825 */     GIR_RootConstrainSelectedInstOperands,
     /* 340826 */     // GIR_Coverage, 5038,
     /* 340826 */     GIR_EraseRootFromParent_Done,
     /* 340827 */   // Label 6715: @340827
     /* 340827 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(340846), // Rule ID 767 //
     /* 340832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340839 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 340839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 340844 */     GIR_RootConstrainSelectedInstOperands,
     /* 340845 */     // GIR_Coverage, 767,
     /* 340845 */     GIR_Done,
     /* 340846 */   // Label 6716: @340846
     /* 340846 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(340880), // Rule ID 6409 //
     /* 340851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340858 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 340858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 340861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340865 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 340875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 340878 */     GIR_RootConstrainSelectedInstOperands,
     /* 340879 */     // GIR_Coverage, 6409,
     /* 340879 */     GIR_EraseRootFromParent_Done,
     /* 340880 */   // Label 6717: @340880
     /* 340880 */   GIM_Reject,
     /* 340881 */ // Label 6714: @340881
     /* 340881 */ GIM_Reject,
     /* 340882 */ // Label 6690: @340882
     /* 340882 */ GIM_Reject,
     /* 340883 */ // Label 74: @340883
     /* 340883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6726*/ GIMT_Encode4(341164),
     /* 340894 */ /*GILLT_s16*//*Label 6718*/ GIMT_Encode4(340934),
     /* 340898 */ /*GILLT_s32*//*Label 6719*/ GIMT_Encode4(340961),
     /* 340902 */ /*GILLT_s64*//*Label 6720*/ GIMT_Encode4(340985), GIMT_Encode4(0),
     /* 340910 */ /*GILLT_v2s32*//*Label 6721*/ GIMT_Encode4(341009),
     /* 340914 */ /*GILLT_v2s64*//*Label 6722*/ GIMT_Encode4(341040),
     /* 340918 */ /*GILLT_v4s16*//*Label 6723*/ GIMT_Encode4(341071),
     /* 340922 */ /*GILLT_v4s32*//*Label 6724*/ GIMT_Encode4(341102), GIMT_Encode4(0),
     /* 340930 */ /*GILLT_v8s16*//*Label 6725*/ GIMT_Encode4(341133),
     /* 340934 */ // Label 6718: @340934
     /* 340934 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(340960), // Rule ID 4856 //
     /* 340939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340949 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 340949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 340952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340954 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 340956 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 340958 */   GIR_RootConstrainSelectedInstOperands,
     /* 340959 */   // GIR_Coverage, 4856,
     /* 340959 */   GIR_EraseRootFromParent_Done,
     /* 340960 */ // Label 6727: @340960
     /* 340960 */ GIM_Reject,
     /* 340961 */ // Label 6719: @340961
     /* 340961 */ GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(340984), // Rule ID 4853 //
     /* 340966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340973 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 340973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 340976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340978 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 340980 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 340982 */   GIR_RootConstrainSelectedInstOperands,
     /* 340983 */   // GIR_Coverage, 4853,
     /* 340983 */   GIR_EraseRootFromParent_Done,
     /* 340984 */ // Label 6728: @340984
     /* 340984 */ GIM_Reject,
     /* 340985 */ // Label 6720: @340985
     /* 340985 */ GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(341008), // Rule ID 4850 //
     /* 340990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340997 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 340997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 341000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341002 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341004 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341006 */   GIR_RootConstrainSelectedInstOperands,
     /* 341007 */   // GIR_Coverage, 4850,
     /* 341007 */   GIR_EraseRootFromParent_Done,
     /* 341008 */ // Label 6729: @341008
     /* 341008 */ GIM_Reject,
     /* 341009 */ // Label 6721: @341009
     /* 341009 */ GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(341039), // Rule ID 5047 //
     /* 341014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341028 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 341028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 341031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341033 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341035 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341037 */   GIR_RootConstrainSelectedInstOperands,
     /* 341038 */   // GIR_Coverage, 5047,
     /* 341038 */   GIR_EraseRootFromParent_Done,
     /* 341039 */ // Label 6730: @341039
     /* 341039 */ GIM_Reject,
     /* 341040 */ // Label 6722: @341040
     /* 341040 */ GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(341070), // Rule ID 5041 //
     /* 341045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341059 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 341059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 341062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341064 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341066 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341068 */   GIR_RootConstrainSelectedInstOperands,
     /* 341069 */   // GIR_Coverage, 5041,
     /* 341069 */   GIR_EraseRootFromParent_Done,
     /* 341070 */ // Label 6731: @341070
     /* 341070 */ GIM_Reject,
     /* 341071 */ // Label 6723: @341071
     /* 341071 */ GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(341101), // Rule ID 5053 //
     /* 341076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341090 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 341090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 341093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341095 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341097 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341099 */   GIR_RootConstrainSelectedInstOperands,
     /* 341100 */   // GIR_Coverage, 5053,
     /* 341100 */   GIR_EraseRootFromParent_Done,
     /* 341101 */ // Label 6732: @341101
     /* 341101 */ GIM_Reject,
     /* 341102 */ // Label 6724: @341102
     /* 341102 */ GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(341132), // Rule ID 5044 //
     /* 341107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341121 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 341121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 341124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341126 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341128 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341130 */   GIR_RootConstrainSelectedInstOperands,
     /* 341131 */   // GIR_Coverage, 5044,
     /* 341131 */   GIR_EraseRootFromParent_Done,
     /* 341132 */ // Label 6733: @341132
     /* 341132 */ GIM_Reject,
     /* 341133 */ // Label 6725: @341133
     /* 341133 */ GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(341163), // Rule ID 5050 //
     /* 341138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341152 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 341152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 341155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341157 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341159 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341161 */   GIR_RootConstrainSelectedInstOperands,
     /* 341162 */   // GIR_Coverage, 5050,
     /* 341162 */   GIR_EraseRootFromParent_Done,
     /* 341163 */ // Label 6734: @341163
     /* 341163 */ GIM_Reject,
     /* 341164 */ // Label 6726: @341164
     /* 341164 */ GIM_Reject,
     /* 341165 */ // Label 75: @341165
     /* 341165 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6743*/ GIMT_Encode4(341542),
     /* 341176 */ /*GILLT_s16*//*Label 6735*/ GIMT_Encode4(341216),
     /* 341180 */ /*GILLT_s32*//*Label 6736*/ GIMT_Encode4(341254),
     /* 341184 */ /*GILLT_s64*//*Label 6737*/ GIMT_Encode4(341292), GIMT_Encode4(0),
     /* 341192 */ /*GILLT_v2s32*//*Label 6738*/ GIMT_Encode4(341352),
     /* 341196 */ /*GILLT_v2s64*//*Label 6739*/ GIMT_Encode4(341390),
     /* 341200 */ /*GILLT_v4s16*//*Label 6740*/ GIMT_Encode4(341428),
     /* 341204 */ /*GILLT_v4s32*//*Label 6741*/ GIMT_Encode4(341466), GIMT_Encode4(0),
     /* 341212 */ /*GILLT_v8s16*//*Label 6742*/ GIMT_Encode4(341504),
     /* 341216 */ // Label 6735: @341216
     /* 341216 */ GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(341253), // Rule ID 608 //
     /* 341221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341242 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 341242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 341247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341251 */   GIR_RootConstrainSelectedInstOperands,
     /* 341252 */   // GIR_Coverage, 608,
     /* 341252 */   GIR_Done,
     /* 341253 */ // Label 6744: @341253
     /* 341253 */ GIM_Reject,
     /* 341254 */ // Label 6736: @341254
     /* 341254 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(341291), // Rule ID 610 //
     /* 341259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341280 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 341280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 341285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341289 */   GIR_RootConstrainSelectedInstOperands,
     /* 341290 */   // GIR_Coverage, 610,
     /* 341290 */   GIR_Done,
     /* 341291 */ // Label 6745: @341291
     /* 341291 */ GIM_Reject,
     /* 341292 */ // Label 6737: @341292
     /* 341292 */ GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(341351),
     /* 341297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 341303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341315 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(341334), // Rule ID 612 //
     /* 341320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341323 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 341323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 341328 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341332 */     GIR_RootConstrainSelectedInstOperands,
     /* 341333 */     // GIR_Coverage, 612,
     /* 341333 */     GIR_Done,
     /* 341334 */   // Label 6747: @341334
     /* 341334 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(341350), // Rule ID 4847 //
     /* 341339 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 341339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 341344 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341348 */     GIR_RootConstrainSelectedInstOperands,
     /* 341349 */     // GIR_Coverage, 4847,
     /* 341349 */     GIR_Done,
     /* 341350 */   // Label 6748: @341350
     /* 341350 */   GIM_Reject,
     /* 341351 */ // Label 6746: @341351
     /* 341351 */ GIM_Reject,
     /* 341352 */ // Label 6738: @341352
     /* 341352 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(341389), // Rule ID 1273 //
     /* 341357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 341366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341378 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 341378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 341383 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341387 */   GIR_RootConstrainSelectedInstOperands,
     /* 341388 */   // GIR_Coverage, 1273,
     /* 341388 */   GIR_Done,
     /* 341389 */ // Label 6749: @341389
     /* 341389 */ GIM_Reject,
     /* 341390 */ // Label 6739: @341390
     /* 341390 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(341427), // Rule ID 1277 //
     /* 341395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 341404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341416 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 341416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 341421 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341425 */   GIR_RootConstrainSelectedInstOperands,
     /* 341426 */   // GIR_Coverage, 1277,
     /* 341426 */   GIR_Done,
     /* 341427 */ // Label 6750: @341427
     /* 341427 */ GIM_Reject,
     /* 341428 */ // Label 6740: @341428
     /* 341428 */ GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(341465), // Rule ID 1269 //
     /* 341433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 341442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341454 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 341454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 341459 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341463 */   GIR_RootConstrainSelectedInstOperands,
     /* 341464 */   // GIR_Coverage, 1269,
     /* 341464 */   GIR_Done,
     /* 341465 */ // Label 6751: @341465
     /* 341465 */ GIM_Reject,
     /* 341466 */ // Label 6741: @341466
     /* 341466 */ GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(341503), // Rule ID 1275 //
     /* 341471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 341480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341492 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 341492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 341497 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341501 */   GIR_RootConstrainSelectedInstOperands,
     /* 341502 */   // GIR_Coverage, 1275,
     /* 341502 */   GIR_Done,
     /* 341503 */ // Label 6752: @341503
     /* 341503 */ GIM_Reject,
     /* 341504 */ // Label 6742: @341504
     /* 341504 */ GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(341541), // Rule ID 1271 //
     /* 341509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 341518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341530 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 341530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 341535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341539 */   GIR_RootConstrainSelectedInstOperands,
     /* 341540 */   // GIR_Coverage, 1271,
     /* 341540 */   GIR_Done,
     /* 341541 */ // Label 6753: @341541
     /* 341541 */ GIM_Reject,
     /* 341542 */ // Label 6743: @341542
     /* 341542 */ GIM_Reject,
     /* 341543 */ // Label 76: @341543
     /* 341543 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6762*/ GIMT_Encode4(341920),
     /* 341554 */ /*GILLT_s16*//*Label 6754*/ GIMT_Encode4(341594),
     /* 341558 */ /*GILLT_s32*//*Label 6755*/ GIMT_Encode4(341632),
     /* 341562 */ /*GILLT_s64*//*Label 6756*/ GIMT_Encode4(341670), GIMT_Encode4(0),
     /* 341570 */ /*GILLT_v2s32*//*Label 6757*/ GIMT_Encode4(341730),
     /* 341574 */ /*GILLT_v2s64*//*Label 6758*/ GIMT_Encode4(341768),
     /* 341578 */ /*GILLT_v4s16*//*Label 6759*/ GIMT_Encode4(341806),
     /* 341582 */ /*GILLT_v4s32*//*Label 6760*/ GIMT_Encode4(341844), GIMT_Encode4(0),
     /* 341590 */ /*GILLT_v8s16*//*Label 6761*/ GIMT_Encode4(341882),
     /* 341594 */ // Label 6754: @341594
     /* 341594 */ GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(341631), // Rule ID 596 //
     /* 341599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341620 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 341620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 341625 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341629 */   GIR_RootConstrainSelectedInstOperands,
     /* 341630 */   // GIR_Coverage, 596,
     /* 341630 */   GIR_Done,
     /* 341631 */ // Label 6763: @341631
     /* 341631 */ GIM_Reject,
     /* 341632 */ // Label 6755: @341632
     /* 341632 */ GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(341669), // Rule ID 598 //
     /* 341637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341658 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 341658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 341663 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341667 */   GIR_RootConstrainSelectedInstOperands,
     /* 341668 */   // GIR_Coverage, 598,
     /* 341668 */   GIR_Done,
     /* 341669 */ // Label 6764: @341669
     /* 341669 */ GIM_Reject,
     /* 341670 */ // Label 6756: @341670
     /* 341670 */ GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(341729),
     /* 341675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 341681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341693 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(341712), // Rule ID 600 //
     /* 341698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341701 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 341701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 341706 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341710 */     GIR_RootConstrainSelectedInstOperands,
     /* 341711 */     // GIR_Coverage, 600,
     /* 341711 */     GIR_Done,
     /* 341712 */   // Label 6766: @341712
     /* 341712 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(341728), // Rule ID 4846 //
     /* 341717 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 341717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 341722 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341726 */     GIR_RootConstrainSelectedInstOperands,
     /* 341727 */     // GIR_Coverage, 4846,
     /* 341727 */     GIR_Done,
     /* 341728 */   // Label 6767: @341728
     /* 341728 */   GIM_Reject,
     /* 341729 */ // Label 6765: @341729
     /* 341729 */ GIM_Reject,
     /* 341730 */ // Label 6757: @341730
     /* 341730 */ GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(341767), // Rule ID 1243 //
     /* 341735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 341744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341756 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 341756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 341761 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341765 */   GIR_RootConstrainSelectedInstOperands,
     /* 341766 */   // GIR_Coverage, 1243,
     /* 341766 */   GIR_Done,
     /* 341767 */ // Label 6768: @341767
     /* 341767 */ GIM_Reject,
     /* 341768 */ // Label 6758: @341768
     /* 341768 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(341805), // Rule ID 1247 //
     /* 341773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 341782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341794 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 341794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 341799 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341803 */   GIR_RootConstrainSelectedInstOperands,
     /* 341804 */   // GIR_Coverage, 1247,
     /* 341804 */   GIR_Done,
     /* 341805 */ // Label 6769: @341805
     /* 341805 */ GIM_Reject,
     /* 341806 */ // Label 6759: @341806
     /* 341806 */ GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(341843), // Rule ID 1239 //
     /* 341811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 341820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341832 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 341832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 341837 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341841 */   GIR_RootConstrainSelectedInstOperands,
     /* 341842 */   // GIR_Coverage, 1239,
     /* 341842 */   GIR_Done,
     /* 341843 */ // Label 6770: @341843
     /* 341843 */ GIM_Reject,
     /* 341844 */ // Label 6760: @341844
     /* 341844 */ GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(341881), // Rule ID 1245 //
     /* 341849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 341858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341870 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 341870 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 341875 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341879 */   GIR_RootConstrainSelectedInstOperands,
     /* 341880 */   // GIR_Coverage, 1245,
     /* 341880 */   GIR_Done,
     /* 341881 */ // Label 6771: @341881
     /* 341881 */ GIM_Reject,
     /* 341882 */ // Label 6761: @341882
     /* 341882 */ GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(341919), // Rule ID 1241 //
     /* 341887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 341896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341908 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 341908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 341913 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341917 */   GIR_RootConstrainSelectedInstOperands,
     /* 341918 */   // GIR_Coverage, 1241,
     /* 341918 */   GIR_Done,
     /* 341919 */ // Label 6772: @341919
     /* 341919 */ GIM_Reject,
     /* 341920 */ // Label 6762: @341920
     /* 341920 */ GIM_Reject,
     /* 341921 */ // Label 77: @341921
     /* 341921 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6781*/ GIMT_Encode4(342270),
     /* 341932 */ /*GILLT_s16*//*Label 6773*/ GIMT_Encode4(341972),
     /* 341936 */ /*GILLT_s32*//*Label 6774*/ GIMT_Encode4(342010),
     /* 341940 */ /*GILLT_s64*//*Label 6775*/ GIMT_Encode4(342045), GIMT_Encode4(0),
     /* 341948 */ /*GILLT_v2s32*//*Label 6776*/ GIMT_Encode4(342080),
     /* 341952 */ /*GILLT_v2s64*//*Label 6777*/ GIMT_Encode4(342118),
     /* 341956 */ /*GILLT_v4s16*//*Label 6778*/ GIMT_Encode4(342156),
     /* 341960 */ /*GILLT_v4s32*//*Label 6779*/ GIMT_Encode4(342194), GIMT_Encode4(0),
     /* 341968 */ /*GILLT_v8s16*//*Label 6780*/ GIMT_Encode4(342232),
     /* 341972 */ // Label 6773: @341972
     /* 341972 */ GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(342009), // Rule ID 4854 //
     /* 341977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341998 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 341998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 342003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342007 */   GIR_RootConstrainSelectedInstOperands,
     /* 342008 */   // GIR_Coverage, 4854,
     /* 342008 */   GIR_Done,
     /* 342009 */ // Label 6782: @342009
     /* 342009 */ GIM_Reject,
     /* 342010 */ // Label 6774: @342010
     /* 342010 */ GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(342044), // Rule ID 4851 //
     /* 342015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342029 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342033 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 342033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 342038 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342042 */   GIR_RootConstrainSelectedInstOperands,
     /* 342043 */   // GIR_Coverage, 4851,
     /* 342043 */   GIR_Done,
     /* 342044 */ // Label 6783: @342044
     /* 342044 */ GIM_Reject,
     /* 342045 */ // Label 6775: @342045
     /* 342045 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(342079), // Rule ID 4848 //
     /* 342050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342068 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 342068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342073 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342077 */   GIR_RootConstrainSelectedInstOperands,
     /* 342078 */   // GIR_Coverage, 4848,
     /* 342078 */   GIR_Done,
     /* 342079 */ // Label 6784: @342079
     /* 342079 */ GIM_Reject,
     /* 342080 */ // Label 6776: @342080
     /* 342080 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(342117), // Rule ID 5045 //
     /* 342085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342106 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 342111 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342115 */   GIR_RootConstrainSelectedInstOperands,
     /* 342116 */   // GIR_Coverage, 5045,
     /* 342116 */   GIR_Done,
     /* 342117 */ // Label 6785: @342117
     /* 342117 */ GIM_Reject,
     /* 342118 */ // Label 6777: @342118
     /* 342118 */ GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(342155), // Rule ID 5039 //
     /* 342123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342144 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 342149 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342153 */   GIR_RootConstrainSelectedInstOperands,
     /* 342154 */   // GIR_Coverage, 5039,
     /* 342154 */   GIR_Done,
     /* 342155 */ // Label 6786: @342155
     /* 342155 */ GIM_Reject,
     /* 342156 */ // Label 6778: @342156
     /* 342156 */ GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(342193), // Rule ID 5051 //
     /* 342161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342182 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 342182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 342187 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342191 */   GIR_RootConstrainSelectedInstOperands,
     /* 342192 */   // GIR_Coverage, 5051,
     /* 342192 */   GIR_Done,
     /* 342193 */ // Label 6787: @342193
     /* 342193 */ GIM_Reject,
     /* 342194 */ // Label 6779: @342194
     /* 342194 */ GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(342231), // Rule ID 5042 //
     /* 342199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342220 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 342220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 342225 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342229 */   GIR_RootConstrainSelectedInstOperands,
     /* 342230 */   // GIR_Coverage, 5042,
     /* 342230 */   GIR_Done,
     /* 342231 */ // Label 6788: @342231
     /* 342231 */ GIM_Reject,
     /* 342232 */ // Label 6780: @342232
     /* 342232 */ GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(342269), // Rule ID 5048 //
     /* 342237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342258 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 342258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 342263 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342267 */   GIR_RootConstrainSelectedInstOperands,
     /* 342268 */   // GIR_Coverage, 5048,
     /* 342268 */   GIR_Done,
     /* 342269 */ // Label 6789: @342269
     /* 342269 */ GIM_Reject,
     /* 342270 */ // Label 6781: @342270
     /* 342270 */ GIM_Reject,
     /* 342271 */ // Label 78: @342271
     /* 342271 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6798*/ GIMT_Encode4(342620),
     /* 342282 */ /*GILLT_s16*//*Label 6790*/ GIMT_Encode4(342322),
     /* 342286 */ /*GILLT_s32*//*Label 6791*/ GIMT_Encode4(342360),
     /* 342290 */ /*GILLT_s64*//*Label 6792*/ GIMT_Encode4(342395), GIMT_Encode4(0),
     /* 342298 */ /*GILLT_v2s32*//*Label 6793*/ GIMT_Encode4(342430),
     /* 342302 */ /*GILLT_v2s64*//*Label 6794*/ GIMT_Encode4(342468),
     /* 342306 */ /*GILLT_v4s16*//*Label 6795*/ GIMT_Encode4(342506),
     /* 342310 */ /*GILLT_v4s32*//*Label 6796*/ GIMT_Encode4(342544), GIMT_Encode4(0),
     /* 342318 */ /*GILLT_v8s16*//*Label 6797*/ GIMT_Encode4(342582),
     /* 342322 */ // Label 6790: @342322
     /* 342322 */ GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(342359), // Rule ID 4855 //
     /* 342327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342348 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 342348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 342353 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342357 */   GIR_RootConstrainSelectedInstOperands,
     /* 342358 */   // GIR_Coverage, 4855,
     /* 342358 */   GIR_Done,
     /* 342359 */ // Label 6799: @342359
     /* 342359 */ GIM_Reject,
     /* 342360 */ // Label 6791: @342360
     /* 342360 */ GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(342394), // Rule ID 4852 //
     /* 342365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342383 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 342383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 342388 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342392 */   GIR_RootConstrainSelectedInstOperands,
     /* 342393 */   // GIR_Coverage, 4852,
     /* 342393 */   GIR_Done,
     /* 342394 */ // Label 6800: @342394
     /* 342394 */ GIM_Reject,
     /* 342395 */ // Label 6792: @342395
     /* 342395 */ GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(342429), // Rule ID 4849 //
     /* 342400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342418 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 342418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 342423 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342427 */   GIR_RootConstrainSelectedInstOperands,
     /* 342428 */   // GIR_Coverage, 4849,
     /* 342428 */   GIR_Done,
     /* 342429 */ // Label 6801: @342429
     /* 342429 */ GIM_Reject,
     /* 342430 */ // Label 6793: @342430
     /* 342430 */ GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(342467), // Rule ID 5046 //
     /* 342435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342456 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342456 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 342461 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342465 */   GIR_RootConstrainSelectedInstOperands,
     /* 342466 */   // GIR_Coverage, 5046,
     /* 342466 */   GIR_Done,
     /* 342467 */ // Label 6802: @342467
     /* 342467 */ GIM_Reject,
     /* 342468 */ // Label 6794: @342468
     /* 342468 */ GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(342505), // Rule ID 5040 //
     /* 342473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342494 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 342499 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342503 */   GIR_RootConstrainSelectedInstOperands,
     /* 342504 */   // GIR_Coverage, 5040,
     /* 342504 */   GIR_Done,
     /* 342505 */ // Label 6803: @342505
     /* 342505 */ GIM_Reject,
     /* 342506 */ // Label 6795: @342506
     /* 342506 */ GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(342543), // Rule ID 5052 //
     /* 342511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342532 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 342532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 342537 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342541 */   GIR_RootConstrainSelectedInstOperands,
     /* 342542 */   // GIR_Coverage, 5052,
     /* 342542 */   GIR_Done,
     /* 342543 */ // Label 6804: @342543
     /* 342543 */ GIM_Reject,
     /* 342544 */ // Label 6796: @342544
     /* 342544 */ GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(342581), // Rule ID 5043 //
     /* 342549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342570 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 342570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 342575 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342579 */   GIR_RootConstrainSelectedInstOperands,
     /* 342580 */   // GIR_Coverage, 5043,
     /* 342580 */   GIR_Done,
     /* 342581 */ // Label 6805: @342581
     /* 342581 */ GIM_Reject,
     /* 342582 */ // Label 6797: @342582
     /* 342582 */ GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(342619), // Rule ID 5049 //
     /* 342587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342608 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 342608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 342613 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342617 */   GIR_RootConstrainSelectedInstOperands,
     /* 342618 */   // GIR_Coverage, 5049,
     /* 342618 */   GIR_Done,
     /* 342619 */ // Label 6806: @342619
     /* 342619 */ GIM_Reject,
     /* 342620 */ // Label 6798: @342620
     /* 342620 */ GIM_Reject,
     /* 342621 */ // Label 79: @342621
     /* 342621 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6815*/ GIMT_Encode4(343323),
     /* 342632 */ /*GILLT_s16*//*Label 6807*/ GIMT_Encode4(342672),
     /* 342636 */ /*GILLT_s32*//*Label 6808*/ GIMT_Encode4(342710),
     /* 342640 */ /*GILLT_s64*//*Label 6809*/ GIMT_Encode4(342748), GIMT_Encode4(0),
     /* 342648 */ /*GILLT_v2s32*//*Label 6810*/ GIMT_Encode4(342808),
     /* 342652 */ /*GILLT_v2s64*//*Label 6811*/ GIMT_Encode4(342911),
     /* 342656 */ /*GILLT_v4s16*//*Label 6812*/ GIMT_Encode4(343014),
     /* 342660 */ /*GILLT_v4s32*//*Label 6813*/ GIMT_Encode4(343117), GIMT_Encode4(0),
     /* 342668 */ /*GILLT_v8s16*//*Label 6814*/ GIMT_Encode4(343220),
     /* 342672 */ // Label 6807: @342672
     /* 342672 */ GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(342709), // Rule ID 614 //
     /* 342677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342698 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 342698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 342703 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342707 */   GIR_RootConstrainSelectedInstOperands,
     /* 342708 */   // GIR_Coverage, 614,
     /* 342708 */   GIR_Done,
     /* 342709 */ // Label 6816: @342709
     /* 342709 */ GIM_Reject,
     /* 342710 */ // Label 6808: @342710
     /* 342710 */ GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(342747), // Rule ID 616 //
     /* 342715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342736 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 342736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 342741 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342745 */   GIR_RootConstrainSelectedInstOperands,
     /* 342746 */   // GIR_Coverage, 616,
     /* 342746 */   GIR_Done,
     /* 342747 */ // Label 6817: @342747
     /* 342747 */ GIM_Reject,
     /* 342748 */ // Label 6809: @342748
     /* 342748 */ GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(342807),
     /* 342753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342771 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(342790), // Rule ID 618 //
     /* 342776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342779 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 342779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 342784 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342788 */     GIR_RootConstrainSelectedInstOperands,
     /* 342789 */     // GIR_Coverage, 618,
     /* 342789 */     GIR_Done,
     /* 342790 */   // Label 6819: @342790
     /* 342790 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(342806), // Rule ID 4845 //
     /* 342795 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 342795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 342800 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342804 */     GIR_RootConstrainSelectedInstOperands,
     /* 342805 */     // GIR_Coverage, 4845,
     /* 342805 */     GIR_Done,
     /* 342806 */   // Label 6820: @342806
     /* 342806 */   GIM_Reject,
     /* 342807 */ // Label 6818: @342807
     /* 342807 */ GIM_Reject,
     /* 342808 */ // Label 6810: @342808
     /* 342808 */ GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(342910),
     /* 342813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342823 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(342882), // Rule ID 2366 //
     /* 342828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 342831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 342839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 342856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342867 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 342870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 342880 */     GIR_RootConstrainSelectedInstOperands,
     /* 342881 */     // GIR_Coverage, 2366,
     /* 342881 */     GIR_EraseRootFromParent_Done,
     /* 342882 */   // Label 6822: @342882
     /* 342882 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(342909), // Rule ID 1288 //
     /* 342887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342898 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 342903 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342907 */     GIR_RootConstrainSelectedInstOperands,
     /* 342908 */     // GIR_Coverage, 1288,
     /* 342908 */     GIR_Done,
     /* 342909 */   // Label 6823: @342909
     /* 342909 */   GIM_Reject,
     /* 342910 */ // Label 6821: @342910
     /* 342910 */ GIM_Reject,
     /* 342911 */ // Label 6811: @342911
     /* 342911 */ GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(343013),
     /* 342916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342926 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(342985), // Rule ID 2372 //
     /* 342931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 342934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 342942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 342959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342970 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 342973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 342983 */     GIR_RootConstrainSelectedInstOperands,
     /* 342984 */     // GIR_Coverage, 2372,
     /* 342984 */     GIR_EraseRootFromParent_Done,
     /* 342985 */   // Label 6825: @342985
     /* 342985 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(343012), // Rule ID 1292 //
     /* 342990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343001 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 343006 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343010 */     GIR_RootConstrainSelectedInstOperands,
     /* 343011 */     // GIR_Coverage, 1292,
     /* 343011 */     GIR_Done,
     /* 343012 */   // Label 6826: @343012
     /* 343012 */   GIM_Reject,
     /* 343013 */ // Label 6824: @343013
     /* 343013 */ GIM_Reject,
     /* 343014 */ // Label 6812: @343014
     /* 343014 */ GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(343116),
     /* 343019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343029 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(343088), // Rule ID 2360 //
     /* 343034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343073 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 343076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343086 */     GIR_RootConstrainSelectedInstOperands,
     /* 343087 */     // GIR_Coverage, 2360,
     /* 343087 */     GIR_EraseRootFromParent_Done,
     /* 343088 */   // Label 6828: @343088
     /* 343088 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(343115), // Rule ID 1284 //
     /* 343093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343104 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 343109 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343113 */     GIR_RootConstrainSelectedInstOperands,
     /* 343114 */     // GIR_Coverage, 1284,
     /* 343114 */     GIR_Done,
     /* 343115 */   // Label 6829: @343115
     /* 343115 */   GIM_Reject,
     /* 343116 */ // Label 6827: @343116
     /* 343116 */ GIM_Reject,
     /* 343117 */ // Label 6813: @343117
     /* 343117 */ GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(343219),
     /* 343122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343132 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(343191), // Rule ID 2369 //
     /* 343137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343176 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 343179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343189 */     GIR_RootConstrainSelectedInstOperands,
     /* 343190 */     // GIR_Coverage, 2369,
     /* 343190 */     GIR_EraseRootFromParent_Done,
     /* 343191 */   // Label 6831: @343191
     /* 343191 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(343218), // Rule ID 1290 //
     /* 343196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343207 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 343212 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343216 */     GIR_RootConstrainSelectedInstOperands,
     /* 343217 */     // GIR_Coverage, 1290,
     /* 343217 */     GIR_Done,
     /* 343218 */   // Label 6832: @343218
     /* 343218 */   GIM_Reject,
     /* 343219 */ // Label 6830: @343219
     /* 343219 */ GIM_Reject,
     /* 343220 */ // Label 6814: @343220
     /* 343220 */ GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(343322),
     /* 343225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343235 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(343294), // Rule ID 2363 //
     /* 343240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343279 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 343282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343292 */     GIR_RootConstrainSelectedInstOperands,
     /* 343293 */     // GIR_Coverage, 2363,
     /* 343293 */     GIR_EraseRootFromParent_Done,
     /* 343294 */   // Label 6834: @343294
     /* 343294 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(343321), // Rule ID 1286 //
     /* 343299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343310 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 343315 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343319 */     GIR_RootConstrainSelectedInstOperands,
     /* 343320 */     // GIR_Coverage, 1286,
     /* 343320 */     GIR_Done,
     /* 343321 */   // Label 6835: @343321
     /* 343321 */   GIM_Reject,
     /* 343322 */ // Label 6833: @343322
     /* 343322 */ GIM_Reject,
     /* 343323 */ // Label 6815: @343323
     /* 343323 */ GIM_Reject,
     /* 343324 */ // Label 80: @343324
     /* 343324 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6844*/ GIMT_Encode4(344026),
     /* 343335 */ /*GILLT_s16*//*Label 6836*/ GIMT_Encode4(343375),
     /* 343339 */ /*GILLT_s32*//*Label 6837*/ GIMT_Encode4(343413),
     /* 343343 */ /*GILLT_s64*//*Label 6838*/ GIMT_Encode4(343451), GIMT_Encode4(0),
     /* 343351 */ /*GILLT_v2s32*//*Label 6839*/ GIMT_Encode4(343511),
     /* 343355 */ /*GILLT_v2s64*//*Label 6840*/ GIMT_Encode4(343614),
     /* 343359 */ /*GILLT_v4s16*//*Label 6841*/ GIMT_Encode4(343717),
     /* 343363 */ /*GILLT_v4s32*//*Label 6842*/ GIMT_Encode4(343820), GIMT_Encode4(0),
     /* 343371 */ /*GILLT_v8s16*//*Label 6843*/ GIMT_Encode4(343923),
     /* 343375 */ // Label 6836: @343375
     /* 343375 */ GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(343412), // Rule ID 602 //
     /* 343380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343401 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 343401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 343406 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343410 */   GIR_RootConstrainSelectedInstOperands,
     /* 343411 */   // GIR_Coverage, 602,
     /* 343411 */   GIR_Done,
     /* 343412 */ // Label 6845: @343412
     /* 343412 */ GIM_Reject,
     /* 343413 */ // Label 6837: @343413
     /* 343413 */ GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(343450), // Rule ID 604 //
     /* 343418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343439 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 343439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 343444 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343448 */   GIR_RootConstrainSelectedInstOperands,
     /* 343449 */   // GIR_Coverage, 604,
     /* 343449 */   GIR_Done,
     /* 343450 */ // Label 6846: @343450
     /* 343450 */ GIM_Reject,
     /* 343451 */ // Label 6838: @343451
     /* 343451 */ GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(343510),
     /* 343456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343474 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(343493), // Rule ID 606 //
     /* 343479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343482 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 343482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 343487 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343491 */     GIR_RootConstrainSelectedInstOperands,
     /* 343492 */     // GIR_Coverage, 606,
     /* 343492 */     GIR_Done,
     /* 343493 */   // Label 6848: @343493
     /* 343493 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(343509), // Rule ID 4844 //
     /* 343498 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 343498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 343503 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343507 */     GIR_RootConstrainSelectedInstOperands,
     /* 343508 */     // GIR_Coverage, 4844,
     /* 343508 */     GIR_Done,
     /* 343509 */   // Label 6849: @343509
     /* 343509 */   GIM_Reject,
     /* 343510 */ // Label 6847: @343510
     /* 343510 */ GIM_Reject,
     /* 343511 */ // Label 6839: @343511
     /* 343511 */ GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(343613),
     /* 343516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343526 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(343585), // Rule ID 2351 //
     /* 343531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343570 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 343573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343583 */     GIR_RootConstrainSelectedInstOperands,
     /* 343584 */     // GIR_Coverage, 2351,
     /* 343584 */     GIR_EraseRootFromParent_Done,
     /* 343585 */   // Label 6851: @343585
     /* 343585 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(343612), // Rule ID 1258 //
     /* 343590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343601 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 343606 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343610 */     GIR_RootConstrainSelectedInstOperands,
     /* 343611 */     // GIR_Coverage, 1258,
     /* 343611 */     GIR_Done,
     /* 343612 */   // Label 6852: @343612
     /* 343612 */   GIM_Reject,
     /* 343613 */ // Label 6850: @343613
     /* 343613 */ GIM_Reject,
     /* 343614 */ // Label 6840: @343614
     /* 343614 */ GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(343716),
     /* 343619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343629 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(343688), // Rule ID 2357 //
     /* 343634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343673 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 343676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343686 */     GIR_RootConstrainSelectedInstOperands,
     /* 343687 */     // GIR_Coverage, 2357,
     /* 343687 */     GIR_EraseRootFromParent_Done,
     /* 343688 */   // Label 6854: @343688
     /* 343688 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(343715), // Rule ID 1262 //
     /* 343693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343704 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 343709 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343713 */     GIR_RootConstrainSelectedInstOperands,
     /* 343714 */     // GIR_Coverage, 1262,
     /* 343714 */     GIR_Done,
     /* 343715 */   // Label 6855: @343715
     /* 343715 */   GIM_Reject,
     /* 343716 */ // Label 6853: @343716
     /* 343716 */ GIM_Reject,
     /* 343717 */ // Label 6841: @343717
     /* 343717 */ GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(343819),
     /* 343722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343732 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(343791), // Rule ID 2345 //
     /* 343737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343776 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 343779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343789 */     GIR_RootConstrainSelectedInstOperands,
     /* 343790 */     // GIR_Coverage, 2345,
     /* 343790 */     GIR_EraseRootFromParent_Done,
     /* 343791 */   // Label 6857: @343791
     /* 343791 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(343818), // Rule ID 1254 //
     /* 343796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343807 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 343812 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343816 */     GIR_RootConstrainSelectedInstOperands,
     /* 343817 */     // GIR_Coverage, 1254,
     /* 343817 */     GIR_Done,
     /* 343818 */   // Label 6858: @343818
     /* 343818 */   GIM_Reject,
     /* 343819 */ // Label 6856: @343819
     /* 343819 */ GIM_Reject,
     /* 343820 */ // Label 6842: @343820
     /* 343820 */ GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(343922),
     /* 343825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343835 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(343894), // Rule ID 2354 //
     /* 343840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343879 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 343882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343892 */     GIR_RootConstrainSelectedInstOperands,
     /* 343893 */     // GIR_Coverage, 2354,
     /* 343893 */     GIR_EraseRootFromParent_Done,
     /* 343894 */   // Label 6860: @343894
     /* 343894 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(343921), // Rule ID 1260 //
     /* 343899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343910 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 343915 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343919 */     GIR_RootConstrainSelectedInstOperands,
     /* 343920 */     // GIR_Coverage, 1260,
     /* 343920 */     GIR_Done,
     /* 343921 */   // Label 6861: @343921
     /* 343921 */   GIM_Reject,
     /* 343922 */ // Label 6859: @343922
     /* 343922 */ GIM_Reject,
     /* 343923 */ // Label 6843: @343923
     /* 343923 */ GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(344025),
     /* 343928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343938 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(343997), // Rule ID 2348 //
     /* 343943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343982 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 343985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343995 */     GIR_RootConstrainSelectedInstOperands,
     /* 343996 */     // GIR_Coverage, 2348,
     /* 343996 */     GIR_EraseRootFromParent_Done,
     /* 343997 */   // Label 6863: @343997
     /* 343997 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(344024), // Rule ID 1256 //
     /* 344002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344013 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 344018 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344022 */     GIR_RootConstrainSelectedInstOperands,
     /* 344023 */     // GIR_Coverage, 1256,
     /* 344023 */     GIR_Done,
     /* 344024 */   // Label 6864: @344024
     /* 344024 */   GIM_Reject,
     /* 344025 */ // Label 6862: @344025
     /* 344025 */ GIM_Reject,
     /* 344026 */ // Label 6844: @344026
     /* 344026 */ GIM_Reject,
     /* 344027 */ // Label 81: @344027
     /* 344027 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6873*/ GIMT_Encode4(344430),
     /* 344038 */ /*GILLT_s32*//*Label 6865*/ GIMT_Encode4(344078),
     /* 344042 */ /*GILLT_s64*//*Label 6866*/ GIMT_Encode4(344152), GIMT_Encode4(0),
     /* 344050 */ /*GILLT_v2s32*//*Label 6867*/ GIMT_Encode4(344226), GIMT_Encode4(0),
     /* 344058 */ /*GILLT_v4s16*//*Label 6868*/ GIMT_Encode4(344260),
     /* 344062 */ /*GILLT_v4s32*//*Label 6869*/ GIMT_Encode4(344294),
     /* 344066 */ /*GILLT_v8s8*//*Label 6870*/ GIMT_Encode4(344328),
     /* 344070 */ /*GILLT_v8s16*//*Label 6871*/ GIMT_Encode4(344362),
     /* 344074 */ /*GILLT_v16s8*//*Label 6872*/ GIMT_Encode4(344396),
     /* 344078 */ // Label 6865: @344078
     /* 344078 */ GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(344151),
     /* 344083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344097 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(344131), // Rule ID 2328 //
     /* 344102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 344117 */     // MIs[1] Operand 1
     /* 344117 */     // No operand predicates
     /* 344117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344119 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 344119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 344122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344129 */     GIR_RootConstrainSelectedInstOperands,
     /* 344130 */     // GIR_Coverage, 2328,
     /* 344130 */     GIR_EraseRootFromParent_Done,
     /* 344131 */   // Label 6875: @344131
     /* 344131 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(344150), // Rule ID 2327 //
     /* 344136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344143 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 344143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 344148 */     GIR_RootConstrainSelectedInstOperands,
     /* 344149 */     // GIR_Coverage, 2327,
     /* 344149 */     GIR_Done,
     /* 344150 */   // Label 6876: @344150
     /* 344150 */   GIM_Reject,
     /* 344151 */ // Label 6874: @344151
     /* 344151 */ GIM_Reject,
     /* 344152 */ // Label 6866: @344152
     /* 344152 */ GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(344225),
     /* 344157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344171 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(344205), // Rule ID 2330 //
     /* 344176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 344191 */     // MIs[1] Operand 1
     /* 344191 */     // No operand predicates
     /* 344191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344193 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 344193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 344196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344203 */     GIR_RootConstrainSelectedInstOperands,
     /* 344204 */     // GIR_Coverage, 2330,
     /* 344204 */     GIR_EraseRootFromParent_Done,
     /* 344205 */   // Label 6878: @344205
     /* 344205 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(344224), // Rule ID 2329 //
     /* 344210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344217 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 344217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 344222 */     GIR_RootConstrainSelectedInstOperands,
     /* 344223 */     // GIR_Coverage, 2329,
     /* 344223 */     GIR_Done,
     /* 344224 */   // Label 6879: @344224
     /* 344224 */   GIM_Reject,
     /* 344225 */ // Label 6877: @344225
     /* 344225 */ GIM_Reject,
     /* 344226 */ // Label 6867: @344226
     /* 344226 */ GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(344259), // Rule ID 1414 //
     /* 344231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344252 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 344252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 344257 */   GIR_RootConstrainSelectedInstOperands,
     /* 344258 */   // GIR_Coverage, 1414,
     /* 344258 */   GIR_Done,
     /* 344259 */ // Label 6880: @344259
     /* 344259 */ GIM_Reject,
     /* 344260 */ // Label 6868: @344260
     /* 344260 */ GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(344293), // Rule ID 1412 //
     /* 344265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344286 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 344286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 344291 */   GIR_RootConstrainSelectedInstOperands,
     /* 344292 */   // GIR_Coverage, 1412,
     /* 344292 */   GIR_Done,
     /* 344293 */ // Label 6881: @344293
     /* 344293 */ GIM_Reject,
     /* 344294 */ // Label 6869: @344294
     /* 344294 */ GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(344327), // Rule ID 1415 //
     /* 344299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344320 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 344320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 344325 */   GIR_RootConstrainSelectedInstOperands,
     /* 344326 */   // GIR_Coverage, 1415,
     /* 344326 */   GIR_Done,
     /* 344327 */ // Label 6882: @344327
     /* 344327 */ GIM_Reject,
     /* 344328 */ // Label 6870: @344328
     /* 344328 */ GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(344361), // Rule ID 1410 //
     /* 344333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 344339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 344342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344354 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 344354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 344359 */   GIR_RootConstrainSelectedInstOperands,
     /* 344360 */   // GIR_Coverage, 1410,
     /* 344360 */   GIR_Done,
     /* 344361 */ // Label 6883: @344361
     /* 344361 */ GIM_Reject,
     /* 344362 */ // Label 6871: @344362
     /* 344362 */ GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(344395), // Rule ID 1413 //
     /* 344367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344388 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 344388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 344393 */   GIR_RootConstrainSelectedInstOperands,
     /* 344394 */   // GIR_Coverage, 1413,
     /* 344394 */   GIR_Done,
     /* 344395 */ // Label 6884: @344395
     /* 344395 */ GIM_Reject,
     /* 344396 */ // Label 6872: @344396
     /* 344396 */ GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(344429), // Rule ID 1411 //
     /* 344401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 344407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 344410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344422 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 344422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 344427 */   GIR_RootConstrainSelectedInstOperands,
     /* 344428 */   // GIR_Coverage, 1411,
     /* 344428 */   GIR_Done,
     /* 344429 */ // Label 6885: @344429
     /* 344429 */ GIM_Reject,
     /* 344430 */ // Label 6873: @344430
     /* 344430 */ GIM_Reject,
     /* 344431 */ // Label 82: @344431
     /* 344431 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6894*/ GIMT_Encode4(344834),
     /* 344442 */ /*GILLT_s32*//*Label 6886*/ GIMT_Encode4(344482),
     /* 344446 */ /*GILLT_s64*//*Label 6887*/ GIMT_Encode4(344556), GIMT_Encode4(0),
     /* 344454 */ /*GILLT_v2s32*//*Label 6888*/ GIMT_Encode4(344630), GIMT_Encode4(0),
     /* 344462 */ /*GILLT_v4s16*//*Label 6889*/ GIMT_Encode4(344664),
     /* 344466 */ /*GILLT_v4s32*//*Label 6890*/ GIMT_Encode4(344698),
     /* 344470 */ /*GILLT_v8s8*//*Label 6891*/ GIMT_Encode4(344732),
     /* 344474 */ /*GILLT_v8s16*//*Label 6892*/ GIMT_Encode4(344766),
     /* 344478 */ /*GILLT_v16s8*//*Label 6893*/ GIMT_Encode4(344800),
     /* 344482 */ // Label 6886: @344482
     /* 344482 */ GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(344555),
     /* 344487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344501 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(344535), // Rule ID 2324 //
     /* 344506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 344521 */     // MIs[1] Operand 1
     /* 344521 */     // No operand predicates
     /* 344521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344523 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 344523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 344526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344533 */     GIR_RootConstrainSelectedInstOperands,
     /* 344534 */     // GIR_Coverage, 2324,
     /* 344534 */     GIR_EraseRootFromParent_Done,
     /* 344535 */   // Label 6896: @344535
     /* 344535 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(344554), // Rule ID 2323 //
     /* 344540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344547 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 344547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 344552 */     GIR_RootConstrainSelectedInstOperands,
     /* 344553 */     // GIR_Coverage, 2323,
     /* 344553 */     GIR_Done,
     /* 344554 */   // Label 6897: @344554
     /* 344554 */   GIM_Reject,
     /* 344555 */ // Label 6895: @344555
     /* 344555 */ GIM_Reject,
     /* 344556 */ // Label 6887: @344556
     /* 344556 */ GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(344629),
     /* 344561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344575 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(344609), // Rule ID 2326 //
     /* 344580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 344595 */     // MIs[1] Operand 1
     /* 344595 */     // No operand predicates
     /* 344595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344597 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 344597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 344600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344607 */     GIR_RootConstrainSelectedInstOperands,
     /* 344608 */     // GIR_Coverage, 2326,
     /* 344608 */     GIR_EraseRootFromParent_Done,
     /* 344609 */   // Label 6899: @344609
     /* 344609 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(344628), // Rule ID 2325 //
     /* 344614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344621 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 344621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 344626 */     GIR_RootConstrainSelectedInstOperands,
     /* 344627 */     // GIR_Coverage, 2325,
     /* 344627 */     GIR_Done,
     /* 344628 */   // Label 6900: @344628
     /* 344628 */   GIM_Reject,
     /* 344629 */ // Label 6898: @344629
     /* 344629 */ GIM_Reject,
     /* 344630 */ // Label 6888: @344630
     /* 344630 */ GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(344663), // Rule ID 1402 //
     /* 344635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344656 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 344656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 344661 */   GIR_RootConstrainSelectedInstOperands,
     /* 344662 */   // GIR_Coverage, 1402,
     /* 344662 */   GIR_Done,
     /* 344663 */ // Label 6901: @344663
     /* 344663 */ GIM_Reject,
     /* 344664 */ // Label 6889: @344664
     /* 344664 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(344697), // Rule ID 1400 //
     /* 344669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344690 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 344690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 344695 */   GIR_RootConstrainSelectedInstOperands,
     /* 344696 */   // GIR_Coverage, 1400,
     /* 344696 */   GIR_Done,
     /* 344697 */ // Label 6902: @344697
     /* 344697 */ GIM_Reject,
     /* 344698 */ // Label 6890: @344698
     /* 344698 */ GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(344731), // Rule ID 1403 //
     /* 344703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344724 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 344724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 344729 */   GIR_RootConstrainSelectedInstOperands,
     /* 344730 */   // GIR_Coverage, 1403,
     /* 344730 */   GIR_Done,
     /* 344731 */ // Label 6903: @344731
     /* 344731 */ GIM_Reject,
     /* 344732 */ // Label 6891: @344732
     /* 344732 */ GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(344765), // Rule ID 1398 //
     /* 344737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 344743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 344746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344758 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 344758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 344763 */   GIR_RootConstrainSelectedInstOperands,
     /* 344764 */   // GIR_Coverage, 1398,
     /* 344764 */   GIR_Done,
     /* 344765 */ // Label 6904: @344765
     /* 344765 */ GIM_Reject,
     /* 344766 */ // Label 6892: @344766
     /* 344766 */ GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(344799), // Rule ID 1401 //
     /* 344771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344792 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 344792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 344797 */   GIR_RootConstrainSelectedInstOperands,
     /* 344798 */   // GIR_Coverage, 1401,
     /* 344798 */   GIR_Done,
     /* 344799 */ // Label 6905: @344799
     /* 344799 */ GIM_Reject,
     /* 344800 */ // Label 6893: @344800
     /* 344800 */ GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(344833), // Rule ID 1399 //
     /* 344805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 344811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 344814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344826 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 344826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 344831 */   GIR_RootConstrainSelectedInstOperands,
     /* 344832 */   // GIR_Coverage, 1399,
     /* 344832 */   GIR_Done,
     /* 344833 */ // Label 6906: @344833
     /* 344833 */ GIM_Reject,
     /* 344834 */ // Label 6894: @344834
     /* 344834 */ GIM_Reject,
     /* 344835 */ // Label 83: @344835
     /* 344835 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6915*/ GIMT_Encode4(345238),
     /* 344846 */ /*GILLT_s32*//*Label 6907*/ GIMT_Encode4(344886),
     /* 344850 */ /*GILLT_s64*//*Label 6908*/ GIMT_Encode4(344960), GIMT_Encode4(0),
     /* 344858 */ /*GILLT_v2s32*//*Label 6909*/ GIMT_Encode4(345034), GIMT_Encode4(0),
     /* 344866 */ /*GILLT_v4s16*//*Label 6910*/ GIMT_Encode4(345068),
     /* 344870 */ /*GILLT_v4s32*//*Label 6911*/ GIMT_Encode4(345102),
     /* 344874 */ /*GILLT_v8s8*//*Label 6912*/ GIMT_Encode4(345136),
     /* 344878 */ /*GILLT_v8s16*//*Label 6913*/ GIMT_Encode4(345170),
     /* 344882 */ /*GILLT_v16s8*//*Label 6914*/ GIMT_Encode4(345204),
     /* 344886 */ // Label 6907: @344886
     /* 344886 */ GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(344959),
     /* 344891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344905 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(344939), // Rule ID 2336 //
     /* 344910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 344925 */     // MIs[1] Operand 1
     /* 344925 */     // No operand predicates
     /* 344925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344927 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 344927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 344930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344937 */     GIR_RootConstrainSelectedInstOperands,
     /* 344938 */     // GIR_Coverage, 2336,
     /* 344938 */     GIR_EraseRootFromParent_Done,
     /* 344939 */   // Label 6917: @344939
     /* 344939 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(344958), // Rule ID 2335 //
     /* 344944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344951 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 344951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 344956 */     GIR_RootConstrainSelectedInstOperands,
     /* 344957 */     // GIR_Coverage, 2335,
     /* 344957 */     GIR_Done,
     /* 344958 */   // Label 6918: @344958
     /* 344958 */   GIM_Reject,
     /* 344959 */ // Label 6916: @344959
     /* 344959 */ GIM_Reject,
     /* 344960 */ // Label 6908: @344960
     /* 344960 */ GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(345033),
     /* 344965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344979 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(345013), // Rule ID 2338 //
     /* 344984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 344999 */     // MIs[1] Operand 1
     /* 344999 */     // No operand predicates
     /* 344999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345001 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 345004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345011 */     GIR_RootConstrainSelectedInstOperands,
     /* 345012 */     // GIR_Coverage, 2338,
     /* 345012 */     GIR_EraseRootFromParent_Done,
     /* 345013 */   // Label 6920: @345013
     /* 345013 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(345032), // Rule ID 2337 //
     /* 345018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345025 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 345030 */     GIR_RootConstrainSelectedInstOperands,
     /* 345031 */     // GIR_Coverage, 2337,
     /* 345031 */     GIR_Done,
     /* 345032 */   // Label 6921: @345032
     /* 345032 */   GIM_Reject,
     /* 345033 */ // Label 6919: @345033
     /* 345033 */ GIM_Reject,
     /* 345034 */ // Label 6909: @345034
     /* 345034 */ GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(345067), // Rule ID 1537 //
     /* 345039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345060 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 345065 */   GIR_RootConstrainSelectedInstOperands,
     /* 345066 */   // GIR_Coverage, 1537,
     /* 345066 */   GIR_Done,
     /* 345067 */ // Label 6922: @345067
     /* 345067 */ GIM_Reject,
     /* 345068 */ // Label 6910: @345068
     /* 345068 */ GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(345101), // Rule ID 1535 //
     /* 345073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345094 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 345094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 345099 */   GIR_RootConstrainSelectedInstOperands,
     /* 345100 */   // GIR_Coverage, 1535,
     /* 345100 */   GIR_Done,
     /* 345101 */ // Label 6923: @345101
     /* 345101 */ GIM_Reject,
     /* 345102 */ // Label 6911: @345102
     /* 345102 */ GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(345135), // Rule ID 1538 //
     /* 345107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345128 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 345128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 345133 */   GIR_RootConstrainSelectedInstOperands,
     /* 345134 */   // GIR_Coverage, 1538,
     /* 345134 */   GIR_Done,
     /* 345135 */ // Label 6924: @345135
     /* 345135 */ GIM_Reject,
     /* 345136 */ // Label 6912: @345136
     /* 345136 */ GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(345169), // Rule ID 1533 //
     /* 345141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 345147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 345150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345162 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 345162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 345167 */   GIR_RootConstrainSelectedInstOperands,
     /* 345168 */   // GIR_Coverage, 1533,
     /* 345168 */   GIR_Done,
     /* 345169 */ // Label 6925: @345169
     /* 345169 */ GIM_Reject,
     /* 345170 */ // Label 6913: @345170
     /* 345170 */ GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(345203), // Rule ID 1536 //
     /* 345175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345196 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 345196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 345201 */   GIR_RootConstrainSelectedInstOperands,
     /* 345202 */   // GIR_Coverage, 1536,
     /* 345202 */   GIR_Done,
     /* 345203 */ // Label 6926: @345203
     /* 345203 */ GIM_Reject,
     /* 345204 */ // Label 6914: @345204
     /* 345204 */ GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(345237), // Rule ID 1534 //
     /* 345209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 345215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 345218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345230 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 345230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 345235 */   GIR_RootConstrainSelectedInstOperands,
     /* 345236 */   // GIR_Coverage, 1534,
     /* 345236 */   GIR_Done,
     /* 345237 */ // Label 6927: @345237
     /* 345237 */ GIM_Reject,
     /* 345238 */ // Label 6915: @345238
     /* 345238 */ GIM_Reject,
     /* 345239 */ // Label 84: @345239
     /* 345239 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6936*/ GIMT_Encode4(345642),
     /* 345250 */ /*GILLT_s32*//*Label 6928*/ GIMT_Encode4(345290),
     /* 345254 */ /*GILLT_s64*//*Label 6929*/ GIMT_Encode4(345364), GIMT_Encode4(0),
     /* 345262 */ /*GILLT_v2s32*//*Label 6930*/ GIMT_Encode4(345438), GIMT_Encode4(0),
     /* 345270 */ /*GILLT_v4s16*//*Label 6931*/ GIMT_Encode4(345472),
     /* 345274 */ /*GILLT_v4s32*//*Label 6932*/ GIMT_Encode4(345506),
     /* 345278 */ /*GILLT_v8s8*//*Label 6933*/ GIMT_Encode4(345540),
     /* 345282 */ /*GILLT_v8s16*//*Label 6934*/ GIMT_Encode4(345574),
     /* 345286 */ /*GILLT_v16s8*//*Label 6935*/ GIMT_Encode4(345608),
     /* 345290 */ // Label 6928: @345290
     /* 345290 */ GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(345363),
     /* 345295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345309 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(345343), // Rule ID 2332 //
     /* 345314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 345329 */     // MIs[1] Operand 1
     /* 345329 */     // No operand predicates
     /* 345329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345331 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 345331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 345334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345341 */     GIR_RootConstrainSelectedInstOperands,
     /* 345342 */     // GIR_Coverage, 2332,
     /* 345342 */     GIR_EraseRootFromParent_Done,
     /* 345343 */   // Label 6938: @345343
     /* 345343 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(345362), // Rule ID 2331 //
     /* 345348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345355 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 345355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 345360 */     GIR_RootConstrainSelectedInstOperands,
     /* 345361 */     // GIR_Coverage, 2331,
     /* 345361 */     GIR_Done,
     /* 345362 */   // Label 6939: @345362
     /* 345362 */   GIM_Reject,
     /* 345363 */ // Label 6937: @345363
     /* 345363 */ GIM_Reject,
     /* 345364 */ // Label 6929: @345364
     /* 345364 */ GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(345437),
     /* 345369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345383 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(345417), // Rule ID 2334 //
     /* 345388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 345403 */     // MIs[1] Operand 1
     /* 345403 */     // No operand predicates
     /* 345403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345405 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 345408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345415 */     GIR_RootConstrainSelectedInstOperands,
     /* 345416 */     // GIR_Coverage, 2334,
     /* 345416 */     GIR_EraseRootFromParent_Done,
     /* 345417 */   // Label 6941: @345417
     /* 345417 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(345436), // Rule ID 2333 //
     /* 345422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345429 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 345434 */     GIR_RootConstrainSelectedInstOperands,
     /* 345435 */     // GIR_Coverage, 2333,
     /* 345435 */     GIR_Done,
     /* 345436 */   // Label 6942: @345436
     /* 345436 */   GIM_Reject,
     /* 345437 */ // Label 6940: @345437
     /* 345437 */ GIM_Reject,
     /* 345438 */ // Label 6930: @345438
     /* 345438 */ GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(345471), // Rule ID 1525 //
     /* 345443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345464 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 345469 */   GIR_RootConstrainSelectedInstOperands,
     /* 345470 */   // GIR_Coverage, 1525,
     /* 345470 */   GIR_Done,
     /* 345471 */ // Label 6943: @345471
     /* 345471 */ GIM_Reject,
     /* 345472 */ // Label 6931: @345472
     /* 345472 */ GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(345505), // Rule ID 1523 //
     /* 345477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345498 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 345498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 345503 */   GIR_RootConstrainSelectedInstOperands,
     /* 345504 */   // GIR_Coverage, 1523,
     /* 345504 */   GIR_Done,
     /* 345505 */ // Label 6944: @345505
     /* 345505 */ GIM_Reject,
     /* 345506 */ // Label 6932: @345506
     /* 345506 */ GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(345539), // Rule ID 1526 //
     /* 345511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345532 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 345532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 345537 */   GIR_RootConstrainSelectedInstOperands,
     /* 345538 */   // GIR_Coverage, 1526,
     /* 345538 */   GIR_Done,
     /* 345539 */ // Label 6945: @345539
     /* 345539 */ GIM_Reject,
     /* 345540 */ // Label 6933: @345540
     /* 345540 */ GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(345573), // Rule ID 1521 //
     /* 345545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 345551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 345554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345566 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 345566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 345571 */   GIR_RootConstrainSelectedInstOperands,
     /* 345572 */   // GIR_Coverage, 1521,
     /* 345572 */   GIR_Done,
     /* 345573 */ // Label 6946: @345573
     /* 345573 */ GIM_Reject,
     /* 345574 */ // Label 6934: @345574
     /* 345574 */ GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(345607), // Rule ID 1524 //
     /* 345579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345600 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 345600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 345605 */   GIR_RootConstrainSelectedInstOperands,
     /* 345606 */   // GIR_Coverage, 1524,
     /* 345606 */   GIR_Done,
     /* 345607 */ // Label 6947: @345607
     /* 345607 */ GIM_Reject,
     /* 345608 */ // Label 6935: @345608
     /* 345608 */ GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(345641), // Rule ID 1522 //
     /* 345613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 345619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 345622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345634 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 345634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 345639 */   GIR_RootConstrainSelectedInstOperands,
     /* 345640 */   // GIR_Coverage, 1522,
     /* 345640 */   GIR_Done,
     /* 345641 */ // Label 6948: @345641
     /* 345641 */ GIM_Reject,
     /* 345642 */ // Label 6936: @345642
     /* 345642 */ GIM_Reject,
     /* 345643 */ // Label 85: @345643
     /* 345643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6958*/ GIMT_Encode4(346457),
     /* 345654 */ /*GILLT_s32*//*Label 6949*/ GIMT_Encode4(345694),
     /* 345658 */ /*GILLT_s64*//*Label 6950*/ GIMT_Encode4(345721), GIMT_Encode4(0),
     /* 345666 */ /*GILLT_v2s32*//*Label 6951*/ GIMT_Encode4(345800),
     /* 345670 */ /*GILLT_v2s64*//*Label 6952*/ GIMT_Encode4(345827),
     /* 345674 */ /*GILLT_v4s16*//*Label 6953*/ GIMT_Encode4(346010),
     /* 345678 */ /*GILLT_v4s32*//*Label 6954*/ GIMT_Encode4(346037),
     /* 345682 */ /*GILLT_v8s8*//*Label 6955*/ GIMT_Encode4(346220),
     /* 345686 */ /*GILLT_v8s16*//*Label 6956*/ GIMT_Encode4(346247),
     /* 345690 */ /*GILLT_v16s8*//*Label 6957*/ GIMT_Encode4(346430),
     /* 345694 */ // Label 6949: @345694
     /* 345694 */ GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(345720), // Rule ID 2317 //
     /* 345699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345713 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 345713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 345718 */   GIR_RootConstrainSelectedInstOperands,
     /* 345719 */   // GIR_Coverage, 2317,
     /* 345719 */   GIR_Done,
     /* 345720 */ // Label 6959: @345720
     /* 345720 */ GIM_Reject,
     /* 345721 */ // Label 6950: @345721
     /* 345721 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(345799),
     /* 345726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345729 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(345752), // Rule ID 1652 //
     /* 345734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345745 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 345745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 345750 */     GIR_RootConstrainSelectedInstOperands,
     /* 345751 */     // GIR_Coverage, 1652,
     /* 345751 */     GIR_Done,
     /* 345752 */   // Label 6961: @345752
     /* 345752 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(345775), // Rule ID 2318 //
     /* 345757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345768 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 345768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 345773 */     GIR_RootConstrainSelectedInstOperands,
     /* 345774 */     // GIR_Coverage, 2318,
     /* 345774 */     GIR_Done,
     /* 345775 */   // Label 6962: @345775
     /* 345775 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(345798), // Rule ID 2507 //
     /* 345780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 345783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345791 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 345791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 345796 */     GIR_RootConstrainSelectedInstOperands,
     /* 345797 */     // GIR_Coverage, 2507,
     /* 345797 */     GIR_Done,
     /* 345798 */   // Label 6963: @345798
     /* 345798 */   GIM_Reject,
     /* 345799 */ // Label 6960: @345799
     /* 345799 */ GIM_Reject,
     /* 345800 */ // Label 6951: @345800
     /* 345800 */ GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(345826), // Rule ID 707 //
     /* 345805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345819 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 345819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 345824 */   GIR_RootConstrainSelectedInstOperands,
     /* 345825 */   // GIR_Coverage, 707,
     /* 345825 */   GIR_Done,
     /* 345826 */ // Label 6964: @345826
     /* 345826 */ GIM_Reject,
     /* 345827 */ // Label 6952: @345827
     /* 345827 */ GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(346009),
     /* 345832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345839 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(345917), // Rule ID 4922 //
     /* 345844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 345852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 345860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 345864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 345868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 345876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 345880 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 345893 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 345900 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 345900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 345903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 345910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 345915 */     GIR_RootConstrainSelectedInstOperands,
     /* 345916 */     // GIR_Coverage, 4922,
     /* 345916 */     GIR_EraseRootFromParent_Done,
     /* 345917 */   // Label 6966: @345917
     /* 345917 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(345989), // Rule ID 4921 //
     /* 345922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 345930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 345938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 345942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 345946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 345959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 345963 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345967 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345974 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 345974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 345977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 345983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 345987 */     GIR_RootConstrainSelectedInstOperands,
     /* 345988 */     // GIR_Coverage, 4921,
     /* 345988 */     GIR_EraseRootFromParent_Done,
     /* 345989 */   // Label 6967: @345989
     /* 345989 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(346008), // Rule ID 709 //
     /* 345994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346001 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 346001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 346006 */     GIR_RootConstrainSelectedInstOperands,
     /* 346007 */     // GIR_Coverage, 709,
     /* 346007 */     GIR_Done,
     /* 346008 */   // Label 6968: @346008
     /* 346008 */   GIM_Reject,
     /* 346009 */ // Label 6965: @346009
     /* 346009 */ GIM_Reject,
     /* 346010 */ // Label 6953: @346010
     /* 346010 */ GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(346036), // Rule ID 705 //
     /* 346015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346029 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 346029 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 346034 */   GIR_RootConstrainSelectedInstOperands,
     /* 346035 */   // GIR_Coverage, 705,
     /* 346035 */   GIR_Done,
     /* 346036 */ // Label 6969: @346036
     /* 346036 */ GIM_Reject,
     /* 346037 */ // Label 6954: @346037
     /* 346037 */ GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(346219),
     /* 346042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346049 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(346127), // Rule ID 4920 //
     /* 346054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346090 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 346103 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 346110 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 346110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 346113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 346120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 346125 */     GIR_RootConstrainSelectedInstOperands,
     /* 346126 */     // GIR_Coverage, 4920,
     /* 346126 */     GIR_EraseRootFromParent_Done,
     /* 346127 */   // Label 6971: @346127
     /* 346127 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(346199), // Rule ID 4919 //
     /* 346132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346173 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346177 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346184 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 346184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 346187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 346193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 346197 */     GIR_RootConstrainSelectedInstOperands,
     /* 346198 */     // GIR_Coverage, 4919,
     /* 346198 */     GIR_EraseRootFromParent_Done,
     /* 346199 */   // Label 6972: @346199
     /* 346199 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(346218), // Rule ID 708 //
     /* 346204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346211 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 346211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 346216 */     GIR_RootConstrainSelectedInstOperands,
     /* 346217 */     // GIR_Coverage, 708,
     /* 346217 */     GIR_Done,
     /* 346218 */   // Label 6973: @346218
     /* 346218 */   GIM_Reject,
     /* 346219 */ // Label 6970: @346219
     /* 346219 */ GIM_Reject,
     /* 346220 */ // Label 6955: @346220
     /* 346220 */ GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(346246), // Rule ID 703 //
     /* 346225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346239 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 346239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 346244 */   GIR_RootConstrainSelectedInstOperands,
     /* 346245 */   // GIR_Coverage, 703,
     /* 346245 */   GIR_Done,
     /* 346246 */ // Label 6974: @346246
     /* 346246 */ GIM_Reject,
     /* 346247 */ // Label 6956: @346247
     /* 346247 */ GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(346429),
     /* 346252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346259 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(346337), // Rule ID 4918 //
     /* 346264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 346313 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 346320 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 346320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 346323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 346330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 346335 */     GIR_RootConstrainSelectedInstOperands,
     /* 346336 */     // GIR_Coverage, 4918,
     /* 346336 */     GIR_EraseRootFromParent_Done,
     /* 346337 */   // Label 6976: @346337
     /* 346337 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(346409), // Rule ID 4917 //
     /* 346342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346383 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346387 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346394 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 346394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 346397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 346403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 346407 */     GIR_RootConstrainSelectedInstOperands,
     /* 346408 */     // GIR_Coverage, 4917,
     /* 346408 */     GIR_EraseRootFromParent_Done,
     /* 346409 */   // Label 6977: @346409
     /* 346409 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(346428), // Rule ID 706 //
     /* 346414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346421 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 346421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 346426 */     GIR_RootConstrainSelectedInstOperands,
     /* 346427 */     // GIR_Coverage, 706,
     /* 346427 */     GIR_Done,
     /* 346428 */   // Label 6978: @346428
     /* 346428 */   GIM_Reject,
     /* 346429 */ // Label 6975: @346429
     /* 346429 */ GIM_Reject,
     /* 346430 */ // Label 6957: @346430
     /* 346430 */ GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(346456), // Rule ID 704 //
     /* 346435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346449 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 346449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 346454 */   GIR_RootConstrainSelectedInstOperands,
     /* 346455 */   // GIR_Coverage, 704,
     /* 346455 */   GIR_Done,
     /* 346456 */ // Label 6979: @346456
     /* 346456 */ GIM_Reject,
     /* 346457 */ // Label 6958: @346457
     /* 346457 */ GIM_Reject,
     /* 346458 */ // Label 86: @346458
     /* 346458 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6982*/ GIMT_Encode4(346623),
     /* 346469 */ /*GILLT_s32*//*Label 6980*/ GIMT_Encode4(346477),
     /* 346473 */ /*GILLT_s64*//*Label 6981*/ GIMT_Encode4(346550),
     /* 346477 */ // Label 6980: @346477
     /* 346477 */ GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(346503), // Rule ID 4763 //
     /* 346482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 346485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 346488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346492 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 346492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 346497 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346501 */   GIR_RootConstrainSelectedInstOperands,
     /* 346502 */   // GIR_Coverage, 4763,
     /* 346502 */   GIR_Done,
     /* 346503 */ // Label 6983: @346503
     /* 346503 */ GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(346526), // Rule ID 4769 //
     /* 346508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346515 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 346515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 346520 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346524 */   GIR_RootConstrainSelectedInstOperands,
     /* 346525 */   // GIR_Coverage, 4769,
     /* 346525 */   GIR_Done,
     /* 346526 */ // Label 6984: @346526
     /* 346526 */ GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(346549), // Rule ID 4771 //
     /* 346531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346538 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 346538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 346543 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346547 */   GIR_RootConstrainSelectedInstOperands,
     /* 346548 */   // GIR_Coverage, 4771,
     /* 346548 */   GIR_Done,
     /* 346549 */ // Label 6985: @346549
     /* 346549 */ GIM_Reject,
     /* 346550 */ // Label 6981: @346550
     /* 346550 */ GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(346576), // Rule ID 4765 //
     /* 346555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 346558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 346561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346565 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 346565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 346570 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346574 */   GIR_RootConstrainSelectedInstOperands,
     /* 346575 */   // GIR_Coverage, 4765,
     /* 346575 */   GIR_Done,
     /* 346576 */ // Label 6986: @346576
     /* 346576 */ GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(346599), // Rule ID 4773 //
     /* 346581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346588 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 346588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 346593 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346597 */   GIR_RootConstrainSelectedInstOperands,
     /* 346598 */   // GIR_Coverage, 4773,
     /* 346598 */   GIR_Done,
     /* 346599 */ // Label 6987: @346599
     /* 346599 */ GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(346622), // Rule ID 4775 //
     /* 346604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346611 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 346611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 346616 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346620 */   GIR_RootConstrainSelectedInstOperands,
     /* 346621 */   // GIR_Coverage, 4775,
     /* 346621 */   GIR_Done,
     /* 346622 */ // Label 6988: @346622
     /* 346622 */ GIM_Reject,
     /* 346623 */ // Label 6982: @346623
     /* 346623 */ GIM_Reject,
     /* 346624 */ // Label 87: @346624
     /* 346624 */ GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(346722),
     /* 346629 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 346632 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6993*/ GIMT_Encode4(346721),
     /* 346643 */   /*GILLT_s16*//*Label 6990*/ GIMT_Encode4(346655),
     /* 346647 */   /*GILLT_s32*//*Label 6991*/ GIMT_Encode4(346679),
     /* 346651 */   /*GILLT_s64*//*Label 6992*/ GIMT_Encode4(346700),
     /* 346655 */   // Label 6990: @346655
     /* 346655 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(346678), // Rule ID 4767 //
     /* 346660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 346663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346667 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 346667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 346672 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346676 */     GIR_RootConstrainSelectedInstOperands,
     /* 346677 */     // GIR_Coverage, 4767,
     /* 346677 */     GIR_Done,
     /* 346678 */   // Label 6994: @346678
     /* 346678 */   GIM_Reject,
     /* 346679 */   // Label 6991: @346679
     /* 346679 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(346699), // Rule ID 4777 //
     /* 346684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346688 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 346688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 346693 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346697 */     GIR_RootConstrainSelectedInstOperands,
     /* 346698 */     // GIR_Coverage, 4777,
     /* 346698 */     GIR_Done,
     /* 346699 */   // Label 6995: @346699
     /* 346699 */   GIM_Reject,
     /* 346700 */   // Label 6992: @346700
     /* 346700 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(346720), // Rule ID 4779 //
     /* 346705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346709 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 346709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 346714 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346718 */     GIR_RootConstrainSelectedInstOperands,
     /* 346719 */     // GIR_Coverage, 4779,
     /* 346719 */     GIR_Done,
     /* 346720 */   // Label 6996: @346720
     /* 346720 */   GIM_Reject,
     /* 346721 */   // Label 6993: @346721
     /* 346721 */   GIM_Reject,
     /* 346722 */ // Label 6989: @346722
     /* 346722 */ GIM_Reject,
     /* 346723 */ // Label 88: @346723
     /* 346723 */ GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(346738), // Rule ID 225 //
     /* 346728 */   // MIs[0] addr
     /* 346728 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 346731 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 346731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 346736 */   GIR_RootConstrainSelectedInstOperands,
     /* 346737 */   // GIR_Coverage, 225,
     /* 346737 */   GIR_Done,
     /* 346738 */ // Label 6997: @346738
     /* 346738 */ GIM_Reject,
     /* 346739 */ // Label 89: @346739
     /* 346739 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 7009*/ GIMT_Encode4(352110),
     /* 346750 */ /*GILLT_s64*//*Label 6998*/ GIMT_Encode4(346822), GIMT_Encode4(0),
     /* 346758 */ /*GILLT_v2s32*//*Label 6999*/ GIMT_Encode4(347224), GIMT_Encode4(0),
     /* 346766 */ /*GILLT_v4s16*//*Label 7000*/ GIMT_Encode4(347626), GIMT_Encode4(0),
     /* 346774 */ /*GILLT_v8s8*//*Label 7001*/ GIMT_Encode4(348028), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 346786 */ /*GILLT_nxv1s1*//*Label 7002*/ GIMT_Encode4(348208),
     /* 346790 */ /*GILLT_nxv2s1*//*Label 7003*/ GIMT_Encode4(350471),
     /* 346794 */ /*GILLT_nxv2s16*//*Label 7004*/ GIMT_Encode4(351326),
     /* 346798 */ /*GILLT_nxv2s32*//*Label 7005*/ GIMT_Encode4(351613), GIMT_Encode4(0),
     /* 346806 */ /*GILLT_nxv4s1*//*Label 7006*/ GIMT_Encode4(351683),
     /* 346810 */ /*GILLT_nxv4s16*//*Label 7007*/ GIMT_Encode4(351970), GIMT_Encode4(0),
     /* 346818 */ /*GILLT_nxv8s1*//*Label 7008*/ GIMT_Encode4(352040),
     /* 346822 */ // Label 6998: @346822
     /* 346822 */ GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(347223),
     /* 346827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346834 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(346886), // Rule ID 5592 //
     /* 346839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 346847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346851 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 346853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346858 */     // MIs[0] Operand 2
     /* 346858 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 346869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346871 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 346871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 346874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 346880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 346884 */     GIR_RootConstrainSelectedInstOperands,
     /* 346885 */     // GIR_Coverage, 5592,
     /* 346885 */     GIR_EraseRootFromParent_Done,
     /* 346886 */   // Label 7011: @346886
     /* 346886 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(346938), // Rule ID 5595 //
     /* 346891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 346899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346903 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 346905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346910 */     // MIs[0] Operand 2
     /* 346910 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 346921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346923 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 346923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 346926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 346932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 346936 */     GIR_RootConstrainSelectedInstOperands,
     /* 346937 */     // GIR_Coverage, 5595,
     /* 346937 */     GIR_EraseRootFromParent_Done,
     /* 346938 */   // Label 7012: @346938
     /* 346938 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(347006), // Rule ID 5471 //
     /* 346943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346947 */     // MIs[0] Operand 2
     /* 346947 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 346958 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 346958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 346965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 346974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 346978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 346981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346988 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347005 */     // GIR_Coverage, 5471,
     /* 347005 */     GIR_EraseRootFromParent_Done,
     /* 347006 */   // Label 7013: @347006
     /* 347006 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(347074), // Rule ID 5476 //
     /* 347011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347015 */     // MIs[0] Operand 2
     /* 347015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347026 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347046 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347056 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347073 */     // GIR_Coverage, 5476,
     /* 347073 */     GIR_EraseRootFromParent_Done,
     /* 347074 */   // Label 7014: @347074
     /* 347074 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(347116), // Rule ID 6925 //
     /* 347079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347083 */     // MIs[0] Operand 2
     /* 347083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347094 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 347094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347099 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347115 */     // GIR_Coverage, 6925,
     /* 347115 */     GIR_EraseRootFromParent_Done,
     /* 347116 */   // Label 7015: @347116
     /* 347116 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(347158), // Rule ID 6926 //
     /* 347121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347125 */     // MIs[0] Operand 2
     /* 347125 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347136 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 347136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347141 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347157 */     // GIR_Coverage, 6926,
     /* 347157 */     GIR_EraseRootFromParent_Done,
     /* 347158 */   // Label 7016: @347158
     /* 347158 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(347222), // Rule ID 6930 //
     /* 347163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347167 */     // MIs[0] Operand 2
     /* 347167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347178 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 347178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 347185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347194 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 347197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347204 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347221 */     // GIR_Coverage, 6930,
     /* 347221 */     GIR_EraseRootFromParent_Done,
     /* 347222 */   // Label 7017: @347222
     /* 347222 */   GIM_Reject,
     /* 347223 */ // Label 7010: @347223
     /* 347223 */ GIM_Reject,
     /* 347224 */ // Label 6999: @347224
     /* 347224 */ GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(347625),
     /* 347229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347236 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(347288), // Rule ID 5591 //
     /* 347241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347253 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347260 */     // MIs[0] Operand 2
     /* 347260 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347273 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 347273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 347276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347286 */     GIR_RootConstrainSelectedInstOperands,
     /* 347287 */     // GIR_Coverage, 5591,
     /* 347287 */     GIR_EraseRootFromParent_Done,
     /* 347288 */   // Label 7019: @347288
     /* 347288 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(347340), // Rule ID 5594 //
     /* 347293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347305 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347312 */     // MIs[0] Operand 2
     /* 347312 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 347323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347325 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 347325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 347328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347338 */     GIR_RootConstrainSelectedInstOperands,
     /* 347339 */     // GIR_Coverage, 5594,
     /* 347339 */     GIR_EraseRootFromParent_Done,
     /* 347340 */   // Label 7020: @347340
     /* 347340 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(347408), // Rule ID 5461 //
     /* 347345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347349 */     // MIs[0] Operand 2
     /* 347349 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 347360 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347390 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347407 */     // GIR_Coverage, 5461,
     /* 347407 */     GIR_EraseRootFromParent_Done,
     /* 347408 */   // Label 7021: @347408
     /* 347408 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(347476), // Rule ID 5466 //
     /* 347413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347417 */     // MIs[0] Operand 2
     /* 347417 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 347428 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347448 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347458 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347475 */     // GIR_Coverage, 5466,
     /* 347475 */     GIR_EraseRootFromParent_Done,
     /* 347476 */   // Label 7022: @347476
     /* 347476 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(347518), // Rule ID 6922 //
     /* 347481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347485 */     // MIs[0] Operand 2
     /* 347485 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347496 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 347496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347501 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347517 */     // GIR_Coverage, 6922,
     /* 347517 */     GIR_EraseRootFromParent_Done,
     /* 347518 */   // Label 7023: @347518
     /* 347518 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(347560), // Rule ID 6924 //
     /* 347523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347527 */     // MIs[0] Operand 2
     /* 347527 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347538 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 347538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347543 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347559 */     // GIR_Coverage, 6924,
     /* 347559 */     GIR_EraseRootFromParent_Done,
     /* 347560 */   // Label 7024: @347560
     /* 347560 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(347624), // Rule ID 6929 //
     /* 347565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347569 */     // MIs[0] Operand 2
     /* 347569 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347580 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 347580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 347587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 347599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347606 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347623 */     // GIR_Coverage, 6929,
     /* 347623 */     GIR_EraseRootFromParent_Done,
     /* 347624 */   // Label 7025: @347624
     /* 347624 */   GIM_Reject,
     /* 347625 */ // Label 7018: @347625
     /* 347625 */ GIM_Reject,
     /* 347626 */ // Label 7000: @347626
     /* 347626 */ GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(348027),
     /* 347631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347638 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(347690), // Rule ID 5590 //
     /* 347643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347655 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347662 */     // MIs[0] Operand 2
     /* 347662 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347675 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 347675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 347678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347688 */     GIR_RootConstrainSelectedInstOperands,
     /* 347689 */     // GIR_Coverage, 5590,
     /* 347689 */     GIR_EraseRootFromParent_Done,
     /* 347690 */   // Label 7027: @347690
     /* 347690 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(347742), // Rule ID 5593 //
     /* 347695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347707 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347714 */     // MIs[0] Operand 2
     /* 347714 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 347725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347727 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 347727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 347730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347740 */     GIR_RootConstrainSelectedInstOperands,
     /* 347741 */     // GIR_Coverage, 5593,
     /* 347741 */     GIR_EraseRootFromParent_Done,
     /* 347742 */   // Label 7028: @347742
     /* 347742 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(347810), // Rule ID 5451 //
     /* 347747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347751 */     // MIs[0] Operand 2
     /* 347751 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 347762 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347792 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347809 */     // GIR_Coverage, 5451,
     /* 347809 */     GIR_EraseRootFromParent_Done,
     /* 347810 */   // Label 7029: @347810
     /* 347810 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(347878), // Rule ID 5456 //
     /* 347815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347819 */     // MIs[0] Operand 2
     /* 347819 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 347830 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347850 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347877 */     // GIR_Coverage, 5456,
     /* 347877 */     GIR_EraseRootFromParent_Done,
     /* 347878 */   // Label 7030: @347878
     /* 347878 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(347920), // Rule ID 6920 //
     /* 347883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347887 */     // MIs[0] Operand 2
     /* 347887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347898 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 347898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347903 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347919 */     // GIR_Coverage, 6920,
     /* 347919 */     GIR_EraseRootFromParent_Done,
     /* 347920 */   // Label 7031: @347920
     /* 347920 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(347962), // Rule ID 6923 //
     /* 347925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347929 */     // MIs[0] Operand 2
     /* 347929 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347940 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 347940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347945 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347961 */     // GIR_Coverage, 6923,
     /* 347961 */     GIR_EraseRootFromParent_Done,
     /* 347962 */   // Label 7032: @347962
     /* 347962 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(348026), // Rule ID 6928 //
     /* 347967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347971 */     // MIs[0] Operand 2
     /* 347971 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347982 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 347982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 347989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348008 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348025 */     // GIR_Coverage, 6928,
     /* 348025 */     GIR_EraseRootFromParent_Done,
     /* 348026 */   // Label 7033: @348026
     /* 348026 */   GIM_Reject,
     /* 348027 */ // Label 7026: @348027
     /* 348027 */ GIM_Reject,
     /* 348028 */ // Label 7001: @348028
     /* 348028 */ GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(348207),
     /* 348033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348044 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(348108), // Rule ID 5446 //
     /* 348049 */     // MIs[0] Operand 2
     /* 348049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 348060 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348090 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348107 */     // GIR_Coverage, 5446,
     /* 348107 */     GIR_EraseRootFromParent_Done,
     /* 348108 */   // Label 7035: @348108
     /* 348108 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(348146), // Rule ID 6921 //
     /* 348113 */     // MIs[0] Operand 2
     /* 348113 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348124 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 348124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348129 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348145 */     // GIR_Coverage, 6921,
     /* 348145 */     GIR_EraseRootFromParent_Done,
     /* 348146 */   // Label 7036: @348146
     /* 348146 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(348206), // Rule ID 6927 //
     /* 348151 */     // MIs[0] Operand 2
     /* 348151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348162 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348178 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348188 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348205 */     // GIR_Coverage, 6927,
     /* 348205 */     GIR_EraseRootFromParent_Done,
     /* 348206 */   // Label 7037: @348206
     /* 348206 */   GIM_Reject,
     /* 348207 */ // Label 7034: @348207
     /* 348207 */ GIM_Reject,
     /* 348208 */ // Label 7002: @348208
     /* 348208 */ GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(348243), // Rule ID 9019 //
     /* 348213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 348219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348223 */   // MIs[0] Operand 2
     /* 348223 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348234 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 348234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348239 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 348241 */   GIR_RootConstrainSelectedInstOperands,
     /* 348242 */   // GIR_Coverage, 9019,
     /* 348242 */   GIR_EraseRootFromParent_Done,
     /* 348243 */ // Label 7038: @348243
     /* 348243 */ GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(348278), // Rule ID 9020 //
     /* 348248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 348254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348258 */   // MIs[0] Operand 2
     /* 348258 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348269 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 348269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348274 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 348276 */   GIR_RootConstrainSelectedInstOperands,
     /* 348277 */   // GIR_Coverage, 9020,
     /* 348277 */   GIR_EraseRootFromParent_Done,
     /* 348278 */ // Label 7039: @348278
     /* 348278 */ GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(348332), // Rule ID 9027 //
     /* 348283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 348289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348293 */   // MIs[0] Operand 2
     /* 348293 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348304 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 348304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348316 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348330 */   GIR_RootConstrainSelectedInstOperands,
     /* 348331 */   // GIR_Coverage, 9027,
     /* 348331 */   GIR_EraseRootFromParent_Done,
     /* 348332 */ // Label 7040: @348332
     /* 348332 */ GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(348386), // Rule ID 9028 //
     /* 348337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 348343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348347 */   // MIs[0] Operand 2
     /* 348347 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348358 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 348358 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348361 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348365 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348370 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348384 */   GIR_RootConstrainSelectedInstOperands,
     /* 348385 */   // GIR_Coverage, 9028,
     /* 348385 */   GIR_EraseRootFromParent_Done,
     /* 348386 */ // Label 7041: @348386
     /* 348386 */ GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(348440), // Rule ID 9029 //
     /* 348391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 348397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348401 */   // MIs[0] Operand 2
     /* 348401 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348412 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 348412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348424 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348435 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348438 */   GIR_RootConstrainSelectedInstOperands,
     /* 348439 */   // GIR_Coverage, 9029,
     /* 348439 */   GIR_EraseRootFromParent_Done,
     /* 348440 */ // Label 7042: @348440
     /* 348440 */ GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(348494), // Rule ID 9030 //
     /* 348445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 348451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348455 */   // MIs[0] Operand 2
     /* 348455 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 348466 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 348466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348478 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348492 */   GIR_RootConstrainSelectedInstOperands,
     /* 348493 */   // GIR_Coverage, 9030,
     /* 348493 */   GIR_EraseRootFromParent_Done,
     /* 348494 */ // Label 7043: @348494
     /* 348494 */ GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(348565), // Rule ID 9039 //
     /* 348499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348509 */   // MIs[0] Operand 2
     /* 348509 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348520 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348520 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348523 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348527 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348532 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348550 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348563 */   GIR_RootConstrainSelectedInstOperands,
     /* 348564 */   // GIR_Coverage, 9039,
     /* 348564 */   GIR_EraseRootFromParent_Done,
     /* 348565 */ // Label 7044: @348565
     /* 348565 */ GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(348636), // Rule ID 9040 //
     /* 348570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348580 */   // MIs[0] Operand 2
     /* 348580 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348591 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348591 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348594 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348598 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348603 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348621 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348634 */   GIR_RootConstrainSelectedInstOperands,
     /* 348635 */   // GIR_Coverage, 9040,
     /* 348635 */   GIR_EraseRootFromParent_Done,
     /* 348636 */ // Label 7045: @348636
     /* 348636 */ GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(348707), // Rule ID 9041 //
     /* 348641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348651 */   // MIs[0] Operand 2
     /* 348651 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348662 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348662 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348665 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348669 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348674 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348692 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348705 */   GIR_RootConstrainSelectedInstOperands,
     /* 348706 */   // GIR_Coverage, 9041,
     /* 348706 */   GIR_EraseRootFromParent_Done,
     /* 348707 */ // Label 7046: @348707
     /* 348707 */ GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(348778), // Rule ID 9042 //
     /* 348712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348722 */   // MIs[0] Operand 2
     /* 348722 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 348733 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348733 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348736 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348740 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348745 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348763 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348776 */   GIR_RootConstrainSelectedInstOperands,
     /* 348777 */   // GIR_Coverage, 9042,
     /* 348777 */   GIR_EraseRootFromParent_Done,
     /* 348778 */ // Label 7047: @348778
     /* 348778 */ GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(348849), // Rule ID 9043 //
     /* 348783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348793 */   // MIs[0] Operand 2
     /* 348793 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 348804 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348804 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348807 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348811 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348816 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348834 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348847 */   GIR_RootConstrainSelectedInstOperands,
     /* 348848 */   // GIR_Coverage, 9043,
     /* 348848 */   GIR_EraseRootFromParent_Done,
     /* 348849 */ // Label 7048: @348849
     /* 348849 */ GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(348920), // Rule ID 9044 //
     /* 348854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348864 */   // MIs[0] Operand 2
     /* 348864 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 348875 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348875 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348878 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348882 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348887 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348905 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348915 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348918 */   GIR_RootConstrainSelectedInstOperands,
     /* 348919 */   // GIR_Coverage, 9044,
     /* 348919 */   GIR_EraseRootFromParent_Done,
     /* 348920 */ // Label 7049: @348920
     /* 348920 */ GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(348991), // Rule ID 9045 //
     /* 348925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348935 */   // MIs[0] Operand 2
     /* 348935 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 348946 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348946 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348949 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348953 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348958 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348976 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348989 */   GIR_RootConstrainSelectedInstOperands,
     /* 348990 */   // GIR_Coverage, 9045,
     /* 348990 */   GIR_EraseRootFromParent_Done,
     /* 348991 */ // Label 7050: @348991
     /* 348991 */ GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(349062), // Rule ID 9046 //
     /* 348996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349006 */   // MIs[0] Operand 2
     /* 349006 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 349017 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349017 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349020 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349024 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349029 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349047 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349057 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349060 */   GIR_RootConstrainSelectedInstOperands,
     /* 349061 */   // GIR_Coverage, 9046,
     /* 349061 */   GIR_EraseRootFromParent_Done,
     /* 349062 */ // Label 7051: @349062
     /* 349062 */ GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(349150), // Rule ID 9055 //
     /* 349067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349077 */   // MIs[0] Operand 2
     /* 349077 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349088 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349088 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349091 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349095 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349100 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349106 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349109 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349113 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349118 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349123 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349126 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349130 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349135 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349145 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349148 */   GIR_RootConstrainSelectedInstOperands,
     /* 349149 */   // GIR_Coverage, 9055,
     /* 349149 */   GIR_EraseRootFromParent_Done,
     /* 349150 */ // Label 7052: @349150
     /* 349150 */ GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(349238), // Rule ID 9056 //
     /* 349155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349165 */   // MIs[0] Operand 2
     /* 349165 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349176 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349176 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349179 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349183 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349188 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349194 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349197 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349201 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349206 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349223 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349236 */   GIR_RootConstrainSelectedInstOperands,
     /* 349237 */   // GIR_Coverage, 9056,
     /* 349237 */   GIR_EraseRootFromParent_Done,
     /* 349238 */ // Label 7053: @349238
     /* 349238 */ GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(349326), // Rule ID 9057 //
     /* 349243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349253 */   // MIs[0] Operand 2
     /* 349253 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349264 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349264 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349267 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349271 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349276 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349282 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349285 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349289 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349294 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349299 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349302 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349306 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349311 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349324 */   GIR_RootConstrainSelectedInstOperands,
     /* 349325 */   // GIR_Coverage, 9057,
     /* 349325 */   GIR_EraseRootFromParent_Done,
     /* 349326 */ // Label 7054: @349326
     /* 349326 */ GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(349414), // Rule ID 9058 //
     /* 349331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349341 */   // MIs[0] Operand 2
     /* 349341 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 349352 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349352 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349355 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349359 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349364 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349370 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349373 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349377 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349382 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349399 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349412 */   GIR_RootConstrainSelectedInstOperands,
     /* 349413 */   // GIR_Coverage, 9058,
     /* 349413 */   GIR_EraseRootFromParent_Done,
     /* 349414 */ // Label 7055: @349414
     /* 349414 */ GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(349502), // Rule ID 9059 //
     /* 349419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349429 */   // MIs[0] Operand 2
     /* 349429 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 349440 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349440 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349443 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349447 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349452 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349458 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349461 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349465 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349470 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349475 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349478 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349482 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349487 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349500 */   GIR_RootConstrainSelectedInstOperands,
     /* 349501 */   // GIR_Coverage, 9059,
     /* 349501 */   GIR_EraseRootFromParent_Done,
     /* 349502 */ // Label 7056: @349502
     /* 349502 */ GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(349590), // Rule ID 9060 //
     /* 349507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349517 */   // MIs[0] Operand 2
     /* 349517 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 349528 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349528 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349531 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349535 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349540 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349546 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349549 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349553 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349558 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349575 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349588 */   GIR_RootConstrainSelectedInstOperands,
     /* 349589 */   // GIR_Coverage, 9060,
     /* 349589 */   GIR_EraseRootFromParent_Done,
     /* 349590 */ // Label 7057: @349590
     /* 349590 */ GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(349678), // Rule ID 9061 //
     /* 349595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349605 */   // MIs[0] Operand 2
     /* 349605 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 349616 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349616 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349619 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349623 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349628 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349634 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349637 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349641 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349646 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349663 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349673 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349676 */   GIR_RootConstrainSelectedInstOperands,
     /* 349677 */   // GIR_Coverage, 9061,
     /* 349677 */   GIR_EraseRootFromParent_Done,
     /* 349678 */ // Label 7058: @349678
     /* 349678 */ GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(349766), // Rule ID 9062 //
     /* 349683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349693 */   // MIs[0] Operand 2
     /* 349693 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 349704 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349704 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349707 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349711 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349716 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349722 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349725 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349729 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349734 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349751 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349764 */   GIR_RootConstrainSelectedInstOperands,
     /* 349765 */   // GIR_Coverage, 9062,
     /* 349765 */   GIR_EraseRootFromParent_Done,
     /* 349766 */ // Label 7059: @349766
     /* 349766 */ GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(349854), // Rule ID 9063 //
     /* 349771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349781 */   // MIs[0] Operand 2
     /* 349781 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 349792 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349792 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349795 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349799 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349804 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349810 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349813 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349817 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349822 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349839 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349852 */   GIR_RootConstrainSelectedInstOperands,
     /* 349853 */   // GIR_Coverage, 9063,
     /* 349853 */   GIR_EraseRootFromParent_Done,
     /* 349854 */ // Label 7060: @349854
     /* 349854 */ GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(349942), // Rule ID 9064 //
     /* 349859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349869 */   // MIs[0] Operand 2
     /* 349869 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 349880 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349880 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349883 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349887 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349892 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349898 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349901 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349905 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349910 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349927 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349937 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349940 */   GIR_RootConstrainSelectedInstOperands,
     /* 349941 */   // GIR_Coverage, 9064,
     /* 349941 */   GIR_EraseRootFromParent_Done,
     /* 349942 */ // Label 7061: @349942
     /* 349942 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(350030), // Rule ID 9065 //
     /* 349947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349957 */   // MIs[0] Operand 2
     /* 349957 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 349968 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349968 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349971 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349975 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349980 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349986 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349989 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349993 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349998 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350015 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350028 */   GIR_RootConstrainSelectedInstOperands,
     /* 350029 */   // GIR_Coverage, 9065,
     /* 350029 */   GIR_EraseRootFromParent_Done,
     /* 350030 */ // Label 7062: @350030
     /* 350030 */ GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(350118), // Rule ID 9066 //
     /* 350035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350045 */   // MIs[0] Operand 2
     /* 350045 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 350056 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350056 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350059 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350063 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350068 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350074 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350077 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350081 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350086 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350091 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350094 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350098 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350103 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350116 */   GIR_RootConstrainSelectedInstOperands,
     /* 350117 */   // GIR_Coverage, 9066,
     /* 350117 */   GIR_EraseRootFromParent_Done,
     /* 350118 */ // Label 7063: @350118
     /* 350118 */ GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(350206), // Rule ID 9067 //
     /* 350123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350133 */   // MIs[0] Operand 2
     /* 350133 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 350144 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350144 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350147 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350151 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350156 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350162 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350165 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350169 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350174 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350191 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350204 */   GIR_RootConstrainSelectedInstOperands,
     /* 350205 */   // GIR_Coverage, 9067,
     /* 350205 */   GIR_EraseRootFromParent_Done,
     /* 350206 */ // Label 7064: @350206
     /* 350206 */ GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(350294), // Rule ID 9068 //
     /* 350211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350221 */   // MIs[0] Operand 2
     /* 350221 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 350232 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350232 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350235 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350239 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350244 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350250 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350253 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350257 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350262 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350267 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350270 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350274 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350279 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350292 */   GIR_RootConstrainSelectedInstOperands,
     /* 350293 */   // GIR_Coverage, 9068,
     /* 350293 */   GIR_EraseRootFromParent_Done,
     /* 350294 */ // Label 7065: @350294
     /* 350294 */ GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(350382), // Rule ID 9069 //
     /* 350299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350309 */   // MIs[0] Operand 2
     /* 350309 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 350320 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350320 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350323 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350327 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350332 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350338 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350341 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350345 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350350 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350367 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350380 */   GIR_RootConstrainSelectedInstOperands,
     /* 350381 */   // GIR_Coverage, 9069,
     /* 350381 */   GIR_EraseRootFromParent_Done,
     /* 350382 */ // Label 7066: @350382
     /* 350382 */ GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(350470), // Rule ID 9070 //
     /* 350387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350397 */   // MIs[0] Operand 2
     /* 350397 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 350408 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350408 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350411 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350415 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350420 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350426 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350429 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350433 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350438 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350455 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350465 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350468 */   GIR_RootConstrainSelectedInstOperands,
     /* 350469 */   // GIR_Coverage, 9070,
     /* 350469 */   GIR_EraseRootFromParent_Done,
     /* 350470 */ // Label 7067: @350470
     /* 350470 */ GIM_Reject,
     /* 350471 */ // Label 7003: @350471
     /* 350471 */ GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(350506), // Rule ID 9021 //
     /* 350476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 350482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350486 */   // MIs[0] Operand 2
     /* 350486 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350497 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 350497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350502 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 350504 */   GIR_RootConstrainSelectedInstOperands,
     /* 350505 */   // GIR_Coverage, 9021,
     /* 350505 */   GIR_EraseRootFromParent_Done,
     /* 350506 */ // Label 7068: @350506
     /* 350506 */ GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(350541), // Rule ID 9022 //
     /* 350511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 350517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350521 */   // MIs[0] Operand 2
     /* 350521 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350532 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 350532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350537 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 350539 */   GIR_RootConstrainSelectedInstOperands,
     /* 350540 */   // GIR_Coverage, 9022,
     /* 350540 */   GIR_EraseRootFromParent_Done,
     /* 350541 */ // Label 7069: @350541
     /* 350541 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(350595), // Rule ID 9031 //
     /* 350546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350556 */   // MIs[0] Operand 2
     /* 350556 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350567 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 350567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350579 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350590 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350593 */   GIR_RootConstrainSelectedInstOperands,
     /* 350594 */   // GIR_Coverage, 9031,
     /* 350594 */   GIR_EraseRootFromParent_Done,
     /* 350595 */ // Label 7070: @350595
     /* 350595 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(350649), // Rule ID 9032 //
     /* 350600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350610 */   // MIs[0] Operand 2
     /* 350610 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350621 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 350621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350633 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350647 */   GIR_RootConstrainSelectedInstOperands,
     /* 350648 */   // GIR_Coverage, 9032,
     /* 350648 */   GIR_EraseRootFromParent_Done,
     /* 350649 */ // Label 7071: @350649
     /* 350649 */ GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(350703), // Rule ID 9033 //
     /* 350654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350664 */   // MIs[0] Operand 2
     /* 350664 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350675 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 350675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350687 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350701 */   GIR_RootConstrainSelectedInstOperands,
     /* 350702 */   // GIR_Coverage, 9033,
     /* 350702 */   GIR_EraseRootFromParent_Done,
     /* 350703 */ // Label 7072: @350703
     /* 350703 */ GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(350757), // Rule ID 9034 //
     /* 350708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350718 */   // MIs[0] Operand 2
     /* 350718 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 350729 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 350729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350741 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350755 */   GIR_RootConstrainSelectedInstOperands,
     /* 350756 */   // GIR_Coverage, 9034,
     /* 350756 */   GIR_EraseRootFromParent_Done,
     /* 350757 */ // Label 7073: @350757
     /* 350757 */ GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(350828), // Rule ID 9047 //
     /* 350762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350772 */   // MIs[0] Operand 2
     /* 350772 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350783 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 350783 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350786 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350790 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350795 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350813 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350826 */   GIR_RootConstrainSelectedInstOperands,
     /* 350827 */   // GIR_Coverage, 9047,
     /* 350827 */   GIR_EraseRootFromParent_Done,
     /* 350828 */ // Label 7074: @350828
     /* 350828 */ GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(350899), // Rule ID 9048 //
     /* 350833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350843 */   // MIs[0] Operand 2
     /* 350843 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350854 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 350854 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350857 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350861 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350866 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350872 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350875 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350879 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350884 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350897 */   GIR_RootConstrainSelectedInstOperands,
     /* 350898 */   // GIR_Coverage, 9048,
     /* 350898 */   GIR_EraseRootFromParent_Done,
     /* 350899 */ // Label 7075: @350899
     /* 350899 */ GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(350970), // Rule ID 9049 //
     /* 350904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350914 */   // MIs[0] Operand 2
     /* 350914 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350925 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 350925 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350928 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350932 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350937 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350955 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350968 */   GIR_RootConstrainSelectedInstOperands,
     /* 350969 */   // GIR_Coverage, 9049,
     /* 350969 */   GIR_EraseRootFromParent_Done,
     /* 350970 */ // Label 7076: @350970
     /* 350970 */ GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(351041), // Rule ID 9050 //
     /* 350975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350985 */   // MIs[0] Operand 2
     /* 350985 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 350996 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 350996 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350999 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351003 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351008 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351026 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351039 */   GIR_RootConstrainSelectedInstOperands,
     /* 351040 */   // GIR_Coverage, 9050,
     /* 351040 */   GIR_EraseRootFromParent_Done,
     /* 351041 */ // Label 7077: @351041
     /* 351041 */ GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(351112), // Rule ID 9051 //
     /* 351046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351056 */   // MIs[0] Operand 2
     /* 351056 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 351067 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351067 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351070 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351074 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351079 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351097 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351110 */   GIR_RootConstrainSelectedInstOperands,
     /* 351111 */   // GIR_Coverage, 9051,
     /* 351111 */   GIR_EraseRootFromParent_Done,
     /* 351112 */ // Label 7078: @351112
     /* 351112 */ GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(351183), // Rule ID 9052 //
     /* 351117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351127 */   // MIs[0] Operand 2
     /* 351127 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 351138 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351138 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351141 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351145 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351150 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351168 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351181 */   GIR_RootConstrainSelectedInstOperands,
     /* 351182 */   // GIR_Coverage, 9052,
     /* 351182 */   GIR_EraseRootFromParent_Done,
     /* 351183 */ // Label 7079: @351183
     /* 351183 */ GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(351254), // Rule ID 9053 //
     /* 351188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351198 */   // MIs[0] Operand 2
     /* 351198 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 351209 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351209 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351212 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351216 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351221 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351239 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351252 */   GIR_RootConstrainSelectedInstOperands,
     /* 351253 */   // GIR_Coverage, 9053,
     /* 351253 */   GIR_EraseRootFromParent_Done,
     /* 351254 */ // Label 7080: @351254
     /* 351254 */ GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(351325), // Rule ID 9054 //
     /* 351259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351269 */   // MIs[0] Operand 2
     /* 351269 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 351280 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351280 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351283 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351287 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351292 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351310 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351323 */   GIR_RootConstrainSelectedInstOperands,
     /* 351324 */   // GIR_Coverage, 9054,
     /* 351324 */   GIR_EraseRootFromParent_Done,
     /* 351325 */ // Label 7081: @351325
     /* 351325 */ GIM_Reject,
     /* 351326 */ // Label 7004: @351326
     /* 351326 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(351361), // Rule ID 9071 //
     /* 351331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 351337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351341 */   // MIs[0] Operand 2
     /* 351341 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351352 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 351352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 351355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351357 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 351359 */   GIR_RootConstrainSelectedInstOperands,
     /* 351360 */   // GIR_Coverage, 9071,
     /* 351360 */   GIR_EraseRootFromParent_Done,
     /* 351361 */ // Label 7082: @351361
     /* 351361 */ GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(351396), // Rule ID 9072 //
     /* 351366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 351372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351376 */   // MIs[0] Operand 2
     /* 351376 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351387 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 351387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 351390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351392 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 351394 */   GIR_RootConstrainSelectedInstOperands,
     /* 351395 */   // GIR_Coverage, 9072,
     /* 351395 */   GIR_EraseRootFromParent_Done,
     /* 351396 */ // Label 7083: @351396
     /* 351396 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(351450), // Rule ID 9077 //
     /* 351401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351411 */   // MIs[0] Operand 2
     /* 351411 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351422 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 351422 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351425 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 351429 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351434 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 351438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 351443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351448 */   GIR_RootConstrainSelectedInstOperands,
     /* 351449 */   // GIR_Coverage, 9077,
     /* 351449 */   GIR_EraseRootFromParent_Done,
     /* 351450 */ // Label 7084: @351450
     /* 351450 */ GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(351504), // Rule ID 9078 //
     /* 351455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351465 */   // MIs[0] Operand 2
     /* 351465 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351476 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 351476 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351479 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 351483 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351488 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 351492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 351497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351502 */   GIR_RootConstrainSelectedInstOperands,
     /* 351503 */   // GIR_Coverage, 9078,
     /* 351503 */   GIR_EraseRootFromParent_Done,
     /* 351504 */ // Label 7085: @351504
     /* 351504 */ GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(351558), // Rule ID 9079 //
     /* 351509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351519 */   // MIs[0] Operand 2
     /* 351519 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351530 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 351530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 351537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351542 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 351546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 351551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351556 */   GIR_RootConstrainSelectedInstOperands,
     /* 351557 */   // GIR_Coverage, 9079,
     /* 351557 */   GIR_EraseRootFromParent_Done,
     /* 351558 */ // Label 7086: @351558
     /* 351558 */ GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(351612), // Rule ID 9080 //
     /* 351563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351573 */   // MIs[0] Operand 2
     /* 351573 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 351584 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 351584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 351591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351596 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 351600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 351605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351610 */   GIR_RootConstrainSelectedInstOperands,
     /* 351611 */   // GIR_Coverage, 9080,
     /* 351611 */   GIR_EraseRootFromParent_Done,
     /* 351612 */ // Label 7087: @351612
     /* 351612 */ GIM_Reject,
     /* 351613 */ // Label 7005: @351613
     /* 351613 */ GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(351682),
     /* 351618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351625 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(351653), // Rule ID 9075 //
     /* 351630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351633 */     // MIs[0] Operand 2
     /* 351633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351644 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 351644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 351647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 351651 */     GIR_RootConstrainSelectedInstOperands,
     /* 351652 */     // GIR_Coverage, 9075,
     /* 351652 */     GIR_EraseRootFromParent_Done,
     /* 351653 */   // Label 7089: @351653
     /* 351653 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(351681), // Rule ID 9076 //
     /* 351658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351661 */     // MIs[0] Operand 2
     /* 351661 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351672 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 351672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 351675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 351679 */     GIR_RootConstrainSelectedInstOperands,
     /* 351680 */     // GIR_Coverage, 9076,
     /* 351680 */     GIR_EraseRootFromParent_Done,
     /* 351681 */   // Label 7090: @351681
     /* 351681 */   GIM_Reject,
     /* 351682 */ // Label 7088: @351682
     /* 351682 */ GIM_Reject,
     /* 351683 */ // Label 7006: @351683
     /* 351683 */ GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(351718), // Rule ID 9023 //
     /* 351688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351698 */   // MIs[0] Operand 2
     /* 351698 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351709 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 351709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351714 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351716 */   GIR_RootConstrainSelectedInstOperands,
     /* 351717 */   // GIR_Coverage, 9023,
     /* 351717 */   GIR_EraseRootFromParent_Done,
     /* 351718 */ // Label 7091: @351718
     /* 351718 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(351753), // Rule ID 9024 //
     /* 351723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351733 */   // MIs[0] Operand 2
     /* 351733 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351744 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 351744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351749 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351751 */   GIR_RootConstrainSelectedInstOperands,
     /* 351752 */   // GIR_Coverage, 9024,
     /* 351752 */   GIR_EraseRootFromParent_Done,
     /* 351753 */ // Label 7092: @351753
     /* 351753 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(351807), // Rule ID 9035 //
     /* 351758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351768 */   // MIs[0] Operand 2
     /* 351768 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351779 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 351779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351791 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351805 */   GIR_RootConstrainSelectedInstOperands,
     /* 351806 */   // GIR_Coverage, 9035,
     /* 351806 */   GIR_EraseRootFromParent_Done,
     /* 351807 */ // Label 7093: @351807
     /* 351807 */ GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(351861), // Rule ID 9036 //
     /* 351812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351822 */   // MIs[0] Operand 2
     /* 351822 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351833 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 351833 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351836 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351840 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351845 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351859 */   GIR_RootConstrainSelectedInstOperands,
     /* 351860 */   // GIR_Coverage, 9036,
     /* 351860 */   GIR_EraseRootFromParent_Done,
     /* 351861 */ // Label 7094: @351861
     /* 351861 */ GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(351915), // Rule ID 9037 //
     /* 351866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351876 */   // MIs[0] Operand 2
     /* 351876 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 351887 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 351887 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351890 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351894 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351899 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351913 */   GIR_RootConstrainSelectedInstOperands,
     /* 351914 */   // GIR_Coverage, 9037,
     /* 351914 */   GIR_EraseRootFromParent_Done,
     /* 351915 */ // Label 7095: @351915
     /* 351915 */ GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(351969), // Rule ID 9038 //
     /* 351920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351930 */   // MIs[0] Operand 2
     /* 351930 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 351941 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 351941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351953 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351967 */   GIR_RootConstrainSelectedInstOperands,
     /* 351968 */   // GIR_Coverage, 9038,
     /* 351968 */   GIR_EraseRootFromParent_Done,
     /* 351969 */ // Label 7096: @351969
     /* 351969 */ GIM_Reject,
     /* 351970 */ // Label 7007: @351970
     /* 351970 */ GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(352039),
     /* 351975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351982 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(352010), // Rule ID 9073 //
     /* 351987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351990 */     // MIs[0] Operand 2
     /* 351990 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352001 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 352001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 352004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352008 */     GIR_RootConstrainSelectedInstOperands,
     /* 352009 */     // GIR_Coverage, 9073,
     /* 352009 */     GIR_EraseRootFromParent_Done,
     /* 352010 */   // Label 7098: @352010
     /* 352010 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(352038), // Rule ID 9074 //
     /* 352015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352018 */     // MIs[0] Operand 2
     /* 352018 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352029 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 352029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 352032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352036 */     GIR_RootConstrainSelectedInstOperands,
     /* 352037 */     // GIR_Coverage, 9074,
     /* 352037 */     GIR_EraseRootFromParent_Done,
     /* 352038 */   // Label 7099: @352038
     /* 352038 */   GIM_Reject,
     /* 352039 */ // Label 7097: @352039
     /* 352039 */ GIM_Reject,
     /* 352040 */ // Label 7008: @352040
     /* 352040 */ GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(352109),
     /* 352045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352052 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(352080), // Rule ID 9025 //
     /* 352057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352060 */     // MIs[0] Operand 2
     /* 352060 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352071 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 352071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352078 */     GIR_RootConstrainSelectedInstOperands,
     /* 352079 */     // GIR_Coverage, 9025,
     /* 352079 */     GIR_EraseRootFromParent_Done,
     /* 352080 */   // Label 7101: @352080
     /* 352080 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(352108), // Rule ID 9026 //
     /* 352085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352088 */     // MIs[0] Operand 2
     /* 352088 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 352099 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 352099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352106 */     GIR_RootConstrainSelectedInstOperands,
     /* 352107 */     // GIR_Coverage, 9026,
     /* 352107 */     GIR_EraseRootFromParent_Done,
     /* 352108 */   // Label 7102: @352108
     /* 352108 */   GIM_Reject,
     /* 352109 */ // Label 7100: @352109
     /* 352109 */ GIM_Reject,
     /* 352110 */ // Label 7009: @352110
     /* 352110 */ GIM_Reject,
     /* 352111 */ // Label 90: @352111
     /* 352111 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7118*/ GIMT_Encode4(385032),
     /* 352122 */ /*GILLT_s64*//*Label 7103*/ GIMT_Encode4(352206), GIMT_Encode4(0),
     /* 352130 */ /*GILLT_v2s32*//*Label 7104*/ GIMT_Encode4(352916),
     /* 352134 */ /*GILLT_v2s64*//*Label 7105*/ GIMT_Encode4(356447),
     /* 352138 */ /*GILLT_v4s16*//*Label 7106*/ GIMT_Encode4(359688),
     /* 352142 */ /*GILLT_v4s32*//*Label 7107*/ GIMT_Encode4(363328),
     /* 352146 */ /*GILLT_v8s8*//*Label 7108*/ GIMT_Encode4(366396),
     /* 352150 */ /*GILLT_v8s16*//*Label 7109*/ GIMT_Encode4(369609),
     /* 352154 */ /*GILLT_v16s8*//*Label 7110*/ GIMT_Encode4(373028), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 352166 */ /*GILLT_nxv2s16*//*Label 7111*/ GIMT_Encode4(376232),
     /* 352170 */ /*GILLT_nxv2s32*//*Label 7112*/ GIMT_Encode4(376357),
     /* 352174 */ /*GILLT_nxv2s64*//*Label 7113*/ GIMT_Encode4(376482), GIMT_Encode4(0),
     /* 352182 */ /*GILLT_nxv4s16*//*Label 7114*/ GIMT_Encode4(378460),
     /* 352186 */ /*GILLT_nxv4s32*//*Label 7115*/ GIMT_Encode4(378612), GIMT_Encode4(0),
     /* 352194 */ /*GILLT_nxv8s16*//*Label 7116*/ GIMT_Encode4(380644), GIMT_Encode4(0),
     /* 352202 */ /*GILLT_nxv16s8*//*Label 7117*/ GIMT_Encode4(382912),
     /* 352206 */ // Label 7103: @352206
     /* 352206 */ GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(352915),
     /* 352211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 352214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352224 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(352354), // Rule ID 5748 //
     /* 352229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352262 */     // MIs[2] Operand 1
     /* 352262 */     // No operand predicates
     /* 352262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352270 */     // MIs[3] Operand 1
     /* 352270 */     // No operand predicates
     /* 352270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352272 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352272 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 352275 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352279 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352284 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352287 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352291 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352299 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 352311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 352322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 352329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352336 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352353 */     // GIR_Coverage, 5748,
     /* 352353 */     GIR_EraseRootFromParent_Done,
     /* 352354 */   // Label 7120: @352354
     /* 352354 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(352515), // Rule ID 5749 //
     /* 352359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 352375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352392 */     // MIs[2] Operand 1
     /* 352392 */     // No operand predicates
     /* 352392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352400 */     // MIs[3] Operand 1
     /* 352400 */     // No operand predicates
     /* 352400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352402 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352402 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 352405 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352409 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352414 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 352417 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352421 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 352424 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352429 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352434 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 352437 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352441 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352446 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352449 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352453 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352456 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352461 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 352473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352478 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 352484 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 352487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 352490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352497 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352514 */     // GIR_Coverage, 5749,
     /* 352514 */     GIR_EraseRootFromParent_Done,
     /* 352515 */   // Label 7121: @352515
     /* 352515 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(352645), // Rule ID 5788 //
     /* 352520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352553 */     // MIs[2] Operand 1
     /* 352553 */     // No operand predicates
     /* 352553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352561 */     // MIs[3] Operand 1
     /* 352561 */     // No operand predicates
     /* 352561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352563 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 352566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352575 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352582 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 352602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 352613 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 352620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352627 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352644 */     // GIR_Coverage, 5788,
     /* 352644 */     GIR_EraseRootFromParent_Done,
     /* 352645 */   // Label 7122: @352645
     /* 352645 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(352806), // Rule ID 5789 //
     /* 352650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 352666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352683 */     // MIs[2] Operand 1
     /* 352683 */     // No operand predicates
     /* 352683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352691 */     // MIs[3] Operand 1
     /* 352691 */     // No operand predicates
     /* 352691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352693 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352693 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 352696 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352700 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352705 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 352708 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352712 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 352715 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352720 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352725 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 352728 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352732 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352740 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352744 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352747 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352752 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 352764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352769 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 352775 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 352778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 352781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352788 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352805 */     // GIR_Coverage, 5789,
     /* 352805 */     GIR_EraseRootFromParent_Done,
     /* 352806 */   // Label 7123: @352806
     /* 352806 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(352842), // Rule ID 6701 //
     /* 352811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352829 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 352829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 352836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352841 */     // GIR_Coverage, 6701,
     /* 352841 */     GIR_EraseRootFromParent_Done,
     /* 352842 */   // Label 7124: @352842
     /* 352842 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(352878), // Rule ID 6703 //
     /* 352847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352865 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 352865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 352872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352877 */     // GIR_Coverage, 6703,
     /* 352877 */     GIR_EraseRootFromParent_Done,
     /* 352878 */   // Label 7125: @352878
     /* 352878 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(352914), // Rule ID 6705 //
     /* 352883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352901 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 352901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352904 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 352906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 352908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352913 */     // GIR_Coverage, 6705,
     /* 352913 */     GIR_EraseRootFromParent_Done,
     /* 352914 */   // Label 7126: @352914
     /* 352914 */   GIM_Reject,
     /* 352915 */ // Label 7119: @352915
     /* 352915 */ GIM_Reject,
     /* 352916 */ // Label 7104: @352916
     /* 352916 */ GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(356446),
     /* 352921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 352924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352934 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(353043), // Rule ID 4305 //
     /* 352939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352943 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352949 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352959 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352966 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 352983 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 352983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 352990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353010 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353042 */     // GIR_Coverage, 4305,
     /* 353042 */     GIR_EraseRootFromParent_Done,
     /* 353043 */   // Label 7128: @353043
     /* 353043 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(353152), // Rule ID 4306 //
     /* 353048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353052 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353058 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353068 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353075 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 353092 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 353099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353119 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353151 */     // GIR_Coverage, 4306,
     /* 353151 */     GIR_EraseRootFromParent_Done,
     /* 353152 */   // Label 7129: @353152
     /* 353152 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(353261), // Rule ID 4413 //
     /* 353157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353161 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353167 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353177 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353180 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353184 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 353201 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 353208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353228 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353260 */     // GIR_Coverage, 4413,
     /* 353260 */     GIR_EraseRootFromParent_Done,
     /* 353261 */   // Label 7130: @353261
     /* 353261 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(353370), // Rule ID 4414 //
     /* 353266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353270 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353276 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353286 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353293 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353303 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 353310 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 353317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353337 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353369 */     // GIR_Coverage, 4414,
     /* 353369 */     GIR_EraseRootFromParent_Done,
     /* 353370 */   // Label 7131: @353370
     /* 353370 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(353475), // Rule ID 4311 //
     /* 353375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353391 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353398 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 353415 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 353422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353442 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353474 */     // GIR_Coverage, 4311,
     /* 353474 */     GIR_EraseRootFromParent_Done,
     /* 353475 */   // Label 7132: @353475
     /* 353475 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(353580), // Rule ID 4313 //
     /* 353480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353496 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353503 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 353520 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 353527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353547 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353579 */     // GIR_Coverage, 4313,
     /* 353579 */     GIR_EraseRootFromParent_Done,
     /* 353580 */   // Label 7133: @353580
     /* 353580 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(353685), // Rule ID 4419 //
     /* 353585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353601 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353608 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 353625 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 353632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353652 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353684 */     // GIR_Coverage, 4419,
     /* 353684 */     GIR_EraseRootFromParent_Done,
     /* 353685 */   // Label 7134: @353685
     /* 353685 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(353790), // Rule ID 4421 //
     /* 353690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353706 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353713 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 353730 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 353737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353757 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353789 */     // GIR_Coverage, 4421,
     /* 353789 */     GIR_EraseRootFromParent_Done,
     /* 353790 */   // Label 7135: @353790
     /* 353790 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(353894), // Rule ID 4303 //
     /* 353795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353799 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353815 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353822 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 353839 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 353839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 353846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353861 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353893 */     // GIR_Coverage, 4303,
     /* 353893 */     GIR_EraseRootFromParent_Done,
     /* 353894 */   // Label 7136: @353894
     /* 353894 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(353998), // Rule ID 4304 //
     /* 353899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353909 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353919 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353922 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353926 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 353943 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 353943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 353950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353965 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353997 */     // GIR_Coverage, 4304,
     /* 353997 */     GIR_EraseRootFromParent_Done,
     /* 353998 */   // Label 7137: @353998
     /* 353998 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(354102), // Rule ID 4411 //
     /* 354003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354007 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354013 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354023 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354030 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354047 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354069 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354101 */     // GIR_Coverage, 4411,
     /* 354101 */     GIR_EraseRootFromParent_Done,
     /* 354102 */   // Label 7138: @354102
     /* 354102 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(354206), // Rule ID 4412 //
     /* 354107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354111 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354117 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354127 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354134 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 354151 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 354151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 354158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354173 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354205 */     // GIR_Coverage, 4412,
     /* 354205 */     GIR_EraseRootFromParent_Done,
     /* 354206 */   // Label 7139: @354206
     /* 354206 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(354306), // Rule ID 4307 //
     /* 354211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354227 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354234 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354251 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354273 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354305 */     // GIR_Coverage, 4307,
     /* 354305 */     GIR_EraseRootFromParent_Done,
     /* 354306 */   // Label 7140: @354306
     /* 354306 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(354406), // Rule ID 4309 //
     /* 354311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354327 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354330 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354334 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 354351 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 354351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 354358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354373 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354405 */     // GIR_Coverage, 4309,
     /* 354405 */     GIR_EraseRootFromParent_Done,
     /* 354406 */   // Label 7141: @354406
     /* 354406 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(354506), // Rule ID 4415 //
     /* 354411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354427 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354434 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354451 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354473 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354505 */     // GIR_Coverage, 4415,
     /* 354505 */     GIR_EraseRootFromParent_Done,
     /* 354506 */   // Label 7142: @354506
     /* 354506 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(354606), // Rule ID 4417 //
     /* 354511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354527 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354530 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354534 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 354551 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 354551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 354558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354573 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354605 */     // GIR_Coverage, 4417,
     /* 354605 */     GIR_EraseRootFromParent_Done,
     /* 354606 */   // Label 7143: @354606
     /* 354606 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(354726), // Rule ID 6479 //
     /* 354611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 354614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354630 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354633 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354637 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354644 */     // MIs[2] Rn
     /* 354644 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 354648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 354653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354659 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 354659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 354662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 354680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354688 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 354691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 354695 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354708 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354725 */     // GIR_Coverage, 6479,
     /* 354725 */     GIR_EraseRootFromParent_Done,
     /* 354726 */   // Label 7144: @354726
     /* 354726 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(354846), // Rule ID 6481 //
     /* 354731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 354734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354750 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354753 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354757 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 354764 */     // MIs[2] Rn
     /* 354764 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 354768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 354773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354779 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 354779 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 354782 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354786 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 354800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354805 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354808 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 354811 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 354815 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354828 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354845 */     // GIR_Coverage, 6481,
     /* 354845 */     GIR_EraseRootFromParent_Done,
     /* 354846 */   // Label 7145: @354846
     /* 354846 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(354976), // Rule ID 5740 //
     /* 354851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 354867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354884 */     // MIs[2] Operand 1
     /* 354884 */     // No operand predicates
     /* 354884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354892 */     // MIs[3] Operand 1
     /* 354892 */     // No operand predicates
     /* 354892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354894 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 354894 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 354897 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354901 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354906 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 354909 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354913 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 354916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354921 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 354933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354938 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 354944 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 354951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354958 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354975 */     // GIR_Coverage, 5740,
     /* 354975 */     GIR_EraseRootFromParent_Done,
     /* 354976 */   // Label 7146: @354976
     /* 354976 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(355137), // Rule ID 5741 //
     /* 354981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 354997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355014 */     // MIs[2] Operand 1
     /* 355014 */     // No operand predicates
     /* 355014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355022 */     // MIs[3] Operand 1
     /* 355022 */     // No operand predicates
     /* 355022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355024 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355024 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 355027 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355031 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355036 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355039 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355043 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 355046 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355051 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355068 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355071 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355075 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 355095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355100 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355106 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355119 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355136 */     // GIR_Coverage, 5741,
     /* 355136 */     GIR_EraseRootFromParent_Done,
     /* 355137 */   // Label 7147: @355137
     /* 355137 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(355267), // Rule ID 5780 //
     /* 355142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 355158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355175 */     // MIs[2] Operand 1
     /* 355175 */     // No operand predicates
     /* 355175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355183 */     // MIs[3] Operand 1
     /* 355183 */     // No operand predicates
     /* 355183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355185 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 355188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355197 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355200 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355204 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355207 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 355224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355249 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355266 */     // GIR_Coverage, 5780,
     /* 355266 */     GIR_EraseRootFromParent_Done,
     /* 355267 */   // Label 7148: @355267
     /* 355267 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(355428), // Rule ID 5781 //
     /* 355272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355305 */     // MIs[2] Operand 1
     /* 355305 */     // No operand predicates
     /* 355305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355313 */     // MIs[3] Operand 1
     /* 355313 */     // No operand predicates
     /* 355313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355315 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355315 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 355318 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355322 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355327 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355330 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355334 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 355337 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355342 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355359 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355362 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355366 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355369 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 355386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355391 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355410 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355427 */     // GIR_Coverage, 5781,
     /* 355427 */     GIR_EraseRootFromParent_Done,
     /* 355428 */   // Label 7149: @355428
     /* 355428 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(355494), // Rule ID 5687 //
     /* 355433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355451 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), GPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 355451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 355454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 355475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355493 */     // GIR_Coverage, 5687,
     /* 355493 */     GIR_EraseRootFromParent_Done,
     /* 355494 */   // Label 7150: @355494
     /* 355494 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(355560), // Rule ID 5703 //
     /* 355499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355517 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 355517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 355520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 355541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355559 */     // GIR_Coverage, 5703,
     /* 355559 */     GIR_EraseRootFromParent_Done,
     /* 355560 */   // Label 7151: @355560
     /* 355560 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(355695), // Rule ID 5711 //
     /* 355565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 355577 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 355581 */     // MIs[1] Operand 1
     /* 355581 */     // No operand predicates
     /* 355581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 355593 */     // MIs[2] Operand 1
     /* 355593 */     // No operand predicates
     /* 355593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355595 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 355595 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 355598 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355602 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355609 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 355612 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355616 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355621 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 355624 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 355628 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355631 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355636 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355641 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 355653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355658 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 355664 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 355670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355677 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355694 */     // GIR_Coverage, 5711,
     /* 355694 */     GIR_EraseRootFromParent_Done,
     /* 355695 */   // Label 7152: @355695
     /* 355695 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(355827), // Rule ID 6488 //
     /* 355700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 355719 */     // MIs[1] Rn
     /* 355719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 355723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355736 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 355740 */     // MIs[2] Operand 1
     /* 355740 */     // No operand predicates
     /* 355740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355742 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 355742 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355745 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355749 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355754 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355757 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 355761 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355769 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 355781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355786 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 355792 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355796 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355809 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355826 */     // GIR_Coverage, 6488,
     /* 355826 */     GIR_EraseRootFromParent_Done,
     /* 355827 */   // Label 7153: @355827
     /* 355827 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(355959), // Rule ID 6489 //
     /* 355832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355844 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 355851 */     // MIs[1] Rn
     /* 355851 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 355855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 355872 */     // MIs[2] Operand 1
     /* 355872 */     // No operand predicates
     /* 355872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355874 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 355874 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355877 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355881 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355886 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355889 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 355893 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355896 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355901 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 355913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355918 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 355924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355928 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355958 */     // GIR_Coverage, 6489,
     /* 355958 */     GIR_EraseRootFromParent_Done,
     /* 355959 */   // Label 7154: @355959
     /* 355959 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(356142), // Rule ID 5791 //
     /* 355964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 355972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 355976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355989 */     // MIs[2] Operand 1
     /* 355989 */     // No operand predicates
     /* 355989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355991 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 355991 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 355994 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355998 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 356005 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 356008 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356012 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356017 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356020 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 356024 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 356027 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356032 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356037 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356042 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356045 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356049 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356068 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356071 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356075 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356088 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356105 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 356111 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356124 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356141 */     // GIR_Coverage, 5791,
     /* 356141 */     GIR_EraseRootFromParent_Done,
     /* 356142 */   // Label 7155: @356142
     /* 356142 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(356320), // Rule ID 5714 //
     /* 356147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 356159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356167 */     // MIs[1] Operand 1
     /* 356167 */     // No operand predicates
     /* 356167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356169 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 356169 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 356172 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356176 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 356183 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 356186 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356190 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356195 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356198 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 356202 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 356205 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356210 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356215 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356220 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356223 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356227 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356234 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356237 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356241 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356246 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356249 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 356253 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356256 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356261 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356266 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356283 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 356289 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356292 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356302 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356319 */     // GIR_Coverage, 5714,
     /* 356319 */     GIR_EraseRootFromParent_Done,
     /* 356320 */   // Label 7156: @356320
     /* 356320 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(356445), // Rule ID 5717 //
     /* 356325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 356337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356345 */     // MIs[1] Operand 1
     /* 356345 */     // No operand predicates
     /* 356345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356347 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 356347 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356350 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356354 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356361 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356364 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356368 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356373 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356376 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 356380 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356383 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356388 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356393 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 356405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356410 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 356416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 356420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356427 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356444 */     // GIR_Coverage, 5717,
     /* 356444 */     GIR_EraseRootFromParent_Done,
     /* 356445 */   // Label 7157: @356445
     /* 356445 */   GIM_Reject,
     /* 356446 */ // Label 7127: @356446
     /* 356446 */ GIM_Reject,
     /* 356447 */ // Label 7105: @356447
     /* 356447 */ GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(359687),
     /* 356452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 356455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 356458 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356465 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(356574), // Rule ID 4329 //
     /* 356470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356474 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356480 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356490 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356493 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356497 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 356514 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 356521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356541 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356573 */     // GIR_Coverage, 4329,
     /* 356573 */     GIR_EraseRootFromParent_Done,
     /* 356574 */   // Label 7159: @356574
     /* 356574 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(356683), // Rule ID 4330 //
     /* 356579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356583 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356589 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356599 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356606 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 356623 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 356630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356650 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356682 */     // GIR_Coverage, 4330,
     /* 356682 */     GIR_EraseRootFromParent_Done,
     /* 356683 */   // Label 7160: @356683
     /* 356683 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(356792), // Rule ID 4437 //
     /* 356688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356692 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356698 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356708 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356715 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 356732 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 356739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356759 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356791 */     // GIR_Coverage, 4437,
     /* 356791 */     GIR_EraseRootFromParent_Done,
     /* 356792 */   // Label 7161: @356792
     /* 356792 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(356901), // Rule ID 4438 //
     /* 356797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356801 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356807 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356817 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356820 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356824 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 356841 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 356848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356868 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356900 */     // GIR_Coverage, 4438,
     /* 356900 */     GIR_EraseRootFromParent_Done,
     /* 356901 */   // Label 7162: @356901
     /* 356901 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(357006), // Rule ID 4335 //
     /* 356906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356922 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356925 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356929 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 356946 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 356953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356973 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357005 */     // GIR_Coverage, 4335,
     /* 357005 */     GIR_EraseRootFromParent_Done,
     /* 357006 */   // Label 7163: @357006
     /* 357006 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(357111), // Rule ID 4337 //
     /* 357011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357027 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357034 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357051 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357078 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357110 */     // GIR_Coverage, 4337,
     /* 357110 */     GIR_EraseRootFromParent_Done,
     /* 357111 */   // Label 7164: @357111
     /* 357111 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(357216), // Rule ID 4443 //
     /* 357116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357132 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357139 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357156 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357183 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357215 */     // GIR_Coverage, 4443,
     /* 357215 */     GIR_EraseRootFromParent_Done,
     /* 357216 */   // Label 7165: @357216
     /* 357216 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(357321), // Rule ID 4445 //
     /* 357221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357237 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357240 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357244 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357261 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357288 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357320 */     // GIR_Coverage, 4445,
     /* 357320 */     GIR_EraseRootFromParent_Done,
     /* 357321 */   // Label 7166: @357321
     /* 357321 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(357425), // Rule ID 4327 //
     /* 357326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357330 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357336 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357346 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357353 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357370 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 357377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357392 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357424 */     // GIR_Coverage, 4327,
     /* 357424 */     GIR_EraseRootFromParent_Done,
     /* 357425 */   // Label 7167: @357425
     /* 357425 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(357529), // Rule ID 4328 //
     /* 357430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357434 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357440 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357450 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357457 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 357474 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 357474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 357481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357496 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357528 */     // GIR_Coverage, 4328,
     /* 357528 */     GIR_EraseRootFromParent_Done,
     /* 357529 */   // Label 7168: @357529
     /* 357529 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(357633), // Rule ID 4435 //
     /* 357534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357554 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357561 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357578 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 357585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357632 */     // GIR_Coverage, 4435,
     /* 357632 */     GIR_EraseRootFromParent_Done,
     /* 357633 */   // Label 7169: @357633
     /* 357633 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(357737), // Rule ID 4436 //
     /* 357638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357642 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357648 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357658 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357665 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 357682 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 357682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 357689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357704 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357736 */     // GIR_Coverage, 4436,
     /* 357736 */     GIR_EraseRootFromParent_Done,
     /* 357737 */   // Label 7170: @357737
     /* 357737 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(357837), // Rule ID 4331 //
     /* 357742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357758 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357765 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357775 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357782 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 357789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357804 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357836 */     // GIR_Coverage, 4331,
     /* 357836 */     GIR_EraseRootFromParent_Done,
     /* 357837 */   // Label 7171: @357837
     /* 357837 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(357937), // Rule ID 4333 //
     /* 357842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357858 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357865 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 357882 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 357882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 357889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357904 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357936 */     // GIR_Coverage, 4333,
     /* 357936 */     GIR_EraseRootFromParent_Done,
     /* 357937 */   // Label 7172: @357937
     /* 357937 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(358037), // Rule ID 4439 //
     /* 357942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357958 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357965 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357982 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 357989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358004 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358036 */     // GIR_Coverage, 4439,
     /* 358036 */     GIR_EraseRootFromParent_Done,
     /* 358037 */   // Label 7173: @358037
     /* 358037 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(358137), // Rule ID 4441 //
     /* 358042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358058 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358065 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358082 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358104 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358136 */     // GIR_Coverage, 4441,
     /* 358136 */     GIR_EraseRootFromParent_Done,
     /* 358137 */   // Label 7174: @358137
     /* 358137 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(358250), // Rule ID 5746 //
     /* 358142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 358175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358179 */     // MIs[3] Operand 1
     /* 358179 */     // No operand predicates
     /* 358179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358185 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 358185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 358188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 358192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358197 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 358201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 358204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 358231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358249 */     // GIR_Coverage, 5746,
     /* 358249 */     GIR_EraseRootFromParent_Done,
     /* 358250 */   // Label 7175: @358250
     /* 358250 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(358363), // Rule ID 5786 //
     /* 358255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 358288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358292 */     // MIs[3] Operand 1
     /* 358292 */     // No operand predicates
     /* 358292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358298 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 358298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 358301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 358305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358310 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 358314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 358317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 358344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358362 */     // GIR_Coverage, 5786,
     /* 358362 */     GIR_EraseRootFromParent_Done,
     /* 358363 */   // Label 7176: @358363
     /* 358363 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(358441), // Rule ID 1941 //
     /* 358368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 358408 */     // MIs[2] Operand 1
     /* 358408 */     // No operand predicates
     /* 358408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358416 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 358420 */     // MIs[3] Operand 1
     /* 358420 */     // No operand predicates
     /* 358420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358422 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 358422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 358429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 358432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 358439 */     GIR_RootConstrainSelectedInstOperands,
     /* 358440 */     // GIR_Coverage, 1941,
     /* 358440 */     GIR_EraseRootFromParent_Done,
     /* 358441 */   // Label 7177: @358441
     /* 358441 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(358536), // Rule ID 7468 //
     /* 358446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 358449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 358461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 358465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358473 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 358476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358480 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 358487 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 358490 */     // MIs[2] Rn
     /* 358490 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 358494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 358499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358507 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 358511 */     // MIs[3] Operand 1
     /* 358511 */     // No operand predicates
     /* 358511 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358513 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15832>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 358513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 358516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 358520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 358523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 358527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 358534 */     GIR_RootConstrainSelectedInstOperands,
     /* 358535 */     // GIR_Coverage, 7468,
     /* 358535 */     GIR_EraseRootFromParent_Done,
     /* 358536 */   // Label 7178: @358536
     /* 358536 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(358625), // Rule ID 5743 //
     /* 358541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 358553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358565 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 358569 */     // MIs[2] Operand 1
     /* 358569 */     // No operand predicates
     /* 358569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358577 */     // MIs[3] Operand 1
     /* 358577 */     // No operand predicates
     /* 358577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358579 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 358579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358591 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 358597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 358617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 358623 */     GIR_RootConstrainSelectedInstOperands,
     /* 358624 */     // GIR_Coverage, 5743,
     /* 358624 */     GIR_EraseRootFromParent_Done,
     /* 358625 */   // Label 7179: @358625
     /* 358625 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(358714), // Rule ID 5783 //
     /* 358630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 358642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358654 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 358658 */     // MIs[2] Operand 1
     /* 358658 */     // No operand predicates
     /* 358658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358666 */     // MIs[3] Operand 1
     /* 358666 */     // No operand predicates
     /* 358666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358668 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 358668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358680 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 358686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 358706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 358712 */     GIR_RootConstrainSelectedInstOperands,
     /* 358713 */     // GIR_Coverage, 5783,
     /* 358713 */     GIR_EraseRootFromParent_Done,
     /* 358714 */   // Label 7180: @358714
     /* 358714 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(358781), // Rule ID 5745 //
     /* 358719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358752 */     // MIs[2] Operand 1
     /* 358752 */     // No operand predicates
     /* 358752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358760 */     // MIs[3] Operand 1
     /* 358760 */     // No operand predicates
     /* 358760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358762 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 358762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358767 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 358769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 358772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 358779 */     GIR_RootConstrainSelectedInstOperands,
     /* 358780 */     // GIR_Coverage, 5745,
     /* 358780 */     GIR_EraseRootFromParent_Done,
     /* 358781 */   // Label 7181: @358781
     /* 358781 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(358879), // Rule ID 5747 //
     /* 358786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 358802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358819 */     // MIs[2] Operand 1
     /* 358819 */     // No operand predicates
     /* 358819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358827 */     // MIs[3] Operand 1
     /* 358827 */     // No operand predicates
     /* 358827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358829 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 358829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358841 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 358844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358848 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 358851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358866 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 358868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 358871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 358877 */     GIR_RootConstrainSelectedInstOperands,
     /* 358878 */     // GIR_Coverage, 5747,
     /* 358878 */     GIR_EraseRootFromParent_Done,
     /* 358879 */   // Label 7182: @358879
     /* 358879 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(358946), // Rule ID 5785 //
     /* 358884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358917 */     // MIs[2] Operand 1
     /* 358917 */     // No operand predicates
     /* 358917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358925 */     // MIs[3] Operand 1
     /* 358925 */     // No operand predicates
     /* 358925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358927 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 358927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358932 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 358934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 358937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 358944 */     GIR_RootConstrainSelectedInstOperands,
     /* 358945 */     // GIR_Coverage, 5785,
     /* 358945 */     GIR_EraseRootFromParent_Done,
     /* 358946 */   // Label 7183: @358946
     /* 358946 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(359044), // Rule ID 5787 //
     /* 358951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 358967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358984 */     // MIs[2] Operand 1
     /* 358984 */     // No operand predicates
     /* 358984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358992 */     // MIs[3] Operand 1
     /* 358992 */     // No operand predicates
     /* 358992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358994 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 358994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359006 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 359009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359013 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359042 */     GIR_RootConstrainSelectedInstOperands,
     /* 359043 */     // GIR_Coverage, 5787,
     /* 359043 */     GIR_EraseRootFromParent_Done,
     /* 359044 */   // Label 7184: @359044
     /* 359044 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(359110), // Rule ID 5691 //
     /* 359049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359067 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), GPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), GPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 359067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 359091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359109 */     // GIR_Coverage, 5691,
     /* 359109 */     GIR_EraseRootFromParent_Done,
     /* 359110 */   // Label 7185: @359110
     /* 359110 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(359176), // Rule ID 5705 //
     /* 359115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359133 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 359133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 359157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359175 */     // GIR_Coverage, 5705,
     /* 359175 */     GIR_EraseRootFromParent_Done,
     /* 359176 */   // Label 7186: @359176
     /* 359176 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(359245), // Rule ID 6470 //
     /* 359181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359193 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359196 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 359200 */     // MIs[1] Rn
     /* 359200 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 359204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 359209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359217 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359221 */     // MIs[2] Operand 1
     /* 359221 */     // No operand predicates
     /* 359221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359223 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 359223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 359226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 359233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359243 */     GIR_RootConstrainSelectedInstOperands,
     /* 359244 */     // GIR_Coverage, 6470,
     /* 359244 */     GIR_EraseRootFromParent_Done,
     /* 359245 */   // Label 7187: @359245
     /* 359245 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(359314), // Rule ID 6471 //
     /* 359250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359262 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 359269 */     // MIs[1] Rn
     /* 359269 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 359273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 359278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359286 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359290 */     // MIs[2] Operand 1
     /* 359290 */     // No operand predicates
     /* 359290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359292 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 359292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 359295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 359302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359312 */     GIR_RootConstrainSelectedInstOperands,
     /* 359313 */     // GIR_Coverage, 6471,
     /* 359313 */     GIR_EraseRootFromParent_Done,
     /* 359314 */   // Label 7188: @359314
     /* 359314 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(359396), // Rule ID 7467 //
     /* 359319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 359322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359334 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 359337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 359341 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 359348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 359351 */     // MIs[1] Rn
     /* 359351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 359355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 359360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359372 */     // MIs[2] Operand 1
     /* 359372 */     // No operand predicates
     /* 359372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359374 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15832>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 359374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 359377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 359384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359394 */     GIR_RootConstrainSelectedInstOperands,
     /* 359395 */     // GIR_Coverage, 7467,
     /* 359395 */     GIR_EraseRootFromParent_Done,
     /* 359396 */   // Label 7189: @359396
     /* 359396 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(359445), // Rule ID 5712 //
     /* 359401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 359409 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 359413 */     // MIs[1] Operand 1
     /* 359413 */     // No operand predicates
     /* 359413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359421 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359425 */     // MIs[2] Operand 1
     /* 359425 */     // No operand predicates
     /* 359425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359427 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 359427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 359430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 359437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 359443 */     GIR_RootConstrainSelectedInstOperands,
     /* 359444 */     // GIR_Coverage, 5712,
     /* 359444 */     GIR_EraseRootFromParent_Done,
     /* 359445 */   // Label 7190: @359445
     /* 359445 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(359546), // Rule ID 5792 //
     /* 359450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 359458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 359462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359475 */     // MIs[2] Operand 1
     /* 359475 */     // No operand predicates
     /* 359475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359477 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 359477 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 359480 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359484 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 359510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359533 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 359538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359544 */     GIR_RootConstrainSelectedInstOperands,
     /* 359545 */     // GIR_Coverage, 5792,
     /* 359545 */     GIR_EraseRootFromParent_Done,
     /* 359546 */   // Label 7191: @359546
     /* 359546 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(359590), // Rule ID 1937 //
     /* 359551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 359566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359574 */     // MIs[1] Operand 1
     /* 359574 */     // No operand predicates
     /* 359574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359576 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 359576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 359579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 359586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 359588 */     GIR_RootConstrainSelectedInstOperands,
     /* 359589 */     // GIR_Coverage, 1937,
     /* 359589 */     GIR_EraseRootFromParent_Done,
     /* 359590 */   // Label 7192: @359590
     /* 359590 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(359686), // Rule ID 5716 //
     /* 359595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 359607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359615 */     // MIs[1] Operand 1
     /* 359615 */     // No operand predicates
     /* 359615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359617 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 359617 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 359620 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359624 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359643 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 359650 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 359678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359684 */     GIR_RootConstrainSelectedInstOperands,
     /* 359685 */     // GIR_Coverage, 5716,
     /* 359685 */     GIR_EraseRootFromParent_Done,
     /* 359686 */   // Label 7193: @359686
     /* 359686 */   GIM_Reject,
     /* 359687 */ // Label 7158: @359687
     /* 359687 */ GIM_Reject,
     /* 359688 */ // Label 7106: @359688
     /* 359688 */ GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(363327),
     /* 359693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 359696 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(359822), // Rule ID 4269 //
     /* 359701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359731 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359734 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359738 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359745 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359755 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 359762 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 359762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 359769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359789 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359821 */     // GIR_Coverage, 4269,
     /* 359821 */     GIR_EraseRootFromParent_Done,
     /* 359822 */   // Label 7195: @359822
     /* 359822 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(359948), // Rule ID 4270 //
     /* 359827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359841 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359847 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359857 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359860 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359864 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359871 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 359888 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 359888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 359895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359915 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359947 */     // GIR_Coverage, 4270,
     /* 359947 */     GIR_EraseRootFromParent_Done,
     /* 359948 */   // Label 7196: @359948
     /* 359948 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(360067), // Rule ID 4377 //
     /* 359953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359967 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359973 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359983 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359990 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360007 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360034 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360066 */     // GIR_Coverage, 4377,
     /* 360066 */     GIR_EraseRootFromParent_Done,
     /* 360067 */   // Label 7197: @360067
     /* 360067 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(360186), // Rule ID 4378 //
     /* 360072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360086 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360092 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360102 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360109 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 360126 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 360133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360153 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360185 */     // GIR_Coverage, 4378,
     /* 360185 */     GIR_EraseRootFromParent_Done,
     /* 360186 */   // Label 7198: @360186
     /* 360186 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(360308), // Rule ID 4275 //
     /* 360191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360217 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360220 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360224 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360231 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360248 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360275 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360307 */     // GIR_Coverage, 4275,
     /* 360307 */     GIR_EraseRootFromParent_Done,
     /* 360308 */   // Label 7199: @360308
     /* 360308 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(360430), // Rule ID 4277 //
     /* 360313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360339 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360342 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360346 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360353 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 360370 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 360377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360397 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360429 */     // GIR_Coverage, 4277,
     /* 360429 */     GIR_EraseRootFromParent_Done,
     /* 360430 */   // Label 7200: @360430
     /* 360430 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(360545), // Rule ID 4383 //
     /* 360435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360461 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360464 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360468 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360485 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360512 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360544 */     // GIR_Coverage, 4383,
     /* 360544 */     GIR_EraseRootFromParent_Done,
     /* 360545 */   // Label 7201: @360545
     /* 360545 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(360660), // Rule ID 4385 //
     /* 360550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360576 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360583 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 360600 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 360607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360627 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360659 */     // GIR_Coverage, 4385,
     /* 360659 */     GIR_EraseRootFromParent_Done,
     /* 360660 */   // Label 7202: @360660
     /* 360660 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(360781), // Rule ID 4267 //
     /* 360665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360679 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360685 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360695 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360698 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360702 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360709 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 360726 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 360726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 360733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360748 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360780 */     // GIR_Coverage, 4267,
     /* 360780 */     GIR_EraseRootFromParent_Done,
     /* 360781 */   // Label 7203: @360781
     /* 360781 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(360902), // Rule ID 4268 //
     /* 360786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360800 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360806 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360816 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360819 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360823 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360830 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 360847 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 360847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 360854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360869 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360891 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360901 */     // GIR_Coverage, 4268,
     /* 360901 */     GIR_EraseRootFromParent_Done,
     /* 360902 */   // Label 7204: @360902
     /* 360902 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(361016), // Rule ID 4375 //
     /* 360907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360921 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360927 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360937 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360944 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 360961 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 360961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 360968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360983 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361015 */     // GIR_Coverage, 4375,
     /* 361015 */     GIR_EraseRootFromParent_Done,
     /* 361016 */   // Label 7205: @361016
     /* 361016 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(361130), // Rule ID 4376 //
     /* 361021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361035 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361041 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361051 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361058 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361068 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361075 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361097 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361129 */     // GIR_Coverage, 4376,
     /* 361129 */     GIR_EraseRootFromParent_Done,
     /* 361130 */   // Label 7206: @361130
     /* 361130 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(361247), // Rule ID 4271 //
     /* 361135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361161 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361164 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361168 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361175 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 361192 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 361192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 361199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361214 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361246 */     // GIR_Coverage, 4271,
     /* 361246 */     GIR_EraseRootFromParent_Done,
     /* 361247 */   // Label 7207: @361247
     /* 361247 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(361364), // Rule ID 4273 //
     /* 361252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361278 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361281 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361285 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361292 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361309 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361331 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361363 */     // GIR_Coverage, 4273,
     /* 361363 */     GIR_EraseRootFromParent_Done,
     /* 361364 */   // Label 7208: @361364
     /* 361364 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(361474), // Rule ID 4379 //
     /* 361369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361395 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361402 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 361419 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 361419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 361426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361441 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361473 */     // GIR_Coverage, 4379,
     /* 361473 */     GIR_EraseRootFromParent_Done,
     /* 361474 */   // Label 7209: @361474
     /* 361474 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(361584), // Rule ID 4381 //
     /* 361479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361505 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361508 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361512 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361529 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361551 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361583 */     // GIR_Coverage, 4381,
     /* 361583 */     GIR_EraseRootFromParent_Done,
     /* 361584 */   // Label 7210: @361584
     /* 361584 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(361714), // Rule ID 6483 //
     /* 361589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361618 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361621 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361625 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361632 */     // MIs[2] Rn
     /* 361632 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 361636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 361641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361647 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 361647 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 361650 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361654 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 361664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 361668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361673 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361676 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 361679 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 361683 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361696 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 361703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361713 */     // GIR_Coverage, 6483,
     /* 361713 */     GIR_EraseRootFromParent_Done,
     /* 361714 */   // Label 7211: @361714
     /* 361714 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(361854), // Rule ID 5732 //
     /* 361719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 361745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361762 */     // MIs[2] Operand 1
     /* 361762 */     // No operand predicates
     /* 361762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361770 */     // MIs[3] Operand 1
     /* 361770 */     // No operand predicates
     /* 361770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361772 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 361772 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 361775 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361779 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361784 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 361787 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 361791 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 361794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 361807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 361811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361816 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 361822 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 361829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361836 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 361843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361853 */     // GIR_Coverage, 5732,
     /* 361853 */     GIR_EraseRootFromParent_Done,
     /* 361854 */   // Label 7212: @361854
     /* 361854 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(362025), // Rule ID 5733 //
     /* 361859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 361885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361902 */     // MIs[2] Operand 1
     /* 361902 */     // No operand predicates
     /* 361902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361910 */     // MIs[3] Operand 1
     /* 361910 */     // No operand predicates
     /* 361910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361912 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 361912 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 361915 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361919 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361924 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 361927 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361931 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 361934 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361939 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 361947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361956 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 361959 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 361963 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 361966 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 361979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 361983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361988 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 361994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 361997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362007 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362024 */     // GIR_Coverage, 5733,
     /* 362024 */     GIR_EraseRootFromParent_Done,
     /* 362025 */   // Label 7213: @362025
     /* 362025 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(362165), // Rule ID 5772 //
     /* 362030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362073 */     // MIs[2] Operand 1
     /* 362073 */     // No operand predicates
     /* 362073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362081 */     // MIs[3] Operand 1
     /* 362081 */     // No operand predicates
     /* 362081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362083 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362083 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 362086 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362090 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362095 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362098 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 362102 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 362122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 362133 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362147 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362164 */     // GIR_Coverage, 5772,
     /* 362164 */     GIR_EraseRootFromParent_Done,
     /* 362165 */   // Label 7214: @362165
     /* 362165 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(362336), // Rule ID 5773 //
     /* 362170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362213 */     // MIs[2] Operand 1
     /* 362213 */     // No operand predicates
     /* 362213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362221 */     // MIs[3] Operand 1
     /* 362221 */     // No operand predicates
     /* 362221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362223 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362223 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 362226 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362230 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362235 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 362238 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362242 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 362245 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362250 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362267 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 362274 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 362294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362299 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 362305 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362318 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362335 */     // GIR_Coverage, 5773,
     /* 362335 */     GIR_EraseRootFromParent_Done,
     /* 362336 */   // Label 7215: @362336
     /* 362336 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(362415), // Rule ID 5685 //
     /* 362341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362369 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 362369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 362372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362381 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 362385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 362404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362414 */     // GIR_Coverage, 5685,
     /* 362414 */     GIR_EraseRootFromParent_Done,
     /* 362415 */   // Label 7216: @362415
     /* 362415 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(362491), // Rule ID 5693 //
     /* 362420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362448 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 362448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 362451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362490 */     // GIR_Coverage, 5693,
     /* 362490 */     GIR_EraseRootFromParent_Done,
     /* 362491 */   // Label 7217: @362491
     /* 362491 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(362567), // Rule ID 5697 //
     /* 362496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362524 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 362524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 362527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362566 */     // GIR_Coverage, 5697,
     /* 362566 */     GIR_EraseRootFromParent_Done,
     /* 362567 */   // Label 7218: @362567
     /* 362567 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(362712), // Rule ID 5709 //
     /* 362572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 362594 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 362598 */     // MIs[1] Operand 1
     /* 362598 */     // No operand predicates
     /* 362598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362606 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362610 */     // MIs[2] Operand 1
     /* 362610 */     // No operand predicates
     /* 362610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362612 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 362612 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 362615 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362619 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 362626 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 362629 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362633 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362638 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 362641 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 362645 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 362670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362675 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 362681 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362694 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362711 */     // GIR_Coverage, 5709,
     /* 362711 */     GIR_EraseRootFromParent_Done,
     /* 362712 */   // Label 7219: @362712
     /* 362712 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(362861), // Rule ID 6487 //
     /* 362717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362739 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362742 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 362746 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362753 */     // MIs[1] Rn
     /* 362753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 362757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362770 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362774 */     // MIs[2] Operand 1
     /* 362774 */     // No operand predicates
     /* 362774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362776 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 362776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362788 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362791 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 362795 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362803 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 362815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362820 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 362826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362830 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362843 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362860 */     // GIR_Coverage, 6487,
     /* 362860 */     GIR_EraseRootFromParent_Done,
     /* 362861 */   // Label 7220: @362861
     /* 362861 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(363003), // Rule ID 6490 //
     /* 362866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 362895 */     // MIs[1] Rn
     /* 362895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 362899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362912 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362916 */     // MIs[2] Operand 1
     /* 362916 */     // No operand predicates
     /* 362916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362918 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 362918 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362921 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362925 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362930 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362933 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 362937 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362940 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362945 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 362957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362962 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 362968 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362972 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362985 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363002 */     // GIR_Coverage, 6490,
     /* 363002 */     GIR_EraseRootFromParent_Done,
     /* 363003 */   // Label 7221: @363003
     /* 363003 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(363191), // Rule ID 5707 //
     /* 363008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 363030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363038 */     // MIs[1] Operand 1
     /* 363038 */     // No operand predicates
     /* 363038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363040 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 363040 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 363043 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363047 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 363054 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 363057 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363061 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363066 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 363069 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 363073 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 363076 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363081 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363086 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363091 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 363094 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363098 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363105 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363108 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363112 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363117 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 363120 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363124 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363137 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363154 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 363160 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 363163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 363166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363173 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363190 */     // GIR_Coverage, 5707,
     /* 363190 */     GIR_EraseRootFromParent_Done,
     /* 363191 */   // Label 7222: @363191
     /* 363191 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(363326), // Rule ID 5718 //
     /* 363196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 363218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363226 */     // MIs[1] Operand 1
     /* 363226 */     // No operand predicates
     /* 363226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363228 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 363228 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 363231 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363235 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363254 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 363257 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363261 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363264 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363269 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 363286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363291 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 363297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 363301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363308 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363325 */     // GIR_Coverage, 5718,
     /* 363325 */     GIR_EraseRootFromParent_Done,
     /* 363326 */   // Label 7223: @363326
     /* 363326 */   GIM_Reject,
     /* 363327 */ // Label 7194: @363327
     /* 363327 */ GIM_Reject,
     /* 363328 */ // Label 7107: @363328
     /* 363328 */ GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(366395),
     /* 363333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363339 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363346 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(363455), // Rule ID 4293 //
     /* 363351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363355 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363361 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363371 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363374 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363378 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363388 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 363395 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 363402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363422 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363454 */     // GIR_Coverage, 4293,
     /* 363454 */     GIR_EraseRootFromParent_Done,
     /* 363455 */   // Label 7225: @363455
     /* 363455 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(363564), // Rule ID 4294 //
     /* 363460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363464 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363470 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363480 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363487 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 363504 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 363511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363531 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363563 */     // GIR_Coverage, 4294,
     /* 363563 */     GIR_EraseRootFromParent_Done,
     /* 363564 */   // Label 7226: @363564
     /* 363564 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(363673), // Rule ID 4401 //
     /* 363569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363573 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363579 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363589 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363592 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363596 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 363613 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 363620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363640 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363672 */     // GIR_Coverage, 4401,
     /* 363672 */     GIR_EraseRootFromParent_Done,
     /* 363673 */   // Label 7227: @363673
     /* 363673 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(363782), // Rule ID 4402 //
     /* 363678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363682 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363688 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363698 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363705 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 363722 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 363729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363749 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363781 */     // GIR_Coverage, 4402,
     /* 363781 */     GIR_EraseRootFromParent_Done,
     /* 363782 */   // Label 7228: @363782
     /* 363782 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(363887), // Rule ID 4299 //
     /* 363787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363803 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363810 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 363827 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 363834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363854 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363886 */     // GIR_Coverage, 4299,
     /* 363886 */     GIR_EraseRootFromParent_Done,
     /* 363887 */   // Label 7229: @363887
     /* 363887 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(363992), // Rule ID 4301 //
     /* 363892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363908 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363915 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 363932 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 363939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363959 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363991 */     // GIR_Coverage, 4301,
     /* 363991 */     GIR_EraseRootFromParent_Done,
     /* 363992 */   // Label 7230: @363992
     /* 363992 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(364097), // Rule ID 4407 //
     /* 363997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364013 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364016 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364020 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 364037 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 364044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364064 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364096 */     // GIR_Coverage, 4407,
     /* 364096 */     GIR_EraseRootFromParent_Done,
     /* 364097 */   // Label 7231: @364097
     /* 364097 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(364202), // Rule ID 4409 //
     /* 364102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364118 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364121 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364125 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 364142 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 364149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364169 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364201 */     // GIR_Coverage, 4409,
     /* 364201 */     GIR_EraseRootFromParent_Done,
     /* 364202 */   // Label 7232: @364202
     /* 364202 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(364306), // Rule ID 4291 //
     /* 364207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364211 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364217 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364227 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364234 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 364251 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 364251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 364258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364273 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364305 */     // GIR_Coverage, 4291,
     /* 364305 */     GIR_EraseRootFromParent_Done,
     /* 364306 */   // Label 7233: @364306
     /* 364306 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(364410), // Rule ID 4292 //
     /* 364311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364331 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364338 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 364355 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 364355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 364362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364377 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364409 */     // GIR_Coverage, 4292,
     /* 364409 */     GIR_EraseRootFromParent_Done,
     /* 364410 */   // Label 7234: @364410
     /* 364410 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(364514), // Rule ID 4399 //
     /* 364415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364419 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364425 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364435 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364438 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364442 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 364459 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 364459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 364466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364481 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364513 */     // GIR_Coverage, 4399,
     /* 364513 */     GIR_EraseRootFromParent_Done,
     /* 364514 */   // Label 7235: @364514
     /* 364514 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(364618), // Rule ID 4400 //
     /* 364519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364539 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364542 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364546 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 364563 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 364563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 364570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364585 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364617 */     // GIR_Coverage, 4400,
     /* 364617 */     GIR_EraseRootFromParent_Done,
     /* 364618 */   // Label 7236: @364618
     /* 364618 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(364718), // Rule ID 4295 //
     /* 364623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364639 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364642 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364646 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 364663 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 364663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 364670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364685 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364717 */     // GIR_Coverage, 4295,
     /* 364717 */     GIR_EraseRootFromParent_Done,
     /* 364718 */   // Label 7237: @364718
     /* 364718 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(364818), // Rule ID 4297 //
     /* 364723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364739 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364742 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364746 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 364763 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 364763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 364770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364785 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364817 */     // GIR_Coverage, 4297,
     /* 364817 */     GIR_EraseRootFromParent_Done,
     /* 364818 */   // Label 7238: @364818
     /* 364818 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(364918), // Rule ID 4403 //
     /* 364823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364839 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364846 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 364863 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 364863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 364870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364885 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364917 */     // GIR_Coverage, 4403,
     /* 364917 */     GIR_EraseRootFromParent_Done,
     /* 364918 */   // Label 7239: @364918
     /* 364918 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(365018), // Rule ID 4405 //
     /* 364923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364939 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364946 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 364963 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 364963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 364970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364985 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365017 */     // GIR_Coverage, 4405,
     /* 365017 */     GIR_EraseRootFromParent_Done,
     /* 365018 */   // Label 7240: @365018
     /* 365018 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(365131), // Rule ID 5738 //
     /* 365023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365060 */     // MIs[3] Operand 1
     /* 365060 */     // No operand predicates
     /* 365060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365066 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 365066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 365069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 365073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365078 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 365082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 365085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365130 */     // GIR_Coverage, 5738,
     /* 365130 */     GIR_EraseRootFromParent_Done,
     /* 365131 */   // Label 7241: @365131
     /* 365131 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(365244), // Rule ID 5778 //
     /* 365136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365173 */     // MIs[3] Operand 1
     /* 365173 */     // No operand predicates
     /* 365173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365179 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 365179 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 365182 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 365186 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 365195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 365198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365243 */     // GIR_Coverage, 5778,
     /* 365243 */     GIR_EraseRootFromParent_Done,
     /* 365244 */   // Label 7242: @365244
     /* 365244 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(365322), // Rule ID 1940 //
     /* 365249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365289 */     // MIs[2] Operand 1
     /* 365289 */     // No operand predicates
     /* 365289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365297 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365301 */     // MIs[3] Operand 1
     /* 365301 */     // No operand predicates
     /* 365301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365303 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 365303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 365310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 365313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 365320 */     GIR_RootConstrainSelectedInstOperands,
     /* 365321 */     // GIR_Coverage, 1940,
     /* 365321 */     GIR_EraseRootFromParent_Done,
     /* 365322 */   // Label 7243: @365322
     /* 365322 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(365411), // Rule ID 5735 //
     /* 365327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365351 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365355 */     // MIs[2] Operand 1
     /* 365355 */     // No operand predicates
     /* 365355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365363 */     // MIs[3] Operand 1
     /* 365363 */     // No operand predicates
     /* 365363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365365 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 365365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365377 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 365383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365409 */     GIR_RootConstrainSelectedInstOperands,
     /* 365410 */     // GIR_Coverage, 5735,
     /* 365410 */     GIR_EraseRootFromParent_Done,
     /* 365411 */   // Label 7244: @365411
     /* 365411 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(365500), // Rule ID 5775 //
     /* 365416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365444 */     // MIs[2] Operand 1
     /* 365444 */     // No operand predicates
     /* 365444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365452 */     // MIs[3] Operand 1
     /* 365452 */     // No operand predicates
     /* 365452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365454 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 365454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365466 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 365472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365498 */     GIR_RootConstrainSelectedInstOperands,
     /* 365499 */     // GIR_Coverage, 5775,
     /* 365499 */     GIR_EraseRootFromParent_Done,
     /* 365500 */   // Label 7245: @365500
     /* 365500 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(365567), // Rule ID 5737 //
     /* 365505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365538 */     // MIs[2] Operand 1
     /* 365538 */     // No operand predicates
     /* 365538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365546 */     // MIs[3] Operand 1
     /* 365546 */     // No operand predicates
     /* 365546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365548 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 365548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 365555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365565 */     GIR_RootConstrainSelectedInstOperands,
     /* 365566 */     // GIR_Coverage, 5737,
     /* 365566 */     GIR_EraseRootFromParent_Done,
     /* 365567 */   // Label 7246: @365567
     /* 365567 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(365665), // Rule ID 5739 //
     /* 365572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 365588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365605 */     // MIs[2] Operand 1
     /* 365605 */     // No operand predicates
     /* 365605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365613 */     // MIs[3] Operand 1
     /* 365613 */     // No operand predicates
     /* 365613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365615 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 365615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365634 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 365637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365652 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 365654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365663 */     GIR_RootConstrainSelectedInstOperands,
     /* 365664 */     // GIR_Coverage, 5739,
     /* 365664 */     GIR_EraseRootFromParent_Done,
     /* 365665 */   // Label 7247: @365665
     /* 365665 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(365732), // Rule ID 5777 //
     /* 365670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365703 */     // MIs[2] Operand 1
     /* 365703 */     // No operand predicates
     /* 365703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365711 */     // MIs[3] Operand 1
     /* 365711 */     // No operand predicates
     /* 365711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365713 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 365713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 365720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365730 */     GIR_RootConstrainSelectedInstOperands,
     /* 365731 */     // GIR_Coverage, 5777,
     /* 365731 */     GIR_EraseRootFromParent_Done,
     /* 365732 */   // Label 7248: @365732
     /* 365732 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(365830), // Rule ID 5779 //
     /* 365737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 365753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365770 */     // MIs[2] Operand 1
     /* 365770 */     // No operand predicates
     /* 365770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365778 */     // MIs[3] Operand 1
     /* 365778 */     // No operand predicates
     /* 365778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365780 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 365780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365792 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365799 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 365802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 365819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365828 */     GIR_RootConstrainSelectedInstOperands,
     /* 365829 */     // GIR_Coverage, 5779,
     /* 365829 */     GIR_EraseRootFromParent_Done,
     /* 365830 */   // Label 7249: @365830
     /* 365830 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(365896), // Rule ID 5689 //
     /* 365835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365853 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), GPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 365853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365895 */     // GIR_Coverage, 5689,
     /* 365895 */     GIR_EraseRootFromParent_Done,
     /* 365896 */   // Label 7250: @365896
     /* 365896 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(365962), // Rule ID 5701 //
     /* 365901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365919 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 365919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365961 */     // GIR_Coverage, 5701,
     /* 365961 */     GIR_EraseRootFromParent_Done,
     /* 365962 */   // Label 7251: @365962
     /* 365962 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(366015), // Rule ID 5710 //
     /* 365967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365979 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365983 */     // MIs[1] Operand 1
     /* 365983 */     // No operand predicates
     /* 365983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 365987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365991 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365995 */     // MIs[2] Operand 1
     /* 365995 */     // No operand predicates
     /* 365995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365997 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 365997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 366000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 366007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366013 */     GIR_RootConstrainSelectedInstOperands,
     /* 366014 */     // GIR_Coverage, 5710,
     /* 366014 */     GIR_EraseRootFromParent_Done,
     /* 366015 */   // Label 7252: @366015
     /* 366015 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(366084), // Rule ID 6468 //
     /* 366020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 366039 */     // MIs[1] Rn
     /* 366039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 366043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 366048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366060 */     // MIs[2] Operand 1
     /* 366060 */     // No operand predicates
     /* 366060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366062 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 366062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 366065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366082 */     GIR_RootConstrainSelectedInstOperands,
     /* 366083 */     // GIR_Coverage, 6468,
     /* 366083 */     GIR_EraseRootFromParent_Done,
     /* 366084 */   // Label 7253: @366084
     /* 366084 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(366153), // Rule ID 6469 //
     /* 366089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 366108 */     // MIs[1] Rn
     /* 366108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 366112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 366117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366129 */     // MIs[2] Operand 1
     /* 366129 */     // No operand predicates
     /* 366129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366131 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 366131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 366134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366151 */     GIR_RootConstrainSelectedInstOperands,
     /* 366152 */     // GIR_Coverage, 6469,
     /* 366152 */     GIR_EraseRootFromParent_Done,
     /* 366153 */   // Label 7254: @366153
     /* 366153 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(366254), // Rule ID 5790 //
     /* 366158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 366166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366183 */     // MIs[2] Operand 1
     /* 366183 */     // No operand predicates
     /* 366183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366185 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 366188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366211 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 366218 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 366221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366241 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 366246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366252 */     GIR_RootConstrainSelectedInstOperands,
     /* 366253 */     // GIR_Coverage, 5790,
     /* 366253 */     GIR_EraseRootFromParent_Done,
     /* 366254 */   // Label 7255: @366254
     /* 366254 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(366298), // Rule ID 1936 //
     /* 366259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 366274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366282 */     // MIs[1] Operand 1
     /* 366282 */     // No operand predicates
     /* 366282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366284 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 366284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 366287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 366294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366296 */     GIR_RootConstrainSelectedInstOperands,
     /* 366297 */     // GIR_Coverage, 1936,
     /* 366297 */     GIR_EraseRootFromParent_Done,
     /* 366298 */   // Label 7256: @366298
     /* 366298 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(366394), // Rule ID 5715 //
     /* 366303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 366315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366323 */     // MIs[1] Operand 1
     /* 366323 */     // No operand predicates
     /* 366323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366325 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366325 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 366328 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366332 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366351 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 366358 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 366361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 366386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366392 */     GIR_RootConstrainSelectedInstOperands,
     /* 366393 */     // GIR_Coverage, 5715,
     /* 366393 */     GIR_EraseRootFromParent_Done,
     /* 366394 */   // Label 7257: @366394
     /* 366394 */   GIM_Reject,
     /* 366395 */ // Label 7224: @366395
     /* 366395 */ GIM_Reject,
     /* 366396 */ // Label 7108: @366396
     /* 366396 */ GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(369608),
     /* 366401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 366404 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(366523), // Rule ID 4197 //
     /* 366409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 366412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366423 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366429 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366439 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366442 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366446 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 366463 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 366463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 366466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 366470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366490 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 366512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 366522 */     // GIR_Coverage, 4197,
     /* 366522 */     GIR_EraseRootFromParent_Done,
     /* 366523 */   // Label 7259: @366523
     /* 366523 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(366642), // Rule ID 4198 //
     /* 366528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 366531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366542 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366548 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366558 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366565 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366575 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 366582 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 366582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 366585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 366589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366609 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 366631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 366641 */     // GIR_Coverage, 4198,
     /* 366641 */     GIR_EraseRootFromParent_Done,
     /* 366642 */   // Label 7260: @366642
     /* 366642 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(366768), // Rule ID 4233 //
     /* 366647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 366650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366661 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366667 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366677 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366680 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366684 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 366691 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 366708 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 366708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 366711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 366715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366735 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 366757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 366767 */     // GIR_Coverage, 4233,
     /* 366767 */     GIR_EraseRootFromParent_Done,
     /* 366768 */   // Label 7261: @366768
     /* 366768 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(366894), // Rule ID 4234 //
     /* 366773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 366776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366787 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366793 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366803 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366806 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366810 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 366817 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 366834 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 366834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 366837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 366841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366861 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 366883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 366893 */     // GIR_Coverage, 4234,
     /* 366893 */     GIR_EraseRootFromParent_Done,
     /* 366894 */   // Label 7262: @366894
     /* 366894 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(367009), // Rule ID 4203 //
     /* 366899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 366902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366925 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366932 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 366949 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 366949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 366952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 366956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366976 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 366998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367008 */     // GIR_Coverage, 4203,
     /* 367008 */     GIR_EraseRootFromParent_Done,
     /* 367009 */   // Label 7263: @367009
     /* 367009 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(367124), // Rule ID 4205 //
     /* 367014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367040 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367043 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367047 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 367064 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 367071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367091 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367123 */     // GIR_Coverage, 4205,
     /* 367123 */     GIR_EraseRootFromParent_Done,
     /* 367124 */   // Label 7264: @367124
     /* 367124 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(367246), // Rule ID 4239 //
     /* 367129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367155 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367158 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367162 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367169 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 367186 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 367193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367213 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367245 */     // GIR_Coverage, 4239,
     /* 367245 */     GIR_EraseRootFromParent_Done,
     /* 367246 */   // Label 7265: @367246
     /* 367246 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(367368), // Rule ID 4241 //
     /* 367251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367277 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367280 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367284 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367291 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 367308 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 367315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367335 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367367 */     // GIR_Coverage, 4241,
     /* 367367 */     GIR_EraseRootFromParent_Done,
     /* 367368 */   // Label 7266: @367368
     /* 367368 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(367482), // Rule ID 4195 //
     /* 367373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367387 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367393 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367403 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367410 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 367427 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 367427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 367434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367449 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367481 */     // GIR_Coverage, 4195,
     /* 367481 */     GIR_EraseRootFromParent_Done,
     /* 367482 */   // Label 7267: @367482
     /* 367482 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(367596), // Rule ID 4196 //
     /* 367487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367507 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367517 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367520 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367524 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 367541 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 367541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 367548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367563 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367595 */     // GIR_Coverage, 4196,
     /* 367595 */     GIR_EraseRootFromParent_Done,
     /* 367596 */   // Label 7268: @367596
     /* 367596 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(367717), // Rule ID 4231 //
     /* 367601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367615 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367621 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367631 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367634 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367638 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367645 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367655 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 367662 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 367662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 367669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367684 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367716 */     // GIR_Coverage, 4231,
     /* 367716 */     GIR_EraseRootFromParent_Done,
     /* 367717 */   // Label 7269: @367717
     /* 367717 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(367838), // Rule ID 4232 //
     /* 367722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367736 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367742 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367752 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367755 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367759 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367766 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 367783 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 367783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 367790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367805 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367837 */     // GIR_Coverage, 4232,
     /* 367837 */     GIR_EraseRootFromParent_Done,
     /* 367838 */   // Label 7270: @367838
     /* 367838 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(367948), // Rule ID 4199 //
     /* 367843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367869 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367876 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 367893 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 367893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 367900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367915 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367947 */     // GIR_Coverage, 4199,
     /* 367947 */     GIR_EraseRootFromParent_Done,
     /* 367948 */   // Label 7271: @367948
     /* 367948 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(368058), // Rule ID 4201 //
     /* 367953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367979 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367986 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368003 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368025 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368057 */     // GIR_Coverage, 4201,
     /* 368057 */     GIR_EraseRootFromParent_Done,
     /* 368058 */   // Label 7272: @368058
     /* 368058 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(368175), // Rule ID 4235 //
     /* 368063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368089 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368092 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368096 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368103 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 368120 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 368120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 368127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368142 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368174 */     // GIR_Coverage, 4235,
     /* 368174 */     GIR_EraseRootFromParent_Done,
     /* 368175 */   // Label 7273: @368175
     /* 368175 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(368292), // Rule ID 4237 //
     /* 368180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368206 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368209 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368213 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368220 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368237 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368259 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368291 */     // GIR_Coverage, 4237,
     /* 368291 */     GIR_EraseRootFromParent_Done,
     /* 368292 */   // Label 7274: @368292
     /* 368292 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(368432), // Rule ID 5756 //
     /* 368297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 368323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368340 */     // MIs[2] Operand 1
     /* 368340 */     // No operand predicates
     /* 368340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368348 */     // MIs[3] Operand 1
     /* 368348 */     // No operand predicates
     /* 368348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368350 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 368350 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 368353 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368357 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368362 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 368365 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368369 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 368372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368377 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 368389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368394 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 368400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 368407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368414 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368431 */     // GIR_Coverage, 5756,
     /* 368431 */     GIR_EraseRootFromParent_Done,
     /* 368432 */   // Label 7275: @368432
     /* 368432 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(368603), // Rule ID 5757 //
     /* 368437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 368463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368480 */     // MIs[2] Operand 1
     /* 368480 */     // No operand predicates
     /* 368480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368488 */     // MIs[3] Operand 1
     /* 368488 */     // No operand predicates
     /* 368488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368490 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 368490 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 368493 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368497 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368502 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 368505 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368509 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 368512 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368517 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 368525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368534 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 368537 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368541 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 368544 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368549 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 368561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368566 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 368572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 368575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 368578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368585 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368602 */     // GIR_Coverage, 5757,
     /* 368602 */     GIR_EraseRootFromParent_Done,
     /* 368603 */   // Label 7276: @368603
     /* 368603 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(368743), // Rule ID 5764 //
     /* 368608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 368634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368651 */     // MIs[2] Operand 1
     /* 368651 */     // No operand predicates
     /* 368651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368659 */     // MIs[3] Operand 1
     /* 368659 */     // No operand predicates
     /* 368659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368661 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 368661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 368664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368673 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 368676 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368680 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 368683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 368700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368705 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 368711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 368718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368725 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368742 */     // GIR_Coverage, 5764,
     /* 368742 */     GIR_EraseRootFromParent_Done,
     /* 368743 */   // Label 7277: @368743
     /* 368743 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(368914), // Rule ID 5765 //
     /* 368748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 368774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368791 */     // MIs[2] Operand 1
     /* 368791 */     // No operand predicates
     /* 368791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368799 */     // MIs[3] Operand 1
     /* 368799 */     // No operand predicates
     /* 368799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368801 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 368801 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 368804 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368808 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368813 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 368816 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368820 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 368823 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368828 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368833 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 368836 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368840 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368845 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 368848 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368852 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 368855 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 368872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368877 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 368883 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 368886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 368889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368896 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368913 */     // GIR_Coverage, 5765,
     /* 368913 */     GIR_EraseRootFromParent_Done,
     /* 368914 */   // Label 7278: @368914
     /* 368914 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(368993), // Rule ID 5680 //
     /* 368919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368947 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 368947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 368963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 368982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368992 */     // GIR_Coverage, 5680,
     /* 368992 */     GIR_EraseRootFromParent_Done,
     /* 368993 */   // Label 7279: @368993
     /* 368993 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(369135), // Rule ID 6485 //
     /* 368998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 369027 */     // MIs[1] Rn
     /* 369027 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 369031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369044 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369048 */     // MIs[2] Operand 1
     /* 369048 */     // No operand predicates
     /* 369048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369050 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 369050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369062 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369065 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 369069 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369072 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369077 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 369089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369094 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 369100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369104 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369117 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369134 */     // GIR_Coverage, 6485,
     /* 369134 */     GIR_EraseRootFromParent_Done,
     /* 369135 */   // Label 7280: @369135
     /* 369135 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(369284), // Rule ID 6486 //
     /* 369140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369162 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369165 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 369169 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369176 */     // MIs[1] Rn
     /* 369176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 369180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369193 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369197 */     // MIs[2] Operand 1
     /* 369197 */     // No operand predicates
     /* 369197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369199 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 369199 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369202 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369206 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369214 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 369218 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369221 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369226 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 369238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369243 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 369249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369253 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369266 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369283 */     // GIR_Coverage, 6486,
     /* 369283 */     GIR_EraseRootFromParent_Done,
     /* 369284 */   // Label 7281: @369284
     /* 369284 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(369419), // Rule ID 5719 //
     /* 369289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369319 */     // MIs[1] Operand 1
     /* 369319 */     // No operand predicates
     /* 369319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369321 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 369321 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 369324 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369328 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369335 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 369338 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369342 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369347 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 369350 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369354 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369357 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369367 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 369379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369384 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 369390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 369394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369418 */     // GIR_Coverage, 5719,
     /* 369418 */     GIR_EraseRootFromParent_Done,
     /* 369419 */   // Label 7282: @369419
     /* 369419 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(369607), // Rule ID 5720 //
     /* 369424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369454 */     // MIs[1] Operand 1
     /* 369454 */     // No operand predicates
     /* 369454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369456 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 369456 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 369459 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369463 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 369470 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 369473 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369477 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369482 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 369485 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 369489 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 369492 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369497 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369502 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369507 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 369510 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369514 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369521 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 369524 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369528 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369533 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 369536 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369540 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369543 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369548 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369553 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 369576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 369579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369589 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369606 */     // GIR_Coverage, 5720,
     /* 369606 */     GIR_EraseRootFromParent_Done,
     /* 369607 */   // Label 7283: @369607
     /* 369607 */   GIM_Reject,
     /* 369608 */ // Label 7258: @369608
     /* 369608 */ GIM_Reject,
     /* 369609 */ // Label 7109: @369609
     /* 369609 */ GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(373027),
     /* 369614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369617 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(369743), // Rule ID 4257 //
     /* 369622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369636 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369642 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369652 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369655 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369659 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 369666 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 369683 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 369683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 369686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 369690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 369732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369742 */     // GIR_Coverage, 4257,
     /* 369742 */     GIR_EraseRootFromParent_Done,
     /* 369743 */   // Label 7285: @369743
     /* 369743 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(369869), // Rule ID 4258 //
     /* 369748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369762 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369768 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369778 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369781 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369785 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 369792 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 369809 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 369809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 369812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 369816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369836 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 369858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369868 */     // GIR_Coverage, 4258,
     /* 369868 */     GIR_EraseRootFromParent_Done,
     /* 369869 */   // Label 7286: @369869
     /* 369869 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(369988), // Rule ID 4365 //
     /* 369874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 369877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369888 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369894 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369904 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369911 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 369928 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 369928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 369931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 369935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 369977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369987 */     // GIR_Coverage, 4365,
     /* 369987 */     GIR_EraseRootFromParent_Done,
     /* 369988 */   // Label 7287: @369988
     /* 369988 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(370107), // Rule ID 4366 //
     /* 369993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 369996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370007 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370013 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370023 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370030 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370047 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 370054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370074 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370106 */     // GIR_Coverage, 4366,
     /* 370106 */     GIR_EraseRootFromParent_Done,
     /* 370107 */   // Label 7288: @370107
     /* 370107 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(370229), // Rule ID 4263 //
     /* 370112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370138 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370141 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370145 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370152 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 370169 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 370176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370196 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370218 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370228 */     // GIR_Coverage, 4263,
     /* 370228 */     GIR_EraseRootFromParent_Done,
     /* 370229 */   // Label 7289: @370229
     /* 370229 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(370351), // Rule ID 4265 //
     /* 370234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370260 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370263 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370267 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370274 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370291 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 370298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370318 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370350 */     // GIR_Coverage, 4265,
     /* 370350 */     GIR_EraseRootFromParent_Done,
     /* 370351 */   // Label 7290: @370351
     /* 370351 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(370466), // Rule ID 4371 //
     /* 370356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370382 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370385 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370389 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 370406 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 370413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370433 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370465 */     // GIR_Coverage, 4371,
     /* 370465 */     GIR_EraseRootFromParent_Done,
     /* 370466 */   // Label 7291: @370466
     /* 370466 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(370581), // Rule ID 4373 //
     /* 370471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370497 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370500 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370504 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370521 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 370528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370548 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370580 */     // GIR_Coverage, 4373,
     /* 370580 */     GIR_EraseRootFromParent_Done,
     /* 370581 */   // Label 7292: @370581
     /* 370581 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(370702), // Rule ID 4255 //
     /* 370586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370600 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370606 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370616 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370619 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370623 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370630 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 370647 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 370647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 370654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370669 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370701 */     // GIR_Coverage, 4255,
     /* 370701 */     GIR_EraseRootFromParent_Done,
     /* 370702 */   // Label 7293: @370702
     /* 370702 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(370823), // Rule ID 4256 //
     /* 370707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370737 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370740 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370744 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370751 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 370768 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 370768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 370775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370790 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370822 */     // GIR_Coverage, 4256,
     /* 370822 */     GIR_EraseRootFromParent_Done,
     /* 370823 */   // Label 7294: @370823
     /* 370823 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(370937), // Rule ID 4363 //
     /* 370828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370842 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370848 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370858 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370865 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 370882 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 370882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 370889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370904 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370936 */     // GIR_Coverage, 4363,
     /* 370936 */     GIR_EraseRootFromParent_Done,
     /* 370937 */   // Label 7295: @370937
     /* 370937 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(371051), // Rule ID 4364 //
     /* 370942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370956 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370962 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370972 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370979 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 370996 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 370996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371018 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371050 */     // GIR_Coverage, 4364,
     /* 371050 */     GIR_EraseRootFromParent_Done,
     /* 371051 */   // Label 7296: @371051
     /* 371051 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(371168), // Rule ID 4259 //
     /* 371056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371082 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371085 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371089 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371096 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 371113 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 371113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 371120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371135 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371167 */     // GIR_Coverage, 4259,
     /* 371167 */     GIR_EraseRootFromParent_Done,
     /* 371168 */   // Label 7297: @371168
     /* 371168 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(371285), // Rule ID 4261 //
     /* 371173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371199 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371202 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371206 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371213 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 371230 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 371230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371252 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371284 */     // GIR_Coverage, 4261,
     /* 371284 */     GIR_EraseRootFromParent_Done,
     /* 371285 */   // Label 7298: @371285
     /* 371285 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(371395), // Rule ID 4367 //
     /* 371290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371316 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371323 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 371340 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 371340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 371347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371362 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371394 */     // GIR_Coverage, 4367,
     /* 371394 */     GIR_EraseRootFromParent_Done,
     /* 371395 */   // Label 7299: @371395
     /* 371395 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(371505), // Rule ID 4369 //
     /* 371400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371426 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371429 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371433 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 371450 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 371450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371472 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371504 */     // GIR_Coverage, 4369,
     /* 371504 */     GIR_EraseRootFromParent_Done,
     /* 371505 */   // Label 7300: @371505
     /* 371505 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(371628), // Rule ID 5730 //
     /* 371510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371557 */     // MIs[3] Operand 1
     /* 371557 */     // No operand predicates
     /* 371557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371563 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 371563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 371566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 371570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371575 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 371579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 371582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 371584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 371587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371627 */     // GIR_Coverage, 5730,
     /* 371627 */     GIR_EraseRootFromParent_Done,
     /* 371628 */   // Label 7301: @371628
     /* 371628 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(371751), // Rule ID 5770 //
     /* 371633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371680 */     // MIs[3] Operand 1
     /* 371680 */     // No operand predicates
     /* 371680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371686 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 371686 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 371689 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 371693 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371698 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 371702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 371705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 371707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 371710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371750 */     // GIR_Coverage, 5770,
     /* 371750 */     GIR_EraseRootFromParent_Done,
     /* 371751 */   // Label 7302: @371751
     /* 371751 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(371839), // Rule ID 1939 //
     /* 371756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371802 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371806 */     // MIs[2] Operand 1
     /* 371806 */     // No operand predicates
     /* 371806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371814 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371818 */     // MIs[3] Operand 1
     /* 371818 */     // No operand predicates
     /* 371818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371820 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 371820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 371823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 371827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 371830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 371837 */     GIR_RootConstrainSelectedInstOperands,
     /* 371838 */     // GIR_Coverage, 1939,
     /* 371838 */     GIR_EraseRootFromParent_Done,
     /* 371839 */   // Label 7303: @371839
     /* 371839 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(371938), // Rule ID 5727 //
     /* 371844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 371866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371878 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371882 */     // MIs[2] Operand 1
     /* 371882 */     // No operand predicates
     /* 371882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371890 */     // MIs[3] Operand 1
     /* 371890 */     // No operand predicates
     /* 371890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371892 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 371892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 371895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371904 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 371910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 371920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 371923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 371927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 371930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 371936 */     GIR_RootConstrainSelectedInstOperands,
     /* 371937 */     // GIR_Coverage, 5727,
     /* 371937 */     GIR_EraseRootFromParent_Done,
     /* 371938 */   // Label 7304: @371938
     /* 371938 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(372037), // Rule ID 5767 //
     /* 371943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 371965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371981 */     // MIs[2] Operand 1
     /* 371981 */     // No operand predicates
     /* 371981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371989 */     // MIs[3] Operand 1
     /* 371989 */     // No operand predicates
     /* 371989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371991 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 371991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 371994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372003 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 372009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 372019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372035 */     GIR_RootConstrainSelectedInstOperands,
     /* 372036 */     // GIR_Coverage, 5767,
     /* 372036 */     GIR_EraseRootFromParent_Done,
     /* 372037 */   // Label 7305: @372037
     /* 372037 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(372114), // Rule ID 5729 //
     /* 372042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372085 */     // MIs[2] Operand 1
     /* 372085 */     // No operand predicates
     /* 372085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372093 */     // MIs[3] Operand 1
     /* 372093 */     // No operand predicates
     /* 372093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372095 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 372095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372100 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372112 */     GIR_RootConstrainSelectedInstOperands,
     /* 372113 */     // GIR_Coverage, 5729,
     /* 372113 */     GIR_EraseRootFromParent_Done,
     /* 372114 */   // Label 7306: @372114
     /* 372114 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(372222), // Rule ID 5731 //
     /* 372119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372162 */     // MIs[2] Operand 1
     /* 372162 */     // No operand predicates
     /* 372162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372170 */     // MIs[3] Operand 1
     /* 372170 */     // No operand predicates
     /* 372170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372172 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 372172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372184 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 372187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372191 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372209 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372220 */     GIR_RootConstrainSelectedInstOperands,
     /* 372221 */     // GIR_Coverage, 5731,
     /* 372221 */     GIR_EraseRootFromParent_Done,
     /* 372222 */   // Label 7307: @372222
     /* 372222 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(372299), // Rule ID 5769 //
     /* 372227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372270 */     // MIs[2] Operand 1
     /* 372270 */     // No operand predicates
     /* 372270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372278 */     // MIs[3] Operand 1
     /* 372278 */     // No operand predicates
     /* 372278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372280 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 372280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372297 */     GIR_RootConstrainSelectedInstOperands,
     /* 372298 */     // GIR_Coverage, 5769,
     /* 372298 */     GIR_EraseRootFromParent_Done,
     /* 372299 */   // Label 7308: @372299
     /* 372299 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(372407), // Rule ID 5771 //
     /* 372304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372347 */     // MIs[2] Operand 1
     /* 372347 */     // No operand predicates
     /* 372347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372355 */     // MIs[3] Operand 1
     /* 372355 */     // No operand predicates
     /* 372355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372357 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 372357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372369 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 372372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372376 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372405 */     GIR_RootConstrainSelectedInstOperands,
     /* 372406 */     // GIR_Coverage, 5771,
     /* 372406 */     GIR_EraseRootFromParent_Done,
     /* 372407 */   // Label 7309: @372407
     /* 372407 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(372486), // Rule ID 5683 //
     /* 372412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372440 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 372440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 372456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 372475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372485 */     // GIR_Coverage, 5683,
     /* 372485 */     GIR_EraseRootFromParent_Done,
     /* 372486 */   // Label 7310: @372486
     /* 372486 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(372562), // Rule ID 5695 //
     /* 372491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372519 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 372519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372561 */     // GIR_Coverage, 5695,
     /* 372561 */     GIR_EraseRootFromParent_Done,
     /* 372562 */   // Label 7311: @372562
     /* 372562 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(372638), // Rule ID 5699 //
     /* 372567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372595 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 372595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372637 */     // GIR_Coverage, 5699,
     /* 372637 */     GIR_EraseRootFromParent_Done,
     /* 372638 */   // Label 7312: @372638
     /* 372638 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(372701), // Rule ID 5708 //
     /* 372643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 372665 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 372669 */     // MIs[1] Operand 1
     /* 372669 */     // No operand predicates
     /* 372669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 372673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372677 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372681 */     // MIs[2] Operand 1
     /* 372681 */     // No operand predicates
     /* 372681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372683 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 372683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 372686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 372693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 372699 */     GIR_RootConstrainSelectedInstOperands,
     /* 372700 */     // GIR_Coverage, 5708,
     /* 372700 */     GIR_EraseRootFromParent_Done,
     /* 372701 */   // Label 7313: @372701
     /* 372701 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(372787), // Rule ID 6467 //
     /* 372706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372731 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 372735 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372742 */     // MIs[1] Rn
     /* 372742 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 372746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 372751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 372755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372763 */     // MIs[2] Operand 1
     /* 372763 */     // No operand predicates
     /* 372763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372765 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 372765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 372768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 372772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372785 */     GIR_RootConstrainSelectedInstOperands,
     /* 372786 */     // GIR_Coverage, 6467,
     /* 372786 */     GIR_EraseRootFromParent_Done,
     /* 372787 */   // Label 7314: @372787
     /* 372787 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(372866), // Rule ID 6472 //
     /* 372792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372814 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 372821 */     // MIs[1] Rn
     /* 372821 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 372825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 372830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 372834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372838 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372842 */     // MIs[2] Operand 1
     /* 372842 */     // No operand predicates
     /* 372842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372844 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 372844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 372847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 372851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372864 */     GIR_RootConstrainSelectedInstOperands,
     /* 372865 */     // GIR_Coverage, 6472,
     /* 372865 */     GIR_EraseRootFromParent_Done,
     /* 372866 */   // Label 7315: @372866
     /* 372866 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(372920), // Rule ID 1935 //
     /* 372871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372904 */     // MIs[1] Operand 1
     /* 372904 */     // No operand predicates
     /* 372904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372906 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 372906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 372909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 372913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 372916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372918 */     GIR_RootConstrainSelectedInstOperands,
     /* 372919 */     // GIR_Coverage, 1935,
     /* 372919 */     GIR_EraseRootFromParent_Done,
     /* 372920 */   // Label 7316: @372920
     /* 372920 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(373026), // Rule ID 5713 //
     /* 372925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372955 */     // MIs[1] Operand 1
     /* 372955 */     // No operand predicates
     /* 372955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372957 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 372957 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 372960 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372964 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 372990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 372993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 373018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373024 */     GIR_RootConstrainSelectedInstOperands,
     /* 373025 */     // GIR_Coverage, 5713,
     /* 373025 */     GIR_EraseRootFromParent_Done,
     /* 373026 */   // Label 7317: @373026
     /* 373026 */   GIM_Reject,
     /* 373027 */ // Label 7284: @373027
     /* 373027 */ GIM_Reject,
     /* 373028 */ // Label 7110: @373028
     /* 373028 */ GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(376231),
     /* 373033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 373036 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(373155), // Rule ID 4185 //
     /* 373041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373055 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373061 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373071 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373078 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 373095 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 373102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373122 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373154 */     // GIR_Coverage, 4185,
     /* 373154 */     GIR_EraseRootFromParent_Done,
     /* 373155 */   // Label 7319: @373155
     /* 373155 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(373274), // Rule ID 4186 //
     /* 373160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373174 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373180 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373190 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373197 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 373214 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 373221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373241 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373273 */     // GIR_Coverage, 4186,
     /* 373273 */     GIR_EraseRootFromParent_Done,
     /* 373274 */   // Label 7320: @373274
     /* 373274 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(373400), // Rule ID 4221 //
     /* 373279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373293 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373299 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373309 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373312 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373316 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 373323 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 373340 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 373347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373367 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373399 */     // GIR_Coverage, 4221,
     /* 373399 */     GIR_EraseRootFromParent_Done,
     /* 373400 */   // Label 7321: @373400
     /* 373400 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(373526), // Rule ID 4222 //
     /* 373405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373419 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373425 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373435 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373438 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373442 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 373449 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 373466 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 373473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373493 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373525 */     // GIR_Coverage, 4222,
     /* 373525 */     GIR_EraseRootFromParent_Done,
     /* 373526 */   // Label 7322: @373526
     /* 373526 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(373641), // Rule ID 4191 //
     /* 373531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373557 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373560 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373564 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 373581 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 373588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373608 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373640 */     // GIR_Coverage, 4191,
     /* 373640 */     GIR_EraseRootFromParent_Done,
     /* 373641 */   // Label 7323: @373641
     /* 373641 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(373756), // Rule ID 4193 //
     /* 373646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373672 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373679 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 373696 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 373703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373723 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373755 */     // GIR_Coverage, 4193,
     /* 373755 */     GIR_EraseRootFromParent_Done,
     /* 373756 */   // Label 7324: @373756
     /* 373756 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(373878), // Rule ID 4227 //
     /* 373761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373787 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373790 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373794 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 373801 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 373818 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 373825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373845 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373877 */     // GIR_Coverage, 4227,
     /* 373877 */     GIR_EraseRootFromParent_Done,
     /* 373878 */   // Label 7325: @373878
     /* 373878 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(374000), // Rule ID 4229 //
     /* 373883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373909 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373912 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373916 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 373923 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 373940 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 373947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373967 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373989 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373999 */     // GIR_Coverage, 4229,
     /* 373999 */     GIR_EraseRootFromParent_Done,
     /* 374000 */   // Label 7326: @374000
     /* 374000 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(374114), // Rule ID 4183 //
     /* 374005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374019 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374025 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374042 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374059 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 374066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374081 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374113 */     // GIR_Coverage, 4183,
     /* 374113 */     GIR_EraseRootFromParent_Done,
     /* 374114 */   // Label 7327: @374114
     /* 374114 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(374228), // Rule ID 4184 //
     /* 374119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374133 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374139 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374149 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374156 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 374173 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 374173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 374180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374195 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374227 */     // GIR_Coverage, 4184,
     /* 374227 */     GIR_EraseRootFromParent_Done,
     /* 374228 */   // Label 7328: @374228
     /* 374228 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(374349), // Rule ID 4219 //
     /* 374233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374247 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374253 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374263 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374266 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374270 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374277 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374294 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 374301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374316 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374348 */     // GIR_Coverage, 4219,
     /* 374348 */     GIR_EraseRootFromParent_Done,
     /* 374349 */   // Label 7329: @374349
     /* 374349 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(374470), // Rule ID 4220 //
     /* 374354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374368 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374374 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374384 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374387 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374391 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374398 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 374415 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 374415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 374422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374437 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374469 */     // GIR_Coverage, 4220,
     /* 374469 */     GIR_EraseRootFromParent_Done,
     /* 374470 */   // Label 7330: @374470
     /* 374470 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(374580), // Rule ID 4187 //
     /* 374475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374501 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374504 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374508 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374518 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374525 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 374532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374547 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374579 */     // GIR_Coverage, 4187,
     /* 374579 */     GIR_EraseRootFromParent_Done,
     /* 374580 */   // Label 7331: @374580
     /* 374580 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(374690), // Rule ID 4189 //
     /* 374585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374611 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374618 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 374635 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 374635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 374642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374657 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374689 */     // GIR_Coverage, 4189,
     /* 374689 */     GIR_EraseRootFromParent_Done,
     /* 374690 */   // Label 7332: @374690
     /* 374690 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(374807), // Rule ID 4223 //
     /* 374695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374721 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374724 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374728 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374735 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374752 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 374759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374774 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374806 */     // GIR_Coverage, 4223,
     /* 374806 */     GIR_EraseRootFromParent_Done,
     /* 374807 */   // Label 7333: @374807
     /* 374807 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(374924), // Rule ID 4225 //
     /* 374812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374838 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374841 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374845 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374852 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 374869 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 374869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 374876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374891 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374923 */     // GIR_Coverage, 4225,
     /* 374923 */     GIR_EraseRootFromParent_Done,
     /* 374924 */   // Label 7334: @374924
     /* 374924 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(375047), // Rule ID 5754 //
     /* 374929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 374959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374976 */     // MIs[3] Operand 1
     /* 374976 */     // No operand predicates
     /* 374976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374982 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 374982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 374985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 374989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 374998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 375001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 375028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375046 */     // GIR_Coverage, 5754,
     /* 375046 */     GIR_EraseRootFromParent_Done,
     /* 375047 */   // Label 7335: @375047
     /* 375047 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(375170), // Rule ID 5762 //
     /* 375052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375099 */     // MIs[3] Operand 1
     /* 375099 */     // No operand predicates
     /* 375099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375105 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 375105 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 375108 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 375112 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375117 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 375121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 375124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 375151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375169 */     // GIR_Coverage, 5762,
     /* 375169 */     GIR_EraseRootFromParent_Done,
     /* 375170 */   // Label 7336: @375170
     /* 375170 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(375258), // Rule ID 1938 //
     /* 375175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375221 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375225 */     // MIs[2] Operand 1
     /* 375225 */     // No operand predicates
     /* 375225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375233 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375237 */     // MIs[3] Operand 1
     /* 375237 */     // No operand predicates
     /* 375237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375239 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 375239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 375246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 375256 */     GIR_RootConstrainSelectedInstOperands,
     /* 375257 */     // GIR_Coverage, 1938,
     /* 375257 */     GIR_EraseRootFromParent_Done,
     /* 375258 */   // Label 7337: @375258
     /* 375258 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(375357), // Rule ID 5751 //
     /* 375263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 375285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375297 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375301 */     // MIs[2] Operand 1
     /* 375301 */     // No operand predicates
     /* 375301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375309 */     // MIs[3] Operand 1
     /* 375309 */     // No operand predicates
     /* 375309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375311 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i8] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 375311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375323 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 375329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 375339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375355 */     GIR_RootConstrainSelectedInstOperands,
     /* 375356 */     // GIR_Coverage, 5751,
     /* 375356 */     GIR_EraseRootFromParent_Done,
     /* 375357 */   // Label 7338: @375357
     /* 375357 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(375456), // Rule ID 5759 //
     /* 375362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 375384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375396 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375400 */     // MIs[2] Operand 1
     /* 375400 */     // No operand predicates
     /* 375400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375408 */     // MIs[3] Operand 1
     /* 375408 */     // No operand predicates
     /* 375408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375410 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 375410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375422 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 375428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 375438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375454 */     GIR_RootConstrainSelectedInstOperands,
     /* 375455 */     // GIR_Coverage, 5759,
     /* 375455 */     GIR_EraseRootFromParent_Done,
     /* 375456 */   // Label 7339: @375456
     /* 375456 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(375533), // Rule ID 5753 //
     /* 375461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375504 */     // MIs[2] Operand 1
     /* 375504 */     // No operand predicates
     /* 375504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375512 */     // MIs[3] Operand 1
     /* 375512 */     // No operand predicates
     /* 375512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375514 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 375514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375531 */     GIR_RootConstrainSelectedInstOperands,
     /* 375532 */     // GIR_Coverage, 5753,
     /* 375532 */     GIR_EraseRootFromParent_Done,
     /* 375533 */   // Label 7340: @375533
     /* 375533 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(375641), // Rule ID 5755 //
     /* 375538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 375564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375581 */     // MIs[2] Operand 1
     /* 375581 */     // No operand predicates
     /* 375581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375589 */     // MIs[3] Operand 1
     /* 375589 */     // No operand predicates
     /* 375589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375591 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 375591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375603 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375610 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375628 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375639 */     GIR_RootConstrainSelectedInstOperands,
     /* 375640 */     // GIR_Coverage, 5755,
     /* 375640 */     GIR_EraseRootFromParent_Done,
     /* 375641 */   // Label 7341: @375641
     /* 375641 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(375718), // Rule ID 5761 //
     /* 375646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375689 */     // MIs[2] Operand 1
     /* 375689 */     // No operand predicates
     /* 375689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375697 */     // MIs[3] Operand 1
     /* 375697 */     // No operand predicates
     /* 375697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375699 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 375699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375716 */     GIR_RootConstrainSelectedInstOperands,
     /* 375717 */     // GIR_Coverage, 5761,
     /* 375717 */     GIR_EraseRootFromParent_Done,
     /* 375718 */   // Label 7342: @375718
     /* 375718 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(375826), // Rule ID 5763 //
     /* 375723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 375749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375766 */     // MIs[2] Operand 1
     /* 375766 */     // No operand predicates
     /* 375766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375774 */     // MIs[3] Operand 1
     /* 375774 */     // No operand predicates
     /* 375774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375776 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 375776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375788 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375791 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375795 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375824 */     GIR_RootConstrainSelectedInstOperands,
     /* 375825 */     // GIR_Coverage, 5763,
     /* 375825 */     GIR_EraseRootFromParent_Done,
     /* 375826 */   // Label 7343: @375826
     /* 375826 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(375905), // Rule ID 5678 //
     /* 375831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 375853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375859 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 375859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 375875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 375894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375904 */     // GIR_Coverage, 5678,
     /* 375904 */     GIR_EraseRootFromParent_Done,
     /* 375905 */   // Label 7344: @375905
     /* 375905 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(375984), // Rule ID 6465 //
     /* 375910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 375939 */     // MIs[1] Rn
     /* 375939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 375943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 375948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 375952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375956 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375960 */     // MIs[2] Operand 1
     /* 375960 */     // No operand predicates
     /* 375960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375962 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 375962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 375965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 375969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375982 */     GIR_RootConstrainSelectedInstOperands,
     /* 375983 */     // GIR_Coverage, 6465,
     /* 375983 */     GIR_EraseRootFromParent_Done,
     /* 375984 */   // Label 7345: @375984
     /* 375984 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(376070), // Rule ID 6466 //
     /* 375989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376011 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376014 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 376018 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376025 */     // MIs[1] Rn
     /* 376025 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 376029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 376034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 376038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376042 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376046 */     // MIs[2] Operand 1
     /* 376046 */     // No operand predicates
     /* 376046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376048 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 376048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 376051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376068 */     GIR_RootConstrainSelectedInstOperands,
     /* 376069 */     // GIR_Coverage, 6466,
     /* 376069 */     GIR_EraseRootFromParent_Done,
     /* 376070 */   // Label 7346: @376070
     /* 376070 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(376124), // Rule ID 1934 //
     /* 376075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 376096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 376100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376108 */     // MIs[1] Operand 1
     /* 376108 */     // No operand predicates
     /* 376108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376110 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 376110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 376113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 376120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376122 */     GIR_RootConstrainSelectedInstOperands,
     /* 376123 */     // GIR_Coverage, 1934,
     /* 376123 */     GIR_EraseRootFromParent_Done,
     /* 376124 */   // Label 7347: @376124
     /* 376124 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(376230), // Rule ID 5721 //
     /* 376129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 376151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376159 */     // MIs[1] Operand 1
     /* 376159 */     // No operand predicates
     /* 376159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376161 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 376164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376187 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 376194 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 376197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 376222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376228 */     GIR_RootConstrainSelectedInstOperands,
     /* 376229 */     // GIR_Coverage, 5721,
     /* 376229 */     GIR_EraseRootFromParent_Done,
     /* 376230 */   // Label 7348: @376230
     /* 376230 */   GIM_Reject,
     /* 376231 */ // Label 7318: @376231
     /* 376231 */ GIM_Reject,
     /* 376232 */ // Label 7111: @376232
     /* 376232 */ GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(376356), // Rule ID 11240 //
     /* 376237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 376240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 376243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 376246 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376257 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 376261 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 376261 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 376264 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 376268 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376273 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 376277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 376279 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 376282 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 376286 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376291 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 376294 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 376297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 376299 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 376302 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 376306 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376311 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 376314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 376319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 376323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376328 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376331 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 376334 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 376337 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 376340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 376345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 376347 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 376349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376352 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 376354 */   GIR_RootConstrainSelectedInstOperands,
     /* 376355 */   // GIR_Coverage, 11240,
     /* 376355 */   GIR_EraseRootFromParent_Done,
     /* 376356 */ // Label 7349: @376356
     /* 376356 */ GIM_Reject,
     /* 376357 */ // Label 7112: @376357
     /* 376357 */ GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(376481), // Rule ID 11243 //
     /* 376362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 376365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 376368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376382 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 376386 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 376386 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 376389 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 376393 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376398 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 376402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 376404 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 376407 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 376411 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376416 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 376419 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 376422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 376424 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 376427 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 376431 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376436 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 376439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 376444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 376448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376453 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376456 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 376459 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 376462 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 376465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 376470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 376472 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 376474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376477 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 376479 */   GIR_RootConstrainSelectedInstOperands,
     /* 376480 */   // GIR_Coverage, 11243,
     /* 376480 */   GIR_EraseRootFromParent_Done,
     /* 376481 */ // Label 7350: @376481
     /* 376481 */ GIM_Reject,
     /* 376482 */ // Label 7113: @376482
     /* 376482 */ GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(378459),
     /* 376487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 376490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 376493 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376500 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(376609), // Rule ID 4353 //
     /* 376505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376509 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376515 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376525 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376528 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376532 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 376549 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 376549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 376556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376576 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 376598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376608 */     // GIR_Coverage, 4353,
     /* 376608 */     GIR_EraseRootFromParent_Done,
     /* 376609 */   // Label 7352: @376609
     /* 376609 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(376718), // Rule ID 4354 //
     /* 376614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376618 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376624 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376634 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376637 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376641 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 376658 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 376658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 376665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376685 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 376707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376717 */     // GIR_Coverage, 4354,
     /* 376717 */     GIR_EraseRootFromParent_Done,
     /* 376718 */   // Label 7353: @376718
     /* 376718 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(376827), // Rule ID 4461 //
     /* 376723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376727 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376733 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376743 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376746 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376750 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 376767 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 376767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 376774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376794 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 376816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376826 */     // GIR_Coverage, 4461,
     /* 376826 */     GIR_EraseRootFromParent_Done,
     /* 376827 */   // Label 7354: @376827
     /* 376827 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(376936), // Rule ID 4462 //
     /* 376832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376836 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376842 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376852 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376859 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 376876 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 376876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 376883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376903 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 376925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376935 */     // GIR_Coverage, 4462,
     /* 376935 */     GIR_EraseRootFromParent_Done,
     /* 376936 */   // Label 7355: @376936
     /* 376936 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(377041), // Rule ID 4359 //
     /* 376941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376957 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376964 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 376981 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 376981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 376988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377008 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377040 */     // GIR_Coverage, 4359,
     /* 377040 */     GIR_EraseRootFromParent_Done,
     /* 377041 */   // Label 7356: @377041
     /* 377041 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(377146), // Rule ID 4361 //
     /* 377046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377062 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377065 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377069 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 377086 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 377093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377113 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377145 */     // GIR_Coverage, 4361,
     /* 377145 */     GIR_EraseRootFromParent_Done,
     /* 377146 */   // Label 7357: @377146
     /* 377146 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(377251), // Rule ID 4467 //
     /* 377151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377167 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377174 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 377191 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 377198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377218 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377250 */     // GIR_Coverage, 4467,
     /* 377250 */     GIR_EraseRootFromParent_Done,
     /* 377251 */   // Label 7358: @377251
     /* 377251 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(377356), // Rule ID 4469 //
     /* 377256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377272 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377275 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377279 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 377296 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 377303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377323 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377355 */     // GIR_Coverage, 4469,
     /* 377355 */     GIR_EraseRootFromParent_Done,
     /* 377356 */   // Label 7359: @377356
     /* 377356 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(377460), // Rule ID 4351 //
     /* 377361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377365 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377371 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377381 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377388 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 377405 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 377405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 377412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377427 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377459 */     // GIR_Coverage, 4351,
     /* 377459 */     GIR_EraseRootFromParent_Done,
     /* 377460 */   // Label 7360: @377460
     /* 377460 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(377564), // Rule ID 4352 //
     /* 377465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377469 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377475 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377485 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377492 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 377509 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 377509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 377516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377531 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377563 */     // GIR_Coverage, 4352,
     /* 377563 */     GIR_EraseRootFromParent_Done,
     /* 377564 */   // Label 7361: @377564
     /* 377564 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(377668), // Rule ID 4459 //
     /* 377569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377573 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377579 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377589 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377592 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377596 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 377613 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 377613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 377620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377635 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377667 */     // GIR_Coverage, 4459,
     /* 377667 */     GIR_EraseRootFromParent_Done,
     /* 377668 */   // Label 7362: @377668
     /* 377668 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(377772), // Rule ID 4460 //
     /* 377673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377677 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377683 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377693 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377696 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377700 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 377717 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 377717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 377724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377739 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377771 */     // GIR_Coverage, 4460,
     /* 377771 */     GIR_EraseRootFromParent_Done,
     /* 377772 */   // Label 7363: @377772
     /* 377772 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(377872), // Rule ID 4355 //
     /* 377777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377793 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377796 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377800 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377810 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 377817 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 377817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 377824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377839 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377871 */     // GIR_Coverage, 4355,
     /* 377871 */     GIR_EraseRootFromParent_Done,
     /* 377872 */   // Label 7364: @377872
     /* 377872 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(377972), // Rule ID 4357 //
     /* 377877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377893 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377900 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 377917 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 377917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 377924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377939 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377971 */     // GIR_Coverage, 4357,
     /* 377971 */     GIR_EraseRootFromParent_Done,
     /* 377972 */   // Label 7365: @377972
     /* 377972 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(378072), // Rule ID 4463 //
     /* 377977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377993 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377996 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378000 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 378017 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 378017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 378024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378039 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378071 */     // GIR_Coverage, 4463,
     /* 378071 */     GIR_EraseRootFromParent_Done,
     /* 378072 */   // Label 7366: @378072
     /* 378072 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(378172), // Rule ID 4465 //
     /* 378077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378093 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378096 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378100 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 378117 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 378117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 378124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378139 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378171 */     // GIR_Coverage, 4465,
     /* 378171 */     GIR_EraseRootFromParent_Done,
     /* 378172 */   // Label 7367: @378172
     /* 378172 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(378236), // Rule ID 11298 //
     /* 378177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 378200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378212 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 378216 */     // MIs[3] Operand 1
     /* 378216 */     // No operand predicates
     /* 378216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378222 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 378222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 378225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 378231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 378234 */     GIR_RootConstrainSelectedInstOperands,
     /* 378235 */     // GIR_Coverage, 11298,
     /* 378235 */     GIR_EraseRootFromParent_Done,
     /* 378236 */   // Label 7368: @378236
     /* 378236 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(378347), // Rule ID 11239 //
     /* 378241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378252 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 378252 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 378255 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 378259 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378264 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 378268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378270 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 378273 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 378277 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378282 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 378285 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 378288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 378293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 378297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378302 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 378305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 378310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 378314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378319 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378322 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 378325 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 378328 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 378331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 378336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378338 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 378340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378343 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 378345 */     GIR_RootConstrainSelectedInstOperands,
     /* 378346 */     // GIR_Coverage, 11239,
     /* 378346 */     GIR_EraseRootFromParent_Done,
     /* 378347 */   // Label 7369: @378347
     /* 378347 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(378458), // Rule ID 11245 //
     /* 378352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378363 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 378363 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 378366 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 378370 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378375 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 378379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378381 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 378384 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 378388 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378393 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 378396 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 378399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 378404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 378408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378413 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 378416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 378421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 378425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378430 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378433 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 378436 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 378439 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 378442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 378447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378449 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 378451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 378456 */     GIR_RootConstrainSelectedInstOperands,
     /* 378457 */     // GIR_Coverage, 11245,
     /* 378457 */     GIR_EraseRootFromParent_Done,
     /* 378458 */   // Label 7370: @378458
     /* 378458 */   GIM_Reject,
     /* 378459 */ // Label 7351: @378459
     /* 378459 */ GIM_Reject,
     /* 378460 */ // Label 7114: @378460
     /* 378460 */ GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(378611), // Rule ID 11241 //
     /* 378465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 378471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 378474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378485 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378489 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 378489 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 378492 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378496 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378501 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 378507 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 378512 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378517 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 378520 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 378524 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378529 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 378532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378534 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 378537 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 378541 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378546 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 378549 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 378552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378554 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 378557 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 378561 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378566 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 378569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 378574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 378578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378583 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 378589 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 378592 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 378595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 378600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378602 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 378604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378607 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 378609 */   GIR_RootConstrainSelectedInstOperands,
     /* 378610 */   // GIR_Coverage, 11241,
     /* 378610 */   GIR_EraseRootFromParent_Done,
     /* 378611 */ // Label 7371: @378611
     /* 378611 */ GIM_Reject,
     /* 378612 */ // Label 7115: @378612
     /* 378612 */ GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(380643),
     /* 378617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 378620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378623 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378630 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(378739), // Rule ID 4317 //
     /* 378635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378639 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378645 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378655 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378662 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 378679 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 378679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 378686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378706 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 378728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378738 */     // GIR_Coverage, 4317,
     /* 378738 */     GIR_EraseRootFromParent_Done,
     /* 378739 */   // Label 7373: @378739
     /* 378739 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(378848), // Rule ID 4318 //
     /* 378744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378748 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378754 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378764 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378771 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 378788 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 378788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 378795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378815 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 378837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378847 */     // GIR_Coverage, 4318,
     /* 378847 */     GIR_EraseRootFromParent_Done,
     /* 378848 */   // Label 7374: @378848
     /* 378848 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(378957), // Rule ID 4425 //
     /* 378853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378857 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378863 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378873 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378880 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 378897 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 378897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 378904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378924 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 378946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378956 */     // GIR_Coverage, 4425,
     /* 378956 */     GIR_EraseRootFromParent_Done,
     /* 378957 */   // Label 7375: @378957
     /* 378957 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(379066), // Rule ID 4426 //
     /* 378962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378966 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378972 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378982 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378985 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378989 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379006 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379033 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379065 */     // GIR_Coverage, 4426,
     /* 379065 */     GIR_EraseRootFromParent_Done,
     /* 379066 */   // Label 7376: @379066
     /* 379066 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(379171), // Rule ID 4323 //
     /* 379071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379087 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379094 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 379111 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 379118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379138 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379170 */     // GIR_Coverage, 4323,
     /* 379170 */     GIR_EraseRootFromParent_Done,
     /* 379171 */   // Label 7377: @379171
     /* 379171 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(379276), // Rule ID 4325 //
     /* 379176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379192 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379199 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379216 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379243 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379275 */     // GIR_Coverage, 4325,
     /* 379275 */     GIR_EraseRootFromParent_Done,
     /* 379276 */   // Label 7378: @379276
     /* 379276 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(379381), // Rule ID 4431 //
     /* 379281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379297 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379304 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 379321 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 379328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379348 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379380 */     // GIR_Coverage, 4431,
     /* 379380 */     GIR_EraseRootFromParent_Done,
     /* 379381 */   // Label 7379: @379381
     /* 379381 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(379486), // Rule ID 4433 //
     /* 379386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379402 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379409 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379426 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379453 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379485 */     // GIR_Coverage, 4433,
     /* 379485 */     GIR_EraseRootFromParent_Done,
     /* 379486 */   // Label 7380: @379486
     /* 379486 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(379590), // Rule ID 4315 //
     /* 379491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379495 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379501 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379511 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379514 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379518 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379528 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 379535 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 379535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 379542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379557 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379589 */     // GIR_Coverage, 4315,
     /* 379589 */     GIR_EraseRootFromParent_Done,
     /* 379590 */   // Label 7381: @379590
     /* 379590 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(379694), // Rule ID 4316 //
     /* 379595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379599 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379605 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379615 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379622 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 379639 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 379639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 379646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379661 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379693 */     // GIR_Coverage, 4316,
     /* 379693 */     GIR_EraseRootFromParent_Done,
     /* 379694 */   // Label 7382: @379694
     /* 379694 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(379798), // Rule ID 4423 //
     /* 379699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379709 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379719 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379722 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379726 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 379743 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 379743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 379750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379765 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379797 */     // GIR_Coverage, 4423,
     /* 379797 */     GIR_EraseRootFromParent_Done,
     /* 379798 */   // Label 7383: @379798
     /* 379798 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(379902), // Rule ID 4424 //
     /* 379803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379807 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379813 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379823 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379830 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 379847 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 379847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 379854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379869 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379891 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379901 */     // GIR_Coverage, 4424,
     /* 379901 */     GIR_EraseRootFromParent_Done,
     /* 379902 */   // Label 7384: @379902
     /* 379902 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(380002), // Rule ID 4319 //
     /* 379907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379923 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379930 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379940 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 379947 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 379947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 379954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379969 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380001 */     // GIR_Coverage, 4319,
     /* 380001 */     GIR_EraseRootFromParent_Done,
     /* 380002 */   // Label 7385: @380002
     /* 380002 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(380102), // Rule ID 4321 //
     /* 380007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380023 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380030 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380047 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380069 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380101 */     // GIR_Coverage, 4321,
     /* 380101 */     GIR_EraseRootFromParent_Done,
     /* 380102 */   // Label 7386: @380102
     /* 380102 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(380202), // Rule ID 4427 //
     /* 380107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380123 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380126 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380130 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380140 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 380147 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 380147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 380154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380169 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380201 */     // GIR_Coverage, 4427,
     /* 380201 */     GIR_EraseRootFromParent_Done,
     /* 380202 */   // Label 7387: @380202
     /* 380202 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(380302), // Rule ID 4429 //
     /* 380207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380223 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380230 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380247 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380269 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380301 */     // GIR_Coverage, 4429,
     /* 380301 */     GIR_EraseRootFromParent_Done,
     /* 380302 */   // Label 7388: @380302
     /* 380302 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(380366), // Rule ID 11296 //
     /* 380307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 380330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380342 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 380346 */     // MIs[3] Operand 1
     /* 380346 */     // No operand predicates
     /* 380346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380352 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 380352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 380355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 380361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 380364 */     GIR_RootConstrainSelectedInstOperands,
     /* 380365 */     // GIR_Coverage, 11296,
     /* 380365 */     GIR_EraseRootFromParent_Done,
     /* 380366 */   // Label 7389: @380366
     /* 380366 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(380504), // Rule ID 11238 //
     /* 380371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 380378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380382 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 380382 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 380385 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380389 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380394 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 380400 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 380405 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380410 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 380413 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 380417 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380422 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 380425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380427 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 380430 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 380434 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380439 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 380442 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 380445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 380450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 380454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380459 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 380462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 380467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 380471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380476 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380479 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380482 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 380485 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 380488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 380493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380495 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 380497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380500 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 380502 */     GIR_RootConstrainSelectedInstOperands,
     /* 380503 */     // GIR_Coverage, 11238,
     /* 380503 */     GIR_EraseRootFromParent_Done,
     /* 380504 */   // Label 7390: @380504
     /* 380504 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(380642), // Rule ID 11244 //
     /* 380509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380520 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 380520 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 380523 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380527 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380532 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 380538 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 380543 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380548 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 380551 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 380555 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380560 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 380563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380565 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 380568 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 380572 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380577 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 380580 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 380583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380585 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 380588 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 380592 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380597 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 380600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 380605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 380609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380617 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380620 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 380623 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 380626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 380631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380633 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 380635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380638 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 380640 */     GIR_RootConstrainSelectedInstOperands,
     /* 380641 */     // GIR_Coverage, 11244,
     /* 380641 */     GIR_EraseRootFromParent_Done,
     /* 380642 */   // Label 7391: @380642
     /* 380642 */   GIM_Reject,
     /* 380643 */ // Label 7372: @380643
     /* 380643 */ GIM_Reject,
     /* 380644 */ // Label 7116: @380644
     /* 380644 */ GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(382911),
     /* 380649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 380652 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(380778), // Rule ID 4281 //
     /* 380657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 380660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 380663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380677 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380687 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380690 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380694 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 380701 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 380718 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 380718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 380725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380745 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 380767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380777 */     // GIR_Coverage, 4281,
     /* 380777 */     GIR_EraseRootFromParent_Done,
     /* 380778 */   // Label 7393: @380778
     /* 380778 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(380904), // Rule ID 4282 //
     /* 380783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 380786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 380789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380797 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380803 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380813 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380816 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380820 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 380827 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 380844 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 380844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 380851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380871 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 380893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380903 */     // GIR_Coverage, 4282,
     /* 380903 */     GIR_EraseRootFromParent_Done,
     /* 380904 */   // Label 7394: @380904
     /* 380904 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(381023), // Rule ID 4389 //
     /* 380909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 380912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 380915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380923 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380929 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380939 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380946 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 380963 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 380963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 380970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380990 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381022 */     // GIR_Coverage, 4389,
     /* 381022 */     GIR_EraseRootFromParent_Done,
     /* 381023 */   // Label 7395: @381023
     /* 381023 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(381142), // Rule ID 4390 //
     /* 381028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381042 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381048 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381058 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381065 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 381082 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 381089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381109 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381141 */     // GIR_Coverage, 4390,
     /* 381141 */     GIR_EraseRootFromParent_Done,
     /* 381142 */   // Label 7396: @381142
     /* 381142 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(381264), // Rule ID 4287 //
     /* 381147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381173 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381176 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381180 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381187 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 381204 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 381211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381231 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381263 */     // GIR_Coverage, 4287,
     /* 381263 */     GIR_EraseRootFromParent_Done,
     /* 381264 */   // Label 7397: @381264
     /* 381264 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(381386), // Rule ID 4289 //
     /* 381269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381295 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381298 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381302 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381309 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 381326 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 381333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381353 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381385 */     // GIR_Coverage, 4289,
     /* 381385 */     GIR_EraseRootFromParent_Done,
     /* 381386 */   // Label 7398: @381386
     /* 381386 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(381501), // Rule ID 4395 //
     /* 381391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381417 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381420 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381424 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 381441 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 381448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381468 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381500 */     // GIR_Coverage, 4395,
     /* 381500 */     GIR_EraseRootFromParent_Done,
     /* 381501 */   // Label 7399: @381501
     /* 381501 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(381616), // Rule ID 4397 //
     /* 381506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381532 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381539 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 381556 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 381563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381583 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381615 */     // GIR_Coverage, 4397,
     /* 381615 */     GIR_EraseRootFromParent_Done,
     /* 381616 */   // Label 7400: @381616
     /* 381616 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(381737), // Rule ID 4279 //
     /* 381621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381635 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381641 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381651 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381654 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381658 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381665 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 381682 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 381682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 381689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381704 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381736 */     // GIR_Coverage, 4279,
     /* 381736 */     GIR_EraseRootFromParent_Done,
     /* 381737 */   // Label 7401: @381737
     /* 381737 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(381858), // Rule ID 4280 //
     /* 381742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381756 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381762 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381772 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381775 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381779 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381786 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 381803 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 381803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 381810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381825 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381857 */     // GIR_Coverage, 4280,
     /* 381857 */     GIR_EraseRootFromParent_Done,
     /* 381858 */   // Label 7402: @381858
     /* 381858 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(381972), // Rule ID 4387 //
     /* 381863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381877 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381883 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381893 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381900 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 381917 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 381917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 381924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381939 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381971 */     // GIR_Coverage, 4387,
     /* 381971 */     GIR_EraseRootFromParent_Done,
     /* 381972 */   // Label 7403: @381972
     /* 381972 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(382086), // Rule ID 4388 //
     /* 381977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381991 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381997 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382007 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382014 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382031 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382053 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382085 */     // GIR_Coverage, 4388,
     /* 382085 */     GIR_EraseRootFromParent_Done,
     /* 382086 */   // Label 7404: @382086
     /* 382086 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(382203), // Rule ID 4283 //
     /* 382091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382117 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382120 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382124 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382131 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 382148 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 382148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 382155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382170 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382202 */     // GIR_Coverage, 4283,
     /* 382202 */     GIR_EraseRootFromParent_Done,
     /* 382203 */   // Label 7405: @382203
     /* 382203 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(382320), // Rule ID 4285 //
     /* 382208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382234 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382237 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382241 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382248 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382258 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382265 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382287 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382319 */     // GIR_Coverage, 4285,
     /* 382319 */     GIR_EraseRootFromParent_Done,
     /* 382320 */   // Label 7406: @382320
     /* 382320 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(382430), // Rule ID 4391 //
     /* 382325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382351 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382354 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382358 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382368 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 382375 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 382375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 382382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382397 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382429 */     // GIR_Coverage, 4391,
     /* 382429 */     GIR_EraseRootFromParent_Done,
     /* 382430 */   // Label 7407: @382430
     /* 382430 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(382540), // Rule ID 4393 //
     /* 382435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382461 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382464 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382468 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382485 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382507 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382539 */     // GIR_Coverage, 4393,
     /* 382539 */     GIR_EraseRootFromParent_Done,
     /* 382540 */   // Label 7408: @382540
     /* 382540 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(382614), // Rule ID 11294 //
     /* 382545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 382548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 382578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 382594 */     // MIs[3] Operand 1
     /* 382594 */     // No operand predicates
     /* 382594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382600 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 382600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 382603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 382609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 382612 */     GIR_RootConstrainSelectedInstOperands,
     /* 382613 */     // GIR_Coverage, 11294,
     /* 382613 */     GIR_EraseRootFromParent_Done,
     /* 382614 */   // Label 7409: @382614
     /* 382614 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(382762), // Rule ID 11237 //
     /* 382619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 382622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382640 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 382640 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 382643 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382647 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382652 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 382658 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382663 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382668 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 382671 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 382675 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382680 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 382683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 382685 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 382688 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 382692 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382697 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 382700 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 382703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 382705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 382708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 382712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382717 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 382720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 382722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 382725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 382729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 382737 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 382740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 382743 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 382746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 382751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382753 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 382755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382758 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 382760 */     GIR_RootConstrainSelectedInstOperands,
     /* 382761 */     // GIR_Coverage, 11237,
     /* 382761 */     GIR_EraseRootFromParent_Done,
     /* 382762 */   // Label 7410: @382762
     /* 382762 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(382910), // Rule ID 11242 //
     /* 382767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 382770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382788 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 382788 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 382791 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382795 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382800 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 382806 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382811 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382816 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 382819 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 382823 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382828 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 382831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 382833 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 382836 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 382840 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382845 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 382848 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 382851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 382853 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 382856 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 382860 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382865 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 382868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 382870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 382873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 382877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382882 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 382885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 382888 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 382891 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 382894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 382899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382901 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 382903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382906 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 382908 */     GIR_RootConstrainSelectedInstOperands,
     /* 382909 */     // GIR_Coverage, 11242,
     /* 382909 */     GIR_EraseRootFromParent_Done,
     /* 382910 */   // Label 7411: @382910
     /* 382910 */   GIM_Reject,
     /* 382911 */ // Label 7392: @382911
     /* 382911 */ GIM_Reject,
     /* 382912 */ // Label 7117: @382912
     /* 382912 */ GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(385031),
     /* 382917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 382920 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(383039), // Rule ID 4209 //
     /* 382925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 382928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382939 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382945 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382955 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382962 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 382979 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 382979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 382982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 382986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383006 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383038 */     // GIR_Coverage, 4209,
     /* 383038 */     GIR_EraseRootFromParent_Done,
     /* 383039 */   // Label 7413: @383039
     /* 383039 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(383158), // Rule ID 4210 //
     /* 383044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383058 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383064 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383074 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383081 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 383098 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 383105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383125 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383157 */     // GIR_Coverage, 4210,
     /* 383157 */     GIR_EraseRootFromParent_Done,
     /* 383158 */   // Label 7414: @383158
     /* 383158 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(383284), // Rule ID 4245 //
     /* 383163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383177 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383193 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383196 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383200 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 383207 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 383224 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 383231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383251 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383283 */     // GIR_Coverage, 4245,
     /* 383283 */     GIR_EraseRootFromParent_Done,
     /* 383284 */   // Label 7415: @383284
     /* 383284 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(383410), // Rule ID 4246 //
     /* 383289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383303 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383309 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383319 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383322 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383326 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 383333 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383343 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 383350 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 383357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383377 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383409 */     // GIR_Coverage, 4246,
     /* 383409 */     GIR_EraseRootFromParent_Done,
     /* 383410 */   // Label 7416: @383410
     /* 383410 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(383525), // Rule ID 4215 //
     /* 383415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383441 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383448 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 383465 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 383472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383492 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383524 */     // GIR_Coverage, 4215,
     /* 383524 */     GIR_EraseRootFromParent_Done,
     /* 383525 */   // Label 7417: @383525
     /* 383525 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(383640), // Rule ID 4217 //
     /* 383530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383556 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383563 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 383580 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 383587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383607 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383639 */     // GIR_Coverage, 4217,
     /* 383639 */     GIR_EraseRootFromParent_Done,
     /* 383640 */   // Label 7418: @383640
     /* 383640 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(383762), // Rule ID 4251 //
     /* 383645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383671 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383674 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383678 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 383685 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 383702 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 383709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383729 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383761 */     // GIR_Coverage, 4251,
     /* 383761 */     GIR_EraseRootFromParent_Done,
     /* 383762 */   // Label 7419: @383762
     /* 383762 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(383884), // Rule ID 4253 //
     /* 383767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383793 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383796 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383800 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 383807 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 383824 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 383831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383851 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383883 */     // GIR_Coverage, 4253,
     /* 383883 */     GIR_EraseRootFromParent_Done,
     /* 383884 */   // Label 7420: @383884
     /* 383884 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(383998), // Rule ID 4207 //
     /* 383889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383909 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383919 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383922 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383926 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 383943 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 383943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 383950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383965 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383997 */     // GIR_Coverage, 4207,
     /* 383997 */     GIR_EraseRootFromParent_Done,
     /* 383998 */   // Label 7421: @383998
     /* 383998 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(384112), // Rule ID 4208 //
     /* 384003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384017 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384023 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384033 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384040 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 384057 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 384057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 384064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384079 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384111 */     // GIR_Coverage, 4208,
     /* 384111 */     GIR_EraseRootFromParent_Done,
     /* 384112 */   // Label 7422: @384112
     /* 384112 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(384233), // Rule ID 4243 //
     /* 384117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384131 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384137 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384147 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384150 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384154 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384161 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 384178 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 384178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 384185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384200 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384232 */     // GIR_Coverage, 4243,
     /* 384232 */     GIR_EraseRootFromParent_Done,
     /* 384233 */   // Label 7423: @384233
     /* 384233 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(384354), // Rule ID 4244 //
     /* 384238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384252 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384258 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384268 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384271 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384275 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384282 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 384299 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 384299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 384306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384321 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384353 */     // GIR_Coverage, 4244,
     /* 384353 */     GIR_EraseRootFromParent_Done,
     /* 384354 */   // Label 7424: @384354
     /* 384354 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(384464), // Rule ID 4211 //
     /* 384359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384385 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384392 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 384409 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 384409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 384416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384431 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384463 */     // GIR_Coverage, 4211,
     /* 384463 */     GIR_EraseRootFromParent_Done,
     /* 384464 */   // Label 7425: @384464
     /* 384464 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(384574), // Rule ID 4213 //
     /* 384469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384495 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384502 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 384519 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 384519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 384526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384541 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384573 */     // GIR_Coverage, 4213,
     /* 384573 */     GIR_EraseRootFromParent_Done,
     /* 384574 */   // Label 7426: @384574
     /* 384574 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(384691), // Rule ID 4247 //
     /* 384579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384605 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384608 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384612 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384619 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 384636 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 384636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 384643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384658 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384690 */     // GIR_Coverage, 4247,
     /* 384690 */     GIR_EraseRootFromParent_Done,
     /* 384691 */   // Label 7427: @384691
     /* 384691 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(384808), // Rule ID 4249 //
     /* 384696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384722 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384725 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384729 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384736 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 384753 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 384753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 384760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384775 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384807 */     // GIR_Coverage, 4249,
     /* 384807 */     GIR_EraseRootFromParent_Done,
     /* 384808 */   // Label 7428: @384808
     /* 384808 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(384882), // Rule ID 11292 //
     /* 384813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 384816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 384846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384858 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 384862 */     // MIs[3] Operand 1
     /* 384862 */     // No operand predicates
     /* 384862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384868 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 384868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 384871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 384873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 384877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 384880 */     GIR_RootConstrainSelectedInstOperands,
     /* 384881 */     // GIR_Coverage, 11292,
     /* 384881 */     GIR_EraseRootFromParent_Done,
     /* 384882 */   // Label 7429: @384882
     /* 384882 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(385030), // Rule ID 11236 //
     /* 384887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 384890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384908 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 384908 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 384911 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384915 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384920 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 384926 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384931 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384936 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 384939 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 384943 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384948 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 384951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 384953 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 384956 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 384960 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384965 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 384968 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 384971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 384973 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 384976 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 384980 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384985 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 384988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 384993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 384997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385005 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 385008 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 385011 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 385019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385021 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 385028 */     GIR_RootConstrainSelectedInstOperands,
     /* 385029 */     // GIR_Coverage, 11236,
     /* 385029 */     GIR_EraseRootFromParent_Done,
     /* 385030 */   // Label 7430: @385030
     /* 385030 */   GIM_Reject,
     /* 385031 */ // Label 7412: @385031
     /* 385031 */ GIM_Reject,
     /* 385032 */ // Label 7118: @385032
     /* 385032 */ GIM_Reject,
     /* 385033 */ // Label 91: @385033
     /* 385033 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7434*/ GIMT_Encode4(387950),
     /* 385044 */ /*GILLT_s16*//*Label 7431*/ GIMT_Encode4(385056),
     /* 385048 */ /*GILLT_s32*//*Label 7432*/ GIMT_Encode4(385690),
     /* 385052 */ /*GILLT_s64*//*Label 7433*/ GIMT_Encode4(387283),
     /* 385056 */ // Label 7431: @385056
     /* 385056 */ GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(385100), // Rule ID 11285 //
     /* 385061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385074 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385078 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 385078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385083 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 385089 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385094 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385099 */   // GIR_Coverage, 11285,
     /* 385099 */   GIR_EraseRootFromParent_Done,
     /* 385100 */ // Label 7435: @385100
     /* 385100 */ GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(385144), // Rule ID 11286 //
     /* 385105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 385111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385118 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385122 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 385122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385127 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 385133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385143 */   // GIR_Coverage, 11286,
     /* 385143 */   GIR_EraseRootFromParent_Done,
     /* 385144 */ // Label 7436: @385144
     /* 385144 */ GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(385188), // Rule ID 11287 //
     /* 385149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 385155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385162 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385166 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 385166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385171 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 385177 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385187 */   // GIR_Coverage, 11287,
     /* 385187 */   GIR_EraseRootFromParent_Done,
     /* 385188 */ // Label 7437: @385188
     /* 385188 */ GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(385233), // Rule ID 5815 //
     /* 385193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385207 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385211 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 385211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385216 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 385222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385232 */   // GIR_Coverage, 5815,
     /* 385232 */   GIR_EraseRootFromParent_Done,
     /* 385233 */ // Label 7438: @385233
     /* 385233 */ GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(385278), // Rule ID 5818 //
     /* 385238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385260 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385264 */   // MIs[1] Operand 1
     /* 385264 */   // No operand predicates
     /* 385264 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385266 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 385266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 385269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385271 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385273 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 385276 */   GIR_RootConstrainSelectedInstOperands,
     /* 385277 */   // GIR_Coverage, 5818,
     /* 385277 */   GIR_EraseRootFromParent_Done,
     /* 385278 */ // Label 7439: @385278
     /* 385278 */ GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(385354), // Rule ID 11260 //
     /* 385283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385296 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385300 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385304 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 385308 */   // MIs[1] Operand 1
     /* 385308 */   // No operand predicates
     /* 385308 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385310 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 385310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 385313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 385317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385322 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 385326 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 385329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385336 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 385343 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385348 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385353 */   // GIR_Coverage, 11260,
     /* 385353 */   GIR_EraseRootFromParent_Done,
     /* 385354 */ // Label 7440: @385354
     /* 385354 */ GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(385430), // Rule ID 11261 //
     /* 385359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 385365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385380 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 385384 */   // MIs[1] Operand 1
     /* 385384 */   // No operand predicates
     /* 385384 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385386 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 385386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 385389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 385393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 385402 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 385405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385412 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 385419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385424 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385429 */   // GIR_Coverage, 11261,
     /* 385429 */   GIR_EraseRootFromParent_Done,
     /* 385430 */ // Label 7441: @385430
     /* 385430 */ GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(385506), // Rule ID 11262 //
     /* 385435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 385441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385456 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 385460 */   // MIs[1] Operand 1
     /* 385460 */   // No operand predicates
     /* 385460 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385462 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 385462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 385465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 385469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385474 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 385478 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 385481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385488 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 385495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385500 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385505 */   // GIR_Coverage, 11262,
     /* 385505 */   GIR_EraseRootFromParent_Done,
     /* 385506 */ // Label 7442: @385506
     /* 385506 */ GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(385567), // Rule ID 11250 //
     /* 385511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385528 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 385528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 385535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385540 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 385546 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 385550 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 385558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 385560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385563 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385565 */   GIR_RootConstrainSelectedInstOperands,
     /* 385566 */   // GIR_Coverage, 11250,
     /* 385566 */   GIR_EraseRootFromParent_Done,
     /* 385567 */ // Label 7443: @385567
     /* 385567 */ GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(385628), // Rule ID 11251 //
     /* 385572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 385578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385589 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 385589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 385596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385601 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 385607 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 385611 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 385619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 385621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385624 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385626 */   GIR_RootConstrainSelectedInstOperands,
     /* 385627 */   // GIR_Coverage, 11251,
     /* 385627 */   GIR_EraseRootFromParent_Done,
     /* 385628 */ // Label 7444: @385628
     /* 385628 */ GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(385689), // Rule ID 11252 //
     /* 385633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 385639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385650 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 385650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 385657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385662 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 385668 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 385672 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 385680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 385682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385685 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385687 */   GIR_RootConstrainSelectedInstOperands,
     /* 385688 */   // GIR_Coverage, 11252,
     /* 385688 */   GIR_EraseRootFromParent_Done,
     /* 385689 */ // Label 7445: @385689
     /* 385689 */ GIM_Reject,
     /* 385690 */ // Label 7432: @385690
     /* 385690 */ GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(385735), // Rule ID 6994 //
     /* 385695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385709 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385713 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 385713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385718 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 385724 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385729 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385734 */   // GIR_Coverage, 6994,
     /* 385734 */   GIR_EraseRootFromParent_Done,
     /* 385735 */ // Label 7446: @385735
     /* 385735 */ GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(385780), // Rule ID 6995 //
     /* 385740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385754 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385758 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 385758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385763 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 385769 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385774 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385779 */   // GIR_Coverage, 6995,
     /* 385779 */   GIR_EraseRootFromParent_Done,
     /* 385780 */ // Label 7447: @385780
     /* 385780 */ GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(385824), // Rule ID 11281 //
     /* 385785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 385791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385798 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385802 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 385802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385807 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 385813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385823 */   // GIR_Coverage, 11281,
     /* 385823 */   GIR_EraseRootFromParent_Done,
     /* 385824 */ // Label 7448: @385824
     /* 385824 */ GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(385868), // Rule ID 11282 //
     /* 385829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385842 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385846 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 385846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385851 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 385857 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385862 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385867 */   // GIR_Coverage, 11282,
     /* 385867 */   GIR_EraseRootFromParent_Done,
     /* 385868 */ // Label 7449: @385868
     /* 385868 */ GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(385912), // Rule ID 11283 //
     /* 385873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 385879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385886 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385890 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 385890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385895 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 385901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385906 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385911 */   // GIR_Coverage, 11283,
     /* 385911 */   GIR_EraseRootFromParent_Done,
     /* 385912 */ // Label 7450: @385912
     /* 385912 */ GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(385956), // Rule ID 11288 //
     /* 385917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 385923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385930 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385934 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 385934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385939 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 385945 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385955 */   // GIR_Coverage, 11288,
     /* 385955 */   GIR_EraseRootFromParent_Done,
     /* 385956 */ // Label 7451: @385956
     /* 385956 */ GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(386000), // Rule ID 11289 //
     /* 385961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 385967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385974 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385978 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 385978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385983 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 385989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385994 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385999 */   // GIR_Coverage, 11289,
     /* 385999 */   GIR_EraseRootFromParent_Done,
     /* 386000 */ // Label 7452: @386000
     /* 386000 */ GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(386045), // Rule ID 5814 //
     /* 386005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386019 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386023 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 386023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386028 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 386034 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386044 */   // GIR_Coverage, 5814,
     /* 386044 */   GIR_EraseRootFromParent_Done,
     /* 386045 */ // Label 7453: @386045
     /* 386045 */ GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(386118), // Rule ID 11266 //
     /* 386050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386071 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386075 */   // MIs[1] Operand 1
     /* 386075 */   // No operand predicates
     /* 386075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386077 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 386077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 386080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386089 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 386095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386100 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 386108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386113 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 386116 */   GIR_RootConstrainSelectedInstOperands,
     /* 386117 */   // GIR_Coverage, 11266,
     /* 386117 */   GIR_EraseRootFromParent_Done,
     /* 386118 */ // Label 7454: @386118
     /* 386118 */ GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(386191), // Rule ID 11267 //
     /* 386123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386136 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386140 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386144 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386148 */   // MIs[1] Operand 1
     /* 386148 */   // No operand predicates
     /* 386148 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386150 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 386150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 386153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386162 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 386168 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386173 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 386181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386186 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 386189 */   GIR_RootConstrainSelectedInstOperands,
     /* 386190 */   // GIR_Coverage, 11267,
     /* 386190 */   GIR_EraseRootFromParent_Done,
     /* 386191 */ // Label 7455: @386191
     /* 386191 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(386264), // Rule ID 11268 //
     /* 386196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386209 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386213 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386217 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386221 */   // MIs[1] Operand 1
     /* 386221 */   // No operand predicates
     /* 386221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386223 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 386223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 386226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386235 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 386241 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386246 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 386254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386256 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386259 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 386262 */   GIR_RootConstrainSelectedInstOperands,
     /* 386263 */   // GIR_Coverage, 11268,
     /* 386263 */   GIR_EraseRootFromParent_Done,
     /* 386264 */ // Label 7456: @386264
     /* 386264 */ GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(386312), // Rule ID 1926 //
     /* 386269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 386272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386286 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386290 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386294 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 386298 */   // MIs[1] Operand 1
     /* 386298 */   // No operand predicates
     /* 386298 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386300 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 386303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386305 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386307 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386310 */   GIR_RootConstrainSelectedInstOperands,
     /* 386311 */   // GIR_Coverage, 1926,
     /* 386311 */   GIR_EraseRootFromParent_Done,
     /* 386312 */ // Label 7457: @386312
     /* 386312 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(386360), // Rule ID 1927 //
     /* 386317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 386320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386342 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 386346 */   // MIs[1] Operand 1
     /* 386346 */   // No operand predicates
     /* 386346 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386348 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 386351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386353 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386355 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386358 */   GIR_RootConstrainSelectedInstOperands,
     /* 386359 */   // GIR_Coverage, 1927,
     /* 386359 */   GIR_EraseRootFromParent_Done,
     /* 386360 */ // Label 7458: @386360
     /* 386360 */ GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(386408), // Rule ID 1928 //
     /* 386365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 386368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386390 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 386394 */   // MIs[1] Operand 1
     /* 386394 */   // No operand predicates
     /* 386394 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386396 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 386399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386401 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386403 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386406 */   GIR_RootConstrainSelectedInstOperands,
     /* 386407 */   // GIR_Coverage, 1928,
     /* 386407 */   GIR_EraseRootFromParent_Done,
     /* 386408 */ // Label 7459: @386408
     /* 386408 */ GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(386456), // Rule ID 1930 //
     /* 386413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386430 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386434 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386438 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386442 */   // MIs[1] Operand 1
     /* 386442 */   // No operand predicates
     /* 386442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386444 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 386447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386449 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386451 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386454 */   GIR_RootConstrainSelectedInstOperands,
     /* 386455 */   // GIR_Coverage, 1930,
     /* 386455 */   GIR_EraseRootFromParent_Done,
     /* 386456 */ // Label 7460: @386456
     /* 386456 */ GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(386504), // Rule ID 1931 //
     /* 386461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386478 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386486 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386490 */   // MIs[1] Operand 1
     /* 386490 */   // No operand predicates
     /* 386490 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386492 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 386495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386497 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386499 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386502 */   GIR_RootConstrainSelectedInstOperands,
     /* 386503 */   // GIR_Coverage, 1931,
     /* 386503 */   GIR_EraseRootFromParent_Done,
     /* 386504 */ // Label 7461: @386504
     /* 386504 */ GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(386552), // Rule ID 1932 //
     /* 386509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386526 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386530 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386534 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386538 */   // MIs[1] Operand 1
     /* 386538 */   // No operand predicates
     /* 386538 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386540 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 386543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386545 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386547 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386550 */   GIR_RootConstrainSelectedInstOperands,
     /* 386551 */   // GIR_Coverage, 1932,
     /* 386551 */   GIR_EraseRootFromParent_Done,
     /* 386552 */ // Label 7462: @386552
     /* 386552 */ GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(386597), // Rule ID 5817 //
     /* 386557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386579 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386583 */   // MIs[1] Operand 1
     /* 386583 */   // No operand predicates
     /* 386583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386585 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 386588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386590 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386592 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386595 */   GIR_RootConstrainSelectedInstOperands,
     /* 386596 */   // GIR_Coverage, 5817,
     /* 386596 */   GIR_EraseRootFromParent_Done,
     /* 386597 */ // Label 7463: @386597
     /* 386597 */ GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(386673), // Rule ID 11256 //
     /* 386602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386615 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386619 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386623 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 386627 */   // MIs[1] Operand 1
     /* 386627 */   // No operand predicates
     /* 386627 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386629 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 386629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 386636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386641 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386645 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386655 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386667 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386672 */   // GIR_Coverage, 11256,
     /* 386672 */   GIR_EraseRootFromParent_Done,
     /* 386673 */ // Label 7464: @386673
     /* 386673 */ GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(386749), // Rule ID 11257 //
     /* 386678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386699 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 386703 */   // MIs[1] Operand 1
     /* 386703 */   // No operand predicates
     /* 386703 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386705 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 386705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 386712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386717 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386721 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386731 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386748 */   // GIR_Coverage, 11257,
     /* 386748 */   GIR_EraseRootFromParent_Done,
     /* 386749 */ // Label 7465: @386749
     /* 386749 */ GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(386825), // Rule ID 11258 //
     /* 386754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386767 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386771 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386775 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 386779 */   // MIs[1] Operand 1
     /* 386779 */   // No operand predicates
     /* 386779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386781 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 386781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 386788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386793 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386797 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386807 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386814 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386824 */   // GIR_Coverage, 11258,
     /* 386824 */   GIR_EraseRootFromParent_Done,
     /* 386825 */ // Label 7466: @386825
     /* 386825 */ GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(386901), // Rule ID 11263 //
     /* 386830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386843 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386851 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 386855 */   // MIs[1] Operand 1
     /* 386855 */   // No operand predicates
     /* 386855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386857 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 386857 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386860 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 386864 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386869 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386873 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386883 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386890 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386895 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386900 */   // GIR_Coverage, 11263,
     /* 386900 */   GIR_EraseRootFromParent_Done,
     /* 386901 */ // Label 7467: @386901
     /* 386901 */ GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(386977), // Rule ID 11264 //
     /* 386906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 386912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386927 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 386931 */   // MIs[1] Operand 1
     /* 386931 */   // No operand predicates
     /* 386931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386933 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 386933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 386940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386949 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386959 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386976 */   // GIR_Coverage, 11264,
     /* 386976 */   GIR_EraseRootFromParent_Done,
     /* 386977 */ // Label 7468: @386977
     /* 386977 */ GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(387038), // Rule ID 11246 //
     /* 386982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386999 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 386999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 387006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387011 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387017 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387021 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 387029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387034 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387036 */   GIR_RootConstrainSelectedInstOperands,
     /* 387037 */   // GIR_Coverage, 11246,
     /* 387037 */   GIR_EraseRootFromParent_Done,
     /* 387038 */ // Label 7469: @387038
     /* 387038 */ GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(387099), // Rule ID 11247 //
     /* 387043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387060 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 387060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 387067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387072 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387078 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387082 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 387090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387095 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387097 */   GIR_RootConstrainSelectedInstOperands,
     /* 387098 */   // GIR_Coverage, 11247,
     /* 387098 */   GIR_EraseRootFromParent_Done,
     /* 387099 */ // Label 7470: @387099
     /* 387099 */ GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(387160), // Rule ID 11248 //
     /* 387104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387121 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 387121 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387124 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 387128 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387133 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387139 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387143 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 387151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387156 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387158 */   GIR_RootConstrainSelectedInstOperands,
     /* 387159 */   // GIR_Coverage, 11248,
     /* 387159 */   GIR_EraseRootFromParent_Done,
     /* 387160 */ // Label 7471: @387160
     /* 387160 */ GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(387221), // Rule ID 11253 //
     /* 387165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387182 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 387182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387185 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 387189 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387194 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387200 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387204 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 387212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387217 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387219 */   GIR_RootConstrainSelectedInstOperands,
     /* 387220 */   // GIR_Coverage, 11253,
     /* 387220 */   GIR_EraseRootFromParent_Done,
     /* 387221 */ // Label 7472: @387221
     /* 387221 */ GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(387282), // Rule ID 11254 //
     /* 387226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 387232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387243 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 387243 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387246 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 387250 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387255 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387261 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387265 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 387273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387278 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387280 */   GIR_RootConstrainSelectedInstOperands,
     /* 387281 */   // GIR_Coverage, 11254,
     /* 387281 */   GIR_EraseRootFromParent_Done,
     /* 387282 */ // Label 7473: @387282
     /* 387282 */ GIM_Reject,
     /* 387283 */ // Label 7433: @387283
     /* 387283 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(387328), // Rule ID 6993 //
     /* 387288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387302 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387306 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 387306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387311 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 387317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387327 */   // GIR_Coverage, 6993,
     /* 387327 */   GIR_EraseRootFromParent_Done,
     /* 387328 */ // Label 7474: @387328
     /* 387328 */ GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(387372), // Rule ID 11284 //
     /* 387333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387346 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387350 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 387350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387355 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 387361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387371 */   // GIR_Coverage, 11284,
     /* 387371 */   GIR_EraseRootFromParent_Done,
     /* 387372 */ // Label 7475: @387372
     /* 387372 */ GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(387416), // Rule ID 11290 //
     /* 387377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387390 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387394 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 387394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387399 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 387405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387415 */   // GIR_Coverage, 11290,
     /* 387415 */   GIR_EraseRootFromParent_Done,
     /* 387416 */ // Label 7476: @387416
     /* 387416 */ GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(387461), // Rule ID 5813 //
     /* 387421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387435 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387439 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 387439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387444 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387450 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387460 */   // GIR_Coverage, 5813,
     /* 387460 */   GIR_EraseRootFromParent_Done,
     /* 387461 */ // Label 7477: @387461
     /* 387461 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(387534), // Rule ID 11269 //
     /* 387466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387487 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387491 */   // MIs[1] Operand 1
     /* 387491 */   // No operand predicates
     /* 387491 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387493 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 387493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 387496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387505 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387511 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387516 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 387524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387526 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387529 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387532 */   GIR_RootConstrainSelectedInstOperands,
     /* 387533 */   // GIR_Coverage, 11269,
     /* 387533 */   GIR_EraseRootFromParent_Done,
     /* 387534 */ // Label 7478: @387534
     /* 387534 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(387582), // Rule ID 1929 //
     /* 387539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387564 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 387568 */   // MIs[1] Operand 1
     /* 387568 */   // No operand predicates
     /* 387568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387570 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 387573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387575 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387577 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387580 */   GIR_RootConstrainSelectedInstOperands,
     /* 387581 */   // GIR_Coverage, 1929,
     /* 387581 */   GIR_EraseRootFromParent_Done,
     /* 387582 */ // Label 7479: @387582
     /* 387582 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(387630), // Rule ID 1933 //
     /* 387587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387604 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387612 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387616 */   // MIs[1] Operand 1
     /* 387616 */   // No operand predicates
     /* 387616 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387618 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 387621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387623 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387625 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387628 */   GIR_RootConstrainSelectedInstOperands,
     /* 387629 */   // GIR_Coverage, 1933,
     /* 387629 */   GIR_EraseRootFromParent_Done,
     /* 387630 */ // Label 7480: @387630
     /* 387630 */ GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(387675), // Rule ID 5816 //
     /* 387635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387649 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387653 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387657 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387661 */   // MIs[1] Operand 1
     /* 387661 */   // No operand predicates
     /* 387661 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387663 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 387666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387668 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387670 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387673 */   GIR_RootConstrainSelectedInstOperands,
     /* 387674 */   // GIR_Coverage, 5816,
     /* 387674 */   GIR_EraseRootFromParent_Done,
     /* 387675 */ // Label 7481: @387675
     /* 387675 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(387751), // Rule ID 11259 //
     /* 387680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387701 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 387705 */   // MIs[1] Operand 1
     /* 387705 */   // No operand predicates
     /* 387705 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387707 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 387707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 387714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387719 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387723 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387733 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387740 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387745 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387750 */   // GIR_Coverage, 11259,
     /* 387750 */   GIR_EraseRootFromParent_Done,
     /* 387751 */ // Label 7482: @387751
     /* 387751 */ GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(387827), // Rule ID 11265 //
     /* 387756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387769 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387777 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 387781 */   // MIs[1] Operand 1
     /* 387781 */   // No operand predicates
     /* 387781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387783 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 387783 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387786 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 387790 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387795 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387799 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387809 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387826 */   // GIR_Coverage, 11265,
     /* 387826 */   GIR_EraseRootFromParent_Done,
     /* 387827 */ // Label 7483: @387827
     /* 387827 */ GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(387888), // Rule ID 11249 //
     /* 387832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387849 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 387849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 387856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387861 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387867 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387871 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 387879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387884 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387886 */   GIR_RootConstrainSelectedInstOperands,
     /* 387887 */   // GIR_Coverage, 11249,
     /* 387887 */   GIR_EraseRootFromParent_Done,
     /* 387888 */ // Label 7484: @387888
     /* 387888 */ GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(387949), // Rule ID 11255 //
     /* 387893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387910 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 387910 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387913 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 387917 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387922 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387928 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387932 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 387940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387945 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387947 */   GIR_RootConstrainSelectedInstOperands,
     /* 387948 */   // GIR_Coverage, 11255,
     /* 387948 */   GIR_EraseRootFromParent_Done,
     /* 387949 */ // Label 7485: @387949
     /* 387949 */ GIM_Reject,
     /* 387950 */ // Label 7434: @387950
     /* 387950 */ GIM_Reject,
     /* 387951 */ // Label 92: @387951
     /* 387951 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7493*/ GIMT_Encode4(390270),
     /* 387962 */ /*GILLT_nxv2s16*//*Label 7486*/ GIMT_Encode4(388002),
     /* 387966 */ /*GILLT_nxv2s32*//*Label 7487*/ GIMT_Encode4(388361),
     /* 387970 */ /*GILLT_nxv2s64*//*Label 7488*/ GIMT_Encode4(388663), GIMT_Encode4(0),
     /* 387978 */ /*GILLT_nxv4s16*//*Label 7489*/ GIMT_Encode4(389038),
     /* 387982 */ /*GILLT_nxv4s32*//*Label 7490*/ GIMT_Encode4(389340), GIMT_Encode4(0),
     /* 387990 */ /*GILLT_nxv8s16*//*Label 7491*/ GIMT_Encode4(389715), GIMT_Encode4(0),
     /* 387998 */ /*GILLT_nxv16s8*//*Label 7492*/ GIMT_Encode4(390126),
     /* 388002 */ // Label 7486: @388002
     /* 388002 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(388360),
     /* 388007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 388010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388014 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(388078), // Rule ID 6047 //
     /* 388019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388030 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 388034 */     // MIs[1] Operand 1
     /* 388034 */     // No operand predicates
     /* 388034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388036 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 388036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 388043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 388067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388077 */     // GIR_Coverage, 6047,
     /* 388077 */     GIR_EraseRootFromParent_Done,
     /* 388078 */   // Label 7495: @388078
     /* 388078 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(388135), // Rule ID 2668 //
     /* 388083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 388098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388115 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388119 */     // MIs[2] Operand 1
     /* 388119 */     // No operand predicates
     /* 388119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388121 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 388121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388133 */     GIR_RootConstrainSelectedInstOperands,
     /* 388134 */     // GIR_Coverage, 2668,
     /* 388134 */     GIR_EraseRootFromParent_Done,
     /* 388135 */   // Label 7496: @388135
     /* 388135 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(388192), // Rule ID 2670 //
     /* 388140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 388155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388176 */     // MIs[2] Operand 1
     /* 388176 */     // No operand predicates
     /* 388176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388178 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 388178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388190 */     GIR_RootConstrainSelectedInstOperands,
     /* 388191 */     // GIR_Coverage, 2670,
     /* 388191 */     GIR_EraseRootFromParent_Done,
     /* 388192 */   // Label 7497: @388192
     /* 388192 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(388249), // Rule ID 8389 //
     /* 388197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388229 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 388233 */     // MIs[2] Operand 1
     /* 388233 */     // No operand predicates
     /* 388233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388235 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 388235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 388238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388247 */     GIR_RootConstrainSelectedInstOperands,
     /* 388248 */     // GIR_Coverage, 8389,
     /* 388248 */     GIR_EraseRootFromParent_Done,
     /* 388249 */   // Label 7498: @388249
     /* 388249 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(388283), // Rule ID 8432 //
     /* 388254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388265 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 388269 */     // MIs[1] Operand 1
     /* 388269 */     // No operand predicates
     /* 388269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388271 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 388271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 388274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388276 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 388281 */     GIR_RootConstrainSelectedInstOperands,
     /* 388282 */     // GIR_Coverage, 8432,
     /* 388282 */     GIR_EraseRootFromParent_Done,
     /* 388283 */   // Label 7499: @388283
     /* 388283 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(388359), // Rule ID 8410 //
     /* 388288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388295 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388295 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 388298 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 388302 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 388309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 388316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388321 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 388324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 388328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 388349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388357 */     GIR_RootConstrainSelectedInstOperands,
     /* 388358 */     // GIR_Coverage, 8410,
     /* 388358 */     GIR_EraseRootFromParent_Done,
     /* 388359 */   // Label 7500: @388359
     /* 388359 */   GIM_Reject,
     /* 388360 */ // Label 7494: @388360
     /* 388360 */ GIM_Reject,
     /* 388361 */ // Label 7487: @388361
     /* 388361 */ GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(388662),
     /* 388366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388373 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(388437), // Rule ID 6045 //
     /* 388378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388389 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 388393 */     // MIs[1] Operand 1
     /* 388393 */     // No operand predicates
     /* 388393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388395 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 388395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 388402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388407 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 388426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388436 */     // GIR_Coverage, 6045,
     /* 388436 */     GIR_EraseRootFromParent_Done,
     /* 388437 */   // Label 7502: @388437
     /* 388437 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(388494), // Rule ID 8398 //
     /* 388442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388474 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388478 */     // MIs[2] Operand 1
     /* 388478 */     // No operand predicates
     /* 388478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388480 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 388480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388492 */     GIR_RootConstrainSelectedInstOperands,
     /* 388493 */     // GIR_Coverage, 8398,
     /* 388493 */     GIR_EraseRootFromParent_Done,
     /* 388494 */   // Label 7503: @388494
     /* 388494 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(388551), // Rule ID 8407 //
     /* 388499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 388514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388531 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388535 */     // MIs[2] Operand 1
     /* 388535 */     // No operand predicates
     /* 388535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388537 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 388537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388549 */     GIR_RootConstrainSelectedInstOperands,
     /* 388550 */     // GIR_Coverage, 8407,
     /* 388550 */     GIR_EraseRootFromParent_Done,
     /* 388551 */   // Label 7504: @388551
     /* 388551 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(388585), // Rule ID 8434 //
     /* 388556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388567 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 388571 */     // MIs[1] Operand 1
     /* 388571 */     // No operand predicates
     /* 388571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388573 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 388573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 388576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388578 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 388583 */     GIR_RootConstrainSelectedInstOperands,
     /* 388584 */     // GIR_Coverage, 8434,
     /* 388584 */     GIR_EraseRootFromParent_Done,
     /* 388585 */   // Label 7505: @388585
     /* 388585 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(388661), // Rule ID 8412 //
     /* 388590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388597 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388597 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 388600 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 388604 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 388611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 388618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388623 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 388626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 388630 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 388633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388659 */     GIR_RootConstrainSelectedInstOperands,
     /* 388660 */     // GIR_Coverage, 8412,
     /* 388660 */     GIR_EraseRootFromParent_Done,
     /* 388661 */   // Label 7506: @388661
     /* 388661 */   GIM_Reject,
     /* 388662 */ // Label 7501: @388662
     /* 388662 */ GIM_Reject,
     /* 388663 */ // Label 7488: @388663
     /* 388663 */ GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(389037),
     /* 388668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 388671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388675 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(388729), // Rule ID 6040 //
     /* 388680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 388687 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 388687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 388694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388699 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 388718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388728 */     // GIR_Coverage, 6040,
     /* 388728 */     GIR_EraseRootFromParent_Done,
     /* 388729 */   // Label 7508: @388729
     /* 388729 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(388793), // Rule ID 6044 //
     /* 388734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388745 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 388749 */     // MIs[1] Operand 1
     /* 388749 */     // No operand predicates
     /* 388749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388751 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 388751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 388758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 388782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388792 */     // GIR_Coverage, 6044,
     /* 388792 */     GIR_EraseRootFromParent_Done,
     /* 388793 */   // Label 7509: @388793
     /* 388793 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(388850), // Rule ID 2665 //
     /* 388798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388830 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388834 */     // MIs[2] Operand 1
     /* 388834 */     // No operand predicates
     /* 388834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388836 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 388836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388848 */     GIR_RootConstrainSelectedInstOperands,
     /* 388849 */     // GIR_Coverage, 2665,
     /* 388849 */     GIR_EraseRootFromParent_Done,
     /* 388850 */   // Label 7510: @388850
     /* 388850 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(388907), // Rule ID 8404 //
     /* 388855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388887 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388891 */     // MIs[2] Operand 1
     /* 388891 */     // No operand predicates
     /* 388891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388893 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 388893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388905 */     GIR_RootConstrainSelectedInstOperands,
     /* 388906 */     // GIR_Coverage, 8404,
     /* 388906 */     GIR_EraseRootFromParent_Done,
     /* 388907 */   // Label 7511: @388907
     /* 388907 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(388941), // Rule ID 8435 //
     /* 388912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388923 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 388927 */     // MIs[1] Operand 1
     /* 388927 */     // No operand predicates
     /* 388927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388929 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 388929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 388932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388934 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 388939 */     GIR_RootConstrainSelectedInstOperands,
     /* 388940 */     // GIR_Coverage, 8435,
     /* 388940 */     GIR_EraseRootFromParent_Done,
     /* 388941 */   // Label 7512: @388941
     /* 388941 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(388960), // Rule ID 2391 //
     /* 388946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 388953 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 388958 */     GIR_RootConstrainSelectedInstOperands,
     /* 388959 */     // GIR_Coverage, 2391,
     /* 388959 */     GIR_Done,
     /* 388960 */   // Label 7513: @388960
     /* 388960 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(389036), // Rule ID 8413 //
     /* 388965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388972 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388972 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 388975 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 388979 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 388986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 388993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388998 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 389008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389034 */     GIR_RootConstrainSelectedInstOperands,
     /* 389035 */     // GIR_Coverage, 8413,
     /* 389035 */     GIR_EraseRootFromParent_Done,
     /* 389036 */   // Label 7514: @389036
     /* 389036 */   GIM_Reject,
     /* 389037 */ // Label 7507: @389037
     /* 389037 */ GIM_Reject,
     /* 389038 */ // Label 7489: @389038
     /* 389038 */ GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(389339),
     /* 389043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389050 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(389114), // Rule ID 6048 //
     /* 389055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389066 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389070 */     // MIs[1] Operand 1
     /* 389070 */     // No operand predicates
     /* 389070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389072 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389084 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389113 */     // GIR_Coverage, 6048,
     /* 389113 */     GIR_EraseRootFromParent_Done,
     /* 389114 */   // Label 7516: @389114
     /* 389114 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(389171), // Rule ID 2669 //
     /* 389119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 389134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389155 */     // MIs[2] Operand 1
     /* 389155 */     // No operand predicates
     /* 389155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389157 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389169 */     GIR_RootConstrainSelectedInstOperands,
     /* 389170 */     // GIR_Coverage, 2669,
     /* 389170 */     GIR_EraseRootFromParent_Done,
     /* 389171 */   // Label 7517: @389171
     /* 389171 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(389228), // Rule ID 8392 //
     /* 389176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389208 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389212 */     // MIs[2] Operand 1
     /* 389212 */     // No operand predicates
     /* 389212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389214 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 389214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389226 */     GIR_RootConstrainSelectedInstOperands,
     /* 389227 */     // GIR_Coverage, 8392,
     /* 389227 */     GIR_EraseRootFromParent_Done,
     /* 389228 */   // Label 7518: @389228
     /* 389228 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(389262), // Rule ID 8431 //
     /* 389233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389244 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 389248 */     // MIs[1] Operand 1
     /* 389248 */     // No operand predicates
     /* 389248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389250 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 389250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 389253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389255 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 389260 */     GIR_RootConstrainSelectedInstOperands,
     /* 389261 */     // GIR_Coverage, 8431,
     /* 389261 */     GIR_EraseRootFromParent_Done,
     /* 389262 */   // Label 7519: @389262
     /* 389262 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(389338), // Rule ID 8409 //
     /* 389267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389274 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389274 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389277 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389281 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389300 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389303 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389336 */     GIR_RootConstrainSelectedInstOperands,
     /* 389337 */     // GIR_Coverage, 8409,
     /* 389337 */     GIR_EraseRootFromParent_Done,
     /* 389338 */   // Label 7520: @389338
     /* 389338 */   GIM_Reject,
     /* 389339 */ // Label 7515: @389339
     /* 389339 */ GIM_Reject,
     /* 389340 */ // Label 7490: @389340
     /* 389340 */ GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(389714),
     /* 389345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389352 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(389406), // Rule ID 6041 //
     /* 389357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 389364 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389376 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389405 */     // GIR_Coverage, 6041,
     /* 389405 */     GIR_EraseRootFromParent_Done,
     /* 389406 */   // Label 7522: @389406
     /* 389406 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(389470), // Rule ID 6046 //
     /* 389411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389422 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389426 */     // MIs[1] Operand 1
     /* 389426 */     // No operand predicates
     /* 389426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389428 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389469 */     // GIR_Coverage, 6046,
     /* 389469 */     GIR_EraseRootFromParent_Done,
     /* 389470 */   // Label 7523: @389470
     /* 389470 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(389527), // Rule ID 2662 //
     /* 389475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389511 */     // MIs[2] Operand 1
     /* 389511 */     // No operand predicates
     /* 389511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389513 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389525 */     GIR_RootConstrainSelectedInstOperands,
     /* 389526 */     // GIR_Coverage, 2662,
     /* 389526 */     GIR_EraseRootFromParent_Done,
     /* 389527 */   // Label 7524: @389527
     /* 389527 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(389584), // Rule ID 8401 //
     /* 389532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389564 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389568 */     // MIs[2] Operand 1
     /* 389568 */     // No operand predicates
     /* 389568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389570 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389582 */     GIR_RootConstrainSelectedInstOperands,
     /* 389583 */     // GIR_Coverage, 8401,
     /* 389583 */     GIR_EraseRootFromParent_Done,
     /* 389584 */   // Label 7525: @389584
     /* 389584 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(389618), // Rule ID 8433 //
     /* 389589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389600 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 389604 */     // MIs[1] Operand 1
     /* 389604 */     // No operand predicates
     /* 389604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389606 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 389606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 389609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389611 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 389616 */     GIR_RootConstrainSelectedInstOperands,
     /* 389617 */     // GIR_Coverage, 8433,
     /* 389617 */     GIR_EraseRootFromParent_Done,
     /* 389618 */   // Label 7526: @389618
     /* 389618 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(389637), // Rule ID 2390 //
     /* 389623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 389630 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 389630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 389635 */     GIR_RootConstrainSelectedInstOperands,
     /* 389636 */     // GIR_Coverage, 2390,
     /* 389636 */     GIR_Done,
     /* 389637 */   // Label 7527: @389637
     /* 389637 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(389713), // Rule ID 8411 //
     /* 389642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389649 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389649 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389652 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389656 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389675 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389682 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389711 */     GIR_RootConstrainSelectedInstOperands,
     /* 389712 */     // GIR_Coverage, 8411,
     /* 389712 */     GIR_EraseRootFromParent_Done,
     /* 389713 */   // Label 7528: @389713
     /* 389713 */   GIM_Reject,
     /* 389714 */ // Label 7521: @389714
     /* 389714 */ GIM_Reject,
     /* 389715 */ // Label 7491: @389715
     /* 389715 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(389776), // Rule ID 6042 //
     /* 389720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389730 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 389734 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389746 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389775 */   // GIR_Coverage, 6042,
     /* 389775 */   GIR_EraseRootFromParent_Done,
     /* 389776 */ // Label 7529: @389776
     /* 389776 */ GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(389847), // Rule ID 6049 //
     /* 389781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389791 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389799 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389803 */   // MIs[1] Operand 1
     /* 389803 */   // No operand predicates
     /* 389803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389805 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389817 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389836 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389841 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389846 */   // GIR_Coverage, 6049,
     /* 389846 */   GIR_EraseRootFromParent_Done,
     /* 389847 */ // Label 7530: @389847
     /* 389847 */ GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(389911), // Rule ID 2659 //
     /* 389852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389874 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389878 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389883 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389887 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389891 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389895 */   // MIs[2] Operand 1
     /* 389895 */   // No operand predicates
     /* 389895 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389897 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 389897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389902 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389906 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389909 */   GIR_RootConstrainSelectedInstOperands,
     /* 389910 */   // GIR_Coverage, 2659,
     /* 389910 */   GIR_EraseRootFromParent_Done,
     /* 389911 */ // Label 7531: @389911
     /* 389911 */ GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(389975), // Rule ID 8395 //
     /* 389916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389934 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389938 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389942 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389947 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389951 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389955 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389959 */   // MIs[2] Operand 1
     /* 389959 */   // No operand predicates
     /* 389959 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389961 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 389961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389966 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389970 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389973 */   GIR_RootConstrainSelectedInstOperands,
     /* 389974 */   // GIR_Coverage, 8395,
     /* 389974 */   GIR_EraseRootFromParent_Done,
     /* 389975 */ // Label 7532: @389975
     /* 389975 */ GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(390016), // Rule ID 8430 //
     /* 389980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389990 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389994 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389998 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 390002 */   // MIs[1] Operand 1
     /* 390002 */   // No operand predicates
     /* 390002 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390004 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 390004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 390007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390009 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 390014 */   GIR_RootConstrainSelectedInstOperands,
     /* 390015 */   // GIR_Coverage, 8430,
     /* 390015 */   GIR_EraseRootFromParent_Done,
     /* 390016 */ // Label 7533: @390016
     /* 390016 */ GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(390042), // Rule ID 2389 //
     /* 390021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 390035 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 390035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 390040 */   GIR_RootConstrainSelectedInstOperands,
     /* 390041 */   // GIR_Coverage, 2389,
     /* 390041 */   GIR_Done,
     /* 390042 */ // Label 7534: @390042
     /* 390042 */ GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(390125), // Rule ID 8408 //
     /* 390047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390061 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390061 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390064 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390068 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390087 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390090 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390094 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390097 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390102 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390123 */   GIR_RootConstrainSelectedInstOperands,
     /* 390124 */   // GIR_Coverage, 8408,
     /* 390124 */   GIR_EraseRootFromParent_Done,
     /* 390125 */ // Label 7535: @390125
     /* 390125 */ GIM_Reject,
     /* 390126 */ // Label 7492: @390126
     /* 390126 */ GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(390269),
     /* 390131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390138 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(390192), // Rule ID 6043 //
     /* 390143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 390150 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390162 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390191 */     // GIR_Coverage, 6043,
     /* 390191 */     GIR_EraseRootFromParent_Done,
     /* 390192 */   // Label 7537: @390192
     /* 390192 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(390249), // Rule ID 2656 //
     /* 390197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 390212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390229 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 390233 */     // MIs[2] Operand 1
     /* 390233 */     // No operand predicates
     /* 390233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390235 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 390235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 390238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390247 */     GIR_RootConstrainSelectedInstOperands,
     /* 390248 */     // GIR_Coverage, 2656,
     /* 390248 */     GIR_EraseRootFromParent_Done,
     /* 390249 */   // Label 7538: @390249
     /* 390249 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(390268), // Rule ID 2388 //
     /* 390254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 390261 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 390261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 390266 */     GIR_RootConstrainSelectedInstOperands,
     /* 390267 */     // GIR_Coverage, 2388,
     /* 390267 */     GIR_Done,
     /* 390268 */   // Label 7539: @390268
     /* 390268 */   GIM_Reject,
     /* 390269 */ // Label 7536: @390269
     /* 390269 */ GIM_Reject,
     /* 390270 */ // Label 7493: @390270
     /* 390270 */ GIM_Reject,
     /* 390271 */ // Label 93: @390271
     /* 390271 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7542*/ GIMT_Encode4(390422),
     /* 390282 */ /*GILLT_s32*//*Label 7540*/ GIMT_Encode4(390290),
     /* 390286 */ /*GILLT_s64*//*Label 7541*/ GIMT_Encode4(390356),
     /* 390290 */ // Label 7540: @390290
     /* 390290 */ GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(390355),
     /* 390295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390306 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(390321), // Rule ID 2321 //
     /* 390311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 390314 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 390314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 390319 */     GIR_RootConstrainSelectedInstOperands,
     /* 390320 */     // GIR_Coverage, 2321,
     /* 390320 */     GIR_Done,
     /* 390321 */   // Label 7544: @390321
     /* 390321 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(390354), // Rule ID 4002 //
     /* 390326 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 390326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 390329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 390333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 390342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 390347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390352 */     GIR_RootConstrainSelectedInstOperands,
     /* 390353 */     // GIR_Coverage, 4002,
     /* 390353 */     GIR_EraseRootFromParent_Done,
     /* 390354 */   // Label 7545: @390354
     /* 390354 */   GIM_Reject,
     /* 390355 */ // Label 7543: @390355
     /* 390355 */ GIM_Reject,
     /* 390356 */ // Label 7541: @390356
     /* 390356 */ GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(390421),
     /* 390361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390372 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(390387), // Rule ID 2322 //
     /* 390377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 390380 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 390380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 390385 */     GIR_RootConstrainSelectedInstOperands,
     /* 390386 */     // GIR_Coverage, 2322,
     /* 390386 */     GIR_Done,
     /* 390387 */   // Label 7547: @390387
     /* 390387 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(390420), // Rule ID 4003 //
     /* 390392 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 390392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 390395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 390399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 390408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 390413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390418 */     GIR_RootConstrainSelectedInstOperands,
     /* 390419 */     // GIR_Coverage, 4003,
     /* 390419 */     GIR_EraseRootFromParent_Done,
     /* 390420 */   // Label 7548: @390420
     /* 390420 */   GIM_Reject,
     /* 390421 */ // Label 7546: @390421
     /* 390421 */ GIM_Reject,
     /* 390422 */ // Label 7542: @390422
     /* 390422 */ GIM_Reject,
     /* 390423 */ // Label 94: @390423
     /* 390423 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7557*/ GIMT_Encode4(391096),
     /* 390434 */ /*GILLT_s32*//*Label 7549*/ GIMT_Encode4(390474),
     /* 390438 */ /*GILLT_s64*//*Label 7550*/ GIMT_Encode4(390704), GIMT_Encode4(0),
     /* 390446 */ /*GILLT_v2s32*//*Label 7551*/ GIMT_Encode4(390934), GIMT_Encode4(0),
     /* 390454 */ /*GILLT_v4s16*//*Label 7552*/ GIMT_Encode4(390961),
     /* 390458 */ /*GILLT_v4s32*//*Label 7553*/ GIMT_Encode4(390988),
     /* 390462 */ /*GILLT_v8s8*//*Label 7554*/ GIMT_Encode4(391015),
     /* 390466 */ /*GILLT_v8s16*//*Label 7555*/ GIMT_Encode4(391042),
     /* 390470 */ /*GILLT_v16s8*//*Label 7556*/ GIMT_Encode4(391069),
     /* 390474 */ // Label 7549: @390474
     /* 390474 */ GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(390703),
     /* 390479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390486 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(390586), // Rule ID 4004 //
     /* 390491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 390499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 390507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 390515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 390531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 390535 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 390539 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 390543 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 390547 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 390551 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390556 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 390560 */     // MIs[3] Rn
     /* 390560 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 390565 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 390569 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 390573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 390575 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 390575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 390578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 390584 */     GIR_RootConstrainSelectedInstOperands,
     /* 390585 */     // GIR_Coverage, 4004,
     /* 390585 */     GIR_EraseRootFromParent_Done,
     /* 390586 */   // Label 7559: @390586
     /* 390586 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(390686), // Rule ID 13881 //
     /* 390591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 390599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 390607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 390615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 390631 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 390635 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 390639 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 390648 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 390652 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 390656 */     // MIs[4] Rn
     /* 390656 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 390661 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 390665 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 390669 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 390673 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 390675 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 390675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 390678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 390684 */     GIR_RootConstrainSelectedInstOperands,
     /* 390685 */     // GIR_Coverage, 13881,
     /* 390685 */     GIR_EraseRootFromParent_Done,
     /* 390686 */   // Label 7560: @390686
     /* 390686 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(390702), // Rule ID 180 //
     /* 390691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390695 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 390695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 390700 */     GIR_RootConstrainSelectedInstOperands,
     /* 390701 */     // GIR_Coverage, 180,
     /* 390701 */     GIR_Done,
     /* 390702 */   // Label 7561: @390702
     /* 390702 */   GIM_Reject,
     /* 390703 */ // Label 7558: @390703
     /* 390703 */ GIM_Reject,
     /* 390704 */ // Label 7550: @390704
     /* 390704 */ GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(390933),
     /* 390709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390716 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(390816), // Rule ID 4005 //
     /* 390721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 390729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 390733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 390745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 390749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 390761 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 390765 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 390769 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 390773 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 390777 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 390781 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390786 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 390790 */     // MIs[3] Rn
     /* 390790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 390795 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 390799 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 390803 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 390805 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 390805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 390808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 390814 */     GIR_RootConstrainSelectedInstOperands,
     /* 390815 */     // GIR_Coverage, 4005,
     /* 390815 */     GIR_EraseRootFromParent_Done,
     /* 390816 */   // Label 7563: @390816
     /* 390816 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(390916), // Rule ID 13882 //
     /* 390821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 390829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 390833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 390845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 390849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 390861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 390865 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 390869 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 390878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 390882 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 390886 */     // MIs[4] Rn
     /* 390886 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 390891 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 390895 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 390899 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 390903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 390905 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 390905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 390908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 390914 */     GIR_RootConstrainSelectedInstOperands,
     /* 390915 */     // GIR_Coverage, 13882,
     /* 390915 */     GIR_EraseRootFromParent_Done,
     /* 390916 */   // Label 7564: @390916
     /* 390916 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(390932), // Rule ID 181 //
     /* 390921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390925 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 390925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 390930 */     GIR_RootConstrainSelectedInstOperands,
     /* 390931 */     // GIR_Coverage, 181,
     /* 390931 */     GIR_Done,
     /* 390932 */   // Label 7565: @390932
     /* 390932 */   GIM_Reject,
     /* 390933 */ // Label 7562: @390933
     /* 390933 */ GIM_Reject,
     /* 390934 */ // Label 7551: @390934
     /* 390934 */ GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(390960), // Rule ID 720 //
     /* 390939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390953 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 390953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 390958 */   GIR_RootConstrainSelectedInstOperands,
     /* 390959 */   // GIR_Coverage, 720,
     /* 390959 */   GIR_Done,
     /* 390960 */ // Label 7566: @390960
     /* 390960 */ GIM_Reject,
     /* 390961 */ // Label 7552: @390961
     /* 390961 */ GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(390987), // Rule ID 718 //
     /* 390966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390980 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 390980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 390985 */   GIR_RootConstrainSelectedInstOperands,
     /* 390986 */   // GIR_Coverage, 718,
     /* 390986 */   GIR_Done,
     /* 390987 */ // Label 7567: @390987
     /* 390987 */ GIM_Reject,
     /* 390988 */ // Label 7553: @390988
     /* 390988 */ GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(391014), // Rule ID 721 //
     /* 390993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391007 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 391007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 391012 */   GIR_RootConstrainSelectedInstOperands,
     /* 391013 */   // GIR_Coverage, 721,
     /* 391013 */   GIR_Done,
     /* 391014 */ // Label 7568: @391014
     /* 391014 */ GIM_Reject,
     /* 391015 */ // Label 7554: @391015
     /* 391015 */ GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(391041), // Rule ID 716 //
     /* 391020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391034 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391034 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 391039 */   GIR_RootConstrainSelectedInstOperands,
     /* 391040 */   // GIR_Coverage, 716,
     /* 391040 */   GIR_Done,
     /* 391041 */ // Label 7569: @391041
     /* 391041 */ GIM_Reject,
     /* 391042 */ // Label 7555: @391042
     /* 391042 */ GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(391068), // Rule ID 719 //
     /* 391047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391061 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 391066 */   GIR_RootConstrainSelectedInstOperands,
     /* 391067 */   // GIR_Coverage, 719,
     /* 391067 */   GIR_Done,
     /* 391068 */ // Label 7570: @391068
     /* 391068 */ GIM_Reject,
     /* 391069 */ // Label 7556: @391069
     /* 391069 */ GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(391095), // Rule ID 717 //
     /* 391074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391088 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 391093 */   GIR_RootConstrainSelectedInstOperands,
     /* 391094 */   // GIR_Coverage, 717,
     /* 391094 */   GIR_Done,
     /* 391095 */ // Label 7571: @391095
     /* 391095 */ GIM_Reject,
     /* 391096 */ // Label 7557: @391096
     /* 391096 */ GIM_Reject,
     /* 391097 */ // Label 95: @391097
     /* 391097 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7576*/ GIMT_Encode4(391256),
     /* 391108 */ /*GILLT_s32*//*Label 7572*/ GIMT_Encode4(391148),
     /* 391112 */ /*GILLT_s64*//*Label 7573*/ GIMT_Encode4(391175), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 391136 */ /*GILLT_v8s8*//*Label 7574*/ GIMT_Encode4(391202), GIMT_Encode4(0),
     /* 391144 */ /*GILLT_v16s8*//*Label 7575*/ GIMT_Encode4(391229),
     /* 391148 */ // Label 7572: @391148
     /* 391148 */ GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(391174), // Rule ID 2319 //
     /* 391153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391167 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 391172 */   GIR_RootConstrainSelectedInstOperands,
     /* 391173 */   // GIR_Coverage, 2319,
     /* 391173 */   GIR_Done,
     /* 391174 */ // Label 7577: @391174
     /* 391174 */ GIM_Reject,
     /* 391175 */ // Label 7573: @391175
     /* 391175 */ GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(391201), // Rule ID 2320 //
     /* 391180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391194 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 391199 */   GIR_RootConstrainSelectedInstOperands,
     /* 391200 */   // GIR_Coverage, 2320,
     /* 391200 */   GIR_Done,
     /* 391201 */ // Label 7578: @391201
     /* 391201 */ GIM_Reject,
     /* 391202 */ // Label 7574: @391202
     /* 391202 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(391228), // Rule ID 764 //
     /* 391207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391221 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 391226 */   GIR_RootConstrainSelectedInstOperands,
     /* 391227 */   // GIR_Coverage, 764,
     /* 391227 */   GIR_Done,
     /* 391228 */ // Label 7579: @391228
     /* 391228 */ GIM_Reject,
     /* 391229 */ // Label 7575: @391229
     /* 391229 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(391255), // Rule ID 765 //
     /* 391234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391248 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 391253 */   GIR_RootConstrainSelectedInstOperands,
     /* 391254 */   // GIR_Coverage, 765,
     /* 391254 */   GIR_Done,
     /* 391255 */ // Label 7580: @391255
     /* 391255 */ GIM_Reject,
     /* 391256 */ // Label 7576: @391256
     /* 391256 */ GIM_Reject,
     /* 391257 */ // Label 96: @391257
     /* 391257 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7588*/ GIMT_Encode4(391570),
     /* 391268 */ /*GILLT_s32*//*Label 7581*/ GIMT_Encode4(391304),
     /* 391272 */ /*GILLT_s64*//*Label 7582*/ GIMT_Encode4(391377), GIMT_Encode4(0),
     /* 391280 */ /*GILLT_v2s32*//*Label 7583*/ GIMT_Encode4(391450),
     /* 391284 */ /*GILLT_v2s64*//*Label 7584*/ GIMT_Encode4(391474),
     /* 391288 */ /*GILLT_v4s16*//*Label 7585*/ GIMT_Encode4(391498),
     /* 391292 */ /*GILLT_v4s32*//*Label 7586*/ GIMT_Encode4(391522), GIMT_Encode4(0),
     /* 391300 */ /*GILLT_v8s16*//*Label 7587*/ GIMT_Encode4(391546),
     /* 391304 */ // Label 7581: @391304
     /* 391304 */ GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(391376),
     /* 391309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391316 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(391359), // Rule ID 4008 //
     /* 391321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 391329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 391333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391342 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 391346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391348 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 391351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391357 */     GIR_RootConstrainSelectedInstOperands,
     /* 391358 */     // GIR_Coverage, 4008,
     /* 391358 */     GIR_EraseRootFromParent_Done,
     /* 391359 */   // Label 7590: @391359
     /* 391359 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(391375), // Rule ID 185 //
     /* 391364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391368 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 391373 */     GIR_RootConstrainSelectedInstOperands,
     /* 391374 */     // GIR_Coverage, 185,
     /* 391374 */     GIR_Done,
     /* 391375 */   // Label 7591: @391375
     /* 391375 */   GIM_Reject,
     /* 391376 */ // Label 7589: @391376
     /* 391376 */ GIM_Reject,
     /* 391377 */ // Label 7582: @391377
     /* 391377 */ GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(391449),
     /* 391382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391389 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(391432), // Rule ID 4009 //
     /* 391394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 391402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 391406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391415 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 391419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391421 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 391424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391430 */     GIR_RootConstrainSelectedInstOperands,
     /* 391431 */     // GIR_Coverage, 4009,
     /* 391431 */     GIR_EraseRootFromParent_Done,
     /* 391432 */   // Label 7593: @391432
     /* 391432 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(391448), // Rule ID 186 //
     /* 391437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391441 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 391446 */     GIR_RootConstrainSelectedInstOperands,
     /* 391447 */     // GIR_Coverage, 186,
     /* 391447 */     GIR_Done,
     /* 391448 */   // Label 7594: @391448
     /* 391448 */   GIM_Reject,
     /* 391449 */ // Label 7592: @391449
     /* 391449 */ GIM_Reject,
     /* 391450 */ // Label 7583: @391450
     /* 391450 */ GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(391473), // Rule ID 5021 //
     /* 391455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391466 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 391466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 391471 */   GIR_RootConstrainSelectedInstOperands,
     /* 391472 */   // GIR_Coverage, 5021,
     /* 391472 */   GIR_Done,
     /* 391473 */ // Label 7595: @391473
     /* 391473 */ GIM_Reject,
     /* 391474 */ // Label 7584: @391474
     /* 391474 */ GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(391497), // Rule ID 5023 //
     /* 391479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391490 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 391490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 391495 */   GIR_RootConstrainSelectedInstOperands,
     /* 391496 */   // GIR_Coverage, 5023,
     /* 391496 */   GIR_Done,
     /* 391497 */ // Label 7596: @391497
     /* 391497 */ GIM_Reject,
     /* 391498 */ // Label 7585: @391498
     /* 391498 */ GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(391521), // Rule ID 5019 //
     /* 391503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391514 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 391514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 391519 */   GIR_RootConstrainSelectedInstOperands,
     /* 391520 */   // GIR_Coverage, 5019,
     /* 391520 */   GIR_Done,
     /* 391521 */ // Label 7597: @391521
     /* 391521 */ GIM_Reject,
     /* 391522 */ // Label 7586: @391522
     /* 391522 */ GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(391545), // Rule ID 5022 //
     /* 391527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391538 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 391538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 391543 */   GIR_RootConstrainSelectedInstOperands,
     /* 391544 */   // GIR_Coverage, 5022,
     /* 391544 */   GIR_Done,
     /* 391545 */ // Label 7598: @391545
     /* 391545 */ GIM_Reject,
     /* 391546 */ // Label 7587: @391546
     /* 391546 */ GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(391569), // Rule ID 5020 //
     /* 391551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391562 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 391567 */   GIR_RootConstrainSelectedInstOperands,
     /* 391568 */   // GIR_Coverage, 5020,
     /* 391568 */   GIR_Done,
     /* 391569 */ // Label 7599: @391569
     /* 391569 */ GIM_Reject,
     /* 391570 */ // Label 7588: @391570
     /* 391570 */ GIM_Reject,
     /* 391571 */ // Label 97: @391571
     /* 391571 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7604*/ GIMT_Encode4(391724),
     /* 391582 */ /*GILLT_s32*//*Label 7600*/ GIMT_Encode4(391622),
     /* 391586 */ /*GILLT_s64*//*Label 7601*/ GIMT_Encode4(391646), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 391610 */ /*GILLT_v8s8*//*Label 7602*/ GIMT_Encode4(391670), GIMT_Encode4(0),
     /* 391618 */ /*GILLT_v16s8*//*Label 7603*/ GIMT_Encode4(391697),
     /* 391622 */ // Label 7600: @391622
     /* 391622 */ GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(391645), // Rule ID 182 //
     /* 391627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391638 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 391643 */   GIR_RootConstrainSelectedInstOperands,
     /* 391644 */   // GIR_Coverage, 182,
     /* 391644 */   GIR_Done,
     /* 391645 */ // Label 7605: @391645
     /* 391645 */ GIM_Reject,
     /* 391646 */ // Label 7601: @391646
     /* 391646 */ GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(391669), // Rule ID 183 //
     /* 391651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391662 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 391667 */   GIR_RootConstrainSelectedInstOperands,
     /* 391668 */   // GIR_Coverage, 183,
     /* 391668 */   GIR_Done,
     /* 391669 */ // Label 7606: @391669
     /* 391669 */ GIM_Reject,
     /* 391670 */ // Label 7602: @391670
     /* 391670 */ GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(391696), // Rule ID 974 //
     /* 391675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391689 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391689 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 391694 */   GIR_RootConstrainSelectedInstOperands,
     /* 391695 */   // GIR_Coverage, 974,
     /* 391695 */   GIR_Done,
     /* 391696 */ // Label 7607: @391696
     /* 391696 */ GIM_Reject,
     /* 391697 */ // Label 7603: @391697
     /* 391697 */ GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(391723), // Rule ID 975 //
     /* 391702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391716 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 391721 */   GIR_RootConstrainSelectedInstOperands,
     /* 391722 */   // GIR_Coverage, 975,
     /* 391722 */   GIR_Done,
     /* 391723 */ // Label 7608: @391723
     /* 391723 */ GIM_Reject,
     /* 391724 */ // Label 7604: @391724
     /* 391724 */ GIM_Reject,
     /* 391725 */ // Label 98: @391725
     /* 391725 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7617*/ GIMT_Encode4(392215),
     /* 391736 */ /*GILLT_s16*//*Label 7609*/ GIMT_Encode4(391776),
     /* 391740 */ /*GILLT_s32*//*Label 7610*/ GIMT_Encode4(391807),
     /* 391744 */ /*GILLT_s64*//*Label 7611*/ GIMT_Encode4(391838), GIMT_Encode4(0),
     /* 391752 */ /*GILLT_v2s32*//*Label 7612*/ GIMT_Encode4(391869),
     /* 391756 */ /*GILLT_v2s64*//*Label 7613*/ GIMT_Encode4(391900),
     /* 391760 */ /*GILLT_v4s16*//*Label 7614*/ GIMT_Encode4(391931),
     /* 391764 */ /*GILLT_v4s32*//*Label 7615*/ GIMT_Encode4(391962), GIMT_Encode4(0),
     /* 391772 */ /*GILLT_v8s16*//*Label 7616*/ GIMT_Encode4(391993),
     /* 391776 */ // Label 7609: @391776
     /* 391776 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(391806), // Rule ID 552 //
     /* 391781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 391784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391795 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 391795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 391800 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391804 */   GIR_RootConstrainSelectedInstOperands,
     /* 391805 */   // GIR_Coverage, 552,
     /* 391805 */   GIR_Done,
     /* 391806 */ // Label 7618: @391806
     /* 391806 */ GIM_Reject,
     /* 391807 */ // Label 7610: @391807
     /* 391807 */ GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(391837), // Rule ID 554 //
     /* 391812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 391815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391826 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 391826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 391831 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391835 */   GIR_RootConstrainSelectedInstOperands,
     /* 391836 */   // GIR_Coverage, 554,
     /* 391836 */   GIR_Done,
     /* 391837 */ // Label 7619: @391837
     /* 391837 */ GIM_Reject,
     /* 391838 */ // Label 7611: @391838
     /* 391838 */ GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(391868), // Rule ID 556 //
     /* 391843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 391846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391857 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 391857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 391862 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391866 */   GIR_RootConstrainSelectedInstOperands,
     /* 391867 */   // GIR_Coverage, 556,
     /* 391867 */   GIR_Done,
     /* 391868 */ // Label 7620: @391868
     /* 391868 */ GIM_Reject,
     /* 391869 */ // Label 7612: @391869
     /* 391869 */ GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(391899), // Rule ID 913 //
     /* 391874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391888 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 391888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 391893 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391897 */   GIR_RootConstrainSelectedInstOperands,
     /* 391898 */   // GIR_Coverage, 913,
     /* 391898 */   GIR_Done,
     /* 391899 */ // Label 7621: @391899
     /* 391899 */ GIM_Reject,
     /* 391900 */ // Label 7613: @391900
     /* 391900 */ GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(391930), // Rule ID 917 //
     /* 391905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391919 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 391919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 391924 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391928 */   GIR_RootConstrainSelectedInstOperands,
     /* 391929 */   // GIR_Coverage, 917,
     /* 391929 */   GIR_Done,
     /* 391930 */ // Label 7622: @391930
     /* 391930 */ GIM_Reject,
     /* 391931 */ // Label 7614: @391931
     /* 391931 */ GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(391961), // Rule ID 909 //
     /* 391936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391950 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 391955 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391959 */   GIR_RootConstrainSelectedInstOperands,
     /* 391960 */   // GIR_Coverage, 909,
     /* 391960 */   GIR_Done,
     /* 391961 */ // Label 7623: @391961
     /* 391961 */ GIM_Reject,
     /* 391962 */ // Label 7615: @391962
     /* 391962 */ GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(391992), // Rule ID 915 //
     /* 391967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391981 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 391981 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 391986 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391990 */   GIR_RootConstrainSelectedInstOperands,
     /* 391991 */   // GIR_Coverage, 915,
     /* 391991 */   GIR_Done,
     /* 391992 */ // Label 7624: @391992
     /* 391992 */ GIM_Reject,
     /* 391993 */ // Label 7616: @391993
     /* 391993 */ GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(392214),
     /* 391998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392009 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(392028), // Rule ID 911 //
     /* 392014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392017 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 392022 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392026 */     GIR_RootConstrainSelectedInstOperands,
     /* 392027 */     // GIR_Coverage, 911,
     /* 392027 */     GIR_Done,
     /* 392028 */   // Label 7626: @392028
     /* 392028 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(392213), // Rule ID 7026 //
     /* 392033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 392036 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 392036 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 392039 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 392043 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392048 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 392054 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 392057 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 392061 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392066 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 392069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 392071 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 392074 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392078 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392083 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 392089 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392094 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392099 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 392102 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 392106 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392111 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 392114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 392116 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 392119 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 392123 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392128 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 392131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 392133 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 392136 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 392140 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392145 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 392148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 392150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 392153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 392182 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 392203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 392211 */     GIR_RootConstrainSelectedInstOperands,
     /* 392212 */     // GIR_Coverage, 7026,
     /* 392212 */     GIR_EraseRootFromParent_Done,
     /* 392213 */   // Label 7627: @392213
     /* 392213 */   GIM_Reject,
     /* 392214 */ // Label 7625: @392214
     /* 392214 */ GIM_Reject,
     /* 392215 */ // Label 7617: @392215
     /* 392215 */ GIM_Reject,
     /* 392216 */ // Label 99: @392216
     /* 392216 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7636*/ GIMT_Encode4(392515),
     /* 392227 */ /*GILLT_s16*//*Label 7628*/ GIMT_Encode4(392267),
     /* 392231 */ /*GILLT_s32*//*Label 7629*/ GIMT_Encode4(392298),
     /* 392235 */ /*GILLT_s64*//*Label 7630*/ GIMT_Encode4(392329), GIMT_Encode4(0),
     /* 392243 */ /*GILLT_v2s32*//*Label 7631*/ GIMT_Encode4(392360),
     /* 392247 */ /*GILLT_v2s64*//*Label 7632*/ GIMT_Encode4(392391),
     /* 392251 */ /*GILLT_v4s16*//*Label 7633*/ GIMT_Encode4(392422),
     /* 392255 */ /*GILLT_v4s32*//*Label 7634*/ GIMT_Encode4(392453), GIMT_Encode4(0),
     /* 392263 */ /*GILLT_v8s16*//*Label 7635*/ GIMT_Encode4(392484),
     /* 392267 */ // Label 7628: @392267
     /* 392267 */ GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(392297), // Rule ID 570 //
     /* 392272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392286 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 392291 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392295 */   GIR_RootConstrainSelectedInstOperands,
     /* 392296 */   // GIR_Coverage, 570,
     /* 392296 */   GIR_Done,
     /* 392297 */ // Label 7637: @392297
     /* 392297 */ GIM_Reject,
     /* 392298 */ // Label 7629: @392298
     /* 392298 */ GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(392328), // Rule ID 572 //
     /* 392303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392317 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 392317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 392322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392326 */   GIR_RootConstrainSelectedInstOperands,
     /* 392327 */   // GIR_Coverage, 572,
     /* 392327 */   GIR_Done,
     /* 392328 */ // Label 7638: @392328
     /* 392328 */ GIM_Reject,
     /* 392329 */ // Label 7630: @392329
     /* 392329 */ GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(392359), // Rule ID 574 //
     /* 392334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392348 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 392348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 392353 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392357 */   GIR_RootConstrainSelectedInstOperands,
     /* 392358 */   // GIR_Coverage, 574,
     /* 392358 */   GIR_Done,
     /* 392359 */ // Label 7639: @392359
     /* 392359 */ GIM_Reject,
     /* 392360 */ // Label 7631: @392360
     /* 392360 */ GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(392390), // Rule ID 960 //
     /* 392365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392379 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 392384 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392388 */   GIR_RootConstrainSelectedInstOperands,
     /* 392389 */   // GIR_Coverage, 960,
     /* 392389 */   GIR_Done,
     /* 392390 */ // Label 7640: @392390
     /* 392390 */ GIM_Reject,
     /* 392391 */ // Label 7632: @392391
     /* 392391 */ GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(392421), // Rule ID 964 //
     /* 392396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392410 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 392415 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392419 */   GIR_RootConstrainSelectedInstOperands,
     /* 392420 */   // GIR_Coverage, 964,
     /* 392420 */   GIR_Done,
     /* 392421 */ // Label 7641: @392421
     /* 392421 */ GIM_Reject,
     /* 392422 */ // Label 7633: @392422
     /* 392422 */ GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(392452), // Rule ID 956 //
     /* 392427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392441 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 392446 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392450 */   GIR_RootConstrainSelectedInstOperands,
     /* 392451 */   // GIR_Coverage, 956,
     /* 392451 */   GIR_Done,
     /* 392452 */ // Label 7642: @392452
     /* 392452 */ GIM_Reject,
     /* 392453 */ // Label 7634: @392453
     /* 392453 */ GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(392483), // Rule ID 962 //
     /* 392458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392472 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 392477 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392481 */   GIR_RootConstrainSelectedInstOperands,
     /* 392482 */   // GIR_Coverage, 962,
     /* 392482 */   GIR_Done,
     /* 392483 */ // Label 7643: @392483
     /* 392483 */ GIM_Reject,
     /* 392484 */ // Label 7635: @392484
     /* 392484 */ GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(392514), // Rule ID 958 //
     /* 392489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392503 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 392508 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392512 */   GIR_RootConstrainSelectedInstOperands,
     /* 392513 */   // GIR_Coverage, 958,
     /* 392513 */   GIR_Done,
     /* 392514 */ // Label 7644: @392514
     /* 392514 */ GIM_Reject,
     /* 392515 */ // Label 7636: @392515
     /* 392515 */ GIM_Reject,
     /* 392516 */ // Label 100: @392516
     /* 392516 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7653*/ GIMT_Encode4(393006),
     /* 392527 */ /*GILLT_s16*//*Label 7645*/ GIMT_Encode4(392567),
     /* 392531 */ /*GILLT_s32*//*Label 7646*/ GIMT_Encode4(392598),
     /* 392535 */ /*GILLT_s64*//*Label 7647*/ GIMT_Encode4(392629), GIMT_Encode4(0),
     /* 392543 */ /*GILLT_v2s32*//*Label 7648*/ GIMT_Encode4(392660),
     /* 392547 */ /*GILLT_v2s64*//*Label 7649*/ GIMT_Encode4(392691),
     /* 392551 */ /*GILLT_v4s16*//*Label 7650*/ GIMT_Encode4(392722),
     /* 392555 */ /*GILLT_v4s32*//*Label 7651*/ GIMT_Encode4(392753), GIMT_Encode4(0),
     /* 392563 */ /*GILLT_v8s16*//*Label 7652*/ GIMT_Encode4(392784),
     /* 392567 */ // Label 7645: @392567
     /* 392567 */ GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(392597), // Rule ID 540 //
     /* 392572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392586 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 392591 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392595 */   GIR_RootConstrainSelectedInstOperands,
     /* 392596 */   // GIR_Coverage, 540,
     /* 392596 */   GIR_Done,
     /* 392597 */ // Label 7654: @392597
     /* 392597 */ GIM_Reject,
     /* 392598 */ // Label 7646: @392598
     /* 392598 */ GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(392628), // Rule ID 542 //
     /* 392603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392617 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 392617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 392622 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392626 */   GIR_RootConstrainSelectedInstOperands,
     /* 392627 */   // GIR_Coverage, 542,
     /* 392627 */   GIR_Done,
     /* 392628 */ // Label 7655: @392628
     /* 392628 */ GIM_Reject,
     /* 392629 */ // Label 7647: @392629
     /* 392629 */ GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(392659), // Rule ID 544 //
     /* 392634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392648 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 392648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 392653 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392657 */   GIR_RootConstrainSelectedInstOperands,
     /* 392658 */   // GIR_Coverage, 544,
     /* 392658 */   GIR_Done,
     /* 392659 */ // Label 7656: @392659
     /* 392659 */ GIM_Reject,
     /* 392660 */ // Label 7648: @392660
     /* 392660 */ GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(392690), // Rule ID 893 //
     /* 392665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392679 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 392684 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392688 */   GIR_RootConstrainSelectedInstOperands,
     /* 392689 */   // GIR_Coverage, 893,
     /* 392689 */   GIR_Done,
     /* 392690 */ // Label 7657: @392690
     /* 392690 */ GIM_Reject,
     /* 392691 */ // Label 7649: @392691
     /* 392691 */ GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(392721), // Rule ID 897 //
     /* 392696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392710 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 392715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392719 */   GIR_RootConstrainSelectedInstOperands,
     /* 392720 */   // GIR_Coverage, 897,
     /* 392720 */   GIR_Done,
     /* 392721 */ // Label 7658: @392721
     /* 392721 */ GIM_Reject,
     /* 392722 */ // Label 7650: @392722
     /* 392722 */ GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(392752), // Rule ID 889 //
     /* 392727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392741 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 392746 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392750 */   GIR_RootConstrainSelectedInstOperands,
     /* 392751 */   // GIR_Coverage, 889,
     /* 392751 */   GIR_Done,
     /* 392752 */ // Label 7659: @392752
     /* 392752 */ GIM_Reject,
     /* 392753 */ // Label 7651: @392753
     /* 392753 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(392783), // Rule ID 895 //
     /* 392758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392772 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 392777 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392781 */   GIR_RootConstrainSelectedInstOperands,
     /* 392782 */   // GIR_Coverage, 895,
     /* 392782 */   GIR_Done,
     /* 392783 */ // Label 7660: @392783
     /* 392783 */ GIM_Reject,
     /* 392784 */ // Label 7652: @392784
     /* 392784 */ GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(393005),
     /* 392789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392800 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(392819), // Rule ID 891 //
     /* 392805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392808 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 392813 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392817 */     GIR_RootConstrainSelectedInstOperands,
     /* 392818 */     // GIR_Coverage, 891,
     /* 392818 */     GIR_Done,
     /* 392819 */   // Label 7662: @392819
     /* 392819 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(393004), // Rule ID 7028 //
     /* 392824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 392827 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 392827 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 392830 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 392834 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392839 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 392845 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 392848 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 392852 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392857 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 392860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 392862 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 392865 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392869 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392874 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 392880 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392885 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392890 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 392893 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 392897 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392902 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 392905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 392907 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 392910 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 392914 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392919 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 392922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 392924 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 392927 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 392931 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392936 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 392939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 392941 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 392944 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392948 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392967 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 392973 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 392994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393002 */     GIR_RootConstrainSelectedInstOperands,
     /* 393003 */     // GIR_Coverage, 7028,
     /* 393003 */     GIR_EraseRootFromParent_Done,
     /* 393004 */   // Label 7663: @393004
     /* 393004 */   GIM_Reject,
     /* 393005 */ // Label 7661: @393005
     /* 393005 */ GIM_Reject,
     /* 393006 */ // Label 7653: @393006
     /* 393006 */ GIM_Reject,
     /* 393007 */ // Label 101: @393007
     /* 393007 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7672*/ GIMT_Encode4(393497),
     /* 393018 */ /*GILLT_s16*//*Label 7664*/ GIMT_Encode4(393058),
     /* 393022 */ /*GILLT_s32*//*Label 7665*/ GIMT_Encode4(393089),
     /* 393026 */ /*GILLT_s64*//*Label 7666*/ GIMT_Encode4(393120), GIMT_Encode4(0),
     /* 393034 */ /*GILLT_v2s32*//*Label 7667*/ GIMT_Encode4(393151),
     /* 393038 */ /*GILLT_v2s64*//*Label 7668*/ GIMT_Encode4(393182),
     /* 393042 */ /*GILLT_v4s16*//*Label 7669*/ GIMT_Encode4(393213),
     /* 393046 */ /*GILLT_v4s32*//*Label 7670*/ GIMT_Encode4(393244), GIMT_Encode4(0),
     /* 393054 */ /*GILLT_v8s16*//*Label 7671*/ GIMT_Encode4(393275),
     /* 393058 */ // Label 7664: @393058
     /* 393058 */ GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(393088), // Rule ID 558 //
     /* 393063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393077 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 393082 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393086 */   GIR_RootConstrainSelectedInstOperands,
     /* 393087 */   // GIR_Coverage, 558,
     /* 393087 */   GIR_Done,
     /* 393088 */ // Label 7673: @393088
     /* 393088 */ GIM_Reject,
     /* 393089 */ // Label 7665: @393089
     /* 393089 */ GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(393119), // Rule ID 560 //
     /* 393094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393108 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 393113 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393117 */   GIR_RootConstrainSelectedInstOperands,
     /* 393118 */   // GIR_Coverage, 560,
     /* 393118 */   GIR_Done,
     /* 393119 */ // Label 7674: @393119
     /* 393119 */ GIM_Reject,
     /* 393120 */ // Label 7666: @393120
     /* 393120 */ GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(393150), // Rule ID 562 //
     /* 393125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393139 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 393144 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393148 */   GIR_RootConstrainSelectedInstOperands,
     /* 393149 */   // GIR_Coverage, 562,
     /* 393149 */   GIR_Done,
     /* 393150 */ // Label 7675: @393150
     /* 393150 */ GIM_Reject,
     /* 393151 */ // Label 7667: @393151
     /* 393151 */ GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(393181), // Rule ID 923 //
     /* 393156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393170 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 393175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393179 */   GIR_RootConstrainSelectedInstOperands,
     /* 393180 */   // GIR_Coverage, 923,
     /* 393180 */   GIR_Done,
     /* 393181 */ // Label 7676: @393181
     /* 393181 */ GIM_Reject,
     /* 393182 */ // Label 7668: @393182
     /* 393182 */ GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(393212), // Rule ID 927 //
     /* 393187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393201 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 393206 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393210 */   GIR_RootConstrainSelectedInstOperands,
     /* 393211 */   // GIR_Coverage, 927,
     /* 393211 */   GIR_Done,
     /* 393212 */ // Label 7677: @393212
     /* 393212 */ GIM_Reject,
     /* 393213 */ // Label 7669: @393213
     /* 393213 */ GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(393243), // Rule ID 919 //
     /* 393218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393232 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 393237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393241 */   GIR_RootConstrainSelectedInstOperands,
     /* 393242 */   // GIR_Coverage, 919,
     /* 393242 */   GIR_Done,
     /* 393243 */ // Label 7678: @393243
     /* 393243 */ GIM_Reject,
     /* 393244 */ // Label 7670: @393244
     /* 393244 */ GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(393274), // Rule ID 925 //
     /* 393249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393263 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 393268 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393272 */   GIR_RootConstrainSelectedInstOperands,
     /* 393273 */   // GIR_Coverage, 925,
     /* 393273 */   GIR_Done,
     /* 393274 */ // Label 7679: @393274
     /* 393274 */ GIM_Reject,
     /* 393275 */ // Label 7671: @393275
     /* 393275 */ GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(393496),
     /* 393280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393291 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(393310), // Rule ID 921 //
     /* 393296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393299 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 393304 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393308 */     GIR_RootConstrainSelectedInstOperands,
     /* 393309 */     // GIR_Coverage, 921,
     /* 393309 */     GIR_Done,
     /* 393310 */   // Label 7681: @393310
     /* 393310 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(393495), // Rule ID 7036 //
     /* 393315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 393318 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 393318 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 393321 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 393325 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393330 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 393336 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 393339 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 393343 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393348 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 393351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 393353 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 393356 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393360 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393365 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 393371 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393376 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393381 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 393384 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 393388 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393393 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 393396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 393398 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 393401 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 393405 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393410 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 393413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 393415 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 393418 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 393422 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393427 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 393430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 393432 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 393435 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 393439 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 393453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393458 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 393461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 393464 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 393467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 393485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393493 */     GIR_RootConstrainSelectedInstOperands,
     /* 393494 */     // GIR_Coverage, 7036,
     /* 393494 */     GIR_EraseRootFromParent_Done,
     /* 393495 */   // Label 7682: @393495
     /* 393495 */   GIM_Reject,
     /* 393496 */ // Label 7680: @393496
     /* 393496 */ GIM_Reject,
     /* 393497 */ // Label 7672: @393497
     /* 393497 */ GIM_Reject,
     /* 393498 */ // Label 102: @393498
     /* 393498 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7691*/ GIMT_Encode4(393988),
     /* 393509 */ /*GILLT_s16*//*Label 7683*/ GIMT_Encode4(393549),
     /* 393513 */ /*GILLT_s32*//*Label 7684*/ GIMT_Encode4(393580),
     /* 393517 */ /*GILLT_s64*//*Label 7685*/ GIMT_Encode4(393611), GIMT_Encode4(0),
     /* 393525 */ /*GILLT_v2s32*//*Label 7686*/ GIMT_Encode4(393642),
     /* 393529 */ /*GILLT_v2s64*//*Label 7687*/ GIMT_Encode4(393673),
     /* 393533 */ /*GILLT_v4s16*//*Label 7688*/ GIMT_Encode4(393704),
     /* 393537 */ /*GILLT_v4s32*//*Label 7689*/ GIMT_Encode4(393735), GIMT_Encode4(0),
     /* 393545 */ /*GILLT_v8s16*//*Label 7690*/ GIMT_Encode4(393766),
     /* 393549 */ // Label 7683: @393549
     /* 393549 */ GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(393579), // Rule ID 534 //
     /* 393554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393568 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 393573 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393577 */   GIR_RootConstrainSelectedInstOperands,
     /* 393578 */   // GIR_Coverage, 534,
     /* 393578 */   GIR_Done,
     /* 393579 */ // Label 7692: @393579
     /* 393579 */ GIM_Reject,
     /* 393580 */ // Label 7684: @393580
     /* 393580 */ GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(393610), // Rule ID 536 //
     /* 393585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393599 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 393604 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393608 */   GIR_RootConstrainSelectedInstOperands,
     /* 393609 */   // GIR_Coverage, 536,
     /* 393609 */   GIR_Done,
     /* 393610 */ // Label 7693: @393610
     /* 393610 */ GIM_Reject,
     /* 393611 */ // Label 7685: @393611
     /* 393611 */ GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(393641), // Rule ID 538 //
     /* 393616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393630 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 393635 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393639 */   GIR_RootConstrainSelectedInstOperands,
     /* 393640 */   // GIR_Coverage, 538,
     /* 393640 */   GIR_Done,
     /* 393641 */ // Label 7694: @393641
     /* 393641 */ GIM_Reject,
     /* 393642 */ // Label 7686: @393642
     /* 393642 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(393672), // Rule ID 883 //
     /* 393647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393661 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 393666 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393670 */   GIR_RootConstrainSelectedInstOperands,
     /* 393671 */   // GIR_Coverage, 883,
     /* 393671 */   GIR_Done,
     /* 393672 */ // Label 7695: @393672
     /* 393672 */ GIM_Reject,
     /* 393673 */ // Label 7687: @393673
     /* 393673 */ GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(393703), // Rule ID 887 //
     /* 393678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393692 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 393697 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393701 */   GIR_RootConstrainSelectedInstOperands,
     /* 393702 */   // GIR_Coverage, 887,
     /* 393702 */   GIR_Done,
     /* 393703 */ // Label 7696: @393703
     /* 393703 */ GIM_Reject,
     /* 393704 */ // Label 7688: @393704
     /* 393704 */ GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(393734), // Rule ID 879 //
     /* 393709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393723 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 393728 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393732 */   GIR_RootConstrainSelectedInstOperands,
     /* 393733 */   // GIR_Coverage, 879,
     /* 393733 */   GIR_Done,
     /* 393734 */ // Label 7697: @393734
     /* 393734 */ GIM_Reject,
     /* 393735 */ // Label 7689: @393735
     /* 393735 */ GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(393765), // Rule ID 885 //
     /* 393740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393754 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 393759 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393763 */   GIR_RootConstrainSelectedInstOperands,
     /* 393764 */   // GIR_Coverage, 885,
     /* 393764 */   GIR_Done,
     /* 393765 */ // Label 7698: @393765
     /* 393765 */ GIM_Reject,
     /* 393766 */ // Label 7690: @393766
     /* 393766 */ GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(393987),
     /* 393771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393782 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(393801), // Rule ID 881 //
     /* 393787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393790 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 393795 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393799 */     GIR_RootConstrainSelectedInstOperands,
     /* 393800 */     // GIR_Coverage, 881,
     /* 393800 */     GIR_Done,
     /* 393801 */   // Label 7700: @393801
     /* 393801 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(393986), // Rule ID 7030 //
     /* 393806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 393809 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 393809 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 393812 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 393816 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393821 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 393827 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 393830 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 393834 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393839 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 393842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 393844 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 393847 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393851 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393856 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 393862 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393867 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393872 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 393875 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 393879 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393884 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 393887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 393889 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 393892 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 393896 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393901 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 393904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 393906 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 393909 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 393913 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393918 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 393921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 393923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 393926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 393930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 393944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393949 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 393952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 393955 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 393958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 393976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393984 */     GIR_RootConstrainSelectedInstOperands,
     /* 393985 */     // GIR_Coverage, 7030,
     /* 393985 */     GIR_EraseRootFromParent_Done,
     /* 393986 */   // Label 7701: @393986
     /* 393986 */   GIM_Reject,
     /* 393987 */ // Label 7699: @393987
     /* 393987 */ GIM_Reject,
     /* 393988 */ // Label 7691: @393988
     /* 393988 */ GIM_Reject,
     /* 393989 */ // Label 103: @393989
     /* 393989 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7710*/ GIMT_Encode4(395114),
     /* 394000 */ /*GILLT_s16*//*Label 7702*/ GIMT_Encode4(394040),
     /* 394004 */ /*GILLT_s32*//*Label 7703*/ GIMT_Encode4(394266),
     /* 394008 */ /*GILLT_s64*//*Label 7704*/ GIMT_Encode4(394492), GIMT_Encode4(0),
     /* 394016 */ /*GILLT_v2s32*//*Label 7705*/ GIMT_Encode4(394664),
     /* 394020 */ /*GILLT_v2s64*//*Label 7706*/ GIMT_Encode4(394702),
     /* 394024 */ /*GILLT_v4s16*//*Label 7707*/ GIMT_Encode4(394740),
     /* 394028 */ /*GILLT_v4s32*//*Label 7708*/ GIMT_Encode4(394778), GIMT_Encode4(0),
     /* 394036 */ /*GILLT_v8s16*//*Label 7709*/ GIMT_Encode4(394816),
     /* 394040 */ // Label 7702: @394040
     /* 394040 */ GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(394265),
     /* 394045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 394051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394055 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(394146), // Rule ID 6950 //
     /* 394060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394081 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 394085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394097 */     // MIs[2] Rn
     /* 394097 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 394106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394108 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 394108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394120 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 394139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394144 */     GIR_RootConstrainSelectedInstOperands,
     /* 394145 */     // GIR_Coverage, 6950,
     /* 394145 */     GIR_EraseRootFromParent_Done,
     /* 394146 */   // Label 7712: @394146
     /* 394146 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(394237), // Rule ID 14019 //
     /* 394151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394172 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 394176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394188 */     // MIs[2] Rn
     /* 394188 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 394197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394199 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 394199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394211 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 394230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394235 */     GIR_RootConstrainSelectedInstOperands,
     /* 394236 */     // GIR_Coverage, 14019,
     /* 394236 */     GIR_EraseRootFromParent_Done,
     /* 394237 */   // Label 7713: @394237
     /* 394237 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(394264), // Rule ID 583 //
     /* 394242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394253 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 394253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 394258 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394262 */     GIR_RootConstrainSelectedInstOperands,
     /* 394263 */     // GIR_Coverage, 583,
     /* 394263 */     GIR_Done,
     /* 394264 */   // Label 7714: @394264
     /* 394264 */   GIM_Reject,
     /* 394265 */ // Label 7711: @394265
     /* 394265 */ GIM_Reject,
     /* 394266 */ // Label 7703: @394266
     /* 394266 */ GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(394491),
     /* 394271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 394277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394281 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(394372), // Rule ID 6948 //
     /* 394286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394307 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 394311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394323 */     // MIs[2] Rn
     /* 394323 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394328 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 394332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394334 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 394334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394346 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 394365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394370 */     GIR_RootConstrainSelectedInstOperands,
     /* 394371 */     // GIR_Coverage, 6948,
     /* 394371 */     GIR_EraseRootFromParent_Done,
     /* 394372 */   // Label 7716: @394372
     /* 394372 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(394463), // Rule ID 14017 //
     /* 394377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394398 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 394402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394414 */     // MIs[2] Rn
     /* 394414 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394419 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 394423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394425 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 394425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394437 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 394456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394461 */     GIR_RootConstrainSelectedInstOperands,
     /* 394462 */     // GIR_Coverage, 14017,
     /* 394462 */     GIR_EraseRootFromParent_Done,
     /* 394463 */   // Label 7717: @394463
     /* 394463 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(394490), // Rule ID 585 //
     /* 394468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394479 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 394479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 394484 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394488 */     GIR_RootConstrainSelectedInstOperands,
     /* 394489 */     // GIR_Coverage, 585,
     /* 394489 */     GIR_Done,
     /* 394490 */   // Label 7718: @394490
     /* 394490 */   GIM_Reject,
     /* 394491 */ // Label 7715: @394491
     /* 394491 */ GIM_Reject,
     /* 394492 */ // Label 7704: @394492
     /* 394492 */ GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(394663),
     /* 394497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 394503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394507 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(394571), // Rule ID 6946 //
     /* 394512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394533 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 394537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394549 */     // MIs[2] Rn
     /* 394549 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394554 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 394558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394560 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 394560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 394563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394569 */     GIR_RootConstrainSelectedInstOperands,
     /* 394570 */     // GIR_Coverage, 6946,
     /* 394570 */     GIR_EraseRootFromParent_Done,
     /* 394571 */   // Label 7720: @394571
     /* 394571 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(394635), // Rule ID 14015 //
     /* 394576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394597 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 394601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394613 */     // MIs[2] Rn
     /* 394613 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394618 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 394622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394624 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 394624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 394627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394633 */     GIR_RootConstrainSelectedInstOperands,
     /* 394634 */     // GIR_Coverage, 14015,
     /* 394634 */     GIR_EraseRootFromParent_Done,
     /* 394635 */   // Label 7721: @394635
     /* 394635 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(394662), // Rule ID 587 //
     /* 394640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394651 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 394651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 394656 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394660 */     GIR_RootConstrainSelectedInstOperands,
     /* 394661 */     // GIR_Coverage, 587,
     /* 394661 */     GIR_Done,
     /* 394662 */   // Label 7722: @394662
     /* 394662 */   GIM_Reject,
     /* 394663 */ // Label 7719: @394663
     /* 394663 */ GIM_Reject,
     /* 394664 */ // Label 7705: @394664
     /* 394664 */ GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(394701), // Rule ID 1202 //
     /* 394669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 394678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394690 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 394690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 394695 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394699 */   GIR_RootConstrainSelectedInstOperands,
     /* 394700 */   // GIR_Coverage, 1202,
     /* 394700 */   GIR_Done,
     /* 394701 */ // Label 7723: @394701
     /* 394701 */ GIM_Reject,
     /* 394702 */ // Label 7706: @394702
     /* 394702 */ GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(394739), // Rule ID 1206 //
     /* 394707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 394716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394728 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 394728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 394733 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394737 */   GIR_RootConstrainSelectedInstOperands,
     /* 394738 */   // GIR_Coverage, 1206,
     /* 394738 */   GIR_Done,
     /* 394739 */ // Label 7724: @394739
     /* 394739 */ GIM_Reject,
     /* 394740 */ // Label 7707: @394740
     /* 394740 */ GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(394777), // Rule ID 1198 //
     /* 394745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394766 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 394766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 394771 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394775 */   GIR_RootConstrainSelectedInstOperands,
     /* 394776 */   // GIR_Coverage, 1198,
     /* 394776 */   GIR_Done,
     /* 394777 */ // Label 7725: @394777
     /* 394777 */ GIM_Reject,
     /* 394778 */ // Label 7708: @394778
     /* 394778 */ GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(394815), // Rule ID 1204 //
     /* 394783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394804 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 394804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 394809 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394813 */   GIR_RootConstrainSelectedInstOperands,
     /* 394814 */   // GIR_Coverage, 1204,
     /* 394814 */   GIR_Done,
     /* 394815 */ // Label 7726: @394815
     /* 394815 */ GIM_Reject,
     /* 394816 */ // Label 7709: @394816
     /* 394816 */ GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(395113),
     /* 394821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 394827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394839 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(394858), // Rule ID 1200 //
     /* 394844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394847 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 394847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 394852 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394856 */     GIR_RootConstrainSelectedInstOperands,
     /* 394857 */     // GIR_Coverage, 1200,
     /* 394857 */     GIR_Done,
     /* 394858 */   // Label 7728: @394858
     /* 394858 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(395112), // Rule ID 7039 //
     /* 394863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 394866 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 394866 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 394869 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394873 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394878 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 394882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 394884 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 394887 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394891 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394896 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 394902 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 394905 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 394909 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394914 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 394917 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 394920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 394922 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 394925 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394929 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394934 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 394940 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394945 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394950 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 394953 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 394957 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394962 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 394965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 394967 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 394970 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394974 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394979 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394985 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394990 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394995 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 394998 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395002 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395007 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395012 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395015 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 395019 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395024 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395027 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 395030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395032 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395035 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395039 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395044 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395049 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395052 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395056 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395075 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395078 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395081 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 395110 */     GIR_RootConstrainSelectedInstOperands,
     /* 395111 */     // GIR_Coverage, 7039,
     /* 395111 */     GIR_EraseRootFromParent_Done,
     /* 395112 */   // Label 7729: @395112
     /* 395112 */   GIM_Reject,
     /* 395113 */ // Label 7727: @395113
     /* 395113 */ GIM_Reject,
     /* 395114 */ // Label 7710: @395114
     /* 395114 */ GIM_Reject,
     /* 395115 */ // Label 104: @395115
     /* 395115 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7738*/ GIMT_Encode4(395730),
     /* 395126 */ /*GILLT_s16*//*Label 7730*/ GIMT_Encode4(395166),
     /* 395130 */ /*GILLT_s32*//*Label 7731*/ GIMT_Encode4(395204),
     /* 395134 */ /*GILLT_s64*//*Label 7732*/ GIMT_Encode4(395242), GIMT_Encode4(0),
     /* 395142 */ /*GILLT_v2s32*//*Label 7733*/ GIMT_Encode4(395280),
     /* 395146 */ /*GILLT_v2s64*//*Label 7734*/ GIMT_Encode4(395318),
     /* 395150 */ /*GILLT_v4s16*//*Label 7735*/ GIMT_Encode4(395356),
     /* 395154 */ /*GILLT_v4s32*//*Label 7736*/ GIMT_Encode4(395394), GIMT_Encode4(0),
     /* 395162 */ /*GILLT_v8s16*//*Label 7737*/ GIMT_Encode4(395432),
     /* 395166 */ // Label 7730: @395166
     /* 395166 */ GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(395203), // Rule ID 631 //
     /* 395171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 395180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395192 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 395192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 395197 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395201 */   GIR_RootConstrainSelectedInstOperands,
     /* 395202 */   // GIR_Coverage, 631,
     /* 395202 */   GIR_Done,
     /* 395203 */ // Label 7739: @395203
     /* 395203 */ GIM_Reject,
     /* 395204 */ // Label 7731: @395204
     /* 395204 */ GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(395241), // Rule ID 633 //
     /* 395209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 395218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395230 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 395230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 395235 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395239 */   GIR_RootConstrainSelectedInstOperands,
     /* 395240 */   // GIR_Coverage, 633,
     /* 395240 */   GIR_Done,
     /* 395241 */ // Label 7740: @395241
     /* 395241 */ GIM_Reject,
     /* 395242 */ // Label 7732: @395242
     /* 395242 */ GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(395279), // Rule ID 635 //
     /* 395247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 395256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395268 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 395268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 395273 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395277 */   GIR_RootConstrainSelectedInstOperands,
     /* 395278 */   // GIR_Coverage, 635,
     /* 395278 */   GIR_Done,
     /* 395279 */ // Label 7741: @395279
     /* 395279 */ GIM_Reject,
     /* 395280 */ // Label 7733: @395280
     /* 395280 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(395317), // Rule ID 1342 //
     /* 395285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 395294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395306 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 395306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 395311 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395315 */   GIR_RootConstrainSelectedInstOperands,
     /* 395316 */   // GIR_Coverage, 1342,
     /* 395316 */   GIR_Done,
     /* 395317 */ // Label 7742: @395317
     /* 395317 */ GIM_Reject,
     /* 395318 */ // Label 7734: @395318
     /* 395318 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(395355), // Rule ID 1346 //
     /* 395323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 395332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395344 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 395344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 395349 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395353 */   GIR_RootConstrainSelectedInstOperands,
     /* 395354 */   // GIR_Coverage, 1346,
     /* 395354 */   GIR_Done,
     /* 395355 */ // Label 7743: @395355
     /* 395355 */ GIM_Reject,
     /* 395356 */ // Label 7735: @395356
     /* 395356 */ GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(395393), // Rule ID 1338 //
     /* 395361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 395370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395382 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 395382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 395387 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395391 */   GIR_RootConstrainSelectedInstOperands,
     /* 395392 */   // GIR_Coverage, 1338,
     /* 395392 */   GIR_Done,
     /* 395393 */ // Label 7744: @395393
     /* 395393 */ GIM_Reject,
     /* 395394 */ // Label 7736: @395394
     /* 395394 */ GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(395431), // Rule ID 1344 //
     /* 395399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 395408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395420 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 395425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395429 */   GIR_RootConstrainSelectedInstOperands,
     /* 395430 */   // GIR_Coverage, 1344,
     /* 395430 */   GIR_Done,
     /* 395431 */ // Label 7745: @395431
     /* 395431 */ GIM_Reject,
     /* 395432 */ // Label 7737: @395432
     /* 395432 */ GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(395729),
     /* 395437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395455 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(395474), // Rule ID 1340 //
     /* 395460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395463 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 395463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 395468 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395472 */     GIR_RootConstrainSelectedInstOperands,
     /* 395473 */     // GIR_Coverage, 1340,
     /* 395473 */     GIR_Done,
     /* 395474 */   // Label 7747: @395474
     /* 395474 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(395728), // Rule ID 7045 //
     /* 395479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 395482 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 395482 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 395485 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395489 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395494 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 395498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 395500 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 395503 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395507 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395512 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 395518 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 395521 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 395525 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395530 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 395533 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 395536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 395538 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 395541 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395545 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395550 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 395556 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395561 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395566 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 395569 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395573 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395578 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 395581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 395583 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 395586 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395590 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395595 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395601 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395606 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395611 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 395614 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395618 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395623 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395628 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395631 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 395635 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395640 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395643 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 395646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395648 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395651 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395655 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395660 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395665 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395668 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395672 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395694 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395697 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 395726 */     GIR_RootConstrainSelectedInstOperands,
     /* 395727 */     // GIR_Coverage, 7045,
     /* 395727 */     GIR_EraseRootFromParent_Done,
     /* 395728 */   // Label 7748: @395728
     /* 395728 */   GIM_Reject,
     /* 395729 */ // Label 7746: @395729
     /* 395729 */ GIM_Reject,
     /* 395730 */ // Label 7738: @395730
     /* 395730 */ GIM_Reject,
     /* 395731 */ // Label 105: @395731
     /* 395731 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7757*/ GIMT_Encode4(399452),
     /* 395742 */ /*GILLT_s16*//*Label 7749*/ GIMT_Encode4(395782),
     /* 395746 */ /*GILLT_s32*//*Label 7750*/ GIMT_Encode4(396336),
     /* 395750 */ /*GILLT_s64*//*Label 7751*/ GIMT_Encode4(396884), GIMT_Encode4(0),
     /* 395758 */ /*GILLT_v2s32*//*Label 7752*/ GIMT_Encode4(397432),
     /* 395762 */ /*GILLT_v2s64*//*Label 7753*/ GIMT_Encode4(397962),
     /* 395766 */ /*GILLT_v4s16*//*Label 7754*/ GIMT_Encode4(398320),
     /* 395770 */ /*GILLT_v4s32*//*Label 7755*/ GIMT_Encode4(398662), GIMT_Encode4(0),
     /* 395778 */ /*GILLT_v8s16*//*Label 7756*/ GIMT_Encode4(399020),
     /* 395782 */ // Label 7749: @395782
     /* 395782 */ GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(396335),
     /* 395787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 395793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395797 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(395910), // Rule ID 6278 //
     /* 395802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395826 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 395830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395863 */     // MIs[3] Operand 1
     /* 395863 */     // No operand predicates
     /* 395863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395865 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 395868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395877 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 395883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 395896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395908 */     GIR_RootConstrainSelectedInstOperands,
     /* 395909 */     // GIR_Coverage, 6278,
     /* 395909 */     GIR_EraseRootFromParent_Done,
     /* 395910 */   // Label 7759: @395910
     /* 395910 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(396023), // Rule ID 13996 //
     /* 395915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395947 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395951 */     // MIs[2] Operand 1
     /* 395951 */     // No operand predicates
     /* 395951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395963 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 395967 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395972 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 395976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395978 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 395981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395990 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 395996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396021 */     GIR_RootConstrainSelectedInstOperands,
     /* 396022 */     // GIR_Coverage, 13996,
     /* 396022 */     GIR_EraseRootFromParent_Done,
     /* 396023 */   // Label 7760: @396023
     /* 396023 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(396102), // Rule ID 13930 //
     /* 396028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396052 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396062 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 396062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396074 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 396080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 396093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396100 */     GIR_RootConstrainSelectedInstOperands,
     /* 396101 */     // GIR_Coverage, 13930,
     /* 396101 */     GIR_EraseRootFromParent_Done,
     /* 396102 */   // Label 7761: @396102
     /* 396102 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(396181), // Rule ID 4835 //
     /* 396107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396135 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396141 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 396141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396153 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 396159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 396172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396179 */     GIR_RootConstrainSelectedInstOperands,
     /* 396180 */     // GIR_Coverage, 4835,
     /* 396180 */     GIR_EraseRootFromParent_Done,
     /* 396181 */   // Label 7762: @396181
     /* 396181 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(396244), // Rule ID 13539 //
     /* 396186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396218 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396222 */     // MIs[2] Operand 1
     /* 396222 */     // No operand predicates
     /* 396222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396228 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396242 */     GIR_RootConstrainSelectedInstOperands,
     /* 396243 */     // GIR_Coverage, 13539,
     /* 396243 */     GIR_EraseRootFromParent_Done,
     /* 396244 */   // Label 7763: @396244
     /* 396244 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(396307), // Rule ID 2011 //
     /* 396249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396289 */     // MIs[2] Operand 1
     /* 396289 */     // No operand predicates
     /* 396289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396291 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396305 */     GIR_RootConstrainSelectedInstOperands,
     /* 396306 */     // GIR_Coverage, 2011,
     /* 396306 */     GIR_EraseRootFromParent_Done,
     /* 396307 */   // Label 7764: @396307
     /* 396307 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(396334), // Rule ID 619 //
     /* 396312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396323 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 396323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 396328 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396332 */     GIR_RootConstrainSelectedInstOperands,
     /* 396333 */     // GIR_Coverage, 619,
     /* 396333 */     GIR_Done,
     /* 396334 */   // Label 7765: @396334
     /* 396334 */   GIM_Reject,
     /* 396335 */ // Label 7758: @396335
     /* 396335 */ GIM_Reject,
     /* 396336 */ // Label 7750: @396336
     /* 396336 */ GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(396883),
     /* 396341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 396347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396351 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(396464), // Rule ID 6280 //
     /* 396356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396380 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396413 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396417 */     // MIs[3] Operand 1
     /* 396417 */     // No operand predicates
     /* 396417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396419 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 396419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396431 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 396437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 396450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396462 */     GIR_RootConstrainSelectedInstOperands,
     /* 396463 */     // GIR_Coverage, 6280,
     /* 396463 */     GIR_EraseRootFromParent_Done,
     /* 396464 */   // Label 7767: @396464
     /* 396464 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(396577), // Rule ID 13998 //
     /* 396469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396505 */     // MIs[2] Operand 1
     /* 396505 */     // No operand predicates
     /* 396505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396517 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 396521 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396526 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 396530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396532 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 396532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396544 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 396550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 396563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396575 */     GIR_RootConstrainSelectedInstOperands,
     /* 396576 */     // GIR_Coverage, 13998,
     /* 396576 */     GIR_EraseRootFromParent_Done,
     /* 396577 */   // Label 7768: @396577
     /* 396577 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(396653), // Rule ID 13932 //
     /* 396582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396603 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396613 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 396613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396625 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 396631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 396644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396651 */     GIR_RootConstrainSelectedInstOperands,
     /* 396652 */     // GIR_Coverage, 13932,
     /* 396652 */     GIR_EraseRootFromParent_Done,
     /* 396653 */   // Label 7769: @396653
     /* 396653 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(396729), // Rule ID 4837 //
     /* 396658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396683 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396689 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 396689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396701 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 396707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 396720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396727 */     GIR_RootConstrainSelectedInstOperands,
     /* 396728 */     // GIR_Coverage, 4837,
     /* 396728 */     GIR_EraseRootFromParent_Done,
     /* 396729 */   // Label 7770: @396729
     /* 396729 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(396792), // Rule ID 13541 //
     /* 396734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396766 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396770 */     // MIs[2] Operand 1
     /* 396770 */     // No operand predicates
     /* 396770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396776 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 396779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396790 */     GIR_RootConstrainSelectedInstOperands,
     /* 396791 */     // GIR_Coverage, 13541,
     /* 396791 */     GIR_EraseRootFromParent_Done,
     /* 396792 */   // Label 7771: @396792
     /* 396792 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(396855), // Rule ID 2013 //
     /* 396797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396833 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396837 */     // MIs[2] Operand 1
     /* 396837 */     // No operand predicates
     /* 396837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396839 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 396842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396853 */     GIR_RootConstrainSelectedInstOperands,
     /* 396854 */     // GIR_Coverage, 2013,
     /* 396854 */     GIR_EraseRootFromParent_Done,
     /* 396855 */   // Label 7772: @396855
     /* 396855 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(396882), // Rule ID 621 //
     /* 396860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396871 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 396871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 396876 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396880 */     GIR_RootConstrainSelectedInstOperands,
     /* 396881 */     // GIR_Coverage, 621,
     /* 396881 */     GIR_Done,
     /* 396882 */   // Label 7773: @396882
     /* 396882 */   GIM_Reject,
     /* 396883 */ // Label 7766: @396883
     /* 396883 */ GIM_Reject,
     /* 396884 */ // Label 7751: @396884
     /* 396884 */ GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(397431),
     /* 396889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 396895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396899 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(397012), // Rule ID 6282 //
     /* 396904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396928 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396961 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 396965 */     // MIs[3] Operand 1
     /* 396965 */     // No operand predicates
     /* 396965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396967 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 396967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396979 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 396998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397010 */     GIR_RootConstrainSelectedInstOperands,
     /* 397011 */     // GIR_Coverage, 6282,
     /* 397011 */     GIR_EraseRootFromParent_Done,
     /* 397012 */   // Label 7775: @397012
     /* 397012 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(397125), // Rule ID 14000 //
     /* 397017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397049 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397053 */     // MIs[2] Operand 1
     /* 397053 */     // No operand predicates
     /* 397053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397065 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 397069 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397074 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 397078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397080 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 397080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397092 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 397111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397123 */     GIR_RootConstrainSelectedInstOperands,
     /* 397124 */     // GIR_Coverage, 14000,
     /* 397124 */     GIR_EraseRootFromParent_Done,
     /* 397125 */   // Label 7776: @397125
     /* 397125 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(397201), // Rule ID 13934 //
     /* 397130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397151 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397161 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 397161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397173 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 397179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 397192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397199 */     GIR_RootConstrainSelectedInstOperands,
     /* 397200 */     // GIR_Coverage, 13934,
     /* 397200 */     GIR_EraseRootFromParent_Done,
     /* 397201 */   // Label 7777: @397201
     /* 397201 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(397277), // Rule ID 4839 //
     /* 397206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397237 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 397237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397249 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 397255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 397268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397275 */     GIR_RootConstrainSelectedInstOperands,
     /* 397276 */     // GIR_Coverage, 4839,
     /* 397276 */     GIR_EraseRootFromParent_Done,
     /* 397277 */   // Label 7778: @397277
     /* 397277 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(397340), // Rule ID 13543 //
     /* 397282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397314 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397318 */     // MIs[2] Operand 1
     /* 397318 */     // No operand predicates
     /* 397318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397324 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 397327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397338 */     GIR_RootConstrainSelectedInstOperands,
     /* 397339 */     // GIR_Coverage, 13543,
     /* 397339 */     GIR_EraseRootFromParent_Done,
     /* 397340 */   // Label 7779: @397340
     /* 397340 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(397403), // Rule ID 2015 //
     /* 397345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397381 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397385 */     // MIs[2] Operand 1
     /* 397385 */     // No operand predicates
     /* 397385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397387 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 397390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397401 */     GIR_RootConstrainSelectedInstOperands,
     /* 397402 */     // GIR_Coverage, 2015,
     /* 397402 */     GIR_EraseRootFromParent_Done,
     /* 397403 */   // Label 7780: @397403
     /* 397403 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(397430), // Rule ID 623 //
     /* 397408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 397411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397419 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 397419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 397424 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397428 */     GIR_RootConstrainSelectedInstOperands,
     /* 397429 */     // GIR_Coverage, 623,
     /* 397429 */     GIR_Done,
     /* 397430 */   // Label 7781: @397430
     /* 397430 */   GIM_Reject,
     /* 397431 */ // Label 7774: @397431
     /* 397431 */ GIM_Reject,
     /* 397432 */ // Label 7752: @397432
     /* 397432 */ GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(397961),
     /* 397437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 397443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397447 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(397533), // Rule ID 13531 //
     /* 397452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397496 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397500 */     // MIs[3] Operand 1
     /* 397500 */     // No operand predicates
     /* 397500 */     // MIs[1] Operand 2
     /* 397500 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397517 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397531 */     GIR_RootConstrainSelectedInstOperands,
     /* 397532 */     // GIR_Coverage, 13531,
     /* 397532 */     GIR_EraseRootFromParent_Done,
     /* 397533 */   // Label 7783: @397533
     /* 397533 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(397619), // Rule ID 2003 //
     /* 397538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397586 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397590 */     // MIs[3] Operand 1
     /* 397590 */     // No operand predicates
     /* 397590 */     // MIs[1] Operand 2
     /* 397590 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397603 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397617 */     GIR_RootConstrainSelectedInstOperands,
     /* 397618 */     // GIR_Coverage, 2003,
     /* 397618 */     GIR_EraseRootFromParent_Done,
     /* 397619 */   // Label 7784: @397619
     /* 397619 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(397682), // Rule ID 13532 //
     /* 397624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397656 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397660 */     // MIs[2] Operand 1
     /* 397660 */     // No operand predicates
     /* 397660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397666 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397680 */     GIR_RootConstrainSelectedInstOperands,
     /* 397681 */     // GIR_Coverage, 13532,
     /* 397681 */     GIR_EraseRootFromParent_Done,
     /* 397682 */   // Label 7785: @397682
     /* 397682 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(397745), // Rule ID 2004 //
     /* 397687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397723 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397727 */     // MIs[2] Operand 1
     /* 397727 */     // No operand predicates
     /* 397727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397729 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397743 */     GIR_RootConstrainSelectedInstOperands,
     /* 397744 */     // GIR_Coverage, 2004,
     /* 397744 */     GIR_EraseRootFromParent_Done,
     /* 397745 */   // Label 7786: @397745
     /* 397745 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(397839), // Rule ID 14002 //
     /* 397750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 397758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 397762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397773 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 397776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 397790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397799 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397806 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 397809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397837 */     GIR_RootConstrainSelectedInstOperands,
     /* 397838 */     // GIR_Coverage, 14002,
     /* 397838 */     GIR_EraseRootFromParent_Done,
     /* 397839 */   // Label 7787: @397839
     /* 397839 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(397933), // Rule ID 6284 //
     /* 397844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 397856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 397860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397867 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397867 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 397870 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397874 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 397884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 397903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397931 */     GIR_RootConstrainSelectedInstOperands,
     /* 397932 */     // GIR_Coverage, 6284,
     /* 397932 */     GIR_EraseRootFromParent_Done,
     /* 397933 */   // Label 7788: @397933
     /* 397933 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(397960), // Rule ID 1322 //
     /* 397938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397949 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 397949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 397954 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397958 */     GIR_RootConstrainSelectedInstOperands,
     /* 397959 */     // GIR_Coverage, 1322,
     /* 397959 */     GIR_Done,
     /* 397960 */   // Label 7789: @397960
     /* 397960 */   GIM_Reject,
     /* 397961 */ // Label 7782: @397961
     /* 397961 */ GIM_Reject,
     /* 397962 */ // Label 7753: @397962
     /* 397962 */ GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(398319),
     /* 397967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 397973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397977 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(398040), // Rule ID 13537 //
     /* 397982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 397993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398014 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398018 */     // MIs[2] Operand 1
     /* 398018 */     // No operand predicates
     /* 398018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398024 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398038 */     GIR_RootConstrainSelectedInstOperands,
     /* 398039 */     // GIR_Coverage, 13537,
     /* 398039 */     GIR_EraseRootFromParent_Done,
     /* 398040 */   // Label 7791: @398040
     /* 398040 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(398103), // Rule ID 2009 //
     /* 398045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 398060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398081 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398085 */     // MIs[2] Operand 1
     /* 398085 */     // No operand predicates
     /* 398085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398087 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398101 */     GIR_RootConstrainSelectedInstOperands,
     /* 398102 */     // GIR_Coverage, 2009,
     /* 398102 */     GIR_EraseRootFromParent_Done,
     /* 398103 */   // Label 7792: @398103
     /* 398103 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(398197), // Rule ID 14006 //
     /* 398108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 398120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398131 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398160 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398164 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 398167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398195 */     GIR_RootConstrainSelectedInstOperands,
     /* 398196 */     // GIR_Coverage, 14006,
     /* 398196 */     GIR_EraseRootFromParent_Done,
     /* 398197 */   // Label 7793: @398197
     /* 398197 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(398291), // Rule ID 6288 //
     /* 398202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 398218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398225 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398225 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398228 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398232 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 398261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398289 */     GIR_RootConstrainSelectedInstOperands,
     /* 398290 */     // GIR_Coverage, 6288,
     /* 398290 */     GIR_EraseRootFromParent_Done,
     /* 398291 */   // Label 7794: @398291
     /* 398291 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(398318), // Rule ID 1326 //
     /* 398296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398307 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 398307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 398312 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398316 */     GIR_RootConstrainSelectedInstOperands,
     /* 398317 */     // GIR_Coverage, 1326,
     /* 398317 */     GIR_Done,
     /* 398318 */   // Label 7795: @398318
     /* 398318 */   GIM_Reject,
     /* 398319 */ // Label 7790: @398319
     /* 398319 */ GIM_Reject,
     /* 398320 */ // Label 7754: @398320
     /* 398320 */ GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(398661),
     /* 398325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398335 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(398421), // Rule ID 13525 //
     /* 398340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398384 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398388 */     // MIs[3] Operand 1
     /* 398388 */     // No operand predicates
     /* 398388 */     // MIs[1] Operand 2
     /* 398388 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398405 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 398408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398419 */     GIR_RootConstrainSelectedInstOperands,
     /* 398420 */     // GIR_Coverage, 13525,
     /* 398420 */     GIR_EraseRootFromParent_Done,
     /* 398421 */   // Label 7797: @398421
     /* 398421 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(398507), // Rule ID 1997 //
     /* 398426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398474 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398478 */     // MIs[3] Operand 1
     /* 398478 */     // No operand predicates
     /* 398478 */     // MIs[1] Operand 2
     /* 398478 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398491 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 398494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398505 */     GIR_RootConstrainSelectedInstOperands,
     /* 398506 */     // GIR_Coverage, 1997,
     /* 398506 */     GIR_EraseRootFromParent_Done,
     /* 398507 */   // Label 7798: @398507
     /* 398507 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(398570), // Rule ID 13526 //
     /* 398512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398544 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398548 */     // MIs[2] Operand 1
     /* 398548 */     // No operand predicates
     /* 398548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398554 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 398557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398568 */     GIR_RootConstrainSelectedInstOperands,
     /* 398569 */     // GIR_Coverage, 13526,
     /* 398569 */     GIR_EraseRootFromParent_Done,
     /* 398570 */   // Label 7799: @398570
     /* 398570 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(398633), // Rule ID 1998 //
     /* 398575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398611 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398615 */     // MIs[2] Operand 1
     /* 398615 */     // No operand predicates
     /* 398615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398617 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 398620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398631 */     GIR_RootConstrainSelectedInstOperands,
     /* 398632 */     // GIR_Coverage, 1998,
     /* 398632 */     GIR_EraseRootFromParent_Done,
     /* 398633 */   // Label 7800: @398633
     /* 398633 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(398660), // Rule ID 1318 //
     /* 398638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398649 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 398649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 398654 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398658 */     GIR_RootConstrainSelectedInstOperands,
     /* 398659 */     // GIR_Coverage, 1318,
     /* 398659 */     GIR_Done,
     /* 398660 */   // Label 7801: @398660
     /* 398660 */   GIM_Reject,
     /* 398661 */ // Label 7796: @398661
     /* 398661 */ GIM_Reject,
     /* 398662 */ // Label 7755: @398662
     /* 398662 */ GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(399019),
     /* 398667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398677 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(398740), // Rule ID 13535 //
     /* 398682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398714 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398718 */     // MIs[2] Operand 1
     /* 398718 */     // No operand predicates
     /* 398718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398724 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 398727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398738 */     GIR_RootConstrainSelectedInstOperands,
     /* 398739 */     // GIR_Coverage, 13535,
     /* 398739 */     GIR_EraseRootFromParent_Done,
     /* 398740 */   // Label 7803: @398740
     /* 398740 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(398803), // Rule ID 2007 //
     /* 398745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398781 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398785 */     // MIs[2] Operand 1
     /* 398785 */     // No operand predicates
     /* 398785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398787 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 398790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398801 */     GIR_RootConstrainSelectedInstOperands,
     /* 398802 */     // GIR_Coverage, 2007,
     /* 398802 */     GIR_EraseRootFromParent_Done,
     /* 398803 */   // Label 7804: @398803
     /* 398803 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(398897), // Rule ID 14004 //
     /* 398808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 398820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398831 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398857 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 398867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 398885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398895 */     GIR_RootConstrainSelectedInstOperands,
     /* 398896 */     // GIR_Coverage, 14004,
     /* 398896 */     GIR_EraseRootFromParent_Done,
     /* 398897 */   // Label 7805: @398897
     /* 398897 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(398991), // Rule ID 6286 //
     /* 398902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 398918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398925 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398951 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398958 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 398961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 398979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398989 */     GIR_RootConstrainSelectedInstOperands,
     /* 398990 */     // GIR_Coverage, 6286,
     /* 398990 */     GIR_EraseRootFromParent_Done,
     /* 398991 */   // Label 7806: @398991
     /* 398991 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(399018), // Rule ID 1324 //
     /* 398996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399007 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 399007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 399012 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399016 */     GIR_RootConstrainSelectedInstOperands,
     /* 399017 */     // GIR_Coverage, 1324,
     /* 399017 */     GIR_Done,
     /* 399018 */   // Label 7807: @399018
     /* 399018 */   GIM_Reject,
     /* 399019 */ // Label 7802: @399019
     /* 399019 */ GIM_Reject,
     /* 399020 */ // Label 7756: @399020
     /* 399020 */ GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(399451),
     /* 399025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399035 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(399098), // Rule ID 13529 //
     /* 399040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399076 */     // MIs[2] Operand 1
     /* 399076 */     // No operand predicates
     /* 399076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399082 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 399085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399096 */     GIR_RootConstrainSelectedInstOperands,
     /* 399097 */     // GIR_Coverage, 13529,
     /* 399097 */     GIR_EraseRootFromParent_Done,
     /* 399098 */   // Label 7809: @399098
     /* 399098 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(399161), // Rule ID 2001 //
     /* 399103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399139 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399143 */     // MIs[2] Operand 1
     /* 399143 */     // No operand predicates
     /* 399143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399145 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 399148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399159 */     GIR_RootConstrainSelectedInstOperands,
     /* 399160 */     // GIR_Coverage, 2001,
     /* 399160 */     GIR_EraseRootFromParent_Done,
     /* 399161 */   // Label 7810: @399161
     /* 399161 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(399188), // Rule ID 1320 //
     /* 399166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399177 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 399177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 399182 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399186 */     GIR_RootConstrainSelectedInstOperands,
     /* 399187 */     // GIR_Coverage, 1320,
     /* 399187 */     GIR_Done,
     /* 399188 */   // Label 7811: @399188
     /* 399188 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(399450), // Rule ID 7043 //
     /* 399193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 399196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399204 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 399204 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 399207 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 399211 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399216 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 399220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 399222 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 399225 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 399229 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399234 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 399240 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 399243 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 399247 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399252 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 399255 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 399258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 399260 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 399263 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399267 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399272 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 399278 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399283 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399288 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 399291 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 399295 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399300 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 399303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 399305 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 399308 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399312 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399317 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 399323 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399328 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399333 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 399336 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 399340 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399345 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 399348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 399350 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 399353 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 399357 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399362 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 399365 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 399368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 399370 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 399373 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 399377 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399382 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 399385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 399387 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 399390 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399394 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399413 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399416 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 399419 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 399422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 399440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 399448 */     GIR_RootConstrainSelectedInstOperands,
     /* 399449 */     // GIR_Coverage, 7043,
     /* 399449 */     GIR_EraseRootFromParent_Done,
     /* 399450 */   // Label 7812: @399450
     /* 399450 */   GIM_Reject,
     /* 399451 */ // Label 7808: @399451
     /* 399451 */ GIM_Reject,
     /* 399452 */ // Label 7757: @399452
     /* 399452 */ GIM_Reject,
     /* 399453 */ // Label 106: @399453
     /* 399453 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7821*/ GIMT_Encode4(400068),
     /* 399464 */ /*GILLT_s16*//*Label 7813*/ GIMT_Encode4(399504),
     /* 399468 */ /*GILLT_s32*//*Label 7814*/ GIMT_Encode4(399542),
     /* 399472 */ /*GILLT_s64*//*Label 7815*/ GIMT_Encode4(399580), GIMT_Encode4(0),
     /* 399480 */ /*GILLT_v2s32*//*Label 7816*/ GIMT_Encode4(399618),
     /* 399484 */ /*GILLT_v2s64*//*Label 7817*/ GIMT_Encode4(399656),
     /* 399488 */ /*GILLT_v4s16*//*Label 7818*/ GIMT_Encode4(399694),
     /* 399492 */ /*GILLT_v4s32*//*Label 7819*/ GIMT_Encode4(399732), GIMT_Encode4(0),
     /* 399500 */ /*GILLT_v8s16*//*Label 7820*/ GIMT_Encode4(399770),
     /* 399504 */ // Label 7813: @399504
     /* 399504 */ GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(399541), // Rule ID 589 //
     /* 399509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 399512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 399515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 399518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399530 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 399530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 399535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399539 */   GIR_RootConstrainSelectedInstOperands,
     /* 399540 */   // GIR_Coverage, 589,
     /* 399540 */   GIR_Done,
     /* 399541 */ // Label 7822: @399541
     /* 399541 */ GIM_Reject,
     /* 399542 */ // Label 7814: @399542
     /* 399542 */ GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(399579), // Rule ID 591 //
     /* 399547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 399550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 399556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399568 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 399568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 399573 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399577 */   GIR_RootConstrainSelectedInstOperands,
     /* 399578 */   // GIR_Coverage, 591,
     /* 399578 */   GIR_Done,
     /* 399579 */ // Label 7823: @399579
     /* 399579 */ GIM_Reject,
     /* 399580 */ // Label 7815: @399580
     /* 399580 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(399617), // Rule ID 593 //
     /* 399585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 399588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 399594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399606 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 399606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 399611 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399615 */   GIR_RootConstrainSelectedInstOperands,
     /* 399616 */   // GIR_Coverage, 593,
     /* 399616 */   GIR_Done,
     /* 399617 */ // Label 7824: @399617
     /* 399617 */ GIM_Reject,
     /* 399618 */ // Label 7816: @399618
     /* 399618 */ GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(399655), // Rule ID 1227 //
     /* 399623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399644 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 399644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 399649 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399653 */   GIR_RootConstrainSelectedInstOperands,
     /* 399654 */   // GIR_Coverage, 1227,
     /* 399654 */   GIR_Done,
     /* 399655 */ // Label 7825: @399655
     /* 399655 */ GIM_Reject,
     /* 399656 */ // Label 7817: @399656
     /* 399656 */ GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(399693), // Rule ID 1231 //
     /* 399661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399682 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 399682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 399687 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399691 */   GIR_RootConstrainSelectedInstOperands,
     /* 399692 */   // GIR_Coverage, 1231,
     /* 399692 */   GIR_Done,
     /* 399693 */ // Label 7826: @399693
     /* 399693 */ GIM_Reject,
     /* 399694 */ // Label 7818: @399694
     /* 399694 */ GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(399731), // Rule ID 1223 //
     /* 399699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399720 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 399720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 399725 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399729 */   GIR_RootConstrainSelectedInstOperands,
     /* 399730 */   // GIR_Coverage, 1223,
     /* 399730 */   GIR_Done,
     /* 399731 */ // Label 7827: @399731
     /* 399731 */ GIM_Reject,
     /* 399732 */ // Label 7819: @399732
     /* 399732 */ GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(399769), // Rule ID 1229 //
     /* 399737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399758 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 399758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 399763 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399767 */   GIR_RootConstrainSelectedInstOperands,
     /* 399768 */   // GIR_Coverage, 1229,
     /* 399768 */   GIR_Done,
     /* 399769 */ // Label 7828: @399769
     /* 399769 */ GIM_Reject,
     /* 399770 */ // Label 7820: @399770
     /* 399770 */ GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(400067),
     /* 399775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399793 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(399812), // Rule ID 1225 //
     /* 399798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399801 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 399801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 399806 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399810 */     GIR_RootConstrainSelectedInstOperands,
     /* 399811 */     // GIR_Coverage, 1225,
     /* 399811 */     GIR_Done,
     /* 399812 */   // Label 7830: @399812
     /* 399812 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(400066), // Rule ID 7041 //
     /* 399817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 399820 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 399820 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 399823 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 399827 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399832 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 399836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 399838 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 399841 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 399845 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399850 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 399856 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 399859 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 399863 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399868 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 399871 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 399874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 399876 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 399879 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399883 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399888 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 399894 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399899 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399904 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 399907 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 399911 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399916 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 399919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 399921 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 399924 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399928 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399933 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 399939 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399944 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399949 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 399952 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 399956 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399961 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 399964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 399966 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 399969 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 399973 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399978 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 399981 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 399984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 399986 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 399989 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 399993 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399998 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 400001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 400003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 400006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 400020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400029 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 400035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 400038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 400056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 400064 */     GIR_RootConstrainSelectedInstOperands,
     /* 400065 */     // GIR_Coverage, 7041,
     /* 400065 */     GIR_EraseRootFromParent_Done,
     /* 400066 */   // Label 7831: @400066
     /* 400066 */   GIM_Reject,
     /* 400067 */ // Label 7829: @400067
     /* 400067 */ GIM_Reject,
     /* 400068 */ // Label 7821: @400068
     /* 400068 */ GIM_Reject,
     /* 400069 */ // Label 107: @400069
     /* 400069 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7840*/ GIMT_Encode4(415675),
     /* 400080 */ /*GILLT_s16*//*Label 7832*/ GIMT_Encode4(400120),
     /* 400084 */ /*GILLT_s32*//*Label 7833*/ GIMT_Encode4(402894),
     /* 400088 */ /*GILLT_s64*//*Label 7834*/ GIMT_Encode4(405824), GIMT_Encode4(0),
     /* 400096 */ /*GILLT_v2s32*//*Label 7835*/ GIMT_Encode4(408754),
     /* 400100 */ /*GILLT_v2s64*//*Label 7836*/ GIMT_Encode4(410275),
     /* 400104 */ /*GILLT_v4s16*//*Label 7837*/ GIMT_Encode4(411796),
     /* 400108 */ /*GILLT_v4s32*//*Label 7838*/ GIMT_Encode4(412975), GIMT_Encode4(0),
     /* 400116 */ /*GILLT_v8s16*//*Label 7839*/ GIMT_Encode4(414496),
     /* 400120 */ // Label 7832: @400120
     /* 400120 */ GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(402893),
     /* 400125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 400128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 400131 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 400134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400138 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(400288), // Rule ID 4897 //
     /* 400143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 400146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400167 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 400171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400192 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 400196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 400200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 400208 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400215 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 400215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 400218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400227 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 400233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400255 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 400274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 400282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 400286 */     GIR_RootConstrainSelectedInstOperands,
     /* 400287 */     // GIR_Coverage, 4897,
     /* 400287 */     GIR_EraseRootFromParent_Done,
     /* 400288 */   // Label 7842: @400288
     /* 400288 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(400435), // Rule ID 4861 //
     /* 400293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 400296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400317 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 400321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 400337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400341 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400345 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 400349 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400354 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 400358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400364 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 400364 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 400367 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400371 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400376 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 400382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400404 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 400423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 400431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 400433 */     GIR_RootConstrainSelectedInstOperands,
     /* 400434 */     // GIR_Coverage, 4861,
     /* 400434 */     GIR_EraseRootFromParent_Done,
     /* 400435 */   // Label 7843: @400435
     /* 400435 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(400582), // Rule ID 13943 //
     /* 400440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 400443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400476 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 400480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400488 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400492 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 400496 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400501 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 400505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400511 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 400511 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 400514 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400518 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400523 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 400529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400534 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400551 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 400570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 400578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 400580 */     GIR_RootConstrainSelectedInstOperands,
     /* 400581 */     // GIR_Coverage, 13943,
     /* 400581 */     GIR_EraseRootFromParent_Done,
     /* 400582 */   // Label 7844: @400582
     /* 400582 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(400713), // Rule ID 6116 //
     /* 400587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400611 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 400615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 400631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400635 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400639 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 400643 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400648 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 400652 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400656 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400660 */     // MIs[4] Operand 1
     /* 400660 */     // No operand predicates
     /* 400660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400664 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 400666 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 400666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400678 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 400697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 400701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 400708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 400711 */     GIR_RootConstrainSelectedInstOperands,
     /* 400712 */     // GIR_Coverage, 6116,
     /* 400712 */     GIR_EraseRootFromParent_Done,
     /* 400713 */   // Label 7845: @400713
     /* 400713 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(400844), // Rule ID 6148 //
     /* 400718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400750 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400754 */     // MIs[2] Operand 1
     /* 400754 */     // No operand predicates
     /* 400754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400762 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 400766 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 400770 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400774 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400778 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 400782 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400787 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 400791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400795 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 400797 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 400797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400809 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 400828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 400832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400842 */     GIR_RootConstrainSelectedInstOperands,
     /* 400843 */     // GIR_Coverage, 6148,
     /* 400843 */     GIR_EraseRootFromParent_Done,
     /* 400844 */   // Label 7846: @400844
     /* 400844 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(400975), // Rule ID 6212 //
     /* 400849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400885 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 400889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400897 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400901 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 400905 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400910 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 400914 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400918 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400922 */     // MIs[4] Operand 1
     /* 400922 */     // No operand predicates
     /* 400922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400926 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 400928 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 400928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400940 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 400959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 400963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 400970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 400973 */     GIR_RootConstrainSelectedInstOperands,
     /* 400974 */     // GIR_Coverage, 6212,
     /* 400974 */     GIR_EraseRootFromParent_Done,
     /* 400975 */   // Label 7847: @400975
     /* 400975 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(401106), // Rule ID 6180 //
     /* 400980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 401020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401024 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401028 */     // MIs[3] Operand 1
     /* 401028 */     // No operand predicates
     /* 401028 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 401032 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401036 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401040 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 401044 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401049 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 401053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401057 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 401059 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401071 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 401090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 401104 */     GIR_RootConstrainSelectedInstOperands,
     /* 401105 */     // GIR_Coverage, 6180,
     /* 401105 */     GIR_EraseRootFromParent_Done,
     /* 401106 */   // Label 7848: @401106
     /* 401106 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(401241), // Rule ID 2455 //
     /* 401111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401135 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401160 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401170 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401170 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401177 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401182 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401210 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 401229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 401237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401239 */     GIR_RootConstrainSelectedInstOperands,
     /* 401240 */     // GIR_Coverage, 2455,
     /* 401240 */     GIR_EraseRootFromParent_Done,
     /* 401241 */   // Label 7849: @401241
     /* 401241 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(401360), // Rule ID 6084 //
     /* 401246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401270 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 401299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401303 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401307 */     // MIs[3] Operand 1
     /* 401307 */     // No operand predicates
     /* 401307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401311 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401313 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401325 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 401344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 401358 */     GIR_RootConstrainSelectedInstOperands,
     /* 401359 */     // GIR_Coverage, 6084,
     /* 401359 */     GIR_EraseRootFromParent_Done,
     /* 401360 */   // Label 7850: @401360
     /* 401360 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(401479), // Rule ID 2530 //
     /* 401365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401397 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401401 */     // MIs[2] Operand 1
     /* 401401 */     // No operand predicates
     /* 401401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401409 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401413 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401417 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401422 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 401426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401432 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401444 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 401463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401477 */     GIR_RootConstrainSelectedInstOperands,
     /* 401478 */     // GIR_Coverage, 2530,
     /* 401478 */     GIR_EraseRootFromParent_Done,
     /* 401479 */   // Label 7851: @401479
     /* 401479 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(401579), // Rule ID 4859 //
     /* 401484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401535 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 401535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401547 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 401566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401577 */     GIR_RootConstrainSelectedInstOperands,
     /* 401578 */     // GIR_Coverage, 4859,
     /* 401578 */     GIR_EraseRootFromParent_Done,
     /* 401579 */   // Label 7852: @401579
     /* 401579 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(401679), // Rule ID 4895 //
     /* 401584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401608 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 401620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401635 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 401635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401647 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 401666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 401673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 401677 */     GIR_RootConstrainSelectedInstOperands,
     /* 401678 */     // GIR_Coverage, 4895,
     /* 401678 */     GIR_EraseRootFromParent_Done,
     /* 401679 */   // Label 7853: @401679
     /* 401679 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(401776), // Rule ID 13939 //
     /* 401684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401720 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401734 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401746 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 401765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401774 */     GIR_RootConstrainSelectedInstOperands,
     /* 401775 */     // GIR_Coverage, 13939,
     /* 401775 */     GIR_EraseRootFromParent_Done,
     /* 401776 */   // Label 7854: @401776
     /* 401776 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(401876), // Rule ID 13941 //
     /* 401781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401822 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401832 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 401832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401844 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 401863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401874 */     GIR_RootConstrainSelectedInstOperands,
     /* 401875 */     // GIR_Coverage, 13941,
     /* 401875 */     GIR_EraseRootFromParent_Done,
     /* 401876 */   // Label 7855: @401876
     /* 401876 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(401976), // Rule ID 4893 //
     /* 401881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401909 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 401917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401932 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401944 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 401963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 401974 */     GIR_RootConstrainSelectedInstOperands,
     /* 401975 */     // GIR_Coverage, 4893,
     /* 401975 */     GIR_EraseRootFromParent_Done,
     /* 401976 */   // Label 7856: @401976
     /* 401976 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(402073), // Rule ID 4857 //
     /* 401981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402021 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402031 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402043 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402071 */     GIR_RootConstrainSelectedInstOperands,
     /* 402072 */     // GIR_Coverage, 4857,
     /* 402072 */     GIR_EraseRootFromParent_Done,
     /* 402073 */   // Label 7857: @402073
     /* 402073 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(402157), // Rule ID 6146 //
     /* 402078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402110 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402114 */     // MIs[2] Operand 1
     /* 402114 */     // No operand predicates
     /* 402114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402122 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 402126 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402137 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 402148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402155 */     GIR_RootConstrainSelectedInstOperands,
     /* 402156 */     // GIR_Coverage, 6146,
     /* 402156 */     GIR_EraseRootFromParent_Done,
     /* 402157 */   // Label 7858: @402157
     /* 402157 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(402238), // Rule ID 6178 //
     /* 402162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402206 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402210 */     // MIs[3] Operand 1
     /* 402210 */     // No operand predicates
     /* 402210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402220 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402236 */     GIR_RootConstrainSelectedInstOperands,
     /* 402237 */     // GIR_Coverage, 6178,
     /* 402237 */     GIR_EraseRootFromParent_Done,
     /* 402238 */   // Label 7859: @402238
     /* 402238 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(402322), // Rule ID 6210 //
     /* 402243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402292 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402296 */     // MIs[3] Operand 1
     /* 402296 */     // No operand predicates
     /* 402296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402302 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402320 */     GIR_RootConstrainSelectedInstOperands,
     /* 402321 */     // GIR_Coverage, 6210,
     /* 402321 */     GIR_EraseRootFromParent_Done,
     /* 402322 */   // Label 7860: @402322
     /* 402322 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(402403), // Rule ID 6114 //
     /* 402327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402375 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402379 */     // MIs[3] Operand 1
     /* 402379 */     // No operand predicates
     /* 402379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402385 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402401 */     GIR_RootConstrainSelectedInstOperands,
     /* 402402 */     // GIR_Coverage, 6114,
     /* 402402 */     GIR_EraseRootFromParent_Done,
     /* 402403 */   // Label 7861: @402403
     /* 402403 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(402488), // Rule ID 2453 //
     /* 402408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402432 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402446 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402458 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 402477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402486 */     GIR_RootConstrainSelectedInstOperands,
     /* 402487 */     // GIR_Coverage, 2453,
     /* 402487 */     GIR_EraseRootFromParent_Done,
     /* 402488 */   // Label 7862: @402488
     /* 402488 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(402573), // Rule ID 2451 //
     /* 402493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402521 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402531 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402543 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 402562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402571 */     GIR_RootConstrainSelectedInstOperands,
     /* 402572 */     // GIR_Coverage, 2451,
     /* 402572 */     GIR_EraseRootFromParent_Done,
     /* 402573 */   // Label 7863: @402573
     /* 402573 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(402642), // Rule ID 2528 //
     /* 402578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402610 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402614 */     // MIs[2] Operand 1
     /* 402614 */     // No operand predicates
     /* 402614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402624 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 402627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402640 */     GIR_RootConstrainSelectedInstOperands,
     /* 402641 */     // GIR_Coverage, 2528,
     /* 402641 */     GIR_EraseRootFromParent_Done,
     /* 402642 */   // Label 7864: @402642
     /* 402642 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(402711), // Rule ID 6082 //
     /* 402647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402683 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402687 */     // MIs[2] Operand 1
     /* 402687 */     // No operand predicates
     /* 402687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402693 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 402696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402709 */     GIR_RootConstrainSelectedInstOperands,
     /* 402710 */     // GIR_Coverage, 6082,
     /* 402710 */     GIR_EraseRootFromParent_Done,
     /* 402711 */   // Label 7865: @402711
     /* 402711 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(402761), // Rule ID 13375 //
     /* 402716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402746 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402759 */     GIR_RootConstrainSelectedInstOperands,
     /* 402760 */     // GIR_Coverage, 13375,
     /* 402760 */     GIR_EraseRootFromParent_Done,
     /* 402761 */   // Label 7866: @402761
     /* 402761 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(402811), // Rule ID 643 //
     /* 402766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402796 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402809 */     GIR_RootConstrainSelectedInstOperands,
     /* 402810 */     // GIR_Coverage, 643,
     /* 402810 */     GIR_EraseRootFromParent_Done,
     /* 402811 */   // Label 7867: @402811
     /* 402811 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(402861), // Rule ID 655 //
     /* 402816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402846 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 402849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 402859 */     GIR_RootConstrainSelectedInstOperands,
     /* 402860 */     // GIR_Coverage, 655,
     /* 402860 */     GIR_EraseRootFromParent_Done,
     /* 402861 */   // Label 7868: @402861
     /* 402861 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(402892), // Rule ID 637 //
     /* 402866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402881 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 402886 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402890 */     GIR_RootConstrainSelectedInstOperands,
     /* 402891 */     // GIR_Coverage, 637,
     /* 402891 */     GIR_Done,
     /* 402892 */   // Label 7869: @402892
     /* 402892 */   GIM_Reject,
     /* 402893 */ // Label 7841: @402893
     /* 402893 */ GIM_Reject,
     /* 402894 */ // Label 7833: @402894
     /* 402894 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(405823),
     /* 402899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 402905 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 402908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402912 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(403062), // Rule ID 4903 //
     /* 402917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 402920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402941 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402966 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 402974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 402982 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402989 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 402989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 402992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403001 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403012 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403029 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 403048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 403060 */     GIR_RootConstrainSelectedInstOperands,
     /* 403061 */     // GIR_Coverage, 4903,
     /* 403061 */     GIR_EraseRootFromParent_Done,
     /* 403062 */   // Label 7871: @403062
     /* 403062 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(403209), // Rule ID 4867 //
     /* 403067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403091 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 403107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 403111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403115 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403128 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403138 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403150 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403156 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403161 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403178 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 403197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403207 */     GIR_RootConstrainSelectedInstOperands,
     /* 403208 */     // GIR_Coverage, 4867,
     /* 403208 */     GIR_EraseRootFromParent_Done,
     /* 403209 */   // Label 7872: @403209
     /* 403209 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(403356), // Rule ID 13949 //
     /* 403214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 403229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403250 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403270 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403275 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403285 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403285 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403288 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403292 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403297 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403303 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403308 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403325 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 403344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403354 */     GIR_RootConstrainSelectedInstOperands,
     /* 403355 */     // GIR_Coverage, 13949,
     /* 403355 */     GIR_EraseRootFromParent_Done,
     /* 403356 */   // Label 7873: @403356
     /* 403356 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(403487), // Rule ID 6132 //
     /* 403361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403385 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 403401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 403405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403409 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403413 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403417 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403422 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 403426 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403430 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403434 */     // MIs[4] Operand 1
     /* 403434 */     // No operand predicates
     /* 403434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403438 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403440 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 403440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 403471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 403482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 403485 */     GIR_RootConstrainSelectedInstOperands,
     /* 403486 */     // GIR_Coverage, 6132,
     /* 403486 */     GIR_EraseRootFromParent_Done,
     /* 403487 */   // Label 7874: @403487
     /* 403487 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(403618), // Rule ID 6164 //
     /* 403492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403524 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403528 */     // MIs[2] Operand 1
     /* 403528 */     // No operand predicates
     /* 403528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403536 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 403540 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 403544 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403548 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403552 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 403556 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403561 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 403565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403569 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403571 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 403571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403583 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 403602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403616 */     GIR_RootConstrainSelectedInstOperands,
     /* 403617 */     // GIR_Coverage, 6164,
     /* 403617 */     GIR_EraseRootFromParent_Done,
     /* 403618 */   // Label 7875: @403618
     /* 403618 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(403749), // Rule ID 6228 //
     /* 403623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 403638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403659 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403675 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403679 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 403688 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403692 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403696 */     // MIs[4] Operand 1
     /* 403696 */     // No operand predicates
     /* 403696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403700 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403702 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 403702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403714 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 403733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 403744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 403747 */     GIR_RootConstrainSelectedInstOperands,
     /* 403748 */     // GIR_Coverage, 6228,
     /* 403748 */     GIR_EraseRootFromParent_Done,
     /* 403749 */   // Label 7876: @403749
     /* 403749 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(403880), // Rule ID 6196 //
     /* 403754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 403769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403798 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403802 */     // MIs[3] Operand 1
     /* 403802 */     // No operand predicates
     /* 403802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 403806 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403810 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403814 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 403818 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403823 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 403827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403831 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403833 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 403833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403845 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 403864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403878 */     GIR_RootConstrainSelectedInstOperands,
     /* 403879 */     // GIR_Coverage, 6196,
     /* 403879 */     GIR_EraseRootFromParent_Done,
     /* 403880 */   // Label 7877: @403880
     /* 403880 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(404015), // Rule ID 2461 //
     /* 403885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403909 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403934 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403944 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403956 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403984 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 404003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404013 */     GIR_RootConstrainSelectedInstOperands,
     /* 404014 */     // GIR_Coverage, 2461,
     /* 404014 */     GIR_EraseRootFromParent_Done,
     /* 404015 */   // Label 7878: @404015
     /* 404015 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(404134), // Rule ID 6100 //
     /* 404020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404044 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404077 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404081 */     // MIs[3] Operand 1
     /* 404081 */     // No operand predicates
     /* 404081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404087 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404099 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 404118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404132 */     GIR_RootConstrainSelectedInstOperands,
     /* 404133 */     // GIR_Coverage, 6100,
     /* 404133 */     GIR_EraseRootFromParent_Done,
     /* 404134 */   // Label 7879: @404134
     /* 404134 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(404253), // Rule ID 2546 //
     /* 404139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404171 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404175 */     // MIs[2] Operand 1
     /* 404175 */     // No operand predicates
     /* 404175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404183 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404191 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404196 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 404200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404206 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404218 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 404237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404251 */     GIR_RootConstrainSelectedInstOperands,
     /* 404252 */     // GIR_Coverage, 2546,
     /* 404252 */     GIR_EraseRootFromParent_Done,
     /* 404253 */   // Label 7880: @404253
     /* 404253 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(404353), // Rule ID 4865 //
     /* 404258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404309 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 404309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404351 */     GIR_RootConstrainSelectedInstOperands,
     /* 404352 */     // GIR_Coverage, 4865,
     /* 404352 */     GIR_EraseRootFromParent_Done,
     /* 404353 */   // Label 7881: @404353
     /* 404353 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(404453), // Rule ID 4901 //
     /* 404358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404382 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 404394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404409 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 404409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404421 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 404440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 404451 */     GIR_RootConstrainSelectedInstOperands,
     /* 404452 */     // GIR_Coverage, 4901,
     /* 404452 */     GIR_EraseRootFromParent_Done,
     /* 404453 */   // Label 7882: @404453
     /* 404453 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(404550), // Rule ID 13945 //
     /* 404458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404508 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404520 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404548 */     GIR_RootConstrainSelectedInstOperands,
     /* 404549 */     // GIR_Coverage, 13945,
     /* 404549 */     GIR_EraseRootFromParent_Done,
     /* 404550 */   // Label 7883: @404550
     /* 404550 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(404650), // Rule ID 13947 //
     /* 404555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404596 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404606 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 404606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404618 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404648 */     GIR_RootConstrainSelectedInstOperands,
     /* 404649 */     // GIR_Coverage, 13947,
     /* 404649 */     GIR_EraseRootFromParent_Done,
     /* 404650 */   // Label 7884: @404650
     /* 404650 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(404750), // Rule ID 4899 //
     /* 404655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404683 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 404691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404706 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404718 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 404737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 404748 */     GIR_RootConstrainSelectedInstOperands,
     /* 404749 */     // GIR_Coverage, 4899,
     /* 404749 */     GIR_EraseRootFromParent_Done,
     /* 404750 */   // Label 7885: @404750
     /* 404750 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(404847), // Rule ID 4863 //
     /* 404755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404795 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404805 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404817 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404845 */     GIR_RootConstrainSelectedInstOperands,
     /* 404846 */     // GIR_Coverage, 4863,
     /* 404846 */     GIR_EraseRootFromParent_Done,
     /* 404847 */   // Label 7886: @404847
     /* 404847 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(404925), // Rule ID 6250 //
     /* 404852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 404889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404893 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404897 */     // MIs[3] Operand 1
     /* 404897 */     // No operand predicates
     /* 404897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404907 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404923 */     GIR_RootConstrainSelectedInstOperands,
     /* 404924 */     // GIR_Coverage, 6250,
     /* 404924 */     GIR_EraseRootFromParent_Done,
     /* 404925 */   // Label 7887: @404925
     /* 404925 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(405009), // Rule ID 6162 //
     /* 404930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404962 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404966 */     // MIs[2] Operand 1
     /* 404966 */     // No operand predicates
     /* 404966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404974 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 404978 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404989 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 405000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405007 */     GIR_RootConstrainSelectedInstOperands,
     /* 405008 */     // GIR_Coverage, 6162,
     /* 405008 */     GIR_EraseRootFromParent_Done,
     /* 405009 */   // Label 7888: @405009
     /* 405009 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(405090), // Rule ID 6194 //
     /* 405014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405058 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405062 */     // MIs[3] Operand 1
     /* 405062 */     // No operand predicates
     /* 405062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405072 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405088 */     GIR_RootConstrainSelectedInstOperands,
     /* 405089 */     // GIR_Coverage, 6194,
     /* 405089 */     GIR_EraseRootFromParent_Done,
     /* 405090 */   // Label 7889: @405090
     /* 405090 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(405174), // Rule ID 6226 //
     /* 405095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405144 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405148 */     // MIs[3] Operand 1
     /* 405148 */     // No operand predicates
     /* 405148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405154 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405172 */     GIR_RootConstrainSelectedInstOperands,
     /* 405173 */     // GIR_Coverage, 6226,
     /* 405173 */     GIR_EraseRootFromParent_Done,
     /* 405174 */   // Label 7890: @405174
     /* 405174 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(405252), // Rule ID 6272 //
     /* 405179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 405220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405224 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405228 */     // MIs[3] Operand 1
     /* 405228 */     // No operand predicates
     /* 405228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405234 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405250 */     GIR_RootConstrainSelectedInstOperands,
     /* 405251 */     // GIR_Coverage, 6272,
     /* 405251 */     GIR_EraseRootFromParent_Done,
     /* 405252 */   // Label 7891: @405252
     /* 405252 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(405333), // Rule ID 6130 //
     /* 405257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405305 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405309 */     // MIs[3] Operand 1
     /* 405309 */     // No operand predicates
     /* 405309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405315 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405331 */     GIR_RootConstrainSelectedInstOperands,
     /* 405332 */     // GIR_Coverage, 6130,
     /* 405332 */     GIR_EraseRootFromParent_Done,
     /* 405333 */   // Label 7892: @405333
     /* 405333 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(405418), // Rule ID 2459 //
     /* 405338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405362 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405376 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405388 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 405407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 405414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405416 */     GIR_RootConstrainSelectedInstOperands,
     /* 405417 */     // GIR_Coverage, 2459,
     /* 405417 */     GIR_EraseRootFromParent_Done,
     /* 405418 */   // Label 7893: @405418
     /* 405418 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(405503), // Rule ID 2457 //
     /* 405423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405451 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405461 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405473 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 405492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405501 */     GIR_RootConstrainSelectedInstOperands,
     /* 405502 */     // GIR_Coverage, 2457,
     /* 405502 */     GIR_EraseRootFromParent_Done,
     /* 405503 */   // Label 7894: @405503
     /* 405503 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(405572), // Rule ID 2544 //
     /* 405508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405540 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405544 */     // MIs[2] Operand 1
     /* 405544 */     // No operand predicates
     /* 405544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405554 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 405557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405570 */     GIR_RootConstrainSelectedInstOperands,
     /* 405571 */     // GIR_Coverage, 2544,
     /* 405571 */     GIR_EraseRootFromParent_Done,
     /* 405572 */   // Label 7895: @405572
     /* 405572 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(405641), // Rule ID 6098 //
     /* 405577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405613 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405617 */     // MIs[2] Operand 1
     /* 405617 */     // No operand predicates
     /* 405617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405623 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 405626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405639 */     GIR_RootConstrainSelectedInstOperands,
     /* 405640 */     // GIR_Coverage, 6098,
     /* 405640 */     GIR_EraseRootFromParent_Done,
     /* 405641 */   // Label 7896: @405641
     /* 405641 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(405691), // Rule ID 13377 //
     /* 405646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405676 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405689 */     GIR_RootConstrainSelectedInstOperands,
     /* 405690 */     // GIR_Coverage, 13377,
     /* 405690 */     GIR_EraseRootFromParent_Done,
     /* 405691 */   // Label 7897: @405691
     /* 405691 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(405741), // Rule ID 645 //
     /* 405696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405726 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405739 */     GIR_RootConstrainSelectedInstOperands,
     /* 405740 */     // GIR_Coverage, 645,
     /* 405740 */     GIR_EraseRootFromParent_Done,
     /* 405741 */   // Label 7898: @405741
     /* 405741 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(405791), // Rule ID 657 //
     /* 405746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 405761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405776 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 405779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 405785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 405789 */     GIR_RootConstrainSelectedInstOperands,
     /* 405790 */     // GIR_Coverage, 657,
     /* 405790 */     GIR_EraseRootFromParent_Done,
     /* 405791 */   // Label 7899: @405791
     /* 405791 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(405822), // Rule ID 639 //
     /* 405796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405811 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 405816 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405820 */     GIR_RootConstrainSelectedInstOperands,
     /* 405821 */     // GIR_Coverage, 639,
     /* 405821 */     GIR_Done,
     /* 405822 */   // Label 7900: @405822
     /* 405822 */   GIM_Reject,
     /* 405823 */ // Label 7870: @405823
     /* 405823 */ GIM_Reject,
     /* 405824 */ // Label 7834: @405824
     /* 405824 */ GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(408753),
     /* 405829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 405832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 405835 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 405838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405842 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(405992), // Rule ID 4909 //
     /* 405847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405871 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405896 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 405904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405908 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 405912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405919 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 405919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 405922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405931 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 405937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405942 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 405950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 405965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 405978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 405986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 405990 */     GIR_RootConstrainSelectedInstOperands,
     /* 405991 */     // GIR_Coverage, 4909,
     /* 405991 */     GIR_EraseRootFromParent_Done,
     /* 405992 */   // Label 7902: @405992
     /* 405992 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(406139), // Rule ID 4873 //
     /* 405997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 406037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 406041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406049 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406053 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406058 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406068 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406080 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 406086 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406091 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406108 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 406127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406137 */     GIR_RootConstrainSelectedInstOperands,
     /* 406138 */     // GIR_Coverage, 4873,
     /* 406138 */     GIR_EraseRootFromParent_Done,
     /* 406139 */   // Label 7903: @406139
     /* 406139 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(406286), // Rule ID 13955 //
     /* 406144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 406159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406180 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406192 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406196 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406200 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406205 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406215 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406227 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 406233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406255 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 406274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406284 */     GIR_RootConstrainSelectedInstOperands,
     /* 406285 */     // GIR_Coverage, 13955,
     /* 406285 */     GIR_EraseRootFromParent_Done,
     /* 406286 */   // Label 7904: @406286
     /* 406286 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(406417), // Rule ID 6136 //
     /* 406291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406315 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 406331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 406335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406339 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406343 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406347 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406352 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 406356 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406360 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 406364 */     // MIs[4] Operand 1
     /* 406364 */     // No operand predicates
     /* 406364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406368 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406370 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 406370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406382 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 406401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 406412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 406415 */     GIR_RootConstrainSelectedInstOperands,
     /* 406416 */     // GIR_Coverage, 6136,
     /* 406416 */     GIR_EraseRootFromParent_Done,
     /* 406417 */   // Label 7905: @406417
     /* 406417 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(406548), // Rule ID 6168 //
     /* 406422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406454 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 406458 */     // MIs[2] Operand 1
     /* 406458 */     // No operand predicates
     /* 406458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 406470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 406474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406478 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406482 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 406486 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406491 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 406495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406499 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406501 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 406501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406513 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 406532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406546 */     GIR_RootConstrainSelectedInstOperands,
     /* 406547 */     // GIR_Coverage, 6168,
     /* 406547 */     GIR_EraseRootFromParent_Done,
     /* 406548 */   // Label 7906: @406548
     /* 406548 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(406679), // Rule ID 6232 //
     /* 406553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 406568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406589 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406601 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406605 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406609 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 406618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406622 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 406626 */     // MIs[4] Operand 1
     /* 406626 */     // No operand predicates
     /* 406626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406632 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 406632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406644 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 406663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 406674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 406677 */     GIR_RootConstrainSelectedInstOperands,
     /* 406678 */     // GIR_Coverage, 6232,
     /* 406678 */     GIR_EraseRootFromParent_Done,
     /* 406679 */   // Label 7907: @406679
     /* 406679 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(406810), // Rule ID 6200 //
     /* 406684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 406699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406728 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 406732 */     // MIs[3] Operand 1
     /* 406732 */     // No operand predicates
     /* 406732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 406736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406740 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406744 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 406748 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406753 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 406757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406763 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 406763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406775 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 406794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406808 */     GIR_RootConstrainSelectedInstOperands,
     /* 406809 */     // GIR_Coverage, 6200,
     /* 406809 */     GIR_EraseRootFromParent_Done,
     /* 406810 */   // Label 7908: @406810
     /* 406810 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(406945), // Rule ID 2467 //
     /* 406815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406839 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406864 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406874 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406874 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406877 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406881 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406886 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 406892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406897 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406914 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 406933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406943 */     GIR_RootConstrainSelectedInstOperands,
     /* 406944 */     // GIR_Coverage, 2467,
     /* 406944 */     GIR_EraseRootFromParent_Done,
     /* 406945 */   // Label 7909: @406945
     /* 406945 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(407064), // Rule ID 6104 //
     /* 406950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406974 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407007 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407011 */     // MIs[3] Operand 1
     /* 407011 */     // No operand predicates
     /* 407011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407017 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407029 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 407048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407062 */     GIR_RootConstrainSelectedInstOperands,
     /* 407063 */     // GIR_Coverage, 6104,
     /* 407063 */     GIR_EraseRootFromParent_Done,
     /* 407064 */   // Label 7910: @407064
     /* 407064 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(407183), // Rule ID 2550 //
     /* 407069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407101 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407105 */     // MIs[2] Operand 1
     /* 407105 */     // No operand predicates
     /* 407105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407113 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407117 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407121 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407126 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 407130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407136 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407148 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 407167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407181 */     GIR_RootConstrainSelectedInstOperands,
     /* 407182 */     // GIR_Coverage, 2550,
     /* 407182 */     GIR_EraseRootFromParent_Done,
     /* 407183 */   // Label 7911: @407183
     /* 407183 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(407283), // Rule ID 4871 //
     /* 407188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407212 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407239 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 407239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407251 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407281 */     GIR_RootConstrainSelectedInstOperands,
     /* 407282 */     // GIR_Coverage, 4871,
     /* 407282 */     GIR_EraseRootFromParent_Done,
     /* 407283 */   // Label 7912: @407283
     /* 407283 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(407383), // Rule ID 4907 //
     /* 407288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407312 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 407324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407339 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 407339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407351 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 407370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 407377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 407381 */     GIR_RootConstrainSelectedInstOperands,
     /* 407382 */     // GIR_Coverage, 4907,
     /* 407382 */     GIR_EraseRootFromParent_Done,
     /* 407383 */   // Label 7913: @407383
     /* 407383 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(407480), // Rule ID 13951 //
     /* 407388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407424 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407438 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407450 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407478 */     GIR_RootConstrainSelectedInstOperands,
     /* 407479 */     // GIR_Coverage, 13951,
     /* 407479 */     GIR_EraseRootFromParent_Done,
     /* 407480 */   // Label 7914: @407480
     /* 407480 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(407580), // Rule ID 13953 //
     /* 407485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407526 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407536 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 407536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407548 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407578 */     GIR_RootConstrainSelectedInstOperands,
     /* 407579 */     // GIR_Coverage, 13953,
     /* 407579 */     GIR_EraseRootFromParent_Done,
     /* 407580 */   // Label 7915: @407580
     /* 407580 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(407680), // Rule ID 4905 //
     /* 407585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407613 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 407621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407636 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407648 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 407667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 407678 */     GIR_RootConstrainSelectedInstOperands,
     /* 407679 */     // GIR_Coverage, 4905,
     /* 407679 */     GIR_EraseRootFromParent_Done,
     /* 407680 */   // Label 7916: @407680
     /* 407680 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(407777), // Rule ID 4869 //
     /* 407685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407725 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407735 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407747 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407775 */     GIR_RootConstrainSelectedInstOperands,
     /* 407776 */     // GIR_Coverage, 4869,
     /* 407776 */     GIR_EraseRootFromParent_Done,
     /* 407777 */   // Label 7917: @407777
     /* 407777 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(407855), // Rule ID 6254 //
     /* 407782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 407819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407823 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407827 */     // MIs[3] Operand 1
     /* 407827 */     // No operand predicates
     /* 407827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407837 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407853 */     GIR_RootConstrainSelectedInstOperands,
     /* 407854 */     // GIR_Coverage, 6254,
     /* 407854 */     GIR_EraseRootFromParent_Done,
     /* 407855 */   // Label 7918: @407855
     /* 407855 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(407939), // Rule ID 6166 //
     /* 407860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407896 */     // MIs[2] Operand 1
     /* 407896 */     // No operand predicates
     /* 407896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 407908 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407919 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 407930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407937 */     GIR_RootConstrainSelectedInstOperands,
     /* 407938 */     // GIR_Coverage, 6166,
     /* 407938 */     GIR_EraseRootFromParent_Done,
     /* 407939 */   // Label 7919: @407939
     /* 407939 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(408020), // Rule ID 6198 //
     /* 407944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407988 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407992 */     // MIs[3] Operand 1
     /* 407992 */     // No operand predicates
     /* 407992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408002 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408018 */     GIR_RootConstrainSelectedInstOperands,
     /* 408019 */     // GIR_Coverage, 6198,
     /* 408019 */     GIR_EraseRootFromParent_Done,
     /* 408020 */   // Label 7920: @408020
     /* 408020 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(408104), // Rule ID 6230 //
     /* 408025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408074 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408078 */     // MIs[3] Operand 1
     /* 408078 */     // No operand predicates
     /* 408078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408084 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 408095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408102 */     GIR_RootConstrainSelectedInstOperands,
     /* 408103 */     // GIR_Coverage, 6230,
     /* 408103 */     GIR_EraseRootFromParent_Done,
     /* 408104 */   // Label 7921: @408104
     /* 408104 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(408182), // Rule ID 6276 //
     /* 408109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 408150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408154 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408158 */     // MIs[3] Operand 1
     /* 408158 */     // No operand predicates
     /* 408158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408164 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408180 */     GIR_RootConstrainSelectedInstOperands,
     /* 408181 */     // GIR_Coverage, 6276,
     /* 408181 */     GIR_EraseRootFromParent_Done,
     /* 408182 */   // Label 7922: @408182
     /* 408182 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(408263), // Rule ID 6134 //
     /* 408187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408235 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408239 */     // MIs[3] Operand 1
     /* 408239 */     // No operand predicates
     /* 408239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408245 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408261 */     GIR_RootConstrainSelectedInstOperands,
     /* 408262 */     // GIR_Coverage, 6134,
     /* 408262 */     GIR_EraseRootFromParent_Done,
     /* 408263 */   // Label 7923: @408263
     /* 408263 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(408348), // Rule ID 2465 //
     /* 408268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408292 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408306 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408318 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 408337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408346 */     GIR_RootConstrainSelectedInstOperands,
     /* 408347 */     // GIR_Coverage, 2465,
     /* 408347 */     GIR_EraseRootFromParent_Done,
     /* 408348 */   // Label 7924: @408348
     /* 408348 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(408433), // Rule ID 2463 //
     /* 408353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408381 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408391 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408403 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 408422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408431 */     GIR_RootConstrainSelectedInstOperands,
     /* 408432 */     // GIR_Coverage, 2463,
     /* 408432 */     GIR_EraseRootFromParent_Done,
     /* 408433 */   // Label 7925: @408433
     /* 408433 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(408502), // Rule ID 2548 //
     /* 408438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408470 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408474 */     // MIs[2] Operand 1
     /* 408474 */     // No operand predicates
     /* 408474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408484 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 408487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408500 */     GIR_RootConstrainSelectedInstOperands,
     /* 408501 */     // GIR_Coverage, 2548,
     /* 408501 */     GIR_EraseRootFromParent_Done,
     /* 408502 */   // Label 7926: @408502
     /* 408502 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(408571), // Rule ID 6102 //
     /* 408507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408543 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408547 */     // MIs[2] Operand 1
     /* 408547 */     // No operand predicates
     /* 408547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408553 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 408556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408569 */     GIR_RootConstrainSelectedInstOperands,
     /* 408570 */     // GIR_Coverage, 6102,
     /* 408570 */     GIR_EraseRootFromParent_Done,
     /* 408571 */   // Label 7927: @408571
     /* 408571 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(408621), // Rule ID 13379 //
     /* 408576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408606 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408619 */     GIR_RootConstrainSelectedInstOperands,
     /* 408620 */     // GIR_Coverage, 13379,
     /* 408620 */     GIR_EraseRootFromParent_Done,
     /* 408621 */   // Label 7928: @408621
     /* 408621 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(408671), // Rule ID 647 //
     /* 408626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408656 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408669 */     GIR_RootConstrainSelectedInstOperands,
     /* 408670 */     // GIR_Coverage, 647,
     /* 408670 */     GIR_EraseRootFromParent_Done,
     /* 408671 */   // Label 7929: @408671
     /* 408671 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(408721), // Rule ID 659 //
     /* 408676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408706 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 408709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 408719 */     GIR_RootConstrainSelectedInstOperands,
     /* 408720 */     // GIR_Coverage, 659,
     /* 408720 */     GIR_EraseRootFromParent_Done,
     /* 408721 */   // Label 7930: @408721
     /* 408721 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(408752), // Rule ID 641 //
     /* 408726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408741 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 408746 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 408750 */     GIR_RootConstrainSelectedInstOperands,
     /* 408751 */     // GIR_Coverage, 641,
     /* 408751 */     GIR_Done,
     /* 408752 */   // Label 7931: @408752
     /* 408752 */   GIM_Reject,
     /* 408753 */ // Label 7901: @408753
     /* 408753 */ GIM_Reject,
     /* 408754 */ // Label 7835: @408754
     /* 408754 */ GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(410274),
     /* 408759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 408765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 408768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408772 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(408850), // Rule ID 6234 //
     /* 408777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 408814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408818 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408822 */     // MIs[3] Operand 1
     /* 408822 */     // No operand predicates
     /* 408822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408832 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 408835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408848 */     GIR_RootConstrainSelectedInstOperands,
     /* 408849 */     // GIR_Coverage, 6234,
     /* 408849 */     GIR_EraseRootFromParent_Done,
     /* 408850 */   // Label 7933: @408850
     /* 408850 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(408934), // Rule ID 6150 //
     /* 408855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408887 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408891 */     // MIs[2] Operand 1
     /* 408891 */     // No operand predicates
     /* 408891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408899 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408914 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 408917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 408925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408932 */     GIR_RootConstrainSelectedInstOperands,
     /* 408933 */     // GIR_Coverage, 6150,
     /* 408933 */     GIR_EraseRootFromParent_Done,
     /* 408934 */   // Label 7934: @408934
     /* 408934 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(409015), // Rule ID 6182 //
     /* 408939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408983 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408987 */     // MIs[3] Operand 1
     /* 408987 */     // No operand predicates
     /* 408987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408997 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409013 */     GIR_RootConstrainSelectedInstOperands,
     /* 409014 */     // GIR_Coverage, 6182,
     /* 409014 */     GIR_EraseRootFromParent_Done,
     /* 409015 */   // Label 7935: @409015
     /* 409015 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(409099), // Rule ID 6214 //
     /* 409020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409069 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409073 */     // MIs[3] Operand 1
     /* 409073 */     // No operand predicates
     /* 409073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409079 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 409090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409097 */     GIR_RootConstrainSelectedInstOperands,
     /* 409098 */     // GIR_Coverage, 6214,
     /* 409098 */     GIR_EraseRootFromParent_Done,
     /* 409099 */   // Label 7936: @409099
     /* 409099 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(409177), // Rule ID 6256 //
     /* 409104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 409145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409149 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409153 */     // MIs[3] Operand 1
     /* 409153 */     // No operand predicates
     /* 409153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409157 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409159 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409175 */     GIR_RootConstrainSelectedInstOperands,
     /* 409176 */     // GIR_Coverage, 6256,
     /* 409176 */     GIR_EraseRootFromParent_Done,
     /* 409177 */   // Label 7937: @409177
     /* 409177 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(409258), // Rule ID 6118 //
     /* 409182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409230 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409234 */     // MIs[3] Operand 1
     /* 409234 */     // No operand predicates
     /* 409234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409240 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409256 */     GIR_RootConstrainSelectedInstOperands,
     /* 409257 */     // GIR_Coverage, 6118,
     /* 409257 */     GIR_EraseRootFromParent_Done,
     /* 409258 */   // Label 7938: @409258
     /* 409258 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(409327), // Rule ID 2532 //
     /* 409263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409295 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409299 */     // MIs[2] Operand 1
     /* 409299 */     // No operand predicates
     /* 409299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409309 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 409312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409325 */     GIR_RootConstrainSelectedInstOperands,
     /* 409326 */     // GIR_Coverage, 2532,
     /* 409326 */     GIR_EraseRootFromParent_Done,
     /* 409327 */   // Label 7939: @409327
     /* 409327 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(409396), // Rule ID 6086 //
     /* 409332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409372 */     // MIs[2] Operand 1
     /* 409372 */     // No operand predicates
     /* 409372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409378 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 409381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409394 */     GIR_RootConstrainSelectedInstOperands,
     /* 409395 */     // GIR_Coverage, 6086,
     /* 409395 */     GIR_EraseRootFromParent_Done,
     /* 409396 */   // Label 7940: @409396
     /* 409396 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(409489), // Rule ID 6238 //
     /* 409401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 409409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 409413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 409425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409440 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409452 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409487 */     GIR_RootConstrainSelectedInstOperands,
     /* 409488 */     // GIR_Coverage, 6238,
     /* 409488 */     GIR_EraseRootFromParent_Done,
     /* 409489 */   // Label 7941: @409489
     /* 409489 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(409588), // Rule ID 6152 //
     /* 409494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 409505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 409509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409537 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409556 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 409580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409586 */     GIR_RootConstrainSelectedInstOperands,
     /* 409587 */     // GIR_Coverage, 6152,
     /* 409587 */     GIR_EraseRootFromParent_Done,
     /* 409588 */   // Label 7942: @409588
     /* 409588 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(409684), // Rule ID 6184 //
     /* 409593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 409616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 409620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409635 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409647 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409654 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409682 */     GIR_RootConstrainSelectedInstOperands,
     /* 409683 */     // GIR_Coverage, 6184,
     /* 409683 */     GIR_EraseRootFromParent_Done,
     /* 409684 */   // Label 7943: @409684
     /* 409684 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(409783), // Rule ID 6216 //
     /* 409689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 409717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 409721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409732 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409744 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 409775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409781 */     GIR_RootConstrainSelectedInstOperands,
     /* 409782 */     // GIR_Coverage, 6216,
     /* 409782 */     GIR_EraseRootFromParent_Done,
     /* 409783 */   // Label 7944: @409783
     /* 409783 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(409876), // Rule ID 6260 //
     /* 409788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 409800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 409804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 409816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409827 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409839 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409846 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409874 */     GIR_RootConstrainSelectedInstOperands,
     /* 409875 */     // GIR_Coverage, 6260,
     /* 409875 */     GIR_EraseRootFromParent_Done,
     /* 409876 */   // Label 7945: @409876
     /* 409876 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(409972), // Rule ID 6120 //
     /* 409881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 409908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 409912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409923 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409970 */     GIR_RootConstrainSelectedInstOperands,
     /* 409971 */     // GIR_Coverage, 6120,
     /* 409971 */     GIR_EraseRootFromParent_Done,
     /* 409972 */   // Label 7946: @409972
     /* 409972 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(410056), // Rule ID 2534 //
     /* 409977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 409988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 409992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410007 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410026 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410054 */     GIR_RootConstrainSelectedInstOperands,
     /* 410055 */     // GIR_Coverage, 2534,
     /* 410055 */     GIR_EraseRootFromParent_Done,
     /* 410056 */   // Label 7947: @410056
     /* 410056 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(410106), // Rule ID 13409 //
     /* 410061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410091 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 410094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410104 */     GIR_RootConstrainSelectedInstOperands,
     /* 410105 */     // GIR_Coverage, 13409,
     /* 410105 */     GIR_EraseRootFromParent_Done,
     /* 410106 */   // Label 7948: @410106
     /* 410106 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(410190), // Rule ID 6088 //
     /* 410111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410141 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410153 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410188 */     GIR_RootConstrainSelectedInstOperands,
     /* 410189 */     // GIR_Coverage, 6088,
     /* 410189 */     GIR_EraseRootFromParent_Done,
     /* 410190 */   // Label 7949: @410190
     /* 410190 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(410240), // Rule ID 1307 //
     /* 410195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410225 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 410228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410238 */     GIR_RootConstrainSelectedInstOperands,
     /* 410239 */     // GIR_Coverage, 1307,
     /* 410239 */     GIR_EraseRootFromParent_Done,
     /* 410240 */   // Label 7950: @410240
     /* 410240 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(410273), // Rule ID 1297 //
     /* 410245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410260 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 410263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 410271 */     GIR_RootConstrainSelectedInstOperands,
     /* 410272 */     // GIR_Coverage, 1297,
     /* 410272 */     GIR_EraseRootFromParent_Done,
     /* 410273 */   // Label 7951: @410273
     /* 410273 */   GIM_Reject,
     /* 410274 */ // Label 7932: @410274
     /* 410274 */ GIM_Reject,
     /* 410275 */ // Label 7836: @410275
     /* 410275 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(411795),
     /* 410280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 410286 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 410289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410293 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(410371), // Rule ID 6246 //
     /* 410298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410339 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410343 */     // MIs[3] Operand 1
     /* 410343 */     // No operand predicates
     /* 410343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410353 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410369 */     GIR_RootConstrainSelectedInstOperands,
     /* 410370 */     // GIR_Coverage, 6246,
     /* 410370 */     GIR_EraseRootFromParent_Done,
     /* 410371 */   // Label 7953: @410371
     /* 410371 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(410455), // Rule ID 6158 //
     /* 410376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410408 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410412 */     // MIs[2] Operand 1
     /* 410412 */     // No operand predicates
     /* 410412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410420 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410424 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410435 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 410446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410453 */     GIR_RootConstrainSelectedInstOperands,
     /* 410454 */     // GIR_Coverage, 6158,
     /* 410454 */     GIR_EraseRootFromParent_Done,
     /* 410455 */   // Label 7954: @410455
     /* 410455 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(410536), // Rule ID 6190 //
     /* 410460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410504 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410508 */     // MIs[3] Operand 1
     /* 410508 */     // No operand predicates
     /* 410508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410518 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410534 */     GIR_RootConstrainSelectedInstOperands,
     /* 410535 */     // GIR_Coverage, 6190,
     /* 410535 */     GIR_EraseRootFromParent_Done,
     /* 410536 */   // Label 7955: @410536
     /* 410536 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(410620), // Rule ID 6222 //
     /* 410541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410594 */     // MIs[3] Operand 1
     /* 410594 */     // No operand predicates
     /* 410594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410600 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 410611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410618 */     GIR_RootConstrainSelectedInstOperands,
     /* 410619 */     // GIR_Coverage, 6222,
     /* 410619 */     GIR_EraseRootFromParent_Done,
     /* 410620 */   // Label 7956: @410620
     /* 410620 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(410698), // Rule ID 6268 //
     /* 410625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410670 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410674 */     // MIs[3] Operand 1
     /* 410674 */     // No operand predicates
     /* 410674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410680 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410696 */     GIR_RootConstrainSelectedInstOperands,
     /* 410697 */     // GIR_Coverage, 6268,
     /* 410697 */     GIR_EraseRootFromParent_Done,
     /* 410698 */   // Label 7957: @410698
     /* 410698 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(410779), // Rule ID 6126 //
     /* 410703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410751 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410755 */     // MIs[3] Operand 1
     /* 410755 */     // No operand predicates
     /* 410755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410759 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410761 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410777 */     GIR_RootConstrainSelectedInstOperands,
     /* 410778 */     // GIR_Coverage, 6126,
     /* 410778 */     GIR_EraseRootFromParent_Done,
     /* 410779 */   // Label 7958: @410779
     /* 410779 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(410848), // Rule ID 2540 //
     /* 410784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410816 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410820 */     // MIs[2] Operand 1
     /* 410820 */     // No operand predicates
     /* 410820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410830 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 410833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410846 */     GIR_RootConstrainSelectedInstOperands,
     /* 410847 */     // GIR_Coverage, 2540,
     /* 410847 */     GIR_EraseRootFromParent_Done,
     /* 410848 */   // Label 7959: @410848
     /* 410848 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(410917), // Rule ID 6094 //
     /* 410853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410893 */     // MIs[2] Operand 1
     /* 410893 */     // No operand predicates
     /* 410893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410899 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 410902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410915 */     GIR_RootConstrainSelectedInstOperands,
     /* 410916 */     // GIR_Coverage, 6094,
     /* 410916 */     GIR_EraseRootFromParent_Done,
     /* 410917 */   // Label 7960: @410917
     /* 410917 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(411010), // Rule ID 6248 //
     /* 410922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 410946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410961 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410973 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410980 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 410983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411008 */     GIR_RootConstrainSelectedInstOperands,
     /* 411009 */     // GIR_Coverage, 6248,
     /* 411009 */     GIR_EraseRootFromParent_Done,
     /* 411010 */   // Label 7961: @411010
     /* 411010 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(411109), // Rule ID 6160 //
     /* 411015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411058 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411077 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 411101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411107 */     GIR_RootConstrainSelectedInstOperands,
     /* 411108 */     // GIR_Coverage, 6160,
     /* 411108 */     GIR_EraseRootFromParent_Done,
     /* 411109 */   // Label 7962: @411109
     /* 411109 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(411205), // Rule ID 6192 //
     /* 411114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411156 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411168 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411175 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411203 */     GIR_RootConstrainSelectedInstOperands,
     /* 411204 */     // GIR_Coverage, 6192,
     /* 411204 */     GIR_EraseRootFromParent_Done,
     /* 411205 */   // Label 7963: @411205
     /* 411205 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(411304), // Rule ID 6224 //
     /* 411210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411253 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411272 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 411296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411302 */     GIR_RootConstrainSelectedInstOperands,
     /* 411303 */     // GIR_Coverage, 6224,
     /* 411303 */     GIR_EraseRootFromParent_Done,
     /* 411304 */   // Label 7964: @411304
     /* 411304 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(411397), // Rule ID 6270 //
     /* 411309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411348 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411360 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411367 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411395 */     GIR_RootConstrainSelectedInstOperands,
     /* 411396 */     // GIR_Coverage, 6270,
     /* 411396 */     GIR_EraseRootFromParent_Done,
     /* 411397 */   // Label 7965: @411397
     /* 411397 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(411493), // Rule ID 6128 //
     /* 411402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411444 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411456 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411463 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411491 */     GIR_RootConstrainSelectedInstOperands,
     /* 411492 */     // GIR_Coverage, 6128,
     /* 411492 */     GIR_EraseRootFromParent_Done,
     /* 411493 */   // Label 7966: @411493
     /* 411493 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(411577), // Rule ID 2542 //
     /* 411498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411528 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411540 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411543 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411547 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 411563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411575 */     GIR_RootConstrainSelectedInstOperands,
     /* 411576 */     // GIR_Coverage, 2542,
     /* 411576 */     GIR_EraseRootFromParent_Done,
     /* 411577 */   // Label 7967: @411577
     /* 411577 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(411627), // Rule ID 13413 //
     /* 411582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411612 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 411615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411625 */     GIR_RootConstrainSelectedInstOperands,
     /* 411626 */     // GIR_Coverage, 13413,
     /* 411626 */     GIR_EraseRootFromParent_Done,
     /* 411627 */   // Label 7968: @411627
     /* 411627 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(411711), // Rule ID 6096 //
     /* 411632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411662 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411674 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411681 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 411697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411709 */     GIR_RootConstrainSelectedInstOperands,
     /* 411710 */     // GIR_Coverage, 6096,
     /* 411710 */     GIR_EraseRootFromParent_Done,
     /* 411711 */   // Label 7969: @411711
     /* 411711 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(411761), // Rule ID 1311 //
     /* 411716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411746 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 411749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411759 */     GIR_RootConstrainSelectedInstOperands,
     /* 411760 */     // GIR_Coverage, 1311,
     /* 411760 */     GIR_EraseRootFromParent_Done,
     /* 411761 */   // Label 7970: @411761
     /* 411761 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(411794), // Rule ID 1301 //
     /* 411766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411781 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 411784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 411792 */     GIR_RootConstrainSelectedInstOperands,
     /* 411793 */     // GIR_Coverage, 1301,
     /* 411793 */     GIR_EraseRootFromParent_Done,
     /* 411794 */   // Label 7971: @411794
     /* 411794 */   GIM_Reject,
     /* 411795 */ // Label 7952: @411795
     /* 411795 */ GIM_Reject,
     /* 411796 */ // Label 7837: @411796
     /* 411796 */ GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(412974),
     /* 411801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 411807 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 411810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411814 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(411898), // Rule ID 6142 //
     /* 411819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 411822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 411830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 411843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411851 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 411855 */     // MIs[2] Operand 1
     /* 411855 */     // No operand predicates
     /* 411855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 411859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411867 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411878 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 411878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 411881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 411889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411896 */     GIR_RootConstrainSelectedInstOperands,
     /* 411897 */     // GIR_Coverage, 6142,
     /* 411897 */     GIR_EraseRootFromParent_Done,
     /* 411898 */   // Label 7973: @411898
     /* 411898 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(411979), // Rule ID 6174 //
     /* 411903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 411906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 411926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 411939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411943 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411947 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 411951 */     // MIs[3] Operand 1
     /* 411951 */     // No operand predicates
     /* 411951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411961 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 411961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 411964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411977 */     GIR_RootConstrainSelectedInstOperands,
     /* 411978 */     // GIR_Coverage, 6174,
     /* 411978 */     GIR_EraseRootFromParent_Done,
     /* 411979 */   // Label 7974: @411979
     /* 411979 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(412063), // Rule ID 6206 //
     /* 411984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 411987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412033 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412037 */     // MIs[3] Operand 1
     /* 412037 */     // No operand predicates
     /* 412037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412043 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412061 */     GIR_RootConstrainSelectedInstOperands,
     /* 412062 */     // GIR_Coverage, 6206,
     /* 412062 */     GIR_EraseRootFromParent_Done,
     /* 412063 */   // Label 7975: @412063
     /* 412063 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(412144), // Rule ID 6110 //
     /* 412068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412116 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412120 */     // MIs[3] Operand 1
     /* 412120 */     // No operand predicates
     /* 412120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412126 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412142 */     GIR_RootConstrainSelectedInstOperands,
     /* 412143 */     // GIR_Coverage, 6110,
     /* 412143 */     GIR_EraseRootFromParent_Done,
     /* 412144 */   // Label 7976: @412144
     /* 412144 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(412213), // Rule ID 2524 //
     /* 412149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412181 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412185 */     // MIs[2] Operand 1
     /* 412185 */     // No operand predicates
     /* 412185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412195 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 412198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412211 */     GIR_RootConstrainSelectedInstOperands,
     /* 412212 */     // GIR_Coverage, 2524,
     /* 412212 */     GIR_EraseRootFromParent_Done,
     /* 412213 */   // Label 7977: @412213
     /* 412213 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(412282), // Rule ID 6078 //
     /* 412218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412258 */     // MIs[2] Operand 1
     /* 412258 */     // No operand predicates
     /* 412258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412264 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 412267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412280 */     GIR_RootConstrainSelectedInstOperands,
     /* 412281 */     // GIR_Coverage, 6078,
     /* 412281 */     GIR_EraseRootFromParent_Done,
     /* 412282 */   // Label 7978: @412282
     /* 412282 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(412381), // Rule ID 6144 //
     /* 412287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412330 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412349 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 412373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412379 */     GIR_RootConstrainSelectedInstOperands,
     /* 412380 */     // GIR_Coverage, 6144,
     /* 412380 */     GIR_EraseRootFromParent_Done,
     /* 412381 */   // Label 7979: @412381
     /* 412381 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(412477), // Rule ID 6176 //
     /* 412386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412428 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412443 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412447 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412475 */     GIR_RootConstrainSelectedInstOperands,
     /* 412476 */     // GIR_Coverage, 6176,
     /* 412476 */     GIR_EraseRootFromParent_Done,
     /* 412477 */   // Label 7980: @412477
     /* 412477 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(412576), // Rule ID 6208 //
     /* 412482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412525 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412537 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412544 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412574 */     GIR_RootConstrainSelectedInstOperands,
     /* 412575 */     // GIR_Coverage, 6208,
     /* 412575 */     GIR_EraseRootFromParent_Done,
     /* 412576 */   // Label 7981: @412576
     /* 412576 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(412672), // Rule ID 6112 //
     /* 412581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412623 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412642 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412670 */     GIR_RootConstrainSelectedInstOperands,
     /* 412671 */     // GIR_Coverage, 6112,
     /* 412671 */     GIR_EraseRootFromParent_Done,
     /* 412672 */   // Label 7982: @412672
     /* 412672 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(412756), // Rule ID 2526 //
     /* 412677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412707 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412726 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 412742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412754 */     GIR_RootConstrainSelectedInstOperands,
     /* 412755 */     // GIR_Coverage, 2526,
     /* 412755 */     GIR_EraseRootFromParent_Done,
     /* 412756 */   // Label 7983: @412756
     /* 412756 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(412806), // Rule ID 13405 //
     /* 412761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412791 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 412791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 412794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412804 */     GIR_RootConstrainSelectedInstOperands,
     /* 412805 */     // GIR_Coverage, 13405,
     /* 412805 */     GIR_EraseRootFromParent_Done,
     /* 412806 */   // Label 7984: @412806
     /* 412806 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(412890), // Rule ID 6080 //
     /* 412811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412841 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412860 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 412876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412888 */     GIR_RootConstrainSelectedInstOperands,
     /* 412889 */     // GIR_Coverage, 6080,
     /* 412889 */     GIR_EraseRootFromParent_Done,
     /* 412890 */   // Label 7985: @412890
     /* 412890 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(412940), // Rule ID 1303 //
     /* 412895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412925 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 412925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 412928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412938 */     GIR_RootConstrainSelectedInstOperands,
     /* 412939 */     // GIR_Coverage, 1303,
     /* 412939 */     GIR_EraseRootFromParent_Done,
     /* 412940 */   // Label 7986: @412940
     /* 412940 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(412973), // Rule ID 1293 //
     /* 412945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412960 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 412960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 412963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 412971 */     GIR_RootConstrainSelectedInstOperands,
     /* 412972 */     // GIR_Coverage, 1293,
     /* 412972 */     GIR_EraseRootFromParent_Done,
     /* 412973 */   // Label 7987: @412973
     /* 412973 */   GIM_Reject,
     /* 412974 */ // Label 7972: @412974
     /* 412974 */ GIM_Reject,
     /* 412975 */ // Label 7838: @412975
     /* 412975 */ GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(414495),
     /* 412980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 412986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 412989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412993 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(413071), // Rule ID 6240 //
     /* 412998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 413035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413039 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413043 */     // MIs[3] Operand 1
     /* 413043 */     // No operand predicates
     /* 413043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413053 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413069 */     GIR_RootConstrainSelectedInstOperands,
     /* 413070 */     // GIR_Coverage, 6240,
     /* 413070 */     GIR_EraseRootFromParent_Done,
     /* 413071 */   // Label 7989: @413071
     /* 413071 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(413155), // Rule ID 6154 //
     /* 413076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413108 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413112 */     // MIs[2] Operand 1
     /* 413112 */     // No operand predicates
     /* 413112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 413116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413120 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413135 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 413146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413153 */     GIR_RootConstrainSelectedInstOperands,
     /* 413154 */     // GIR_Coverage, 6154,
     /* 413154 */     GIR_EraseRootFromParent_Done,
     /* 413155 */   // Label 7990: @413155
     /* 413155 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(413236), // Rule ID 6186 //
     /* 413160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413204 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413208 */     // MIs[3] Operand 1
     /* 413208 */     // No operand predicates
     /* 413208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413218 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413234 */     GIR_RootConstrainSelectedInstOperands,
     /* 413235 */     // GIR_Coverage, 6186,
     /* 413235 */     GIR_EraseRootFromParent_Done,
     /* 413236 */   // Label 7991: @413236
     /* 413236 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(413320), // Rule ID 6218 //
     /* 413241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413290 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413294 */     // MIs[3] Operand 1
     /* 413294 */     // No operand predicates
     /* 413294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413300 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 413311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413318 */     GIR_RootConstrainSelectedInstOperands,
     /* 413319 */     // GIR_Coverage, 6218,
     /* 413319 */     GIR_EraseRootFromParent_Done,
     /* 413320 */   // Label 7992: @413320
     /* 413320 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(413398), // Rule ID 6262 //
     /* 413325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 413366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413370 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413374 */     // MIs[3] Operand 1
     /* 413374 */     // No operand predicates
     /* 413374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413380 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413396 */     GIR_RootConstrainSelectedInstOperands,
     /* 413397 */     // GIR_Coverage, 6262,
     /* 413397 */     GIR_EraseRootFromParent_Done,
     /* 413398 */   // Label 7993: @413398
     /* 413398 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(413479), // Rule ID 6122 //
     /* 413403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413451 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413455 */     // MIs[3] Operand 1
     /* 413455 */     // No operand predicates
     /* 413455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413461 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413477 */     GIR_RootConstrainSelectedInstOperands,
     /* 413478 */     // GIR_Coverage, 6122,
     /* 413478 */     GIR_EraseRootFromParent_Done,
     /* 413479 */   // Label 7994: @413479
     /* 413479 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(413548), // Rule ID 2536 //
     /* 413484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413516 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413520 */     // MIs[2] Operand 1
     /* 413520 */     // No operand predicates
     /* 413520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413530 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 413533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413546 */     GIR_RootConstrainSelectedInstOperands,
     /* 413547 */     // GIR_Coverage, 2536,
     /* 413547 */     GIR_EraseRootFromParent_Done,
     /* 413548 */   // Label 7995: @413548
     /* 413548 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(413617), // Rule ID 6090 //
     /* 413553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413593 */     // MIs[2] Operand 1
     /* 413593 */     // No operand predicates
     /* 413593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413599 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 413602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413615 */     GIR_RootConstrainSelectedInstOperands,
     /* 413616 */     // GIR_Coverage, 6090,
     /* 413616 */     GIR_EraseRootFromParent_Done,
     /* 413617 */   // Label 7996: @413617
     /* 413617 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(413710), // Rule ID 6244 //
     /* 413622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 413634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 413646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413661 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413673 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413708 */     GIR_RootConstrainSelectedInstOperands,
     /* 413709 */     // GIR_Coverage, 6244,
     /* 413709 */     GIR_EraseRootFromParent_Done,
     /* 413710 */   // Label 7997: @413710
     /* 413710 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(413809), // Rule ID 6156 //
     /* 413715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 413730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413758 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413770 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413773 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413777 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 413801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413807 */     GIR_RootConstrainSelectedInstOperands,
     /* 413808 */     // GIR_Coverage, 6156,
     /* 413808 */     GIR_EraseRootFromParent_Done,
     /* 413809 */   // Label 7998: @413809
     /* 413809 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(413905), // Rule ID 6188 //
     /* 413814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 413841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413856 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413868 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413875 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413903 */     GIR_RootConstrainSelectedInstOperands,
     /* 413904 */     // GIR_Coverage, 6188,
     /* 413904 */     GIR_EraseRootFromParent_Done,
     /* 413905 */   // Label 7999: @413905
     /* 413905 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(414004), // Rule ID 6220 //
     /* 413910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 413942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413953 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413968 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413972 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 413996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414002 */     GIR_RootConstrainSelectedInstOperands,
     /* 414003 */     // GIR_Coverage, 6220,
     /* 414003 */     GIR_EraseRootFromParent_Done,
     /* 414004 */   // Label 8000: @414004
     /* 414004 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(414097), // Rule ID 6266 //
     /* 414009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414048 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414067 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414095 */     GIR_RootConstrainSelectedInstOperands,
     /* 414096 */     // GIR_Coverage, 6266,
     /* 414096 */     GIR_EraseRootFromParent_Done,
     /* 414097 */   // Label 8001: @414097
     /* 414097 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(414193), // Rule ID 6124 //
     /* 414102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414144 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414156 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414159 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414191 */     GIR_RootConstrainSelectedInstOperands,
     /* 414192 */     // GIR_Coverage, 6124,
     /* 414192 */     GIR_EraseRootFromParent_Done,
     /* 414193 */   // Label 8002: @414193
     /* 414193 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(414277), // Rule ID 2538 //
     /* 414198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414228 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414240 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414247 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 414263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414275 */     GIR_RootConstrainSelectedInstOperands,
     /* 414276 */     // GIR_Coverage, 2538,
     /* 414276 */     GIR_EraseRootFromParent_Done,
     /* 414277 */   // Label 8003: @414277
     /* 414277 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(414327), // Rule ID 13411 //
     /* 414282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414312 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 414315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414325 */     GIR_RootConstrainSelectedInstOperands,
     /* 414326 */     // GIR_Coverage, 13411,
     /* 414326 */     GIR_EraseRootFromParent_Done,
     /* 414327 */   // Label 8004: @414327
     /* 414327 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(414411), // Rule ID 6092 //
     /* 414332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414362 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 414397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414409 */     GIR_RootConstrainSelectedInstOperands,
     /* 414410 */     // GIR_Coverage, 6092,
     /* 414410 */     GIR_EraseRootFromParent_Done,
     /* 414411 */   // Label 8005: @414411
     /* 414411 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(414461), // Rule ID 1309 //
     /* 414416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414446 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 414449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414459 */     GIR_RootConstrainSelectedInstOperands,
     /* 414460 */     // GIR_Coverage, 1309,
     /* 414460 */     GIR_EraseRootFromParent_Done,
     /* 414461 */   // Label 8006: @414461
     /* 414461 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(414494), // Rule ID 1299 //
     /* 414466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414481 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 414484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 414492 */     GIR_RootConstrainSelectedInstOperands,
     /* 414493 */     // GIR_Coverage, 1299,
     /* 414493 */     GIR_EraseRootFromParent_Done,
     /* 414494 */   // Label 8007: @414494
     /* 414494 */   GIM_Reject,
     /* 414495 */ // Label 7988: @414495
     /* 414495 */ GIM_Reject,
     /* 414496 */ // Label 7839: @414496
     /* 414496 */ GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(415674),
     /* 414501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 414507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 414510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414514 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(414598), // Rule ID 6138 //
     /* 414519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414551 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414555 */     // MIs[2] Operand 1
     /* 414555 */     // No operand predicates
     /* 414555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 414559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414563 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414567 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414578 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 414581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 414589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414596 */     GIR_RootConstrainSelectedInstOperands,
     /* 414597 */     // GIR_Coverage, 6138,
     /* 414597 */     GIR_EraseRootFromParent_Done,
     /* 414598 */   // Label 8009: @414598
     /* 414598 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(414679), // Rule ID 6170 //
     /* 414603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414647 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414651 */     // MIs[3] Operand 1
     /* 414651 */     // No operand predicates
     /* 414651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414661 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 414664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414677 */     GIR_RootConstrainSelectedInstOperands,
     /* 414678 */     // GIR_Coverage, 6170,
     /* 414678 */     GIR_EraseRootFromParent_Done,
     /* 414679 */   // Label 8010: @414679
     /* 414679 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(414763), // Rule ID 6202 //
     /* 414684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414733 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414737 */     // MIs[3] Operand 1
     /* 414737 */     // No operand predicates
     /* 414737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414743 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 414746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414761 */     GIR_RootConstrainSelectedInstOperands,
     /* 414762 */     // GIR_Coverage, 6202,
     /* 414762 */     GIR_EraseRootFromParent_Done,
     /* 414763 */   // Label 8011: @414763
     /* 414763 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(414844), // Rule ID 6106 //
     /* 414768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414816 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414820 */     // MIs[3] Operand 1
     /* 414820 */     // No operand predicates
     /* 414820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414826 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 414829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414842 */     GIR_RootConstrainSelectedInstOperands,
     /* 414843 */     // GIR_Coverage, 6106,
     /* 414843 */     GIR_EraseRootFromParent_Done,
     /* 414844 */   // Label 8012: @414844
     /* 414844 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(414913), // Rule ID 2520 //
     /* 414849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414881 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414885 */     // MIs[2] Operand 1
     /* 414885 */     // No operand predicates
     /* 414885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414895 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 414898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414911 */     GIR_RootConstrainSelectedInstOperands,
     /* 414912 */     // GIR_Coverage, 2520,
     /* 414912 */     GIR_EraseRootFromParent_Done,
     /* 414913 */   // Label 8013: @414913
     /* 414913 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(414982), // Rule ID 6074 //
     /* 414918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414954 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414958 */     // MIs[2] Operand 1
     /* 414958 */     // No operand predicates
     /* 414958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414964 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 414967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414980 */     GIR_RootConstrainSelectedInstOperands,
     /* 414981 */     // GIR_Coverage, 6074,
     /* 414981 */     GIR_EraseRootFromParent_Done,
     /* 414982 */   // Label 8014: @414982
     /* 414982 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(415081), // Rule ID 6140 //
     /* 414987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415030 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415045 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415049 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 415073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415079 */     GIR_RootConstrainSelectedInstOperands,
     /* 415080 */     // GIR_Coverage, 6140,
     /* 415080 */     GIR_EraseRootFromParent_Done,
     /* 415081 */   // Label 8015: @415081
     /* 415081 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(415177), // Rule ID 6172 //
     /* 415086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415128 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415175 */     GIR_RootConstrainSelectedInstOperands,
     /* 415176 */     // GIR_Coverage, 6172,
     /* 415176 */     GIR_EraseRootFromParent_Done,
     /* 415177 */   // Label 8016: @415177
     /* 415177 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(415276), // Rule ID 6204 //
     /* 415182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415225 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415274 */     GIR_RootConstrainSelectedInstOperands,
     /* 415275 */     // GIR_Coverage, 6204,
     /* 415275 */     GIR_EraseRootFromParent_Done,
     /* 415276 */   // Label 8017: @415276
     /* 415276 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(415372), // Rule ID 6108 //
     /* 415281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415323 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415370 */     GIR_RootConstrainSelectedInstOperands,
     /* 415371 */     // GIR_Coverage, 6108,
     /* 415371 */     GIR_EraseRootFromParent_Done,
     /* 415372 */   // Label 8018: @415372
     /* 415372 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(415456), // Rule ID 2522 //
     /* 415377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415407 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415419 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415426 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 415442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415454 */     GIR_RootConstrainSelectedInstOperands,
     /* 415455 */     // GIR_Coverage, 2522,
     /* 415455 */     GIR_EraseRootFromParent_Done,
     /* 415456 */   // Label 8019: @415456
     /* 415456 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(415506), // Rule ID 13407 //
     /* 415461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415491 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 415491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 415494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415504 */     GIR_RootConstrainSelectedInstOperands,
     /* 415505 */     // GIR_Coverage, 13407,
     /* 415505 */     GIR_EraseRootFromParent_Done,
     /* 415506 */   // Label 8020: @415506
     /* 415506 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(415590), // Rule ID 6076 //
     /* 415511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415541 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415553 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 415576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415588 */     GIR_RootConstrainSelectedInstOperands,
     /* 415589 */     // GIR_Coverage, 6076,
     /* 415589 */     GIR_EraseRootFromParent_Done,
     /* 415590 */   // Label 8021: @415590
     /* 415590 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(415640), // Rule ID 1305 //
     /* 415595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415625 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 415625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 415628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415638 */     GIR_RootConstrainSelectedInstOperands,
     /* 415639 */     // GIR_Coverage, 1305,
     /* 415639 */     GIR_EraseRootFromParent_Done,
     /* 415640 */   // Label 8022: @415640
     /* 415640 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(415673), // Rule ID 1295 //
     /* 415645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415660 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 415660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 415663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 415671 */     GIR_RootConstrainSelectedInstOperands,
     /* 415672 */     // GIR_Coverage, 1295,
     /* 415672 */     GIR_EraseRootFromParent_Done,
     /* 415673 */   // Label 8023: @415673
     /* 415673 */   GIM_Reject,
     /* 415674 */ // Label 8008: @415674
     /* 415674 */ GIM_Reject,
     /* 415675 */ // Label 7840: @415675
     /* 415675 */ GIM_Reject,
     /* 415676 */ // Label 108: @415676
     /* 415676 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 8032*/ GIMT_Encode4(415975),
     /* 415687 */ /*GILLT_s16*//*Label 8024*/ GIMT_Encode4(415727),
     /* 415691 */ /*GILLT_s32*//*Label 8025*/ GIMT_Encode4(415758),
     /* 415695 */ /*GILLT_s64*//*Label 8026*/ GIMT_Encode4(415789), GIMT_Encode4(0),
     /* 415703 */ /*GILLT_v2s32*//*Label 8027*/ GIMT_Encode4(415820),
     /* 415707 */ /*GILLT_v2s64*//*Label 8028*/ GIMT_Encode4(415851),
     /* 415711 */ /*GILLT_v4s16*//*Label 8029*/ GIMT_Encode4(415882),
     /* 415715 */ /*GILLT_v4s32*//*Label 8030*/ GIMT_Encode4(415913), GIMT_Encode4(0),
     /* 415723 */ /*GILLT_v8s16*//*Label 8031*/ GIMT_Encode4(415944),
     /* 415727 */ // Label 8024: @415727
     /* 415727 */ GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(415757), // Rule ID 569 //
     /* 415732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 415735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 415738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 415742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 415746 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 415746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 415751 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415755 */   GIR_RootConstrainSelectedInstOperands,
     /* 415756 */   // GIR_Coverage, 569,
     /* 415756 */   GIR_Done,
     /* 415757 */ // Label 8033: @415757
     /* 415757 */ GIM_Reject,
     /* 415758 */ // Label 8025: @415758
     /* 415758 */ GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(415788), // Rule ID 571 //
     /* 415763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 415766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 415769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415777 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 415777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 415782 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415786 */   GIR_RootConstrainSelectedInstOperands,
     /* 415787 */   // GIR_Coverage, 571,
     /* 415787 */   GIR_Done,
     /* 415788 */ // Label 8034: @415788
     /* 415788 */ GIM_Reject,
     /* 415789 */ // Label 8026: @415789
     /* 415789 */ GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(415819), // Rule ID 573 //
     /* 415794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 415797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 415800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415808 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 415808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 415813 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415817 */   GIR_RootConstrainSelectedInstOperands,
     /* 415818 */   // GIR_Coverage, 573,
     /* 415818 */   GIR_Done,
     /* 415819 */ // Label 8035: @415819
     /* 415819 */ GIM_Reject,
     /* 415820 */ // Label 8027: @415820
     /* 415820 */ GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(415850), // Rule ID 959 //
     /* 415825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 415831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415839 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 415839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 415844 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415848 */   GIR_RootConstrainSelectedInstOperands,
     /* 415849 */   // GIR_Coverage, 959,
     /* 415849 */   GIR_Done,
     /* 415850 */ // Label 8036: @415850
     /* 415850 */ GIM_Reject,
     /* 415851 */ // Label 8028: @415851
     /* 415851 */ GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(415881), // Rule ID 963 //
     /* 415856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 415862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415870 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 415870 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 415875 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415879 */   GIR_RootConstrainSelectedInstOperands,
     /* 415880 */   // GIR_Coverage, 963,
     /* 415880 */   GIR_Done,
     /* 415881 */ // Label 8037: @415881
     /* 415881 */ GIM_Reject,
     /* 415882 */ // Label 8029: @415882
     /* 415882 */ GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(415912), // Rule ID 955 //
     /* 415887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415901 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 415901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 415906 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415910 */   GIR_RootConstrainSelectedInstOperands,
     /* 415911 */   // GIR_Coverage, 955,
     /* 415911 */   GIR_Done,
     /* 415912 */ // Label 8038: @415912
     /* 415912 */ GIM_Reject,
     /* 415913 */ // Label 8030: @415913
     /* 415913 */ GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(415943), // Rule ID 961 //
     /* 415918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415932 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 415932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 415937 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415941 */   GIR_RootConstrainSelectedInstOperands,
     /* 415942 */   // GIR_Coverage, 961,
     /* 415942 */   GIR_Done,
     /* 415943 */ // Label 8039: @415943
     /* 415943 */ GIM_Reject,
     /* 415944 */ // Label 8031: @415944
     /* 415944 */ GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(415974), // Rule ID 957 //
     /* 415949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415963 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 415963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 415968 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415972 */   GIR_RootConstrainSelectedInstOperands,
     /* 415973 */   // GIR_Coverage, 957,
     /* 415973 */   GIR_Done,
     /* 415974 */ // Label 8040: @415974
     /* 415974 */ GIM_Reject,
     /* 415975 */ // Label 8032: @415975
     /* 415975 */ GIM_Reject,
     /* 415976 */ // Label 109: @415976
     /* 415976 */ GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(415989), // Rule ID 6555 //
     /* 415981 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 415981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 415984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 415987 */   GIR_RootConstrainSelectedInstOperands,
     /* 415988 */   // GIR_Coverage, 6555,
     /* 415988 */   GIR_EraseRootFromParent_Done,
     /* 415989 */ // Label 8041: @415989
     /* 415989 */ GIM_Reject,
     /* 415990 */ // Label 110: @415990
     /* 415990 */ GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(416010), // Rule ID 6556 //
     /* 415995 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 415995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 415998 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 416008 */   GIR_RootConstrainSelectedInstOperands,
     /* 416009 */   // GIR_Coverage, 6556,
     /* 416009 */   GIR_EraseRootFromParent_Done,
     /* 416010 */ // Label 8042: @416010
     /* 416010 */ GIM_Reject,
     /* 416011 */ // Label 111: @416011
     /* 416011 */ GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(416035), // Rule ID 6557 //
     /* 416016 */   // MIs[0] kind
     /* 416016 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 416019 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 416024 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 416024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 416027 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 416033 */   GIR_RootConstrainSelectedInstOperands,
     /* 416034 */   // GIR_Coverage, 6557,
     /* 416034 */   GIR_EraseRootFromParent_Done,
     /* 416035 */ // Label 8043: @416035
     /* 416035 */ GIM_Reject,
     /* 416036 */ // Label 112: @416036
     /* 416036 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8047*/ GIMT_Encode4(416345),
     /* 416047 */ /*GILLT_s16*//*Label 8044*/ GIMT_Encode4(416059),
     /* 416051 */ /*GILLT_s32*//*Label 8045*/ GIMT_Encode4(416212),
     /* 416055 */ /*GILLT_s64*//*Label 8046*/ GIMT_Encode4(416317),
     /* 416059 */ // Label 8044: @416059
     /* 416059 */ GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(416160), // Rule ID 5618 //
     /* 416064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 416067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416078 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 416078 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 416081 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 416085 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416090 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416094 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 416100 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 416103 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 416107 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416112 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 416115 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 416121 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 416124 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 416128 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416133 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 416140 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416145 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 416153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416158 */   GIR_RootConstrainSelectedInstOperands,
     /* 416159 */   // GIR_Coverage, 5618,
     /* 416159 */   GIR_EraseRootFromParent_Done,
     /* 416160 */ // Label 8048: @416160
     /* 416160 */ GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(416211), // Rule ID 5619 //
     /* 416165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 416168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416179 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 416179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 416182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 416186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416191 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416195 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 416201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 416204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416209 */   GIR_RootConstrainSelectedInstOperands,
     /* 416210 */   // GIR_Coverage, 5619,
     /* 416210 */   GIR_EraseRootFromParent_Done,
     /* 416211 */ // Label 8049: @416211
     /* 416211 */ GIM_Reject,
     /* 416212 */ // Label 8045: @416212
     /* 416212 */ GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(416289), // Rule ID 5620 //
     /* 416217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416228 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 416228 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 416231 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 416235 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416240 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416244 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 416250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 416253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 416257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416262 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 416269 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416274 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 416282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416287 */   GIR_RootConstrainSelectedInstOperands,
     /* 416288 */   // GIR_Coverage, 5620,
     /* 416288 */   GIR_EraseRootFromParent_Done,
     /* 416289 */ // Label 8050: @416289
     /* 416289 */ GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(416316), // Rule ID 5621 //
     /* 416294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416305 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 416310 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416314 */   GIR_RootConstrainSelectedInstOperands,
     /* 416315 */   // GIR_Coverage, 5621,
     /* 416315 */   GIR_Done,
     /* 416316 */ // Label 8051: @416316
     /* 416316 */ GIM_Reject,
     /* 416317 */ // Label 8046: @416317
     /* 416317 */ GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(416344), // Rule ID 5622 //
     /* 416322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416333 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 416333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 416338 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416342 */   GIR_RootConstrainSelectedInstOperands,
     /* 416343 */   // GIR_Coverage, 5622,
     /* 416343 */   GIR_Done,
     /* 416344 */ // Label 8052: @416344
     /* 416344 */ GIM_Reject,
     /* 416345 */ // Label 8047: @416345
     /* 416345 */ GIM_Reject,
     /* 416346 */ // Label 113: @416346
     /* 416346 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8056*/ GIMT_Encode4(416516),
     /* 416357 */ /*GILLT_s16*//*Label 8053*/ GIMT_Encode4(416369),
     /* 416361 */ /*GILLT_s32*//*Label 8054*/ GIMT_Encode4(416430),
     /* 416365 */ /*GILLT_s64*//*Label 8055*/ GIMT_Encode4(416488),
     /* 416369 */ // Label 8053: @416369
     /* 416369 */ GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(416399), // Rule ID 1942 //
     /* 416374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416388 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 416388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 416393 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416397 */   GIR_RootConstrainSelectedInstOperands,
     /* 416398 */   // GIR_Coverage, 1942,
     /* 416398 */   GIR_Done,
     /* 416399 */ // Label 8057: @416399
     /* 416399 */ GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(416429), // Rule ID 1944 //
     /* 416404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416418 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 416418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 416423 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416427 */   GIR_RootConstrainSelectedInstOperands,
     /* 416428 */   // GIR_Coverage, 1944,
     /* 416428 */   GIR_Done,
     /* 416429 */ // Label 8058: @416429
     /* 416429 */ GIM_Reject,
     /* 416430 */ // Label 8054: @416430
     /* 416430 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(416460), // Rule ID 1946 //
     /* 416435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416449 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 416449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 416454 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416458 */   GIR_RootConstrainSelectedInstOperands,
     /* 416459 */   // GIR_Coverage, 1946,
     /* 416459 */   GIR_Done,
     /* 416460 */ // Label 8059: @416460
     /* 416460 */ GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(416487), // Rule ID 5628 //
     /* 416465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416476 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 416481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416485 */   GIR_RootConstrainSelectedInstOperands,
     /* 416486 */   // GIR_Coverage, 5628,
     /* 416486 */   GIR_Done,
     /* 416487 */ // Label 8060: @416487
     /* 416487 */ GIM_Reject,
     /* 416488 */ // Label 8055: @416488
     /* 416488 */ GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(416515), // Rule ID 5630 //
     /* 416493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416504 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 416504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 416509 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416513 */   GIR_RootConstrainSelectedInstOperands,
     /* 416514 */   // GIR_Coverage, 5630,
     /* 416514 */   GIR_Done,
     /* 416515 */ // Label 8061: @416515
     /* 416515 */ GIM_Reject,
     /* 416516 */ // Label 8056: @416516
     /* 416516 */ GIM_Reject,
     /* 416517 */ // Label 114: @416517
     /* 416517 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8065*/ GIMT_Encode4(416687),
     /* 416528 */ /*GILLT_s16*//*Label 8062*/ GIMT_Encode4(416540),
     /* 416532 */ /*GILLT_s32*//*Label 8063*/ GIMT_Encode4(416601),
     /* 416536 */ /*GILLT_s64*//*Label 8064*/ GIMT_Encode4(416659),
     /* 416540 */ // Label 8062: @416540
     /* 416540 */ GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(416570), // Rule ID 1954 //
     /* 416545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416559 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 416559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 416564 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416568 */   GIR_RootConstrainSelectedInstOperands,
     /* 416569 */   // GIR_Coverage, 1954,
     /* 416569 */   GIR_Done,
     /* 416570 */ // Label 8066: @416570
     /* 416570 */ GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(416600), // Rule ID 1956 //
     /* 416575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416589 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 416589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 416594 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416598 */   GIR_RootConstrainSelectedInstOperands,
     /* 416599 */   // GIR_Coverage, 1956,
     /* 416599 */   GIR_Done,
     /* 416600 */ // Label 8067: @416600
     /* 416600 */ GIM_Reject,
     /* 416601 */ // Label 8063: @416601
     /* 416601 */ GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(416631), // Rule ID 1958 //
     /* 416606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416620 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 416620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 416625 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416629 */   GIR_RootConstrainSelectedInstOperands,
     /* 416630 */   // GIR_Coverage, 1958,
     /* 416630 */   GIR_Done,
     /* 416631 */ // Label 8068: @416631
     /* 416631 */ GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(416658), // Rule ID 5636 //
     /* 416636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416647 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 416652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416656 */   GIR_RootConstrainSelectedInstOperands,
     /* 416657 */   // GIR_Coverage, 5636,
     /* 416657 */   GIR_Done,
     /* 416658 */ // Label 8069: @416658
     /* 416658 */ GIM_Reject,
     /* 416659 */ // Label 8064: @416659
     /* 416659 */ GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(416686), // Rule ID 5638 //
     /* 416664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416675 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 416675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 416680 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416684 */   GIR_RootConstrainSelectedInstOperands,
     /* 416685 */   // GIR_Coverage, 5638,
     /* 416685 */   GIR_Done,
     /* 416686 */ // Label 8070: @416686
     /* 416686 */ GIM_Reject,
     /* 416687 */ // Label 8065: @416687
     /* 416687 */ GIM_Reject,
     /* 416688 */ // Label 115: @416688
     /* 416688 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8074*/ GIMT_Encode4(416858),
     /* 416699 */ /*GILLT_s16*//*Label 8071*/ GIMT_Encode4(416711),
     /* 416703 */ /*GILLT_s32*//*Label 8072*/ GIMT_Encode4(416772),
     /* 416707 */ /*GILLT_s64*//*Label 8073*/ GIMT_Encode4(416830),
     /* 416711 */ // Label 8071: @416711
     /* 416711 */ GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(416741), // Rule ID 1948 //
     /* 416716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416730 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 416730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 416735 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416739 */   GIR_RootConstrainSelectedInstOperands,
     /* 416740 */   // GIR_Coverage, 1948,
     /* 416740 */   GIR_Done,
     /* 416741 */ // Label 8075: @416741
     /* 416741 */ GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(416771), // Rule ID 1950 //
     /* 416746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416760 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 416760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 416765 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416769 */   GIR_RootConstrainSelectedInstOperands,
     /* 416770 */   // GIR_Coverage, 1950,
     /* 416770 */   GIR_Done,
     /* 416771 */ // Label 8076: @416771
     /* 416771 */ GIM_Reject,
     /* 416772 */ // Label 8072: @416772
     /* 416772 */ GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(416802), // Rule ID 1952 //
     /* 416777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416791 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 416791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 416796 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416800 */   GIR_RootConstrainSelectedInstOperands,
     /* 416801 */   // GIR_Coverage, 1952,
     /* 416801 */   GIR_Done,
     /* 416802 */ // Label 8077: @416802
     /* 416802 */ GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(416829), // Rule ID 5632 //
     /* 416807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416818 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 416823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416827 */   GIR_RootConstrainSelectedInstOperands,
     /* 416828 */   // GIR_Coverage, 5632,
     /* 416828 */   GIR_Done,
     /* 416829 */ // Label 8078: @416829
     /* 416829 */ GIM_Reject,
     /* 416830 */ // Label 8073: @416830
     /* 416830 */ GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(416857), // Rule ID 5634 //
     /* 416835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416846 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 416846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 416851 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416855 */   GIR_RootConstrainSelectedInstOperands,
     /* 416856 */   // GIR_Coverage, 5634,
     /* 416856 */   GIR_Done,
     /* 416857 */ // Label 8079: @416857
     /* 416857 */ GIM_Reject,
     /* 416858 */ // Label 8074: @416858
     /* 416858 */ GIM_Reject,
     /* 416859 */ // Label 116: @416859
     /* 416859 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8083*/ GIMT_Encode4(417029),
     /* 416870 */ /*GILLT_s16*//*Label 8080*/ GIMT_Encode4(416882),
     /* 416874 */ /*GILLT_s32*//*Label 8081*/ GIMT_Encode4(416943),
     /* 416878 */ /*GILLT_s64*//*Label 8082*/ GIMT_Encode4(417001),
     /* 416882 */ // Label 8080: @416882
     /* 416882 */ GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(416912), // Rule ID 1960 //
     /* 416887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416901 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 416901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 416906 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416910 */   GIR_RootConstrainSelectedInstOperands,
     /* 416911 */   // GIR_Coverage, 1960,
     /* 416911 */   GIR_Done,
     /* 416912 */ // Label 8084: @416912
     /* 416912 */ GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(416942), // Rule ID 1962 //
     /* 416917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416931 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 416931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 416936 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416940 */   GIR_RootConstrainSelectedInstOperands,
     /* 416941 */   // GIR_Coverage, 1962,
     /* 416941 */   GIR_Done,
     /* 416942 */ // Label 8085: @416942
     /* 416942 */ GIM_Reject,
     /* 416943 */ // Label 8081: @416943
     /* 416943 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(416973), // Rule ID 1964 //
     /* 416948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416962 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 416962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 416967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416971 */   GIR_RootConstrainSelectedInstOperands,
     /* 416972 */   // GIR_Coverage, 1964,
     /* 416972 */   GIR_Done,
     /* 416973 */ // Label 8086: @416973
     /* 416973 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(417000), // Rule ID 5640 //
     /* 416978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416989 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 416994 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416998 */   GIR_RootConstrainSelectedInstOperands,
     /* 416999 */   // GIR_Coverage, 5640,
     /* 416999 */   GIR_Done,
     /* 417000 */ // Label 8087: @417000
     /* 417000 */ GIM_Reject,
     /* 417001 */ // Label 8082: @417001
     /* 417001 */ GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(417028), // Rule ID 5642 //
     /* 417006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417017 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 417022 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417026 */   GIR_RootConstrainSelectedInstOperands,
     /* 417027 */   // GIR_Coverage, 5642,
     /* 417027 */   GIR_Done,
     /* 417028 */ // Label 8088: @417028
     /* 417028 */ GIM_Reject,
     /* 417029 */ // Label 8083: @417029
     /* 417029 */ GIM_Reject,
     /* 417030 */ // Label 117: @417030
     /* 417030 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 8093*/ GIMT_Encode4(418158),
     /* 417041 */ /*GILLT_s8*//*Label 8089*/ GIMT_Encode4(417057),
     /* 417045 */ /*GILLT_s16*//*Label 8090*/ GIMT_Encode4(417104),
     /* 417049 */ /*GILLT_s32*//*Label 8091*/ GIMT_Encode4(417519),
     /* 417053 */ /*GILLT_s64*//*Label 8092*/ GIMT_Encode4(417972),
     /* 417057 */ // Label 8089: @417057
     /* 417057 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(417080), // Rule ID 5927 //
     /* 417062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 417069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417073 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 417073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 417078 */   GIR_RootConstrainSelectedInstOperands,
     /* 417079 */   // GIR_Coverage, 5927,
     /* 417079 */   GIR_Done,
     /* 417080 */ // Label 8094: @417080
     /* 417080 */ GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(417103), // Rule ID 5928 //
     /* 417085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 417092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417096 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 417096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 417101 */   GIR_RootConstrainSelectedInstOperands,
     /* 417102 */   // GIR_Coverage, 5928,
     /* 417102 */   GIR_Done,
     /* 417103 */ // Label 8095: @417103
     /* 417103 */ GIM_Reject,
     /* 417104 */ // Label 8090: @417104
     /* 417104 */ GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(417154), // Rule ID 5874 //
     /* 417109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417124 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417127 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 417132 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 417136 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417141 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417143 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 417143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 417146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417148 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417152 */   GIR_RootConstrainSelectedInstOperands,
     /* 417153 */   // GIR_Coverage, 5874,
     /* 417153 */   GIR_EraseRootFromParent_Done,
     /* 417154 */ // Label 8096: @417154
     /* 417154 */ GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(417204), // Rule ID 5876 //
     /* 417159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417166 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417170 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417174 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417177 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 417182 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 417186 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417191 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417193 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 417193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 417196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417198 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417202 */   GIR_RootConstrainSelectedInstOperands,
     /* 417203 */   // GIR_Coverage, 5876,
     /* 417203 */   GIR_EraseRootFromParent_Done,
     /* 417204 */ // Label 8097: @417204
     /* 417204 */ GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(417254), // Rule ID 5884 //
     /* 417209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417216 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417220 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417224 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417227 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 417232 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 417236 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417241 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417243 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 417243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 417246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417248 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417252 */   GIR_RootConstrainSelectedInstOperands,
     /* 417253 */   // GIR_Coverage, 5884,
     /* 417253 */   GIR_EraseRootFromParent_Done,
     /* 417254 */ // Label 8098: @417254
     /* 417254 */ GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(417304), // Rule ID 5886 //
     /* 417259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417266 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417274 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417277 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 417282 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 417286 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417293 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 417293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 417296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417298 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417302 */   GIR_RootConstrainSelectedInstOperands,
     /* 417303 */   // GIR_Coverage, 5886,
     /* 417303 */   GIR_EraseRootFromParent_Done,
     /* 417304 */ // Label 8099: @417304
     /* 417304 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(417346), // Rule ID 5883 //
     /* 417309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417316 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 417324 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417328 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417335 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 417335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 417338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417340 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417344 */   GIR_RootConstrainSelectedInstOperands,
     /* 417345 */   // GIR_Coverage, 5883,
     /* 417345 */   GIR_EraseRootFromParent_Done,
     /* 417346 */ // Label 8100: @417346
     /* 417346 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(417388), // Rule ID 5885 //
     /* 417351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 417366 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417370 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417377 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 417377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 417380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417382 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417386 */   GIR_RootConstrainSelectedInstOperands,
     /* 417387 */   // GIR_Coverage, 5885,
     /* 417387 */   GIR_EraseRootFromParent_Done,
     /* 417388 */ // Label 8101: @417388
     /* 417388 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(417430), // Rule ID 5873 //
     /* 417393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417400 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417404 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 417408 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417412 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417417 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417419 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 417419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 417422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417424 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417428 */   GIR_RootConstrainSelectedInstOperands,
     /* 417429 */   // GIR_Coverage, 5873,
     /* 417429 */   GIR_EraseRootFromParent_Done,
     /* 417430 */ // Label 8102: @417430
     /* 417430 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(417472), // Rule ID 5875 //
     /* 417435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 417450 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417454 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417459 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417461 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 417461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 417464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417466 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417470 */   GIR_RootConstrainSelectedInstOperands,
     /* 417471 */   // GIR_Coverage, 5875,
     /* 417471 */   GIR_EraseRootFromParent_Done,
     /* 417472 */ // Label 8103: @417472
     /* 417472 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(417495), // Rule ID 5929 //
     /* 417477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417488 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 417488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 417493 */   GIR_RootConstrainSelectedInstOperands,
     /* 417494 */   // GIR_Coverage, 5929,
     /* 417494 */   GIR_Done,
     /* 417495 */ // Label 8104: @417495
     /* 417495 */ GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(417518), // Rule ID 5930 //
     /* 417500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417511 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 417511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 417516 */   GIR_RootConstrainSelectedInstOperands,
     /* 417517 */   // GIR_Coverage, 5930,
     /* 417517 */   GIR_Done,
     /* 417518 */ // Label 8105: @417518
     /* 417518 */ GIM_Reject,
     /* 417519 */ // Label 8091: @417519
     /* 417519 */ GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(417569), // Rule ID 5878 //
     /* 417524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417531 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417535 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417539 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417542 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 417547 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 417551 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417556 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417558 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 417558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 417561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417563 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417567 */   GIR_RootConstrainSelectedInstOperands,
     /* 417568 */   // GIR_Coverage, 5878,
     /* 417568 */   GIR_EraseRootFromParent_Done,
     /* 417569 */ // Label 8106: @417569
     /* 417569 */ GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(417619), // Rule ID 5880 //
     /* 417574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417589 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417592 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 417597 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 417601 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417606 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417608 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 417608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 417611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417613 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417617 */   GIR_RootConstrainSelectedInstOperands,
     /* 417618 */   // GIR_Coverage, 5880,
     /* 417618 */   GIR_EraseRootFromParent_Done,
     /* 417619 */ // Label 8107: @417619
     /* 417619 */ GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(417669), // Rule ID 5888 //
     /* 417624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417631 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417635 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417639 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417642 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 417647 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 417651 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417656 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417658 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 417658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 417661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417663 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417667 */   GIR_RootConstrainSelectedInstOperands,
     /* 417668 */   // GIR_Coverage, 5888,
     /* 417668 */   GIR_EraseRootFromParent_Done,
     /* 417669 */ // Label 8108: @417669
     /* 417669 */ GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(417719), // Rule ID 5890 //
     /* 417674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417689 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417692 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 417697 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 417701 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417706 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417708 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 417708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 417711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417713 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417717 */   GIR_RootConstrainSelectedInstOperands,
     /* 417718 */   // GIR_Coverage, 5890,
     /* 417718 */   GIR_EraseRootFromParent_Done,
     /* 417719 */ // Label 8109: @417719
     /* 417719 */ GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(417761), // Rule ID 5887 //
     /* 417724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 417739 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417743 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417750 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 417750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 417753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417755 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417759 */   GIR_RootConstrainSelectedInstOperands,
     /* 417760 */   // GIR_Coverage, 5887,
     /* 417760 */   GIR_EraseRootFromParent_Done,
     /* 417761 */ // Label 8110: @417761
     /* 417761 */ GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(417803), // Rule ID 5889 //
     /* 417766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 417781 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417785 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417790 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417792 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 417792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 417795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417797 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417801 */   GIR_RootConstrainSelectedInstOperands,
     /* 417802 */   // GIR_Coverage, 5889,
     /* 417802 */   GIR_EraseRootFromParent_Done,
     /* 417803 */ // Label 8111: @417803
     /* 417803 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(417845), // Rule ID 5877 //
     /* 417808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 417823 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417827 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417834 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 417834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 417837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417839 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417843 */   GIR_RootConstrainSelectedInstOperands,
     /* 417844 */   // GIR_Coverage, 5877,
     /* 417844 */   GIR_EraseRootFromParent_Done,
     /* 417845 */ // Label 8112: @417845
     /* 417845 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(417887), // Rule ID 5879 //
     /* 417850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 417865 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417869 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417876 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 417876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 417879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417881 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417885 */   GIR_RootConstrainSelectedInstOperands,
     /* 417886 */   // GIR_Coverage, 5879,
     /* 417886 */   GIR_EraseRootFromParent_Done,
     /* 417887 */ // Label 8113: @417887
     /* 417887 */ GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(417948), // Rule ID 5931 //
     /* 417892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417903 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 417903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 417910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417915 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417919 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 417925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 417928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417930 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 417937 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417947 */   // GIR_Coverage, 5931,
     /* 417947 */   GIR_EraseRootFromParent_Done,
     /* 417948 */ // Label 8114: @417948
     /* 417948 */ GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(417971), // Rule ID 5932 //
     /* 417953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417964 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 417964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 417969 */   GIR_RootConstrainSelectedInstOperands,
     /* 417970 */   // GIR_Coverage, 5932,
     /* 417970 */   GIR_Done,
     /* 417971 */ // Label 8115: @417971
     /* 417971 */ GIM_Reject,
     /* 417972 */ // Label 8092: @417972
     /* 417972 */ GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(418157),
     /* 417977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417984 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(418027), // Rule ID 5882 //
     /* 417989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417997 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418000 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 418009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418016 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 418019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418025 */     GIR_RootConstrainSelectedInstOperands,
     /* 418026 */     // GIR_Coverage, 5882,
     /* 418026 */     GIR_EraseRootFromParent_Done,
     /* 418027 */   // Label 8117: @418027
     /* 418027 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(418070), // Rule ID 5892 //
     /* 418032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 418052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418059 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 418062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418068 */     GIR_RootConstrainSelectedInstOperands,
     /* 418069 */     // GIR_Coverage, 5892,
     /* 418069 */     GIR_EraseRootFromParent_Done,
     /* 418070 */   // Label 8118: @418070
     /* 418070 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(418105), // Rule ID 5891 //
     /* 418075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418094 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 418097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418103 */     GIR_RootConstrainSelectedInstOperands,
     /* 418104 */     // GIR_Coverage, 5891,
     /* 418104 */     GIR_EraseRootFromParent_Done,
     /* 418105 */   // Label 8119: @418105
     /* 418105 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(418140), // Rule ID 5881 //
     /* 418110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418129 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 418132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418138 */     GIR_RootConstrainSelectedInstOperands,
     /* 418139 */     // GIR_Coverage, 5881,
     /* 418139 */     GIR_EraseRootFromParent_Done,
     /* 418140 */   // Label 8120: @418140
     /* 418140 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(418156), // Rule ID 5933 //
     /* 418145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418149 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 418149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 418154 */     GIR_RootConstrainSelectedInstOperands,
     /* 418155 */     // GIR_Coverage, 5933,
     /* 418155 */     GIR_Done,
     /* 418156 */   // Label 8121: @418156
     /* 418156 */   GIM_Reject,
     /* 418157 */ // Label 8116: @418157
     /* 418157 */ GIM_Reject,
     /* 418158 */ // Label 8093: @418158
     /* 418158 */ GIM_Reject,
     /* 418159 */ // Label 118: @418159
     /* 418159 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8125*/ GIMT_Encode4(418361),
     /* 418170 */ /*GILLT_s8*//*Label 8122*/ GIMT_Encode4(418182),
     /* 418174 */ /*GILLT_s16*//*Label 8123*/ GIMT_Encode4(418229),
     /* 418178 */ /*GILLT_s32*//*Label 8124*/ GIMT_Encode4(418276),
     /* 418182 */ // Label 8122: @418182
     /* 418182 */ GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(418205), // Rule ID 6024 //
     /* 418187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418198 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 418198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 418203 */   GIR_RootConstrainSelectedInstOperands,
     /* 418204 */   // GIR_Coverage, 6024,
     /* 418204 */   GIR_Done,
     /* 418205 */ // Label 8126: @418205
     /* 418205 */ GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(418228), // Rule ID 6025 //
     /* 418210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418221 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 418221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 418226 */   GIR_RootConstrainSelectedInstOperands,
     /* 418227 */   // GIR_Coverage, 6025,
     /* 418227 */   GIR_Done,
     /* 418228 */ // Label 8127: @418228
     /* 418228 */ GIM_Reject,
     /* 418229 */ // Label 8123: @418229
     /* 418229 */ GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(418252), // Rule ID 6026 //
     /* 418234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418245 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 418245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 418250 */   GIR_RootConstrainSelectedInstOperands,
     /* 418251 */   // GIR_Coverage, 6026,
     /* 418251 */   GIR_Done,
     /* 418252 */ // Label 8128: @418252
     /* 418252 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(418275), // Rule ID 6027 //
     /* 418257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418268 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 418268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 418273 */   GIR_RootConstrainSelectedInstOperands,
     /* 418274 */   // GIR_Coverage, 6027,
     /* 418274 */   GIR_Done,
     /* 418275 */ // Label 8129: @418275
     /* 418275 */ GIM_Reject,
     /* 418276 */ // Label 8124: @418276
     /* 418276 */ GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(418299), // Rule ID 6028 //
     /* 418281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418292 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 418297 */   GIR_RootConstrainSelectedInstOperands,
     /* 418298 */   // GIR_Coverage, 6028,
     /* 418298 */   GIR_Done,
     /* 418299 */ // Label 8130: @418299
     /* 418299 */ GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(418360), // Rule ID 6029 //
     /* 418304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418315 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 418315 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418318 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 418322 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418327 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418331 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418342 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 418349 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418359 */   // GIR_Coverage, 6029,
     /* 418359 */   GIR_EraseRootFromParent_Done,
     /* 418360 */ // Label 8131: @418360
     /* 418360 */ GIM_Reject,
     /* 418361 */ // Label 8125: @418361
     /* 418361 */ GIM_Reject,
     /* 418362 */ // Label 119: @418362
     /* 418362 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8135*/ GIMT_Encode4(418564),
     /* 418373 */ /*GILLT_s8*//*Label 8132*/ GIMT_Encode4(418385),
     /* 418377 */ /*GILLT_s16*//*Label 8133*/ GIMT_Encode4(418432),
     /* 418381 */ /*GILLT_s32*//*Label 8134*/ GIMT_Encode4(418479),
     /* 418385 */ // Label 8132: @418385
     /* 418385 */ GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(418408), // Rule ID 6018 //
     /* 418390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418401 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 418401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 418406 */   GIR_RootConstrainSelectedInstOperands,
     /* 418407 */   // GIR_Coverage, 6018,
     /* 418407 */   GIR_Done,
     /* 418408 */ // Label 8136: @418408
     /* 418408 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(418431), // Rule ID 6019 //
     /* 418413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418424 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 418424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 418429 */   GIR_RootConstrainSelectedInstOperands,
     /* 418430 */   // GIR_Coverage, 6019,
     /* 418430 */   GIR_Done,
     /* 418431 */ // Label 8137: @418431
     /* 418431 */ GIM_Reject,
     /* 418432 */ // Label 8133: @418432
     /* 418432 */ GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(418455), // Rule ID 6020 //
     /* 418437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418448 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 418448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 418453 */   GIR_RootConstrainSelectedInstOperands,
     /* 418454 */   // GIR_Coverage, 6020,
     /* 418454 */   GIR_Done,
     /* 418455 */ // Label 8138: @418455
     /* 418455 */ GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(418478), // Rule ID 6021 //
     /* 418460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418471 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 418471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 418476 */   GIR_RootConstrainSelectedInstOperands,
     /* 418477 */   // GIR_Coverage, 6021,
     /* 418477 */   GIR_Done,
     /* 418478 */ // Label 8139: @418478
     /* 418478 */ GIM_Reject,
     /* 418479 */ // Label 8134: @418479
     /* 418479 */ GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(418502), // Rule ID 6022 //
     /* 418484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418495 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 418500 */   GIR_RootConstrainSelectedInstOperands,
     /* 418501 */   // GIR_Coverage, 6022,
     /* 418501 */   GIR_Done,
     /* 418502 */ // Label 8140: @418502
     /* 418502 */ GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(418563), // Rule ID 6023 //
     /* 418507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418518 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 418518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 418525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418530 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418534 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418545 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 418552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418557 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418562 */   // GIR_Coverage, 6023,
     /* 418562 */   GIR_EraseRootFromParent_Done,
     /* 418563 */ // Label 8141: @418563
     /* 418563 */ GIM_Reject,
     /* 418564 */ // Label 8135: @418564
     /* 418564 */ GIM_Reject,
     /* 418565 */ // Label 120: @418565
     /* 418565 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8145*/ GIMT_Encode4(418767),
     /* 418576 */ /*GILLT_s8*//*Label 8142*/ GIMT_Encode4(418588),
     /* 418580 */ /*GILLT_s16*//*Label 8143*/ GIMT_Encode4(418635),
     /* 418584 */ /*GILLT_s32*//*Label 8144*/ GIMT_Encode4(418682),
     /* 418588 */ // Label 8142: @418588
     /* 418588 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(418611), // Rule ID 6012 //
     /* 418593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418604 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 418604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 418609 */   GIR_RootConstrainSelectedInstOperands,
     /* 418610 */   // GIR_Coverage, 6012,
     /* 418610 */   GIR_Done,
     /* 418611 */ // Label 8146: @418611
     /* 418611 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(418634), // Rule ID 6013 //
     /* 418616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418627 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 418627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 418632 */   GIR_RootConstrainSelectedInstOperands,
     /* 418633 */   // GIR_Coverage, 6013,
     /* 418633 */   GIR_Done,
     /* 418634 */ // Label 8147: @418634
     /* 418634 */ GIM_Reject,
     /* 418635 */ // Label 8143: @418635
     /* 418635 */ GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(418658), // Rule ID 6014 //
     /* 418640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418651 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 418651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 418656 */   GIR_RootConstrainSelectedInstOperands,
     /* 418657 */   // GIR_Coverage, 6014,
     /* 418657 */   GIR_Done,
     /* 418658 */ // Label 8148: @418658
     /* 418658 */ GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(418681), // Rule ID 6015 //
     /* 418663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418674 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 418674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 418679 */   GIR_RootConstrainSelectedInstOperands,
     /* 418680 */   // GIR_Coverage, 6015,
     /* 418680 */   GIR_Done,
     /* 418681 */ // Label 8149: @418681
     /* 418681 */ GIM_Reject,
     /* 418682 */ // Label 8144: @418682
     /* 418682 */ GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(418705), // Rule ID 6016 //
     /* 418687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418698 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 418703 */   GIR_RootConstrainSelectedInstOperands,
     /* 418704 */   // GIR_Coverage, 6016,
     /* 418704 */   GIR_Done,
     /* 418705 */ // Label 8150: @418705
     /* 418705 */ GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(418766), // Rule ID 6017 //
     /* 418710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418721 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 418721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 418728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418733 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418737 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418748 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 418755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418765 */   // GIR_Coverage, 6017,
     /* 418765 */   GIR_EraseRootFromParent_Done,
     /* 418766 */ // Label 8151: @418766
     /* 418766 */ GIM_Reject,
     /* 418767 */ // Label 8145: @418767
     /* 418767 */ GIM_Reject,
     /* 418768 */ // Label 121: @418768
     /* 418768 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8155*/ GIMT_Encode4(418970),
     /* 418779 */ /*GILLT_s8*//*Label 8152*/ GIMT_Encode4(418791),
     /* 418783 */ /*GILLT_s16*//*Label 8153*/ GIMT_Encode4(418838),
     /* 418787 */ /*GILLT_s32*//*Label 8154*/ GIMT_Encode4(418885),
     /* 418791 */ // Label 8152: @418791
     /* 418791 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(418814), // Rule ID 6006 //
     /* 418796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418807 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 418807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 418812 */   GIR_RootConstrainSelectedInstOperands,
     /* 418813 */   // GIR_Coverage, 6006,
     /* 418813 */   GIR_Done,
     /* 418814 */ // Label 8156: @418814
     /* 418814 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(418837), // Rule ID 6007 //
     /* 418819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418830 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 418830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 418835 */   GIR_RootConstrainSelectedInstOperands,
     /* 418836 */   // GIR_Coverage, 6007,
     /* 418836 */   GIR_Done,
     /* 418837 */ // Label 8157: @418837
     /* 418837 */ GIM_Reject,
     /* 418838 */ // Label 8153: @418838
     /* 418838 */ GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(418861), // Rule ID 6008 //
     /* 418843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418854 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 418854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 418859 */   GIR_RootConstrainSelectedInstOperands,
     /* 418860 */   // GIR_Coverage, 6008,
     /* 418860 */   GIR_Done,
     /* 418861 */ // Label 8158: @418861
     /* 418861 */ GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(418884), // Rule ID 6009 //
     /* 418866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418877 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 418877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 418882 */   GIR_RootConstrainSelectedInstOperands,
     /* 418883 */   // GIR_Coverage, 6009,
     /* 418883 */   GIR_Done,
     /* 418884 */ // Label 8159: @418884
     /* 418884 */ GIM_Reject,
     /* 418885 */ // Label 8154: @418885
     /* 418885 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(418908), // Rule ID 6010 //
     /* 418890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418901 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 418906 */   GIR_RootConstrainSelectedInstOperands,
     /* 418907 */   // GIR_Coverage, 6010,
     /* 418907 */   GIR_Done,
     /* 418908 */ // Label 8160: @418908
     /* 418908 */ GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(418969), // Rule ID 6011 //
     /* 418913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418924 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 418924 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418927 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 418931 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418936 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418940 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418951 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 418958 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418968 */   // GIR_Coverage, 6011,
     /* 418968 */   GIR_EraseRootFromParent_Done,
     /* 418969 */ // Label 8161: @418969
     /* 418969 */ GIM_Reject,
     /* 418970 */ // Label 8155: @418970
     /* 418970 */ GIM_Reject,
     /* 418971 */ // Label 122: @418971
     /* 418971 */ GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(419110),
     /* 418976 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 418979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 418983 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(419017), // Rule ID 257 //
     /* 418988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 418995 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 418995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 418998 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 419010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 419015 */     GIR_RootConstrainSelectedInstOperands,
     /* 419016 */     // GIR_Coverage, 257,
     /* 419016 */     GIR_EraseRootFromParent_Done,
     /* 419017 */   // Label 8163: @419017
     /* 419017 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(419051), // Rule ID 258 //
     /* 419022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 419029 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 419029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 419032 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 419044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 419049 */     GIR_RootConstrainSelectedInstOperands,
     /* 419050 */     // GIR_Coverage, 258,
     /* 419050 */     GIR_EraseRootFromParent_Done,
     /* 419051 */   // Label 8164: @419051
     /* 419051 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(419080), // Rule ID 273 //
     /* 419056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 419063 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 419063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 419066 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 419078 */     GIR_RootConstrainSelectedInstOperands,
     /* 419079 */     // GIR_Coverage, 273,
     /* 419079 */     GIR_EraseRootFromParent_Done,
     /* 419080 */   // Label 8165: @419080
     /* 419080 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(419109), // Rule ID 294 //
     /* 419085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 419092 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 419092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 419095 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 419107 */     GIR_RootConstrainSelectedInstOperands,
     /* 419108 */     // GIR_Coverage, 294,
     /* 419108 */     GIR_EraseRootFromParent_Done,
     /* 419109 */   // Label 8166: @419109
     /* 419109 */   GIM_Reject,
     /* 419110 */ // Label 8162: @419110
     /* 419110 */ GIM_Reject,
     /* 419111 */ // Label 123: @419111
     /* 419111 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8179*/ GIMT_Encode4(420098),
     /* 419122 */ /*GILLT_s64*//*Label 8167*/ GIMT_Encode4(419206), GIMT_Encode4(0),
     /* 419130 */ /*GILLT_v2s32*//*Label 8168*/ GIMT_Encode4(419244),
     /* 419134 */ /*GILLT_v2s64*//*Label 8169*/ GIMT_Encode4(419282),
     /* 419138 */ /*GILLT_v4s16*//*Label 8170*/ GIMT_Encode4(419320),
     /* 419142 */ /*GILLT_v4s32*//*Label 8171*/ GIMT_Encode4(419358),
     /* 419146 */ /*GILLT_v8s8*//*Label 8172*/ GIMT_Encode4(419396),
     /* 419150 */ /*GILLT_v8s16*//*Label 8173*/ GIMT_Encode4(419434),
     /* 419154 */ /*GILLT_v16s8*//*Label 8174*/ GIMT_Encode4(419472), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 419174 */ /*GILLT_nxv2s64*//*Label 8175*/ GIMT_Encode4(419510), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 419186 */ /*GILLT_nxv4s32*//*Label 8176*/ GIMT_Encode4(419657), GIMT_Encode4(0),
     /* 419194 */ /*GILLT_nxv8s16*//*Label 8177*/ GIMT_Encode4(419804), GIMT_Encode4(0),
     /* 419202 */ /*GILLT_nxv16s8*//*Label 8178*/ GIMT_Encode4(419951),
     /* 419206 */ // Label 8167: @419206
     /* 419206 */ GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(419243), // Rule ID 5081 //
     /* 419211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 419214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 419217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 419220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419232 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419236 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 419236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 419241 */   GIR_RootConstrainSelectedInstOperands,
     /* 419242 */   // GIR_Coverage, 5081,
     /* 419242 */   GIR_Done,
     /* 419243 */ // Label 8180: @419243
     /* 419243 */ GIM_Reject,
     /* 419244 */ // Label 8168: @419244
     /* 419244 */ GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(419281), // Rule ID 5080 //
     /* 419249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 419255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 419258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419270 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419274 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 419274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 419279 */   GIR_RootConstrainSelectedInstOperands,
     /* 419280 */   // GIR_Coverage, 5080,
     /* 419280 */   GIR_Done,
     /* 419281 */ // Label 8181: @419281
     /* 419281 */ GIM_Reject,
     /* 419282 */ // Label 8169: @419282
     /* 419282 */ GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(419319), // Rule ID 5085 //
     /* 419287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 419293 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 419296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419308 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419312 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 419312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 419317 */   GIR_RootConstrainSelectedInstOperands,
     /* 419318 */   // GIR_Coverage, 5085,
     /* 419318 */   GIR_Done,
     /* 419319 */ // Label 8182: @419319
     /* 419319 */ GIM_Reject,
     /* 419320 */ // Label 8170: @419320
     /* 419320 */ GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(419357), // Rule ID 5079 //
     /* 419325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 419331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 419334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419346 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419350 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 419350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 419355 */   GIR_RootConstrainSelectedInstOperands,
     /* 419356 */   // GIR_Coverage, 5079,
     /* 419356 */   GIR_Done,
     /* 419357 */ // Label 8183: @419357
     /* 419357 */ GIM_Reject,
     /* 419358 */ // Label 8171: @419358
     /* 419358 */ GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(419395), // Rule ID 5084 //
     /* 419363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 419369 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 419372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419384 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419388 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 419388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 419393 */   GIR_RootConstrainSelectedInstOperands,
     /* 419394 */   // GIR_Coverage, 5084,
     /* 419394 */   GIR_Done,
     /* 419395 */ // Label 8184: @419395
     /* 419395 */ GIM_Reject,
     /* 419396 */ // Label 8172: @419396
     /* 419396 */ GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(419433), // Rule ID 5078 //
     /* 419401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 419407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 419410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419422 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419426 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 419426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 419431 */   GIR_RootConstrainSelectedInstOperands,
     /* 419432 */   // GIR_Coverage, 5078,
     /* 419432 */   GIR_Done,
     /* 419433 */ // Label 8185: @419433
     /* 419433 */ GIM_Reject,
     /* 419434 */ // Label 8173: @419434
     /* 419434 */ GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(419471), // Rule ID 5083 //
     /* 419439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 419445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 419448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419460 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419464 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 419464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 419469 */   GIR_RootConstrainSelectedInstOperands,
     /* 419470 */   // GIR_Coverage, 5083,
     /* 419470 */   GIR_Done,
     /* 419471 */ // Label 8186: @419471
     /* 419471 */ GIM_Reject,
     /* 419472 */ // Label 8174: @419472
     /* 419472 */ GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(419509), // Rule ID 5082 //
     /* 419477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 419483 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 419486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419498 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419502 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 419502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 419507 */   GIR_RootConstrainSelectedInstOperands,
     /* 419508 */   // GIR_Coverage, 5082,
     /* 419508 */   GIR_Done,
     /* 419509 */ // Label 8187: @419509
     /* 419509 */ GIM_Reject,
     /* 419510 */ // Label 8175: @419510
     /* 419510 */ GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(419656),
     /* 419515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 419518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 419521 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 419524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 419528 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(419581), // Rule ID 11949 //
     /* 419533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 419540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 419548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 419552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419556 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419562 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419566 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 419566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 419569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 419575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419579 */     GIR_RootConstrainSelectedInstOperands,
     /* 419580 */     // GIR_Coverage, 11949,
     /* 419580 */     GIR_EraseRootFromParent_Done,
     /* 419581 */   // Label 8189: @419581
     /* 419581 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(419634), // Rule ID 11960 //
     /* 419586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 419593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 419601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 419605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419609 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419615 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419619 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 419619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 419622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 419630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419632 */     GIR_RootConstrainSelectedInstOperands,
     /* 419633 */     // GIR_Coverage, 11960,
     /* 419633 */     GIR_EraseRootFromParent_Done,
     /* 419634 */   // Label 8190: @419634
     /* 419634 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(419655), // Rule ID 11941 //
     /* 419639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419642 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 419642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 419645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419653 */     GIR_RootConstrainSelectedInstOperands,
     /* 419654 */     // GIR_Coverage, 11941,
     /* 419654 */     GIR_EraseRootFromParent_Done,
     /* 419655 */   // Label 8191: @419655
     /* 419655 */   GIM_Reject,
     /* 419656 */ // Label 8188: @419656
     /* 419656 */ GIM_Reject,
     /* 419657 */ // Label 8176: @419657
     /* 419657 */ GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(419803),
     /* 419662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 419665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 419668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 419671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 419675 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(419728), // Rule ID 11947 //
     /* 419680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 419687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 419695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 419699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419703 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419709 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419713 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 419713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 419716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 419722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419726 */     GIR_RootConstrainSelectedInstOperands,
     /* 419727 */     // GIR_Coverage, 11947,
     /* 419727 */     GIR_EraseRootFromParent_Done,
     /* 419728 */   // Label 8193: @419728
     /* 419728 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(419781), // Rule ID 11957 //
     /* 419733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 419740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 419748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 419752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419756 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419762 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419766 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 419766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 419769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 419777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419779 */     GIR_RootConstrainSelectedInstOperands,
     /* 419780 */     // GIR_Coverage, 11957,
     /* 419780 */     GIR_EraseRootFromParent_Done,
     /* 419781 */   // Label 8194: @419781
     /* 419781 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(419802), // Rule ID 11939 //
     /* 419786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419789 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 419789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 419792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419800 */     GIR_RootConstrainSelectedInstOperands,
     /* 419801 */     // GIR_Coverage, 11939,
     /* 419801 */     GIR_EraseRootFromParent_Done,
     /* 419802 */   // Label 8195: @419802
     /* 419802 */   GIM_Reject,
     /* 419803 */ // Label 8192: @419803
     /* 419803 */ GIM_Reject,
     /* 419804 */ // Label 8177: @419804
     /* 419804 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(419950),
     /* 419809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 419812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 419815 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 419818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 419822 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(419875), // Rule ID 11945 //
     /* 419827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 419834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 419842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 419846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419850 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419856 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419860 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 419860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 419863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 419869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419873 */     GIR_RootConstrainSelectedInstOperands,
     /* 419874 */     // GIR_Coverage, 11945,
     /* 419874 */     GIR_EraseRootFromParent_Done,
     /* 419875 */   // Label 8197: @419875
     /* 419875 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(419928), // Rule ID 11954 //
     /* 419880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 419887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 419895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 419899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419903 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419913 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 419913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 419916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 419924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419926 */     GIR_RootConstrainSelectedInstOperands,
     /* 419927 */     // GIR_Coverage, 11954,
     /* 419927 */     GIR_EraseRootFromParent_Done,
     /* 419928 */   // Label 8198: @419928
     /* 419928 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(419949), // Rule ID 11937 //
     /* 419933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419936 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 419936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 419939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419947 */     GIR_RootConstrainSelectedInstOperands,
     /* 419948 */     // GIR_Coverage, 11937,
     /* 419948 */     GIR_EraseRootFromParent_Done,
     /* 419949 */   // Label 8199: @419949
     /* 419949 */   GIM_Reject,
     /* 419950 */ // Label 8196: @419950
     /* 419950 */ GIM_Reject,
     /* 419951 */ // Label 8178: @419951
     /* 419951 */ GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(420097),
     /* 419956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 419959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 419962 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 419965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 419969 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(420022), // Rule ID 11943 //
     /* 419974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 419981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 419989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 419993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419997 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420003 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420007 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 420010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 420016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420020 */     GIR_RootConstrainSelectedInstOperands,
     /* 420021 */     // GIR_Coverage, 11943,
     /* 420021 */     GIR_EraseRootFromParent_Done,
     /* 420022 */   // Label 8201: @420022
     /* 420022 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(420075), // Rule ID 11951 //
     /* 420027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 420034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 420042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 420046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420050 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420060 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 420063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 420071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420073 */     GIR_RootConstrainSelectedInstOperands,
     /* 420074 */     // GIR_Coverage, 11951,
     /* 420074 */     GIR_EraseRootFromParent_Done,
     /* 420075 */   // Label 8202: @420075
     /* 420075 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(420096), // Rule ID 11935 //
     /* 420080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420083 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 420086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420094 */     GIR_RootConstrainSelectedInstOperands,
     /* 420095 */     // GIR_Coverage, 11935,
     /* 420095 */     GIR_EraseRootFromParent_Done,
     /* 420096 */   // Label 8203: @420096
     /* 420096 */   GIM_Reject,
     /* 420097 */ // Label 8200: @420097
     /* 420097 */ GIM_Reject,
     /* 420098 */ // Label 8179: @420098
     /* 420098 */ GIM_Reject,
     /* 420099 */ // Label 124: @420099
     /* 420099 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8212*/ GIMT_Encode4(422081),
     /* 420110 */ /*GILLT_s64*//*Label 8204*/ GIMT_Encode4(420146), GIMT_Encode4(0),
     /* 420118 */ /*GILLT_v2s32*//*Label 8205*/ GIMT_Encode4(420341),
     /* 420122 */ /*GILLT_v2s64*//*Label 8206*/ GIMT_Encode4(420588),
     /* 420126 */ /*GILLT_v4s16*//*Label 8207*/ GIMT_Encode4(420835),
     /* 420130 */ /*GILLT_v4s32*//*Label 8208*/ GIMT_Encode4(421111),
     /* 420134 */ /*GILLT_v8s8*//*Label 8209*/ GIMT_Encode4(421358),
     /* 420138 */ /*GILLT_v8s16*//*Label 8210*/ GIMT_Encode4(421583),
     /* 420142 */ /*GILLT_v16s8*//*Label 8211*/ GIMT_Encode4(421859),
     /* 420146 */ // Label 8204: @420146
     /* 420146 */ GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(420340),
     /* 420151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 420154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420158 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(420205), // Rule ID 6451 //
     /* 420163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420171 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420178 */     // MIs[1] Rn
     /* 420178 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420189 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 420192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420203 */     GIR_RootConstrainSelectedInstOperands,
     /* 420204 */     // GIR_Coverage, 6451,
     /* 420204 */     GIR_EraseRootFromParent_Done,
     /* 420205 */   // Label 8214: @420205
     /* 420205 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(420252), // Rule ID 6462 //
     /* 420210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420218 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420225 */     // MIs[1] Rn
     /* 420225 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420236 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 420239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420250 */     GIR_RootConstrainSelectedInstOperands,
     /* 420251 */     // GIR_Coverage, 6462,
     /* 420251 */     GIR_EraseRootFromParent_Done,
     /* 420252 */   // Label 8215: @420252
     /* 420252 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(420299), // Rule ID 13278 //
     /* 420257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420272 */     // MIs[1] Rn
     /* 420272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420283 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 420286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420297 */     GIR_RootConstrainSelectedInstOperands,
     /* 420298 */     // GIR_Coverage, 13278,
     /* 420298 */     GIR_EraseRootFromParent_Done,
     /* 420299 */   // Label 8216: @420299
     /* 420299 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(420319), // Rule ID 5644 //
     /* 420304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 420308 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 420308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420318 */     // GIR_Coverage, 5644,
     /* 420318 */     GIR_Done,
     /* 420319 */   // Label 8217: @420319
     /* 420319 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(420339), // Rule ID 5645 //
     /* 420324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420328 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 420328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420338 */     // GIR_Coverage, 5645,
     /* 420338 */     GIR_Done,
     /* 420339 */   // Label 8218: @420339
     /* 420339 */   GIM_Reject,
     /* 420340 */ // Label 8213: @420340
     /* 420340 */ GIM_Reject,
     /* 420341 */ // Label 8205: @420341
     /* 420341 */ GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(420587),
     /* 420346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 420349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420353 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(420400), // Rule ID 6448 //
     /* 420358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420373 */     // MIs[1] Rn
     /* 420373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420384 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 420387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420398 */     GIR_RootConstrainSelectedInstOperands,
     /* 420399 */     // GIR_Coverage, 6448,
     /* 420399 */     GIR_EraseRootFromParent_Done,
     /* 420400 */   // Label 8220: @420400
     /* 420400 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(420447), // Rule ID 6459 //
     /* 420405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420413 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420420 */     // MIs[1] Rn
     /* 420420 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420431 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 420434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420445 */     GIR_RootConstrainSelectedInstOperands,
     /* 420446 */     // GIR_Coverage, 6459,
     /* 420446 */     GIR_EraseRootFromParent_Done,
     /* 420447 */   // Label 8221: @420447
     /* 420447 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(420494), // Rule ID 13275 //
     /* 420452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420467 */     // MIs[1] Rn
     /* 420467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420478 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 420481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420492 */     GIR_RootConstrainSelectedInstOperands,
     /* 420493 */     // GIR_Coverage, 13275,
     /* 420493 */     GIR_EraseRootFromParent_Done,
     /* 420494 */   // Label 8222: @420494
     /* 420494 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(420513), // Rule ID 1916 //
     /* 420499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 420502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 420506 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 420506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 420511 */     GIR_RootConstrainSelectedInstOperands,
     /* 420512 */     // GIR_Coverage, 1916,
     /* 420512 */     GIR_Done,
     /* 420513 */   // Label 8223: @420513
     /* 420513 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(420586), // Rule ID 5646 //
     /* 420518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420522 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 420522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 420525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 420529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 420536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 420539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 420543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 420551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 420558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 420576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 420581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420584 */     GIR_RootConstrainSelectedInstOperands,
     /* 420585 */     // GIR_Coverage, 5646,
     /* 420585 */     GIR_EraseRootFromParent_Done,
     /* 420586 */   // Label 8224: @420586
     /* 420586 */   GIM_Reject,
     /* 420587 */ // Label 8219: @420587
     /* 420587 */ GIM_Reject,
     /* 420588 */ // Label 8206: @420588
     /* 420588 */ GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(420834),
     /* 420593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 420596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420600 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(420647), // Rule ID 6450 //
     /* 420605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420613 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420620 */     // MIs[1] Rn
     /* 420620 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420631 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 420634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420645 */     GIR_RootConstrainSelectedInstOperands,
     /* 420646 */     // GIR_Coverage, 6450,
     /* 420646 */     GIR_EraseRootFromParent_Done,
     /* 420647 */   // Label 8226: @420647
     /* 420647 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(420694), // Rule ID 6461 //
     /* 420652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420660 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420667 */     // MIs[1] Rn
     /* 420667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420678 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 420681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420692 */     GIR_RootConstrainSelectedInstOperands,
     /* 420693 */     // GIR_Coverage, 6461,
     /* 420693 */     GIR_EraseRootFromParent_Done,
     /* 420694 */   // Label 8227: @420694
     /* 420694 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(420741), // Rule ID 13277 //
     /* 420699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420707 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420710 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420714 */     // MIs[1] Rn
     /* 420714 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420725 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 420728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420739 */     GIR_RootConstrainSelectedInstOperands,
     /* 420740 */     // GIR_Coverage, 13277,
     /* 420740 */     GIR_EraseRootFromParent_Done,
     /* 420741 */   // Label 8228: @420741
     /* 420741 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(420760), // Rule ID 1918 //
     /* 420746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 420749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 420753 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 420753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 420758 */     GIR_RootConstrainSelectedInstOperands,
     /* 420759 */     // GIR_Coverage, 1918,
     /* 420759 */     GIR_Done,
     /* 420760 */   // Label 8229: @420760
     /* 420760 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(420833), // Rule ID 5648 //
     /* 420765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420769 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 420769 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 420772 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 420776 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 420783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 420786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 420790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420795 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 420798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420802 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 420805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 420823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 420828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420831 */     GIR_RootConstrainSelectedInstOperands,
     /* 420832 */     // GIR_Coverage, 5648,
     /* 420832 */     GIR_EraseRootFromParent_Done,
     /* 420833 */   // Label 8230: @420833
     /* 420833 */   GIM_Reject,
     /* 420834 */ // Label 8225: @420834
     /* 420834 */ GIM_Reject,
     /* 420835 */ // Label 8207: @420835
     /* 420835 */ GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(420896), // Rule ID 6446 //
     /* 420840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 420843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420855 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420858 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420862 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 420869 */   // MIs[1] Rn
     /* 420869 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420873 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420878 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420880 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 420883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420885 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420894 */   GIR_RootConstrainSelectedInstOperands,
     /* 420895 */   // GIR_Coverage, 6446,
     /* 420895 */   GIR_EraseRootFromParent_Done,
     /* 420896 */ // Label 8231: @420896
     /* 420896 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(420950), // Rule ID 6463 //
     /* 420901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 420904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420916 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420919 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420923 */   // MIs[1] Rn
     /* 420923 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420927 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420932 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420934 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 420937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420939 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420943 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420948 */   GIR_RootConstrainSelectedInstOperands,
     /* 420949 */   // GIR_Coverage, 6463,
     /* 420949 */   GIR_EraseRootFromParent_Done,
     /* 420950 */ // Label 8232: @420950
     /* 420950 */ GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(421004), // Rule ID 13273 //
     /* 420955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 420958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420962 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420966 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420970 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420973 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420977 */   // MIs[1] Rn
     /* 420977 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420981 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420986 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420988 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 420991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420993 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421002 */   GIR_RootConstrainSelectedInstOperands,
     /* 421003 */   // GIR_Coverage, 13273,
     /* 421003 */   GIR_EraseRootFromParent_Done,
     /* 421004 */ // Label 8233: @421004
     /* 421004 */ GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(421030), // Rule ID 1914 //
     /* 421009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421023 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 421023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 421028 */   GIR_RootConstrainSelectedInstOperands,
     /* 421029 */   // GIR_Coverage, 1914,
     /* 421029 */   GIR_Done,
     /* 421030 */ // Label 8234: @421030
     /* 421030 */ GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(421110), // Rule ID 5649 //
     /* 421035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421046 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421046 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 421049 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421053 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 421063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421072 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421075 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421079 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 421082 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421087 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421092 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 421100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421108 */   GIR_RootConstrainSelectedInstOperands,
     /* 421109 */   // GIR_Coverage, 5649,
     /* 421109 */   GIR_EraseRootFromParent_Done,
     /* 421110 */ // Label 8235: @421110
     /* 421110 */ GIM_Reject,
     /* 421111 */ // Label 8208: @421111
     /* 421111 */ GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(421357),
     /* 421116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421123 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(421170), // Rule ID 6449 //
     /* 421128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421136 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421139 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421143 */     // MIs[1] Rn
     /* 421143 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421154 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 421157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421168 */     GIR_RootConstrainSelectedInstOperands,
     /* 421169 */     // GIR_Coverage, 6449,
     /* 421169 */     GIR_EraseRootFromParent_Done,
     /* 421170 */   // Label 8237: @421170
     /* 421170 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(421217), // Rule ID 6460 //
     /* 421175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421190 */     // MIs[1] Rn
     /* 421190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421201 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 421204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421215 */     GIR_RootConstrainSelectedInstOperands,
     /* 421216 */     // GIR_Coverage, 6460,
     /* 421216 */     GIR_EraseRootFromParent_Done,
     /* 421217 */   // Label 8238: @421217
     /* 421217 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(421264), // Rule ID 13276 //
     /* 421222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421237 */     // MIs[1] Rn
     /* 421237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421248 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 421251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421262 */     GIR_RootConstrainSelectedInstOperands,
     /* 421263 */     // GIR_Coverage, 13276,
     /* 421263 */     GIR_EraseRootFromParent_Done,
     /* 421264 */   // Label 8239: @421264
     /* 421264 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(421283), // Rule ID 1917 //
     /* 421269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421276 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 421276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 421281 */     GIR_RootConstrainSelectedInstOperands,
     /* 421282 */     // GIR_Coverage, 1917,
     /* 421282 */     GIR_Done,
     /* 421283 */   // Label 8240: @421283
     /* 421283 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(421356), // Rule ID 5647 //
     /* 421288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421292 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421292 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 421295 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421299 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 421309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421318 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421325 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 421328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 421346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421354 */     GIR_RootConstrainSelectedInstOperands,
     /* 421355 */     // GIR_Coverage, 5647,
     /* 421355 */     GIR_EraseRootFromParent_Done,
     /* 421356 */   // Label 8241: @421356
     /* 421356 */   GIM_Reject,
     /* 421357 */ // Label 8236: @421357
     /* 421357 */ GIM_Reject,
     /* 421358 */ // Label 8209: @421358
     /* 421358 */ GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(421415), // Rule ID 13271 //
     /* 421363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 421366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421378 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421385 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 421389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421391 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 421398 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 421401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 421408 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421413 */   GIR_RootConstrainSelectedInstOperands,
     /* 421414 */   // GIR_Coverage, 13271,
     /* 421414 */   GIR_EraseRootFromParent_Done,
     /* 421415 */ // Label 8242: @421415
     /* 421415 */ GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(421476), // Rule ID 6444 //
     /* 421420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421427 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421431 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421435 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421438 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421442 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 421449 */   // MIs[1] Rn
     /* 421449 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421453 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421458 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421460 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 421463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421465 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421474 */   GIR_RootConstrainSelectedInstOperands,
     /* 421475 */   // GIR_Coverage, 6444,
     /* 421475 */   GIR_EraseRootFromParent_Done,
     /* 421476 */ // Label 8243: @421476
     /* 421476 */ GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(421502), // Rule ID 1912 //
     /* 421481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421495 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 421495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 421500 */   GIR_RootConstrainSelectedInstOperands,
     /* 421501 */   // GIR_Coverage, 1912,
     /* 421501 */   GIR_Done,
     /* 421502 */ // Label 8244: @421502
     /* 421502 */ GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(421582), // Rule ID 5651 //
     /* 421507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 421510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421518 */   // (AArch64dup:{ *:[v8i8] } FPR8:{ *:[i8] }:$Rn)  =>  (DUPv8i8lane:{ *:[v8i8] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rn, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421518 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 421521 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421525 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 421535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421544 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421547 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421551 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 421554 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421559 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421564 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 421572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421580 */   GIR_RootConstrainSelectedInstOperands,
     /* 421581 */   // GIR_Coverage, 5651,
     /* 421581 */   GIR_EraseRootFromParent_Done,
     /* 421582 */ // Label 8245: @421582
     /* 421582 */ GIM_Reject,
     /* 421583 */ // Label 8210: @421583
     /* 421583 */ GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(421644), // Rule ID 6447 //
     /* 421588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421595 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421603 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421606 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421610 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 421617 */   // MIs[1] Rn
     /* 421617 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421621 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421628 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 421631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421633 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421642 */   GIR_RootConstrainSelectedInstOperands,
     /* 421643 */   // GIR_Coverage, 6447,
     /* 421643 */   GIR_EraseRootFromParent_Done,
     /* 421644 */ // Label 8246: @421644
     /* 421644 */ GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(421698), // Rule ID 6464 //
     /* 421649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421664 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421671 */   // MIs[1] Rn
     /* 421671 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421675 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421680 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421682 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 421685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421687 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421696 */   GIR_RootConstrainSelectedInstOperands,
     /* 421697 */   // GIR_Coverage, 6464,
     /* 421697 */   GIR_EraseRootFromParent_Done,
     /* 421698 */ // Label 8247: @421698
     /* 421698 */ GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(421752), // Rule ID 13274 //
     /* 421703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421710 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421718 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421721 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421725 */   // MIs[1] Rn
     /* 421725 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421729 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421734 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421736 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 421739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421741 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421750 */   GIR_RootConstrainSelectedInstOperands,
     /* 421751 */   // GIR_Coverage, 13274,
     /* 421751 */   GIR_EraseRootFromParent_Done,
     /* 421752 */ // Label 8248: @421752
     /* 421752 */ GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(421778), // Rule ID 1915 //
     /* 421757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421771 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 421771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 421776 */   GIR_RootConstrainSelectedInstOperands,
     /* 421777 */   // GIR_Coverage, 1915,
     /* 421777 */   GIR_Done,
     /* 421778 */ // Label 8249: @421778
     /* 421778 */ GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(421858), // Rule ID 5650 //
     /* 421783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421794 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421794 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 421797 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421801 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421808 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 421811 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421815 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421820 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421827 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 421830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 421848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421856 */   GIR_RootConstrainSelectedInstOperands,
     /* 421857 */   // GIR_Coverage, 5650,
     /* 421857 */   GIR_EraseRootFromParent_Done,
     /* 421858 */ // Label 8250: @421858
     /* 421858 */ GIM_Reject,
     /* 421859 */ // Label 8211: @421859
     /* 421859 */ GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(421920), // Rule ID 6445 //
     /* 421864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421879 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421882 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421886 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 421893 */   // MIs[1] Rn
     /* 421893 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421897 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421902 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421904 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 421907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421909 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421918 */   GIR_RootConstrainSelectedInstOperands,
     /* 421919 */   // GIR_Coverage, 6445,
     /* 421919 */   GIR_EraseRootFromParent_Done,
     /* 421920 */ // Label 8251: @421920
     /* 421920 */ GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(421974), // Rule ID 13272 //
     /* 421925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 421928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421932 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421940 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421943 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421947 */   // MIs[1] Rn
     /* 421947 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421951 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421956 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421958 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 421961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421963 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421972 */   GIR_RootConstrainSelectedInstOperands,
     /* 421973 */   // GIR_Coverage, 13272,
     /* 421973 */   GIR_EraseRootFromParent_Done,
     /* 421974 */ // Label 8252: @421974
     /* 421974 */ GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(422000), // Rule ID 1913 //
     /* 421979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421993 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 421993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 421998 */   GIR_RootConstrainSelectedInstOperands,
     /* 421999 */   // GIR_Coverage, 1913,
     /* 421999 */   GIR_Done,
     /* 422000 */ // Label 8253: @422000
     /* 422000 */ GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(422080), // Rule ID 5652 //
     /* 422005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 422008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 422016 */   // (AArch64dup:{ *:[v16i8] } FPR8:{ *:[i8] }:$Rn)  =>  (DUPv16i8lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rn, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422016 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 422019 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422023 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422030 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 422033 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422037 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422042 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422045 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422049 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 422052 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422062 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 422067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 422070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422078 */   GIR_RootConstrainSelectedInstOperands,
     /* 422079 */   // GIR_Coverage, 5652,
     /* 422079 */   GIR_EraseRootFromParent_Done,
     /* 422080 */ // Label 8254: @422080
     /* 422080 */ GIM_Reject,
     /* 422081 */ // Label 8212: @422081
     /* 422081 */ GIM_Reject,
     /* 422082 */ // Label 125: @422082
     /* 422082 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8257*/ GIMT_Encode4(422336),
     /* 422093 */ /*GILLT_v4s16*//*Label 8255*/ GIMT_Encode4(422109), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 422105 */ /*GILLT_v8s16*//*Label 8256*/ GIMT_Encode4(422195),
     /* 422109 */ // Label 8255: @422109
     /* 422109 */ GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(422194),
     /* 422114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 422117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422128 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(422162), // Rule ID 1922 //
     /* 422133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422148 */     // MIs[1] Operand 1
     /* 422148 */     // No operand predicates
     /* 422148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422150 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422160 */     GIR_RootConstrainSelectedInstOperands,
     /* 422161 */     // GIR_Coverage, 1922,
     /* 422161 */     GIR_EraseRootFromParent_Done,
     /* 422162 */   // Label 8259: @422162
     /* 422162 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(422193), // Rule ID 5653 //
     /* 422167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422179 */     // MIs[1] Operand 1
     /* 422179 */     // No operand predicates
     /* 422179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422181 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 422181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422191 */     GIR_RootConstrainSelectedInstOperands,
     /* 422192 */     // GIR_Coverage, 5653,
     /* 422192 */     GIR_EraseRootFromParent_Done,
     /* 422193 */   // Label 8260: @422193
     /* 422193 */   GIM_Reject,
     /* 422194 */ // Label 8258: @422194
     /* 422194 */ GIM_Reject,
     /* 422195 */ // Label 8256: @422195
     /* 422195 */ GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(422335),
     /* 422200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 422203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422210 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(422261), // Rule ID 6455 //
     /* 422215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422230 */     // MIs[1] Rn
     /* 422230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 422243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422245 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 422248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422259 */     GIR_RootConstrainSelectedInstOperands,
     /* 422260 */     // GIR_Coverage, 6455,
     /* 422260 */     GIR_EraseRootFromParent_Done,
     /* 422261 */   // Label 8262: @422261
     /* 422261 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(422299), // Rule ID 1923 //
     /* 422266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422285 */     // MIs[1] Operand 1
     /* 422285 */     // No operand predicates
     /* 422285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422287 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 422290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422297 */     GIR_RootConstrainSelectedInstOperands,
     /* 422298 */     // GIR_Coverage, 1923,
     /* 422298 */     GIR_EraseRootFromParent_Done,
     /* 422299 */   // Label 8263: @422299
     /* 422299 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(422334), // Rule ID 5654 //
     /* 422304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422320 */     // MIs[1] Operand 1
     /* 422320 */     // No operand predicates
     /* 422320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422322 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 422322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 422325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422332 */     GIR_RootConstrainSelectedInstOperands,
     /* 422333 */     // GIR_Coverage, 5654,
     /* 422333 */     GIR_EraseRootFromParent_Done,
     /* 422334 */   // Label 8264: @422334
     /* 422334 */   GIM_Reject,
     /* 422335 */ // Label 8261: @422335
     /* 422335 */ GIM_Reject,
     /* 422336 */ // Label 8257: @422336
     /* 422336 */ GIM_Reject,
     /* 422337 */ // Label 126: @422337
     /* 422337 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8267*/ GIMT_Encode4(422591),
     /* 422348 */ /*GILLT_v2s32*//*Label 8265*/ GIMT_Encode4(422364), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 422360 */ /*GILLT_v4s32*//*Label 8266*/ GIMT_Encode4(422450),
     /* 422364 */ // Label 8265: @422364
     /* 422364 */ GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(422449),
     /* 422369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 422372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422383 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(422417), // Rule ID 1920 //
     /* 422388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 422403 */     // MIs[1] Operand 1
     /* 422403 */     // No operand predicates
     /* 422403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422405 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 422408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422415 */     GIR_RootConstrainSelectedInstOperands,
     /* 422416 */     // GIR_Coverage, 1920,
     /* 422416 */     GIR_EraseRootFromParent_Done,
     /* 422417 */   // Label 8269: @422417
     /* 422417 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(422448), // Rule ID 5655 //
     /* 422422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 422434 */     // MIs[1] Operand 1
     /* 422434 */     // No operand predicates
     /* 422434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422436 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 422436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 422439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422446 */     GIR_RootConstrainSelectedInstOperands,
     /* 422447 */     // GIR_Coverage, 5655,
     /* 422447 */     GIR_EraseRootFromParent_Done,
     /* 422448 */   // Label 8270: @422448
     /* 422448 */   GIM_Reject,
     /* 422449 */ // Label 8268: @422449
     /* 422449 */ GIM_Reject,
     /* 422450 */ // Label 8266: @422450
     /* 422450 */ GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(422590),
     /* 422455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 422458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422465 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(422516), // Rule ID 6457 //
     /* 422470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422481 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422485 */     // MIs[1] Rn
     /* 422485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 422498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422500 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422514 */     GIR_RootConstrainSelectedInstOperands,
     /* 422515 */     // GIR_Coverage, 6457,
     /* 422515 */     GIR_EraseRootFromParent_Done,
     /* 422516 */   // Label 8272: @422516
     /* 422516 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(422554), // Rule ID 1921 //
     /* 422521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 422540 */     // MIs[1] Operand 1
     /* 422540 */     // No operand predicates
     /* 422540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422542 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 422545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422552 */     GIR_RootConstrainSelectedInstOperands,
     /* 422553 */     // GIR_Coverage, 1921,
     /* 422553 */     GIR_EraseRootFromParent_Done,
     /* 422554 */   // Label 8273: @422554
     /* 422554 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(422589), // Rule ID 5656 //
     /* 422559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 422575 */     // MIs[1] Operand 1
     /* 422575 */     // No operand predicates
     /* 422575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422577 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 422577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 422580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422587 */     GIR_RootConstrainSelectedInstOperands,
     /* 422588 */     // GIR_Coverage, 5656,
     /* 422588 */     GIR_EraseRootFromParent_Done,
     /* 422589 */   // Label 8274: @422589
     /* 422589 */   GIM_Reject,
     /* 422590 */ // Label 8271: @422590
     /* 422590 */ GIM_Reject,
     /* 422591 */ // Label 8267: @422591
     /* 422591 */ GIM_Reject,
     /* 422592 */ // Label 127: @422592
     /* 422592 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(422737),
     /* 422597 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 422600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 422603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422610 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(422661), // Rule ID 6458 //
     /* 422615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422623 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422630 */     // MIs[1] Rn
     /* 422630 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 422643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422645 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 422648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422659 */     GIR_RootConstrainSelectedInstOperands,
     /* 422660 */     // GIR_Coverage, 6458,
     /* 422660 */     GIR_EraseRootFromParent_Done,
     /* 422661 */   // Label 8276: @422661
     /* 422661 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(422736),
     /* 422666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422670 */     GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(422704), // Rule ID 1919 //
     /* 422675 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422678 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422682 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422686 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 422690 */       // MIs[1] Operand 1
     /* 422690 */       // No operand predicates
     /* 422690 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422692 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422692 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 422695 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422697 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422699 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422702 */       GIR_RootConstrainSelectedInstOperands,
     /* 422703 */       // GIR_Coverage, 1919,
     /* 422703 */       GIR_EraseRootFromParent_Done,
     /* 422704 */     // Label 8278: @422704
     /* 422704 */     GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(422735), // Rule ID 5657 //
     /* 422709 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422713 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422717 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 422721 */       // MIs[1] Operand 1
     /* 422721 */       // No operand predicates
     /* 422721 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422723 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 422723 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 422726 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422728 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422730 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422733 */       GIR_RootConstrainSelectedInstOperands,
     /* 422734 */       // GIR_Coverage, 5657,
     /* 422734 */       GIR_EraseRootFromParent_Done,
     /* 422735 */     // Label 8279: @422735
     /* 422735 */     GIM_Reject,
     /* 422736 */   // Label 8277: @422736
     /* 422736 */   GIM_Reject,
     /* 422737 */ // Label 8275: @422737
     /* 422737 */ GIM_Reject,
     /* 422738 */ // Label 128: @422738
     /* 422738 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8282*/ GIMT_Encode4(422916),
     /* 422749 */ /*GILLT_v8s8*//*Label 8280*/ GIMT_Encode4(422761), GIMT_Encode4(0),
     /* 422757 */ /*GILLT_v16s8*//*Label 8281*/ GIMT_Encode4(422810),
     /* 422761 */ // Label 8280: @422761
     /* 422761 */ GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(422809), // Rule ID 1924 //
     /* 422766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 422772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422783 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422791 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 422795 */   // MIs[1] Operand 1
     /* 422795 */   // No operand predicates
     /* 422795 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422797 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 422800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422802 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422804 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422807 */   GIR_RootConstrainSelectedInstOperands,
     /* 422808 */   // GIR_Coverage, 1924,
     /* 422808 */   GIR_EraseRootFromParent_Done,
     /* 422809 */ // Label 8283: @422809
     /* 422809 */ GIM_Reject,
     /* 422810 */ // Label 8281: @422810
     /* 422810 */ GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(422915),
     /* 422815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 422818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422825 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(422876), // Rule ID 6453 //
     /* 422830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422838 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422841 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422845 */     // MIs[1] Rn
     /* 422845 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 422858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422860 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 422863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422874 */     GIR_RootConstrainSelectedInstOperands,
     /* 422875 */     // GIR_Coverage, 6453,
     /* 422875 */     GIR_EraseRootFromParent_Done,
     /* 422876 */   // Label 8285: @422876
     /* 422876 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(422914), // Rule ID 1925 //
     /* 422881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 422900 */     // MIs[1] Operand 1
     /* 422900 */     // No operand predicates
     /* 422900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422902 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 422905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422912 */     GIR_RootConstrainSelectedInstOperands,
     /* 422913 */     // GIR_Coverage, 1925,
     /* 422913 */     GIR_EraseRootFromParent_Done,
     /* 422914 */   // Label 8286: @422914
     /* 422914 */   GIM_Reject,
     /* 422915 */ // Label 8284: @422915
     /* 422915 */ GIM_Reject,
     /* 422916 */ // Label 8282: @422916
     /* 422916 */ GIM_Reject,
     /* 422917 */ // Label 129: @422917
     /* 422917 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8296*/ GIMT_Encode4(424566),
     /* 422928 */ /*GILLT_s64*//*Label 8287*/ GIMT_Encode4(423012), GIMT_Encode4(0),
     /* 422936 */ /*GILLT_v2s32*//*Label 8288*/ GIMT_Encode4(423333),
     /* 422940 */ /*GILLT_v2s64*//*Label 8289*/ GIMT_Encode4(423654),
     /* 422944 */ /*GILLT_v4s16*//*Label 8290*/ GIMT_Encode4(423737),
     /* 422948 */ /*GILLT_v4s32*//*Label 8291*/ GIMT_Encode4(424058),
     /* 422952 */ /*GILLT_v8s8*//*Label 8292*/ GIMT_Encode4(424141),
     /* 422956 */ /*GILLT_v8s16*//*Label 8293*/ GIMT_Encode4(424350),
     /* 422960 */ /*GILLT_v16s8*//*Label 8294*/ GIMT_Encode4(424433), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 423008 */ /*GILLT_nxv16s8*//*Label 8295*/ GIMT_Encode4(424519),
     /* 423012 */ // Label 8287: @423012
     /* 423012 */ GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(423332),
     /* 423017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 423020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423027 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(423142), // Rule ID 5472 //
     /* 423032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423049 */     // MIs[1] Operand 2
     /* 423049 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423068 */     // MIs[2] Rn
     /* 423068 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423073 */     // MIs[2] Operand 2
     /* 423073 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 423084 */     // MIs[0] imm
     /* 423084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423092 */     // MIs[3] Operand 1
     /* 423092 */     // No operand predicates
     /* 423092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423094 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423124 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423141 */     // GIR_Coverage, 5472,
     /* 423141 */     GIR_EraseRootFromParent_Done,
     /* 423142 */   // Label 8298: @423142
     /* 423142 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(423257), // Rule ID 5477 //
     /* 423147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423164 */     // MIs[1] Operand 2
     /* 423164 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423183 */     // MIs[2] Rn
     /* 423183 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423188 */     // MIs[2] Operand 2
     /* 423188 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 423199 */     // MIs[0] imm
     /* 423199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423207 */     // MIs[3] Operand 1
     /* 423207 */     // No operand predicates
     /* 423207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423209 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423239 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423256 */     // GIR_Coverage, 5477,
     /* 423256 */     GIR_EraseRootFromParent_Done,
     /* 423257 */   // Label 8299: @423257
     /* 423257 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(423294), // Rule ID 5469 //
     /* 423262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423270 */     // MIs[0] imm
     /* 423270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423278 */     // MIs[1] Operand 1
     /* 423278 */     // No operand predicates
     /* 423278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423280 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423292 */     GIR_RootConstrainSelectedInstOperands,
     /* 423293 */     // GIR_Coverage, 5469,
     /* 423293 */     GIR_EraseRootFromParent_Done,
     /* 423294 */   // Label 8300: @423294
     /* 423294 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(423331), // Rule ID 5474 //
     /* 423299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423307 */     // MIs[0] imm
     /* 423307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423315 */     // MIs[1] Operand 1
     /* 423315 */     // No operand predicates
     /* 423315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423317 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423329 */     GIR_RootConstrainSelectedInstOperands,
     /* 423330 */     // GIR_Coverage, 5474,
     /* 423330 */     GIR_EraseRootFromParent_Done,
     /* 423331 */   // Label 8301: @423331
     /* 423331 */   GIM_Reject,
     /* 423332 */ // Label 8297: @423332
     /* 423332 */ GIM_Reject,
     /* 423333 */ // Label 8288: @423333
     /* 423333 */ GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(423653),
     /* 423338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 423341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 423344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423348 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(423463), // Rule ID 5462 //
     /* 423353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 423365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423370 */     // MIs[1] Operand 2
     /* 423370 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423389 */     // MIs[2] Rn
     /* 423389 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423394 */     // MIs[2] Operand 2
     /* 423394 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 423405 */     // MIs[0] imm
     /* 423405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423413 */     // MIs[3] Operand 1
     /* 423413 */     // No operand predicates
     /* 423413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423415 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423431 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423445 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423462 */     // GIR_Coverage, 5462,
     /* 423462 */     GIR_EraseRootFromParent_Done,
     /* 423463 */   // Label 8303: @423463
     /* 423463 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(423578), // Rule ID 5467 //
     /* 423468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 423480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423485 */     // MIs[1] Operand 2
     /* 423485 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423504 */     // MIs[2] Rn
     /* 423504 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423509 */     // MIs[2] Operand 2
     /* 423509 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 423520 */     // MIs[0] imm
     /* 423520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423528 */     // MIs[3] Operand 1
     /* 423528 */     // No operand predicates
     /* 423528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423530 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423560 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423577 */     // GIR_Coverage, 5467,
     /* 423577 */     GIR_EraseRootFromParent_Done,
     /* 423578 */   // Label 8304: @423578
     /* 423578 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(423615), // Rule ID 5459 //
     /* 423583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423591 */     // MIs[0] imm
     /* 423591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423599 */     // MIs[1] Operand 1
     /* 423599 */     // No operand predicates
     /* 423599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423601 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423613 */     GIR_RootConstrainSelectedInstOperands,
     /* 423614 */     // GIR_Coverage, 5459,
     /* 423614 */     GIR_EraseRootFromParent_Done,
     /* 423615 */   // Label 8305: @423615
     /* 423615 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(423652), // Rule ID 5464 //
     /* 423620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423628 */     // MIs[0] imm
     /* 423628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423636 */     // MIs[1] Operand 1
     /* 423636 */     // No operand predicates
     /* 423636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423638 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423650 */     GIR_RootConstrainSelectedInstOperands,
     /* 423651 */     // GIR_Coverage, 5464,
     /* 423651 */     GIR_EraseRootFromParent_Done,
     /* 423652 */   // Label 8306: @423652
     /* 423652 */   GIM_Reject,
     /* 423653 */ // Label 8302: @423653
     /* 423653 */ GIM_Reject,
     /* 423654 */ // Label 8289: @423654
     /* 423654 */ GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(423736),
     /* 423659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 423665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423677 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(423706), // Rule ID 5470 //
     /* 423682 */     // MIs[0] imm
     /* 423682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423690 */     // MIs[1] Operand 1
     /* 423690 */     // No operand predicates
     /* 423690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423692 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423704 */     GIR_RootConstrainSelectedInstOperands,
     /* 423705 */     // GIR_Coverage, 5470,
     /* 423705 */     GIR_EraseRootFromParent_Done,
     /* 423706 */   // Label 8308: @423706
     /* 423706 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(423735), // Rule ID 5475 //
     /* 423711 */     // MIs[0] imm
     /* 423711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423719 */     // MIs[1] Operand 1
     /* 423719 */     // No operand predicates
     /* 423719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423721 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423733 */     GIR_RootConstrainSelectedInstOperands,
     /* 423734 */     // GIR_Coverage, 5475,
     /* 423734 */     GIR_EraseRootFromParent_Done,
     /* 423735 */   // Label 8309: @423735
     /* 423735 */   GIM_Reject,
     /* 423736 */ // Label 8307: @423736
     /* 423736 */ GIM_Reject,
     /* 423737 */ // Label 8290: @423737
     /* 423737 */ GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(424057),
     /* 423742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 423745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 423748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423752 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(423867), // Rule ID 5452 //
     /* 423757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 423769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423774 */     // MIs[1] Operand 2
     /* 423774 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423793 */     // MIs[2] Rn
     /* 423793 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423798 */     // MIs[2] Operand 2
     /* 423798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 423809 */     // MIs[0] imm
     /* 423809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423817 */     // MIs[3] Operand 1
     /* 423817 */     // No operand predicates
     /* 423817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423819 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423849 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423866 */     // GIR_Coverage, 5452,
     /* 423866 */     GIR_EraseRootFromParent_Done,
     /* 423867 */   // Label 8311: @423867
     /* 423867 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(423982), // Rule ID 5457 //
     /* 423872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 423884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423889 */     // MIs[1] Operand 2
     /* 423889 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423908 */     // MIs[2] Rn
     /* 423908 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423913 */     // MIs[2] Operand 2
     /* 423913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 423924 */     // MIs[0] imm
     /* 423924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423932 */     // MIs[3] Operand 1
     /* 423932 */     // No operand predicates
     /* 423932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423934 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423964 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423981 */     // GIR_Coverage, 5457,
     /* 423981 */     GIR_EraseRootFromParent_Done,
     /* 423982 */   // Label 8312: @423982
     /* 423982 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(424019), // Rule ID 5449 //
     /* 423987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423995 */     // MIs[0] imm
     /* 423995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424003 */     // MIs[1] Operand 1
     /* 424003 */     // No operand predicates
     /* 424003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424005 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424017 */     GIR_RootConstrainSelectedInstOperands,
     /* 424018 */     // GIR_Coverage, 5449,
     /* 424018 */     GIR_EraseRootFromParent_Done,
     /* 424019 */   // Label 8313: @424019
     /* 424019 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(424056), // Rule ID 5454 //
     /* 424024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424032 */     // MIs[0] imm
     /* 424032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424040 */     // MIs[1] Operand 1
     /* 424040 */     // No operand predicates
     /* 424040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424042 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424054 */     GIR_RootConstrainSelectedInstOperands,
     /* 424055 */     // GIR_Coverage, 5454,
     /* 424055 */     GIR_EraseRootFromParent_Done,
     /* 424056 */   // Label 8314: @424056
     /* 424056 */   GIM_Reject,
     /* 424057 */ // Label 8310: @424057
     /* 424057 */ GIM_Reject,
     /* 424058 */ // Label 8291: @424058
     /* 424058 */ GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(424140),
     /* 424063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 424069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424081 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(424110), // Rule ID 5460 //
     /* 424086 */     // MIs[0] imm
     /* 424086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424094 */     // MIs[1] Operand 1
     /* 424094 */     // No operand predicates
     /* 424094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424096 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424108 */     GIR_RootConstrainSelectedInstOperands,
     /* 424109 */     // GIR_Coverage, 5460,
     /* 424109 */     GIR_EraseRootFromParent_Done,
     /* 424110 */   // Label 8316: @424110
     /* 424110 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(424139), // Rule ID 5465 //
     /* 424115 */     // MIs[0] imm
     /* 424115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424123 */     // MIs[1] Operand 1
     /* 424123 */     // No operand predicates
     /* 424123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424125 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424137 */     GIR_RootConstrainSelectedInstOperands,
     /* 424138 */     // GIR_Coverage, 5465,
     /* 424138 */     GIR_EraseRootFromParent_Done,
     /* 424139 */   // Label 8317: @424139
     /* 424139 */   GIM_Reject,
     /* 424140 */ // Label 8315: @424140
     /* 424140 */ GIM_Reject,
     /* 424141 */ // Label 8292: @424141
     /* 424141 */ GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(424349),
     /* 424146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 424149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 424152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424156 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(424271), // Rule ID 5447 //
     /* 424161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424178 */     // MIs[1] Operand 2
     /* 424178 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424197 */     // MIs[2] Rn
     /* 424197 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424202 */     // MIs[2] Operand 2
     /* 424202 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 424213 */     // MIs[0] imm
     /* 424213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424221 */     // MIs[3] Operand 1
     /* 424221 */     // No operand predicates
     /* 424221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424223 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424253 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424270 */     // GIR_Coverage, 5447,
     /* 424270 */     GIR_EraseRootFromParent_Done,
     /* 424271 */   // Label 8319: @424271
     /* 424271 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(424311), // Rule ID 1868 //
     /* 424276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424287 */     // MIs[0] imm
     /* 424287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424295 */     // MIs[1] Operand 1
     /* 424295 */     // No operand predicates
     /* 424295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424297 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424309 */     GIR_RootConstrainSelectedInstOperands,
     /* 424310 */     // GIR_Coverage, 1868,
     /* 424310 */     GIR_EraseRootFromParent_Done,
     /* 424311 */   // Label 8320: @424311
     /* 424311 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(424348), // Rule ID 5444 //
     /* 424316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424324 */     // MIs[0] imm
     /* 424324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424332 */     // MIs[1] Operand 1
     /* 424332 */     // No operand predicates
     /* 424332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424334 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424346 */     GIR_RootConstrainSelectedInstOperands,
     /* 424347 */     // GIR_Coverage, 5444,
     /* 424347 */     GIR_EraseRootFromParent_Done,
     /* 424348 */   // Label 8321: @424348
     /* 424348 */   GIM_Reject,
     /* 424349 */ // Label 8318: @424349
     /* 424349 */ GIM_Reject,
     /* 424350 */ // Label 8293: @424350
     /* 424350 */ GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(424432),
     /* 424355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 424358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 424361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424373 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(424402), // Rule ID 5450 //
     /* 424378 */     // MIs[0] imm
     /* 424378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424386 */     // MIs[1] Operand 1
     /* 424386 */     // No operand predicates
     /* 424386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424388 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424400 */     GIR_RootConstrainSelectedInstOperands,
     /* 424401 */     // GIR_Coverage, 5450,
     /* 424401 */     GIR_EraseRootFromParent_Done,
     /* 424402 */   // Label 8323: @424402
     /* 424402 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(424431), // Rule ID 5455 //
     /* 424407 */     // MIs[0] imm
     /* 424407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424415 */     // MIs[1] Operand 1
     /* 424415 */     // No operand predicates
     /* 424415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424417 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424429 */     GIR_RootConstrainSelectedInstOperands,
     /* 424430 */     // GIR_Coverage, 5455,
     /* 424430 */     GIR_EraseRootFromParent_Done,
     /* 424431 */   // Label 8324: @424431
     /* 424431 */   GIM_Reject,
     /* 424432 */ // Label 8322: @424432
     /* 424432 */ GIM_Reject,
     /* 424433 */ // Label 8294: @424433
     /* 424433 */ GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(424518),
     /* 424438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 424444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424456 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(424488), // Rule ID 1869 //
     /* 424461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424464 */     // MIs[0] imm
     /* 424464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424472 */     // MIs[1] Operand 1
     /* 424472 */     // No operand predicates
     /* 424472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424474 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424486 */     GIR_RootConstrainSelectedInstOperands,
     /* 424487 */     // GIR_Coverage, 1869,
     /* 424487 */     GIR_EraseRootFromParent_Done,
     /* 424488 */   // Label 8326: @424488
     /* 424488 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(424517), // Rule ID 5445 //
     /* 424493 */     // MIs[0] imm
     /* 424493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424501 */     // MIs[1] Operand 1
     /* 424501 */     // No operand predicates
     /* 424501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424503 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424515 */     GIR_RootConstrainSelectedInstOperands,
     /* 424516 */     // GIR_Coverage, 5445,
     /* 424516 */     GIR_EraseRootFromParent_Done,
     /* 424517 */   // Label 8327: @424517
     /* 424517 */   GIM_Reject,
     /* 424518 */ // Label 8325: @424518
     /* 424518 */ GIM_Reject,
     /* 424519 */ // Label 8295: @424519
     /* 424519 */ GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(424565), // Rule ID 2726 //
     /* 424524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 424527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 424530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 424533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 424537 */   // MIs[0] Op3
     /* 424537 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424541 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424545 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 424549 */   // MIs[1] Operand 1
     /* 424549 */   // No operand predicates
     /* 424549 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424551 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 424551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 424554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 424556 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 424558 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 424560 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 424563 */   GIR_RootConstrainSelectedInstOperands,
     /* 424564 */   // GIR_Coverage, 2726,
     /* 424564 */   GIR_EraseRootFromParent_Done,
     /* 424565 */ // Label 8328: @424565
     /* 424565 */ GIM_Reject,
     /* 424566 */ // Label 8296: @424566
     /* 424566 */ GIM_Reject,
     /* 424567 */ // Label 130: @424567
     /* 424567 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8336*/ GIMT_Encode4(425125),
     /* 424578 */ /*GILLT_s32*//*Label 8329*/ GIMT_Encode4(424614),
     /* 424582 */ /*GILLT_s64*//*Label 8330*/ GIMT_Encode4(424652), GIMT_Encode4(0),
     /* 424590 */ /*GILLT_v2s32*//*Label 8331*/ GIMT_Encode4(424750),
     /* 424594 */ /*GILLT_v2s64*//*Label 8332*/ GIMT_Encode4(424825),
     /* 424598 */ /*GILLT_v4s16*//*Label 8333*/ GIMT_Encode4(424900),
     /* 424602 */ /*GILLT_v4s32*//*Label 8334*/ GIMT_Encode4(424975), GIMT_Encode4(0),
     /* 424610 */ /*GILLT_v8s16*//*Label 8335*/ GIMT_Encode4(425050),
     /* 424614 */ // Label 8329: @424614
     /* 424614 */ GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(424651), // Rule ID 1622 //
     /* 424619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 424628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 424632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 424636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 424640 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 424640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 424645 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424649 */   GIR_RootConstrainSelectedInstOperands,
     /* 424650 */   // GIR_Coverage, 1622,
     /* 424650 */   GIR_Done,
     /* 424651 */ // Label 8337: @424651
     /* 424651 */ GIM_Reject,
     /* 424652 */ // Label 8330: @424652
     /* 424652 */ GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(424749),
     /* 424657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 424660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424671 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(424702), // Rule ID 2506 //
     /* 424676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424683 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 424689 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 424691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424693 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 424693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 424696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424700 */     GIR_RootConstrainSelectedInstOperands,
     /* 424701 */     // GIR_Coverage, 2506,
     /* 424701 */     GIR_EraseRootFromParent_Done,
     /* 424702 */   // Label 8339: @424702
     /* 424702 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(424725), // Rule ID 1621 //
     /* 424707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424714 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 424714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 424719 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424723 */     GIR_RootConstrainSelectedInstOperands,
     /* 424724 */     // GIR_Coverage, 1621,
     /* 424724 */     GIR_Done,
     /* 424725 */   // Label 8340: @424725
     /* 424725 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(424748), // Rule ID 5224 //
     /* 424730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424737 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 424737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 424742 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424746 */     GIR_RootConstrainSelectedInstOperands,
     /* 424747 */     // GIR_Coverage, 5224,
     /* 424747 */     GIR_Done,
     /* 424748 */   // Label 8341: @424748
     /* 424748 */   GIM_Reject,
     /* 424749 */ // Label 8338: @424749
     /* 424749 */ GIM_Reject,
     /* 424750 */ // Label 8331: @424750
     /* 424750 */ GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(424824),
     /* 424755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 424758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 424761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424769 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(424800), // Rule ID 773 //
     /* 424774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424781 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 424787 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 424789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424791 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 424791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 424794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424798 */     GIR_RootConstrainSelectedInstOperands,
     /* 424799 */     // GIR_Coverage, 773,
     /* 424799 */     GIR_EraseRootFromParent_Done,
     /* 424800 */   // Label 8343: @424800
     /* 424800 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(424823), // Rule ID 1210 //
     /* 424805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424812 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 424812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 424817 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424821 */     GIR_RootConstrainSelectedInstOperands,
     /* 424822 */     // GIR_Coverage, 1210,
     /* 424822 */     GIR_Done,
     /* 424823 */   // Label 8344: @424823
     /* 424823 */   GIM_Reject,
     /* 424824 */ // Label 8342: @424824
     /* 424824 */ GIM_Reject,
     /* 424825 */ // Label 8332: @424825
     /* 424825 */ GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(424899),
     /* 424830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 424833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 424836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424844 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(424875), // Rule ID 775 //
     /* 424849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424856 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 424862 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 424864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424866 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 424866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 424869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424873 */     GIR_RootConstrainSelectedInstOperands,
     /* 424874 */     // GIR_Coverage, 775,
     /* 424874 */     GIR_EraseRootFromParent_Done,
     /* 424875 */   // Label 8346: @424875
     /* 424875 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(424898), // Rule ID 1212 //
     /* 424880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424887 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 424887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 424892 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424896 */     GIR_RootConstrainSelectedInstOperands,
     /* 424897 */     // GIR_Coverage, 1212,
     /* 424897 */     GIR_Done,
     /* 424898 */   // Label 8347: @424898
     /* 424898 */   GIM_Reject,
     /* 424899 */ // Label 8345: @424899
     /* 424899 */ GIM_Reject,
     /* 424900 */ // Label 8333: @424900
     /* 424900 */ GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(424974),
     /* 424905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 424908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 424911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424919 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(424950), // Rule ID 771 //
     /* 424924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 424927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424931 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 424937 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 424939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424941 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 424941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 424944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424948 */     GIR_RootConstrainSelectedInstOperands,
     /* 424949 */     // GIR_Coverage, 771,
     /* 424949 */     GIR_EraseRootFromParent_Done,
     /* 424950 */   // Label 8349: @424950
     /* 424950 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(424973), // Rule ID 1208 //
     /* 424955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 424958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424962 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 424962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 424967 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424971 */     GIR_RootConstrainSelectedInstOperands,
     /* 424972 */     // GIR_Coverage, 1208,
     /* 424972 */     GIR_Done,
     /* 424973 */   // Label 8350: @424973
     /* 424973 */   GIM_Reject,
     /* 424974 */ // Label 8348: @424974
     /* 424974 */ GIM_Reject,
     /* 424975 */ // Label 8334: @424975
     /* 424975 */ GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(425049),
     /* 424980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 424986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424994 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(425025), // Rule ID 774 //
     /* 424999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425006 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425012 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425016 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 425016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 425019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425023 */     GIR_RootConstrainSelectedInstOperands,
     /* 425024 */     // GIR_Coverage, 774,
     /* 425024 */     GIR_EraseRootFromParent_Done,
     /* 425025 */   // Label 8352: @425025
     /* 425025 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(425048), // Rule ID 1211 //
     /* 425030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425037 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 425037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 425042 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425046 */     GIR_RootConstrainSelectedInstOperands,
     /* 425047 */     // GIR_Coverage, 1211,
     /* 425047 */     GIR_Done,
     /* 425048 */   // Label 8353: @425048
     /* 425048 */   GIM_Reject,
     /* 425049 */ // Label 8351: @425049
     /* 425049 */ GIM_Reject,
     /* 425050 */ // Label 8335: @425050
     /* 425050 */ GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(425124),
     /* 425055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 425061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425069 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(425100), // Rule ID 772 //
     /* 425074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425081 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425087 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425091 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 425091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 425094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425098 */     GIR_RootConstrainSelectedInstOperands,
     /* 425099 */     // GIR_Coverage, 772,
     /* 425099 */     GIR_EraseRootFromParent_Done,
     /* 425100 */   // Label 8355: @425100
     /* 425100 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(425123), // Rule ID 1209 //
     /* 425105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425112 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 425112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 425117 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425121 */     GIR_RootConstrainSelectedInstOperands,
     /* 425122 */     // GIR_Coverage, 1209,
     /* 425122 */     GIR_Done,
     /* 425123 */   // Label 8356: @425123
     /* 425123 */   GIM_Reject,
     /* 425124 */ // Label 8354: @425124
     /* 425124 */ GIM_Reject,
     /* 425125 */ // Label 8336: @425125
     /* 425125 */ GIM_Reject,
     /* 425126 */ // Label 131: @425126
     /* 425126 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8364*/ GIMT_Encode4(426217),
     /* 425137 */ /*GILLT_s32*//*Label 8357*/ GIMT_Encode4(425173),
     /* 425141 */ /*GILLT_s64*//*Label 8358*/ GIMT_Encode4(425211), GIMT_Encode4(0),
     /* 425149 */ /*GILLT_v2s32*//*Label 8359*/ GIMT_Encode4(425352),
     /* 425153 */ /*GILLT_v2s64*//*Label 8360*/ GIMT_Encode4(425525),
     /* 425157 */ /*GILLT_v4s16*//*Label 8361*/ GIMT_Encode4(425698),
     /* 425161 */ /*GILLT_v4s32*//*Label 8362*/ GIMT_Encode4(425871), GIMT_Encode4(0),
     /* 425169 */ /*GILLT_v8s16*//*Label 8363*/ GIMT_Encode4(426044),
     /* 425173 */ // Label 8357: @425173
     /* 425173 */ GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(425210), // Rule ID 1624 //
     /* 425178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 425184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 425187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425199 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 425199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 425204 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425208 */   GIR_RootConstrainSelectedInstOperands,
     /* 425209 */   // GIR_Coverage, 1624,
     /* 425209 */   GIR_Done,
     /* 425210 */ // Label 8365: @425210
     /* 425210 */ GIM_Reject,
     /* 425211 */ // Label 8358: @425211
     /* 425211 */ GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(425351),
     /* 425216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 425219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425226 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(425261), // Rule ID 5258 //
     /* 425231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425238 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425244 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425252 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 425252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 425255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425259 */     GIR_RootConstrainSelectedInstOperands,
     /* 425260 */     // GIR_Coverage, 5258,
     /* 425260 */     GIR_EraseRootFromParent_Done,
     /* 425261 */   // Label 8367: @425261
     /* 425261 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(425296), // Rule ID 5256 //
     /* 425266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425277 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425283 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425287 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 425287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 425290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425294 */     GIR_RootConstrainSelectedInstOperands,
     /* 425295 */     // GIR_Coverage, 5256,
     /* 425295 */     GIR_EraseRootFromParent_Done,
     /* 425296 */   // Label 8368: @425296
     /* 425296 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(425323), // Rule ID 1623 //
     /* 425301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425312 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 425312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 425317 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425321 */     GIR_RootConstrainSelectedInstOperands,
     /* 425322 */     // GIR_Coverage, 1623,
     /* 425322 */     GIR_Done,
     /* 425323 */   // Label 8369: @425323
     /* 425323 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(425350), // Rule ID 5225 //
     /* 425328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425339 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 425339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 425344 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425348 */     GIR_RootConstrainSelectedInstOperands,
     /* 425349 */     // GIR_Coverage, 5225,
     /* 425349 */     GIR_Done,
     /* 425350 */   // Label 8370: @425350
     /* 425350 */   GIM_Reject,
     /* 425351 */ // Label 8366: @425351
     /* 425351 */ GIM_Reject,
     /* 425352 */ // Label 8359: @425352
     /* 425352 */ GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(425524),
     /* 425357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 425363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425367 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(425426), // Rule ID 1172 //
     /* 425372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 425411 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 425411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 425414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 425424 */     GIR_RootConstrainSelectedInstOperands,
     /* 425425 */     // GIR_Coverage, 1172,
     /* 425425 */     GIR_EraseRootFromParent_Done,
     /* 425426 */   // Label 8372: @425426
     /* 425426 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(425461), // Rule ID 788 //
     /* 425431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425438 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425444 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425452 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 425452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 425455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425459 */     GIR_RootConstrainSelectedInstOperands,
     /* 425460 */     // GIR_Coverage, 788,
     /* 425460 */     GIR_EraseRootFromParent_Done,
     /* 425461 */   // Label 8373: @425461
     /* 425461 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(425496), // Rule ID 778 //
     /* 425466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425477 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425483 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425487 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 425487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 425490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425494 */     GIR_RootConstrainSelectedInstOperands,
     /* 425495 */     // GIR_Coverage, 778,
     /* 425495 */     GIR_EraseRootFromParent_Done,
     /* 425496 */   // Label 8374: @425496
     /* 425496 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(425523), // Rule ID 1215 //
     /* 425501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425512 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 425512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 425517 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425521 */     GIR_RootConstrainSelectedInstOperands,
     /* 425522 */     // GIR_Coverage, 1215,
     /* 425522 */     GIR_Done,
     /* 425523 */   // Label 8375: @425523
     /* 425523 */   GIM_Reject,
     /* 425524 */ // Label 8371: @425524
     /* 425524 */ GIM_Reject,
     /* 425525 */ // Label 8360: @425525
     /* 425525 */ GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(425697),
     /* 425530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 425536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425540 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(425599), // Rule ID 1176 //
     /* 425545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 425584 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 425584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 425587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 425597 */     GIR_RootConstrainSelectedInstOperands,
     /* 425598 */     // GIR_Coverage, 1176,
     /* 425598 */     GIR_EraseRootFromParent_Done,
     /* 425599 */   // Label 8377: @425599
     /* 425599 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(425634), // Rule ID 790 //
     /* 425604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425611 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425617 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425625 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 425625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 425628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425632 */     GIR_RootConstrainSelectedInstOperands,
     /* 425633 */     // GIR_Coverage, 790,
     /* 425633 */     GIR_EraseRootFromParent_Done,
     /* 425634 */   // Label 8378: @425634
     /* 425634 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(425669), // Rule ID 780 //
     /* 425639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425650 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425656 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425660 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 425660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 425663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425667 */     GIR_RootConstrainSelectedInstOperands,
     /* 425668 */     // GIR_Coverage, 780,
     /* 425668 */     GIR_EraseRootFromParent_Done,
     /* 425669 */   // Label 8379: @425669
     /* 425669 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(425696), // Rule ID 1217 //
     /* 425674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425685 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 425685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 425690 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425694 */     GIR_RootConstrainSelectedInstOperands,
     /* 425695 */     // GIR_Coverage, 1217,
     /* 425695 */     GIR_Done,
     /* 425696 */   // Label 8380: @425696
     /* 425696 */   GIM_Reject,
     /* 425697 */ // Label 8376: @425697
     /* 425697 */ GIM_Reject,
     /* 425698 */ // Label 8361: @425698
     /* 425698 */ GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(425870),
     /* 425703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 425706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 425709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425713 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(425772), // Rule ID 1168 //
     /* 425718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 425733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 425750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 425757 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 425757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 425760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 425770 */     GIR_RootConstrainSelectedInstOperands,
     /* 425771 */     // GIR_Coverage, 1168,
     /* 425771 */     GIR_EraseRootFromParent_Done,
     /* 425772 */   // Label 8382: @425772
     /* 425772 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(425807), // Rule ID 786 //
     /* 425777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425784 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425790 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425798 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 425798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 425801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425805 */     GIR_RootConstrainSelectedInstOperands,
     /* 425806 */     // GIR_Coverage, 786,
     /* 425806 */     GIR_EraseRootFromParent_Done,
     /* 425807 */   // Label 8383: @425807
     /* 425807 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(425842), // Rule ID 776 //
     /* 425812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425823 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425829 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425833 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 425833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 425836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425840 */     GIR_RootConstrainSelectedInstOperands,
     /* 425841 */     // GIR_Coverage, 776,
     /* 425841 */     GIR_EraseRootFromParent_Done,
     /* 425842 */   // Label 8384: @425842
     /* 425842 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(425869), // Rule ID 1213 //
     /* 425847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425858 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 425858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 425863 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425867 */     GIR_RootConstrainSelectedInstOperands,
     /* 425868 */     // GIR_Coverage, 1213,
     /* 425868 */     GIR_Done,
     /* 425869 */   // Label 8385: @425869
     /* 425869 */   GIM_Reject,
     /* 425870 */ // Label 8381: @425870
     /* 425870 */ GIM_Reject,
     /* 425871 */ // Label 8362: @425871
     /* 425871 */ GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(426043),
     /* 425876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 425882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425886 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(425945), // Rule ID 1174 //
     /* 425891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 425930 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 425930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 425933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 425943 */     GIR_RootConstrainSelectedInstOperands,
     /* 425944 */     // GIR_Coverage, 1174,
     /* 425944 */     GIR_EraseRootFromParent_Done,
     /* 425945 */   // Label 8387: @425945
     /* 425945 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(425980), // Rule ID 789 //
     /* 425950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425957 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425963 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425971 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 425971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 425974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425978 */     GIR_RootConstrainSelectedInstOperands,
     /* 425979 */     // GIR_Coverage, 789,
     /* 425979 */     GIR_EraseRootFromParent_Done,
     /* 425980 */   // Label 8388: @425980
     /* 425980 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(426015), // Rule ID 779 //
     /* 425985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425996 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426002 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426006 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 426006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 426009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426013 */     GIR_RootConstrainSelectedInstOperands,
     /* 426014 */     // GIR_Coverage, 779,
     /* 426014 */     GIR_EraseRootFromParent_Done,
     /* 426015 */   // Label 8389: @426015
     /* 426015 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(426042), // Rule ID 1216 //
     /* 426020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426031 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 426031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 426036 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426040 */     GIR_RootConstrainSelectedInstOperands,
     /* 426041 */     // GIR_Coverage, 1216,
     /* 426041 */     GIR_Done,
     /* 426042 */   // Label 8390: @426042
     /* 426042 */   GIM_Reject,
     /* 426043 */ // Label 8386: @426043
     /* 426043 */ GIM_Reject,
     /* 426044 */ // Label 8363: @426044
     /* 426044 */ GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(426216),
     /* 426049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 426055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426059 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(426118), // Rule ID 1170 //
     /* 426064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426103 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 426103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 426106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426116 */     GIR_RootConstrainSelectedInstOperands,
     /* 426117 */     // GIR_Coverage, 1170,
     /* 426117 */     GIR_EraseRootFromParent_Done,
     /* 426118 */   // Label 8392: @426118
     /* 426118 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(426153), // Rule ID 787 //
     /* 426123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426130 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426144 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 426144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 426147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426151 */     GIR_RootConstrainSelectedInstOperands,
     /* 426152 */     // GIR_Coverage, 787,
     /* 426152 */     GIR_EraseRootFromParent_Done,
     /* 426153 */   // Label 8393: @426153
     /* 426153 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(426188), // Rule ID 777 //
     /* 426158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426169 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426175 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426179 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 426179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 426182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426186 */     GIR_RootConstrainSelectedInstOperands,
     /* 426187 */     // GIR_Coverage, 777,
     /* 426187 */     GIR_EraseRootFromParent_Done,
     /* 426188 */   // Label 8394: @426188
     /* 426188 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(426215), // Rule ID 1214 //
     /* 426193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426204 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 426204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 426209 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426213 */     GIR_RootConstrainSelectedInstOperands,
     /* 426214 */     // GIR_Coverage, 1214,
     /* 426214 */     GIR_Done,
     /* 426215 */   // Label 8395: @426215
     /* 426215 */   GIM_Reject,
     /* 426216 */ // Label 8391: @426216
     /* 426216 */ GIM_Reject,
     /* 426217 */ // Label 8364: @426217
     /* 426217 */ GIM_Reject,
     /* 426218 */ // Label 132: @426218
     /* 426218 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8403*/ GIMT_Encode4(427309),
     /* 426229 */ /*GILLT_s32*//*Label 8396*/ GIMT_Encode4(426265),
     /* 426233 */ /*GILLT_s64*//*Label 8397*/ GIMT_Encode4(426303), GIMT_Encode4(0),
     /* 426241 */ /*GILLT_v2s32*//*Label 8398*/ GIMT_Encode4(426444),
     /* 426245 */ /*GILLT_v2s64*//*Label 8399*/ GIMT_Encode4(426617),
     /* 426249 */ /*GILLT_v4s16*//*Label 8400*/ GIMT_Encode4(426790),
     /* 426253 */ /*GILLT_v4s32*//*Label 8401*/ GIMT_Encode4(426963), GIMT_Encode4(0),
     /* 426261 */ /*GILLT_v8s16*//*Label 8402*/ GIMT_Encode4(427136),
     /* 426265 */ // Label 8396: @426265
     /* 426265 */ GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(426302), // Rule ID 1626 //
     /* 426270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 426276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 426279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426291 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 426291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 426296 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426300 */   GIR_RootConstrainSelectedInstOperands,
     /* 426301 */   // GIR_Coverage, 1626,
     /* 426301 */   GIR_Done,
     /* 426302 */ // Label 8404: @426302
     /* 426302 */ GIM_Reject,
     /* 426303 */ // Label 8397: @426303
     /* 426303 */ GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(426443),
     /* 426308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 426311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 426314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426318 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(426353), // Rule ID 5259 //
     /* 426323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426330 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426336 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426344 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 426347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426351 */     GIR_RootConstrainSelectedInstOperands,
     /* 426352 */     // GIR_Coverage, 5259,
     /* 426352 */     GIR_EraseRootFromParent_Done,
     /* 426353 */   // Label 8406: @426353
     /* 426353 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(426388), // Rule ID 5257 //
     /* 426358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426369 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426375 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426379 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 426382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426386 */     GIR_RootConstrainSelectedInstOperands,
     /* 426387 */     // GIR_Coverage, 5257,
     /* 426387 */     GIR_EraseRootFromParent_Done,
     /* 426388 */   // Label 8407: @426388
     /* 426388 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(426415), // Rule ID 1625 //
     /* 426393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426404 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 426404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 426409 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426413 */     GIR_RootConstrainSelectedInstOperands,
     /* 426414 */     // GIR_Coverage, 1625,
     /* 426414 */     GIR_Done,
     /* 426415 */   // Label 8408: @426415
     /* 426415 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(426442), // Rule ID 5226 //
     /* 426420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426431 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 426431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 426436 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426440 */     GIR_RootConstrainSelectedInstOperands,
     /* 426441 */     // GIR_Coverage, 5226,
     /* 426441 */     GIR_Done,
     /* 426442 */   // Label 8409: @426442
     /* 426442 */   GIM_Reject,
     /* 426443 */ // Label 8405: @426443
     /* 426443 */ GIM_Reject,
     /* 426444 */ // Label 8398: @426444
     /* 426444 */ GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(426616),
     /* 426449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 426455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426459 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(426518), // Rule ID 1182 //
     /* 426464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426503 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 426503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 426506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426516 */     GIR_RootConstrainSelectedInstOperands,
     /* 426517 */     // GIR_Coverage, 1182,
     /* 426517 */     GIR_EraseRootFromParent_Done,
     /* 426518 */   // Label 8411: @426518
     /* 426518 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(426553), // Rule ID 793 //
     /* 426523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426530 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426536 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426544 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 426544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 426547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426551 */     GIR_RootConstrainSelectedInstOperands,
     /* 426552 */     // GIR_Coverage, 793,
     /* 426552 */     GIR_EraseRootFromParent_Done,
     /* 426553 */   // Label 8412: @426553
     /* 426553 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(426588), // Rule ID 783 //
     /* 426558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426569 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426575 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426579 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 426579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 426582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426586 */     GIR_RootConstrainSelectedInstOperands,
     /* 426587 */     // GIR_Coverage, 783,
     /* 426587 */     GIR_EraseRootFromParent_Done,
     /* 426588 */   // Label 8413: @426588
     /* 426588 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(426615), // Rule ID 1220 //
     /* 426593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426604 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 426604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 426609 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426613 */     GIR_RootConstrainSelectedInstOperands,
     /* 426614 */     // GIR_Coverage, 1220,
     /* 426614 */     GIR_Done,
     /* 426615 */   // Label 8414: @426615
     /* 426615 */   GIM_Reject,
     /* 426616 */ // Label 8410: @426616
     /* 426616 */ GIM_Reject,
     /* 426617 */ // Label 8399: @426617
     /* 426617 */ GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(426789),
     /* 426622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 426628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426632 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(426691), // Rule ID 1186 //
     /* 426637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426676 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 426676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 426679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426689 */     GIR_RootConstrainSelectedInstOperands,
     /* 426690 */     // GIR_Coverage, 1186,
     /* 426690 */     GIR_EraseRootFromParent_Done,
     /* 426691 */   // Label 8416: @426691
     /* 426691 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(426726), // Rule ID 795 //
     /* 426696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426709 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426717 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 426717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 426720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426724 */     GIR_RootConstrainSelectedInstOperands,
     /* 426725 */     // GIR_Coverage, 795,
     /* 426725 */     GIR_EraseRootFromParent_Done,
     /* 426726 */   // Label 8417: @426726
     /* 426726 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(426761), // Rule ID 785 //
     /* 426731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426742 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426748 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426752 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 426752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 426755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426759 */     GIR_RootConstrainSelectedInstOperands,
     /* 426760 */     // GIR_Coverage, 785,
     /* 426760 */     GIR_EraseRootFromParent_Done,
     /* 426761 */   // Label 8418: @426761
     /* 426761 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(426788), // Rule ID 1222 //
     /* 426766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426777 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 426777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 426782 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426786 */     GIR_RootConstrainSelectedInstOperands,
     /* 426787 */     // GIR_Coverage, 1222,
     /* 426787 */     GIR_Done,
     /* 426788 */   // Label 8419: @426788
     /* 426788 */   GIM_Reject,
     /* 426789 */ // Label 8415: @426789
     /* 426789 */ GIM_Reject,
     /* 426790 */ // Label 8400: @426790
     /* 426790 */ GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(426962),
     /* 426795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 426801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426805 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(426864), // Rule ID 1178 //
     /* 426810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426849 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 426849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 426852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426862 */     GIR_RootConstrainSelectedInstOperands,
     /* 426863 */     // GIR_Coverage, 1178,
     /* 426863 */     GIR_EraseRootFromParent_Done,
     /* 426864 */   // Label 8421: @426864
     /* 426864 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(426899), // Rule ID 791 //
     /* 426869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426890 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 426890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 426893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426897 */     GIR_RootConstrainSelectedInstOperands,
     /* 426898 */     // GIR_Coverage, 791,
     /* 426898 */     GIR_EraseRootFromParent_Done,
     /* 426899 */   // Label 8422: @426899
     /* 426899 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(426934), // Rule ID 781 //
     /* 426904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426915 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426921 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426925 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 426925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 426928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426932 */     GIR_RootConstrainSelectedInstOperands,
     /* 426933 */     // GIR_Coverage, 781,
     /* 426933 */     GIR_EraseRootFromParent_Done,
     /* 426934 */   // Label 8423: @426934
     /* 426934 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(426961), // Rule ID 1218 //
     /* 426939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426950 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 426950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 426955 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426959 */     GIR_RootConstrainSelectedInstOperands,
     /* 426960 */     // GIR_Coverage, 1218,
     /* 426960 */     GIR_Done,
     /* 426961 */   // Label 8424: @426961
     /* 426961 */   GIM_Reject,
     /* 426962 */ // Label 8420: @426962
     /* 426962 */ GIM_Reject,
     /* 426963 */ // Label 8401: @426963
     /* 426963 */ GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(427135),
     /* 426968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 426974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426978 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(427037), // Rule ID 1184 //
     /* 426983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427015 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427022 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 427025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427035 */     GIR_RootConstrainSelectedInstOperands,
     /* 427036 */     // GIR_Coverage, 1184,
     /* 427036 */     GIR_EraseRootFromParent_Done,
     /* 427037 */   // Label 8426: @427037
     /* 427037 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(427072), // Rule ID 794 //
     /* 427042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427049 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427055 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427063 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 427066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427070 */     GIR_RootConstrainSelectedInstOperands,
     /* 427071 */     // GIR_Coverage, 794,
     /* 427071 */     GIR_EraseRootFromParent_Done,
     /* 427072 */   // Label 8427: @427072
     /* 427072 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(427107), // Rule ID 784 //
     /* 427077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427088 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427094 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427098 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 427101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427105 */     GIR_RootConstrainSelectedInstOperands,
     /* 427106 */     // GIR_Coverage, 784,
     /* 427106 */     GIR_EraseRootFromParent_Done,
     /* 427107 */   // Label 8428: @427107
     /* 427107 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(427134), // Rule ID 1221 //
     /* 427112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427123 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 427128 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427132 */     GIR_RootConstrainSelectedInstOperands,
     /* 427133 */     // GIR_Coverage, 1221,
     /* 427133 */     GIR_Done,
     /* 427134 */   // Label 8429: @427134
     /* 427134 */   GIM_Reject,
     /* 427135 */ // Label 8425: @427135
     /* 427135 */ GIM_Reject,
     /* 427136 */ // Label 8402: @427136
     /* 427136 */ GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(427308),
     /* 427141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 427147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427151 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(427210), // Rule ID 1180 //
     /* 427156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427195 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 427198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427208 */     GIR_RootConstrainSelectedInstOperands,
     /* 427209 */     // GIR_Coverage, 1180,
     /* 427209 */     GIR_EraseRootFromParent_Done,
     /* 427210 */   // Label 8431: @427210
     /* 427210 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(427245), // Rule ID 792 //
     /* 427215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427222 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427228 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427236 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 427239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427243 */     GIR_RootConstrainSelectedInstOperands,
     /* 427244 */     // GIR_Coverage, 792,
     /* 427244 */     GIR_EraseRootFromParent_Done,
     /* 427245 */   // Label 8432: @427245
     /* 427245 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(427280), // Rule ID 782 //
     /* 427250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427261 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427267 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427271 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 427274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427278 */     GIR_RootConstrainSelectedInstOperands,
     /* 427279 */     // GIR_Coverage, 782,
     /* 427279 */     GIR_EraseRootFromParent_Done,
     /* 427280 */   // Label 8433: @427280
     /* 427280 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(427307), // Rule ID 1219 //
     /* 427285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427296 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 427301 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427305 */     GIR_RootConstrainSelectedInstOperands,
     /* 427306 */     // GIR_Coverage, 1219,
     /* 427306 */     GIR_Done,
     /* 427307 */   // Label 8434: @427307
     /* 427307 */   GIM_Reject,
     /* 427308 */ // Label 8430: @427308
     /* 427308 */ GIM_Reject,
     /* 427309 */ // Label 8403: @427309
     /* 427309 */ GIM_Reject,
     /* 427310 */ // Label 133: @427310
     /* 427310 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8439*/ GIMT_Encode4(427463),
     /* 427321 */ /*GILLT_s32*//*Label 8435*/ GIMT_Encode4(427361),
     /* 427325 */ /*GILLT_s64*//*Label 8436*/ GIMT_Encode4(427385), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 427349 */ /*GILLT_v8s8*//*Label 8437*/ GIMT_Encode4(427409), GIMT_Encode4(0),
     /* 427357 */ /*GILLT_v16s8*//*Label 8438*/ GIMT_Encode4(427436),
     /* 427361 */ // Label 8435: @427361
     /* 427361 */ GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(427384), // Rule ID 4012 //
     /* 427366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 427369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 427373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 427377 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 427377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 427382 */   GIR_RootConstrainSelectedInstOperands,
     /* 427383 */   // GIR_Coverage, 4012,
     /* 427383 */   GIR_Done,
     /* 427384 */ // Label 8440: @427384
     /* 427384 */ GIM_Reject,
     /* 427385 */ // Label 8436: @427385
     /* 427385 */ GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(427408), // Rule ID 4013 //
     /* 427390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 427393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 427397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 427401 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 427401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 427406 */   GIR_RootConstrainSelectedInstOperands,
     /* 427407 */   // GIR_Coverage, 4013,
     /* 427407 */   GIR_Done,
     /* 427408 */ // Label 8441: @427408
     /* 427408 */ GIM_Reject,
     /* 427409 */ // Label 8437: @427409
     /* 427409 */ GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(427435), // Rule ID 976 //
     /* 427414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 427420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427428 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 427428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 427433 */   GIR_RootConstrainSelectedInstOperands,
     /* 427434 */   // GIR_Coverage, 976,
     /* 427434 */   GIR_Done,
     /* 427435 */ // Label 8442: @427435
     /* 427435 */ GIM_Reject,
     /* 427436 */ // Label 8438: @427436
     /* 427436 */ GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(427462), // Rule ID 977 //
     /* 427441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427455 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 427455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 427460 */   GIR_RootConstrainSelectedInstOperands,
     /* 427461 */   // GIR_Coverage, 977,
     /* 427461 */   GIR_Done,
     /* 427462 */ // Label 8443: @427462
     /* 427462 */ GIM_Reject,
     /* 427463 */ // Label 8439: @427463
     /* 427463 */ GIM_Reject,
     /* 427464 */ // Label 134: @427464
     /* 427464 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8448*/ GIMT_Encode4(427639),
     /* 427475 */ /*GILLT_v4s16*//*Label 8444*/ GIMT_Encode4(427495), GIMT_Encode4(0),
     /* 427483 */ /*GILLT_v8s8*//*Label 8445*/ GIMT_Encode4(427540),
     /* 427487 */ /*GILLT_v8s16*//*Label 8446*/ GIMT_Encode4(427567),
     /* 427491 */ /*GILLT_v16s8*//*Label 8447*/ GIMT_Encode4(427612),
     /* 427495 */ // Label 8444: @427495
     /* 427495 */ GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(427539),
     /* 427500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427511 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(427526), // Rule ID 980 //
     /* 427516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427519 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 427519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 427524 */     GIR_RootConstrainSelectedInstOperands,
     /* 427525 */     // GIR_Coverage, 980,
     /* 427525 */     GIR_Done,
     /* 427526 */   // Label 8450: @427526
     /* 427526 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(427538), // Rule ID 4995 //
     /* 427531 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 427531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 427536 */     GIR_RootConstrainSelectedInstOperands,
     /* 427537 */     // GIR_Coverage, 4995,
     /* 427537 */     GIR_Done,
     /* 427538 */   // Label 8451: @427538
     /* 427538 */   GIM_Reject,
     /* 427539 */ // Label 8449: @427539
     /* 427539 */ GIM_Reject,
     /* 427540 */ // Label 8445: @427540
     /* 427540 */ GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(427566), // Rule ID 978 //
     /* 427545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 427551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427559 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 427559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 427564 */   GIR_RootConstrainSelectedInstOperands,
     /* 427565 */   // GIR_Coverage, 978,
     /* 427565 */   GIR_Done,
     /* 427566 */ // Label 8452: @427566
     /* 427566 */ GIM_Reject,
     /* 427567 */ // Label 8446: @427567
     /* 427567 */ GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(427611),
     /* 427572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427583 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(427598), // Rule ID 981 //
     /* 427588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427591 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 427591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 427596 */     GIR_RootConstrainSelectedInstOperands,
     /* 427597 */     // GIR_Coverage, 981,
     /* 427597 */     GIR_Done,
     /* 427598 */   // Label 8454: @427598
     /* 427598 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(427610), // Rule ID 4997 //
     /* 427603 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 427603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 427608 */     GIR_RootConstrainSelectedInstOperands,
     /* 427609 */     // GIR_Coverage, 4997,
     /* 427609 */     GIR_Done,
     /* 427610 */   // Label 8455: @427610
     /* 427610 */   GIM_Reject,
     /* 427611 */ // Label 8453: @427611
     /* 427611 */ GIM_Reject,
     /* 427612 */ // Label 8447: @427612
     /* 427612 */ GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(427638), // Rule ID 979 //
     /* 427617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427631 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 427631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 427636 */   GIR_RootConstrainSelectedInstOperands,
     /* 427637 */   // GIR_Coverage, 979,
     /* 427637 */   GIR_Done,
     /* 427638 */ // Label 8456: @427638
     /* 427638 */ GIM_Reject,
     /* 427639 */ // Label 8448: @427639
     /* 427639 */ GIM_Reject,
     /* 427640 */ // Label 135: @427640
     /* 427640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8463*/ GIMT_Encode4(427913),
     /* 427651 */ /*GILLT_v2s32*//*Label 8457*/ GIMT_Encode4(427679), GIMT_Encode4(0),
     /* 427659 */ /*GILLT_v4s16*//*Label 8458*/ GIMT_Encode4(427724),
     /* 427663 */ /*GILLT_v4s32*//*Label 8459*/ GIMT_Encode4(427769),
     /* 427667 */ /*GILLT_v8s8*//*Label 8460*/ GIMT_Encode4(427814),
     /* 427671 */ /*GILLT_v8s16*//*Label 8461*/ GIMT_Encode4(427841),
     /* 427675 */ /*GILLT_v16s8*//*Label 8462*/ GIMT_Encode4(427886),
     /* 427679 */ // Label 8457: @427679
     /* 427679 */ GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(427723),
     /* 427684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427695 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(427710), // Rule ID 986 //
     /* 427700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427703 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 427703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 427708 */     GIR_RootConstrainSelectedInstOperands,
     /* 427709 */     // GIR_Coverage, 986,
     /* 427709 */     GIR_Done,
     /* 427710 */   // Label 8465: @427710
     /* 427710 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(427722), // Rule ID 4999 //
     /* 427715 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 427715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 427720 */     GIR_RootConstrainSelectedInstOperands,
     /* 427721 */     // GIR_Coverage, 4999,
     /* 427721 */     GIR_Done,
     /* 427722 */   // Label 8466: @427722
     /* 427722 */   GIM_Reject,
     /* 427723 */ // Label 8464: @427723
     /* 427723 */ GIM_Reject,
     /* 427724 */ // Label 8458: @427724
     /* 427724 */ GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(427768),
     /* 427729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427740 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(427755), // Rule ID 984 //
     /* 427745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427748 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 427748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 427753 */     GIR_RootConstrainSelectedInstOperands,
     /* 427754 */     // GIR_Coverage, 984,
     /* 427754 */     GIR_Done,
     /* 427755 */   // Label 8468: @427755
     /* 427755 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(427767), // Rule ID 4996 //
     /* 427760 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 427760 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 427765 */     GIR_RootConstrainSelectedInstOperands,
     /* 427766 */     // GIR_Coverage, 4996,
     /* 427766 */     GIR_Done,
     /* 427767 */   // Label 8469: @427767
     /* 427767 */   GIM_Reject,
     /* 427768 */ // Label 8467: @427768
     /* 427768 */ GIM_Reject,
     /* 427769 */ // Label 8459: @427769
     /* 427769 */ GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(427813),
     /* 427774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427785 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(427800), // Rule ID 987 //
     /* 427790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427793 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 427793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 427798 */     GIR_RootConstrainSelectedInstOperands,
     /* 427799 */     // GIR_Coverage, 987,
     /* 427799 */     GIR_Done,
     /* 427800 */   // Label 8471: @427800
     /* 427800 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(427812), // Rule ID 5000 //
     /* 427805 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 427805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 427810 */     GIR_RootConstrainSelectedInstOperands,
     /* 427811 */     // GIR_Coverage, 5000,
     /* 427811 */     GIR_Done,
     /* 427812 */   // Label 8472: @427812
     /* 427812 */   GIM_Reject,
     /* 427813 */ // Label 8470: @427813
     /* 427813 */ GIM_Reject,
     /* 427814 */ // Label 8460: @427814
     /* 427814 */ GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(427840), // Rule ID 982 //
     /* 427819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 427825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427833 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 427833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 427838 */   GIR_RootConstrainSelectedInstOperands,
     /* 427839 */   // GIR_Coverage, 982,
     /* 427839 */   GIR_Done,
     /* 427840 */ // Label 8473: @427840
     /* 427840 */ GIM_Reject,
     /* 427841 */ // Label 8461: @427841
     /* 427841 */ GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(427885),
     /* 427846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427857 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(427872), // Rule ID 985 //
     /* 427862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427865 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 427865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 427870 */     GIR_RootConstrainSelectedInstOperands,
     /* 427871 */     // GIR_Coverage, 985,
     /* 427871 */     GIR_Done,
     /* 427872 */   // Label 8475: @427872
     /* 427872 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(427884), // Rule ID 4998 //
     /* 427877 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 427877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 427882 */     GIR_RootConstrainSelectedInstOperands,
     /* 427883 */     // GIR_Coverage, 4998,
     /* 427883 */     GIR_Done,
     /* 427884 */   // Label 8476: @427884
     /* 427884 */   GIM_Reject,
     /* 427885 */ // Label 8474: @427885
     /* 427885 */ GIM_Reject,
     /* 427886 */ // Label 8462: @427886
     /* 427886 */ GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(427912), // Rule ID 983 //
     /* 427891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427905 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 427905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 427910 */   GIR_RootConstrainSelectedInstOperands,
     /* 427911 */   // GIR_Coverage, 983,
     /* 427911 */   GIR_Done,
     /* 427912 */ // Label 8477: @427912
     /* 427912 */ GIM_Reject,
     /* 427913 */ // Label 8463: @427913
     /* 427913 */ GIM_Reject,
     /* 427914 */ // Label 136: @427914
     /* 427914 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8484*/ GIMT_Encode4(428119),
     /* 427925 */ /*GILLT_s64*//*Label 8478*/ GIMT_Encode4(427957), GIMT_Encode4(0),
     /* 427933 */ /*GILLT_v2s32*//*Label 8479*/ GIMT_Encode4(427984),
     /* 427937 */ /*GILLT_v2s64*//*Label 8480*/ GIMT_Encode4(428011),
     /* 427941 */ /*GILLT_v4s16*//*Label 8481*/ GIMT_Encode4(428038),
     /* 427945 */ /*GILLT_v4s32*//*Label 8482*/ GIMT_Encode4(428065), GIMT_Encode4(0),
     /* 427953 */ /*GILLT_v8s16*//*Label 8483*/ GIMT_Encode4(428092),
     /* 427957 */ // Label 8478: @427957
     /* 427957 */ GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(427983), // Rule ID 1008 //
     /* 427962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427976 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 427976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 427981 */   GIR_RootConstrainSelectedInstOperands,
     /* 427982 */   // GIR_Coverage, 1008,
     /* 427982 */   GIR_Done,
     /* 427983 */ // Label 8485: @427983
     /* 427983 */ GIM_Reject,
     /* 427984 */ // Label 8479: @427984
     /* 427984 */ GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(428010), // Rule ID 1004 //
     /* 427989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428003 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 428003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 428008 */   GIR_RootConstrainSelectedInstOperands,
     /* 428009 */   // GIR_Coverage, 1004,
     /* 428009 */   GIR_Done,
     /* 428010 */ // Label 8486: @428010
     /* 428010 */ GIM_Reject,
     /* 428011 */ // Label 8480: @428011
     /* 428011 */ GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(428037), // Rule ID 1010 //
     /* 428016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428030 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 428030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 428035 */   GIR_RootConstrainSelectedInstOperands,
     /* 428036 */   // GIR_Coverage, 1010,
     /* 428036 */   GIR_Done,
     /* 428037 */ // Label 8487: @428037
     /* 428037 */ GIM_Reject,
     /* 428038 */ // Label 8481: @428038
     /* 428038 */ GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(428064), // Rule ID 1000 //
     /* 428043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428057 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 428057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 428062 */   GIR_RootConstrainSelectedInstOperands,
     /* 428063 */   // GIR_Coverage, 1000,
     /* 428063 */   GIR_Done,
     /* 428064 */ // Label 8488: @428064
     /* 428064 */ GIM_Reject,
     /* 428065 */ // Label 8482: @428065
     /* 428065 */ GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(428091), // Rule ID 1006 //
     /* 428070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428084 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 428084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 428089 */   GIR_RootConstrainSelectedInstOperands,
     /* 428090 */   // GIR_Coverage, 1006,
     /* 428090 */   GIR_Done,
     /* 428091 */ // Label 8489: @428091
     /* 428091 */ GIM_Reject,
     /* 428092 */ // Label 8483: @428092
     /* 428092 */ GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(428118), // Rule ID 1002 //
     /* 428097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428111 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 428111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 428116 */   GIR_RootConstrainSelectedInstOperands,
     /* 428117 */   // GIR_Coverage, 1002,
     /* 428117 */   GIR_Done,
     /* 428118 */ // Label 8490: @428118
     /* 428118 */ GIM_Reject,
     /* 428119 */ // Label 8484: @428119
     /* 428119 */ GIM_Reject,
     /* 428120 */ // Label 137: @428120
     /* 428120 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8493*/ GIMT_Encode4(428518),
     /* 428131 */ /*GILLT_v2s64*//*Label 8491*/ GIMT_Encode4(428143), GIMT_Encode4(0),
     /* 428139 */ /*GILLT_v4s32*//*Label 8492*/ GIMT_Encode4(428281),
     /* 428143 */ // Label 8491: @428143
     /* 428143 */ GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(428202), // Rule ID 5908 //
     /* 428148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428159 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 428159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 428162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 428166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428171 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 428191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428201 */   // GIR_Coverage, 5908,
     /* 428201 */   GIR_EraseRootFromParent_Done,
     /* 428202 */ // Label 8494: @428202
     /* 428202 */ GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(428280), // Rule ID 6030 //
     /* 428207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428218 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 428218 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 428221 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 428225 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428230 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 428236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 428239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 428243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 428253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 428261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 428264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428274 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428279 */   // GIR_Coverage, 6030,
     /* 428279 */   GIR_EraseRootFromParent_Done,
     /* 428280 */ // Label 8495: @428280
     /* 428280 */ GIM_Reject,
     /* 428281 */ // Label 8492: @428281
     /* 428281 */ GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(428340), // Rule ID 5904 //
     /* 428286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428297 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 428297 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 428300 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 428304 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428309 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 428329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428334 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 428339 */   // GIR_Coverage, 5904,
     /* 428339 */   GIR_EraseRootFromParent_Done,
     /* 428340 */ // Label 8496: @428340
     /* 428340 */ GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(428399), // Rule ID 5905 //
     /* 428345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428356 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 428356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 428359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 428363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428368 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 428388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428398 */   // GIR_Coverage, 5905,
     /* 428398 */   GIR_EraseRootFromParent_Done,
     /* 428399 */ // Label 8497: @428399
     /* 428399 */ GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(428458), // Rule ID 5906 //
     /* 428404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428415 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 428415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 428418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 428422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428427 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 428447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 428457 */   // GIR_Coverage, 5906,
     /* 428457 */   GIR_EraseRootFromParent_Done,
     /* 428458 */ // Label 8498: @428458
     /* 428458 */ GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(428517), // Rule ID 5907 //
     /* 428463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428474 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 428474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 428477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 428481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428486 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 428506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428511 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428516 */   // GIR_Coverage, 5907,
     /* 428516 */   GIR_EraseRootFromParent_Done,
     /* 428517 */ // Label 8499: @428517
     /* 428517 */ GIM_Reject,
     /* 428518 */ // Label 8493: @428518
     /* 428518 */ GIM_Reject,
     /* 428519 */ // Label 138: @428519
     /* 428519 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8504*/ GIMT_Encode4(428888),
     /* 428530 */ /*GILLT_v2s32*//*Label 8500*/ GIMT_Encode4(428590), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 428542 */ /*GILLT_v4s32*//*Label 8501*/ GIMT_Encode4(428710), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 428574 */ /*GILLT_nxv2s64*//*Label 8502*/ GIMT_Encode4(428830), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 428586 */ /*GILLT_nxv4s32*//*Label 8503*/ GIMT_Encode4(428859),
     /* 428590 */ // Label 8500: @428590
     /* 428590 */ GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(428709),
     /* 428595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 428601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 428604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428616 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(428689), // Rule ID 26 //
     /* 428621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 428624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 428628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 428632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 428644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 428652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 428661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 428665 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 428669 */     // MIs[3] Operand 1
     /* 428669 */     // No operand predicates
     /* 428669 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428671 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 428671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 428674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 428678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 428687 */     GIR_RootConstrainSelectedInstOperands,
     /* 428688 */     // GIR_Coverage, 26,
     /* 428688 */     GIR_EraseRootFromParent_Done,
     /* 428689 */   // Label 8506: @428689
     /* 428689 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(428708), // Rule ID 22 //
     /* 428694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 428697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428701 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 428701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 428706 */     GIR_RootConstrainSelectedInstOperands,
     /* 428707 */     // GIR_Coverage, 22,
     /* 428707 */     GIR_Done,
     /* 428708 */   // Label 8507: @428708
     /* 428708 */   GIM_Reject,
     /* 428709 */ // Label 8505: @428709
     /* 428709 */ GIM_Reject,
     /* 428710 */ // Label 8501: @428710
     /* 428710 */ GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(428829),
     /* 428715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 428721 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 428724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428736 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(428809), // Rule ID 27 //
     /* 428741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 428744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 428748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 428752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 428764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 428772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 428781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 428785 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 428789 */     // MIs[3] Operand 1
     /* 428789 */     // No operand predicates
     /* 428789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428791 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 428791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 428794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 428798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 428807 */     GIR_RootConstrainSelectedInstOperands,
     /* 428808 */     // GIR_Coverage, 27,
     /* 428808 */     GIR_EraseRootFromParent_Done,
     /* 428809 */   // Label 8509: @428809
     /* 428809 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(428828), // Rule ID 23 //
     /* 428814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 428817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428821 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 428821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 428826 */     GIR_RootConstrainSelectedInstOperands,
     /* 428827 */     // GIR_Coverage, 23,
     /* 428827 */     GIR_Done,
     /* 428828 */   // Label 8510: @428828
     /* 428828 */   GIM_Reject,
     /* 428829 */ // Label 8508: @428829
     /* 428829 */ GIM_Reject,
     /* 428830 */ // Label 8502: @428830
     /* 428830 */ GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(428858), // Rule ID 2979 //
     /* 428835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 428838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 428841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 428844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 428847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 428851 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 428851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 428856 */   GIR_RootConstrainSelectedInstOperands,
     /* 428857 */   // GIR_Coverage, 2979,
     /* 428857 */   GIR_Done,
     /* 428858 */ // Label 8511: @428858
     /* 428858 */ GIM_Reject,
     /* 428859 */ // Label 8503: @428859
     /* 428859 */ GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(428887), // Rule ID 2978 //
     /* 428864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 428867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 428870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 428873 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 428876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 428880 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 428880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 428885 */   GIR_RootConstrainSelectedInstOperands,
     /* 428886 */   // GIR_Coverage, 2978,
     /* 428886 */   GIR_Done,
     /* 428887 */ // Label 8512: @428887
     /* 428887 */ GIM_Reject,
     /* 428888 */ // Label 8504: @428888
     /* 428888 */ GIM_Reject,
     /* 428889 */ // Label 139: @428889
     /* 428889 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8516*/ GIMT_Encode4(429005),
     /* 428900 */ /*GILLT_s16*//*Label 8513*/ GIMT_Encode4(428912),
     /* 428904 */ /*GILLT_s32*//*Label 8514*/ GIMT_Encode4(428943),
     /* 428908 */ /*GILLT_s64*//*Label 8515*/ GIMT_Encode4(428974),
     /* 428912 */ // Label 8513: @428912
     /* 428912 */ GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(428942), // Rule ID 1658 //
     /* 428917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 428920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 428923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 428927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 428931 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 428931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 428936 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428940 */   GIR_RootConstrainSelectedInstOperands,
     /* 428941 */   // GIR_Coverage, 1658,
     /* 428941 */   GIR_Done,
     /* 428942 */ // Label 8517: @428942
     /* 428942 */ GIM_Reject,
     /* 428943 */ // Label 8514: @428943
     /* 428943 */ GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(428973), // Rule ID 1657 //
     /* 428948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 428951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 428954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428962 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 428962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 428967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428971 */   GIR_RootConstrainSelectedInstOperands,
     /* 428972 */   // GIR_Coverage, 1657,
     /* 428972 */   GIR_Done,
     /* 428973 */ // Label 8518: @428973
     /* 428973 */ GIM_Reject,
     /* 428974 */ // Label 8515: @428974
     /* 428974 */ GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(429004), // Rule ID 1656 //
     /* 428979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 428982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 428985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428993 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 428993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 428998 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429002 */   GIR_RootConstrainSelectedInstOperands,
     /* 429003 */   // GIR_Coverage, 1656,
     /* 429003 */   GIR_Done,
     /* 429004 */ // Label 8519: @429004
     /* 429004 */ GIM_Reject,
     /* 429005 */ // Label 8516: @429005
     /* 429005 */ GIM_Reject,
     /* 429006 */ // Label 140: @429006
     /* 429006 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8523*/ GIMT_Encode4(430238),
     /* 429017 */ /*GILLT_v2s64*//*Label 8520*/ GIMT_Encode4(429037), GIMT_Encode4(0),
     /* 429025 */ /*GILLT_v4s32*//*Label 8521*/ GIMT_Encode4(429598), GIMT_Encode4(0),
     /* 429033 */ /*GILLT_v8s16*//*Label 8522*/ GIMT_Encode4(430159),
     /* 429037 */ // Label 8520: @429037
     /* 429037 */ GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(429597),
     /* 429042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 429048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429052 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(429144), // Rule ID 2054 //
     /* 429057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429101 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429105 */     // MIs[3] Operand 1
     /* 429105 */     // No operand predicates
     /* 429105 */     // MIs[1] Operand 2
     /* 429105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 429116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429125 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 429128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429142 */     GIR_RootConstrainSelectedInstOperands,
     /* 429143 */     // GIR_Coverage, 2054,
     /* 429143 */     GIR_EraseRootFromParent_Done,
     /* 429144 */   // Label 8525: @429144
     /* 429144 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(429236), // Rule ID 13580 //
     /* 429149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429193 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429197 */     // MIs[3] Operand 1
     /* 429197 */     // No operand predicates
     /* 429197 */     // MIs[1] Operand 2
     /* 429197 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 429208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429217 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 429220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429234 */     GIR_RootConstrainSelectedInstOperands,
     /* 429235 */     // GIR_Coverage, 13580,
     /* 429235 */     GIR_EraseRootFromParent_Done,
     /* 429236 */   // Label 8526: @429236
     /* 429236 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(429322), // Rule ID 13578 //
     /* 429241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429289 */     // MIs[3] Operand 1
     /* 429289 */     // No operand predicates
     /* 429289 */     // MIs[1] Operand 2
     /* 429289 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 429300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429306 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 429309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429320 */     GIR_RootConstrainSelectedInstOperands,
     /* 429321 */     // GIR_Coverage, 13578,
     /* 429321 */     GIR_EraseRootFromParent_Done,
     /* 429322 */   // Label 8527: @429322
     /* 429322 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(429408), // Rule ID 2052 //
     /* 429327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429375 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429379 */     // MIs[3] Operand 1
     /* 429379 */     // No operand predicates
     /* 429379 */     // MIs[1] Operand 2
     /* 429379 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 429390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429392 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 429395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429406 */     GIR_RootConstrainSelectedInstOperands,
     /* 429407 */     // GIR_Coverage, 2052,
     /* 429407 */     GIR_EraseRootFromParent_Done,
     /* 429408 */   // Label 8528: @429408
     /* 429408 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(429447), // Rule ID 1741 //
     /* 429413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429430 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 429430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 429433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 429445 */     GIR_RootConstrainSelectedInstOperands,
     /* 429446 */     // GIR_Coverage, 1741,
     /* 429446 */     GIR_EraseRootFromParent_Done,
     /* 429447 */   // Label 8529: @429447
     /* 429447 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(429510), // Rule ID 13579 //
     /* 429452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 429471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429484 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429488 */     // MIs[2] Operand 1
     /* 429488 */     // No operand predicates
     /* 429488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429494 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 429497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 429505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 429508 */     GIR_RootConstrainSelectedInstOperands,
     /* 429509 */     // GIR_Coverage, 13579,
     /* 429509 */     GIR_EraseRootFromParent_Done,
     /* 429510 */   // Label 8530: @429510
     /* 429510 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(429573), // Rule ID 2053 //
     /* 429515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 429538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429551 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429555 */     // MIs[2] Operand 1
     /* 429555 */     // No operand predicates
     /* 429555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429557 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 429560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 429568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 429571 */     GIR_RootConstrainSelectedInstOperands,
     /* 429572 */     // GIR_Coverage, 2053,
     /* 429572 */     GIR_EraseRootFromParent_Done,
     /* 429573 */   // Label 8531: @429573
     /* 429573 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(429596), // Rule ID 1740 //
     /* 429578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429589 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 429589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 429594 */     GIR_RootConstrainSelectedInstOperands,
     /* 429595 */     // GIR_Coverage, 1740,
     /* 429595 */     GIR_Done,
     /* 429596 */   // Label 8532: @429596
     /* 429596 */   GIM_Reject,
     /* 429597 */ // Label 8524: @429597
     /* 429597 */ GIM_Reject,
     /* 429598 */ // Label 8521: @429598
     /* 429598 */ GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(430158),
     /* 429603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 429609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429613 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(429705), // Rule ID 2051 //
     /* 429618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 429641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 429654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429662 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 429666 */     // MIs[3] Operand 1
     /* 429666 */     // No operand predicates
     /* 429666 */     // MIs[1] Operand 2
     /* 429666 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 429677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 429686 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 429689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429703 */     GIR_RootConstrainSelectedInstOperands,
     /* 429704 */     // GIR_Coverage, 2051,
     /* 429704 */     GIR_EraseRootFromParent_Done,
     /* 429705 */   // Label 8534: @429705
     /* 429705 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(429797), // Rule ID 13577 //
     /* 429710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 429733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 429746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429754 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 429758 */     // MIs[3] Operand 1
     /* 429758 */     // No operand predicates
     /* 429758 */     // MIs[1] Operand 2
     /* 429758 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 429769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 429778 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 429781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429795 */     GIR_RootConstrainSelectedInstOperands,
     /* 429796 */     // GIR_Coverage, 13577,
     /* 429796 */     GIR_EraseRootFromParent_Done,
     /* 429797 */   // Label 8535: @429797
     /* 429797 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(429883), // Rule ID 13575 //
     /* 429802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 429825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 429838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429846 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 429850 */     // MIs[3] Operand 1
     /* 429850 */     // No operand predicates
     /* 429850 */     // MIs[1] Operand 2
     /* 429850 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 429861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429867 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 429870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429881 */     GIR_RootConstrainSelectedInstOperands,
     /* 429882 */     // GIR_Coverage, 13575,
     /* 429882 */     GIR_EraseRootFromParent_Done,
     /* 429883 */   // Label 8536: @429883
     /* 429883 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(429969), // Rule ID 2049 //
     /* 429888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 429915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 429928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429936 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 429940 */     // MIs[3] Operand 1
     /* 429940 */     // No operand predicates
     /* 429940 */     // MIs[1] Operand 2
     /* 429940 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 429951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429953 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 429956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429967 */     GIR_RootConstrainSelectedInstOperands,
     /* 429968 */     // GIR_Coverage, 2049,
     /* 429968 */     GIR_EraseRootFromParent_Done,
     /* 429969 */   // Label 8537: @429969
     /* 429969 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(430008), // Rule ID 1739 //
     /* 429974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 429984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 429991 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 429991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 429994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 430006 */     GIR_RootConstrainSelectedInstOperands,
     /* 430007 */     // GIR_Coverage, 1739,
     /* 430007 */     GIR_EraseRootFromParent_Done,
     /* 430008 */   // Label 8538: @430008
     /* 430008 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(430071), // Rule ID 13576 //
     /* 430013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 430032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 430041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430045 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430049 */     // MIs[2] Operand 1
     /* 430049 */     // No operand predicates
     /* 430049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430055 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 430058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 430066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 430069 */     GIR_RootConstrainSelectedInstOperands,
     /* 430070 */     // GIR_Coverage, 13576,
     /* 430070 */     GIR_EraseRootFromParent_Done,
     /* 430071 */   // Label 8539: @430071
     /* 430071 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(430134), // Rule ID 2050 //
     /* 430076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 430099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 430108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430112 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430116 */     // MIs[2] Operand 1
     /* 430116 */     // No operand predicates
     /* 430116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430118 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 430121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 430129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 430132 */     GIR_RootConstrainSelectedInstOperands,
     /* 430133 */     // GIR_Coverage, 2050,
     /* 430133 */     GIR_EraseRootFromParent_Done,
     /* 430134 */   // Label 8540: @430134
     /* 430134 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(430157), // Rule ID 1738 //
     /* 430139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430150 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 430150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 430155 */     GIR_RootConstrainSelectedInstOperands,
     /* 430156 */     // GIR_Coverage, 1738,
     /* 430156 */     GIR_Done,
     /* 430157 */   // Label 8541: @430157
     /* 430157 */   GIM_Reject,
     /* 430158 */ // Label 8533: @430158
     /* 430158 */ GIM_Reject,
     /* 430159 */ // Label 8522: @430159
     /* 430159 */ GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(430237),
     /* 430164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 430170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430174 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(430213), // Rule ID 1737 //
     /* 430179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 430189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 430196 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 430196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 430199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 430211 */     GIR_RootConstrainSelectedInstOperands,
     /* 430212 */     // GIR_Coverage, 1737,
     /* 430212 */     GIR_EraseRootFromParent_Done,
     /* 430213 */   // Label 8543: @430213
     /* 430213 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(430236), // Rule ID 1736 //
     /* 430218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430229 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 430229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 430234 */     GIR_RootConstrainSelectedInstOperands,
     /* 430235 */     // GIR_Coverage, 1736,
     /* 430235 */     GIR_Done,
     /* 430236 */   // Label 8544: @430236
     /* 430236 */   GIM_Reject,
     /* 430237 */ // Label 8542: @430237
     /* 430237 */ GIM_Reject,
     /* 430238 */ // Label 8523: @430238
     /* 430238 */ GIM_Reject,
     /* 430239 */ // Label 141: @430239
     /* 430239 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8563*/ GIMT_Encode4(431018),
     /* 430250 */ /*GILLT_v2s32*//*Label 8545*/ GIMT_Encode4(430326),
     /* 430254 */ /*GILLT_v2s64*//*Label 8546*/ GIMT_Encode4(430381),
     /* 430258 */ /*GILLT_v4s16*//*Label 8547*/ GIMT_Encode4(430436),
     /* 430262 */ /*GILLT_v4s32*//*Label 8548*/ GIMT_Encode4(430491),
     /* 430266 */ /*GILLT_v8s8*//*Label 8549*/ GIMT_Encode4(430546),
     /* 430270 */ /*GILLT_v8s16*//*Label 8550*/ GIMT_Encode4(430580),
     /* 430274 */ /*GILLT_v16s8*//*Label 8551*/ GIMT_Encode4(430635), GIMT_Encode4(0),
     /* 430282 */ /*GILLT_nxv2s1*//*Label 8552*/ GIMT_Encode4(430669),
     /* 430286 */ /*GILLT_nxv2s16*//*Label 8553*/ GIMT_Encode4(430695),
     /* 430290 */ /*GILLT_nxv2s32*//*Label 8554*/ GIMT_Encode4(430721),
     /* 430294 */ /*GILLT_nxv2s64*//*Label 8555*/ GIMT_Encode4(430747),
     /* 430298 */ /*GILLT_nxv4s1*//*Label 8556*/ GIMT_Encode4(430794),
     /* 430302 */ /*GILLT_nxv4s16*//*Label 8557*/ GIMT_Encode4(430820),
     /* 430306 */ /*GILLT_nxv4s32*//*Label 8558*/ GIMT_Encode4(430846),
     /* 430310 */ /*GILLT_nxv8s1*//*Label 8559*/ GIMT_Encode4(430893),
     /* 430314 */ /*GILLT_nxv8s16*//*Label 8560*/ GIMT_Encode4(430919),
     /* 430318 */ /*GILLT_nxv16s1*//*Label 8561*/ GIMT_Encode4(430966),
     /* 430322 */ /*GILLT_nxv16s8*//*Label 8562*/ GIMT_Encode4(430992),
     /* 430326 */ // Label 8545: @430326
     /* 430326 */ GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(430380),
     /* 430331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 430337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430349 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(430364), // Rule ID 1874 //
     /* 430354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430357 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 430357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 430362 */     GIR_RootConstrainSelectedInstOperands,
     /* 430363 */     // GIR_Coverage, 1874,
     /* 430363 */     GIR_Done,
     /* 430364 */   // Label 8565: @430364
     /* 430364 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(430379), // Rule ID 2498 //
     /* 430369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430372 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 430372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 430377 */     GIR_RootConstrainSelectedInstOperands,
     /* 430378 */     // GIR_Coverage, 2498,
     /* 430378 */     GIR_Done,
     /* 430379 */   // Label 8566: @430379
     /* 430379 */   GIM_Reject,
     /* 430380 */ // Label 8564: @430380
     /* 430380 */ GIM_Reject,
     /* 430381 */ // Label 8546: @430381
     /* 430381 */ GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(430435),
     /* 430386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 430389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 430392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430404 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(430419), // Rule ID 1876 //
     /* 430409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430412 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 430412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 430417 */     GIR_RootConstrainSelectedInstOperands,
     /* 430418 */     // GIR_Coverage, 1876,
     /* 430418 */     GIR_Done,
     /* 430419 */   // Label 8568: @430419
     /* 430419 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(430434), // Rule ID 2500 //
     /* 430424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430427 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 430427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 430432 */     GIR_RootConstrainSelectedInstOperands,
     /* 430433 */     // GIR_Coverage, 2500,
     /* 430433 */     GIR_Done,
     /* 430434 */   // Label 8569: @430434
     /* 430434 */   GIM_Reject,
     /* 430435 */ // Label 8567: @430435
     /* 430435 */ GIM_Reject,
     /* 430436 */ // Label 8547: @430436
     /* 430436 */ GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(430490),
     /* 430441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 430447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430459 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(430474), // Rule ID 1872 //
     /* 430464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430467 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 430467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 430472 */     GIR_RootConstrainSelectedInstOperands,
     /* 430473 */     // GIR_Coverage, 1872,
     /* 430473 */     GIR_Done,
     /* 430474 */   // Label 8571: @430474
     /* 430474 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(430489), // Rule ID 2496 //
     /* 430479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430482 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 430482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 430487 */     GIR_RootConstrainSelectedInstOperands,
     /* 430488 */     // GIR_Coverage, 2496,
     /* 430488 */     GIR_Done,
     /* 430489 */   // Label 8572: @430489
     /* 430489 */   GIM_Reject,
     /* 430490 */ // Label 8570: @430490
     /* 430490 */ GIM_Reject,
     /* 430491 */ // Label 8548: @430491
     /* 430491 */ GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(430545),
     /* 430496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 430502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430514 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(430529), // Rule ID 1875 //
     /* 430519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430522 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 430522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 430527 */     GIR_RootConstrainSelectedInstOperands,
     /* 430528 */     // GIR_Coverage, 1875,
     /* 430528 */     GIR_Done,
     /* 430529 */   // Label 8574: @430529
     /* 430529 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(430544), // Rule ID 2499 //
     /* 430534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430537 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 430537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 430542 */     GIR_RootConstrainSelectedInstOperands,
     /* 430543 */     // GIR_Coverage, 2499,
     /* 430543 */     GIR_Done,
     /* 430544 */   // Label 8575: @430544
     /* 430544 */   GIM_Reject,
     /* 430545 */ // Label 8573: @430545
     /* 430545 */ GIM_Reject,
     /* 430546 */ // Label 8549: @430546
     /* 430546 */ GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(430579), // Rule ID 1870 //
     /* 430551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 430560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430572 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 430572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 430577 */   GIR_RootConstrainSelectedInstOperands,
     /* 430578 */   // GIR_Coverage, 1870,
     /* 430578 */   GIR_Done,
     /* 430579 */ // Label 8576: @430579
     /* 430579 */ GIM_Reject,
     /* 430580 */ // Label 8550: @430580
     /* 430580 */ GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(430634),
     /* 430585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 430591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430603 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(430618), // Rule ID 1873 //
     /* 430608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430611 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 430611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 430616 */     GIR_RootConstrainSelectedInstOperands,
     /* 430617 */     // GIR_Coverage, 1873,
     /* 430617 */     GIR_Done,
     /* 430618 */   // Label 8578: @430618
     /* 430618 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(430633), // Rule ID 2497 //
     /* 430623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430626 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 430626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 430631 */     GIR_RootConstrainSelectedInstOperands,
     /* 430632 */     // GIR_Coverage, 2497,
     /* 430632 */     GIR_Done,
     /* 430633 */   // Label 8579: @430633
     /* 430633 */   GIM_Reject,
     /* 430634 */ // Label 8577: @430634
     /* 430634 */ GIM_Reject,
     /* 430635 */ // Label 8551: @430635
     /* 430635 */ GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(430668), // Rule ID 1871 //
     /* 430640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 430646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 430649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430661 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 430661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 430666 */   GIR_RootConstrainSelectedInstOperands,
     /* 430667 */   // GIR_Coverage, 1871,
     /* 430667 */   GIR_Done,
     /* 430668 */ // Label 8580: @430668
     /* 430668 */ GIM_Reject,
     /* 430669 */ // Label 8552: @430669
     /* 430669 */ GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(430694), // Rule ID 9015 //
     /* 430674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 430680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 430683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 430687 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 430687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 430692 */   GIR_RootConstrainSelectedInstOperands,
     /* 430693 */   // GIR_Coverage, 9015,
     /* 430693 */   GIR_Done,
     /* 430694 */ // Label 8581: @430694
     /* 430694 */ GIM_Reject,
     /* 430695 */ // Label 8553: @430695
     /* 430695 */ GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(430720), // Rule ID 8991 //
     /* 430700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 430706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 430709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430713 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 430713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 430718 */   GIR_RootConstrainSelectedInstOperands,
     /* 430719 */   // GIR_Coverage, 8991,
     /* 430719 */   GIR_Done,
     /* 430720 */ // Label 8582: @430720
     /* 430720 */ GIM_Reject,
     /* 430721 */ // Label 8554: @430721
     /* 430721 */ GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(430746), // Rule ID 8992 //
     /* 430726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 430732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 430735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430739 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 430739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 430744 */   GIR_RootConstrainSelectedInstOperands,
     /* 430745 */   // GIR_Coverage, 8992,
     /* 430745 */   GIR_Done,
     /* 430746 */ // Label 8583: @430746
     /* 430746 */ GIM_Reject,
     /* 430747 */ // Label 8555: @430747
     /* 430747 */ GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(430793),
     /* 430752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 430755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 430758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430762 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(430777), // Rule ID 8987 //
     /* 430767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430770 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 430770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 430775 */     GIR_RootConstrainSelectedInstOperands,
     /* 430776 */     // GIR_Coverage, 8987,
     /* 430776 */     GIR_Done,
     /* 430777 */   // Label 8585: @430777
     /* 430777 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(430792), // Rule ID 8993 //
     /* 430782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430785 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 430785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 430790 */     GIR_RootConstrainSelectedInstOperands,
     /* 430791 */     // GIR_Coverage, 8993,
     /* 430791 */     GIR_Done,
     /* 430792 */   // Label 8586: @430792
     /* 430792 */   GIM_Reject,
     /* 430793 */ // Label 8584: @430793
     /* 430793 */ GIM_Reject,
     /* 430794 */ // Label 8556: @430794
     /* 430794 */ GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(430819), // Rule ID 9014 //
     /* 430799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 430805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 430808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 430812 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 430812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 430817 */   GIR_RootConstrainSelectedInstOperands,
     /* 430818 */   // GIR_Coverage, 9014,
     /* 430818 */   GIR_Done,
     /* 430819 */ // Label 8587: @430819
     /* 430819 */ GIM_Reject,
     /* 430820 */ // Label 8557: @430820
     /* 430820 */ GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(430845), // Rule ID 8989 //
     /* 430825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 430831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 430834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430838 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 430838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 430843 */   GIR_RootConstrainSelectedInstOperands,
     /* 430844 */   // GIR_Coverage, 8989,
     /* 430844 */   GIR_Done,
     /* 430845 */ // Label 8588: @430845
     /* 430845 */ GIM_Reject,
     /* 430846 */ // Label 8558: @430846
     /* 430846 */ GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(430892),
     /* 430851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 430854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 430857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430861 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(430876), // Rule ID 8986 //
     /* 430866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430869 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 430869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 430874 */     GIR_RootConstrainSelectedInstOperands,
     /* 430875 */     // GIR_Coverage, 8986,
     /* 430875 */     GIR_Done,
     /* 430876 */   // Label 8590: @430876
     /* 430876 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(430891), // Rule ID 8990 //
     /* 430881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430884 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 430884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 430889 */     GIR_RootConstrainSelectedInstOperands,
     /* 430890 */     // GIR_Coverage, 8990,
     /* 430890 */     GIR_Done,
     /* 430891 */   // Label 8591: @430891
     /* 430891 */   GIM_Reject,
     /* 430892 */ // Label 8589: @430892
     /* 430892 */ GIM_Reject,
     /* 430893 */ // Label 8559: @430893
     /* 430893 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(430918), // Rule ID 9013 //
     /* 430898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 430904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 430907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 430911 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 430911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 430916 */   GIR_RootConstrainSelectedInstOperands,
     /* 430917 */   // GIR_Coverage, 9013,
     /* 430917 */   GIR_Done,
     /* 430918 */ // Label 8592: @430918
     /* 430918 */ GIM_Reject,
     /* 430919 */ // Label 8560: @430919
     /* 430919 */ GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(430965),
     /* 430924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 430927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 430930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430934 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(430949), // Rule ID 8985 //
     /* 430939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430942 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 430942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 430947 */     GIR_RootConstrainSelectedInstOperands,
     /* 430948 */     // GIR_Coverage, 8985,
     /* 430948 */     GIR_Done,
     /* 430949 */   // Label 8594: @430949
     /* 430949 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(430964), // Rule ID 8988 //
     /* 430954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430957 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 430957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 430962 */     GIR_RootConstrainSelectedInstOperands,
     /* 430963 */     // GIR_Coverage, 8988,
     /* 430963 */     GIR_Done,
     /* 430964 */   // Label 8595: @430964
     /* 430964 */   GIM_Reject,
     /* 430965 */ // Label 8593: @430965
     /* 430965 */ GIM_Reject,
     /* 430966 */ // Label 8561: @430966
     /* 430966 */ GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(430991), // Rule ID 2414 //
     /* 430971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 430977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 430980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 430984 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 430984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 430989 */   GIR_RootConstrainSelectedInstOperands,
     /* 430990 */   // GIR_Coverage, 2414,
     /* 430990 */   GIR_Done,
     /* 430991 */ // Label 8596: @430991
     /* 430991 */ GIM_Reject,
     /* 430992 */ // Label 8562: @430992
     /* 430992 */ GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(431017), // Rule ID 8984 //
     /* 430997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 431003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 431006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431010 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 431010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 431015 */   GIR_RootConstrainSelectedInstOperands,
     /* 431016 */   // GIR_Coverage, 8984,
     /* 431016 */   GIR_Done,
     /* 431017 */ // Label 8597: @431017
     /* 431017 */ GIM_Reject,
     /* 431018 */ // Label 8563: @431018
     /* 431018 */ GIM_Reject,
     /* 431019 */ // Label 142: @431019
     /* 431019 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8616*/ GIMT_Encode4(431798),
     /* 431030 */ /*GILLT_v2s32*//*Label 8598*/ GIMT_Encode4(431106),
     /* 431034 */ /*GILLT_v2s64*//*Label 8599*/ GIMT_Encode4(431161),
     /* 431038 */ /*GILLT_v4s16*//*Label 8600*/ GIMT_Encode4(431216),
     /* 431042 */ /*GILLT_v4s32*//*Label 8601*/ GIMT_Encode4(431271),
     /* 431046 */ /*GILLT_v8s8*//*Label 8602*/ GIMT_Encode4(431326),
     /* 431050 */ /*GILLT_v8s16*//*Label 8603*/ GIMT_Encode4(431360),
     /* 431054 */ /*GILLT_v16s8*//*Label 8604*/ GIMT_Encode4(431415), GIMT_Encode4(0),
     /* 431062 */ /*GILLT_nxv2s1*//*Label 8605*/ GIMT_Encode4(431449),
     /* 431066 */ /*GILLT_nxv2s16*//*Label 8606*/ GIMT_Encode4(431475),
     /* 431070 */ /*GILLT_nxv2s32*//*Label 8607*/ GIMT_Encode4(431501),
     /* 431074 */ /*GILLT_nxv2s64*//*Label 8608*/ GIMT_Encode4(431527),
     /* 431078 */ /*GILLT_nxv4s1*//*Label 8609*/ GIMT_Encode4(431574),
     /* 431082 */ /*GILLT_nxv4s16*//*Label 8610*/ GIMT_Encode4(431600),
     /* 431086 */ /*GILLT_nxv4s32*//*Label 8611*/ GIMT_Encode4(431626),
     /* 431090 */ /*GILLT_nxv8s1*//*Label 8612*/ GIMT_Encode4(431673),
     /* 431094 */ /*GILLT_nxv8s16*//*Label 8613*/ GIMT_Encode4(431699),
     /* 431098 */ /*GILLT_nxv16s1*//*Label 8614*/ GIMT_Encode4(431746),
     /* 431102 */ /*GILLT_nxv16s8*//*Label 8615*/ GIMT_Encode4(431772),
     /* 431106 */ // Label 8598: @431106
     /* 431106 */ GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(431160),
     /* 431111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 431117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431129 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(431144), // Rule ID 1881 //
     /* 431134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431137 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 431137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 431142 */     GIR_RootConstrainSelectedInstOperands,
     /* 431143 */     // GIR_Coverage, 1881,
     /* 431143 */     GIR_Done,
     /* 431144 */   // Label 8618: @431144
     /* 431144 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(431159), // Rule ID 5481 //
     /* 431149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431152 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 431152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 431157 */     GIR_RootConstrainSelectedInstOperands,
     /* 431158 */     // GIR_Coverage, 5481,
     /* 431158 */     GIR_Done,
     /* 431159 */   // Label 8619: @431159
     /* 431159 */   GIM_Reject,
     /* 431160 */ // Label 8617: @431160
     /* 431160 */ GIM_Reject,
     /* 431161 */ // Label 8599: @431161
     /* 431161 */ GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(431215),
     /* 431166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 431169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 431172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431184 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(431199), // Rule ID 1883 //
     /* 431189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431192 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 431192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 431197 */     GIR_RootConstrainSelectedInstOperands,
     /* 431198 */     // GIR_Coverage, 1883,
     /* 431198 */     GIR_Done,
     /* 431199 */   // Label 8621: @431199
     /* 431199 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(431214), // Rule ID 5483 //
     /* 431204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431207 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 431207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 431212 */     GIR_RootConstrainSelectedInstOperands,
     /* 431213 */     // GIR_Coverage, 5483,
     /* 431213 */     GIR_Done,
     /* 431214 */   // Label 8622: @431214
     /* 431214 */   GIM_Reject,
     /* 431215 */ // Label 8620: @431215
     /* 431215 */ GIM_Reject,
     /* 431216 */ // Label 8600: @431216
     /* 431216 */ GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(431270),
     /* 431221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 431227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431239 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(431254), // Rule ID 1879 //
     /* 431244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431247 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 431247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 431252 */     GIR_RootConstrainSelectedInstOperands,
     /* 431253 */     // GIR_Coverage, 1879,
     /* 431253 */     GIR_Done,
     /* 431254 */   // Label 8624: @431254
     /* 431254 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(431269), // Rule ID 5479 //
     /* 431259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431262 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 431262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 431267 */     GIR_RootConstrainSelectedInstOperands,
     /* 431268 */     // GIR_Coverage, 5479,
     /* 431268 */     GIR_Done,
     /* 431269 */   // Label 8625: @431269
     /* 431269 */   GIM_Reject,
     /* 431270 */ // Label 8623: @431270
     /* 431270 */ GIM_Reject,
     /* 431271 */ // Label 8601: @431271
     /* 431271 */ GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(431325),
     /* 431276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 431282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431294 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(431309), // Rule ID 1882 //
     /* 431299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431302 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 431302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 431307 */     GIR_RootConstrainSelectedInstOperands,
     /* 431308 */     // GIR_Coverage, 1882,
     /* 431308 */     GIR_Done,
     /* 431309 */   // Label 8627: @431309
     /* 431309 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(431324), // Rule ID 5482 //
     /* 431314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431317 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 431317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 431322 */     GIR_RootConstrainSelectedInstOperands,
     /* 431323 */     // GIR_Coverage, 5482,
     /* 431323 */     GIR_Done,
     /* 431324 */   // Label 8628: @431324
     /* 431324 */   GIM_Reject,
     /* 431325 */ // Label 8626: @431325
     /* 431325 */ GIM_Reject,
     /* 431326 */ // Label 8602: @431326
     /* 431326 */ GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(431359), // Rule ID 1877 //
     /* 431331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 431340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431352 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 431352 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 431357 */   GIR_RootConstrainSelectedInstOperands,
     /* 431358 */   // GIR_Coverage, 1877,
     /* 431358 */   GIR_Done,
     /* 431359 */ // Label 8629: @431359
     /* 431359 */ GIM_Reject,
     /* 431360 */ // Label 8603: @431360
     /* 431360 */ GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(431414),
     /* 431365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 431371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431383 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(431398), // Rule ID 1880 //
     /* 431388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431391 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 431391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 431396 */     GIR_RootConstrainSelectedInstOperands,
     /* 431397 */     // GIR_Coverage, 1880,
     /* 431397 */     GIR_Done,
     /* 431398 */   // Label 8631: @431398
     /* 431398 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(431413), // Rule ID 5480 //
     /* 431403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431406 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 431406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 431411 */     GIR_RootConstrainSelectedInstOperands,
     /* 431412 */     // GIR_Coverage, 5480,
     /* 431412 */     GIR_Done,
     /* 431413 */   // Label 8632: @431413
     /* 431413 */   GIM_Reject,
     /* 431414 */ // Label 8630: @431414
     /* 431414 */ GIM_Reject,
     /* 431415 */ // Label 8604: @431415
     /* 431415 */ GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(431448), // Rule ID 1878 //
     /* 431420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 431429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431441 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 431441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 431446 */   GIR_RootConstrainSelectedInstOperands,
     /* 431447 */   // GIR_Coverage, 1878,
     /* 431447 */   GIR_Done,
     /* 431448 */ // Label 8633: @431448
     /* 431448 */ GIM_Reject,
     /* 431449 */ // Label 8605: @431449
     /* 431449 */ GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(431474), // Rule ID 9018 //
     /* 431454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 431460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 431463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431467 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 431467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 431472 */   GIR_RootConstrainSelectedInstOperands,
     /* 431473 */   // GIR_Coverage, 9018,
     /* 431473 */   GIR_Done,
     /* 431474 */ // Label 8634: @431474
     /* 431474 */ GIM_Reject,
     /* 431475 */ // Label 8606: @431475
     /* 431475 */ GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(431500), // Rule ID 9001 //
     /* 431480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 431486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 431489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431493 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 431493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 431498 */   GIR_RootConstrainSelectedInstOperands,
     /* 431499 */   // GIR_Coverage, 9001,
     /* 431499 */   GIR_Done,
     /* 431500 */ // Label 8635: @431500
     /* 431500 */ GIM_Reject,
     /* 431501 */ // Label 8607: @431501
     /* 431501 */ GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(431526), // Rule ID 9002 //
     /* 431506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 431512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 431515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431519 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 431519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 431524 */   GIR_RootConstrainSelectedInstOperands,
     /* 431525 */   // GIR_Coverage, 9002,
     /* 431525 */   GIR_Done,
     /* 431526 */ // Label 8636: @431526
     /* 431526 */ GIM_Reject,
     /* 431527 */ // Label 8608: @431527
     /* 431527 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(431573),
     /* 431532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 431535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 431538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431542 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(431557), // Rule ID 8997 //
     /* 431547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431550 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 431550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 431555 */     GIR_RootConstrainSelectedInstOperands,
     /* 431556 */     // GIR_Coverage, 8997,
     /* 431556 */     GIR_Done,
     /* 431557 */   // Label 8638: @431557
     /* 431557 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(431572), // Rule ID 9003 //
     /* 431562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431565 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 431565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 431570 */     GIR_RootConstrainSelectedInstOperands,
     /* 431571 */     // GIR_Coverage, 9003,
     /* 431571 */     GIR_Done,
     /* 431572 */   // Label 8639: @431572
     /* 431572 */   GIM_Reject,
     /* 431573 */ // Label 8637: @431573
     /* 431573 */ GIM_Reject,
     /* 431574 */ // Label 8609: @431574
     /* 431574 */ GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(431599), // Rule ID 9017 //
     /* 431579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 431585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 431588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431592 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 431592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 431597 */   GIR_RootConstrainSelectedInstOperands,
     /* 431598 */   // GIR_Coverage, 9017,
     /* 431598 */   GIR_Done,
     /* 431599 */ // Label 8640: @431599
     /* 431599 */ GIM_Reject,
     /* 431600 */ // Label 8610: @431600
     /* 431600 */ GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(431625), // Rule ID 8999 //
     /* 431605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 431611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 431614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431618 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 431618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 431623 */   GIR_RootConstrainSelectedInstOperands,
     /* 431624 */   // GIR_Coverage, 8999,
     /* 431624 */   GIR_Done,
     /* 431625 */ // Label 8641: @431625
     /* 431625 */ GIM_Reject,
     /* 431626 */ // Label 8611: @431626
     /* 431626 */ GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(431672),
     /* 431631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 431634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 431637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431641 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(431656), // Rule ID 8996 //
     /* 431646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431649 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 431649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 431654 */     GIR_RootConstrainSelectedInstOperands,
     /* 431655 */     // GIR_Coverage, 8996,
     /* 431655 */     GIR_Done,
     /* 431656 */   // Label 8643: @431656
     /* 431656 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(431671), // Rule ID 9000 //
     /* 431661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431664 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 431664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 431669 */     GIR_RootConstrainSelectedInstOperands,
     /* 431670 */     // GIR_Coverage, 9000,
     /* 431670 */     GIR_Done,
     /* 431671 */   // Label 8644: @431671
     /* 431671 */   GIM_Reject,
     /* 431672 */ // Label 8642: @431672
     /* 431672 */ GIM_Reject,
     /* 431673 */ // Label 8612: @431673
     /* 431673 */ GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(431698), // Rule ID 9016 //
     /* 431678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 431684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 431687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431691 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 431691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 431696 */   GIR_RootConstrainSelectedInstOperands,
     /* 431697 */   // GIR_Coverage, 9016,
     /* 431697 */   GIR_Done,
     /* 431698 */ // Label 8645: @431698
     /* 431698 */ GIM_Reject,
     /* 431699 */ // Label 8613: @431699
     /* 431699 */ GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(431745),
     /* 431704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 431707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 431710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431714 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(431729), // Rule ID 8995 //
     /* 431719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431722 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 431722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 431727 */     GIR_RootConstrainSelectedInstOperands,
     /* 431728 */     // GIR_Coverage, 8995,
     /* 431728 */     GIR_Done,
     /* 431729 */   // Label 8647: @431729
     /* 431729 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(431744), // Rule ID 8998 //
     /* 431734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431737 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 431737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 431742 */     GIR_RootConstrainSelectedInstOperands,
     /* 431743 */     // GIR_Coverage, 8998,
     /* 431743 */     GIR_Done,
     /* 431744 */   // Label 8648: @431744
     /* 431744 */   GIM_Reject,
     /* 431745 */ // Label 8646: @431745
     /* 431745 */ GIM_Reject,
     /* 431746 */ // Label 8614: @431746
     /* 431746 */ GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(431771), // Rule ID 2418 //
     /* 431751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 431757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 431760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431764 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 431764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 431769 */   GIR_RootConstrainSelectedInstOperands,
     /* 431770 */   // GIR_Coverage, 2418,
     /* 431770 */   GIR_Done,
     /* 431771 */ // Label 8649: @431771
     /* 431771 */ GIM_Reject,
     /* 431772 */ // Label 8615: @431772
     /* 431772 */ GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(431797), // Rule ID 8994 //
     /* 431777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 431783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 431786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431790 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 431790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 431795 */   GIR_RootConstrainSelectedInstOperands,
     /* 431796 */   // GIR_Coverage, 8994,
     /* 431796 */   GIR_Done,
     /* 431797 */ // Label 8650: @431797
     /* 431797 */ GIM_Reject,
     /* 431798 */ // Label 8616: @431798
     /* 431798 */ GIM_Reject,
     /* 431799 */ // Label 143: @431799
     /* 431799 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8657*/ GIMT_Encode4(432004),
     /* 431810 */ /*GILLT_s64*//*Label 8651*/ GIMT_Encode4(431842), GIMT_Encode4(0),
     /* 431818 */ /*GILLT_v2s32*//*Label 8652*/ GIMT_Encode4(431869),
     /* 431822 */ /*GILLT_v2s64*//*Label 8653*/ GIMT_Encode4(431896),
     /* 431826 */ /*GILLT_v4s16*//*Label 8654*/ GIMT_Encode4(431923),
     /* 431830 */ /*GILLT_v4s32*//*Label 8655*/ GIMT_Encode4(431950), GIMT_Encode4(0),
     /* 431838 */ /*GILLT_v8s16*//*Label 8656*/ GIMT_Encode4(431977),
     /* 431842 */ // Label 8651: @431842
     /* 431842 */ GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(431868), // Rule ID 1069 //
     /* 431847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431861 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 431861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 431866 */   GIR_RootConstrainSelectedInstOperands,
     /* 431867 */   // GIR_Coverage, 1069,
     /* 431867 */   GIR_Done,
     /* 431868 */ // Label 8658: @431868
     /* 431868 */ GIM_Reject,
     /* 431869 */ // Label 8652: @431869
     /* 431869 */ GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(431895), // Rule ID 1065 //
     /* 431874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431888 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 431888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 431893 */   GIR_RootConstrainSelectedInstOperands,
     /* 431894 */   // GIR_Coverage, 1065,
     /* 431894 */   GIR_Done,
     /* 431895 */ // Label 8659: @431895
     /* 431895 */ GIM_Reject,
     /* 431896 */ // Label 8653: @431896
     /* 431896 */ GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(431922), // Rule ID 1071 //
     /* 431901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431915 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 431915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 431920 */   GIR_RootConstrainSelectedInstOperands,
     /* 431921 */   // GIR_Coverage, 1071,
     /* 431921 */   GIR_Done,
     /* 431922 */ // Label 8660: @431922
     /* 431922 */ GIM_Reject,
     /* 431923 */ // Label 8654: @431923
     /* 431923 */ GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(431949), // Rule ID 1061 //
     /* 431928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431942 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 431942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 431947 */   GIR_RootConstrainSelectedInstOperands,
     /* 431948 */   // GIR_Coverage, 1061,
     /* 431948 */   GIR_Done,
     /* 431949 */ // Label 8661: @431949
     /* 431949 */ GIM_Reject,
     /* 431950 */ // Label 8655: @431950
     /* 431950 */ GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(431976), // Rule ID 1067 //
     /* 431955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431969 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 431969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 431974 */   GIR_RootConstrainSelectedInstOperands,
     /* 431975 */   // GIR_Coverage, 1067,
     /* 431975 */   GIR_Done,
     /* 431976 */ // Label 8662: @431976
     /* 431976 */ GIM_Reject,
     /* 431977 */ // Label 8656: @431977
     /* 431977 */ GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(432003), // Rule ID 1063 //
     /* 431982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431996 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 431996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 432001 */   GIR_RootConstrainSelectedInstOperands,
     /* 432002 */   // GIR_Coverage, 1063,
     /* 432002 */   GIR_Done,
     /* 432003 */ // Label 8663: @432003
     /* 432003 */ GIM_Reject,
     /* 432004 */ // Label 8657: @432004
     /* 432004 */ GIM_Reject,
     /* 432005 */ // Label 144: @432005
     /* 432005 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8666*/ GIMT_Encode4(432871),
     /* 432016 */ /*GILLT_v2s64*//*Label 8664*/ GIMT_Encode4(432028), GIMT_Encode4(0),
     /* 432024 */ /*GILLT_v4s32*//*Label 8665*/ GIMT_Encode4(432322),
     /* 432028 */ // Label 8664: @432028
     /* 432028 */ GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(432110), // Rule ID 5894 //
     /* 432033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 432048 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 432051 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 432056 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 432060 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432065 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432067 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 432067 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 432070 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 432074 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432079 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 432083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432109 */   // GIR_Coverage, 5894,
     /* 432109 */   GIR_EraseRootFromParent_Done,
     /* 432110 */ // Label 8667: @432110
     /* 432110 */ GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(432184), // Rule ID 5893 //
     /* 432115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432122 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 432130 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432134 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432139 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432141 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 432141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 432144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 432148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432153 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 432157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432178 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432183 */   // GIR_Coverage, 5893,
     /* 432183 */   GIR_EraseRootFromParent_Done,
     /* 432184 */ // Label 8668: @432184
     /* 432184 */ GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(432243), // Rule ID 5903 //
     /* 432189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432200 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 432200 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 432203 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 432207 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432212 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 432232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432242 */   // GIR_Coverage, 5903,
     /* 432242 */   GIR_EraseRootFromParent_Done,
     /* 432243 */ // Label 8669: @432243
     /* 432243 */ GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(432321), // Rule ID 6031 //
     /* 432248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432259 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 432259 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 432262 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 432266 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432271 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 432277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 432280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 432284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 432294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 432302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 432305 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432310 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432320 */   // GIR_Coverage, 6031,
     /* 432320 */   GIR_EraseRootFromParent_Done,
     /* 432321 */ // Label 8670: @432321
     /* 432321 */ GIM_Reject,
     /* 432322 */ // Label 8665: @432322
     /* 432322 */ GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(432404), // Rule ID 5896 //
     /* 432327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 432342 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 432345 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 432350 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 432354 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432359 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432361 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 432361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 432368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432373 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 432377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432403 */   // GIR_Coverage, 5896,
     /* 432403 */   GIR_EraseRootFromParent_Done,
     /* 432404 */ // Label 8671: @432404
     /* 432404 */ GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(432486), // Rule ID 5898 //
     /* 432409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432416 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432420 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 432424 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 432427 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 432432 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 432436 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432441 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432443 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 432443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 432450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432455 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 432459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432469 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432480 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432485 */   // GIR_Coverage, 5898,
     /* 432485 */   GIR_EraseRootFromParent_Done,
     /* 432486 */ // Label 8672: @432486
     /* 432486 */ GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(432560), // Rule ID 5895 //
     /* 432491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432498 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432502 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 432506 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 432510 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432517 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 432517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 432524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432529 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 432533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432559 */   // GIR_Coverage, 5895,
     /* 432559 */   GIR_EraseRootFromParent_Done,
     /* 432560 */ // Label 8673: @432560
     /* 432560 */ GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(432634), // Rule ID 5897 //
     /* 432565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432572 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 432580 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432584 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432591 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 432591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 432598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432603 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 432607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432628 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432633 */   // GIR_Coverage, 5897,
     /* 432633 */   GIR_EraseRootFromParent_Done,
     /* 432634 */ // Label 8674: @432634
     /* 432634 */ GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(432693), // Rule ID 5899 //
     /* 432639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432650 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 432650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 432657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432662 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432692 */   // GIR_Coverage, 5899,
     /* 432692 */   GIR_EraseRootFromParent_Done,
     /* 432693 */ // Label 8675: @432693
     /* 432693 */ GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(432752), // Rule ID 5900 //
     /* 432698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432709 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 432709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 432712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 432716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432721 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432751 */   // GIR_Coverage, 5900,
     /* 432751 */   GIR_EraseRootFromParent_Done,
     /* 432752 */ // Label 8676: @432752
     /* 432752 */ GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(432811), // Rule ID 5901 //
     /* 432757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 432760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432768 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 432768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 432775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432780 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432800 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432810 */   // GIR_Coverage, 5901,
     /* 432810 */   GIR_EraseRootFromParent_Done,
     /* 432811 */ // Label 8677: @432811
     /* 432811 */ GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(432870), // Rule ID 5902 //
     /* 432816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432827 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 432827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 432830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 432834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432839 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432859 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432864 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432869 */   // GIR_Coverage, 5902,
     /* 432869 */   GIR_EraseRootFromParent_Done,
     /* 432870 */ // Label 8678: @432870
     /* 432870 */ GIM_Reject,
     /* 432871 */ // Label 8666: @432871
     /* 432871 */ GIM_Reject,
     /* 432872 */ // Label 145: @432872
     /* 432872 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8683*/ GIMT_Encode4(433241),
     /* 432883 */ /*GILLT_v2s32*//*Label 8679*/ GIMT_Encode4(432943), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 432895 */ /*GILLT_v4s32*//*Label 8680*/ GIMT_Encode4(433063), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 432927 */ /*GILLT_nxv2s64*//*Label 8681*/ GIMT_Encode4(433183), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 432939 */ /*GILLT_nxv4s32*//*Label 8682*/ GIMT_Encode4(433212),
     /* 432943 */ // Label 8679: @432943
     /* 432943 */ GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(433062),
     /* 432948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 432954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 432957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432969 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(433042), // Rule ID 28 //
     /* 432974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 432977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 432981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 432985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433018 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433022 */     // MIs[3] Operand 1
     /* 433022 */     // No operand predicates
     /* 433022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433024 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 433027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 433031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433040 */     GIR_RootConstrainSelectedInstOperands,
     /* 433041 */     // GIR_Coverage, 28,
     /* 433041 */     GIR_EraseRootFromParent_Done,
     /* 433042 */   // Label 8685: @433042
     /* 433042 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(433061), // Rule ID 24 //
     /* 433047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433054 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 433054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 433059 */     GIR_RootConstrainSelectedInstOperands,
     /* 433060 */     // GIR_Coverage, 24,
     /* 433060 */     GIR_Done,
     /* 433061 */   // Label 8686: @433061
     /* 433061 */   GIM_Reject,
     /* 433062 */ // Label 8684: @433062
     /* 433062 */ GIM_Reject,
     /* 433063 */ // Label 8680: @433063
     /* 433063 */ GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(433182),
     /* 433068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 433074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 433077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433089 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(433162), // Rule ID 29 //
     /* 433094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 433101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 433105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433138 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433142 */     // MIs[3] Operand 1
     /* 433142 */     // No operand predicates
     /* 433142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433144 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 433147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 433151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433160 */     GIR_RootConstrainSelectedInstOperands,
     /* 433161 */     // GIR_Coverage, 29,
     /* 433161 */     GIR_EraseRootFromParent_Done,
     /* 433162 */   // Label 8688: @433162
     /* 433162 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(433181), // Rule ID 25 //
     /* 433167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433174 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 433174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 433179 */     GIR_RootConstrainSelectedInstOperands,
     /* 433180 */     // GIR_Coverage, 25,
     /* 433180 */     GIR_Done,
     /* 433181 */   // Label 8689: @433181
     /* 433181 */   GIM_Reject,
     /* 433182 */ // Label 8687: @433182
     /* 433182 */ GIM_Reject,
     /* 433183 */ // Label 8681: @433183
     /* 433183 */ GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(433211), // Rule ID 7701 //
     /* 433188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 433194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 433197 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 433200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433204 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 433204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 433209 */   GIR_RootConstrainSelectedInstOperands,
     /* 433210 */   // GIR_Coverage, 7701,
     /* 433210 */   GIR_Done,
     /* 433211 */ // Label 8690: @433211
     /* 433211 */ GIM_Reject,
     /* 433212 */ // Label 8682: @433212
     /* 433212 */ GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(433240), // Rule ID 7700 //
     /* 433217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 433223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 433226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 433229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433233 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 433233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 433238 */   GIR_RootConstrainSelectedInstOperands,
     /* 433239 */   // GIR_Coverage, 7700,
     /* 433239 */   GIR_Done,
     /* 433240 */ // Label 8691: @433240
     /* 433240 */ GIM_Reject,
     /* 433241 */ // Label 8683: @433241
     /* 433241 */ GIM_Reject,
     /* 433242 */ // Label 146: @433242
     /* 433242 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8695*/ GIMT_Encode4(433358),
     /* 433253 */ /*GILLT_s16*//*Label 8692*/ GIMT_Encode4(433265),
     /* 433257 */ /*GILLT_s32*//*Label 8693*/ GIMT_Encode4(433296),
     /* 433261 */ /*GILLT_s64*//*Label 8694*/ GIMT_Encode4(433327),
     /* 433265 */ // Label 8692: @433265
     /* 433265 */ GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(433295), // Rule ID 1669 //
     /* 433270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 433273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 433276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433284 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 433284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 433289 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 433293 */   GIR_RootConstrainSelectedInstOperands,
     /* 433294 */   // GIR_Coverage, 1669,
     /* 433294 */   GIR_Done,
     /* 433295 */ // Label 8696: @433295
     /* 433295 */ GIM_Reject,
     /* 433296 */ // Label 8693: @433296
     /* 433296 */ GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(433326), // Rule ID 1668 //
     /* 433301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 433304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 433307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433315 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 433315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 433320 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 433324 */   GIR_RootConstrainSelectedInstOperands,
     /* 433325 */   // GIR_Coverage, 1668,
     /* 433325 */   GIR_Done,
     /* 433326 */ // Label 8697: @433326
     /* 433326 */ GIM_Reject,
     /* 433327 */ // Label 8694: @433327
     /* 433327 */ GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(433357), // Rule ID 1667 //
     /* 433332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 433335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 433338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433346 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 433346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 433351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 433355 */   GIR_RootConstrainSelectedInstOperands,
     /* 433356 */   // GIR_Coverage, 1667,
     /* 433356 */   GIR_Done,
     /* 433357 */ // Label 8698: @433357
     /* 433357 */ GIM_Reject,
     /* 433358 */ // Label 8695: @433358
     /* 433358 */ GIM_Reject,
     /* 433359 */ // Label 147: @433359
     /* 433359 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8702*/ GIMT_Encode4(434591),
     /* 433370 */ /*GILLT_v2s64*//*Label 8699*/ GIMT_Encode4(433390), GIMT_Encode4(0),
     /* 433378 */ /*GILLT_v4s32*//*Label 8700*/ GIMT_Encode4(433951), GIMT_Encode4(0),
     /* 433386 */ /*GILLT_v8s16*//*Label 8701*/ GIMT_Encode4(434512),
     /* 433390 */ // Label 8699: @433390
     /* 433390 */ GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(433950),
     /* 433395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 433401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433405 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(433497), // Rule ID 2106 //
     /* 433410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433454 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433458 */     // MIs[3] Operand 1
     /* 433458 */     // No operand predicates
     /* 433458 */     // MIs[1] Operand 2
     /* 433458 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 433469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 433478 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 433481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 433488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433495 */     GIR_RootConstrainSelectedInstOperands,
     /* 433496 */     // GIR_Coverage, 2106,
     /* 433496 */     GIR_EraseRootFromParent_Done,
     /* 433497 */   // Label 8704: @433497
     /* 433497 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(433589), // Rule ID 13616 //
     /* 433502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433546 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433550 */     // MIs[3] Operand 1
     /* 433550 */     // No operand predicates
     /* 433550 */     // MIs[1] Operand 2
     /* 433550 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 433561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 433570 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 433573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 433580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433587 */     GIR_RootConstrainSelectedInstOperands,
     /* 433588 */     // GIR_Coverage, 13616,
     /* 433588 */     GIR_EraseRootFromParent_Done,
     /* 433589 */   // Label 8705: @433589
     /* 433589 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(433675), // Rule ID 13614 //
     /* 433594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433638 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433642 */     // MIs[3] Operand 1
     /* 433642 */     // No operand predicates
     /* 433642 */     // MIs[1] Operand 2
     /* 433642 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 433653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433659 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 433662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433673 */     GIR_RootConstrainSelectedInstOperands,
     /* 433674 */     // GIR_Coverage, 13614,
     /* 433674 */     GIR_EraseRootFromParent_Done,
     /* 433675 */   // Label 8706: @433675
     /* 433675 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(433761), // Rule ID 2104 //
     /* 433680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433728 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433732 */     // MIs[3] Operand 1
     /* 433732 */     // No operand predicates
     /* 433732 */     // MIs[1] Operand 2
     /* 433732 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 433743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433745 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 433748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 433752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433759 */     GIR_RootConstrainSelectedInstOperands,
     /* 433760 */     // GIR_Coverage, 2104,
     /* 433760 */     GIR_EraseRootFromParent_Done,
     /* 433761 */   // Label 8707: @433761
     /* 433761 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(433800), // Rule ID 1831 //
     /* 433766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 433776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 433783 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 433783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 433786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 433793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 433798 */     GIR_RootConstrainSelectedInstOperands,
     /* 433799 */     // GIR_Coverage, 1831,
     /* 433799 */     GIR_EraseRootFromParent_Done,
     /* 433800 */   // Label 8708: @433800
     /* 433800 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(433863), // Rule ID 13615 //
     /* 433805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 433824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 433833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433837 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433841 */     // MIs[2] Operand 1
     /* 433841 */     // No operand predicates
     /* 433841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 433847 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 433850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 433858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 433861 */     GIR_RootConstrainSelectedInstOperands,
     /* 433862 */     // GIR_Coverage, 13615,
     /* 433862 */     GIR_EraseRootFromParent_Done,
     /* 433863 */   // Label 8709: @433863
     /* 433863 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(433926), // Rule ID 2105 //
     /* 433868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 433891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 433900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433908 */     // MIs[2] Operand 1
     /* 433908 */     // No operand predicates
     /* 433908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 433910 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 433913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 433917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 433921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 433924 */     GIR_RootConstrainSelectedInstOperands,
     /* 433925 */     // GIR_Coverage, 2105,
     /* 433925 */     GIR_EraseRootFromParent_Done,
     /* 433926 */   // Label 8710: @433926
     /* 433926 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(433949), // Rule ID 1830 //
     /* 433931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433942 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 433942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 433947 */     GIR_RootConstrainSelectedInstOperands,
     /* 433948 */     // GIR_Coverage, 1830,
     /* 433948 */     GIR_Done,
     /* 433949 */   // Label 8711: @433949
     /* 433949 */   GIM_Reject,
     /* 433950 */ // Label 8703: @433950
     /* 433950 */ GIM_Reject,
     /* 433951 */ // Label 8700: @433951
     /* 433951 */ GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(434511),
     /* 433956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 433962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433966 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(434058), // Rule ID 2103 //
     /* 433971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 433994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434015 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434019 */     // MIs[3] Operand 1
     /* 434019 */     // No operand predicates
     /* 434019 */     // MIs[1] Operand 2
     /* 434019 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 434030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434039 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 434042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434056 */     GIR_RootConstrainSelectedInstOperands,
     /* 434057 */     // GIR_Coverage, 2103,
     /* 434057 */     GIR_EraseRootFromParent_Done,
     /* 434058 */   // Label 8713: @434058
     /* 434058 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(434150), // Rule ID 13613 //
     /* 434063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434107 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434111 */     // MIs[3] Operand 1
     /* 434111 */     // No operand predicates
     /* 434111 */     // MIs[1] Operand 2
     /* 434111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 434122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434131 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 434134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434148 */     GIR_RootConstrainSelectedInstOperands,
     /* 434149 */     // GIR_Coverage, 13613,
     /* 434149 */     GIR_EraseRootFromParent_Done,
     /* 434150 */   // Label 8714: @434150
     /* 434150 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(434236), // Rule ID 13611 //
     /* 434155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434199 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434203 */     // MIs[3] Operand 1
     /* 434203 */     // No operand predicates
     /* 434203 */     // MIs[1] Operand 2
     /* 434203 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434220 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434234 */     GIR_RootConstrainSelectedInstOperands,
     /* 434235 */     // GIR_Coverage, 13611,
     /* 434235 */     GIR_EraseRootFromParent_Done,
     /* 434236 */   // Label 8715: @434236
     /* 434236 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(434322), // Rule ID 2101 //
     /* 434241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434289 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434293 */     // MIs[3] Operand 1
     /* 434293 */     // No operand predicates
     /* 434293 */     // MIs[1] Operand 2
     /* 434293 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434306 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 434313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434320 */     GIR_RootConstrainSelectedInstOperands,
     /* 434321 */     // GIR_Coverage, 2101,
     /* 434321 */     GIR_EraseRootFromParent_Done,
     /* 434322 */   // Label 8716: @434322
     /* 434322 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(434361), // Rule ID 1829 //
     /* 434327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434344 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 434344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 434347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 434359 */     GIR_RootConstrainSelectedInstOperands,
     /* 434360 */     // GIR_Coverage, 1829,
     /* 434360 */     GIR_EraseRootFromParent_Done,
     /* 434361 */   // Label 8717: @434361
     /* 434361 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(434424), // Rule ID 13612 //
     /* 434366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 434385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 434394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434398 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434402 */     // MIs[2] Operand 1
     /* 434402 */     // No operand predicates
     /* 434402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 434408 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 434419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 434422 */     GIR_RootConstrainSelectedInstOperands,
     /* 434423 */     // GIR_Coverage, 13612,
     /* 434423 */     GIR_EraseRootFromParent_Done,
     /* 434424 */   // Label 8718: @434424
     /* 434424 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(434487), // Rule ID 2102 //
     /* 434429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 434452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 434461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434465 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434469 */     // MIs[2] Operand 1
     /* 434469 */     // No operand predicates
     /* 434469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 434471 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 434478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 434482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 434485 */     GIR_RootConstrainSelectedInstOperands,
     /* 434486 */     // GIR_Coverage, 2102,
     /* 434486 */     GIR_EraseRootFromParent_Done,
     /* 434487 */   // Label 8719: @434487
     /* 434487 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(434510), // Rule ID 1828 //
     /* 434492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434503 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 434503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 434508 */     GIR_RootConstrainSelectedInstOperands,
     /* 434509 */     // GIR_Coverage, 1828,
     /* 434509 */     GIR_Done,
     /* 434510 */   // Label 8720: @434510
     /* 434510 */   GIM_Reject,
     /* 434511 */ // Label 8712: @434511
     /* 434511 */ GIM_Reject,
     /* 434512 */ // Label 8701: @434512
     /* 434512 */ GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(434590),
     /* 434517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 434523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434527 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(434566), // Rule ID 1827 //
     /* 434532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 434542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 434549 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 434549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 434552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 434564 */     GIR_RootConstrainSelectedInstOperands,
     /* 434565 */     // GIR_Coverage, 1827,
     /* 434565 */     GIR_EraseRootFromParent_Done,
     /* 434566 */   // Label 8722: @434566
     /* 434566 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(434589), // Rule ID 1826 //
     /* 434571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434582 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 434582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 434587 */     GIR_RootConstrainSelectedInstOperands,
     /* 434588 */     // GIR_Coverage, 1826,
     /* 434588 */     GIR_Done,
     /* 434589 */   // Label 8723: @434589
     /* 434589 */   GIM_Reject,
     /* 434590 */ // Label 8721: @434590
     /* 434590 */ GIM_Reject,
     /* 434591 */ // Label 8702: @434591
     /* 434591 */ GIM_Reject,
     /* 434592 */ // Label 148: @434592
     /* 434592 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8742*/ GIMT_Encode4(435371),
     /* 434603 */ /*GILLT_v2s32*//*Label 8724*/ GIMT_Encode4(434679),
     /* 434607 */ /*GILLT_v2s64*//*Label 8725*/ GIMT_Encode4(434734),
     /* 434611 */ /*GILLT_v4s16*//*Label 8726*/ GIMT_Encode4(434789),
     /* 434615 */ /*GILLT_v4s32*//*Label 8727*/ GIMT_Encode4(434844),
     /* 434619 */ /*GILLT_v8s8*//*Label 8728*/ GIMT_Encode4(434899),
     /* 434623 */ /*GILLT_v8s16*//*Label 8729*/ GIMT_Encode4(434933),
     /* 434627 */ /*GILLT_v16s8*//*Label 8730*/ GIMT_Encode4(434988), GIMT_Encode4(0),
     /* 434635 */ /*GILLT_nxv2s1*//*Label 8731*/ GIMT_Encode4(435022),
     /* 434639 */ /*GILLT_nxv2s16*//*Label 8732*/ GIMT_Encode4(435048),
     /* 434643 */ /*GILLT_nxv2s32*//*Label 8733*/ GIMT_Encode4(435074),
     /* 434647 */ /*GILLT_nxv2s64*//*Label 8734*/ GIMT_Encode4(435100),
     /* 434651 */ /*GILLT_nxv4s1*//*Label 8735*/ GIMT_Encode4(435147),
     /* 434655 */ /*GILLT_nxv4s16*//*Label 8736*/ GIMT_Encode4(435173),
     /* 434659 */ /*GILLT_nxv4s32*//*Label 8737*/ GIMT_Encode4(435199),
     /* 434663 */ /*GILLT_nxv8s1*//*Label 8738*/ GIMT_Encode4(435246),
     /* 434667 */ /*GILLT_nxv8s16*//*Label 8739*/ GIMT_Encode4(435272),
     /* 434671 */ /*GILLT_nxv16s1*//*Label 8740*/ GIMT_Encode4(435319),
     /* 434675 */ /*GILLT_nxv16s8*//*Label 8741*/ GIMT_Encode4(435345),
     /* 434679 */ // Label 8724: @434679
     /* 434679 */ GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(434733),
     /* 434684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 434690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434698 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434702 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(434717), // Rule ID 1888 //
     /* 434707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434710 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 434710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 434715 */     GIR_RootConstrainSelectedInstOperands,
     /* 434716 */     // GIR_Coverage, 1888,
     /* 434716 */     GIR_Done,
     /* 434717 */   // Label 8744: @434717
     /* 434717 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(434732), // Rule ID 5486 //
     /* 434722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434725 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 434725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 434730 */     GIR_RootConstrainSelectedInstOperands,
     /* 434731 */     // GIR_Coverage, 5486,
     /* 434731 */     GIR_Done,
     /* 434732 */   // Label 8745: @434732
     /* 434732 */   GIM_Reject,
     /* 434733 */ // Label 8743: @434733
     /* 434733 */ GIM_Reject,
     /* 434734 */ // Label 8725: @434734
     /* 434734 */ GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(434788),
     /* 434739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 434742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 434745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434757 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(434772), // Rule ID 1890 //
     /* 434762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434765 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 434765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 434770 */     GIR_RootConstrainSelectedInstOperands,
     /* 434771 */     // GIR_Coverage, 1890,
     /* 434771 */     GIR_Done,
     /* 434772 */   // Label 8747: @434772
     /* 434772 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(434787), // Rule ID 5488 //
     /* 434777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434780 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 434780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 434785 */     GIR_RootConstrainSelectedInstOperands,
     /* 434786 */     // GIR_Coverage, 5488,
     /* 434786 */     GIR_Done,
     /* 434787 */   // Label 8748: @434787
     /* 434787 */   GIM_Reject,
     /* 434788 */ // Label 8746: @434788
     /* 434788 */ GIM_Reject,
     /* 434789 */ // Label 8726: @434789
     /* 434789 */ GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(434843),
     /* 434794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 434800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434812 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(434827), // Rule ID 1886 //
     /* 434817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434820 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 434820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 434825 */     GIR_RootConstrainSelectedInstOperands,
     /* 434826 */     // GIR_Coverage, 1886,
     /* 434826 */     GIR_Done,
     /* 434827 */   // Label 8750: @434827
     /* 434827 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(434842), // Rule ID 5484 //
     /* 434832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434835 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 434835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 434840 */     GIR_RootConstrainSelectedInstOperands,
     /* 434841 */     // GIR_Coverage, 5484,
     /* 434841 */     GIR_Done,
     /* 434842 */   // Label 8751: @434842
     /* 434842 */   GIM_Reject,
     /* 434843 */ // Label 8749: @434843
     /* 434843 */ GIM_Reject,
     /* 434844 */ // Label 8727: @434844
     /* 434844 */ GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(434898),
     /* 434849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 434855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434867 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(434882), // Rule ID 1889 //
     /* 434872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434875 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 434875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 434880 */     GIR_RootConstrainSelectedInstOperands,
     /* 434881 */     // GIR_Coverage, 1889,
     /* 434881 */     GIR_Done,
     /* 434882 */   // Label 8753: @434882
     /* 434882 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(434897), // Rule ID 5487 //
     /* 434887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434890 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 434890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 434895 */     GIR_RootConstrainSelectedInstOperands,
     /* 434896 */     // GIR_Coverage, 5487,
     /* 434896 */     GIR_Done,
     /* 434897 */   // Label 8754: @434897
     /* 434897 */   GIM_Reject,
     /* 434898 */ // Label 8752: @434898
     /* 434898 */ GIM_Reject,
     /* 434899 */ // Label 8728: @434899
     /* 434899 */ GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(434932), // Rule ID 1884 //
     /* 434904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 434913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434925 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 434925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 434930 */   GIR_RootConstrainSelectedInstOperands,
     /* 434931 */   // GIR_Coverage, 1884,
     /* 434931 */   GIR_Done,
     /* 434932 */ // Label 8755: @434932
     /* 434932 */ GIM_Reject,
     /* 434933 */ // Label 8729: @434933
     /* 434933 */ GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(434987),
     /* 434938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 434944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434956 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(434971), // Rule ID 1887 //
     /* 434961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434964 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 434964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 434969 */     GIR_RootConstrainSelectedInstOperands,
     /* 434970 */     // GIR_Coverage, 1887,
     /* 434970 */     GIR_Done,
     /* 434971 */   // Label 8757: @434971
     /* 434971 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(434986), // Rule ID 5485 //
     /* 434976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434979 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 434979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 434984 */     GIR_RootConstrainSelectedInstOperands,
     /* 434985 */     // GIR_Coverage, 5485,
     /* 434985 */     GIR_Done,
     /* 434986 */   // Label 8758: @434986
     /* 434986 */   GIM_Reject,
     /* 434987 */ // Label 8756: @434987
     /* 434987 */ GIM_Reject,
     /* 434988 */ // Label 8730: @434988
     /* 434988 */ GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(435021), // Rule ID 1885 //
     /* 434993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 434999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 435002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435014 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 435014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 435019 */   GIR_RootConstrainSelectedInstOperands,
     /* 435020 */   // GIR_Coverage, 1885,
     /* 435020 */   GIR_Done,
     /* 435021 */ // Label 8759: @435021
     /* 435021 */ GIM_Reject,
     /* 435022 */ // Label 8731: @435022
     /* 435022 */ GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(435047), // Rule ID 9009 //
     /* 435027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 435033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 435036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435040 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 435040 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 435045 */   GIR_RootConstrainSelectedInstOperands,
     /* 435046 */   // GIR_Coverage, 9009,
     /* 435046 */   GIR_Done,
     /* 435047 */ // Label 8760: @435047
     /* 435047 */ GIM_Reject,
     /* 435048 */ // Label 8732: @435048
     /* 435048 */ GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(435073), // Rule ID 8971 //
     /* 435053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 435059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 435062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435066 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 435066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435071 */   GIR_RootConstrainSelectedInstOperands,
     /* 435072 */   // GIR_Coverage, 8971,
     /* 435072 */   GIR_Done,
     /* 435073 */ // Label 8761: @435073
     /* 435073 */ GIM_Reject,
     /* 435074 */ // Label 8733: @435074
     /* 435074 */ GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(435099), // Rule ID 8972 //
     /* 435079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 435085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 435088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435092 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 435092 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435097 */   GIR_RootConstrainSelectedInstOperands,
     /* 435098 */   // GIR_Coverage, 8972,
     /* 435098 */   GIR_Done,
     /* 435099 */ // Label 8762: @435099
     /* 435099 */ GIM_Reject,
     /* 435100 */ // Label 8734: @435100
     /* 435100 */ GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(435146),
     /* 435105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 435108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 435111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435115 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(435130), // Rule ID 8967 //
     /* 435120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435123 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 435123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435128 */     GIR_RootConstrainSelectedInstOperands,
     /* 435129 */     // GIR_Coverage, 8967,
     /* 435129 */     GIR_Done,
     /* 435130 */   // Label 8764: @435130
     /* 435130 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(435145), // Rule ID 8973 //
     /* 435135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435138 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 435138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435143 */     GIR_RootConstrainSelectedInstOperands,
     /* 435144 */     // GIR_Coverage, 8973,
     /* 435144 */     GIR_Done,
     /* 435145 */   // Label 8765: @435145
     /* 435145 */   GIM_Reject,
     /* 435146 */ // Label 8763: @435146
     /* 435146 */ GIM_Reject,
     /* 435147 */ // Label 8735: @435147
     /* 435147 */ GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(435172), // Rule ID 9008 //
     /* 435152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 435158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 435161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435165 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 435165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 435170 */   GIR_RootConstrainSelectedInstOperands,
     /* 435171 */   // GIR_Coverage, 9008,
     /* 435171 */   GIR_Done,
     /* 435172 */ // Label 8766: @435172
     /* 435172 */ GIM_Reject,
     /* 435173 */ // Label 8736: @435173
     /* 435173 */ GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(435198), // Rule ID 8969 //
     /* 435178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 435184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 435187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435191 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 435191 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435196 */   GIR_RootConstrainSelectedInstOperands,
     /* 435197 */   // GIR_Coverage, 8969,
     /* 435197 */   GIR_Done,
     /* 435198 */ // Label 8767: @435198
     /* 435198 */ GIM_Reject,
     /* 435199 */ // Label 8737: @435199
     /* 435199 */ GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(435245),
     /* 435204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 435207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 435210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435214 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(435229), // Rule ID 8966 //
     /* 435219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435222 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 435222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435227 */     GIR_RootConstrainSelectedInstOperands,
     /* 435228 */     // GIR_Coverage, 8966,
     /* 435228 */     GIR_Done,
     /* 435229 */   // Label 8769: @435229
     /* 435229 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(435244), // Rule ID 8970 //
     /* 435234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435237 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 435237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435242 */     GIR_RootConstrainSelectedInstOperands,
     /* 435243 */     // GIR_Coverage, 8970,
     /* 435243 */     GIR_Done,
     /* 435244 */   // Label 8770: @435244
     /* 435244 */   GIM_Reject,
     /* 435245 */ // Label 8768: @435245
     /* 435245 */ GIM_Reject,
     /* 435246 */ // Label 8738: @435246
     /* 435246 */ GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(435271), // Rule ID 9007 //
     /* 435251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 435257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 435260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435264 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 435264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 435269 */   GIR_RootConstrainSelectedInstOperands,
     /* 435270 */   // GIR_Coverage, 9007,
     /* 435270 */   GIR_Done,
     /* 435271 */ // Label 8771: @435271
     /* 435271 */ GIM_Reject,
     /* 435272 */ // Label 8739: @435272
     /* 435272 */ GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(435318),
     /* 435277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 435280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 435283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435287 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(435302), // Rule ID 8965 //
     /* 435292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435295 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 435295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 435300 */     GIR_RootConstrainSelectedInstOperands,
     /* 435301 */     // GIR_Coverage, 8965,
     /* 435301 */     GIR_Done,
     /* 435302 */   // Label 8773: @435302
     /* 435302 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(435317), // Rule ID 8968 //
     /* 435307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435310 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 435310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 435315 */     GIR_RootConstrainSelectedInstOperands,
     /* 435316 */     // GIR_Coverage, 8968,
     /* 435316 */     GIR_Done,
     /* 435317 */   // Label 8774: @435317
     /* 435317 */   GIM_Reject,
     /* 435318 */ // Label 8772: @435318
     /* 435318 */ GIM_Reject,
     /* 435319 */ // Label 8740: @435319
     /* 435319 */ GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(435344), // Rule ID 2406 //
     /* 435324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 435330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 435333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435337 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 435337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 435342 */   GIR_RootConstrainSelectedInstOperands,
     /* 435343 */   // GIR_Coverage, 2406,
     /* 435343 */   GIR_Done,
     /* 435344 */ // Label 8775: @435344
     /* 435344 */ GIM_Reject,
     /* 435345 */ // Label 8741: @435345
     /* 435345 */ GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(435370), // Rule ID 8964 //
     /* 435350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 435356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 435359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435363 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 435363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 435368 */   GIR_RootConstrainSelectedInstOperands,
     /* 435369 */   // GIR_Coverage, 8964,
     /* 435369 */   GIR_Done,
     /* 435370 */ // Label 8776: @435370
     /* 435370 */ GIM_Reject,
     /* 435371 */ // Label 8742: @435371
     /* 435371 */ GIM_Reject,
     /* 435372 */ // Label 149: @435372
     /* 435372 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8795*/ GIMT_Encode4(436151),
     /* 435383 */ /*GILLT_v2s32*//*Label 8777*/ GIMT_Encode4(435459),
     /* 435387 */ /*GILLT_v2s64*//*Label 8778*/ GIMT_Encode4(435514),
     /* 435391 */ /*GILLT_v4s16*//*Label 8779*/ GIMT_Encode4(435569),
     /* 435395 */ /*GILLT_v4s32*//*Label 8780*/ GIMT_Encode4(435624),
     /* 435399 */ /*GILLT_v8s8*//*Label 8781*/ GIMT_Encode4(435679),
     /* 435403 */ /*GILLT_v8s16*//*Label 8782*/ GIMT_Encode4(435713),
     /* 435407 */ /*GILLT_v16s8*//*Label 8783*/ GIMT_Encode4(435768), GIMT_Encode4(0),
     /* 435415 */ /*GILLT_nxv2s1*//*Label 8784*/ GIMT_Encode4(435802),
     /* 435419 */ /*GILLT_nxv2s16*//*Label 8785*/ GIMT_Encode4(435828),
     /* 435423 */ /*GILLT_nxv2s32*//*Label 8786*/ GIMT_Encode4(435854),
     /* 435427 */ /*GILLT_nxv2s64*//*Label 8787*/ GIMT_Encode4(435880),
     /* 435431 */ /*GILLT_nxv4s1*//*Label 8788*/ GIMT_Encode4(435927),
     /* 435435 */ /*GILLT_nxv4s16*//*Label 8789*/ GIMT_Encode4(435953),
     /* 435439 */ /*GILLT_nxv4s32*//*Label 8790*/ GIMT_Encode4(435979),
     /* 435443 */ /*GILLT_nxv8s1*//*Label 8791*/ GIMT_Encode4(436026),
     /* 435447 */ /*GILLT_nxv8s16*//*Label 8792*/ GIMT_Encode4(436052),
     /* 435451 */ /*GILLT_nxv16s1*//*Label 8793*/ GIMT_Encode4(436099),
     /* 435455 */ /*GILLT_nxv16s8*//*Label 8794*/ GIMT_Encode4(436125),
     /* 435459 */ // Label 8777: @435459
     /* 435459 */ GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(435513),
     /* 435464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 435467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 435470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435482 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(435497), // Rule ID 1895 //
     /* 435487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435490 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 435490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 435495 */     GIR_RootConstrainSelectedInstOperands,
     /* 435496 */     // GIR_Coverage, 1895,
     /* 435496 */     GIR_Done,
     /* 435497 */   // Label 8797: @435497
     /* 435497 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(435512), // Rule ID 5491 //
     /* 435502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435505 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 435505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 435510 */     GIR_RootConstrainSelectedInstOperands,
     /* 435511 */     // GIR_Coverage, 5491,
     /* 435511 */     GIR_Done,
     /* 435512 */   // Label 8798: @435512
     /* 435512 */   GIM_Reject,
     /* 435513 */ // Label 8796: @435513
     /* 435513 */ GIM_Reject,
     /* 435514 */ // Label 8778: @435514
     /* 435514 */ GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(435568),
     /* 435519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 435522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 435525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435537 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(435552), // Rule ID 1897 //
     /* 435542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435545 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 435545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 435550 */     GIR_RootConstrainSelectedInstOperands,
     /* 435551 */     // GIR_Coverage, 1897,
     /* 435551 */     GIR_Done,
     /* 435552 */   // Label 8800: @435552
     /* 435552 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(435567), // Rule ID 5493 //
     /* 435557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435560 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 435560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 435565 */     GIR_RootConstrainSelectedInstOperands,
     /* 435566 */     // GIR_Coverage, 5493,
     /* 435566 */     GIR_Done,
     /* 435567 */   // Label 8801: @435567
     /* 435567 */   GIM_Reject,
     /* 435568 */ // Label 8799: @435568
     /* 435568 */ GIM_Reject,
     /* 435569 */ // Label 8779: @435569
     /* 435569 */ GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(435623),
     /* 435574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 435580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435592 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(435607), // Rule ID 1893 //
     /* 435597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435600 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 435600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 435605 */     GIR_RootConstrainSelectedInstOperands,
     /* 435606 */     // GIR_Coverage, 1893,
     /* 435606 */     GIR_Done,
     /* 435607 */   // Label 8803: @435607
     /* 435607 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(435622), // Rule ID 5489 //
     /* 435612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435615 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 435615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 435620 */     GIR_RootConstrainSelectedInstOperands,
     /* 435621 */     // GIR_Coverage, 5489,
     /* 435621 */     GIR_Done,
     /* 435622 */   // Label 8804: @435622
     /* 435622 */   GIM_Reject,
     /* 435623 */ // Label 8802: @435623
     /* 435623 */ GIM_Reject,
     /* 435624 */ // Label 8780: @435624
     /* 435624 */ GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(435678),
     /* 435629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 435635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435647 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(435662), // Rule ID 1896 //
     /* 435652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435655 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 435655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 435660 */     GIR_RootConstrainSelectedInstOperands,
     /* 435661 */     // GIR_Coverage, 1896,
     /* 435661 */     GIR_Done,
     /* 435662 */   // Label 8806: @435662
     /* 435662 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(435677), // Rule ID 5492 //
     /* 435667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435670 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 435670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 435675 */     GIR_RootConstrainSelectedInstOperands,
     /* 435676 */     // GIR_Coverage, 5492,
     /* 435676 */     GIR_Done,
     /* 435677 */   // Label 8807: @435677
     /* 435677 */   GIM_Reject,
     /* 435678 */ // Label 8805: @435678
     /* 435678 */ GIM_Reject,
     /* 435679 */ // Label 8781: @435679
     /* 435679 */ GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(435712), // Rule ID 1891 //
     /* 435684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 435693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435705 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 435705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 435710 */   GIR_RootConstrainSelectedInstOperands,
     /* 435711 */   // GIR_Coverage, 1891,
     /* 435711 */   GIR_Done,
     /* 435712 */ // Label 8808: @435712
     /* 435712 */ GIM_Reject,
     /* 435713 */ // Label 8782: @435713
     /* 435713 */ GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(435767),
     /* 435718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 435724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435736 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(435751), // Rule ID 1894 //
     /* 435741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435744 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 435744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 435749 */     GIR_RootConstrainSelectedInstOperands,
     /* 435750 */     // GIR_Coverage, 1894,
     /* 435750 */     GIR_Done,
     /* 435751 */   // Label 8810: @435751
     /* 435751 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(435766), // Rule ID 5490 //
     /* 435756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435759 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 435759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 435764 */     GIR_RootConstrainSelectedInstOperands,
     /* 435765 */     // GIR_Coverage, 5490,
     /* 435765 */     GIR_Done,
     /* 435766 */   // Label 8811: @435766
     /* 435766 */   GIM_Reject,
     /* 435767 */ // Label 8809: @435767
     /* 435767 */ GIM_Reject,
     /* 435768 */ // Label 8783: @435768
     /* 435768 */ GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(435801), // Rule ID 1892 //
     /* 435773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 435779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 435782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435794 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 435794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 435799 */   GIR_RootConstrainSelectedInstOperands,
     /* 435800 */   // GIR_Coverage, 1892,
     /* 435800 */   GIR_Done,
     /* 435801 */ // Label 8812: @435801
     /* 435801 */ GIM_Reject,
     /* 435802 */ // Label 8784: @435802
     /* 435802 */ GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(435827), // Rule ID 9012 //
     /* 435807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 435813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 435816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435820 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 435820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 435825 */   GIR_RootConstrainSelectedInstOperands,
     /* 435826 */   // GIR_Coverage, 9012,
     /* 435826 */   GIR_Done,
     /* 435827 */ // Label 8813: @435827
     /* 435827 */ GIM_Reject,
     /* 435828 */ // Label 8785: @435828
     /* 435828 */ GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(435853), // Rule ID 8981 //
     /* 435833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 435839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 435842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435846 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 435846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 435851 */   GIR_RootConstrainSelectedInstOperands,
     /* 435852 */   // GIR_Coverage, 8981,
     /* 435852 */   GIR_Done,
     /* 435853 */ // Label 8814: @435853
     /* 435853 */ GIM_Reject,
     /* 435854 */ // Label 8786: @435854
     /* 435854 */ GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(435879), // Rule ID 8982 //
     /* 435859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 435865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 435868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435872 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 435872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 435877 */   GIR_RootConstrainSelectedInstOperands,
     /* 435878 */   // GIR_Coverage, 8982,
     /* 435878 */   GIR_Done,
     /* 435879 */ // Label 8815: @435879
     /* 435879 */ GIM_Reject,
     /* 435880 */ // Label 8787: @435880
     /* 435880 */ GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(435926),
     /* 435885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 435888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 435891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435895 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(435910), // Rule ID 8977 //
     /* 435900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435903 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 435903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 435908 */     GIR_RootConstrainSelectedInstOperands,
     /* 435909 */     // GIR_Coverage, 8977,
     /* 435909 */     GIR_Done,
     /* 435910 */   // Label 8817: @435910
     /* 435910 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(435925), // Rule ID 8983 //
     /* 435915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435918 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 435918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 435923 */     GIR_RootConstrainSelectedInstOperands,
     /* 435924 */     // GIR_Coverage, 8983,
     /* 435924 */     GIR_Done,
     /* 435925 */   // Label 8818: @435925
     /* 435925 */   GIM_Reject,
     /* 435926 */ // Label 8816: @435926
     /* 435926 */ GIM_Reject,
     /* 435927 */ // Label 8788: @435927
     /* 435927 */ GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(435952), // Rule ID 9011 //
     /* 435932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 435938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 435941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435945 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 435945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 435950 */   GIR_RootConstrainSelectedInstOperands,
     /* 435951 */   // GIR_Coverage, 9011,
     /* 435951 */   GIR_Done,
     /* 435952 */ // Label 8819: @435952
     /* 435952 */ GIM_Reject,
     /* 435953 */ // Label 8789: @435953
     /* 435953 */ GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(435978), // Rule ID 8979 //
     /* 435958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 435964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 435967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435971 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 435971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 435976 */   GIR_RootConstrainSelectedInstOperands,
     /* 435977 */   // GIR_Coverage, 8979,
     /* 435977 */   GIR_Done,
     /* 435978 */ // Label 8820: @435978
     /* 435978 */ GIM_Reject,
     /* 435979 */ // Label 8790: @435979
     /* 435979 */ GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(436025),
     /* 435984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 435987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 435990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435994 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(436009), // Rule ID 8976 //
     /* 435999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436002 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 436002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 436007 */     GIR_RootConstrainSelectedInstOperands,
     /* 436008 */     // GIR_Coverage, 8976,
     /* 436008 */     GIR_Done,
     /* 436009 */   // Label 8822: @436009
     /* 436009 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(436024), // Rule ID 8980 //
     /* 436014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436017 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 436017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 436022 */     GIR_RootConstrainSelectedInstOperands,
     /* 436023 */     // GIR_Coverage, 8980,
     /* 436023 */     GIR_Done,
     /* 436024 */   // Label 8823: @436024
     /* 436024 */   GIM_Reject,
     /* 436025 */ // Label 8821: @436025
     /* 436025 */ GIM_Reject,
     /* 436026 */ // Label 8791: @436026
     /* 436026 */ GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(436051), // Rule ID 9010 //
     /* 436031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 436037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 436040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436044 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 436044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 436049 */   GIR_RootConstrainSelectedInstOperands,
     /* 436050 */   // GIR_Coverage, 9010,
     /* 436050 */   GIR_Done,
     /* 436051 */ // Label 8824: @436051
     /* 436051 */ GIM_Reject,
     /* 436052 */ // Label 8792: @436052
     /* 436052 */ GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(436098),
     /* 436057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 436060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 436063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436067 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(436082), // Rule ID 8975 //
     /* 436072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436075 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 436075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 436080 */     GIR_RootConstrainSelectedInstOperands,
     /* 436081 */     // GIR_Coverage, 8975,
     /* 436081 */     GIR_Done,
     /* 436082 */   // Label 8826: @436082
     /* 436082 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(436097), // Rule ID 8978 //
     /* 436087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436090 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 436090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 436095 */     GIR_RootConstrainSelectedInstOperands,
     /* 436096 */     // GIR_Coverage, 8978,
     /* 436096 */     GIR_Done,
     /* 436097 */   // Label 8827: @436097
     /* 436097 */   GIM_Reject,
     /* 436098 */ // Label 8825: @436098
     /* 436098 */ GIM_Reject,
     /* 436099 */ // Label 8793: @436099
     /* 436099 */ GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(436124), // Rule ID 2410 //
     /* 436104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 436110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 436113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436117 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 436117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 436122 */   GIR_RootConstrainSelectedInstOperands,
     /* 436123 */   // GIR_Coverage, 2410,
     /* 436123 */   GIR_Done,
     /* 436124 */ // Label 8828: @436124
     /* 436124 */ GIM_Reject,
     /* 436125 */ // Label 8794: @436125
     /* 436125 */ GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(436150), // Rule ID 8974 //
     /* 436130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 436136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 436139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436143 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 436143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 436148 */   GIR_RootConstrainSelectedInstOperands,
     /* 436149 */   // GIR_Coverage, 8974,
     /* 436149 */   GIR_Done,
     /* 436150 */ // Label 8829: @436150
     /* 436150 */ GIM_Reject,
     /* 436151 */ // Label 8795: @436151
     /* 436151 */ GIM_Reject,
     /* 436152 */ // Label 150: @436152
     /* 436152 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8838*/ GIMT_Encode4(436849),
     /* 436163 */ /*GILLT_s64*//*Label 8830*/ GIMT_Encode4(436199), GIMT_Encode4(0),
     /* 436171 */ /*GILLT_v2s32*//*Label 8831*/ GIMT_Encode4(436310),
     /* 436175 */ /*GILLT_v2s64*//*Label 8832*/ GIMT_Encode4(436387),
     /* 436179 */ /*GILLT_v4s16*//*Label 8833*/ GIMT_Encode4(436464),
     /* 436183 */ /*GILLT_v4s32*//*Label 8834*/ GIMT_Encode4(436541),
     /* 436187 */ /*GILLT_v8s8*//*Label 8835*/ GIMT_Encode4(436618),
     /* 436191 */ /*GILLT_v8s16*//*Label 8836*/ GIMT_Encode4(436695),
     /* 436195 */ /*GILLT_v16s8*//*Label 8837*/ GIMT_Encode4(436772),
     /* 436199 */ // Label 8830: @436199
     /* 436199 */ GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(436309),
     /* 436204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 436207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436215 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(436240), // Rule ID 5263 //
     /* 436220 */     // MIs[0] Operand 2
     /* 436220 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 436231 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 436231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 436234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436238 */     GIR_RootConstrainSelectedInstOperands,
     /* 436239 */     // GIR_Coverage, 5263,
     /* 436239 */     GIR_EraseRootFromParent_Done,
     /* 436240 */   // Label 8840: @436240
     /* 436240 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(436274), // Rule ID 2120 //
     /* 436245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436248 */     // MIs[0] imm
     /* 436248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436260 */     // MIs[1] Operand 1
     /* 436260 */     // No operand predicates
     /* 436260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436262 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 436265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436272 */     GIR_RootConstrainSelectedInstOperands,
     /* 436273 */     // GIR_Coverage, 2120,
     /* 436273 */     GIR_EraseRootFromParent_Done,
     /* 436274 */   // Label 8841: @436274
     /* 436274 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(436308), // Rule ID 6327 //
     /* 436279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436282 */     // MIs[0] imm
     /* 436282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436294 */     // MIs[1] Operand 1
     /* 436294 */     // No operand predicates
     /* 436294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436296 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 436296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 436299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436306 */     GIR_RootConstrainSelectedInstOperands,
     /* 436307 */     // GIR_Coverage, 6327,
     /* 436307 */     GIR_EraseRootFromParent_Done,
     /* 436308 */   // Label 8842: @436308
     /* 436308 */   GIM_Reject,
     /* 436309 */ // Label 8839: @436309
     /* 436309 */ GIM_Reject,
     /* 436310 */ // Label 8831: @436310
     /* 436310 */ GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(436386),
     /* 436315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436326 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(436351), // Rule ID 4925 //
     /* 436331 */     // MIs[0] Operand 2
     /* 436331 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 436342 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 436342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 436345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436349 */     GIR_RootConstrainSelectedInstOperands,
     /* 436350 */     // GIR_Coverage, 4925,
     /* 436350 */     GIR_EraseRootFromParent_Done,
     /* 436351 */   // Label 8844: @436351
     /* 436351 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(436385), // Rule ID 2227 //
     /* 436356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436359 */     // MIs[0] imm
     /* 436359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 436371 */     // MIs[1] Operand 1
     /* 436371 */     // No operand predicates
     /* 436371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436373 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 436376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436383 */     GIR_RootConstrainSelectedInstOperands,
     /* 436384 */     // GIR_Coverage, 2227,
     /* 436384 */     GIR_EraseRootFromParent_Done,
     /* 436385 */   // Label 8845: @436385
     /* 436385 */   GIM_Reject,
     /* 436386 */ // Label 8843: @436386
     /* 436386 */ GIM_Reject,
     /* 436387 */ // Label 8832: @436387
     /* 436387 */ GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(436463),
     /* 436392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 436395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436403 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(436428), // Rule ID 4929 //
     /* 436408 */     // MIs[0] Operand 2
     /* 436408 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 436419 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 436419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 436422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436426 */     GIR_RootConstrainSelectedInstOperands,
     /* 436427 */     // GIR_Coverage, 4929,
     /* 436427 */     GIR_EraseRootFromParent_Done,
     /* 436428 */   // Label 8847: @436428
     /* 436428 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(436462), // Rule ID 2229 //
     /* 436433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436436 */     // MIs[0] imm
     /* 436436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436448 */     // MIs[1] Operand 1
     /* 436448 */     // No operand predicates
     /* 436448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436450 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 436453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436460 */     GIR_RootConstrainSelectedInstOperands,
     /* 436461 */     // GIR_Coverage, 2229,
     /* 436461 */     GIR_EraseRootFromParent_Done,
     /* 436462 */   // Label 8848: @436462
     /* 436462 */   GIM_Reject,
     /* 436463 */ // Label 8846: @436463
     /* 436463 */ GIM_Reject,
     /* 436464 */ // Label 8833: @436464
     /* 436464 */ GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(436540),
     /* 436469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 436472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436480 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(436505), // Rule ID 4924 //
     /* 436485 */     // MIs[0] Operand 2
     /* 436485 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 436496 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 436496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 436499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436503 */     GIR_RootConstrainSelectedInstOperands,
     /* 436504 */     // GIR_Coverage, 4924,
     /* 436504 */     GIR_EraseRootFromParent_Done,
     /* 436505 */   // Label 8850: @436505
     /* 436505 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(436539), // Rule ID 2225 //
     /* 436510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436513 */     // MIs[0] imm
     /* 436513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 436525 */     // MIs[1] Operand 1
     /* 436525 */     // No operand predicates
     /* 436525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436527 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 436530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436537 */     GIR_RootConstrainSelectedInstOperands,
     /* 436538 */     // GIR_Coverage, 2225,
     /* 436538 */     GIR_EraseRootFromParent_Done,
     /* 436539 */   // Label 8851: @436539
     /* 436539 */   GIM_Reject,
     /* 436540 */ // Label 8849: @436540
     /* 436540 */ GIM_Reject,
     /* 436541 */ // Label 8834: @436541
     /* 436541 */ GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(436617),
     /* 436546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436557 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(436582), // Rule ID 4928 //
     /* 436562 */     // MIs[0] Operand 2
     /* 436562 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 436573 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 436573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 436576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436580 */     GIR_RootConstrainSelectedInstOperands,
     /* 436581 */     // GIR_Coverage, 4928,
     /* 436581 */     GIR_EraseRootFromParent_Done,
     /* 436582 */   // Label 8853: @436582
     /* 436582 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(436616), // Rule ID 2228 //
     /* 436587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436590 */     // MIs[0] imm
     /* 436590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 436602 */     // MIs[1] Operand 1
     /* 436602 */     // No operand predicates
     /* 436602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436604 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 436607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436614 */     GIR_RootConstrainSelectedInstOperands,
     /* 436615 */     // GIR_Coverage, 2228,
     /* 436615 */     GIR_EraseRootFromParent_Done,
     /* 436616 */   // Label 8854: @436616
     /* 436616 */   GIM_Reject,
     /* 436617 */ // Label 8852: @436617
     /* 436617 */ GIM_Reject,
     /* 436618 */ // Label 8835: @436618
     /* 436618 */ GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(436694),
     /* 436623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 436626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436634 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(436659), // Rule ID 4923 //
     /* 436639 */     // MIs[0] Operand 2
     /* 436639 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 436650 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 436650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 436653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436657 */     GIR_RootConstrainSelectedInstOperands,
     /* 436658 */     // GIR_Coverage, 4923,
     /* 436658 */     GIR_EraseRootFromParent_Done,
     /* 436659 */   // Label 8856: @436659
     /* 436659 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(436693), // Rule ID 2223 //
     /* 436664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436667 */     // MIs[0] imm
     /* 436667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 436679 */     // MIs[1] Operand 1
     /* 436679 */     // No operand predicates
     /* 436679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436681 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 436684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436691 */     GIR_RootConstrainSelectedInstOperands,
     /* 436692 */     // GIR_Coverage, 2223,
     /* 436692 */     GIR_EraseRootFromParent_Done,
     /* 436693 */   // Label 8857: @436693
     /* 436693 */   GIM_Reject,
     /* 436694 */ // Label 8855: @436694
     /* 436694 */ GIM_Reject,
     /* 436695 */ // Label 8836: @436695
     /* 436695 */ GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(436771),
     /* 436700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436711 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(436736), // Rule ID 4927 //
     /* 436716 */     // MIs[0] Operand 2
     /* 436716 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 436727 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 436727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 436730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436734 */     GIR_RootConstrainSelectedInstOperands,
     /* 436735 */     // GIR_Coverage, 4927,
     /* 436735 */     GIR_EraseRootFromParent_Done,
     /* 436736 */   // Label 8859: @436736
     /* 436736 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(436770), // Rule ID 2226 //
     /* 436741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436744 */     // MIs[0] imm
     /* 436744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 436756 */     // MIs[1] Operand 1
     /* 436756 */     // No operand predicates
     /* 436756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436758 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 436761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436768 */     GIR_RootConstrainSelectedInstOperands,
     /* 436769 */     // GIR_Coverage, 2226,
     /* 436769 */     GIR_EraseRootFromParent_Done,
     /* 436770 */   // Label 8860: @436770
     /* 436770 */   GIM_Reject,
     /* 436771 */ // Label 8858: @436771
     /* 436771 */ GIM_Reject,
     /* 436772 */ // Label 8837: @436772
     /* 436772 */ GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(436848),
     /* 436777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 436780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436788 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(436813), // Rule ID 4926 //
     /* 436793 */     // MIs[0] Operand 2
     /* 436793 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 436804 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 436804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 436807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436811 */     GIR_RootConstrainSelectedInstOperands,
     /* 436812 */     // GIR_Coverage, 4926,
     /* 436812 */     GIR_EraseRootFromParent_Done,
     /* 436813 */   // Label 8862: @436813
     /* 436813 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(436847), // Rule ID 2224 //
     /* 436818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436821 */     // MIs[0] imm
     /* 436821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 436833 */     // MIs[1] Operand 1
     /* 436833 */     // No operand predicates
     /* 436833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436835 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 436838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436845 */     GIR_RootConstrainSelectedInstOperands,
     /* 436846 */     // GIR_Coverage, 2224,
     /* 436846 */     GIR_EraseRootFromParent_Done,
     /* 436847 */   // Label 8863: @436847
     /* 436847 */   GIM_Reject,
     /* 436848 */ // Label 8861: @436848
     /* 436848 */ GIM_Reject,
     /* 436849 */ // Label 8838: @436849
     /* 436849 */ GIM_Reject,
     /* 436850 */ // Label 151: @436850
     /* 436850 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8872*/ GIMT_Encode4(437305),
     /* 436861 */ /*GILLT_s64*//*Label 8864*/ GIMT_Encode4(436897), GIMT_Encode4(0),
     /* 436869 */ /*GILLT_v2s32*//*Label 8865*/ GIMT_Encode4(436983),
     /* 436873 */ /*GILLT_v2s64*//*Label 8866*/ GIMT_Encode4(437029),
     /* 436877 */ /*GILLT_v4s16*//*Label 8867*/ GIMT_Encode4(437075),
     /* 436881 */ /*GILLT_v4s32*//*Label 8868*/ GIMT_Encode4(437121),
     /* 436885 */ /*GILLT_v8s8*//*Label 8869*/ GIMT_Encode4(437167),
     /* 436889 */ /*GILLT_v8s16*//*Label 8870*/ GIMT_Encode4(437213),
     /* 436893 */ /*GILLT_v16s8*//*Label 8871*/ GIMT_Encode4(437259),
     /* 436897 */ // Label 8864: @436897
     /* 436897 */ GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(436982),
     /* 436902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 436905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436913 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(436947), // Rule ID 2129 //
     /* 436918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436921 */     // MIs[0] imm
     /* 436921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436933 */     // MIs[1] Operand 1
     /* 436933 */     // No operand predicates
     /* 436933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436935 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 436938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436945 */     GIR_RootConstrainSelectedInstOperands,
     /* 436946 */     // GIR_Coverage, 2129,
     /* 436946 */     GIR_EraseRootFromParent_Done,
     /* 436947 */   // Label 8874: @436947
     /* 436947 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(436981), // Rule ID 6330 //
     /* 436952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436955 */     // MIs[0] imm
     /* 436955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436967 */     // MIs[1] Operand 1
     /* 436967 */     // No operand predicates
     /* 436967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436969 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 436969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 436972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436979 */     GIR_RootConstrainSelectedInstOperands,
     /* 436980 */     // GIR_Coverage, 6330,
     /* 436980 */     GIR_EraseRootFromParent_Done,
     /* 436981 */   // Label 8875: @436981
     /* 436981 */   GIM_Reject,
     /* 436982 */ // Label 8873: @436982
     /* 436982 */ GIM_Reject,
     /* 436983 */ // Label 8865: @436983
     /* 436983 */ GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(437028), // Rule ID 2286 //
     /* 436988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437002 */   // MIs[0] imm
     /* 437002 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437006 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437010 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437014 */   // MIs[1] Operand 1
     /* 437014 */   // No operand predicates
     /* 437014 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437016 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 437019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437021 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437023 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437026 */   GIR_RootConstrainSelectedInstOperands,
     /* 437027 */   // GIR_Coverage, 2286,
     /* 437027 */   GIR_EraseRootFromParent_Done,
     /* 437028 */ // Label 8876: @437028
     /* 437028 */ GIM_Reject,
     /* 437029 */ // Label 8866: @437029
     /* 437029 */ GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(437074), // Rule ID 2288 //
     /* 437034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437048 */   // MIs[0] imm
     /* 437048 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437056 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437060 */   // MIs[1] Operand 1
     /* 437060 */   // No operand predicates
     /* 437060 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437062 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 437065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437067 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437069 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437072 */   GIR_RootConstrainSelectedInstOperands,
     /* 437073 */   // GIR_Coverage, 2288,
     /* 437073 */   GIR_EraseRootFromParent_Done,
     /* 437074 */ // Label 8877: @437074
     /* 437074 */ GIM_Reject,
     /* 437075 */ // Label 8867: @437075
     /* 437075 */ GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(437120), // Rule ID 2284 //
     /* 437080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437094 */   // MIs[0] imm
     /* 437094 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437098 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437102 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 437106 */   // MIs[1] Operand 1
     /* 437106 */   // No operand predicates
     /* 437106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437108 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 437111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437113 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437115 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437118 */   GIR_RootConstrainSelectedInstOperands,
     /* 437119 */   // GIR_Coverage, 2284,
     /* 437119 */   GIR_EraseRootFromParent_Done,
     /* 437120 */ // Label 8878: @437120
     /* 437120 */ GIM_Reject,
     /* 437121 */ // Label 8868: @437121
     /* 437121 */ GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(437166), // Rule ID 2287 //
     /* 437126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437140 */   // MIs[0] imm
     /* 437140 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437144 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437148 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437152 */   // MIs[1] Operand 1
     /* 437152 */   // No operand predicates
     /* 437152 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437154 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 437157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437159 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437161 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437164 */   GIR_RootConstrainSelectedInstOperands,
     /* 437165 */   // GIR_Coverage, 2287,
     /* 437165 */   GIR_EraseRootFromParent_Done,
     /* 437166 */ // Label 8879: @437166
     /* 437166 */ GIM_Reject,
     /* 437167 */ // Label 8869: @437167
     /* 437167 */ GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(437212), // Rule ID 2282 //
     /* 437172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437186 */   // MIs[0] imm
     /* 437186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437194 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437198 */   // MIs[1] Operand 1
     /* 437198 */   // No operand predicates
     /* 437198 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437200 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 437203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437205 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437207 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437210 */   GIR_RootConstrainSelectedInstOperands,
     /* 437211 */   // GIR_Coverage, 2282,
     /* 437211 */   GIR_EraseRootFromParent_Done,
     /* 437212 */ // Label 8880: @437212
     /* 437212 */ GIM_Reject,
     /* 437213 */ // Label 8870: @437213
     /* 437213 */ GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(437258), // Rule ID 2285 //
     /* 437218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437232 */   // MIs[0] imm
     /* 437232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437240 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 437244 */   // MIs[1] Operand 1
     /* 437244 */   // No operand predicates
     /* 437244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437246 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 437249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437251 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437253 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437256 */   GIR_RootConstrainSelectedInstOperands,
     /* 437257 */   // GIR_Coverage, 2285,
     /* 437257 */   GIR_EraseRootFromParent_Done,
     /* 437258 */ // Label 8881: @437258
     /* 437258 */ GIM_Reject,
     /* 437259 */ // Label 8871: @437259
     /* 437259 */ GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(437304), // Rule ID 2283 //
     /* 437264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 437270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437278 */   // MIs[0] imm
     /* 437278 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437282 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437286 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437290 */   // MIs[1] Operand 1
     /* 437290 */   // No operand predicates
     /* 437290 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437292 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 437295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437297 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437299 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437302 */   GIR_RootConstrainSelectedInstOperands,
     /* 437303 */   // GIR_Coverage, 2283,
     /* 437303 */   GIR_EraseRootFromParent_Done,
     /* 437304 */ // Label 8882: @437304
     /* 437304 */ GIM_Reject,
     /* 437305 */ // Label 8872: @437305
     /* 437305 */ GIM_Reject,
     /* 437306 */ // Label 152: @437306
     /* 437306 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8901*/ GIMT_Encode4(438085),
     /* 437317 */ /*GILLT_v2s32*//*Label 8883*/ GIMT_Encode4(437393),
     /* 437321 */ /*GILLT_v2s64*//*Label 8884*/ GIMT_Encode4(437448),
     /* 437325 */ /*GILLT_v4s16*//*Label 8885*/ GIMT_Encode4(437503),
     /* 437329 */ /*GILLT_v4s32*//*Label 8886*/ GIMT_Encode4(437558),
     /* 437333 */ /*GILLT_v8s8*//*Label 8887*/ GIMT_Encode4(437613),
     /* 437337 */ /*GILLT_v8s16*//*Label 8888*/ GIMT_Encode4(437647),
     /* 437341 */ /*GILLT_v16s8*//*Label 8889*/ GIMT_Encode4(437702), GIMT_Encode4(0),
     /* 437349 */ /*GILLT_nxv2s1*//*Label 8890*/ GIMT_Encode4(437736),
     /* 437353 */ /*GILLT_nxv2s16*//*Label 8891*/ GIMT_Encode4(437762),
     /* 437357 */ /*GILLT_nxv2s32*//*Label 8892*/ GIMT_Encode4(437788),
     /* 437361 */ /*GILLT_nxv2s64*//*Label 8893*/ GIMT_Encode4(437814),
     /* 437365 */ /*GILLT_nxv4s1*//*Label 8894*/ GIMT_Encode4(437861),
     /* 437369 */ /*GILLT_nxv4s16*//*Label 8895*/ GIMT_Encode4(437887),
     /* 437373 */ /*GILLT_nxv4s32*//*Label 8896*/ GIMT_Encode4(437913),
     /* 437377 */ /*GILLT_nxv8s1*//*Label 8897*/ GIMT_Encode4(437960),
     /* 437381 */ /*GILLT_nxv8s16*//*Label 8898*/ GIMT_Encode4(437986),
     /* 437385 */ /*GILLT_nxv16s1*//*Label 8899*/ GIMT_Encode4(438033),
     /* 437389 */ /*GILLT_nxv16s8*//*Label 8900*/ GIMT_Encode4(438059),
     /* 437393 */ // Label 8883: @437393
     /* 437393 */ GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(437447),
     /* 437398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 437404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437416 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(437431), // Rule ID 1902 //
     /* 437421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437424 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 437424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 437429 */     GIR_RootConstrainSelectedInstOperands,
     /* 437430 */     // GIR_Coverage, 1902,
     /* 437430 */     GIR_Done,
     /* 437431 */   // Label 8903: @437431
     /* 437431 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(437446), // Rule ID 5496 //
     /* 437436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437439 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 437439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 437444 */     GIR_RootConstrainSelectedInstOperands,
     /* 437445 */     // GIR_Coverage, 5496,
     /* 437445 */     GIR_Done,
     /* 437446 */   // Label 8904: @437446
     /* 437446 */   GIM_Reject,
     /* 437447 */ // Label 8902: @437447
     /* 437447 */ GIM_Reject,
     /* 437448 */ // Label 8884: @437448
     /* 437448 */ GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(437502),
     /* 437453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 437459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437471 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(437486), // Rule ID 1904 //
     /* 437476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437479 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 437479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 437484 */     GIR_RootConstrainSelectedInstOperands,
     /* 437485 */     // GIR_Coverage, 1904,
     /* 437485 */     GIR_Done,
     /* 437486 */   // Label 8906: @437486
     /* 437486 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(437501), // Rule ID 5498 //
     /* 437491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437494 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 437494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 437499 */     GIR_RootConstrainSelectedInstOperands,
     /* 437500 */     // GIR_Coverage, 5498,
     /* 437500 */     GIR_Done,
     /* 437501 */   // Label 8907: @437501
     /* 437501 */   GIM_Reject,
     /* 437502 */ // Label 8905: @437502
     /* 437502 */ GIM_Reject,
     /* 437503 */ // Label 8885: @437503
     /* 437503 */ GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(437557),
     /* 437508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 437514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437526 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(437541), // Rule ID 1900 //
     /* 437531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437534 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 437534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 437539 */     GIR_RootConstrainSelectedInstOperands,
     /* 437540 */     // GIR_Coverage, 1900,
     /* 437540 */     GIR_Done,
     /* 437541 */   // Label 8909: @437541
     /* 437541 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(437556), // Rule ID 5494 //
     /* 437546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437549 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 437549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 437554 */     GIR_RootConstrainSelectedInstOperands,
     /* 437555 */     // GIR_Coverage, 5494,
     /* 437555 */     GIR_Done,
     /* 437556 */   // Label 8910: @437556
     /* 437556 */   GIM_Reject,
     /* 437557 */ // Label 8908: @437557
     /* 437557 */ GIM_Reject,
     /* 437558 */ // Label 8886: @437558
     /* 437558 */ GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(437612),
     /* 437563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 437569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437581 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(437596), // Rule ID 1903 //
     /* 437586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437589 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 437589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 437594 */     GIR_RootConstrainSelectedInstOperands,
     /* 437595 */     // GIR_Coverage, 1903,
     /* 437595 */     GIR_Done,
     /* 437596 */   // Label 8912: @437596
     /* 437596 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(437611), // Rule ID 5497 //
     /* 437601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437604 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 437604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 437609 */     GIR_RootConstrainSelectedInstOperands,
     /* 437610 */     // GIR_Coverage, 5497,
     /* 437610 */     GIR_Done,
     /* 437611 */   // Label 8913: @437611
     /* 437611 */   GIM_Reject,
     /* 437612 */ // Label 8911: @437612
     /* 437612 */ GIM_Reject,
     /* 437613 */ // Label 8887: @437613
     /* 437613 */ GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(437646), // Rule ID 1898 //
     /* 437618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 437627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437639 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 437639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 437644 */   GIR_RootConstrainSelectedInstOperands,
     /* 437645 */   // GIR_Coverage, 1898,
     /* 437645 */   GIR_Done,
     /* 437646 */ // Label 8914: @437646
     /* 437646 */ GIM_Reject,
     /* 437647 */ // Label 8888: @437647
     /* 437647 */ GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(437701),
     /* 437652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 437658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437670 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(437685), // Rule ID 1901 //
     /* 437675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437678 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 437678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 437683 */     GIR_RootConstrainSelectedInstOperands,
     /* 437684 */     // GIR_Coverage, 1901,
     /* 437684 */     GIR_Done,
     /* 437685 */   // Label 8916: @437685
     /* 437685 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(437700), // Rule ID 5495 //
     /* 437690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437693 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 437693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 437698 */     GIR_RootConstrainSelectedInstOperands,
     /* 437699 */     // GIR_Coverage, 5495,
     /* 437699 */     GIR_Done,
     /* 437700 */   // Label 8917: @437700
     /* 437700 */   GIM_Reject,
     /* 437701 */ // Label 8915: @437701
     /* 437701 */ GIM_Reject,
     /* 437702 */ // Label 8889: @437702
     /* 437702 */ GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(437735), // Rule ID 1899 //
     /* 437707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 437713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 437716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437728 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 437728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 437733 */   GIR_RootConstrainSelectedInstOperands,
     /* 437734 */   // GIR_Coverage, 1899,
     /* 437734 */   GIR_Done,
     /* 437735 */ // Label 8918: @437735
     /* 437735 */ GIM_Reject,
     /* 437736 */ // Label 8890: @437736
     /* 437736 */ GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(437761), // Rule ID 3341 //
     /* 437741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 437747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 437750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437754 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 437754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 437759 */   GIR_RootConstrainSelectedInstOperands,
     /* 437760 */   // GIR_Coverage, 3341,
     /* 437760 */   GIR_Done,
     /* 437761 */ // Label 8919: @437761
     /* 437761 */ GIM_Reject,
     /* 437762 */ // Label 8891: @437762
     /* 437762 */ GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(437787), // Rule ID 2872 //
     /* 437767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 437773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 437776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437780 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 437780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 437785 */   GIR_RootConstrainSelectedInstOperands,
     /* 437786 */   // GIR_Coverage, 2872,
     /* 437786 */   GIR_Done,
     /* 437787 */ // Label 8920: @437787
     /* 437787 */ GIM_Reject,
     /* 437788 */ // Label 8892: @437788
     /* 437788 */ GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(437813), // Rule ID 2873 //
     /* 437793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 437799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 437802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437806 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 437806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 437811 */   GIR_RootConstrainSelectedInstOperands,
     /* 437812 */   // GIR_Coverage, 2873,
     /* 437812 */   GIR_Done,
     /* 437813 */ // Label 8921: @437813
     /* 437813 */ GIM_Reject,
     /* 437814 */ // Label 8893: @437814
     /* 437814 */ GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(437860),
     /* 437819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 437822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 437825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437829 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(437844), // Rule ID 2868 //
     /* 437834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437837 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 437837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 437842 */     GIR_RootConstrainSelectedInstOperands,
     /* 437843 */     // GIR_Coverage, 2868,
     /* 437843 */     GIR_Done,
     /* 437844 */   // Label 8923: @437844
     /* 437844 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(437859), // Rule ID 2874 //
     /* 437849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437852 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 437852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 437857 */     GIR_RootConstrainSelectedInstOperands,
     /* 437858 */     // GIR_Coverage, 2874,
     /* 437858 */     GIR_Done,
     /* 437859 */   // Label 8924: @437859
     /* 437859 */   GIM_Reject,
     /* 437860 */ // Label 8922: @437860
     /* 437860 */ GIM_Reject,
     /* 437861 */ // Label 8894: @437861
     /* 437861 */ GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(437886), // Rule ID 3340 //
     /* 437866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 437872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 437875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437879 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 437879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 437884 */   GIR_RootConstrainSelectedInstOperands,
     /* 437885 */   // GIR_Coverage, 3340,
     /* 437885 */   GIR_Done,
     /* 437886 */ // Label 8925: @437886
     /* 437886 */ GIM_Reject,
     /* 437887 */ // Label 8895: @437887
     /* 437887 */ GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(437912), // Rule ID 2870 //
     /* 437892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 437898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 437901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437905 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 437905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 437910 */   GIR_RootConstrainSelectedInstOperands,
     /* 437911 */   // GIR_Coverage, 2870,
     /* 437911 */   GIR_Done,
     /* 437912 */ // Label 8926: @437912
     /* 437912 */ GIM_Reject,
     /* 437913 */ // Label 8896: @437913
     /* 437913 */ GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(437959),
     /* 437918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 437921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 437924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437928 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(437943), // Rule ID 2867 //
     /* 437933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437936 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 437936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 437941 */     GIR_RootConstrainSelectedInstOperands,
     /* 437942 */     // GIR_Coverage, 2867,
     /* 437942 */     GIR_Done,
     /* 437943 */   // Label 8928: @437943
     /* 437943 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(437958), // Rule ID 2871 //
     /* 437948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437951 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 437951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 437956 */     GIR_RootConstrainSelectedInstOperands,
     /* 437957 */     // GIR_Coverage, 2871,
     /* 437957 */     GIR_Done,
     /* 437958 */   // Label 8929: @437958
     /* 437958 */   GIM_Reject,
     /* 437959 */ // Label 8927: @437959
     /* 437959 */ GIM_Reject,
     /* 437960 */ // Label 8897: @437960
     /* 437960 */ GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(437985), // Rule ID 3339 //
     /* 437965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 437971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 437974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437978 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 437978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 437983 */   GIR_RootConstrainSelectedInstOperands,
     /* 437984 */   // GIR_Coverage, 3339,
     /* 437984 */   GIR_Done,
     /* 437985 */ // Label 8930: @437985
     /* 437985 */ GIM_Reject,
     /* 437986 */ // Label 8898: @437986
     /* 437986 */ GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(438032),
     /* 437991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 437994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 437997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438001 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(438016), // Rule ID 2866 //
     /* 438006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438009 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 438009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 438014 */     GIR_RootConstrainSelectedInstOperands,
     /* 438015 */     // GIR_Coverage, 2866,
     /* 438015 */     GIR_Done,
     /* 438016 */   // Label 8932: @438016
     /* 438016 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(438031), // Rule ID 2869 //
     /* 438021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438024 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 438024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 438029 */     GIR_RootConstrainSelectedInstOperands,
     /* 438030 */     // GIR_Coverage, 2869,
     /* 438030 */     GIR_Done,
     /* 438031 */   // Label 8933: @438031
     /* 438031 */   GIM_Reject,
     /* 438032 */ // Label 8931: @438032
     /* 438032 */ GIM_Reject,
     /* 438033 */ // Label 8899: @438033
     /* 438033 */ GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(438058), // Rule ID 2398 //
     /* 438038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 438044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 438047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438051 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 438051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 438056 */   GIR_RootConstrainSelectedInstOperands,
     /* 438057 */   // GIR_Coverage, 2398,
     /* 438057 */   GIR_Done,
     /* 438058 */ // Label 8934: @438058
     /* 438058 */ GIM_Reject,
     /* 438059 */ // Label 8900: @438059
     /* 438059 */ GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(438084), // Rule ID 2865 //
     /* 438064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 438070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 438073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438077 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 438077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 438082 */   GIR_RootConstrainSelectedInstOperands,
     /* 438083 */   // GIR_Coverage, 2865,
     /* 438083 */   GIR_Done,
     /* 438084 */ // Label 8935: @438084
     /* 438084 */ GIM_Reject,
     /* 438085 */ // Label 8901: @438085
     /* 438085 */ GIM_Reject,
     /* 438086 */ // Label 153: @438086
     /* 438086 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8954*/ GIMT_Encode4(438865),
     /* 438097 */ /*GILLT_v2s32*//*Label 8936*/ GIMT_Encode4(438173),
     /* 438101 */ /*GILLT_v2s64*//*Label 8937*/ GIMT_Encode4(438228),
     /* 438105 */ /*GILLT_v4s16*//*Label 8938*/ GIMT_Encode4(438283),
     /* 438109 */ /*GILLT_v4s32*//*Label 8939*/ GIMT_Encode4(438338),
     /* 438113 */ /*GILLT_v8s8*//*Label 8940*/ GIMT_Encode4(438393),
     /* 438117 */ /*GILLT_v8s16*//*Label 8941*/ GIMT_Encode4(438427),
     /* 438121 */ /*GILLT_v16s8*//*Label 8942*/ GIMT_Encode4(438482), GIMT_Encode4(0),
     /* 438129 */ /*GILLT_nxv2s1*//*Label 8943*/ GIMT_Encode4(438516),
     /* 438133 */ /*GILLT_nxv2s16*//*Label 8944*/ GIMT_Encode4(438542),
     /* 438137 */ /*GILLT_nxv2s32*//*Label 8945*/ GIMT_Encode4(438568),
     /* 438141 */ /*GILLT_nxv2s64*//*Label 8946*/ GIMT_Encode4(438594),
     /* 438145 */ /*GILLT_nxv4s1*//*Label 8947*/ GIMT_Encode4(438641),
     /* 438149 */ /*GILLT_nxv4s16*//*Label 8948*/ GIMT_Encode4(438667),
     /* 438153 */ /*GILLT_nxv4s32*//*Label 8949*/ GIMT_Encode4(438693),
     /* 438157 */ /*GILLT_nxv8s1*//*Label 8950*/ GIMT_Encode4(438740),
     /* 438161 */ /*GILLT_nxv8s16*//*Label 8951*/ GIMT_Encode4(438766),
     /* 438165 */ /*GILLT_nxv16s1*//*Label 8952*/ GIMT_Encode4(438813),
     /* 438169 */ /*GILLT_nxv16s8*//*Label 8953*/ GIMT_Encode4(438839),
     /* 438173 */ // Label 8936: @438173
     /* 438173 */ GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(438227),
     /* 438178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 438181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 438184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438196 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(438211), // Rule ID 1909 //
     /* 438201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438204 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 438204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 438209 */     GIR_RootConstrainSelectedInstOperands,
     /* 438210 */     // GIR_Coverage, 1909,
     /* 438210 */     GIR_Done,
     /* 438211 */   // Label 8956: @438211
     /* 438211 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(438226), // Rule ID 5501 //
     /* 438216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438219 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 438219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 438224 */     GIR_RootConstrainSelectedInstOperands,
     /* 438225 */     // GIR_Coverage, 5501,
     /* 438225 */     GIR_Done,
     /* 438226 */   // Label 8957: @438226
     /* 438226 */   GIM_Reject,
     /* 438227 */ // Label 8955: @438227
     /* 438227 */ GIM_Reject,
     /* 438228 */ // Label 8937: @438228
     /* 438228 */ GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(438282),
     /* 438233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 438239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438251 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(438266), // Rule ID 1911 //
     /* 438256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438259 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 438259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 438264 */     GIR_RootConstrainSelectedInstOperands,
     /* 438265 */     // GIR_Coverage, 1911,
     /* 438265 */     GIR_Done,
     /* 438266 */   // Label 8959: @438266
     /* 438266 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(438281), // Rule ID 5503 //
     /* 438271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438274 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 438274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 438279 */     GIR_RootConstrainSelectedInstOperands,
     /* 438280 */     // GIR_Coverage, 5503,
     /* 438280 */     GIR_Done,
     /* 438281 */   // Label 8960: @438281
     /* 438281 */   GIM_Reject,
     /* 438282 */ // Label 8958: @438282
     /* 438282 */ GIM_Reject,
     /* 438283 */ // Label 8938: @438283
     /* 438283 */ GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(438337),
     /* 438288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 438294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438306 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(438321), // Rule ID 1907 //
     /* 438311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438314 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 438314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 438319 */     GIR_RootConstrainSelectedInstOperands,
     /* 438320 */     // GIR_Coverage, 1907,
     /* 438320 */     GIR_Done,
     /* 438321 */   // Label 8962: @438321
     /* 438321 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(438336), // Rule ID 5499 //
     /* 438326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438329 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 438329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 438334 */     GIR_RootConstrainSelectedInstOperands,
     /* 438335 */     // GIR_Coverage, 5499,
     /* 438335 */     GIR_Done,
     /* 438336 */   // Label 8963: @438336
     /* 438336 */   GIM_Reject,
     /* 438337 */ // Label 8961: @438337
     /* 438337 */ GIM_Reject,
     /* 438338 */ // Label 8939: @438338
     /* 438338 */ GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(438392),
     /* 438343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 438349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438361 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(438376), // Rule ID 1910 //
     /* 438366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438369 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 438369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 438374 */     GIR_RootConstrainSelectedInstOperands,
     /* 438375 */     // GIR_Coverage, 1910,
     /* 438375 */     GIR_Done,
     /* 438376 */   // Label 8965: @438376
     /* 438376 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(438391), // Rule ID 5502 //
     /* 438381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438384 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 438384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 438389 */     GIR_RootConstrainSelectedInstOperands,
     /* 438390 */     // GIR_Coverage, 5502,
     /* 438390 */     GIR_Done,
     /* 438391 */   // Label 8966: @438391
     /* 438391 */   GIM_Reject,
     /* 438392 */ // Label 8964: @438392
     /* 438392 */ GIM_Reject,
     /* 438393 */ // Label 8940: @438393
     /* 438393 */ GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(438426), // Rule ID 1905 //
     /* 438398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 438407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438419 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 438419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 438424 */   GIR_RootConstrainSelectedInstOperands,
     /* 438425 */   // GIR_Coverage, 1905,
     /* 438425 */   GIR_Done,
     /* 438426 */ // Label 8967: @438426
     /* 438426 */ GIM_Reject,
     /* 438427 */ // Label 8941: @438427
     /* 438427 */ GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(438481),
     /* 438432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 438438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438450 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(438465), // Rule ID 1908 //
     /* 438455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438458 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 438458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 438463 */     GIR_RootConstrainSelectedInstOperands,
     /* 438464 */     // GIR_Coverage, 1908,
     /* 438464 */     GIR_Done,
     /* 438465 */   // Label 8969: @438465
     /* 438465 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(438480), // Rule ID 5500 //
     /* 438470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438473 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 438473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 438478 */     GIR_RootConstrainSelectedInstOperands,
     /* 438479 */     // GIR_Coverage, 5500,
     /* 438479 */     GIR_Done,
     /* 438480 */   // Label 8970: @438480
     /* 438480 */   GIM_Reject,
     /* 438481 */ // Label 8968: @438481
     /* 438481 */ GIM_Reject,
     /* 438482 */ // Label 8942: @438482
     /* 438482 */ GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(438515), // Rule ID 1906 //
     /* 438487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 438496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438508 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 438508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 438513 */   GIR_RootConstrainSelectedInstOperands,
     /* 438514 */   // GIR_Coverage, 1906,
     /* 438514 */   GIR_Done,
     /* 438515 */ // Label 8971: @438515
     /* 438515 */ GIM_Reject,
     /* 438516 */ // Label 8943: @438516
     /* 438516 */ GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(438541), // Rule ID 9006 //
     /* 438521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 438527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 438530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438534 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 438534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 438539 */   GIR_RootConstrainSelectedInstOperands,
     /* 438540 */   // GIR_Coverage, 9006,
     /* 438540 */   GIR_Done,
     /* 438541 */ // Label 8972: @438541
     /* 438541 */ GIM_Reject,
     /* 438542 */ // Label 8944: @438542
     /* 438542 */ GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(438567), // Rule ID 8961 //
     /* 438547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 438553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 438556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438560 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 438560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 438565 */   GIR_RootConstrainSelectedInstOperands,
     /* 438566 */   // GIR_Coverage, 8961,
     /* 438566 */   GIR_Done,
     /* 438567 */ // Label 8973: @438567
     /* 438567 */ GIM_Reject,
     /* 438568 */ // Label 8945: @438568
     /* 438568 */ GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(438593), // Rule ID 8962 //
     /* 438573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 438579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 438582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438586 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 438586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 438591 */   GIR_RootConstrainSelectedInstOperands,
     /* 438592 */   // GIR_Coverage, 8962,
     /* 438592 */   GIR_Done,
     /* 438593 */ // Label 8974: @438593
     /* 438593 */ GIM_Reject,
     /* 438594 */ // Label 8946: @438594
     /* 438594 */ GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(438640),
     /* 438599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 438602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 438605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438609 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(438624), // Rule ID 8957 //
     /* 438614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438617 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 438617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 438622 */     GIR_RootConstrainSelectedInstOperands,
     /* 438623 */     // GIR_Coverage, 8957,
     /* 438623 */     GIR_Done,
     /* 438624 */   // Label 8976: @438624
     /* 438624 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(438639), // Rule ID 8963 //
     /* 438629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438632 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 438632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 438637 */     GIR_RootConstrainSelectedInstOperands,
     /* 438638 */     // GIR_Coverage, 8963,
     /* 438638 */     GIR_Done,
     /* 438639 */   // Label 8977: @438639
     /* 438639 */   GIM_Reject,
     /* 438640 */ // Label 8975: @438640
     /* 438640 */ GIM_Reject,
     /* 438641 */ // Label 8947: @438641
     /* 438641 */ GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(438666), // Rule ID 9005 //
     /* 438646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 438652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 438655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438659 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 438659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 438664 */   GIR_RootConstrainSelectedInstOperands,
     /* 438665 */   // GIR_Coverage, 9005,
     /* 438665 */   GIR_Done,
     /* 438666 */ // Label 8978: @438666
     /* 438666 */ GIM_Reject,
     /* 438667 */ // Label 8948: @438667
     /* 438667 */ GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(438692), // Rule ID 8959 //
     /* 438672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 438678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 438681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438685 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 438685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 438690 */   GIR_RootConstrainSelectedInstOperands,
     /* 438691 */   // GIR_Coverage, 8959,
     /* 438691 */   GIR_Done,
     /* 438692 */ // Label 8979: @438692
     /* 438692 */ GIM_Reject,
     /* 438693 */ // Label 8949: @438693
     /* 438693 */ GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(438739),
     /* 438698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 438701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 438704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438708 */   GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(438723), // Rule ID 8956 //
     /* 438713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438716 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 438716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 438721 */     GIR_RootConstrainSelectedInstOperands,
     /* 438722 */     // GIR_Coverage, 8956,
     /* 438722 */     GIR_Done,
     /* 438723 */   // Label 8981: @438723
     /* 438723 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(438738), // Rule ID 8960 //
     /* 438728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438731 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 438731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 438736 */     GIR_RootConstrainSelectedInstOperands,
     /* 438737 */     // GIR_Coverage, 8960,
     /* 438737 */     GIR_Done,
     /* 438738 */   // Label 8982: @438738
     /* 438738 */   GIM_Reject,
     /* 438739 */ // Label 8980: @438739
     /* 438739 */ GIM_Reject,
     /* 438740 */ // Label 8950: @438740
     /* 438740 */ GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(438765), // Rule ID 9004 //
     /* 438745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 438751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 438754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438758 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 438758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 438763 */   GIR_RootConstrainSelectedInstOperands,
     /* 438764 */   // GIR_Coverage, 9004,
     /* 438764 */   GIR_Done,
     /* 438765 */ // Label 8983: @438765
     /* 438765 */ GIM_Reject,
     /* 438766 */ // Label 8951: @438766
     /* 438766 */ GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(438812),
     /* 438771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 438774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 438777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438781 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(438796), // Rule ID 8955 //
     /* 438786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438789 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 438789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 438794 */     GIR_RootConstrainSelectedInstOperands,
     /* 438795 */     // GIR_Coverage, 8955,
     /* 438795 */     GIR_Done,
     /* 438796 */   // Label 8985: @438796
     /* 438796 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(438811), // Rule ID 8958 //
     /* 438801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438804 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 438804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 438809 */     GIR_RootConstrainSelectedInstOperands,
     /* 438810 */     // GIR_Coverage, 8958,
     /* 438810 */     GIR_Done,
     /* 438811 */   // Label 8986: @438811
     /* 438811 */   GIM_Reject,
     /* 438812 */ // Label 8984: @438812
     /* 438812 */ GIM_Reject,
     /* 438813 */ // Label 8952: @438813
     /* 438813 */ GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(438838), // Rule ID 2402 //
     /* 438818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 438824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 438827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438831 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 438831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 438836 */   GIR_RootConstrainSelectedInstOperands,
     /* 438837 */   // GIR_Coverage, 2402,
     /* 438837 */   GIR_Done,
     /* 438838 */ // Label 8987: @438838
     /* 438838 */ GIM_Reject,
     /* 438839 */ // Label 8953: @438839
     /* 438839 */ GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(438864), // Rule ID 8954 //
     /* 438844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 438850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 438853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438857 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 438857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 438862 */   GIR_RootConstrainSelectedInstOperands,
     /* 438863 */   // GIR_Coverage, 8954,
     /* 438863 */   GIR_Done,
     /* 438864 */ // Label 8988: @438864
     /* 438864 */ GIM_Reject,
     /* 438865 */ // Label 8954: @438865
     /* 438865 */ GIM_Reject,
     /* 438866 */ // Label 154: @438866
     /* 438866 */ GIM_Reject,
     /* 438867 */ }; // Size: 438867 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
